--
-- PostgreSQL database dump
--

SET client_encoding = 'UTF8';
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- Name: manuscript; Type: SCHEMA; Schema: -; Owner: detrix
--

CREATE SCHEMA manuscript;


ALTER SCHEMA manuscript OWNER TO detrix;

--
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: detrix
--

COMMENT ON SCHEMA public IS 'Standard public schema';


SET search_path = manuscript, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: md_media; Type: TABLE; Schema: manuscript; Owner: detrix; Tablespace: 
--

CREATE TABLE md_media (
    file_id integer NOT NULL,
    name character varying(255),
    directory character varying(1024),
    md5 character(32),
    sha1 character(40),
    user_id integer,
    created_at integer,
    "type" character varying(255),
    size integer NOT NULL
);


ALTER TABLE manuscript.md_media OWNER TO detrix;

--
-- Name: wf_access_list; Type: TABLE; Schema: manuscript; Owner: detrix; Tablespace: 
--

CREATE TABLE wf_access_list (
    doctype_id integer NOT NULL,
    structure_id integer NOT NULL,
    can_view integer NOT NULL,
    can_remove integer NOT NULL,
    group_id integer NOT NULL
);


ALTER TABLE manuscript.wf_access_list OWNER TO detrix;

--
-- Name: wf_archive; Type: TABLE; Schema: manuscript; Owner: detrix; Tablespace: 
--

CREATE TABLE wf_archive (
    archive_id serial NOT NULL,
    structure_id integer NOT NULL,
    author_name character varying NOT NULL,
    created_at date NOT NULL,
    modified_at timestamp without time zone NOT NULL,
    archived_at timestamp without time zone NOT NULL,
    doctype_id integer NOT NULL,
    document_id integer NOT NULL,
    registration_number text NOT NULL,
    document_title character varying NOT NULL,
    fields_xml character varying NOT NULL,
    template_xml character varying NOT NULL,
    doctype_title character varying NOT NULL,
    subdivision_name character varying,
    sysfields_xml character varying,
    media_id integer DEFAULT 0 NOT NULL
);


ALTER TABLE manuscript.wf_archive OWNER TO detrix;

--
-- Name: wf_archive_archive_id_seq; Type: SEQUENCE SET; Schema: manuscript; Owner: detrix
--

SELECT pg_catalog.setval(pg_catalog.pg_get_serial_sequence('wf_archive', 'archive_id'), 824, true);


--
-- Name: wf_elements_access_list; Type: TABLE; Schema: manuscript; Owner: detrix; Tablespace: 
--

CREATE TABLE wf_elements_access_list (
    archive_id integer,
    structure_id integer
);


ALTER TABLE manuscript.wf_elements_access_list OWNER TO detrix;

--
-- Data for Name: md_media; Type: TABLE DATA; Schema: manuscript; Owner: detrix
--

COPY md_media (file_id, name, directory, md5, sha1, user_id, created_at, "type", size) FROM stdin;
\.


--
-- Data for Name: wf_access_list; Type: TABLE DATA; Schema: manuscript; Owner: detrix
--

COPY wf_access_list (doctype_id, structure_id, can_view, can_remove, group_id) FROM stdin;
\.


--
-- Data for Name: wf_archive; Type: TABLE DATA; Schema: manuscript; Owner: detrix
--

COPY wf_archive (archive_id, structure_id, author_name, created_at, modified_at, archived_at, doctype_id, document_id, registration_number, document_title, fields_xml, template_xml, doctype_title, subdivision_name, sysfields_xml, media_id) FROM stdin;
\.


--
-- Data for Name: wf_elements_access_list; Type: TABLE DATA; Schema: manuscript; Owner: detrix
--

COPY wf_elements_access_list (archive_id, structure_id) FROM stdin;
\.


--
-- Name: md_media_pkey; Type: CONSTRAINT; Schema: manuscript; Owner: detrix; Tablespace: 
--

ALTER TABLE ONLY md_media
    ADD CONSTRAINT md_media_pkey PRIMARY KEY (file_id);


--
-- Name: wf_archive_pkey; Type: CONSTRAINT; Schema: manuscript; Owner: detrix; Tablespace: 
--

ALTER TABLE ONLY wf_archive
    ADD CONSTRAINT wf_archive_pkey PRIMARY KEY (archive_id);


--
-- Name: public; Type: ACL; Schema: -; Owner: detrix
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO detrix;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--

