<?php
set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
include_once "system/mvc/MSF_ModelDBSupport.php";
include_once "system/mvc/MSF_ViewSupportXml.php";
include_once 'system/MSF_MsfxSupport.php';
include_once 'system/MSF_Registry.php';
include_once 'msfx/userbox/library/MSF_UserBox.php';
include_once 'msfx/userbox/MSF_UserBoxExtension.php';
include_once 'modules/lms/library/LMS_Mail.php';
include_once 'modules/lms/library/LMS_MailDB.php';
include_once 'system/utils/MSF_XmlWrapper.php';
include_once 'system/MSF_Locale.php';
include_once 'system/utils/MSF_String.php';
include_once 'system/utils/MSF_SL.php';
include_once 'system/MSF_Template.php';
include_once "msfx/messenger/library/MSF_Messenger.php";
include_once 'system/MSF_Settings.php';
include_once 'modules/references/library/Reference/REF_Value.php';
include_once "modules/workflow/library/common/WF_Exception.php";
include_once 'modules/workflow/library/document/WF_Document.php';
include_once 'modules/workflow/library/doctype/WF_Doctype.php';
include_once 'modules/workflow/library/actions/WF_DocFacade.php';
include_once 'modules/workflow/library/actions/WF_IAction.php';
include_once 'modules/main/library/orgStructure/MSF_OrgStructureFacade.php';
include_once 'modules/workflow/actions/control/WF_Control.php';
include_once 'modules/workflow/library/actions/WF_ActionBuilder.php';
include_once 'system/MSF_IOException.php';
include_once 'modules/workflow/library/actions/WF_ActionBox.php';
include_once 'system/utils/MSF_File.php';
include_once "system/utils/MSF_Date.php";
include_once "modules/workflow/library/actions/WF_ExecutionContext.php";


class ControlAtomicOperation extends AtomicOperation
{
	private $oQuery				= null;
	
	private $oMail 			  	= null;
	
	private $oStructureFacade 	= null;
	
	private $oRouter			= null;
	
	private $ActionBuilder		= null;
	
	private $oDocument			= null;
	
	private $oXmlWrapper		= null;
	
	private $oValue				= null;
	
	private $oDocFacade			= null;
	
	private $oLc 			  	= null;
	
	private $sServerName		= null;
	
	private function prepare() 
	{
		MSF_Registry::set("MSF_DB", $this->getDb());
		MSF_Registry::set("MSF_UserBox", MSF_UserBox::getInstance());
		$this->oLc = new MSF_Locale(CNF_ABS_PATH . '/languages/ru.ini');
		$this->oLc->loadDictionary(CNF_ABS_PATH . '/languages/ru.ini');              
		MSF_Registry::set("MSF_Locale", $this->oLc);

                MSF_Registry::set("MSF_Template", new MSF_Template());
		MSF_Registry::set("MSF_Messenger", new MSF_Messenger(MSF_Registry::get("MSF_Template")));
		$sContent  = MSF_File::read(CNF_ABS_PATH . '/settings.xml');
		$oSettings = MSF_Settings::getInstance($sContent);
		MSF_Registry::set("MSF_Settings", $oSettings);
		$this->oQuery 			= new WF_Control();
		$this->oMail 			= new LMS_Mail(new LMS_MailDB($this->getDb()));
		$this->oStructureFacade = MSF_OrgStructureFacade::getInstance();
		$this->oDocFacade	 	= new WF_DocFacade();
		$this->oValue 			= new REF_Value();
		$this->oXmlWrapper		= new MSF_XmlWrapper();
		$this->sServerName		= CNF_HOST_URL;
	}
	
	public function execute() 
	{			
		$this->prepare();	
		$this->QueryFindByIsExpired();			
		$this->QueryFindByNotifyAt();
	}
	
	public function QueryFindByIsExpired()
	{
		$aTempDocId 	= array();
		$i				= 0;
		$aControl	= $this->oQuery->findByIsExpired();
		foreach ($aControl AS $aNumber) {
			if ($this->oDocFacade->getDocumentById($aNumber["document_id"]) !== null) {
				if ($aNumber["number_of_points"] != 0) {
					$iTI			= $aNumber["number_of_points"] + $aNumber["document_position"];
					$oDocument 		= $this->oDocFacade->getDocumentById($aNumber["document_id"]);
					$sXml			= $oDocument->getDoctypeVersion()->getRouteXml();
					$aXml			= $this->oXmlWrapper->xmlToArray($sXml);
					if (count($aXml) > $iTI) {
						$oDocument->setPointId($iTI);
						$oAb 		= WF_ActionBox::newInstance();
						$oAb->loadAction("view", 0, $oDocument->getDocumentId(), null, true);
						$oAction	= $oAb->getAction();
						$oAction->call("move", array("iNewPoint" => $aNumber["number_of_points"]), "call", true);
						MSF_Registry::get("MSF_UserBox")->destroy();
						MSF_Registry::set("MSF_UserBox", MSF_UserBox::getInstance());
						$this->oDocFacade->initContextExecution($oDocument);
					//	$oDocument->save();
					}
					
				}
				if	($aNumber["controller"] != '') {
					$this->mailController($aNumber);	
				}
				$this->mailExecutorOverdue($aNumber);
				$this->oQuery->updateByControlId($aNumber["control_id"], array("notify_at" => time() + 86400));
				$this->oQuery->updateByControlId($aNumber["control_id"], array("is_expired" => 1));
			}
			else if (array_search($aNumber["document_id"], $aTempDocId) == false) {
				$this->oQuery->removeByDocumentId($aNumber["document_id"]);
				$aTempDocId[$i] = $aNumber["document_id"];
				$i++;
			}
		}
	}
	
	public function QueryFindByNotifyAt () 
	{
		$aTempDocId 	= array();
		$i				= 0;
		$aControl 		= $this->oQuery->findByNotifyAt();			
		foreach ($aControl AS $aNumber) {
			if ($this->oDocFacade->getDocumentById($aNumber["document_id"]) !== null) {	
				if	($aNumber["is_expired"] == 0) {
					$this->mailExecutorRemind($aNumber);
					$this->oQuery->updateByControlId($aNumber["control_id"], array("notify_at" => $aNumber["notify_at"] + $aNumber["mailing_timeout"]));	
				}
				else {
					$this->mailExecutorOverdue($aNumber);
					$this->oQuery->updateByControlId($aNumber["control_id"], array("notify_at" => time() + 86400));
				}
			}
			else if (array_search($aNumber["document_id"], $aTempDocId) == false) {
				$this->oQuery->removeByDocumentId($aNumber["document_id"]);
				$aTempDocId[$i] = $aNumber["document_id"];
				$i++;
			}
		}
	}
	
	public function	mailExecutorRemind($aNumber)
	{
		$this->oValue->parse($aNumber["executor"]);
		$aExecutor 		= $this->oValue->getKeysList();
		$Document 		= $this->oDocFacade->getDocumentById($aNumber["document_id"]);
		$sDocTitle 		= $Document->getRowTitle();
		foreach ($aExecutor AS $ExecutorItem) {
			if (isset($ExecutorItem[0])) {
				$this->oMail->setStructureIds(array($ExecutorItem[0]));
				$this->oMail->setFrom("", "Detrix");
				$this->oMail->setSubject($this->oLc->getWord("MAIL_SUBJECT_EXECUTOR_REMIND") . $sDocTitle);
				$aSearch	= array('%SERVER_NAME%','%DOCUMENT_ID%', '%DOC_TITLE%');
				$aReplace	= array($this->sServerName, $aNumber["document_id"], $sDocTitle);
				$sBody 		= str_replace($aSearch, $aReplace, $this->oLc->getWord("MAIL_BODY_EXECUTOR_REMIND"))
							  . date("d.m.Y H:i", $aNumber["finish_at"]);
				$this->oMail->setBody($sBody);
				$this->oMail->save();			
			}

		}

	}
	
	public function	mailExecutorOverdue($aNumber)
	{
		if ($this->isWorkDay()) {
			$this->oValue->parse($aNumber["executor"]);
			$aExecutor = $this->oValue->getKeysList();
			$Document 	= $this->oDocFacade->getDocumentById($aNumber["document_id"]);
			$sDocTitle = $Document->getRowTitle();
			foreach ($aExecutor AS $ExecutorItem) {
				if (isset($ExecutorItem[0])) {
					$this->oMail->setStructureIds(array($ExecutorItem[0]));
					$this->oMail->setFrom("", "Detrix");
					$this->oMail->setSubject($this->oLc->getWord("MAIL_SUBJECT_OVERDUE") . $sDocTitle);
					$aSearch	= array('%SERVER_NAME%','%DOCUMENT_ID%', '%DOC_TITLE%');
					$aReplace	= array($this->sServerName, $aNumber["document_id"], $sDocTitle);
					$sBody 		= str_replace($aSearch, $aReplace, $this->oLc->getWord("MAIL_BODY_OVERDUE"));
					$this->oMail->setBody($sBody);
					$this->oMail->save();		
				}
	
			}
		}	
	}
	
	public function	mailController($aNumber)
	{
		$this->oValue->parse($aNumber["controller"]);
		$aController = $this->oValue->getKeysList();
		$Document 	= $this->oDocFacade->getDocumentById($aNumber["document_id"]);
		$sDocTitle = $Document->getRowTitle();
		foreach ($aController AS $ControllerItem) {
			if (isset($ControllerItem[0])) {
				$this->oMail->setStructureIds(array($ControllerItem[0]));
				$this->oMail->setFrom("", "Detrix");
				$this->oMail->setSubject($this->oLc->getWord("MAIL_SUBJECT_OVERDUE") . $sDocTitle);
				$aSearch	= array('%SERVER_NAME%','%DOCUMENT_ID%', '%DOC_TITLE%');
				$aReplace	= array($this->sServerName, $aNumber["document_id"], $sDocTitle);
				$sBody 		= str_replace($aSearch, $aReplace, $this->oLc->getWord("MAIL_BODY_OVERDUE"));
				$this->oMail->setBody($sBody);
				$this->oMail->save();
			}
		}
	}
	
	private function isWorkDay()
	{
		$bSend = true;
		$sWorkDaysXml = MSF_File::read(CNF_ABS_PATH . "/work_days.xml");
		$aWorkDaysXml = $this->oXmlWrapper->xmlToArray($sWorkDaysXml);
		if (in_array(date("w", time()), $aWorkDaysXml["weekend"]["value"])) {
			$bSend = false;
			if (isset($aWorkDaysXml["exceptions"]["value"]) && in_array(date("d.m.Y", time()), $aWorkDaysXml["exceptions"]["value"])) {
				$bSend = true;
			}
		}
		if (in_array(date("d.m.Y", time()), $aWorkDaysXml["holidays"]["value"])) {
			$bSend = false;
		}
		
		return $bSend;
	}
	
	public static function test()
	{
		$oDb 		= new MSF_DB();
		$oDb->connect('server', 'manuscript', 'detrix', '1', 'manuscript');
		$oTestAO 	= AtomicOperation::create(MSF_Registry::get("MSF_DB"), 'ControlAtomicOperation.php', 'ControlAtomicOperation', array(1 => 1));
		$oTestAO->execute();
		
	}
}

?>