<?php
//tst
//DEFINE('__MSF', true);
//DEFINE('CNF_ABS_PATH', 'D:/projects/msf.lcl/wwwroot');
//DEFINE('CNF_ABS_PATH', '/var/www/dev');
//DEFINE('CNM_MEDIA_UPLOAD_DIRECTORY', '/var/www/dev/var/files/uploads');
//DEFINE('CNM_MEDIA_LINKS_DIRECTORY', '/var/www/dev/var/files/uploads');
//DEFINE('CNM_MEDIA_IMAGE_CACHE_DIRECTORY', '/var/www/dev/var/files/uploads');
set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
//include_once 'system/MSF_ThrowableException.php';
//include_once 'system/MSF_Registry.php';
//include_once 'system/utils/MSF_DB.php';
//include_once 'cs/library/AtomicOperation.php';
//include_once 'system/debug.php';
//include_once "modules/media/library/MD_Media.php";

//prd
include_once 'system/MSF_Locale.php';
include_once "modules/references/library/Reference/REF_Value.php";
include_once "system/utils/MSF_Date.php";
include_once "modules/workflow/library/common/WF_Exception.php";
include_once 'modules/workflow/library/doctype/WF_Doctype.php';
include_once 'modules/workflow/library/document/WF_Document.php';
include_once 'system/utils/MSF_XmlWrapper.php';
include_once "modules/references/library/Reference/REF_Fields.php";
include_once "library/MSF_SearchUtil/MSF_SearchUtil.php";
include_once 'system/utils/MSF_DBRecord.php';
include_once 'library/MSF_SearchUtil/MSF_CsIndexedDB.php';
include_once "system/utils/MSF_XmlWrapper.php";
include_once "system/mvc/MSF_ViewSupportXml.php";
include_once "system/utils/MSF_SL.php";
include_once "system/mvc/MSF_ModelDBSupport.php";
include_once "modules/references/library/Reference/UserReferenceDB.php";
include_once "modules/references/library/Reference/UserReference.php";
include_once 'modules/lms/library/LMS_Mail.php';
include_once 'modules/lms/library/LMS_MailDB.php';
include_once 'system/MSF_MsfxSupport.php';
include_once 'library/MSF_DBTree/MSF_DBTree.php';
include_once 'msfx/userbox/MSF_UserBoxExtension.php';
include_once 'system/MSF_Template.php';
include_once 'system/utils/MSF_String.php';
include_once 'system/MSF_Settings.php';
include_once 'library/MSF_FileWrapper/MSF_ContentWrapperFactory.php';


class IndexAtomicOperation extends AtomicOperation
{
	private $IndexedDB	= 0;
	
	private function init()
	{
		MSF_Registry::set("MSF_DB", $this->getDb());
		MSF_Registry::set("MSF_Locale", new MSF_Locale('cs/languages/russian.ini'));
		MSF_Registry::set("MSF_UserBox", MSF_UserBox::getInstance());
		MSF_Registry::set("MSF_Template", new MSF_Template());
		MSF_Registry::set("MSF_Settings", MSF_Settings::getInstance('<document></document>'));
		$this->IndexedDB 	= new MSF_CsIndexedDB('cs_indexed', 'indexed_id');
		$this->IndexedDB->resetSequence();
	}

/*	private function log($sStr) {
		//$sFile = "/var/www/dev/var/logs/indexAO.log";
		$sFile = "D:/projects/msf.lcl/wwwroot/var/logs/indexAO.log";
		$fp = fopen($sFile, "a");
		fwrite($fp, $sStr);
		fclose($fp);
	}*/
	
	public function execute() 
	{
		$this->init();
        $aIndexed  = $this->IndexedDB->find("indexed_id, subject_id, context_id, module, operation", 
        							  		"1=1 ORDER BY module DESC LIMIT " . $this->getParam("limit"), array());
       	
        foreach ($aIndexed AS $sValue) {
			try {
	        	$this->IndexedDB->remove('indexed_id = ' . $sValue["indexed_id"]);
	        	if (in_array($sValue["module"], array("mail", "reference", "workflow"))) {
	        		if (!$this->remove($sValue)) {
	        			$this->index($sValue);
	        		}
	        		
	        	}
	        	
			}
			catch (Exception $e) {
/*		    	$this->log(
	        			"ERR: Operation:" . $sValue["operation"] . " " .
	        			"module: ".$sValue["module"] . " " .
	        			"context_id: " . $sValue["context_id"] . " " .
	        			"subject_id: " . $sValue["subject_id"] . "\n" .
		    			$e->getMessage() . "\n" .
	        			$e->getTraceAsString()
	        			);*/
			}
        	
        }
        
	}
	
	private function remove($sValue) 
	{
		return $this->IndexedDB->findOperation(
				$sValue["subject_id"], 
				$sValue["module"], 
				'remove', 
				$sValue["context_id"]
				);	
	}
	
	private function index($sValue) 
	{
		switch ($sValue["module"]) {
			case "workflow":
				$this->workflowIndex($sValue["subject_id"], $sValue["context_id"], $sValue["operation"]);
				break;
			case "reference":
				$this->referenceIndex($sValue["subject_id"], $sValue["context_id"], $sValue["operation"]);
				break;
			case "mail":
				$this->mailIndex($sValue["subject_id"], $sValue["context_id"], $sValue["operation"]);
				break;
		}

	
	}
	
	public function workflowIndex($iSubjectId, $iContextId, $sOperation) 
	{
		$Doctype 		= new WF_Doctype($iContextId);
		if ($sOperation == 'index') {
			$oF 			= new WF_DocFacade();
			$Document		= $oF->getDocumentById($iSubjectId);
			if ($Document != null) {
				$aFieldsXml 	= $Document->getCurrentVersion()->getFieldsAsList();
				$sText 			= "";
				$oMedia 		= new MD_Media(new MD_MediaDB(MSF_Registry::get("MSF_DB")));
				// indexing document fields
				foreach ($aFieldsXml AS $aBody) {
					if ($aBody["type"] == "picture") {
						$aFiles = explode(',', $aBody['value']);
						foreach ($aFiles AS $sFile) {
							$aMedia = $oMedia->getFileInfo($sFile);
							if (!empty($aMedia)) {
								$sText .= " " . $aMedia["name"];
							}
						}
					}
					else if($aBody["type"] == "file")
					{
                        $aFilesIds = explode(',', $aBody['value']);
                        foreach($aFilesIds as $iFileId)
                        {
                            $aFile = $oMedia->getFileInfo($iFileId);
                            if (isset($aFile['name']) && isset($aFile['directory']) && isset($aFile['file_id'])) {
	                            $sFileExtension = substr(strrchr($aFile['name'], '.'), 1);
	                            $sText .= ' '.$aFile['name'].' ';
	                            $cont = MSF_ContentWrapperFactory::create(CNF_ABS_PATH .'/'. $aFile['directory'].'/'.$aFile['file_id'], $sFileExtension);
	                            $sText .= $cont;
                            }
                        }
					}
					elseif ($aBody["type"] == "table")
					{
						$aTmp 	= explode("^R^", urldecode(str_replace(array("&#160;", "^S^"), " ", $aBody["value"])));
						if (isset($aTmp[2])) {
							$aTxt	= explode("^C^", $aTmp[2]);
							$sTmp = implode(' ', $aTxt);
							$sText .= $sTmp; 
						}
						$aFiles = $this->parseTable($aBody["value"]);
						for ($i=0; $i<sizeof($aFiles); $i++) {
							$aFile = $oMedia->getFileInfo($aFiles[$i]);
							if (isset($aFile['name']) && isset($aFile['directory']) && isset($aFile['file_id'])) {
	                            $sFileExtension = substr(strrchr($aFile['name'], '.'), 1);
	                            $sText .= ' '.$aFile['name'].' ';
	                            $cont = MSF_ContentWrapperFactory::create(CNF_ABS_PATH .'/'. $aFile['directory'].'/'.$aFile['file_id'], $sFileExtension);
	                            $sText .= $cont;
							}
						}
					}
					elseif ($aBody["type"] == "text") {
						//$this->log("File parsing\n");
						$aFiles = $this->parseText($aBody["value"]);
						for ($i=0; $i<sizeof($aFiles); $i++) {
							$aFile = $oMedia->getFileInfo($aFiles[$i]);
							if (isset($aFile['name']) && isset($aFile['directory']) && isset($aFile['file_id'])) {
/*								$this->log("File name: " . $aFile['name'] . "\n");
								$this->log("Dir: " . $aFile['directory'] . "\n");
								$this->log("File id: " . $aFile['file_id'] . "\n");*/
								
	                            $sFileExtension = substr(strrchr($aFile['name'], '.'), 1);
	                            $sText .= ' '.$aFile['name'].' ';
	                            $cont = MSF_ContentWrapperFactory::create(CNF_ABS_PATH .'/'. $aFile['directory'].'/'.$aFile['file_id'], $sFileExtension);
	                            $sText .= $cont . " " . $aBody["value"];
	                            //$this->log("Content: " . $cont . "\n");
							}
							else {
								$sText .= " " . $aBody["value"];	
							}
						}
					}
					else {
						$sText .= " " . $aBody["value"];
					}
					
				}

				$aLog		= $Document->getLog()->getFullLog();
				foreach (MSF_SL::getParam($aLog, 'display', array()) AS $aEntry) {
					if ($aEntry['employeeName'] !== 'DEBUG') {
						$sText .= ' ' . $aEntry['fullText'];
					}
					
				}

				// indexing system document fields and vars	
				$sSettings = file_get_contents(CNF_ABS_PATH . "/settings.xml");
		
				$oSettings = new MSF_Settings($sSettings);
				foreach ($oSettings->getConstants() AS $sConstantName => $sConstantValue) {
					if (!defined($sConstantName)) {
						DEFINE($sConstantName, $sConstantValue);
					}

				}

				date_default_timezone_set(CNF_TIME_ZONE);
				MSF_Registry::set("MSF_Settings", $oSettings);		
				$oActionBox	   = WF_ActionBox::newInstance();
				$oActionBox->loadAction("view", 0, $iSubjectId, null, true);
				$oAction	   = $oActionBox->getAction();
				$oVars		   = new WF_Vars($oAction);
				foreach ($oVars->getList() AS $aField) {
					if ($aField["name"] != "current_date" && $aField["name"] != "current_date_time") {
						//ne trogat'... eto vremennya otladka
						$sText .= " " . $aField["html"];
					}
				}
						
				MSF_SearchUtil::newInstance()->removeIndex("wf_index", $Doctype->getFolderId(), $iSubjectId);
				MSF_SearchUtil::newInstance($sText)->createIndex("wf_index", $Doctype->getFolderId(), $iSubjectId);
			}
			else {
				MSF_SearchUtil::newInstance()->removeIndex("wf_index", $Doctype->getFolderId(), $iSubjectId);
			}
		}
		if ($sOperation == 'remove') {
			MSF_SearchUtil::newInstance()->removeIndex("wf_index", $Doctype->getFolderId(), $iSubjectId);
		}
	}
	private static function parseTable($sStr) {
		$aResult = array();
		try {
			if ($sStr) {
				$aVar 	= explode("^R^", urldecode(str_replace(array("&#160;", "^S^"), " ", $sStr)));
				for ($i=2; $i<sizeof($aVar); $i++) {
					$aVar2	= explode("^C^", $aVar[$i]);
					for ($j=0; $j<sizeof($aVar2); $j++) {
						if (strpos($aVar2[$j],":.:")) {
							$aRows 	= explode(":.:", $aVar2[$j]);
							if (isset($aRows[1])) $aTmp[] = $aRows[1];
						}
					}
				}
				if (isset($aTmp)) {
					$aResult = $aTmp;
				}
			
			}
		}
		catch(Exception $e) {
			$this->log($e->getMessage());
		}
		return $aResult;
	}
	
	private static function parseText($sStr) {
		$aResult = array();
		$aOut = array();
		preg_match_all('~href=("|\')(.*?)\1~', $sStr, $aOut);
		if (isset($aOut[2])) {
			for($j=0; $j<sizeof($aOut[2]); $j++) {
				if (isset($aOut[2][$j])) {
					$aTmp = explode("/", $aOut[2][$j]);
					if (isset($aTmp[3])) {
						$iFile =  (int) $aTmp[3];
						if ($iFile)	$aResult[] = $iFile; 
					}
				}
			}
		}
		return $aResult;
	}
	
	
	public function referenceIndex($iSubjectId, $iContextId, $sOperation)
	{	
		if($sOperation == "index") {		
			$UserReference = new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
			$UserReference->load($iContextId, array());
			$aFields 	= $UserReference->row($iSubjectId)->getAsHash();						
			$aFileNames	= array();
			$Media		= new MD_Media(new MD_MediaDB(MSF_Registry::get("MSF_DB")));				
			foreach($UserReference->getFields() as $aField) {
				if(in_array($aField["type"], array("picture", "file"))) {
					$aIds	= explode(",", $aFields[$aField["name"]]);
					
					foreach($aIds as $iId) {
						if((int)$iId > 0) {
							$aFileInfo	= $Media->getFileInfo($iId);
							array_push($aFileNames, $aFileInfo["name"]);
							
							// content indexing
							// rinatous, 2010/12/09
							if($aField["type"] == 'file')
							{
                                $sFileExtension = substr(strrchr($aFileInfo['name'], '.'), 1);
                                $sText = MSF_ContentWrapperFactory::create(CNF_ABS_PATH .'/'. $aFileInfo['directory'].'/'.$aFileInfo['file_id'], $sFileExtension);
                                array_push($aFileNames, $sText);
                            }
						}									
					}					
				}
			}
			MSF_SearchUtil::newInstance()->removeIndex("ref_index", $iContextId, $iSubjectId);							
			MSF_SearchUtil::newInstance(implode(" ", $aFields) . " " . implode(" ", $aFileNames))
										->createIndex("ref_index", $iContextId, $iSubjectId);
		}
		else {
			MSF_SearchUtil::newInstance()->removeIndex("ref_index", $iContextId, $iSubjectId);
		}		
	}
	
	public function mailIndex($iSubjectId, $iContextId, $sOperation) 
	{
		if ($sOperation == "index") {
			$aMail 		= $this->IndexedDB->open($iSubjectId, $this->getFolder($iContextId));
			if (!isset($aMail["subject"])) {
				$aMail["subject"] = "";
			}
			if (!isset($aMail["from_name"])) {
				$aMail["from_name"] = "";
			}
			if (!isset($aMail["to_email"])) {
				$aMail["to_email"] = "";
			}
			if (!isset($aMail["from_email"])) {
				$aMail["from_email"] = "";
			}
			if (!isset($aMail["body"])) {
				$aMail["body"] = "";
			}
			
			// content indexing
			// rinatous, 2010/12/09
			$sAttachmentsContent = '';
			if(isset($aMail['attachments']) && $aMail['attachments'] == 'Y')
			{
                $oMedia = new MD_Media(new MD_MediaDB(MSF_Registry::get("MSF_DB")));
                $aFiles = $oMedia->getFiles("lms_" . $iContextId, $aMail["email_id"]);
                foreach($aFiles as $aFile)
                {
                    $sFileExtension = substr(strrchr($aFile['name'], '.'), 1);
                    $sText = MSF_ContentWrapperFactory::create(CNF_ABS_PATH .'/'. $aFile['directory'].'/'.$aFile['file_id'], $sFileExtension);
                    $sAttachmentsContent .= ' ' . $sText; 
                }

			}
			
			
			MSF_SearchUtil::newInstance()->removeIndex("lms_index", $iContextId, $iSubjectId);
			MSF_SearchUtil::newInstance(
				$aMail["subject"] . " " .
				$aMail["from_name"] . " " .
				$aMail["to_email"] . " " .
				$aMail["from_email"] . " " .
				$aMail["body"]. ' ' .
				$sAttachmentsContent
			)->createIndex("lms_index", $iContextId, $iSubjectId);
		}
		if ($sOperation == 'remove') {
			MSF_SearchUtil::newInstance()->removeIndex("lms_index", $iContextId, $iSubjectId);
		}
	}
	
	private function getFolder($iFolderId)
	{
		$sFolder = "";

		switch ($iFolderId) {
			case -1:
			case 0:
				$sFolder = "inbox";
				break;
			case 1:
				$sFolder = "outbox";
				break;
			case 2:
				$sFolder = "sent";
				break;
			case 3:
				$sFolder = "draft";
				break;
			case 4:
				$sFolder = "trash";
				break;
			default:
				$sFolder = "messages";
				break;
		}
		$sTable 	= "lms_" . $sFolder;
		return $sTable;	
	}
		
	public static function test() 
	{
		$oDb 		= new MSF_DB();
		$oDb->connect('127.0.0.1', 'dev', 'detrix', '12345', 'manuscript');
		MSF_Registry::set("MSF_DB", $oDb);
		MSF_Registry::set("MSF_Locale", new MSF_Locale('cs/languages/russian.ini'));
		$oTestAO 	= AtomicOperation::create(MSF_Registry::get("MSF_DB"), 'IndexAtomicOperation.php',
											   'IndexAtomicOperation', array('limit' => 25));
		//exit();
		$oTestAO->execute();
	}
}
//IndexAtomicOperation::test();
?>