<?php
//DEFINE('__MSF', true);
//DEFINE('CNF_ABS_PATH', 'D:/projects/msf.lcl/wwwroot');
set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
include_once "cs/library/AtomicOperation.php";
include_once "system/MSF_ThrowableException.php";
include_once "system/utils/MSF_DB.php";
include_once "system/MSF_Registry.php";

class LogsCleanerAtomicOperation extends AtomicOperation {
	
	public function execute()
	{		
		$this->cleanLogsInDir(CNF_ABS_PATH . "/var");
	}
	
	public function cleanLogsInDir($sDir)
	{
		
		if ($sDh = opendir($sDir)) {								
			while (($sFile = readdir($sDh)) !== false) {						
				if(fnmatch('*.log', $sFile) && !is_dir($sFile)) {
					$iSize = filesize($sDir . "/" . $sFile);
					if($iSize > CNF_MAX_LOG) {
						$sFh = fopen( $sDir . "/" .  $sFile , "r" );
						ftruncate($sFh , 0);
						fclose($sFh);						
					}
					
				}
				else if(is_dir($sDir . "/" . $sFile) && $sFile != "." && $sFile != "..") {					
					$this->cleanLogsInDir($sDir . "/" .  $sFile);
				}
				
			}
			
			closedir($sDh);
    	}
	}
	
	public static function test()
	{		
		$oDb 		= new MSF_DB();
		$oDb->connect('server', 'manuscript', 'detrix', '1', 'manuscript');
		MSF_Registry::set("MSF_DB", $oDb);		
		$oTestAO 	= AtomicOperation::create(MSF_Registry::get("MSF_DB"), 'LogsCleanerAtomicOperation.php',
											   'LogsCleanerAtomicOperation', array('limit' => 50));
		
		$oTestAO->execute();
	}
}

//LogsCleanerAtomicOperation::test();
?>