<?php
		//DEFINE('__MSF', true);
		//DEFINE('CNF_ABS_PATH', 'D:/projects/msf.lcl/wwwroot');
		set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
		
		include_once "cs/library/AtomicOperation.php";
		include_once "system/MSF_ThrowableException.php";
		include_once "system/MSF_Locale.php";
		include_once "system/utils/MSF_DB.php";		
		include_once "system/MSF_Registry.php";
		include_once "system/utils/MSF_XmlWrapper.php";
		include_once "system/mvc/MSF_ModelDBSupport.php";
		include_once "library/MSF_DBTree/MSF_DBTree.php";		
		include_once "msfx/userbox/library/MSF_UserBox.php";
		include_once "system/MSF_Template.php";
		include_once "system/MSF_IOException.php";
		include_once "system/utils/MSF_String.php";
		include_once "system/utils/MSF_File.php";
		include_once "system/MSF_Settings.php";				
		include_once "msfx/messenger/library/MSF_Messenger.php";		
		include_once "modules/references/library/Reference/UserReference.php";
		include_once "modules/references/library/Reference/REF_Fields.php";
		include_once "modules/references/library/Reference/REF_SystemFieldsSettings.php";
		include_once "system/utils/MSF_SL.php";
		include_once "modules/1cv81/library/V81_ExchangerDB.php";
		include_once "library/NuSoap/nusoap.php";
		include_once "system/utils/MSF_Date.php";
		include_once "modules/main/library/orgStructure/MSF_OrgStructureFacade.php";
		include_once "msfx/basket/MSF_Basket.php";

class MSF_SynchronizationOperation extends AtomicOperation {
	
	const code = "Код";
	private $sRefName;	
	
	public function execute()
	{
		MSF_Registry::set("MSF_DB", $this->getDb());
		MSF_Registry::set("MSF_Locale", new MSF_Locale('cs/languages/russian.ini'));
		MSF_Registry::set("MSF_UserBox", MSF_UserBox::getInstance());
		MSF_Registry::set("MSF_Template", new MSF_Template());
		$Template = MSF_Registry::get("MSF_Template");
		MSF_Registry::set("MSF_Messenger", new MSF_Messenger($Template));
		$iTimeout = $this->getParam("timeout1");
		$this->setParam("timeout", $iTimeout);
		$this->syncChangesMSF();
		
	}
	
	public function getChangedData($iPeriodBegin, $aComparedFields, $sNew, $sEdit, $sDelete)
	{
		//$oSystemFieldsSettings = new REF_SystemFieldsSettings();
		//$aSysFields 		   = $oSystemFieldsSettings->getSystemFieldsNames();
		$aCompFieldsHash	   = array();
		$oBasket 			   = new MSF_Basket();
		try {		
			$oReference		   = new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
			$oReference->loadByName($this->sRefName, array());
		}
		catch(Exception $oException) {
			exit();
		}
		$aFields 			   = $oReference->getAsArray();		
		$aRemFields 		   = $oBasket->getRefData($oReference->getId());
		// Найдем физ. имя поля, которое сопоставлено полю "Код"
		$sCodeKey = "";
		foreach($aComparedFields AS $Key => $Value) {
			if($Value == self::code) {
				$sCodeKey = $Key;				
			}
			else {
				$aCompFieldsHash[] = $Key;
			}			
			
		}
		
		$aNewFields = array();
		$iId = 0;
		for($i = 0; $i < count($aFields); $i++) {
			$iKey = $aFields[$i]["id"];
			$aRow = $oReference->row($iKey)->getAsHash();			
			$iModified = strtotime($aRow["modified_at"]);			
			if($iModified > $iPeriodBegin) {				
				if($aRow[$sCodeKey] == "") {
					$aNewFields[$iId]["action"] = "add";
				}
				else {
					$aNewFields[$iId]["action"] = "edit";
				}
				
				$aNewFields[$iId]["id"] = $iKey;
				$aNewFields[$iId]["link"] = $aRow[$sCodeKey];								
				foreach($aRow AS $Key => $Value) {
					if(in_array($Key, $aCompFieldsHash)) {
						$aNewFields[$iId]["fields"][] = 
							array(
								"name" => $aComparedFields[$Key],
								"value" => $Value);
					}					
					
				}
				
				$iId++;
			}		
			
		}
		
		// Добавление к списку полей, которые удалены
		for($i = 0; $i < count($aRemFields); $i++) {
			if($aRemFields[$i]["date"] > $iPeriodBegin && $aRemFields[$i]["fields"][$sCodeKey] != "") {
					$TmpCol 		  = array();
					$TmpCol["action"] = "delete";
					$TmpCol["id"]	  = $aRemFields[$i]["id"];
					$TmpCol["link"]	  = $aRemFields[$i]["fields"][$sCodeKey];
					$TmpCol["fields"] = array();
					array_push($aNewFields, $TmpCol);
				}
		}		
		
		// Преобразование массива в строку с разделителями
		$sResult = "";
		for($i = 0; $i < count($aNewFields); $i++) {
			if($aNewFields[$i]["action"] == "add" && $sNew == "yes" || 
				$aNewFields[$i]["action"] == "edit" && $sEdit == "yes" ||
					$aNewFields[$i]["action"] == "delete" && $sDelete == "yes") {
						$sResult .= $aNewFields[$i]["action"]."-;-".$aNewFields[$i]["id"]."-;-".$aNewFields[$i]["link"]."-;-";
						for($j = 0; $j < count($aNewFields[$i]["fields"]); $j++) {
							$sResult .= $aNewFields[$i]["fields"][$j]["name"]."-;-".$aNewFields[$i]["fields"][$j]["value"]."-;-";
						}
						
						$sResult .= "-:-";						
					}
						
		}		
		
		return $sResult;
	}
	
	public function syncChangesMSF()
	{
		// Параметры обмена		
		$this->sRefName = $this->getParam("refname");
		$wsdlUrl		= $this->getParam("wsdl");
		$sLogin 		= $this->getParam("login");
		$sPassword  	= $this->getParam("password");
		$sPeriod		= $this->getParam("period");	
		
		/*echo "\nWSDL: ";
		var_dump($wsdlUrl);
		echo "\nЛогин: ";
		var_dump($sLogin);
		echo "\nПароль: ";
		var_dump($sPassword);
		echo "\nИсх. справочник:\n";
		var_dump($this->sRefName);*/		
		//$this->sRefName = "Склады";
		//$wsdlUrl		= "http://127.0.0.1/ws/1C/Operation1C.1cws?wsdl";		
		//$sPeriod		= "2000-01-01 01:01:01";			
		
		// Чтение информации о сопоставленных полях и получение массива сопоставленных полей
		$oXMLWrapper 	 	= new MSF_XmlWrapper;
		$DBRecord	  	 	= new V81_ExchangerDB('v81_comparison', 0);
		$aQueryResult 	 	= $DBRecord->find("*" , "ref_doc_name = '".$this->sRefName."' AND direction = 'MSF'", array());
		$aPreComparedFields = $oXMLWrapper->xmlToArray($aQueryResult[0]["compared_xml"]);
		$v81RefName		 	= $aQueryResult[0]["ref_v81_name"];
		$aComparedFields 	= array();
		foreach($aPreComparedFields AS $Key => $Value) {
			$aComparedFields[$Value["value"]] = $Key;
		}
		
		$iPeriod = strtotime($sPeriod);				
		$sData = $this->getChangedData($iPeriod, $aComparedFields, $aQueryResult[0]["is_new"], 
			$aQueryResult[0]["is_edit"], $aQueryResult[0]["is_delete"]);			

		// Создаем экземпляр клиента						
		$client 	= new nusoap_client($wsdlUrl, true);
		$client->setCredentials($sLogin, $sPassword, "basic");
		$client->decode_utf8 = false;
		$client->soap_defencoding = 'UTF-8';
		try {		
			$a1CPreResult = $client->call('SynchronizeFromMSF', array('sRefName' => $v81RefName, 'sData' => $sData));
		}
		catch(Exception $oException) {
			$sMsg	= $oException->getMessage();						
			print_r(substr($sMsg, 0, strpos($sMsg, "\n")));
			echo "\n";
			return;	
		}
		
		$a1CResult = array();
		if(isset($a1CPreResult["return"]["value"])) {
			if(!isset($a1CPreResult["return"]["value"][0])) {
				$a1CResult[0] = $a1CPreResult["return"]["value"];
			}
			else {
				$a1CResult = $a1CPreResult["return"]["value"];
			}
			
		}			
		
		/*echo "\nИсх. данные:\n";
		var_dump($sData);		
		echo "\nСправочник: ";
		var_dump($v81RefName);		
		echo "\nРезультат:";
		var_dump($a1CPreResult);*/		
			
		if(isset($a1CPreResult["return"])) {
			try {
				$oReference	= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
				$oReference->loadByName($this->sRefName, array());
			}
			catch(ReferenceException $oException) {
				exit();
			}
			for($i = 0; $i < count($a1CResult); $i++) {
				$sKey = $aPreComparedFields[self::code]["value"];
				$aRow = $oReference->row($a1CResult[$i]["name"])->show();
				for($j = 0; $j < count($aRow); $j++) {
					if($aRow[$j]["name"] != $sKey) {
						$aInput[$aRow[$j]["name"]] = $aRow[$j]["value"];
					}
				}		
				
				$aInput[$sKey] = $a1CResult[$i]["value"];			
				$oReference->row($a1CResult[$i]["name"])->save($aInput);
			}
			
			$sNewPeriod 	= date("Y-m-d H:i:s");			
			$this->setParam("period", $sNewPeriod);				
		}
		
	}
	
	public static function test()
	{

		$oDb 		= new MSF_DB();
		$oDb->connect('server', 'manuscript', 'detrix', '1', 'manuscript');
		MSF_Registry::set("MSF_DB", $oDb);		
		$oTestAO 	= AtomicOperation::create(MSF_Registry::get("MSF_DB"), 'MSF_SynchronizationOperation.php',
											   'MSF_SynchronizationOperation', array('limit' => 25));
		
		$oTestAO->execute();

	}
}
//MSF_SynchronizationOperation::test();
?>