<?php
if (!defined('__MSF')) {
	exit('Direct access is not allowed');
}

set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
/**
 * 
 */
class ReindexAtomicOperation extends AtomicOperation 
{	
	public function execute() 
	{	
		$this->debug("Start reindexing");
		$this->debug("Load table list");
		$oDb = $this->getDb();
		foreach ($this->getAllTables() AS $aTable) {
			$this->debug("Reindex table " . $aTable["tablename"]);
			$oDb->executeQuery("REINDEX TABLE " . $aTable["tablename"]);
		}
		
		$this->debug("Finish reindexing");
	}
	
	public function getAllTables()
	{
		$sSql 	= "SELECT * "
				. "FROM pg_tables "
				. "WHERE "
				. "tablename !~'^pg' "
				. "AND "
				. "tablename !~'^sql'";
		return $this->getDb()->select($sSql);
	}
	
}

?>