<?php
//tst
//DEFINE('__MSF', true);
//DEFINE('CNF_ABS_PATH', 'C:/projects/msf.lcl/wwwroot');
set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
//include_once 'system/MSF_ThrowableException.php';
//include_once 'system/utils/MSF_DB.php';
//include_once 'cs/library/AtomicOperation.php';


if (!defined('__MSF')) {
	exit('Direct access is not allowed');
}
//prd
//set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
include_once 'RemindAtomicOperationDB.php';
include_once 'modules/workflow/actions/remind/WF_Remind.php';
include_once "system/utils/MSF_Date.php";
include_once 'modules/workflow/actions/remind/WF_DateFormatter.php';

include_once "system/mvc/MSF_ModelDBSupport.php";
include_once "system/mvc/MSF_ViewSupportXml.php";
include_once 'system/MSF_Registry.php';
include_once "modules/workflow/library/common/WF_Exception.php";
include_once 'modules/lms/library/LMS_Mail.php';
include_once 'modules/lms/library/LMS_MailDB.php';
include_once 'system/MSF_MsfxSupport.php';
include_once 'library/MSF_DBTree/MSF_DBTree.php';
include_once 'system/utils/MSF_XmlWrapper.php';
include_once 'system/MSF_Locale.php';
include_once 'msfx/userbox/MSF_UserBoxExtension.php';
include_once 'system/MSF_Template.php';
include_once 'system/utils/MSF_String.php';
include_once 'system/utils/MSF_SL.php';
include_once 'system/MSF_Settings.php';
include_once 'modules/main/library/orgStructure/MSF_OrgStructureFacade.php';
include_once 'modules/workflow/library/actions/WF_DocFacade.php';
include_once 'modules/workflow/library/doctype/WF_Doctype.php';
include_once 'modules/workflow/actions/control/WF_WorkDateUtil.php';


class RemindAtomicOperation extends AtomicOperation 
{
	
	private $oQuery 		  	= null;
	
	private $oLc 			  	= null;
	
	private $oMail 			  	= null;
	
	private $oStructureFacade 	= null;
	
	private $oDocFacade		  	= null;
	
	private $oXmlWrapper		= null;
	
	private function prepare() 
	{
		MSF_Registry::set("MSF_DB", $this->getDb());
		MSF_Registry::set("MSF_Locale", new MSF_Locale('cs/languages/russian.ini'));
		MSF_Registry::set("MSF_UserBox", MSF_UserBox::getInstance());
		MSF_Registry::set("MSF_Template", new MSF_Template());
		MSF_Registry::set("MSF_Settings", MSF_Settings::getInstance('<document></document>'));
		$this->oQuery 			= new RemindAtomicOperationDB($this->getDb());
		$this->oLc				= new MSF_Locale('modules/workflow/languages/russian.ini');
		$this->oMail 			= new LMS_Mail(new LMS_MailDB($this->getDb()));
		$this->oStructureFacade = MSF_OrgStructureFacade::getInstance();
		$this->oDocFacade		= new WF_DocFacade();
		$this->oXmlWrapper		= new MSF_XmlWrapper();
		$this->sServerName		= CNF_HOST_URL;
	} 
	
	public function execute() 
	{
		$this->prepare();
		$aTempDocId 	= array();
		$i				= 0;
		$aRemind 	= $this->oQuery->selectTime(time());				
		foreach ($aRemind AS $aNumber) {
			if ($this->oDocFacade->getDocumentById($aNumber["document_id"]) !== null && $this->oStructureFacade->isStructureId($aNumber["structure_id"])) {
				$this->mail($aNumber);
			}
			else if (array_search($aNumber["document_id"], $aTempDocId) == false) {
				$this->oQuery->remove($aNumber["document_id"]);
				$aTempDocId[$i] = $aNumber["document_id"];
				$i++;
			}
		}
	}
	
	public function mail($aNumber) 
	{
		$this->oMail->setStructureIds(array($aNumber["structure_id"]));
		$this->oMail->setFrom("", "Detrix");
		$this->oMail->setSubject($this->oLc->getWord("MAIL_SUBJECT_REMIND") . $this->oDocFacade->getDocumentById($aNumber["document_id"])->getRowTitle());
		$aSearch	= array('%SERVER_NAME%', '%DOCUMENT_ID%', '%DOC_TITLE%');
		$aReplace	= array($this->sServerName, $aNumber["document_id"], 
							$this->oDocFacade->getDocumentById($aNumber["document_id"])->getRowTitle());
		$sBody = str_replace($aSearch, $aReplace, $this->oLc->getWord("MAIL_BODY_REMIND"));
		$this->oMail->setBody($sBody);
		$this->oMail->save();
		
		$iNewRemind = $this->updateRemindAt($aNumber["frequency"], $aNumber["remind_at"]);
		$this->oQuery->update($aNumber["remind_id"], $iNewRemind);
	}
	
	public function updateRemindAt($sFrequency, $iRemind) 
	{
		$iNewRemind = 0;
		$iDay		= date("d", $iRemind);
		$iMonth		= date("m", $iRemind);
		$iYear		= date("Y", $iRemind);
		$iMinut		= date("i", $iRemind);
		$iHour 		= date("H", $iRemind);
		if ($sFrequency != ""){
			while ($iNewRemind < time()){
				if ($sFrequency == "daily") {
					$iNewRemind		= $this->getWorkTime($iRemind + 86400);
				}
					
				if ($sFrequency == "weekly") {
					$iNewRemind = $iRemind + 604800;
				}
			
				if ($sFrequency == "monthly") {
					$iMonth++;
					$iNewRemind = mktime($iHour, $iMinut, 0, $iMonth, $iDay, $iYear);
				}
			
				if ($sFrequency == "yearly") {
					$iYear++;
					$iNewRemind = mktime($iHour, $iMinut, 0, $iMonth, $iDay, $iYear);	
				}				
				if (is_numeric($sFrequency)) {
					$iNewRemind = $iRemind + $sFrequency;
				}
				$iRemind = $iNewRemind;
			}
		}

		return $iNewRemind;
	}
	
	private function getWorkTime($iTime)
	{
		$sWorkDaysXml 	= MSF_File::read(CNF_ABS_PATH . "/work_days.xml");
		$aWorkDaysXml 	= $this->oXmlWrapper->xmlToArray($sWorkDaysXml);
		
		$bWeekend		= in_array(date("w", $iTime), $aWorkDaysXml["weekend"]["value"]);
		$bExceptions	= (isset($aWorkDaysXml["exceptions"]["value"]) && in_array(date("d.m.Y", $iTime), $aWorkDaysXml["exceptions"]["value"]));
		if ($bWeekend && !$bExceptions) {
			$iTime = $this->getWorkTime($iTime  + 86400);
		}
		
		$bHolidays = (isset($aWorkDaysXml["holidays"]["value"]) && in_array(date("d.m.Y", $iTime), $aWorkDaysXml["holidays"]["value"]));
		if ($bHolidays) {
			$iTime = $this->getWorkTime($iTime + 86400);
		}
		
		return $iTime;
	}

	public static function test() 
	{
		$oDb 		= new MSF_DB();
		$oDb->connect('server', 'manuscript', 'detrix', '1', 'manuscript');
		$oTestAO 	= AtomicOperation::create($oDb, 'RemindAtomicOperation.php', 'RemindAtomicOperation', array(1 => 1));
		$oTestAO->execute();	
	}
	
}

//tst
//RemindAtomicOperation::test();
?>