<?php
		//DEFINE('__MSF', true);
		//DEFINE('CNF_ABS_PATH', 'D:/projects/msf.lcl/wwwroot');
		set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
		
		include_once "cs/library/AtomicOperation.php";
		include_once "system/MSF_ThrowableException.php";
		include_once "system/MSF_Locale.php";
		include_once "system/utils/MSF_DB.php";		
		include_once "system/MSF_Registry.php";
		include_once "system/utils/MSF_XmlWrapper.php";
		include_once "system/mvc/MSF_ModelDBSupport.php";
		include_once "library/MSF_DBTree/MSF_DBTree.php";		
		include_once "msfx/userbox/library/MSF_UserBox.php";
		include_once "system/MSF_Template.php";
		include_once "system/MSF_IOException.php";
		include_once "system/utils/MSF_String.php";
		include_once "system/utils/MSF_File.php";
		include_once "system/MSF_Settings.php";				
		include_once "msfx/messenger/library/MSF_Messenger.php";		
		include_once "modules/references/library/Reference/UserReference.php";
		include_once "modules/references/library/Reference/REF_Fields.php";
		include_once "system/utils/MSF_SL.php";
		include_once "modules/1cv81/library/V81_ExchangerDB.php";
		include_once "library/NuSoap/nusoap.php";
		include_once "modules/main/library/orgStructure/MSF_OrgStructureFacade.php";
		include_once "system/utils/MSF_Date.php";	
		

class V81_SynchronizationOperation extends AtomicOperation
{
	public function execute()
	{
		MSF_Registry::set("MSF_DB", $this->getDb());
		MSF_Registry::set("MSF_Locale", new MSF_Locale('cs/languages/russian.ini'));
		MSF_Registry::set("MSF_UserBox", MSF_UserBox::getInstance());
		MSF_Registry::set("MSF_Template", new MSF_Template());
		$Template = MSF_Registry::get("MSF_Template");
		MSF_Registry::set("MSF_Messenger", new MSF_Messenger($Template));
		$iTimeout = $this->getParam("timeout1");
		$this->setParam("timeout", $iTimeout);				
		$this->syncChanges1C();
	}
	
	public function requestTo1C($sWsdlURL, $sLogin, $sPassword, $sRefName, $aFields, $sPeriod)
	{
		// Создаем экземпляр клиента						
		$client 	= new nusoap_client($sWsdlURL, true);
		$client->setCredentials($sLogin, $sPassword, "basic");
		$client->decode_utf8 	  = false;
		$client->soap_defencoding = 'UTF-8';		
		
		try {
			$a1CResult = (array)$client->call('Operation', array('sString' => $sRefName, 'sPeriod' => $sPeriod));
		}
		catch(Exception $oException) {
			$sMsg	= $oException->getMessage();						
			print_r(substr($sMsg, 0, strpos($sMsg, "\n")));
			echo "\n";
			exit();;
		}
		
		//var_dump($a1CResult);
				
		// Преобразование массива (если не найдется способ нормального возврата)		
		$aResult = array();
		if(isset($a1CResult["return"]["changeDataElement"])) {
			if(isset($a1CResult["return"]["changeDataElement"][0])) {		
				for($i = 0; $i < count($a1CResult["return"]["changeDataElement"]); $i++) {
					$aResult[$i]["action"] = $a1CResult["return"]["changeDataElement"][$i]["action"];
					for($j = 0; $j < count($aFields); $j++) {
						for($k = 0; $k < count($a1CResult["return"]["changeDataElement"][$i]["values"]); $k++) {
							if($aFields[$j] == $a1CResult["return"]["changeDataElement"][$i]["values"][$k]["name"]) {
								$aResult[$i]["values"][] = $a1CResult["return"]["changeDataElement"][$i]["values"][$k]["value"];
							}
							
						}			
						
					}			
					
				}
				
			}
			
			else {				
				$aResult[0]["action"] = $a1CResult["return"]["changeDataElement"]["action"];
				for($j = 0; $j < count($aFields); $j++) {
					for($k = 0; $k < count($a1CResult["return"]["changeDataElement"]["values"]); $k++) {
						if($aFields[$j] == $a1CResult["return"]["changeDataElement"]["values"][$k]["name"]) {
							$aResult[0]["values"][] = $a1CResult["return"]["changeDataElement"]["values"][$k]["value"];
						}
						
					}			
					
				}
				
			}
				
		}

		/*echo "<pre>";
		var_dump($aResult);
		echo "</pre>";*/
				
		return $aResult;		
	}
	
	public function syncChanges1C()
	{
		// Параметры обмена
		$docRefName = $this->getParam("refname");
		$wsdlUrl	= $this->getParam("wsdl");
		$sLogin 	= $this->getParam("login");
		$sPassword 	= $this->getParam("password");
		$sPeriod	= $this->getParam("period");
		$sNewPeriod = date("YmdHis");
		//$docRefName = "Физические личности";
		//$wsdlUrl	= "http://127.0.0.1/ws/1C/Operation1C.1cws?wsdl";		
		//$sPeriod	= "20000101010101";
		//$sNewPeriod = "20090812190000";	
		
		// Чтение информации о сопоставленных полях и получение массива сопоставленных полей
		$oXMLWrapper 	 = new MSF_XmlWrapper;
		$DBRecord	  	 = new V81_ExchangerDB('v81_comparison', 0);
		$aQueryResult 	 = $DBRecord->find("*" , "ref_doc_name = '".$docRefName."' AND direction = '1C'", array());
		$aComparedFields = $oXMLWrapper->xmlToArray($aQueryResult[0]["compared_xml"]);
		$v81RefName		 = $aQueryResult[0]["ref_v81_name"];
		
		// Массив нужных полей для 1С
		foreach($aComparedFields As $Key => $Value) {
			$aFieldsTitles[] = $Key;
		}		
		
		// Вызов сервиса 1С, который возвращает массив					
		$aChangeData = $this->requestTo1C($wsdlUrl, $sLogin, $sPassword, $v81RefName, $aFieldsTitles, $sPeriod);
		if(count($aChangeData) > 0) {
			// Получаем справочник
			try {						
				$oReference	= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
				$oReference->loadByName($docRefName, array());
			}
			catch(ReferenceException $oException) {
				exit();
			}
			
			$iFieldPlace = 0;
			foreach($aComparedFields AS $Key => $Value) {
				if($Key == "Код") {
					$sFindName = $Value["value"];
					break;
				}				
	
				$iFieldPlace++;
			}			

								
			for($i = 0; $i < count($aChangeData); $i++) {
				// Получаем Id элемента по значению его поля
				$iId = $oReference->getRecordIdByFieldValue($sFindName, $aChangeData[$i]["values"][$iFieldPlace]);				
				if($aChangeData[$i]["action"] == "add") {
					$iOrd = 0;
					// Подготовка массива вставляемых данных
					foreach($aComparedFields As $Key => $Value) {
						if(strlen($Value["value"]) != 0) {
							$aInput[$Value["value"]] = $aChangeData[$i]["values"][$iOrd];
						}
						$iOrd++;
					}									
					
					if($iId == -1 && $aQueryResult[0]["is_new"] == "yes") {
						
						$oReference->row(0)->save($aInput);
					}
					
					else if ($iId != -1 && $aQueryResult[0]["is_edit"] == "yes") {
						$oReference->row($iId)->save($aInput);
					}
					
				}
				
				else {
					if($iId != -1 && $aQueryResult[0]["is_delete"] == "yes") {
						$oReference->row($iId)->remove();
					}
					
				}			
				
			}			
			 
			$this->setParam("period", $sNewPeriod);						
		}	
			
	}
	
	public static function test()
	{

		$oDb 		= new MSF_DB();
		$oDb->connect('server', 'manuscript', 'detrix', '1', 'manuscript');
		MSF_Registry::set("MSF_DB", $oDb);		
		$oTestAO 	= AtomicOperation::create(MSF_Registry::get("MSF_DB"), 'V81_SynchronizationOperation.php',
											   'V81_SynchronizationOperation', array('limit' => 25));
		
		$oTestAO->execute();

	}
}

//V81_SynchronizationOperation::test();
?>