<?php

include_once 'AtomUtilDb.php';






class AtomUtil {
	
	/**
	 * @var AtomUtilDb
	 */
	private $oDb = null;
	
	public function __construct(MSF_DB $oDb) {
		$this->oDb = new AtomUtilDb($oDb);
	}
	
	/**
	 * @return AtomUtilDb
	 */
	public function getDb() {
		return $this->oDb;
	}
	
	public function getCountOfAtomsInStatus($iStatus)
	{
		try {
			$iResult = (int) $this->oDb->select("COUNT(*) AS total", "status = $iStatus", true, 'total');
		}
		catch (Exception $oE) {
			$iResult = -1;
		}
		
		return $iResult;
	}
	
	public function resetAtomsByExpiredTTL($sAtomType, $iTTL) {
		$this->oDb->resetAtomsByExpiredTTL($sAtomType, time()- $iTTL);
	}
	
	public function getNextAtom() {
		return $this->oDb->select(
				"*",
				"status = " . CronoSphere::WAITING . " AND start_at < " . time() . " ORDER BY weight, start_at",
		 		true
		 		);
/*
 *  dbg
		return $this->oDb->select(
				"*",
				"status = " . CronoSphere::WAITING . " AND start_at > 0 AND atom_type = 'index' ORDER BY weight, start_at",
		 		true
		 		);
*/
	}
	
	public function save($sAtomType, $iSubjectId, $aSubjectParams,
			$iWeight, $iStartAt, $iStatus, $sSessionId, $iAtomId = 0
	) {
		if ($this->exists($iAtomId)) {
 			$this->oDb->update(
				$sAtomType,
				$iSubjectId,
				$aSubjectParams,
				$iWeight,
				$iStartAt,
				$iStatus,
				$sSessionId,
				$iAtomId
				);
		}
		else {
 			$this->oDb->insert(
				$sAtomType,
				$iSubjectId,
				$aSubjectParams,
				$iWeight,
				$iStartAt,
				$iStatus,
				$sSessionId
				);

		}
		
	}
	
	public function exists($iAtomId) {
		return (int)$this->oDb->select("COUNT(*) AS total", "atom_id = $iAtomId", true, 'total') == 1;
	}
	
	public function reset()
	{
		$this->oDb->resetStatus();
	}	
}
?>