<?php
//DEFINE('__MSF', true);

/*
SET client_encoding = 'UTF8';
SET check_function_bodies = false;
SET client_min_messages = warning;
SET search_path = manuscript, pg_catalog;
SET default_tablespace = '';
SET default_with_oids = true;

CREATE TABLE cs_atoms (
    atom_id serial NOT NULL,
    atom_type character varying,
    subject_id integer,
    subject_params character varying,
    weight integer,
    start_at integer,
    timeout integer,
    status integer
);


ALTER TABLE manuscript.cs_atoms OWNER TO detrix;
ALTER TABLE ONLY cs_atoms ADD CONSTRAINT cs_atoms_pkey PRIMARY KEY (atom_id);
*/

class AtomUtilDb {
	
	private $oDb = null;
	
	public function __construct(MSF_DB $oDb) {
		$this->oDb = $oDb;
	}
	
	public function insert($sAtomType, $iSubjectId, $aSubjectParams,
			$iWeight, $iStartAt, $iStatus, $sSessionId) {
		$sSql = "INSERT INTO cs_atoms (
					atom_type, 
					subject_id , 
					subject_params, 
					weight, 
					start_at, 
					status,
					session_id
				) VALUES (
					'$sAtomType',
					'$iSubjectId',
					'" . serialize($aSubjectParams) . "',
					'$iWeight',
					'$iStartAt',
					'$iStatus',
					'" . $sSessionId . "'
				)";
		$this->oDb->executeQuery($sSql);
		return $this->oDb->insertId();
	}
	
	public function update($sAtomType, $iSubjectId, $aSubjectParams,
			$iWeight, $iStartAt, $iStatus, $sSessionId, $iAtomId) {
		$sSql = "UPDATE cs_atoms
				SET 
					atom_type 		= '$sAtomType', 
					subject_id 		= '$iSubjectId', 
					subject_params 	= '" . serialize($aSubjectParams) . "', 
					weight 			= '$iWeight', 
					start_at 		= '$iStartAt', 
					status 			= '$iStatus',
					session_id		= '" . $sSessionId . "'
				WHERE 
					atom_id 		= '$iAtomId'";
		$this->oDb->executeQuery($sSql);
		return $this->oDb->affectedRows() == 1;
	}
	
	public function resetStatus() {
		$sSql = "UPDATE 
					cs_atoms
				SET 
					status 			= '0',
					session_id		= '****'";
		$this->oDb->executeQuery($sSql);
	}
	
	public function resetAtomsByExpiredTTL($sAtomType, $iTTLTime) {
		$sSql = "UPDATE 
					cs_atoms
				SET 
					status 			= '0',
					session_id		= '****'
				WHERE 
					atom_type = '" . $sAtomType . "'
				AND
					start_at < " . $iTTLTime . "
				AND
					(
						status = 1
					OR
						status = 2
					)";
		$this->oDb->executeQuery($sSql);
	}
	
	public function select($sSubject, $sWhere, $bOneRow = false, $sFieldname = null) {
		$sSql 		= 'SELECT ' . $sSubject . ' FROM cs_atoms WHERE ' . $sWhere;
		$mResult 	= $this->oDb->select($sSql, $bOneRow, $sFieldname);
		if ($sFieldname !== null) {
			// do nothing
		}
		else if (empty($mResult)) {
			// do nothing
		}
		else if ($bOneRow) {
			$mResult['subject_params'] = (array)unserialize($mResult['subject_params']);
		}
		else {
			foreach ($mResult AS $iKey => $aRow) {
				$aRow['subject_params'] = (array)unserialize($aRow['subject_params']);
				$mResult[$iKey] = $aRow;
			}
			
		}	
		
		return $mResult;
	}
	
	public function remove($iAtomId) {
		$sSql = 'DELETE FROM cs_atoms WHERE atom_id = ' . $iAtomId; 
		$this->oDb->executeQuery($sSql);
		return $this->oDb->affectedRows() == 1;
	}
	
	public static function test() {
		echo '<hr/>';

		$oDb 		= new MSF_DB();
		$oDb->connect('server', 'manuscript', 'detrix', '1', 'manuscript');
		$oAuDb 		= new self($oDb);
		$iAtomId 	= $oAuDb->insert('test', 502, array(1=>1), 1, 0, 0, 0);
		if ($iAtomId > 0) {
			echo 'Created.';
		}
		else {
			echo 'Not created'; 
		}
		
		//
		$aAtom = $oAuDb->select("*", "atom_id = $iAtomId", true); 
		if (!empty($aAtom)) {
			echo 'Loaded.';
		}
		else {
			echo 'Not loaded.';
		}

		//
		if ($oAuDb->update('test', 502, array(1=>1), 1, 0, 0, 0, $iAtomId)) {
			echo 'Updated.';
		}
		else {
			echo 'Not updated.';
		}
		
		//
		if ($oAuDb->remove($iAtomId)) {
			echo 'Removed.';
		}
		else {
			echo 'Not removed.';
		}
		
		echo '<hr/>';
	}
	
}


// AtomUtilDb::test();
?>