<?php
		
class CSLauncher {

	protected static $aSettings = array();
	
	public static function main()  {
	}
	
	protected static function initConstants() {
		DEFINE('CNF_ADMIN_USER_ID', 				self::$aSettings['adminUserId']);
		DEFINE('CNF_HOST_URL', 						self::$aSettings['hostURL']);
		DEFINE('CNM_MEDIA_UPLOAD_DIRECTORY', 		self::$aSettings['uploadDirectory']);
		DEFINE('CNF_IS_DEBUG', 						self::$aSettings['isDebug']);
		DEFINE("CNM_MEDIA_LINKS_DIRECTORY",			"");
		DEFINE("CNM_MEDIA_IMAGE_CACHE_DIRECTORY",	"");
		DEFINE("CNF_SKIN", 							"default");
		DEFINE("CNF_MODE", 							"standard");
		DEFINE("MSF_TIME_START",					0);
		DEFINE("MSF_DATE" , 						gmdate("D, d M Y H:i:s") . " GMT");
		DEFINE("MSF_CLIENT", 						"127.0.0.1");
		DEFINE("MSF_HOST", 							"localhost");
		DEFINE("MSF_PORT", 							"80");
		DEFINE("MSF_VERSION", 						"");
		DEFINE("MSF_USE_GZIP",						false);
		DEFINE("IS_REQUEST", 						false);
	}
	
	protected static function initDb() {
		static $oDb = null;
		if ($oDb == null) {
			$oDb 	= new MSF_DB();
			$oDb->connect(
					self::$aSettings['db']['host'], 
					self::$aSettings['db']['database'], 
					self::$aSettings['db']['user'], 
					self::$aSettings['db']['password'], 
					self::$aSettings['db']['scheme'],
					self::$aSettings['db']['port']
                                
					);
		}

		return $oDb;
	}
	
	protected static function resetAtoms() {
		$oDb	= self::initDb();
		$oUtil	= new AtomUtil($oDb);
		$oUtil->reset();
		$oDb->close();
	}
	
	protected static function initErrorHandler() {
		include_once "system/msfErrorHandler.php";
		error_reporting(E_ALL);
		set_error_handler("msfErrorHandler");
	}
	
	protected static function initIncludes() {
		include_once 'system/MSF_ThrowableException.php';
		include_once "system/MSF_IOException.php";
		include_once 'system/utils/MSF_DB.php';
		include_once 'system/debug.php';
		include_once "system/MSF_Registry.php";
		include_once "system/MSF_Settings.php";
		include_once "system/MSF_Locale.php";
		include_once "system/utils/MSF_XmlWrapper.php";
		include_once "system/utils/MSF_File.php";
		include_once "system/utils/MSF_Dir.php";
		include_once "system/utils/MSF_DB.php";
                include_once 'system/utils/MSF_Logger.php';
		include_once "system/mvc/MSF_ModelDBSupport.php";
		include_once "system/MSF_MsfxSupport.php";
		
		include_once "system/utils/MSF_Date.php";
		include_once "system/utils/MSF_SL.php";
		include_once "system/utils/MSF_XmlWrapper.php";
		include_once "modules/workflow/library/common/WF_Exception.php";
		include_once 'cs/library/CronoSphere.php';
		include_once 'cs/library/Updater.php';
		include_once 'system/utils/MSF_Logger.php';
		include_once 'msfx/userbox/library/MSF_UserBox.php';
		include_once 'modules/main/library/orgStructure/MSF_OrgStructureFacade.php';
		include_once 'msfx/userbox/MSF_UserBoxExtension.php';

		include_once "system/utils/MSF_Json.php";
		include_once "system/MSF_DbCache.php";
	}
	
	protected static function initSettings() {
		$aSettings 						= array();
		$aSettings['uploadDirectory']	= '';
		$aSettings['hostURL']			= '';
		$aSettings['countOfParts']		= 0;
		$aSettings['db'] 				= array();
		$aSettings['atoms'] 			= array();
		include_once CNF_ABS_PATH . '/settings.php';
		self::$aSettings 				= $aSettings;
	}
	
	protected static function write($sTimeStampFilePath, $iTime) {
		$rPointer = fopen($sTimeStampFilePath, "w+");
		fwrite($rPointer, (int)$iTime);
                fflush($rPointer);
		fclose($rPointer);	
	}
	
	protected static function hibernate($sTimeStampFilePath) {
            set_time_limit(0);
		while (true) {
			sleep(10);
			//if (pcntl_fork() == -1) {
			//    exit('could not fork');
			//} else {
			//    self::run();
			//}
			// If file unlinked(deleted) 
			if (file_exists($sTimeStampFilePath)) {
				self::write($sTimeStampFilePath, time());
			}
			else {
				break;
			}
			
		}
		
	}
	
	protected static function run() {
		$oCs = new CronoSphere(self::$aSettings['countOfParts']);
		$oDb = self::initDb();
		$oCs->setDb($oDb);	
		foreach (self::$aSettings['atoms'] AS $aAtom) {
			$oCs->addAtom($aAtom['type'], CNF_ABS_PATH . "/". $aAtom['filepath'], $aAtom['classname'], (array)$aAtom['settings']);
		}

		$oCs->resetAtomsByExpiredTTL();
		$oCs->execute();
		$oDb->close();
	}
	
	protected static function update()
	{
		$oU = new Updater(CNF_ABS_PATH, self::initDb());
		if (!$oU->isProcessing()) {
			$oU->update();
		}
		
	}
	
}

?>