<?php
//update cs_atoms set status = 2 where atom_id != 567
defined("__MSF") or die("Direct access is not allowed!");
		
include_once "Net/POP3.php";
include_once "system/utils/MSF_String.php";
include_once "modules/lms/library/LMS_MailDecode.php";
include_once "modules/media/library/MD_MediaDB.php";
include_once "modules/media/library/MD_Media.php";
include_once "system/utils/MSF_String.php";
include_once "a.charset.php";

class LMS_Pop3
{
	private $DB 		= null;
	
	private $Pop3 		= null;
	
	private $Media 		= null;
	
	private $isLogged 	= false;
	
	private $sEmail 	= "";
	
	private $isDelete 	= 0;
	
	private $aToDelete 	= array();
	
	private $sCharset 	= "";
	
	private $aAttachs 	= array();
	
	private $iFileSize 	= 104857600;
	
	
	private $mUserIds 		= null;
	
	private $isFiewUsers 	= false;
	
	private $sUpload 		= '';
	
	private $aUidl			= array();
	
	public function __construct(LMS_Pop3DB $DB, $DBConn)
	{
		$this->DB 		= $DB;
		$this->Pop3 	= new Net_POP3();
		$this->Media 	= new MD_Media(new MD_MediaDB($DBConn));
		$this->sUpload 	= CNF_ABS_PATH . '/var/files/uploads';
		
		$this->Media->setMaxFileSize($this->iFileSize);
		$this->Media->setUploadDirectory($this->sUpload);
		$this->Media->setLinkDirectory(CNF_ABS_PATH . '/var/files/links');
	}
	
	public function connect($mHost, $mLogin, $sEmail, $mPassword, $aParams)
	{
		$this->mUserIds = $aParams["user_id"];
		$this->aUidl	= $this->DB->selectUidl($this->mUserIds);
		
		if (is_array($mHost)) {
			$bConnected = false;
			
			foreach ($mHost as $iKey => $sValue) {
				$bTmp = $this->tryToConnect($sValue, $mLogin[$iKey], $sEmail, $mPassword[$iKey], $aParams);
				if (!$bTmp) {
					unset($this->mUserIds[$iKey]);
				}
				elseif ($bTmp) {
					$bConnected = true;
					foreach ($this->mUserIds as $iIndex => $sParam) {
						if (strtolower($mHost[$iIndex]) != strtolower($mHost[$iKey])) {
							unset($this->mUserIds[$iIndex]);
						}
						elseif (strtolower($mLogin[$iIndex]) != strtolower($mLogin[$iKey])) {
							unset($this->mUserIds[$iIndex]);
						}
						elseif ($mPassword[$iIndex] != $mPassword[$iKey]) {
							unset($this->mUserIds[$iIndex]);
						}
						
					}
					
					break;
				}
				
			}
			
			return $bConnected;
		}
		else {
			return $this->tryToConnect($mHost, $mLogin, $sEmail, $mPassword, $aParams);
		}
		
	}
	
	public function tryToConnect($sHost, $sLogin, $sEmail, $sPassword, $aParams, $isSilenceMode = false)
	{
		$bSuccess 	= true;
		$aHost 		= parse_url($sHost);
		try {
			if (isset($aHost["path"])) {
				$aHost["host"] = $aHost["path"];
			}
			if (isset($aHost["scheme"]) && $aHost["scheme"] == "ssl") {
				$aHost["host"] = "ssl://" . $aHost["host"];
			}
			
			if (isset($aHost["port"])) {
				$this->Pop3->connect($aHost["host"], $aHost["port"]);
			}
			else {
				$this->Pop3->connect($aHost["host"]);
			}
			
			$Conn = $this->Pop3->login($sLogin, MSF_String::decrypt($sPassword));
			if (!is_a($Conn, "PEAR_Error")) {
				$this->isLogged = true;
				$this->sEmail 	= (string)	$sEmail;
				$this->isDelete = (int) 	$aParams["delete_emails"];
				if (is_array($this->mUserIds)) {
					$this->isFiewUsers = true;
				}
				
			}
			else {
				if (!$isSilenceMode) {
					echo ("Connection error: " . $sEmail . " " . $Conn->message . "\n");
				}
				
				$bSuccess = false;
			}
			
		}
		catch (Exception $e) {
			if (!$isSilenceMode) {
				echo ("Error: " . $sEmail . " " . $e->getMessage() . "\n");
			}
			
			$bSuccess = false;
		}
		
		return $bSuccess;
	}
	
	
	public function readMessages()
	{
		$aMessages 	 = (array)$this->Pop3->getListing();
		$iMessages 	 = count($aMessages);
		$iNewMessage = 0;
		if ($iMessages > 0) {
			$aMsgIds 		= array();
			$iUserId 		= $this->mUserIds;

			for ($i = $iMessages - 1; $i >= 0; $i--) {
				try {
					if (($i % 100) == 0) {
						$this->Pop3->getSize();
					}
					
					$sUniqueId 	= $iUserId . ":" . $this->sEmail . ":" . $aMessages[$i]["uidl"];
					if (!in_array(array("headers" => $sUniqueId), $this->aUidl)) {
						$this->DB->insertUniqueId($sUniqueId);
						$sHeaders = $this->Pop3->getRawHeaders($aMessages[$i]["msg_id"]);
						if (empty($sHeaders)) {
							continue;
						}
						
						$sUniqueId = $iUserId . ":" . $this->sEmail . ":" . $aMessages[$i]["uidl"];
						if($this->prepareMessage($iUserId, $this->Pop3->getMsg($aMessages[$i]["msg_id"]), $sHeaders, $sUniqueId)){
							$iNewMessage++;
							if ($this->isDelete) {
								$this->Pop3->deleteMsg($aMessages[$i]["msg_id"]);
							}
						}
					}
					
				}
				catch (Exception $e) {
					echo ("\nError: " . $this->sEmail . " " . $e->getMessage() . "\n"); 
					continue;
				}
				
			}	 

		}
		
		echo "Recieved mails: " . $iNewMessage . "\n";
	}
	
	private $aCType = array();
	
	private function repairMessage($sMessage)
	{
		$sResult 	= "";
		$aMessage 	= explode("\r\n", $sMessage);
		
		foreach ($aMessage as $sLine) {
			$aTmp = explode(": ", $sLine);
			if (count($aTmp) == 2) {
				$sResult .= trim(implode(": ", $aTmp)) . "\r\n";
			}
			else {
				if (strtolower(substr(trim($sLine), 0, 8)) == "charset=") {
					$sResult = trim($sResult, "\r\n") . " " . $sLine . "\r\n";
				}
				else {
					$sResult .= $sLine . "\r\n";
				}
			}
		}
		
		return $sResult;
	}
	
	private function prepareMessage($iUserId, $Message, $sHeaders, $sUniqueId)
	{
		$this->aAttachs = array();
		$this->sCharset = "";
		
		$iSize 		= 0;
		$aFileIds 	= array();
		$aImages 	= array();
		$Headers 	= LMS_MailDecode::process($sHeaders);
		$Message 	= LMS_MailDecode::process($this->repairMessage($Message));
		
		$aCType 	= $this->getCType($Message);
		$this->holdCType($aCType);
		
		$aMessage 	= $this->prepareHeaders($Headers);
		
		if (strlen($this->sCharset) == 0) {
			$aMessage["from_email"] = $this->convert($aMessage["from_email"], "");
			$aMessage["from_name"] 	= $this->convert($aMessage["from_name"], "");
			$aMessage["subject"] 	= $this->convert($aMessage["subject"], "");
		}
		else {
			$aMessage["from_email"] = $this->convert($aMessage["from_email"], $this->sCharset);
			$aMessage["from_name"] 	= $this->convert($aMessage["from_name"], $this->sCharset);
			$aMessage["subject"] 	= $this->convert($aMessage["subject"], $this->sCharset);
		}
		
		if (empty($aMessage["from_name"]) && isset($aMessage["from_email"])) {
			$aMessage["from_name"] = $aMessage["from_email"];
		}
		
		$sBody 		= $this->prepareBody($Message, implode("/", $aCType));
		$a 			= array();
		
		if (preg_match("/MSF-(.*)-MSF/", $sBody, $a)) {
			$sMessageId = isset($a[0]) ? $a[0] : "";
			if (!empty($sMessageId) && $this->DB->existsId($iUserId, $sMessageId)) {
				$this->DB->updateId($iUserId, $sMessageId, $sUniqueId);
				return false;
			}
		}
		
		/*
		foreach ($aMessage as $sKey => $mValue) {
			if (is_string($mValue)) {
				try {
					$aMessage[$sKey] = $this->stripDotBackslash(trim(LMS_MailDecode::decodeValue($mValue)));
				}
				catch (Exception $e) {}
			}
		}*/
		
		$iFolderId = -1;
		if (!empty($aMessage["subject"])) {
			//$iFolderId = $this->DB->getFolderId($iUserId, $aMessage["subject"]);
			$iFolderId = 0;
		}
		else {
			$aMessage["subject"] = MSF_HtmlEntities::strip(mb_substr(
				strip_tags(str_replace(array("<br>", "<br/>", "<br />"), " ", $sBody)),
				0, 75, "UTF8"
			)) . "...";
		}
		
		try {
			if (!empty($aImages)) {
				for ($i = 0; $i < count($aImages); $i++) {
					$sBody = str_replace("cid:" . $aImages[$i]["name"], "/media/image/" . $aImages[$i]["id"], $sBody);
				}
				
			}
			
			if (!empty($this->aAttachs)) {
				$aMessage["attachments"] = "Y";
			}
			
			$sBody = preg_replace('|href="[^>]+|', "$0 target='_blank'", $sBody);
			
			$aMessage["headers"] 	= $sUniqueId;
			$aMessage["encode"] 	= $this->sCharset;
			$aMessage["type"] 		= implode("/", $this->aCType);
			$aMessage["body"] 		= $this->stripDotBackslash($sBody);
			$aMessage["size"] 		= $iSize + strlen($sBody) + strlen($sHeaders);
			$iEmailId = $this->DB->insert($iUserId, $aMessage, $iFolderId);
		}
		catch (Exception $oE) {
			$sContent					= $aMessage["subject"] . "\r\n\r\n\r\n" . $aMessage["body"];
			$this->aAttachs[]			= array(
					"filename" 			=> 'text-' . $iUserId,
					"filetype"		 	=> $aMessage["type"],
					"filesize" 			=> strlen($sContent),
					"filebody" 			=> $sContent
					);
			$aMessage["attachments"] 	= 'Y';
			$aMessage["body"] 			= '?????';
			$aMessage["subject"] 		= '?????';
			$iEmailId 					= $this->DB->insert($iUserId, $aMessage, $iFolderId);
		}
		
		if (!empty($this->aAttachs)) {
			$aMessage["attachments"] = "Y";
			$aPaths = array();
			
			for ($i = 0; $i < count($this->aAttachs); $i++) {
				$sFileName 			= str_replace("/", "", LMS_MailDecode::decodeValue($this->aAttachs[$i]["filename"]));
				$sFilePath 			= $this->sUpload . "/" . $sFileName;
				$aPaths[] 			= $sFilePath;
				$sFileName 			= $this->convert($sFileName, "");
				$aFile["name"] 		= $sFileName;
				$aFile["type"] 		= $this->aAttachs[$i]["filetype"];
				$aFile["tmp_name"] 	= $sFilePath;
				$aFile["size"] 		= $this->aAttachs[$i]["filesize"];
				$aFile["error"] 	= 0;
				
				file_put_contents($sFilePath, $this->aAttachs[$i]["filebody"]);
				$iFileId = $this->Media->upload($aFile, "lms_" . (($iFolderId == -1) ? 0 : $iFolderId), $iUserId);
				
				$aFileIds[] = $iFileId;
				if (!empty($this->aAttachs[$i]["_inline_"])) {
					$aTmp["id"] 	= $iFileId;
					$aTmp["name"] 	= LMS_MailDecode::decodeValue($this->aAttachs[$i]["_inline_"]);
					$aTmp["name"] 	= $this->convert($aTmp["name"], "");
					$aImages[] 		= $aTmp;
				}
				$iSize += $this->aAttachs[$i]["filesize"];
			}
			
			for ($i = 0; $i < count($aPaths); $i++) {
				if (MSF_File::exists($aPaths[$i])) {
					MSF_File::remove($aPaths[$i]);
				}
			}
		}
		
		if (!empty($aFileIds)) {
			$this->DB->updateFiles(implode(",", $aFileIds), $iEmailId);
		}
		
		return true;
		
	}
	
	private function stripDotBackslash($sString)
	{
		return str_replace("\.", ".", str_replace("\0", "&#92;0", stripslashes($sString)));
	}
	
	private function prepareHeaders($Headers)
	{
		$Date 					= new MSF_Date();
		$aResult 				= array();
		$aResult["to_email"] 	= $this->stripDotBackslash($this->sEmail);
		$aResult["from_name"] 	= "";
		$aResult["from_email"] 	= "";
		$aResult["time"] 		= $Date->formatTimestamp();
		$aResult["subject"] 	= "";
		$aResult["attachments"] = "N";
		
		if (isset($Headers->headers["from"])) {
			if (is_array($Headers->headers["from"])) {
				if (count($Headers->headers["from"]) == 1) {
					$sFrom = $Headers->headers["from"][0];
				}
				else {
					foreach ($Headers->headers["from"] as $sValue) {
						if (substr_count($sValue, "<") > 0 && substr_count($sValue, ">") > 0 && substr_count($sValue, "@") > 0) {
							$sFrom = $sValue;
							break;
						}
						else {
							$sFrom = $sValue;
						}
					}
				}
			}
			else {
				$sFrom = $Headers->headers["from"];
			}
			
			$sFrom 	= $this->stripDotBackslash($sFrom);
			$aTmp 	= explode("<", $sFrom);
			
			if (count($aTmp) > 1) {
				$aResult["from_name"] 	= trim($aTmp[0]);
				$aResult["from_email"] 	= trim(trim($aTmp[1], ">"));
				
				if (empty($aResult["from_name"])) {
					$aResult["from_name"] = $aResult["from_email"];
				}
			}
			else {
				$aResult["from_name"] 	= trim(trim($aTmp[0], ">"));
				$aResult["from_email"] 	= trim(trim($aTmp[0], ">"));
			}
		}
		
		$aResult["from_name"] 	= $this->stripDotBackslash($aResult["from_name"]);
		$aResult["from_email"] 	= $this->stripDotBackslash($aResult["from_email"]);
		
		if (isset($Headers->headers["date"])) {
			if (is_array($Headers->headers["date"])) {
				$Date = new MSF_Date(strtotime($Headers->headers["date"][0]));
			}
			else {
				$Date = new MSF_Date(strtotime($Headers->headers["date"]));
			}
			$aResult["time"] = $Date->formatTimestamp();
		}
		
		if (isset($Headers->headers["subject"])) {
			if (is_array($Headers->headers["subject"])) {
				if (isset($Headers->headers["subject"][1])) {
					$Headers->headers["subject"] = $Headers->headers["subject"][1];
				}
				else {
					$Headers->headers["subject"] = $Headers->headers["subject"][0];
				}
			}
			
			$aResult["subject"] = $this->stripDotBackslash($Headers->headers["subject"]);
			//$aResult["subject"] = str_replace(" ", "", $aResult["subject"]);
			
			preg_match('/=\?(.*?)\?(Q|B|q|b)\?/', $aResult["subject"], $aMatched);
			
			if (isset($aMatched[1])) {
				$this->sCharset = $aMatched[1];
			}
		}
		
		foreach ($aResult as $sKey => $sValue) {
			if (is_string($sValue)) {
				$aResult[$sKey] = $this->stripDotBackslash(trim(LMS_MailDecode::decodeValue($sValue)));
			}
		}
		
		return $aResult;
	}
	
	private function prepareBody($Message, $sType = "")
	{
		$aCType = $this->getCType($Message, $sType);
		$sBody 	= "";
		switch ($aCType[0]) {
			case "message":
			case "text":
				if ($this->checkBody($Message)) {
					$this->holdCType($aCType);
					$sBody .= $this->getBody($Message, $this->getCTypeParams($Message));
				}
				break;
			case "multipart":
				if (isset($Message->parts)) {
					if (($aCType[1] == "alternative") || ($sType == "multipart/report") ) {
						$sBody .= $this->buildAlternative($Message);
					}
					else {
						$sBody .= $this->prepareParts($Message->parts, $this->getCTypeParams($Message));
					}
				}
				break;
		}
		
		return $sBody;
	}
	
	private function checkBody($Message)
	{
		if (isset($Message->headers['']) && (empty($Message->headers['']) || $Message->headers[''] == '-')) {
			return false;
		}
		
		return true;
	}
	
	private function prepareParts($aParts, $aParams = array())
	{
		$sBody 		= "";
		$aEscape 	= array("alternative");
		$iSize 		= count($aParts);
		
		for ($i = 0; $i < $iSize; $i++) {
			$aCType = $this->getCType($aParts[$i]);
			switch (strtolower($aCType[0])) {
				case "text":
				case "message":
					if ($this->checkBody($aParts[$i])) {
						$this->holdCType($aCType);
						$sBody .= $this->prepareBody($aParts[$i]);
					}
					break;
				case "image":
				case "application":
				case "video":
				case "audio":
					$aAttachment 	= array();
					$sFileName 		= "undefined";
					$aFileType 		= $this->getCType($aParts[$i]);
					$aTypeParams 	= $this->getCTypeParams($aParts[$i]);
					if (isset($aTypeParams["name"])) {
						$sFileName = $aTypeParams["name"];
					}
					else {
						$aTypeParams = $this->getDParams($aParts[$i]);
						if (isset($aTypeParams["filename"])) {
							$sFileName = $aTypeParams["filename"];
						}
					}
					
					$aAttachment["filename"] = $sFileName;
					$aAttachment["filebody"] = isset($aParts[$i]->body) ? $aParts[$i]->body : "";
					$aAttachment["filetype"] = $aFileType[0] . "/" . $aFileType[1];
					$aAttachment["filesize"] = strlen($aAttachment["filebody"]);
					$aAttachment["_inline_"] = "";
					
					/*
					if ($this->getDisposition($aParts[$i]) == "inline" && $aCType[0] == "image") {
						if (isset($aParts[$i]->headers["content-id"])) {
							$sContentId = $aParts[$i]->headers["content-id"];
							$aTmp 		= pathinfo($sFileName);
							
							if ($sContentId == "<" . $aTmp["basename"] . ">" || $sContentId == "<" . $aTmp["filename"] . ">") {
								$aAttachment["_inline_"] = $aTmp["basename"];
							}
						}
					}
					*/
					if (isset($aParts[$i]->headers["content-id"]) && $aCType[0] == "image") {
						$sContentId = $aParts[$i]->headers["content-id"];
						$aAttachment["_inline_"] = str_replace(array("<", ">"), "", $sContentId);
					}
					
					$this->aAttachs[] = $aAttachment;
					break;
			}
			
			switch ($aCType[1]) {
				case "rfc822":
				case "plain":
				case "report":
				case "related":
					if (isset($aParams["charset"])) {
						$this->holdCType($aCType);
						$sBody .= $this->getBody($aParts[$i], $aParams["charset"]);
					}
				case "alternative":
					if (isset($aParts[$i]->parts)) {
						$sBody .= $this->buildAlternative($aParts[$i]);
					}
					break;
			}
			
			if (!in_array($aCType[1], $aEscape) && isset($aParts[$i]->parts)) {
				$sBody .= $this->prepareParts($aParts[$i]->parts);
			}
		}
		
		return $sBody;
	}
	
	private function buildAlternative($Part)
	{
		$bText 			= false;
		$aPartCTypes 	= array();
		$sBody 			= "";
		
		for ($j = 0; $j < count($Part->parts); $j++) {
			$aTmp = $this->getCType($Part->parts[$j]);
			// vozmojno est eshe varianti krome tipa "text"
			if ($aTmp[0] == "text") {
				if ($this->checkBody($Part->parts[$j])) {
					$aPartCTypes[] 	= $aTmp[1];
					$bText 			= true;
				}
			}
		}
		
		if ($bText) {
			if (in_array("html", $aPartCTypes)) {
				$aPartCTypeParams = $this->getCTypeParams($Part->parts[$this->getArrayIndex($aPartCTypes, "html")]);
				$sBody .= $this->getBody(
					$Part->parts[$this->getArrayIndex($aPartCTypes, "html")],
					$aPartCTypeParams
				);
				$this->holdCType(array("text", "html"));
			}
			elseif (in_array("richtext", $aPartCTypes)) {
				$aPartCTypeParams = $this->getCTypeParams($Part->parts[$this->getArrayIndex($aPartCTypes, "text")]);
				$sBody .= $this->getBody(
					$Part->parts[$this->getArrayIndex($aPartCTypes, "richtext")],
					$aPartCTypeParams
				);
				$this->holdCType(array("text", "richtext"));
			}
			elseif (in_array("plain", $aPartCTypes)) {
				$aPartCTypeParams = $this->getCTypeParams($Part->parts[$this->getArrayIndex($aPartCTypes, "plain")]);
				$sBody .= $this->getBody(
					$Part->parts[$this->getArrayIndex($aPartCTypes, "plain")],
					$aPartCTypeParams
				);
				$this->holdCType(array("text", "plain"));
			}
		}
		
		return $sBody;
	}
	
	private function getCType($Message, $sType = "")
	{
		$aResult = array("text", "plain");
		
		if (!empty($sType)) {
			$aTmp = explode("/", $sType);
			
			if (count($aTmp) == 2) {
				$aResult = $aTmp;
			}
		}
		else {
			if (isset($Message->ctype_primary) && isset($Message->ctype_secondary)) {
				$aResult = array($Message->ctype_primary, $Message->ctype_secondary);
			}
		}
		
		return $aResult;
	}
	
	private function getDisposition($Message)
	{
		$sResult = "";
		
		if (isset($Message->disposition)) {
			$sResult = $Message->disposition;
		}
		
		return $sResult;
	}
	
	private function getCTypeParams($Message)
	{
		$aResult = array();
		
		if (isset($Message->ctype_parameters)) {
			$aResult = $Message->ctype_parameters;
		}
		
		return $aResult;
	}
	
	private function getDParams($Message)
	{
		$aResult = array();
		
		if (isset($Message->d_parameters)) {
			$aResult = $Message->d_parameters;
		}
		
		return $aResult;
	}
	
	private function getBody($Message, $aParams = array())
	{
		$sResult = "";
		
		if (isset($Message->body)) {
			if (isset($aParams["charset"])) {
				if (empty($this->sCharset)) {
					$aTmp = explode(" ", $aParams["charset"]);
					if (count($aTmp) > 1) {
						$this->sCharset = trim($aTmp[0], "\"");
					}
					else {
						$this->sCharset = $aParams["charset"];
					}
				}
				
				$sResult = $this->convert($Message->body, $this->sCharset);
			}
			else {
				$sResult = $this->convert($Message->body, "");
			}
		}
		
		return $sResult;
	}
	
	private function convert($sString, $sCharset)
	{
		if (!empty($sString)) {
			if (is_array($sString)) {
				if (isset($sString[0])) {
					$sString = $sString[0];
				}
				else {
					$sString = "";
				}
			}
			
			$sCharset 	= strtoupper($sCharset);
			//$aEscape 	= array("UTF-8", "ISO-8859-1", "UTF8");
			$aEscape 	= array("UTF-8", "UTF8");
			
			if (substr_count($sCharset, "ISO-8859") > 0) {			
				$sString = mb_convert_encoding($sString, "UTF8", $sCharset);
			}
			elseif (!in_array(strtoupper($sCharset), $aEscape)) {				
				$sString = mb_convert_encoding(charset_x_win($sString), "UTF8", "CP1251");
			}
		}
		
		return str_replace(array("љ"), "", $sString);
	}
	
	private function getArrayIndex($aSource, $sSearch)
	{
		$iIndex = -1;
		
		for ($i = 0; $i < count($aSource); $i++) {
			if ($aSource[$i] == $sSearch) {
				$iIndex = $i;
				break;
			}
		}
		
		return $iIndex;
	}
	
	public function disconnect()
	{
		try {
			if (!empty($this->aToDelete)) {
				for ($i = 0; $i < count($this->aToDelete); $i++) {
					$this->Pop3->deleteMsg($this->aToDelete[$i]);
				}
			}
			
			$this->DB->deleteUniqueIds($this->mUserIds, $this->sEmail);
			
			$this->Pop3->disconnect();
		}
		catch (Exception $e) {
			
		}
	}
	
	private function holdCType($aCType)
	{
		if ($aCType[1] != "alternative") {
			$this->aCType = $aCType;
		}
	}
}

?>