<?php

defined('__MSF') or die('Direct access is not allowed!');

include_once "library/MSF_SearchUtil/MSF_SearchUtil.php";
include_once "modules/lms/library/LMS_Contstants.php";
include_once "system/mvc/MSF_ModelDBSupport.php";
include_once 'library/MSF_SearchUtil/MSF_CsIndexedDB.php';

class LMS_Pop3DB extends MSF_ModelDBSupport
{
	private $sSearchTable = "lms_index";
	
	public function __construct(MSF_DB $DB)
	{
		$this->DB = $DB;
		$this->DBRecord = new MSF_CsIndexedDB('cs_indexed', 'indexed_id');
	}
	
	public function selectCount()
	{
		$aValue["external"] = "Y";
		$iTotal 			= 0;
		
		$iTotal += $this->getCount("lms_remote_deleted");
		$iTotal += $this->getCount("lms_inbox", $aValue);
		$iTotal += $this->getCount("lms_messages", $aValue);
		$iTotal += $this->getCount("lms_trash", $aValue);
		
		return $iTotal;
	}
	
	public function exists($iUserId, $sBHeaders)
	{
		$aValue["headers"] 	= $sBHeaders;
		$iTotal 			= 0;
		
		$iTotal += $this->getCount($iUserId, "lms_holder", $aValue, false);
		$iTotal += $this->getCount($iUserId, "lms_remote_deleted", $aValue);
		$iTotal += $this->getCount($iUserId, "lms_inbox", $aValue);
		$iTotal += $this->getCount($iUserId, "lms_messages", $aValue);
		$iTotal += $this->getCount($iUserId, "lms_trash", $aValue);
		
		return ($iTotal > 0) ? true : false;
	}
	
	public function existsId($iUserId, $sMessageId)
	{
		$aValue["identifier"] 	= $sMessageId;
		$iTotal 				= 0;
		
		$iTotal += $this->getCount($iUserId, "lms_inbox", $aValue);
		$iTotal += $this->getCount($iUserId, "lms_messages", $aValue);
		$iTotal += $this->getCount($iUserId, "lms_trash", $aValue);
		
		return ($iTotal > 0) ? true : false;
	}
	
	public function updateId($iUserId, $sMessageId, $sUniqueId)
	{
		$aValue["identifier"] = $sMessageId;
		
		if ($this->getCount($iUserId, "lms_inbox", $aValue) > 0) {
			$this->updateIdByTable("lms_inbox", $sMessageId, $sUniqueId);
		}
		elseif ($this->getCount($iUserId, "lms_messages", $aValue) > 0) {
			$this->updateIdByTable("lms_messages", $sMessageId, $sUniqueId);
		}
		elseif ($this->getCount($iUserId, "lms_trash", $aValue) > 0) {
			$this->updateIdByTable("lms_trash", $sMessageId, $sUniqueId);
		}
	}
	
	private function updateIdByTable($sTable, $sMessageId, $sUniqueId)
	{
		$sSql = "UPDATE\n" .
					$sTable . "\n" .
				"SET\n" .
					"headers = '" . $sUniqueId . "'\n" .
				"WHERE\n" .
					"identifier = '" . $sMessageId . "'";
		
		$this->DB->executeQuery($sSql);
	}
	
	public function selectDeleted($iUserId)
	{
		return $this->getSelect($iUserId, "lms_remote_deleted");
	}
	
	public function clearDeleted($sMessageIds)
	{
		$sSql = "DELETE FROM lms_remote_deleted WHERE message_id IN(" . $sMessageIds . ")";
		
		$this->DB->executeQuery($sSql);
	}
	
	private function getCount($iUserId, $sTable, $aValues = array(), $bUser = true)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					$sTable . "\n" .
				"WHERE\n" .
					"1=1\n";
		
		if ($bUser) {
			$sSql .= "AND\n" .
						"user_id = " . $iUserId;
		}
		
		if (!empty($aValues)) {
			foreach ($aValues as $k => $v) {
				$sSql .= "
						AND
							" . $k . " = '" . $this->escapeValue($v) . "'";
			}
		}
		
		return $this->DB->select($sSql, true, "total");
	}
	
	private function getSelect($iUserId, $sTable, $aValues = array())
	{
		$sSql = "SELECT * FROM " . $sTable . " WHERE user_id IN(" . $iUserId . ")";
		
		if (!empty($aValues)) {
			foreach ($aValues as $k => $v) {
				$sSql .= "
						AND
							" . $k . " = '" . $this->escapeValue($v) . "'";
			}
		}
		
		return $this->DB->select($sSql);
	}
	
	//
	public function insertUniqueId($sUniqueId)
	{
		$sSql = "INSERT INTO\n" .
					"lms_holder\n" .
				"(headers)\n" .
				"VALUES('" . $sUniqueId . "')";
		
		$this->DB->executeQuery($sSql);
	}
	
	public function deleteUniqueIds($iUserId, $sEmail)
	{
		$sSql = "DELETE FROM\n" .
					"lms_holder\n" .
				"WHERE\n" .
					"headers LIKE '" . $iUserId . ":" . $sEmail . "%'";
		
		$this->DB->executeQuery($sSql);
	}
	//
	
	
	public function insert($iUserId, $aParams, $iFolderId = -1)
	{
		try {
			$aParams = $this->escapeHashValues($aParams);
			
			$sSql = "INSERT INTO\n" .
						"lms_emails\n" .
					"(\n" .
						"body\n" .
					")\n" .
					"VALUES(\n" .
						"'" . $aParams["body"] . "'\n" .
					")";
			
			$this->DB->executeQuery($sSql);
			$iEmailId = (int) $this->DB->select("SELECT currval('lms_emails_email_id_seq') AS last_id", true, "last_id");
			
			if (!$this->DBRecord->findOperation($iEmailId, 'mail', 'index', LMS_Contstants::EMAIL)) {
				$this->DBRecord->insert(array('subject_id' => $iEmailId, 
								'module' => 'mail', 'operation' => 'index', 'context_id' => LMS_Contstants::EMAIL));
			}
			//MSF_SearchUtil::newInstance($aParams["body"])->createIndex($this->sSearchTable, LMS_Contstants::EMAIL, $iEmailId);
			
			$sTableName = "lms_inbox";
			if ($iFolderId > 4) {
				$sTableName = "lms_messages";
			}
			else {
				$iFolderId = LMS_Contstants::INBOX;
			}
			
			$sSql = "INSERT INTO\n" .
						$sTableName .
					"(\n";
					
			if ($iFolderId > 4) {
				$sSql .= "folder_id,\n";
			}
					
			$sSql .=	"email_id,\n" .
						"user_id,\n" .
						"headers,\n" .
						"encode,\n" .
						"from_email,\n" .
						"from_name,\n" .
						"to_email,\n" .
						"time,\n" .
						"subject,\n" .
						"type,\n" .
						"attachments,\n" .
						"size,\n" .
						"external,\n" .
						"status\n" .
					")\n" .
					"VALUES(\n";
			
			if ($iFolderId > 4) {
				$sSql .= $iFolderId . ",\n";
			}
			
			$sSql .=	$iEmailId . ",\n" .
						$iUserId . ",\n" .
						"'" . $aParams['headers'] . "',\n" .
						"'" . $aParams['encode'] . "',\n" .
						"'" . $aParams['from_email'] . "',\n" .
						"'" . $aParams['from_name'] . "',\n" .
						"'" . $aParams['to_email'] . "',\n" .
						"'" . $aParams['time'] . "',\n" .
						"'" . $aParams['subject'] . "',\n" .
						"'" . $aParams['type'] . "',\n" .
						"'" . $aParams['attachments'] . "',\n" .
						$aParams["size"] . ",\n" .
						"'Y',\n" .
						"'new'\n" .
					")";
					
			$this->DB->executeQuery($sSql);
			
			$iMessageId = (int) $this->DB->select("SELECT currval('" . $sTableName . "_message_id_seq') AS last_id", true, "last_id");
			if (!$this->DBRecord->findOperation($iFolderId, 'mail', 'index', $iMessageId)) {
				$this->DBRecord->insert(array('subject_id' => $iMessageId, 
								'module' => 'mail', 'operation' => 'index', 'context_id' => $iFolderId));
			}	
		//	MSF_SearchUtil::newInstance(
		//		$aParams["from_name"] . " " .
		//		$aParams["from_email"] . " " .
		//		$aParams["to_email"] . " " .
		//		$aParams["subject"]
		//	)->createIndex($this->sSearchTable, $iFolderId, $iMessageId);
			
			return $iEmailId;
		}
		catch(Exception $e) {
			echo "Error on insert: " . $e->getMessage();
		}
	}
	
	/*
	public function insert($iUserId, $aParams, $iFolderId = -1)
	{
		try {
			$aParams = $this->escapeHashValues($aParams);
			
			$sSql = "INSERT INTO\n" .
						"lms_emails\n" .
					"(\n" .
						"body\n" .
					")\n" .
					"VALUES(\n" .
						"'" . $aParams["body"] . "'\n" .
					")";
			
			$this->DB->executeQuery($sSql);
			$iEmailId = (int) $this->DB->select("SELECT currval('lms_emails_email_id_seq') AS last_id", true, "last_id");
			
			MSF_SearchUtil::newInstance($aParams["body"])->createIndex($this->sSearchTable, LMS_Contstants::EMAIL, $iEmailId);
			
			$sTableName = "lms_inbox";
			if ($iFolderId > 4) {
				$sTableName = "lms_messages";
			}
			else {
				$iFolderId = LMS_Contstants::INBOX;
			}
			
			$sSql = "INSERT INTO\n" .
						$sTableName .
					"(\n";
					
			if ($iFolderId > 4) {
				$sSql .= "folder_id,\n";
			}
					
			$sSql .=	"email_id,\n" .
						"user_id,\n" .
						"headers,\n" .
						"encode,\n" .
						"from_email,\n" .
						"from_name,\n" .
						"to_email,\n" .
						"time,\n" .
						"subject,\n" .
						"type,\n" .
						"attachments,\n" .
						"size,\n" .
						"external,\n" .
						"status\n" .
					")\n" .
					"VALUES(\n";
			
			if ($iFolderId > 4) {
				$sSql .= $iFolderId . ",\n";
			}
			
			$sSql .=	$iEmailId . ",\n" .
						$iUserId . ",\n" .
						"'" . $aParams['headers'] . "',\n" .
						"'" . $aParams['encode'] . "',\n" .
						"'" . $aParams['from_email'] . "',\n" .
						"'" . $aParams['from_name'] . "',\n" .
						"'" . $aParams['to_email'] . "',\n" .
						"'" . $aParams['time'] . "',\n" .
						"'" . $aParams['subject'] . "',\n" .
						"'" . $aParams['type'] . "',\n" .
						"'" . $aParams['attachments'] . "',\n" .
						$aParams["size"] . ",\n" .
						"'Y',\n" .
						"'new'\n" .
					")";
					
			$this->DB->executeQuery($sSql);
			
			$iMessageId = (int) $this->DB->select("SELECT currval('" . $sTableName . "_message_id_seq') AS last_id", true, "last_id");
			MSF_SearchUtil::newInstance(
				$aParams["from_name"] . " " .
				$aParams["from_email"] . " " .
				$aParams["to_email"] . " " .
				$aParams["subject"]
			)->createIndex($this->sSearchTable, $iFolderId, $iMessageId);
			
			return $iEmailId;
		}
		catch(Exception $e) {
			echo "Error on insert: " . $e->getMessage();
		}
	}
	*/
	
	public function getFolderId($iUserId, $sString)
	{
		$sSql = "SELECT\n" .
					"folder_id\n" .
				"FROM\n" .
					"lms_folders\n" .
				"WHERE\n" .
					"user_id = " . $iUserId . "\n" .
				"AND\n" .
					"title LIKE '%" . $this->escapeValue($sString) . "%'";
		
		$aRes = $this->DB->select($sSql, true);
		
		return ((isset($aRes['folder_id'])) ? $aRes['folder_id'] : -1);
	}
	
	public function updateFiles($sFileIds, $iEmailId)
	{
		$sSql = "UPDATE md_media SET user_id = " . $iEmailId . " WHERE file_id IN (" . $sFileIds . ")";
		
		$this->DB->executeQuery($sSql);
	}
	
	public function selectUidl($iUserId) {
		
		$sSql = "SELECT\n" .
					"headers\n" .
				"FROM\n" .
					"lms_inbox\n" .
				"WHERE\n" .
					"user_id = " . $iUserId;	
		$aInbox = $this->DB->select($sSql);
		
		$sSql = "SELECT\n" .
					"headers\n" .
				"FROM\n" .
					"lms_holder";
		$aHolder = $this->DB->select($sSql);
		
		$sSql = "SELECT\n" .
					"headers\n" .
				"FROM\n" .
					"lms_remote_deleted\n" .
				"WHERE\n" .
					"user_id = " . $iUserId;
		$aRemoteDeleted = $this->DB->select($sSql);
		
		$sSql = "SELECT\n" .
					"headers\n" .
				"FROM\n" .
					"lms_messages\n" .
				"WHERE\n" .
					"user_id = " . $iUserId;
		$aMessages = $this->DB->select($sSql);
		
		$sSql = "SELECT\n" .
					"headers\n" .
				"FROM\n" .
					"lms_trash\n" .
				"WHERE\n" .
					"user_id = " . $iUserId;		
		$aTrash = $this->DB->select($sSql);
		
		return array_merge($aInbox, $aHolder, $aRemoteDeleted, $aMessages, $aTrash);
	}
}

?>