<?php

include_once "library/MSF_SearchUtil/MSF_SearchUtil.php";
include_once "modules/lms/library/LMS_Contstants.php";
include_once "system/mvc/MSF_ModelDBSupport.php";
include_once 'library/MSF_SearchUtil/MSF_CsIndexedDB.php';

class LMS_SmtpDB extends MSF_ModelDBSupport
{
	private $sSearchTable = "lms_index";
	
	public function __construct(MSF_DB $DB)
	{
		$this->DB = $DB;
		$this->DBRecord = new MSF_CsIndexedDB('cs_indexed', 'indexed_id');
	}
	
	public function exists($iUserId)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"lms_outbox f, lms_emails e\n" .
				"WHERE\n" .
					"f.user_id = '" . $iUserId . "'\n" .
				"AND\n" .
					"f.email_id = e.email_id\n";// .
			//	"AND\n" .
			//		"e.blocked = 0";
				
		$aRes 	= $this->DB->select($sSql, true);
		
		return (($aRes['total'] > 0) ? true : false);
	}
	
	public function open($iUserId)
	{
		$sSql 	= "SELECT\n"
					. "*\n"
				. "FROM\n"
					. "lms_outbox f, lms_emails e\n"
				. "WHERE\n"
					. "f.user_id = '" . $iUserId . "'\n"
				. "AND\n"
					. "f.email_id = e.email_id\n";
				//. "AND\n"
				//	. "e.blocked='0'";
					
		return $this->DB->select($sSql);
	}
	
	public function sent($aParams, $bReturn = false)
	{
		$sTable 	= "lms_sent";
		$iFolderId 	= LMS_Contstants::SENT;
		$aParams 	= $this->escapeHashValues($aParams);
				
		if ($bReturn) {
			$iFolderId 	= LMS_Contstants::INBOX;
			$sTable 	= "lms_inbox";
		}
		
		$sSql = "INSERT INTO\n" .
					$sTable .
				"(\n" .
					"email_id,\n" .
					"user_id,\n" .
					"headers,\n" .
					"encode,\n" .
					"from_email,\n" .
					"from_name,\n" .
					"to_email,\n" .
					"type,\n" .
					"time,\n" .
					"subject,\n" .
					"size,\n" .
					"attachments\n" .
				")\n" .
				"VALUES(\n" .
					$aParams["email_id"] . ",\n" .
					$aParams["user_id"] . ",\n" .
					"'" . $aParams["headers"] . "',\n" .
					"'" . $aParams["encode"] . "',\n" .
					"'" . $aParams["from_email"] . "',\n" .
					"'" . $aParams["from_name"] . "',\n" .
					"'" . $aParams["to_email"] . "',\n" .
					"'" . $aParams["type"] . "',\n" .
					"'" . $aParams["time"] . "',\n" .
					"'" . $aParams["subject"] . "',\n" .
					$aParams["size"] . ",\n" .
					"'" . $aParams["attachments"] . "'\n" .
				")";
		
		$this->DB->executeQuery($sSql);
		$iMessageId = (int) $this->DB->select("SELECT currval('" . $sTable . "_message_id_seq') AS last_id", true, "last_id");
		if (!$this->DBRecord->findOperation($iFolderId, 'mail', 'index', $iMessageId)) {
			$this->DBRecord->insert(array('subject_id' => $iMessageId, 
							'module' => 'mail', 'operation' => 'index', 'context_id' => $iFolderId));
		}
	//	MSF_SearchUtil::newInstance(
	//		$aParams["from_name"] . " " .
	//		$aParams["from_email"] . " " .
	//		$aParams["to_email"] . " " .
	//		$aParams["subject"]
	//	)->createIndex($this->sSearchTable, $iFolderId, $iMessageId);
		
		$sSql 	= "DELETE FROM\n"
					. "lms_outbox\n"
				. "WHERE\n"
					. "message_id = " . $aParams["message_id"];
					
		$this->DB->executeQuery($sSql);
		
		if ($bReturn) {
			$sSql = "UPDATE\n" .
						"lms_emails\n" .
					"SET\n" .
						"body = '" . $aParams["body"] . "'\n" .
					"WHERE\n" .
						"email_id = " . $aParams["email_id"];
			
			$this->DB->executeQuery($sSql);
			
			$iEmailId = (int) $this->DB->select("SELECT currval('lms_emails_email_id_seq') AS last_id", true, "last_id");
			if (!$this->DBRecord->findOperation(LMS_Contstants::EMAIL, 'mail', 'index', $iEmailId)) {
				$this->DBRecord->insert(array('subject_id' => $iEmailId, 
								'module' => 'mail', 'operation' => 'index', 'context_id' => LMS_Contstants::EMAIL));
			}
		//	MSF_SearchUtil::newInstance(
		//		$aParams["from_name"] . " " .
		//		$aParams["from_email"] . " " .
		//		$aParams["to_email"] . " " .
		//		$aParams["subject"]
		//	)->createIndex($this->sSearchTable, LMS_Contstants::EMAIL, $iEmailId);
			if (!$this->DBRecord->findOperation(LMS_Contstants::EMAIL, 'mail', 'remove', $aParams["email_id"])) {
				$this->DBRecord->insert(array('subject_id' => $aParams["email_id"], 
							'module' => 'mail', 'operation' => 'remove', 'context_id' => LMS_Contstants::EMAIL));
			}
		//	MSF_SearchUtil::newInstance()->removeIndex($this->sSearchTable, LMS_Contstants::EMAIL, $aParams["email_id"]);
		}
	}
	
	public function saveError($sBody, $sSubject, $iSize)
	{
		$sSql = "INSERT INTO\n" .
				"lms_emails\n" .
			"(\n" .
				"body\n" .
			")\n" .
			"VALUES(\n" .
				"'" . $sBody . "'\n" .
			")";
		
		$this->DB->executeQuery($sSql);
		$iEmailId = (int) $this->DB->select("SELECT currval('lms_emails_email_id_seq') AS last_id", true, "last_id");
		
		$sSql = "INSERT INTO lms_inbox(\n" .
				"email_id,\n" .
				"user_id,\n" .
				"headers,\n" .
				"encode,\n" .
				"from_email,\n" .
				"from_name,\n" .
				"to_email,\n" .
				"type,\n" .
				"time,\n" .
				"subject,\n" .
				"size,\n" .
				"attachments\n" .
			")\n" .
			"VALUES(\n" .
				$iEmailId . ",\n" .
				CNF_ADMIN_USER_ID . ",\n" .
				"'',\n" .
				"'',\n" .
				"'',\n" .
				"'DetriX',\n" .
				"'Администратор',\n" .
				"'text/html',\n" .
				"now(),\n" .
				"'" . $sSubject . "',\n" .
				$iSize . ",\n" .
				"'N'\n" .
			")";
		$this->DB->executeQuery($sSql);
	}
	
}
