/*
Typecast 1.4 (release)
by Ara Pehlivanian (http://arapehlivanian.com)

This work is licensed under a Creative Commons Licence
http://creativecommons.org/licenses/by-nd/2.5/
*/

Typecast.Config = {
	Settings : {
		Mask : {
			FieldDataSeparator : ",",
			MaskCharacters : {
				Numeric : "0",
				Alpha : "A"
			},
			AllowInsert : false,
			DisplayMaskCharacters : false //Display mask characters when default text is not present
		},
		
		Suggest : {
			OutputAreaID : "SuggestOutputArea",
			isCaseSensitive : false,
			MatchFromStart : false,
			ResultLimit : 20,
			BrowserAutoComplete : false,
			IEForceRelative : true
		}
	},
	
	Data : {
		Mask : {
			Masks : {
				fax : "(###) ###-####,(   )    -    "
			}
		},
		Suggest : {
			Dictionaries : {
				Default : ["aah", "aardvark", "aardvarks", "abacus", "abacuses", "abalone", "abalones", "abandon", "abandoned", "abandoning", "abandonment", "abandons", "abase", "abased", "abasement", "abases", "abashed", "abasing", "abate", "abated", "abatement", "abates", "abating", "abattoir", "abattoirs", "abbess", "abbesses", "abbey", "abbeys", "abbot", "abbots", "abbreviate", "abbreviated", "abbreviates", "abbreviating", "abbreviation", "abbreviations", "abdicate", "abdicated", "abdicates", "abdicating", "abdication", "abdications", "abdomen", "abdomens", "abdominal", "abduct", "abducted", "abducting", "abduction", "abductions", "abductor", "abductors", "abducts", "abed", "aberrant", "aberration", "aberrations", "abet", "abets", "abetted", "abetting", "abhor", "abhorred", "abhorrence", "abhorrent", "abhorring", "abhors", "abide", "abided", "abides", "abiding", "abilities", "ability", "abject", "abjectly", "abjure", "abjured", "abjures", "abjuring", "ablaze", "able", "abler", "ablest", "ablutions", "ably", "abnegation", "abnormal", "abnormalities", "abnormality", "abnormally", "aboard", "abode", "abodes", "abolish", "abolished", "abolishes", "abolishing", "abolition", "abolitionist", "abolitionists", "abominable", "abominably", "abominate", "abominated", "abominates", "abominating", "abomination", "abominations", "aboriginal", "aboriginals", "aborigine", "aborigines", "abort", "aborted", "aborting", "abortion", "abortionist", "abortionists", "abortions", "abortive", "aborts", "abound", "abounded", "abounding", "abounds", "about", "above", "aboveboard", "abracadabra", "abrade", "abraded", "abrades", "abrading", "abrasion", "abrasions", "abrasive", "abrasively", "abrasiveness", "abrasives", "abreast", "abridge", "abridged", "abridgement", "abridgements", "abridges", "abridging", "abridgment", "abridgments", "abroad", "abrogate", "abrogated", "abrogates", "abrogating", "abrogation", "abrupt", "abruptly", "abruptness", "abscess", "abscesses", "abscond", "absconded", "absconding", "absconds", "abseil", "abseiled", "abseiling", "abseils", "absence", "absences", "absent", "absented", "absentee", "absenteeism", "absentees", "absenting", "absently", "absents", "absinth", "absinthe", "absolute", "absolutely", "absolutes", "absolution", "absolutism", "absolutist", "absolutists", "absolve", "absolved", "absolves", "absolving", "absorb", "absorbed", "absorbency", "absorbent", "absorbing", "absorbs", "absorption", "abstain", "abstained", "abstainer", "abstainers", "abstaining", "abstains", "abstemious", "abstention", "abstentions", "abstinence", "abstinent", "abstract", "abstracted", "abstractedly", "abstracting", "abstraction", "abstractions", "abstracts", "abstruse", "absurd", "absurdities", "absurdity", "absurdly", "abundance", "abundant", "abundantly", "abuse", "abused", "abuser", "abusers", "abuses", "abusing", "abusive", "abusively", "abut", "abuts", "abutted", "abutting", "abuzz", "abysmal", "abysmally", "abyss", "abysses", "acacia", "acacias", "academe", "academia", "academic", "academically", "academician", "academicians", "academics", "academies", "academy", "accede", "acceded", "accedes", "acceding", "accelerate", "accelerated", "accelerates", "accelerating", "acceleration", "accelerator", "accelerators", "accent", "accented", "accenting", "accents", "accentuate", "accentuated", "accentuates", "accentuating", "accentuation", "accept", "acceptability", "acceptable", "acceptably", "acceptance", "acceptances", "accepted", "accepting", "accepts", "access", "accessed", "accesses", "accessibility", "accessible", "accessing", "accession", "accessions", "accessories", "accessorise", "accessorised", "accessorises", "accessorising", "accessorize", "accessorized", "accessorizes", "accessorizing", "accessory", "accident", "accidental", "accidentally", "accidents", "acclaim", "acclaimed", "acclaiming", "acclaims", "acclamation", "acclimate", "acclimated", "acclimates", "acclimating", "acclimatisation", "acclimatise", "acclimatised", "acclimatises", "acclimatising", "acclimatization", "acclimatize", "acclimatized", "acclimatizes", "acclimatizing", "accolade", "accolades", "accommodate", "accommodated", "accommodates", "accommodating", "accommodation", "accommodations", "accompanied", "accompanies", "accompaniment", "accompaniments", "accompanist", "accompanists", "accompany", "accompanying", "accomplice", "accomplices", "accomplish", "accomplished", "accomplishes", "accomplishing", "accomplishment", "accomplishments", "accord", "accorded", "according", "accordingly", "accordion", "accordions", "accords", "accost", "accosted", "accosting", "accosts", "account", "accountability", "accountable", "accountancy", "accountant", "accountants", "accounted", "accounting", "accounts", "accouterments", "accoutrements", "accredit", "accreditation", "accredited", "accrediting", "accredits", "accretion", "accretions", "accrual", "accruals", "accrue", "accrued", "accrues", "accruing", "accumulate", "accumulated", "accumulates", "accumulating", "accumulation", "accumulations", "accumulative", "accumulator", "accumulators", "accuracy", "accurate", "accurately", "accursed", "accusation", "accusations", "accusative", "accusatives", "accusatory", "accuse", "accused", "accuser", "accusers", "accuses", "accusing", "accusingly", "accustom", "accustomed", "accustoming", "accustoms", "ace", "acerbic", "acerbity", "aces", "acetaminophen", "acetate", "acetone", "acetylene", "ache", "ached", "aches", "achievable", "achieve", "achieved", "achievement", "achievements", "achiever", "achievers", "achieves", "achieving", "aching", "achingly", "achy", "acid", "acidic", "acidified", "acidifies", "acidify", "acidifying", "acidity", "acidly", "acids", "acknowledge", "acknowledged", "acknowledgement", "acknowledgements", "acknowledges", "acknowledging", "acknowledgment", "acknowledgments", "acme", "acne", "acolyte", "acolytes", "acorn", "acorns", "acoustic", "acoustically", "acoustics", "acquaint", "acquaintance", "acquaintances", "acquaintanceship", "acquainted", "acquainting", "acquaints", "acquiesce", "acquiesced", "acquiescence", "acquiescent", "acquiesces", "acquiescing", "acquire", "acquired", "acquirer", "acquirers", "acquires", "acquiring", "acquisition", "acquisitions", "acquisitive", "acquisitiveness", "acquit", "acquits", "acquittal", "acquittals", "acquitted", "acquitting", "acre", "acreage", "acreages", "acres", "acrid", "acrimonious"],
				fname : ["Ara", "Jack", "Bono", "Robert", "Mark", "Marc", "Robin", "Stuart", "Stewart", "Howard", "Paul", "Mathieu", "Mathias", "James", "Jerome", "Michel"],
				lname : ["Pehlivanian", "Channing", "Robertson", "Hewson", "Clayton", "Flemming", "Philips", "Sylvain", "Brule", "Brl", "Monette"],
				country : ["Afghanistan", "Albania", "Algeria", "American Samoa", "Andorra", "Angola", "Anguilla", "Antarctica", "Antigua and Barbuda", "Argentina", "Armenia", "Aruba", "Ashmore and Cartier Islands", "Australia", "Austria", "Azerbaijan", "Bahamas, The", "Bahrain", "Baker Island", "Bangladesh", "Barbados", "Bassas da India", "Belarus", "Belgium", "Belize", "Benin", "Bermuda", "Bhutan", "Bolivia", "Bosnia and Herzegovina", "Botswana", "Bouvet Island", "Brazil", "British Indian Ocean Territory", "British Virgin Islands", "Brunei", "Bulgaria", "Burkina Faso", "Burma", "Burundi", "Cambodia", "Cameroon", "Canada", "Cape Verde", "Cayman Islands", "Central African Republic", "Chad", "Chile", "China", "Christmas Island", "Clipperton Island", "Cocos (Keeling) Islands", "Colombia", "Comoros", "Congo, Democratic Republic of the", "Congo, Republic of the", "Cook Islands", "Coral Sea Islands", "Costa Rica", "Cote d'Ivoire", "Croatia", "Cuba", "Cyprus", "Czech Republic", "Denmark", "Djibouti", "Dominica", "Dominican Republic", "East Timor", "Ecuador", "Egypt", "El Salvador", "Equatorial Guinea", "Eritrea", "Estonia", "Ethiopia", "Europa Island", "Falkland Islands (Islas Malvinas)", "Faroe Islands", "Fiji", "Finland", "France", "France, Metropolitan", "French Guiana", "French Polynesia", "French Southern and Antarctic Lands", "Gabon", "Gambia, The", "Gaza Strip", "Georgia", "Germany", "Ghana", "Gibraltar", "Glorioso Islands", "Greece", "Greenland", "Grenada", "Guadeloupe", "Guam", "Guatemala", "Guernsey", "Guinea", "Guinea-Bissau", "Guyana", "Haiti", "Heard Island and McDonald Islands", "Holy See (Vatican City)", "Honduras", "Hong Kong", "Howland Island", "Hungary", "Iceland", "India", "Indonesia", "Iran", "Iraq", "Ireland", "Israel", "Italy", "Jamaica", "Jan Mayen", "Japan", "Jarvis Island", "Jersey", "Johnston Atoll", "Jordan", "Juan de Nova Island", "Kazakhstan", "Kenya", "Kingman Reef", "Kiribati", "Korea, North", "Korea, South", "Kuwait", "Kyrgyzstan", "Laos", "Latvia", "Lebanon", "Lesotho", "Liberia", "Libya", "Liechtenstein", "Lithuania", "Luxembourg", "Macau", "Macedonia", "Madagascar", "Malawi", "Malaysia", "Maldives", "Mali", "Malta", "Man, Isle of", "Marshall Islands", "Martinique", "Mauritania", "Mauritius", "Mayotte", "Mexico", "Micronesia, Federated States of", "Midway Islands", "Moldova", "Monaco", "Mongolia", "Montserrat", "Morocco", "Mozambique", "Myanmar", "Namibia", "Nauru", "Navassa Island", "Nepal", "Netherlands", "Netherlands Antilles", "New Caledonia", "New Zealand", "Nicaragua", "Niger", "Nigeria", "Niue", "Norfolk Island", "Northern Mariana Islands", "Norway", "Oman", "Pakistan", "Palau", "Palmyra Atoll", "Panama", "Papua New Guinea", "Paracel Islands", "Paraguay", "Peru", "Philippines", "Pitcairn Islands", "Poland", "Portugal", "Puerto Rico", "Qatar", "Reunion", "Romania", "Russia", "Rwanda", "Saint Helena", "Saint Kitts and Nevis", "Saint Lucia", "Saint Pierre and Miquelon", "Saint Vincent and the Grenadines", "Samoa", "San Marino", "Sao Tome and Principe", "Saudi Arabia", "Senegal", "Serbia and Montenegro", "Seychelles", "Sierra Leone", "Singapore", "Slovakia", "Slovenia", "Solomon Islands", "Somalia", "South Africa", "South Georgia and the Islands", "Spain", "Spratly Islands", "Sri Lanka", "Sudan", "Suriname", "Svalbard", "Swaziland", "Sweden", "Switzerland", "Syria", "Taiwan", "Tajikistan", "Tanzania", "Thailand", "Togo", "Tokelau", "Tonga", "Trinidad and Tobago", "Tromelin Island", "Tunisia", "Turkey", "Turkmenistan", "Turks and Caicos Islands", "Tuvalu", "Uganda", "Ukraine", "United Arab Emirates", "United Kingdom", "United States", "United States Minor Outlying Islands", "Uruguay", "Uzbekistan", "Vanuatu", "Venezuela", "Vietnam", "Virgin Islands", "Virgin Islands (UK)", "Virgin Islands (US)", "Wake Island", "Wallis and Futuna", "West Bank", "Western Sahara", "Western Samoa", "World", "Yemen", "Zaire", "Zambia", "Zimbabwe"]
			}
		}
	}
}