MSFW.DataRefinement.Filters	= Class.create(MSFW.DataRefinement, {
	
	LABEL_TEXT			: aGlobalMsfWords["REF_PLACEHOLDER_FILTERS"],
	
	BUTTON_TEXT			: aGlobalMsfWords["MSFW_SEARCH"],
	
	TABLE_CLASS			: "RSMiniPanelButton",
	
	TABLE_CLASS_ACTIVE	: "RSMiniPanelButtonActive", 
	
	visibleElements	: $A(),
	
	initialize : function(options)
	{
		MSFW.DataRefinement.prototype.initialize.apply(this, arguments);
		
		this.lastOn	= 0;
		this.Form	= new Element("form");
		//this.Table	= new Element("table", {"class":this.TABLE_CLASS, "cellpadding":"0", "cellspacing":"0"});
		this.Table	= new Element("span");
		this.Panel	= new Element("div");
		this.Link 	= new Element("a");
		this.Panel.addClassName("popupPanel");
		
		this.Values	= {};
		
		this.Container.insert(this.Table);
		
		
		this.ContentDiv	= new Element("div")
		this.ContentDiv.addClassName("popupPanelContent");
		this.ContentDiv.insert(this.Form);
		var oContentLayout	= new Element("div");
		var oContentRight	= new Element("div");
		this.Panel.insert(oContentLayout.insert(oContentRight.insert(this.ContentDiv)));
		oContentLayout.addClassName("popupPanelContentLayout");
		oContentRight.addClassName("popupPanelContentRight");
		var oBottomLayout	= new Element("div");
		var oBottomRight	= new Element("div");
		var oBottomCenter	= new Element("div");
		var oBottom			= new Element("div");
		this.Panel.insert(oBottomLayout.insert(oBottomRight.insert(oBottomCenter.insert(oBottom))));		
		oBottomLayout.addClassName("popupPanelBottomLayout");
		oBottomRight.addClassName("popupPanelBottomRight");
		oBottomCenter.addClassName("popupPanelBottomCenter");
		oBottom.addClassName("popupPanelBottom");
		this._buildTable();
		this._buildPanel();
		//this._buildButton();
	},
	
	setDefaultValues : function(values)
	{			
		var inputs		= this.Form.getInputs();
		var lastCheck	= null;
		var me			= this;

		inputs.each(function(e) {			
			$H(values).each(function(k){
				if(e.name.include(k.key) && k.value != "") {
					e.value				= k.value;
					me.Link.update(new Element("span").insert(new Element("u").insert(me.LABEL_TEXT)));
					return;
				}
				
			})
			/*
			if(e.name != "") {
				$H(values).each(function(k){
					if(e.name.include(k.key)) {
						e.value				= k.value;						
						lastCheck.checked	= true;
						e.enable();
						return;
					}
					
				})
				
			}
			else {
				lastCheck	= e;
			}*/
			
		});
		
	},
	
	getValue : function()
	{
		this._setValues();
		return this.Values;
	},
	
	_setValues : function()
	{		
		var inputs	= this.Form.getInputs();
		var values	= {};
		bUnderline  = false;
		var me 		= this;
		inputs.each(function(e) {			
			/*
			if(e.name != "" && !e.disabled) {
				values[e.name]	= e.value; 
			}*/
			if(e.value != "" && e.value != me.BUTTON_TEXT) {
				bUnderline = true;
				values[e.name]	= e.value;
			}
			
		});
		if (bUnderline) {
			this.Link.update(new Element("span").insert(new Element("u").insert(this.LABEL_TEXT)));
		}
		else {
			this.Link.update(new Element("span").insert(this.LABEL_TEXT));
		}
		
		this.Values	= values;
	},
	
	_buildButton : function()
	{
		var me		= this;
		var Button	= new Element("input", {"type":"button", "value":this.BUTTON_TEXT});
		
		Button.observe("click", function(event){
			event.stop();
			
			
			me._setValues();
			me._fireEvent("buttonclick");
			me._clearElements();			
		});

		return Button;
	},
	
	_buildPanel : function()
	{
		var me		= this;
		
		var Table	= new Element("table", {"cellpadding":"5","cellspacing":"5"});
		var i		= 0;
		this.Form.insert(Table);

		$H(this.Options.columns).each(function(e){
			if(e.value.filter) {
				var Row	= $(Table.insertRow(i));
				i++;
				
				//var Cell1	= Row.insertCell(0);
				var Cell2	= $(Row.insertCell(0));
				var Cell3	= $(Row.insertCell(1));
				
				//var Check	= new Element("input", {"type":"checkbox"});
				//Cell1.insert(Check);
				
				Cell2.insert(e.value.title);
				
				//var Input	= new Element("input", {"disabled":true, "type":"text", "name":"rs_searchParam_" + e.key});
				var Input	= new Element("input", {"type":"text", "name":"rs_searchParam_" + e.key});
				Cell3.insert(Input);
				
				//Check.observe("click", function(){(Check.checked) ? Input.enable() : Input.disable()});
			}
			
		});
		var Row	= Table.insertRow(i);
		var Cell2 = $(Row.insertCell(0));
		Cell2.insert(this._buildButton());
		this.Panel.hide();
	},
	
	_buildTable : function()
	{
		var me 		= this;
		this.Link.addClassName(this.TABLE_CLASS);		
		this.textContainer	= new Element("span").insert(this.LABEL_TEXT);	
		this.Link.insert(this.textContainer);
		this.Table.insert(this.Link);
		this.Table.insert(this.Panel);
		
		
		this.Link.observe("click", function(){
			if(me.Panel.visible()) {
				return;
			}
			
			me._clearElements();			
			var tmp	= {
				Panel	: me.Panel,
				onClick	: me._stop.bindAsEventListener(me, me.Panel, me)
			};
			
			me.visibleElements.push(tmp);
			var d		= new Date();				
			me.lastOn	= d.getTime();	
			
			var Html	= $$("html")[0];
			Html.observe("click", tmp.onClick);
			//me.Panel.show();
			MSF_Effect.show(me.Panel);
			me.Panel.style.left = (me.Link.positionedOffset()[0] - 4) + "px";
			me.Panel.style.top 	= (me.Link.positionedOffset()[1] + me.Link.getHeight()) + "px";
		});
		
		
		/*
		var me		= this;
		var Row		= this.Table.insertRow(0);
		var Cell1	= $(Row.insertCell(0));
		var Cell2	= $(Row.insertCell(1));
		
		Cell1.insert(this.LABEL_TEXT);
		Cell2.insert(new Element("img", {"src":"/templates/default/images/win-rs/rs-panel-arrow.gif"})).insert(this.Panel);
	
		this.Table.observe("mouseover", function(){			
			me.Table.addClassName(me.TABLE_CLASS_ACTIVE);
		});
		
		this.Table.observe("mouseout", function(){			
			me.Table.removeClassName(me.TABLE_CLASS_ACTIVE);
		});
		
		Cell2.observe("click", function(){			
			if(me.Panel.visible()) {
				return;
			}
			
			me._clearElements();			
			var tmp	= {
				Panel	: me.Panel,
				onClick	: me._stop.bindAsEventListener(me, me.Panel, me)
			};
			
			me.visibleElements.push(tmp);
			var d		= new Date();				
			me.lastOn	= d.getTime();	
			
			var Html	= $$("html")[0];
			Html.observe("click", tmp.onClick);
			me.Panel.show();			
		});
		*/
	},
	
	_stop : function(e, Panel, me)
	{		
		var Html	= $$("html")[0];
		var d		= new Date();
		
		if(!e || (Panel.visible() && (d.getTime() - me.lastOn) > 100 && !me._inPanel(e.target))) {			
			this._clearElements();
		}
	},
	
	_clearElements : function()
	{
		var me		= this;
		var Html	= $$("html")[0];		
		
		this.visibleElements.each(function(e)
		{			
			//e.Panel.hide();	
			MSF_Effect.hide(e.Panel);					
			Html.stopObserving("click", e.onClick);			
		});
		
		this.visibleElements.clear();		
	},
	
	_inPanel : function(el)
	{
		var ret	= false;
		
		while(el) {
			if(el == this.Panel) {
				ret	= true;
				break;
			}
			
			el	= el.parentNode;
		}		
			
		return ret;
	}
});