MSFW.DataRefinement.Groups	= Class.create(MSFW.DataRefinement.Filters, {
	
	LABEL_TEXT	: aGlobalMsfWords["REF_PLACEHOLDER_GROUPS"],
	
	BUTTON_TEXT	: aGlobalMsfWords["MSFW_GROUP"],
	
	LIST_CLASS	: "MSFW_DataRefinement_Groups",
	
	_buildPanel : function(values)
	{		
		var me	= this;
		this.Ul	= new Element("ul", {"class":this.LIST_CLASS});
		this.Ul.identify();
		
		this.Form.update(this.Ul);		
		
		//
		if (values) {
			var aSort = [];
			for (var i = 0; i < values.length; i++) {
				$H(this.Options.columns).each(function(e) {
					if(e.value.group) {
						if (values[i] == e.value.name) {
							aSort.push(e.value);
							me._drawGroupElement(e.value.name, e.value.title, true);
						}
					}
				});
			}

			$H(this.Options.columns).each(function(e) {
				if(e.value.group) {
					var bExists = false;
					for (var i = 0; i < aSort.length; i++) {
						if (e.value.name == aSort[i].name) {
							bExists = true;
							break;
						}
					}
					
					if (!bExists) {
						me._drawGroupElement(e.value.name, e.value.title);
					}
				}
			});
		}
		//
		
		else {
			$H(this.Options.columns).each(function(e){
				if(e.value.group) {
					me._drawGroupElement(e.value.name, e.value.title);
				}
			});
		}
		this.Form.insert(this._buildButton());
		this.Panel.hide();
	},
	
	_buildButton : function()
	{
		var me		= this;
		var Button	= new Element("input", {"type":"button", "value":this.BUTTON_TEXT});
		
		Button.observe("click", function(event){
			event.stop();
			
			
			me._setValues();
			me._fireEvent("buttonclick");
			me._clearElements();			
		});

		return Button;
	},
	
	_drawGroupElement: function(name, title, checked)
	{
		var Li	= new Element("li");
		Li.identify();
		this.Ul.insert(Li);
		
		var Input	= new Element("input", {
			"type"	: "hidden", 
			"value"	: "0",
			"name"	: "rs_groups[" + name + "]"
		});
		
		Li.insert(Input);
		
		var Span	= new Element("span", {"class":"drag"});
		Span.insert("&#160;");
		Li.insert(Span);
		
		var Label	= new Element("label");
		Li.insert(Label);
		
		var Checkbox	= new Element("input", {
			"type"	: "checkbox",
			"value"	: "1",
			"name"	: "rs_groups[" + name + "]"
		});
		
		if (checked) {
			Checkbox.checked = true;
			Checkbox.defaultChecked = true;
		}
		
		Label.insert(Checkbox).insert(title);
	},
	
	createSortable : function()
	{
		Sortable.create(this.Ul, {"handle":"drag"});
	},
	
	_setValues : function()
	{
		if (!this.counter) {
			this.counter = 1;
		}
		else {
			this.counter++;
		}
		
		var inputs	= this.Form.getInputs();
		var values	= {};
		var me 		= this;
		
		if (this.counter < 3 && this.aDefault && this.aDefault.length > 0) {
			for (var i = 0; i < this.aDefault.length; i++) {
				inputs.each(function(e) {			
					if(e.name == "rs_groups[" + me.aDefault[i] + "]" && (e.type.toUpperCase() != "CHECKBOX" || e.checked)) {
						values[e.name] = "1";
						throw $break;
					}
				});
			}

			inputs.each(function(e2) {
				var bHas = false;
				$H(values).each(function(e) {
					if (e[0] == e2.name) {
						bHas = true;
						throw $break;
					}
				});
				
				if (!bHas) {
					values[e2.name] = e2.value;
				}
			});
		}
		else {
			inputs.each(function(e) {			
				if(e.name != "" && (e.type.toUpperCase() != "CHECKBOX" || e.checked)) {
					values[e.name] = e.value; 
				}
			});
		}
		
		me.textContainer.style.textDecoration = "none";
		$H(values).each(function(e) {
			if(e[1] == "1") {
				me.textContainer.style.textDecoration = "underline";
			}
							
		});

		this.Values	= values;
	},
	
	setDefaultValues : function(values)
	{
		var flag 	= false;
		var inputs	= this.Form.getInputs();
		
		inputs.each(function(e) {			
			if(e.name != "" && e.type.toUpperCase() == "CHECKBOX") {			
				$A(values).each(function(k){
					//if(e.name.include(k)) {
					if(e.name == "rs_groups[" + k + "]") {
						e.checked	= true;
						flag		= true;
						throw $break;
					}
					
				});				
				
			}
			
		});
		
		if(flag) {
			this.aDefault = values;
			this._buildPanel(values);
			this.createSortable();
			//this._setValues(values);
			this._fireEvent("buttonclick");
		}
		
	}
		
});