MSFW.DataRefinement.QuickFilter	= Class.create(MSFW.DataRefinement, {
	
	CONTAINER_CLASS		: "RSSearchBar",
	
	BUTTON_TEXT	: aGlobalMsfWords["MSFW_SEARCH"],
	
	initialize : function(options)
	{
		MSFW.DataRefinement.prototype.initialize.apply(this, arguments);
		
		this.Container.addClassName(this.CONTAINER_CLASS);
		
		//this.QFContainer	= new Element("div", {"class":"RSSearchBarRow"});
		this.Table	= new Element("table", {"cellpadding":"0", "cellspacing":"0"});
		this.Table.addClassName("RSMiniSearchBar");
		this.Row	= $(this.Table.insertRow(0));
		this.Container.insert(this.Table);
		
		this.Input	= null;
		this.Button	= null;
		
		this._buildTitle();		
		this._buildInput();
		this._buildButton();		
	},
	
	_buildTitle : function()
	{	
		$(this.Row.insertCell(0)).addClassName("RSMiniSearchText").insert(jsLocale.JS_LOCALE_SEARCH);
		//this.QFContainer.insert((new Element("div", {"class":"RSSearchBarLabel"})).insert("Поиск"));
	},
	
	_buildInput : function()
	{
		var me	= this;
		this.Input	= new Element("input", {"type":"text", "class":"searchInput"});
		this.Input.observe("keyup", function(event){
			//13 - enter
			if(event.keyCode == 13){
				me._onClick();
			}
			
		});
		
		var Table	= new Element("table", {"cellpadding":"0","cellspacing":"0"});
		var Row		= $(Table.insertRow(0));
		$(Row.insertCell(0)).addClassName("RSMiniSearchImg").insert("&#160;");
		$(Row.insertCell(1)).insert(this.Input);
		
		$(this.Row.insertCell(1)).addClassName("RSMiniSearchInput").insert((new Element("div")).insert(Table));
		
		
		//this.QFContainer.insert((new Element("div", {"class":"RSSearchBarInput"})).insert(this.Input));		
	},
	
	_buildButton : function()
	{
		this.Button	= new Element("input", {"type":"button", "value":this.BUTTON_TEXT, "class":"buttonStub"});
		this.Button.observe("click", this._onClick.bind(this));
		$(this.Row.insertCell(2)).addClassName("RSMiniSearchButton").insert(this.Button);
		
		//this.QFContainer.insert((new Element("div", {"class":"RSSearchBarButton"})).insert(this.Button));
	},
	
	_onClick : function()
	{		
		this.Values	= {"rs_quickFilter" : this.Input.value};
		this._fireEvent("buttonclick");
	},
	
	focus : function()
	{		
		this.Input.focus();		
	}
	
});