MSFW.DataSource.Calendar	= Class.create(MSFW.DataSource, {
	initialize : function(options)
	{
		MSFW.DataSource.prototype.initialize.apply(this, arguments);
		//this.anhor				= new Element("a", {"href":"#","onclick":"return false;","style": "text-decoration:none;margin:0px;padding:0px;"});
		this.Container.addClassName("calendar_date_select");
		this._buildCalendar();
		//this.Container			= this.Container.wrap(this.anhor);
		this.Container.observe('keyup', function(event){if(event.keyCode == 13){this.next(0).down(0).click();}});
	},
	
	_buildCalendar : function()
	{		
		this._parseDate();
		this._buildHeaderDiv();
		this._buildCalendarGrid();
		this._buildButtonsDiv();
		
		this._refresh();		
	},
	
	_parseDate: function()
	{				
		if(this.Options["default"]) {
			this.Date	= Date.parseFormattedString(this.Options["default"]);
			if(!this.Date) {
				this.Date	= new Date();
			}
		}
		else {
			this.Date			= new Date();
		}		
		
		this.SelectedDate	= new Date(this.Date);		
		this.Date.setDate(1);
	},
	
	_refresh: function ()
	{
		this._refreshMonthYear();
		this._refreshCalendarGrid();
		this._refreshTime();
		
		this._updateSelectedDate();
		this._setSelectedClass();		
	},
	
	_refreshMonthYear: function()
	{		
	    var m = this.Date.getMonth();
	    var y = this.Date.getFullYear();
	    
	    this.MonthSelect.setValue(m, false);
	    if (y > 2037) {
	    	y = 2037;
	    }
	    
	    this.YearSelect.setValue(y);  
	},
	
	_refreshTime : function()
	{
		if(this.Options.time) {
		    this.HourSelect.setValue(this.SelectedDate.getHours());
		    this.MinuteSelect.setValue(this.SelectedDate.getPaddedMinutes());
		}
		
	},
	
	_refreshCalendarGrid: function ()
	{
		this.BeginingDate	= new Date(this.Date).stripTime();
		this.BeginingDate.setDate(1);
		this.BeginingDate.setHours(12); 			// Prevent daylight savings time boundaries from showing a duplicate day
		var preDays = this.BeginingDate.getDay() 	// draw some days before the fact
		
		if (preDays < 3) {
			preDays += 7;
		}
		
	    this.BeginingDate.setDate(1 - preDays + Date.first_day_of_week);
	    
	    var iterator	= new Date(this.BeginingDate);	    
	    var today		= new Date().stripTime();
	    var thisMonth	= this.Date.getMonth();
	    
	       
	    for(var cellIndex = 0; cellIndex<42; cellIndex++)
	    {
	    	var day			= iterator.getDate();
	    	var month		= iterator.getMonth();
	    	var cell		= this.calendarDayGrid[cellIndex];
	    	var div			= $(cell.childNodes[0]);	    	
	    	div.className	= "";
	      
	    	div.update(day);
	    	
	    	if (month!=thisMonth) {	    		
	    		div.className = "other";
	    	}
	    	
	    	cell.day	= day;
	    	cell.month	= month;
	    	cell.year	= iterator.getFullYear();
	    	
	    	iterator.setDate(day + 1);	      
	    }
	    
	    if(this.todayCell) {
	    	this.todayCell.removeClassName("today");
	    }
	    
	    if ($R(0, 41).include(daysUntil = this.BeginingDate.stripTime().daysDistance(today)) ) {
	    	this.todayCell = this.calendarDayGrid[daysUntil];
	    	this.todayCell.addClassName("today");
	    }
		
	},
	
	_buildHeaderDiv: function()
	{
		var me			= this;
		
		this.HeaderDiv	= new Element("div", {"clear":"left"});
		this.HeaderDiv.addClassName("cds_header");
		this.Container.insert(this.HeaderDiv);
		
		this.NextMonthButton	= new Element("a", {"href":"#", "onclick":"return false;"}).insert("&gt;");
		this.NextMonthButton.addClassName("next");
				
		this.HeaderDiv.insert(this.NextMonthButton);
					
		this.PrevMonthButton	= new Element("a", {"href":"#", "onclick":"return false;"}).insert("&lt;");
		this.PrevMonthButton.addClassName("prev");
		
		this.HeaderDiv.insert(this.PrevMonthButton);
		
		this.MonthSelect	= new MSFW.DataSource.Calendar.SelectBox(this.HeaderDiv, $R(0,11).map(function(m){return [Date.months[m], m]}), {className: "month", onchange: function () { this._navMonth(this.MonthSelect.getValue()) }.bindAsEventListener(this)});
		this.YearSelect		= new MSFW.DataSource.Calendar.MaskInput(this.HeaderDiv, [], {style: "width:25pt; font-size:11px;", className: "year"}, null, {format:"    ", regex:/^\d{1,4}$/}, function () { this._navYear(this.YearSelect.getValue()) }.bindAsEventListener(this));
		
		//this.NextMonthButton.observe("click",  this._navMonth.bind(this, parseInt(this.MonthSelect.getValue()) + 1));
		//this.PrevMonthButton.observe("click",  this._navMonth.bind(this, parseInt(this.MonthSelect.getValue()) - 1));
		
		this.NextMonthButton.observe("click",  function(){			
			me._navMonth(parseInt(me.MonthSelect.getValue()) + 1)
		});
		
		this.PrevMonthButton.observe("click",  function(){			
			me._navMonth(parseInt(me.MonthSelect.getValue()) - 1)
		});
		
	},
	
	_buildCalendarGrid: function() 
	{
		this.BodyDiv			= new Element("div");
		this.BodyDiv.addClassName("cds_body");
		this.Container.insert(this.BodyDiv);
		this.calendarDayGrid	= [];
		var daysTable			= new Element("table", {"cellpadding":"0px", "cellspacing":"0px", "width":"100%", "align":"left"});
		var tHead		= new Element("thead");
		var weekdaysRow = new Element("tr");
		daysTable.insert(tHead.insert(weekdaysRow));
		Date.weekdays.each( function(weekday) { 			
			var Th	= new Element("th").insert(weekday);
			weekdaysRow.insert(Th);
	    });
		
		var daysTBody = new Element("tbody");
		daysTable.insert(daysTBody);
		
		var rowNumber	= 0, weekday;
		var daysRow		= null;
	    for(var cellIndex = 0; cellIndex < 42; cellIndex++)
	    {
	    	weekday	= (cellIndex + Date.first_day_of_week ) % 7;
	    	if(cellIndex % 7 == 0) {
	    		daysRow	= new Element("tr");
	    		daysRow.addClassName("row_" + rowNumber++);
	    		daysTBody.insert(daysRow);	    		
	    	}
	    	
	    	this.calendarDayGrid[cellIndex]	= new Element("td",{
	    		"style"	: "cursor:pointer"
	    	});
	    	
	    	this.calendarDayGrid[cellIndex].addClassName((weekday==0) || (weekday==6) ? " weekend" : "");
	    	this.calendarDayGrid[cellIndex].insert(new Element("div"));
	    	
	    	daysRow.insert(this.calendarDayGrid[cellIndex]);
	    	
	    	this.calendarDayGrid[cellIndex].observe("click", this._updateSelectedDate.bind(this, this.calendarDayGrid[cellIndex], true));
	    }
	    var divClear			= new Element("div", {style: "clear:both"});
		
		this.BodyDiv.insert(daysTable);
		this.BodyDiv.insert(divClear);
	    		
		
	},
	
	_buildButtonsDiv: function()
	{		
		
		if(this.Options.time)
	    {
			this.ButtonsDiv	= new Element("div", {"clear":"left"});
			this.ButtonsDiv.addClassName("cds_buttons");
			this.Container.insert(this.ButtonsDiv);
			
			this.HourSelect	= new MSFW.DataSource.Calendar.MaskInput(
				this.ButtonsDiv, 
			    [], 
			    {
					size: 2,
					maxlength: 2,
			      	calendar_date_select: this,
			      	className: "hour"
			    }, 
			    null, 
			    {format:" ", regex:/([1-6]{1})?[0-9]{1}/, check:function(val){if(val>=0 && val<=23){return true;}else{return false}}},
			    function () { this._updateSelectedDate({"hour":this.HourSelect.getValue()}) }.bindAsEventListener(this)
			);
			
			var tmp = new Element("span").insert(":");
			tmp.addClassName("separator");
			this.ButtonsDiv.insert(tmp);
			
			this.MinuteSelect	= new MSFW.DataSource.Calendar.MaskInput(
				this.ButtonsDiv, 
				[], 
		      	{
		      		size: 2,
		      		maxlength: 2,
		      		calendar_date_select: this,
		      		className: "minute"
		      	}, 
		      	null, 
		      	{format:" ", regex:/([0-6]{1})?[0-9]{1}/, check:function(val){if(val>=0 && val<=59){return true;}else{return false}}},
		      	function () { this._updateSelectedDate({"minute":this.MinuteSelect.getValue()}) }.bindAsEventListener(this)
			);
			
	    }
		
	},
	
	_navMonth: function(month)
	{	
		(targetDate = new Date(this.Date)).setMonth(month);
		this._updateSelectedDate({"month":month});
		return (this._navTo(targetDate));
	},
	
	_navYear: function(year)
	{
		if (year > 2037) {
			year = 2037;
		}
		
		(targetDate = new Date(this.Date)).setYear(year);
		this._updateSelectedDate({"year":year});
		return (this._navTo(targetDate));
	},
	
	_navTo: function(date)
	{
	    this.Date = date;
	    this.Date.setDate(1);
	    
	    this._refresh();
	   
	    return true;
	},
	
	_updateSelectedDate : function(partsOrElement)
	{		
	    var parts = $H(partsOrElement);
	    	    
	    if (parts.get("day")) {	
	    	this.SelectedDate.setYear(parts.get("year"));
	    	this.SelectedDate.setMonth(parts.get("month"));    	
	    	this.SelectedDate.setDate(parts.get("day"));
	    	this.SelectedDate.setDate(parts.get("day")); // kontrol'nii    		    	
	    }	    
	    if (!isNaN(parts.get("hour"))) {
	    	this.SelectedDate.setHours(parts.get("hour"));
	    }    	 
	    if (!isNaN(parts.get("minute"))) {
	    	this.SelectedDate.setMinutes(parts.get("minute"));
	    }
	    if (!isNaN(parts.get("month"))) {
	    	this.SelectedDate.setMonth(parts.get("month"));   	
	    }
	    if (!isNaN(parts.get("year"))) {
	    	this.SelectedDate.setYear(parts.get("year"));
	    }
	    
	    
	    this.Values[0]	= [{"name":"date", "value":this.SelectedDate.toFormattedString(this.Options.time)}]
	    this._setSelectedClass();	  
	},
	
	_clearSelectedClass: function()
	{
		if(this.selectedCell){
			this.selectedCell.removeClassName("selected");
		}
		
	},
	
	_setSelectedClass: function()
	{
		this._clearSelectedClass()
		if($R(0,42).include(daysUntil = this.BeginingDate.stripTime().daysDistance(this.SelectedDate.stripTime()))) {
			this.selectedCell = this.calendarDayGrid[daysUntil];
			if (this.selectedCell) {
				this.selectedCell.addClassName("selected");
			}
		}
		
	},
	
	clear : function()
	{
		this.Values = {};		
	}
	
});
