MSFW.Input	= Class.create(MSFW.EventListener, {
	
	DATA_ROW_DELIMETER		: "|^|row|^|",
	
	DATA_COL_DELIMETER		: "/^/col/^/",
	
	VALUE_SEPARATOR			: " ",
	
	CONTAINER_CLASS_NAME	: "placeHolder",
	
	EVENT_TYPES				: ["valuechange"],
	
	initialize : function(options)
	{
		MSFW.EventListener.prototype.initialize.apply(this, arguments);	
	
		this.Options		= Object.extend({
			"inputName" 	: "undefinedInput",
			"inputClass"	: ""			
		}, options || {});
		
		this.Input		= null;
		this.Values		= {};
		this.Container	= (new Element("span")).addClassName(this.CONTAINER_CLASS_NAME);
	},
	
	setOptions : function(key, value)
	{
		this.Options[key]	= value;
	},
	
	getOptions : function(key)
	{
		return this.Options[key];
	},
	
	setArrayValue : function(Value)
	{
		this.Values	= Value;
		this._draw();
	},
	
	addArrayValue : function(Value)
	{	
		this.Values	= Object.extend(this.Values, Value || {});
		this._draw();
	},
	
	getArrayValue : function()
	{
		return this.Values;
	},
	
	setStringValue : function(value)
	{
		
	},
	
	getDom : function()
	{
		return this.Container;
	},
	
	clear : function()
	{
		this.Values		= {};
		this._fireEvent("valuechange");
	},
	
	_draw : function()
	{
		this._fireEvent("valuechange");
	},
	
	getHtmlInput : function()
	{
		return this.Input;
	},
	
	stripElements: function(string)
	{
		string = string.split("&#160;").join(" ");
		string = string.split("&quot;").join("\"");
		string = string.split("<br/>").join(", ");
		string = string.split("<br />").join(", ");
		string = string.split("<br>").join(", ");
		string = string.split("&lt;").join("<");
		string = string.split("&gt;").join(">");
		string = string.split("&amp;").join("&");
		
		return string;
	},
	
	strip_tags: function(str, allowed_tags)
	{
	    var key = '', allowed = false;
	    var matches = [];
	    var allowed_array = [];
	    var allowed_tag = '';
	    var i = 0;
	    var k = '';
	    var html = '';
	 
	    var replacer = function(search, replace, str) {
	        return str.split(search).join(replace);
	    };
	 
	    // Build allowes tags associative array
	    if (allowed_tags) {
	        allowed_array = allowed_tags.match(/([a-zA-Z]+)/gi);
	    }
	  
	    str += '';
	 
	    // Match tags
	    matches = str.match(/(<\/?[\S][^>]*>)/gi);
	 
	    // Go through all HTML tags
	    for (key in matches) {
	        if (isNaN(key)) {
	            // IE7 Hack
	            continue;
	        }
	 
	        // Save HTML tag
	        html = matches[key].toString();
	 
	        // Is tag not in allowed list? Remove from str!
	        allowed = false;
	 
	        // Go through all allowed tags
	        for (k in allowed_array) {
	            // Init
	            allowed_tag = allowed_array[k];
	            i = -1;
	 
	            if (i != 0) { i = html.toLowerCase().indexOf('<'+allowed_tag+'>');}
	            if (i != 0) { i = html.toLowerCase().indexOf('<'+allowed_tag+' ');}
	            if (i != 0) { i = html.toLowerCase().indexOf('</'+allowed_tag)   ;}
	 
	            // Determine
	            if (i == 0) {
	                allowed = true;
	                break;
	            }
	        }
	 
	        if (!allowed) {
	            str = replacer(html, "", str); // Custom replace. No regexing
	        }
	    }
	 
	    return str;
	}
});