MSFW.Input.Editable	= Class.create(MSFW.Input, {
	
	REMOVE_IMAGE		: "/templates/default/images/remove_row.png",
	
	DEFAULT_VALUE		: aGlobalMsfWords["MSFW_DOCUMENT"],
	
	DELETE_BUTTON_TITLE	: aGlobalMsfWords["MSFW_DELETE"],
	
	initialize : function(options)
	{
		MSFW.Input.prototype.initialize.apply(this, arguments);
				
		this.Input			= new Element("input", {"type" : "hidden", "name" : this.Options.inputName});
		this.Table			= new Element("table");
		this.EditableValues	= {};
				
		this.Container.insert(this.Input).insert(this.Table);		
	},
	
	setStringValue : function(value)
	{		
		var Rows	= value.split(this.DATA_ROW_DELIMETER);
		var ret		= {};
		var me		= this;
		$A(Rows).each(function(e){
			var tmp = e.split(me.DATA_COL_DELIMETER);
			var key = tmp.slice(1).join(me.DATA_COL_DELIMETER);
			ret[key]	= tmp[0];
		});
		
		this.Values	= ret;
		this._draw();
	},
	
	setArrayValue : function(Value)
	{		
		this.Values	= this._prepareData(Value);
		this._draw();
	},
	
	addArrayValue : function(Value)
	{		
		this.Values	= Object.extend(this.Values, this._prepareData(Value));
		this._draw();
	},
	
	_prepareData : function(Value)
	{				
		var ret	= {};
		var me	= this;
		$H(Value).each(function(e){
			$H(e.value).each(function(l){
				var tmp			= [];
				var doctype		= "";
				var i			= 0;			
				$A(l.value).each(function(k){			
					if(i>0 && k.value && k.type != "file" && k.type != "picture" && k.name != "doctype") {			
						tmp.push(k.value);				
					}
					else if(k.name == "doctype") {
						doctype = k.value;
					}
					
					i++;						
				});				
				ret[l.key + me.DATA_COL_DELIMETER + e.key]	= doctype + " (" + tmp.join(me.VALUE_SEPARATOR) + ")";
			});
			
		});
		
		
		return ret;
	},	
	
	_clearTable : function()
	{
		var me	= this;
		for(var i=($A(this.Table.rows).size()-1); i>=0; i--) {
			me.Table.deleteRow(i);
		}
	},
	
	_draw : function()
	{		
		var me		= this;
		var size	= 0;
		this._clearTable();		
		
		$H(this.Values).each(function(value){
			var Row		= $(me.Table.insertRow(size));
			Row._data	= value;
			size++;
			
			var Cell1	= $(Row.insertCell(0));
			var Cell2	= $(Row.insertCell(1));
			
			var Input	= new Element("input", {"type":"text", "value":me.stripElements(value.value), "style": "width: 550px"});
			Input.observe("keyup", function(){				
				me.Values[value.key]	= Input.value;
				me._updateHiddenValues();		
			});
			Cell1.insert(Input);
			
			
			var RemoveButton	= new Element("img", {"src" : me.REMOVE_IMAGE, "title":me.DELETE_BUTTON_TITLE, "style":"cursor:pointer;"});
			RemoveButton.observe("click", function(){				
				me.Table.deleteRow(Row.rowIndex);
				delete me.Values[value.key];
				me._updateHiddenValues();
			});
			
			Cell2.insert(RemoveButton);
		});
		
		this._updateHiddenValues();		
	},
			
	_updateHiddenValues : function()
	{
		var hidden	= $A();
		var me		= this;		
		
		$H(this.Values).each(function(e){			
			hidden.push(e.value + me.DATA_COL_DELIMETER + e.key);
		});
		
		//this.Input.value	= hidden.join(me.DATA_ROW_DELIMETER);
		this.Input.value	= this.stripElements(hidden.join(me.DATA_ROW_DELIMETER));
		this._fireEvent("valuechange");
	}
	
});