MSFW.Input.Sortable	= Class.create(MSFW.Input, {
	
	REMOVE_IMAGE		: "/templates/default/images/remove_row.png",
	
	LIST_CLASS			: "MSFW_Sortable",

	DEFAULT_VALUE_NAME	: "defaultNameToRestore",
	
	DELETE_BUTTON_TITLE	: aGlobalMsfWords["MSFW_DELETE"],
	
	SORT_BUTTON_TITLE	: aGlobalMsfWords["MSFW_SORT"],
	
	initialize : function(options)
	{
		MSFW.Input.prototype.initialize.apply(this, arguments);
		
		this.Options			= Object.extend({			
			"valueSeparator"	: " "			
		}, this.Options || {});
		
		this.Input	= new Element("input", {"type" : "hidden", "name" : this.Options.inputName});
		this.Ul		= new Element("ul", {"class" : this.LIST_CLASS});
		
		this.Ul.identify();
		this.Container.insert(this.Input).insert(this.Ul);		
	},
	
	clear : function()
	{	
		this.Input.value	= "";
		this.Values			= {};
		this.Ul.update();
		this._fireEvent("valuechange");
	},
	
	setStringValue : function(value)
	{
		var Rows	= value.split(this.DATA_ROW_DELIMETER);
		var value	= {};
		var me		= this;
		$A(Rows).each(function(e){
			var tmp			= e.split(me.DATA_COL_DELIMETER);						
			value[tmp[1]]	= [
			{
				"mark"		: 0,
				"name"		: "id",
				"original"	: tmp[1],
				"type"		: "int",
				"value"		: tmp[1]
			},
			{
				"mark"		: 0,
				"name"		: me.DEFAULT_VALUE_NAME,
				"original"	: (tmp[0] != "undefined") ? tmp[0] : "",
				"type"		: "string",
				"value"		: (tmp[0] != "undefined") ? tmp[0] : ""
			}
			];
		});
		
		this.setArrayValue(value);
	},
	
	_draw : function()
	{
		var me	= this;
		this.Ul.update();
		
		$H(this.Values).each(function(e){			
			var Li			= new Element("li");
			Li._data		= e;						
									
			Li.identify();
			
			var Table	= new Element("table", {"style": "width: 100%"});
			var Row		= Table.insertRow(0);
			
			var RemoveButton	= new Element("img", {"src" : me.REMOVE_IMAGE, "title":me.DELETE_BUTTON_TITLE});
			RemoveButton.observe("click", function(){
				Li.remove();
				me._updateVisibleValues();
				me._updateHiddenValues();
				me._fireEvent("valuechange");
			});
			
			$(Row.insertCell(0)).insert(new Element("img", {"src":"/templates/default/images/move_row.png", "class":"move", "title":me.SORT_BUTTON_TITLE}));
			
			me._devideRecord(me._getSortableValue(e), $(Row.insertCell(1)).setStyle({"width": "100%"}));
			//$(Row.insertCell(1)).insert(me._getSortableValue(e)).addClassName("text");
			//$(Row.insertCell(1)).insert(new Element("nobr").insert(me._getSortableValue(e))).addClassName("text");
			$(Row.insertCell(2)).insert(RemoveButton);
			RemoveButton.addClassName("remove");
			Li.insert(Table);
			
			me.Ul.insert(Li);
		});
		
		Sortable.destroy(this.Ul);
		Sortable.create(this.Ul, {"handle":"move", "onUpdate": function() { me._updateVisibleValues(); me._updateHiddenValues();}});
		me._updateHiddenValues();
	},
	
	//
	_devideRecord: function(sString, Cont)
	{
		var aRecs = sString.split("(");
		
		for (var i = 0; i < aRecs.length; i++) {
			var Nobr 	= new Element("div");
			var sValue 	= (i > 0) ? "(" + aRecs[i] : aRecs[i];
			Nobr.insert(sValue);
			Cont.insert(Nobr);
			
			if (i < aRecs.length - 1) {
				Cont.insert(" ");
			}
		}
	},
	//
	
	_getSortableValue : function(e)
	{
		return this._getVisibleValue(e.value);
	},
	
	_updateVisibleValues : function()
	{
		var me		= this;		
		this.Values	= {};
		
		$A(this.Ul.childNodes).each(function(e){			
			me.Values[e._data.key]	= e._data.value;			
		});	
		
	},
	
	_updateHiddenValues : function()
	{
		var hidden	= $A();
		var me		= this;
		var value	= "";
		
		$H(this.Values).each(function(e){
			hidden.push(me._getHiddenValue(e.value));
		});
		
		this.Input.value	= hidden.join(me.DATA_ROW_DELIMETER);
		this._fireEvent("valuechange");
	},
	
	_getVisibleValue : function(data)
	{
		var me		= this;
		var ret		= $A();
		
		$A(data).each(function(k){			
			if(me.Options.columns[k.name] && me.Options.columns[k.name].select || k.name == me.DEFAULT_VALUE_NAME) {				
				if(k.value) {
					ret.push(k.value);
				}
				
			}
						
		});
		
		return ret.join(this.Options.valueSeparator);
	},
	
	_getHiddenValue : function(data)
	{		
		return this._getVisibleValue(data) + this.DATA_COL_DELIMETER + data[0].value;
	}

});