MSFW.Input.Textarea	= Class.create(MSFW.Input, {
	
	TEXTAREA_CLASS		: "MSFW_Input_Textarea",
	
	VALUE_SEPARATOR		: " ",
	
	VALUE_DELIMETER 	: ", ",
	
	DEFAULT_VALUE_NAME	: "toInputColumn",
	
	initialize : function(options)
	{
		MSFW.Input.prototype.initialize.apply(this, arguments);
		
		
		this.Input	= new Element("textarea", {"name":this.Options.inputName});
		this.Input.addClassName(this.TEXTAREA_CLASS);
		this.Container.insert(this.Input);
	},
	
	clear : function()
	{			
		this.Values			= {};
		this.Input.update();
		this._fireEvent("valuechange");
	},
	
	setStringValue : function(value)
	{
		this.Input.value = value;
		this._fireEvent("valuechange");
	},
	
	_draw : function()
	{
		var me	= this;
				
		$H(this.Values).each(function(e){			
			me.Input.value	+= me._getVisibleValue(e.value) + me.VALUE_DELIMETER;
		});		
		
		this.Values	= {};
		this._fireEvent("valuechange");
	},
	
	_getVisibleValue : function(data)
	{
		var me		= this;
		var ret		= $A();
		
		$A(data).each(function(k){			
			if(me.Options.columns[k.name] && me.Options.columns[k.name].select || k.name == me.DEFAULT_VALUE_NAME) {				
				if(k.value) {
					ret.push(k.value);
				}
				
			}
						
		});
		
		return ret.join(this.VALUE_SEPARATOR);
	}

});