MSFW.Placeholder	= Class.create(MSFW.EventListener, {
	
	INPUT_CLASS					: MSFW.Input,
	
	BUTTON_IMAGE				: "/modules/references/view/img/table.png",
	
	SELECT_BUTTON_TEXT			: aGlobalMsfWords["MSFW_SELECT"],
		
	PLACEHOLDER_BUTTON_TITLE	: aGlobalMsfWords["MSFW_PLACEHODELR_BUTTON_TITLE"],
	
	EVENT_TYPES					: ["buttonbeforeclick", "buttonafterclick"],
	
	initialize : function(options)
	{	
		MSFW.EventListener.prototype.initialize.apply(this, arguments);	
		this.Options		= Object.extend({
			"Container"			: document.body,			
			"default"			: null,
			"inlineWindow"		: false
		}, options || {});
		
		
		this.Options.Container	= $(this.Options.Container);
		this.Input				= null;
		this.PlacehoderButton	= null;
		this.SelectButton		= null;
		this.Window				= null;
		this.ButtonPosition		= null;
		this.DataSource			= null;
		this.onLoad				= $A();
		this.loaderStatus		= 0;
		
		
		this.Table		= new Element("table");
		this.Row		= $(this.Table.insertRow(0));
		this.Options.Container.insert(this.Table);
		this.Table.addClassName("placeHolder");
		this.Table.border = "0";
		this.Table.cellpadding = "0";
		this.Table.cellspacing = "0";
		this._buildInput();
		this._buildPlacehoderButton();
		this._buildSelectButton();
	},
	
	_buildInput : function()
	{		
		this.Input	= new this.INPUT_CLASS(this.Options);		
		$(this.Row.insertCell($A(this.Row.cells).size())).insert(this.Input.getDom());
		
		if(this.Options["default"]) {
			this.Input.setStringValue(this.Options["default"]);
		}
	},
	
	_buildPlacehoderButton : function()
	{		
		
		this.PlacehoderButton	= new Element("img");		
		this.PlacehoderButton.observe("click", this._showWindow.bindAsEventListener(this));
		this._correctButton(this.PlacehoderButton, this.BUTTON_IMAGE);		
		$(this.Row.insertCell($A(this.Row.cells).size())).insert(this.PlacehoderButton);
		this.PlacehoderButton.title 	= this.PLACEHOLDER_BUTTON_TITLE;
		this.PlacehoderButton.addClassName("open");
		var oPl = this.PlacehoderButton;
		var oSc	= this.BUTTON_IMAGE;
		oPl.src = oSc;
		registerEvent(function() {
			oPl.src = oSc;
		});
		
	},
	
	_buildSelectButton : function()
	{
		var me				= this;
		this.SelectButton	= new Element("input", {"type" : "button", "value" : this.SELECT_BUTTON_TEXT, "class":"buttonStub"});
		this.SelectButton.observe("click", function(event){			
			me._fireEvent("buttonbeforeclick");			
			me._onSelectButtonClick();			
			me._fireEvent("buttonafterclick");		
		});
		
	},
	
	_correctButton : function(oButton, sImg)
	{
		/*
		var isIE		= (navigator.userAgent.toLowerCase().indexOf("msie") != -1);		
		if(sImg.indexOf("structure") != -1 || sImg.indexOf("table") != -1) {
			if(isIE && sCnfMode == "debug") {			
				oButton.style.marginLeft = "6px";
			}
		}
		else if(sImg.indexOf("calendar") != -1) {
			if(isIE) {
				oButton.style.marginTop	= "2px";
			}
		}
		
		*/
					
	},
	
	_onSelectButtonClick : function()
	{						
		this.Input.addArrayValue(this.DataSource.getValue());
		this.Window.visibleFlag	= false;
		this.Window.Container.hide();
		this.DataSource.clear();
	},
	
	_showWindow : function(event)
	{
		if(!this.Window) {
			if (typeof(this.Options.time) != "undefined") { // proverka na calendar
				this._showNewWindow(event);
			}
		}
		if(!this.loaderStatus) {
			var me 					= this;
			me.PlacehoderButton.src = "/templates/default/images/win/mid-ajax-loader.gif";
			var oRefSaveHandler 	= new REF_SaveHandler($("doc_form"), false, $("login_layer"), function(){me._showNewWindow(event);}, true);
			oRefSaveHandler.process();
			me.loaderStatus = 1;
		}
		else {
			if (this.Window) {
				this.Window.show();
				this.Window.refreshPosition();
			}
		}
	},
	
	_showNewWindow : function(event)
	{
		this.PlacehoderButton.src = this.BUTTON_IMAGE;
		if(this.Options.inlineWindow) {
				var windowCont	= this.Options.Container;
			}
			else {
				var windowCont	= document.body;
			}
			
			this.Window	= new MSFW.Window(null, windowCont);			
			this._onWindowCreate();			
						
			var ButtonContainer	= (new Element("div")).insert(this.SelectButton);
			ButtonContainer.addClassName("RSMiniBottomBar");
			this.Window.appendToBody(ButtonContainer);
			
			if(!this.Options.inlineWindow){
				this.Window.moveTo(event.pageX, event.pageY);
		}
		this.Window.show();
		this.Window.refreshPosition();
	},
	
	
	_onWindowCreate : function()
	{
		alert("MSFW.Placeholder::_onWindowCreate()");
	},
	
	_ajaxLoadStart : function(id)
	{	
		this.onLoad.push(id);
		this._checkBlocking();
	},
	
	_ajaxLoadEnd : function(id)
	{
		this.onLoad	= this.onLoad.without(id);
		this._checkBlocking();
		this.Window.refreshPosition();
	},
	
	_checkBlocking : function()
	{
		if(this.Window) {
			if(this.onLoad.size()) {
				this.Window.blockContent();
			}
			else {				
				this.Window.freeContent();
			}
			
		}
		
	},
	
	destroy : function()
	{
		if(this.Window) {
			this.Window.destroy();
		}

		this.Options.Container.update();
	},
	
	getInput : function()
	{
		return this.Input;
	}
	
});