MSFW.Placeholder.Document	= Class.create(MSFW.Placeholder, {
	
	INPUT_CLASS		: MSFW.Input.Editable,
	
	BUTTON_IMAGE	: "/modules/workflow/view/templates/default/img/documents.png",	
	
	initialize : function(options)
	{	
		MSFW.Placeholder.prototype.initialize.apply(this, arguments);		
		this.Options		= Object.extend({			
			"multiselect"		: false,		
			"defaultFilters"	: null,
			"folders"			: null
		}, this.Options || {});		
		
		this.DataRefinement			= new Element("div");
		this.RefinementPanel		= null;
		this.RefinementParameters	= "";
		this.RefinementCallback		= null;
		this.GroupsTree				= null;		
		this.QuickFilter			= null;
		this.Filters				= null;
		this.lastLoadedFolderId		= 0;
		
		this.DataSourceValues		= {};
		
		if(!this.Options.multiselect) {
			var me	= this;			
			this.addEventListener("buttonbeforeclick", function(){
				me.DataSourceValues = {};
				me.Input.clear();
			});
		}
		
	},
	
	_onWindowCreate : function()
	{
		if(!this.DataSource) {
			
			var me				= this;
			var params			= "";

			if(this.Options.folders) {
				$A(this.Options.folders).each(function(e){
					params	+= "&folders[]=" + e;
				});
			}

			params += "docTypes=" + this.Options.docTypes;			
			this.GroupsTree	= new MSFW.DataSource.Tree({"params":params, "url":"/workflow/ajaxfolders/?", "idColumn":"document_id"});
			this.GroupsTree.addEventListener("groupclick", me._reloadTable.bind(this, true));
			this.GroupsTree.addEventListener("loadstart", function(){ me._ajaxLoadStart("tree"); });
			this.GroupsTree.addEventListener("loadend", function(){
				if (me.GroupsTree.Data.length>0) {
					me._ajaxLoadEnd("tree");
				} else {
					me.Window.freeContent();
					var oDeniedCont	= new Element("div", {"style": "font-size: 12pt; margin: 30pt;"});
					oDeniedCont.insert(aGlobalMsfWords["ACCESS_DENIED"]);
					me.Window.body().update(oDeniedCont); 
				} 
			});
			
			this.GroupsTree.load();	
			this.DataSource	= new MSFW.DataSource.AjaxTable({"params":"docTypes=" + this.Options.docTypes, "url":"/workflow/ajaxdocuments/?", "multiselect":this.Options.multiselect});		
			this.DataSource.addEventListener("loadend", this._buildDataRefinement.bind(this));
			this.DataSource.addEventListener("loadstart", function(){ me._ajaxLoadStart("table");});
			this.DataSource.addEventListener("refreshposition", function(){ me.Window.refreshPosition();});
			this.DataSource.addEventListener("refreshposition", function(){if (me.QuickFilter) { me.QuickFilter.focus(); } });
			this.DataSource.addEventListener("loadend", function(){ me._ajaxLoadEnd("table"); });
			
			var LeftPart	= new MSFW.Container.VerticalTwoBox();
			LeftPart.insert(aGlobalMsfWords["MSFW_NAVIGATION"], this.GroupsTree.getDom());
			
			var Container	= new MSFW.Container.FloatPanel();
			Container.insert(LeftPart.getDom(), this.DataSource.getDom());
		
			this.Window.setTitle(aGlobalMsfWords["ROOT_DOCUMENT_WINDOW_TITLE"]);
			this.Window.appendToBody(this.DataRefinement);
			this.Window.appendToBody(Container.getDom());
			
		}
		
	},
	
		
	_buildDataRefinement : function()
	{
		if(this.GroupsTree.getLastGroupValue().folder_id != this.lastLoadedFolderId) {
			if(!this.QuickFilter) {
				this.QuickFilter	= new MSFW.DataRefinement.QuickFilter();
				this.DataRefinement.insert(this.QuickFilter.getDom());
				this.QuickFilter.addEventListener("buttonclick", this._reloadTable.bind(this));
				//this.QuickFilter.focus();
			}
			
			
			var data	= this.DataSource.getData();		
			var me		= this;
			var columns	= {};
			this.lastLoadedFolderId	= this.GroupsTree.getLastGroupValue().folder_id;
			
			$A(data.titles).each(function(e){
				if (e.name != "wf_documents.document_id") {
					columns[e.name]	= {
						"filter"	: e.filter,				
						"name"		: e.name,
						"title"		: e.title
					}
				}
			});
			
			if(this.Filters) {
				var FilterContainer	= this.Filters.getDom().parentNode;
				this.Filters.destroy();
				this.Filters	= null;
			}
			else {				
				var Table			= new Element("table", {"cellpadding":"0", "cellspacing":"0", "class":"RSMiniPanel"});
				var Row				= $(Table.insertRow(0));
				var FilterContainer	= $(Row.insertCell(0));
				FilterContainer.addClassName("RSMiniPanelTd");
				this.DataRefinement.insert(Table);
				
				var Refresh	= new Element("img", {"src":"/templates/default/images/win-rs/rs-reload-icon.png"});
				Refresh.observe("click", this._reloadTable.bind(this, false));
				var Cell	= $(Row.insertCell(1)).addClassName("RSMiniPanelRefresh").insert(Refresh); 
				Cell.addClassName("RSMiniPanelTd");
				Cell.setAttribute("width", "20");
			}
			
			this.Filters	= new MSFW.DataRefinement.Filters({"columns":columns});
			FilterContainer.insert(this.Filters.getDom());
			this.Filters.addEventListener("buttonclick", this._reloadTable.bind(this));
		}
					
	},
	
	_onSelectButtonClick : function()
	{
		this._setDataSourceValues();
		this.Input.VALUE_SEPARATOR = "; ";
		this.Input.addArrayValue(this.DataSourceValues);
		this.Window.hide();
		this.DataSource.clear();		
		this.DataSourceValues	= {};
	},
	
	_setDataSourceValues : function()
	{
		if(this.lastLoadedFolderId) {
			var tmp		= {};
			var values	= this.DataSource.getValue();
			this.DataSource.clear();
			
			//osoboya magiya JS. Ne udalyat
			$H(values).each(function(e){
				tmp[e.key]	= e.value;
			});			
				
			this.DataSourceValues[this.lastLoadedFolderId]	= tmp;
		}
		
	},
	
	_reloadTable : function(firstLoad)
	{			
		this._setDataSourceValues();
		
		if(firstLoad) {
			if(this.QuickFilter) {				
				this.DataSource.setFilters(this.QuickFilter.getValue());
			}
			else {
				this.DataSource.setFilters({});
			}
						
			this.DataSource.load({"folderId":this.GroupsTree.getLastGroupValue().folder_id});	
		}
		else {
			var filters	= {};
			filters	= Object.extend(filters, this.Filters.getValue());
			filters	= Object.extend(filters, this.QuickFilter.getValue());
			
			if(this.DataSourceValues[this.GroupsTree.getLastGroupValue().folder_id]) {
				this.DataSource.setValue(this.DataSourceValues[this.GroupsTree.getLastGroupValue().folder_id]);
			}
			
			this.DataSource.setFilters(filters);
			this.DataSource.reload();
		}
			
	}
	
});