MSFW.Placeholder.Reference	= Class.create(MSFW.Placeholder, {
	
	INPUT_CLASS			: MSFW.Input.Sortable,
	
	BUTTON_IMAGE		: "/modules/references/view/img/table.png",	
	
	WITHOUT_GROUP_KEY	: "nullRow",
	
	initialize : function(options)
	{	
		if(!!!options.byId) {
			this.INPUT_CLASS	= MSFW.Input.Textarea;
		}
		
		MSFW.Placeholder.prototype.initialize.apply(this, arguments);
		
		this.Options			= Object.extend({			
			"multiselect"		: false,
			"byId"				: false,
			"referenceId"		: 0,
			"unique"			: false,
			"uniqueType"		: "",
			"objectId"			: 0,
			"defaultGroups"		: null,
			"defaultFilters"	: null,
			"blockGroups"		: false,
			"blockFilters"		: false,
			"recordsLimit"		: -1
		}, this.Options || {});		
				
		
		this.DataRefinement			= new Element("div");
		this.Table					= null;
		this.RefinementParameters	= "";
		this.RefinementCallback		= null;
		this.GroupsTree				= null;
		this.Groups					= null;
		this.QuickFilter			= null;
		this.Filters				= null;
		this.lastGroupLoad			= null;
		this.DataSourceValues		= {};
		
		if(!this.Options.multiselect) {
			var me	= this;			
			this.addEventListener("buttonbeforeclick", function(){me.Input.clear()});
		}
		
	},
	
	_onWindowCreate : function()
	{
		if(!this.DataSource) {
			var me					= this;
			var Options				= {};
			var Container			= new MSFW.Container.FloatPanel();
			var LeftPart			= new MSFW.Container.VerticalTwoBox();		
			Options.params			= this._getAjaxParams();
			Options.url				= this._getAjaxUrl();
			Options.multiselect 	= this.Options.multiselect;
			Options.page		 	= LeftPart.getPageLinksArea();
			
			(typeof(this.Options.miniColumns) != "undefined") ? Options.defaultOrder = $H(this.Options.miniColumns).keys()[0] : Options.defaultOrder = $H(this.Options.columns).keys()[0];
		
	
						
			this.GroupsTree	= new MSFW.DataSource.AjaxTree(Options);			
			this.GroupsTree.addEventListener("groupclick", me._reloadTable.bind(this));
			this.GroupsTree.addEventListener("loadstart", function(){ me._ajaxLoadStart("tree");});
			this.GroupsTree.addEventListener("loadend", function(){ me._ajaxLoadEnd("tree");});
			
						
			this.DataSource	= new MSFW.DataSource.AjaxTable(Options);		
			this.Window.appendToBody(this.DataRefinement);	
			this.Window.appendToBody(Container.getDom());
			LeftPart.insert(aGlobalMsfWords["MSFW_NAVIGATION"], this.GroupsTree.getDom());
			
			Container.insert(LeftPart.getDom(), this.DataSource.getDom());
			
			this.RefinementCallback	= function(){me._buildDataRefinement(me.DataSource.getData());}
			
			this.DataSource.addEventListener("loadstart", function(){ me._ajaxLoadStart("table");});
			this.DataSource.addEventListener("refreshposition", function(){ me.Window.refreshPosition();});
			this.DataSource.addEventListener("loadend", function(){	
				if (me.DataSource.reference && me.DataSource.reference.denied) {
					me.Window.freeContent();
					var oDeniedCont	= new Element("div", {"style": "font-size: 12pt; margin: 30pt;"});
					oDeniedCont.insert(me.DataSource.reference.accessDenied);
					me.Window.body().update(oDeniedCont); 
				}
				else {
					me._ajaxLoadEnd("table");
					me.Window.setTitle(me.DataSource.getTitle());
				}
			});
			this.DataSource.addEventListener("loadend", this.RefinementCallback);	
			
			
			
			if(this.Options.defaultFilters) {
				var tmp	= {};
				$H(this.Options.defaultFilters).each(function(e){
					tmp["rs_searchParam_" + e.key]	= e.value;
				});
				
				this.DataSource.setFilters(tmp);			
			}
			this.DataSource.load();
			
		
		}
		
	},
	
		
	_getAjaxParams : function()
	{
		var params	= "";		
		var i		= 0;		
		(typeof(this.Options.miniColumns) != "undefined") ? aColumns = this.Options.miniColumns : aColumns = this.Options.columns;
		$H(aColumns).each(function(e){
			params += "&select[" + i + "]=" + e.key;
			i++;
		});
		
		if(this.Options["default"]) {
			params	+= "&default=" + encodeURIComponent(this.Options["default"]);
		}
		
		params	+= "&inputName=" + this.Options.inputName;
		params	+= "&recordsLimit=" + this.Options.recordsLimit;
		return params.split("?").join("%3F");
	},
	
	_getAjaxUrl : function()
	{		
		var url	= "";
		url		+= "/references/ajaxview/";
		url		+= this.Options.referenceId;
		url		+= "/";
		url		+= this.Options.unique;
		
		//this.Options.unique ? url += "1" : url += "0";
		
		url		+= "/";
		url		+= this.Options.uniqueType;
		url		+= "/";
		url		+= this.Options.objectId;
		url		+= "?";
		
		return url;		
	},
	
				
	_getCell : function()
	{
		return $(this.Row.insertCell($A(this.Row.cells).size()));
	},
	
	_buildDataRefinement : function(data)
	{	
		var me = this;
		if(typeof(this.DataSource.error) != "undefined") {
			this.Window.Body.children[1].insert("<center>" + aGlobalMsfWords["REF_LOADING_ERROR"] + "</center>");
		}
		
		if(typeof(this.DataSource.reference) != "undefined") {
			this.Window.Body.children[1].insert("<center>" + aGlobalMsfWords["ROOT_ERROR_NO_ACCESS"] + "</center>");
		}
		
		this.QuickFilter	= new MSFW.DataRefinement.QuickFilter();
		this.DataRefinement.insert(this.QuickFilter.getDom());
		this.QuickFilter.addEventListener("buttonclick", this._filterClick.bind(this));
		this.QuickFilter.focus();
		this.Window.addEventListener("freeContent", function(){
			me.QuickFilter.focus();
		});
		
		var Table	= new Element("table", {"cellpadding":"0", "cellspacing":"0"});
		Table.addClassName("RSMiniPanel");
		var Row		= $(Table.insertRow(0));
		var Cell	= $(Row.insertCell(0));
		Cell.addClassName("RSMiniPanelTd");
		this.DataRefinement.insert(Table);
		
		this.DataSource.removeEventListener("loadend", this.RefinementCallback);	
		
		var columns	= {};
		(typeof(me.Options.miniColumns) != "undefined") ? aColumns = me.Options.miniColumns : aColumns = me.Options.columns;
		$A(data.titles).each(function(e){			
			var name	= e.name;
						
			if(aColumns[name]) {				
				columns[e.name]	= {
					"filter"	: aColumns[name].filter,
					"group"		: aColumns[name].group,
					"name"		: e.name,
					"title"		: e.title
				}
				
			}
			
		});
					
		this.Filters	= new MSFW.DataRefinement.Filters({"columns":columns});
		//Ul.insert((new Element("li")).insert(this.Filters.getDom()));
		Cell.insert(this.Filters.getDom());
		
		this.Filters.addEventListener("buttonclick", this._filterClick.bind(this));
		
		if(this.Options.blockFilters) {
			this.Filters.hide();
		}
		
		this.Groups	= new MSFW.DataRefinement.Groups({"columns":columns});	
		//Cell1.insert(this.Groups.getDom());
		//Ul.insert((new Element("li")).insert(this.Groups.getDom()));
		Cell.insert(this.Groups.getDom());
		this.Groups.createSortable();
		this.Groups.addEventListener("buttonclick", this._loadTree.bind(this));
		
		if(this.Options.blockGroups) {
			this.Groups.hide();
		}
		
		if(this.Options.defaultFilters) {			
			this.Filters.setDefaultValues(this.Options.defaultFilters);
		}
		
		
		if(this.Options.defaultGroups) {
			this.Groups.setDefaultValues(this.Options.defaultGroups);
		}
		
		
		var AddRef	= new Element("img", {"src":"/templates/default/images/win-rs/rs-addref-icon.png", "title":aGlobalMsfWords["MSF_ADDREF"]});
		AddRef.observe("click", this._addRefBookmark.bind(this));
		var Cell	= $(Row.insertCell(1)).addClassName("RSMiniPanelAddRef").insert(AddRef);
		Cell.addClassName("RSMiniPanelTd");
		var Refresh	= new Element("img", {"src":"/templates/default/images/win-rs/rs-reload-icon.png", "title":aGlobalMsfWords["MSF_REFRESH"]}) ;
		Refresh.observe("click", this._filterClick.bind(this));
		var Cell	= $(Row.insertCell(2)).addClassName("RSMiniPanelRefresh").insert(Refresh); 
		Cell.addClassName("RSMiniPanelTd");
		Cell.setAttribute("width", "20");

	},
	
	_filterClick : function()
	{
		var filters	= this._getFiltersValues();
		
		
		if(this._chechGroupLoad()) {
			this.GroupsTree.setFilters(filters);
			this.GroupsTree.reload();
		}
		
		
		this.DataSource.setFilters(filters);
		this.DataSource.reload();		
	},
	
	_addRefBookmark : function()
	{		
		var host;
		var proto;
		host  = document.location.host;
		proto = document.location.protocol;
		if (this.Options.referenceId == 6) {
			window.open(proto + "//" + host + "/lms/addresses/add");
		}
		else {	
			window.open(proto + "//" + host + "/references/add/" + this.Options.referenceId);
		}
	},
	
	_getFiltersValues : function()
	{
		var filters	= {};
		filters	= Object.extend(filters, this.Filters.getValue());
		filters	= Object.extend(filters, this.QuickFilter.getValue());
		
		return filters;
	},
	
	_loadTree : function()
	{		
		this.GroupsTree.setFilters(this._getFiltersValues());
		
		if(this._chechGroupLoad()) {
			this.GroupsTree.load(this.Groups.getValue());
		}
		else {
			this.GroupsTree.clear();
			this._reloadTable();
		}
	},
	
	_reloadTable : function()
	{
		var me		= this;
		var options	= {
			get		: {},
			post	: {}
		};
				
		var groups	= this._parseGroupValues(this.GroupsTree.getLastGroupValue());
		var key		= this._getGroupKey(groups);
		this._setDataSourceValues(groups);
		
		if(this.DataSourceValues[key]) {			
			this.DataSource.setValue(this.DataSourceValues[key].rows);			
		}
		
		this.lastGroupLoad	= groups;		
		this.DataSource.setGroups("get", this.Groups.getValue());
		this.DataSource.setGroups("post", this.GroupsTree.getLastGroupValue());						
		this.DataSource.setFilters(this._getFiltersValues());
		
		this.DataSource.load();		
	},
	
	_setDataSourceValues : function()
	{
		var key	= this._getGroupKey(this.lastGroupLoad);;
		
		var tmp		= {};
		var values	= this.DataSource.getValue();
		
		//osoboya magiya JS. Ne udalyat
		$H(values).each(function(e){
			tmp[e.key]	= e.value;
		});			
		
		this.DataSourceValues[key]	= {"rows":tmp, "groups":Object.clone(this.lastGroupLoad)};			
		this.DataSource.clear();
	},
	
	_onSelectButtonClick : function()
	{
		this._setDataSourceValues();
		var toInputValues	= {};
		var me				= this;
		
		$H(this.DataSourceValues).each(function(e){			
			$H(e.value.rows).each(function(row){
				var inputValue	= [];
				var tmp	= {
					"name"	: "id",
					"value"	: row.value[0].value
				}
				inputValue.push(tmp);
				
				$H(me.Options.columns).each(function(column){
					if(column.value.select) {
						$A(row.value).each(function(tmpColumn){						
							if(tmpColumn.name == column.key) {
								var tmp	= {
									"name"	: tmpColumn.name,
									"value"	: tmpColumn.value
								}
								
								inputValue.push(tmp);
							}
							
						});						
						
					}
					
					if(e.value.groups[column.key]) {
						if (e.value.groups[column.key].indexOf("|^|row|^|")) {
							aGroup	= e.value.groups[column.key].split("|^|row|^|");
							var tmp	= {
								"name"	: column.key,
								"value"	: aGroup[0]
							}
							
						}
						else {
							aGroup	= e.value.groups[column.key].split("/^/col/^/");
							var tmp	= {
								"name"	: column.key,
								"value"	: aGroup[0]
							}
						}					
						
						inputValue.push(tmp);
					}
					
				});
								
				if(!me.Options.multiselect) {
					toInputValues = {};				
				}
				
				toInputValues[row.key]	= inputValue;
				
			});
			
		});
		
		this.Input.addArrayValue(toInputValues);
		this.Window.hide();
		this.DataSourceValues 	= {};
		this.DataSource.setValue({});		
	},
	
	_getGroupKey : function(values)
	{
		var key	= "";
		if($H(values).size()) {
			$H(values).each(function(e){
				key	+= e.value;
			});
		}
		else {
			key	= this.WITHOUT_GROUP_KEY;
		}
				
		return key;
	},
	
	_parseGroupValues : function(values)
	{
		var tmp	= {};
		$H(values).each(function(e){			
			tmp[e.key.match(/\[(.*)\]/)[1]]	= e.value;
		});
		
		return tmp;
	},
	
	_chechGroupLoad : function()
	{
		var value	= this.Groups.getValue();
		var flag	= false;
		
		
		$H(value).each(function(e){
			if(e.value == 1) {
				flag	= true;
			}
			
		});
		
		return flag;
	},
	
	_correctDefaultValues: function(aId)
	{
		var me			  		  = this;
		var toInputValues 		  = {};		
		var data;
		this.Options.recordsLimit = 0;		
		new Ajax.Request(
			me._getAjaxUrl(),
			{
				method 		: "post",
				parameters 	: me._getAjaxParams(),
			  	onSuccess 	: function(resp) {					
					data 	= resp.responseText.evalJSON().data;							
					data.records.each(function(row) {
						bInArray = false;
						for(i = 0; i < aId.length; i++) {
							if(aId[i] == row["columns"][0].value) {
								bInArray = true;
								break;
							}
							
						}
						
						if(bInArray) {													
							var inputValue	= [];
							var tmp	= {
								"name"	: "id",
								"value"	: row["columns"][0].value
							}							
							inputValue.push(tmp);
							
							$H(me.Options.columns).each(function(column){
								if(column.value.select) {
									$A(row["columns"]).each(function(tmpColumn){															
										if(tmpColumn.name == column.key) {										
											var tmp	= {
												"name"	: tmpColumn.name,
												"value"	: tmpColumn.value
											}
											
											inputValue.push(tmp);
										}
										
									});						
									
								}								
								
							});
							
							toInputValues[row["columns"][0].value]	= inputValue;
						} 
						
					});
					
					me.Input.clear();
					me.Input.addArrayValue(toInputValues);											
				}
			
			}
			
		);
		
	}
	
});