MSFW.Placeholder.Structure	= Class.create(MSFW.Placeholder, {
	
	INPUT_CLASS			: MSFW.Input.SortableStructure,
	
	BUTTON_IMAGE		: "/templates/default/images/open_structure.png",
	
	initialize : function(options)
	{	
		MSFW.Placeholder.prototype.initialize.apply(this, arguments);
		
		this.Options		= Object.extend({
			"multiselect"		: false,
			"showEmployees"		: 1,
			"showPosts"			: 1,
			"withSubdivision"	: 1,
			"employee"			: "name",
			"post"				: "post",
			"subdivision"		: "subdivision",
			"skipNodeId"		: 0
		}, this.Options || {});		
		this.GroupsTree				= null;		
		this.QuickFilter			= null;
		this.DataSourceValues		= {};
		this.LastNodeId				= null;
		
		if(!this.Options.multiselect) {
			var me	= this;			
			this.addEventListener("buttonbeforeclick", function(){
				me.DataSourceValues	= {};
				me.Input.clear()
			});
		}
		
		if (this.Options.withSubdivision) {
			this.Options.withSubdivision = this.Options.multiselect;
		}
		
	},
	
	_onWindowCreate : function()
	{
		if(!this.DataSource) {
			var me	= this;

			this.QuickFilter	= new MSFW.DataRefinement.QuickFilter();			
			this.QuickFilter.addEventListener("buttonclick", function(){
				me._reloadTree();
				me._reloadTable();
			});
					
			this.GroupsTree		= new MSFW.DataSource.StructureTree({
				"url"			: "/structure/view/tree/"+this.Options.subdivision+"?",
				"multiselect"	: this.Options.withSubdivision});
			this.GroupsTree.addEventListener("groupclick", this._reloadTable.bind(this));
			this.GroupsTree.addEventListener("loadstart", function(){ me._ajaxLoadStart("tree");});
			this.GroupsTree.addEventListener("loadend", function(){ me._ajaxLoadEnd("tree");});
			this.GroupsTree.load();
			
			this.DataSource		= new MSFW.DataSource.AjaxTable({
				"params"		: "", 
				"url"			: "/structure/view/table/"+this.Options.employee+"/"+this.Options.post+"?", 
				"multiselect"	: this.Options.multiselect,
				"defaultOrder"	: "structure.position" //tolko dlya structuri tak, t.k. ona zhestko privyazana k svoey tablice
			});		
			this.DataSource.addEventListener("loadstart", function(){ me._ajaxLoadStart("table");});
			this.DataSource.addEventListener("refreshposition", function(){ me.Window.refreshPosition();});
			this.DataSource.addEventListener("loadend", function(){ 
				if (!me.DataSource.Data.denied) {
					me._ajaxLoadEnd("table"); 
				}
				else {
					me.Window.freeContent();
					var oDeniedCont	= new Element("div", {"style": "font-size: 12pt; margin: 30pt;"});
					oDeniedCont.insert(me.DataSource.Data.accessDenied);
					me.Window.body().update(oDeniedCont);
				}
				
			});
			this.DataSource.load({"id":0, "skipNodeId":this.Options.skipNodeId});
			
			var LeftPart	= new MSFW.Container.VerticalTwoBox();
			LeftPart.insert(aGlobalMsfWords["MSFW_NAVIGATION"], this.GroupsTree.getDom());
			
			var Container	= new MSFW.Container.FloatPanel();
			Container.insert(LeftPart.getDom(), this.DataSource.getDom());
			
			this.Window.setTitle(aGlobalMsfWords["STRUCTURE_MODULE_NAME"]);
			this.Window.appendToBody(this.QuickFilter.getDom());
			this.Window.appendToBody(Container.getDom());
			
			
						
			this.Window.addEventListener("freeContent", function(){
				me.QuickFilter.focus();
			});			
		}
		
	},
			
	_onSelectButtonClick : function()
	{
		this._setDataSourceValues();
		
		var tmp	= {
			"tree"			: this.GroupsTree.getValue(),
			"table"			: this.DataSourceValues,
			"currentGroup"	: this.GroupsTree.getLastGroupValue()
		};
						
		this.Input.addArrayValue(tmp);		
		this.DataSource.clear();
		this.GroupsTree.clear();
		this.DataSourceValues	= {};
		this.Window.hide();
	},
	
	_reloadTable : function(firstLoad)
	{
		if(!this.Options.multiselect) {
			this.DataSourceValues	= {};
		}
		
		//this._setDataSourceValues(); # Commented by 3-3161
		
		if(this.DataSourceValues[this.GroupsTree.getLastGroupValue().node_id]) {			
			this.DataSource.setValue(this.DataSourceValues[this.GroupsTree.getLastGroupValue().node_id]);			
		}
		
		
		this.LastNodeId	= this.GroupsTree.getLastGroupValue().node_id;
		this.DataSource.setFilters(this.QuickFilter.getValue());
		this.DataSource.load({"id":this.LastNodeId, "skipNodeId":this.Options.skipNodeId});			
	},
	
	_setDataSourceValues : function()
	{			
		var key	= 0;
		if(this.LastNodeId) {
			key	= this.LastNodeId;
		}
		var tmp		= {};
		var values	= this.DataSource.getValue();
		
		//osoboya magiya JS. Ne udalyat
		$H(values).each(function(e){
			tmp[e.key]	= e.value;
		});			
		
		this.DataSourceValues[this.LastNodeId]	= tmp;			
		this.DataSource.clear();	
	},
	
	_reloadTree : function(firstLoad)
	{	
		this.GroupsTree.setFilters(this.QuickFilter.getValue());
		this.GroupsTree.load();			
	}
	
});