MSFW.Window	= Class.create(MSFW.EventListener, {
	
	EVENT_TYPES		: ["close", "open", "blockContent", "freeContent"],
	
	initialize : function(name, container)
	{	
		MSFW.EventListener.prototype.initialize.apply(this, arguments);
		this.Container		= new Element("div");
		this.Table			= null;
		this.Body			= null;
		this.WinContent		= null;
		this.Dragable		= null;
		this.Busy			= null;
		this.Title			= null;
		this.visibleFlag	= true;
		
		if(container) {
			$(container).insert(this.Container);
		}
		else {
			$(document.body).insert(this.Container);
		}
		
		this.Container.addClassName("win");		
		
		this.Table	= new Element("table", {"cellpadding":"0", "cellspacing":"0"});	
		this.Container.insert(this.Table);
		
		
		if(!name) {
			name = Math.random();
		}

		this.Name = name;
		MSFW.Window.Manager.add(this, name);
		
		this._build();		
	},
	
	_build : function()
	{		
		this._buildHeader();
		this._buildBody();
		this._buildFooter();
	},
	
	_buildHeader : function()
	{		
		var me		= this;
		var Table	= this._getTable("winTitle");	
		var Row		= $(Table.insertRow(0));
		
		$(Row.insertCell(0)).addClassName("winTitleLeftCorner");
		$(Row.insertCell(1)).addClassName("winTitleBg winTitleIcon").insert(new Element("img", {"src":"/templates/default/images/win/favicon.ico"}));
		
		this.Title	= $(Row.insertCell(2)).addClassName("winTitleBg winTitleText");
		
		var Close	= new Element("img", {"src":"/templates/default/images/win/win-close-button.gif"});
		
		$(Row.insertCell(3)).addClassName("winTitleBg winTitleClose").insert(Close);		
		$(Row.insertCell(4)).addClassName("winTitleRightCorner");
		
		this.Dragable = new Draggable(
			this.Container,
			{
				handle : Table,
				zindex : "500",
				starteffect: null,
				reverteffect: null,
				endeffect: null,
				snap: function(x, y) {
		            	return [ (x < 0) ? 0 : x,
		                    	 (y < 0) ? 0 : y ];
		              }
			}
		);
		
		Close.observe("click", this.hide.bind(this));		
	},
	
	_buildBody : function()
	{
		var Table	= this._getTable("winContent");
		var Row		= $(Table.insertRow(0));
		
		$(Row.insertCell(0)).addClassName("winSideBorderBg").insert("&nbsp;");
		this.Body	= $(Row.insertCell(1)).addClassName("winContentBg");
		$(Row.insertCell(2)).addClassName("winSideRightBorder");		
	},
	
	_buildFooter : function()
	{		
		var Table	= this._getTable("winBottom");
		var Row		= $(Table.insertRow(0));
		
		$(Row.insertCell(0)).addClassName("winLeftBottomCorner");
		$(Row.insertCell(1)).addClassName("winBottomBg").insert("&#160;");
		$(Row.insertCell(2)).addClassName("winRightBottomCorner");		
	},
	
	_getTable : function(c)
	{
		var Table	= new Element("table", {"cellpadding":"0","cellspacing":"0"});
		$(this.Table.insertRow($A(this.Table.rows).size()).insertCell(0)).insert(Table).addClassName("winTableCell");
		Table.addClassName(c);
		return Table;
	},
			
	setTitle: function(sTitle)
	{
		if (sTitle) {
			this.Title.innerHTML = "<nobr>" + sTitle + "</nobr>";
		}
	},

	show : function()
	{	
		this.visibleFlag	= true;
		this._fireEvent("open");
		this.Container.show();
	//	this._fireEvent("freeContent");
		//Effect.Appear(this.Container);
		//Effect.Shake(this.Container);
	},

	hide : function()
	{
		this.visibleFlag	= false;
		this._fireEvent("close");	
		this.Container.hide();	
		//Effect.Puff(this.Container);	
	},
	
	visible : function()
	{
		return this.visibleFlag;
	},
	
	blockContent : function()
	{		
		this.Body.addClassName("winContentBusy");
		this._fireEvent("blockContent");
	},
	
	freeContent : function()
	{			
		this.Body.removeClassName("winContentBusy");
		this._fireEvent("freeContent");
	},
	
	moveTo : function(x, y)
	{			
		this.Container.style.left 	= x + "px";
		this.Container.style.top	= y + "px";
	//	this.refreshPosition();		
	},
	
	moveToCenter : function()
	{
		iCenterScreenWidth  = (document.viewport.getDimensions().width - this.width)/2;
		iCenterScreenHeight = (window.pageYOffset || document.documentElement.scrollTop) + 
							  (document.viewport.getDimensions().height - this.height)/2
		this.moveTo(iCenterScreenWidth, iCenterScreenHeight);
	},

	body : function ()
	{
		return this.Body;
	},

	appendToBody : function (el)
	{	
		this.Body.insert(el);		
	},

	destroy : function()
	{
		if (this.Container) {
			this.Container.remove();
		}
		this.Container	= null;
		MSFW.Window.Manager.remove(this.Name);
	},
	
	clear: function()
	{		
		this.Title.innerHTML	= "";
		this.Body.innerHTML		= "";
	},
	
	getPosition: function()
	{
		return {
			"x": parseInt(this.Container.style.left.split("px").join("")),
			"y": parseInt(this.Container.style.top.split("px").join(""))
		};	
	},
	
	refreshPosition: function()
	{
		var Pos 		= this.getPosition();
		
		var iWinWidth 	= document.body.clientWidth;

		var iScroll		= window.pageYOffset || document.documentElement.scrollTop + 50;
  
		var iWinHeight 	= iScroll + screen.height;  
		
		var iDataWidth 	= this.Container.getWidth();
		var iDataHeight	= this.Container.getHeight() + 190;

		if (((Pos.x + iDataWidth) > iWinWidth) && ((Pos.y + iDataHeight) > iWinHeight)) {
			NewPosX = Pos.x - (Pos.x + iDataWidth - iWinWidth) - 50;
			NewPosY = Pos.y - (Pos.y + iDataHeight - iWinHeight);
			if (NewPosY > 80) {
				NewPosY = NewPosY - 80;
			}
			if (NewPosY < 0) {
				NewPosY = 0;
			}
			this.moveTo(
				NewPosX,
				NewPosY
			);
		}
		else {
			if ((Pos.x + iDataWidth) > iWinWidth) {
				NewPosX = Pos.x - (Pos.x + iDataWidth - iWinWidth) - 50;
				this.moveTo(
					NewPosX,
					Pos.y
				);
			}
			if ((Pos.y + iDataHeight) > iWinHeight) {
				NewPosY = Pos.y - (Pos.y + iDataHeight - iWinHeight);
				if (NewPosY > 80) {
					NewPosY = NewPosY - 80;
				}
				if (NewPosY < 0) {
					NewPosY = 0;
				}
				this.moveTo(
					Pos.x,
					NewPosY
				);
			}
		}
		
	}
});