var MSF_AbstractTable = Class.create();
MSF_AbstractTable.prototype =
{
	initialize : function(conf)
	{			
		this.Conf		= conf;
		this.Headers	= null;	
	},
	
	
	buildTable : function()
	{			
		this.Table 			= new Element('table');
		this.Table.border 	= '1';
		this.Table.addClassName('sortableTable');
		
		
		return this.Table;		
	},
	
	buildTitles : function(Table, aShowColumns)
	{
		this.Headers 	= $(Table.insertRow(0));
		var cellCount 	= 0;
		var me			= this;
	
		
		aShowColumns.each(function(Column)
		{
			me.Conf.Data.titles.each(function(el)
			{					
				if(el && el.key == Column.name) {		
					var Td = $(me.Headers.insertCell(cellCount));
					Td.addClassName('headers');
					var Container	= new Element('nobr');				
					//console.log(me.Conf.aColumns, el);
					if(me.Conf.aColumns[el.key].bSort && Column.sort) {
						var ImgUp	= $(document.createElement('img'));
						ImgUp.src	= '/templates/default/images/arrow_up.png';						
						Container.insert(ImgUp);
						
						var ImgDown	= $(document.createElement('img'));
						ImgDown.src	= '/templates/default/images/arrow_down.png';						
						Container.insert(ImgDown);
												
						ImgUp.observe('click', function(){ me.sortTable(ImgUp, el.key, 'asc', el.type)});
						ImgDown.observe('click', function(){ me.sortTable(ImgDown, el.key, 'desc', el.type)});
						
						Td._ImgUp	= ImgUp;
						Td._ImgDown	= ImgDown;
					}				
							
					Container.insert(new Element('span', {'class' : 'title'}).insert(el.text));
					Td.insert(Container);
					
					Td._data	= el;									
					cellCount++;					
				}
				
			});
			
		});
		
	},
	
	buildRow : function(Table, aData, aShowColumns, bBuildEmpty)
	{
		var Row		= $(Table.insertRow($A(Table.rows).size()));		
		var i		= 0;
		var me		= this;
		
		Row.data	= aData;
		
		
		//TODO: sdelat po normalnomu
		if(bBuildEmpty) {
			var Td 		= $(Row.insertCell(0));
			Td.insert(' ');
			i++;
		}
		
		$H(aData).each(function(e){			
			if(e.key != 'id') {
				Td 		= $(Row.insertCell(i));
				Td.setAttribute('align', 'left');
				Td.insert(e.value);
				Td.className	= 'cell';
				i++;
			}			
						
		});
		
		if(this.Conf.selected && this.Conf.selected.indexOf(aData) != -1) {
			this.select(Row);
		}		
		
		Row.observe('click', function(){me.select(Row)});
		
		Row.observe('mouseover', function(){
			$A(Row.cells).each(function(e){
				$(e).addClassName('cell-active');
			});
		});
		
		Row.observe('mouseout', function(){
			$A(Row.cells).each(function(e){
				$(e).removeClassName('cell-active');
			});
		});
		
		return Row;	
	},
	
	getColumnByKey : function(key)
	{
		var me	= this;
		var out	= null;
		this.Conf.Data.titles.each(function(e)
		{
			if(e.key == key) {				
				out	= me.Conf.aColumns[e.text];
				
			}
		});
		
		return out;
	},
	
	getKeyByColumnTitle : function(key)
	{
		var me	= this;
		var out	= null;
		this.Conf.Data.titles.each(function(e)
		{
			if(e && e.text == key) {				
				out	= e.key;				
			}
		});
		
		return out;
	},
	
	filterData : function(aInData)
	{
		var aColumns	= new Array();
		var me			= this;
		var aOutData	= new Array();
		
		this.Conf.filters.each(function(e){
			var tmp		= new Object;
			tmp.key		= e.title;
			tmp.value	= e.value;
			tmp.type	= me.Conf.aColumns[e.title].type;
			
			aColumns.push(tmp);					
		});
		
		this.Conf.Data.body.each(function(e)
		{
			if(me.passedFilter(e, aColumns)) {
				aOutData.push(e);
			}
		});		
		
		return aOutData;
	},
	
	passedFilter : function(aData, aColumns)
	{
		var bOut	= true;
		
		aColumns.each(function(e){
			/*
			switch(e.type) {
				case 'string'	:
				case 'text'		:
					if(!aData[e.key].include(e.value)) {
						bOut	= false;
					}
					break;
				default			:
					if(aData[e.key] != e.value) {
						bOut	= false;
					}
					break;
			}
			*/
			
			if (aData[e.key]) {
				var sText = aData[e.key].toLowerCase();
				if(!sText.include(e.value.toLowerCase())) {
					bOut = false;
				}
			}
		});
		
		return bOut;		
	},
	
	sortTable : function(Img, key, order, type)
	{
		
		if(this.currentOrderImg == Img) {
			return;
		}		
		
		this._chengeSortImage(Img, order);	
		
		
		this._removeRows();
		
		this.sort(key, order, this._getSortFunction(key, order, type));	
		
		this.buildRows(this.Table);			
	},	
	
	_chengeSortImage : function(Img, order)
	{
		if(order == 'asc') {			
			if(this.currentOrderImg) {
				this.currentOrderImg.src	= '/templates/default/images/arrow_down.png';
			}
			Img.src	= '/templates/default/images/arrow_up_alter.png';
		}
		else {
			if(this.currentOrderImg) {
				this.currentOrderImg.src	= '/templates/default/images/arrow_up.png';
			}
			Img.src	= '/templates/default/images/arrow_down_alter.png';
		}
		
		this.currentOrderImg	= Img;
	},
	
	_removeRows : function()
	{
		var rowCount = this.Table.rows.length;
		var me 	= this;
		for(var i = rowCount - 1; i>0; i--) {
			this.Table.deleteRow(i);
		}
	},
	
	_getSortFunction : function(key, order, type)
	{		
		if(order == 'asc') {
			return this._sortingAsc(key, type);
		}
		else {
			return this._sortingDesc(key, type);
		}		
	},
	
	_sortingAsc : function(key, type)
	{
		//parseInt
		var sorting = function(a,b)
		{
			var arg1	= a[key];
			var arg2	= b[key];
			
						
			switch(type) {
				case 'int'			:
				case 'bool'			: 
					arg1	= parseInt(arg1);
					arg2	= parseInt(arg2);
					break;
				case 'float'		:
					arg1	= parseFloat(arg1);
					arg2	= parseFloat(arg2);
					break;
				case 'timestamp'	:
					var d1		= new Date();
					var d2		= new Date();
					var aTmp	= arg1.split(" ");
					var aDate	= aTmp[0].split(".");
					var aTime	= aTmp[1].split(":");
					
					d1.setFullYear(aDate[2], aDate[1] - 1, aDate[0]);
					d1.setHours(aTime[0]);
					d1.setMinutes(aTime[1]);
					
					var aTmp	= arg2.split(" ");
					var aDate	= aTmp[0].split(".");
					var aTime	= aTmp[1].split(":");
					
					d2.setFullYear(aDate[2], aDate[1] - 1, aDate[0]);
					d2.setHours(aTime[0]);
					d2.setMinutes(aTime[1]);
					
					arg1	= d1.getTime();
					arg2	= d2.getTime();
									
					break;
			}
			
			if(arg1 > arg2) {
				return 1;
			}
			else if(arg1 < arg2) {
				return -1;
			}
			else {
				return 0;
			}

		}
		
		return sorting;
	},
	
	_sortingDesc : function(key, type)
	{
			
		var sorting = function(a,b)
		{
			var arg1	= a[key];
			var arg2	= b[key];
			
			switch(type) {
				case 'int'		:
				case 'bool'		: 
					arg1	= parseInt(arg1);
					arg2	= parseInt(arg2);
					break;
				case 'float'	:
					arg1	= parseFloat(arg1);
					arg2	= parseFloat(arg2);
					break;
				case 'timestamp'	:
					var d1		= new Date();
					var d2		= new Date();
					var aTmp	= arg1.split(" ");
					var aDate	= aTmp[0].split(".");
					var aTime	= aTmp[1].split(":");
					
					d1.setFullYear(aDate[2], aDate[1] - 1, aDate[0]);
					d1.setHours(aTime[0]);
					d1.setMinutes(aTime[1]);
					
					var aTmp	= arg2.split(" ");
					var aDate	= aTmp[0].split(".");
					var aTime	= aTmp[1].split(":");
					
					d2.setFullYear(aDate[2], aDate[1] - 1, aDate[0]);
					d2.setHours(aTime[0]);
					d2.setMinutes(aTime[1]);
					
					arg1	= d1.getTime();
					arg2	= d2.getTime();
									
					break;
			}
		
			if(arg1 > arg2) {
				return -1;
			}
			else if(arg1 < arg2) {
				return 1;
			}
			else {
				return 0;
			}

		}
		
		return sorting;
	},
	
	defaultSort : function()
	{
		var me	= this;
		//console.log(this.Conf.sort.column);
		
		if(this.Conf.sort) {
			$A(me.Headers.cells).each(function(e) {
				if(e._data.key == me.Conf.sort.column) {					
					if(me.Conf.sort.order	== 'asc') {
						me.sortTable(e._ImgUp, e._data.key, 'asc', e._data.type)
					}
					else {
						me.sortTable(e._ImgDown, e._data.key, 'desc', e._data.type);
					}
					
				}
				
			});
			
		}
	},
	
	select : function(Row)
	{	
		Row.selected	= !!Row.selected;
		
		if(Row.selected) {
			this.markRow(Row, false);
		}
		else {			
			this.markRow(Row, true);			
		}		
				
		if(!this.Conf.bMultiselect && this.currentTr && Row != this.currentTr) {			
			this.markRow(this.currentTr, false);						
		}			
		
		this.currentTr	= Row;		
	},

	markRow : function (Row, flag)
	{		
		$A(Row.childNodes).each(function(e)
		{			
			if(flag) {
				e.addClassName('selected');
				Row.selected	= true;
			}
			else {
				e.removeClassName('selected');
				Row.selected	= false;
			}

		});

	},

	getSelected : function()
	{
		var aSelected = new Array();
		var count = 0;
		$A(this.Table.rows).each(function(el)
		{
			if(el.selected) {
				aSelected.push(el.data);
			}
		});
		
		return aSelected;
	},	

	unSelectAll : function()
	{
		var me = this;
		$A(this.Table.rows).each(function(el)
		{
			if(el.selected) {
				me.select(el);
			}
		});

	},
	
	getDOM : function()
	{
		return this.build();
	},
	
	setValueById : function(iId)
	{
		var me = this;		
		$A(this.Table.rows).each(function(el)
		{
			if(el.data && iId.indexOf(el.data.id) != -1) {				
				
				me.select(el);
			}			
		});		

	},
	
	destroy : function()
	{
		this.Table.parentNode.removeChild(this.Table);
		this.Table	= null;
	}
		
}