MSF_FiltersPanel	= Class.create();
MSF_FiltersPanel.prototype	=
{
	initialize	: function(aColumns, aTitles, aDefault)
	{
		this.aTitles	= aTitles;
		this.aDefault	= aDefault;
		this.aColumns	= this.prepareData(aColumns);
		
		this.Container	= new Element('form');
		this.Table		= new Element('table', {'cellpaing' : '5', 'cellspacing' : '5'});		
		this.Container.insert(this.Table);
		
		this.buildPanel();
	},
	
	buildPanel : function()
	{
		var me	= this;
			
		this.aColumns.each(function(column)
		{
			var aData	= $A();
			var Check	= new Element('input', {'type' : 'checkbox'});			
			aData.push([Check]);
		
			var Label	= new Element('label', {'for' : Check.identify()}).insert(column.title);
			aData.push([Label]);
				
			
			column.input			= new Element('input', {'type' : 'text'});
			column.input.disabled	= true;
			
			
			
			aData.push([column.input]);			
			if(me.aDefault[column.name]) {		
				column.input.value		= me.aDefault[column.name];
				Check.checked			= true;
				column.input.disabled	= false;
				//column.input.enable()
			}			
			
			me.buildRow(aData);
			
			Check.observe('click', function()
			{
				Check.checked ? column.input.disabled = false : column.input.disabled = true;				
			});
			
		});		
				
	},
	
	buildRow : function(data)
	{		
		var Row	= this.Table.insertRow($A(this.Table.rows).size());
		var i	= 0;	
		data.each(function(col)
		{
			var Td	= $(Row.insertCell(i));
			$(col).each(function(el)
			{
				Td.insert(el);
			});
			
			i++;
		});	
			
	},
	
	prepareData : function(data)
	{	
		var aOut	= new Array();
		var me		= this;
		$H(data).each(function(e)
		{
			if(e.value.bFilter) {
				var tmp		= new Object();
				
				tmp.title	= me.aTitles[e.key];
				tmp.name	= e.key;			
				tmp.input	= null;				
				
				aOut.push(tmp);				
			}
						
		});
		
		return aOut;
	},
	
	getFilters	: function()
	{
		var aOut	= new Array();
		this.aColumns.each(function(e)
		{
			if(!e.input.disabled) {
				var Tmp		= new Object();
				Tmp.title	= e.name;
				Tmp.value	= e.input.value;	
				
				aOut.push(Tmp);
			}
					
		});
		
		return aOut;
	},
	
	getDom	: function()
	{
		return this.Container;
	}
	
}