tinymce.create("tinymce.plugins.MSFFilesPlugin",
{
	oEditor 		: null,
	
	isMenuRendered	: false,
	
	oBookmark		: false,
	
	init : function(ed, url) {
		this.sImgUri 	= '/templates/' + sGlobalMsfSkin + '/images/attach.png';
		this.oEditor 	= ed;
		this.sName 		= 'msffiles';
		this.sId 		= this.oEditor.id + '_' + this.sName;
		this.oBookmark  = "";
		this.aTypes = new Array(
			'jpg', 'jpeg', 'png', 'gif'
		);
	},
	
	createControl: function(n, cm) {
		if (n !== this.sName) return null;
		var oThis = this;  
		var c = cm.createButton(this.sName, {
			title 	: aGlobalMsfWords['ROOT_RTE_BUTTON_FILE'],
			image 	: this.sImgUri,
			onclick : function()
			{
				oThis.oEditor.focus();
				//oThis.oEditor.selection.select(oThis.oEditor.selection.getNode());
				oThis.oBookmark = oThis.oEditor.selection.getBookmark();
				//dbg(oThis.oEditor.selection.getNode());
				MD_ShowWindow(
					oThis.oEditor.settings.extra_name,
					oThis.oEditor.settings.extra_id,
					function(s,i) { oThis.getRteFileParams(s,i); },
					oThis.sId
				);
			}
		});

		return c;
	},

	paste : function(sValue) {
		this.oEditor.selection.moveToBookmark(this.oBookmark);
		this.oEditor.execCommand("mceInsertContent", false, sValue,{skip_undo : true});
	},	
	
	getRteFileParams: function(iId, sName)
	{
		var sPaste = '<a href="/media/download/'+iId+'">'+sName+'</a>';
		
		if (this.checkType(sName)) {
			sPaste = '<img src="/media/image/'+iId+'"/>';
		}
		
		this.paste(sPaste);
	},
	
	checkType: function(sFileName)
	{
		var bCheck 	= false;
		var sExt 	= sFileName.substring(sFileName.lastIndexOf('.') + 1).toLowerCase();
		
		for (var i = 0; i < this.aTypes.length; i++) {
			if (sExt == this.aTypes[i]) {
				bCheck = true;
				break;
			}
		}
		
		return bCheck;
	},
	
	getInfo : function() {
		return {
			longname 	: "MSFFiles",
			author 		: "Detrix LLP",
			authorurl 	: "http://www.detrix.kz",
			infourl 	: "http://www.detrix.kz",
			version 	: tinymce.majorVersion + "." + tinymce.minorVersion
		};
	}
});

tinymce.create('tinymce.plugins.WFDocsPlugin', {

	sImgUri			: "/templates/" + sGlobalMsfSkin + "/images/doc.png",
	
	sName			: "wfdocs",

	oEditor 		: null,
	
	sId				: null,
	
	oBookmark		: false,
	
	init : function(ed, url) {
		this.oEditor 	= ed;
		this.sId 		= this.oEditor.id + "_" + this.sName;
		this.oBookmark  = "";
	},

	paste : function(self, aDoc) {		
		var sServer 	= '';
		var aToInsert	= $A();
		$H(aDoc).each(function(e){			
			aToInsert.push('<a href="' + sServer + '/workflow/document/view/' + e.key + '">' + e.value + '</a>');
		});
		
		this.oEditor.selection.moveToBookmark(this.oBookmark);
		self.oEditor.execCommand("mceInsertContent", 0, aToInsert.join(", "));
	},		

	createControl: function(n, cm) {
		if (n !== this.sName) return null;
		var oThis = this;  
		var c = cm.createButton(this.sName, {
			title 	: aGlobalMsfWords["ROOT_RTE_BUTTON_DOCUMENT"],
			image 	: this.sImgUri,
			onclick : function() {
				oThis.oEditor.focus();
				oThis.oBookmark = oThis.oEditor.selection.getBookmark();
				oThis.handler(c.id)
			}

		});
				
		return c;
	},
	
	handler : function(id)
	{
		if(!this.Placeholder) {
			this.Placeholder	= new MSFW.Placeholder.DocumentRTE({
				"Container"		: id,
				"inputName"		: "testInput1",										
				"multiselect"	: false,
				"button"		: id
			});
						
			var pos	= $(id).cumulativeOffset();
			var me	= this;
			this.Placeholder._showWindow({"pageX" : pos.left, pageY : pos.top});
			this.Placeholder.addEventListener("buttonafterclick",function(){
				me.paste(me, me.Placeholder.getInput().getArrayValue());				
			});
		}
		
	},
	
	getInfo : function() {
		return {
			longname 	: "WFDocs",
			author 		: "Detrix LLP",
			authorurl 	: "http://www.detrix.kz",
			infourl 	: "http://www.detrix.kz",
			version 	: tinymce.majorVersion + "." + tinymce.minorVersion
		};
	}
});

tinymce.PluginManager.add('wfdocs', 	tinymce.plugins.WFDocsPlugin);
tinymce.PluginManager.add('msffiles', 	tinymce.plugins.MSFFilesPlugin);