var MSF_Window = Class.create();
MSF_Window.prototype =
{
	mainCont 		: null,

	headerCont 		: null,

	bodyCont 		: null,

	closeCont 		: null,

	dragable 		: null,
	
	onClose 		: null,

	initialize : function(name, bDisableFone)
	{
		this.onClose		= null;
		this.mainCont		= $(document.createElement('div'));
		this.Overlay 		= null;
		this.bDisableFone 	= bDisableFone;
		
		this.mainCont.hide();
		this.mainCont.addClassName('dragableMainContainer');
		
		//document.body.appendChild(this.mainCont);
		document.body.insertBefore(this.mainCont, document.body.firstChild);
		
		this.addHeader();

		this.bodyCont				= $(document.createElement('div'));
		this.bodyCont.align			= 'center';
		this.bodyCont.style.padding	= '4px';
		this.bodyCont.addClassName('msfWinBody');
		this.mainCont.appendChild(this.bodyCont);

		this.dragable = new Draggable(
			this.mainCont,
			{
				handle : this.headerCont,
				zindex : "300101",
				starteffect: null,
				reverteffect: null,
				endeffect: null
			}
		);
		//this.dragable = new Draggable(this.mainCont, {handle : this.MainDragHandler});

		if(!name) {
			name = Math.random();
		}

		this.Name = name;
		WindowManager.add(this, name);

		this.show();
	},
	
	addHeader: function()
	{
		this.headerCont = new Element("div");
		var Tr 			= new Element("div");
		this.Title 		= new Element("div");
		
		//Tr.setAttribute("style", "border:1px dashed green;");
		
		//Tr.appendChild(this.Title);
		//this.headerCont.appendChild(Tr);
		this.headerCont.appendChild(this.Title);
		this.headerCont.addClassName('msfWinHeader');
		this.mainCont.appendChild(this.headerCont);
		this.Title.addClassName('msfWinTitle');

		this.closeCont	= $(document.createElement('div'));
		var Img 		= $(document.createElement('img'));
		Img.src 		= "/templates/default/images/red_cross.png";
		this.closeCont.appendChild(Img);
		this.closeCont.addClassName('msfWinClose');
		
		this.headerCont.appendChild(this.closeCont);
		//Tr.appendChild(this.closeCont);
		//this.headerCont.appendChild(Tr);
		
		//this.MainDragHandler	= Tr;
		//console.log(Tr);
		Event.observe(Img, 'click', this.hide.bindAsEventListener(this, this.mainCont));
	},
	
	setTitle: function(sTitle)
	{
		if (sTitle) {
			this.Title.innerHTML = sTitle;
		}

		
	},

	show : function()
	{
		if (this.bDisableFone) {
			this.showOverlay();
		}
		
		WindowManager.setActive(this);	
		this.mainCont.show();

		

	},

	hide : function(el)
	{

		if (this.bDisableFone) {
			this.hideOverlay();
		}
		
		var data = $A(arguments);
		if(data.length > 0){
			data[1].hide();
		}
		else {
			this.mainCont.hide();
		}
		
		if (this.onClose) {
			this.onClose();
		}
		
	},
	
	moveTo : function(x, y)
	{
		//console.log('<apBo>');
		this.mainCont.style.left 	= x + 'px';
		this.mainCont.style.top		= y + 'px';
	//	console.log('</apBo>');
	},

	body : function ()
	{
		return this.bodyCont;
	},

	appendToBody : function (el)
	{
		el = $(el);
		this.bodyCont.appendChild(el);
		if(parseInt(this.mainCont.style.width) < el.getWidth())
		{
			this.mainCont.style.width = el.getWidth() + parseInt(this.bodyCont.style.paddingLeft) + parseInt(this.bodyCont.style.paddingRight) + 4;//4 - for border. ToDO:count it automatically
			this.headerCont.style.width = this.mainCont.style.width;
		}

		el = null
	},

	destroy : function()
	{
		document.body.removeChild(this.mainCont);
		this.mainCont	= null;
		WindowManager.remove(this.Name);
	},
	
	clear: function()
	{
		//this.Title.update();
		//this.bodyCont.update();
		//this.Title.innerHTML = '';
		//this.bodyCont.innerHTML = '';
	},
	
	showOverlay: function()
	{
		if (!this.Overlay) {
			this.Overlay = $(document.createElement("div"));
			this.Overlay.style.height 	= (document.body.scrollHeight > document.body.offsetHeight) ? document.body.scrollHeight : document.body.offsetHeight;
			this.Overlay.style.width 	= (document.body.scrollWidth > document.body.offsetWidth) ? document.body.scrollWidth : document.body.offsetWidth;
			
			this.Overlay.addClassName("draggableOverlayFoneDisabler");
			document.body.appendChild(this.Overlay);
		}
		
		this.Overlay.style.opacity = 0;
		
		new Effect.Appear(
			this.Overlay,
			{
				duration 	: 0.2,
				from 		: 0.0,
				to 			: 0.5
			}
		);
	},
	
	hideOverlay: function()
	{
		new Effect.Fade(this.Overlay, { duration: 0.2 });
	}
}

var MSF_WindowManager = Class.create();
MSF_WindowManager.prototype =
{
	initialize : function()
	{
		this.Registry		= $H();
		this.zIndex			= 1;
		this.ActiveWindow	= null;
	},

	add : function(win, name)
	{
		win.mainCont.style.zIndex	= 1;
		this.Registry.set(name, win);
	},

	get : function(name)
	{
		if(this.Registry.get(name)) {
			return this.Registry.get(name);
		}
		else {
			return null;
		}
	},

	closeAll : function()
	{
		$H(this.Registry).each(function(e)
		{			
			e.value.hide();
		});

	},

	remove : function(name)
	{		
		this.ActiveWindow	= null;
		this.Registry.unset(name);
	},
	
	setActive : function(win)
	{
		if(this.ActiveWindow) {
			this.ActiveWindow.mainCont.style.zIndex	= 1;
		}
	
		this.ActiveWindow				= win;
		this.ActiveWindow.mainCont.style.zIndex	= "300100";
	}

}

var WindowManager = new MSF_WindowManager();