<?php

/**
 *
 * Description
 *
 * File: MSF_DBTreeDIL.php
 * Created: 30.07.2007
 * Author: T. Anre
 */
class MSF_DBTreeDIL extends MSF_ModelDBSupport {

    private $sTableName = "";
    private $sFieldId = "";
    private $sFieldPath = "";
    private $sFieldParentId = "";

    public function __construct($DB, $sTableName, $sFieldId, $sFieldParentId, $sFieldPath) {
        $this->DB = $DB;
        $this->sTableName = $sTableName;
        $this->sFieldId = $sFieldId;
        $this->sFieldPath = $sFieldPath;
        $this->sFieldParentId = $sFieldParentId;
    }

    public function insert($iParentId, $aOtherFields) {
        list($sTitles, $sValues) = $this->getInsertExtSQL($aOtherFields, $iParentId);

        $sSQL = "INSERT INTO " . $this->sTableName . "\n" .
                "(\n" .
                $sTitles . //  dont write comma or any whitespaces here
                $this->sFieldParentId . "\n" .
                ") VALUES (\n" .
                $sValues . //  dont write comma or any whitespaces here
                (($iParentId == 0) ? 1 : $iParentId ) . "\n" .
                ")";

        $this->DB->executeQuery($sSQL);

        $iId = $this->DB->insertId($this->sTableName, $this->sFieldId);

        $sSQL = "UPDATE " . $this->sTableName . "\n"
                . "SET" . "\n"
                . $this->sFieldPath . " = '" . $this->getPath($iParentId) . "." . $iId . "'"
                . "WHERE" . "\n"
                . $this->sFieldId . " = '" . $iId . "'";
        $this->DB->executeQuery($sSQL);

        return $iId;
    }

    private function getInsertExtSQL($aOtherFields, $iParentId) {
        // 0 - titles
        // 1 - values
        $aResult = array("", "");
        if (count($aOtherFields) > 0) {
            foreach ($aOtherFields AS $sFieldname => $sValue) {
                $aResult[0] .= $sFieldname . ",\n";
                $aResult[1] .= "'" . $this->escapeValue($sValue) . "',\n";
            }
        }

        $aResult[0] .= "position,\n";
        $aResult[1] .= "'" . $this->getLastPos($iParentId) . "',\n";

        return $aResult;
    }

    public function exists($iId) {
        if ($iId > 0) {
            $sSQL = "SELECT " . "\n"
                    . " COUNT(*) AS total" . "\n"
                    . "FROM" . "\n"
                    . $this->sTableName . "\n"
                    . "WHERE" . "\n"
                    . $this->sFieldId . " = '" . $iId . "'";
            $aResult = $this->DB->select($sSQL, true);
            $bResult = ($aResult["total"] > 0) ? true : false;
        } else if ($iId == 0) {
            $bResult = true;
        } else {
            $bResult = false;
        }

        return $bResult;
    }

    // added
    public function selectAll($iId) {
        $sSql = "SELECT\n" .
                "*\n" .
                "FROM\n" .
                $this->sTableName . "\n" .
                "WHERE\n" .
                $this->sFieldId . " = " . $iId;

        return $this->DB->select($sSql, true);
    }

    // select post
    public function selectPosts($iId) {
        $sSql = "SELECT\n" .
                "*\n" .
                "FROM\n" . $this->sTableName . "\n" .
                "WHERE\n" . "parent_id=" . $iId;
        return $this->DB->select($sSql);
    }

    public function select($iId, $iParentId, $aOtherFields, $aConditions, $aOrders) {
        $aOrders[$iParentId] = " ASC";
        //$aOrders[$this->sFieldPath] = " ASC";
        $aOrders["position"] = " ASC";
        $sSQL = "SELECT " . "\n"
                . $this->getSelectExtSQL($aOtherFields)
                . $this->sFieldId . ",\n"
                . $this->sFieldParentId . "\n"
                . "FROM" . "\n"
                . $this->sTableName . "\n"
                . "WHERE" . "\n"
                . $this->getWhereExtSQL($aConditions)
                . $this->sFieldPath . " LIKE '%" . $iId . "%'" . "\n"
                . "ORDER BY" . "\n"
                . $this->getOrders($aOrders);
        return $this->DB->select($sSQL);
    }

    public function selectByPathCount($iId, $iParentId, $aOtherFields, $aConditions, $aOrders) {
        $sSQL = "SELECT " . "\n"
                . $this->getSelectExtSQL($aOtherFields)
                . $this->sFieldId . ",\n"
                . $this->sFieldParentId . "\n"
                . "FROM" . "\n"
                . $this->sTableName . "\n"
                . "WHERE" . "\n"
                . $this->getWhereExtSQL($aConditions)
                . $this->sFieldPath . " LIKE '%" . $iId . "%'" . "\n"
                . "ORDER BY char_length(path)";
        return $this->DB->select($sSQL);
    }

    public function getOrders($aOrders) {
        $aResult = array();
        foreach ($aOrders AS $sKey => $sOrder) {
            $aResult[] = $sKey . " " . $sOrder;
        }

        return implode(", ", $aResult);
    }

    private function getSelectExtSQL($aOtherFields) {
        $sResult = "";
        if (count($aOtherFields) > 0) {
            foreach ($aOtherFields AS $sField) {
                $sResult .= $sField . ",\n";
            }
        }

        return $sResult;
    }

    private function getWhereExtSQL($aConditions) {
        $aResult = array();
        $sResult = "";
        if (count($aConditions) > 0) {
            foreach ($aConditions AS $sField => $sValue) {
                $aResult[] = $sField . " = '" . $this->escapeValue($sValue) . "'";
            }
        }

        if (!empty($aResult)) {
            $sResult = implode("\n" . "AND" . "\n", $aResult) . "\n" . "AND" . "\n";
        }
        return $sResult;
    }

    public function removeBranch($sPath, $iPosition) {
        $sSql = "DELETE FROM" . "\n"
                . $this->sTableName . "\n"
                . "WHERE" . "\n"
                . $this->sFieldPath . " LIKE '" . $sPath . "'";

        $bResult1 = $this->DB->executeQuery($sSql);

        $sSql = "DELETE FROM" . "\n"
                . $this->sTableName . "\n"
                . "WHERE" . "\n"
                . $this->sFieldPath . " LIKE '" . $sPath . ".%'";

        $bResult2 = $this->DB->executeQuery($sSql);
        $sSql = "UPDATE" . "\n"
                . $this->sTableName . "\n"
                . "SET" . "\n"
                . "position	= position - 1" . "\n"
                . "WHERE" . "\n"
                . "position	> '" . $iPosition . "'";
        $bResult3 = $this->DB->executeQuery($sSql);
    }

    public function getLastPos($iParentId) {
        $sSql = "SELECT\n" .
                "position\n" .
                "FROM\n" .
                $this->sTableName . "\n" .
                "WHERE\n" .
                $this->sFieldParentId . "=" . $iParentId . "\n" .
                "ORDER BY\n" .
                "position DESC";

        $aPosition = $this->DB->select($sSql, true);
        if (empty($aPosition)) {
            $sSql = "SELECT\n" .
                    "position\n" .
                    "FROM\n" .
                    $this->sTableName . "\n" .
                    "WHERE\n" .
                    "node_id =" . $iParentId;

            $aPosition = $this->DB->select($sSql, true);
        }

        return (int) $aPosition['position'] + 1;
    }

    public function getPos($iId) {
        if ($iId > 0) {
            $sSQL = "SELECT " . "\n"
                    . "position\n"
                    . "FROM" . "\n"
                    . $this->sTableName . "\n"
                    . "WHERE" . "\n"
                    . $this->sFieldId . " = '" . $iId . "'";
            $aResult = $this->DB->select($sSQL, true);
            $sResult = $aResult["position"];
        } else {
            $sResult = "1";
        }
        return $sResult;
    }

    public function getPath($iId) {
        if ($iId > 0) {
            $sSQL = "SELECT " . "\n"
                    . $this->sFieldPath . "\n"
                    . "FROM" . "\n"
                    . $this->sTableName . "\n"
                    . "WHERE" . "\n"
                    . $this->sFieldId . " = '" . $iId . "'";
            $aResult = $this->DB->select($sSQL, true);
            $sResult = $aResult[$this->sFieldPath];
        } else {
            $sResult = "1";
        }
        return $sResult;
    }

    public function updatePos($iNodeId, $sNewPath) {
        $sSql = "UPDATE" . "\n"
                . $this->sTableName . "\n"
                . "SET" . "\n"
                . "position	= '" . $sNewPath . "'" . "\n"
                . "WHERE" . "\n"
                . $this->sFieldId . "	= '" . $iNodeId . "'";

        return $this->DB->executeQuery($sSql);
    }

    public function update($iNodeId, $aOtherFields) {
        $sSql = "UPDATE " . $this->sTableName . "\n"
                . "SET" . "\n"
                . $this->getUpdateFields((array) $aOtherFields)
                . "WHERE" . "\n"
                . $this->sFieldId . " = " . $iNodeId;
        $this->DB->executeQuery($sSql);


        return ($this->DB->affectedRows() == 1) ? true : false;
    }

    public function getUpdateFields($aOtherFields) {
        $iCount = 0;
        $sString = "";

        foreach ($aOtherFields as $k => $v) {
            $sString .= $k . " = '" . $this->escapeValue($v) . "'";

            if ($iCount < sizeof($aOtherFields) - 1) {
                $sString .= ",";
            }

            $sString .= "\n";

            $iCount++;
        }

        return $sString;
    }

    public function moveBegin($iThisPos, $iFirstPos) {
        $sSql = "UPDATE" . "\n"
                . $this->sTableName . "\n"
                . "SET" . "\n"
                . "position	= position + 1" . "\n"
                . "WHERE" . "\n"
                . "position	>= '" . $iFirstPos . "'\n"
                . "AND" . "\n"
                . "position	< '" . $iThisPos . "'";

        return $this->DB->executeQuery($sSql);
    }

    public function moveEnd($iThisPos, $iLastPos) {
        $sSql = "UPDATE" . "\n"
                . $this->sTableName . "\n"
                . "SET" . "\n"
                . "position	= position - 1" . "\n"
                . "WHERE" . "\n"
                . "position	<= '" . $iLastPos . "'\n"
                . "AND" . "\n"
                . "position	> '" . $iThisPos . "'";

        return $this->DB->executeQuery($sSql);
    }

    public function updatePositionQuery($iNodeId, $iPosition) {
        $sSql = "UPDATE" . "\n"
                . "structure \n"
                . "SET" . "\n"
                . "position	= " . $iPosition . "\n"
                . "WHERE" . "\n"
                . "node_id	= '" . $iNodeId . "'";

        $this->DB->executeQuery($sSql);
    }

}

?>