<?php

class MSF_ExtractDocHtml {
	
	private $oDocument;
	private $oSettings;
	private $oAction;
	private $oDocumentVersion;
	
	public function __construct($iDocumentId, $iDocumentVersionId) {
		$oFacade = new WF_DocFacade ( );
		$this->oDocument = $oFacade->getDocumentById ( $iDocumentId );
		if(!empty($iDocumentVersionId)) {
			$this->oDocumentVersion	= $this->oDocument->getVersion($iDocumentVersionId);
		}
		else {
			$this->oDocumentVersion	= $this->oDocument->getCurrentVersion();	
		}
		
		$this->oAction = $oFacade->getActionByDocumentId ( $iDocumentId );
		$this->oSettings = $this->oAction->getSettings ();
	}
	
	public function getDocHtml() {
		$oMsfTemplate	= new MSF_Template ( );
		$sPage 			= "docPage.xsl";
		$sXslPath		= CNF_ABS_PATH . "/templates/" . CNF_SKIN . "/" . $sPage;
		$oMsfTemplate->setPageTitle ( $this->getDocTitle() );
		$oMsfTemplate->loadXsl ( $sXslPath );
		$Fields = new REF_Fields ( $this->oDocument->getDoctypeVersion ()->getFieldsXml () );
		$aFields = $this->oDocumentVersion->getFields ();
		$Template = $this->getDocumentWordTemplate ();
		foreach ( $aFields as $sKey => $mVal ) {
			$Fields->set ( $sKey, $mVal );
		}
		
		$Template->setFields ( $Fields );
		$Template->setPoints ( new WF_Points ( $this->oDocument, count ( $this->oSettings->getRoute () ) ) );
		$Template->addViewTemplate ( $oMsfTemplate, "module/template" );
		$oMsfTemplate->addLinksOf ( CNF_ABS_PATH . "/modules/references/view/links.ini" );
		$oMsfTemplate->addLinksOf ( CNF_ABS_PATH . "/modules/structure/view/links.ini" );
		
		$sHtml = $oMsfTemplate->process ();
		return preg_replace ( '#<a.+>|</a>#Ui', '', $sHtml );
	}
	
	public function getDocTitle() {
		return $this->oDocument->getTitle ();
	}
	
	private function getDocumentWordTemplate() {
		$MediaId = new WF_MediaId ( );
		$MediaId->generate ();
		
		$WFVars = new WF_Vars ( $this->oAction );
		
		$oDocumentWordTemplate = new REF_Template ( $this->oDocument->getDoctypeVersion ()->getTemplateXml () );
		$oDocumentWordTemplate->isWord = true;
		$oDocumentWordTemplate->setExtra ( "workflow_document", $MediaId->get () );
		$oDocumentWordTemplate->setUniqueId ( $this->oDocument->getDoctype ()->getDoctypeId () );
		$oDocumentWordTemplate->setUniqueType ( MSF_UniqueField::TYPE_DOCTYPE );
		
		$oDocumentWordTemplate->setVars ( $WFVars );
		return $oDocumentWordTemplate;
	}

}
?>