<?php

class MSF_ExtractRefHtml {
	
	private $oReference;
	private $aReferenceRow;
	
	public function __construct($iReferenceId, $iRowId) {
		$this->oReference		= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
		$this->oReference->load($iReferenceId);
		$this->aReferenceRow	= $this->oReference->row($iRowId)->show();
	}
	
	public function getRefHtml() {
		$oMsfTemplate	= new MSF_Template ( );
		$sPage			= "docPage.xsl";
		$sXslPath 		= CNF_ABS_PATH . "/templates/" . CNF_SKIN . "/" . $sPage;
		$oMsfTemplate->setPageTitle ($this->oReference->getName());
		$oMsfTemplate->loadXsl ( $sXslPath );
		$Fields 		= new REF_Fields($this->oReference->getFieldsXml());
		$oSysFields 	= new REF_SystemFieldsSettings();
		$aSysFields 	= $oSysFields->getRefSystemFields();
		$Fields->injectFields($aSysFields);
		$oTemplate		= $this->getReferenceWordTemplate();
		foreach ($this->aReferenceRow AS $aCol) {
			$Fields->set($aCol["name"], $aCol["value"]);			
		}
		
		$oTemplate->setFields($Fields);
		$oTemplate->addViewTemplate ( $oMsfTemplate, "module/template" );
		$oMsfTemplate->addLinksOf ( CNF_ABS_PATH . "/modules/references/view/links.ini" );
		$oMsfTemplate->addLinksOf ( CNF_ABS_PATH . "/modules/structure/view/links.ini" );
		
		$sHtml = $oMsfTemplate->process ();
		return preg_replace ( '#<a.+>|</a>#Ui', '', $sHtml );				
	}
	
	public function getRefTitle()
	{
		return $this->oReference->getName();	
	}
	
	public function getReferenceWordTemplate()
	{
		$oReferenceWordTemplate	= new REF_Template($this->oReference->getTemplate());
		return $oReferenceWordTemplate;
	}
	
}
?>