<?php
if(!defined("__MSF"))die("Direct access is not allowed");

 require_once "library/MSF_FileWrapper/MSF_Word03Wrapper.php";
 require_once "library/MSF_FileWrapper/MSF_Word07Wrapper.php";
 require_once "library/MSF_FileWrapper/MSF_Excel03Wrapper.php";
 require_once "library/MSF_FileWrapper/MSF_Excel07Wrapper.php";
 require_once "library/MSF_FileWrapper/MSF_Ppt03Wrapper.php";
 require_once "library/MSF_FileWrapper/MSF_Ppt07Wrapper.php";
 
 require_once "library/MSF_FileWrapper/MSF_PdfWrapper.php";
 require_once "library/MSF_FileWrapper/MSF_OdxWrapper.php";
 require_once "library/MSF_FileWrapper/MSF_TxtWrapper.php";
 require_once "library/MSF_FileWrapper/MSF_RtfWrapper.php";
 
 class MSF_ContentWrapperFactory{
 	const MSWORD03   = "doc";  // MS Word 2003
 	const MSWORD07   = "docx"; // MS Word 2007
 	const MSEXCEL03  = "xls";  // MS Excel 2003
 	const MSEXCEL07  = "xlsx"; // MS Excel 2007
 	const MSPPT03    = "ppt";  // MS PowerPoint 2003
 	const MSPPT07    = "pptx"; // MS PowerPoint 2007
  	const PDF  		 = "pdf";  // PDF
 	const ODT  		 = "odt";  // ODT OpenOffice
 	const ODP  		 = "odp";  // ODP OpenOffice
 	const ODS  		 = "ods";  // ODS OpenOffice
 	const TXT  		 = "txt";  // TXT Simple Text format
 	const RTF  		 = "rtf";  // TXT Simple Text format
 	/**
 	 * Возвращает текстовые данные из файлов
 	 * @param $sFilename
 	 * @param $sFileExtension если файлик представлен с другим расширением или его вообще нет, то этот параметр задаст расширение
 	 *                        для представленого файлика в первом аргументе
 	 * @return text 
 	 */
 	public static function create($sFilename, $sFileExtension = null){
        if(!$sFileExtension) $sFileExtension = self::detectMimeType($sFilename);
 		switch($sFileExtension){
 			case self::MSWORD03 : $oContentWrapper  = new MSF_Word03Wrapper(); break;
 			case self::MSEXCEL03: $oContentWrapper  = new MSF_Excel03Wrapper();break;
 			case self::MSWORD07 : $oContentWrapper  = new MSF_Word07Wrapper(); break;
 			case self::MSEXCEL07: $oContentWrapper  = new MSF_Excel07Wrapper();break;
 			case self::MSPPT03  : $oContentWrapper  = new MSF_Ppt03Wrapper();  break;
 			case self::MSPPT07  : $oContentWrapper  = new MSF_Ppt07Wrapper();  break;
 			case self::PDF      : $oContentWrapper  = new MSF_PdfWrapper();    break;
 			case self::ODT      : $oContentWrapper  = new MSF_OdxWrapper();    break;
 			case self::ODP      : $oContentWrapper  = new MSF_OdxWrapper();    break;
 			case self::ODS      : $oContentWrapper  = new MSF_OdxWrapper();    break;
 			case self::TXT      : $oContentWrapper  = new MSF_TxtWrapper();    break;
 			case self::RTF      : $oContentWrapper  = new MSF_RtfWrapper();    break;
 		}	
 		if (isset($oContentWrapper)){
 			try{
 			$oContentWrapper->load($sFilename);
 			return $oContentWrapper->getContent();
 			}catch(Exception $E){}
 		}
 		return "";
 	}
 	/**
 	 * Определяет расширение файла
 	 * @param $sFilename
 	 * @return string
 	 */
 	private function detectMimeType($sFilename){
    	return substr(strrchr($sFilename, '.'), 1);			
 	}
 }
?>
