<?php
if(!defined("__MSF"))die("Direct access is not allowed");
 
 require_once "library/MSF_FileWrapper/MSF_IFileWrapper.php";
 
 class MSF_Excel07Wrapper implements MSF_IFileWrapper{
 	
 	private $sContent  = "";
 	
 	public function load($sFilePath = null){ 		
 		if (file_exists($sFilePath) && is_readable ($sFilePath)) {		
 			$this->sContent = $this->parse($sFilePath);
 		}
 	}
 	private function parse($sFileName){ 		 
	    $oZip = new ZipArchive;

	    if ($oZip->open($sFileName)) {
	        if (($iNum = $oZip->locateName("xl/sharedStrings.xml")) !== false) {	            
	            $sContent = $oZip->getFromIndex($iNum);
	            $oZip->close();	            
	            $domXml = DOMDocument::loadXML($sContent, LIBXML_NOENT | LIBXML_XINCLUDE | LIBXML_NOERROR | LIBXML_NOWARNING);	 
	            return $domXml->saveXML();
	        }
	        $oZip->close();
	    }
	    return "";
 	}
 	public function getContent(){
 		return strip_tags(str_replace(array("<t>","</t>")," ",$this->sContent));
 	}
 	
 /**
  * THE END ) 
  */
 }
?>
