MSFW.DataRefinement.Groups	= Class.create(MSFW.DataRefinement.Filters, {
	
	LABEL_TEXT	: aGlobalMsfWords["REF_PLACEHOLDER_GROUPS"],
	
	BUTTON_TEXT	: aGlobalMsfWords["MSFW_GROUP"],
	
	LIST_CLASS	: "MSFW_DataRefinement_Groups",
	
	_buildPanel : function()
	{		
		var me	= this;
		this.Ul	= new Element("ul", {"class":this.LIST_CLASS});
		this.Ul.identify();
		
		this.Form.insert(this.Ul);		
		
		$H(this.Options.columns).each(function(e){
			if(e.value.group) {
				var Li	= new Element("li");
				Li.identify();
				me.Ul.insert(Li);
				
				var Input	= new Element("input", {
					"type"	: "hidden", 
					"value"	: "0",
					"name"	: "rs_groups[" + e.value.name + "]"
				});
				
				Li.insert(Input);
				
				var Span	= new Element("span", {"class":"drag"});
				Span.insert("&#160;");
				Li.insert(Span);
				
				var Label	= new Element("label");
				Li.insert(Label);
				
				var Checkbox	= new Element("input", {
					"type"	: "checkbox",
					"value"	: "1",
					"name"	: "rs_groups[" + e.value.name + "]"
				});
				
				Label.insert(Checkbox).insert(e.value.title);				
			}
			
		});
		
		this.Panel.hide();
	},
	
	createSortable : function()
	{
		Sortable.create(this.Ul, {"handle":"drag"});
	},
	
	_setValues : function()
	{		
		var inputs	= this.Form.getInputs();
		var values	= {};
		inputs.each(function(e) {			
			if(e.name != "" && (e.type.toUpperCase() != "CHECKBOX" || e.checked)) {
				values[e.name]	= e.value; 
			}
			
		});		
		
		this.Values	= values;
	},
	
	setDefaultValues : function(values)
	{
		var flag 	= false;
		var inputs	= this.Form.getInputs();
		
		inputs.each(function(e) {			
			if(e.name != "" && e.type.toUpperCase() == "CHECKBOX") {			
				$A(values).each(function(k){					
					if(e.name.include(k)) {
						e.checked	= true;
						flag		= true;
						throw $break;
					}
					
				});				
				
			}
			
		});
		
		if(flag) {
			this._setValues();
			this._fireEvent("buttonclick");
		}
		
	}
		
});