MSFW.DataSource.Calendar.MaskInput = Class.create({
	initialize: function(parentElement, values, htmlOptions, style_options, mask, callback)
	{		
		var me				= this;
		this.mask			= mask;
		this.callback		= callback;
		this.defaultValue	= null;
		
			
		
		this.Element	= new Element("input");
		$H(htmlOptions).each(function(e){
			me.Element.setAttribute(e.key, e.value);
		});
		$(parentElement).insert(this.Element);
		
		this.Element.observe("keypress", me.onPress.bindAsEventListener(this, me));
		this.Element.observe("focus", function() {me.Element.select()});
			
		this.populate(values);
	},
	populate : function(values)
	{
		//console.log(values);
	},
	
	setValue : function(value)
	{
		this.defaultValue	= value;
		this.Element.value	= value;
	},
	
	getValue : function()
	{
		return this.Element.value;
	},
	
	onPress: function(event, me)
	{
		var key  	= this.getKey(event);
		var ch      = String.fromCharCode(key);
		
		this.keyUpHandler	= this.onUp.bindAsEventListener(this, me, this.Element.value, ch, key);
		this.Element.observe("keyup", this.keyUpHandler);		
	},

	onUp: function(event, me, oldValue, ch, key)
	{
		event.stop();
		this.Element.stopObserving("keyup", this.keyUpHandler);
		var mask	= this.mask;
		var pos     = this.Element.value.length;
		
		if (this.isPrintable(key) ) {			
			if (!mask.regex.test(this.Element.value) || pos > mask.format.length ) {			
				this.Element.value	= oldValue;
	   		}
	   		else {
	   			if(mask.check && !mask.check(this.Element.value)) {
	   				this.Element.value	= oldValue;
	   			}
	   			
	   		}
	   		
		}
		
		if(this.callback && this.Element.value.length == mask.format.length) {
	   		this.callback();
	   	}
	
	},
	   
	isPrintable: function(key)
	{
	  return ( key >= 32 && key < 127 );
	},
	
	getKey: function(e)
	{
	  return window.event ? window.event.keyCode
	       : e            ? e.which
	       :                0;
	}
});