MSFW.DataSource.Tree	= Class.create(MSFW.DataSource, {
	
	EVENT_TYPES				: ["loadstart", "loadend", "groupclick"],
	
	CONTAINER_CLASS			: "MSFW_DataSource_AjaxTree",
	
	CLOSED_GROUP_IMAGE		: "/templates/default/images/folder_closed.png",
	
	OPENED_GROUP_IMAGE		: "/templates/default/images/folder_open.png",	
	
	initialize : function(options)
	{
		MSFW.DataSource.prototype.initialize.apply(this, arguments);		
		
		//this.clear();
		
		this.Container.addClassName(this.CONTAINER_CLASS);		
	},
	
	clear : function()
	{		
		this.Data				= {};
		this.LastGroup			= null;
		this.Container.update();
	},
	
			
	getData : function()
	{
		return this.Data;
	},
	
	getLastGroupValue : function()
	{		
		if(this.LastGroup) {
			return  this.LastGroup.value;
		}
		else {
			return {};
		}
					
	},
	
	reload : function()
	{
		this.load(this.Groups);
	},
	
	load : function(values)
	{
		this._fireEvent("loadstart");
		
		var me		= this;
		var params	= this.Options.params;
		var url		= this.Options.url;
		
		new Ajax.Request(
				url,
				{
					method 		: "post",
					parameters 	: params,
				  	onSuccess 	: function(resp){					
						me.Data = resp.responseText.evalJSON().data;						
						me._draw();					
						me._fireEvent("loadend");
					}
				
				}
				
			);
	},
		
	_draw : function()
	{
		var me	= this;
		var Ul	= new Element("ul");
		
		this.Container.insert(Ul);
		
		this.Data.each(function(group){
			var Li	= new Element("li");
			Ul.insert(Li);
			
			var Nobr	= new Element("nobr");
			Li.insert(Nobr);
			
			var Div	= new Element("div");			
			Nobr.insert(Div);
			
			var Img	= new Element("img", {"src":me.CLOSED_GROUP_IMAGE});
			Div.insert(Img);
			
			var Content	= new Element("span", {"class":"content"});
			Content.insert(group.name);
			Div.insert(Content);
			
			var Groups	= new Element("ul");
			Li.insert(Groups);
			Groups.hide();
			
			Div.observe("click", me._toggleGroup.bind(me, Img, Groups));
			Div.observe("mouseover", function(){me._mark(Div, true)});
			
			$A(group.folders).each(function(folder){
				
				var FolderLi	= new Element("li");
				Groups.insert(FolderLi);
				
				var FolderNobr	= new Element("nobr");
				FolderLi.insert(FolderNobr);
			
				var FolderDiv	= new Element("div");
				FolderNobr.insert(FolderDiv);
				
				var FolderImg	= new Element("img", {"src":me.CLOSED_GROUP_IMAGE});
				FolderDiv.insert(FolderImg);
				
				var FolderContent	= new Element("span", {"class":"content"});
				FolderContent.insert(folder.name);
				FolderDiv.insert(FolderContent);
				
				FolderDiv.observe("mouseover", function(){me._mark(FolderDiv, true)});
				FolderDiv.observe("click", me._selectFolder.bind(me, FolderDiv, FolderImg, folder));
			});
			
		});
		
	},
	
	_selectFolder : function(Div, Img, Data)
	{
		
		if(this.LastGroup) {
			this.LastGroup.img.src	= this.CLOSED_GROUP_IMAGE;
			this.LastGroup.div.removeClassName("selected");
		}
		
		this.LastGroup	= {
			"img"	: Img,
			"div"	: Div,
			"value"	: Data
		};
		Img.src			= this.OPENED_GROUP_IMAGE;
		Div.addClassName("selected");
		this._fireEvent("groupclick");
	},
	
	_mark : function(Div, flag)
	{
		var me	= this;
		
		if(flag) {
			Div.addClassName("marked");
		}
		else {
			Div.removeClassName("marked");
		}
				
		if(flag) {			
			this._UnMarkFunction	= function(){me._mark(Div, false)}.bindAsEventListener(this);
			Div.observe("mouseout", this._UnMarkFunction);
		}
		else {			
			Div.stopObserving("mouseout", this._UnMarkFunction);
			this._UnMarkFunction	= null;
		}
		
	},
	
	_toggleGroup : function(Img, Container)
	{	
		if(Container.visible()) {
			Img.src	= this.CLOSED_GROUP_IMAGE;
		}
		else {
			Img.src	= this.OPENED_GROUP_IMAGE;
		}
		
		Container.toggle();					
	}
	
});