MSFW.Input.Editable	= Class.create(MSFW.Input, {
	
	REMOVE_IMAGE		: "/templates/default/images/red_cross.png",
	
	DEFAULT_VALUE		: aGlobalMsfWords["MSFW_DOCUMENT"],
	
	initialize : function(options)
	{
		MSFW.Input.prototype.initialize.apply(this, arguments);
				
		this.Input			= new Element("input", {"type" : "hidden", "name" : this.Options.inputName});
		this.Table			= new Element("table");
		this.EditableValues	= {};
				
		this.Container.insert(this.Input).insert(this.Table);		
	},
	
	setStringValue : function(value)
	{
		var Rows	= value.split(this.DATA_ROW_DELIMETER);
		var ret		= {};
		var me		= this;
		$A(Rows).each(function(e){
			var tmp = e.split(me.DATA_COL_DELIMETER);
			ret[tmp[1]]	= tmp[0];
		});
		
		this.Values	= ret;
		this._draw();
	},
	
	setArrayValue : function(Value)
	{
		this.Values	= this._prepareData(Value);
		this._draw();
	},
	
	addArrayValue : function(Value)
	{		
		this.Values	= Object.extend(this.Values, this._prepareData(Value));
		this._draw();
	},
	
	_prepareData : function(Value)
	{
		var ret	= {};
		var me	= this;
		$H(Value).each(function(e){
			var tmp		= [];
			var i		= 0;			
			$A(e.value).each(function(k){			
				if(i>0 && k.value && k.type != "file" && k.type != "picture") {			
					tmp.push(k.value);				
				}
				
				i++;						
			});
			
			ret[e.key]	= me.DEFAULT_VALUE + " (" + tmp.join(me.VALUE_SEPARATOR) + ")";
		});
		
		
		return ret;
	},	
	
	_clearTable : function()
	{
		var me	= this;
		for(var i=($A(this.Table.rows).size()-1); i>=0; i--) {
			me.Table.deleteRow(i);
		}
	},
	
	_draw : function()
	{		
		var me		= this;
		var size	= 0;
		this._clearTable();		
		
		$H(this.Values).each(function(value){
			var Row		= $(me.Table.insertRow(size));
			Row._data	= value;
			size++;
			
			var Cell1	= $(Row.insertCell(0));
			var Cell2	= $(Row.insertCell(1));
			
			var Input	= new Element("input", {"type":"text", "value":value.value});
			Input.observe("keyup", function(){				
				me.Values[value.key]	= Input.value;
				me._updateHiddenValues();		
			});
			Cell1.insert(Input);
			
			
			var RemoveButton	= new Element("img", {"src" : me.REMOVE_IMAGE});
			RemoveButton.observe("click", function(){				
				me.Table.deleteRow(Row.rowIndex);
				delete me.Values[value.key];
				me._updateHiddenValues();
			});
			
			Cell2.insert(RemoveButton);
		});
		
		this._updateHiddenValues();		
	},
			
	_updateHiddenValues : function()
	{
		var hidden	= $A();
		var me		= this;		
		
		$H(this.Values).each(function(e){			
			hidden.push(e.value + me.DATA_COL_DELIMETER + e.key);
		});
		
		this.Input.value	= hidden.join(me.DATA_ROW_DELIMETER);
	}
	
});