MSFW.Input.Sortable	= Class.create(MSFW.Input, {
	
	REMOVE_IMAGE		: "/templates/default/images/red_cross.png",
	
	LIST_CLASS			: "MSFW_Sortable",

	DEFAULT_VALUE_NAME	: "defaultNameToRestore",
	
	initialize : function(options)
	{
		MSFW.Input.prototype.initialize.apply(this, arguments);
		
		
		this.Input	= new Element("input", {"type" : "hidden", "name" : this.Options.inputName});
		this.Ul		= new Element("ul", {"class" : this.LIST_CLASS});
		
		this.Ul.identify();
		this.Container.insert(this.Input).insert(this.Ul);		
	},
	
	clear : function()
	{	
		this.Input.value	= "";
		this.Values			= {};
		this.Ul.update();
	},
	
	setStringValue : function(value)
	{
		var Rows	= value.split(this.DATA_ROW_DELIMETER);
		var value	= {};
		var me		= this;
		$A(Rows).each(function(e){
			var tmp			= e.split(me.DATA_COL_DELIMETER);
			value[tmp[1]]	= [
			{
				"mark"		: 0,
				"name"		: "id",
				"original"	: tmp[1],
				"type"		: "int",
				"value"		: tmp[1]
			},
			{
				"mark"		: 0,
				"name"		: me.DEFAULT_VALUE_NAME,
				"original"	: tmp[0],
				"type"		: "string",
				"value"		: tmp[0]
			}
			];
		});
		
		this.setArrayValue(value);
	},
	
	_draw : function()
	{
		var me	= this;
		this.Ul.update();
		
		$H(this.Values).each(function(e){			
			var Li			= new Element("li");
			Li._data		= e;						
			
			Li.insert(me._getVisibleValue(e.value));
			
			Li.identify();
			
			var RemoveButton	= new Element("img", {"src" : me.REMOVE_IMAGE});
			RemoveButton.observe("click", function(){
				Li.remove();
				me._updateVisibleValues();
				me._updateHiddenValues();
			});
			
			Li.insert(RemoveButton);			
			me.Ul.insert(Li);
		});
		
		Sortable.destroy(this.Ul);
		Sortable.create(this.Ul, {onUpdate: function() { me._updateVisibleValues(); me._updateHiddenValues();}});
		me._updateHiddenValues();
	},
	
	_updateVisibleValues : function()
	{
		var me		= this;		
		this.Values	= {};
		
		$A(this.Ul.childNodes).each(function(e){			
			me.Values[e._data.key]	= e._data.value;			
		});	
		
	},
	
	_updateHiddenValues : function()
	{
		var hidden	= $A();
		var me		= this;
		var value	= "";
		
		$H(this.Values).each(function(e){
			hidden.push(me._getHiddenValue(e.value));
		});
		
		this.Input.value	= hidden.join(me.DATA_ROW_DELIMETER);
	},
	
	_getVisibleValue : function(data)
	{
		var me		= this;
		var ret		= $A();
		
		$A(data).each(function(k){			
			if(me.Options.columns[k.name] && me.Options.columns[k.name].select || k.name == me.DEFAULT_VALUE_NAME) {				
				if(k.value) {
					ret.push(k.value);
				}
				
			}
						
		});
		
		return ret.join(this.VALUE_SEPARATOR);
	},
	
	_getHiddenValue : function(data)
	{		
		return this._getVisibleValue(data) + this.DATA_COL_DELIMETER + data[0].value;
	}

});