MSFW.Placeholder	= Class.create(MSFW.EventListener,{
	
	INPUT_CLASS	: MSFW.Input,
	
	BUTTON_IMAGE	: "/modules/references/view/img/table.png",	
		
	EVENT_TYPES		: ["buttonbeforeclick", "buttonafterclick"],
	
	initialize : function(options)
	{	
		MSFW.EventListener.prototype.initialize.apply(this, arguments);	
	
		this.Options		= Object.extend({
			"Container"		: document.body,			
			"default"		: null			
		}, options || {});
		
		
		this.Options.Container	= $(this.Options.Container);
		this.Input				= null;
		this.PlacehoderButton	= null;
		this.SelectButton		= null;
		this.Window				= null;
		this.ButtonPosition		= null;
		this.DataSource			= null;
				
		this._buildInput();
		this._buildPlacehoderButton();
		this._buildSelectButton();
	},
	
	_buildInput : function()
	{					
		this.Input				= new this.INPUT_CLASS(this.Options);		
		this.Options.Container.insert(this.Input.getDom());	
		
		if(this.Options.default) {
			this.Input.setStringValue(this.Options.default);
		}
	},
	
	_buildPlacehoderButton : function()
	{		
		this.PlacehoderButton	= new Element("img", {"src":this.BUTTON_IMAGE});		
		this.PlacehoderButton.observe("click", this._showWindow.bind(this));
		
		this.Options.Container.insert(this.PlacehoderButton);
		
		this.ButtonPosition	= Position.cumulativeOffset(this.PlacehoderButton);
	},
	
	_buildSelectButton : function()
	{
		var me				= this;
		this.SelectButton	= new Element("input", {"type" : "button", "value" : "Ok"});
		this.SelectButton.observe("click", function(){
			me._fireEvent("buttonbeforeclick");			
			me.Input.addArrayValue(me.DataSource.getValue());
			me.Window.hide();
			me.DataSource.clear();
			me._fireEvent("buttonafterclick");
		});
		
	},
	
	_showWindow : function()
	{
		if(!this.Window) {
			this.Window	= new MSFW.Window();			
			this._onWindowCreate();
			
			this.Window.appendToBody(this.SelectButton);
		}
		
		this.Window.moveTo(this.ButtonPosition[0], this.ButtonPosition[1]);
		this.Window.show();
	},
	
	_onWindowCreate : function()
	{
		alert("MSFW.Placeholder::_onWindowCreate()");
	}
	
});