MSFW.Placeholder.Document	= Class.create(MSFW.Placeholder, {
	
	INPUT_CLASS		: MSFW.Input.Editable,
	
	BUTTON_IMAGE	: "/modules/workflow/view/templates/default/img/documents.png",	
	
	initialize : function(options)
	{	
		MSFW.Placeholder.prototype.initialize.apply(this, arguments);
		
		this.Options		= Object.extend({			
			"multiselect"		: false,		
			"defaultFilters"	: null,
			"folders"			: null
		}, this.Options || {});		
				
		this.DataContainer			= new Element("table");
		this.DataRefinement			= new Element("div");
		this.Table					= null;
		this.Row					= this.DataContainer.insertRow(0);		
		this.RefinementParameters	= "";
		this.RefinementCallback		= null;
		this.GroupsTree				= null;		
		this.QuickFilter			= null;
		this.Filters				= null;
		this.lastLoadedFolderId		= 0;
		
		this.DataSourceValues		= {};
		
		if(!this.Options.multiselect) {
			var me	= this;			
			this.addEventListener("buttonbeforeclick", function(){me.Input.clear()});
		}
		
	},
	
	_onWindowCreate : function()
	{
		if(!this.DataSource) {
			
			var me				= this;
			var params			= "";
			
			if(this.Options.folders) {
				$A(this.Options.folders).each(function(e){
					params	+= "&folders[]=" + e;
				});
			}
						
			this.GroupsTree	= new MSFW.DataSource.Tree({"params":params, "url":"/workflow/ajaxfolders", "idColumn":"document_id"});
			this._getCell().insert(this.GroupsTree.getDom());
			this.GroupsTree.load();			
			this.GroupsTree.addEventListener("groupclick", me._reloadTable.bind(this, true));
					
			this.DataSource	= new MSFW.DataSource.AjaxTable({"params":"", "url":"/workflow/ajaxdocuments/?", "multiselect":this.Options.multiselect});		
			this._getCell().insert(this.DataSource.getDom());
			this.DataSource.addEventListener("loadend", this._buildDataRefinement.bind(this));
			
			
			this.Window.appendToBody(this.DataRefinement);
			this.Window.appendToBody(this.DataContainer);			
		}
		
	},
	
	_getCell : function()
	{
		return $(this.Row.insertCell($A(this.Row.cells).size()));
	},
	
	_buildDataRefinement : function()
	{			
		if(this.GroupsTree.getLastGroupValue().folder_id != this.lastLoadedFolderId) {
			var data	= this.DataSource.getData();		
			var me		= this;
			var columns	= {};
			
			this.lastLoadedFolderId	= this.GroupsTree.getLastGroupValue().folder_id;
			
			$A(data.titles).each(function(e){			
				columns[e.name]	= {
					"filter"	: e.filter,				
					"name"		: e.name,
					"title"		: e.title
				}			
				
			});
			
			if(this.Filters) {
				var FilterContainer	= this.Filters.getDom().parentNode;
				this.Filters.destroy();
				this.Filters	= null;
			}
			else {
				var FilterContainer	= new Element("span");
				this.DataRefinement.insert(FilterContainer);
			}
			
			this.Filters	= new MSFW.DataRefinement.Filters({"columns":columns});
			FilterContainer.insert(this.Filters.getDom());
			this.Filters.addEventListener("buttonclick", this._reloadTable.bind(this));
			
			
			if(!this.QuickFilter) {				
				this.QuickFilter	= new MSFW.DataRefinement.QuickFilter();
				this.DataRefinement.insert(this.QuickFilter.getDom());
				this.QuickFilter.addEventListener("buttonclick", this._reloadTable.bind(this));	
			}
			
			
			
		}
					
	},
		
	_reloadTable : function(firstLoad)
	{	
		this.DataSourceValues	= Object.extend(this.DataSourceValues, this.DataSource.getValue());
		
		if(firstLoad) {
			if(this.QuickFilter) {				
				this.DataSource.setFilters(this.QuickFilter.getValue());
			}
			else {
				this.DataSource.setFilters({});
			}
			this.DataSource.load({"folderId":this.GroupsTree.getLastGroupValue().folder_id});	
		}
		else {
			var filters	= {};
			filters	= Object.extend(filters, this.Filters.getValue());
			filters	= Object.extend(filters, this.QuickFilter.getValue());
			
			this.DataSource.setValue(this.DataSourceValues);
			this.DataSource.setFilters(filters);
			this.DataSource.reload();
		}
			
	}
	
});