MSFW.Placeholder.Reference	= Class.create(MSFW.Placeholder, {
	
	INPUT_CLASS	: MSFW.Input.Sortable,
	
	BUTTON_IMAGE	: "/modules/references/view/img/table.png",	
	
	initialize : function(options)
	{	
		if(!!!options.byId) {
			this.INPUT_CLASS	= MSFW.Input.Textarea;
		}
	
		
		MSFW.Placeholder.prototype.initialize.apply(this, arguments);
		
		this.Options		= Object.extend({			
			"multiselect"		: false,
			"byId"				: false,
			"referenceId"		: 0,
			"unique"			: false,
			"uniqueType"		: "",
			"defaultGroups"		: null,
			"defaultFilters"	: null
		}, this.Options || {});		
				
		this.DataContainer			= new Element("table");
		this.DataRefinement			= new Element("div");
		this.Table					= null;
		this.Row					= this.DataContainer.insertRow(0);		
		this.RefinementParameters	= "";
		this.RefinementCallback		= null;
		this.GroupsTree				= null;
		this.Groups					= null;
		this.QuickFilter			= null;
		this.Filters				= null;
		
		if(!this.Options.multiselect) {
			var me	= this;			
			this.addEventListener("buttonbeforeclick", function(){me.Input.clear()});
		}
		
	},
	
	_onWindowCreate : function()
	{
		if(!this.DataSource) {
			var me				= this;
			var Options			= {};
			Options.params		= this._getAjaxParams();
			Options.url			= this._getAjaxUrl();
			Options.multiselect = this.Options.multiselect;
			
			
						
			this.GroupsTree	= new MSFW.DataSource.AjaxTree(Options);
			this._getCell().insert(this.GroupsTree.getDom());
			this.GroupsTree.addEventListener("groupclick", me._reloadTable.bind(this));
			
			
			this.DataSource	= new MSFW.DataSource.AjaxTable(Options);		
			this._getCell().insert(this.DataSource.getDom());
			
			this.RefinementCallback	= function(){me._buildDataRefinement(me.DataSource.getData());}
			
			this.DataSource.addEventListener("loadend", this.RefinementCallback);
			if(this.Options.defaultFilters) {
				var tmp	= {};
				$H(this.Options.defaultFilters).each(function(e){
					tmp["rs_searchParam_" + e.key]	= e.value;
				});
				
				this.DataSource.setFilters(tmp);			
			}
			this.DataSource.load();
			
			this.Window.appendToBody(this.DataRefinement);
			this.Window.appendToBody(this.DataContainer);
		}
		
	},
	
		
	_getAjaxParams : function()
	{
		var params	= "";		
		var i		= 0;
		
		$H(this.Options.columns).each(function(e){
			params += "&select[" + i + "]=" + e.key;
			i++;
		});
		
		if(this.Options.default) {
			params	+= "&default=" + this.Options.default;
		}
		
		params	+= "&inputName=" + this.Options.inputName;
		
		return params;
	},
	
	_getAjaxUrl : function()
	{		
		var url	= "";
		url		+= "/references/ajaxview/";
		url		+= this.Options.referenceId;
		url		+= "/";
		
		this.Options.unique ? url += "1" : url += "0";
		
		url		+= "/";
		url		+= this.Options.uniqueType;
		url		+= "?";
		
		return url;		
	},
	
				
	_getCell : function()
	{
		return $(this.Row.insertCell($A(this.Row.cells).size()));
	},
	
	_buildDataRefinement : function(data)
	{	
		var Table	= new Element("table");
		var Row		= $(Table.insertRow(0));
		var Cell1	= $(Row.insertCell(0));
		var Cell2	= $(Row.insertCell(1));
		
		this.DataRefinement.insert(Table);
		
		this.DataSource.removeEventListener("loadend", this.RefinementCallback);	
		
		var me		= this;
		var columns	= {};
		$A(data.titles).each(function(e){			
			var name	= e.name;
						
			if(me.Options.columns[name]) {				
				columns[e.name]	= {
					"filter"	: me.Options.columns[name].filter,
					"group"		: me.Options.columns[name].group,
					"name"		: e.name,
					"title"		: e.title
				}
				
			}
			
		});
						
		this.Filters	= new MSFW.DataRefinement.Filters({"columns":columns});
		Cell1.insert(this.Filters.getDom());
		
		this.Filters.addEventListener("buttonclick", this._filterClick.bind(this));
		
		this.Groups	= new MSFW.DataRefinement.Groups({"columns":columns});		
		Cell2.insert(this.Groups.getDom());
		this.Groups.createSortable();		
		this.Groups.addEventListener("buttonclick", this._loadTree.bind(this));
		
		
		this.QuickFilter	= new MSFW.DataRefinement.QuickFilter();
		this.DataRefinement.insert(this.QuickFilter.getDom());
		this.QuickFilter.addEventListener("buttonclick", this._filterClick.bind(this));
		
		
		if(this.Options.defaultFilters) {
			//console.log(this.Options.defaultFilters);
			this.Filters.setDefaultValues(this.Options.defaultFilters);
		}
		
		
		if(this.Options.defaultGroups) {
			this.Groups.setDefaultValues(this.Options.defaultGroups);
		}
	},
	
	_filterClick : function()
	{/*
		if(this.GroupsTree.loaded()) {				
			this._loadTree();
		}
		else {				
			this.DataSource.setFilters(this._getFiltersValues());
			this.DataSource.reload();
		}*/
		this.DataSource.setFilters(this._getFiltersValues());
		this.DataSource.reload();		
	},
	
	_getFiltersValues : function()
	{
		var filters	= {};
		filters	= Object.extend(filters, this.Filters.getValue());
		filters	= Object.extend(filters, this.QuickFilter.getValue());
		
		return filters;
	},
	
	_loadTree : function()
	{
		var me		= this;
		var value	= me.Groups.getValue();
		var flag	= false;
		
		
		$H(value).each(function(e){
			if(e.value == 1) {
				flag	= true;
			}
		});
		
		this.GroupsTree.setFilters(this._getFiltersValues());
		
		if(flag) {
			me.GroupsTree.load(value);
		}
		else {
			me.GroupsTree.clear();
			me._reloadTable();
		}
	},
	
	_reloadTable : function()
	{
		
		var me		= this;
		var options	= {
			get		: {},
			post	: {}
		};
				
		this.DataSource.setGroups("get", this.Groups.getValue());
		this.DataSource.setGroups("post", this.GroupsTree.getLastGroupValue());
						
		this.DataSource.setFilters(this._getFiltersValues());
		
		this.DataSource.reload();		
	},
});