<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

class MSF_RS_State
{
	private $isRecoverState		= true;
	
	private $clearGroupState	= false;
	
	private $aParams		= array();
	
	private $aColumns		= array();
	
	/**
	 * @var MSF_DB
	 */
	private $DB				= null;
			
	private $aState			= null;
	
	private $aGroupsState	= null;
	
	private $iStateId		= 0;
	
	public function __construct($DB)
	{
		$this->DB			= $DB;
			
		isset($_GET["noStateRecover"]) ? $this->isRecoverState	= false : $this->isRecoverState	= true;
		isset($_GET["clearGroupState"]) ? $this->clearGroupState = true : $this->clearGroupState = false;
	}
	
	public function isRecoverState()
	{
		return $this->isRecoverState;
	}
	
	public function isClearGroupState()
	{
		return $this->clearGroupState;
	}
	
	public function setColumns($aInput)
	{
		$this->aColumns	= $aInput;
	}
	
	public function setStateParams($aInput)
	{
		$this->aParams	= $aInput;
	}
	
	public function checkParamsState($aInput)
	{
		$aOutput = $aInput;
		if(!empty($this->aParams)) {
			$this->load();
			if($this->isRecoverState && !empty($this->aState)) {
				$aOutput	= $this->actualizeParams($this->aState);
			}
			else {
				if(!$this->aState) {
					$this->saveNewParamsState($aInput);
				}
				else {
					$this->updateParamsState($aInput, $this->iStateId);
				}

			}

		}
		
		return $aOutput;
	}
	

	public function update($aInput)
	{
		if(!empty($this->aParams)) {
			$this->load();
			if(!empty($this->aState)) {
				$this->aState["orderBy"]		= $aInput["orderBy"];
				$this->aState["orderDirection"]	= $aInput["orderDirection"];
				$this->updateParamsState($this->aState, $this->iStateId);
			}
		}
		
	}
	
	private function load()
	{
		if($this->aState == null) {
			$sSQL	= 	"SELECT" . "\n" .
							"state_id, params_state, groups_state" . "\n" .
						"FROM" . "\n" .
							"recordset_states" . "\n" .
						"WHERE"	. "\n" .
								"module='" . $this->aParams["module"] . "'" . "\n" .
						"AND" . "\n" .
							"action='" . $this->aParams["action"] . "'" . "\n" .
						"AND" . "\n" .
							"action_id='" . (int)$this->aParams["action_id"] . "'" . "\n" .
						"AND" . "\n" .
							"structure_id='" . (int)$this->aParams["structure_id"] . "'" . "\n" .
						"ORDER BY" . "\n" .
							"state_id DESC";
			
			$aRes	= $this->DB->select($sSQL, true);
			//debug($aRes);
			if(!empty($aRes)) {
				$this->aState		= unserialize(base64_decode($aRes["params_state"]));
				$this->aGroupsState	= unserialize(base64_decode($aRes["groups_state"]));
				$this->iStateId		= $aRes["state_id"];
			}
			else {
				$this->aState	= null;
			}
				
		}
		
	}

	private function saveNewParamsState($aInput)
	{
		$sSQL	=	"INSERT INTO" . "\n" .
						"recordset_states" . "\n" .
						"(module, action, action_id, params_state,structure_id)" . "\n" .
					"VALUES" . "\n" .
						"(" .
							"'" . $this->aParams["module"] . "'," . "\n" .
							"'" . $this->aParams["action"] . "'," . "\n" .
							"'" . $this->aParams["action_id"] . "'," . "\n" .
							"'" . base64_encode(serialize($aInput)) . "'," . "\n" .
							"'" . (int)$this->aParams["structure_id"] . "'" . "\n" .
						")";
		
		$this->DB->executeQuery($sSQL);
	}
	
	private function updateParamsState($aInput, $iStateId)
	{
		$sSQL	=	"UPDATE" . "\n" .
						"recordset_states" . "\n" .
					"SET" . "\n" .
						"params_state='" . base64_encode(serialize($aInput)) . "'" . "\n" .
					"WHERE" . "\n" .
							"state_id='" . $iStateId . "'";
		
		$this->DB->executeQuery($sSQL);
	}
	
	private function actualizeParams($aParams)
	{
		$aToDeleteGroups	= array();
		foreach($this->aColumns as $aColumn) {
			if(!$aColumn["filter"]) {
				if(isset($aParams["aFilters"]) && isset($aParams["aFilters"][$aColumn["name"]])) {
					unset($aParams["aFilters"][$aColumn["name"]]);
				}
			}
			
			if(!$aColumn["group"]) {
				
				for($i=0; $i<count($aParams["aGroups"]); $i++) {
					if($aColumn["name"] == $aParams["aGroups"][$i]["name"]) {
						array_push($aToDeleteGroups, $i);
					}
										
				}
				
			}
			
		}
		
		foreach($aToDeleteGroups as $index) {
			unset($aParams["aGroups"][$index]);
		}
		
		if(empty($aParams["aGroups"])) {
			$aParams["isGroup"]			= 0;
			$aParams["currentGroup"]	= "";
			$aParams["nextGroup"]		= "";
			$aParams["lastGroup"]		= "";
		}
		
		
		if(isset($aParams["limitFrom"])) {
			if($aParams["limitFrom"] % MSF_Recordset::$RECORDS_PER_PAGE) {
				$aParams["limitFrom"]	= 0;
			}
			
		}
		
		return $aParams;
	}
	
	public function clearState()
	{
		if(!empty($this->aParams)) {
			$sSQL	=	"UPDATE" . "\n" .
							"recordset_states" . "\n" .
						"SET" . "\n" .
							"params_state=''," . "\n" .
							"groups_state=''" . "\n" .
 						"WHERE" . "\n" .
							"module='" . $this->aParams["module"] . "'" . "\n" .
						"AND" . "\n" .
							"action='" . $this->aParams["action"] . "'" . "\n" .
						"AND" . "\n" .
							"action_id='" . $this->aParams["action_id"] ."'";
		
			$this->DB->executeQuery($sSQL);
		}
			
	}
	
	public function clearGroupState()
	{
		if(!empty($this->aParams)) {
			$sSQL	=	"UPDATE" . "\n" .
							"recordset_states" . "\n" .
						"SET" . "\n" .
							"groups_state=''" . "\n" .
						"WHERE" . "\n" .
							"module='" . $this->aParams["module"] . "'"  . "\n" .
						"AND" . "\n" .
							"action='" . $this->aParams["action"] . "'" . "\n" .
						"AND" . "\n" .
							"action_id='" . $this->aParams["action_id"] ."'";
		
			$this->DB->executeQuery($sSQL);
		}
	}
	
	public function saveGroupsState($aParams)
	{/*
		echo "<pre>";
		print_r($aParams);
		echo "</pre>";
		die("ololo");
		*/
		if(!empty($this->aParams)) {
			$this->load();
			$aInsertNode	= null;
		
					
			if(!$this->aGroupsState) {
				$this->aGroupsState	= array();
				$aInsertNode		= &$this->aGroupsState;
			}
			else {
				$aInsertNode		= &$this->findNode($aParams);
			}
			
			$sGroupKey							= $this->getGroupKey($aParams["currentGroup"], $aParams["aGroupValues"][$aParams["currentGroup"]]);
			
			if($aParams["groupAction"] == "close") {
				/*
				if(isset($aInsertNode[$sGroupKey])) {
					unset($aInsertNode[$sGroupKey]);
				}*/
				$aInsertNode[$sGroupKey]["visible"]	= 0;
				if(isset($aInsertNode[$sGroupKey]["childs"])) {
					$this->recursiveHide($aInsertNode[$sGroupKey]["childs"]);
				}
				//print_r($aInsertNode[$sGroupKey]);
				//$this->recursiveHide();
			}
			elseif($aParams["groupAction"] == "open" || $aParams["groupAction"] == "load") {
				$aInsertNode[$sGroupKey]["value"]	= $aParams;
				$aInsertNode[$sGroupKey]["visible"]	= 1;
			}
			//echo "<pre>";
			//print_r($this->aGroupsState);
			//echo "</pre>";
			//try {
				$sSQL	=	"UPDATE" . "\n" .
								"recordset_states" . "\n" .
							"SET" . "\n" .
								"groups_state='" . base64_encode(serialize($this->aGroupsState)) . "'" . "\n" .
							"WHERE" . "\n" .
									"state_id='" . $this->iStateId . "'";
				
				$this->DB->executeQuery($sSQL);

		}
		
	}
	
	public function getGroupToRestore($aGroupValues)
	{
		
		$aReturn	= array();
		if(!empty($this->aParams)) {
			$this->load();
			$aSource	= $this->aGroupsState;
						
			foreach($aGroupValues as $sName=>$sValue) {
				$sKey	= $this->getGroupKey($sName, $sValue);
				if(isset($aSource[$sKey]) && isset($aSource[$sKey]["childs"])) {
					$aSource	= $aSource[$sKey]["childs"];
				}
				else {
					$aSource	= null;
					break;
				}
				
			}
			
			//debug($this->aGroupsState);
			
			if(is_array($aSource)) {
				foreach($aSource as $aGroup) {
					if (!isset($aGroup["value"]))
						continue;
					$sParams	= "";
					$sParams	.= "&rs_limitFrom=" . $aGroup["value"]["limitFrom"];
					$sParams	.= "&rs_orderDirection=" . $aGroup["value"]["orderDirection"];
					$sParams	.= "&rs_orderBy=" . $aGroup["value"]["orderBy"];
					
					$aTmp	= array(
						"name"		=> $aGroup["value"]["currentGroup"],
						"value"		=> addslashes($aGroup["value"]["aGroupValues"][$aGroup["value"]["currentGroup"]]),
						"params"	=> $sParams,
						"visible"	=> $aGroup["visible"]
					);
					
					array_push($aReturn, $aTmp);
				}
			}
		}
		//echo "<pre>";
		//print_r($aReturn);
		//print_r($this->aGroupsState);
		//print_r($aSource);
		//echo "</pre>";
		//debug($this->aGroupsState);
		//debug($aGroupValues);
		//return $this->aGroupsState();
		//debug($aReturn);
		return $aReturn;
	}
	
	public function getGroupKey($sName, $sValue)
	{
		return MSF_String::hash($sName . $sValue, 32);
	}

	private function &findNode($aParams)
	{
		$aReturn	= &$this->aGroupsState;
		$iTotal		= count($aParams["aGroupValues"]);
		$iCurrent	= 1;
				
		foreach($aParams["aGroups"] as $aGroup) {
			if(isset($aGroup["value"])) {
				if($iCurrent == $iTotal) {
					break;
				}
				
				$sKey	= $this->getGroupKey($aGroup["name"], $aGroup["value"]);
				
				if(!isset($aReturn[$sKey])) {
					$aReturn[$sKey]	= array();
				}
				
				if(!isset($aReturn[$sKey]["childs"])) {
					$aReturn[$sKey]["childs"]	= array();
				}
					
				$aReturn	= &$aReturn[$sKey]["childs"];
				$iCurrent++;
			}
			
		}
		
		//die("here");
		return $aReturn;
	}
	
	private function recursiveHide(&$aNodes)
	{
		foreach($aNodes as &$aNode) {
			$aNode["visible"]	= 0;
			if(isset($aNode["childs"])) {
				$this->recursiveHide($aNode["childs"]);
			}
			
		}
		
	}
	
}

?>
