<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

class MSF_RS_Urls 
{
	private $sBaseUrl	= "";
	
	private $sRpcUrl	= "";
	
	private $Params		= null;
	
	public function __construct($Params)
	{
		$this->Params	= $Params;		
	}
	
	public function setBaseUrl($sUrl)
	{
		$this->sBaseUrl	= $sUrl . "&noStateRecover";
	}
	
	public function setRpcUrl($sUrl)
	{
		$this->sRpcUrl	= $sUrl . "&noStateRecover";
	}
	
	public function getOrder()
	{
		/*
		$sUrl	=	$this->sBaseUrl . $this->_filters() . $this->__search();
		return $sUrl;
		*/
		return $this->getFilters();
	}
	
	public function getBase()
	{
		return $this->sBaseUrl;
	}
	
	public function getLimit()
	{		
		/*
		$sUrl	=	$this->sBaseUrl . 
					$this->_order() .
					$this->_filters() .
					$this->_groups();
		
		return $sUrl;
		*/
		return $this->getFilters();
	}
	
	public function getRpc()
	{		
		return $this->sRpcUrl . $this->_groups() . $this->_filters();	
	}
	
	public function getGroups()
	{
		return $this->sBaseUrl .  $this->__search(). "&clearGroupState" . $this->_filters();
	}
	
	public function getFilters()
	{
		$sUrl	=	$this->sBaseUrl .	
					$this->__search(). 				
					$this->_groups() .
					$this->_order() .
					$this->_filters();
		return $sUrl;
	}
	
	private function _filters()
	{
		$aFilters	= $this->Params->get("aFilters");
		$sStr		= "";
		if (!empty($aFilters)) {
			foreach($aFilters as $sName=>$aFilter) {
				if($aFilter["isMulti"]) {					
					$sStr	.=	"&rs_searchParam_isMulti_" . $sName . "=1" .
								"&rs_searchParam_" . $sName . "_from=" . $aFilter["mFrom"] .
								"&rs_searchParam_" . $sName . "_to=" . $aFilter["mTo"];
				}
				else {
					$sStr	.= "&rs_searchParam_" . $sName . "=" . urlencode($aFilter["mValue"]);
					if(isset($aFilter["sCondition"])) {						
						$sStr	.= "&rs_searchParam_" . $sName  . "_condition=" . $aFilter["sCondition"];					
					}
					
				}
				
			}			
		}
		
		$sStr	.= "&rs_quickFilter=" . urlencode($this->Params->get("sQuickFilter")) . $this->__search();

		return $sStr;
	}
	
	private function _groups()
	{
		$aGroups	= (array)$this->Params->get("aGroups");
		$sGroups	= "";
		foreach($aGroups as $aGroup) {
			if (!empty($aGroup)) {
				$sGroups .= "&rs_groups[" . $aGroup["name"] . "]=" . $aGroup["active"];
			}	
			
		}


		return $sGroups . $this->__search();
	}
	
	private function _order()
	{
		$sStr	=	"&rs_orderBy=" . $this->Params->get("orderBy") .
					"&rs_orderDirection=" . strtolower($this->Params->get("orderDirection"));
		
		return $sStr;
	}
	
	private function __search() {
		return "&rs_search=" . urlencode($this->Params->get("rs_search"));
	}
	
}

?>
