var RS_GroupManager	= Class.create();
RS_GroupManager.prototype	= 
{
	initialize : function(sRpcLink)
	{
		this.sRpcLink		= sRpcLink + "&msf_view=noAuthForm";
		this.aGroups		= {};		
		this.WaitingQueue	= new RS_TreeQueue();
		this.EvalQueue		= new RS_EvalQueue();		
	},
	
	toggleGroup : function(groupIdentity, value, currentGroup, post, get, bOpenChild, parent)
	{
		if(!this.aGroups[groupIdentity]) {
			var Group			= new RS_Group(groupIdentity, parent, value, currentGroup, this.sRpcLink, post, get, this);
			Group.bOpenChild	= !!bOpenChild;
			this.aGroups[groupIdentity]	= Group;
		}
		
		this.aGroups[groupIdentity].toggle();
	},
	
	reloadGroup : function(groupIdentity, params)
	{		
		if(!this.aGroups[groupIdentity]) {			
			return null;
		}
		
		this.aGroups[groupIdentity].reload(params);
	},
	
	showAll : function()
	{
		var me	= this;
		$H(this.aGroups).each(function(e)
		{
			if(!e.value.bIsLoaded) {				
				e.value.bOpenChild	= true;
			}
			
			e.value.show();
		});
	},
	
	hideAll : function()
	{
		$H(this.aGroups).each(function(e)
		{
			if(e.value.visible()) {
				e.value.hide();
			}
		
		});
		
	},
	
	addGroup : function(groupIdentity, value, currentGroup, post, get, parent)
	{		
		if(!this.aGroups[groupIdentity]) {			
			this.aGroups[groupIdentity]	= new RS_Group(groupIdentity, parent, value, currentGroup, this.sRpcLink, post, get, this);
		}	
			
	},
	
	toEvalStack : function(group, parent, func)
	{		
		this.WaitingQueue.push(parent, group, func);		
		this.nextLoad();		
	},
	
	onDataLoad : function(group)
	{
		this.EvalQueue.remove(group);
		this.nextLoad();
	},
	
	nextLoad : function()
	{
		if(!this.EvalQueue.full() && this.WaitingQueue.size() > 0) {
			var tmpGroup	= this.WaitingQueue.pop();
			this.EvalQueue.add(tmpGroup.id);
			tmpGroup.value();
		}
		
	}	
		
}


var RS_Group	= Class.create();
RS_Group.prototype	= 
{
	initialize : function(groupIdentity, parentGroup, value, currentGroup, rpcLink, post, get, manager)
	{
		this.sGroupIdentity		= groupIdentity;
		this.sParentGroup		= parentGroup;
		this.GroupContainer		= $("RS_groupContainer_" + groupIdentity);
		this.LoaderContainer	= $("RS_loaderContainer_" + groupIdentity);
		this.GroupImage			= $("RS_groupImage_" + groupIdentity);		
		this.sPostParams		= post || "";
		this.sGetParams			= get || "";
		this.sRpcLink			= rpcLink + "&rs_group_identity=" + groupIdentity;
		this.mGroupValue		= value;
		this.sCurrentGroup		= currentGroup;
		this.bVisible			= false;
		this.bIsLoaded			= false;
		this.bInLoading			= false;
		this.LastRequestParams	= {"post":"", "get":""};		
		this.bOpenChild			= false;
		this.GroupManager		= manager;		
		this.sQuickFilter		= $("RS_QuickFilter").value;
	},
	
	show : function()
	{
		if(this.bInLoading) {
			return;
		}
		var me	= this;
		
		if(!this.bIsLoaded) {			
			me.load();
		}
		else {
			var ret		= {};
			ret.get		= this.LastRequestParams.get + "&noData&rs_groupAction=open";
			ret.post	= this.LastRequestParams.post;			
			
			this.toEval(function(){
				me.sendRequest(ret);
				//MSF_Effect.show(me.GroupContainer);
				me.GroupContainer.show();
			});			
		}
		
		this.GroupImage.src	= "/templates/default/images/folder_open.png";
		this.bVisible		= true;
			
		
	},
	
	hide : function()
	{
		if(this.bInLoading) {
			return;
		}
		
		this.GroupImage.src	= "/templates/default/images/folder_closed.png";
		this.bVisible		= false;
		//this.GroupContainer.hide();
		
		
		var me	= this;
		var ret		= {};
		ret.get		= this.LastRequestParams.get + "&noData&rs_groupAction=close";
		ret.post	= this.LastRequestParams.post;
		
				
		this.toEval(function(){	me.sendRequest(ret);
							   	//MSF_Effect.hide(me.GroupContainer);
							   	me.GroupContainer.hide();
							  });
	},
	
	toggle : function()
	{
		this.bVisible ? this.hide() : this.show();			
	},
	
	visible : function()
	{
		return this.bVisible;
	},
	
	load : function(addParams)
	{
		if(this.bInLoading) {
			return;
		}
		
		var params		= this.getRequestParams(addParams);
		var me			= this;
		
		
		this.toEval(function(){me.sendRequest(params, function(me, req) { 
				me.GroupContainer.update(req.responseText);	
				//MSF_Effect.show(me.GroupContainer);
				me.GroupContainer.show();
				if (HIDE_MENU) {
					registerEvent(resizeIframeContents);
				}
				
			});
		});	
		
		this.bIsLoaded	= true;		
	},
	
	reload : function(params)
	{
		this.load(params);
	},
	
	getRequestParams : function(getParams)
	{		
		var ret		= {"post" : "", "get" : ""};
		//this.mGroupValue = this.mGroupValue.split("&quot;").join("\"");
		this.mGroupValue	= this.mGroupValue.replace(/\+/g, "&#43;");
		ret.post	+= "&rs_groupValues[" + this.sCurrentGroup + "]=" + encodeURIComponent(this.mGroupValue);
		ret.post	+= this.sPostParams;
		ret.get		+= this.sRpcLink;
		ret.get		+= this.sGetParams;
		if(getParams) {
			ret.get	+= getParams;
		}		
		
		this.LastRequestParams	= ret;
		
		return ret;
	},
	
	sendRequest : function(par, callback)
	{
		if(this.bInLoading) {
			return false;
		}
		
		var me			= this;		
		this.bInLoading	= true;		
		this.LoaderContainer.show();			
		
		var link	= par.get;
		if(this.bOpenChild) {
			link	+= "&rs_showGroupChild=1";
		}
		//@TODO Fix recordsets quickfilter when Marik come back
		if (this.sQuickFilter !== aGlobalMsfWords["ROOT_SEARCH_QUICK"]) {
			link	+= "&rs_quickFilter=" + escape(this.sQuickFilter); // hack
		}
		new Ajax.Request(
			link,
			{
				method 		: "post",
				parameters 	: par.post,
			  	onSuccess 	: function(req)
			  	{				
					if(callback) {
						callback(me, req);
					}
										
					me.LoaderContainer.hide();
			  		me.bInLoading	= false;
			  		me.GroupManager.onDataLoad(me.sGroupIdentity);
			  	}

			}

		);
		
	},
	
	toEval : function(func)
	{			
		this.GroupManager.toEvalStack(this.sGroupIdentity, this.sParentGroup, func)
	}
	
}