RS_TreeQueue	= Class.create();
RS_TreeQueue.prototype	= 
{
	initialize : function()
	{
		this.reset();
	},
	
	reset : function()
	{
		this.Tree		= $A();
		this.iSize		= 0;
		this.aReturned	= $A();
		
		this.aQueue		= $A();
	},
	
	push : function(parent, child, val)
	{
		var tmpQue		= $A();
		var el			= {"id" : child, "parent" : parent, "value" : val, "ready" : false};
		var addedFlag	= false;
		var rdyAdd		= false;
		
		this.aQueue.each(function(e)
		{	
			
			if(rdyAdd && !addedFlag) {
				if(e.parent != parent) {
					
					tmpQue.push(el);
					addedFlag	= true;
				}
				
			}
			
			tmpQue.push(e);			
			
			if(e.id == parent) {				
				rdyAdd	= true;				
			}
			
		});
		
		if(!addedFlag) {
			tmpQue.push(el);
		}
		
		this.aQueue	= tmpQue;		
		this.iSize++;
	},
	
	pop : function()
	{	
		/*
		var ret	= {};
		if(this.iSize) {
			var tmp		= this.findNext(this.Tree);
			ret.id			= tmp.value.id;
			ret.value		= tmp.value.value;
			
			this.Tree	= tmp.source;			
			this.iSize--;
		}*/
		var ret	= null;
		var me	= this;
		
		this.aQueue.each(function(e)
		{
			if(!e.ready && !ret) {
				ret			= {};
				ret.id		= e.id;
				ret.value	= e.value;
				
				e.ready		= true;
				me.iSize--;
			}
		});
		
		if(!this.iSize) {
			this.reset();			
		}
		
		return ret;		
	},
	
	size : function()
	{
		return this.iSize;
	},
	
	findNext : function(source)
	{
		var ret	= null;
		var me	= this;
		
		if(source[0].childs.size() && this.aReturned.indexOf(source[0].id) != -1) {
			ret		= this.findNext(source[0].childs);
			if(!ret.source.size()) {
				source	= source.without(source[0]);
			}
			else {
				source[0].childs	= ret.source;
			}
			
			ret.source			= source;
		}
		else {
			ret			= {};
			ret.value	= source.first();		
			
			if(source[0].childs.size() > 0) {
				this.aReturned.push(source[0].id);
			}
			else {				
				source		= source.without(ret.value);				
			}
			
			ret.source	= source;
		}
		
		
		
		return ret;		
	},
	
	findNode : function(source, id)
	{
		var ret	= null;
		var me	= this;
		
		source.each(function(e)
		{
			if(!ret) {
				
				if(e.id == id) {
					ret	= e.childs;
				}
				else {
					ret	= me.findNode(e.childs, id);
				}
				
			}
			
		});
		
		if(!ret) {
			ret	= source;
		}
		
		return ret;
	}	
	
}
/*
 * - a1
 * - a2
 * --- b1
 * --- b2
 * ------ c1
 * ------ c2
 * ------ c4
 * --- b3
 * - a3
 */
/*
 * result: a1, a2, b1, b2, c1, c2, c3, b3, a3
 */
/*
var TestQ	= new RS_TreeQueue();
TestQ.push(null, "a1");
TestQ.push(null, "a2");
TestQ.push(null, "a3");

TestQ.push("a2", "b1");
TestQ.push("a2", "b2");
TestQ.push("a2", "b3");

TestQ.push("b2", "c1");
TestQ.push("b2", "c2");
TestQ.push("b2", "c3");

//console.log(TestQ.pop());
//console.log(TestQ.pop());
//console.log(TestQ.Tree.flatten());

while(TestQ.size()) {
	console.log(TestQ.pop());
}*/