<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output encoding="UTF-8"/>
	<xsl:output method="html" indent="no" media-type="text/xhtml"/>

	<xsl:template match="/">		
		<xsl:apply-templates select="/page/module"/>
	</xsl:template>
	
	<xsl:template match="/page/module">	
		 
		<xsl:if test="recordset/@dataLoad = 1">		
			 <xsl:choose>			
				<xsl:when test="recordset/groups/@groupMode = 'table'">	
					<div style="padding-left:20px;">							
						<xsl:call-template name="recordsetGroupTable"/>
						<xsl:call-template name="rs_pagination_ajax"/>
					</div>																	
				</xsl:when>
				<xsl:otherwise>					
					<xsl:call-template name="recordsetGroup"/>
					<xsl:call-template name="rs_pagination_ajax"/>								
				</xsl:otherwise>						 
			</xsl:choose>								
		</xsl:if>
					
	</xsl:template>
	
	
	<xsl:template name="rs_pagination_ajax">
		
		<xsl:if test="recordset/pagination/pages/page/@number>1">
			<table class="rs-total">
				<tr>
					<td>
					<xsl:value-of select="$ROOT_RS_FOUND"/>: <xsl:value-of select="recordset/pagination/@totalRecords"/>&#160;
					<xsl:value-of select="$ROOT_RS_PAGES"/>: <xsl:value-of select="recordset/pagination/@totalPages"/>
					</td>
					<td style="width:10%;white-space: nowrap;">
						<xsl:choose>
							<xsl:when test="not(recordset/pagination/@previusPage = -1)">
								<a title="{$ROOT_RS_FIRST}" href="#" onclick="groupManager.reloadGroup('{recordset/groups/@groupIdentity}', '&amp;rs_limitFrom=0{recordset/@limitUrl}'); return false;"><img src="/library/MSF_Recordset/resources/default/img/rs-first.png"/></a>
								<xsl:text>  </xsl:text>
								<a title="{$ROOT_RS_PREVIOUS}" href="#" onclick="groupManager.reloadGroup('{recordset/groups/@groupIdentity}', '&amp;rs_limitFrom={recordset/pagination/@previusPage}{recordset/@limitUrl}'); return false;"><img src="/library/MSF_Recordset/resources/default/img/rs-previous.png"/></a>
							</xsl:when>
							<xsl:otherwise>
								<!-- 
								<xsl:text>&lt;&lt;  &lt;</xsl:text>
								-->
							</xsl:otherwise>
						</xsl:choose>
						<xsl:text>  </xsl:text>
				
							<xsl:for-each select="recordset/pagination/pages/page">
								<xsl:choose>
									<xsl:when test="@currentPage = 1">
										<span class="rs-current-page">
											<xsl:value-of select="@number"/>
										</span>
									</xsl:when>
									<xsl:otherwise>
										<a class="rs-link" href="#" onclick="groupManager.reloadGroup('{../../../groups/@groupIdentity}', '&amp;rs_limitFrom={@limitFrom}{../../../@limitUrl}');"><xsl:value-of select="@number"/></a>
									</xsl:otherwise>
								</xsl:choose>
								<xsl:choose>
									<xsl:when test="not (position() = last())">
										<xsl:text>&#160;</xsl:text>
									</xsl:when>
								</xsl:choose>
							</xsl:for-each>
				
						<xsl:text>  </xsl:text>
						<xsl:choose>
							<xsl:when test="not(recordset/pagination/@nextPage = -1)">
								<a title="{$ROOT_RS_NEXT}" href="#" onclick="groupManager.reloadGroup('{recordset/groups/@groupIdentity}', '&amp;rs_limitFrom={recordset/pagination/@nextPage}{recordset/@limitUrl}'); return false;"><img src="/library/MSF_Recordset/resources/default/img/rs-next.png"/></a>
								<xsl:text>  </xsl:text>
								<a title="{$ROOT_RS_LAST}" href="#" onclick="groupManager.reloadGroup('{recordset/groups/@groupIdentity}', '&amp;rs_limitFrom={recordset/pagination/@lastPage}{recordset/@limitUrl}'); return false;"><img src="/library/MSF_Recordset/resources/default/img/rs-last.png"/></a>
							</xsl:when>
							<xsl:otherwise>
								<!-- 
								<xsl:text>&gt;  &gt;&gt;</xsl:text>
								-->
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
			</table>

		</xsl:if>
		
	</xsl:template>
</xsl:stylesheet>