<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template name="recordsetGroup">			
		<xsl:call-template name="rs_records_whith_group"/>	
	</xsl:template>
	
		
		
	<xsl:template name="rs_records_whith_group">
		<ul id="RS_Records_{recordset/groups/@groupIdentity}" class="rs-group">
			<xsl:for-each select="recordset/records/item">
				<li>
					<div style="cursor:pointer;padding:2px;" onClick="groupManager.toggleGroup('{@identity}', '{columns/column/@slash_original}', '{../../groups/@currentGroup}', '{../../groups/@groupValues}', '{../../groups/@groupIdentity}{@getParams}')">
						<!-- 
						<img id="RS_groupImage_{@identity}" class="RS_GM_more_image" src="/templates/default/images/folder_closed.png"/>
						&#160;
						<xsl:value-of select="columns/column/@value" disable-output-escaping="yes"/> (<xsl:value-of select="@totalInGroup" disable-output-escaping="yes"/>)
						<span id="RS_loaderContainer_{@identity}" style="display:none;">&#160;&#160;<img src="/templates/default/images/loader.gif"/></span>
						 -->
						
						<img id="RS_groupImage_{@identity}" class="RS_GM_more_image" src="/templates/default/images/folder_closed.png"/>
						<span style="padding-left:8px;">
							<xsl:attribute name="class">
								<xsl:value-of select="columns/column/@text_class"/>
							</xsl:attribute>
							<xsl:value-of select="columns/column/@value" disable-output-escaping="yes"/>
						</span>
						<span class="rs-group-count">(<xsl:value-of select="@totalInGroup" disable-output-escaping="yes"/>)</span>
						<span id="RS_loaderContainer_{@identity}" style="display:none;">&#160;&#160;<img src="/templates/default/images/loader.gif"/></span>
						
					</div>				
					<div id="RS_groupContainer_{@identity}" style="display:none;">&#160;</div>				
				</li>
			</xsl:for-each>
		</ul>
		<script>
								
			new RS_GroupSupply("RS_Records_<xsl:value-of select="recordset/groups/@groupIdentity"/>", "hightlight");				
			
			<xsl:for-each select="recordset/restoreGroups/item">		
				groupManager.toggleGroup('<xsl:value-of select="@identity"/>', '<xsl:value-of select="@value"/>', '<xsl:value-of select="@name"/>', '<xsl:value-of select="@postParams"/>', '<xsl:value-of select="@getParams"/>')
			</xsl:for-each>
			
			<xsl:if test="recordset/groups/@showGroupChild = 1">
				<xsl:for-each select="recordset/records/item">
					groupManager.toggleGroup('<xsl:value-of select="@identity"/>', '<xsl:value-of select="columns/column/@slash_original"/>', '<xsl:value-of select="../../groups/@currentGroup"/>', '<xsl:value-of select="../../groups/@groupValues"/>', true);
				</xsl:for-each>
			</xsl:if>
			
			<xsl:for-each select="recordset/records/item">
				groupManager.addGroup('<xsl:value-of select="@identity"/>', '<xsl:value-of select="columns/column/@slash_original"/>', '<xsl:value-of select="../../groups/@currentGroup"/>', '<xsl:value-of select="../../groups/@groupValues"/>', '<xsl:value-of select="@getParams"/>', '<xsl:value-of select="../../groups/@groupIdentity"/>');
			</xsl:for-each>			
		</script>
	</xsl:template>

</xsl:stylesheet>