<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template name="recordsetGroupTable">		
		
		<table id="RS_Records_{recordset/groups/@groupIdentity}" class="rs-table">	
			<xsl:choose>
				<xsl:when test="count(/page/module/recordset/titles/title) > 0">
					<xsl:attribute name="style">width:100%;</xsl:attribute>
				</xsl:when>
			</xsl:choose>							
			<xsl:call-template name="rs_group_table_titles_without_group"/>
			<xsl:call-template name="rs_group_table_records_wihtout_group"/>
			<xsl:call-template name="rs_records_amount"/>		
		</table>
					
		<script>					
			new RS_RowSupply("RS_Records_<xsl:value-of select="recordset/groups/@groupIdentity"/>", "rs-cell-hightlight");				
		</script>
		
	</xsl:template>
	
		
		
	<xsl:template name="rs_group_table_titles_without_group">		
		<tr>
			<xsl:choose>
				<xsl:when test="recordset/@isMultiaction = 1">
					<th class="rs-cell-checkbox-title">
						<input type="checkbox" onClick="RS_SelectAllCheckbox(this.parentNode.parentNode.parentNode.parentNode, this)"/>
					</th>
				</xsl:when>
			</xsl:choose>
			<th class="rs-cell-context-title">
				<!-- <div class="rs-cell-context-title"></div> -->
				<a href="{recordset/@baseUrl}">
					<img title="{$RS_RESET}" src="/templates/default/images/0document.png"/>
				</a>
			</th>
			<xsl:for-each select="recordset/titles/title">
				<th class="rs-title">
					<xsl:choose>
						<xsl:when test="@sort = 1">		
								<xsl:choose>
									<xsl:when test="@sort = 1 and (@orderBy = 'asc' or @orderBy = 'desc')">
										<xsl:attribute name="style">background-color:#cccccc;</xsl:attribute>
									</xsl:when>
								</xsl:choose>				
								<xsl:choose>
									<xsl:when test="@orderBy = 'none'">
										<xsl:attribute name="onclick">groupManager.reloadGroup('<xsl:value-of select="../../groups/@groupIdentity"/>', '&amp;<xsl:value-of select="../../@orderUrl"/>&amp;rs_orderBy=<xsl:value-of select="@name"/>&amp;rs_orderDirection=asc');</xsl:attribute>
										<a>
											<nobr>
												<xsl:value-of select="@title"/>											
												&#160;										
												<img src="/templates/default/images/arrow_small.png" border="0"/>										
											</nobr>
										</a>
									</xsl:when>
									<xsl:when test="@orderBy = 'asc'">
										<xsl:attribute name="onclick">groupManager.reloadGroup('<xsl:value-of select="../../groups/@groupIdentity"/>', '&amp;<xsl:value-of select="../../@orderUrl"/>&amp;rs_orderBy=<xsl:value-of select="@name"/>&amp;rs_orderDirection=desc');</xsl:attribute>
										<a>
											<nobr>
												<xsl:value-of select="@title"/>											
												&#160;										
												<img src="/templates/default/images/arrow_small_down.png" border="0"/>										
											</nobr>
										</a>
									</xsl:when>
									<xsl:when test="@orderBy = 'desc'">
										<xsl:attribute name="onclick">groupManager.reloadGroup('<xsl:value-of select="../../groups/@groupIdentity"/>', '&amp;<xsl:value-of select="../../@orderUrl"/>&amp;rs_orderBy=<xsl:value-of select="@name"/>&amp;rs_orderDirection=asc');</xsl:attribute>
										<a>
											<nobr>
												<xsl:value-of select="@title"/>											
												&#160;										
												<img src="/templates/default/images/arrow_small_up.png" border="0"/>										
											</nobr>
										</a>
									</xsl:when>
								</xsl:choose>
						</xsl:when>
						<xsl:otherwise>
							<a href="#" style="cursor:default;">
								<xsl:value-of select="@title"/>
							</a>							
						</xsl:otherwise>
						
					</xsl:choose>
				</th>
			</xsl:for-each>
		</tr> 
	</xsl:template>

	
	<xsl:template name="rs_group_table_records_wihtout_group">
		<xsl:for-each select="recordset/records/item">
			<tr link="{link/@value}">
				<xsl:choose>
					<xsl:when test="../../@isMultiaction = 1">
						<td>
							<xsl:attribute name="class">
								<xsl:choose>
									<xsl:when test="columns/column/@mark = 1">
										rs-cell-checkbox-marked
									</xsl:when>
									<xsl:otherwise>
										rs-cell-checkbox
									</xsl:otherwise>
								</xsl:choose>							
							</xsl:attribute>							
							<input type="checkbox" onClick="RS_SelectACheckbox(this.parentNode.parentNode, this)" name="{../../multiactions/@field}[]" value="{@multiactionFiled}"/>
						</td>
					</xsl:when>
				</xsl:choose>
				<td class="rs-cell-context">
					<xsl:choose>
						<xsl:when test="link/@value">
							<xsl:attribute name="class">
								<xsl:choose>
									<xsl:when test="columns/column/@mark = 1">
										rs-cell-context-marked
									</xsl:when>
									<xsl:otherwise>
										rs-cell-context
									</xsl:otherwise>
								</xsl:choose>							
							</xsl:attribute>
							
							<img src="/library/MSF_Recordset/resources/default/img/rs-context-active.png" class="rs-cell-context-button" id="RS_recordsContextMenuButton_{../../groups/@groupIdentity}_{position()}"/>
					
							<div class="rs-cell-context-options" style="display:none;" id="RS_recordsContextMenuPanel_{../../groups/@groupIdentity}_{position()}">						
								<xsl:for-each select="actions/action">
									<a class="rs-cell-context-option-open">
										<xsl:choose>
											<xsl:when test="@export = 1">
												<xsl:attribute name="onclick">
													RS_Href('<xsl:value-of select="@href"/>'); return false;
												</xsl:attribute>
											</xsl:when>
											<xsl:otherwise>
												<xsl:attribute name="href">
													<xsl:value-of select="@href"/>
												</xsl:attribute>
											</xsl:otherwise>
										</xsl:choose>
										<xsl:if test="@confirm = 1">
											<xsl:attribute name="onclick">
												RS_ShowConfirm('<xsl:value-of select="@href"/>',<xsl:value-of select="@confirm"/>,'<xsl:value-of select="@question"/>'); return false;
											</xsl:attribute>
										</xsl:if>
										<xsl:if test="@blank = 1">
											<xsl:attribute name="target">
												_blank
											</xsl:attribute>
										</xsl:if>
										<img src="{@image}" border="0"/>&#160;<xsl:value-of select="@title"/>
									</a>					
								</xsl:for-each>
							</div>
							<script>
								new RS_ContextMenu("RS_recordsContextMenuButton_<xsl:value-of select="../../groups/@groupIdentity"/>_<xsl:value-of select="position()"/>", "RS_recordsContextMenuPanel_<xsl:value-of select="../../groups/@groupIdentity"/>_<xsl:value-of select="position()"/>");							
							</script>
						</xsl:when>
						<xsl:otherwise>
							<img src="/library/MSF_Recordset/resources/default/img/rs-context-active.png" />
						</xsl:otherwise>
					</xsl:choose>			
				</td>

				<xsl:for-each select="columns/column">
					<td>
						<xsl:attribute name="class">
							<xsl:choose>
								<xsl:when test="@mark = 1">
									rs-cell rs-cell-marked
								</xsl:when>
								<xsl:otherwise>
									rs-cell
								</xsl:otherwise>
							</xsl:choose>							
						</xsl:attribute>
						<xsl:choose>
							<xsl:when test="@type = 'string' or @type = 'text'">
								<xsl:attribute name="align">
									<xsl:text>left</xsl:text>
								</xsl:attribute>
							</xsl:when>
							<xsl:when test="@type = 'int' or @type = 'float'">
								<xsl:attribute name="align">
									<xsl:text>right</xsl:text>
								</xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="align">
									<xsl:text>center</xsl:text>
								</xsl:attribute>
							</xsl:otherwise>						
						</xsl:choose>
						<xsl:choose>
							<xsl:when test="@color = '#000'">
								<xsl:value-of select="@value" disable-output-escaping="yes"/>
							</xsl:when>
							<xsl:otherwise>
								<font color="{@color}">
									<xsl:value-of select="@value" disable-output-escaping="yes"/>
								</font>
							</xsl:otherwise>
						</xsl:choose>																							
						<xsl:if test="@value = ''">
							&#160;
						</xsl:if>															
					</td>
				</xsl:for-each>
			</tr>
		</xsl:for-each>
	</xsl:template>	
</xsl:stylesheet>
