<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template name="recordset">		
		<div class="recordset">			
			<span class="no-print">
				<xsl:call-template name="rs_actions_panel"/>								
			</span>				
			<form id="RS_RecordsForm" class="rs-form" method="post" action="">
				<div style="display:none;">
					<div id="login_layer" style="padding:5pt;">							
							<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
							<table cellpadding="5pt">
							<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
							<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
							<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
						</table>	
					</div>
				</div>			
				<xsl:choose>
					<xsl:when test="recordset/@isGroup = 0">
						<div id="RS_HScroll" style="overflow-x:auto; width:100%;">							
							<xsl:call-template name="recordsetTable"/>
						</div>
						<script>
							 //var oScroll = (typeof(lmsRecordset) == 'undefined') ? new RS_HScroll(50, false) : new RS_HScroll(50, true);
						</script>
					</xsl:when>
					<xsl:otherwise>
						<script>							
							var RS_RpcLoadLink	= "<xsl:value-of select="recordset/@rpcUrl"/>";
							var groupManager	= new RS_GroupManager(RS_RpcLoadLink);
							var aSuplies		= [];					
						</script>
						<div id="RS_HScroll" style="overflow-x:auto; width:100%;">						
							<xsl:call-template name="recordsetGroup"/>
						</div>
						<script>
							//var oScroll = (typeof(lmsRecordset) == 'undefined') ? new RS_HScroll(70, false) : new RS_HScroll(70, true);
						</script>						 
					</xsl:otherwise>
				</xsl:choose>
				<xsl:call-template name="rs_pagination"/>				
			</form>
			
			
			<xsl:call-template name="rs_multiactions_bottom"/>
					
		</div>
	</xsl:template>
	
	<xsl:template name="rs_pagination">		
		<xsl:if test="recordset/pagination/pages/page/@number>1">
			<table class="rs-total">
				<tr>
					<td>
					<xsl:value-of select="$ROOT_RS_TOTAL"/>: <xsl:value-of select="recordset/pagination/@totalRecords"/> &#160;
					<xsl:value-of select="$ROOT_RS_PAGES"/>: <xsl:value-of select="recordset/pagination/@totalPages"/>
					</td>
					<td style="width:10%;white-space: nowrap;">
						<xsl:choose>
							<xsl:when test="not(recordset/pagination/@previusPage = -1)">
								<a title="{$ROOT_RS_FIRST}" href="{recordset/@limitUrl}&amp;rs_limitFrom=0"><img src="/library/MSF_Recordset/resources/default/img/rs-first.png"/></a>
								<xsl:text>  </xsl:text>
								<a title="{$ROOT_RS_PREVIOUS}" href="{recordset/@limitUrl}&amp;rs_limitFrom={recordset/pagination/@previusPage}"><img src="/library/MSF_Recordset/resources/default/img/rs-previous.png"/></a>
							</xsl:when>
							<xsl:otherwise>
								<!-- 
								<xsl:text>&lt;&lt;  &lt;</xsl:text>
								-->
							</xsl:otherwise>
						</xsl:choose>
						<xsl:text>  </xsl:text>
				
							<xsl:for-each select="recordset/pagination/pages/page">
								<xsl:choose>
									<xsl:when test="@currentPage = 1">
										<span class="rs-current-page">
											<xsl:value-of select="@number"/>
										</span>
									</xsl:when>
									<xsl:otherwise>
										<a class="rs-link" href="{../../../@limitUrl}&amp;rs_limitFrom={@limitFrom}"><xsl:value-of select="@number"/></a>
									</xsl:otherwise>
								</xsl:choose>
								<xsl:choose>
									<xsl:when test="not (position() = last())">
										<xsl:text>&#160;</xsl:text>
									</xsl:when>
								</xsl:choose>
							</xsl:for-each>
				
						<xsl:text>  </xsl:text>
						<xsl:choose>
							<xsl:when test="not(recordset/pagination/@nextPage = -1)">
								<a title="{$ROOT_RS_NEXT}" href="{recordset/@limitUrl}&amp;rs_limitFrom={recordset/pagination/@nextPage}"><img src="/library/MSF_Recordset/resources/default/img/rs-next.png"/></a>
								<xsl:text>  </xsl:text>
								<a title="{$ROOT_RS_LAST}" href="{recordset/@limitUrl}&amp;rs_limitFrom={recordset/pagination/@lastPage}"><img src="/library/MSF_Recordset/resources/default/img/rs-last.png"/></a>
							</xsl:when>
							<xsl:otherwise>
								<!-- 
								<xsl:text>&gt;  &gt;&gt;</xsl:text>
								-->
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>
			</table>

		</xsl:if>
		
	</xsl:template>
	
	<xsl:template name="rs_actions_panel">	
		<table class="rs-bar" border="0">
			<tr>
				<!-- Hack -->
				<xsl:if test="/page/module/recordset/@isMultiaction = 1">
					<td class="rs-bar-multiaction" style="width:100px;">
					
						<xsl:choose>
							<xsl:when test="recordset/@isMultiaction = 1">
								<table cellpadding="0" cellspacing="0">
									<tr>
										<td>
											<nobr><xsl:value-of select="$ROOT_RS_WITH_SELECTED"/>: &#160;</nobr>
										</td>
										<xsl:if test="recordset/pagination/@totalRecords > 0">										
											<xsl:for-each select="recordset/multiactions/action">
												<td>
													<img class="rs-bar-button" onClick="RS_SelectMultiAction('{@href}', {@confirm}, '{@question}')" src="{@image}" title="{@title}" alt="{@title}"/>
												</td>
											</xsl:for-each>
										</xsl:if>
									</tr>
								</table>						
	
							</xsl:when>
						</xsl:choose>
						
					</td>
				</xsl:if>
				<td class="rs-bar-search">
					<form id="RS_QuickFilter_Form" action="{recordset/@limitUrl}" method="post">
						<table>
							<tr>
								<td>
									<input style="width:150px" type="text" class="searchInput" id="RS_QuickFilter" name="rs_quickFilter" onfocus="MSF_SearchInput.quick(this, true)" onblur="MSF_SearchInput.quick(this, false)">
										<xsl:attribute name="value">
											<xsl:choose>
												<xsl:when test="recordset/@quickFilter!=''">
													<xsl:value-of select="recordset/@quickFilter"/>
												</xsl:when>
												<xsl:otherwise>
													<xsl:value-of select="$ROOT_SEARCH_QUICK"/>
												</xsl:otherwise>
											</xsl:choose>
										</xsl:attribute>
									</input>
									<div id="RS_QuickResults" style="display:none;"></div>
									<script>
									var sBase	= "<xsl:value-of select="/page/module/@autoCompleteUri"/>";
									var sAcUri  = sBase + "?<xsl:value-of select="recordset/@limitUrl"/>";
									if (sBase.length > 0) {
										new Ajax.Autocompleter("RS_QuickFilter", "RS_QuickResults", sAcUri, {
												paramName: "rs_quickFilter", 
												minChars: 1,
												updateElement: function(item) { /* no update */ }
												});
									}

									
									</script>
								</td>
								<td>
									<input type="button" value="{$ROOT_RS_FIND}" onclick="quickSearch()"/>
									<script>
										var quickSearch = function()
										{
											var sValue = $('RS_QuickFilter').value;
											if (sValue == "<xsl:value-of select="$ROOT_SEARCH_QUICK"/>") {
												sValue = "";
											}
											
											sValue	= sValue.replace(/&amp;/g, "%26");
											sValue	= sValue.replace(/\+/g, "%2B");								
											window.location = '?<xsl:value-of select="recordset/@limitUrl"/>&amp;rs_quickFilter=' + sValue + hideMenu("&amp;");
										}
										
										
										$("RS_QuickFilter").observe("keyup", function(event){
											event = (!event) ? window.event : event;
											//13 - enter
											if(event.keyCode == 13){
												quickSearch();
											}
											
										});
									</script>
								</td>
							</tr>
						</table>
					</form>					
				</td>	
				
				<td class="rs-filtering-n-grouping" style="width:250px;">
					<ul class="rs-action-panel">
						<xsl:if test="recordset/titles/title/@filter = 1">
							<li id="rs-filter" class="rs-action-component">
								<a class="rs-action-title">																	
									<span>
										<xsl:choose>
											<xsl:when test="recordset/titles/title/@filterEnable = 1">
												<u><xsl:value-of select="$ROOT_RS_FILTER_TITLE"/></u>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="$ROOT_RS_FILTER_TITLE"/>
											</xsl:otherwise>
										</xsl:choose>									
									</span>
								</a>
								<div class="rs-filter-panel" id="rs-filter-panel">
									<xsl:call-template name="rs_filters"/>
								</div>
							</li>
							<script>
								var flagFilter	= false;
								<xsl:if test="recordset/titles/title/@filterEnable = 1">
									flagFilter	= true;
								</xsl:if>
								new RS_ActionPanel("rs-filter", "rs-filter-panel", flagFilter);							
							</script>
						</xsl:if>
						<xsl:if test="recordset/titles/title/@group = 1">
							<li id="rs-group" class="rs-action-component">
								<a class="rs-action-title">
									<span>
										<xsl:choose>
											<xsl:when test="recordset/@isGroup = 1">
												<u><xsl:value-of select="$REF_PLACEHOLDER_GROUPS"/></u>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="$REF_PLACEHOLDER_GROUPS"/>
											</xsl:otherwise>
										</xsl:choose>										
									</span>
								</a>
								<div class="rs-group-panel" id="rs-group-panel">
									<xsl:call-template name="rs_groups"/>
								</div>
							</li>
							<script>
								var flagFilter	= false;
								<xsl:if test="recordset/titles/title/@groupEnable = 1">
									flagFilter	= true;
								</xsl:if>
								new RS_ActionPanel("rs-group", "rs-group-panel", flagFilter);							
							</script>
						</xsl:if>
					</ul> 

				</td>
			</tr>
		</table>	
		
						
	</xsl:template>
	
	<xsl:template name="rs_groups">
		<div class="rsPopupPanel">
			<div class="rsPopupPanelContentLayout">
				<div class="rsPopupPanelContentRight">
					<div class="rsPopupPanelContent">
		<table>
			<tr>
				<td>
					<form id="RS_GM_groupPanelForm" method="POST">					
						<ul id="RS_GM_groupPanel" class="RD_GM_groupPanel">								
							<xsl:for-each select="recordset/groups/item">
								<xsl:variable name="groupName">
								     <xsl:value-of select="@name"/>
								</xsl:variable> 
								<xsl:if test="../../titles/title[@name = $groupName]">										
									<li id="group_{@name}">
										<span class="dragHandler">&#160;</span>
										<input type="hidden" name="rs_groups[{@name}]" value="0"/>				
										<label>
											<input type="checkbox" name="rs_groups[{@name}]" value="1">
												<xsl:if test="@active = 1">
													<xsl:attribute name="checked">
														checked
													</xsl:attribute>
												</xsl:if>
											</input>											
																													
											<xsl:value-of select="../../titles/title[@name = $groupName]/@title"/>
										</label>
									</li>
								</xsl:if>							
							</xsl:for-each>
						</ul>
					</form>
				</td>
			</tr>
			<tr>
				<td>
					<input type="button" value="{$MSFW_GROUP}" id="RS_GM_groupButton"/>
				</td>
			</tr>
		</table>
					</div>
				</div>
			</div>
			<div class="rsPopupPanelBottomLayout">
				<div class="rsPopupPanelBottomRight">
					<div class="rsPopupPanelBottomCenter">
						<div class="rsPopupPanelBottom"/>
					</div>
				</div>
			</div>
		</div>

		<script>
			new RS_GroupPanel("RS_GM_groupPanel", "RS_GM_groupButton", "<xsl:value-of select="recordset/@groupUrl"/>");				
		</script>
	</xsl:template>
	
	<xsl:template name="rs_filters">
		<div class="rsPopupPanel">
			<div class="rsPopupPanelContentLayout">
				<div class="rsPopupPanelContentRight">
					<div class="rsPopupPanelContent">
					
		<form method="post" id="RS_FilterForm" action="{recordset/@filterUrl}">
			<table id="RS_FilterTable" border="0" cellpaing="5" cellspacing="5">
				<xsl:for-each select="recordset/titles/title">
					<xsl:choose>
						<xsl:when test="@filter = 1">
							<tr id="RS_Filter_Row_{@name}">
							<!-- 
								<td>
									<input id="RS_Activate_Checkboc_{@name}" type="checkbox" class="RS_less_image"/>
								</td>
								 -->								
								<td>
									<label for="RS_Activate_Checkboc_{@name}"><xsl:value-of select="@title"/>:</label>
								</td>
								<td>
									<nobr>
										<xsl:choose>										
											<xsl:when test="@type = 'int' or @type = 'float' or @type = 'date' or @type = 'timestamp'">
												<label>
													<input id="RS_Filter_Radio_Single_{@name}" name="rs_searchParam_isMulti_{@name}" type="radio" value="0"/>												
													<xsl:value-of select="$ROOT_RS_FILTER_1"/>
												</label><br/>
												<label>
													<input id="RS_Filter_Radio_Multi_{@name}" name="rs_searchParam_isMulti_{@name}" type="radio" value="1"/>
													<xsl:value-of select="$ROOT_RS_FILTER_RANGE"/>
												</label>
											</xsl:when>
											<xsl:otherwise>
												<select id="rs_searchParam_{@name}_condition" name="rs_searchParam_{@name}_condition">
													<option value="="><xsl:value-of select="$ROOT_RS_FILTER_CONTAINS"/></option>
													<option value="!="><xsl:value-of select="$ROOT_RS_FILTER_NOT_CONTAINS"/></option>
												</select>
											</xsl:otherwise>
										</xsl:choose>
									</nobr>
								</td>
								<td>
									<xsl:choose>
										<xsl:when test="@type = 'int' or @type = 'float' or @type = 'date' or @type = 'timestamp'">
											<span id="RS_Filter_Container_Single_{@name}">
												<table cellpadding="0" cellspacing="0">
												<tr>
												<td>
												<select name="rs_searchParam_{@name}_condition">
													<xsl:choose>
														<xsl:when test="@condition = '&#60;'">
															<option value="=">=</option>
															<option value="&#60;" selected="selected">&#60;</option>
															<option value="&#62;">&#62;</option>
														</xsl:when>
														<xsl:when test="@condition = '&#62;'">
															<option value="=">=</option>
															<option value="&#60;">&#60;</option>
															<option value="&#62;" selected="selected">&#62;</option>
														</xsl:when>
														<xsl:otherwise>
															<option value="=" selected="selected">=</option>
															<option value="&#60;">&#60;</option>
															<option value="&#62;">&#62;</option>
														</xsl:otherwise>
													</xsl:choose>																										
												</select>
												</td>
												<td>
												<xsl:choose>													
														<xsl:when test="@type = 'date'">														
															<span id="conteiner_rs_searchParam_{@name}"/>															
															<script>
																new MSFW.Placeholder.Calendar(
																{
																	"Container"	: "conteiner_rs_searchParam_<xsl:value-of select="@name"/>",
																	"inputName"	: "rs_searchParam_<xsl:value-of select="@name"/>",
																	"default"	: "<xsl:value-of select="@filterValue"/>"
																});
															</script>
														</xsl:when>
														<xsl:when test="@type = 'timestamp'">														
															<span id="conteiner_rs_searchParam_{@name}"/>															
															<script>
																new MSFW.Placeholder.Calendar(
																{
																	"Container"	: "conteiner_rs_searchParam_<xsl:value-of select="@name"/>",
																	"inputName"	: "rs_searchParam_<xsl:value-of select="@name"/>",
																	"time"		: true,
																	"default"	: "<xsl:value-of select="@filterValue"/>"
																});
															</script>
														</xsl:when>	
														<xsl:otherwise>
															<input type="text" id="rs_searchParam_{@name}" name="rs_searchParam_{@name}" value="{@filterValue}"/>	
														</xsl:otherwise>
													</xsl:choose>																								
												</td>
												</tr>
												</table>								
											</span>
											<span id="RS_Filter_Container_Multi_{@name}">
												<table cellpadding="0" cellspacing="0">
												<tr>
												<td>
												<xsl:value-of select="$LABEL_FROM"/>:
												</td>
												<td>
												<xsl:choose>													
													<xsl:when test="@type = 'date'">
														<span id="conteiner_rs_searchParam_{@name}_from" class="scal tinyscal slick"/>															
														<script>
															new MSFW.Placeholder.Calendar(
															{
																"Container"		: "conteiner_rs_searchParam_<xsl:value-of select="@name"/>_from",
																"inputName"		: "rs_searchParam_<xsl:value-of select="@name"/>_from",
																"default"		: "<xsl:value-of select="@filterValue_from"/>"
															});
															
														</script>
													</xsl:when>
													<xsl:when test="@type = 'timestamp'">
														<span id="conteiner_rs_searchParam_{@name}_from" class="scal tinyscal slick"/>															
														<script>
															new MSFW.Placeholder.Calendar(
															{
																"Container"		: "conteiner_rs_searchParam_<xsl:value-of select="@name"/>_from",
																"inputName"		: "rs_searchParam_<xsl:value-of select="@name"/>_from",
																"time"			: true,
																"default"		: "<xsl:value-of select="@filterValue_from"/>"
															});
															
														</script>
													</xsl:when>
													<xsl:otherwise>
														<input type="text" name="rs_searchParam_{@name}_from" value="{@filterValue_from}"/>
													</xsl:otherwise>
												</xsl:choose>
												</td>
												</tr>
												</table>
												<table cellpadding="0" cellspacing="0">
												<tr>
												<td>
												<xsl:value-of select="$LABEL_ON"/>:
												</td>
												<td>									
												<xsl:choose>													
													<xsl:when test="@type = 'date'">
														<span id="conteiner_rs_searchParam_{@name}_to" class="scal tinyscal slick"/>															
														<script>	
															new MSFW.Placeholder.Calendar(
															{
																"Container"		: "conteiner_rs_searchParam_<xsl:value-of select="@name"/>_to",
																"inputName"		: "rs_searchParam_<xsl:value-of select="@name"/>_to",
																"default"		: "<xsl:value-of select="@filterValue_to"/>"
															});																	
														</script>
													</xsl:when>
													<xsl:when test="@type = 'timestamp'">
														<span id="conteiner_rs_searchParam_{@name}_to" class="scal tinyscal slick"/>															
														<script>															
															new MSFW.Placeholder.Calendar(
															{
																"Container"		: "conteiner_rs_searchParam_<xsl:value-of select="@name"/>_to",
																"inputName"		: "rs_searchParam_<xsl:value-of select="@name"/>_to",
																"time"			: true,
																"default"		: "<xsl:value-of select="@filterValue_to"/>"
															});																	
														</script>
													</xsl:when>
													<xsl:otherwise>
														<input type="text" name="rs_searchParam_{@name}_to" value="{@filterValue_to}"/>
													</xsl:otherwise>
												</xsl:choose>
												</td>
												</tr>
												</table>
											</span>
										</xsl:when>
										<!-- xsl:when test="@type = 'bool'">
											<nobr>
												<label>
													<input type="radio" value="1" id="rs_searchParam_{@name}" name="rs_searchParam_{@name}">
														<xsl:if test="not(@filterValue) or @filterValue = 1">
															<xsl:attribute name="checked">
																checked
															</xsl:attribute>
														</xsl:if>
													</input>
													<xsl:value-of select="optional/item[@key = 'labelYes']/@value"/>
												</label>
												<label>
													<input type="radio" value="0" id="rs_searchParam_{@name}" name="rs_searchParam_{@name}">
														<xsl:if test="@filterValue = 0">
															<xsl:attribute name="checked">
																checked
															</xsl:attribute>
														</xsl:if>
													</input>
													<xsl:value-of select="optional/item[@key = 'labelNo']/@value"/>
												</label>
											</nobr>
										</xsl:when-->
										<!--xsl:when test="@type = 'enum'">
											<select id="rs_searchParam_{@name}" name="rs_searchParam_{@name}">
												<option value="">- - - - -</option>	
												<xsl:for-each select="optional/enum/item">
													<option value="{@value}|^|row|^|{@key}">														
														<xsl:if test="../../../@filterValue = @value">
															<xsl:attribute name="selected">
																selected
															</xsl:attribute>
														</xsl:if>
														<xsl:value-of select="@value"/>
													</option>
												</xsl:for-each>
											</select>
										</xsl:when-->
										<xsl:otherwise>
											<script>
												sCondition 	= "<xsl:value-of select="@condition"/>";
												oSelect		= $("rs_searchParam_<xsl:value-of select="@name"/>_condition");
												if(sCondition == "!=") {
													oSelect.value = "!=";
												}
												else {
													oSelect.value = "=";
												}
											</script>
											<input type="text" id="rs_searchParam_{@name}" name="rs_searchParam_{@name}" value="{@filterValue}" onchange="/*this.value = this.value.toLowerCase()*/"/>
											
										</xsl:otherwise>
									</xsl:choose>										
								</td>							
							</tr>
						</xsl:when>
					</xsl:choose>
				</xsl:for-each>
				<tr>
					<td colspan="4">
						<input type="button" onClick="RS_Search('search')" value="{$ROOT_RS_FIND}"/>
						<!-- <input type="button" onClick="RS_Search('reset')" value="Сбросить"/>  -->
					</td>
				</tr>
			</table>
		</form>
		<script>
		$('RS_FilterForm').onkeydown = function(e)
		{
			e = (!e) ? window.event : e;
			if (e.keyCode == 13) {
				RS_Search('search');
			}
			
		};

		</script>
					</div>
				</div>
			</div>
			<div class="rsPopupPanelBottomLayout">
				<div class="rsPopupPanelBottomRight">
					<div class="rsPopupPanelBottomCenter">
						<div class="rsPopupPanelBottom"/>
					</div>
				</div>
			</div>
		</div>
		
		<script>
			var actions = new Array(
				<xsl:for-each select="recordset/titles/title">
					<xsl:choose>
						<xsl:when test="@filter = 1">

							<xsl:if test="position() != 1">
								<xsl:text>,</xsl:text>
							</xsl:if>

							<xsl:text>{</xsl:text>
								<xsl:text>position :  </xsl:text><xsl:value-of select="position()"/>,
								<xsl:text>title : "</xsl:text><xsl:value-of select="@title"/><xsl:text>"</xsl:text>,
								<xsl:text>isMulti : "</xsl:text><xsl:value-of select="@isMulti"/><xsl:text>"</xsl:text>,
								<xsl:text>type : "</xsl:text><xsl:value-of select="@type"/><xsl:text>"</xsl:text>,
								<xsl:text>enable:</xsl:text><xsl:value-of select="@filterEnable"/>,
								<xsl:text>name:"</xsl:text><xsl:value-of select="@name"/><xsl:text>"</xsl:text>
							<xsl:text>}</xsl:text>


						</xsl:when>
						<xsl:otherwise>
							<xsl:if test="position() != 1">
								<xsl:text>,</xsl:text>
							</xsl:if>
							<xsl:text>{}</xsl:text>
						</xsl:otherwise>
					</xsl:choose>
				</xsl:for-each>
			);
		
			new RS_Filter({
				aActionList	: actions,
				isFilter	: <xsl:value-of select="recordset/titles/@isFilter"/>
			});
		</script>
		<script src="/modules/workflow/view/js/WF_DoctypeImport.js"></script>
		<div style="display:none;">
			<div id="import_login_layer" style="padding:5pt;">							
					<input id="import_ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
					<table cellpadding="5pt">
					<tr><td colspan="2" id="import_ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
					<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="import_ajax_password" type="password"/></td></tr>
					<tr><td colspan="2" align="right"><input id="import_ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
				</table>	
			</div>
		</div>
	</xsl:template>	
	
</xsl:stylesheet>