<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template name="recordsetTable">			
		
		<xsl:call-template name="rs_multiactions_top"/>
		<table id="RS_Records" class="rs-table">	
			<xsl:choose>
				<xsl:when test="count(/page/module/recordset/titles/title) > 0">
					<xsl:attribute name="style">width:100%;</xsl:attribute>
				</xsl:when>
			</xsl:choose>							
			<xsl:call-template name="rs_titles_without_group"/>
			<xsl:call-template name="rs_records_wihtout_group"/>
			<xsl:call-template name="rs_records_amount"/>		
		</table>
		
		<script>			
			var RS_RS	= new RS_RowSupply("RS_Records", "rs-cell-hightlight");				
		</script>
		
	</xsl:template>
	
	
	<xsl:template name="rs_multiactions_top">

	</xsl:template>	
	
	<xsl:template name="rs_multiactions_bottom">
		<table class="rs-bar" style="margin-top:10px;">
			<tr>
				<td class="rs-bar-multiaction">
					<xsl:choose>
						<xsl:when test="recordset/@isMultiaction = 1">
							<table cellpadding="0" cellspacing="0">
								<tr>
									<td><xsl:value-of select="$ROOT_RS_WITH_SELECTED"/>: &#160;</td>
									<xsl:if test="recordset/pagination/@totalRecords > 0">
										<xsl:for-each select="recordset/multiactions/action">
										<td>
											<img class="rs-bar-button" onClick="RS_SelectMultiAction('{@href}', {@confirm}, '{@question}')" src="{@image}" title="{@title}" alt="{@title}"/>
											<xsl:text> </xsl:text>
										</td>
										</xsl:for-each>
									</xsl:if>									
								
									<xsl:if test="recordset/@isGroup = 0">
										<td style="padding-left:5px;">
											<img src="/library/MSF_Recordset/resources/default/img/vertical_divider.png" />
										</td>								
										<td style="padding-left:5px;padding-right:5px;">											
											<xsl:value-of select="$RS_EXPORT_TO"/>
										</td>
										<td>																						
											<img onclick="doExportExcel()" style="margin-bottom:-2px; cursor: pointer;" src="/templates/default/images/export_excel.png"/>											
										</td>
										<td>
											<img id="export_progress" height="25" width="25" src="/templates/default/images/win/mini-ajax-loader.gif" style="display:none;"/>	
										</td>
										<script>
											function doExportExcel()
											{												
												if(typeof(iBusy) == "undefined" || iBusy == 0) {
													iBusy 					= 1;	
													oProgress 				= $("export_progress");
													oProgress.style.display	= "block";													
													new Ajax.Request("<xsl:value-of select="initPath"/>", {
															method 		: "post",
															onComplete 	: function(response) {
																if (200 == response.status) {
																	var aData = response.responseText.evalJSON().data;
																	oProgress.style.display	= "none";
																	window.location.href = "/main/exportDownload/?" + "link=" + aData.link + "&amp;ext=" + aData.ext + "&amp;name=" + aData.name;																
																	iBusy 					= 0;	
																}				
																else {
																	alert(response.status + "\n" + transport.responseText);
																}	
																											
															}
																	
														}
													
													);
													
													
												}
																																				
											}
										</script>
									</xsl:if>									
								</tr>
							</table>						

						</xsl:when>
					</xsl:choose>
				</td>
				<td style="text-align:right; color:#333333;padding-right:10px;">
				<xsl:value-of select="$ROOT_RS_TOTAL"/>: <xsl:value-of select="recordset/pagination/@totalRecords"/>
				</td>
			</tr>
		</table>		
	</xsl:template>	
		
	<xsl:template name="rs_titles_without_group">		
		<tr>
			<xsl:choose>
				<xsl:when test="recordset/@isMultiaction = 1">
					<th class="rs-cell-checkbox-title">
						<input type="checkbox" onClick="RS_SelectAllCheckbox(this.parentNode.parentNode.parentNode.parentNode, this)"/>
					</th>
				</xsl:when>
			</xsl:choose>
			<th class="rs-cell-context-title">
				<a href="{recordset/@baseUrl}">
					<img class="rs-cell-context-button" title="{$RS_RESET}" src="/templates/default/images/0document.png"/>
				</a>
			</th>
			<xsl:for-each select="recordset/titles/title">
				<th class="rs-title" onclick="window.location.href = this.firstChild.href">
					<xsl:choose>
						<xsl:when test="@sort = 1 and (@orderBy = 'asc' or @orderBy = 'desc')">
							<xsl:attribute name="style">background-color:#cccccc;</xsl:attribute>
						</xsl:when>
					</xsl:choose>
					<!-- 
					<xsl:choose>
						<xsl:when test="@type = 'string' or @type = 'text'">
							<xsl:attribute name="align">
								<xsl:text>left</xsl:text>
							</xsl:attribute>
						</xsl:when>
						<xsl:when test="@type = 'int' or @type = 'float'">
							<xsl:attribute name="align">
								<xsl:text>right</xsl:text>
							</xsl:attribute>
						</xsl:when>
						<xsl:otherwise>
							<xsl:attribute name="align">
								<xsl:text>center</xsl:text>
							</xsl:attribute>
						</xsl:otherwise>						
					</xsl:choose>
					 -->
					<!-- <xsl:value-of select="@title"/> -->					
					<xsl:choose>
						<xsl:when test="@sort = 1">
							<xsl:choose>
								<xsl:when test="@orderBy = 'none'">
									<a href="{../../@orderUrl}&amp;rs_orderBy={@name}&amp;rs_orderDirection=asc">
										<nobr>
											<xsl:value-of select="@title"/>
											&#160;										
											<img src="/templates/default/images/arrow_small.png" border="0"/>										
										</nobr>
									</a>
								</xsl:when>
								<xsl:when test="@orderBy = 'asc'">
									<a href="{../../@orderUrl}&amp;rs_orderBy={@name}&amp;rs_orderDirection=desc">
										<nobr>
											<xsl:value-of select="@title"/>
											&#160;
											<img src="/templates/default/images/arrow_small_down.png" border="0"/>
										</nobr>
									</a>
									
								</xsl:when>
								<xsl:when test="@orderBy = 'desc'">
									<a href="{../../@orderUrl}&amp;rs_orderBy={@name}&amp;rs_orderDirection=asc">
										<nobr>
											<xsl:value-of select="@title"/>
											&#160;
											<img src="/templates/default/images/arrow_small_up.png" border="0"/>
										</nobr>
									</a>
									
								</xsl:when>
							</xsl:choose>
							<xsl:text> </xsl:text>
						</xsl:when>
						<xsl:otherwise>
							<a href="#" style="cursor:default;">
								<xsl:value-of select="@title"/>
							</a>							
						</xsl:otherwise>
					</xsl:choose>
				</th>
			</xsl:for-each>
		</tr> 
	</xsl:template>

	
	<xsl:template name="rs_records_wihtout_group">
		<xsl:for-each select="recordset/records/item">
			<tr link="{link/@value}">
				<xsl:choose>
					<xsl:when test="../../@isMultiaction = 1">
						<td>
							<xsl:attribute name="class">
								<xsl:choose>
									<xsl:when test="columns/column/@mark = 1">
										rs-cell-checkbox-marked
									</xsl:when>
									<xsl:otherwise>
										rs-cell-checkbox
									</xsl:otherwise>
								</xsl:choose>							
							</xsl:attribute>							
							<input type="checkbox" onClick="RS_SelectACheckbox(this.parentNode.parentNode, this)" name="{../../multiactions/@field}[]" value="{@multiactionFiled}"/>
						</td>
					</xsl:when>
				</xsl:choose>
				<td class="rs-cell-context">
					<xsl:choose>
						<xsl:when test="link/@value">
							<xsl:attribute name="class">
								<xsl:choose>
									<xsl:when test="columns/column/@mark = 1">
										rs-cell-context-marked
									</xsl:when>
									<xsl:otherwise>
										rs-cell-context
									</xsl:otherwise>
								</xsl:choose>							
							</xsl:attribute>
							
							<img class="rs-cell-context-button" id="RS_recordsContextMenuButton_{position()}" src="/library/MSF_Recordset/resources/default/img/rs-context-active.png"/>				
							<div class="rs-cell-context-options" style="display:none;" id="RS_recordsContextMenuPanel_{position()}">						
								<xsl:for-each select="actions/action">
									<a class="rs-cell-context-option-open">
										<xsl:choose>
											<xsl:when test="@export = 1">
												<xsl:attribute name="onclick">
													RS_Href('<xsl:value-of select="@href"/>'); return false;
												</xsl:attribute>
											</xsl:when>
											<xsl:otherwise>
												<xsl:attribute name="href">
													<xsl:value-of select="@href"/>
												</xsl:attribute>
											</xsl:otherwise>
										</xsl:choose>
										<xsl:if test="@confirm = 1">
											<xsl:attribute name="onclick">
												RS_ShowConfirm('<xsl:value-of select="@href"/>',<xsl:value-of select="@confirm"/>,'<xsl:value-of select="@question"/>'); return false;
											</xsl:attribute>
										</xsl:if>
										<xsl:if test="@blank = 1">
											<xsl:attribute name="target">
												_blank
											</xsl:attribute>
										</xsl:if>
										<img src="{@image}" border="0"/>&#160;<xsl:value-of select="@title"/>
									</a>					
								</xsl:for-each>
							</div>
							<script>
								new RS_ContextMenu("RS_recordsContextMenuButton_<xsl:value-of select="position()"/>", "RS_recordsContextMenuPanel_<xsl:value-of select="position()"/>");							
							</script>			
						</xsl:when>
						<xsl:otherwise>
							<img src="/library/MSF_Recordset/resources/default/img/rs-context-active.png"/>
						</xsl:otherwise>
					</xsl:choose>
				</td>
				<xsl:for-each select="columns/column">
					<td>
						<xsl:choose>
							<xsl:when test="@type = 'string' or @type = 'text'">
								<xsl:attribute name="align">
									<xsl:text>left</xsl:text>
								</xsl:attribute>
							</xsl:when>
							<xsl:when test="@type = 'int' or @type = 'float'">
								<xsl:attribute name="align">
									<xsl:text>right</xsl:text>
								</xsl:attribute>
							</xsl:when>
							<xsl:otherwise>
								<xsl:attribute name="align">
									<xsl:text>center</xsl:text>
								</xsl:attribute>
							</xsl:otherwise>						
						</xsl:choose>
						<xsl:attribute name="class">
							<xsl:choose>
								<xsl:when test="@mark = 1">
									rs-cell rs-cell-marked
								</xsl:when>
								<xsl:otherwise>
									rs-cell
								</xsl:otherwise>
							</xsl:choose>							
						</xsl:attribute>
						<xsl:choose>
							<xsl:when test="@color = '#000'">
								<xsl:value-of select="@value" disable-output-escaping="yes"/>
							</xsl:when>
							<xsl:otherwise>
								<font color="{@color}">
									<xsl:value-of select="@value" disable-output-escaping="yes"/>
								</font>
							</xsl:otherwise>
						</xsl:choose>
						<xsl:if test="@value = ''">
							&#160;
						</xsl:if>															
					</td>
				</xsl:for-each>
			</tr>
		</xsl:for-each>
	</xsl:template>
	
	<xsl:template name="rs_records_amount">
		<xsl:if test="count(recordset/records/item) > 1 and recordset/@columnSumStatus = 1">
			<tr id="sum_cont_{recordset/groups/@groupIdentity}" class="footer">
				<xsl:if test="recordset/@isMultiaction = 1">
					<th colspan="2"><xsl:value-of select="$ROOT_RS_IN_TOTAL"/>: </th>
				</xsl:if>
				<xsl:if test="recordset/@isMultiaction != 1">
					<th><xsl:value-of select="$ROOT_RS_IN_TOTAL"/>: </th>
				</xsl:if>
				<xsl:for-each select="/page/module/recordset/titles/title">
					<th align="right" style="height:17pt; background: #f5f5f5;">
						<nobr><xsl:value-of select='@columnSum'/></nobr>
					</th>
				</xsl:for-each>	
			</tr>
		</xsl:if>
	</xsl:template>	
</xsl:stylesheet>
