<?php
require_once 'MSF_Iterator.php';

class MSF_Collection
{
	private $collection = array();

	private $size		= 0;

	private $Iterator	= null;

	public function __construct()
	{
		$this->Iterator = new MSF_Iterator($this->collection, $this->size);
	}

	public function equals(MSF_Collection $c)
	{
		return ($this->collection == $c->toArray());
	}

	public function toArray()
	{
		return $this->collection;
	}

	public function add($item)
	{
		if (MSF_Iterator::acceptedType($item)) {
			array_push($this->collection, $item);
			$this->size++;
		}
		else {
			throw new MSF_UtilsException('MSF_Iterator::set(' . type_of($item) . ') argument not allowed.');
		}

	}

	public function addAll(MSF_Collection $c)
	{
		$this->updateCollection(array_merge($this->collection, $c->toArray()));
	}

	public function containsAll(MSF_Collection $c)
	{
		$b = true;
		$a = $c->toArray();
		foreach ($a AS $item)
			if (!$this->contains($item))
				$b = false;
		return $b;
	}

	public function retainAll(MSF_Collection $c)
	{
		$b		= false;
		$res	= array();
		foreach ($this->collection AS $item)
			if ($c->contains($item))
				array_push($res, $item);
			else
				$b = true;
		$this->updateCollection($res);
		return $b;
	}

	public function removeAll(MSF_Collection $c)
	{
		$b		= false;
		$res	= array();
		foreach ($this->collection AS $item)
			if (!$c->contains($item))
				array_push($res, $item);
			else
				$b = true;
		$this->updateCollection($res);
		return $b;
	}

	private function updateCollection($newCollection)
	{
		$this->collection	= $newCollection;
		$this->size			= count($this->collection);
	}
	public function clear()
	{
		$this->collection = array();
		$this->size = 0;
	}

	public function contains($item)
	{
		return in_array($item, $this->collection);
	}

	public function isEmpty()
	{
		return empty($this->collection);
	}

	public function iterator()
	{
		return $this->Iterator;
	}

	public function remove($item)
	{
		$res	= array();
		$b 		= false;
		for ($i = 0; $i < $this->size; $i++)
			if ($this->collection[$i] == $item)
				$b = true;
			else
				array_push($res, $this->collection[$i]);
		$this->updateCollection($res);
		return $b;
	}

	public function size()
	{
		return $this->size;
	}

}
?>