<?php

class MSF_Iterator
{
	private $collection 	= array();

	private $currentIndex 	= -1;

	private $size 			= 0;

	private $asc			= true;

	public function __construct(&$collection = null, &$size = null)
	{
		if (!is_null($this->collection) && !is_null($this->size)) {
			$this->collection	=& $collection;
			$this->size 		=&  $size;
		}
	}

	public function add($item)
	{
		array_push($this->collection, $item);
		$thos->size++;
	}

	public function hasNext()
	{
		$this->asc = true;
		$b = ($this->currentIndex < ($this->size - 1));
		if (!$b)
			$this->setMaxIndex();
		return $b;
	}

	public function hasPrevious()
	{
		$this->asc = false;
		$b = ($this->currentIndex > 0);
		if (!$b)
			$this->setMinIndex();
		return $b;
	}

	private function setMinIndex()
	{
		$this->currentIndex = -1;
	}

	private function setMaxIndex()
	{
		$this->currentIndex = $this->size;
	}

	public function next()
	{
		$this->currentIndex++;
		return $this->collection[$this->currentIndex];
	}

	public function nextIndex()
	{
		return $this->currentIndex + 1;
	}

	public function previous()
	{
		$this->currentIndex--;
		return $this->collection[$this->currentIndex];
	}

	public function previousIndex()
	{
		return $this->currentIndex - 1;
	}

	public function set($item)
	{
		if ($this->acceptedType($item))
			$this->collection[$this->currentIndex] = $item;
		else
			throw new MSF_UtilsException('MSF_Iterator::set(' . typeOf($item) . ') argument not allowed.');

	}

	public static function acceptedType($item)
	{
		return (is_object($item) || is_array($item));
	}

	/**
	 * todo направления
	 */
	public function remove()
	{
		$b 		= false;
		$res	= array();
		for ($i = 0; $i < $this->size; $i++)
			if ($i == $this->currentIndex)
				$b = true;
			else
				array_push($res, $this->collection[$i]);
		if ($b)
			$this->size--;
		$this->collection = $res;
		if ($this->asc)
			$this->currentIndex--;
		else
			$this->currentIndex++;
		return $b;
	}

	public function reset()
	{
		$this->currentIndex	= -1;
	}

}

class MSF_UtilsException extends Exception
{
	public function __construct($msg)
	{
		parent::__construct($msg);
	}

}
?>
