<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "modules/media/library/MD_Utils.php";
include_once "modules/workflow/library/folders/WF_FolderGroupDB.php";
include_once "modules/workflow/library/folders/WF_FolderGroup.php";
include_once "modules/workflow/library/folders/WF_FoldersGroupsList.php";

class MSF_RteObjectsIntegrator
{
	public static function files($iId, $sName)
	{
		MSF_Registry::get("MSF_Template")->getModule()->setAttribute("extra_id", $iId);
		MSF_Registry::get("MSF_Template")->getModule()->setAttribute("extra_name", $sName);
		MD_Utils::appendFilesToModule($sName, $iId);
	}
	
	public static function documents()
	{
		$Template 	= MSF_Registry::get("MSF_Template");
		$ElmFolders = $Template->createElement("folders");
		
		self::getFoldersGroups($ElmFolders, $Template);
		self::getFoldersGroupsList($ElmFolders, $Template);
		
		$Template->getModule()->appendChild($ElmFolders);
	}
	
	public static function getFolders()
	{
		$aResult = array('unsorted' => array(), 'sorted' => array());
		
		$Folders = new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));
		$Folders->load(0);
		
		$aResult['unsorted'] = $Folders->getFolders();
		
		$List 	= new WF_FoldersGroupsList();
		$aList 	= $List->getList();
		
		for ($i = 0; $i < sizeof($aList); $i++) {
			$Folders = new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));
			$Folders->load($aList[$i]["group_id"]);
			$aResult["sorted"][$i]["group_id"] 	= $aList[$i]["group_id"];
			$aResult["sorted"][$i]["name"] 		= $aList[$i]["name"];
			$aResult["sorted"][$i]["elements"] 	= $Folders->getFolders();
		}
		
		return $aResult;
	}
	
	private static function getFoldersGroups($Element, $Template)
	{
		$Folders = new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));
		$Folders->load(0);
		$aFolders = $Folders->getFolders();
		
		for ($i = 0; $i < sizeof($aFolders); $i++) {
			$Item = $Template->createElement("item");
			$Item->setAttribute("type", "folder");
			$Item->setAttribute("id", $aFolders[$i]["folder_id"]);
			$Item->setAttribute("title", $aFolders[$i]["name"]);
			$Element->appendChild($Item);
		}
	}
	
	private static function getFoldersGroupsList($Element, $Template)
	{
		$List 	= new WF_FoldersGroupsList();
		$aList 	= $List->getList();
		
		for ($i = 0; $i < sizeof($aList); $i++) {
			$Item = $Template->createElement("item");
			$Item->setAttribute("type", "group");
			$Item->setAttribute("id", $aList[$i]["group_id"]);
			$Item->setAttribute("title", $aList[$i]["name"]);
			
			$Folders = new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));
			$Folders->load($aList[$i]["group_id"]);
			$aFolders = $Folders->getFolders();
			
			for ($j = 0; $j < sizeof($aFolders); $j++) {
				$ItemFolder = $Template->createElement("item");
				$ItemFolder->setAttribute("type", "folder");
				$ItemFolder->setAttribute("id", $aFolders[$j]["folder_id"]);
				$ItemFolder->setAttribute("title", $aFolders[$j]["name"]);
				$Item->appendChild($ItemFolder);
			}
			
			$Element->appendChild($Item);
		}
	}
}

?>