<?php
/*
 * Created on 26.10.2007
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */
include_once "WF_ITemplate.php";
include_once "WF_TemplateNotValidException.php";
include_once CNF_ABS_PATH . "/modules/references/library/Reference/UserReference.php";

/**
 * TODO Rename TemplateException to TemplateNotValidException
 */
class WF_Template implements WF_ITemplate
{
	private $Doc 		= null;

	private $sXml		= "";

	private $bSafe		= true;

	public function __construct($sTemplateXML, $bSafe = false)
	// throws WF_TemplateNotValidException
	{
		//
		$bSafe 			= true; // stub, because no DTD
		$this->sXml		= $sTemplateXML;
		$this->bSafe	= $bSafe;
		$this->init();

	}

	public function init()
	{
		$this->Doc 	= new DOMDocument(self::XML_VERSION, self::XML_ENCODING);
		if ($this->bSafe) {
			$this->Doc->loadXML($this->sXml);
		}
		else {
			$this->Doc->loadXML($this->prepareXml());
			$this->validate();
		}

		$i = 0;
		foreach ($this->Doc->getElementsByTagName("msfField") AS $MsfField) {
			if ($MsfField->getElementsByTagName('msfTitle')->item(0)->hasAttribute("name")) {
				continue;
			}

			$MsfTitle 	= $MsfField->getElementsByTagName('msfTitle')->item(0);
			$MsfValue 	= $MsfField->getElementsByTagName('msfValue')->item(0);

			$sTitle 	= $MsfTitle->getAttribute("title");
			$sName		= substr(md5(++$i . $sTitle), 0, 10);
			$MsfTitle->setAttribute("name", "n" . $sName);
			$MsfValue->setAttribute("name", "n" . $sName);
		}

	}

	private function getName($i, $sName)
	{
		return substr(md5(++$i . $sName), 0, 10);
	}

	public function getFields($aValues = array())
	{
		$aRes			= array();
		$NLMsfFields 	= $this->Doc->getElementsByTagName('msfField');
		$i=0;
		foreach ($NLMsfFields AS $ElmMsfFields) {
			$aRes[$i] = array
			(
				"name"	=> $ElmMsfFields->getElementsByTagName('msfValue')->item(0)->getAttribute("name"),
				"title" => $ElmMsfFields->getElementsByTagName('msfTitle')->item(0)->getAttribute("title"),
				"type"	=> $ElmMsfFields->getElementsByTagName('msfValue')->item(0)->getAttribute("type"),
				"value" => $ElmMsfFields->getElementsByTagName('msfValue')->item(0)->getAttribute("value")
			);

			if ($aRes[$i]["type"] == "reference") {
				$aRes[$i]["id"] = $ElmMsfFields->getElementsByTagName('msfValue')->item(0)->getAttribute("refId");
			}

			$i++;

		}

		if (!empty($aValues)) {
			for ($i = 0; $i < count($aRes); $i++) {
				if (array_key_exists($aRes[$i]["name"], $aValues)) {
					$aRes[$i]["value"] = $aValues[$aRes[$i]["name"]];
				}

			}

		}

		return $aRes;
	}

	public function getXml() {
		return $this->sXml;
	}

	public function getDom()
	{
		return $this->Doc;
	}

	public function getTableParams()
	{
		$aRes			= array();
		$NLMsfFields 	= $this->Doc->getElementsByTagName('msfField');
		$i				= 0;
		foreach ($NLMsfFields AS $ElmMsfFields) {
			$aRes[] = array
			(
				'name' => "n" . substr(md5(++$i . $ElmMsfFields->getElementsByTagName('msfTitle')->item(0)->getAttribute('title')), 0, 10),
				'type'	=> $this->fieldTypeXmlToSql($ElmMsfFields->getElementsByTagName('msfValue')->item(0)->getAttribute('type'))
			);

		}

		return $aRes;
	}

	private function fieldTypeXmlToSql($sXmlType)
	{
		switch ($sXmlType) {
			case "integer":
				$sSqlType = "INT(11)";
				break;
			case "date":
				$sSqlType = "INT(8)";
				break;
			case "string":
				$sSqlType = "VARCHAR(255)";
				break;
			case "reference":
				$sSqlType = "VARCHAR(255)";
				break;
			default:
				$sSqlType = "TEXT";
				break;
		}

		return $sSqlType;

	}

	private function commentDefinition($sXml)
	{
		$sXml = str_replace('<?', '<!--', $sXml);
		return str_replace('?>', '-->', $sXml);
	}

	public function getFormXml($bMode)
	{
		$NewDoc 	= new DOMDocument();
		$Parent 	= $NewDoc->createElement("div", "");
		$Parent 	= $NewDoc->appendChild($Parent);

		$Form		= $NewDoc->createElement("form", "");
		$Form->setAttribute("method", "POST");
		$Parent->appendChild($Form);


		$Root 	= $this->Doc->getElementsByTagName("template")->item(0)->childNodes;
		$this->cloneDoc($NewDoc, $Form, $Root, $bMode);
		// FALSE eq WF_Form::EDIT_MODE

		/*
		if (!$bMode) {
			$XslCallTemplate = $NewDoc->createElementNS("http://www.w3.org/1999/XSL/Transform", "call-template", "");
			$XslCallTemplate->setAttribute("name", "edit_controls");
			$Form->appendChild($XslCallTemplate);
		}
		*/
		// shows cloned tree
		/*
		debug(
			htmlspecialchars($this->Doc->saveXML()),
			htmlspecialchars($NewDoc->saveXML())
			);
		*/
		return $this->commentDefinition($NewDoc->saveXML());
	}

	private function cloneDoc($NewDoc, $NewParent, $Parent, $bIsView = true)
	{
		switch (true) {
			case $Parent instanceof DOMTextNode:
				$TextNode = $NewDoc->createTextNode($Parent->nodeValue);
				$NewParent->appendChild($TextNode);
				break;

			case $Parent instanceof DOMNodeList:
				foreach ($Parent AS $Child) {
					$this->cloneDoc($NewDoc, $NewParent, $Child, $bIsView);
				}

				break;

			case $Parent instanceof DOMElement:
				switch ($Parent->tagName) {
					case "msfField":
						$this->cloneDoc($NewDoc, $NewParent, $Parent->childNodes, $bIsView);
						break;

					case "msfTitle":
						$XslValueOf = $NewDoc->createElementNS("http://www.w3.org/1999/XSL/Transform", "value-of", "");
						$XslValueOf->setAttribute("select", "field[@name='" . $Parent->getAttribute("name") . "']/@title");
						$NewParent->appendChild($XslValueOf);
						break;

					case "msfValue":
						if ($bIsView) {
							switch ($Parent->getAttribute("type")) {
								default:
									$XslValueOf = $NewDoc->createElementNS("http://www.w3.org/1999/XSL/Transform", "value-of", "");
									$XslValueOf->setAttribute("select", "field[@name='" . $Parent->getAttribute("name") . "']");
									$XslValueOf->setAttribute("disable-output-escaping", "yes");
									$NewParent->appendChild($XslValueOf);
									break;
							}

						}
						else {
							//
							switch ($Parent->getAttribute("type")) {
								//
								case "integer":
									$Elm = $NewDoc->createElement("input", "");
									$Elm->setAttribute("name", $Parent->getAttribute("name"));
									$Elm->setAttribute("class", "wf_input");
									$Elm->setAttribute("value", "{field[@name='" . $Parent->getAttribute("name") . "']}");
									break;
								case "date":
									$Elm = $NewDoc->createElement("input", "");
									$Elm->setAttribute("class", "wf_input");
									$Elm->setAttribute("name", $Parent->getAttribute("name"));
									$Elm->setAttribute("value", "{field[@name='" . $Parent->getAttribute("name") . "']}");
									break;
								//
								case "string":
									$Elm = $NewDoc->createElement("input", "");
									$Elm->setAttribute("class", "wf_input");
									$Elm->setAttribute("name", $Parent->getAttribute("name"));
									$Elm->setAttribute("value", "{field[@name='" . $Parent->getAttribute("name") . "']}");
									break;
								//
								case "text":

									$Elm = $NewDoc->createElement("textarea", "");
									$Elm->setAttribute("class", "wf_textarea");
									$Elm->setAttribute("name", $Parent->getAttribute("name"));
									$XslValueOf = $NewDoc->createElementNS("http://www.w3.org/1999/XSL/Transform", "value-of", "");
									$XslValueOf->setAttribute("select", "document/field[@name='" . $Parent->getAttribute("name") . "']");
									$Elm->appendChild($XslValueOf);
									/*
									$Elm = $NewDoc->createElement("div", "");
									$Elm->setAttribute("id", "i" . $Parent->getAttribute("name"));
									$Elm->setAttribute("style", "display:none;");
									$XslValueOf = $NewDoc->createElementNS("http://www.w3.org/1999/XSL/Transform", "value-of", "");
									$XslValueOf->setAttribute("select", "field[@name='" . $Parent->getAttribute("name") . "']");
									$XslValueOf->setAttribute("disable-output-escaping", "yes");
									$Elm->appendChild($XslValueOf);
									$Script = $NewDoc->createElement("script", "var xiEditor = new xiEditor(); xiEditor.load('".$Parent->getAttribute("name")."','i".$Parent->getAttribute("name")."');");
									*/
									break;
								//
								case "reference":
									$Elm = $NewDoc->createElement("div", "");
									$Elm->setAttribute("id", "container_ref_" . $Parent->getAttribute("name"));
									//implode(", ", $Parent->getAttribute("value"))
									$Script = $NewDoc->createElement("script",
											"new ReferencePlaceholder({
												sContainerId 	: '" . "container_ref_" . $Parent->getAttribute("name") . "',
												iRefId			: "  . $Parent->getAttribute("refId") . ",
												sInputName 		: '" . $Parent->getAttribute("name") . "',
												select			: {" . $Parent->getAttribute("select") . "},
												multiselect 	: "  . $Parent->getAttribute("multiselect") . ",
												byId 			: "  . $Parent->getAttribute("byId") . ",
												type 			: '" . $Parent->getAttribute("refType") . "',
												defaultId       : ["
												);
									$XslValueOf = $NewDoc->createElementNS("http://www.w3.org/1999/XSL/Transform", "value-of", "");
									$XslValueOf->setAttribute("select", "field[@name='" . $Parent->getAttribute("name") . "']");
									$XslValueOf->setAttribute("disable-output-escaping", "yes");
									$Script->appendChild($XslValueOf);
									$Script->appendChild($NewDoc->createTextNode("]});"));
									break;
								//
								case "linked-reference":
									$Elm = $NewDoc->createElement("div", "");
									$Elm->setAttribute("id", "container_ref_" . $Parent->getAttribute("name"));

									$Script = $NewDoc->createElement("script",
											"new ReferencePlaceholder({
												sContainerId 	: '" . "container_ref_" . $Parent->getAttribute("name") . "',
												iRefId			: ");

									$XslValueOf = $NewDoc->createElementNS("http://www.w3.org/1999/XSL/Transform", "value-of", "");
									$XslValueOf->setAttribute("select", "field[@name='" . $Parent->getAttribute("name") . "']/@reference_id");
									$XslValueOf->setAttribute("disable-output-escaping", "yes");
									$Script->appendChild($XslValueOf);

									$Script->appendChild(
												$NewDoc->createTextNode (
													",
													sInputName 		: '" . $Parent->getAttribute("name") . "',
													select			: {\"id\":true, \""
													)
												);

									$XslValueOf = $NewDoc->createElementNS("http://www.w3.org/1999/XSL/Transform", "value-of", "");
									$XslValueOf->setAttribute("select", "field[@name='" . $Parent->getAttribute("name") . "']/@column");
									$XslValueOf->setAttribute("disable-output-escaping", "yes");
									$Script->appendChild($XslValueOf);

									$Script->appendChild(
												$NewDoc->createTextNode (
													"\":true},
													multiselect 	: false,
													byId 			: true,
													defaultId       : [")
												);
									$XslValueOf = $NewDoc->createElementNS("http://www.w3.org/1999/XSL/Transform", "value-of", "");
									$XslValueOf->setAttribute("select", "field[@name='" . $Parent->getAttribute("name") . "']");
									$XslValueOf->setAttribute("disable-output-escaping", "yes");
									$Script->appendChild($XslValueOf);
									$Script->appendChild($NewDoc->createTextNode("]});"));
									break;
								default:
									$Elm = $NewDoc->createTextNode(
										"[NOT_HANDLED " .
										"name=\"" .	$Parent->getAttribute("name")."\" " .
										"type=\"" .	$Parent->getAttribute("type")."\"]" .
										$Parent->getAttribute("value") .
										"[/NOT_HANDLED]");
									break;

							}

							$NewParent->appendChild($Elm);
							if (isset($Script)) {
								$NewParent->appendChild($Script);
							}
						}

						break;

					default:
						$Elm = $NewDoc->createElement($Parent->tagName, "");
						foreach ($Parent->attributes AS $attr) {
							$Elm->setAttribute($attr->nodeName, $attr->nodeValue);
						}

						$NewParent->appendChild($Elm);
						$this->cloneDoc($NewDoc, $Elm, $Parent->childNodes, $bIsView);
						break;

				}

				break;

		}

		return $NewDoc;
	}

	private function prepareXml()
	{
		$sDtdSystem = "http://" . MSF_HOST . ':' . MSF_PORT . self::DTD_SYSTEM;
		$sDtd 		= "<!DOCTYPE template PUBLIC \"" . self::DTD_PUBLIC . "\" \"" . $sDtdSystem . "\">";
		return $sDtd . "\n" .  $this->sXml;
	}

	private function validate()
	// throws WF_TemplateNotValidException
	{
		try {
			if (!$this->Doc->validate()) {
				throw new WF_TemplateNotValidException("Template not valid");
			}

		}
		catch (Exception $E) {
			throw new WF_TemplateNotValidException($E->getMessage());
		}

	}

}
?>
