<?php

class V81_Base64FilesSaver {
	
	public function saveBase64Files($iUserId, $sFilesContent)
	{
		$aFiles = explode("^file^", $sFilesContent);		
		$oMedia	= new MD_Media(new MD_MediaDB(MSF_Registry::get("MSF_DB")));
		$oMedia->setUploadDirectory(CNM_MEDIA_UPLOAD_DIRECTORY);
		$oMedia->setMaxFileSize(CNM_MEDIA_MAX_FILE_SIZE);
		$sResult = "";		
		for($i = 0; $i < count($aFiles); $i++) {
			$aFile = explode("^name^", $aFiles[$i]);
			$sDir	   = date("d.m.Y");
			$sFullPath = $oMedia->getUploadDirectory() . "/" . $sDir;							
			if(!MSF_Dir::exists($sFullPath)) {
				MSF_Dir::create($sFullPath);
			}
			
			$sFullPath	= $sFullPath . "/" . date("H");		
			if(!MSF_Dir::exists($sFullPath)) {
				MSF_Dir::create($sFullPath);
			}
			
			$sFullPath	= $sFullPath . "/" . MSF_String::random(10);
			MSF_Dir::create($sFullPath);							
			$sNewName	= $aFile[0];
			$sNewFile	= $sFullPath . "/" . $sNewName;
			$sModule	= "workflow_document";													
			$sContent 	= base64_decode($aFile[1]);
			MSF_File::write($sNewFile, $sContent, "w", 0777);													
			$sFSize = filesize($sNewFile);
			$sFType = "";
			$sExt = array_pop(explode('.',$sNewName)); 							
			foreach (file(CNF_MIME_TYPES_LIST) as $sLine){
			  if (preg_match('/^([^#]\S+)\s+.*'.$sExt.'.*$/', $sLine, $aType)){
			  	$sFType = $aType[1];
			  }
			}
	
			if($sFType == "") {
				$sFType = 'application/octet-stream';
			}						
			
			$oDB = $oMedia->getDB();
			$iFileId	= $oDB->upload(
				$sNewName,
				$sFullPath,
				md5_file($sNewFile),
				sha1_file($sNewFile),
				$sModule,
				$iUserId,
				$sFType,
				$sFSize
				);
				
			if($i > 0) {
				$sResult .= ",".$iFileId;														
			}
			else {
				$sResult .= $iFileId;
			}
		}
				
		return $sResult;
	}
}
?>