<?php

include_once "modules/1cv81/library/V81_ExchangerDB.php";
include_once "cs/library/AtomUtil.php";

class V81_Exchanger {
	
	private $oDb		= null;
	
	public function save($aData)
	{	
		$oXMLWrapper = new MSF_XmlWrapper;
		$DBRecord	 = new V81_ExchangerDB("v81_comparison", 0);
		$DBAtom		 = new V81_ExchangerDB("cs_atoms", 0);
		$oDb		 = MSF_Registry::get("MSF_DB");		
		$Utl 		 = new AtomUtil($oDb);
		$sContent  	 = MSF_File::read('settings.xml');
		$oSettings 	 = MSF_Settings::getInstance($sContent);
		MSF_Registry::set("MSF_Settings", $oSettings);
		$aSettings 	 = MSF_Registry::get("MSF_Settings")->getModule("1cv81");
		$wsdlUrl 	 = $aSettings["settings"]["wsdl_url"];
		$sLogin		 = $aSettings["settings"]["accesslogin"];
		$sPassword	 = $aSettings["settings"]["accesspassword"];
		$aPreData 	 = $DBRecord->find('*','true',array());
		$NewData  	 = array();		
		
		// Преобразование массива
		array_pop($aData);
		$iNum = 0;
		foreach($aData AS $Value) {		
			$NewData[$iNum]["ref_v81"]   = $Value["ref_v81"];
			$NewData[$iNum]["ref_doc"]   = $Value["ref_doc"];
			$NewData[$iNum]["direction"] = $Value["direction"];
			$NewData[$iNum]["new"]       = $Value["new"];
			$NewData[$iNum]["edit"]      = $Value["edit"];
			$NewData[$iNum]["delete"]    = $Value["delete"];			
			$NewData[$iNum]["frequency"] = $Value["before_minuts"]*60 +
				$Value["before_hours"]*3600 + $Value["before_days"]*86400;

			
			for($j = 0; $j < 9; $j++) {
				array_shift($Value);
			}
			
			$NewData[$iNum]["fields"] = array();
			foreach($Value AS $sKey => $sValue) {
				$NewData[$iNum]["fields"][$sKey] = $sValue;
			}			
			
			$iNum++;
		}

		for($i = 0; $i < count($aPreData); $i++) {
			$bInData = false;
			for($j = 0; $j < count($NewData); $j++) {
				if($aPreData[$i]["ref_v81_name"] == $NewData[$j]["ref_v81"] &&
					$aPreData[$i]["ref_doc_name"] == $NewData[$j]["ref_doc"]) {
						$bInData = true;
						break;
					}
					
			}
						
			if(!$bInData) {				
				$DBRecord->remove("ref_v81_name = '".$aPreData[$i]["ref_v81_name"].
				"'". " AND ref_doc_name = '".$aPreData[$i]["ref_doc_name"]."'");
			}
			
		}
		
		// Удаление всех записей, касающихся синхронизации, из таблицы cs_atoms
		$DBAtom->remove("atom_type = 'synchronize' OR atom_type = 'synchronizemsf'");
		
		for($i = 0; $i < count($NewData); $i++) {			
			$aFields = $NewData[$i]["fields"];			
			foreach($aFields AS $Key => $Value) {
				$oXMLWrapper->set($Key, $Value);
			}
					
			$sXML	= $oXMLWrapper->getXml();

			if(!$DBRecord->findComparison($NewData[$i]["ref_v81"], $NewData[$i]["ref_doc"])) {
				$DBRecord->insert(array("ref_v81_name" => $NewData[$i]["ref_v81"],
				 "ref_doc_name" => $NewData[$i]["ref_doc"],
				 "direction" => $NewData[$i]["direction"],
				 "is_new" => $NewData[$i]["new"],
				 "is_edit" => $NewData[$i]["edit"],
				 "is_delete" => $NewData[$i]["delete"],
				 "frequency" => $NewData[$i]["frequency"],
				 "compared_xml" => $sXML));				
			}

			else {
				$DBRecord->update(array("ref_v81_name" => $NewData[$i]["ref_v81"],
				 "ref_doc_name" => $NewData[$i]["ref_doc"],
				 "direction" => $NewData[$i]["direction"],
				 "is_new" => $NewData[$i]["new"],
				 "is_edit" => $NewData[$i]["edit"],
				 "is_delete" => $NewData[$i]["delete"],
				 "frequency" => $NewData[$i]["frequency"],
				 "compared_xml" => $sXML),
				 "ref_v81_name = '".$NewData[$i]["ref_v81"]."'".
				 " AND ref_doc_name = '".$NewData[$i]["ref_doc"]."'",
				 array());
			}			
			
			$oXMLWrapper->clear();
			
			// Сохранение параметров в таблицу cs_atoms
			$aParams = array();			
			if($NewData[$i]["direction"] == "1C") {
				$atomType = "synchronize";
				$sPeriod  = "20000101010101";													
			}
			else {
				$atomType 		  	 = "synchronizemsf";
				$sPeriod  		  	 = "2000-01-01 01:01:01";				
			}			
			
			$aParams["refname"] 	 = $NewData[$i]["ref_doc"];
			$aParams["wsdl"]		 = $wsdlUrl;
			$aParams["period"]		 = $sPeriod;
			$aParams["login"] 	 	 = $sLogin;
			$aParams["password"] 	 = $sPassword;
			$aParams["timeout1"]	 = $NewData[$i]["frequency"];			
			
			$Utl->save(
			$atomType,
			0,
			$aParams,
			0,
			0,			
			0,
			"---");
			
		}
		
		
		
				
				
	}
	
	public function load()
	{
		$oXMLWrapper  = new MSF_XmlWrapper;
		$DBRecord	  = new V81_ExchangerDB('v81_comparison', 0);
		$aQueryResult = $DBRecord->find('*','true',array());		
		$aData 		  = array();
		for($i = 0; $i < count($aQueryResult); $i++) {
			$aData[$i]["ref_v81"] 		= $aQueryResult[$i]["ref_v81_name"];
			$aData[$i]["ref_doc"] 		= $aQueryResult[$i]["ref_doc_name"];
			$aData[$i]["direction"] 	= $aQueryResult[$i]["direction"];
			$aData[$i]["new"]			= $aQueryResult[$i]["is_new"];
			$aData[$i]["edit"]			= $aQueryResult[$i]["is_edit"];
			$aData[$i]["delete"]		= $aQueryResult[$i]["is_delete"];
			$iFrequency 				= $aQueryResult[$i]["frequency"];
			$iDay						= (int)($iFrequency / 86400);
			$iHour						= (int)(($iFrequency - $iDay * 86400) / 3600);
			$iMin						= (int)(($iFrequency - $iDay * 86400 - $iHour * 3600) / 60);
			$aData[$i]["before_days"]	= $iDay;
			$aData[$i]["before_hours"] 	= $iHour;
			$aData[$i]["before_minuts"]	= $iMin;						
			$aFields					= $oXMLWrapper->xmlToArray($aQueryResult[$i]["compared_xml"]);
			foreach ($aFields AS $Key => $Value) {
				$aData[$i]["fields"][$Key] = $Value["value"];
			}
			
		}	
		
		return $aData;
	}
	
	public static function test()
	{
		DEFINE('__MSF', true);
		DEFINE('CNF_ABS_PATH', 'D:/projects/msf.lcl/wwwroot');
		set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
			
		include_once "system/MSF_ThrowableException.php";
		include_once "system/utils/MSF_XmlWrapper.php";
		include_once "system/MSF_Locale.php";
		include_once "system/utils/MSF_DB.php";
		include_once "system/MSF_Registry.php";
		include_once "system/utils/MSF_DBRecord.php";
		include_once "modules/1cv81/library/V81_ExchangerDB.php";
		include_once "cs/library/AtomUtil.php";
		
		
		$oDb	= new MSF_DB();
		$oDb->connect('server', 'manuscript', 'detrix', '1', 'manuscript');
		MSF_Registry::set("MSF_DB", $oDb);
		MSF_Registry::set("MSF_Locale", new MSF_Locale('cs/languages/russian.ini'));		
		
		$aData = array();
		$aData[0]["ref_v81"] 	= "Номенклатура1";
		$aData[0]["ref_doc"] 	= "Номенклатура1";
		$aData[0]["direction"] 	= "1C->Doc";
		$aData[0]["is_new"]		= "";
		$aData[0]["is_edit"]		= true;
		$aData[0]["is_delete"]		= true;
		$aData[0]["frequency"] 	= 10;
		$aData[0]["fields"]["name_c2a49ca27c"] = "Код";
		$aData[0]["fields"]["name_bda10e01c6"] = "ЕдиницаИзмерения";
		$aData[0]["fields"]["name_c5dbb0ced2"] = "Наименование";		

		$oDb	= MSF_Registry::get("MSF_DB");		
		$Utl 	= new AtomUtil($oDb);
		
		$aParams = array(
			"refname" => "Номенклатура");
		
		$Utl->save(
			"synchronizate",
			0,
			$aParams,
			0,
			0,
			10,
			0,
			"---");
		
		//$oObj = new self;
		//$oObj->load();
			
	}
}
		
//V81_Exchanger::test();
?>