<?php

include_once "modules/references/library/ReferencesList/REF_ReferencesList.php";

class V81_RefList {
	
	const REF 		= "Справочник";
	
	const NAME 		= "ИмяСправочника";
	
	const FIELDS 	= "Поля";
	
	public function getFrom1C($sWsdlUrl, $sMethod)
	// throws Exception
	{	
		$aSettings 					= MSF_Registry::get("MSF_Settings")->getModule("1cv81");
		$sLogin 					= $aSettings["settings"]["accesslogin"];
		$sPassword  				= $aSettings["settings"]["accesspassword"];
		$client 					= new nusoap_client($sWsdlUrl, true);
		$client->setCredentials($sLogin, $sPassword, "basic");
		$client->decode_utf8 		= false;
		$client->soap_defencoding 	= "UTF-8";		
		$a1CResult 					= (array) $client->call($sMethod, array());
		$aHash						= array();
		if (!isset($a1CResult["return"])) {
			// logging
		}
		else if (!isset($a1CResult["return"][self::REF])) {
			// logging
		}
		else {
			$aRefList 		= $a1CResult["return"][self::REF];
			foreach ($aRefList AS $aRef) {
				$aHash[$aRef[self::NAME]] = $aRef[self::FIELDS];
			}
			
		}		
		
		return $aHash;		
	}
	
	public function getFromMSF()
	{
		$aRefList	  	  = new REF_ReferencesList(new REF_ReferencesListDB(MSF_Registry::get("MSF_DB")));
		$aRefAll	 	  = $aRefList->getList();		
		$aHash 		  	  = array();
		for($i = 0; $i < count($aRefAll); $i++)
		{
			$iId 		  = $aRefAll[$i]["reference_id"];
			$sKey		  = $aRefAll[$i]["name"];
			$oReference	  = new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
			$oReference->load($iId, array());
			$aFields 	  = $oReference->getFields();
			$aHash[$sKey] = array();						
			foreach($aFields AS $Value) {
				$aHash[$sKey][$Value["name"]] = $Value["title"];
			}	
					
		}			
		
		return $aHash;	
		
	}
	
	public static function test()
	{
		DEFINE('__MSF', true);
		DEFINE('CNF_ABS_PATH', 'D:/projects/msf.lcl/wwwroot');
		set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
		
		include_once "system/MSF_ThrowableException.php";
		include_once "system/utils/MSF_XmlWrapper.php";
		include_once "system/utils/MSF_SL.php";
		include_once 'system/utils/MSF_String.php';
		include_once "system/utils/MSF_DB.php";
		include_once "system/MSF_Locale.php";
		include_once "system/MSF_Registry.php";
		include_once "modules/workflow/library/doctype/WF_DoctypesList.php";
		include_once "modules/workflow/library/common/WF_Exception.php";
		include_once "modules/workflow/library/doctype/WF_Doctype.php";
		include_once "modules/references/library/ReferencesList/REF_ReferencesList.php";
		include_once CNF_ABS_PATH."/library/NuSoap/nusoap.php";
		$oDb 		= new MSF_DB();
		$oDb->connect('server', 'manuscript', 'detrix', '1', 'manuscript');
		MSF_Registry::set("MSF_DB", $oDb);
		MSF_Registry::set("MSF_Locale", new MSF_Locale('cs/languages/russian.ini'));
		$oObj = new self;
		$oObj->getFromMSF();
	}
}

//V81_RefList::test();
?>