<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

class V81_MenuService implements MSF_IService
{
	/**
	 * @var MSF_Menu
	 */
	private $oMenu;
	
	/**
	 * @var MSF_Locale
	 */
	private $oLocale;
	
	/**
	 * @var MSF_UserBox
	 */
	private $oUserBox; 

	public function __construct()
	{
		$this->oMenu 	= MSF_Registry::get("MSF_Menu");
		$this->oLocale	= MSF_Registry::get("MSF_Locale");
		$this->oUserBox = MSF_Registry::get("MSF_UserBox");
	}

	public function execute()
	{
		$aSettings 	 = MSF_Registry::get("MSF_Settings")->getModule("1cv81");		
		if ((int) $this->oUserBox->getUserAttribute("is_admin") == 1 && !empty($aSettings["settings"]["wsdl_url"])) {
			$this->oMenu->setItem("ref_admin", "v81_admin", $this->oLocale->getWord("V81_MENU_TITLE"), "/admin/1cv81", "image", "return false");
		}
	}
}

?>