
var Frame = Class.create();
Frame.prototype = { 

	initialize: function(iTable) {
		this.iTable = iTable;
	},				
	
	rebuild		: function () {
	   var oThis = this;
	   aComparedData.each(function(hash) {
			oThis.createTable();
			oThis.createHead(oTbody, hash['ref_v81']);
			oThis.rebuildBody(oTbody, hash, oMinimalize);
			oThis.iTable++;
		});
	},
	
	create 		: function () {
		this.createTable();
		this.createHead(oTbody);
		this.createBody(oTbody, oMinimalize);
		this.iTable++;
	},
	
	createTable : function () {
		oForm  			= $('references');
		oTable 			= new Element ("TABLE",  {"class":"newcompare-table", "cellspacing":"0"});
		oTbody			= new Element ("TBODY");					
		oTable.id 		= this.iTable;
		oTable.width 	= '900px';		
		oTable.insert(oTbody);									
		oForm.insert(oTable);
	},
	
	createHead : function (oTable, sRef_v81) {
		oHead					= new Element("TR", {"class":"field-main-title"});
		oHead.id				= 'head_'+this.iTable;							
		oTitle 					= new Element("TD");
		oTitle.width			= "700px";
		oNavigation 			= new Element("TD");
		oNavigation.width		= "30px";
		oNavigation.align		= "center";
		oMinimalize				= new Element("DIV", {"class":"field-main-controls-hidden"});
		oRemove					= new Element("DIV", {"class":"field-main-controls-remove"});
		oNavigation.insert(oMinimalize);
		oNavigation.insert(oRemove);
		
		if (sRef_v81) {
			oTitle.insert(sRef_v81);
		}
		else {
			oTitle.insert("Название справочника");
		}
		oHead.insert(oTitle);
		oHead.insert(oNavigation);
		oTable.insert(oHead);
	},
	
	createBody : function (oTable, oMinimalize) {		
		var oBody 		 = new Element("TR");
		oBody.show();
		oTitle.onclick				= function (){
			if (oBody.style.display == 'none') {
				oBody.show();
				oMinimalize.setAttribute('class', 'field-main-controls-visible');
			}
			else {
				oBody.hide();
				oMinimalize.setAttribute('class', 'field-main-controls-hidden');
			}
		},
		oMinimalize.setAttribute('class', 'field-main-controls-visible');
		oMinimalize.onclick			= function() {
			if (oBody.style.display == 'none') {
				oBody.show();
				oMinimalize.setAttribute('class', 'field-main-controls-visible');
			}
			else {
				oBody.hide();
				oMinimalize.setAttribute('class', 'field-main-controls-hidden');
			}
		};
		oContent		 	 = new Element("TD", {"colspan":"3"});		
		oOptionTable		 = new Element("TABLE", {"class":"field-table"});
		oOptionBody			 = new Element("TBODY");		
		oOptionTable.width	 = '100%';
		oOptionTable.insert(oOptionBody);
		oComparison		 	= new Element("TABLE", {"class":"field-table"});
		oCompBody			= new Element("TBODY");							
		oComparison.width 	= '100%';
		oComparison.insert(oCompBody);
		oReference 		 	 = new Reference(this.iTable);
		oReference.createBodyReferenceV81();
		oReference.createBodyReferenceMSF(oTbody, oSelectV81);
		oReference.createBodyDirection();
		oReference.createBodySynchronizationOptions();
		oReference.createBodyFrequency();		
		oContent.insert(oOptionTable);
		oBody.insert(oContent);		
		oTable.insert(oBody);
	},
	
	rebuildBody : function (oTable, aRebuilding, oMinimalize) {
		var oBody 		 = new Element("TR");
		oBody.hide();
		oTitle.onclick				= function (){
			if (oBody.style.display == 'none') {
				oBody.show();
				oMinimalize.setAttribute('class', 'field-main-controls-visible');
			}
			else {
				oBody.hide();
				oMinimalize.setAttribute('class', 'field-main-controls-hidden');
			}
		},
		oMinimalize.onclick			= function() {
			if (oBody.style.display == 'none') {
				oBody.show();							
				oMinimalize.setAttribute('class', 'field-main-controls-visible');
			}
			else {
				oBody.hide();
				oMinimalize.setAttribute('class', 'field-main-controls-hidden');
			}
		};
		oContent		 	= new Element("TD", {"colspan":"3"});		
		oOptionTable	 	= new Element("TABLE", {"class":"field-table"});
		oOptionBody			= new Element("TBODY");		
		oOptionTable.width 	= '100%';
		oOptionTable.insert(oOptionBody);
		oRebuild 		 	= new Rebuild(this.iTable);
		oRebuild.rebuildBodyReferenceV81(aRebuilding['ref_v81']);
		oRebuild.rebuildBodyReferenceMSF(aRebuilding['ref_doc'], oTbody, oSelectV81);
		oRebuild.rebuildBodyDirection(aRebuilding['direction']);
		oRebuild.rebuildBodySynchronizationOptions(aRebuilding['new'], 
												   aRebuilding['edit'], aRebuilding['delete']);
		oRebuild.rebuildBodyFrequency(aRebuilding['before_days'],
									  aRebuilding['before_hours'], aRebuilding['before_minuts']);

		oContent.insert(oOptionTable);
		
		if (aRebuilding) {
			oRebuild.rebuildComparison(aRebuilding['fields']);
		}
		oBody.insert(oContent);
		oTable.insert(oBody);
		WindowHandler.onLoad();
	}

};

var Reference = Class.create();
Reference.prototype = {

	initialize: function(iTable) {
		this.iTable = iTable;
	},
	
	createBodyReferenceMSF : function (oTable, oSelectV81) {		
		oMSF_TR				= new Element("TR");
		oNameMSF			= new Element("TD");
		oNameMSF.width 		= "100px";
		oNameMSF.insert(aGlobalMsfWords["V81_INTEGRATION_REFMSF"]);
		oMSF_TR.insert(oNameMSF);
		oValueMSF				= new Element("TD");
		oSelectMSF				= new Element("SELECT");
		oSelectMSF.id			= this.iTable + '[ref_doc]';
		oSelectMSF.name			= this.iTable + '[ref_doc]';
		i = 0;
		var oOption				= new Option('не выбран', '');
		oSelectMSF.options[i++] = oOption;
		aMsfRefList.each(function(hash) {
			if (aMsfRefExist.get(hash.key) == undefined) {
				var oOption				= new Option(hash.key, hash.key);
				oSelectMSF.options[i++] = oOption;
			}
		});
		oValueMSF.insert(oSelectMSF);
		
		oSelectMSF.onchange = function () {
			oCompBody.update();
			if ((oSelectV81.value != "") && (oSelectMSF.value != "") ) {				
				oReference.comparison();
				oContent.insert(oComparison);
			}
		}		
		
		oMSF_TR.insert(oValueMSF);		
		oOptionBody.insert(oMSF_TR);
		oRemove.onclick			= function() {
			aMsfRefExist.unset(oSelectMSF.value);
			aV81RefExist.unset(oSelectV81.value);
			oTable.remove();
		};
	},
	
	createBodyReferenceV81 : function () {
		oV81_TR					= new Element("TR");
		oNameV81				= new Element("TD");
		oNameV81.width 			= "100px";
		oNameV81.insert(aGlobalMsfWords["V81_INTEGRATION_RFFV81"]);
		oV81_TR.insert(oNameV81);
		oValueV81				= new Element("TD");
		oSelectV81				= new Element("SELECT");
		oSelectV81.name			= this.iTable + '[ref_v81]';
		i = 0;
		var oOption				= new Option('не выбран', '');
		oSelectV81.options[i++] 	= oOption;
		if (aV81RefList.get('code') != 4) {
			$H(aV81RefList.get('value')).each(function(hash) {
				if (aV81RefExist.get(hash.key) == undefined) {
					var oOption				= new Option(hash.key, hash.key);
					oSelectV81.options[i++] 	= oOption;
				}
			});
		}
		oValueV81.insert(oSelectV81);
		oSelectV81.onchange = function () {
			oTitle.update(oSelectV81.value);
			oCompBody.update();
			if ((oSelectV81.value != "") && (oSelectMSF.value != "")) {
				oReference.comparison();
				oContent.insert(oComparison);
			}
		}
		oV81_TR.insert(oValueV81);
		oOptionBody.insert(oV81_TR);
	},
	
	createBodyDirection : function () {
		oDirection					= new Element("TR");
		oNameDirection				= new Element("TD");
		oNameDirection.width 		= "100px";
		oNameDirection.insert('Направление');
		oDirection.insert(oNameDirection);
		oValueDirection				= new Element("TD");
		oSelectDirection			= new Element("SELECT");
		oSelectDirection.name		= this.iTable + '[direction]';
		var oOption					= new Option('Из 1С в Detrix', '1C');
		oSelectDirection.options[0] = oOption;
		var oOption					= new Option('Из Detrix в 1С', 'MSF');
		oSelectDirection.options[1] = oOption;
		oValueDirection.insert(oSelectDirection);
		oDirection.insert(oValueDirection);
		oOptionBody.insert(oDirection);
	},
	
	createBodySynchronizationOptions : function () {
		oTableTR		 = new Element("TR");
		oTableTD		 = new Element("TD", {"colspan":"3"});
		oFieldset		 = new Element("FIELDSET");		
		oTableTD.width   = '100%';
		oLegend			 = new Element("LEGEND");
		oLegend.insert(aGlobalMsfWords["V81_INTEGRATION_SYNCOPTIONS"]);
		oFieldset.insert(oLegend);
		oSynchTable	 = new Element("TABLE", {"class":"field-table"});
		oSynchBody	 = new Element("TBODY");		
		oSynchTable.insert(oSynchBody);
		sName			 = this.iTable;
		aSynchOptions		 = $H(
									{
										'new'  	 : aGlobalMsfWords["V81_INTEGRATION_NEWRECORDS"],
										'edit' 	 : aGlobalMsfWords["V81_INTEGRATION_EDITRECORDS"],
										'delete' : aGlobalMsfWords["V81_INTEGRATION_DELETERECORDS"]
									}
							  	 );
		aSynchOptions.each(function(hash) {
			oSynchTR			= new Element("TR");
			oSynchName			= new Element("TD");						
			oSynchName.insert(hash.value);
			oSynchTR.insert(oSynchName);
			oSynchOption		= new Element("TD");
			var oSynchYes			= new Element("INPUT");
			oSynchYes.type		= 'radio';
			oSynchYes.name		= sName + '[' + hash.key + ']';
			oSynchYes.value		= 'yes';
			oSynchOption.insert(oSynchYes);
			oSynchOption.insert('Да');
			var oSynchNo			= new Element("INPUT");
			oSynchNo.type		= 'radio';
			oSynchNo.name		= sName + '[' + hash.key + ']';
			oSynchNo.checked   	= 'true';
			oSynchNo.defaultChecked = 'true';
			oSynchNo.value		= 'no';
			oSynchOption.insert(oSynchNo);
			oSynchOption.insert('Нет');
			oSynchYes.onclick = function() {
				oSynchYes.checked   	 = true;
				oSynchYes.defaultChecked = true;
				oSynchNo.checked   		 = false;
				oSynchNo.defaultChecked  = false;	
			}
			oSynchNo.onclick = function() {								
				oSynchYes.checked   	 = false;
				oSynchYes.defaultChecked = false;
				oSynchNo.checked   		 = true;
				oSynchNo.defaultChecked  = true;					
			}
			
			oSynchTR.insert(oSynchOption);
			oSynchBody.insert(oSynchTR);
		});
		oFieldset.insert(oSynchTable);
		oTableTD.insert(oFieldset);
		oTableTR.insert(oTableTD);
		oOptionBody.insert(oTableTR);
	},
	
	createBodyFrequency : function () {
		oFrequency					= new Element("TR");
		oNameFrequency				= new Element("TD");
		oNameFrequency.width 		= "100px";
		oNameFrequency.insert(aGlobalMsfWords["V81_INTEGRATION_FREQUENCY"]);
		oFrequency.insert(oNameFrequency);
		oValueFrequency				= new Element("TD");
		
		
		
					// days
		var oInput 				= new Element('INPUT');
		oInput.name				= this.iTable + '[before_days]';
		oInput.value			= 0;
		oInput.style.width		= "20px";
		oInput.style.textAlign	= "right";
		oInput.maxLength		= "3";
		oValueFrequency.insert(oInput);
		oValueFrequency.insert(aGlobalMsfWords["WORKFLOW_REMIND_DAYS"]);
		oInput.onkeydown = function(e) {
			var e = (!e) ? window.event : e;
			if (e.keyCode ==9) {
				return true;
			}
			
			if (((e.keyCode >=96) && (e.keyCode <= 105)) || ((e.keyCode >=48) && (e.keyCode <= 57)) || (e.keyCode == 8) || (e.keyCode == 46)|| (e.keyCode == 37)|| (e.keyCode == 39)) {
				if (this.value.charAt(0) == '0') {	
					this.value = '';
				}
				
				return true;
			} else {
				oMe = this;
				oMe.style.backgroundColor = 'red';
				setTimeout(function() {oMe.style.backgroundColor = 'white'}, 500);
				return false;
			}
			
		};
		
		oInput.onchange = function(e) {
			this.value = parseInt(this.value);
			if (isNaN(this.value)) { 
				this.value = '';
			}
			
		};
		
		// hous
		var oSelect				= new Element('SELECT');
		oSelect.name			= this.iTable + '[before_hours]';
		for (var i = 0; i < 24; i++) {
			var oOption = new Option(((i < 10)? '0' + i: i), i);
			oSelect.options[i] = oOption;
		}
		oValueFrequency.insert(oSelect);
		oValueFrequency.insert(aGlobalMsfWords["WORKFLOW_REMIND_HOUR"]);
		
		// minuts
		var oSelect				= new Element('SELECT');
		oSelect.name			= this.iTable + '[before_minuts]';
		var j					= 0;
		for (var i = 0; i < 60; i = i+5) {
			var oOption = new Option(((i < 10)? '0' + i: i), i);
			oSelect.options[j] = oOption;
			j++;
		}
		
		oValueFrequency.insert(oSelect);
		oValueFrequency.insert(aGlobalMsfWords["WORKFLOW_REMIND_MINUT"]);
		oFrequency.insert(oValueFrequency);
		oOptionBody.insert(oFrequency);
	},
	
	comparison : function (aFields) {
		oTableTR			= new Element("TR");
		oTableTD			= new Element("TD");
		oFieldset			= new Element("FIELDSET");
		oLegend				= new Element("LEGEND");
		oLegend.insert('Сопоставление полей');
		oFieldset.insert(oLegend);
		oFieldsTable	 = new Element("TABLE", {"class":"field-table"});
		oFieldsBody		 = new Element("TBODY");		
		oFieldsTable.insert(oFieldsBody);
		i = 0;
		sName			 = this.iTable;
		aV81RefFields	 = aV81RefList.get('value')[oSelectV81.value];
		aMsfRefFields	 = aMsfRefList.get(oSelectMSF.value);
		aV81RefFields.each(function(hash) {
			oFieldsTR			= new Element("TR");
			oFieldsV81			= new Element("TD");
			oFieldsV81.width = "100px";
			oFieldsV81.insert(hash);
			oFieldsTR.insert(oFieldsV81);
			oFieldsMSF			= new Element("TD");
			oMSF				= new Element("SELECT");
			
			oMSF.name			= sName + '[' + hash + ']';
			j	= 0;
			var oOption 		= new Option('не выбран', '');
			oMSF.options[j++] 	= oOption;
			if (aMsfRefFields != "") {
				for (var $Key in aMsfRefFields) {
					var oOption 		= new Option(aMsfRefFields[$Key], $Key);
					oMSF.options[j++] 	= oOption;
				}
			}
			oFieldsMSF.insert(oMSF);
			oFieldsTR.insert(oFieldsMSF);
			oFieldsBody.insert(oFieldsTR);
		});
		oFieldset.insert(oFieldsTable);
		oTableTD.insert(oFieldset);
		oTableTR.insert(oTableTD);
		oCompBody.update(oTableTR);					
	}
};


var Rebuild = Class.create();
Rebuild.prototype = {
				
	initialize: function(iTable) {
		this.iTable = iTable;
	},
	
	rebuildBodyReferenceMSF : function (sRef_doc, oTable, oSelectV81) {
		oMSF_TR				= new Element("TR");
		oNameMSF			= new Element("TD");
		oNameMSF.width 		= "100px";
		oNameMSF.insert(aGlobalMsfWords["V81_INTEGRATION_REFMSF"]);
		oMSF_TR.insert(oNameMSF);
		oValueMSF				= new Element("TD");
		oSelectMSF				= new Element("SELECT");
		oSelectMSF.name			= this.iTable + '[ref_doc]';
		aMsfRefExist.set(sRef_doc, sRef_doc);
		var oOption				= new Option(sRef_doc, sRef_doc);
		oSelectMSF.options[0] 	= oOption;
		oSelectMSF.disabled		= true;					
		oValueMSF.insert(oSelectMSF);
		var oInputMSF				= new Element("INPUT");
		oInputMSF.name			= this.iTable + '[ref_doc]';
		oInputMSF.value			= sRef_doc;
		oInputMSF.type			= 'hidden';
		oValueMSF.insert(oInputMSF);
		oMSF_TR.insert(oValueMSF);
		oOptionBody.insert(oMSF_TR);
		oRemove.onclick			= function() {
			if (confirm(aGlobalMsfWords["V81_INTEGRATION_REMOVE_QUESTION"])) {
				aMsfRefExist.unset(oInputMSF.value);
				aV81RefExist.unset(oSelectV81.value);
				oTable.remove();
			}
		};
		
	},
	
	rebuildBodyReferenceV81 : function (sRef_v81) {
		oV81_TR					= new Element("TR");
		oNameV81					= new Element("TD");
		oNameV81.width 			= "100px";
		oNameV81.insert(aGlobalMsfWords["V81_INTEGRATION_RFFV81"]);
		oV81_TR.insert(oNameV81);
		oValueV81				= new Element("TD");
		oSelectV81				= new Element("SELECT");
		oSelectV81.name			= this.iTable + '[ref_v81]';
		aV81RefExist.set(sRef_v81, sRef_v81);
		var oOption				= new Option(sRef_v81, sRef_v81);
		oSelectV81.options[0] 	= oOption;
		oSelectV81.disabled		= true;
		oValueV81.insert(oSelectV81);
		oInputV81				= new Element("INPUT");
		oInputV81.name			= this.iTable + '[ref_v81]';
		oInputV81.value			= sRef_v81;
		oInputV81.type			= 'hidden';
		oValueV81.insert(oInputV81);
		oV81_TR.insert(oValueV81);
		oOptionBody.insert(oV81_TR);
	},
	
	rebuildBodyDirection : function (sDirection) {
		oDirection					= new Element("TR");
		oNameDirection				= new Element("TD");
		oNameDirection.width 		= "100px";
		oNameDirection.insert('Направление');
		oDirection.insert(oNameDirection);
		oValueDirection				= new Element("TD");
		oSelectDirection			= new Element("SELECT");
		oSelectDirection.name		= this.iTable + '[direction]';
		var oOption					= new Option(sDirection, sDirection);
		var oOption					= new Option('Из 1С в Detrix', '1C');
		oSelectDirection.options[0] = oOption;
		var oOption					= new Option('Из Detrix в 1С', 'MSF');
		oSelectDirection.options[1] = oOption;
		oSelectDirection.value 		= sDirection;
		oValueDirection.insert(oSelectDirection);
		oDirection.insert(oValueDirection);
		oOptionBody.insert(oDirection);
	},
	
	
	rebuildBodySynchronizationOptions : function (sNew, sEdit, sDelete) {
		oTableTR		 = new Element("TR");
		oTableTD		 = new Element("TD", {"colspan":"3"});
		oFieldset		 = new Element("FIELDSET");		
		oTableTD.width   = '100%';
		oLegend			 = new Element("LEGEND");
		oLegend.insert(aGlobalMsfWords["V81_INTEGRATION_SYNCOPTIONS"]);
		oFieldset.insert(oLegend);
		oSynchTable	 = new Element("TABLE", {"class":"field-table"});
		oSynchBody	 = new Element("TBODY");		
		oSynchTable.insert(oSynchBody);
		sName			 = this.iTable;
		aSynchOptions		 = $H(
									{
										'new'  	 : aGlobalMsfWords["V81_INTEGRATION_NEWRECORDS"],
										'edit' 	 : aGlobalMsfWords["V81_INTEGRATION_EDITRECORDS"],
										'delete' : aGlobalMsfWords["V81_INTEGRATION_DELETERECORDS"]
									}
							  	 );
		aSynchOptions.each(function(hash) {
			oSynchTR			= new Element("TR");
			oSynchName			= new Element("TD");
			oSynchName.width 	= "100px";
			oSynchName.insert(hash.value);
			oSynchTR.insert(oSynchName);
			oSynchOption		= new Element("TD");
			var oSynchYes			= new Element("INPUT");
			oSynchYes.type		= 'radio';
			oSynchYes.name		= sName + '[' + hash.key + ']';			
			oSynchYes.value		= 'yes';			
			oSynchOption.insert(oSynchYes);
			oSynchOption.insert('Да');
			var oSynchNo			= new Element("INPUT");
			oSynchNo.type		= 'radio';
			oSynchNo.name		= sName + '[' + hash.key + ']';			
			oSynchNo.value		= 'no';		
			oSynchOption.insert(oSynchNo);
			oSynchOption.insert('Нет');			
			oSynchYes.onclick = function() {
				oSynchYes.checked   	 = true;
				oSynchYes.defaultChecked = true;
				oSynchNo.checked   		 = false;
				oSynchNo.defaultChecked  = false;	
			}
			oSynchNo.onclick = function() {								
				oSynchYes.checked   	 = false;
				oSynchYes.defaultChecked = false;
				oSynchNo.checked   		 = true;
				oSynchNo.defaultChecked  = true;					
			}					
			
			switch (hash.key) {
				case 'new':
					if (sNew == 'yes') {
						oSynchYes.checked   	 = true;
						oSynchYes.defaultChecked = true;
						
					}
					else {
						oSynchNo.checked   		= true;
						oSynchNo.defaultChecked = true;
					}
					break;
				case 'edit':
					if (sEdit == 'yes') {
						oSynchYes.checked   	 = true;
						oSynchYes.defaultChecked = true;
					}
					else {
						oSynchNo.checked   		= true;
						oSynchNo.defaultChecked = true;
					}
					break;
				case 'delete':
					if (sDelete == 'yes') {
						oSynchYes.checked   	 = true;
						oSynchYes.defaultChecked = true;
					}
					else {
						oSynchNo.checked   		= true;
						oSynchNo.defaultChecked = true;
					}
					break;
			}		
			
			oSynchTR.insert(oSynchOption);
			oSynchBody.insert(oSynchTR);
		});
		oFieldset.insert(oSynchTable);
		oTableTD.insert(oFieldset);
		oTableTR.insert(oTableTD);
		oOptionBody.insert(oTableTR);
	},
	
	rebuildBodyFrequency : function (iDays, iHours, iMinuts) {
		oFrequency					= new Element("TR");
		oNameFrequency				= new Element("TD");
		oNameFrequency.width 		= "100px";
		oNameFrequency.insert(aGlobalMsfWords["V81_INTEGRATION_FREQUENCY"]);
		oFrequency.insert(oNameFrequency);
		
		oValueFrequency				= new Element("TD");
		// days
		var oInput 				= new Element('INPUT');
		oInput.name				= this.iTable + '[before_days]';					
		oInput.value			= iDays;
		oInput.style.width		= "20px";
		oInput.style.textAlign	= "right";
		oInput.maxLength		= "3";
		oValueFrequency.insert(oInput);
		oValueFrequency.insert(aGlobalMsfWords["WORKFLOW_REMIND_DAYS"]);
		oInput.onkeydown = function(e) {
			var e = (!e) ? window.event : e;
			if (e.keyCode ==9) {
				return true;
			}
			
			if (((e.keyCode >=96) && (e.keyCode <= 105)) || ((e.keyCode >=48) && (e.keyCode <= 57)) || (e.keyCode == 8) || (e.keyCode == 46)|| (e.keyCode == 37)|| (e.keyCode == 39)) {
				if (this.value.charAt(0) == '0') {	
					this.value = '';
				}
				
				return true;
			} else {
				oMe = this;
				oMe.style.backgroundColor = 'red';
				setTimeout(function() {oMe.style.backgroundColor = 'white'}, 500);
				return false;
			}
			
		};
		
		oInput.onchange = function(e) {
			this.value = parseInt(this.value);
			if (isNaN(this.value)) { 
				this.value = '';
			}
			
		};
		
		// hours
		var oSelect				= new Element('SELECT');
		oSelect.name			= this.iTable + '[before_hours]';
		for (var i = 0; i < 24; i++) {
			var oOption = new Option(((i < 10)? '0' + i: i), i);
			oSelect.options[i] = oOption;
			if (iHours == i) {
				oSelect.options[i].selected = true;
			}
			
		}
		oValueFrequency.insert(oSelect);
		oValueFrequency.insert(aGlobalMsfWords["WORKFLOW_REMIND_HOUR"]);
		
		// minuts
		var oSelect				= new Element('SELECT');
		oSelect.name			= this.iTable + '[before_minuts]';
		var j					= 0;
		for (var i = 0; i < 60; i = i+5) {
			var oOption = new Option(((i < 10)? '0' + i: i), i);
			oSelect.options[j] = oOption;
			if (iMinuts == i) {
				oSelect.options[j].selected = true;
			}
			j++;
		}
		
		oValueFrequency.insert(oSelect);
		oValueFrequency.insert(aGlobalMsfWords["WORKFLOW_REMIND_MINUT"]);
	
		oFrequency.insert(oValueFrequency);
		oOptionBody.insert(oFrequency);
	},
	
	rebuildComparison : function (aFields) {
		oComparison		 	= new Element("TABLE", {"class":"field-table"});
		oCompBody			= new Element("TBODY");		
		oComparison.width 	= '100%';
		oComparison.insert(oCompBody);
		oTableTR			= new Element("TR");
		oTableTD			= new Element("TD");
		oFieldset		 = new Element("FIELDSET");
		oLegend			 = new Element("LEGEND");
		oLegend.insert('Сопоставление полей');
		oFieldset.insert(oLegend);
		oFieldsTable	 = new Element("TABLE", {"class":"field-table"});
		oFieldsBody		 = new Element("TBODY");		
		oFieldsTable.insert(oFieldsBody);
		i = 0;
		sName			 = this.iTable;
		aV81RefFields	 = aV81RefList.get('value')[oSelectV81.value];
		aMsfRefFields	 = $H(aMsfRefList.get(oSelectMSF.value));
		aV81RefFields.each(function(hash) {
			oFieldsTR			= new Element("TR");
			oFieldsV81			= new Element("TD");
			oFieldsV81.width = "100px";
			oFieldsV81.insert(hash);
			oFieldsTR.insert(oFieldsV81);
			oFieldsMSF			= new Element("TD");
			oMSF				= new Element("SELECT");
			
			oMSF.name			= sName + '[' + hash + ']';
			j	= 0;
			var oOption 		= new Option('не выбран', '');
			oMSF.options[j++] 	= oOption;
			
			aMsfRefFields.each(function(e) {
				var oOption 		= new Option(e.value, e.key);
				oMSF.options[j++] 	= oOption;
				oOption.selected 	= e.key == aFields[hash];
			});
			oFieldsMSF.insert(oMSF);
			oFieldsTR.insert(oFieldsMSF);
			oFieldsBody.insert(oFieldsTR);
		});
		oFieldset.insert(oFieldsTable);
		oTableTD.insert(oFieldset);
		oTableTR.insert(oTableTD);
		oCompBody.insert(oTableTR);
		oContent.insert(oComparison);
	}
};

var AjaxRequest = Class.create();
AjaxRequest.prototype = {

	initialize: function() {

	},
	
	getRefListAction: function() {
		new Ajax.Request('1Cv81/getRefList', 
								{
									requestTimeout: 10,												
									onSuccess : function(responce) {
										aV81RefList 		 = $H(responce.responseText.evalJSON());
										if (aV81RefList.get('code') == 4) {
											$('message').update(aGlobalMsfWords["V81_INTEGRATION_MESSAGE_NOT_WSDL"]);
										}
										else {
											$('message').style.display = 'none';
											$('new_ref').style.display = 'block';
											$('button_save').style.display = 'block';
											Form.rebuild();
										}
									},
									onTimeout: function() {
										$('message').update(aGlobalMsfWords["V81_INTEGRATION_MESSAGE_NOT_CONNECTION"]);
									},
									onException: function(e) {
										$('message').update(aGlobalMsfWords["V81_INTEGRATION_MESSAGE_NOT_CONNECTION"]);
									}
																					
								}
							 );
	}
	
};