<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
//require_once "modules/help/view/xml/HELP_HelpXml.php";
//require_once "modules/references/library/Reference/UserReference.php";
require_once "modules/archive/view/xml/ARCH_ViewXml.php";
require_once "modules/archive/library/ARCH_DBRecord.php";
require_once "modules/archive/library/ARCH_SecurityManager.php";
require_once "modules/archive/library/ARCH_ArchiveElement.php";
require_once "modules/archive/library/ARCH_Archive.php";
require_once "library/MSF_Export/MSF_ExportToExcel.php";

class MSF_FrontController extends MSF_ControllerSupport
{	
	public function indexAction()
	{				
		$oView 	    = new MSF_RecordsetXml();
		$oArchive   = new ARCH_Archive();
		$aRecordset = $oArchive->getRecords();
		$oView->buildRecordset($aRecordset);
		$sInitPath = "/archive/exportRecordset";
		$this->Template->getModule ()->appendChild ( $this->Template->createElement ( "initPath", $sInitPath ) );
		$oView->addTemplate("/modules/references/view/templates/default/reference.xsl");
                $Locale = MSF_Registry::get("MSF_Locale");
		$this->Template->setPageTitle($Locale->getWord("LABEL_DOCUMENTS") . " / " . $Locale->getWord("LABEL_ARCHIVE"));		
		$this->setView($oView);
		//$this->notAccessAction();
		//return;		
	}
	
	public function viewAction()
	{
		$iArchiveId = $this->getIntParam(0);		
		$oView 		= new ARCH_ViewXml();
		$oDBRecord 	= new ARCH_DBRecord();
		$aData		= $oDBRecord->findItem($iArchiveId);
		$oManager	= new ARCH_SecurityManager($aData["doctype_id"]);
		if(!$oManager->hasAccess("view", $iArchiveId)) {
			$this->notAccessAction();
			return;
		}
		else {			
			$oView->initTitle($aData["doctype_title"]);
			$oView->initNotify($aData["structure_id"], $iArchiveId);
			$oView->initTemplate($aData["fields_xml"], $aData["sysfields_xml"], $aData["template_xml"]);
			$this->setView($oView);
		}		
	}
	
	public function groupAction()
	{		
		$oView	= new MSF_RecordsetXml();
		$oArchive   = new ARCH_Archive();
		$oView->buildGroup($oArchive->getArchiveGroup());
		$this->setView($oView);		
	}
	
	public function removeAction()
	{		
		$aArchiveIds = (array) MSF_SL::getParam($_POST, "archive_id");
		if(empty($aArchiveIds)) {
			$iId = $this->getIntParam(0);
			if($iId != 0) {
				$aArchiveIds[] = $iId;
			}
			
		}
						
		$oView 		= new ARCH_ViewXml();
		$oDBRecord 	= new ARCH_DBRecord();
		$aNotRemove = array();
		for($i = 0; $i < count($aArchiveIds); $i++) {
			$aData		= $oDBRecord->findItem($aArchiveIds[$i]);
			$oManager	= new ARCH_SecurityManager($aData["doctype_id"]);
			if(!$oManager->hasAccess("remove", $aArchiveIds[$i])) {
				$aNotRemove[] 	= $aData["document_title"];
			}
			else {
				$oArchiveElement = new ARCH_ArchiveElement();
				$oArchiveElement->deleteItem($aArchiveIds[$i]);
			}
		}
		
		if (!empty($aNotRemove)){
			if (count($aNotRemove) == 1) {
				$sMessage = MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCUMENT_REMOVE_DENIED");
			}
			else {
				$sMessage = MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCUMENTS_REMOVE_DENIED");
			}
			 
			MSF_Registry::get("MSF_Messenger")->addError($sMessage . " " . implode(", ", $aNotRemove));
		}
		else {
			MSF_Registry::get("MSF_Messenger")->addMessage(MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCUMENT_DELETED"));
		}
		
		$this->redirect("/archive/");
	}
	
	public function notifyAction()
	{		
		$iArchiveId  = $this->getIntParam(0);
		$oElement	 = new ARCH_ArchiveElement();
		$aData		 = $oElement->findItem($iArchiveId);
		$aAddresses  = MSF_SL::getParam($_POST, "notify_addresses");
		$sNotifyText = MSF_SL::getParam($_POST, "notify_text");	
		$sHttp = "http";
		if (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on") {
			$sHttp = "https";
		}
		
		$sArchive	= MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_ADMIN_MENU_DOCTYPE_ARCHIVE");
		$sUrl 		= $sArchive . (($sArchive{strlen($sArchive) - 1} != ":") ? ":" : "") . "<br/>" .
					"<a href=\"" . $sHttp . "://" . $_SERVER["HTTP_HOST"] . "/archive/view/" . $iArchiveId . "\">" .
						$aData["document_title"] .
					"</a><br/><br/>";
		if (!empty($sNotifyText)) {
			$sCommentWord 	= MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCTYPE_SPA_COMMENT");
			$sNotifyText 	= $sCommentWord . (($sCommentWord{strlen($sCommentWord) - 1} != ":") ? ":" : "") . "<br/>" . $sNotifyText;
		}
		
		$sText = $sUrl . $sNotifyText;
		$sSubject	= $sArchive . " - " . $aData["document_title"];
		$oRefValue	= new REF_Value();
		$oRefValue->parse($aAddresses);		
		$aKeys = $oRefValue->getKeysList();
		$aStructureIds = array();
		foreach($aKeys AS $aIds) {
			$aStructureIds[] =  $aIds[0];
		}	
		
		try {
			$Mail = new LMS_Mail(new LMS_MailDB(MSF_Registry::get("MSF_DB")));
			$Mail->setStructureIds($aStructureIds);
			$Mail->setSubject($sSubject);
			$Mail->setType("text/html");
			$Mail->setBody(MSF_HtmlEntities::strip($sText));
			$Mail->save(0, true);
		}
		catch(Exception $oException) {
			debug($oException);
			exit();	
		}
		
		$oManager = new ARCH_SecurityManager();
		$oManager->editElement($iArchiveId, $aStructureIds);
		$this->redirect("/archive/view/" . $iArchiveId);		
	}
	
	public function exportRecordsetAction() {		
		$oArchive = new ARCH_Archive ( );
		$aRecordset = $oArchive->getRecords ( 0, true );
		$iPages = $aRecordset ["pagination"] ["totalPages"];
		try {
			$oPHPExcel = new MSF_ExportToExcel ( );
			$oPHPExcel->exportTitles ( $aRecordset );
			for($i = 0; $i < $iPages; $i ++) {
				set_time_limit(MSF_Recordset::$RECORDS_PER_PAGE);;
				$aRecordset = $oArchive->getRecords ( $i * MSF_Recordset::$RECORDS_PER_PAGE, true );
				$oPHPExcel->exportBody ( $aRecordset );
			}
			
			$sLink	= $oPHPExcel->saveSpreadsheet ();
		}
		catch(Exception $e) {
			$this->redirect("/archive/", MSF_Registry::get("MSF_Locale")->getWord("EXPORT_ERROR"));				
		}
		
		$sLink = $oPHPExcel->saveSpreadsheet ();
		$aResult = array(
			"link"	=> $sLink,
			"ext"	=> "xls",
			"name"	=> urlencode(MSF_Registry::get("MSF_Locale")->getWord("LABEL_ARCHIVE"))
			);
			
		$View = new MSF_ViewSupportJson();
		$View->set("data", $aResult);
		$this->setView($View);				
	}

}
?>