<?php

include_once "modules/archive/library/ARCH_DBRecord.php";
include_once "modules/archive/library/ARCH_Media.php";

class ARCH_ArchiveElement {
	
	private $DB;
	public $iArchiveId;
	public $iStructureId;
	public $sAuthorName;
	public $sCreatedAt;
	public $sModifiedAt;
	public $sArchivedAt;
	public $iDoctypeId;
	public $iDocumentId;
	public $iRegistrationNumber;
	public $sDocumentTitle;
	public $sFieldsXml;
	public $sTemplateXml;
	
	public function __construct()
	{
		$this->DB = new ARCH_DBRecord();
	}
	
	public function findItem($iArchiveId)
	{
		$aData = $this->DB->findItem($iArchiveId);
		return $aData;
	}
	
	public function findItemByDocId($iDocumentId)
	{
		$Result = $this->DB->findItemByDocId($iDocumentId);
		if(count($Result) == 1) {
			$Result = $Result["archive_id"];
		}
		else {
			$Result = -1;
		}
		
		return $Result;
	}
	
	public function deleteItem($iArchiveId)
	{
		$aElement = $this->DB->findItem($iArchiveId);
		$sFields  = $aElement["fields_xml"];
		$oWrapper = new MSF_XmlWrapper();
		$DB = MSF_Registry::get("MSF_DB");
		$oMedia   = new ARCH_Media();
		$oDir	  = new MSF_Dir();
		$aFields  = $oWrapper->xmlToArray($sFields);
		foreach($aFields AS $sKey => $aValue) {
			$aBody = $aValue["value"];			
			if (($aBody["type"] == "file") || ($aBody["type"] == "picture") || ($aBody["type"] == "text")) {
				switch ($aBody["type"]) {
					case "file":
					case "picture":
						$aFiles = explode(',', $aBody['value']);
						break;
					case "text":
						preg_match_all('!"/media/(image|download)/(\d{1,})"!', $aBody['value'], $aSearch);
						$aFiles = $aSearch[2];
						break;
				}
				if (!empty($aFiles)) {
					foreach ($aFiles AS $sFile) {
						try {
							$aInfo		= $oMedia->getFileInfo($sFile);
							$oMedia->remove($sFile);
							if(!empty($aInfo)) {
								$aDir		= $oDir->read($aInfo["directory"]);
								if (empty($aDir)) {
									$aInfoHour	= pathinfo($aInfo["directory"]);
									$oDir->remove($aInfo["directory"]);
									$aDirHour	= $oDir->read($aInfoHour["dirname"]);
									if (empty($aDirHour)) {
										$aInfoDay	= pathinfo($aInfoHour["dirname"]);
										$oDir->remove($aInfoHour["dirname"]);
										$aDirDay	= $oDir->read($aInfoDay["dirname"]);
										if (empty($aDirDay)) {
											$oDir->remove($aInfoDay["dirname"]);
										}
									}
								}
							
							}
						}
						catch (Exception $e) {
							debug($e);
							exit();
						}
					}
				}
			}
		}

		$this->DB->deleteItem($iArchiveId);		
	}

}
?>