<?php
if(!defined("__MSF")) {
	die("Direct access not allowed");
}

include_once "modules/archive/library/ARCH_MediaDB.php";

class ARCH_Media {
	
	private $sUploadDirectory;
	private $sDownloadDirectory;
	private $aFileInfo = array();
	
	public function __construct()
	{
		$this->DB	= new ARCH_MediaDB();
		$aSettings  = MSF_Registry::get("MSF_Settings")->getModule("archive");		
		$this->sUploadDirectory = $aSettings["settings"]["arch_files_catalog"];
		$this->sDownloadDirectory = CNM_MEDIA_UPLOAD_DIRECTORY;
	}
	
	public function updateUploadDirectory($sPath)
	{
		$this->sUploadDirectory = $sPath;
	}
	
	public function updateDownloadDirectory($sPath)
	{
		$this->sDownloadDirectory = $sPath;
	}
	
	public function upload($sFiles)
	{
		$aFiles	   = explode(",", $sFiles);		
		$oMedia	   = new MD_MediaDB(MSF_Registry::get("MSF_DB"));				
		for($i = 0; $i < count($aFiles); $i++) {
			$aFileInfo = $oMedia->load($aFiles[$i]);
			if(isset($aFileInfo["directory"])) {												
				$sOldPath  = $aFileInfo["directory"];
				$sFilePath = substr($sOldPath, strlen(CNM_MEDIA_UPLOAD_DIRECTORY));
				$sTmp	   = $sFilePath;
				$sDir	   = $this->sUploadDirectory;
				do {
					$iPos = strpos($sTmp, "/");
					if($iPos != false) {
						$sDir .= "/" . substr($sTmp, 0, $iPos);
					}
					else {
						$sDir .= "/" . substr($sTmp, 0);
					}
					
					if(!MSF_Dir::exists($sDir)) {
						MSF_Dir::create($sDir);
					}				
					$sTmp = substr($sTmp, $iPos + 1);						
				} while($iPos != false);
				
				$sNewPath  = $this->sUploadDirectory . "/". $sFilePath;			
				MSF_File::copy($this->sDownloadDirectory . "/" . $sFilePath . "/" . $aFileInfo["file_id"], $sNewPath . "/" . $aFileInfo["file_id"]);
				$aFileInfo["directory"] = $sNewPath;
				$this->DB->insert($aFileInfo);
			}
			
		}
		
	}
	
	public function download()
	{
		
	}
	
	public function getFileInfo($iId)
	{
		$this->load($iId);
		return $this->aFileInfo;
	}
	
	public function load($iId)
	{
		if(!empty($iId)) {
			$this->aFileInfo = $this->DB->load($iId);			
		}
		
	}
	
	public function remove($iId)
	{
		$this->load($iId);
		$this->DB->remove($iId);
		if(!empty($this->aFileInfo)) {
                        $sFilePath	= $this->aFileInfo["directory"] . "/" . $this->aFileInfo["file_id"];
			MSF_File::remove($sFilePath);
		}
		
	}
	
	public function fileExists($iFileId)
	{
		
	}
}
?>