<?php
if(!defined("__MSF")) {
	die("Direct access not allowed");
}

class ARCH_MediaDB {
	
	private $oDb;
	
	public function __construct()
	{
		$this->oDb = new MSF_DB();
		$aSettings = MSF_Registry::get("MSF_Settings")->getModule("archive");
		$sServer   = $aSettings["settings"]["arch_sql_host"];
		$sBase	   = $aSettings["settings"]["arch_sql_database"];
		$sUser	   = $aSettings["settings"]["arch_sql_user"];
		$sPassword = $aSettings["settings"]["arch_sql_password"];
		$sScheme   = $aSettings["settings"]["arch_sql_scheme"];
                $sPort     = $aSettings["settings"]["arch_sql_port"];
		$this->oDb->connect($sServer, $sBase, $sUser, $sPassword, $sScheme, $sPort);
	}
	
	public function select($sSql)
	{
		$mResult = array();		
		$this->oDb->executeQuery($sSql);		
		while ($aRow = $this->oDb->fetchArray()) {
			array_push($mResult, $aRow);
		}		

		return $mResult;
	}
	
	public function insert($aData)
	{
		$sSQL	=	"DELETE FROM" . "\n" .
						"md_media" . "\n" .
					"WHERE" . "\n" .
						"file_id='" . $aData["file_id"] . "'";
		
		$this->oDb->executeQuery($sSQL);
		
		$sSQL	=	"INSERT INTO" . "\n" .
						"md_media (file_id, name, directory, md5, sha1, user_id, created_at, type, size)" . "\n" .
					"VALUES" . "\n" .
						"(" .
							$aData["file_id"] . "," .
							"'" . $aData["name"] . "'," .
							"'" . $aData["directory"] . "'," .
							"'" . $aData["md5"] . "'," .
							"'" . $aData["sha1"] . "'," .							
							"'" . $aData["user_id"] . "'," .
							"'" . $aData["created_at"] . "'," .
							"'" . $aData["type"] . "'," .
							"'" . $aData["size"] . "'" .
						")";						
					
		$this->oDb->executeQuery($sSQL);
	}
	
	public function load($iId)
	{
		$mResult = array();
		$sSQL	= 	"SELECT" . "\n" .
						"*" . "\n" .
					"FROM" . "\n" .
						"md_media" . "\n" .
					"WHERE" . "\n" .
						"file_id='" . (int)$iId . "'";
		$this->oDb->executeQuery($sSQL);		
		$mResult = $this->oDb->fetchArray();

		return $mResult;
	}
	
	public function remove($iId)
	{
		$sSQL	=	"DELETE FROM" . "\n" .
						"md_media" . "\n" .
					"WHERE" . "\n" .
						"file_id='" . (int)$iId . "'";		
		$this->oDb->executeQuery($sSQL);
	}
	
}
?>