<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

include_once "modules/archive/library/ARCH_SecurityManagerDB.php";

class ARCH_SecurityManager {

	private $DB;
	private $iId;
	
	public function __construct($iId = 0)
	{
		$this->iId = $iId;
		$this->DB	= new ARCH_SecurityManagerDB();
	}
	
	public function edit($aPost)
	{
		try {
			$aToSave 	= array();
			$iGroup		= 1;
			$RV			= new REF_Value();
			foreach($aPost AS $aRow) {
				 $RV->parse($aRow["structure"]);
				 $aStructureIds	= $RV->getKeysList();				 
				 foreach($aStructureIds as $mStructureId) {
					if (is_array($mStructureId)) {
						$mStructureId = $mStructureId[0];
					}
					
					$tmp	= array(
							"structure_id"		=> $mStructureId,							
							"can_view"			=> $aRow["can_view"],
							"can_remove"		=> $aRow["can_remove"],
							"group_id"			=> $iGroup
						);
						
					array_push($aToSave, $tmp);											
				}
				
				$iGroup++;				
			}
			
			$this->DB->edit($aToSave, $this->iId);
			
		}
		catch(Exception $oException) {
			debug($oException);
			exit();
		}
		
	}	
	
	public function get()
	{
		$aData		=  $this->DB->get($this->iId);		
		$aTmpData	= array();
		$aReady		= array();
		foreach($aData as $aRow) {
			if(!isset($aTmpData[$aRow["group_id"]])) {
				$aTmpData[$aRow["group_id"]] = array(
					"structure"		=> array(),					
					"can_view"		=> $aRow["can_view"],
					"can_remove"	=> $aRow["can_remove"]
				);
			}
			
			if(!in_array($aRow["structure_id"], $aTmpData[$aRow["group_id"]]["structure"])) {
				array_push($aTmpData[$aRow["group_id"]]["structure"], $aRow["structure_id"]);
			}
			
		}
		
		foreach($aTmpData as $aRow) {
			$aTmp = array(
				"structure"		=> MSF_OrgStructureFacade::getInstance()->strIdsToRefValue($aRow["structure"]),				
				"can_view"		=> $aRow["can_view"],
				"can_remove"	=> $aRow["can_remove"]
			);
			
			array_push($aReady, $aTmp);
		}
		
		return $aReady;
	}
	
	public function editElement($iArchiveId, $aStructureIds)
	{
		$this->DB->editElement($iArchiveId, $aStructureIds);
	}
	
	public function hasAccess($sAccessType, $iArchiveId)
	{
		$bAllow 					= false;		
		$UserBox 					= MSF_Registry::get("MSF_UserBox");
		$sPath						= $UserBox->getCurrentStructurePath();
		if (!empty($sPath)) {
			$aRevEmployeePath	= explode(".", $sPath);
		}
		else {
			$aRevEmployeePath	= array(0);
		}
		
		$aEmployeePath = array_reverse($aRevEmployeePath);
				
		for($i = 0; $i < count($aEmployeePath); $i++) {
			$aResult = $this->DB->selectAllowed($this->iId, $aEmployeePath[$i]);
			if (!empty($aResult)) {
				if($aResult["can_" . $sAccessType] == 1) {
					$bAllow = true;
					break;
				}
				if($aResult["can_" . $sAccessType] == 2) {
					break;
				}
			}
			
		}
		
		if(!$bAllow) {
			for($i = 0; $i < count($aEmployeePath); $i++) {
				$iResult = $this->DB->selectElementAllowed($iArchiveId, $aRevEmployeePath[$i]);				
				if($iResult == 1) {
					$bAllow = true;
					break;
				}
				
			}
			
		}
		
		return $bAllow;
		
	}

	public function hasFileAccess($iMediaId)
	{
		$UserBox 		= MSF_Registry::get("MSF_UserBox");
		$sPath 	 		= $UserBox->getCurrentStructurePath();				
		$sStructurePath = str_replace(".", ",", $sPath);
		if(empty($sStructurePath)) {
			$sStructurePath = "0";		
		}
		
		$iAllowed		= $this->DB->selectFileAllowed($iMediaId, $sStructurePath);
		if($iAllowed > 0) {
			return true;
		}
		else {
			return false;
		}
		
	}
	
	public function hasMenuAccess()
	{
		$UserBox 		= MSF_Registry::get("MSF_UserBox");
		$sPath 	 		= $UserBox->getCurrentStructurePath();				
		$sStructurePath = str_replace(".", ",", $sPath);
		if(empty($sStructurePath)) {
			$sStructurePath = "0";		
		}
		
		$iAllowed 		= $this->DB->selectMenuAllowed($sStructurePath);
		if($iAllowed > 0) {
			return true;
		}
		else {
			return false;
		}
		
	}
	
}

?>