<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

class ARCH_SecurityManagerDB {
	
	private $oDb;
	
	public function __construct()
	{
		$this->oDb = new MSF_DB();
		$aSettings = MSF_Registry::get("MSF_Settings")->getModule("archive");
		$sServer   = $aSettings["settings"]["arch_sql_host"];
		$sBase	   = $aSettings["settings"]["arch_sql_database"];
		$sUser	   = $aSettings["settings"]["arch_sql_user"];
		$sPassword = $aSettings["settings"]["arch_sql_password"];
		$sScheme   = $aSettings["settings"]["arch_sql_scheme"];
                $sPort     = $aSettings["settings"]["arch_sql_port"];
		$this->oDb->connect($sServer, $sBase, $sUser, $sPassword, $sScheme, $sPort);
	}
	
	public function edit(array $aData, $iId)
	{
		$sSql	=	"DELETE FROM" . "\n" . 
						"wf_access_list" . "\n" .
					"WHERE" . "\n" .
						"doctype_id='" . $iId . "'";		
		
		$this->oDb->executeQuery($sSql);			
	
		foreach($aData as $aRow) {
			$sSql =	"INSERT INTO" . "\n" .
						"wf_access_list" . "\n" .
						"(" . "\n" .
							"doctype_id," .
							"structure_id," .							
							"can_view," .
							"can_remove," .
							"group_id" .
						")" . "\n" .
					"VALUES" . "\n" .
						"(" . 
							"'" . (int)$iId . "'," . 
							"'" . (int)$aRow["structure_id"] . "'," .							
							"'" . (int)$aRow["can_view"] . "'," .
							"'" . (int)$aRow["can_remove"] . "'," .
							"'" . (int)$aRow["group_id"] . "'" .
						")";		
		
			$this->oDb->executeQuery($sSql);
		}
		
	}
	
	public function get($iId)
	{
		$sSql	=	"SELECT" . "\n" .
						"structure_id, can_view, can_remove, group_id" . "\n" .
					"FROM" . "\n" .
						"wf_access_list" . "\n" .
					"WHERE" . "\n" .
						"doctype_id='" . $iId .  "'" . "\n" .
					"ORDER BY" . "\n" .
						"structure_id";
		return $this->oDb->select($sSql);
	}
	
	public function editElement($iArchiveId, $aStructureIds)
	{
		for($i = 0; $i < count($aStructureIds); $i++) {
			$sSql	=	"DELETE FROM" . "\n" . 
							"wf_elements_access_list" . "\n" .
						"WHERE" . "\n" .
							"archive_id = " . $iArchiveId . "\n" . 
							"AND structure_id = " . $aStructureIds[$i];			
			$this->oDb->executeQuery($sSql);			
			$sSql =	"INSERT INTO" . "\n" .
						"wf_elements_access_list" . "\n" .
						"(" . "\n" .
							"archive_id," .
							"structure_id" .							
						")" . "\n" .
					"VALUES" . "\n" .
						"(" . 
							(int)$iArchiveId . "," . 
							(int)$aStructureIds[$i] .							
						")";		
			$this->oDb->executeQuery($sSql);	
		}				
		
	}
	
	public function selectAllowed($iId, $iStructureId)
	{
		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"wf_access_list\n" .
				"WHERE\n" .
					"doctype_id = " . $iId . "\n" .
				"AND\n" .
					"structure_id = " . $iStructureId;	
		
		return $this->oDb->select($sSql, true);
	}
	
	public function selectElementAllowed($iArchiveId, $iStructureId)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"wf_elements_access_list\n" .
				"WHERE\n" .
					"archive_id = " . $iArchiveId . "\n" .
				"AND\n" .
					"structure_id = " . $iStructureId;		
		
		return $this->oDb->select($sSql, true, "total");		
	}
	
	public function selectFileAllowed($iMediaId, $sStructureIds)
	{
		$sSql = "SELECT\n" . 
					"COUNT(*) AS total\n" . 
				"FROM\n" . 
					"wf_archive\n" . 
				"WHERE\n" .
				"((SELECT\n" .
					"COUNT(*)\n" .
				"FROM\n" .
					"wf_elements_access_list\n" .
				"WHERE\n" .
					"wf_elements_access_list.archive_id = wf_archive.archive_id\n" .
				"AND\n" .
					"wf_elements_access_list.structure_id = wf_archive.structure_id) > 0 OR\n" .
				"(SELECT\n" .
						"COUNT(*)\n" .
					"FROM\n" .
						"wf_access_list\n" .
					"WHERE\n" .
						"wf_access_list.doctype_id = wf_archive.doctype_id\n" .
					"AND\n" .
						"wf_access_list.structure_id = wf_archive.structure_id\n" .
					"AND\n" .
						"wf_access_list.can_view = 1) > 0) AND\n" . 
					"wf_archive.media_id = " . $iMediaId . "\n" . 
					"AND wf_archive.structure_id IN(" . $sStructureIds . ")";

		return $this->oDb->select($sSql, true, "total");				
					
	}
	
	public function selectMenuAllowed($sStructureIds)
	{
		$sSql = "SELECT\n" . 
					"COUNT(*) AS total\n" .
				"FROM\n" . 
					"wf_archive\n" . 
				"WHERE\n" . 
					"(
					doctype_id IN 
					(
					SELECT DISTINCT doctype_id FROM wf_access_list
					WHERE structure_id IN (" . $sStructureIds . ")
					)
					) 
					OR
					( 
					archive_id IN 
					(
					SELECT DISTINCT archive_id FROM wf_elements_access_list
					WHERE wf_elements_access_list.archive_id = archive_id AND
					structure_id IN (" . $sStructureIds . ")
					)
					)";

		return $this->oDb->select($sSql, true, "total");
	}
	
}

?>