<?php
/*
 * File: 	WF_TemplateXml.php
 * Date: 	15.02.2008
 * Time:	15:33:43
 * Detrix
 *
 */

 defined("__MSF")
 		or die("Direct access is not allowed");

// [include]
include_once "library/MSF_Utils/MSF_RteObjectsIntegrator.php";
include_once "modules/workflow/library/variables/WF_Vars.php";
include_once "modules/references/library/Reference/REF_Template.php";
// [/include]

/**
 * @package 	workflow
 * @author 	
 * @copyright 	Copyright (c) 2007, Detrix
 */
class ARCH_ViewXml extends MSF_ViewSupportXml
{
	public function initialize()
	{
		$this->Template->addXslPath("/modules/archive/view/templates/" . CNF_SKIN . "/view.xsl");
	}
	
	public function initTitle($sDoctype) 
	{
                $Locale = MSF_Registry::get("MSF_Locale");
                
		$sTitle = $Locale->getWord("LABEL_DOCUMENTS") . " / " . $Locale->getWord("LABEL_ARCHIVE") . " / " . $sDoctype;
		$this->Template->setPageTitle($sTitle);
	}
	
	public function initNotify($iStructureId, $iArchiveId) 
	{
		$Locale	= MSF_Registry::get("MSF_Locale");		
		$aAction = array(
			"spa_id" => 0,
			"employeeIds" => array($iStructureId),
			"title" => $Locale->getWord("WORKFLOW_DOCTYPE_SPA_NOTIFY_TITLE"),
			"name" => "notify",
			"description" => "",
			"options" => array(
				"visible" => 1,
	            "notify_address_type" => "structure",
	            "addresses" => "|^|row|^|",
	            "text" => "",
	            "type" => "parallel",	            
	            "multi" => true,
	            "showPosts" => true	
			),
			"settings" => array()			
		);		
		
		$oAb = MSF_Registry::get("MSF_ActionBar");		
		$this->Template->addLink("/modules/workflow/view/js/showActionWindow.js", "text/javascript");		
		$SpaNode	= $this->Template->createElement("spa");		
		$this->Template->getModule()->appendChild($SpaNode);		
		$ElmAction	= $this->Template->createElement("action");
		$SpaNode->appendChild($ElmAction);
		$ElmAction->setAttribute("id", 		$aAction["spa_id"]);
		$ElmAction->setAttribute("title",	$aAction["title"]);
		$ElmAction->setAttribute("type", 	$aAction["name"]);
		$sPath	= "/modules/workflow/actions/" . $aAction["name"] . "/default/spa.xsl";
		$this->Template->addXslPath($sPath);		
		$sUrl = "/archive/notify/" . $iArchiveId;
		$ElmAction->setAttribute("url", 	$sUrl);		
		foreach ($aAction["options"] AS $sKey => $mValue) {
			$ElmItem = $this->Template->createElement("item");
			$ElmAction->appendChild($ElmItem);
			$ElmItem->setAttribute("name", $sKey);			
			$ElmItem->setAttribute("value", $mValue);		
		}
		
		$sTitle 		= $aAction["title"];
		$sWindowTitle	= addslashes(trim($sTitle));
		$bIsVisible 	= $aAction["options"]["visible"];
		$sId			= "action_window_" . $aAction["spa_id"];
		$sAction		= "showActionWindow(this, '" . $sId . "', " . $bIsVisible . ", '" . $sWindowTitle . "'); return false;";
		$oAb->addAction($sTitle, "#" . $aAction["spa_id"], CNX_ACTIONBAR_IMG, $sAction, false, "left", $aAction["description"]);
		$oAb->addAction($Locale->getWord("WORKWLOW_TO_ARCHIVE"), "/archive");		
		
	}
	
	public function initTemplate($sFieldsXml, $sSysFieldsXml, $sTemplateXml)
	{	
		$oRefTemplate = new REF_Template($sTemplateXml);
		$Fields 	= new REF_Fields($sFieldsXml);
		$oVars  	= new WF_Vars();
		$aVars  	= $oVars->getList();
		$oWrapper 	= new MSF_XmlWrapper($sFieldsXml);		
		$aFields 	= $oWrapper->getAsArray();
		$oWrapper->clear();
		$aSysFields = $oWrapper->xmlToArray($sSysFieldsXml);		
		foreach($aFields AS $sKey => $aValue) {
			$Fields->set($sKey, $aValue["value"]["value"]);		
		}
		
		foreach($aVars AS $Key => $Value) {
			foreach($aSysFields AS $sKey => $aValue) {				
				if($Value["name"] == $sKey) {					
					$aVars[$Key]["html"] = $aValue["value"];
				}
				
			}
			
		}		
		
		foreach($aVars AS $iKey => $aValue) {
			$oVars->setHtml($iKey, $aValue["html"]);	
		}
		
		$oRefTemplate->setFields($Fields);
		$oRefTemplate->setVars($oVars);
		$oRefTemplate->getViewForm();
		$oRefTemplate->addViewTemplate($this->Template, "template");
		$this->addLinksOf("references");
		$this->addLinksOf("structure");
	}
}
?>