<?php
if (!defined("__MSF")) {
	exit("Direct access is not allowed");
}
class ELOG_EventLog extends MSF_ModelDBSupport {


	public function __construct(MSF_DB $DB) {
		$this->DB 		= $DB;
		$this->checkEventLogsTable();
	}
	
	public function addItem($aParams) {

		$Date	= new MSF_Date();
		$sType		= $this->defineType($aParams["event_type"]);
		if (isset($aParams["message_type"]) && isset($aParams["event_title"])) {
			$sTitle	= $this->defineTitle($aParams["event_type"], $aParams["event_title"], $aParams["message_type"]);
		}
		elseif (isset($aParams["event_title"])) {
			$sTitle	= $this->defineTitle($aParams["event_type"], $aParams["event_title"]);
		}
		else {
			$sTitle	= $this->defineTitle($aParams["event_type"]);
		}
		$UserBox 		= MSF_Registry::get("MSF_UserBox");
		if (isset($_SESSION["MSF_UserBox"]["employee"]["name"])) {
			$sUserName = $_SESSION["MSF_UserBox"]["employee"]["name"];
		}
		else {
			$sUserName = "";
		}
		$sSql = "INSERT INTO event_logs (" .
				" employee," .
				" ip_address," .
				" event_type," .
				" event_title," .
				" event_date)" .
				" VALUES ('" . 
				$sUserName . "', '" .
				$_SERVER["REMOTE_ADDR"] . "', '" .
				$sType . "', '" .
				$sTitle . "', '" .
				$Date->formatTimestamp() .
				"')";
		$this->execute($sSql);

	}
		
	private function select($sSql) {
		return $this->DB->select($sSql, true);
	}
	
	private function execute($sSql) {
		$this->DB->executeQuery($sSql);
	}

	private function defineType($sType) {
		if ($sType == "") $sType = "detrix";
		return MSF_Registry::get("MSF_Locale")->getWord("ELOG_" . strtoupper($sType));			
	}
	
	private function defineTitle($sType, $sMessage = "", $sMsgType = "") {
		if ($sType == "") $sType = "detrix";
		if ($sMessage != "") $sMessage = " \"" . $sMessage . "\"";
		if ($sType == "admin") {
			if ($sMsgType == "") $sMsgType = "reference";
			return MSF_Registry::get("MSF_Locale")->getWord("ELOG_" . strtoupper($sType) . "_" . strtoupper($sMsgType) . "_MSG") . $sMessage;
		}
		else {
			return MSF_Registry::get("MSF_Locale")->getWord("ELOG_" . strtoupper($sType) . "_MSG") . $sMessage;
		}
	}
	
	public function getItem($iEventId) {
		$sSql = "SELECT	employee, ip_address, event_type, event_title, event_date " .
				"FROM	event_logs " .
				"WHERE	event_logs_id = " . $iEventId;
		return $this->select($sSql);
	}

	private function checkEventLogsTable() {

		$sSql 		= "SELECT COUNT(tablename) AS event_logs FROM pg_tables WHERE tablename = 'event_logs'";
		$aResult 	= $this->select($sSql);
		if ($aResult["event_logs"] == 0)
			$this->createTableEventLogs();
			
	}

	private function createTableEventLogs() {
		$sSql	= "CREATE SEQUENCE manuscript.event_logs_id_seq " .
    			  " INCREMENT BY 1 " .
    			  " NO MAXVALUE" .
    			  " NO MINVALUE" .
    			  " CACHE 1";
		$this->execute($sSql);			

		$sSql	= "CREATE TABLE manuscript.event_logs (" .
    			  " event_logs_id integer DEFAULT nextval('event_logs_id_seq'::regclass) NOT NULL," .
    			  " employee character varying NOT NULL," .
    			  " ip_address character varying(16) NOT NULL," .
    			  " event_type character varying NOT NULL," .
    			  " event_title text NOT NULL," .
    			  " event_date timestamp without time zone NOT NULL)";
		$this->execute($sSql);

		$sSql	= "ALTER TABLE manuscript.event_logs OWNER TO detrix";
		$this->execute($sSql);

		$sSql	= "ALTER TABLE ONLY manuscript.event_logs ADD CONSTRAINT event_logs_pkey PRIMARY KEY (event_logs_id)";
		$this->execute($sSql);	 	
	}
}
?>