<?php
if (!defined("__MSF")) {
	exit("Direct access is not allowed");
}

class ELOG_Recordset {

	private $Recordset;
	
	public function getRecords()
	{
		$this->buildRecordset();		
		return $this->Recordset->getAllRecords(false);
	}
	
	public function getEventLogGroup() {
		$this->buildRecordset();		
		return $this->Recordset->getGroup();		
	}

	private function buildRecordset()
	{
		$this->Recordset = new MSF_Recordset(MSF_Registry::get("MSF_DB"), MSF_Registry::get("MSF_Template"));
		$this->Recordset->setBaseURL("/admin/eventlog/?");
		$this->Recordset->setRpcURL("/admin/eventlog/group/?");
		$this->setRecordsetSQL();
		$this->setRecordsetColumns();
		$this->Recordset->setDefaultOrder("event_logs_id");
		$this->Recordset->setDefaultDirection("desc");
	}
	private function setRecordsetSQL()
	{		
		$this->Recordset->setTables(array("event_logs"));
	}
	private function setRecordsetColumns()
	{		
		$aColumns	= array(
			1 => array(
				"name" 		=> "event_logs_id",
				"title" 	=> "ID",
				"type"		=> "int"
				),		
			2 => array(
				"name"		=> "event_date",
				"title"		=> MSF_Registry::get("MSF_Locale")->getWord("ELOG_TIMESTAMP"),
				"type"		=> "timestamp"
				),
			3 => array(
				"name"		=> "employee",
				"title"		=> MSF_Registry::get("MSF_Locale")->getWord("ELOG_EMPLOYEE"),
				"type"		=> "string"
			),
			4 => array(
				"name"		=> "ip_address",
				"title" 	=> MSF_Registry::get("MSF_Locale")->getWord("ELOG_IP_ADDRESS"),
				"type"		=> "string"
			),
			5 => array(
				"name"		=> "event_type",
				"title"		=> MSF_Registry::get("MSF_Locale")->getWord("ELOG_MODULE"),
				"type"		=> "string"
			),
			6 => array(
				"name"		=> "event_title",
				"title" 	=> MSF_Registry::get("MSF_Locale")->getWord("ELOG_DETAILS"),
				"type"		=> "string"
			)
		);
			
		$i = 1;
		$aExclusions = array("employee", "ip_address", "event_type");
		for ($i = 1; $i<7; $i++) {
			$aColumns[$i]["sort"] = 1;
			$aColumns[$i]["filter"] = 1;
			if(in_array($aColumns[$i]["name"], $aExclusions)) {
				$aColumns[$i]["group"] = 1;									
			}
			else {
				$aColumns[$i]["group"] = 0;
			}				
			if ($i>1)
				$aColumns[$i]["visible"] = 1;
			else
				$aColumns[$i]["visible"] = 0;
			$aColumns[$i]["compare"] = "like";
		}				
		
		$this->Recordset->setColumns($aColumns);	
	}
}
?>