<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
require_once "modules/help/view/xml/HELP_HelpXml.php";
require_once "modules/references/library/Reference/UserReference.php";
require_once "modules/workflow/library/folders/WF_Folder.php";

class MSF_FrontController extends MSF_ControllerSupport
{
		
		
	public function indexAction()
	{
			
	}
	
	public function moduleAction()
	{
		$sModule	= $this->getParam(0);
		$sText		= "";
		$sTitle		= "";
		$iId		= (int) $this->getParam(1);
		$sBack		= (string) MSF_SL::getParam($_GET, "back", "");
		
		if (strlen($sBack) == 0) {
			$sBack = "javascript:history.back();";
		}
		
		switch($sModule) {
			case "references"	:
				$Reference	= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
				$Reference->load($iId);
				$sText	= $Reference->getFullDescription();
				$sTitle	= $Reference->getName();
				break;
			case "folders"		:
				$Folder		= new WF_Folder(new WF_FolderDB(MSF_Registry::get("MSF_DB")));
				$Folder->load($iId);
				$aConfig	= $Folder->getConfig();
				$sText		= $aConfig["full_description"];
                                $sText          = MSF_Registry::get("MSF_Locale")->getI18N($sText);
				$sTitle		= $aConfig["name"];
				break;
			case "workflow"		:
				$Doctype	= new WF_Doctype($iId);
				$sText		= $Doctype->getFullDescription();
				$sTitle		= $Doctype->getTitle();
				break;
		}
		
		
		
		$View	= new HELP_HelpXml();
		$View->show($sText);
		
		
		$this->setView($View);
		$this->setTitle($sTitle);
		
		$AB	= MSF_Registry::get("MSF_ActionBar");
		$AB->addAction(
				$this->Locale->getWord("HELP_CLOSE"),
				$sBack,
				""
			);
	}
	
	private function setTitle($sTitle)
	{
		$this->Template->setPageTitle(
				$this->locale("HELP_HELP") .
				$this->locale("ROOT_TITLE_SEPARATOR") .
				MSF_Registry::get("MSF_Locale")->getI18N($sTitle)
			);
	}
	
	public function descriptionAction()
	{
		$this->buildHelp();
	}
	
	private function buildHelp()
	{
		try {
			$sModule = $this->getModuleRequest();
	
			switch($sModule) {
				case "references"	:
					$this->buildReferenceHelp();
					break;
				case "folders"		:
					$this->buildFoldersHelp();
					break;
				case "workflow"		:
					$this->buildWorkflowHelp();
					break;
			}
		}
		catch (Exception $e) {}
		
		$this->redirect($_SERVER["HTTP_REFERER"], $this->locale("HELP_DESCRIPTION_IS_MISSING"));
	}
	
	private function getModuleRequest()
	{
		$sRequest	=  $_SERVER["HTTP_REFERER"];
		$sModule	= "none";
		
		if(strpos($sRequest, "help") === false && strpos($sRequest, "admin") === false)
		{
			if(strpos($sRequest, "references/editrow") !== false
				|| strpos($sRequest, "references/viewrow") !== false
				|| strpos($sRequest, "references/viewref") !== false
				|| strpos($sRequest, "references/add") !== false) {
	
				$sModule	= "references";
			}
			elseif(strpos($sRequest, "workflow/folders") !== false) {
				$sModule	= "folders";
			}
			elseif(strpos($sRequest, "document/view") !== false
					|| strpos($sRequest, "document/spa/edit") !== false
					|| strpos($sRequest, "document/spa/create") !== false
					|| strpos($sRequest, "document/create")){
				$sModule	= "workflow";
			}
			
		}
		
		return $sModule;
	}
	
	private function buildReferenceHelp()
	{
		$sRequest	= $_SERVER["HTTP_REFERER"];
		$aTmp		= split("/", $sRequest);
		
		$iReferenceId	= (int)$aTmp[5];
		
		$Reference	= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
		$Reference->load($iReferenceId);
		
		if(strip_tags((string) $Reference->getFullDescription(), "<img>") != "") {
			$this->redirect("/help/module/references/" . $iReferenceId . "?back=" . $sRequest);
		}
		
	}
	
	private function buildFoldersHelp()
	{
		$sRequest	= $_SERVER["HTTP_REFERER"];
		$aTmp		= split("/", $sRequest);
		$iId		= (int)$aTmp[5];
		
		$Folder		= new WF_Folder(new WF_FolderDB(MSF_Registry::get("MSF_DB")));
		
		$Folder->load($iId);
		
		$aConfig	= $Folder->getConfig();
		
		if(strip_tags((string) $aConfig["full_description"], "<img>") != "") {
			$this->redirect("/help/module/folders/" . $iId . "?back=" . $sRequest);
		}
	}
	
	private function buildWorkflowHelp()
	{
		$sRequest	= $_SERVER["HTTP_REFERER"];
		$aTmp		= split("/", $sRequest);
		$aId		= 0;
		$Doctype	= null;

		if($aTmp[5]	== "create") {
			$Doctype	= new WF_Doctype((int)$aTmp[6]);
		}
		else {
			$Facade	= new WF_DocFacade();
			switch ($aTmp[5]) {
				case "view":
					$Doctype	= $Facade->getDoctypeByDocumentId((int)$aTmp[6]);
					break;
				case "spa":
					if($aTmp[6] == "edit") {
						$Doctype	= $Facade->getDoctypeByDocumentId((int)$aTmp[8]);	
					}
					if($aTmp[6] == "create") {
						$aGet = explode("=", $aTmp[8]);
						$Doctype	= new WF_Doctype((int)$aGet[1]);
					}
					break;
				
			}
		}
		if ($Doctype != null) {
			if(strip_tags((string) $Doctype->getFullDescription(), "<img>") != "") {
				$this->redirect("/help/module/workflow/" . $Doctype->getDoctypeId() . "?back=" . $sRequest);
			}
		}
		
	}
}
?>