<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "LMS_FoldersDB.php";
include_once "LMS_MailDB.php";
include_once "LMS_Mail.php";

class LMS_Folders
{
	private $DB 			= null;
	
	private $aAttributes 	= array();
	
	public function __construct(LMS_FoldersDB $DB)
	{
		$this->DB = $DB;
		$this->init();
	}
	
	private function init()
	{
		$this->aAttributes["title"] 	= (string) MSF_SL::getParam($_POST, "title");
		$this->aAttributes["status"] 	= (string) MSF_SL::getParam($_POST, "status");
	}
	
	private function exists($iFolderId)
	{
		return $this->DB->exists($iFolderId);
	}
	
	public function save($iFolderId = 0)
	{
		if ($this->exists($iFolderId)) {
			$this->DB->update($iFolderId, $this->aAttributes);
		}
		else {
			$this->DB->insert($this->aAttributes);
		}
	}
	
	public function remove($mFolderId)
	{
		$Mail = new LMS_Mail(new LMS_MailDB(MSF_Registry::get("MSF_DB")));
		
		if (is_array($mFolderId)) {
			for ($i = 0; $i < count($mFolderId); $i++) {
				$Mail->setFolderId($mFolderId[$i]);
				$aMails = $this->DB->selectByFolderId($mFolderId[$i]);
				if (!empty($aMails)) {
					for ($j = 0; $j < count($aMails); $j++) {
						$aMails[$j] = $aMails[$j]["message_id"];
					}
					$Mail->move($aMails, LMS_Mail::TRASH);
				}
			}
		}
		else {
			$Mail->setFolderId($mFolderId);
			$aMails = $this->DB->selectByFolderId($mFolderId);
			if (!empty($aMails)) {
				for ($j = 0; $j < count($aMails); $j++) {
					$aMails[$j] = $aMails[$j]["message_id"];
				}
				$Mail->move($aMails, LMS_Mail::TRASH);
			}
		}
		
		if (is_array($mFolderId)) {
			$mFolderId = implode(",", $mFolderId);
		}
		
		$this->DB->delete($mFolderId);
	}
	
	public function get()
	{
		return $this->DB->select();
	}
	
	public function getNewCount()
	{
		return $this->DB->selectNew();
	}
	
	public function getInboxUpdatedAt()
	{
		return $this->DB->selectInboxUpdatedAt();
	}
	
	public function getOne($iFolderId)
	{
		return $this->DB->selectOne($iFolderId);
	}
	
	public function getTrashEmailsIds()
	{
		$aResult = array();
		$aEmails = $this->DB->getTrashEmails();
		
		for ($i = 0; $i < count($aEmails); $i++) {
			$aResult[] = $aEmails[$i]["message_id"];
		}
		
		return $aResult;
	}
}

?>