<?php

defined("__MSF") or die("Direct access is not allowed");

class LMS_FoldersDB extends MSF_ModelDBSupport
{
	private $iUserId 	= 0;
	
	public function __construct(MSF_DB $DB)
	{
		$this->DB 		= $DB;
		$this->iUserId 	= MSF_Registry::get("MSF_UserBox")->getUserAttribute("id");
	}
	
	public function exists($iId)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"lms_folders\n" .
				"WHERE\n" .
					"folder_id = " . $iId . "\n" .
				"AND\n" .
					"user_id = " . $this->iUserId;
					
		return $this->DB->select($sSql, true, "total");
	}
	
	public function selectByFolderId($iFolderId)
	{
		$sSql = "SELECT
					message_id
				FROM
					lms_messages
				WHERE
					folder_id = " . $iFolderId;
		
		return $this->DB->select($sSql);
	}
	
	public function insert($aParams)
	{	
		$aParams = $this->escapeHashValues($aParams);
			
		$sSql = "INSERT INTO\n" .
					"lms_folders\n" .
				"(\n" .
					"user_id,\n" .
					"title,\n" .
					"status" .
				")\n" .
				"VALUES(\n" .
					$this->iUserId . ",\n" .
					"'" . $aParams["title"] . "',\n" .
					"'" . $aParams["status"] . "'\n" .
				")";
		
		$this->DB->executeQuery($sSql);
	}
	
	public function update($iId, $aParams)
	{
		$aParams = $this->escapeHashValues($aParams);
		
		$sSql = "UPDATE\n" .
					"lms_folders\n" .
				"SET\n" .
					"user_id = " . $this->iUserId . ",\n" .
					"title = '" . $aParams["title"] . "',\n" .
					"status = '" . $aParams["status"] . "'\n" .
				"WHERE\n" .
					"folder_id = " . $iId;
					
		$this->DB->executeQuery($sSql);
	}
	
	public function delete($mIds)
	{
		$sSql = "DELETE FROM\n" .
					"lms_folders\n" .
				"WHERE\n" .
					"folder_id IN (" . $mIds . ")\n" .
				"AND\n" .
					"user_id = " . $this->iUserId;
					
		$this->DB->executeQuery($sSql);
	}
	
	public function getTrashEmails()
	{
		$sSql = "SELECT\n" .
					"message_id\n" .
				"FROM\n" .
					"lms_trash\n" .
				"WHERE\n" .
					"user_id = " . $this->iUserId;
		
		return $this->DB->select($sSql);
	}
	
	public function select()
	{
		$sSql = "SELECT\n" .
					"f.folder_id,\n" .
					"f.title,\n" .
					"(
						SELECT\n
							COUNT(*) AS total\n
						FROM\n
							lms_messages
						WHERE\n
							folder_id = f.folder_id\n
						AND\n
							user_id = " . $this->iUserId . "\n
						AND\n
							status = 'new'
					) as new_total\n" .
				"FROM\n" .
					"lms_folders f\n" .
				"WHERE\n" .
					"f.user_id = " . $this->iUserId;

		return $this->DB->select($sSql);
	}
	
	public function selectNew()
	{
		$sSql = "SELECT\n" .
					"(
						SELECT\n
							COUNT(*) AS inbox_total\n
						FROM\n
							lms_inbox
						WHERE\n
							user_id = " . $this->iUserId . "\n
						AND\n
							status = 'new'
					) AS inbox_total,
					(
						SELECT\n
							COUNT(*) AS draft_total\n
						FROM\n
							lms_draft
						WHERE\n
							user_id = " . $this->iUserId . "\n
						AND\n
							status = 'new'
					) AS draft_total,
					(
						SELECT\n
							COUNT(*) AS outbox_total
						FROM
							lms_outbox
						WHERE
							user_id = " . $this->iUserId . "
					) AS outbox_total";
		
		return $this->DB->select($sSql, true);
	}
	
	public function selectOne($iFolderId)
	{
		$sSql = "SELECT\n" .
					"folder_id,\n" .
					"title\n" .
				"FROM\n" .
					"lms_folders\n" .
				"WHERE\n" .
					"user_id = " . $this->iUserId . "\n" .
				"AND\n" .
					"folder_id = " . $iFolderId;

		return $this->DB->select($sSql, true);
	}
	
	public function selectInboxUpdatedAt()
	{
		$sSql = "SELECT\n" .
					"time\n" .
				"FROM\n" .
					"lms_inbox\n" .
				"ORDER BY\n" .
					"time DESC\n" .
				"LIMIT 1";

		return $this->DB->select($sSql, true, "time");
	}
}

?>