<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "library/MSF_Recordset/MSF_Recordset.php";

class LMS_FoldersList
{
	private $Recordset;
	
	public function __construct()
	{
		$this->Recordset = new MSF_Recordset(MSF_Registry::get("MSF_DB"));
	}
	
	public function get($iLimitFrom = -1, $bExport = false)
	{
		$aActions 		= array();
		$aMultiActions 	= array();
		$aTypes 		= array("int", "string");
		$aTitles 		= array("ID", MSF_Registry::get("MSF_Locale")->getWord("LMS_TITLE_FOLDERS"));
		$aColumns 		= array("folder_id", "title");
		
		
		$aRColumns[0]["name"] 		= $aColumns[0];
		$aRColumns[0]["title"] 		= $aTitles[0];
		$aRColumns[0]["type"] 		= $aTypes[0];
		$aRColumns[0]["sort"] 		= true;
		$aRColumns[0]["filter"] 	= true;
		$aRColumns[0]["group"] 		= false;
		$aRColumns[0]["compare"] 	= "equal";
		$aRColumns[0]["visible"] 	= false;
		
		$aRColumns[1]["name"] 		= $aColumns[1];
		$aRColumns[1]["title"] 		= $aTitles[1];
		$aRColumns[1]["type"] 		= $aTypes[1];
		$aRColumns[1]["sort"] 		= true;
		$aRColumns[1]["filter"] 	= true;
		$aRColumns[1]["group"] 		= false;
		$aRColumns[1]["compare"] 	= "like";
		$aRColumns[1]["visible"] 	= true;
		
		
		$aActions[] = array(
			"title" 	=> MSF_Registry::get("MSF_Locale")->getWord("LMS_BTN_OPEN"),
			"href" 		=> "/lms/folder",
			"image" 	=> "/templates/" . CNF_SKIN . "/images/folder_page_white.png",
			"bind" 		=> array("folder_id"),
			"confirm" 	=> false
		);
		$aActions[] = array(
			"title" 	=> MSF_Registry::get("MSF_Locale")->getWord("LMS_BTN_OPEN_BLANK"),
			"href" 		=> "/lms/folder",
			"image" 	=> "/templates/" . CNF_SKIN . "/images/folder_page_white_blank.png",
			"bind" 		=> array("folder_id"),
			"confirm" 	=> false,
			"blank"		=> true
		);
		$aActions[] = array(
			"title" 	=> MSF_Registry::get("MSF_Locale")->getWord("LMS_BTN_EDIT"),
			"href" 		=> "/lms/folders/edit",
			"image" 	=> "/templates/" . CNF_SKIN . "/images/pencil.png",
			"bind" 		=> array("folder_id"),
			"confirm" 	=> false
		);
		$aActions[] = array(
			"title" 	=> MSF_Registry::get("MSF_Locale")->getWord("LMS_BTN_DELETE"),
			"href" 		=> "/lms/folders/remove",
			"image" 	=> "/templates/" . CNF_SKIN . "/images/red_cross.png",
			"bind" 		=> array("folder_id"),
			"confirm" 	=> true,
			"question"	=> MSF_Registry::get("MSF_Locale")->getWord("LMS_CONFIRM_FOLDER_DELETE")
		);
		
		$aMultiActions[] = array(
			"title" 	=> MSF_Registry::get("MSF_Locale")->getWord("LMS_BTN_DELETE"),
			"href" 		=> "/lms/folders/remove",
			"image"		=> "/templates/" . CNF_SKIN . "/images/red_cross.png",
			"confirm" 	=> true,
			"question"	=> MSF_Registry::get("MSF_Locale")->getWord("LMS_CONFIRM_FOLDER_DELETE")
		);
		
		$this->Recordset->setExport($bExport);		
		if ($iLimitFrom != - 1) {
			$this->Recordset->setParam ("limitFrom", $iLimitFrom);
		}
		
		$this->Recordset->setTables(array("lms_folders"));
 		$this->Recordset->setConditions(array(
 			"AND user_id = " . MSF_Registry::get("MSF_UserBox")->getUserAttribute("id"))
 		);
 		$this->Recordset->setLink(array(
 			"href" 	=> "/lms/folder",
 			"bind" 	=> array("folder_id")
 		));
 		$this->Recordset->setActions($aActions);
 		$this->Recordset->setMultiActions($aMultiActions);
 		$this->Recordset->setColumns($aRColumns);
 		$this->Recordset->setBaseURL("/lms/folders/?");
 		$this->Recordset->setMultiActionField("folder_id");
 		
 		return $this->Recordset->getAllRecords();
	}
}

?>