<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "LMS_Contstants.php";
include_once "library/MSF_SearchUtil/MSF_SearchUtil.php";
include_once 'library/MSF_SearchUtil/MSF_CsIndexedDB.php';

class LMS_MailDB extends MSF_ModelDBSupport
{
	private $iUserId 		= 0;
	
	private $sEmail 		= "";
	
	private $sSearchTable 	= "lms_index";
	
	private $iMessageId 	= 0;
	
	private $bDirect 		= false;
	
	private $DBRecord		= 0;
	
	public function __construct(MSF_DB $DB)
	{
		$this->DB 		= $DB;
		$this->iUserId 	= (int) MSF_Registry::get("MSF_UserBox")->getUserAttribute("id");
		$this->sEmail 	= MSF_Registry::get("MSF_UserBox")->getUserAttribute("email");
		$this->DBRecord = new MSF_CsIndexedDB('cs_indexed', 'indexed_id');
	}
	
	public function getNewMessageId()
	{
		return $this->iMessageId;
	}
	
	public function isDirect($bDirect)
	{
		$this->bDirect = (bool) $bDirect;
	}

	public function exists($iId, $iFolderId)
	{
		$sFolder = $this->getFolder($iFolderId);

		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"lms_" . $sFolder . "\n" .
				"WHERE\n" .
					"message_id = " . $iId . "\n" .
				"AND\n" .
					"user_id = " . $this->iUserId;

		return $this->DB->select($sSql, true, "total");
	}
	
	public function updateMark($sIds, $iFolderId, $sType)
	{
		$sFolder = $this->getFolder($iFolderId);
		
		$sSql = "UPDATE\n" .
					"lms_" . $sFolder . "\n" .
				"SET\n" .
					"status = '" . $sType . "'\n" .
				"WHERE\n" .
					"user_id = " . $this->iUserId . "\n" .
				"AND\n" .
					"message_id IN (" . $sIds . ")";
		
		$this->DB->executeQuery($sSql);
	}

	public function selectLast($iFolderId)
	{
		$sFolder = $this->getFolder($iFolderId);

		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"lms_" . $sFolder . " f,\n" .
					"lms_emails e\n" .
				"WHERE\n" .
					"f.email_id = e.email_id\n" .
				"AND\n" .
					"f.user_id = " . $this->iUserId . "\n" .
				"ORDER BY\n" .
					"f.message_id DESC";

		return $this->DB->select($sSql, true);
	}
	
	public function getEmailId($iFolderId, $iMailId)
	{
		$sIds 		= $iMailId;
		$sFolder 	= $this->getFolder($iFolderId);
		
		if (is_array($iMailId)) {
			$sIds[] 	= 0;
			$sIds 		= implode(",", $sIds);
		}
		
		$sSql = "SELECT
					email_id
				FROM
					lms_" . $sFolder . "
				WHERE
					message_id IN (" . $sIds . ")";
		
		if (is_array($iMailId)) {
			return $this->DB->select($sSql);
		}
		else {
			return $this->DB->select($sSql, true);
		}
	}
	
	public function updateAttachmets($iFolderId, $iMailId)
	{
		$sFolder = $this->getFolder($iFolderId);
		
		$sSql = "UPDATE
					lms_" . $sFolder . "
				SET
					attachments = 'N'
				WHERE
					message_id = " . $iMailId;
		
		$this->DB->executeQuery($sSql);
	}

	public function insert($aParams, $iFolderId)
	{
		$this->defineEmail($aParams);
		
		$sFolder 	= $this->getFolder($iFolderId);
		$aParams 	= $this->escapeHashValues($aParams);
		$sTable 	= "lms_" . $sFolder;

		$sSql = "INSERT INTO\n" .
					"lms_emails\n" .
				"(
					body"
					. ((isset($aParams["blocked"])) ? ",\nblocked" : "") . "
				)\n" .
				"values(
					'" . $aParams["body"] . "'"
					. ((isset($aParams["blocked"])) ? "\n," . $aParams["blocked"] : "") .
				")";

		$this->DB->executeQuery($sSql);
		$iEmailId = $this->DB->insertId("lms_emails", "email_id");

		$sSql = "INSERT INTO\n" .
					$sTable . "\n" .
				"(\n" .
					"email_id,\n" .
					"user_id,\n" .
					"headers,\n" .
					"encode,\n" .
					"from_email,\n" .
					"from_name,\n" .
					"time,\n" .
					"type,\n" .
					"subject,\n" .
					"to_email,\n" .
					"identifier,\n" .
					"size";
		
		if ($iFolderId < 1 || $iFolderId > 3) {
			$sSql .= ",\nexternal";
		}
		if ($sFolder == "messages") {
			$sSql .= ",\nfolder_id";
		}
		if (isset($aParams["attachments"])) {
			$sSql .= ",\nattachments";
		}

		$sSql .= "\n)\n" .
				"values(\n" .
					$iEmailId . ",\n" .
					$aParams["user_id"] . ",\n" .
					"'" . $aParams["headers"] . "',\n" .
					"'" . $aParams["encode"] . "',\n" .
//					"'" . $this->sEmail . "',\n" .
					"'" . $aParams["from_email"] . "',\n" .
					"'" . $aParams["from_name"] . "',\n" .
					"'" . $aParams["time"] . "',\n" .
					"'" . $aParams["type"] . "',\n" .
					"'" . $aParams["subject"] . "',\n" .
					"'" . $aParams["to"] . "',\n" .
					"'" . $aParams["identifier"] . "',\n" .
					$aParams["size"];

		if ($iFolderId < 1 || $iFolderId > 3) {
			$sSql .= ",\n'" . $aParams["external"]. "'";
		}
		if ($sFolder == "messages") {
			$sSql .= ",\n" . $iFolderId;
		}
		if (isset($aParams["attachments"])) {
			$sSql .= ",\n'" . $aParams["attachments"] . "'";
		}

		$sSql .= "\n)";
		$this->DB->executeQuery($sSql);
		$this->iMessageId = $this->DB->insertId($sTable, "message_id");
		
		
		if (!$this->DBRecord->findOperation($iFolderId, 'mail', 'index', $this->iMessageId)) {
			$this->DBRecord->insert(array('subject_id' => $this->iMessageId, 
									'module' => 'mail', 'operation' => 'index', 'context_id' => $iFolderId));
		}
		//MSF_SearchUtil::newInstance($aParams["body"])->createIndex($this->sSearchTable, LMS_Contstants::EMAIL, $iEmailId);
	//	MSF_SearchUtil::newInstance(
	//		$aParams["subject"] . " " .
	//		$aParams["from_name"] . " " .
	//		$aParams["to"] . " " .
	//		$this->sEmail . " " .
	//		$aParams["body"]
	//	)->createIndex($this->sSearchTable, $iFolderId, $this->iMessageId);
		return $iEmailId;
	}
	
	public function unBlock($iEmailId)
	{
		$sSql = "UPDATE
					lms_emails
				SET
					blocked = 0
				WHERE
					email_id = " . $iEmailId;
		
		$this->DB->executeQuery($sSql);
	}
	
	public function addFilesToSearch($aFileNames, $iFolderId, $iMessageId)
	{
		if (!$this->DBRecord->findOperation($iFolderId, 'mail', 'index', $this->iMessageId)) {
			$this->DBRecord->insert(array('subject_id' => $this->iMessageId, 
									'module' => 'mail', 'operation' => 'index', 'context_id' => $iFolderId));
		}
		//MSF_SearchUtil::newInstance(implode(" ", $aFileNames))->createIndex($this->sSearchTable, $iFolderId, $iMessageId);
	}

	public function open($iId, $iFolderId)
	{
		$sFolder 	= $this->getFolder($iFolderId);
		$sTable 	= "lms_" . $sFolder;

		if ($sFolder == "inbox" || $sFolder == "messages") {
			$sSql = "UPDATE\n" .
						$sTable . "\n" .
					"SET\n" .
						"status = 'viewed'\n" .
					"WHERE\n" .
						"message_id = '" . $iId . "'\n" .
					"AND\n" .
						"user_id = " . $this->iUserId;

			if ($sFolder == "messages") {
				$sSql .= "\nAND\nfolder_id = '" . $iFolderId . "'";
			}

			$this->DB->executeQuery($sSql);
		}

		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					$sTable . " f,\n" .
					"lms_emails e\n" .
				"WHERE\n" .
					"f.message_id = '" . $iId . "'\n" .
				"AND\n" .
					"f.email_id = e.email_id\n" .
				"AND\n" .
					"f.user_id = " . $this->iUserId;

		if ($sFolder == "messages") {
			$sSql .= "\nAND\nf.folder_id = '" . $iFolderId . "'";
		}
		
		return $this->DB->select($sSql, true);
	}

	public function update($iId, $aParams)
	{
		$this->defineEmail($aParams);
		$aParams = $this->escapeHashValues($aParams);
		
		$sSql = "SELECT\n
					email_id\n
				FROM\n
					lms_draft\n
				WHERE\n
					message_id = '" . $iId . "'";
		
		$iEmailId = $this->DB->select($sSql, true, "email_id");
		
		$sSql 	= "UPDATE" . "\n"
					. "lms_emails" . "\n"
				. "SET" . "\n"
					. "body = '" . $aParams['body'] . "'"
				. "WHERE" . "\n"
					. "email_id = " . $iEmailId;

		$this->DB->executeQuery($sSql);
		
		$sSql = "UPDATE\n" .
					"lms_draft\n" .
				"SET\n" .
					"headers 	= '" . $aParams['headers'] . "',\n" .
					"encode 	= '" . $aParams['encode'] . "',\n" .
					"from_name 	= '" . $aParams['from_name'] . "',\n" .
					"to_email 	= '" . $aParams['to'] . "',\n" .
					"time 		= '" . $aParams['time'] . "',\n" .
					"subject 	= '" . $aParams['subject'] . "'\n" .
				"WHERE\n" .
					"message_id = '" . $iId . "'\n" .
				"AND\n" .
					"from_email = '" . $aParams['from_email'] . "'";
					//"from_email = '" . $this->sEmail . "'";

		$this->DB->executeQuery($sSql);
		if (!$this->DBRecord->findOperation(LMS_Contstants::EMAIL, 'mail', 'index', $iEmailId)) {
			$this->DBRecord->insert(array('subject_id' => $iEmailId, 
									'module' => 'mail', 'operation' => 'index', 'context_id' => LMS_Contstants::EMAIL));
		}
		if (!$this->DBRecord->findOperation(LMS_Contstants::DRAFT, 'mail', 'index', $iId)) {
			$this->DBRecord->insert(array('subject_id' => $iId, 
									'module' => 'mail', 'operation' => 'index', 'context_id' => LMS_Contstants::DRAFT));
		}
		if (!$this->DBRecord->findOperation(LMS_Contstants::EMAIL, 'mail', 'index', $iEmailId)) {
			$this->DBRecord->insert(array('subject_id' => $iEmailId, 
									'module' => 'mail', 'operation' => 'index', 'context_id' => LMS_Contstants::EMAIL));
		}
		
		//MSF_SearchUtil::newInstance()->removeIndex($this->sSearchTable, LMS_Contstants::EMAIL, $iEmailId);
		//MSF_SearchUtil::newInstance()->removeIndex($this->sSearchTable, LMS_Contstants::DRAFT, $iId);
		//MSF_SearchUtil::newInstance($aParams["body"])->createIndex($this->sSearchTable, LMS_Contstants::EMAIL, $iEmailId);
		//MSF_SearchUtil::newInstance(
		//	$aParams["from_name"] . " " .
		//	$aParams["to"] . " " .
		//	$aParams["subject"] . " " .
		//	$this->sEmail . " " .
		//	$aParams["body"]
		//)->createIndex($this->sSearchTable, LMS_Contstants::DRAFT, $iId);
	}

	public function delete($mId, $iFolderId)
	{
		$aIds 		= array();
		$sSql 		= "";
		$sFolder 	= $this->getFolder($iFolderId);
		$sTable 	= "lms_" . $sFolder;
		$UserBox 	= MSF_Registry::get("MSF_UserBox");
		$bSave 		= (
			trim($UserBox->getUserAttribute("email_pop3_password")) != "" &&
			trim($UserBox->getUserAttribute("email_pop3_address")) != ""
		) ? true : false;
		/*
		$bSave 		= (
			$UserBox->getUserAttribute("email_send_copy") == 1 &&
			trim($UserBox->getUserAttribute("email_send_copy")) != "" &&
			trim($UserBox->getUserAttribute("email_smtp_password")) != "" &&
			trim($UserBox->getUserAttribute("email_smtp_address")) != ""
		) ? true : false;
		*/
		
		if (is_array($mId)) {
			foreach ($mId as $iId) {
				if (!$this->DBRecord->findOperation($iFolderId, 'mail', 'remove', $iId)) {
					$this->DBRecord->insert(array('subject_id' => $iId, 
									'module' => 'mail', 'operation' => 'remove', 'context_id' => $iFolderId));
				}
				//MSF_SearchUtil::newInstance()->removeIndex($this->sSearchTable, $iFolderId, $iId);
			}
			$mId = implode(",", $mId);
		}
		else {
			if (!$this->DBRecord->findOperation($iFolderId, 'mail', 'remove', $mId)) {
				$this->DBRecord->insert(array('subject_id' => $mId, 
									'module' => 'mail', 'operation' => 'remove', 'context_id' => $iFolderId));
			}
			//MSF_SearchUtil::newInstance()->removeIndex($this->sSearchTable, $iFolderId, $mId);
		}
		
		if ($sFolder == "trash") {
			$sSql = "SELECT\n" .
						"*\n" .
					"FROM\n" .
						"lms_trash\n" .
					"WHERE\n" .
						"message_id IN (" . $mId . ")\n" .
					"AND\n" .
						"user_id = '" . $this->iUserId . "'";

			$aRes 	= $this->DB->select($sSql);
			$iSize 	= count($aRes);

			$this->DB->executeQuery("PREPARE preparedInsert (
				integer, text, character varying(40)
			) AS
			INSERT INTO lms_remote_deleted (
				user_id, headers, identifier
			)
			VALUES (
				$1, $2, $3
			)");
			
			for ($i = 0; $i < $iSize; $i++) {
				$aIds[] = $aRes[$i]["email_id"];
				
				if ($aRes[$i]["external"] == "Y" || (!empty($aRes[$i]["identifier"]) && $bSave)) {
					$sSql = "EXECUTE preparedInsert (
								" . $aRes[$i]["user_id"] . ",
								'" . $aRes[$i]["headers"] . "',
								'" . $aRes[$i]["identifier"] . "'
							)";
					
					$this->DB->executeQuery($sSql);
				}
				if (!$this->DBRecord->findOperation(LMS_Contstants::EMAIL, 'mail', 'remove', $aRes[$i]["email_id"])) {
					$this->DBRecord->insert(array('subject_id' => $aRes[$i]["email_id"], 
									'module' => 'mail', 'operation' => 'remove', 'context_id' => LMS_Contstants::EMAIL));
				}
				//MSF_SearchUtil::newInstance()->removeIndex($this->sSearchTable, LMS_Contstants::EMAIL, $aRes[$i]["email_id"]);
			}
			
			$this->DB->executeQuery("DEALLOCATE preparedInsert");
			
			if (!empty($aIds)) {
				$sSql = "DELETE FROM\n" .
							"lms_emails\n" .
						"WHERE\n" .
							"email_id IN (" . implode(",", $aIds) . ")";

				$this->DB->executeQuery($sSql);
			}

			$sSql = "DELETE FROM\n" .
						"lms_trash\n" .
					"WHERE\n" .
						"message_id IN (" . $mId . ")\n" .
					"AND\n" .
						"user_id = '" . $this->iUserId . "'";

			$this->DB->executeQuery($sSql);
		}
		else {
			$sSql = "SELECT\n" .
						"*\n" .
					"FROM\n" .
						$sTable . "\n" .
					"WHERE\n" .
						"message_id IN (" . $mId . ")\n" .
					"AND\n" .
						"user_id = " . $this->iUserId;

			if ($sFolder == "messages") {
				$sSql .= "\nAND\nfolder_id = '" . $iFolderId . "'";
			}

			$aRes = $this->DB->select($sSql);

			$this->DB->executeQuery("PREPARE preparedInsert (
				integer, integer, integer, text, character varying(50), character varying(255), character varying(255),
				text, timestamp without time zone, character varying(255), character varying(50), character(1), character(1),
				integer, character varying(40)
			) AS
			INSERT INTO lms_trash (
				email_id, folder_restore_id, user_id, headers, encode, from_email, from_name, to_email, time, subject,
				type, attachments, external, size, identifier
			)
			VALUES (
				$1, $2, $3, $4, $5, $6, $7, $8, $9, $10, $11, $12, $13, $14, $15
			)");
			
			for ($i = 0; $i < count($aRes); $i++) {
				$aIds[] 	= $aRes[$i]["email_id"];
				$aRes[$i] 	= $this->escapeHashValues($aRes[$i]);

				$sSql = "EXECUTE\n" .
							"preparedInsert\n" .
						"(\n" .
							$aRes[$i]["email_id"] . ",\n" .
							$iFolderId . ",\n" .
							$aRes[$i]["user_id"] . ",\n" .
							"'" . $aRes[$i]["headers"] . "',\n" .
							"'" . $aRes[$i]["encode"] . "',\n" .
							"'" . $aRes[$i]["from_email"] . "',\n" .
							"'" . $aRes[$i]["from_name"] . "',\n" .
							"'" . $aRes[$i]["to_email"] . "',\n" .
							"'" . $aRes[$i]["time"] . "',\n" .
							"'" . $aRes[$i]["subject"] . "',\n" .
							"'" . $aRes[$i]["type"] . "',\n" .
							"'" . $aRes[$i]["attachments"] . "',\n" .
							"'" . ((isset($aRes[$i]["external"])) ? $aRes[$i]["external"] . "',\n" : "',\n") .
							$aRes[$i]["size"] . ",\n" .
							"'" . $aRes[$i]["identifier"] . "'\n" .
						")";
				
				$this->DB->executeQuery($sSql);
				if (!$this->DBRecord->findOperation(LMS_Contstants::TRASH, 'mail', 'index', $this->DB->insertId("lms_trash", "message_id"))) {
					$this->DBRecord->insert(array('subject_id' => $this->DB->insertId("lms_trash", "message_id"), 
									'module' => 'mail', 'operation' => 'index', 'context_id' => LMS_Contstants::TRASH));
				}
			//	MSF_SearchUtil::newInstance(
			//		$aRes[$i]["from_email"] . " " .
			//		$aRes[$i]["from_name"] . " " .
			//		$aRes[$i]["subject"] . " " .
			//		$aRes[$i]["to_email"] . " " .
			//		$this->DB->select("SELECT body FROM lms_emails WHERE email_id = " . $aRes[$i]["email_id"], true, "body")
			//	)->createIndex($this->sSearchTable, LMS_Contstants::TRASH, $this->DB->insertId("lms_trash", "message_id"));
			}
			
			$this->DB->executeQuery("DEALLOCATE preparedInsert");

			$sSql = "DELETE FROM\n" .
						$sTable . "\n" .
					"WHERE\n" .
						"message_id IN (" . $mId . ")\n" .
					"AND\n" .
						"user_id = " . $this->iUserId;

			if ($sFolder == "messages") {
				$sSql .= "\nAND\nfolder_id = '" . $iFolderId . "'";
			}

			$this->DB->executeQuery($sSql);
		}

		return $aIds;
	}

	public function forceDelete($mId, $iFolderId)
	{
		$aIds 		= array();
		$sFolder 	= $this->getFolder($iFolderId);
		$sTable 	= "lms_" . $sFolder;

		if (is_array($mId)) {
			foreach ($mId as $iId) {
				
				if (!$this->DBRecord->findOperation($iFolderId, 'mail', 'remove', $iId)) {
					$this->DBRecord->insert(array('subject_id' => $iId, 
									'module' => 'mail', 'operation' => 'remove', 'context_id' => $iFolderId));
				}
			}
			$mId = implode(",", $mId);
		}
		else {
			if ($mId && $iFolderId) {
				if (!$this->DBRecord->findOperation($iFolderId, 'mail', 'remove', $mId)) {
					$this->DBRecord->insert(array('subject_id' => $mId, 
										'module' => 'mail', 'operation' => 'remove', 'context_id' => $iFolderId));
				}
			}
		}

		$sSql = "SELECT\n" .
					"email_id\n" .
				"FROM\n" .
					$sTable . "\n" .
				"WHERE\n" .
					"message_id IN (" . $mId . ")\n" .
				"AND\n" .
					"user_id = '" . $this->iUserId . "'";

		$aRes 	= $this->DB->select($sSql);
		$iSize 	= count($aRes);

		for ($i = 0; $i < $iSize; $i++) {
			$aIds[] = $aRes[$i]["email_id"];
		}

		if (!empty($aIds)) {
			$sSql = "DELETE FROM\n" .
						"lms_emails\n" .
					"WHERE\n" .
						"email_id IN (" . implode(",", $aIds) . ")";

			$this->DB->executeQuery($sSql);
		}

		$sSql = "DELETE FROM\n" .
					$sTable . "\n" .
				"WHERE\n" .
					"message_id IN (" . $mId . ")\n";

		$this->DB->executeQuery($sSql);
		
		return $aIds;
	}

	public function restore($mId)
	{
		$aFolderIds = array();
		$aEmailIds 	= array();
		if (is_array($mId)) {
			$mId = implode(",", $mId);
		}

		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"lms_trash\n" .
				"WHERE\n" .
					"message_id IN (" . $mId . ")";

		$aRes = $this->DB->select($sSql);
		
		for ($i = 0; $i < count($aRes); $i++) {
			$aFolderIds[] 				= $aRes[$i]["folder_restore_id"];
			$sFolder 					= $this->getFolder($aRes[$i]["folder_restore_id"]);
			$sTable 					= "lms_" . $sFolder;
			$aEmailIds[$i]["email_id"] 	= $aRes[$i]["email_id"];
			$aRes[$i] 					= $this->escapeHashValues($aRes[$i]);
			
			$sSql = "INSERT INTO\n" .
						$sTable . "\n" .
					"(\n" .
						"email_id,\n" .
						"user_id,\n" .
						"headers,\n" .
						"encode,\n" .
						"from_email,\n" .
						"from_name,\n" .
						"to_email,\n" .
						"time,\n" .
						"subject,\n" .
						"type,\n" .
						"attachments,\n" .
						"size,\n" .
						"identifier,\n" .
						"status" .
						(($sFolder == "messages") ? "\n,folder_id\n" : "\n") .
						((isset($aRes[$i]["external"])) ? "\n,external\n" : "\n") .
					")\n" .
					"VALUES(\n" .
						$aRes[$i]["email_id"] . ",\n" .
						$aRes[$i]["user_id"] . ",\n" .
						"'" . $aRes[$i]["headers"] . "',\n" .
						"'" . $aRes[$i]["encode"] . "',\n" .
						"'" . $aRes[$i]["from_email"] . "',\n" .
						"'" . $aRes[$i]["from_name"] . "',\n" .
						"'" . $aRes[$i]["to_email"] . "',\n" .
						"'" . $aRes[$i]["time"] . "',\n" .
						"'" . $aRes[$i]["subject"] . "',\n" .
						"'" . $aRes[$i]["type"] . "',\n" .
						"'" . $aRes[$i]["attachments"] . "',\n" .
						$aRes[$i]["size"] . ",\n" .
						"'" . $aRes[$i]["identifier"] . "',\n" .
						"'" . $aRes[$i]["status"] . "'" .
						(($sFolder == "messages") ? ",\n" . $aRes[$i]["folder_restore_id"] . "\n" : "\n") .
						((isset($aRes[$i]["external"])) ? ",\n'" . $aRes[$i]["external"] . "'\n" : "\n") .
					")";

			$this->DB->executeQuery($sSql);
			
			$sSql = "DELETE FROM\n" .
						"lms_trash\n" .
					"WHERE\n" .
						"message_id = " . $aRes[$i]["message_id"];
		
			$this->DB->executeQuery($sSql);
			$iMessageId = $this->DB->insertId($sTable, "message_id");
			
			if (!$this->DBRecord->findOperation($aRes[$i]["folder_restore_id"], 'mail', 'remove', $aRes[$i]["message_id"])) {
				$this->DBRecord->insert(array('subject_id' => $aRes[$i]["folder_restore_id"], 
								'module' => 'mail', 'operation' => 'remove', 'context_id' => $aRes[$i]["message_id"]));
			}
			if (!$this->DBRecord->findOperation(LMS_Contstants::TRASH, 'mail', 'index', $aRes[$i]["message_id"])) {
				$this->DBRecord->insert(array('subject_id' => $aRes[$i]["message_id"], 
								'module' => 'mail', 'operation' => 'index', 'context_id' => LMS_Contstants::TRASH));
			}
	//		MSF_SearchUtil::newInstance()->removeIndex($this->sSearchTable, LMS_Contstants::TRASH, $aRes[$i]["message_id"]);
	//		MSF_SearchUtil::newInstance(
	//			$aRes[$i]["from_email"] . " " .
	//			$aRes[$i]["from_name"] . " " .
	//			$aRes[$i]["to_email"] . " " .
	//			$aRes[$i]["subject"] . " " .
	//			$this->DB->select("SELECT body FROM lms_emails WHERE email_id = " . $aRes[$i]["email_id"], true, "body")
	//		)->createIndex($this->sSearchTable, $aRes[$i]["folder_restore_id"], $iMessageId);
		}
		
		return array("folders" => $aFolderIds, "emails" => $aEmailIds);
	}

	public function move($mId, $iFolderId, $iToFolderId)
	{
		$sFolder 	= $this->getFolder($iFolderId);
		$sTable 	= "lms_" . $sFolder;

		if (is_array($mId)) {
			foreach ($mId as $iId) {
				if (!$this->DBRecord->findOperation($iFolderId, 'mail', 'remove', $iId)) {
					$this->DBRecord->insert(array('subject_id' => $iId, 
									'module' => 'mail', 'operation' => 'remove', 'context_id' => $iFolderId));
				}
				//MSF_SearchUtil::newInstance()->removeIndex($this->sSearchTable, $iFolderId, $iId);
			}
			$mId = implode(",", $mId);
		}
		else {
			foreach (explode("," , $mId) AS $iId) {
				if (!$this->DBRecord->findOperation($iFolderId, 'mail', 'remove', $iId)) {
					$this->DBRecord->insert(array('subject_id' => $iId, 
									'module' => 'mail', 'operation' => 'remove', 'context_id' => $iFolderId));
				}
			}
			//MSF_SearchUtil::newInstance()->removeIndex($this->sSearchTable, $iFolderId, $mId);
		}

		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					$sTable . "\n" .
				"WHERE\n" .
					"message_id IN (" . $mId . ")\n" .
				"AND\n" .
					"user_id = " . $this->iUserId;

		if ($sFolder == "messages") {
			$sSql .= "\nAND\nfolder_id = '" . $iFolderId . "'";
		}

		$aRes 		= $this->DB->select($sSql);
		$sFolder2 	= $this->getFolder($iToFolderId);
		$sTable2 	= "lms_" . $sFolder2;

		for ($i = 0; $i < count($aRes); $i++) {
			$aRes[$i] = $this->escapeHashValues($aRes[$i]);
			
			$sSql = "INSERT INTO\n" .
						$sTable2 . "\n" .
					"(\n" .
						"email_id,\n" .
						"user_id,\n" .
						"headers,\n" .
						"encode,\n" .
						"from_email,\n" .
						"from_name,\n" .
						"to_email,\n" .
						"time,\n" .
						"subject,\n" .
						"type,\n" .
						"attachments,\n" .
						"external,\n" .
						"status,\n" .
						"size,\n" .
						"identifier" .
						(($sFolder2 == "messages") ? ",\nfolder_id\n"  : "\n") .
					")\n" .
					"VALUES(\n" .
						$aRes[$i]["email_id"] . ",\n" .
						$aRes[$i]["user_id"] . ",\n" .
						"'" . $aRes[$i]["headers"] . "',\n" .
						"'" . $aRes[$i]["encode"] . "',\n" .
						"'" . $aRes[$i]["from_email"] . "',\n" .
						"'" . $aRes[$i]["from_name"] . "',\n" .
						"'" . $aRes[$i]["to_email"] . "',\n" .
						"'" . $aRes[$i]["time"] . "',\n" .
						"'" . $aRes[$i]["subject"] . "',\n" .
						"'" . $aRes[$i]["type"] . "',\n" .
						"'" . $aRes[$i]["attachments"] . "',\n" .
						"'" . $aRes[$i]["external"] . "',\n" .
						"'" . (($sFolder2 == "trash") ? "viewed" : $aRes[$i]["status"]) . "',\n" .
						$aRes[$i]["size"] . ",\n" .
						"'" . $aRes[$i]["identifier"] . "'" .
						(($sFolder2 == "messages") ? ",\n" . $iToFolderId . "\n" : "\n") .
					")";
			
			$this->DB->executeQuery($sSql);
			if (!$this->DBRecord->findOperation($this->DB->insertId($sTable2, "message_id"), 'mail', 'index', $iToFolderId)) {
				$this->DBRecord->insert(array('subject_id' => $this->DB->insertId($sTable2, "message_id"), 
								'module' => 'mail', 'operation' => 'index', 'context_id' => $iToFolderId));
			}
		//	MSF_SearchUtil::newInstance(
		//		$aRes[$i]["from_email"] . " " .
		//		$aRes[$i]["from_name"] . " " .
		//		$aRes[$i]["to_email"] . " " .
		//		$aRes[$i]["subject"] . " " .
		//		$this->DB->select("SELECT body FROM lms_emails WHERE email_id = " . $aRes[$i]["email_id"], true, "body")
		//	)->createIndex($this->sSearchTable, $iToFolderId, $this->DB->insertId($sTable2, "message_id"));
		}
		
		$sSql = "DELETE FROM\n" .
					"lms_" . $sFolder . "\n" .
				"WHERE\n" .
					"message_id IN (" . $mId . ")";
		
		$this->DB->executeQuery($sSql);
	}

	public function getFolderId($sString, $sEmail)
	{
		$sSql = "SELECT\n" .
					"folder_id\n" .
				"FROM\n" .
					"lms_folders\n" .
				"WHERE\n" .
					"user_id = (
						SELECT\n
							user_id\n
						FROM\n
							users\n
						WHERE\n
							email = '" . $this->escapeValue($sEmail) . "'
					)\n" .
				"AND\n" .
					"title LIKE '%" . $this->escapeValue($sString) . "%'";

		$aRes = $this->DB->select($sSql, true);

		return ((isset($aRes['folder_id'])) ? $aRes['folder_id'] : -1);
	}

	private function getFolder($iFolderId)
	{
		$sFolder = "";

		switch ($iFolderId) {
			case -1:
			case 0:
				$sFolder = "inbox";
				break;
			case 1:
				$sFolder = "outbox";
				break;
			case 2:
				$sFolder = "sent";
				break;
			case 3:
				$sFolder = "draft";
				break;
			case 4:
				$sFolder = "trash";
				break;
			default:
				$sFolder = "messages";
				break;
		}

		return $sFolder;
	}
	
	public function insertId($sTable, $sIdName)
	{
		return $this->DB->insertId($sTable, $sIdName);
	}
	
	private function defineEmail($aParams)
	{
		if ($this->bDirect && isset($aParams["from_email"])) {
			$this->sEmail = $aParams["from_email"];
		}
	}
	
	public function deleteUserMessages($iUserId) 
	{
		$aBoxes = array(0=>"inbox", 1=>"outbox", 2=>"sent", 3=>"draft", 4=>"trash", 5=>"messages");
		for ($i=0; $i<sizeof($aBoxes); $i++) {
			$sSql = "SELECT " . 
						"message_id " . 
					"FROM " .
						"lms_" . $aBoxes[$i] . " " .
					"WHERE " .
						"user_id = " . $iUserId;
			$aTmp = $this->DB->select($sSql);
			if (!empty($aTmp)) {
				foreach ($aTmp as $aMessage) {
					foreach ($aMessage as $iMessage) {
						if ($i==5) {
							$iFolder = $this->getFolderByMessageId($iMessage); 
						}
						else {
							$iFolder = $i;
						}
						$this->forceDelete($iMessage, $iFolder);
					}
				}
				$aTmp = array();
			}
		}
		
		$sSql = "DELETE " .
				"FROM " . 
					"lms_folders " . 
				"WHERE " .
					"user_id = " . $iUserId;
		$this->DB->executeQuery($sSql);

	}
	
	private function getFolderByMessageId($iMessage) {
		$iResult = 0;
		$sSql = "SELECT " .
					"folder_id " .
				"FROM " . 
					"lms_messages " . 
				"WHERE " .
					"message_id = " . $iMessage . " " . 
				"LIMIT 1";
		$aTmp = $this->DB->select($sSql);
		if (!empty($aTmp)) {
			foreach ($aTmp as $aMessage) {
				$iResult = (int) $aMessage["folder_id"];
			}	
		}
		return $iResult;
	}

}

?>