<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "library/MSF_Recordset/MSF_Recordset.php";
include_once "LMS_MailListDB.php";
include_once "LMS_FoldersDB.php";

class LMS_MailList
{
	private $Recordset 		= null;

	private $sFolderTitle 	= "";

	private $iUserId 		= 0;

	private $sUserEmail 	= "";

	private $DIL 			= null;
	
	private $FDB 			= null;

 	public function __construct()
 	{
 		$this->DIL 			= new LMS_MailListDB();
 		$this->FDB 			= new LMS_FoldersDB(MSF_Registry::get("MSF_DB"));
 		$this->Recordset 	= new MSF_Recordset(MSF_Registry::get("MSF_DB"), MSF_Registry::get("MSF_Template"));
 		$this->iUserId 		= MSF_Registry::get("MSF_UserBox")->getUserAttribute("id");
		$this->sUserEmail 	= MSF_Registry::get("MSF_UserBox")->getUserAttribute("email");
 	}

 	public function exists($iFolderId)
 	{
 		$aSystemFolders = array(0, 1, 2, 3, 4);

 		if (in_array($iFolderId, $aSystemFolders)) {
 			return true;
 		}

 		return ($this->DIL->exists($iFolderId) == 1) ? true : false;
 	}

 	public function open($iFolderId, $iLimitFrom = -1, $bExport = false, $bSaveState = true)
 	{
 		$this->mailList($iFolderId, $iLimitFrom, $bExport, $bSaveState);
		return $this->Recordset->getAllRecords();
 	}
 	
 	public function group($iFolderId)
 	{
  		$this->mailList($iFolderId);
 		return $this->Recordset->getGroup();
 	}
 	
 	private function mailList($iFolderId, $iLimitFrom = -1, $bExport = false, $bSaveState = true)
 	{
 		$Locale 	= MSF_Registry::get("MSF_Locale");
 		$sFolder 	= $this->getFolder($iFolderId);
 		$aActions 	= array();
		$aTypes		= array("int", "string", "string", "timestamp", "int", "");
 		$aTitles 	= array("id", array($Locale->getWord("LMS_AUTHOR_TBL"), $Locale->getWord("LMS_RECIPIENT_TBL")), $Locale->getWord("LMS_SUBJECT_TBL"), $Locale->getWord("LMS_DATE_TBL"), $Locale->getWord("LMS_SIZE_TBL"), "");
 		$aColumns 	= array("message_id", "from_name", "subject", "time", "size", "status");
 		$aInvisible = array("message_id", "status");
 		$aRColumns 	= array();

 		if ($iFolderId == 1 || $iFolderId == 2 || $iFolderId == 3) {
 			$aColumns[1] = "to_email";
 		}
 		
 		if ($iFolderId == 1 || $iFolderId == 0) {
 			$this->Recordset->setLmsHookOn($this->iUserId, 'lms_' . $this->getFolder($iFolderId), $iFolderId == 0 ? 'from_name' : 'to_email');
 		}
		
 		for ($i = 0; $i < sizeof($aTitles); $i++) {
 			$aRColumns[$i]["title"] 	= $aTitles[$i];
	 		$aRColumns[$i]["name"] 		= $aColumns[$i];
			$aRColumns[$i]["type"] 		= $aTypes[$i];
	 		$aRColumns[$i]["sort"] 		= true;
	 		$aRColumns[$i]["filter"] 	= true;
	 		$aRColumns[$i]["group"] 	= ($aColumns[$i] == "from_name" || $aColumns[$i] == "to_email") ? true : false;
	 		$aRColumns[$i]["visible"] 	= true;
	 		
	 		if($aColumns[$i] == "time") {
	 			$aRColumns[$i]["compare"] 	= "equal";
	 		}
	 		else {
	 			$aRColumns[$i]["compare"] 	= "like";
	 		}
	 		
 			if (($iFolderId == 1 || $iFolderId == 2 || $iFolderId == 3) && is_array($aTitles[$i])) {
 				$aRColumns[$i]["title"] = $aTitles[$i][1];
 			}
 			elseif (is_array($aTitles[$i])) {
 				$aRColumns[$i]["title"] = $aTitles[$i][0];
 			}
	 		if (in_array($aColumns[$i], $aInvisible)) {
	 			$aRColumns[$i]["visible"] = false;
	 		}
 		}
		
		if ($iFolderId == LMS_Mail::DRAFT) {
			$aActions[] = array(
				"title" 	=> $Locale->getWord("LMS_BTN_EDIT"),
				"href" 		=> "/lms/mail/edit/" . $iFolderId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/pencil.png",
				"bind" 		=> array("message_id"),
				"confirm" 	=> ""
			);
		}
		else {
			$aActions[] = array(
				"title" 	=> $Locale->getWord("LMS_BTN_OPEN"),
				"href" 		=> "/lms/mail/view/" . $iFolderId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/folder_page_white.png",
				"bind" 		=> array("message_id"),
				"confirm" 	=> ""
			);
			$aActions[] = array(
				"title" 	=> MSF_Registry::get("MSF_Locale")->getWord("LMS_BTN_OPEN_BLANK"),
				"href" 		=> "/lms/mail/view/" . $iFolderId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/folder_page_white_blank.png",
				"bind" 		=> array("message_id"),
				"confirm" 	=> "",
				"blank"		=> true
			);
		}
		
 		if ($iFolderId == LMS_Mail::INBOX || $iFolderId > LMS_Mail::TRASH) {
			$aActions[] = array(
				"title" 	=> $Locale->getWord("LMS_TITLE_REPLY"),
				"href" 		=> "/lms/mail/reply/" . $iFolderId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/email_reply.png",
				"bind" 		=> array("message_id"),
				"confirm" 	=> ""
			);
			$aActions[] = array(
				"title" 	=> $Locale->getWord("LMS_TITLE_FORWARD"),
				"href" 		=> "/lms/mail/forward/" . $iFolderId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/email_forward.png",
				"bind" 		=> array("message_id"),
				"confirm" 	=> ""
			);
			$aMultiActions[] = array(
				"title" 	=> $Locale->getWord("LMS_BTN_MARK"),
				"href" 		=> "/lms/mail/mark/" . $iFolderId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/email.png",
				"confirm" 	=> ""
			);
			$aMultiActions[] = array(
				"title" 	=> $Locale->getWord("LMS_BTN_UNMARK"),
				"href" 		=> "/lms/mail/unmark/" . $iFolderId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/email_open.png",
				"confirm" 	=> ""
			);
		}
		
		if ($iFolderId == LMS_Mail::TRASH) {
			$aActions[] = array(
				"title" 	=> $Locale->getWord("LMS_BTN_RESTORE"),
				"href" 		=> "/lms/mail/restore/" . $iFolderId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/folder_page_white.png",
				"bind" 		=> array("message_id"),
				"confirm" 	=> ""
			);
			$aActions[] = array(
				"title" 	=> $Locale->getWord("LMS_BTN_DELETE"),
				"href" 		=> "/lms/mail/remove/" . $iFolderId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/red_cross.png",
				"bind" 		=> array("message_id"),
				"confirm" 	=> true,
				"question" 	=> $Locale->getWord("LMS_CONFIRM_DELETE_MESSAGE")
			);
			$aMultiActions[] = array(
	 			"title"		=> $Locale->getWord("LMS_BTN_RESTORE"),
				"href"		=> "/lms/mail/restore/" . $iFolderId,
				"image"		=> "/templates/" . CNF_SKIN . "/images/folder_page_white.png",
				"confirm"	=> false,
				"question" 	=> ""
	 		);
			$aMultiActions[] = array(
	 			"title"		=> $Locale->getWord("LMS_BTN_DELETE"),
				"href"		=> "/lms/mail/remove/" . $iFolderId,
				"image"		=> "/templates/" . CNF_SKIN . "/images/red_cross.png",
				"confirm"	=> true,
				"question" 	=> $Locale->getWord("LMS_CONFIRM_DELETE_MESSAGE_")
	 		);
		}
		else {
			$aActions[] = array(
				"title" 	=> $Locale->getWord("LMS_BTN_DELETE"),
				"href" 		=> "/lms/mail/remove/" . $iFolderId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/red_cross.png",
				"bind" 		=> array("message_id"),
				"confirm" 	=> true
			);
			$aMultiActions[] = array(
	 			"title"		=> $Locale->getWord("LMS_BTN_DELETE"),
				"href"		=> "/lms/mail/remove/" . $iFolderId,
				"image"		=> "/templates/" . CNF_SKIN . "/images/red_cross.png",
				"confirm"	=> true
	 		);
		}
		
		$aMark = array(
			"field" 	=> "status",
			"condition" => "=",
			"argument" 	=> "new"
		);
		
 		$this->Recordset->setExport($bExport);		
		if ($iLimitFrom != - 1) {
			$this->Recordset->setParam ("limitFrom", $iLimitFrom);
		}
		
		$this->Recordset->setMarkParams($aMark);
		$this->Recordset->setTables(array("lms_" . $sFolder));
 		$sCond = "";
		if ($sFolder == "messages") {
			$sCond = "AND folder_id = " . $iFolderId;
		}
		$this->Recordset->setConditions(array(
			"AND user_id = " . $this->iUserId,
			"AND status != 'deleted'" .
			$sCond
		));
		$this->Recordset->setLink(array(
			"href" 	=> "/lms/mail/view/" . $iFolderId,
			"bind" 	=> array("message_id")
		));
		if ($bSaveState) {
			$this->Recordset->setStateParams(array(
				"module"		=> "lms",
				"action"		=> "show",
				"action_id"		=> $iFolderId,
				"structure_id"	=> MSF_Registry::get("MSF_UserBox")->getUserAttribute("id")
			));			
		}

		$this->Recordset->setRpcUrl("/lms/folder/" . $iFolderId . "/ajaxrequest/?");
		$this->Recordset->setActions($aActions);
		$this->Recordset->setColumns($aRColumns);
		$this->Recordset->setMultiActions($aMultiActions);
 		$this->Recordset->setMultiActionField("message_id");
 		$this->Recordset->setBaseURL("/lms/folder/" . $iFolderId . "/?");
 		$this->Recordset->setDefaultOrder("message_id");
 		$this->Recordset->setSecondaryOrder("message_id");
 		$this->Recordset->setDefaultDirection("desc");
 		$this->Recordset->enableContextSearch("lms_index", "message_id", $iFolderId);
  	}

 	private function getFolder($iFolderId)
	{
		$sFolder = "";

		switch ($iFolderId) {
			case LMS_Mail::INBOX:
				$sFolder 			= "inbox";
				$this->sFolderTitle = MSF_Registry::get("MSF_Locale")->getWord("INBOX");
				break;
			case LMS_Mail::OUTBOX:
				$sFolder 			= "outbox";
				$this->sFolderTitle = MSF_Registry::get("MSF_Locale")->getWord("OUTBOX");
				break;
			case LMS_Mail::SENT:
				$sFolder 			= "sent";
				$this->sFolderTitle = MSF_Registry::get("MSF_Locale")->getWord("SENT");
				break;
			case LMS_Mail::DRAFT:
				$sFolder 			= "draft";
				$this->sFolderTitle = MSF_Registry::get("MSF_Locale")->getWord("DRAFT");
				break;
			case LMS_Mail::TRASH:
				$sFolder 			= "trash";
				$this->sFolderTitle = MSF_Registry::get("MSF_Locale")->getWord("TRASH");
				break;
			default:
				$sFolder 			= "messages";
				$this->sFolderTitle = $this->DIL->getFolderTitle($iFolderId);
		}

		return $sFolder;
	}

	public function getFolderTitle()
	{
		return $this->sFolderTitle;
	}

}

?>