<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:template match="/page/module">
		<script src="/modules/references/view/js/REF_SaveHandler.js"></script>		
		<script>
			registerEvent(function() {
				new REF_SaveHandler($("mail_form"), $("send_button"), $("login_layer"), "send");
				new REF_SaveHandler($("mail_form"), $("drafts_button"), $("login_layer"), "save");
			});	
		</script>		
		<script type="text/javascript">
			WindowHandler.attachHandlers();
		</script>	
		<script>
			registerEvent(function() {
				new MSFW.Placeholder.MailBook({
	                             "Container" : "container_ref_addresses",
	                             "inputName" : "addresses",
	                             "default" : "<xsl:value-of select="item/@to"/>"
	                        });
				new MSFW.Placeholder.MailBook({
	                             "Container" : "container_ref_cc",
	                             "inputName" : "cc",
	                             "default" : "<xsl:value-of select="item/@cc"/>"
	                        });
				new MSFW.Placeholder.MailBook({
	                             "Container" : "container_ref_bcc",
	                             "inputName" : "bcc",
	                             "default" : "<xsl:value-of select="item/@bcc"/>"
	                        });
	            if ("<xsl:value-of select="item/@cc"/>") {
	            	LMS_Functions.addCC($("link_cc"));
	            }
	            if ("<xsl:value-of select="item/@bcc"/>") {
	            	LMS_Functions.addBCC($("link_bcc"));
	            }
			});
		</script>
		<form id="mail_form" method="post" enctype="multipart/form-data" onsubmit="LMS_Functions.disabledSubm()">
			<div style="display:none;">
				<div id="login_layer" style="padding:5pt;">							
					<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
					<table cellpadding="5pt">
						<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
						<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
						<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
					</table>	
				</div>
			</div>
			<table class="form">
				<tr>
					<td class="form-row-title">
						<b><xsl:value-of select="$LMS_TO"/></b>
					</td>
					<td class="form-row-value">
						<div id="container_ref_addresses"></div>
						<a id="link_cc" href="#" onclick="LMS_Functions.addCC(this); return false"><xsl:value-of select="$LMS_LINK_ADD_CC"/></a>
						<a id="link_bcc" href="#" onclick="LMS_Functions.addBCC(this); return false"><xsl:value-of select="$LMS_LINK_ADD_BCC"/></a>
					</td>
				</tr>
				<tr id="lms_cc_cont" style="display:none">
					<td class="form-row-title">
						<xsl:value-of select="$LMS_CC"/>
					</td>
					<td class="form-row-value">
						<div id="container_ref_cc"></div>
					</td>
				</tr>
				<tr id="lms_bcc_cont" style="display:none">
					<td class="form-row-title">
						<xsl:value-of select="$LMS_BCC"/>
					</td>
					<td class="form-row-value">
						<div id="container_ref_bcc"></div>
					</td>
				</tr>
				<tr>
					<td class="form-row-title">
						<b><xsl:value-of select="$LMS_SUBJECT"/></b>
					</td>
					<td class="form-row-value">
						<input type="text" name="subject" maxlength="255" style="width: 93%" value="{item/@subject}"/>
					</td>
				</tr>
				<tr>
					<td class="form-row-title"><xsl:value-of select="$LMS_FILES"/></td>
					<td class="form-row-value">
						<xsl:if test="item/@attachments='Y'">
							<div style="padding-bottom: 15px; padding-left: 15px">
								<xsl:for-each select="files/item">
									<div class="lmsAttachedFile">
										<xsl:value-of select="@name"/>
										............
										<a href="#">
											<xsl:attribute name="onclick">
												return LMS_Functions.removeFile(this.parentNode)
											</xsl:attribute>
											<xsl:value-of select="$LMS_LINK_DELETE_FILE"/>
										</a>
										<input type="hidden" name="lms_attached_files[]" value="{@id}"/>
									</div>
								</xsl:for-each>
							</div>
						</xsl:if>
						<div id="lms_files_container">
						</div>
						<div style="padding-left: 15px">
							<a href="#">
								<xsl:attribute name="onclick">
									LMS_Functions.addFileField(
										"lms_files_container",
										"lms_files[]",
										"<xsl:value-of select="$LMS_LINK_DELETE_FILE"/>",
										this
									); return false
								</xsl:attribute>
								<xsl:value-of select="$LMS_LINK_ADD_FILE"/>
							</a>
						</div>
					</td>
				</tr>
			</table>
			<table class="form">
				<tr>
					<td class="form-row-value">
						<xsl:value-of select="$LMS_TEXT"/>
					</td>
				</tr>
				<tr>
					<td colspan="2" class="form-row-value">
						<div class="body-container">
							<textarea name="body" id="msf_lms_ta" class="body">
								<xsl:value-of select="item/@body"/>
							</textarea>
						</div>
						<script>
							//tinymce.PluginManager.add('wfdocs', 	null);
							tinymce.PluginManager.add('msffiles', 	null);
							initRte("msf_lms_ta", null, {remove_script_host: false});
						</script>
					</td>
				</tr>
				<tr>
					<td class="form-row-value">
						<div style="margin-right:10px; float:left">
							<input id="send_button" type="button">
								<xsl:attribute name="value">
									<xsl:value-of select="$LMS_BTN_SEND"/>
								</xsl:attribute>
							</input>
						</div>
						<div style="float:left">
							<input id="drafts_button" type="button">
								<xsl:attribute name="value">
									<xsl:value-of select="$LMS_BTN_SAVE"/>
								</xsl:attribute>
							</input>
						</div>
						<input type="hidden" id="onsubmit_mail_action" name="action"/>
					</td>
				</tr>
			</table>
		</form>
	</xsl:template>
</xsl:stylesheet>