<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:template match="/page/module">
		<table class="form">
			<tr>
				<td class="form-row-title">
					<xsl:value-of select="$LMS_FROM"/>
				</td>
				<td class="form-row-value">
					<xsl:value-of select="item/@from"/>
				</td>
			</tr>
			<tr>
				<td class="form-row-title">
					<xsl:value-of select="$LMS_TO"/>
				</td>
				<td class="form-row-value">
					<xsl:value-of select="item/@to" disable-output-escaping="yes"/>
					<xsl:if test="item/@hide_to != ''">
						<span id="hide_to" style="display:none;">,
							<xsl:value-of select="item/@hide_to" disable-output-escaping="yes"/>
						</span>
						<span style="cursor: pointer; color: #CCCCCC;" onclick="$('hide_to').toggle(); $(this).hide();">
							<xsl:value-of select="$LMS_VISIBLE_ALL"/>
						</span>
					</xsl:if>
					
				</td>
			</tr>
			<xsl:choose>
				<xsl:when test="item/@cc=''">
				</xsl:when>
				<xsl:otherwise>
					<tr>
						<td class="form-row-title">
							<xsl:value-of select="$LMS_CC"/>
						</td>
						<td class="form-row-value">
							<xsl:value-of select="item/@cc"/>
						</td>
					</tr>
				</xsl:otherwise>
			</xsl:choose>
			<tr>
				<td class="form-row-title">
					<xsl:value-of select="$LMS_DATE"/>
				</td>
				<td class="form-row-value">
					<xsl:value-of select="item/@time"/>
				</td>
			</tr>
			<xsl:choose>
				<xsl:when test="item/@subject=''">
				</xsl:when>
				<xsl:otherwise>
					<tr>
						<td class="form-row-title">
							<xsl:value-of select="$LMS_SUBJECT"/>
						</td>
						<td class="form-row-value">
							<xsl:value-of select="item/@subject"/>
						</td>
					</tr>
				</xsl:otherwise>
			</xsl:choose>
		</table>
		<table class="form">
			<tr>
				<td class="form-row-value">
					<xsl:value-of select="$LMS_TEXT"/>
				</td>
			</tr>
			<tr>
				<td class="form-row-value">
					<xsl:value-of select="item/@body" disable-output-escaping="yes"/>
					<br/>
					<br/>
					<xsl:for-each select="files/item">
						<hr/>
						<xsl:if test="@image='Y'">
						
							<a href="/media/download/{@id}" >
								<img src="/media/image/{@id}/{@image_size}/{@image_size}" border="0"/>
							</a><br/>
						</xsl:if>
						<xsl:value-of select="@name"/>&#xA0;(<xsl:value-of select="@type"/>, <xsl:value-of select="@size"/>)
						<br/>
						<!--  target="_blank" -->
						<a href="/media/download/{@id}">
							<xsl:value-of select="$LMS_LINK_DOWNLOAD"/>
						</a>&#xA0;<a href="#">
							<xsl:attribute name="onclick">return LMS_Functions.removeAttachedFile('/lms/mail/view/<xsl:value-of select="/page/module/@folder_id"/>/<xsl:value-of select="/page/module/@message_id"/>/file/remove/<xsl:value-of select="@id"/>')</xsl:attribute>
							<xsl:value-of select="$LMS_BTN_DELETE"/>
						</a><br/><br/>
					</xsl:for-each>
				</td>
			</tr>
		</table>
		<xsl:if test="@show_move_to='yes'">
			<br/>
			<form method="post" action="/lms/mail/moveto/{@folder_id}/{@message_id}">
				<xsl:value-of select="$LMS_TITLE_MOVE_TO"/>
				<select name="folder_id" style="margin-left: 10px">
					<xsl:for-each select="folders/item">
						<xsl:if test="@moveto='yes'">
							<xsl:if test="@selected='no'">
								<option value="{@folder_id}">
									<xsl:value-of select="@title"/>
								</option>
							</xsl:if>
						</xsl:if>
					</xsl:for-each>
				</select>
				<input type="button" value="OK" style="margin-left: 5px;" onclick="LMS_Functions.moveTo(this.form, true)"/>
			</form>
		</xsl:if>
	</xsl:template>
</xsl:stylesheet>