<?php

defined("__MSF") or die("Direct access is not allowed");

include_once CNF_ABS_PATH . "/library/MSF_Recordset/MSF_RecordsetXml.php";

class LMS_ListXml extends MSF_RecordsetXml
{
	public function viewFolder($aResult, $aFolders, $iFolderId)
	{
		$this->Template->addLink("/modules/lms/view/templates/" . CNF_SKIN . "/style/lms.css", "text/css");
		$bCheck = false;
		
		for ($i = 0; $i < count($aFolders); $i++) {
			if ($iFolderId != LMS_Mail::INBOX || $aFolders[$i]["folder_id"] > LMS_Mail::TRASH) {
				$bCheck = true;
				break;
			}
		}
		
		if (($iFolderId == LMS_Mail::INBOX || $iFolderId > LMS_Mail::TRASH) && $bCheck) {
			$this->Root->setAttribute("show_move_to", "yes");
		}
		else {
			$this->Root->setAttribute("show_move_to", "no");
		}
		
		try {
			$this->buildRecordset($aResult);
		}
		catch (Exception $e) {}
		$this->Template->addLink("/modules/lms/view/js/LMS_Functions.js", "text/javascript");
		$this->Template->addXslPath("/modules/lms/view/templates/" . CNF_SKIN . "/folder.xsl");
		$this->Root->appendChild(MSF_SL::hashlist2dom("folders", "item", $aFolders));
		$this->addAction($this->getWord("LMS_LINK_NEW_LETTER"), "/lms/mail/create");
		$this->addAction($this->getWord("LMS_TITLE_MY_FOLDERS"), "/lms/folders");
		$this->addAction($this->getWord("LMS_TITLE_ADDRESS_BOOK"), "/lms/addresses");
		if ($iFolderId == LMS_Mail::TRASH) {
			$this->addAction(
				$this->getWord("LMS_LINK_CLEAR_TRASH"),
				"/lms/folder/clear/" . $iFolderId,
				"",
				"return confirm(\"" . $this->getWord("LMS_MESSAGE_CLEAR_TRASH") . "\")"
			);
		}
	}
}

?>