<?php

defined("__MSF") or die("Direct access is not allowed");

class LMS_Xml extends MSF_ViewSupportXml
{
	public function viewOne($aResult, $iFolderId, $aFolders, $iMailId)
	{

		$this->addAction($this->getWord("LMS_LINK_NEW_LETTER"), "/lms/mail/create", "", "", false, "right");
		
		if (!empty($aResult)) {
			$sHost 				= $_SERVER["SERVER_NAME"];
			$RefTemplate 		= new REF_Template($this->Template->getXml());
			$aResult["body"] 	= $RefTemplate->hrefActivate($aResult["body"]);
			$aResult["body"] 	= preg_replace("{href=.htt(p|ps)://(?!$sHost)[^>]+}", "$0 target='_blank'", $aResult["body"]);
			$aResult["body"] 	= str_replace(array("<pre>", "</pre>"), "", $aResult["body"]);
			$aResult["body"]	= preg_replace('@<form[^>]*?>.*?</form>@si', '', $aResult["body"]);
			$aResult["body"]	= MSF_String::breakingLongWords($aResult["body"]);
			$aResult["to"]		= MSF_String::breakingLongWords(htmlspecialchars($aResult["to"]));
			
			$aResult["hide_to"] = "";
			$aShowAndHideTo		= array();
			$aTo				= explode(", ", $aResult["to"]);
			if (count($aTo) > 10) {
				foreach ($aTo AS $iKey => $sValue) {
					if ($iKey < 10) {
						$aShowAndHideTo["visible"][] = $sValue;
					}
					else {
						$aShowAndHideTo["hide"][] 	 = $sValue;
					}
				}
				$aResult["to"] 		= implode(", ", $aShowAndHideTo["visible"]);
				$aResult["hide_to"] = implode(", ", $aShowAndHideTo["hide"]);
			}
			
			$sConfirmMessage 	= $this->getWord("LMS_CONFIRM_MESSAGE");
			$bCheck = false;
			
			for ($i = 0; $i < count($aFolders); $i++) {
				if ($iFolderId != LMS_Mail::INBOX || $aFolders[$i]["folder_id"] > LMS_Mail::TRASH) {
					$bCheck = true;
					break;
				}
			}
			
			if (($iFolderId == LMS_Mail::INBOX || $iFolderId > LMS_Mail::TRASH) && $bCheck) {
				$this->Root->setAttribute("show_move_to", "yes");
			}
			else {
				$this->Root->setAttribute("show_move_to", "no");
			}
			
			$this->Root->setAttribute("folder_id", $iFolderId);
			$this->Root->setAttribute("message_id", $iMailId);
			
			$this->addFiles($aResult["files"]);
			unset($aResult["files"]);
			$this->Root->appendChild(MSF_SL::hash2dom("item", $aResult));
			$this->Template->addLink("/modules/lms/view/js/LMS_Functions.js", "text/javascript");
			$this->Template->addXslPath("/modules/lms/view/templates/" . CNF_SKIN . "/view.xsl");
			
			$this->Root->appendChild(MSF_SL::hashlist2dom("folders", "item", $aFolders));
			
			if ($iFolderId != LMS_Mail::OUTBOX && $iFolderId != LMS_Mail::SENT) {
				$this->addAction($this->getWord("LMS_TITLE_REPLY"), "/lms/mail/reply/" . $iFolderId . "/" . $aResult["message_id"]);
			}
			if ($iFolderId != LMS_Mail::OUTBOX) {
				$this->addAction($this->getWord("LMS_TITLE_FORWARD"), "/lms/mail/forward/" . $iFolderId . "/" . $aResult["message_id"]);
			}
			
			
			if ($iFolderId == LMS_Mail::TRASH) {
				$this->addAction($this->getWord("LMS_BTN_RESTORE"), "/lms/mail/restore/" . $iFolderId . "/" . $aResult["message_id"]);
				$sConfirmMessage = $this->getWord("LMS_CONFIRM_DELETE_MESSAGE");
			}
			
			$this->addAction(
				$this->getWord("LMS_BTN_DELETE"),
				"/lms/mail/remove/" . $iFolderId . "/" . $aResult["message_id"],
				"",
				"return confirm('" . $sConfirmMessage . "');"
			);
		}
		else {
			$this->Template->addXslPath("/modules/lms/view/templates/" . CNF_SKIN . "/empty.xsl");
		}
		
		$this->addAction($this->getWord("LMS_LINK_CLOSE"), "/lms/folder/" . $iFolderId);
	}

	public function editOne($aResult, $iFolderId)
	{
		if (!empty($aResult)) {
			if (isset($aResult["files"])) {
				$this->addFiles($aResult["files"]);
				unset($aResult["files"]);
			}
			$this->Root->appendChild(MSF_SL::hash2dom("item", $aResult));
			$this->Root->setAttribute("folder_id", $iFolderId);
			$this->Root->setAttribute("message_id", $aResult["message_id"]);
		}

		$this->addAction($this->getWord("LMS_LINK_NEW_LETTER"), "/lms/mail/create", "", "", true, "right");
		$this->addAction($this->getWord("LMS_LINK_CLOSE"), "/lms/folder/" . $iFolderId, "", "", false);
		$this->addAction($this->getWord("LMS_BTN_SEND"), "", "", "$('send_button').click(); return false;");
		$this->addAction($this->getWord("LMS_BTN_SAVE"), "", "", "$('drafts_button').click(); return false;");
		$this->addLinksOf("references");
		$this->Template->addLink("/modules/lms/view/js/LMS_Functions.js", "text/javascript");
		$this->Template->addXslPath("/modules/lms/view/templates/" . CNF_SKIN . "/edit.xsl");
	}
	
	private function addFiles($aFiles)
	{
		if (!empty($aFiles)) {
			$Files = $this->Template->createElement("files");
			
			for ($i = 0; $i < sizeof($aFiles); $i++) {
				$sSize = "";
				$iSize = $aFiles[$i]["size"]/1024;
				
				if ($iSize < 1024) {
					if ($iSize < 1) {
						$iSize = 1;
					}
					$sSize = number_format($iSize, 1) . " Kb";
				}
				elseif ($iSize >= 1024) {
					$sSize = number_format($iSize/1024, 1) . " Mb";
				}
				
				$Item = $this->Template->createElement("item");
				$Item->setAttribute("id", $aFiles[$i]["file_id"]);
				$Item->setAttribute("name", $aFiles[$i]["name"]);
				$Item->setAttribute("link", $aFiles[$i]["link"]);
				$Item->setAttribute("type", $aFiles[$i]["type"]);
				$Item->setAttribute("size", $sSize);
				if ($this->isImage($aFiles[$i]["type"])) {
					$Item->setAttribute("image", "Y");
					
					$aSize = getimagesize(CNF_ABS_PATH . "/" . str_replace(CNF_ABS_PATH, "", $aFiles[$i]["directory"] . "/" . $aFiles[$i]["file_id"]));
					if ((isset($aSize[0]) && $aSize[0] > 150) || (isset($aSize[1]) && $aSize[1] > 150)) {
						$Item->setAttribute("image_size", 150);
					}
				}
				else {
					$Item->setAttribute("image", "N");
				}
				$Files->appendChild($Item);
			}
			
			$this->Root->appendChild($Files);
		}
	}
	
	private function isImage($sType)
	{
		$bResult 	= false;
		$aType 		= explode("/", $sType);
		
		if (!empty($aType) && $aType[0] == "image") {
			$bResult = true;
		}
		
		return $bResult;
	}
}

?>