<?php

/**
 * Memory for developers
 * - Uses MSF_Registry::get("MSF_DB")
 */
class MSF_RefUtils 
{
	
	/**
	 * @return {phys_name1 => title1,..,phys_nameN => titleN} 
     */
	public static function getFieldsOfReference($iRefId) 
	{
		static $aCache 	= array();
		$aResult		= array();
		if (!isset($aCache[$iRefId])) {
			$oDb 				= new UserReferenceDB(MSF_Registry::get("MSF_DB"));
			$aCache[$iRefId] 	= $oDb->load($iRefId);
		}

		foreach (MSF_XmlWrapper::xmlToArray($aCache[$iRefId]["columns"]) 
				AS $sName => $aBody) {
			$aResult[$sName] = $aBody["title"];
		}
		
		return $aResult;
	}
	
	/**
	 * @return string
	 */
	public static function getTitleOfField($iRefId, $sColumn)
	{
		$aFields = self::getFieldsOfReference($iRefId);
		return MSF_SL::getParam($aFields, $sColumn, null);
	} 
	
}