<?php

if (!defined("__MSF")) {
    die("Direct access not allowed");
}

include_once "MD_DetrixImage.php";

class MD_Image {

    private $Image = null;
    private $aInfo = array();
    private $sType = "";

    public function __construct($sImage) {
        $this->Image = new MD_DetrixImage($sImage);
    }

    public function resize($sPath, $x = 0, $y = 0) {
        $aSize = $this->scaleImage(
                $this->Image->getImageWidth(), $this->Image->getImageHeight(), $x, $y
        );

        $this->Image->resizeImage($aSize[0], $aSize[1]);

        $this->Image->saveImage($sPath);
    }

    private function scaleImage($iWidth, $iHeight, $x, $y) {
        if ($x == 0 && $y == 0) {
            $iNewHeight = $iHeight;
            $iNewWidth = $iWidth;
        } else {
            if ($x == 0) {
                $x = $iWidth;
            }

            if ($y == 0) {
                $y = $iHeight;
            }

            $iNewWidth = $x;
            $iNewHeight = ($iNewWidth / $iWidth) * $iHeight;

            if ($iNewHeight > $y) {
                $tmpHeight = $iNewHeight;
                $iNewHeight = $y;
                $iNewWidth = ($iNewHeight / $tmpHeight) * $iNewWidth;
            }
        }

        return array($iNewWidth, $iNewHeight);
    }

}

?>