<?php
/**
 * 
 */
class WF_MediaId 
{
	/**
	 * @var integer media id
	 */
	private $iMediaId = 0;

	/**
	 * 
	 */
	public function __construct()
	{
		if (!$this->isSaved()) {
			$this->generate();
		}
		else {
			$this->load();
		}
		
	}

	/**
	 * @return void
   	 */
	public function generate()
	{
		$this->iMediaId = time();
		if ($this->uniqueMediaId()) {
			$this->save();		
		}
		else {
			$this->generate();
		}
		
	}
	
	private function uniqueMediaId()
	{
		$oMediaDb = new MD_MediaDB(MSF_Registry::get("MSF_DB"));
		
		if ($oMediaDb->countMediaId($this->iMediaId) > 0) return false;
		return true; 
	}
	
	public function isSaved()
	{
		return array_key_exists("WF_MediaId", $_SESSION);
	}
	
	public function load()
	{
		$this->iMediaId = $_SESSION["WF_MediaId"];
	} 
	
	/**
	 * @return integer
   	 */
	public function get()
	{
		return $this->iMediaId;
	}
	
	public function remove()
	{
		unset($_SESSION["WF_MediaId"]);
	}

	public function save($iMediaId = null)
	{
		if ($iMediaId == null) {
			$_SESSION["WF_MediaId"] = $this->iMediaId;
		}
		else {
			$_SESSION["WF_MediaId"] = (int)$iMediaId;
		}
		
	}
	
}
?>