<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "modules/profile/view/xml/ProfileXml.php";
include_once "modules/references/library/Reference/UserReferenceDB.php";
include_once "modules/references/library/Reference/UserReference.php";

include_once "cs/mail/library/LMS_Pop3.php";
include_once "cs/mail/library/LMS_Pop3DB.php";

include_once "Mail.php";
include_once "Mail/smtp.php";
include_once "Mail/mime.php";

class MSF_FrontController extends MSF_ControllerSupport
{
	private $Ref;
	
	private $iUserId;
	
	private $View;
	
	public function __construct()
	{
		$this->Ref 		= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
		$this->iUserId 	= MSF_Registry::get("MSF_UserBox")->getUserAttribute("id");
		$this->View 	= new ProfileXml();
		$this->Ref->load(1);
		parent::__construct();
	}
	
	public function indexAction()
	{
		$this->addAction($this->locale("PROFILE_LINK_CHANGE_PASSWORD"), "/profile/password");
		$this->actionProfile();
		$this->Template->setPageTitle($this->locale("PROFILE_MODULE_TITLE"));
	}
	
	public function passwordAction()
	{
		$this->addAction($this->locale("PROFILE_LINK_CLOSE"), "/profile");
		$this->actionPassword();
		$this->Template->setPageTitle(
			$this->locale("PROFILE_MODULE_TITLE") .
			$this->locale("ROOT_TITLE_SEPARATOR") .
			$this->locale("PROFILE_PASS_TITLE")
		);
	}
	
	public function changepostAction()
	{
		$sRedirect 	= isset($_SERVER["HTTP_REFERER"]) ? $_SERVER["HTTP_REFERER"] : "/profile";
		$sRedirect 	= '/profile';
		$sReferer	= MSF_SL::getParam($_SERVER, 'HTTP_REFERER');
		if (!strstr($sReferer, 'profile/changepost')) {
			$sRedirect = $sReferer;
		}
		
		$aUserBox 	= $_SESSION["MSF_UserBox"];
		$iPostId 	= $this->getIntParam(0);
		$iIndex 	= -1;
		$iSize 		= count($aUserBox["posts"]);
		$aPostIds 	= array(0);
		for ($i = 0; $i < $iSize; $i++) {
			$aPostIds[] = $aUserBox["posts"][$i]["id"];
		}
		
		for ($i = 0; $i < $iSize; $i++) {
			if ($aUserBox["posts"][$i]["id"] == $iPostId) {
				$iIndex = $i;
				break;
			}
			
		}
		
		if ($iIndex > -1) {
			
			$aUserBox["currentPostId"] 						= $iPostId;
			$aUserBox["currentStructureId"] 				= $aUserBox["structure"]["id_list"][$iIndex];
			$aUserBox["currentStructurePath"] 				= $aUserBox["structure"]["paths_list"][$iIndex];
			// Redesign
			//try {
				$aPath 										= explode('.', $aUserBox["currentStructurePath"]);
				$iStrSubDivId								= MSF_SL::getParam($aPath, count($aPath) - 2, 0);
				$oFacade									= MSF_OrgStructureFacade::getInstance();
				$aSubDiv									= $oFacade->getSubdivisionByStructureId($iStrSubDivId);
				if (isset($aSubDiv[0])) {
					$aUserBox['structure']['subdivision'] 		= MSF_SL::getParam($aSubDiv[0],'value','');
					$aUserBox['structure']['subdivision_id'] 	= $oFacade->getSubdivisionIdByStructureId($iStrSubDivId);
				}
			//}
			//catch (ReferenceException $oE) {
			//	MSF_Logger::logTrace($oE);
			//}
			
			$_SESSION["MSF_UserBox"] 					= $aUserBox;
			$this->applyLastPost(implode(",", $aPostIds), $iPostId);
		}	
		
		$this->redirect($sRedirect);
	}
	
	private function applyLastPost($sPostIds, $iPostId)
	{
		$DB = MSF_Registry::get("MSF_DB");
		
		$sSql = "UPDATE
					ref_system_posts
				SET
					last_selected = 0
				WHERE
					id IN (" . $sPostIds . ")";
		
		$DB->executeQuery($sSql);
		
		$sSql = "UPDATE
					ref_system_posts
				SET
					last_selected = 1
				WHERE
					id = " . $iPostId;
		
		$DB->executeQuery($sSql);
	}
	
	private function actionPassword()
	{
		if (IS_REQUEST) {
			$sNewPassword 	= (string) MSF_SL::getParam($_POST, "new_password");
			$sConfPassword 	= (string) MSF_SL::getParam($_POST, "confirm_password");
			$sOldPassword 	= (string) MSF_SL::getParam($_POST, "current_password");
			
			if (empty($sNewPassword)) {
				$this->addError($this->locale("PROFILE_MESSAGE_EMPTY_NEW_PASSWORD"));
			}
			elseif ($sNewPassword != $sConfPassword) {
				$this->addError($this->locale("PROFILE_MESSAGE_CONFIRM_PASSWORD"));
			}
			else {
				$sPassword 	= "";
				$aParams 	= $this->Ref->row($this->iUserId)->show();
			
				for ($i = 0; $i < count($aParams); $i++) {
					if ($aParams[$i]["name"] == "password") {
						$sPassword = $aParams[$i]["value"];
						break;
					}
				}
				
				
				if (empty($sOldPassword)) {
					$this->addError($this->locale("PROFILE_MESSAGE_EMPTY_PASSWORD"));
				}
				elseif ($sPassword != MSF_String::encrypt($sOldPassword)) {
					$this->addError($this->locale("PROFILE_MESSAGE_WRONG_PASSWORD"));
				}
				else {
					$aResult = array();
					
					for ($i = 0; $i < count($aParams); $i++) {
						$sValue = $aParams[$i]["value"];
						if ($aParams[$i]["name"] == "password") {
							$sValue = MSF_String::encrypt($sNewPassword);
						}
						$aResult[$aParams[$i]["name"]] = $sValue;
					}
										
					if ($this->Ref->row($this->iUserId)->save($aResult)) {
						$this->redirect("/profile", $this->locale("PROFILE_PASSWORD_SAVED"));
						return;
					}
					
				}
				
			}
			
		}
		
		$this->View->editPass();
		$this->setView($this->View);
	}
	
	private function actionProfile()
	{
		$aParams = $this->Ref->row($this->iUserId)->show();
		$Fields	= new REF_Fields($this->Ref->getFieldsXml());
		
		foreach($aParams as $aParam) {
			$Fields->set($aParam["name"], $aParam["value"]);
		}
		
		
		if (IS_REQUEST) {
			$aRequest 		= $this->prepareRequest();
			foreach($aRequest as $sKey=>$mValue) {
				if ($sKey == "email_pop3_password" || $sKey == "email_smtp_password") {
					if (($mValue["main"] == $mValue["confirm"]) && ($mValue["main"] == ":!")) {
						$Fields->set($sKey, $Fields->get($sKey));
					}
					else {
						$Fields->set($sKey, $mValue);
					}
					
				}
				else {
					$Fields->set($sKey, $mValue);
				}
				
			}

			if ($this->Ref->row($this->iUserId)->save($Fields->getAsHash())) {
				foreach($Fields->getAsHash() as $k => $v) {
					if($k != "id") {
						$_SESSION["MSF_UserBox"]["user"][$k] = $v;
					}
					
				}
				
				$this->redirect("/profile", $this->locale("PROFILE_MESSAGE_SAVED"));
			}
			
			for ($i = 0; $i < count($aParams); $i++) {
				foreach ($aRequest as $k => $v) {
					if ($aParams[$i]["name"] == $k) {
						$aParams[$i]["value"] = $v;
					}
					
				}
				
			}
			
		}
		
		$this->View->edit($Fields);
		$this->setView($this->View);
	}
	
	private function prepareRequest()
	{
		$aParams	= array();
		
		$aParams["email"] 					= MSF_SL::getParam($_POST, "email");
		$aParams["language"] 					= MSF_SL::getParam($_POST, "language");
		$aParams["email_pop3_login"] 		= MSF_SL::getParam($_POST, "email_pop3_login");
		
		$aParams["email_pop3_password"]["main"] 	= MSF_SL::getParam($_POST, "email_pop3_password");
		$aParams["email_pop3_password"]["confirm"] 	= MSF_SL::getParam($_POST, "email_pop3_password");
		
		//chtobi polya zashifrovali parol
		$aParams["email_pop3_address"] 		= MSF_SL::getParam($_POST, "email_pop3_address");
		$aParams["email_smtp_login"] 		= MSF_SL::getParam($_POST, "email_smtp_login");
		
		$aParams["email_smtp_password"]["main"] 	= MSF_SL::getParam($_POST, "email_smtp_password");
		$aParams["email_smtp_password"]["confirm"] 	= MSF_SL::getParam($_POST, "email_smtp_password");
		
		$aParams["email_smtp_address"] 		= MSF_SL::getParam($_POST, "email_smtp_address");
		$aParams["email_send_copy"] 		= (MSF_SL::getParam($_POST, "email_send_copy") == "on") ? 1 : 0;
		$aParams["email_remove_on_recieve"] = (MSF_SL::getParam($_POST, "email_remove_on_recieve") == "on") ? 1 : 0;
		$aParams["records_per_page"]		= MSF_SL::getParam($_POST, "records_per_page");
		$aParams["email_template"]			= MSF_SL::getParam($_POST, "email_template");
		
		$Fields								= new REF_Fields($this->Ref->getFieldsXml());
		$aToolbarStatus 					= $Fields->getField("toolbar_status");
		$iToolValue							= MSF_SL::getParam($_POST, "toolbar_status");
		$aParams["toolbar_status"] 			= $aToolbarStatus["optional"]["enum"][$iToolValue] . "|^|row|^|" . $iToolValue;
		$aParams["toolbar_template"] 		= $_POST["toolbar_template"];
		
		$aParams["start_page_type"] 		= MSF_SL::getParam($_POST, "start_page_type", 1);
		$aParams["page_url"] 				= MSF_SL::getParam($_POST, "page_url");
		
		return $aParams;
	}
	
	
	public function checkPOP3Action()
	{
		// 0 - error, 2 - busy, 1 - valid
		$Reciever 	= new Net_POP3();
		$sPwd		= MSF_SL::getParam($_POST, 'pop3Password');
		if ($sPwd == ':!') {
			$oUbox					= MSF_Registry::get('MSF_UserBox');
			$sPwd = MSF_String::decrypt($oUbox->getUserAttribute('email_pop3_password'));
		}
		$sPop3Login	= MSF_SL::getParam($_POST, 'pop3Login');
		$sEmail		= MSF_SL::getParam($_POST, 'email');
		$aHost 		= parse_url(MSF_SL::getParam($_POST, 'pop3Host'));
		
		if (isset($aHost["path"])) {
			$aHost["host"] = $aHost["path"];
		}
		if (isset($aHost["scheme"]) && $aHost["scheme"] == "ssl") {
			$aHost["host"] = "ssl://" . $aHost["host"];
		}
		try {
			if (isset($aHost["port"])) {
				$Reciever->connect($aHost["host"], $aHost["port"]);
			}
			else {
				$Reciever->connect($aHost["host"]);
			}
	
			$Conn = $Reciever->login($sPop3Login, $sPwd);
			
			if (PEAR::isError($Conn)) {
				echo 0;
			}
			else {
				echo 1;
			}
		}
		catch (Exception $e) {
			echo 2;
		}
	}
	
	public function checkSMTPAction() 
	{
		$aHost 					= parse_url(MSF_SL::getParam($_POST, 'smtpHost'));
		$aParams 				= array();
		$aParams['auth'] 		= true;
		$aParams['username'] 	= MSF_SL::getParam($_POST, 'smtpLogin');
		$oUbox					= MSF_Registry::get('MSF_UserBox');
		$iUid					= (int)$oUbox->getUserAttribute('id');
		$aParams['password']	= MSF_SL::getParam($_POST, 'smtpPassword');
		if ($aParams['password'] == ':!') {
			$aParams['password'] = MSF_String::decrypt($oUbox->getUserAttribute('email_smtp_password'));
		}
		
		$aParams['timeout'] 	= 10;
		$aParams['persist'] 	= true;
		if (isset($aHost['path'])) {
			$aParams['host'] = $aHost['path'];
		}
		else {
			$aParams['host'] = $aHost['host'];
		}
		
		if (isset($aHost['port'])) {
			$aParams['port'] = $aHost['port'];
		}
		
		if (isset($aHost['scheme']) && ($aHost['scheme'] == 'tls' || $aHost['scheme'] == 'ssl')) {
			$aParams['host'] = $aHost['scheme'] . '://' . $aParams['host'];
		}
		
		$oSmpt 	= Mail::factory('smtp', $aParams);
		try {
			$oMail 	= $oSmpt->send(
					'', 
					array(
							'From' 		=> '', 
							'To' 		=> '', 
							'Subject' 	=> '', 
							'Cc' 		=> '',
							'Reply-To' 	=> ''
							),
					'');

			if (PEAR::isError($oMail)) {
		        if ($oMail->getCode() == 10004) {
		        	echo 1;
		        }
		        else {
					echo 0;
		        }   
		    }
		    else {
				echo 0;
		    }
		}
		catch (Exception $e) {
			echo 2;
		}
		
	}
	
}

?>