<?php

defined("__MSF") or die("Direct access is not allowed");

class ProfileXml extends MSF_ViewSupportXml
{
	public function edit(REF_Fields $Params)
	{
		$Item = $this->Template->createElement("item");
		foreach($Params->getAsHash() as $sKey=>$mValue) {
			if(in_array($sKey, array("email_send_copy", "email_remove_on_recieve", "records_per_page", "start_page_type"))) {
				$aTmp	= MSF_EnumValue::parse($mValue);
				if($aTmp) {
					$mValue	= $aTmp["key"];
				}
				else {
					$mValue	= 0;
				}
			}
			elseif(in_array($sKey, array("email_pop3_password", "email_smtp_password")) && $mValue != "") {
				$mValue	= MSF_String::decrypt($mValue);
			}

			try {
				$Item->setAttribute($sKey, $this->stripAllASlashes($mValue));
			}
			catch (Exception $oE) {
				MSF_Logger::logTrace($oE);
			}
			
		}
		
		$Records	= $this->Template->createElement("records_enum_values");
		foreach($Params->getAsList() as $aParam) {
			if(in_array($aParam["name"], array("records_per_page"))) {
				foreach($aParam["optional"]["enum"] as $sKey=>$mValue) {
					$EV	= $this->Template->createElement("item");
					$EV->setAttribute("key", $sKey);
					$EV->setAttribute("value", $mValue);
					
					$Records->appendChild($EV);
				}
				
			}
			
		}		
                
                $localeList = explode(",", SUPPORT_LOCALE);
                $LocaleList = $this->Template->createElement("locale_list");
                foreach ($localeList as $locale){
                    $localeKeyVal = explode(":", $locale);
                    $localeItem = $this->Template->createElement("locale",$localeKeyVal[0]);
                    $LocaleList->appendChild($localeItem);
                }
		
		$this->Root->appendChild($Item);
		$this->Root->appendChild($Records);                
		$this->Root->appendChild($LocaleList);                
		$this->Template->addXslPath("/modules/profile/view/templates/" . CNF_SKIN . "/profile.xsl");
	}
	
	private function stripAllASlashes($sString)
	{
		$sString = stripslashes($sString);
		if (substr_count($sString, "\\") > 0) {
			$sString = $this->stripAllASlashes($sString);
		}
		
		return $sString;
	}
	
	public function editPass()
	{
		$this->Template->addXslPath("/modules/profile/view/templates/" . CNF_SKIN . "/password.xsl");
	}
}

?>