<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

require_once "modules/references/library/ReferencesList/REF_ReferencesList.php";
require_once "modules/references/view/xml/REF_ReferencesListXml.php";
require_once "modules/references/view/xml/REF_ReferenceXml.php";
require_once "modules/references/library/Reference/UserReference.php";
require_once "modules/media/library/WF_MediaId.php";
require_once "modules/references/library/Reference/REF_Template.php";
require_once "modules/workflow/library/WF_Utils.php";
require_once "modules/references/library/security/REF_ReferencesSwitcherDB.php";
require_once "modules/references/library/security/REF_ReferencesSwitcher.php";
require_once "library/MSF_SearchUtil/MSF_SearchUtil.php";
require_once "library/MSF_SearchUtil/MSF_CsIndexedDB.php";
require_once "library/MSF_Export/MSF_ExportToExcel.php";
require_once "library/MSF_Export/MSF_HtmlExporter.php";
include_once "modules/main/library/orgStructure/MSF_OrgStructureFacade.php";
require_once "modules/eventlog/library/ELOG_EventLog.php";

class MSF_FrontController extends MSF_ControllerSupport
{
	private $iReferenceId;

	/**
	 * Enter description here...
	 *
	 * @var UserReference
	 */
	private $Reference;

	private $sType;

	private $View;
	
	private $sBackUrl = "";
	
	/**
	 * @var MSF_BackUrl
	 */
	private $BackUrl	= null;
	
		
	public function indexAction()
	{
		$ReferenceList	= new REF_ReferencesList(new REF_ReferencesListDB(MSF_Registry::get("MSF_DB")));
		$View			= new REF_ReferencesListXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		$ReferenceList->addAction(MSF_Registry::get("MSF_Locale")->getWord("REFERENCE_VIEW"), "/references/viewref", "/templates/default/img/view.gif",  array("reference_id"), false);
		$ReferenceList->setBaseUrl("/references/?");
		$View->buildRecordset($ReferenceList->getListRecordset());
		$View->addTemplate("/modules/references/view/templates/default/referenceList.xsl");
		$this->setView($View);
	}
	
		
	private function checkAccess($sAction)
	{
		$Switcher = new REF_ReferencesSwitcher(MSF_Registry::get("MSF_DB"));
		return $Switcher->hasAccess($sAction, WF_Utils::getPath(), array("reference_id" => $this->getIntParam(0)));
	}
	
	

	public function viewrefAction()
	{	
		// Проверка на существование справочника	
		try {
			$iTmpReferenceId = (int)$this->getParam(0);
			$oTmpReference	 = new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
			$oTmpReference->load($iTmpReferenceId, array());
		}
		catch(ReferenceException $oException) {			
			$View = new REF_ReferencesListXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
			$this->setView($View);	
			MSF_Registry::get("MSF_Messenger")->addError($this->Locale->getWord("ROOT_404_PAGE_REF"));
			return;
		}		
		
		if ($this->checkAccess("view")) {
			MSF_AutoCompletor::setUri("/references/autocomplete/" . $iTmpReferenceId);
			$this->setReferencePlain();
					
			$this->View->buildRecordset($this->Reference->getRecords());

			$sInitPath = "/references/exportRecordset/" . $iTmpReferenceId;
			$this->Template->getModule ()->appendChild ( $this->Template->createElement ( "initPath", $sInitPath ) );
			$this->View->addTemplate("/modules/references/view/templates/default/reference.xsl");
			
			$AB	= MSF_Registry::get("MSF_ActionBar");
			if ($this->checkAccess("edit_conf")) {
				$AB->addAction(
					$this->Locale->getWord("REF_ADD_RECORD"),
					"/references/add/" . $this->iReferenceId,
					CNX_ACTIONBAR_IMG,
					"",
					false,
					"left",
					$this->Locale->getWord("REF_ADD_RECORD_HELP")
				);
			}
			
			
			$this->setPageTitle();
		}
		else {
			//MSF_AccessDenied::exitApp("viewrefAction()");
			//MSF_AccessDenied::exitApp($this->Locale->getWord("ROOT_ERROR_NO_ACCESS"));
			$this->notAccessAction();
			return;
		}		

	}

	public function ajaxviewAction()
	{
		$bError = false;
		try {
			$this->setReferenceAjax();			
		}
		catch(Exception $oException) {
			$this->View	= new MSF_ViewSupportJson();
			$this->setView($this->View);
			$bError = true;
		}
		
		if (($this->checkAccess("view") || $this->getParam(0) == 6) && !$bError) {
			
			$bIsUnique		= $this->getParam(1);
			$sUniqueType	= $this->getParam(2);
			$iObjectId		= (int)$this->getParam(3);
			
						
			
			$sFieldName			= (string) 	MSF_SL::getParam($_POST, "inputName", "");
			$sDefaultValues		= (string) 	MSF_SL::getParam($_POST, "defaultValues", "");
			$sOrderBy			= (string) 	MSF_SL::getParam($_POST, "orderBy", "");
			$sOrderDirection	= (string) 	MSF_SL::getParam($_POST, "orderDirection", "asc");
			$sLimitFrom			= (int) 	MSF_SL::getParam($_POST, "limitFrom", 0);
			$iRecordsLimit		= (int)		MSF_SL::getParam($_POST, "recordsLimit", -1);
			$sCurrentValue		= (string)	MSF_SL::getParam($_POST, "default", -1);
			if ($sCurrentValue != -1) {
				$oRefValue 			= new REF_Value();
				$oRefValue->parse($sCurrentValue);
				$aCurrentValue 		= $oRefValue->getKeysList();
			}
			else {
				$aCurrentValue		= array(-1);
			}
			
			//print_r($this->Reference->getMiniView($bIsUnique, $sUniqueType, $iObjectId, $sFieldName, $sDefaultValues));
			
			//
			$this->View->set("title", MSF_Registry::get("MSF_Locale")->getI18N($this->Reference->getName()));
			//
			
			$this->View->set("data",
				$this->Reference->getMiniView(
					$bIsUnique,
					$sUniqueType,
					$iObjectId,
					$sFieldName,
					$sDefaultValues,
					$sOrderBy,
					$sOrderDirection,
					$sLimitFrom,
					$iRecordsLimit,
					$aCurrentValue
				)
			);
			
		}
		else if($bError) {
			$this->View->set("error", 1);
		}
		else {
			$Locale	= MSF_Registry::get("MSF_Locale");
			
			$aOut	= array(
				"denied"		=> 1,
				"accessDenied"	=> $Locale->getWord("REF_ACCESS_DENIED"),
				"changeDenied"	=> $Locale->getWord("RED_CHANGE_DENIED")
			);
			
			$this->View->set("reference", $aOut);
		}		
	}

	public function editrowAction()
	{	
		$iRowId	= (int)$this->getParam(1);
		// Проверка на существование элемента справочника	
		try {
			$iTmpReferenceId = (int)$this->getParam(0);
			$oTmpReference	 = new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
			$oTmpReference->load($iTmpReferenceId, array());
			$oTmpReference->row($iRowId)->show();		
		}
		catch(Exception $oException) {
			$View = new REF_ReferencesListXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
			$this->setView($View);	
			MSF_Registry::get("MSF_Messenger")->addError($this->Locale->getWord("REFROW_NOT_EXISTS"));
			return;
		}
		
		if ($this->checkAccess("edit_ref")) {					
			$this->editRow($iRowId);			
		}
		else {
			//MSF_AccessDenied::exitApp("viewrefAction()");
			//MSF_AccessDenied::exitApp($this->Locale->getWord("ROOT_ERROR_NO_ACCESS"));
			$this->notAccessAction();
			return;
		}		
	}

	public function viewrowAction()
	{
		$iRowId	= (int)$this->getParam(1);
		// Проверка на существование элемента справочника
		try {
			$iTmpReferenceId = (int)$this->getParam(0);
			$oTmpReference	 = new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
			$oTmpReference->load($iTmpReferenceId, array());
			$oTmpReference->row($iRowId)->show();		
		}
		catch(Exception $oException) {
			$View = new REF_ReferencesListXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
			$this->setView($View);	
			MSF_Registry::get("MSF_Messenger")->addError($this->Locale->getWord("ROOT_404_PAGE_REFROW"));
			return;			
		}
		
		if ($this->checkAccess("view")) {				
			$this->setReferencePlain();
			$Fields 		= new REF_Fields($this->Reference->getFieldsXml());
			$REF_Template 	= new REF_Template($this->Reference->getTemplate());
			// Добавляем системные поля
			$oSysFields 	= new REF_SystemFieldsSettings();
			$aSysFields 	= $oSysFields->getRefSystemFields();
			$Fields->injectFields($aSysFields);
			$REF_Template->setExtra("references", $this->iReferenceId);
			$REF_Template->setFields($Fields);				
			
			$aRow	= $this->Reference->row($iRowId)->show();				
			foreach ($aRow as $aCol) {
				$Fields->set($aCol["name"], $aCol["value"]);
				/*if ($aCol["name"] == "author_name") {
					$oOs 	= MSF_OrgStructureFacade::getInstance();
					$oRv 	= new REF_Value();
					$oRv->parse($aCol["value"]);
					$aTemp	=  $oRv->getKeysList();
					list($iStrId, $iEmplId, $iPostId) = $aTemp[0];
					list($sTitle) = $oRv->getValuesList();
					$aTemp = explode(" (", $sTitle);
					if (count($aTemp) == 2) {
						$aTemp[1] = explode(")", $aTemp[1]);
						$REF_Template->setStructureId($iStrId);
						$REF_Template->setEmployeeName($aTemp[0]);
						$REF_Template->setEmployeeId($iEmplId);
						$REF_Template->setPostId($iPostId);
						$REF_Template->setPost($aTemp[1][0]);
					}
					else {
						$REF_Template->setStructureId($iStrId);
						$REF_Template->setEmployeeName($aTemp[0]);
						$aPost	= $oOs->getPostByStructureId($iStr);
						$REF_Template->setPost($aPost[0]["value"]);
					}

				}*/
				
			}					
			
			$this->Template->getModule()->appendChild($this->Template->createElement("document"));
			$REF_Template->addViewTemplate($this->Template, "module/template");
		
			
			$AB	= MSF_Registry::get("MSF_ActionBar");
			if ($this->checkAccess("edit_ref")) {	
				$AB->addAction(
					$this->Locale->getWord("REF_EDIT"),
					"/references/editrow/" . $this->iReferenceId . "/" . $iRowId,
					CNX_ACTIONBAR_IMG,
					"",
					false,
					"left",
					$this->Locale->getWord("REF_EDIT_HELP")
				);
			}
			$aDropDown[0]["title"]		= MSF_Registry::get("MSF_Locale")->getWord("LABEL_EXPORT");
			$aDropDown[0]["url"]		= "/references/export/" . $this->iReferenceId . "/" . $iRowId;
			$aDropDown[0]["image"]		= "";
			$aDropDown[0]["onclick"]	= "";						
			$AB->addDropDropDown($aDropDown);
			if ($this->checkAccess("edit_conf")) {
				$AB->addAction(
					$this->Locale->getWord("REF_ADD_RECORD"),
					"/references/add/" . $this->iReferenceId,
					"",
					"",
					false,
					"right",
					$this->Locale->getWord("REF_ADD_RECORD_HELP")
				);
			}
			
			$AB->addAction(
				$this->Locale->getWord("REF_TO_REFERENCE"),
				"/references/viewref/" . $this->iReferenceId,
				CNX_ACTIONBAR_IMG,
				"",
				false,
				"left",
				$this->Locale->getWord("REF_TO_REFERENCE_HELP")
			);
			
			$this->setPageTitle();
		}
		else {
			//MSF_AccessDenied::exitApp("viewrefAction()");
			//MSF_AccessDenied::exitApp($this->Locale->getWord("ROOT_ERROR_NO_ACCESS"));
			$this->notAccessAction();
			return;
		}	
				
	}
	
	public function exportRecordsetAction() {		
		$oPHPExcel = new MSF_ExportToExcel ( );
		$iRefId = $this->getIntParam ( 0 );
		//if ($iRefId != 0) {
			$oReference = new UserReference ( new UserReferenceDB ( MSF_Registry::get ( "MSF_DB" ) ) );
			$oReference->load ( $iRefId, array () );
			$aRecordset = $oReference->getRecords ( 0, true );
			$iPages = $aRecordset ["pagination"] ["totalPages"];
			$oPHPExcel->exportTitles ( $aRecordset );
			for($i = 0; $i < $iPages; $i ++) {
				set_time_limit(MSF_Recordset::$RECORDS_PER_PAGE);
				$aRecordset = $oReference->getRecords ( $i * MSF_Recordset::$RECORDS_PER_PAGE, true );
				$oPHPExcel->exportBody ( $aRecordset );
			}
		
		/*} else {
			$ReferenceList = new REF_ReferencesList ( new REF_ReferencesListDB ( MSF_Registry::get ( "MSF_DB" ) ) );
			$aRecordset = $ReferenceList->getListRecordset ( false, 0, true );
			$iPages = $aRecordset ["pagination"] ["totalPages"];
			$oPHPExcel->exportTitles ( $aRecordset );
			for($i = 0; $i < $iPages; $i ++) {
				$aRecordset = $ReferenceList->getListRecordset ( false, $i * MSF_Recordset::$RECORDS_PER_PAGE, true );
				$oPHPExcel->exportBody ( $aRecordset );
			}
		
		}*/		
		
		$sLink = $oPHPExcel->saveSpreadsheet ();
		$aResult = array(
			"link"	=> $sLink,
			"ext"	=> "xls",
			"name"	=> urlencode($oReference->getName())
			);
		$View = new MSF_ViewSupportJson();
		$View->set("data", $aResult);
		$this->setView($View);		
	}
	
	public function exportAction()
	{
		$iRefId		= $this->getIntParam(0);
		$iRowId		= $this->getIntParam(1);
		$oExporter	= new MSF_HtmlExporter($iRefId, "reference", $iRowId);
		$oExporter->exportToWord();	
	}

	public function addAction()
	{
		// Проверка на существование справочника
		try {
			$iTmpReferenceId = (int)$this->getParam(0);
			$oTmpReference	 = new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
			$oTmpReference->load($iTmpReferenceId, array());			
		}
		catch(ReferenceException $oException) {
			$View = new REF_ReferencesListXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
			$this->setView($View);	
			MSF_Registry::get("MSF_Messenger")->addError($this->Locale->getWord("REF_NOT_EXISTS"));
			return;						
		}
					
		if ($this->checkAccess("edit_conf")) {
			$this->editRow(0);
		}
		else {
			//MSF_AccessDenied::exitApp("Access denied");
			//MSF_AccessDenied::exitApp($this->Locale->getWord("ROOT_ERROR_NO_ACCESS"));
			$this->notAccessAction();
			return;
		}
		
	}

	public function removeAction()
	{
		$this->iReferenceId		= (int)$this->getParam(0);
		$sBackUrl	= "/references/viewref/" . $this->iReferenceId;
		
		if ($this->checkAccess("edit_conf")) {
			$oUserBox		  = MSF_UserBox::getInstance();
			$aIds	= array();
			if(IS_REQUEST) {
				$sMessage	= $this->locale("REF_ROWS_REMOVED");
				$aTmp		= MSF_SL::getParam($_POST, "id", array());
				foreach($aTmp as $iTmpId) {
					array_push($aIds, $iTmpId);
				}
				
			}
			else {
				$sMessage	= $this->locale("REF_ROW_REMOVED");
				array_push($aIds, (int)$this->getParam(1));
			}
			
			switch ($this->iReferenceId) {
				case "1":
					$iKey = array_search($oUserBox->getUserAttribute("id"), $aIds);
					if ($iKey !== false){
						MSF_Registry::get("MSF_Messenger")->addError($this->locale("REF_ROWS_REMOVED_ERROR"));
						unset($aIds[$iKey]);						
					}
					else {
						$this->removeMails($aIds);
					}
					break;
				case "2":
					$iKey = array_search($oUserBox->getEmployeeAttribute("id"), $aIds);
					if ($iKey !== false){
						MSF_Registry::get("MSF_Messenger")->addError($this->locale("REF_ROWS_REMOVED_ERROR"));
						unset($aIds[$iKey]);						
					}
					break;
				case "3":
					$iKey = array_search($oUserBox->getCurrentPostId(), $aIds);
					if ($iKey !== false){
						MSF_Registry::get("MSF_Messenger")->addError($this->locale("REF_ROWS_REMOVED_ERROR"));
						unset($aIds[$iKey]);
					}
					break;
			}
			
			$this->Reference	= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
			$this->Reference->load($this->iReferenceId, array());
			$UF		= new MSF_UniqueField(MSF_Registry::get("MSF_DB"));
					
			foreach($aIds as $iId) {
				$Fields 	= new REF_Fields($this->Reference->getFieldsXml());
				$aRow		= $this->Reference->row($iId)->show();
				foreach ($aRow as $aCol) {
					$Fields->set($aCol["name"], $aCol["value"]);
				}
				$this->referenceRowDeleteEventLog($aRow);
				
				$UF->freeFields($Fields->getAsList(), MSF_UniqueField::TYPE_REFERENCE, $this->iReferenceId);				
				$this->Reference->row($iId)->remove();
				
				$DBRecord = new MSF_CsIndexedDB('cs_indexed', 0); // Экземпляр класса для работы с БД (25.06.2009)
				$DBRecord->insert(array('subject_id' => $iId, 'module' => 'reference', 'operation' => 'remove', 'context_id' => $this->iReferenceId));
				// Добавляем в БД ID справочника, индексы которого нужно удалить (25.06.2009)
				//MSF_SearchUtil::newInstance()->removeIndex("ref_index", $this->iReferenceId, $iId);
			}			
			
			if (!empty($aIds)){
				MSF_Registry::get("MSF_Messenger")->redirect($sBackUrl, $sMessage);
			}
			else {
				MSF_Registry::get("MSF_Messenger")->redirect($sBackUrl);
			}
		}
		else {
			//MSF_AccessDenied::exitApp("Access denied");
			//MSF_AccessDenied::exitApp($this->Locale->getWord("ROOT_ERROR_NO_ACCESS"));
			MSF_Registry::get("MSF_Messenger")->addError($this->Locale->getWord("REF_REMOVE_DENIED"));
			MSF_Registry::get("MSF_Messenger")->redirect($sBackUrl);
		}
		
	}
	
	private function removeMails($aIds)
	{
		$oLMS = new LMS_MailDB(MSF_Registry::get("MSF_DB"));
		foreach ($aIds as $iId) {
			$oLMS->deleteUserMessages($iId);
		}
	}
	
	private function referenceRowDeleteEventLog($aRow) {
		$Locale	= new MSF_Locale('modules/eventlog/languages/russian.ini');
		$sEventTitle = "";
		foreach ($aRow as $aValue) {
			if ($aValue["value"] != "") {
				$sEventTitle .= $this->prepareMessage($aValue);
			}
		}
		if ($sEventTitle != "") $sEventTitle = $sEventTitle . "\" "; 
		$sEventTitle .= $Locale->getWord("ELOG_FROM_REFERENCE");
		$sEventTitle .= " \"" . $this->Reference->getName();
		$oEventLog = new ELOG_EventLog(MSF_Registry::get("MSF_DB"));
		$oEventLog->addItem(array("event_type"=>"reference", "event_title"=>$sEventTitle));
	}
	
	private function prepareMessage($aValue) {
		$sResult = "";
		switch ($aValue["type"]) {
			case "string":
			case "int":
			case "float":
			case "date":
			case "file":
			case "image":
				$sResult .= $aValue["title"] . ": " . $aValue["value"] . "; ";
				break;
			case "timestamp":
				if (!in_array($aValue["name"], array("created_at", "modified_at"))) 
					$sResult .= $aValue["title"] . ": " . $aValue["value"] . "; ";
				break;
			case "structure":
				if (!in_array($aValue["name"], array("author_name", "editor_name"))) {
					$aRows 	= explode("|^|row|^|", $aValue["value"]);
					$sResult .= $aValue["title"] . ": ";
					foreach ($aRows AS $aRow) {
						$aCells = explode("/^/col/^/", $aRow);
						$sResult .= $aCells[0] . "; ";
					}
				}
				break;
			case "bool":
			case "reference":
			case "document":
				$aRows 	= explode("|^|row|^|", $aValue["value"]);
				$sResult .= $aValue["title"] . ": ";
				foreach ($aRows AS $aRow) {
					$aCells = explode("/^/col/^/", $aRow);
					$sResult .= $aCells[0] . "; ";
				}
				break;
			case "enum":
				$aCols 	= explode("/^/col/^/", $aValue["value"]);
				$sResult .= $aValue["title"] . ": ";
				foreach ($aCols AS $aCol) {
					$aCells = explode("|^|row|^|", $aCol);
					$sResult .= $aCells[0] . "; ";
				}
				break;
			case "text":
				$sValue = mb_substr(strip_tags($aValue["value"]), 0, 50);
				$sResult .= $aValue["title"] . ": " . $sValue . "; ";
				break;
			case "table":
				$aVar 	= explode("^R^", urldecode(str_replace(array("&#160;", "^S^"), " ", $aValue["value"])));
				$aVar0	= explode("^C^", $aVar[0]);
                                if(count($aVar0) < 2) break;
				$sField = $aVar0[0]; $sType = $aVar0[1];   
				$aVar1	= explode("^C^", $aVar[1]);
				for ($i=0; $i<sizeof($aVar1); $i++) {
					if ($sField == $aVar1[$i]) $iField = $i;
				}
				if (isset($iField)) {
					$sResult .= $aValue["title"] . ": ";
					for ($i=2; $i<sizeof($aVar); $i++) {
						$aVar2	= explode("^C^", $aVar[$i]);
						switch ($sType) {
							case "string":
							case "int":
							case "float":
							case "date":
							case "file":
							case "image":
							case "timestamp":
							case "text":
								$sResult .= strip_tags($aVar2[$iField]) . "; ";
								break;
							case "bool":
							case "reference":
							case "document":
							case "structure":
								$aRows 	= explode("|^|row|^|", $aVar2[$iField]);
								foreach ($aRows AS $aRow) {
									$aCells = explode("/^/col/^/", $aRow);
									$sResult .= $aCells[0] . "; ";
								}						
								break;
							case "enum":
								$aCols 	= explode("/^/col/^/", $aVar2[$iField]);
								foreach ($aCols AS $aCol) {
									$aCells = explode("|^|row|^|", $aCol);
									$sResult .= $aCells[0] . "; ";
								}						
								break;
								
						}
					}
				}
 				break;				
		}

		return $sResult;
	}

	public function groupreferenceAction()
	{
		$this->setReferencePlain();
		$this->View->buildGroup($this->Reference->getGroup());
	}
	
	public function autocompleteAction()
	{
		$this->setReferencePlain();
		MSF_AutoCompletor::autoCompleteResponse($this->Reference->getRecords());
		exit();
	}

	public function testminiAction()
	{
		if(IS_REQUEST) {
			//debug($_POST);
		}
		
		//$this->Template->addLink("/library/MSF_InputPlaceholder/js/MSFW.js", "text/javascript");
		//$this->Template->addLink("/library/MSF_InputPlaceholder/css/MSFW.css", "text/css");
		//$this->Template->addLink("/js/ext/calendar_date_select/css/default.css", "text/css");
				
		$this->View		= new REF_ReferenceXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		$this->View->testMini();
		$this->setView($this->View);
	}
	
	private function editRow($iRowId)
	{		
		$this->setReferencePlain();		
		$this->setPageTitle();
		$Fields 		= new REF_Fields($this->Reference->getFieldsXml());
		// Добавляем системные поля
		$oSysFields 	= new REF_SystemFieldsSettings();
		$aSysFields 	= $oSysFields->getRefSystemFields();
		$Fields->injectFields($aSysFields);		
		$Fields->setExtra("references", $this->iReferenceId);
		$REF_Template 	= new REF_Template($this->Reference->getTemplate());
		$REF_Template->setExtra("references", $this->iReferenceId);
		$REF_Template->setUniqueId($this->iReferenceId);
		$REF_Template->setUniqueType(MSF_UniqueField::TYPE_REFERENCE);
		if ($iRowId == 0) {
			$oOs 	= MSF_OrgStructureFacade::getInstance();
			$iStr	= $oOs->getCurrentStructureId();
			$aPost	= $oOs->getPostByStructureId($iStr);
			$REF_Template->setStructureId($iStr);
			$REF_Template->setEmployeeName($_SESSION["MSF_UserBox"]["employee"]["name"]);
			if (isset($aPost[0]["value"])) {
				$REF_Template->setPost($aPost[0]["value"]);
			}
			$REF_Template->setMode("add");
		}


		$AB	= MSF_Registry::get("MSF_ActionBar");
			
		if($iRowId != 0) {
			$aRow	= $this->Reference->row($iRowId)->show();
			foreach ($aRow as $aCol) {
				$Fields->set($aCol["name"], $aCol["value"]);
				if ($aCol["name"] == "author_name") {
					$oOs 	= MSF_OrgStructureFacade::getInstance();
					$oRv 	= new REF_Value();
					$oRv->parse($aCol["value"]);
					$aTemp	=  $oRv->getKeysList();
					if (!isset($aTemp[0])) {
						$aTemp[0] = array(0, 0, 0);
					}
				
					list($iStrId, $iEmplId, $iPostId) = $aTemp[0];
					$aTemp1 = $oRv->getValuesList();
					if (!isset($aTemp1[0])) {
						$aTemp1[0] = "";
					}
					list($sTitle) = $aTemp1;
					$aTemp = explode(" (", $sTitle);
					if (count($aTemp) == 2) {
						$aTemp[1] = explode(")", $aTemp[1]);
						$REF_Template->setStructureId($iStrId);
						$REF_Template->setEmployeeName($aTemp[0]);
						$REF_Template->setPost($aTemp[1][0]);
						$REF_Template->setEmployeeId($iEmplId);
						$REF_Template->setPostId($iPostId);
					}
					else {
						$REF_Template->setStructureId($iStrId);
						$REF_Template->setEmployeeName($aTemp[0]);
						try {
							$aPost	= $oOs->getPostByStructureId($iStrId);
							$REF_Template->setPost($aPost[0]["value"]);
						}
						catch (Exception $oE) {
							$REF_Template->setPost("");
						}
						

						
						$REF_Template->setEmployeeId($iEmplId);
						$REF_Template->setPostId($iPostId);
					}

				}

			}

			$AB->addAction(
				$this->Locale->getWord("REF_CANCEL"),
				"/references/viewrow/" . $this->iReferenceId . "/" . $iRowId,
				CNX_ACTIONBAR_IMG,
				"",
				false,
				"left",
				$this->Locale->getWord("REF_CANCEL_HELP")
			);
		}
		else {
			$AB->addAction(
				$this->Locale->getWord("REF_TO_REFERENCE"),
				"/references/viewref/" . $this->iReferenceId,
				CNX_ACTIONBAR_IMG,
				"",
				false,
				"left",
				$this->Locale->getWord("REF_TO_REFERENCE_HELP")
			);
			
		}
		$AB->addAction(
			$this->Locale->getWord("WORKFLOW_BTN_SAVE"),
			"", 
			CNX_ACTIONBAR_IMG, 
			'$("save_button").click(); return false;'
		);
		
		// 11 nov 2009. Enabling support for saving hidden fields
		$aCurrent = array();
		foreach ($Fields->getAsHash() AS $sName => $sValue) {
			$aCurrent[$sName] = $sValue;			
		}

		if(IS_REQUEST) {
			$NewFields	= new REF_Fields($this->Reference->getFieldsXml());
			$NewFields->setExtra("references", $this->iReferenceId);
			$NewFields->registerCheck("unique", array($this->Reference, "checkUnique"), array("iRowId"=>$iRowId));
			foreach ($aCurrent AS $Name => $Value) {
				if ($NewFields->getFieldType($Name) == 'table') {
					$aCurrent[$Name] = htmlspecialchars_decode($Value);
				}
			}
			
			$aPOST	= array_merge($aCurrent, $_POST, $_FILES);		
			foreach($aPOST as $sName=>$mValue) {
				if (strstr($sName, "password")) {
					if (($mValue["main"] == $mValue["confirm"]) && ($mValue["main"] == ":!")) {
						$NewFields->set($sName, $Fields->get($sName), true);
					}
					else {
						$NewFields->set($sName, $mValue, true);
					}
					
				}
				elseif($sName == "login") {
					$NewFields->set($sName, strtolower($mValue), true);
				}
				else {
					$NewFields->set($sName, $mValue, true);
				}
				
			}
									
			$aUnfilledFields 		= $NewFields->getUnfilled();			
			$aIncorrectFields 		= $NewFields->getIncorrect();
			$aIncorrectUniqueFields	= $NewFields->getIncorrectUnique();
			$aFields				= $NewFields->getAsHash();			
			$bLicenseFlag			= true;
			
			
			if($this->iReferenceId == 1) {
				$aIsActive		= MSF_EnumValue::parse($aFields["is_active"]);
				if(isset($aFields["is_active"]) && (int)$aIsActive["key"] == 1) {
					$bLicenseFlag	= $this->Reference->checkLicense(MSF_NUMBER_OF_LICENSES, $iRowId);
				}
				
			}
			else if($this->iReferenceId == 5) {
				if(MSF_EnumValue::parse($aFields["numbers_count"]) == null) {
					$iCount = $aFields["numbers_count"];						
				}
				else {
					$aTmp	= MSF_EnumValue::parse($aFields["numbers_count"]);
					$iCount	= $aTmp["key"];					
				}
				
				$iCounter	= (int)$aFields["count"];				
				$iPre		= $iCount - strlen($iCounter);
				for($i = 0; $i <= $iPre; $i++) {
					$iCounter = "0" . $iCounter;					
				}
				
				$aFields["count"] = $iCounter;								
			}			
			
			unset($aFields["id"]);			
			
			if(!$bLicenseFlag && !CNF_IS_CONCURRENT) {
				$this->addToFill(array(), $this->locale("REF_NUM_OF_LICENSE_EXCEED"));
			}
			elseif(!empty($aUnfilledFields)) {
				$this->addToFill($aUnfilledFields, $this->locale("REF_FULFILL_FIELDS"));
			}
			elseif(!empty($aIncorrectFields)){
				$this->addToFill($aIncorrectFields, $this->locale("REF_FULFILL_FIELDS_CORRECTLY"));
			}
			elseif(!empty($aIncorrectUniqueFields)){
				$this->addToFill($aIncorrectUniqueFields, $this->locale("REF_FULFILL_FIELDS_UNIQUE"));
			}
			else {
				$iId	= $this->Reference->row($iRowId)->save($aFields);
				if($iId) {
					$UF	= new MSF_UniqueField(MSF_Registry::get("MSF_DB"));
					
					$UF->freeFields($Fields->getAsList(), MSF_UniqueField::TYPE_REFERENCE, $this->iReferenceId);
					$UF->blockFields($NewFields->getAsList(), MSF_UniqueField::TYPE_REFERENCE, $this->iReferenceId);
					
					$sBackUrl	= "/references/viewrow/" . $this->iReferenceId . "/" . $iId;
					unset($_SESSION["REF_References"]);
					
										
					/*$aFileNames	= array();
					$Media		= new MD_Media(new MD_MediaDB(MSF_Registry::get("MSF_DB")));
					
					foreach($this->Reference->getFields() as $aField) {
						if(in_array($aField["type"], array("picture", "file"))) {
							$aIds	= explode(",", $aFields[$aField["name"]]);
							foreach($aIds as $iId) {
								if((int)$iId != 0) {
									$aFileInfo	= $Media->getFileInfo($iId);
									array_push($aFileNames, $aFileInfo["name"]);
								}
																
							}
							
						}
						
					}*/
										
					$DBRecord = new MSF_CsIndexedDB('cs_indexed', 0); // Экземпляр класса для работы с БД (25.06.2009)					
					if (!$DBRecord->findOperation($iId, 'reference', 'index', $this->iReferenceId)) {
						$DBRecord->insert(array('subject_id' => $iId, 'module' => 'reference', 'operation' => 'index', 'context_id' => $this->iReferenceId));
					}	// Добавляем в БД ID справочника, который нужно проиндексировать (25.06.2009)				
					//MSF_SearchUtil::newInstance(implode(" ", $aFields) . " " . implode(" ", $aFileNames))->createIndex("ref_index", $this->iReferenceId, $iId);
					
					MSF_Registry::get("MSF_Messenger")->redirect($sBackUrl, MSF_Registry::get("MSF_Locale")->getWord("REFERENCE_SAVE"));
				}
				else {
					unset($_SESSION["REF_References"]);
				}
				
			}
			
			
			if (isset($_SESSION["REF_References"])) {
				foreach($NewFields->getAsHash() as $sName => $mValue) {
					$Fields->set($sName, $mValue);

				}
				
				unset($_SESSION["REF_References"]);
			}
			
		}
		
		$REF_Template->setFields($Fields);
		$this->Template->getModule()->appendChild($this->Template->createElement("document"));
		$REF_Template->addEditTemplate($this->Template, "module/template");
	}
	
	private function addToFill($aFields, $sMessage)
	{
		$oMessenger		= MSF_Registry::get("MSF_Messenger");
		$sMessage	 	= $sMessage . implode(", ", $this->getTitles($aFields));
		$oMessenger->addError($sMessage);
		$_SESSION["REF_References"] = $_POST;
	}
	
	private function getTitles($aFields)
	{
		$aTitles = array();
		foreach ($aFields AS $aField) {
			$aTitles[] = $aField["title"];
		}
		
		return $aTitles;
	}

	private function setReferencePlain()
	{
		$this->iReferenceId		= (int)$this->getParam(0);
		
		$this->View				= new REF_ReferenceXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));

		$this->View->setReferenceId($this->iReferenceId,  MSF_SL::getParam($_POST, "select",array()));
		$this->setView($this->View);

		$this->Reference	= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
		$this->Reference->load($this->iReferenceId, array());

		//$this->View->addLinksOf("references");
		//$this->View->addLinksOf("structure");
		$this->View->addEditResurces();
	}

	private function setReferenceAjax()
	{
		$this->Reference	= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
		
		$this->Reference->load((int)$this->getParam(0), MSF_SL::getParam($_POST, "select",array()));

		$this->View	= new MSF_ViewSupportJson();

		$this->setView($this->View);
	}
	
	
	private function setPageTitle()
	{
		$this->Template->setPageTitle(
				$this->locale("REF_REFERENCES") .
				$this->locale("ROOT_TITLE_SEPARATOR") .
				MSF_Registry::get("MSF_Locale")->getI18N($this->Reference->getName())
			);
	}
}
?>