<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
require_once "modules/references/library/Reference/REF_ReferenceGroupsList.php";
require_once "modules/references/library/Reference/REF_ReferenceGroup.php";

class REF_ReferenceGroupsBack extends REF_BackAbstract
{
	public function indexAction()
	{		
		MSF_Registry::get("MSF_ActionBar")->addAction(
			$this->Controller->locale("REF_ADD_REF_GROUP"),
			"/admin/references/groups/add/"
		);
		
		$GroupList	= new REF_ReferenceGroupsList();
		$View		= new REF_ReferenceGroupsListXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		
		$GroupList->setBaseUrl("/admin/references/groups/?");
		$GroupList->addAction($this->Controller->locale("WORKFLOW_ADMIN_LIST_ACTION_EDIT"), "/admin/references/groups/edit", "/templates/default/images/folder_page_white.png", array("group_id"));
		$GroupList->addAction($this->Controller->locale("WORKFLOW_ADMIN_LIST_ACTION_DELETE"), "/admin/references/groups/remove", "/templates/default/images/red_cross.png", array("group_id"), true);
		$GroupList->setLink("/admin/references/groups/edit", array("group_id"));

		$GroupList->setStateParams(
			array(
				"module"		=> "admin_references_groups",
				"action"		=> "index",
				"action_id"		=> "0",
				"structure_id"	=> MSF_Registry::get("MSF_UserBox")->getUserAttribute("id")
			)
		);
		
		$View->buildRecordset($GroupList->getListRecordset());
		$View->addTemplate("/modules/references/view/templates/default/referenceGroupsList.xsl");

		$this->Controller->setView($View);
		
		$this->Controller->getTemplate()->setPageTitle(				
				$this->Controller->locale("ROOT_ADMIN_MENU") .
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") . 
				$this->Controller->locale("REF_REF_GROUPS")				
			);
	}

	public function editAction()
	{
		$iId	= $this->Controller->getIntParam(1);
		$Group	= new REF_ReferenceGroup(new REF_ReferenceGroupDB(MSF_Registry::get("MSF_DB")));
		$View	= new REF_ReferenceGroupXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));

		$Group->load($iId);
		if(IS_REQUEST) {
			$aConfig				= array();
			$aConfig["name"]		= MSF_SL::getParam($_POST, "name");
			$aConfig["description"]	= MSF_SL::getParam($_POST, "description");
			$Group->setConfig($aConfig);
			$iId	= $Group->save();
			/*
			if ($Group->nameExists($aConfig["name"])) {
				MSF_Registry::get("MSF_Messenger")->addError(
					MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_MESSAGE_NAME_DULICATION")
				);
				
			}
			*/
			$this->Controller->redirect("/admin/references/groups/", $this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_GROUP_SAVED"));
		}
		else {
			$View->edit($Group->getConfig(), false);
			$this->Controller->setView($View);
		}

		$aConfig	= $Group->getConfig();
		
		$this->addActionPanel();
		$this->Controller->getTemplate()->setPageTitle(				
				$this->Controller->locale("ROOT_ADMIN_MENU") .
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") . 
				$this->Controller->locale("REF_REF_GROUPS")	.
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") . 
				MSF_Registry::get("MSF_Locale")->getI18N($aConfig["name"])			
			);
	}

	public function addAction()
	{
		$Group	= new REF_ReferenceGroup(new REF_ReferenceGroupDB(MSF_Registry::get("MSF_DB")));
		$View	= new REF_ReferenceGroupXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));

		$Group->create();
		if(IS_REQUEST) {
			$aConfig				= array();
			$aConfig["name"]		= MSF_SL::getParam($_POST, "name");
			$aConfig["description"]	= MSF_SL::getParam($_POST, "description");
			$Group->setConfig($aConfig);
			if (strlen($aConfig["name"])) {
				if ($Group->nameExists($aConfig["name"])) {
					MSF_Registry::get("MSF_Messenger")->addError(
						MSF_Registry::get("MSF_Locale")->getWord("REFERENCE_MESSAGE_GROUP_NAME_DULICATION")
					);
					
				}

				$Group->save();
				$this->Controller->redirect("/admin/references/groups/", $this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_GROUP_CREATED"));
			}
			else {
				$View->edit($aConfig, true);
				MSF_Registry::get("MSF_Messenger")->addError(
						MSF_Registry::get("MSF_Locale")->getWord("REFERENCE_MESSAGE_EMPTY_TITLE")
						);
				$this->Controller->setView($View);
			}
			
		}
		else {
			$View->edit($Group->getConfig(), true);
			$this->Controller->setView($View);
		}

		$this->addActionPanel();
		
		$this->Controller->getTemplate()->setPageTitle(				
				$this->Controller->locale("ROOT_ADMIN_MENU") .
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") . 
				$this->Controller->locale("REF_REF_GROUPS")				
			);
	}

	public function removeAction()
	{
		$iId	= $this->Controller->getIntParam(1);
		$Group	= new REF_ReferenceGroup(new REF_ReferenceGroupDB(MSF_Registry::get("MSF_DB")));


		$Group->load($iId);
		$Group->remove();

		$this->Controller->redirect("/admin/references/groups/", $this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_GROUP_REMOVED"));
	}

	private function addActionPanel()
	{
		$AB	= MSF_Registry::get("MSF_ActionBar");			
		$AB->addAction(
			$this->Controller->locale("REF_CLOSE"), 
			"/admin/references/groups/",  
			""
		);
	}
}
?>