<?php
/*
 * File: 	REF_Template.php
 * Date: 	27.02.2008
 * Time:	16:15:06
 * Detrix
 *
 */

// [include]
include_once "modules/references/library/Reference/REF_Value.php";
include_once "library/MSF_Utils/MSF_RteObjectsIntegrator.php";
include_once "library/MSF_SafeText/MSF_SafeText.php";
require_once "library/MSF_EnumValue/MSF_EnumValue.php";
include_once "RefFieldHelper.php";


// [/include]

/**
 * @package 	workflow
 * @copyright 	Copyright (c) 2007, Detrix
 */
class REF_Template
{
	
	protected $sTemplateXml 		= "";
	
	protected $Fields 				= null;
	
	protected $Vars					= null;
	
	protected $iUniqueId			= 0;
	
	protected $sUniqueType			= "";
	
	protected $iExtraId				= 0;
	
	protected $sExtraName			= "trash";
	
	protected $oPoints				= null;
	
	protected $sMode				= null;
	
	public $isWord					= false;
	
	private $sDebug					= "";
	
	public function addDebugInfo($sHtml) 
	{
		$this->sDebug .= $sHtml;
	}
		
	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// Setters
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	public function setExtra($sName, $iId)
	{
		$this->iExtraId 	= $iId;
		$this->sExtraName 	= $sName;
	}
	
	public function setFields(REF_Fields $Fields)
	{
		$this->Fields = $Fields;
	}
	
	public function setVars(WF_Vars $Vars)
	{
		$this->Vars = $Vars;
	}
	
	
	public function setUniqueId($iId)
	{
		$this->iUniqueId	= $iId;
	}
	
	public function setUniqueType($sType)
	{
		$this->sUniqueType	= $sType;
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// Public Doers
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	public function __construct($sTemplateXml)
	{
		$this->sTemplateXml = $sTemplateXml;
	}
	

	public function getViewForm()
	{
		return $this->getForm("view");
	}
	
public function getEditForm()
	{
		$sResult = "<div/>";
		
		if ($this->Fields->getCount() > 0 && $this->existFieldsInTemplate()) {
			$sSaveTitle	 = MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_SAVE");			
			$sResult  	.= "<form id=\"doc_form\" method=\"POST\" enctype=\"multipart/form-data\">\n";
			$sResult 	.= $this->getForm("edit");		
			$sResult 	.= "</form>";
			$sResult 	.= "\n<div><input type=\"button\" id=\"save_button\" value=\"" . $sSaveTitle . "\" style=\"float:left;\" />\n";
			$sResult 	.= "<img id=\"busy_loader\" height=\"25\" width=\"25\" src=\"/templates/default/images/win/big-ajax-loader.gif\" style=\"display:none;\"/>";
			$sResult 	.= "</div>";
			$sResult 	.= "<div style=\"display:none;\"><div id=\"login_layer\" style=\"padding:5pt;\">";							
			$sResult 	.= 	"<input id=\"ajax_login\" type=\"hidden\" value=\"".htmlspecialchars($_SESSION["MSF_UserBox"]["user"]["login"])."\"/>";
			$sResult 	.= 	"<table cellpadding=\"5pt\">";
			$sResult 	.= 	"<tr><td colspan=\"2\" id=\"ajax_error\">" . MSF_Registry::get("MSF_Locale")->getWord("ROOT_LOGIN_CONTINUE_MSG") . ":</td></tr>";
			$sResult 	.= 	"<tr><td>" . MSF_Registry::get("MSF_Locale")->getWord("ROOT_LABEL_PASSWORD") . ": </td><td><input id=\"ajax_password\" type=\"password\"></td></tr>";
			$sResult 	.= 	"<tr><td colspan=\"2\" align=\"right\"><input id=\"ajax_button\" type=\"button\" value=\"" . MSF_Registry::get("MSF_Locale")->getWord("ROOT_LOG_IN") . "\"></td></tr>";
			$sResult 	.= 	"</table>";	
			$sResult 	.= "</div></div>";
			$sResult 	.= "<script>registerEvent(function() {new REF_SaveHandler($(\"doc_form\"), $(\"save_button\"), $(\"login_layer\"), \"submit\");});</script>";
			$sResult 	.= "<script>
								document.onkeydown = function(e){
									key = (!e) ? window.event : e;
								   	if (key.ctrlKey && key.keyCode == 13){
										$(\"save_button\").click();
									} 
								}
							</script>";
		}
		
		//$pattern = "/&lt;!--.*--&gt;/";
		//$sResult	= preg_replace($pattern, "", $sResult);
		
		return $sResult;
	}
	
	public function existFieldsInTemplate()
	{
		$bExists = false;
		$aFields = $this->Fields->getAsList();
		
		for ($i = 0; $i < count($aFields); $i++) {
			if (strstr($this->sTemplateXml, $aFields[$i]["tag"])) {
				$bExists = true;
				break;
			}
		}
		
		return $bExists;
	}
	
	public function addViewTemplate($Template, $sMatch)
	{
		return $this->addTemplate($Template, $sMatch, $this->getViewForm());
	}

	public function addEditTemplate($Template, $sMatch)
	{
		MSF_RteObjectsIntegrator::files($this->iExtraId, $this->sExtraName);
		
		return $this->addTemplate($Template, $sMatch, $this->getEditForm());
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	//                                                                                             //
	// Private Doers                                                                               //
	//                                                                                             //
	/////////////////////////////////////////////////////////////////////////////////////////////////

	public function setPoints($oPoints) {
		$this->oPoints = $oPoints;
		
	}
	
	public static function addTemplate($Template, $sMatch, $sXml)
	{
		$oMsfTemplate = $Template->createElement("template");
		$sXml = str_replace(array("<![CDATA[", "]]>"), "", $sXml);
		$Template->appendXmlString($oMsfTemplate, "<![CDATA[" . $sXml . "]]>");
		$Template->getModule()->appendChild($oMsfTemplate);
		$sTemplate = "<xsl:value-of xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" disable-output-escaping=\"yes\" select=\".\"/>";
		$Template->addLink("/js/msf/date/DatePlaceholder.js", "text/javascript");
		$Template->addLink("/js/ext/scal/styles/scaltables.css", "text/css");
		$Template->addXsl("match", $sMatch, $sTemplate);
	}

	protected function getForm($sRenderType)
	{	
		$sTemplateXml  = $this->getTemplateXml();
		if ($this->Vars !== null) {

			foreach ($this->Vars->getList() AS $aVar) {
				$sTemplateXml = str_replace($aVar["tag"], (string)$aVar["html"], $sTemplateXml);
				$sTemplateXml = $sTemplateXml;
			}
			
		}

		if ($this->oPoints !== null) {
			foreach ($this->oPoints->get() AS $sKey => $sValue) {
				$sTemplateXml = str_replace($sKey, $sValue, $sTemplateXml);
			}
			
		}
		
		// РџРѕР»СѓС‡РёС‚СЊ СЃРїРёСЃРѕРє РЅР°Р·РІР°РЅРёР№ СЃРёСЃС‚РµРјРЅС‹С… РїРѕР»РµР№
		$oSysFieldsSettings = new REF_SystemFieldsSettings();
		$aSysFieldsTitles = $oSysFieldsSettings->getSysFieldsTitles();
		$sTemplateXml  = $this->initStyles($sTemplateXml);
		if ($sRenderType == "edit") { 
			$sTemplateXml = $this->initEditScripts($sTemplateXml);			
			foreach ($this->Fields->getAsList() AS $aField) {
				$aField["tag"] = str_replace(array("&","•"), array("&amp;","&bull;"), $aField["tag"]);
				if(in_array($aField["title"], $aSysFieldsTitles)) {
					$aField["tag"] = str_replace(array("{", "}"), array("[", "]"), $aField["tag"]);
					$sTemplateXml  = str_replace($aField["tag"], "", $sTemplateXml);
				}
				else {
					$sTemplateXml 	= str_replace($aField["tag"], $this->get($aField, $sRenderType), $sTemplateXml);
				}				
				$sTemplateXml 	= str_replace($this->getCopyTagName($aField["title"]), "", $sTemplateXml);				
				$sTemplateXml	= $this->initEditScriptVar($sTemplateXml, $aField["title"], $aField["name"]);								
			}				
		}
		else {				
			$sTemplateXml = $this->initViewScripts($sTemplateXml);
			foreach ($this->Fields->getAsList() AS $aField) {
				$aField["tag"] = str_replace(array("&","•"), array("&amp;","&bull;"), $aField["tag"]);
				if(in_array($aField["title"], $aSysFieldsTitles)) {					
					$aField["tag"] = str_replace(array("{", "}"), array("[", "]"), $aField["tag"]);
				}
			
				$sTemplateXml	= $this->initViewTag($sTemplateXml, $aField);
				$sTemplateXml	= $this->initViewScriptVar($sTemplateXml, $aField["title"], $aField["value"]);
			}
			
		}
		$sTemplate = $this->prepareTemplate($sTemplateXml);
		if ($sRenderType == "view") {
//			$sTemplate 	.= "<div style=\"display:none;\"><div id=\"login_layer\" style=\"padding:5pt;\">";							
//			$sTemplate 	.= 	"<input id=\"ajax_login\" type=\"hidden\" value=\"".htmlspecialchars($_SESSION["MSF_UserBox"]["user"]["login"])."\"/>";
//			$sTemplate 	.= 	"<table cellpadding=\"5pt\">";
//			$sTemplate 	.= 	"<tr><td colspan=\"2\" id=\"ajax_error\">" . MSF_Registry::get("MSF_Locale")->getWord("ROOT_LOGIN_CONTINUE_MSG") .":</td></tr>";
//			$sTemplate 	.= 	"<tr><td>" . MSF_Registry::get("MSF_Locale")->getWord("ROOT_LABEL_PASSWORD") . ": </td><td><input id=\"ajax_password\" type=\"password\"></td></tr>";
//			$sTemplate 	.= 	"<tr><td colspan=\"2\" align=\"right\"><input id=\"ajax_button\" type=\"button\" value=\"" . MSF_Registry::get("MSF_Locale")->getWord("ROOT_LOG_IN") . "\"></td></tr>";
//			$sTemplate 	.= 	"</table>";	
//			$sTemplate 	.= "</div></div>";
		}
		return $sTemplate;
	}
	
	protected function initEditTag($sTemplateXml, $aField)
	{		
		$aSearch 		= array($aField["tag"], $this->getCopyTagName($aField["title"]));
		$aReplace		= array($this->get($aField, "view"), "");
		$sTemplateXml 	= str_replace($aSearch, $aReplace, $sTemplateXml);						
	}
	
	protected function initViewTag($sTemplateXml, $aField)
	{
		$aSearch 		= array($aField["tag"], $this->getCopyTagName($aField["title"]));
		$sTemplateXml 	= str_replace($aSearch, $this->get($aField, "view"), $sTemplateXml);
		return $sTemplateXml;
	}
	
	protected function getTemplateXml()
	{
		$sTemplateXml  = "<div class=\"msfContent\">";
		$sTemplateXml .= $this->sTemplateXml;
		$sTemplateXml .= "</div>";
		if (CNF_MODE == "debug") {
			$sTemplateXml .= "<div>&#160;";
			$sTemplateXml .= $this->sDebug;
			$sTemplateXml .= "</div>";
		}
		$sTemplateXml .= "<div style=\"clear: both;\">&#160;</div>";
		return $sTemplateXml;		
	}
	
	/**
	 * <code>
	 * <div style="display:none">
	 * {%style%}
	 * HERE IS CSS
	 * {%/style%}
	 * </div>
	 * </code>
	 */
	protected function initStyles($sTemplateXml)
	{
		$aSearch 	= array("{%style%}", "{%/style%}");
		$aReplace 	= array("<style>",   "</style>");
		return str_replace($aSearch, $aReplace, $sTemplateXml);
	}
	
	protected function initViewScripts($sTemplateXml)
	{
		$aSearch 	= array("{%all%}", "{%/all%}", "{%edit%}", "{%/edit%}", "{%view%}", "{%/view%}", "{%iframe%}", "{%/iframe%}");
		$aReplace 	= array("<script>", "</script>", "<div style=\"display:none;\">", "</div>", "<script>", "</script>", "<iframe ", "></iframe>" );
		return str_replace($aSearch, $aReplace, $sTemplateXml);
	}
	
	protected function initEditScripts($sTemplateXml)
	{
		$aSearch 	= array("{%all%}", "{%/all%}", "{%edit%}", "{%/edit%}", "{%view%}", "{%/view%}", "{%iframe%}", "{%/iframe%}");
		$aReplace 	= array("<script>", "</script>", "<script>", "</script>", "<div style=\"display:none;\">", "</div>", "<iframe ", "></iframe>" );
		return str_replace($aSearch, $aReplace, $sTemplateXml);
	}
	
	protected function initEditScriptVar($sTemplateXml, $sTitle, $sName)
	{
		return str_replace($this->getVarName($sTitle), $this->getId($sName), $sTemplateXml);
	}
	
	protected function initViewScriptVar($sTemplateXml, $sTitle, $sValue)
	{
		return str_replace($this->getVarName($sTitle), "\"". $sValue . "\"", $sTemplateXml);
	}
	
	protected function getVarName($sTitle)
	{
		return "$".$sTitle."$";
	}
	
	
	protected function getCopyTagName($sTitle)
	{
		return "{" . $sTitle . " [*]}";
	}
	
	protected function prepareTemplate($sTpl)
	{
		$sTpl	= str_replace("&nbsp;", "&#160;", $sTpl);
	//	$pattern = "/&lt;!--.*?--&gt;/";
	//	$sTpl	= preg_replace($pattern, "", $sTpl);
	//	$pattern = "/<!--(.*?)-->/e";
	//	$sTpl	= preg_replace($pattern, "", $sTpl);
		return $sTpl;
	}
	
	protected function clearReplacePattern($sTag)
	{
		$aReplace = array("/", "{", "}", "(", ")", "?");
		
		for ($i = 0; $i < count($aReplace); $i++) {
			$sTag = str_replace($aReplace[$i], "\\" . $aReplace[$i], $sTag);
		}
		
		return $sTag;
	}

	protected function get($aField, $sRenderType)
	{
		$sResult = "";
		switch ($aField["type"]) {
			case REF_Fields::INTEGER:
			case REF_Fields::FLOAT	:
			case REF_Fields::STRING	:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getSimpleView($aField);
						break;
					case "edit":
						$sResult = $this->getInputEdit($aField, $aField["type"]);
						break;
				}

				break;

			case REF_Fields::TEXT	:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getSimpleView($aField);
						break;
					case "edit":
						$sResult = $this->getTextEdit($aField);
						break;
				}
		
				// kostyl
				// validaciya utf-8 symvolov
		   		$sResult = tidy_repair_string($sResult, array("show-body-only" => true), "utf8");
				break;

			case REF_Fields::BOOLEAN	:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getBooleanView($aField);
						break;
					case "edit":
						$sResult = $this->getBooleanEdit($aField);
						break;
				}
				$sResult = MSF_String::breakingLongWords($sResult);
				break;

			case REF_Fields::REFERENCE:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getReferenceView($aField);
						break;
					case "edit":
						$sResult = $this->getReferenceEdit($aField);
						break;
				}

				break;

			case REF_Fields::STRUCTURE:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getStructureView($aField);
						break;
					case "edit":
						$sResult = $this->getStructureEdit($aField);
						break;
				}

				break;
				
			case REF_Fields::ENUM:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getEnumView($aField);
						break;
					case "edit":
						$sResult = $this->getEnumEdit($aField);
						break;
				}

				break;
				
			case REF_Fields::DATE:
			case REF_Fields::TIMESTAMP:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getDateView($aField);
						break;
					case "edit":
						$sResult = $this->getDateEdit($aField);
						break;
				}

				break;

			case REF_Fields::PICTURE:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getPictureView($aField);
						break;
					case "edit":
						$sResult = $this->getPictureEdit($aField);
						break;
				}

				break;
				
			case REF_Fields::FILE:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getFileView($aField);
						break;
					case "edit":
						$sResult = $this->getFileEdit($aField);
						break;
				}

				break;
			
			case REF_Fields::DOCUMENT:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getDocumentView($aField);
						break;
					case "edit":
						$sResult = $this->getDocumentEdit($aField);
						break;
				}

				break;
			case REF_Fields::PASSWORD:
				switch ($sRenderType) {
					case "view":
						$sResult = $this->getPasswordView($aField);
						break;
					case "edit":
						$sResult = $this->getPasswordEdit($aField);
						break;
				}

				break;
			case REF_Fields::TABLE:
				$sResult = $this->getTable($aField, $sRenderType);
				break;
			default:
				$sResult = $this->getXxx($aField, $sRenderType);
				break;
	
		}

		if($sRenderType == "edit") {
			if($aField["type"] == "file" || $aField["type"] == "picture") {
				$sTmp		= $sResult;
				$sResult	= "<a title=\"" . htmlspecialchars($aField["description"]) . "\">" . $sTmp["field"] . "</a>";
				$sResult	.= $sTmp["script"];
			}
			else {
				$sResult	= "<a title=\"" . htmlspecialchars($aField["description"]) . "\">" . $sResult . "</a>";
			}
			
		}
		
		return $sResult;
	}

	protected function getBooleanEdit($aField)
	{
		$aValue		= MSF_EnumValue::parse($aField["value"]);
		
		if($aValue) {
			$iCurrentKey	= $aValue["key"];
		}
		else {
			$iCurrentKey	= $aField["value"];
		}
		
		if ($iCurrentKey == "1") {
			$sYesSelected 	= " checked=\"checked\"";
			$sNoSelected 	= "";
		}
		elseif ($iCurrentKey == "0")  {
			$sYesSelected 	= "";
			$sNoSelected 	= " checked=\"checked\"";
		} else {
			$sYesSelected 	= "";
			$sNoSelected 	= "";
		}
		
		$sYes 		 = "<input name=\"" . $aField["name"] . "\" type=\"radio\" value=\"1\"" . $sYesSelected . "/>";
		$sNo  		 = "<input name=\"" . $aField["name"] . "\" type=\"radio\" value=\"0\"" . $sNoSelected . "/>";
                $labelYes = MSF_Registry::get("MSF_Locale")->getI18N($aField["optional"]["labelYes"]);
		$labelNo = MSF_Registry::get("MSF_Locale")->getI18N($aField["optional"]["labelNo"]);
		$sResult     = "<label>" . $sYes . htmlspecialchars($labelYes) . "</label>\n";
		$sResult 	.= "<label>" . $sNo . htmlspecialchars($labelNo) . "</label>\n";
		
		return $sResult;
	}

	protected function getBooleanView($aField)
	{
		$aValue		= MSF_EnumValue::parse($aField["value"]);
		$sResult	= "";
		if ($aValue["key"] == "1") {
			$sResult = htmlspecialchars(MSF_Registry::get("MSF_Locale")->getI18N($aField["optional"]["labelYes"]));
		} elseif ($aValue["key"] == "0") {
			$sResult	= htmlspecialchars(MSF_Registry::get("MSF_Locale")->getI18N($aField["optional"]["labelNo"]));
		}
		
		return $sResult;
	}

	protected function getSimpleView($aField)
	{
		$sValue = $aField["value"];
		if (($aField["type"] == REF_Fields::INTEGER) && ($sValue !== "")) {
			$sValue = number_format($sValue, 0, '.', ' ');
		}
		if (($aField["type"] == REF_Fields::FLOAT) && ($sValue !== "")) {
			$sFractionalPart = strstr($sValue, ".");
			$sValue 		 = number_format($sValue, strlen($sFractionalPart) - 1, '.', ' ');
		}
		if ($aField["type"] == "string") {
			$sValue = htmlspecialchars($sValue);
		}
		else {
			$sValue = preg_replace('@<script[^>]*?>.*?</script>@si',' ',$sValue);
			$sValue = preg_replace('@<style[^>]*?>.*?</style>@si',' ',$sValue);
		}
		if ($aField["type"] == "string"){
			$sValue = $this->hrefActivate($sValue);
			$sValue = MSF_String::breakingLongWords($sValue);
		}
		if ($aField["type"] == "text") {
			$sValue = $this->hrefActivate($sValue);
			$sValue = MSF_String::breakingLongWords($sValue);
			if (isset($aField["optional"]["viewRTE"]) && $aField["optional"]["viewRTE"] == 0) {
				$sValue = str_replace("\n", "<br>", $sValue);
			}
		}
		return $sValue;
	}
	
	protected function getIntInputHandler($sId) {
		return "<script>".
					"var id = '".$sId."';" .
					"$(id).onkeydown = function(e) {".
						"e = (!e) ? window.event : e;".
						"if (
								((e.keyCode >=96) && (e.keyCode <= 105)) || ((e.keyCode >=48) && (e.keyCode <= 57))
								 || (e.keyCode == 8) || (e.keyCode == 9) || (e.keyCode == 46)|| (e.keyCode == 37) || (e.keyCode == 39) || (e.keyCode == 189) || (e.keyCode == 109)
								 || (e.ctrlKey && (e.keyCode == 67  || e.keyCode == 86 || e.keyCode == 88 || e.keyCode == 90 || e.keyCode == 65))
								 || (e.shiftKey && (e.keyCode == 35 || e.keyCode == 36))
							) {".
							"if (this.value.charAt(0) == '0' && this.value.length > 1) { ".	
								"this.value = '';" .
							"}".	
							"return true;".
						"} else {" .
							"return false;".
						"}" .			
					"};" .
					"$(id).onchange = function(e) {" .
						"if (isNaN(this.value)) { " .	
							"this.value = '';" .
						"}".	
						
					"};" .
				"</script>"; 
	}
	
	protected function getFloatInputHandler($sId) {
		return "<script>".
					"var id = '".$sId."';" .
					"$(id).onkeydown = function(e) {".
						"e = (!e) ? window.event : e;".
						"if (
							((e.keyCode >=96) && (e.keyCode <= 105)) || ((e.keyCode >=48) && (e.keyCode <= 57)) 
							|| (e.keyCode == 8) || (e.keyCode == 9) || (e.keyCode == 46)|| (e.keyCode == 37)|| (e.keyCode == 39)|| (e.keyCode == 110)
							|| (e.keyCode == 190)|| (e.keyCode == 191)|| (e.keyCode == 188) || (e.keyCode == 189) || (e.keyCode == 109)
							|| (e.ctrlKey && (e.keyCode == 67  || e.keyCode == 86 || e.keyCode == 88 || e.keyCode == 90 || e.keyCode == 65))
							|| (e.shiftKey && (e.keyCode == 35 || e.keyCode == 36))
							) {".	
							"return true;".
						"} else {" .
							"return false;".
						"}" .	
					"};" .
					"$(id).onchange = function(e) {" .
						"this.value = this.value.replace(',', '.');" .
						"if (isNaN(this.value)) { " .	
							"this.value = '';" .
						"}".						
					"};" .
				"</script>";
	}

	protected function getInputEdit($aField, $sType)
	{
		$iLength	= null;
		$iSize		= "250px";		
		if($sType == REF_Fields::INTEGER) {
			$iLength	= 12;
			$iSize		= 12;
		}
		elseif($sType == REF_Fields::FLOAT) {
			$iLength	= 15;
			$iSize		= 12;
		}
		
		if($sType == REF_Fields::STRING) {
			$sValue	= htmlspecialchars($aField["value"]);
			if (isset($aField["optional"]["width"]) && $aField["optional"]["width"] != "") {
				$iSize	= $aField["optional"]["width"];
				if (isset($aField["optional"]["widthUnit"])) {
					$iSize	.= $aField["optional"]["widthUnit"];
				}
			}	
		}
		else {
			$sValue = str_replace('"', '&#34;',$aField["value"]);
		}
		
		$sResult     = "<input ";
		$sResult    .= "id = \"" . $this->getId($aField["name"]) . "\"";
		$sResult    .= ($sType == "string") ? "style=\"width:" . $iSize . "\"" : "size = \"" . $iSize . "\"";
		$sResult    .= "maxlength = \"" . $iLength ."\"";
		$sResult    .= "name	= \"" . $aField["name"] . "\"";
		$sResult    .= "value = \"" . $sValue ."\"/>";
		
		if ($sType == 'int') {
			$sResult .= $this->getIntInputHandler($this->getId($aField["name"]));
		}
		if ($sType == 'float') {
			$sResult .= $this->getFloatInputHandler($this->getId($aField["name"]));
		}

		return $sResult;
	}

	protected function getTextEdit($aField)
	{
		$sSize = "90%";
		if (isset($aField["optional"]["width"]) && $aField["optional"]["width"] != "") {
			$sSize	= $aField["optional"]["width"];
			if (isset($aField["optional"]["widthUnit"])) {
				$sSize	.= $aField["optional"]["widthUnit"];
			}
		}
		
		if (isset($aField["optional"]["viewRTE"]) && $aField["optional"]["viewRTE"] == 0) {
			$aField["value"] = str_replace("<br>", "\n", html_entity_decode($aField["value"]));
			$sRte = "<p/>
					<textarea id=\"" . $this->getId($aField["name"]) . "\" style=\"width:" . $sSize . "\" 
					 name=\"" . $aField["name"] . "\">" . $aField["value"] . "</textarea>
					 <script>initTextarea('" . $this->getId($aField["name"]) . "');</script>";
		}
		else {
			$sRte  = "<textarea id=\"" . $this->getId($aField["name"]) . "\" style=\"height:350px; width:" . $sSize . ";\""; 
			$sRte .= "name=\"" . $aField["name"] . "\">" . htmlspecialchars($aField["value"]) . "</textarea>";
			$sRte .= "<script>initRte('" . $this->getId($aField["name"]) . "');</script>";
		}
		return $sRte;
	}

	protected function getReferenceEdit($aField)
	{	
		$aField		= $this->Fields->validateReference($aField);		
		$aColumns	= array();

		if (isset($aField["optional"]["columns"])) {
			foreach ($aField["optional"]["columns"] AS $aColumn) {
				if(isset($aField["optional"]["fieldsValue"][$aColumn])) {
					$sSelect	= "true";
				}
				else {
					$sSelect	= "false";
				}
				
				$sColumn  	 = "\"" . $aColumn . "\" : ";
				$sColumn 	.= "{";
				$sColumn 	.= "sType : \"int\",";
				$sColumn 	.= "\"select\" : " . $sSelect . ",";
				$sColumn 	.= "\"group\" : true,";
				$sColumn 	.= "\"sort\" : true,";
				$sColumn 	.= "\"filter\" : true";
				$sColumn 	.= "}";
				$aColumns[]  = $sColumn;
			}

		}
				
	
		$sRte 	 = "<span id=\"" . $aField["name"] . "\"></span>\n";
		$sRte 	.= "<script type=\"text/javascript\">";
		$sRte 	.= "new MSFW.Placeholder.Reference({";
		$sRte 	.= "	\"Container\" 		: \"".$aField["name"]."\",";
		$sRte 	.= "	\"referenceId\" 	: " . $aField["optional"]["reference"] . ",";
		$sRte 	.= "	\"inputName\" 		: \"" . $aField["name"] . "\",";
		$sRte 	.= "	\"columns\" 		: {" . implode(", ", $aColumns). "},";
		$sRte 	.= "	\"byId\" 			: true,";
		
		
		if($aField["optional"]["unique"] == 1) {			
			/*
			$sRte 	.= "	\"bIsUnique\"	: true,";
			$sRte	.= "	\"iObjectId\"	: " . $this->iUniqueId . ",";
			$sRte 	.= "	\"sUniqueType\"	: \"" . $this->sUniqueType . "\",";*/

			$sRte 	.= "	\"unique\"		: 1,";
			$sRte	.= "	\"objectId\"	: " . $this->iUniqueId . ",";
			$sRte 	.= "	\"uniqueType\"	: \"" . $this->sUniqueType . "\",";
		}
		
		if(isset($aField["optional"]["defaultGroup"])) {
			$sRte	.= "   \"defaultGroups\" : [";
			$i		= 0;
			foreach($aField["optional"]["defaultGroup"] as $sGroup) {
				$sRte 	.= "'" . $sGroup . "'";
				if($i<(count($aField["optional"]["defaultGroup"]) - 1)) {
					$sRte 	.= ",";
				}
				$i++;
			}
			$sRte	.="],";
		}
		
		if(isset($aField["optional"]["defaultFilter"])) {
			$sRte	.= "   \"defaultFilters\" : {";
			$i		= 0;
			foreach($aField["optional"]["defaultFilter"] as $name=>$value) {
				$sRte 	.= "'" . $name . "':'" . $value . "'";
				if($i<(count($aField["optional"]["defaultFilter"]) - 1)) {
					$sRte 	.= ",";
				}
				$i++;
			}
			$sRte	.="},";
		}
		
		if (isset($aField["optional"]["separator"])) {
			$sRte	.= "	\"valueSeparator\"	: '" . $aField["optional"]["separator"] . "',";
		}
		
		$aOpt 	 = $aField["optional"];
		$sRte	.= "	\"blockFilters\"	: " . (int)!(bool)MSF_SL::getParam($aOpt, "filterEnable", 0) . ",";
		$sRte	.= "	\"blockGroups\"		: " . (int)!(bool)MSF_SL::getParam($aOpt, "groupEnable", 0) . ",";
		$sRte 	.= "	\"multiselect\" 	: " . MSF_SL::getParam($aOpt, "multiselect") . ",";
		$sRte 	.= "	\"default\" 		: \"" . addslashes($aField["value"]) . "\"";
		$sRte 	.= "});";
		$sRte 	.= "</script>";
		
		return $sRte;
	}

	protected function getReferenceView($aField)
	{
		$sRowsSeparator = (isset($aField["optional"]["rowsSeparator"])) ? $aField["optional"]["rowsSeparator"] : ", ";
		$RefValue 	= new REF_Value();
		$RefValue->parse(preg_replace('|<a href="/media/download/\d{1,}">"' . MSF_Registry::get("MSF_Locale")->getWord("ROOT_RS_DOWNLOAD") . '</a>|', MSF_Registry::get("MSF_Locale")->getWord("ROOT_RS_DOWNLOAD"), $aField["value"]));	
		$aKeys		= $RefValue->getKeysList();
		$aValues 	= $RefValue->getValuesList();
		$aStr		= array();
		//$sBackUrl	= MSF_SL::getParam($_GET, "msf_path", "");
						
		for($i=0; $i<$RefValue->getSize(); $i++) {		
			$sKey = '0';
			if (is_array($aKeys[$i])) {
				$sKey = key($aKeys[$i]);
			}
			else {
				$sKey = $aKeys[$i];
			}
			$aStr[$i]= "<a href=\"/references/viewrow/" . $aField["optional"]["reference"] . "/" . stripslashes($sKey) 
					 . "\" id=\"reference\">" . $aValues[$i] . "</a>";
		}
		
		return implode($sRowsSeparator, $aStr);
	}

	protected function getStructureEdit($aField)
	{
		$UBox 		= MSF_Registry::get("MSF_UserBox");
		$sDefault 	= $aField["value"];
		$aOpt		= &$aField["optional"];
		$RefValue 	= new REF_Value();
		if (($sDefault === null) && isset($aOpt["selectAuthor"]) && $aOpt["selectAuthor"] == 1) {
			$sRes = RefFieldHelper::formatStructureValue(
					$UBox->getEmployeeAttribute("id"), 
					$UBox->getCurrentPostId(), 
					MSF_SL::getParam($aOpt, "employee", "name"), 
					MSF_SL::getParam($aOpt, "post", "post"), 
					MSF_SL::getParam($aOpt, "employeeEnable", 1), 
					MSF_SL::getParam($aOpt, "postEnable", 1),
					true
					);
			$RefValue->add(array(
				$UBox->getCurrentStructureId(),
				$UBox->getEmployeeAttribute("id"),
				$UBox->getCurrentPostId()
			), $sRes);
			
		}
		else {
			$oTempRefValue 	= new REF_Value();
			$oTempRefValue->parse($sDefault);
			$aTempValue	 	= $oTempRefValue->getValuesList();
			foreach ($oTempRefValue->getKeysList() AS $i => $aKeys) {
				switch (count($aKeys)) {
					case 3:
						$RefValue->add($aKeys, RefFieldHelper::formatStructureValue(
								$aKeys[1], 
								$aKeys[2], 
								MSF_SL::getParam($aOpt, "employee", "name"), 
								MSF_SL::getParam($aOpt, "post", "post"), 
								MSF_SL::getParam($aOpt, "employeeEnable", 1), 
								MSF_SL::getParam($aOpt, "postEnable", 1)
								)
						);
						break;
					case 2:
						$RefValue->add($aKeys, $aTempValue[$i]);
						break;
				}


			}
			
		}
		$sDefault = $RefValue->format();	
		$sRte 	 = "<span id=\"" . $aField["name"] . "\"></span>\n";
		$sRte 	.= "<script type=\"text/javascript\">\n";
		$sRte 	.= "new MSFW.Placeholder.Structure({\n";
		$sRte 	.= "	\"Container\"			: \"" . $aField["name"] . "\",\n";
		$sRte 	.= "	\"inputName\" 			: \"" . $aField["name"] . "\",\n";
		$sRte 	.= "	\"multiselect\" 		: " . MSF_SL::getParam($aOpt, "multiselect") .", \n";
		if (isset($aOpt["employeeEnable"])) 
			$sRte 	.= "	\"showEmployees\" 	: " . $aOpt["employeeEnable"] . ", \n";
		if (isset($aOpt["postEnable"]))
			$sRte 	.= "	\"showPosts\" 		: " . $aOpt["postEnable"] . ", \n";
		if (isset($aOpt["employee"]))
			$sRte 	.= "	\"employee\" 		: \"" . $aOpt["employee"] . "\", \n";
		if (isset($aOpt["post"])) 
			$sRte 	.= "	\"post\" 			: \"" . $aOpt["post"] . "\", \n";
		if (isset($aOpt["subdivision"])) 
			$sRte 	.= "	\"subdivision\" 	: \"" . $aOpt["subdivision"] . "\", \n";
		if (isset($aOpt["structOrder"])) 
			$sRte 	.= "	\"structOrder\" 	: \"" . $aOpt["structOrder"] . "\", \n";
		if (isset($aOpt["useStructSeparator"])) 
			$sRte 	.= "	\"useSeparator\" 	: \"" . $aOpt["useStructSeparator"] . "\", \n";
		if (isset($aOpt["structSeparator"])) 
			$sRte 	.= "	\"structSeparator\" : \"" . $aOpt["structSeparator"] . "\", \n";
		$sRte 	.= "	\"default\" 			: \"" . str_replace("\"", " ", $sDefault) . "\"\n";
		$sRte 	.= "});\n";
		$sRte 	.= "</script>\n";
		return $sRte;
	}

protected function getStructureView($aField)
	{
		$RefValue 	= new REF_Value();
		$RefValue->parse($aField["value"]);
		$aValues 	= $RefValue->getValuesList();
		$aKeys		= $RefValue->getKeysList();
		$aReturn	= array();
		$aOpt		= $aField["optional"];
		for($i = 0; $i<count($aKeys); $i++) {
			//dva idishnika - znachit eto podrazdelenie
			//spravochnok podrazdelelniy - 4
			if(count($aKeys[$i]) == 2) {
				//$aKeys[$i][1]. [0] - id structuri, [1] - id stroki v spravochnike podrazdeleniy
				$sTmp = "<a href=\"/references/viewrow/4/" . $aKeys[$i][1] . "\" id=\"structure\">" . $aValues[$i] . "</a>";
				array_push($aReturn, $sTmp);
			}
			//odin idishnik - eto polzovatel.
			//Spravochnik polzovateley - 2,
			// dolzhnostey - 3
			else {
				//$aKeys[$i][1]. [0] - id structuri, [1] - id stroki v spravochnike polzovateley,
				//[2] - id stroki b spravochnike podrazdeleniy
				/*
				if(MSF_SL::getParam($aOpt, "employeeEnable", 1) && MSF_SL::getParam($aOpt, "postEnable", 1)) {
					$sPattern		= "/(.*)\((.*)\)/i";
					$sRreplacement	= "<a href=\"/references/viewrow/2/"
									. $aKeys[$i][1] . "\">$1</a>"
									. "&#160;("
									. "<a href=\"/references/viewrow/3/"
									.  $aKeys[$i][2] . "\">$2</a>)";
				}
				else if(MSF_SL::getParam($aOpt, "employeeEnable", 1) && !MSF_SL::getParam($aOpt, "postEnable", 1)) {
					$sPattern		= "/(.*)/i";
					$sRreplacement	= "<a href=\"/references/viewrow/2/"
									. $aKeys[$i][1] . "\">$1</a>";
				}
				else if(!MSF_SL::getParam($aOpt, "employeeEnable", 1) && MSF_SL::getParam($aOpt, "postEnable", 1)) {
					$sPattern		= "/(.*)/i";
					$sRreplacement	= "<a href=\"/references/viewrow/3/"
									. $aKeys[$i][1] . "\">$1</a>";
				}
				else {
					$sPattern		= "/(.*)/i";
					$sRreplacement	= "";	
				}
				*/			
				$sValue	= "";				
				$iLen	= mb_strlen($aValues[$i]);
				if(!empty($aValues[$i]) && isset($aOpt["employeeEnable"]) && isset($aOpt["postEnable"]) 
					&& $aOpt["employeeEnable"] == 1 && $aOpt["postEnable"] == 1) {
					$aOpen 	= array();
					$aClose	= array();
					$n = 0;
					while($n < $iLen) {
						if(($iPos	= mb_strpos($aValues[$i], "(", $n)) != false) {
							$aOpen[]	= $iPos;
							$n			= $iPos + 1;			
						}
						else {
							break;
						}
					}
					
					$n = 0;
					while($n < $iLen) {
						if(($iPos	= mb_strpos($aValues[$i], ")", $n)) != false) {
							$aClose[]	= $iPos;
							$n			= $iPos + 1;			
						}
						else {
							break;
						}
					}					
					
					if(!empty($aOpen) && !empty($aClose) && count($aOpen) == count($aClose)) {
						$iIndex	= $aOpen[0];
						for($j = count($aOpen) - 1; $j >= 1; $j--) {
							if($aOpen[$j] > $aClose[$j - 1]) {
								$iIndex	= $aOpen[$j];
								break;	
							}
						}
						
						$sEmployee	= mb_substr($aValues[$i], 0, $iIndex - 1);
						$sPost		= mb_substr($aValues[$i], $iIndex + 1, $iLen - $iIndex - 2);
						if(isset($aOpt["structOrder"]) && $aOpt["structOrder"] == 0) {
							$sFirst		= $sPost;
							$sSecond	= $sEmployee;	
						}
						else {
							$sFirst		= $sEmployee;
							$sSecond	= $sPost;
						}
						
						if(isset($aOpt["useStructSeparator"]) && $aOpt["useStructSeparator"] == 1) {
							$sValue	= $sFirst . $aOpt["structSeparator"] . $sSecond;			
						}
						else {
							$sValue	= $sFirst . " (" . $sSecond . ")";
						}
					}
					else {
						$sValue	= $aValues[$i];						
					}				
					
				}
				else {
					$sValue	= $aValues[$i];
				}
				
				array_push($aReturn, "<a href=\"/references/viewrow/3/".$aKeys[$i][2]."\" id=\"structure\">".$sValue."</a>");
			}
			
		}
		if(isset($aOpt["structValuesSeparator"])) {
			$sValuesSeparator	= $aOpt["structValuesSeparator"];
		}
		else {
			$sValuesSeparator	= ", ";	
		}
		
		return implode($sValuesSeparator, $aReturn);
	}
	
	protected function getEnumView($aField)
	{
		$aValue	= MSF_EnumValue::parse($aField["value"]);
		$iKey	= 0;
		if (!empty($aField["optional"]["enum"])) {
			$sReturn	= current($aField["optional"]["enum"]);
		}
		if (isset($aField["optional"]["separator"])) {
			$sSeparator = $aField["optional"]["separator"];
		}
		if (!empty($aValue)) {
			if (isset($aValue[0])) {
				$sReturn	= "";
				for ($i=0; $i < sizeof($aValue); $i++) {
					if (strlen($sReturn)) $sReturn .= $sSeparator;
					if (isset($aField["optional"]["enum"][$aValue[$i]["key"]])) {
						$sReturn	.= $aField["optional"]["enum"][$aValue[$i]["key"]];
					}
				}
			} else {
				$iKey		= $aValue["key"];
				if (isset($aField["optional"]["enum"][$iKey])) {
					$sReturn	= $aField["optional"]["enum"][$iKey];
				}
			}
		}
		else {
  			$sReturn = ""; 
			if ($aField["value"] != "") {
				$sReturn	= current($aField["optional"]["enum"]);
			}
		}	
		$sReturn = MSF_Registry::get("MSF_Locale")->getI18N($sReturn);
                return 	htmlspecialchars($sReturn);
	}
	
	protected function getEnumEdit($aField)
	{
		$aValue			= MSF_EnumValue::parse($aField["value"]);
		$aCurrentKey	= array();
		$bMultiselect	= false;
		$sSeparator		= ", ";
		$sHtml			= "";
                
		if ($aValue) {
			if (isset($aValue[0])) {
				for ($i=0; $i < sizeof($aValue); $i++) {
					$aCurrentKey[$i]	= $aValue[$i]["key"];
				}
			} else {
				$aCurrentKey[0]	= $aValue["key"];
			}
		}
		else {
			if ($aField["value"] != "") {
				$aCurrentKey	= split(", ", $aField["value"]);
			}
		}
		if (isset($aField["optional"]["multiselect"])) {
			$bMultiselect = ($aField["optional"]["multiselect"] == 1) ? true : false;
		}
		if ($bMultiselect) {
			if (isset($aField["optional"]["separator"])) {
				$sSeparator = ((strlen(trim($aField["optional"]["separator"]))) > 0) ? trim($aField["optional"]["separator"]) : $sSeparator;
//				$sSeparator = htmlspecialchars($sSeparator);   
			}
			foreach ($aField["optional"]["enum"] AS $iKey => $sValue) {
				if (strlen($sHtml)) $sHtml .= $sSeparator;
				$sHtml .= " <input type=\"checkbox\" id=\"" . $this->getId($aField["name"]) . "\" name=\"" . $aField["name"] . "[]\" value=\"" . $iKey . "\"";
				if (in_array($iKey, $aCurrentKey)) $sHtml .= " checked ";  
				$sHtml .= " />\n"; 
				$sHtml .= "<label for=\"" . $this->getId($aField["name"]) . "\" >" .  htmlspecialchars($sValue) . "</label>\n";
			}
			$sHtml .= "<input type=\"hidden\" name=\"" . $aField["name"] . "[]\" value=\"-1\" />\n";
		
		}
		else {
			$sHtml   = "<select id=\"" . $this->getId($aField["name"]) . "\" name=\"" . $aField["name"] . "\">\n";
			foreach ($aField["optional"]["enum"] AS $iKey => $sValue) {
				$sValue = MSF_Registry::get("MSF_Locale")->getI18N($sValue);                                
                                if (in_array($iKey, $aCurrentKey)) {
					$sHtml .= "<option value=\"" . $iKey . "\" selected=\"selected\">" .  htmlspecialchars($sValue) . "</option>";
				}
				else {
					$sHtml .= "<option value=\"" . $iKey . "\">" .  htmlspecialchars($sValue) . "</option>";
				}
				
			}
			
			$sHtml .= "</select><span style=\"cursor:default;\">&#160;&#160;&#160;&#160;</span>";
		}
		return $sHtml;
	}
	
	protected function getId($sName)
	{
		return "id" . $sName;
	}
	
	protected function getDateEdit($aField)
	{
		if($aField["type"] == "date") {
			$bTime			= false;
			$sTimeFormat	= CNF_DATE_FORMAT;
		}
		else {
			$bTime			= true;
			$sTimeFormat	= CNF_DATE_TIME_FORMAT;
		}
		
		if($aField["optional"]["setCurrentDate"] == "1" || $aField["value"] != "") {
			if($aField["optional"]["setCurrentDate"] == "1" && $aField["value"] === null) {
				$oDate 				= new MSF_Date();
				$aField["value"]	= $oDate->format($sTimeFormat);
			}
			$sDefault	= MSF_Date::toViewFormat($aField["value"]);
		}
		else {
			$sDefault	= "";
		}
		
		$sRte 	 = "<span id=\"" . $aField["name"] . "\"></span>\n";
		$sRte 	.= "<script type=\"text/javascript\">";
		$sRte 	.= "new MSFW.Placeholder.Calendar({";
		$sRte 	.= "	\"Container\"		: \"" . $aField["name"] ."\",";
		$sRte 	.= "	\"inputName\" 	: \"" . $aField["name"] . "\",";
		$sRte 	.= "	\"default\" 	: \"" . $sDefault . "\",";
		$sRte 	.= "	\"time\" 		: \"" . $bTime . "\"";
		$sRte 	.= "});";
		$sRte	.= "</script>";
		
		return $sRte;
	}
	
	protected function getDateView($aField)
	{
		if($aField["value"] == "") {
			$sReturn	= "";
		}
		else {
			$sReturn	= MSF_Date::toViewFormat($aField["value"]);
		}
		
		return $sReturn;
	}
	
	protected function getPictureView($aField)
	{
		$sValuesSeparator	= (isset($aField["optional"]["valuesSeparator"])) ? $aField["optional"]["valuesSeparator"] : ", ";
		$aPictures			= array();
		if(!empty($aField["value"])) {
			$aIds		= explode(",", $aField["value"]);
			foreach($aIds as $iId) {
				$iWidth			 = (int) $aField["optional"]["width"];
				$iHeight		 = (int) $aField["optional"]["height"];
				$sAlt			 = $aField["optional"]["alt"];
				$sSrc 			 = "/media/image/" . $iId;
				$sResizedSrc	 = $sSrc . "/" . $iWidth . "/" . $iHeight;
				
				$sLink 	= "<a href=\"".$sSrc."\" target=\"blank\">";
				$sLink 	.= "<img src=\"" . $sResizedSrc . "\" alt=\"" . $sAlt . "\"/>";
				$sLink 	.= "</a>";
				
				array_push($aPictures, $sLink);
			}
		}
				
		return implode($sValuesSeparator, $aPictures);
	}
	
	protected function getPictureEdit($aField)
	{
		return $this->getFileEdit($aField, "picture");
	}
	
	protected function getFileEdit($aField, $sType = "file")
	{
		$aFiles		= array();
		$iMediaId	= 0;
		if(!empty($aField["value"])) {
			$aIds		= explode(",", $aField["value"]);
			if (count($aIds) > 0) {
				$Media     	= new MD_Media(new MD_MediaDB(MSF_Registry::get("MSF_DB")));
				$Media->setLinkDirectory(CNM_MEDIA_LINKS_DIRECTORY);
				foreach($aIds as $iFileId) {
					try {
						$aAtrs			= $Media->getFileInfo($iFileId);
						$iMediaId		= $aAtrs["user_id"];
						$sPathFile		= CNF_ABS_PATH . "/" . $aAtrs["directory"] . "/" . $aAtrs["file_id"];
						if (!file_exists($sPathFile)) {
							$sLink = $aAtrs["name"] . " (" .MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_MESSAGE_FILE_NOT_FOUND") . ")";
						}
						else {
							$sLink			= /*"<a target=\"blank\" href=\"/media/download/" . $iFileId . "\">" . */$aAtrs["name"]/* . "</a>"*/;
						}				
					}
					catch(Exception $e) {
						$sLink			= MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_MESSAGE_FILE_NOT_FOUND");
					}
					
					$aTmp			= array();
					if($sType == "file") {
						$aTmp["link"]	= $sLink;
					}
					else {
						$iWidth			 = (int) $aField["optional"]["width"];
						$iHeight		 = (int) $aField["optional"]["height"];
						$sAlt			 = $aField["optional"]["alt"];
						$sSrc 			 = "/media/image/" . $iFileId;
						$sResizedSrc	 = $sSrc . "/" . $iWidth . "/" . $iHeight;
						$aTmp["link"]		= "<img src=\"" . $sResizedSrc . "\" alt=\"" . $sAlt . "\"/>";
					}
                                        try {
                                            $aTmp["name"]	= $aAtrs["name"];
                                            $aTmp["id"]		= $iFileId;
                                            array_push($aFiles, $aTmp);
                                        }
                                        catch(Exception $e) {
                                            $sLink	= MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_MESSAGE_FILE_NOT_FOUND");
					}

				}
								
			}
				
		}
		
		$sFiles 	= "<script type=\"text/javascript\">\n"
						.	"	new REF_File({\n"
						.	"		container	: \"" . "cont-" . $aField["name"] . "\",\n"
						.	"		name 		: \"" . $aField["name"] . "\",\n"
						.	"		files 		:  " . MSF_Json::encode($aFiles) . ",\n"
						.	"		multiselect	: \"" . $aField["optional"]["multiselect"] . "\"\n"
						.	"	});\n"
				  .	"</script>";
		
		
		$sStr = '<div class="file-placeholder" id="cont-' . $aField['name']. '"></div>';
		
		return array(
						"field"  => $sStr . $sFiles,
						"script" => ''
					);
	}

	protected function getFileView($aField) {
        $oDb = MSF_Registry::get("MSF_DB");
        if (MSF_Registry::exists("HAS_ACCESS")) {
            $hasAccess = MSF_Registry::get("HAS_ACCESS");
            $docTypeId = MSF_Registry::get("DOC_TYPE_ID");
            $docId = MSF_Registry::get("DOC_ID");
            $docVerId = MSF_Registry::get("DOC_VERSION_ID");
            $currStructureId = MSF_Registry::get("CURRENT_STRUCTURE_ID");
            $fieldName = $aField["name"];
            if ($hasAccess) {
                $sLogin = $_SESSION["MSF_UserBox"]["user"]["login"];
                $oAuthDb = new MSF_AuthenticationDB($oDb);
                $oAuthDb->checkLostUsersDB();
                $oAuthDb->deleteOldLostUsers();
                $sSecret = md5(MSF_String::random(10) . microtime());
                $sParams = "$docTypeId:$docId:$fieldName:$currStructureId";
                $oAuthDb->insertSecretParams($sLogin, $sSecret, $sParams);
            }
        }
        else $hasAccess = false;
        $sReturn			= "";
		$sValuesSeparator	= (isset($aField["optional"]["valuesSeparator"])) ? $aField["optional"]["valuesSeparator"] : ", ";
		$agentScript = "";
                if(!empty($aField["value"])) {
			$aIds		= explode(",", $aField["value"]);
			if (count($aIds) > 0) {
				$Media     	= new MD_Media(new MD_MediaDB(MSF_Registry::get("MSF_DB")));
				$Media->setLinkDirectory(CNM_MEDIA_LINKS_DIRECTORY);
				$aFiles		= array();
				foreach($aIds as $iMediaId) {
					try {
						$aAtrs		= $Media->getFileInfo($iMediaId);
						$sPathFile	= $aAtrs["directory"] . "/" . $aAtrs["file_id"];
						if (!file_exists($sPathFile)) {
							$sLink = $aAtrs["name"] . " (" .MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_MESSAGE_FILE_NOT_FOUND") . ")";
						}
						else {
							$sLink		= "<a href=\"/media/download/" . $iMediaId . "\" id=\"file\">" . $aAtrs["name"] . "</a>";
                                                        
                                                        //".$iMediaId."&key=".$sSecret."&server=".$strOut."                                                        
                                                        if (strtolower(substr($_SERVER["SERVER_PROTOCOL"], 0, 5)) == 'https') {
                                                            $strOut = 'https://'.$_SERVER['HTTP_HOST'];
                                                        } else {
                                                            $strOut = 'http://'. $_SERVER['HTTP_HOST'];
                                                        }                
                                                        if(isset($sSecret)){
                                                            $sLink     .= "<a href='javascript:void(0);' style='display:none' class='agent-btn' onclick='sendAgentLink(\"$iMediaId&key=$sSecret&server=$strOut\");'><img src=\"/modules/workflow/view/templates/default/img/pencil.png\" style=\"cursor:pointer\" title=\"" . 
                                                                    MSF_Registry::get("MSF_Locale")->getWord("REFERENCE_EDIT") . "\"></a>";
                                                        }
						}	
					}
					catch(Exception $e) {
						$sLink = MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_MESSAGE_FILE_NOT_FOUND");
					}					
					array_push($aFiles, $sLink);
				}                                
                                if ($hasAccess && isset($sSecret)) {
                                            $agentScript ="<script>
                                                        new Ajax.Request('http://127.0.0.1:9898/ping', {
                                                                method: 'get',
                                                                onCreate: function(request) { 
                                                                    request.transport.setRequestHeader = Prototype.emptyFunction; 
                                                                }, 
                                                                onSuccess: function(transport) {
                                                                    if(transport.responseText == 'ok'){
                                                                        $$('.agent-btn').each(function(i){i.style.display='inline';})
                                                                    }
                                                                }
                                                        });
                                                        function sendAgentLink(path){
                                                           new Ajax.Request('http://127.0.0.1:9898/?file='+path, {
                                                              method: 'get',
                                                              onCreate: function(request) { 
                                                                 request.transport.setRequestHeader = Prototype.emptyFunction; 
                                                              }, 
                                                              onSuccess: function(transport) {
                                                                 
                                                              }
                                                           });
                                                        }
                                                      </script>";
                                        }
				
				$sReturn	= implode($sValuesSeparator, $aFiles);
			}
				
		}
		
		return $sReturn . $agentScript;
	}

	protected function getDocumentEdit($aField)
	{	
		// chtoby sozdavalis' docymenty so starym polem document
		if(!isset($aField["optional"]["doctypes"])) {
			$DoctypeList = new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));
			$aList		 = $DoctypeList->getAll();
			foreach($aList as $aDoctype) {	
				$aField["optional"]["doctypes"][] = $aDoctype["doctype_id"];				
			}
					
		}
		
		$sRte 	 = "<span id=\"" . $aField["name"] . "\"></span>\n";
		$sRte 	.= "<script type=\"text/javascript\">";
		$sRte 	.= "new MSFW.Placeholder.Document({";
		$sRte 	.= "	\"Container\"	: \"" . $aField["name"] . "\",";
		$sRte 	.= "	\"inputName\" 	: \"" . $aField["name"] . "\",";
		$sRte 	.= "	\"multiselect\" : " . $aField["optional"]["multiselect"].", ";
		$sRte 	.= "	\"docTypes\" : " . "\"" . implode(",", $aField["optional"]["doctypes"])."\", ";		
		$sRte 	.= "	\"default\" 	: \"" . str_replace('"', '&quot;', $aField["value"]) . "\"";
		$sRte 	.= "});";
		$sRte 	.= "</script>";
		
		return $sRte;
	}
	
	protected function getDocumentView($aField)
	{				
		$sResult 			= "";
		$sValuesSeparator	= (isset($aField["optional"]["valuesSeparator"])) ? $aField["optional"]["valuesSeparator"] : ", ";
		$RefValue 			= new REF_Value();
		$RefValue->parse($aField["value"]);		
		$iSize 		= $RefValue->getSize();		
		for ($i = 0; $i < $iSize; $i++) {
			$aTmp = $RefValue->get($i);
			
			if (isset($aTmp["key"][0])) {								
				$sResult .= "<a href=\"/workflow/document/view/" . $aTmp["key"][0] . "\" id=\"document\">" . htmlspecialchars($aTmp["value"]) . "</a>";
			}
			elseif (isset($aTmp["value"])) {			
				$sResult .= "<a href=\"/workflow/document/view/" . $aTmp["key"] . "\" id=\"document\">" . htmlspecialchars($aTmp["value"]) . "</a>";
			}

			if ($i < $iSize - 1) {
				$sResult .= $sValuesSeparator;
			}
		}
		
		return $sResult;
	}
	
	protected function getPasswordEdit($aField)
	{
		if ($this->sMode == "add") {
			$sPass		 = MSF_String::decrypt($aField["value"]);
		}
		else {
			$sPass		 = ":!";
		}
		$sReturn	 = "<div id=\"e".$aField["name"]."\" style=\"color:red;\"></div>";
		$sHandler	 = "if ((this.value.length < 3) && this.value.length > 0) {"
					 . "\$('e".$aField["name"]."').update('" 
                                         . MSF_Registry::get("MSF_Locale")->getWord("ROOT_PASSWORD_LENGTH")
                                         . "')}"
					 . "else {\$('e".$aField["name"]."').update('')}";
		$sReturn	.= "<input type=\"password\" name=\"" . $aField["name"] 
					.  "[main]\" value=\"" . $sPass . "\" onchange=\"".$sHandler."\"/>";
		$sReturn	.= "<br/>";
		$sReturn	.= "<input type=\"password\" name=\"" . $aField["name"] 
					.  "[confirm]\" value=\"" . $sPass ."\" onchange=\"".$sHandler."\"/>";
		return $sReturn;
	}
	
	protected function getPasswordView($aField)
	{
		return "**";
	}
	
	protected function getXxx($aField, $sRenderType)
	{
		return  "\n<span style=\"color:#FF0000;\">\n" .
				"[unsupported " .
						"mode = \"" . $sRenderType . "\" " .
						"name = \"" . $aField["name"] . "\" " .
						"type = \"" . $aField["type"] . "\" " .
						"title = \"" . $aField["title"] . "\" " .
						"value = \"" . $aField["value"] . "\" " .
						"/]\n" .
				"</span>\n";
	}
	
	

	protected function getTable($aField, $sMode)
	{
		$sId			= "c_" . $aField["name"];
		$aFields		= (isset($aField["optional"]["fields"])) 
							? $aField["optional"]["fields"] 
							: array();
		if(!$this->isWord) {
			$sDisplayInRS	= (isset($aField["optional"]["displayInRS"])) 
								? $aField["optional"]["displayInRS"] 
								: null;
			$sValue 		= ($sMode == "view")
								? addslashes(str_replace(array("\n", " "), array("^S^", "&#160;"), 
								  $this->hrefActivate(htmlspecialchars(str_replace("&#160;", " ", $aField["value"])))))
								: addslashes(htmlspecialchars_decode($aField["value"]));	
			foreach ($aFields AS $sKey => $aBody) {
				if (is_string($aBody)) {
					continue;
				}
				else if ($aBody["type"] !== "TEXT") {
					$aExtField 					= $this->Fields->getField($aBody["type"]);
					if (!empty($aExtField)) {
						$aFields[$sKey]["type"] 	= $aExtField["type"];
						$aFields[$sKey]["optional"] = $aExtField["optional"]; 
						$aFields[$sKey]["default"] 	= $aExtField["default"];	
						if ($aFields[$sKey]["type"] == "structure") {
							$this->getAuthor($aFields[$sKey]["optional"]["postEnable"]);
							$UBox = MSF_Registry::get("MSF_UserBox");
							$oRv 	= new REF_Value();
							$oRv->add(
									array(
											$UBox->getCurrentStructureId(),
											$UBox->getEmployeeAttribute("id"), 
											$UBox->getCurrentPostId()
											),
									RefFieldHelper::formatStructureValue(
											$UBox->getEmployeeAttribute("id"), 
											$UBox->getCurrentPostId(), 
											MSF_SL::getParam($aFields[$sKey]["optional"], "employee", "name"), 
											MSF_SL::getParam($aFields[$sKey]["optional"], "post", "post"), 
											MSF_SL::getParam($aFields[$sKey]["optional"], "employeeEnable", 1), 
											MSF_SL::getParam($aFields[$sKey]["optional"], "postEnable", 1)
											)
									);
							$aFields[$sKey]["optional"]["author"] = $oRv->format();
						}
						if($aFields[$sKey]["type"] == "reference") {
							$aFields[$sKey] = $this->Fields->validateReference($aFields[$sKey]);								
						}
						if ($aFields[$sKey]["type"] == "text") {
							$aFields[$sKey]["default"] = str_replace("</p> ", "\n", $aFields[$sKey]["default"]);
							$aFields[$sKey]["default"] = str_replace("<br>", "\n", $aFields[$sKey]["default"]);
							$aFields[$sKey]["default"] = strip_tags($aFields[$sKey]["default"]);
						}					
						
					}
					else {
						$aFields[$sKey]["optional"] = null;
						$aFields[$sKey]["default"] 	= "";
					}
	
				}
	
			}
			return 		"<div id=\"" . $sId . "\" title = \"" . $aField["description"] ."\"></div>\n"
					.	"<script type=\"text/javascript\">\n"
					.	"	new REF_Table({\n"
					.	"	oContainer 		: \"" . $sId . "\",\n"
					.	"	sWidth 			: \"" . $aField["optional"]["width"] . "\",\n"
					.	"	sCellpadding 	: \"" . $aField["optional"]["cellpadding"] . "\",\n"
					.	"	sBorderWidth 	: \"" . $aField["optional"]["borderWidth"] . "\",\n"
					.	"	sDisplayInRS 	: \"" . $sDisplayInRS . "\",\n"
					.	"	sMode 			: \"" . $sMode. "\",\n"
					.	"	aFields 		:  " . MSF_Json::encode($aFields) . ",\n"
					.	"	sName 			: \"" . $aField["name"] . "\",\n"
					.	"	sDefaultValue	: \"" . $sValue . "\"\n"
					.	"	});\n"
					.	"</script>";
		}
		else {
			$aPreTitles = array();
			foreach($aFields AS $sKey => $Value) {
				if(is_array($Value)) {
					$aPreTitles[$sKey] = $Value["title"];			
				}
				else {
					$aPreTitles[$sKey] = $Value;	
				}
				
			}
			
			$sTable = "<div id=\"" . $sId . "\" title = \"" . $aField["description"] ."\">\n
						<table width='" . $aField["optional"]["width"] . "' cellpadding='" . 
						$aField["optional"]["cellpadding"] . "'border='" . $aField["optional"]["borderWidth"] . "'>";
												
			if(!empty($aField["value"])) {				
				$aTmp		= explode("^R^", str_replace(array("^S^", "  "), array("<br/>", "&#160; "), str_replace("&#160;", "  ", $aField["value"])));
				$aTmpT 		= explode("^C^", $aTmp[1]);
				$sTable 	.= "<tr style='font:bold;'>";
				foreach($aTmpT AS $sValue) {
					$sTable .= "<td>" . $aPreTitles[$sValue] . "</td>";					
				}				
				
				$sTable .= "</tr>";				
				for($i = 2; $i < count($aTmp); $i++) {
					$sTable 	.= "<tr>";
					$aCols		= explode("^C^", $aTmp[$i]);
					$iN 		= 0;
					$sRecValue	= "";
					foreach($aCols AS $sCol) {						
						if(is_array($aFields[$aTmpT[$iN]])) {
							$sType	= $aFields[$aTmpT[$iN]]["type"];
						}
						else {
							$sType = "text";
						}
						
						if($sType != "text") {							
							$aDocFields = $this->Fields->getAsList();							
							foreach($aDocFields AS $aValue) {
								if($aValue["name"] == $sType) {
									$aValue["value"] = $sCol;
									$sRecValue = $this->get($aValue, "view");									
									break;					
								}
								
							}		
							
						}
						else {							
							$sRecValue = $sCol;
						}						
						
						$sTable .= "<td>" . $sRecValue . "</td>";
						$iN++;						
					}
					
					$sTable .= "</tr>";					
				}			
				
			}
			else {
				$sTable 	.= "<tr style='font:bold;'>";
				foreach($aPreTitles AS $sValue) {
					$sTable .= "<td>" . $sValue . "</td>";					
				}				
				
				$sTable .= "</tr>";			
			}
			
			$sTable .= "</table></div>";			
			return $sTable;
		}
		
	}
	
	protected $sEmployeeName 	= "";
	
	protected $sPost 			= "";
	
	protected $iStructureId 	= 0;
	
	protected $iPostId		= 0;
	
	protected $iEmployeeId	= 0;
	
	public function setEmployeeId($iEmployeeId)
	{
		$this->iEmployeeId = $iEmployeeId;
	}
	
	public function setPostId($iPostId) 
	{
		$this->iPostId = $iPostId;
	}
	
	public function setEmployeeName($sEmployeeName)
	{
		$this->sEmployeeName = $sEmployeeName;
	}
	
	public function setPost($sPost)
	{
		$this->sPost = $sPost;
	}
		
	public function setStructureId($iStructureId)
	{
		$this->iStructureId = $iStructureId;
	}
	
	public function getAuthor($hasPost = false)
	{
		if ($hasPost) {
			return $this->sEmployeeName . "(" . $this->sPost . ")" . 
					REF_Value::COLUMN_DELIMITER . $this->iStructureId . 
					REF_Value::COLUMN_DELIMITER . $this->iEmployeeId. 
					REF_Value::COLUMN_DELIMITER . $this->iPostId;
		}
		else {
			return $this->sEmployeeName . 
					REF_Value::COLUMN_DELIMITER . $this->iStructureId . 
					REF_Value::COLUMN_DELIMITER . $this->iEmployeeId.
					REF_Value::COLUMN_DELIMITER . 0;
		}
		
	}
	
	public function setMode($sMode)
	{
		$this->sMode	= $sMode;
	}
	  
	public function hrefActivate($sText)
	{                      		
		$UrlPattern = 	"#(https?://|ftp://).[^\s'\"\^]+[^\s.,>)\]'!?\^]#";		 	   	  
		$aText 		= preg_split("%(<.*?>)%is", $sText, -1, PREG_SPLIT_DELIM_CAPTURE);
		$bWaitLink 	= false;

		for($i = 0; $i < count($aText); $i++)
		{
			if ($bWaitLink) {
				if (preg_match("%</a>%is", $aText[$i])) {
		    		$bWaitLink = false;
		    	}
		    	else {
					continue;
		    	}
			}
			
		    if($i & 1) {
		    	if (preg_match("%<[a].*[^/]>%is", $aText[$i])) {
		    		$bWaitLink = true;
		    	}
		    }
		    else {		    	
		    	$aText[$i] = preg_replace($UrlPattern, '<a href="$0">$0</a>', $aText[$i]);
		    }
		}	
		$sText = implode('', $aText);

		return $sText;
	}	
}


?>