<?php
class RefFieldHelper 
{
	public static function getValue($iRefId, $sColumnName, $iId)
	{
		$oDb 	= MSF_Registry::get("MSF_DB");
		$sSql 	= "SELECT ".$sColumnName." FROM ".self::getTableName($iRefId)." WHERE id = ". $iId;
		$sValue = $oDb->select($sSql, true, $sColumnName);
		return MSF_RS_Params::toOutput($sValue, self::getType($iRefId, $sColumnName));
	}
	
	public static function getType($iRefId, $sColumnName) 
	{
		$aTemp 		= self::getInfo($iRefId);
		$oColumns 	= new MSF_XmlWrapper($aTemp["columns"]);
		return $oColumns->get($sColumnName)->getValue("type");
	}
	
	public static function getTableName($iRefId) 
	{
		$aTemp 		= self::getInfo($iRefId);
		return $aTemp["table_name"];
	}
	
	public static function getInfo($iRefId)
	{
		static $aInfo = array();
		if (!isset($aInfo[$iRefId])) {
			$oDb 			= new UserReferenceDB(MSF_Registry::get("MSF_DB"));
			$aInfo[$iRefId] = $oDb->load($iRefId);
		}
		
		return $aInfo[$iRefId];
	}
	
	public static function formatStructureValue($iEmployeeId, $iPostId, $sEmployee, 
												$sPost, $bShowEmployee, $bShowPost, $bAuthor = false)
	{
		try {
			$sEmployeeTitle = RefFieldHelper::getValue(
					2, 
					$sEmployee, 
					$iEmployeeId
					);	
		}
		catch (Exception $oE) {
			MSF_Logger::logTrace($oE);
			$sEmployeeTitle = "";
		}
		
		try {
			$sPostTitle 	= RefFieldHelper::getValue(
				3, 
				$sPost, 
				$iPostId
				);
				
			$UBox 	= MSF_Registry::get("MSF_UserBox");
			$aPosts = $UBox->getPosts();
			$sBoss	= "";
			if ($bAuthor) {		
				for ($i = 0; $i < count($aPosts); $i++) {
					if ($aPosts[$i]["id"] == $iPostId) {
						if (isset($aPosts[$i]["boss"]) && $aPosts[$i]["boss"] == 1) {
							$sBoss = " " . MSF_Registry::get("MSF_Locale")->getWord("ROOT_POST_IO");
						}
						break;
					}
				}
				$sPostTitle .= $sBoss;
			}
		}
		catch (Exception $oE) {
			MSF_Logger::logTrace($oE);
			$sPostTitle = "";
		}

		if ($bShowEmployee && $bShowPost) {
			return $sEmployeeTitle . " (" . $sPostTitle . ")";
		}
		else if ($bShowEmployee && !$bShowPost) {
			return $sEmployeeTitle;
		}
		else if (!$bShowEmployee && $bShowPost) {
			return $sPostTitle;
		}
		else {
			return "";
		}
		
	}
	
	public static function formatStructureValueByStructureId($iStructureId, $sEmployee, 
												$sPost, $bShowEmployee, $bShowPost) {
		$oOs = MSF_OrgStructureFacade::getInstance();
		return self::formatStructureValue(
				$oOs->getEmployeeIdByStructureId($iStructureId), 
				$oOs->getPostIdByStructureId($iStructureId),
				$sEmployee, 
				$sPost, 
				$bShowEmployee, 
				$bShowPost);
	}
	
}
?>