<?

include_once "modules/references/library/Reference/REF_SystemFieldsSettings.php";

class UserReferenceDB extends MSF_ModelDBSupport {

    public function patchColumnTemplate($tableName, $colName, $colType, $colRussian, $default, $defaultValue) {
        $sSQL = "select  count(column_name)  from  information_schema.columns  where  table_name = 'ref_system_users'  and  column_name='language'";
        $aResult = $this->DB->select($sSQL);
        if ($aResult[0]["count"] == 0) {
            $this->addColumn($this->escapeValue($tableName),$colName, $colType, null, $default, $defaultValue);

            $sSQL = "SELECT columns, template" . "\n" .
                    "FROM references_config" . "\n" .
                    "WHERE table_name='" . $this->escapeValue($tableName) . "'";
            $colTempl = $this->DB->select($sSQL, true);

            $tb_columns = $colTempl["columns"];
            $tb_templ = $colTempl["template"];

            $lang_element = '
                            <element type="array" name="'.$colName.'" title="'.$colRussian.'">
                                <item name="blocked" value="1"/>
                                <item name="description" value=""/>
                                <item name="type" value="string"/>
                                <item name="required" value="1"/>
                                <item name="unique" value="0"/>
                                <item name="visible" value="0"/>
                                <item name="group" value="0"/>
                                <item name="sort" value="0"/>
                                <item name="filter" value="0"/>
                                <item type="array" name="optional">
                                    <item name="width" value="50"/>
                                    <item name="widthUnit" value="px"/>                                    
                                </item>
                                <item name="defaultValue" value="ru"/>
                            </element>
                            ';
            $lang_templ = '
                           <tr>
                            <td class="form-row-title">'.$colRussian.'</td>
                            <td class="form-row-title">&nbsp;{'.$colRussian.'}</td>
                        </tr>
                        ';

            $colString = substr_replace($tb_columns, $lang_element, stripos($tb_columns, "</document>"), 0);
            $tempString = substr_replace($tb_templ, $lang_templ, strrpos(substr($tb_templ, 0, stripos($tb_templ, 'Шаблон панели инструментов')), '<tr>'), 0);

            $sSQL = "UPDATE  references_config" . "\n" .
                    "SET  columns = '$colString', template = '$tempString'" . "\n" .
                    "WHERE table_name='" . $this->escapeValue($tableName) . "'";
            $this->DB->executeQuery($sSQL);
        }
    }

    public function nameExists($sName) {
		$sSQL =	"SELECT" . "\n" .
                "COUNT(*) AS total" . "\n" .
                "FROM" . "\n" .
                "references_config" . "\n" .
                "WHERE" . "\n" .
                "name = '" . $this->escapeValue($sName) . "'";

        return $this->DB->select($sSQL, true, 'total') > 0;
    }

	public function load($iId)
	{
        $sSQL = "SELECT name, columns, table_name, template, description, group_id, is_system, full_description" . "\n" .
				"FROM references_config". "\n" .
                "WHERE reference_id='" . $iId . "'";

        return $this->DB->select($sSQL, true);
    }

	public function loadByName($sName)
	{
        $sSQL = "SELECT reference_id, name, columns, table_name, template, is_system" . "\n" .
				"FROM references_config". "\n" .
                "WHERE name='" . $sName . "'";

        return $this->DB->select($sSQL, true);
    }

	public function checkUnique($sTable, $sName, $mValue, $iId)
	{
		$sSql	=	"SELECT" . "\n" .
                "COUNT(*) AS total" . "\n" .
                "FROM" . "\n" .
                $sTable . "\n" .
                "WHERE" . "\n" .
                $sName . "='" . $this->escapeValue($mValue) . "'" . "\n" .
                "AND" . "\n" .
                "id != '" . $iId . "'";

        return $this->DB->select($sSql, true, "total");
    }

	public function loadByTableName($sTableName)
	{
        $sSQL = "SELECT reference_id, name, columns, table_name, is_system" . "\n" .
				"FROM references_config". "\n" .
                "WHERE table_name='" . $this->escapeValue($sTableName) . "'";

        return $this->DB->select($sSQL, true);
    }

	public function saveConfig($iId, $sName, $sColumns, $sTemplate, $sDesc, $sFullDesc, $iGroupId)
	{
		$Date	= new MSF_Date(time());
		$sSQL = "UPDATE". "\n" .
                "references_config" . "\n" .
                "SET" . "\n" .
                "name='" . $this->escapeValue($sName) . "'," . "\n" .
                "columns='" . $this->escapeValue($sColumns) . "'," . "\n" .
                "template='" . $this->escapeValue($sTemplate) . "'," . "\n" .
                "description='" . $this->escapeValue($sDesc) . "'," . "\n" .
                "full_description='" . $this->escapeValue($sFullDesc) . "'," . "\n" .
                "group_id='" . $iGroupId . "'," . "\n" .
                "modified_at='" . $Date->formatTimestamp() . "'" . "\n" .
                "WHERE" . "\n" .
                "reference_id=" . $iId;


        $this->DB->executeQuery($sSQL);
    }

    public function addColumn($sTableName, $sColumnName, $sType, $aParams = array(), $default = false, $defaultValue = '') {
        $sSQL = "ALTER TABLE " . $sTableName . "\n" .
                "ADD COLUMN " . $sColumnName . " ";

        switch ($sType) {
            case "int" :
                $sSQL .= "bigint";
                break;
            case "date" :
                $sSQL .= "date";
                break;
            case "timestamp" :
                $sSQL .= "timestamp without time zone";
                break;
            case "time" :
                $sSQL .= "time without time zone";
                break;
            case "float" :
                $sSQL .= "double precision";
                break;
            case "password" :
                $sSQL .= "character varying(255)";
                break;
            case "reference" :
            case "string" :
            case "table" :
            case "structure" :
            case "document" :
            case "file" :
            case "picture" :
            case "text" :
            case "bool" :
            case "enum" :
                $sSQL .= "text";
                break;
        }
        
        if($default){
            $sSQL .= " default ".$defaultValue;
        }
        //debug($sSQL);
        $this->DB->executeQuery($sSQL);
    }

	public function removeColumn($sTableName, $sColumnName)
	{
        $sSQL = "ALTER TABLE " . $sTableName . "\n" .
                "DROP COLUMN " . $sColumnName;


        $this->DB->executeQuery($sSQL);
    }

	public function createReference($sName, $sDescription, $sColumns, $sTableName)
	{
		$Date					= new MSF_Date(time());
		$oSystemFieldsSettings  = new REF_SystemFieldsSettings();
		$sSystemFields			= $oSystemFieldsSettings->getFieldsAndTypesAsString();
		$sSQL					= 	"CREATE TABLE " . $sTableName . " (id SERIAL,  " . $sSystemFields .
                " CONSTRAINT " . $sTableName . "_pkey PRIMARY KEY (id)) WITH OIDS;";
        $this->DB->executeQuery($sSQL);


        $sSQL = "INSERT INTO references_config (name, description, columns, table_name, created_at, modified_at) VALUES" .
                "('" .
                $this->escapeValue($sName) . "','" .
                $this->escapeValue($sDescription) . "','" .
                $this->escapeValue($sColumns) . "','" .
                $this->escapeValue($sTableName) . "', '" .
                $Date->formatDate() . "', '" .
                $Date->formatTimestamp() . "')";


        $this->DB->executeQuery($sSQL);


        return $this->DB->insertId("references_config", "reference_id");
    }

	public function removeReferenceConfig($iId)
	{
        $sSQL = "DELETE FROM" . "\n" .
                "references_config" . "\n" .
                "WHERE" . "\n" .
                "reference_id='" . $iId . "'";
        $this->DB->executeQuery($sSQL);
    }

	public function removeReferenceTable($sName)
	{
        $sSQL = "DROP TABLE " . $sName;

        $this->DB->executeQuery($sSQL);
    }

	public function getAllRecords($sTableName, $aSelect	= array(), $aExcept	= array())
	{
		if(empty($aSelect)) {
			$sSelect	= "*";
        }
		else {
			$sSelect	= implode(",", $aSelect);
		}

		if(count($aExcept) > 0) {
			$sWhere	=	"WHERE" . "\n" .
							"id NOT IN(" .  implode("," , $aExcept) . ")";
        }
		else {
			$sWhere	= "";
		}

		$sSQL	= 	"SELECT" . "\n" .
                $sSelect . "\n" .
                "FROM" . "\n" .
                $sTableName . "\n" .
                $sWhere;

        return $this->DB->select($sSQL);
    }

	public function getRecords($sTableName, $aSelect, $aExcept, $sOrderBy, $sOrderDirection, $sLimitFrom)
	{
		if(empty($aSelect)) {
			$sSelect	= "*";
        }
		else {
			$sSelect	= implode(",", $aSelect);
		}

		if(count($aExcept) > 0) {
			$sWhere	=	"WHERE" . "\n" .
							"id NOT IN(" .  implode("," , $aExcept) . ")";
        }
		else {
			$sWhere	= "";
		}

		$sSQL	= 	"SELECT" . "\n" .
                $sSelect . "\n" .
                "FROM" . "\n" .
                $sTableName . "\n" .
                $sWhere . "\n" .
                "ORDER BY" . "\n" .
                $sOrderBy . " " . $sOrderDirection . "\n" .
                "LIMIT 10 OFFSET " . $sLimitFrom;


        return $this->DB->select($sSQL);
    }

	public function begin()
	{
        $this->DB->begin();
    }

	public function commit()
	{
        $this->DB->commit();
    }

	public function getLicense($sDelimetr)
	{
		$sSQL	=	"SELECT" . "\n" .
                "id" . "\n" .
                "FROM" . "\n" .
                "ref_system_users" . "\n" .
                "WHERE" . "\n" .
                "is_active LIKE '%" . $this->escapeValue($sDelimetr) . "1%'";

        return $this->DB->select($sSQL);
    }

	public function getUserId($sUserName)
	{
		$sSQL	=	"SELECT" . "\n" . 
                "id" . "\n" .
                "FROM" . "\n" .
                "ref_system_users" . "\n" .
                "WHERE" . "\n" .
                "employee_ref_value LIKE '" . $sUserName . "/^/col/^/%'";
        return $this->DB->select($sSQL);
		
    }

        public function setLanguage($userId, $lang){
        $sSQL = "UPDATE  ref_system_users  
                    SET  language = '$lang' 
                    WHERE  id = $userId";
        $this->DB->executeQuery($sSQL);
    }

        public function getLanguage($userId){
        $sSQL = "SELECT  language  
                    FROM  ref_system_users 
                    WHERE  id = $userId";
        return $this->DB->select($sSQL);
    }

	public function getUserEmail($iUserId)
	{
		$sSQL	=	"SELECT" . "\n" . 
                "email" . "\n" .
                "FROM" . "\n" .
                "ref_system_users" . "\n" .
                "WHERE" . "\n" .
                "id=" . $iUserId;
        return $this->DB->select($sSQL);
		
    }

	public function getUserSmtpAddress($iUserId)
	{
		$sSQL	=	"SELECT" . "\n" . 
                "email_smtp_address" . "\n" .
                "FROM" . "\n" .
                "ref_system_users" . "\n" .
                "WHERE" . "\n" .
                "id=" . $iUserId;
        return $this->DB->select($sSQL);
		
    }

	public function getSystemUserId()
	{
		$sSQL	=	"SELECT COUNT(*)" . "\n" .
                "FROM ref_system_users " . "\n" .
                "WHERE login='detrix'";
        $aResult = $this->DB->select($sSQL);

        if ($aResult[0]["count"] == 0) {
            $sRandom = rand(10000000, 99999999);
            $sSQL = "INSERT INTO ref_system_users (login, password)" . "\n" .
                    "VALUES ('detrix', '" . $sRandom . "')";
            $this->DB->executeQuery($sSQL);
        }

		$sSQL	=	"SELECT" . "\n" . 
                "id" . "\n" .
                "FROM" . "\n" .
                "ref_system_users" . "\n" .
                "WHERE" . "\n" .
                "login='detrix'";
        return $this->DB->select($sSQL);

}
}
?>