<?
class UserReferenceRowDB extends MSF_ModelDBSupport
{
	private $iRefId;

	private $iRowId;

	private $sTable;

	public function __construct(MSF_DB $DB, $iRefId, $iRowId)
	{
		parent::__construct($DB);

		$this->iRefId	= $iRefId;
		$this->iRowId	= $iRowId;

		$this->setTableName();
	}

	public function getRow()
	{
		$sSQL	= 	"SELECT" . "\n" .
						"*" . "\n" .
					"FROM" . "\n" .
						$this->sTable . "\n" .
					"WHERE" . "\n" .
						"id='" . $this->iRowId . "'";						
		
		return $this->DB->select($sSQL, true);
	}

	public function changeRow($aColumns)
	{
		$sSQL = "UPDATE" . "\n" .
					$this->sTable . "\n" .
				"SET" . "\n";

		$iCount = 0;
		$iTotal = count($aColumns) - 1;
		foreach($aColumns as $sName=>$sValue) {
			if(strlen($sValue) == 0) {
				$sSQL .= $sName . "=" . "null";
			}
			else {
				$sSQL .= $sName . " = '" .  $this->escapeValue($sValue) . "'";
			}
			
			if($iCount < $iTotal) {
				$sSQL .= ",";
			}
			$sSQL .= "\n";
			$iCount++;

		}

		$sSQL .= "WHERE" . "\n" .
				 "id='" . $this->iRowId . "'";

		$this->DB->executeQuery($sSQL);
		
		return $this->iRowId;
	}

	public function addRow($aColumns)
	{
		$sSQL 		= "INSERT INTO " . $this->sTable;
		$sFields	= "";
		$sValues	= "";

		$iCount = 0;
		$iTotal = count($aColumns) - 1;
		foreach($aColumns as $sName=>$sValue) {
			$sFields	.= $sName;
			if($sValue !== "") {
				$sValues	.= "'" . $this->escapeValue($sValue) . "'";
			}
			else {
				$sValues	.= "null";
			}
			

			if($iCount < $iTotal) {
				$sFields	.= ",";
				$sValues	.= ",";
			}

			$iCount++;
		}

		$sSQL	=  $sSQL . " (" . $sFields . ") VALUES (" . $sValues . ")";					
		$this->DB->executeQuery($sSQL);
		return $this->DB->insertId(trim($this->sTable), "id");
	}

	public function remove()
	{
		$sSQL = "DELETE FROM " . "\n" .
						$this->sTable . "\n" .
				"WHERE" . "\n" .
					"id='" . $this->iRowId . "'";

		$this->DB->executeQuery($sSQL);
	}

	public function getRefId()
	{
		return $this->iRefId;
	}
	
	public function getRowId()
	{
		return $this->iRowId;
	}

	private function setTableName()
	{
		$sSQL	=	"SELECT" . "\n" .
						"table_name" . "\n" .
					"FROM" . "\n" .
						"references_config" . "\n" .
					"WHERE" . "\n" .
						"reference_id='" . $this->iRefId . "'";



		$aRes			= $this->DB->select($sSQL, true);
		$this->sTable	= $aRes["table_name"];
	}

}
?>