<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
include_once "system/security/MSF_ISecurityManager.php";
include_once "REF_ReferencesSecurityManagerDB.php";
include_once "system/security/MSF_SecurityMatrixNotSavedException.php";
include_once "modules/references/library/Reference/REF_Value.php";
include_once "modules/main/library/orgStructure/MSF_OrgStructureFacade.php";

class REF_ReferencesSecurityManager implements MSF_ISecurityManager
{
	/**
	 * Enter description here...
	 *
	 * @var WF_FoldersSecurityManagerDB
	 */
	private $DB;
	
	/**
	 * Enter description here...
	 *
	 * @var int
	 */
	private $iId;
	
	/**
	 * Enter description here...
	 *
	 * @param MSF_DB $DB
	 * @param int $iId
	 * @return void
	 */
	public function __construct(MSF_DB $DB, $iId)
	{
		$this->DB	= new REF_ReferencesSecurityManagerDB($DB);
		$this->iId	= $iId;
	}
	
	/**
	 * Enter description here...
	 *
	 * @param array $aPost
	 * @return void
	 */
	public function edit($aPost)
	{
		try {
			$aToSave	= array();
			$iGroup		= 1;
			$RV			= new REF_Value();
			foreach($aPost as $aRow) {
				$RV->parse($aRow["structure"]);
				$aIds		= $RV->getKeysList();
				
				foreach($aIds as $mId) {
					if (is_array($mId)) {
						$mId = $mId[0];
					}
					$tmp	= array(
						"structure_id"			=> $mId,
						"can_view"				=> $aRow["can_view"],
						"can_edit_reference"	=> $aRow["can_edit_reference"],
						"can_edit_config"		=> $aRow["can_edit_config"],
						"group_id"				=> $iGroup
					);
					
					array_push($aToSave, $tmp);
				}

				$iGroup++;
			}
			
			//print_r($aToSave);
			$this->DB->edit($aToSave, $this->iId);
		}
		catch(MSF_DBException $e) {
			throw new MSF_SecurityMatrixNotSavedException($e->getMessage());
		}
		
	}
	
	/**
	 * Enter description here...
	 *
	 * @return array
	 */
	public function get()
	{
		$aData		=  $this->DB->get($this->iId);
		$aTmpData	= array();
		$aReady		= array();
		foreach($aData as $aRow) {
			if(!isset($aTmpData[$aRow["group_id"]])) {
				$aTmpData[$aRow["group_id"]] = array(
					"structure"				=> array(),
					"can_view"				=> $aRow["can_view"],
					"can_edit_reference"	=> $aRow["can_edit_reference"],
					"can_edit_config"		=> $aRow["can_edit_config"]
				);
				
			}
			
			$aTmpData[$aRow["group_id"]]["structure"][] = $aRow["structure_id"];
		}
		
		//print_r($aTmpData);
		foreach($aTmpData as $aTmp) {
			$aTmp["structure"] = MSF_OrgStructureFacade::getInstance()->strIdsToRefValue($aTmp["structure"]);
			array_push($aReady, $aTmp);
		}
		
		return $aReady;
	}
	
}

?>