<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "system/security/MSF_Access.php";
include_once "REF_ReferencesSwitcherDB.php";

class REF_ReferencesSwitcher extends MSF_Access
{
	private $DB 			= null;
	
	private $aAccessTypes 	= array(
		"view" 		=> "can_view",
		"edit_ref" 	=> "can_edit_reference",
		"edit_conf" => "can_edit_config"
	);
	
	protected function initialize()
	{
		$this->DB = new REF_ReferencesSwitcherDB($this->getDb());
	}
	
	protected function getAccessValue($sAccessType, $iStructureId, $aParams)
	{
		$iResult = self::INHERIT;
		
		if (!isset($this->aAccessTypes[$sAccessType])) {
			$iResult = self::DENY;
		}
		else {
			$aRights = $this->DB->select($iStructureId, $aParams["reference_id"]);
			
			if(count($aRights) > 0) {
				foreach($aRights as $aR) {
					if($aR[$this->aAccessTypes[$sAccessType]] == self::DENY) {
						$iResult	= self::DENY;
						break;
					}
					elseif($aR[$this->aAccessTypes[$sAccessType]] == self::ALLOW) {
						$iResult	= self::ALLOW;
					}
					
				}
				
			}
			
		}
		
		return $iResult;
	}
	
}

?>