<?php
/*
 * File: 	Test__RefValue.php
 * Date: 	28.02.2008
 * Time:	11:50:10
 * Detrix
 *
 */

// [include]
include_once "modules/references/library/Reference/REF_Value.php";
// [/include]

/**
 * @package 	references
 * @copyright 	Copyright (c) 2007, Detrix
 */
class Test__REF_Value extends MSF_TestUnit
{
	public function setUp()
	{}

	public function setDown()
	{}

	public function test()
	{
		$R = new REF_Value();
		try {
			$R->parse($this->getFormattedString());
			$this->pass("Test parse()");
			$this->assertEquals($R->getSize(), 2, "Test getSize()");
			$this->assertEquals($R->format(), $this->getFormattedString(), "Test format()");
			$this->assertEquals($R->get(0), $this->getZeroRow(), "Test get(0)");
			$this->assertEquals($R->get(0, "key"), 1, "Test get(0, key)");
			$this->assertEquals($R->get(0, "value"), "Almaty", "Test get(0, value)");
			$this->assertEquals($R->getKeysList(), $this->getKeysList(), "Test getKeysList()");
			$this->assertEquals($R->getValuesList(), $this->getValuesList(), "Test getValuesList()");
			$R->add(2, "Quaraganda");
			$this->assertEquals($R->get(2, "key"), 2, "Test add() // get key");
			$this->assertEquals($R->get(2, "value"), "Quaraganda", "Test add() // get value");
			$R->remove(2);
			$this->assertEquals($R->get(2), null, "Test remove() // get removed value");
		}
		catch (REF_ParsingException $REFPE) {
			$this->fail("REF_ParsingException: " . $REFPE->getMessage());
		}

	}

	private function getFormattedString()
	{
		return "Almaty/1|Astana/2";
	}

	private function getZeroRow()
	{
		return array (
					"key"	=> 1,
					"value"	=> "Almaty"
				);
	}

	private function getKeysList()
	{
		return array (1, 2);
	}

	private function getValuesList()
	{
		return array ("Almaty", "Astana");
	}

}
?>