<?php

include_once "modules/references/library/Reference/UserReferenceDB.php";
include_once "modules/references/library/Reference/UserReference.php";

class Test__UserReference extends MSF_TestUnit
{
	private $aPostarray 	= array();
	
	private $aPostEdited 	= array();
	
	private $aShowed 		= array();
	
	private $aShowedEdited 	= array();
	
	public function setUp()
	{
		$this->aPostarray = array(
			"login" 		=> "test_login",
			"password" 		=> "test_password",
			"email" 		=> "test_email",
			"email_size" 	=> 10,
			"email_delete_on_recieve" => 1,
			"email_send_copy" => 1,
			"status" 		=> 1,
			"user_link" 	=> 4
		);
		
		$this->aPostEdited = array(
			"login" 		=> "test_login2",
			"password" 		=> "test_password2",
			"email" 		=> "test_email2",
			"email_size" 	=> 0,
			"email_delete_on_recieve" => 0,
			"email_send_copy" => 0,
			"status" 		=> 0,
			"user_link" 	=> 6
		);
		
		$this->aShowed = array(
			0 => array
			(
				"name" => "login",
				"title" => "Логин",
				"type" => "string",
				"value" => "test_login"
			),			
			1 => array
			(
				"name" => "password",
				"title" => "Пароль",
				"type" => "string",
				"value" => "test_password"
			),
			2 => array
			(
				"name" => "email",
				"title" => "E-mail адрес",
				"type" => "string",
				"value" => "test_email"
			),
			3 => array
			(
				"name" => "email_pop3_login",
				"title" => "POP3 логин",
				"type" => "string",
				"value" => ""
			),
			4 => array
			(
				"name" => "email_pop3_password",
				"title" => "POP3 пароль",
				"type" => "string",
				"value" => ""
			),
			5 => array
			(
				"name" => "email_pop3_address",
				"title" => "POP3 адрес",
				"type" => "string",
				"value" => ""
			),
			6 => array
			(
				"name" => "email_smtp_login",
				"title" => "SMTP логин",
				"type" => "string",
				"value" => ""
			),
			7 => array
			(
				"name" => "email_smtp_password",
				"title" => "SMTP пароль",
				"type" => "string",
				"value" => ""
			),
			8 => array
			(
				"name" => "email_smtp_address",
				"title" => "SMTP адрес",
				"type" => "string",
				"value" => ""
			),
			9 => array
			(
				"name" => "email_size",
				"title" => "Размер e-mail",
				"type" => "int",
				"value" => 10
			),
			10 => array
			(
				"name" => "email_delete_on_recieve",
				"title" => "Удаление при получании",
				"type" => "int",
				"value" => 1
			),
			11 => array
			(
				"name" => "email_send_copy",
				"title" => "Копия на сервер при отправке",
				"type" => "int",
				"value" => 1
			),
			12 => array
			(
				"name" => "status",
				"title" => "Статус",
				"type" => "int",
				"value" => 1
			),
			13 => array
			(
				"name" => "user_link",
				"title" => "user_link",
				"type" => "int",
				"value" => 4
			)
		);
		
		$this->aShowedEdited = array(
			0 => array
			(
				"name" => "login",
				"title" => "Логин",
				"type" => "string",
				"value" => "test_login2"
			),			
			1 => array
			(
				"name" => "password",
				"title" => "Пароль",
				"type" => "string",
				"value" => "test_password2"
			),
			2 => array
			(
				"name" => "email",
				"title" => "E-mail адрес",
				"type" => "string",
				"value" => "test_email2"
			),
			3 => array
			(
				"name" => "email_pop3_login",
				"title" => "POP3 логин",
				"type" => "string",
				"value" => ""
			),
			4 => array
			(
				"name" => "email_pop3_password",
				"title" => "POP3 пароль",
				"type" => "string",
				"value" => ""
			),
			5 => array
			(
				"name" => "email_pop3_address",
				"title" => "POP3 адрес",
				"type" => "string",
				"value" => ""
			),
			6 => array
			(
				"name" => "email_smtp_login",
				"title" => "SMTP логин",
				"type" => "string",
				"value" => ""
			),
			7 => array
			(
				"name" => "email_smtp_password",
				"title" => "SMTP пароль",
				"type" => "string",
				"value" => ""
			),
			8 => array
			(
				"name" => "email_smtp_address",
				"title" => "SMTP адрес",
				"type" => "string",
				"value" => ""
			),
			9 => array
			(
				"name" => "email_size",
				"title" => "Размер e-mail",
				"type" => "int",
				"value" => 0
			),
			10 => array
			(
				"name" => "email_delete_on_recieve",
				"title" => "Удаление при получании",
				"type" => "int",
				"value" => 0
			),
			11 => array
			(
				"name" => "email_send_copy",
				"title" => "Копия на сервер при отправке",
				"type" => "int",
				"value" => 0
			),
			12 => array
			(
				"name" => "status",
				"title" => "Статус",
				"type" => "int",
				"value" => 0
			),
			13 => array
			(
				"name" => "user_link",
				"title" => "user_link",
				"type" => "int",
				"value" => 6
			)
		);
	}
	
	public function setDown()
	{
		
	}
	
	public function test()
	{
		$Ref = new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
		$Ref->load(1);
		$this->pass("reference loaded");
		
		$iId = $Ref->row()->save($this->aPostarray);
		$this->pass("row added");

		$aRow = $Ref->row($iId)->show();
		$this->assertEquals($aRow, $this->aShowed, "reference row showed");
		
		$Ref->row($iId)->save($this->aPostEdited);
		$this->pass("row edited");
		
		$aRow = $Ref->row($iId)->show();
		$this->assertEquals($aRow, $this->aShowedEdited, "reference row showed");
		
		$Ref->row($iId)->remove();
		$this->pass("row removed");
	}
}

?>