
tinymce.create("tinymce.plugins.REFFieldsPlugin", {

	sImgUri			: "/modules/workflow/view/templates/default/img/cfield.png",
	
	sRemoteJsonUri	: "/admin/references/list/jsonfields",

	oEditor 		: null,
	
	isMenuRendered	: false,
	
	aFields 		: {},
	
	init : function(ed, url) {
		this.oEditor 	= ed;
	},
	
	paste : function(sValue) {
		this.oEditor.execCommand("mceInsertContent", 0, sValue);
	},		

	createControl: function(n, cm) {
		if (n !== "reffields") return null;
		var oThis = this;  
		var c = cm.createSplitButton("reffields", {
			title 	: aGlobalMsfWords['WORKFLOW_CFIELDS'],
			image 	: this.sImgUri

		});

		c.onRenderMenu.add(function(c, m) {
			var oMenuItem 	= m.add({title : aGlobalMsfWords['WORKFLOW_CFIELDS'], "class" : "mceMenuItemTitle"});
			oMenuItem.setDisabled(true);
			var sUri = oThis.sRemoteJsonUri + "/" + oThis.oEditor.settings.subject_id;
			new Ajax.Request(sUri, {
				onSuccess: function(transport) {
					if ((transport.responseText.length > 0)) {
						var aFields = transport.responseText.evalJSON().fields;
						
						for (var i = 0; i < aFields.length; i++) {
							oThis.renderMenuField(m, oThis, aFields[i], aFields[i]);
						}					
					}

				}
				
			});
			
		});
		
		return c;
	},
	
	renderMenuField : function(oMenu, oThis, sTitle, sValue)
	{
		oMenu.add({title : sTitle, onclick : function() {
			var sTmp = sValue;
			if (oThis.substrCount(oThis.oEditor.getContent(), "{" + sValue + "}") > 0) {
				sTmp += " [*]";
			}
			oThis.paste("{" + sTmp + "}");
		}});
		
	},

	
	getInfo : function() {
		return {
			longname 	: "REFFields",
			author 		: "Detrix LLP",
			authorurl 	: "http://www.newinttech.com",
			infourl 	: "http://www.newinttech.com",
			version 	: tinymce.majorVersion + "." + tinymce.minorVersion
		};
	},
	
	substrCount: function(sString, sSubstring)
	{
		var iResult = 0;
		
		for (var i=0; i< sString.length; i++) {
			if (sSubstring == sString.substr(i, sSubstring.length)) {
				iResult++;
			}
		}

		return iResult++;
	}
});

tinymce.PluginManager.add('reffields', 	tinymce.plugins.REFFieldsPlugin);


tinymce.create("tinymce.plugins.REFSystemFieldsPlugin", {

	sImgUri			: "/modules/workflow/view/templates/default/img/sfield.png",
	
	sRemoteJsonUri	: "/admin/references/list/jsonsysfields",

	oEditor 		: null,
	
	isMenuRendered	: false,
	
	aFields 		: {},
	
	init : function(ed, url) {
		this.oEditor 	= ed;
	},
	
	paste : function(sValue) {
		this.oEditor.execCommand("mceInsertContent", 0, sValue);
	},		

	createControl: function(n, cm) {
		if (n !== "refsystemfields") return null;
		var oThis = this;  
		var c = cm.createSplitButton("refsystemfields", {
			title 	: aGlobalMsfWords['WORKFLOW_SFIELDS'],
			image 	: this.sImgUri

		});

		c.onRenderMenu.add(function(c, m) {
			var oMenuItem 	= m.add({title : aGlobalMsfWords['WORKFLOW_SFIELDS'], "class" : "mceMenuItemTitle"});
			oMenuItem.setDisabled(true);
			var sUri = oThis.sRemoteJsonUri + "/" + oThis.oEditor.settings.subject_id;
			new Ajax.Request(sUri, {
				onSuccess: function(transport) {
					if ((transport.responseText.length > 0)) {
						var aFields = transport.responseText.evalJSON().fields;
						
						for (var i = 0; i < aFields.length; i++) {
							oThis.renderMenuField(m, oThis, aFields[i], aFields[i]);
						}					
					}

				}
				
			});
			
		});
		
		return c;
	},
	
	renderMenuField : function(oMenu, oThis, sTitle, sValue)
	{
		oMenu.add({title : sTitle, onclick : function() {
			var sTmp = sValue;			
			oThis.paste("[" + sTmp + "]");
		}});
		
	},

	
	getInfo : function() {
		return {
			longname 	: "REFSystemFields",
			author 		: "Detrix LLP",
			authorurl 	: "http://www.newinttech.com",
			infourl 	: "http://www.newinttech.com",
			version 	: tinymce.majorVersion + "." + tinymce.minorVersion
		};
	},
	
	substrCount: function(sString, sSubstring)
	{
		var iResult = 0;
		
		for (var i=0; i< sString.length; i++) {
			if (sSubstring == sString.substr(i, sSubstring.length)) {
				iResult++;
			}
		}

		return iResult++;
	}
});

tinymce.PluginManager.add('refsystemfields', 	tinymce.plugins.REFSystemFieldsPlugin);