var REF_Table = Class.create();
REF_Table.prototype = {

	ROW_DELIMITER	: "^R^",
	
	COL_DELIMITER	: "^C^",
	
	aFields			: {},

	aTable 			: {},
	
	aTables			: [],

	oContainer 		: null,

	oTable			: null,
	
	oBody			: null,
	
	oHead			: null,

	sName 			: "",

	sDefaultValue 	: "",
	
	sDisplayInRS	: "",
	
	sMode			: "",
	
	aKeys			: [],
	
	sWidth			: null, 
	
	sCellpadding	: null, 
	
	sCellspacing	: null, 
	
	sBorderWidth	: null,
	 
	initialize : function(aOptions) {
		if (aOptions.aFields != "") {
			this.aKeys			= [];
			this.sMode 			= aOptions.sMode;
			this.oContainer 	= $(aOptions.oContainer);
			this.sDisplayInRS	= aOptions.sDisplayInRS;
			this.sName 			= aOptions.sName;
			this.sDefaultValue 	= this.decode(aOptions.sDefaultValue);
			this.aFields		= $H(aOptions.aFields);
			this.sWidth			= this.prepareRawValue(aOptions.sWidth); 
			this.sCellpadding	= this.prepareRawValue(aOptions.sCellpadding); 
			this.sBorderWidth	= this.prepareRawValue(aOptions.sBorderWidth); 
			this.buildFrame();
			this.parseAndBuild();
		}

	},
	
	buildFrame : function() {
		this.oValue 		= new Element("INPUT", {
				name 	: this.sName, 
				style	: "display:none;", 
				value	: this.encode(this.sDefaultValue)
				});
		this.oTable 		= new Element("TABLE", {
				style	: 
						"width:" + this.sWidth + ";" +
						"border-collapse: collapse;"
				});
		this.oBody			= new Element("TBODY");
		this.oHead			= new Element("THEAD");
		var oTr				= new Element("TR", {"style":"border: " + this.sBorderWidth + " solid #d0d7e5"});
		this.oHead.appendChild(oTr);
		if (this.sMode == "edit") {
			var oTh	= new Element("TH", {
					style:
							"border				: " + this.sBorderWidth + " solid #9eb6ce;" +
							"width				: 24px;"+
							"text-align			: center;"+
							"padding			: 0px;"+
							"background-color	: #d3dbe9"
					});
			var oButton = new Element("IMG", {
					title	: aGlobalMsfWords["REF_TABLE_ADD"], 
					src 	: "/modules/workflow/view/templates/default/img/add1.gif", 
					style	: "margin:5px;font-weight:bold;cursor:pointer;padding:0px;"
					});
			oTh.insert(oButton);
			oButton.observe("click", this.addThListiner.bindAsEventListener(this));
			oTr.appendChild(oTh);
		}
		
		var sHost 	= window.location.protocol + "//" + window.location.host + "/modules/references/view/img/th-bg.png";
		var me 		= this;
		$H(this.aFields).each(function(aHash) {
			if (!this.sDisplayInRS) {
				this.sDisplayInRS = aHash[0];
			} 
			
			var oTh	= new Element("TH", {"style":
				"padding: " + me.sCellpadding + "; border: " + me.sBorderWidth + " solid #9eb6ce;" +
				"background: url(" + sHost + ") repeat-x bottom;"
			});
			
			oTr.insert(oTh);
			if (aHash.value.title) {
				oTh.insert(aHash.value.title);
			}
			else {
				oTh.insert(aHash.value);
			}
			
			me.aKeys.push(aHash[0]);;
		}.bind(this));

		this.oContainer.insert(this.oValue);		
		this.oTable.insert(this.oHead);
		this.oTable.insert(this.oBody);
		//this.oContainer.insert("width:" + this.sWidth);
		this.oContainer.insert(this.oTable);
	},
	
	prepareRawValue : function(sRawValue) {
		var sPreparedValue;
		if (sRawValue.indexOf('pt') > 1) {
			sPreparedValue = parseFloat(sRawValue) + "pt";
		}
		else if (sRawValue.indexOf('%') > 1) {
			sPreparedValue = parseFloat(sRawValue) + "%";
		}
		else {
			sPreparedValue = parseFloat(sRawValue) + "px";
		}
		
		if ((sPreparedValue == "NaNpx") ||(sPreparedValue == "NaNpt") ||(sPreparedValue == "NaN%")) {
			sPreparedValue = "";	
		}
		
		return sPreparedValue;
	},
	

	add : function(aFields, oNext) {
		var aFields = (aFields == null) ? {} : aFields;
		var oTr		= new Element("TR", {"style":"border: " + this.sBorderWidth + " solid #d0d7e5"});
		
		if (oNext && oNext.next()) {
			this.oBody.insertBefore(oTr, oNext.next());			
		}
		else if (oNext) {
			this.oBody.appendChild(oTr);			
		}
		else if (this.oBody.childNodes.length > 0) {
			this.oBody.insertBefore(oTr, this.oBody.childNodes.item(0));
		}
		else {
			this.oBody.appendChild(oTr);
		}

		if (this.sMode == "edit") {
			var oTd	= new Element("TD", {
					style	:
							"border			: " + this.sBorderWidth + " solid #cccccc; " + 
							"padding		: 0px;"+
							"text-align		: center;"+
							"width			: 24px;"
			});

			var oInsertButton = new Element("IMG", {
					title	: aGlobalMsfWords["REF_TABLE_ADD"], 
					src 	: "/modules/workflow/view/templates/default/img/add1.gif", 
					style	: 
							"margin			: 5px;"+
							"font-weight	: bold;"+
							"cursor			: pointer;"
					});
			var oRemoveButton = new Element("IMG", {
					title	: aGlobalMsfWords["REF_TABLE_REMOVE"], 
					src 	: "/modules/workflow/view/templates/default/img/remove.gif", 
					align	: "center",
					style	:
							"margin			: 5px;"+
							"font-weight	: bold;"+
							"cursor			: pointer;"
					});

			oTd.insert(oInsertButton);
			oTd.insert("<br/>");
			oTd.insert(oRemoveButton);
			oInsertButton.observe("click",
					this.addTrListener.bindAsEventListener(this, oTr)
					);
			oRemoveButton.observe("click", 
					this.removeTrListener.bindAsEventListener(this, oTr)
					);
			oTr.appendChild(oTd);
		
			$H(this.aFields).each(function(aHash) {
				var aCfg	= this.aFields.get(aHash.key);
				if (!aCfg["default"]) {
					aCfg["default"] = "";
				}


				var sWidth	= (aHash.value.width) ? aHash.value.width : "";
				if (aHash.value.type == "enum") {
	 				var sValue 	= (aFields[aHash.key]) 
							? aFields[aHash.key] 
							: "";
					this.createCellEdit(oTr, aHash.key, aHash.value.type, sValue, this.prepareRawValue(sWidth));
				}
				else {
	 				var sValue 	= (aFields[aHash.key]) 
							? aFields[aHash.key] 
							: this.decode(aCfg["default"]);
					this.createCellEdit(oTr, aHash.key, aHash.value.type, sValue, this.prepareRawValue(sWidth));
				}
				
				
			}.bind(this));
			this.synchronize();
		}
		else {
			$H(this.aFields).each(function(aHash) {
				var sValue 	= (aFields[aHash.key]) ? aFields[aHash.key] : "";
				var sWidth	= (aHash.value.width) ? aHash.value.width : "";
				this.createCellView(oTr, aHash.key, aHash.value.type, sValue, this.prepareRawValue(sWidth));
			}.bind(this));
		}

	},

	createCellView : function(oTr, sName, sType, sValue, sWidth) {
		var oTd			= new Element("TD", {"style": "vertical-align:top; padding: " + this.sCellpadding + "; border: " + this.sBorderWidth + " solid #d0d7e5"});
		oTd.style.width = sWidth;
		switch (sType) {
			case "structure":
				var aRows 	= $A(sValue.split("|^|row|^|"));
				var aValue	= $A();
				aRows.each(function(sRow) {
					if (sRow.length > 0) {
						var aCells 				= sRow.split("/^/col/^/");
						var iRefId				= (aCells.length == 3) ? 4 : 2;
						//subdiv
						if (aCells.length == 3) {
							sLink = "<a href=\"/references/viewrow/4/"+aCells[2]+"\">" + aCells[0] + "</a>";
						}
						else {
							sLink = "<a href=\"/references/viewrow/3/"+aCells[3]+"\">" + aCells[0] + "</a>"
						}
						
						aValue[aValue.size()] 	= "<span>" + sLink + "</span>";
					}
				});
				
				oTd.insert(aValue.join(",<br/>") + "&#160;");
				break;
			case "document":
				var aRows 	= $A(sValue.split("|^|row|^|"));
				var aValue	= $A();
				aRows.each(function(sRow) {
					var aCells 				= sRow.split("/^/col/^/");
					aValue[aValue.size()] 	= "<a href=\"/workflow/document/view/"+aCells[1]+"\">" + aCells[0] + "</a>";
				});
				
				oTd.insert(aValue.join(",<br/>") + "&#160;");
				break;
				
			case "reference":
				var aExtInfo 	= this.aFields.get(sName);
				var aRows 		= $A(sValue.split("|^|row|^|"));
				var aValue		= $A();
				
				aRows.each(function(sRow) {
					var aCells 				= sRow.split("/^/col/^/");
					var sEsc				= aCells[0];
           			var regExp1 			= /&lt;.+?&gt;/m;
           			var regExp2 			= /&lt;\/.+?&gt;/m;
					sEsc = sEsc.replace(regExp1, "");
					sEsc = sEsc.replace(regExp2, "");
					aValue[aValue.size()] 	= "<a href=\"/references/viewrow/" + aExtInfo["optional"]["reference"] + "/" + aCells[1] + "\">" + sEsc + "</a>";
					//console.log(aCells[1], aCells[0]);
				});
				
				oTd.insert(aValue.join(",<br/>") + "&#160;");
				break;
			case "file":
				var aFile 			= sValue.split(":.:");
				if (aFile.length > 1) {
					var aFileName 		= aFile[0].split(",");
					var aFileId 		= aFile[1].split(",");
					
					var sSeparator		= "";
					var aExtInfo 		= this.aFields.get(sName);
					if (aExtInfo["optional"]["multiselect"] == 1) {
						sSeparator = aExtInfo["optional"]["multiselect"]["valueSeparator"];
					}
					
					var aInsert = new Array();
					for (var i = 0; i < aFileName.length; i++) {
						aInsert[i] = "<a href=\"/media/download/" + aFileId[i] + "\" id=\"file\">" + aFileName[i] + "</a>";
					}
					
					oTd.insert(aInsert.join(sSeparator));
				}					
				break;
			default:
				oTd.insert(sValue + "&#160;");
				break;
		}
		
		oTr.appendChild(oTd);
	},
	
	createCellEdit : function(oTr, sName, sType, sValue, sWidth) {
		var oTd	= new Element("TD", {
				style: 	"border					: " + this.sBorderWidth + " solid #d0d7e5;"
				});
		oTr.appendChild(oTd);
		oTd.setAttribute("value", sValue);
		oTd.style.verticalAlign = "top";
		oTd.style.textAlign = "center";
		oTd.style.width = sWidth;
		switch (sType) {
			case "int":
			case "float":
				var oInput	= new Element("INPUT", {style : "width: 70%; border: 1px solid #CCCCCC; margin-right: 0px;",
													maxlength: (sType == "int") ? 12 : 15});
				oChange = function(e) {
					this.value = this.value.replace(',', '.');
					this.value = this.value.replace(/[^0-9\.]*/, '');
					if (isNaN(this.value)) {	
						this.value = '';
					}
									
				};
				oInput.observe("change", oChange);
				var oHandler	= function() {oTd.setAttribute("value", oInput.value); this.synchronize();}.bind(this);				
				oInput.observe("change", oHandler);
				oInput.onkeydown = function(e) {
					e = (!e) ? window.event : e;
					if (
						((e.keyCode >=96) && (e.keyCode <= 105)) || ((e.keyCode >=48) && (e.keyCode <= 57)) 
						|| (e.keyCode == 8) || (e.keyCode == 9) || (e.keyCode == 46)|| (e.keyCode == 37)|| (e.keyCode == 39)|| (e.keyCode == 110)
						|| (e.keyCode == 190)|| (e.keyCode == 191)|| (e.keyCode == 188) || (e.keyCode == 189) || (e.keyCode == 109)
						|| (e.ctrlKey && (e.keyCode == 67  || e.keyCode == 86 || e.keyCode == 88 || e.keyCode == 90 || e.keyCode == 65))
						|| (e.shiftKey && (e.keyCode == 35 || e.keyCode == 36))
						) {	
						return true;
					} else {
						return false;
					}	
				};

				if (sValue) {
					oInput.value 	= sValue;
				}
				
				oTd.insert(oInput);
				oTd.setAttribute("value", oInput.value);
				break;
			case "string":
				var oInput	= new Element("INPUT", {
						style : "width				: 100%;"+
								"border				: 1px solid #CCCCCC;" +
								"border-left-width	: 0px;" +
								"border-right-width	: 0px;" +
								"margin				: 0px;"
						});
				var oHandler	= function() {
						oTd.setAttribute("value", oInput.value);
						this.synchronize();
						}.bind(this);
				
				oInput.observe("change", oHandler);
				if (sValue) {
					oInput.value = sValue;
				}
				
				oTd.insert(new Element("DIV", {style:"overflow:hidden;"}).insert(oInput));
				oTd.setAttribute("value", oInput.value);
				break;
			case "reference":
				var aExtInfo 	= this.aFields.get(sName);
				var oHandler	= function() {
						oTd.setAttribute("value", oRph.getInput().getHtmlInput().value);
						this.synchronize();
						}.bind(this);				
				var oRph = new MSFW.Placeholder.Reference({
						"Container"			: oTd,
						"inputName"			: "no_name",
						"referenceId"		: aExtInfo["optional"]["reference"],
						"columns"			: this.prepareRefColumns(aExtInfo["optional"]),
						"byId"				: true,
						"multiselect"		: (aExtInfo["optional"]["multiselect"] == 1) ? true : false,
						"valueSeparator" 	: aExtInfo["optional"]["separator"],
						"defaultGroups"		: aExtInfo["optional"]["defaultGroup"],
						"defaultFilters"	: aExtInfo["optional"]["defaultFilter"],
						"blockGroups"		: (aExtInfo["optional"]["groupEnable"] != "1") ? true : false,
						"blockFilters"		: (aExtInfo["optional"]["filterEnable"] != "1") ? true : false,
						"unique"			: aExtInfo["optional"]["unique"],
						"default"			: sValue
						});
				oRph.addEventListener("buttonafterclick", oHandler);
				oRph.getInput().addEventListener("valuechange", oHandler);
				oTd.setAttribute("value", oRph.getInput().getHtmlInput().value);
				break;
			case "timestamp":
				var aExtInfo 	= this.aFields.get(sName);
				if ((aExtInfo['optional']['setCurrentDate'] == 1) && (sValue.length == 0)) {
					var oDate = new Date();
					//exmpl 10.10.2009 16:00
					var sY = "" + oDate.getYear();
					if (sY.length == 3) {
						sY = 1900 + parseInt(sY);
					}
					var iM = oDate.getMonth() + 1;
					var sM = (iM < 10) ? "0" + iM : iM;
					var sD = (oDate.getDate() < 10) ? "0" + oDate.getDate():oDate.getDate();
					
					var sH = (oDate.getHours() < 10) ? "0" + oDate.getHours():oDate.getHours();
					var sI = (oDate.getMinutes() < 10) ? "0" + oDate.getMinutes():oDate.getMinutes();
					sValue = sD + "." + sM + "." + sY + " " + sH + ":" + sI;
				}
				
				var oDt 		= new MSFW.Placeholder.Calendar({ 
						"Container" : oTd, 
						"inputName" : "no_name", 
						"default" 	: sValue, 
						"time" 		: "1"
						});
				var oHandler	= function() {
						oTd.setAttribute("value", oDt.getInput().getHtmlInput().value);
						this.synchronize();
						}.bind(this);
				oDt.addEventListener("buttonafterclick", oHandler);
				oDt.getInput().addEventListener("valuechange", oHandler);
				oTd.setAttribute("value", oDt.getInput().getHtmlInput().value);
				break;
			case "date":
				var aExtInfo 	= this.aFields.get(sName);
				if ((aExtInfo['optional']['setCurrentDate'] == 1) && (sValue.length == 0)) {
					var oDate = new Date();
					//exmpl 10.10.2009 16:00
					var sY = "" + oDate.getYear();
					if (sY.length == 3) {
						sY = 1900 + parseInt(sY);
					}
					var iM = oDate.getMonth() + 1;
					var sM = (iM < 10) ? "0" + iM : iM;
					var sD = (oDate.getDate() < 10) ? "0" + oDate.getDate():oDate.getDate();
					sValue = sD + "." + sM + "." + sY;
				}
				var oDt		 	= new MSFW.Placeholder.Calendar({ 
						"Container" : oTd, 
						"inputName" : "no_name", 
						"default" 	: sValue
						});
				var oHandler	= function() {
						oTd.setAttribute("value", oDt.getInput().getHtmlInput().value);
						this.synchronize();
						}.bind(this);
				oDt.addEventListener("buttonafterclick", oHandler);
				oDt.getInput().addEventListener("valuechange", oHandler);
				oTd.setAttribute("value", oDt.getInput().getHtmlInput().value);
				break;
			case "structure":
				var aExtInfo 	= this.aFields.get(sName);
				if ((sValue == "") && (aExtInfo["optional"]["selectAuthor"] == "1")) {
					sValue = aExtInfo["optional"]["author"];
				}
				
				//console.log(aExtInfo["optional"]);
				var oStr 		= new MSFW.Placeholder.Structure({ 
						"Container" 	: oTd, 
						"inputName" 	: "no_name", 
						"multiselect" 	: (aExtInfo["optional"]["multiselect"] == 1 ? true : false), 
						"showPosts" 	: (aExtInfo["optional"]["postEnable"] == 1 ? true: false),
						"showEmployees"	: ((aExtInfo["optional"]["employeeEnable"] == undefined || aExtInfo["optional"]["employeeEnable"] == 1) ? true: false),
						"employee"		: (aExtInfo["optional"]["employee"] == undefined ? "name": aExtInfo["optional"]["employee"]),
						"post"			: (aExtInfo["optional"]["post"] == undefined ? "post": aExtInfo["optional"]["post"]),
						"default" 		: sValue
						});
				var oHandler	= function() {
						oTd.setAttribute("value", oStr.getInput().getHtmlInput().value);
						this.synchronize();
						}.bind(this);
				oStr.addEventListener("buttonafterclick", oHandler);
				oStr.getInput().addEventListener("valuechange", oHandler);
				oTd.setAttribute("value", oStr.getInput().getHtmlInput().value);
				break;
			case "document":
				var aExtInfo 	= this.aFields.get(sName);
				var oDoc		= new MSFW.Placeholder.Document({ 
						"Container" 	: oTd, 
						"inputName" 	: "no_name",
						"docTypes"		: aExtInfo["optional"]["doctypes"], 
						"multiselect" 	: (aExtInfo["optional"]["multiselect"] == 1) ? true : false, 
						"default" 		: sValue
						});
				var oHandler	= function() {
						oTd.setAttribute("value", oDoc.getInput().getHtmlInput().value);
						this.synchronize();
						}.bind(this);
				oDoc.addEventListener("buttonafterclick", oHandler);
				oDoc.getInput().addEventListener("valuechange", oHandler);
				oTd.setAttribute("value", oDoc.getInput().getHtmlInput().value);
				break;
			case "enum":
				var aExtInfo 	= this.aFields.get(sName);
                                var globalObj = this;
                                var noSeparator = 1;
                                if(aExtInfo.optional.multiselect == 1){
                                    $A(aExtInfo["optional"]["enum"]).each(function(sValue1){
                                        if(noSeparator == 0) {
                                            oTd.insert(aExtInfo.optional.separator);
                                        } else {
                                            noSeparator = 0;
                                        }                                            
                                        var inputCheckbox = new Element("input");
                                        inputCheckbox.type = "checkbox";
                                        inputCheckbox.value = sValue1;
                                        var default_values = aExtInfo.default.split(aExtInfo.optional.separator);
                                        for (var i=0; i<default_values.length; i++){
                                                if(aExtInfo.optional.enum[default_values[i]] == sValue1){
                                                    inputCheckbox.checked = true;
                                                }
                                        }
                                        var inputLabel = new Element("label");
                                        inputLabel.insert(sValue1)
//                                        
                                        var oHandler = function() {
                                            if(inputCheckbox.checked){
                                                if(oTd.getAttribute("value").length == 0){
                                                    oTd.setAttribute("value",inputCheckbox.value);
                                                } else {
                                                    oTd.setAttribute("value", oTd.getAttribute("value")+aExtInfo.optional.separator+inputCheckbox.value); 
                                                    var valueArr = oTd.getAttribute("value").split(aExtInfo.optional.separator);
                                                    var valueStr="";
                                                    for(var i=0; i<aExtInfo.optional.enum.length; i++){
                                                        for(var j=0; j<valueArr.length; j++){
                                                                if(aExtInfo.optional.enum[i] == valueArr[j]){
                                                                    valueStr += valueArr[j]+aExtInfo.optional.separator;
                                                                }
                                                        }
                                                    }
                                                    valueStr = valueStr.substr(0,valueStr.lastIndexOf(aExtInfo.optional.separator));
                                                    oTd.setAttribute("value",valueStr);
                                                }
                                            } else {
                                                var valueArr = oTd.getAttribute("value").split(aExtInfo.optional.separator);
                                                var idx_val = valueArr.indexOf(inputCheckbox.value);
                                                valueArr.splice(idx_val,1);
                                                var valueStr="";
                                                for(var i=0; i<valueArr.length; i++){
                                                    if(i != valueArr.length - 1){
                                                        valueStr += valueArr[i]+aExtInfo.optional.separator;
                                                    } else {
                                                        valueStr += valueArr[i];
                                                    }
                                                }
                                                oTd.setAttribute("value",valueStr);
                                            }
                                            globalObj.synchronize();
                                        }.bind(globalObj);
                                    
                                        inputCheckbox.observe("click", oHandler);
                                        oTd.insert(inputCheckbox);
                                        oTd.insert(inputLabel);
                                        
                                        if(inputCheckbox.checked){
                                            if(oTd.getAttribute("value").length == 0){
                                                oTd.setAttribute("value",inputCheckbox.value)
                                            } else {
                                            oTd.setAttribute("value", oTd.getAttribute("value")+aExtInfo.optional.separator+inputCheckbox.value);    
                                            }
                                        }                                        
                                    });
                                } else {
                                    var oSelect 	= new Element("SELECT");
                                    $A(aExtInfo["optional"]["enum"]).each(function(sValue1){
                                            var i				= oSelect.options.length;
                                            var oOption 		= new Option(sValue1, sValue1);
                                            if (sValue.length == 0) {
                                                    if (aExtInfo['default'] == i) {
                                                            oOption.selected = true;
                                                    }

                                            }
                                            else if (sValue1 == sValue) {
                                                    oOption.selected = true;
                                            }

                                            oSelect[i]			= oOption;
                                    });
                                    var oHandler	= function() {
                                                    oTd.setAttribute("value", oSelect.value);
                                                    this.synchronize();
                                                    }.bind(this);
                                    oSelect.observe("change", oHandler);
                                    oTd.insert(oSelect);
                                    oTd.setAttribute("value", oSelect.value);
                                }
				break;
			case "bool":
				var aExtInfo 	= this.aFields.get(sName);
				var sRandomName	= "no_name_" + Math.random();
				var oYes		= new Element("INPUT", {name: sRandomName, type:"radio", value: aExtInfo["optional"]["labelYes"]});
				var oNo			= new Element("INPUT", {name: sRandomName, type:"radio", value: aExtInfo["optional"]["labelNo"]});
				
				switch (sValue) {
					case aExtInfo["optional"]["labelYes"]:
						oYes.defaultChecked = true;
						oYes.checked 		= true;
						break;
					case aExtInfo["optional"]["labelNo"]:
						oNo.defaultChecked 	= true;
						oNo.checked 		= true;	
						break;
					default:
						if (aExtInfo["default"] == 1) {
							oYes.defaultChecked = true;
							oYes.checked 		= true;
						}
						else {
							oNo.defaultChecked 	= true;
							oNo.checked 		= true;						
						}
						break;
				}

				oTd.insert(oYes);
				oTd.insert(this.htmlentities(aExtInfo["optional"]["labelYes"]));
				oTd.insert("<br/>");
				oTd.insert(oNo);
				oTd.insert(this.htmlentities(aExtInfo["optional"]["labelNo"]));
				var oHandler	= function() {
						if (oYes.checked) {
							oTd.setAttribute("value", oYes.value);
						}
						else if (oNo.checked) {
							oTd.setAttribute("value", oNo.value);
						}
						
						this.synchronize();
						}.bind(this);
				oYes.observe("change", oHandler);
				oNo.observe("change", oHandler);
				if (oYes.checked) {
					oTd.setAttribute("value", oYes.value);
				}
				else if (oNo.checked) {
					oTd.setAttribute("value", oNo.value);
				}
				break;
			case "file":
				var aDefaultValue 	= [];
				var aExtInfo 		= this.aFields.get(sName);
				if (sValue.length) {
					var aFile 			= sValue.split(":.:");
					if (aFile.length > 1) {
						var aFileName 		= aFile[0].split(",");
						var aFileId 		= aFile[1].split(",");
						for (var i = 0; i < aFileName.length; i++) {
							aDefaultValue.push({"link" : aFileName[i], "name" : aFileName[i], "id" : aFileId[i]});
						}
					}
				}
				var sRandomName	= "cont-" + Math.random();
				var oDiv 		= new Element("DIV", {id: sRandomName, className: "file-placeholder", style: "text-align:left;"});
				oTd.insert(oDiv);
				var oFile 		= new REF_File({
												"container"		: sRandomName,
												"name" 			: sName + "_" + sRandomName,
												"files"			: aDefaultValue,
												"multiselect"	: (aExtInfo["optional"]["multiselect"] == 1 ? true : false)
											   });
				oTd.setAttribute("value", "-f-" + sName + "-f-");

				break;
			default:
				oTd.style.textAlign = "center";
				oTd.style.padding 	= "0px";
				var oTa	= new Element("TEXTAREA", {
						style : "overflow		: hidden;"+
								"width			: 100%;"+
								"maring			: 0px;"+
								"border-width	: 0px;",
						wrap  : "physical"
						});

				var oRh = function (_txt)
				{

				    if (_txt) {
				        function setRows() {
				        	if (_txt.clientHeight < _txt.scrollHeight) _txt.style.height = _txt.scrollHeight + "px";
				        }

				        setRows();
				        _txt.onkeyup = function(){
				            setRows();
				        }
				    }
				}

				var oTypeHandler = function() {
					oRh(oTa);
				}
				
				oTa.observe("keydown", oTypeHandler);
				oTa.observe("click", oTypeHandler);
				oTd.observe("click", function() {
					oTa.focus();
				});
				var oHandler	= function() {
						oRh(oTa);
						oTypeHandler.call();
						oTd.setAttribute("value", oTa.value);
						this.synchronize();
						}.bind(this);
				oTa.observe("change", oHandler);				
				if (sValue) {
					oTa.value = sValue;
					
				}
				
				oTd.insert(new Element("DIV", {style : "overflow:hidden;"}).insert(oTa));
				oTd.setAttribute("value", oTa.value);
				this.aTables[this.aTables.length] = oTa;
				break;
		}
	},
	
	prepareRefColumns : function(aOptional)
	{
		var aResult = {};
		//console.log(aOptional);
		$A(aOptional.columns).each(function(sName) {
			aResult[sName] 				= {};
			aResult[sName]["filter"] 	= true;
			aResult[sName]["group"] 	= true;
			if (aOptional.fieldsValue && aOptional.fieldsValue[sName]) {
				aResult[sName]["select"] 	= true;
			}
			else {
				aResult[sName]["select"] 	= false;
			}
			
			aResult[sName]["sort"] 		= true;
		});
		return aResult;

	},	
	
	addThListiner : function() {
		this.add();
	},
	
	addTrListener : function(oEvent, oTr) {
		this.add(null, oTr);
	},

	removeTrListener : function(oEvent, oTr) {
		this.oBody.removeChild(oTr);
		this.synchronize();
	},

	synchronize : function() {
		this.oValue.value = this.format();
	},

	format : function() {
		var iNumberOfCols	= this.aFields.size();
		var iNumberOfRows	= this.oBody.childNodes.length;
		var aRows			= [];
		
		// zero row
		aRows.push(this.sDisplayInRS + this.COL_DELIMITER + this.aFields.get(this.sDisplayInRS).type);
		
		
		// first row		
		aRows.push(this.aKeys);
		
		// data fields
		if (iNumberOfCols > 0) {
			for (var i = 0; i < iNumberOfRows; i++) {
				var aRow = [];
				for (var j = 1; j < (iNumberOfCols + 1); j++) {
					var oNode = this.oBody.childNodes.item(i).childNodes.item(j);
					if (oNode) {
						aRow.push(oNode.getAttribute("value"));
					}
					
				}
				
				aRows.push(aRow);
			}
			
		}
		
		//toString
		for (var i = 0; i < aRows.length; i++) {
			if (Object.isArray(aRows[i])) {
				aRows[i] = aRows[i].join(this.COL_DELIMITER);
			}
			
		}

		return this.encode(aRows.join(this.ROW_DELIMITER));
	},
	
	parseAndBuild : function() {

		var aValue 	= this.sDefaultValue.split(this.ROW_DELIMITER);
		if (aValue.length > 2) {
			aValue[1] = aValue[1].split(this.COL_DELIMITER);
			for (var i = (aValue.length - 1); i >= 2 ; i--) {
				aValue[i] 	= aValue[i].split(this.COL_DELIMITER);
				var aRow	= {};
				for (var j = 0; j < this.aKeys.length; j++) {
					if (aValue[i][j] !== undefined) {
						aRow[aValue[1][j]] = aValue[i][j];
						
					}
					
				}

				this.add(aRow);
			}
			
		}
		
	},
	decode : function(sRawValue) {
		var sPreparedValue = sRawValue;
		var hHash 			= $H({
			'&#160;' 		: ' ',
			'\"'			: '"'
		});	
		
		var hContextHash = $H(
			(this.sMode == 'edit') 
			?{ // EDIT
					'^S^' : '\n'
					}
			:{ // VIEW
					'^S^' : '<br/>'
					}
		);

		hHash.each(function(hash) {
			sPreparedValue = this.strReplace(hash.key, hash.value, sPreparedValue);
						
		}.bind(this));
		
		hContextHash.each(function(hash) {
			sPreparedValue = this.strReplace(hash.key, hash.value, sPreparedValue);
		}.bind(this));
		
		if(this.sMode == 'view') {				
			sPreparedValue = this.strReplace('  ', '&#160; ', sPreparedValue);						
		}
		
		return sPreparedValue;
	},
	
	encode : function(sRawValue) {
		var sPreparedValue 	= sRawValue;
		var hHash 			= $H({
			' ' 	: '&#160;',
			'"'		: '\"',
			'\n'	: '^S^'
		});

		hHash.each(function(hash) {
			sPreparedValue = this.strReplace(hash.key, hash.value, sPreparedValue);
		}.bind(this));
		
		return sPreparedValue;
	},
	
	strReplace : function(sWhat, sBy, sSubject) {
		if (sSubject) {
			return sSubject.split(sWhat).join(sBy);
		}
		else {
			return "";
		}
		
	},
	
	htmlentities : function(sString) {
		var oDiv = document.createElement('div');
		var sText = document.createTextNode(sString);
		oDiv.appendChild(sText);
		return oDiv.innerHTML;
	}
	

};
