var REF_TableField = Class.create();
REF_TableField.prototype = Object.extend(new REF_Field(), {

	oDefaultValue : null,
	
	aPersistent : {
			name			: null,
			fields 			: null, 
			displayInRS 	: null,
			defaultValue	: null,
			style			: {
					width			: null,
					cellpadding 	: null,
					cellspacing	 	: null,
					borderWidth		: null
					}

			},
	
	hExtFields : {},
	
	build : function() {
		this.oDefaultValue = null;
		this.buildExtFields();
		this.buildPersistent();
		this.buildFieldBuilder();
		//this.buildDefaultValue();
		this.buildStyle();
	},
	
	buildExtFields : function()
	{
		this.hExtFields = $H({
				text	: {
				type	: 'text', 
				title	: aGlobalMsfWords['REF_TABLE_FIELD_DEFAULT']
				}});
		
		$A(this.oController.aData).each(function(el) {
			if (el.params.type == "table") {
			}
			else if (el.params.type == "picture") {
			}
			else {
				this.hExtFields.set(
					el.name, {
							type	: el.params.type,
							title	: el.title
					});

			}

		}.bind(this));

	},
	
	buildPersistent : function() {
		//console.log(this.oController);
		this.aPersistent.name			= this.oController.Element.name;
		this.aPersistent.fields 		= this.oController.Element.params.fields;
		this.aPersistent.displayInRS 	= this.oController.Element.params.displayInRS;
		this.aPersistent.defaultValue	= this.oController.Element.params.defaultValue;
		this.aPersistent.width			= (this.oController.Element.params.width !== undefined) ? this.oController.Element.params.width : "";
		this.aPersistent.cellpadding	= (this.oController.Element.params.cellpadding !== undefined) ? this.oController.Element.params.cellpadding : "";
		this.aPersistent.cellspacing	= (this.oController.Element.params.cellspacing !== undefined) ? this.oController.Element.params.cellspacing : "";
		this.aPersistent.borderWidth	= (this.oController.Element.params.borderWidth !== undefined) ? this.oController.Element.params.borderWidth : "";

	},
	
	buildFieldBuilder : function() {
		var oThis			= this;
		var oFieldBuilder 	= new REF_FieldBuilder(this.aPersistent.name, this.hExtFields);
		//console.log(this.hExtFields);
		this.addRow("REF_TABLE_FIELD_BUILDER", oFieldBuilder.getContainer(), "REF_TABLE_FIELD_BUILDER_HELP");
		var i = 0;
		$H(this.aPersistent.fields).each(function(aHash) {
			var bDisplayInRS = false;
			if (aHash[0] == oThis.aPersistent.displayInRS || i == 0) {
				bDisplayInRS = true;
			}

			var sWidth = aHash[1].width ? aHash[1].width : "";
			oFieldBuilder.add(aHash[0], bDisplayInRS, aHash[1].title, aHash[1].width, aHash[1].type);
			i++;
		});

	},
	
	buildStyle: function() {
		this.addRow(
				"REF_TABLE_FIELD_WIDTH", 
				new Element(
						"INPUT", {
						name 	: "fields[" + this.aPersistent.name + "][value][optional][width]",
						value	: this.aPersistent.width
						}),
				"REF_TABLE_FIELD_WIDTH_HELP"
				);
				
		this.addRow(
				"REF_TABLE_FIELD_CELLPADDING", 
				new Element(
						"INPUT", {
						name 	: "fields[" + this.aPersistent.name + "][value][optional][cellpadding]",
						value	: this.aPersistent.cellpadding
						}),
				"REF_TABLE_FIELD_CELLPADDING_HELP"
				);
								
		this.addRow(
				"REF_TABLE_FIELD_BORDERWIDTH", 
				new Element(
						"INPUT", {
						name 	: "fields[" + this.aPersistent.name + "][value][optional][borderWidth]",
						value	: this.aPersistent.borderWidth
						}),
				"REF_TABLE_FIELD_BORDERWIDTH_HELP"
				);
	},
	
	buildDefaultValue : function() {
		var oDiv	= new Element("div");
		this.addRow("REF_TABLE_DEFAULT_VALUE", oDiv);
		this.oDefaultValue = new REF_Table({
				oContainer 	: oDiv,
				aFields		: this.aPersistent.aFields,
				sName		: "fields[" + this.oController.Element.name + "][value][defaultValue]",
				sValue		: this.oController.Element.params.defaultValue
				});
		
	}
	
});

var REF_FieldBuilder = Class.create();
REF_FieldBuilder.prototype = {

	initialize : function(sFieldname, hExtFields) {
		this.hExtFields = hExtFields;
		this.oBlank = {
			oBox 			: null,
			sLabel 			: null, 
			oTitle 			: null, 
			oType			: null,
			oWidth			: null,
			oButton 		: null
			};
		this.oFilled = {
			oContainer 	: null, 
			aList 		: [], 
			iTabIndex 	: 0
			};
		this.sFieldname	= sFieldname;
		this.oContainer = new Element("DIV");
		this.oContainer.identify();
		this.buildBlank();
		this.buildFilled();
	},
	
	getContainer : function() {
		return this.oContainer;
	},
	
	buildBlank : function() {
		// initialize
		this.oBlank.oBox 			= new Element("TABLE", {width:"100%", style:"padding:5pt;padding-left:12pt;border:1px solid #A9A9A9;background-color:#CCCCCC;"});
		//this.oBlank.sLabel		= aGlobalMsfWords["REF_FIELDS"];
		oTBody						= new Element("TBODY");
		oTR							= new Element("TR");
		oTDL						= new Element("TD", {style:"background-color: rgb(204, 204, 204);"});
		oTDR						= new Element("TD", {style:"background-color: rgb(204, 204, 204);"});
		this.oBlank.sLabel			= aGlobalMsfWords['REF_TABLE_FIELD_TITLE'];
		this.oBlank.oType			= new Element("SELECT",{style:'margin-right:5pt;'});
		this.hExtFields.each(function(hash) {
			//var oOption = ;
			this.oBlank.oType[this.oBlank.oType.length] = new Option(hash.value.title, hash.key);
		}.bind(this));
		this.oBlank.oTitle			= new Element("INPUT", {tabindex : 1,style:'margin-right:5pt;'});
		this.oBlank.oButton			= new Element("IMG", {src:'/modules/workflow/view/templates/default/img/add.gif', style:'cursor:pointer'});
		
		// render
		oTDL.insert(this.oBlank.sLabel)  
            .insert(this.oBlank.oTitle)
            .insert(aGlobalMsfWords['REF_TABLE_FIELD_TYPE'])
            .insert(this.oBlank.oType);
        oTDR.insert(this.oBlank.oButton);
        oTR.insert(oTDL)
           .insert(oTDR);
     	oTBody.insert(oTR);
     	this.oBlank.oBox.insert(oTBody);
        this.oContainer.insert(this.oBlank.oBox);
        this.oContainer.insert("<table width=\"100%\" cellpadding=\"0\" cellspacing=\"0\"><tr><td style=\"width:25pt;\">Ид.</td><td style=\"width:135pt;\">Название</td><td style=\"width:27pt;\">Шир.</td><td>Тип</td></tr></table>");
		// observe
		this.oBlank.oTitle.observe("keydown", this.onEnterBlank.bindAsEventListener(this));
		this.oBlank.oButton.observe("click", this.addBlank.bindAsEventListener(this));
	},
	
	buildFilled : function() {
		// init
		this.oFilled.oContainer = new Element("UL", {style:"list-style:none;padding:0px;margin:0px;"});
		this.oFilled.oContainer.identify();
		this.oContainer.appendChild(this.oFilled.oContainer);
		
	},
	
	onEnterBlank : function (oEvent) {
		if (oEvent.keyCode == 13) {
			this.addBlank();
		}
		
	},
	
	onEnter : function (oEvent, sId) {
		if ((oEvent.keyCode == 13) && (this.oFilled.aList[sId].oTitle.value == "")) {
			this.remove(oEvent, sId);
		}
		
	},
	
	onChange : function (oEvent, iCounter) {
		if ((this.oFilled.aList[iCounter].oTitle.value == "")) {
			this.remove(oEvent, iCounter);
		}
		
	},
	
	addBlank : function() {
		if (this.oBlank.oTitle.value.length > 0) {
			this.oBlank.oTitle.style.backgroundColor = "#ffffff"; 
			this.add(null, false, this.oBlank.oTitle.value, "", this.oBlank.oType.value);
			this.oBlank.oTitle.value = "";
			this.oBlank.oTitle.focus();
		}
		else {
			this.oBlank.oTitle.style.backgroundColor = "#FF0000"
			new Effect.Highlight(this.oBlank.oTitle, { startcolor: '#ff0000', endcolor: '#ffffff' });
		}

	},
	
	add : function(sId, isRSView, sTitle, sWidth, sTypeValue) {
		if (!sTypeValue) sTypeValue = "text";
		var sId 								= (sId !== null) ? sId : this.generateId();
		this.oFilled.aList[sId]					= {};
		this.oFilled.aList[sId].oBox 			= new Element("LI", {
				id		: sId,
				style		: "background:url('/templates/default/images/move_row.png') no-repeat scroll 5px 10px;padding:5pt;padding-left:12pt;border:1px solid #A9A9A9;border-top-color:#CCCCCC;"
				});
		this.oFilled.aList[sId].oDisplayInRS	= new Element("INPUT", {
				name		: "fields[" + this.sFieldname + "][value][optional][displayInRS]", 
				type 		: 'radio',
				value		: sId,
				style:'margin-right:5pt;margin-left:5pt;'
				});
		this.oFilled.aList[sId].oIndex		= new Element("INPUT", {
				name		: "fields[" + this.sFieldname + "][value][optional][fields]["+sId+"][index]", 
				type 		: 'hidden',
				value		: sId
				});
		this.oFilled.aList[sId].oTitle		= new Element("INPUT", {
				name		: "fields[" + this.sFieldname + "][value][optional][fields]["+sId+"][title]", 
				value 		: sTitle,
				tabindex	: this.oFilled.iTabIndex++,
				style		: 'margin-right:5pt;'
				});
		this.oFilled.aList[sId].oWidth		= new Element("INPUT", {
				name		: "fields[" + this.sFieldname + "][value][optional][fields]["+sId+"][width]", 
				value 		: sWidth,
				tabindex	: this.oFilled.iTabIndex++,
				style		: 'margin-right:5pt;width:25pt;'
				});
				
		var oType = this.hExtFields.get(sTypeValue);
		this.oFilled.aList[sId].oType		= new Element("INPUT", {
				name		: "fields[" + this.sFieldname + "][value][optional][fields]["+sId+"][type]", 
				value 		: sTypeValue,
				type		: 'hidden'
				});
				
		
		this.oFilled.aList[sId].oButton		= new Element("IMG", {src	: "/templates/default/images/red_cross.png", style:'margin-left:5pt; cursor:pointer'});
		
		if (isRSView) {
			this.oFilled.aList[sId].oDisplayInRS.checked 			= true;
			this.oFilled.aList[sId].oDisplayInRS.defaultChecked 	= true;
		}
		
		this.oFilled.aList[sId].oTitle.observe("keypress", this.onEnter.bindAsEventListener(this, sId));
		this.oFilled.aList[sId].oTitle.observe("change", this.onChange.bindAsEventListener(this, sId));
		this.oFilled.aList[sId].oButton.observe("click", this.remove.bindAsEventListener(this, sId));
		// render
		this.oFilled.oContainer.appendChild(this.oFilled.aList[sId].oBox);
		this.oFilled.aList[sId].oBox.appendChild(this.oFilled.aList[sId].oIndex);
		this.oFilled.aList[sId].oBox.appendChild(this.oFilled.aList[sId].oDisplayInRS);
		this.oFilled.aList[sId].oBox.appendChild(this.oFilled.aList[sId].oTitle);
		this.oFilled.aList[sId].oBox.appendChild(this.oFilled.aList[sId].oWidth);
		this.oFilled.aList[sId].oBox.appendChild(this.oFilled.aList[sId].oType);
		if (oType) {
			this.oFilled.aList[sId].oBox.appendChild(document.createTextNode(oType.title));
		}
		
		this.oFilled.aList[sId].oBox.appendChild(this.oFilled.aList[sId].oButton);
		Sortable.create(this.oFilled.oContainer);
	},
	
	remove : function(oEvent, sId) {
		if (oPrevious = this.oFilled.aList[sId].oBox.previous()) {
			if (this.oFilled.aList[oPrevious.id]) {
				if (this.oFilled.aList[oPrevious.id].oTitle) {
					this.oFilled.aList[oPrevious.id].oTitle.focus();
				}
				
			}
			
		}

		this.oFilled.aList[sId].oBox.style.display 	= "none";
		this.oFilled.aList[sId].oBox.innerHTML 		= "";
		delete(this.oFilled.aList[sId]);
	},
	
	generateId : function() {
		return "n" + Math.random().toString().substring(2);
	}
	
}