var ReferencePlaceholder = Class.create();
ReferencePlaceholder.prototype =
{
	initialize : function(conf)
	{	
		var me					= this;	
		this.iRefId 			= conf["iRefId"];
		this.sContainerId 		= conf["mPlace"];
		this.aColumns 			= conf["aColumns"];
		this.sInputName 		= conf["sInputName"];
		this.bMultiselect 		= conf["bMultiselect"];
		this.bById				= conf["bById"];
		this.bBlockFilters		= conf["bBlockFilters"];
		this.bBlockGroups		= conf["bBlockGroups"];
		this.sStyle				= conf["sStyle"];		
		this.bAddValue			= !!conf["bAddValue"];
		
			
		if(conf["iObjectId"]) {
			this.iObjectId	= conf["iObjectId"];
		}
		else {
			this.iObjectId	= 0;
		}
				
		if(conf["aDefaultSort"]) {
			this.aDefaultSort		= conf["aDefaultSort"];
		}
		else {
			var bSortFlag	= true;
			$H(this.aColumns).each(function(e){
				if(bSortFlag) {
					me.aDefaultSort	= {
						"column"	: e.key, 
						"order"		: "asc"
					}
					
					bSortFlag			= false;
				}
				
			}); 				
		}
		
		
		if(conf["aDefaultFilters"]) {
			this.aDefaultFilters	= conf["aDefaultFilters"];
		}
		else {
			this.aDefaultFilters	= {};
		}
		
		if(conf["aDefaultGroups"]) {
			this.aDefaultGroups	= conf["aDefaultGroups"];
		}
		else {
			this.aDefaultGroups	= [];
		}
				
		if(conf["sSeparator"] != null) {
			this.sSeparator	= conf["sSeparator"];
		}
		else {
			this.sSeparator	= " ";
		}
		
		
		
		if(conf["bIsUnique"]) {
			this.bIsUnique		= 1;
			this.sUniqueType	= conf["sUniqueType"];
		}
		else {
			this.bIsUnique		= 0;
			this.sUniqueType	= "";
		}
		
		this.Container 		= $(this.sContainerId);
		//this.Container		= new Element("nobr");
		//$(this.sContainerId).insert(this.Container);
		this.Container.addClassName("refContainerClass");


		this.Panel			= null;
		this.Reference		= null;
		this.RefButton		= null;
		this.Input			= null;
		this.GroupPanel		= null;
		this.FilterPanel	= null;
		this.sContainerId	= null;
		this.aXY			= new Array();
		this.aHiddenInput	= new Array();
		this.JSON			= null;
		this.aInputs		= new Array();
		this.SearchInput	= null;
		
		this.aCurrentGroups	= [];
		//this.sCurrentGroup	= null;


		this.MainContainer		= null;
		this.RefContainer		= null;
		this.ControlContainer	= null;
		this.ListContainer		= null;
		this.RefScrollDiv		= null;
		this.ListDiv			= null;
		this.bIsLoad			= false;

		this.mValues			= null;

		this.SortableList		= null;
		this.SortableWidth		= 0;


		this.sRowDelimiter		= "|^|row|^|";
		this.sColumnDelimeter	= "/^/col/^/";

		this.aSelectNames		= new Object();

		if(conf["sDefaultValues"]){			
			this.defaultValues = conf["sDefaultValues"];			
		}
		else{
			this.defaultValues = null;
		}

		if(this.bById){
			this.HiddenInput		= $(document.createElement("input"));
			this.HiddenInput.type	= "hidden";
			this.HiddenInput.name	= this.sInputName;
			
			if(this.defaultValues) {
				this.HiddenInput.value	= this.defaultValues;				
			}

			this.Container.appendChild(this.HiddenInput);
		}
		else {
			this.HiddenInput	= null;
		}

		

		this.buildInput();
		this.buildRefButton();

		if(this.defaultValues) {
			this.loadPanel();
		}
		
	},

	getParentWidth: function(Node)
	{
		var iWidth = -1;
		var Parent = Node.parentNode;
		
		if (Parent) {
			if (Parent.tagName == "TD") {
				if (Parent.width == "") {
					Parent.width = "339";
				}
				if (Parent.width > 0) {
					iWidth = Parent.width;
				}
				else {
					iWidth = this.getParentWidth(Parent);
				}
			}
			else if (Parent.tagName == "TABLE") {
				if (Parent.width > 0) {
					iWidth = Parent.width;
				}
			}
			else {
				iWidth = this.getParentWidth(Parent);
			}
		}
		
		return iWidth;
	},
	
	buildInput : function()
	{	
		if(this.bMultiselect){
			if(this.bById) {
				this.Input = $(document.createElement('span'));
				
				var iWidth = this.getParentWidth(this.Container);
				if (iWidth != -1 && iWidth < 340) {
					this.Container.removeClassName("refContainerClass");
					this.Container.addClassName("refContainerClassIE");
					this.Input.addClassName('refInputMultiSelectIE');
					this.Container.style.width = iWidth + "px";
					this.Input.style.width = (iWidth - 40) + "px";
				}
				else {
					this.Input.addClassName('refInputMultiSelect');
				}
			}
			else {
				this.Input 		= $(document.createElement('textarea'));
				this.Input.name = this.sInputName;
				this.Input.addClassName('refInputMultiSelect');
			}
			
		}
		else{
			this.Input = $(document.createElement('input'));
			this.Input.type = 'text';
			this.Input.addClassName('refInputText');

			if(this.bById) {
				var sStr	= "";
				
				if(this.defaultValues) {
					var aRows	= $A(this.defaultValues.split(this.sColumnDelimeter));
					
					if(aRows[0]) {
						this.Input.value	= aRows[0];
					}
				}
				
				this.Input.readOnly = true;
			}
			else {
				this.Input.name = this.sInputName;
			}

		}
		
		if(this.sStyle) {
			this.Input.className = this.sStyle;			
		}
		
		if (this.Input.tagName != "SPAN") {
			var Nobr = new Element("nobr");
			this.Container.appendChild(Nobr);
			this.Container = Nobr;
		}
		
		this.Container.appendChild(this.Input);
	},

	buildRefButton : function()
	{
		this.RefButton = $(document.createElement('img'));
		this.RefButton.src = '/modules/references/view/img/table.png';
		//this.RefButton.src = "/modules/structure/view/templates/default/img/structure_icon.png";
		Event.observe(this.RefButton, 'click', this.toggleRef.bind(this));
		this.Container.appendChild(this.RefButton);		
	},


	toggleRef : function(event, me)
	{
		var aPosition	= Position.cumulativeOffset(this.RefButton);
		this.aXY[0]		= aPosition[0];
		this.aXY[1]		= aPosition[1];
	
		if(!this.Panel){
			this.loadPanel();
		}
		else {
			this.Panel.moveTo(this.aXY[0],this.aXY[1]);
			this.Panel.show();
		}

	},

	loadPanel : function()
	{
		var me = this;
		
		var callback = function(resp)
		{
			me.JSON 	= resp.responseText.evalJSON();
									
			me.Container.removeChild(me.Loader);
			me.Panel 	= new MSF_Window();
			if(me.defaultValues) {
				me.Panel.hide();					
			}
			
			if(me.JSON.reference.denied) {				
				if(me.bMultiselect) {				
					me.Input.update(me.JSON.reference.changeDenied);
				}
				else {
					me.Input.value	= me.JSON.reference.changeDenied;
				}				
				
				me.Panel.appendToBody(new Element('span').insert(me.JSON.reference.accessDenied));
			}
			else {
				
				me.prepareSelectNames();
				me.prepareContainers();				
				
				me.Panel.setTitle(me.JSON.reference.name);
								
				me.buildActionPanel();
				
				me.buildReference();
				me.Panel.appendToBody(me.MainContainer);
				
				
				if(me.bMultiselect && !me.bAddValue) {
					me.buildControls();
					me.buildList();
				}
	
				if(me.defaultValues) {
					me.setDefaultValue();				
					if(me.bById) {
						me.setInput(me);
					}
					else {
						me.setInput(me, me.defaultValues);
					}
					
				}
	
				me.buildOkButton();
			}
			WindowHandler.onLoad();
			
			me.Panel.moveTo(me.aXY[0], me.aXY[1]);
		}

		this.ajaxLoad(callback);
	},
	
	ajaxLoad : function(callback)
	{
		var param = '';
		var i = 0;
		
		for(var key in this.aColumns){
			param += '&select[' + i + ']=' + key;
			i++;
		}
		
		if(this.defaultValues) {
			param += '&defaultValues=' + this.defaultValues;
		}
		
		//param += '&objectId=' + this.iObjectId;
		//param += '&fieldName' + 
		param += '&inputName=' + this.sInputName;


		var url	= '/references/ajaxview/' + this.iRefId + '/' + this.bIsUnique + '/'+ this.sUniqueType;
		url += '/' + this.iObjectId + '/';
	
		new Ajax.Request(
			url,
			{
				method 		: 'post',
				parameters 	: param,
			  	onSuccess 	: callback
			}
		);

		this.Loader 	= document.createElement('img');
		this.Loader.src = '/templates/default/images/loader.gif';
		this.Container.appendChild(this.Loader);
	},

	prepareContainers : function()
	{
		this.MainContainer 				= $(document.createElement('table'));
		//this.MainContainer.border 	= '1';
		this.MainContainer.cellSpacing 	= '5';

		var Row = this.MainContainer.insertRow(0);

		this.RefContainer = Row.insertCell(0);

		if(this.bMultiselect)
		{
			this.ControlContainer		= $(Row.insertCell(1));
			this.ListContainer			= Row.insertCell(2);

			this.ControlContainer.width = '30';

			this.ControlContainer.setAttribute('align','center');
			this.RefContainer.setAttribute('valign','top');
			this.RefContainer.setAttribute('align','left');
			this.ListContainer.setAttribute('valign','top');
		}

	},

	prepareSelectNames : function()
	{
		var me		= this;
		
		var aFields	= $H(this.JSON.reference.fields);
		
		$H(this.aColumns).each(function(select)
		{
			if(select.value.bSelect) {
				aFields.each(function(field)
				{							
					if(select.key == field.key) {
						me.aSelectNames[field[0]] = true;
					}

				});

			}

		});		
		
	},

	buildReference : function()
	{		
		var me		= this;
		var Data	= Object.clone(this.JSON.reference);
		
		var conf			= new Object;
		conf.Data			= Data;
		conf.bMultiselect	= this.bMultiselect;
		conf.aColumns		= this.aColumns;
		conf.group			= this.getSelectGroups();	
		conf.filters		= this.FilterPanel.getFilters();
		conf.sort			= this.aDefaultSort;
		//console.log(this.aDefaultSort);	
		if(this.Reference) {
			conf.selected	= this.Reference.getSelected();//console.log(conf.selected);
		}
		
		if(conf.group.size() > 0) {			
			this.Reference	= new MSF_GroupTable(conf);
		}
		else {
			this.Reference 	= new MSF_Table(conf);
		}
		

		var RefDom = $(this.Reference.getDOM());
		document.body.appendChild(RefDom);
		
		var iTotalCount		= 0;
		var iSelectedCount	= 0;
		$H(this.aColumns).each(function(e)
		{
			iTotalCount++;
			if(e.value.bSelect) {
				iSelectedCount++;
			}
		});
		
		if(iSelectedCount == 0) {
			iSelectedCount++;
		}
		
		if(iTotalCount >= 2) {
			this.SortableWidth = RefDom.getWidth() / iTotalCount * iSelectedCount;
		}
		else {
			this.SortableWidth = RefDom.getWidth();
		}
				
		if(this.RefScrollDiv) {
			$A(this.RefScrollDiv.childNodes).each(function(e)
			{
				me.RefScrollDiv.removeChild(e);
			});
			
		}
		else {
			this.RefScrollDiv = $(document.createElement('div'));
			this.RefScrollDiv.addClassName('scrollable');			
			this.RefContainer.appendChild(this.RefScrollDiv);
		}
		
		this.RefScrollDiv.appendChild(RefDom);
	},	

	buildOkButton : function ()
	{
		var me			= this;
		this.OkButton 	= $(document.createElement('input'));
		this.OkButton.type 	= 'button';
		this.OkButton.value 	= 'Выбрать';
		this.OkButton.addClassName('okButton');		
		this.OkButton.observe('click', function(){ me.setInput(me);});
		
		this.Panel.appendToBody(this.OkButton);
	},

	buildActionPanel : function()
	{
		var Table	= new Element('table');
		this.Panel.appendToBody(Table);
		var Row		= Table.insertRow(0);
		
		var FilterContainer	= new Element('table', {'class' : 'rs-action'});
		var FilterRow		= FilterContainer.insertRow(0);
		$(FilterRow.insertCell(0)).addClassName('rs-action-cell-title').insert(aGlobalMsfWords['REF_PLACEHOLDER_FILTERS']);		
		$(Row.insertCell(0)).insert(FilterContainer);
		this.buildFilterPanel($(FilterRow.insertCell(1)).addClassName('rs-action-cell-button').insert('&#160;'));		
		this.bBlockFilters ? FilterContainer.hide() : new RS_ActionPanel(FilterContainer);
		
		
		var GroupContainer	= new Element('table', {'class' : 'rs-action'});
		var GroupRow		= GroupContainer.insertRow(0);
		$(GroupRow.insertCell(0)).addClassName('rs-action-cell-title').insert(aGlobalMsfWords['REF_PLACEHOLDER_GROUPS']);		
		$(Row.insertCell(1)).insert(GroupContainer);
		this.buildGroupPanel($(GroupRow.insertCell(1)).addClassName('rs-action-cell-button').insert('&#160;'));		
		this.bBlockGroups ? GroupContainer.hide() : new RS_ActionPanel(GroupContainer);		
				
		
		this.buildRefreshPanel($(Row.insertCell(2)));		
	},

	buildGroupPanel : function(MainContainer)
	{
		var me			= this;	
		var Table	= new Element('table');
			
		var Div		= new Element('div', {'class' : 'rs-action-panel'}).insert(Table);
		MainContainer.insert(Div);		
		this.GroupPanel	= new Element('form');		
		$(Table.insertRow(0).insertCell(0)).insert(this.GroupPanel);
		
		var Ul	= new Element('ul', {'class' : 'RD_GM_groupPanel'});
		Ul.identify();
		this.GroupPanel.insert(Ul);
		
		
		$A(this.aDefaultGroups).each(function(e)
		{			
			var Checkbox	= new Element('input', {
					name	: 'group_' + e.key,
					type	: 'checkbox',
					value	: e,
					checked : true,
					defaultChecked : true
				});
			var Label	= new Element('label').insert(Checkbox).insert(me.JSON.reference.fields[e]);
			
			var Li			= new Element('li');
			Li.identify();
			
			Li.insert(new Element('span', {'class' : 'dragHandler'}).insert('&#160;'))
				.insert(Label);				
			Ul.insert(Li);
			
			
		});		
		
		//console.log();
		$H(this.aColumns).each(function(e)
		{			
			if(e.value.bGroup && me.aDefaultGroups.indexOf(e.key) == -1) {
				var Checkbox	= new Element('input', {
					name	: 'group_' + e.key,
					type	: 'checkbox',
					value	: e.key
				});
				var Label	= new Element('label').insert(Checkbox).insert(me.JSON.reference.fields[e.key]);
				
				var Li			= new Element('li');
				Li.identify();
				
				Li.insert(new Element('span', {'class' : 'dragHandler'}).insert('&#160;'))
					.insert(Label);				
				Ul.insert(Li);
			}	
		});		
				
		Sortable.create(Ul);		
		
		var Button	= new Element('input',{type:'button', value:'Групировать'});
		$(Table.insertRow(1).insertCell(0)).insert(Button);
		
		Button.observe('click', function(e){			
			e.stop();
			Div.hide();
			me.buildReference();		
		});
		
	},
	
	getSelectGroups : function()
	{
		var aChecks		= Form.getElements(this.GroupPanel);
		var aChecked	= [];
		aChecks.each(function(e)
		{
			if(e.checked) {
				aChecked.push(e.value);
			}
		});
		
		return aChecked;
	},
	
	buildRefreshPanel : function(MainContainer)
	{
		var me			= this;
		var Button		= new Element('img', 
		{
			'src' 	: '/templates/default/images/reload.png',
			'style'	: 'cursor : pointer'
		}).observe('click', function(){ me.refreshReference(); });
			
		MainContainer.insert(Button);
	},
	
	refreshReference : function()
	{
		var me				= this;
		var Selected		= this.Reference.getSelected();
		this.defaultValues	= '';
		$A(Selected).each(function(e)
		{
			if(me.defaultValues != '') {
				me.defaultValues += this.sRowDelimiter;
			}
			
			me.defaultValues += 'empty' + this.sColumnDelimeter + e.id;
		});
		
			
		this.Reference.destroy();
		this.Reference	= null;
		
		this.OkButton.parentNode.removeChild(this.OkButton);
		
		var callback = function(resp)
		{
			me.JSON 	= resp.responseText.evalJSON();
									
			me.Container.removeChild(me.Loader);
					
			me.buildReference();
			me.Panel.appendToBody(me.MainContainer);
			
			me.buildOkButton();
			me.setDefaultValue();					
		}

		this.ajaxLoad(callback);
	},
	
	buildFilterPanel : function(MainContainer)
	{
		var me				= this;
		var Table			= new Element('table');		
		
		this.FilterPanel	= new MSF_FiltersPanel(this.aColumns, this.JSON.reference.fields, this.aDefaultFilters);		
				
		var Div		= new Element('div', {'class' : 'rs-action-panel'}).insert(Table);
		MainContainer.insert(Div);		
		$(Table.insertRow(0).insertCell(0)).insert(this.FilterPanel.getDom());
		
		var Button	= new Element('input', {'type' : 'button', 'value' : 'Фильтровать'})
			.observe('click', function(e){
				e.stop();
				Div.hide(); me.buildReference(); 
			});
			
		$(Table.insertRow(1).insertCell(0)).insert(Button);
	},

	buildControls : function()
	{
		
		var AddButton	= new Element("img", {
			"src"	: "/templates/default/images/arrow_right.png",
			"style"	: "cursor:pointer"
		}).observe('click', this.addToList.bind(this));

		var RemoveButton = new Element("img", {
			"src"	: "/templates/default/images/arrow_left.png",
			"style"	: "cursor:pointer"
		}).observe('click', this.removeFromList.bind(this));
		
		this.ControlContainer.insert(AddButton).insert("<br/><br/>").insert(RemoveButton);
	},

	buildList : function()
	{
		this.ListDiv				= $(document.createElement('div'));
		this.ListDiv.id				= 'sortable_' + Math.floor(Math.random() * 10000);
		if(this.JSON.type == 'tree') {
			this.ListDiv.style.width	= (this.SortableWidth * 0.5) + 20; //20 - primerno shirina checkboxa
		}
		else {
			this.ListDiv.style.width	= this.SortableWidth + 20; //20 - primerno shirina checkboxa
		}
		
		this.ListDiv.addClassName('scrollable');
		this.ListDiv.addClassName('sortable');

		this.ListContainer.appendChild(this.ListDiv);
		this.SortableList = new MSF_SortableList(this.ListDiv);
	},

	setDefaultValue : function()
	{
		var me		= this;
		var aIds	= new Array();
		var aRows	= $A(this.defaultValues.split(this.sRowDelimiter));
		
		aRows.each(function(e){
			var Tmp	= e.split(me.sColumnDelimeter);
			aIds.push(Tmp.last());
		});
		
		this.Reference.setValueById(aIds);
	},

	addToList : function()
	{
		var selected = this.Reference.getSelected();
		
		this.SortableList.add(selected, this.aSelectNames);
		this.Reference.unSelectAll();
	},

	removeFromList : function ()
	{
		this.SortableList.remove();
	},	

	setInput : function(me, sValue)
	{
		var me = this;
		
		if(sValue && !me.bById) {
			me.Input.value	= sValue;
			this.Panel.hide();
			return;
		}
		
		if(this.bMultiselect) {			
			
			if(!this.bAddValue) {
				var aValues		= this.SortableList.getValues();
			}
			else {
				//this.addToList();
				var aSelected	= this.Reference.getSelected();
				var aValues		= [];
				$A(aSelected).each(function(aSelect)
				{
					var iCount	= 0;
					var sStr	= "";
					$H(me.aSelectNames).keys().each(function(index)
					{
						if(iCount > 0) {
							sStr += me.sSeparator;
						}
		
						sStr += aSelect[index];
						iCount++;
					});
					
					aValues.push({"id" : aSelect["id"], "value" : sStr});					
				});
			}
			
			
			
			//if($A(aValues).size() == 0) {
			if (this.SortableList) {
				this.addToList();
				aValues = this.SortableList.getValues();
			}
			//}
			
			if(me.bById) {
				this.mValues 	= new Array();
				var sReturn		= "";
				var sText 		= "";

				for (var i = 0; i < this.Input.childNodes.length; i++) {
					this.Input.removeChild(this.Input.childNodes[i]);
				}
				
				aValues.each(function(e)
				{					
					sText += e.value + ", ";
					
					me.mValues.push(e.id);
					
					if(sReturn != "") {
						sReturn	+= me.sRowDelimiter;
					}
					sReturn	+= e.value + me.sColumnDelimeter + e.id;

				});
				
				this.Input.appendChild(document.createTextNode(sText.substring(0, sText.length - 2)));
				this.HiddenInput.value	= sReturn;
			}
			else {
				this.mValues = "";
				var sStr = "";
				var flag = false;
				aValues.each(function(e)
				{	/*				
					if(flag) {
						sStr += ", ";
					}*/
					sStr += e.value + ", ";
					//flag = true;
				});
				
				if(this.bAddValue) {
					/*
					if(this.Input.value != "") {
						this.Input.value += ", ";
					}*/
					this.Input.value += sStr;
					this.mValues = this.Input.value;
					this.Reference.unSelectAll();
				}
				else {
					this.Input.value = sStr;
					this.mValues = sStr;					
				}
								
			}
			
		}
		else {
			var iCount		= 0;
			var sStr		= "";
			var aSelected	= me.Reference.getSelected();
			
						
			if(aSelected.size() == 0) {
				this.Input.value	= "";
				if(this.bById) {				
					this.HiddenInput.value	= "";
				}
				
			}
			else {
				aSelected = aSelected[0];			
				$H(me.aSelectNames).keys().each(function(index)
				{
					if(iCount > 0) {
						sStr += me.sSeparator;
					}
					
					if(aSelected[index]) {
						sStr += aSelected[index];
					}
					
					iCount++;
				});
				
				this.Input.value = sStr;	
				if(this.bById) {				
					this.HiddenInput.value	= this.Input.value + this.sColumnDelimeter + aSelected.id;
				}
				else {
					this.mValues = sStr;
				}
			}	

		}

		this.Panel.hide();
	},

	getValues : function ()
	{
		return this.mValues;
	},

	destroy : function()
	{
		if(this.Panel) {
			this.Panel.destroy();
		}

		this.Container.removeChild(this.Input);
		this.Container.removeChild(this.RefButton);
	},
	
	getInput : function()
	{
		if(this.HiddenInput) {
			return this.HiddenInput;
		}
		else {
			return this.Input;
		}
	}
}