<?xml version="1.0" encoding="utf-8"?><xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"><xsl:output encoding="utf-8" />
	<xsl:template match="/page/module">
		<script src="/modules/references/view/js/REF_SaveHandler.js"></script>
		<script>
			registerEvent(function() {
				new REF_SaveHandler($("access_form"), $("access_button"), $("login_layer"), "submit");
			});	
		</script>
		<script>
			document.onkeydown = function(e){
				key = (!e) ? window.event : e;
				if (key.ctrlKey &amp;&amp; key.keyCode == 13){
					$("access_button").click();
				} 
			}
		</script>	
		<script type="text/javascript">
			WindowHandler.attachHandlers();
		</script>				
		<table border="0" width="100%">
			<tr id="test_element">
				<td valign="top" class="form-row-value">
					<div id="structure_container_|i|"/>
					<div
						class="msfJsScript"
						place="structure_container_|i|"
						inputname="access[|i|][structure]"
						multiselect="true"
						defaultvalues=""
					/>
				</td>
				<td valign="top" class="form-row-value">
					<select name="access[|i|][can_view]">
						<!-- <option value="0"><xsl:value-of select="$REF_ACCESS_INHERIT"/></option> -->
						<option value="1"><xsl:value-of select="$REF_ACCESS_ALLOW"/></option>
						<option value="2"><xsl:value-of select="$REF_ACCESS_DENY"/></option>
					</select>						
				</td>
				<td valign="top" class="form-row-value">
					<select name="access[|i|][can_edit_reference]">
						<!-- <option value="0"><xsl:value-of select="$REF_ACCESS_INHERIT"/></option> -->
						<option value="1"><xsl:value-of select="$REF_ACCESS_ALLOW"/></option>
						<option value="2"><xsl:value-of select="$REF_ACCESS_DENY"/></option>
					</select>						
				</td>
				<td valign="top" class="form-row-value">
					<select name="access[|i|][can_edit_config]">
						<!-- <option value="0"><xsl:value-of select="$REF_ACCESS_INHERIT"/></option> -->
						<option value="1"><xsl:value-of select="$REF_ACCESS_ALLOW"/></option>
						<option value="2"><xsl:value-of select="$REF_ACCESS_DENY"/></option>
					</select>						
				</td>
				<td  valign="top" class="form-row-value">
					<a href="#" id="remove_element">
						<img src="/templates/default/images/red_cross.png" border="0"/>
					</a>
				</td>
			</tr>
		</table>
		
		<div class="add-field" id="ref_access_add_button">
			<xsl:value-of select="$WORKFLOW_ACCESS_ADD"/>
		</div><br/>
		<form method="post" id="access_form" style="width:800px; clear: left">
			<div style="display:none;">
				<div id="login_layer" style="padding:5pt;">							
						<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
						<table cellpadding="5pt">
						<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
						<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
						<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
					</table>	
				</div>
			</div>
			<table class="form" id="elements_container">
				<tr>
					<td width="360" class="form-row-value"><xsl:value-of select="$REF_ACCESS_SUBJECT_OF_ACCESS"/></td>
					<td width="125" class="form-row-value"><xsl:value-of select="$REF_ACCESS_CAN_VIEW"/></td>
					<td width="125" class="form-row-value"><xsl:value-of select="$REF_ACCESS_CAN_EDIT_REFERENCE"/></td>
					<td width="160" class="form-row-value"><xsl:value-of select="$REF_ACCESS_CAN_EDIT_CONFIG"/></td>
					<td class="form-row-value">&#160;</td>
				</tr>
				<xsl:for-each select="access/item">					
					<tr id="test_element">
						<td valign="top" class="form-row-value">
							<div id="structure_container_|i|"/>
							<div
								class="msfJsScript"
								place="structure_container_|i|"
								inputname="access[|i|][structure]"
								multiselect="true"
								defaultvalues="{@structure}"
							/>
						</td>
						<td  valign="top" class="form-row-value">
							<select name="access[|i|][can_view]">								
								<option value="1">
									<xsl:if test="@can_view = 1">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$REF_ACCESS_ALLOW"/>
								</option>
								<option value="2">
									<xsl:if test="@can_view = 2">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$REF_ACCESS_DENY"/>
								</option>
							</select>						
						</td>
						<td  valign="top" class="form-row-value">
							<select name="access[|i|][can_edit_reference]">
								<option value="1">
									<xsl:if test="@can_edit_reference = 1">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$REF_ACCESS_ALLOW"/>
								</option>
								<option value="2">
									<xsl:if test="@can_edit_reference = 2">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$REF_ACCESS_DENY"/>
								</option>
							</select>						
						</td>
						<td  valign="top" class="form-row-value">
							<select name="access[|i|][can_edit_config]">											
								<option value="1">
									<xsl:if test="@can_edit_config = 1">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$REF_ACCESS_ALLOW"/>
								</option>
								<option value="2">
									<xsl:if test="@can_edit_config = 2">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$REF_ACCESS_DENY"/>
								</option>
							</select>						
						</td>
						<td  valign="top" class="form-row-value">
							<a href="#" id="remove_element">
								<img src="/templates/default/images/red_cross.png" border="0"/>
							</a>
						</td>
					</tr>						
				</xsl:for-each>				
			</table><br/>
			<div class="add-field" id="ref_access_add_button1">
				<xsl:value-of select="$WORKFLOW_ACCESS_ADD"/>
			</div>
			<div style="clear: left"></div>
			<input type="hidden" name="is_request" value="true"/>
			<input value="{$REF_ACCESS_SAVE}" id="access_button" type="button" style="float:left;"/>
			<img id="busy_loader" height="25" width="25" src="/templates/default/images/win/big-ajax-loader.gif" style="display:none;"/>
		</form>		
		
		<script>
			new MSF_ElementAdder('test_element', 'elements_container', ['ref_access_add_button', 'ref_access_add_button1'], 'remove_element', '<xsl:value-of select="$REF_FIELD_CONTROLLER_NEW_CONFIRM"/>');
		</script>
	
	</xsl:template>
</xsl:stylesheet>