<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/page/module">
		<script type="text/javascript">
			WindowHandler.attachHandlers();
		</script>	
		<!--  <xsl:apply-templates select="/page/module/row"/> -->

		<xsl:choose>
			<xsl:when test="@template_mode = 'default'">
				<xsl:call-template name="default_row"/>
			</xsl:when>
			<xsl:otherwise>
				<xsl:apply-templates match="/page/module/row"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template name="default_row">
	
		<form method="post">
			<table cellpadding="3" cellspacing="1" border="1">
				<xsl:for-each select="row/field">
					<tr>
						<td valign="top">
							<strong>
								<xsl:value-of select="@title"/>
							</strong>
						</td>
						<td>
							<xsl:choose>
								<xsl:when test="@type = 'date' or @type='timestamp' or @type='time'">
									<xsl:if test="@type='date' or @type='timestamp'">
										<select name="{@name}[day]">
											<xsl:for-each select="days/item">
												<option value="{@value}">
													<xsl:if test="@value = ../../@day">
														<xsl:attribute name="selected">
															<xsl:text>selected</xsl:text>
														</xsl:attribute>
													</xsl:if>
													<xsl:value-of select="@value"/>
												</option>
											</xsl:for-each>
										</select>

										<select name="{@name}[month]">
											<xsl:for-each select="months/item">
												<option value="{@value}">
													<xsl:if test="@value = ../../@month">
														<xsl:attribute name="selected">
															<xsl:text>selected</xsl:text>
														</xsl:attribute>
													</xsl:if>
													<xsl:value-of select="@value"/>
												</option>
											</xsl:for-each>
										</select>

										<select name="{@name}[year]">
											<xsl:for-each select="years/item">
												<option value="{@value}">
													<xsl:if test="@value = ../../@year">
														<xsl:attribute name="selected">
															<xsl:text>selected</xsl:text>
														</xsl:attribute>
													</xsl:if>
													<xsl:value-of select="@value"/>
												</option>
											</xsl:for-each>
										</select>
									</xsl:if>

									<xsl:if test="@type='timestamp'">
										:
									</xsl:if>

									<xsl:if test="@type='timestamp' or @type='time'">
										<select name="{@name}[hour]">
											<xsl:for-each select="hours/item">
												<option value="{@value}">
													<xsl:if test="@value = ../../@hour">
														<xsl:attribute name="selected">
															<xsl:text>selected</xsl:text>
														</xsl:attribute>
													</xsl:if>
													<xsl:value-of select="@value"/>
												</option>
											</xsl:for-each>
										</select>

										<select name="{@name}[minute]">
											<xsl:for-each select="minutes/item">
												<option value="{@value}">
													<xsl:if test="@value = ../../@minute">
														<xsl:attribute name="selected">
															<xsl:text>selected</xsl:text>
														</xsl:attribute>
													</xsl:if>
													<xsl:value-of select="@value"/>
												</option>
											</xsl:for-each>
										</select>
									</xsl:if>

								</xsl:when>
								<xsl:when test="@type = 'enum'">
									<select name="{@name}">
										<xsl:for-each select="values/item">
											<option value="{@value}">
												<xsl:if test="@value = ../../@value">
													<xsl:attribute name="selected">
														<xsl:text>selected</xsl:text>
													</xsl:attribute>
												</xsl:if>
												<xsl:value-of select="@value"/>
											</option>
										</xsl:for-each>
									</select>
								</xsl:when>
								<xsl:when test="@type = 'text'">
									<textarea name="{@name}"><xsl:value-of select="@value"/></textarea>
								</xsl:when>
								<xsl:when test="@type = 'reference'">
									<div id="container_ref_{@reference_id}_{@name}"></div>
									<script>
										new ReferencePlaceholder({
																	mPlace			: "container_ref_<xsl:value-of select="@reference_id"/>_<xsl:value-of select="@name"/>",
																	iRefId			: <xsl:value-of select="@reference_id"/>,
																	sInputName		: "<xsl:value-of select="@name"/>",
																	aColumns			: {
																		<xsl:for-each select="column/item">
																			"<xsl:value-of select="@value"/>": {"sType" : "int", 	"bSelect" : true,	"bGroup" : false,	"bFilter" : false, "bSort" : false}
																			<xsl:if test="position() != last()">
																				<xsl:text>,</xsl:text>
																			</xsl:if>
																		</xsl:for-each>
																	},
																	bById			: true,
																	bMultiselect		: <xsl:value-of select="@multiselect"/>,
																	sDefaultValues	: "<xsl:value-of select="@value"/>"
																});
									</script>
								</xsl:when>
								<xsl:when test="@type = 'structure'">
									<div id="container_ref_{@reference_id}_{@name}"></div>
									<script>
										new StructurePlaceholder({
																	mPlace			: "container_ref_<xsl:value-of select="@reference_id"/>_<xsl:value-of select="@name"/>",																	
																	sInputName		: "<xsl:value-of select="@name"/>",																	
																	bMultiselect	: "<xsl:value-of select="@multiselect"/>",
																	sDefaultValues	: "<xsl:value-of select="@value"/>"
																});
									</script>
								</xsl:when>
								<xsl:when test="@type = 'bool'">
									<label>
										<input name="{@name}" type="radio" value="1">
											<xsl:if test="@value = '1'">
												<xsl:attribute name="checked">
													<xsl:text>checked</xsl:text>
												</xsl:attribute>
											</xsl:if>
										</input>
										<xsl:value-of select="@labelYes"/>
									</label>
									<label>
										<input name="{@name}" type="radio" value="0">
											<xsl:if test="@value = '0'">
												<xsl:attribute name="checked">
													<xsl:text>checked</xsl:text>
												</xsl:attribute>
											</xsl:if>
										</input>
										<xsl:value-of select="@labelNo"/>
									</label>
								</xsl:when>
								<xsl:otherwise>
									<input type="text" name="{@name}" value="{@value}"/>
								</xsl:otherwise>
							</xsl:choose>
						</td>
					</tr>
				</xsl:for-each>
			</table>
			<input type="submit" value="{$LABEL_SAVE}"/>
		</form>
	</xsl:template>
</xsl:stylesheet>