<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template name="editFieldsLang">
                var locale = {both:'<xsl:value-of select="$REF_FIELD_CONTROLLER_VISIBLE_LANGUAGE"/>',<xsl:value-of select="@support_locale"/>};
		var lang	= {
					addField		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_ADD_FIELD"/>',
					newField		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_NEW_FIELD"/>',
					title			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_TITLE"/>',					
					
					int				: '<xsl:value-of select="$REF_FIELD_CONTROLLER_INT"/>',
					float			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_FLOAT"/>',
					string			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_SRING"/>',
					text			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_TEXT"/>',
					reference		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_REFERENCE"/>',
					bool			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_BOOL"/>',
					date			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_DATE"/>',
					"enum"			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_ENUM"/>',
					file			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_FILE"/>',
					picture			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_PICTURE"/>',
					
					structure		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_STRUCTURE"/>',				
					document		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_DOCUMENT"/>',
					password		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_PASSWORD"/>',
					password_confirm: '<xsl:value-of select="$REF_FIELD_CONTROLLER_PASSWORD_CONFIRM"/>',
					
					type			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_TYPE"/>',
					yes				: '<xsl:value-of select="$REF_FIELD_CONTROLLER_YES"/>',
					no				: '<xsl:value-of select="$REF_FIELD_CONTROLLER_NO"/>',
					required		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_REQUIRED"/>',
					group			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_GROUP"/>',
					sort			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_SORT"/>',
					filter			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_FILTER"/>',
					visible			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_VISIBLE"/>',
                                        visible_on_locale         : '<xsl:value-of select="$REF_FIELD_CONTROLLER_VISIBLE_ON_LOCALE"/>',
					intitle			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_INTITLE"/>',
					
					on				: '<xsl:value-of select="$REF_FIELD_CONTROLLER_ON"/>',
					off				: '<xsl:value-of select="$REF_FIELD_CONTROLLER_OFF"/>',
					
					defaultValue	: '<xsl:value-of select="$REF_FIELD_CONTROLLER_DEFAULT_VALUE"/>',
					addEnum			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_ADD_ENUM"/>',
					columns			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_COLUMNS"/>',
					referenceType	: '<xsl:value-of select="$REF_FIELD_CONTROLLER_REFERENCE_TYPE"/>',
					multiselect		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_MULTISELECT"/>',
					singleselect	: '<xsl:value-of select="$REF_FIELD_CONTROLLER_SINGLESELECT"/>',
					newValue		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_NEW_VALUE"/>',
					show			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_NEW_SHOW"/>',
					hide			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_NEW_HIDE"/>',
					confirm			: '<xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_MESSAGE"/>',
					remove			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_NEW_REMOVE"/>',			
					
					defaultGroup	: '<xsl:value-of select="$REF_FIELD_CONTROLLER_DEFAULT_GROUP"/>',
					defaultFilter	: '<xsl:value-of select="$REF_FIELD_CONTROLLER_DEFAULT_FILTER"/>',
					blockGroup		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_BLOCK_GROUP"/>',
					blockFilter		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_BLOCK_FILTER"/>',
					fieldCopy		: '<xsl:value-of select="$REF_FIELD_CONTROLLER_FIELD_COPY"/>',
					options			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_OPTIONS"/>',					
					
					unique			: '<xsl:value-of select="$REF_FIELD_CONTROLLER_NEW_UNIQUE"/>'
				};
	</xsl:template>
	
	<xsl:template match="references">
	var refList =
		[
			<xsl:for-each select="reference">
				{
					id		: "<xsl:value-of select="@id"/>",
					name	: "<xsl:value-of select="@name"/>",
					columns	:
					[										
						<xsl:for-each select="column">
							<xsl:if test="@name	!= 'id'">
								{
									
										name	: "<xsl:value-of select="@name"/>",
										title	: "<xsl:value-of select="@title"/>"								
								}
								<xsl:if test="not(position() = last())">
									<xsl:text>,</xsl:text>
								</xsl:if>
							</xsl:if>
						</xsl:for-each>							
					]
				}
				<xsl:if test="not(position() = last())">
					<xsl:text>,</xsl:text>
				</xsl:if>
			</xsl:for-each>
		];
		</xsl:template>

		<xsl:template match="document">	
			var data = [];
			data = [
				<xsl:for-each select="element">
					<xsl:if test="@name != 'id'">
						{
							title	: '<xsl:value-of select="@title"/>',
							name	: '<xsl:value-of select="@name"/>',							
							params	:
							{
								"description" 	: '<xsl:value-of select="item[@name = 'description']/@value"/>',
								"type" 			: '<xsl:value-of select="item[@name = 'type']/@value"/>',
								"required"		: '<xsl:value-of select="item[@name = 'required']/@value"/>',
								"unique"		: '<xsl:value-of select="item[@name = 'unique']/@value"/>',
								"group"			: '<xsl:value-of select="item[@name = 'group']/@value"/>',
								"sort"			: '<xsl:value-of select="item[@name = 'sort']/@value"/>',
								"filter"		: '<xsl:value-of select="item[@name = 'filter']/@value"/>',
								"visible"		: '<xsl:value-of select="item[@name = 'visible']/@value"/>',
                                                                <xsl:if test="item[@name = 'visible_on_locale']">
                                                                    "visible_on_locale" : '<xsl:value-of select="item[@name = 'visible_on_locale']/@value"/>',
                                                                </xsl:if>
								"intitle"		: '<xsl:value-of select="item[@name = 'intitle']/@value"/>',
								<xsl:if test="item[@name = 'blocked']">
									"blocked"	: '<xsl:value-of select="item[@name = 'blocked']/@value"/>',
								</xsl:if>
								<xsl:choose>
									<xsl:when test="item[@name = 'type']/@value = 'string'">
										"width" : '<xsl:value-of select="item[@name = 'optional']/item[@name = 'width']/@value"/>',
										"widthUnit" : '<xsl:value-of select="item[@name = 'optional']/item[@name = 'widthUnit']/@value"/>',
										"defaultValue" 	: '<xsl:value-of select="item[@name = 'defaultValue']/@value"/>'
									</xsl:when>
									<xsl:when test="item[@name = 'type']/@value = 'structure'">
										"multiselect" 			: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'multiselect']/@value"/>',
										"postEnable"			: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'postEnable']/@value"/>',
										"employeeEnable"		: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'employeeEnable']/@value"/>',
										"employee"				: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'employee']/@value"/>',
										"post"					: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'post']/@value"/>',
										"subdivision"			: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'subdivision']/@value"/>',
										"defaultValue" 			: '<xsl:value-of select="item[@name = 'defaultValue']/@value"/>',
										"selectAuthor" 			: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'selectAuthor']/@value"/>',
										"useStructSeparator"	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'useStructSeparator']/@value"/>',
										<xsl:if test="item[@name = 'optional']/item[@name = 'structValuesSeparator']">
											"structValuesSeparator"	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'structValuesSeparator']/@value"/>',
										</xsl:if>										
										"structOrder"			: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'structOrder']/@value"/>'
										<xsl:if test="item[@name = 'optional']/item[@name = 'structSeparator']">
											,
											"structSeparator"	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'structSeparator']/@value"/>'
										</xsl:if>										
									</xsl:when>
									<xsl:when test="item[@name = 'type']/@value = 'reference'">
										"reference"		: <xsl:value-of select="item[@name = 'optional']/item[@name = 'reference']/@value"/>,
										"multiselect"	: <xsl:value-of select="item[@name = 'optional']/item[@name = 'multiselect']/@value"/>,
										"unique"		: <xsl:value-of select="item[@name = 'optional']/item[@name = 'unique']/@value"/>,
										"separator"		: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'separator']/@value"/>',
										"rowsSeparator"	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'rowsSeparator']/@value"/>',
										"columns"		:
										<xsl:text>"</xsl:text>
											<xsl:for-each select="item[@name = 'optional']/item[@name = 'columns']/item">
												<xsl:value-of select="@value"/>
												<xsl:if test="not(position() = last())">
													<xsl:text>,</xsl:text>
												</xsl:if>
											</xsl:for-each>
										<xsl:text>"</xsl:text>,
										"defaultValues" : '<xsl:value-of select="item[@name = 'defaultValue']/@value"/>',
										"groupEnable"	: <xsl:value-of select="item[@name = 'optional']/item[@name = 'groupEnable']/@value"/>,
										"filterEnable"	: <xsl:value-of select="item[@name = 'optional']/item[@name = 'filterEnable']/@value"/>,
										"defaultGroup"	: [
											<xsl:for-each select="item[@name = 'optional']/item[@name = 'defaultGroup']/item">
												'<xsl:value-of select="@value"/>'
												<xsl:if test="not(position() = last())">
													<xsl:text>,</xsl:text>
												</xsl:if>
											</xsl:for-each>
										],
										"defaultFilter"	: {
											<xsl:for-each select="item[@name = 'optional']/item[@name = 'defaultFilter']/item">
												'<xsl:value-of select="@name"/>' : '<xsl:value-of select="@value"/>'
												<xsl:if test="not(position() = last())">
													<xsl:text>,</xsl:text>
												</xsl:if>
											</xsl:for-each>
										},
										"fieldsValue"	: {
											<xsl:for-each select="item[@name = 'optional']/item[@name = 'fieldsValue']/item">
												'<xsl:value-of select="@name"/>' : '<xsl:value-of select="@value"/>'
												<xsl:if test="not(position() = last())">
													<xsl:text>,</xsl:text>
												</xsl:if>
											</xsl:for-each>
										}
									</xsl:when>
									<xsl:when test="item[@name = 'type']/@value = 'bool'">
										"labelYes" 		: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'labelYes']/@value"/>',
										"labelNo"		: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'labelNo']/@value"/>',
										"defaultValue" 	: '<xsl:value-of select="item[@name = 'defaultValue']/@value"/>'
									</xsl:when>
									
									<xsl:when test="item[@name = 'type']/@value = 'date' or item[@name = 'type']/@value = 'timestamp'">
										"setCurrentDate" 	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'setCurrentDate']/@value"/>',								
										"defaultValue" 		: '<xsl:value-of select="item[@name = 'defaultValue']/@value"/>'
									</xsl:when>									
									<xsl:when test="item[@name = 'type']/@value = 'enum'">
										"defaultValue" 	: "<xsl:value-of select="item[@name = 'defaultValue']/@value"/>",
										"separator"		: "<xsl:value-of select="item[@name = 'optional']/item[@name = 'separator']/@value"/>",
										"multiselect"	: "<xsl:value-of select="item[@name = 'optional']/item[@name = 'multiselect']/@value"/>",
										"enum"			:
										{
												<xsl:for-each select="item[@name = 'optional']/item[@name = 'enum']/item">
													<xsl:value-of select="@name"/>:"<xsl:value-of select="@value"/>"
													<xsl:if test="not(position() = last())">
														<xsl:text>,</xsl:text>
													</xsl:if>
												</xsl:for-each>
										}
									</xsl:when>
									<xsl:when test="item[@name = 'type']/@value = 'picture'">
										"width" : '<xsl:value-of select="item[@name = 'optional']/item[@name = 'width']/@value"/>',
										"height" : '<xsl:value-of select="item[@name = 'optional']/item[@name = 'height']/@value"/>',
										"alt" : '<xsl:value-of select="item[@name = 'optional']/item[@name = 'alt']/@value"/>',
										"multiselect" : '<xsl:value-of select="item[@name = 'optional']/item[@name = 'multiselect']/@value"/>'									
										<xsl:if test="item[@name = 'optional']/item[@name = 'valuesSeparator']">
											,
											"valuesSeparator"	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'valuesSeparator']/@value"/>'
										</xsl:if>
									</xsl:when>
									<xsl:when test="item[@name = 'type']/@value = 'file'">
										"multiselect" : '<xsl:value-of select="item[@name = 'optional']/item[@name = 'multiselect']/@value"/>'															
										<xsl:if test="item[@name = 'optional']/item[@name = 'valuesSeparator']">
											,
											"valuesSeparator"	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'valuesSeparator']/@value"/>'
										</xsl:if>
									</xsl:when>
									<xsl:when test="item[@name = 'type']/@value = 'document'">
										"multiselect" 	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'multiselect']/@value"/>',
										"selectThisDoc" : '<xsl:value-of select="item[@name = 'optional']/item[@name = 'selectThisDoc']/@value"/>',
										<xsl:if test="item[@name = 'optional']/item[@name = 'valuesSeparator']">											
											"valuesSeparator"	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'valuesSeparator']/@value"/>',
										</xsl:if>
										"doctypes"	  	:
										<xsl:text>"</xsl:text>
											<xsl:for-each select="item[@name = 'optional']/item[@name = 'doctypes']/item">
												<xsl:value-of select="@value"/>
												<xsl:if test="not(position() = last())">
													<xsl:text>,</xsl:text>
												</xsl:if>
											</xsl:for-each>
										<xsl:text>"</xsl:text> 															
									</xsl:when>
									<xsl:when test="item[@name = 'type']/@value = 'table'">
										"displayInRS" 	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'displayInRS']/@value"/>',
										"fields" 		: 
										{
											<xsl:for-each select="item[@name = 'optional']/item[@name = 'fields']/item">
												<xsl:value-of select="@name"/>: {
												<xsl:choose>
													<xsl:when test="item[@name='type']/@value">
														type : '<xsl:value-of select="item[@name='type']/@value"/>',
														title : '<xsl:value-of select="item[@name='title']/@value"/>',
														width : '<xsl:value-of select="item[@name='width']/@value"/>'
													</xsl:when>
													<xsl:otherwise>
														type : 'text',
														title : '<xsl:value-of select="@value"/>',
														width : '<xsl:value-of select="item[@name='width']/@value"/>'
													</xsl:otherwise>
												</xsl:choose>
												}
												<xsl:if test="not(position() = last())">
													<xsl:text>,</xsl:text>
												</xsl:if>
											</xsl:for-each>
										},	
										"width" 	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'width']/@value"/>',
										"cellpadding" 	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'cellpadding']/@value"/>',
										"borderWidth" 	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'borderWidth']/@value"/>',	
										"defaultValue" : '<xsl:value-of select="item[@name = 'defaultValue']/@value"/>'					
									</xsl:when>
									<xsl:when test="item[@name = 'type']/@value = 'text'">
										"viewRTE" 	   	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'viewRTE']/@value"/>',
										"width" 		: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'width']/@value"/>',
										"widthUnit" 	: '<xsl:value-of select="item[@name = 'optional']/item[@name = 'widthUnit']/@value"/>',	
										"defaultValue" 	: '<xsl:value-of select="item[@name = 'defaultValue']/@value"/>'					
									</xsl:when>
									<xsl:otherwise>
										"defaultValue" : '<xsl:value-of select="item[@name = 'defaultValue']/@value"/>'
									</xsl:otherwise>
								</xsl:choose>
							}
						}
						<xsl:if test="not(position() = last())">
							<xsl:text>,</xsl:text>
						</xsl:if>
					</xsl:if>
				</xsl:for-each>
			];
	
		</xsl:template>
		
		<xsl:template match="doctypes">
			var aDoctypes = 
				[
					<xsl:for-each select="doctype">
					{
						id		: "<xsl:value-of select="@doctype_id"/>",
						title	: "<xsl:value-of select="@title"/>"						
					}
					
					<xsl:if test="not(position() = last())">
					<xsl:text>,</xsl:text>
					</xsl:if>
					</xsl:for-each>
				];	
		</xsl:template>		
	
</xsl:stylesheet>
	