<?xml version='1.0'?>
	<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
		<xsl:template match="/page/module">
		<script src="/modules/references/view/js/REF_SaveHandler.js"></script>
		<script>
			registerEvent(function() {
				new REF_SaveHandler($("mainForm"), $("savemain_button"), $("login_layer"), "submit");
			});	
		</script>
		<script>
			document.onkeydown = function(e){
				key = (!e) ? window.event : e;
				if (key.ctrlKey &amp;&amp; key.keyCode == 13){
					$("savemain_button").click();
				} 
			}
		</script>
		<script type="text/javascript">
			WindowHandler.attachHandlers();
		</script>	
			<form method="post" id="mainForm">
				<div class="WF_Fields_ElementContainer">
					<input type="hidden" name="request" value="1"/>
					<table class="form">
						<tr>
							<td class="form-row-title">
								<xsl:value-of select="$REFERENCE_NAME"/>:
							</td>
							<td class="form-row-value">
								<input name="refName" value="{/page/module/@name}" class="wide"/>
							</td>
						</tr>
						<tr>
							<td class="form-row-title">
								<xsl:value-of select="$REFERENCE_SHORT_DESCRIPTION"/>:
							</td>
							<td class="form-row-value">
								<textarea name="refDescription" class="wide">
									<xsl:value-of select="/page/module/@description"/>
								</textarea>
							</td>
						</tr>
						<tr>
							<td class="form-row-title">
								<xsl:value-of select="$REFERENCE_FULL_DESCRIPTION"/>:
							</td>
							<td class="form-row-value">
								<textarea id="refFullDescription" name="refFullDescription" class="wide">
									<xsl:value-of select="/page/module/@fullDescription"/>
								</textarea>
								<script>
									initRte("refFullDescription");
								</script>
							</td>
						</tr>
						<tr>
							<td class="form-row-title">
								<xsl:value-of select="$REFERENCE_GROUP"/>:
							</td>
							<td class="form-row-value">
								<select name="refGroupId">
									<option value="0"><xsl:value-of select="$LABEL_NO"/></option>
									<xsl:for-each select="groups/item">
										<option value="{@group_id}">
											<xsl:if test="@group_id = ../../@group_id">
												<xsl:attribute name="selected">
													selected
												</xsl:attribute>
											</xsl:if>
											<xsl:value-of select="@name"/>
										</option>
									</xsl:for-each>
								</select>
							</td>
						</tr>					
					</table>
					<div style="display:none;">
					<div id="login_layer" style="padding:5pt;">							
								<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
								<table cellpadding="5pt">
								<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
								<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
								<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
							</table>	
						</div>
					</div>
					<input id="savemain_button" type="button" value="{$LABEL_SAVE}" style="float: left;"/>
					<img id="busy_loader" height="25" width="25" src="/templates/default/images/win/big-ajax-loader.gif" style="display:none;"/>
				</div>
				<!-- <input type="button" value="ok" onclick="console.log(Form.getInputs('mainForm'));"/> -->
			</form>
		</xsl:template>		
</xsl:stylesheet>