<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
include_once CNF_ABS_PATH . "/library/MSF_Recordset/MSF_RecordsetXml.php";
include_once CNF_ABS_PATH . "/library/WF_Template/WF_Template.php";

class REF_ReferenceXml extends MSF_RecordsetXml
{

	public function showRow($aRow, $sTemplate, $IsPlain)
	{
		if(trim($sTemplate == "")) {
			$this->Root->setAttribute("template_mode", "default");
		}
		else {
			$this->Root->setAttribute("template_mode", "user");

			$WF_Template	= new WF_Template($sTemplate);
			$this->Template->addXsl("match", "row", $WF_Template->getFormXml($IsPlain));
		}


		$Row	= $this->Template->createElement("row");
		$this->Root->appendChild($Row);

		foreach($aRow as $aColumn) {
			$Column	= $this->Template->createElement("field");
			$Row->appendChild($Column);

			foreach($aColumn as $sKey=>$mValue) {
				if(is_array($mValue)) {
					$Element	= $this->Template->createElement($sKey);
					$Column->appendChild($Element);
					foreach($mValue as $v) {
						$Item	= $this->Template->createElement("item");
						$Item->setAttribute("value", $v);

						$Element->appendChild($Item);
					}
				}
				else {
					$Column->setAttribute($sKey, $mValue);
				}

			}

		}

	}

	public function setReferenceId($iId)
	{
		$this->Root->setAttribute("referenceId", $iId);
		$this->Root->setAttribute("id", $iId);
	}

	public function setGroupId($iId)
	{
		$this->Root->setAttribute("group_id", $iId);
	}
	
	public function setReferenceName($sName)
	{
		$this->Root->setAttribute("name", $sName);
	}
	
	public function setReferenceDescription($sDesc)
	{
		$this->Root->setAttribute("description", $sDesc);
	}
	
	public function setReferenceFullDescription($sDesc)
	{
		$this->Root->setAttribute("fullDescription", $sDesc);
	}

	public function setTemplate($sTemplate)
	{
		$this->Root->setAttribute("template", $sTemplate);
	}

	public function editMain()
	{
		$this->Template->addLink("/modules/references/view/css/Fields.css", "text/css");
		$this->Template->addXslPath("/modules/references/view/templates/" . CNF_SKIN . "/editMain.xsl");
	}
	
	public function editFields($aColumns)
	{
		// chtoby u staryh spravochnikah byli vybrany vse tipy v pole document
		$oWrapper = new MSF_XmlWrapper($aColumns);
		$aFields  = $oWrapper->getAsArray();		
		foreach($aFields AS $Key => $Value) {
			if($Value["value"]["type"] == "document" && !isset($Value["value"]["optional"]["doctypes"])) {
				$DoctypeList = new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));
				$aList		 = $DoctypeList->getAll();
				foreach($aList as $aDoctype) {	
					$aFields[$Key]["value"]["optional"]["doctypes"][] = $aDoctype["doctype_id"];				
				}
						
			}
			
		}
		
		$oWrapper->clear();
		$oWrapper->import($aFields);
		$aColumns = $oWrapper->getXml();
		//
		$this->Template->appendXmlString($this->Root, MSF_SL::slashXml($aColumns));
		$this->Template->addXslPath("/modules/references/view/templates/" . CNF_SKIN . "/editFields.xsl");
		$this->Template->addXslPath("/modules/references/view/templates/" . CNF_SKIN . "/editFieldsTemplates.xsl");
				
		$this->addEditResurces();
	}
	
	public function addEditResurces()
	{
		
		//$this->Template->addLink("/js/ext/scal/javascripts/scal.js", "text/javascript");
		//$this->Template->addLink("/js/ext/scal/styles/scaltables.css", "text/css");
		
		$this->Template->addLink("/js/ext/calendar_date_select/js/calendar_date_select.js", "text/javascript");
		$this->Template->addLink("/js/ext/calendar_date_select/css/default.css", "text/css");
		$this->Template->addLink("/js/msf/date/DatePlaceholder.js", "text/javascript");
		
		
		$this->Template->addLink("/library/MSF_Recordset/resources/" . CNF_SKIN . "/css/RS_GroupManager.css", "text/css");
		
		$this->Template->addLink("/modules/references/view/js/REF_FieldsController.js", "text/javascript");
		$this->Template->addLink("/modules/references/view/css/Fields.css", "text/css");
		
		$this->addLinksOf("references");
		$this->addLinksOf("structure");
	}

	public function setReferencesList($aList)
	{
		$References	= $this->Template->createElement("references");
		$this->Root->appendChild($References);

		foreach($aList as $aRow) {
			$Reference	= $this->Template->createElement("reference");
			$References->appendChild($Reference);

			$Reference->setAttribute("id", $aRow["reference_id"]);
			$Reference->setAttribute("name", MSF_String::encodeSpecialCharsFull($aRow["name"]));

			//$Columns	= $this->Template->createElement("columns");
			foreach($aRow["columns"] as $aColumn) {
				//if($aColumn["name"] != 'id') {
					$Column	= $this->Template->createElement("column");
					$Reference->appendChild($Column);

					$Column->setAttribute("name", $aColumn["name"]);
					$Column->setAttribute("title", addslashes($aColumn["title"]));
				//}
				
			}

		}

	}
	
	public function setDoctypesList($aList)
	{
		$Doctypes	= $this->Template->createElement("doctypes");		
		foreach($aList as $aDoctype) {
			$Doctype 	= $this->Template->createElement("doctype");
			$Doctypes->appendChild($Doctype);

			$Doctype->setAttribute("doctype_id", $aDoctype["doctype_id"]);
			$Doctype->setAttribute("title", addslashes($aDoctype["title"]));
		}

		$this->Root->appendChild($Doctypes);
	}

	public function setGroupsList($aList)
	{
                $Groups	= $this->Template->createElement("groups");
		$this->Root->appendChild($Groups);
		
		foreach($aList as $aGroup) {
//                        debug($aGroup);
//                        exit;
                        $aGroup["name"]= MSF_Registry::get("MSF_Locale")->getI18N($aGroup["name"]);
                        $Item	= $this->Template->createElement("item");
			$Groups->appendChild($Item);
			
			foreach($aGroup as $k=>$v) {
				$Item->setAttribute($k, mb_substr($v, 0, 90));
			}
			
		}
		
	}
	
	public function setColumnTypes($aTypes)
	{
		$Types	= $this->Template->createElement("types");
		$this->Root->appendChild($Types);

		foreach($aTypes as $sType) {
			$Type	= $this->Template->createElement("type");
			$Types->appendChild($Type);

			$Type->setAttribute("name", $sType);
		}

	}

	public function testMini()
	{
		$this->addTemplate("/modules/references/view/templates/default/testmini.xsl");
		$this->addLinksOf("references");
	}

	public function changeAccess($aData)
	{
		$Access	= $this->Template->createElement("access");
		$this->Root->appendChild($Access);
		$iCount	= 0;
		foreach($aData as $aRow) {
			$Item	= $this->Template->createElement("item");
			$Item->setAttribute("id", $iCount);
			$Access->appendChild($Item);
			
			foreach($aRow as $n=>$k) {
				$Item->setAttribute($n, $k);
			}
			
			$iCount++;
		}
		
		$this->addTemplate("/modules/references/view/templates/default/editAccess.xsl");
		$this->Template->addLink("/js/msf/element/MSF_ElementAdder.js", "text/javascript");
		$this->addLinksOf("structure");
	}
	
	public function add()
	{
		$this->Template->addLink("/modules/references/view/css/Fields.css", "text/css");
	}
}
?>