<?php

defined("__MSF") or die("Direct access is not allowed");

class Struct_DocumentWatcher
{
	private $DB;
	
	public function __construct(Struct_DocumentWatcherDB $DB)
	{
		$this->DB = $DB;
	}
	
	public function exists($aStructureIds)
	{
		$sStructureIds = implode(",", $aStructureIds);
		
		return (
			($this->DB->existsAcl($sStructureIds) > 0) || ($this->DB->existsDocuments($sStructureIds) > 0)
		) ? true : false;
	}
	
	public function save($aOldStructureIds, $iNewStructureId)
	{
		$sOldStructureIds = implode(",", $aOldStructureIds);
		
		$this->DB->updateAcl($sOldStructureIds, $iNewStructureId);
		$this->DB->updateDocuments($sOldStructureIds, $iNewStructureId);
	}
}

?>