<?php

defined("__MSF") or die("Direct access is not allowed");

class Struct_DocumentWatcherDB
{
	private $DB;
	
	public function __construct(MSF_DB $DB)
	{
		$this->DB = $DB;
	}
	
	public function existsAcl($sStructureIds)
	{
		if (!empty($sStructureIds)) {
			$sSql = "SELECT\n" .
						"COUNT(*) AS total\n" .
					"FROM\n" .
						"wf_documents_access_list\n" .
					"WHERE\n" .
						"structure_id IN (" . $sStructureIds . ")";
			
			return $this->DB->select($sSql, true, "total");
		}
		else {
			return array();
		}

	}
	
	public function existsDocuments($sStructureIds)
	{
		if (!empty($sStructureIds)) {
			$sSql = "SELECT\n" .
						"COUNT(*) AS total\n" .
					"FROM\n" .
						"wf_documents\n" .
					"WHERE\n" .
						"structure_id IN (" . $sStructureIds . ")";
			
			return $this->DB->select($sSql, true, "total");
		}
		else {
			return array();
		}

	}
	
	public function updateAcl($sOldIds, $iNewId)
	{
		if (!empty($sOldIds)) {
			$sSql = "UPDATE\n" .
						"wf_documents_access_list\n" .
					"SET\n" .
						"structure_id = " . $iNewId . "\n" .
					"WHERE\n" .
						"structure_id IN (" . $sOldIds . ")";
			
			$this->DB->executeQuery($sSql);
		}

	}
	
	public function updateDocuments($sOldIds, $iNewId)
	{
		if (!empty($sOldIds)) {
			$sSql = "UPDATE\n" .
						"wf_documents\n" .
					"SET\n" .
						"structure_id = " . (int)$iNewId . "\n" .
					"WHERE\n" .
						"structure_id IN (" . $sOldIds . ")";
			
			$this->DB->executeQuery($sSql);
		}
		
	}
	
}

?>