<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "Struct_Tree.php";
include_once "modules/references/library/Reference/UserReference.php";

class Struct_Main
{
	/**
	 * @var Struct_Tree
	 */
	private $Tree 		= null;
	
	/**
	 * @var UserReference
  	 */
	private $Reference 	= null;
	
	private $aConfig 	= array();
	
	private $sColDelim 	= "/^/col/^/";
	
	private $aTreeFull	= null;
	
	public function __construct()
	{
		$this->Tree 		= new Struct_Tree(MSF_Registry::get("MSF_DB"));
		
		$this->Reference 	= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
	}
	
	public function setConfig($aConfig)
	{
		$this->aConfig 		= array(
			"subdivision" 	=> $aConfig["subdivision"],
			"post" 			=> $aConfig["post"]
		);
	}
	
	public function searchByValues($mColumns, $mValues)
	{
		return $this->Tree->search($mColumns, $mValues);
	}

	public function getSubdivisions($sSearch = "", $sFieldName = "")
	{
		/*
		$aTree = array($this->Tree->get(true, 1, "subdivision"));
		$this->Reference->load(4, $this->getColumns("subdivision"));
		$aSubs = $this->Reference->getAsArray();
		
		$this->Reference->load(3, $this->getColumns("post"));
		$aPosts = $this->Reference->getAsArray();
		
		$aTree = $this->addValues($aTree, $aSubs, $aPosts, $sSearch);
		*/
		
		//eto sdelano dlya poiska v minipredstavlenii
		//sposob ebanutiy, no reshili do refactoringa budet rabotat tak
		
		//$aTree	= $this->getTree();
		//debug($aPosts);
		//debug($aTree);
		/*
		$aTree = array($this->Tree->get(true, 1, "subdivision"));
		$this->Reference->load(4, $this->getColumns("subdivision"));
		$aSubs = $this->Reference->getAsArray();
		
		$this->Reference->load(3, $this->getColumns("post"));
		$aPosts = $this->Reference->getAsArray();
		
		$aTree = $this->addValues($aTree, $aSubs, $aPosts, $sSearch);
		//debug($aSubs, $aPosts);
		//$aTree	= $this->buildSubdivision($aTree, $aSubs, $aPosts, $sSearch);
		*/
		$aTree	= $this->getTree($sFieldName);
		//debug($aTree);
		$this->buildSubdivision($aTree, mb_strtolower($sSearch, "UTF-8"), 0);
		//debug($aTree);
		
		//debug($aTree, mb_strtolower($sSearch));
		return $aTree;
	}
	
	
	
	private function buildSubdivision(&$aTree, $sSearch, $level)
	{
		$currentLevelFlag	= false;
		$previusLevelFlag	= false;
		$currentBranchFlag	= false;
		foreach($aTree as $iKey=>&$aBranch) {				
			if(isset($aBranch["nodes"]) && !empty($aBranch["nodes"])) {
				$currentBranchFlag	= $this->buildSubdivision($aBranch["nodes"], $sSearch, ++$level);
				if($currentBranchFlag) {
					$previusLevelFlag	= true;
				}
				
			}			
			if(isset($aBranch["value"]) && $sSearch != "") {
				$iValue    = strpos(mb_strtolower($aBranch["value"], "UTF-8"), $sSearch);
				$iEmployee = strpos(mb_strtolower(MSF_SL::getPAram($aBranch, "employee"), "UTF-8"), $sSearch);
				if($iValue !== false || ($aBranch["type"] == "post" && $iEmployee !== false)) {				
				  	$currentLevelFlag	= true;
				}
			}
			if($aBranch["type"] == "post" || ((!$currentBranchFlag || !isset($aBranch["nodes"])) && $level != 1 && $sSearch != "")) {
				unset($aTree[$iKey]);
			}
		}

		return ($currentLevelFlag || $previusLevelFlag);
	}
	
	private function getColumns($sKey)
	{
		$aResult 	= array();
		$aResult[] 	= array("title" => "id", "visible" => 0);
		
		if (isset($this->aConfig[$sKey])) {
			foreach ($this->aConfig[$sKey] AS $v) {
				$aResult[] = $v;
			}
		}
		
		return $aResult;
	}
	

	
	public function getConfig()
	{
		return $this->aConfig;
	}

	public function getTree($sFieldName = "")
	{
		$aTree = array($this->Tree->get());
		$this->Reference->load(4, $this->getColumns("subdivision"));
		$aSubs = $this->Reference->getAsArray();
		$this->Reference->load(3, $this->getColumns("post"));
		$aPosts = $this->Reference->getAsArray();
		$this->aTreeFull	= $aTree;
		$aTree = $this->addValues($aTree, $aSubs, $aPosts, "", array(), $sFieldName);
		
		return $aTree;
	}
	
	/**
	 * @return string
	 */
	private function getTitle($iRefId, $sColumnName) 
	{
		$oDb 		= new UserReferenceDB(MSF_Registry::get("MSF_DB"));
		$aTemp 		= $oDb->load($iRefId);
		$oColumns 	= new MSF_XmlWrapper($aTemp["columns"]);
		return $oColumns->get($sColumnName)->getTitle();
	}
	
	private function getType($iRefId, $sColumnName) 
	{
		$oDb 		= new UserReferenceDB(MSF_Registry::get("MSF_DB"));
		$aTemp 		= $oDb->load($iRefId);
		$oColumns 	= new MSF_XmlWrapper($aTemp["columns"]);
		return $oColumns->get($sColumnName)->getValue("type");
	}
	
	public function getPosts($iId = 0, $sEmployee = "name", $sPost = "post", $iSkipNodeId = 0)
	{
		$Recordset					= new MSF_Recordset(MSF_Registry::get("MSF_DB"));
		$Recordset->bCalculateSum 	= false;
		
		$aColumns	= array(
			array(
				"name"		=> "ref_system_posts.id",
				"title"		=> "ID",
				"sort"		=> 1,
				"filter" 	=> 1,
				"group"		=> 0,
				"type"		=> "int",
				"visible"	=> 1,
				"compare"	=> "equal"
			),
			array(
				"name"		=> "ref_system_employees." . $sEmployee,
				"title"		=> MSF_Registry::get("MSF_Locale")->getI18N($this->getTitle(2, $sEmployee)),
				"sort"		=> 1,
				"filter" 	=> 1,
				"group"		=> 0,
				"type"		=> $this->getType(2, $sEmployee),
				"visible"	=> 1,
				"compare"	=> "like"
			),
			array(
				"name"		=> "ref_system_posts." . $sPost,
				"title"		=> MSF_Registry::get("MSF_Locale")->getI18N($this->getTitle(3, $sPost)),
				"sort"		=> 1,
				"filter" 	=> 1,
				"group"		=> 0,
				"type"		=> $this->getType(3, $sPost),
				"visible"	=> 1,
				"compare"	=> "like"
			),
			array(
				"name"		=> "structure.node_id",
				"title"		=> "node_id",
				"sort"		=> 1,
				"filter" 	=> 1,
				"group"		=> 0,
				"type"		=> "int",
				"visible"	=> 1,
				"compare"	=> "equal"
			),
			array(
				"name"		=> "structure.position",
				"title"		=> "posit",
				"sort"		=> 1,
				"filter" 	=> 1,
				"group"		=> 0,
				"type"		=> "int",
				"visible"	=> 0,
				"compare"	=> "equal"
			),
			array(
				"name"		=> "ref_system_employees.id AS employee_id",
				"title"		=> "employee_id",
				"sort"		=> 1,
				"filter" 	=> 1,
				"group"		=> 1,
				"type"		=> "int",
				"visible"	=> 1,
				"compare"	=> "equal"
			)
			
		);
		
		$Recordset->setColumns($aColumns);
		$Recordset->setTables(array(
				"(SELECT *, string_to_array(employee_ref_value, '/^/col/^/') AS emp_arr FROM ref_system_posts WHERE employee_ref_value IS NOT NULL) ref_system_posts", 
				"ref_system_employees", 
				"structure"
				));
		
		if($iId) {
			$aPostsId	= array(-1);
			$aTmp		= $this->Tree->getPosts($iId);
			foreach($aTmp as $aPost) {
				array_push($aPostsId, $aPost["subject_id"]);
			}
			
			$Recordset->setConditions(array(
				"AND ref_system_posts.id IN (" . implode(", ", $aPostsId) . ")",
				"AND ref_system_employees.id=CAST(ref_system_posts.emp_arr[2] AS integer)",
				"AND ref_system_posts.id=structure.subject_id",
				"AND type='post'",
				"AND structure.node_id != " . $iSkipNodeId
			));
		}
		else {
			$Recordset->setConditions(array(
				"AND CAST(ref_system_employees.id AS text)=ref_system_posts.emp_arr[2]",
				"AND ref_system_posts.id=structure.subject_id",
				"AND type='post'",
				"AND structure.node_id != " . $iSkipNodeId
			));
		}
		
		return $Recordset->getGroup();
	}
	
	public function getList()
	{
		return $this->Tree->get(false);
	}
	
	public function edit($iNodeId, $iSubjectId, $sExtraIds = "")
	{
		$this->Tree->edit($iNodeId, $iSubjectId, $sExtraIds);
	}

	public function move($iWhat, $iWhere)
	{
		$this->Tree->move($iWhat, $iWhere);
	}
	
	public function moveBegin($iThisId, $iFirstId)
	{
		$this->Tree->moveBegin($iThisId, $iFirstId);
	}
	
	public function moveEnd($iThisId, $iLastId)
	{
		$this->Tree->moveEnd($iThisId, $iLastId);
	}

	public function remove($iNodeId)
	{
		if ($iNodeId > 1) {
			$this->Tree->remove($iNodeId);
			$this->deleteAccess($iNodeId);
		}
	}
	
	
	private function deleteAccess($iNodeId)
	{
		$DB = MSF_Registry::get("MSF_DB");
		$DB->executeQuery("DELETE FROM ref_references_access_list WHERE structure_id = " . $iNodeId);
		$DB->executeQuery("DELETE FROM wf_documents_access_list WHERE structure_id = " . $iNodeId);
		$DB->executeQuery("DELETE FROM wf_doctypes_access_list WHERE structure_id = " . $iNodeId);
	}
	

	public function add($iParentId, $sType, $iSubjectId)
	{
		$this->Tree->add($iParentId, $sType, $iSubjectId);
	}
	
	private function addValues($aTree, $aSubs, $aEmps, $sSearch="", $aParent = array(), $sFieldName = "subdivision") 
	{
		$aTmp = array();
		for ($i = 0; $i < sizeof($aTree); $i++) {
			if ($aTree[$i]["type"] == "subdivision") {
				$aTmp = $aSubs;
			}
			else {
				$aTmp = $aEmps;
			}
			
			for ($j = 0; $j < sizeof($aTmp); $j++) {
				if ($aTmp[$j]["id"] == $aTree[$i]["subject_id"]) {
					foreach ($aTmp[$j] AS $k => $v) {
						switch ($k) {
							case "id":
								break;
							case "post":
								$aTree[$i]["subdivision"] 		= MSF_SL::getParam($aParent,"value","");
								$aTree[$i]["subdivision_id"] 	= $aParent["subject_id"];
							case $sFieldName:
								$aTree[$i]["value"] = $v;
								break;
							case "subdivision":
								$aTree[$i]["value"] = $v;
								$aTree[$i]["parent_subject_id"] = (isset($aParent["subject_id"])) ? $aParent["subject_id"] : 0;
								$aTree[$i]["parent_value"] = (isset($aParent["value"])) ? $aParent["value"] : 0;
								break;
							case "employee_ref_value":
								if (!empty($v)) {
									$aValue 					= explode($this->sColDelim, $v);
									$aTree[$i]["employee"] 		= $aValue[0];
									$aTree[$i]["employee_id"] 	= $aValue[1];
								}
								else {
									$aTree[$i]["employee"] 		= "";
									$aTree[$i]["employee_id"] 	= 0;	
								}
								break;
						}
					}
				}
				if ($aTree[$i]["subject_id"] == 0 && isset($aParent["value"])) {
					$aTree[$i]["subdivision"] 		= $aParent["value"];
					$aTree[$i]["subdivision_id"] 	= $aParent["subject_id"];
				}
			}
			
			if (!empty($aTree[$i]["additional_subject_ids"])) {
				//echo $aTree[$i]["additional_subject_ids"] . "[[[";
				$aIds 	= explode(",", $aTree[$i]["additional_subject_ids"]);
				$aAds 	= array();
				$k 		= 0;				
				$aTree[$i]["additional_subject_ids"] = $this->addAdditionalIds($this->aTreeFull, $aIds, $aEmps);
				//echo "]]]";
			}
			else {
				$aTree[$i]["additional_subject_ids"] = array();
			}
			
			if (isset($aTree[$i]["nodes"]) && !empty($aTree[$i]["nodes"])) {
				$aTree[$i]["nodes"] = $this->addValues($aTree[$i]["nodes"], $aSubs, $aEmps, $sSearch, $aTree[$i], $sFieldName);
			}
			
		}
				
		return $aTree;
	}
	
	private function addAdditionalIds($aTree, $aIds, $aEmps)
	{
		$aAds = array();
		$k = 0;
		
		foreach ($aTree as $aItem) {
			
			if (in_array($aItem["node_id"], $aIds)) {
				foreach ($aEmps as $aEmployee) {
					if ($aItem["subject_id"] == $aEmployee["id"]) {
						$RefValue = new REF_Value();
						$RefValue->parse($aEmployee["employee_ref_value"]);

						$aAds[$k] 				= array();
						$aAds[$k]["node_id"] 	= $aItem["node_id"];
						$aAds[$k]["post_id"] 	= $aEmployee["id"];
						$aAds[$k]["post"] 		= $aEmployee["post"];
						
						$aValues 	= $RefValue->getValuesList();
						$aKeys 		= $RefValue->getKeysList();
						
						foreach ($aValues as $iKey => $sValue) {
							$aAds[$k]["employee"] 		= $sValue;
							$aAds[$k]["employee_id"] 	= $aKeys[$iKey];
						}
						
						$k++;
						break;
					}
				}
			}
			
			if (!empty($aItem["nodes"])) {
				$aAds = array_merge($aAds, $this->addAdditionalIds($aItem["nodes"], $aIds, $aEmps));
			}
		}
		

		return $aAds;
	}

	public function getElement($iStrId)
	{
		$sSql = "SELECT
					*
				FROM
					structure
				WHERE
					node_id = " . $iStrId;
		
		return MSF_Registry::get("MSF_DB")->select($sSql, true);
	}
	
	public function getBySubjectId($sType, $iSubjectId)
	{
		$sSql = "SELECT
					*
				FROM
					structure
				WHERE
					type = '" . $sType ."'
				AND
					subject_id = " . (int)$iSubjectId;
		
		return MSF_Registry::get("MSF_DB")->select($sSql, true, "node_id");
	}
	
	public function replace($iNode, $iElem) 
	{
		$this->Tree->replace($this->getBySubjectId("subdivision", $iNode), $this->getBySubjectId("post", $iElem));
	}
	
	public function replaceSubdivision($iNode, $iElem) 
	{
		$this->Tree->replace($this->getBySubjectId("subdivision", $iNode), $this->getBySubjectId("subdivision", $iElem));
	}
	
}

?>