<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "modules/references/library/ReferencesList/REF_ReferencesList.php";
include_once "Struct_ReferencesSecurityManagerDb.php";

class Struct_ReferencesSecurityManager
{
	private $aReferenceList = array();

	private $aStrucureList	= array();
	
	private $aAccessList	= array();

	/**
	 * @param MSF_DB $oDB
	 * @access public 
	 */
	public function __construct(MSF_DB $oDb)
	{
		$this->aAccessList		= $this->getAccessList($oDb);
		$this->aReferenceList	= $this->getReferenceList($oDb);
	}

	/**
	 * @access public 
	 * @return array
	 */
	public function get()
	{
		$aResult = array();
		foreach ($this->aReferenceList as $iRefId => $sRefTitle) {
			foreach ($this->aAccessList AS $iStrId => $aValue) {
				if (isset($aValue[$iRefId])) {
					$aResult[$iStrId][$iRefId]["title"] 	= $sRefTitle;
					$aResult[$iStrId][$iRefId]["view"] 		= $aValue[$iRefId]["view"];
					$aResult[$iStrId][$iRefId]["edit_ref"] 	= $aValue[$iRefId]["edit_ref"];
					$aResult[$iStrId][$iRefId]["edit_conf"] = $aValue[$iRefId]["edit_conf"];
				}
			}
		}
		
		return $aResult;
	}

	private function getReferenceList(MSF_DB $oDb)
	{
		$aResult 	= array();
		$oList 		= new REF_ReferencesList(new REF_ReferencesListDB($oDb));
		$aList 		= $oList->getList();
		foreach ($aList AS $aItem) {
			$aResult[$aItem["reference_id"]]= $aItem["name"];
		}

		asort($aResult);
		return $aResult;
	}
	
	private function getAccessList(MSF_DB $oDb)
	{
		$aResult	= array();
		$oAccessDb 	= new Struct_ReferencesSecurityManagerDb($oDb);
		$aList 		= $oAccessDb->get();		
		
		foreach ($aList AS $aItem) {
			if (!isset($aResult[$aItem["structure_id"]])) {
				$aResult[$aItem["structure_id"]] = array();
			}

			if (!isset($aResult[$aItem["structure_id"]][$aItem["reference_id"]])) {
				$aResult[$aItem["structure_id"]][$aItem["reference_id"]] = array();
			}
			
			$aResult[$aItem["structure_id"]][$aItem["reference_id"]]["view"] 		= $aItem["can_view"];
			$aResult[$aItem["structure_id"]][$aItem["reference_id"]]["edit_ref"] 	= $aItem["can_edit_reference"];
			$aResult[$aItem["structure_id"]][$aItem["reference_id"]]["edit_conf"] 	= $aItem["can_edit_config"];
		}
		
		$aCorrectResult = array();		
		$oStruct  = new Struct_Main();
		$aStrList = $oStruct->getList();
		foreach($aStrList AS $iKey => $aValue) {
			$iId = $aValue["node_id"];
			if(!isset($aResult[$iId])) {
				$aResult[$iId] = array();			
			}
			
		}
				
		foreach($aResult AS $iStrId => $aValue) {
			$aParents = Struct_Utils::getParents($iStrId);
			$aIds 	  = array();
			for($i = 0; $i < count($aParents); $i++) {
				$aIds[] = $aParents[$i]["node_id"];	
			}
			
			$aCorrectResult[$iStrId] = $aResult[$iStrId];
			for($i = 0; $i < count($aIds); $i++) {				
				foreach($aResult[$aIds[$i]] AS $iKey => $aResValue) {
					$aCorrectResult[$iStrId][$iKey] = $aResValue;						
				}			
				
			}
			
		}
		
		return $aCorrectResult;
	}

}
?>