<?php
defined("__MSF") 
	or die("Direct access is not allowed");

include_once "Struct_Tree.php";
include_once "Struct_DocumentWatcherDB.php";
include_once "Struct_DocumentWatcher.php";

class Struct_Utils
{
	public static function getParents($iStructureId)
	{
		$St 		= new Struct_Tree(MSF_Registry::get("MSF_DB"));
		$aSel 		= $St->get(false);
		$aParsed 	= array();
		$aResult 	= array();
		
		for ($i = 0; $i < sizeof($aSel); $i++) {
			if ($iStructureId == $aSel[$i]["node_id"]) {
				$aParsed = explode(".", $aSel[$i]["path"]);
				break;
			}
		}
		
		for ($i = 0; $i < sizeof($aSel); $i++) {
			if (in_array($aSel[$i]["node_id"], $aParsed)) {
				$aResult[] = $aSel[$i];
			}
		}
		
		return $aResult;
	}
	
	public static function getRefValueId($iStructureId, $sType)
	{
		$sSql = "SELECT
					subject_id
				FROM
					structure
				WHERE
					node_id = " . $iStructureId . "
				AND
					type = '" . $sType . "'";
		
		$aRes = MSF_Registry::get("MSF_DB")->select($sSql, true);
		return isset($aRes["subject_id"]) ? $aRes["subject_id"] : 0;
	}
	
	public static function getPostsInSubdivision($iNodeId)
	{
		$oDb	= MSF_Registry::get("MSF_DB");
		$sSql 	= "SELECT path FROM structure WHERE node_id = " . $iNodeId;
		$sPath 	= $oDb->select($sSql, true, "path");
		$sSql 	= "SELECT
					node_id
				FROM
					structure
				WHERE
					path LIKE '" . $sPath . ".%'
				AND
					type = 'post'";
		$aOut	= array();
		foreach ((array) $oDb->select($sSql) AS $aBody) {
			$aOut[] = $aBody["node_id"];
		}
		
		return $aOut;
	}
	
	public static function isDocumentsExists($aIds)
	{
		$oDocs = new Struct_DocumentWatcher(
				new Struct_DocumentWatcherDB(MSF_Registry::get("MSF_DB"))
				);
		if ($oDocs->exists($aIds)) {
			return true;
		}
		else {
			return false;	
		}
		
	}
	
	public static function didReplaceAuthorDocs($iId, $iNewId, $aIds)
	{
		$oDocs = new Struct_DocumentWatcher(
				new Struct_DocumentWatcherDB(MSF_Registry::get("MSF_DB"))
				);
		if (!IS_REQUEST) {
			return false;
		}		
		else if ($iNewId == 0) {
			return false;
		}
		else if ($iId == $iNewId) {
			$this->addError($this->locale("STRUCTURE_DELETE_DOCS_EQUAL_ERROR"));
			return false;
		}
		else {
			$oDocs->save($aIds, $iNewId);
			return true;
		}

	}
	
}

?>