<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "system/security/MSF_ISecurityManager.php";
include_once "Struct_SecurityManagerDB.php";
include_once "system/security/MSF_SecurityMatrixNotSavedException.php";
include_once "modules/references/library/Reference/REF_Value.php";
include_once "modules/main/library/orgStructure/MSF_OrgStructureFacade.php";

class Struct_SecurityManager implements MSF_ISecurityManager
{
	private $sColDelimeter = "/^/col/^/";
	private $sRowDelimeter = "|^|row|^|";
	/**
	 * Enter description here...
	 *
	 * @var WF_FoldersSecurityManagerDB
	 */
	private $DB;
	
	/**
	 * Enter description here...
	 *
	 * @param MSF_DB $DB
	 * @param int $iId
	 * @return void
	 */
	public function __construct(MSF_DB $DB, $iId)
	{
		$this->DB = new Struct_SecurityManagerDB($DB);
	}
	
	/**
	 * Enter description here...
	 *
	 * @param array $aPost
	 * @return void
	 */
	public function edit($aPost)
	{
		try {
			$this->DB->delete();
			$iGroup		= 1;
			$RV			= new REF_Value();
			foreach($aPost as $aRow) {
				$RV->parse($aRow["structure"]);
				$aIds = $RV->getKeysList();
				
				foreach($aIds as $mId) {
					if (is_array($mId)) {
						$mId = $mId[0];
					}
					$aTmp = array(
						"structure_id"		=> $mId,
						"can_view"			=> $aRow["can_view"],
						"can_edit"			=> $aRow["can_edit"],
						"can_add_delete"	=> $aRow["can_add_delete"],
						"group_id"			=> $iGroup
					);
					
					$this->DB->save($aTmp);
				}

				$iGroup++;
			}
		}
		catch(MSF_DBException $e) {
			throw new MSF_SecurityMatrixNotSavedException($e->getMessage());
		}
		
	}
	
	/**
	 * Enter description here...
	 *
	 * @return array
	 */
	public function get()
	{
		$aData		=  $this->DB->get();
		$aTmpData	= array();
		$aReady		= array();
		foreach($aData as $aRow) {
			if(!isset($aTmpData[$aRow["group_id"]])) {
				$aTmpData[$aRow["group_id"]] = array(
					"structure"			=> array(),
					"can_view"			=> $aRow["can_view"],
					"can_edit"			=> $aRow["can_edit"],
					"can_add_delete"	=> $aRow["can_add_delete"]
				);
			}

			$aTmpData[$aRow["group_id"]]["structure"][] = $aRow["structure_id"];
		}
		
		//print_r($aTmpData);
		foreach($aTmpData as $aTmp) {
			$aTmp["structure"] = MSF_OrgStructureFacade::getInstance()->strIdsToRefValue($aTmp["structure"]);
			array_push($aReady, $aTmp);
		}
		
		return $aReady;
	}
	
}

?>