<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "system/security/MSF_Access.php";
include_once "Struct_SwitcherDB.php";

class Struct_Switcher extends MSF_Access
{
	private $DB 			= null;
	
	private $aAccessTypes 	= array(
		"view" 			=> "can_view",
		"edit" 			=> "can_edit",
		"add_delete" 	=> "can_add_delete"
	);
	
	protected function initialize()
	{
		$this->DB = new Struct_SwitcherDB($this->getDb());
	}
	
	protected function getAccessValue($sAccessType, $iStructureId, $aParams)
	{
		$iResult = self::INHERIT;
		
		if (!isset($this->aAccessTypes[$sAccessType])) {
			$iResult = self::DENY;
		}
		else {
			$aRights = $this->DB->select($iStructureId);
			
			if (count($aRights) > 0) {
				$iResult = $aRights[$this->aAccessTypes[$sAccessType]];
			}
		}
		
		return $iResult;
	}
}

?>