var StructurePlaceholder = Class.create();
StructurePlaceholder.prototype =
{
// sPlaceId, sInputName, bMultiselect, aDefault, sInputField
	initialize: function(aCfg)
	{
		this.aCfg 			= aCfg;
		//this.Container 		= new Element("nobr");
		//$(this.getConf("mPlace")).insert(this.Container);
		this.Container 		= $(this.getConf("mPlace"));
		this.sInputName 	= this.getConf("sInputName");
		this.bMulti 		= this.getConf("bMultiselect");
		//this.sInputField 	= (!this.getConf("sInputField")) ? ((this.bMulti) ? "input" : "input") : this.getConf("sInputField");
		this.sInputField 	= (!this.getConf("sInputField")) ? ((this.bMulti) ? "div" : "input") : this.getConf("sInputField");
		this.sSkin 			= sGlobalMsfSkin;
		this.sDefault 		= this.getConf("sDefaultValues");
		this.bReadOnly 		= (this.getConf("bReadOnly") != null) ? this.getConf("bReadOnly") : true;
		this.OnChange 		= this.getConf("OnChange");
		this.sStyle 		= this.getConf("sStyle");
		
		this.sRowDelimeter 	= '|^|row|^|';
		this.sColDelimeter 	= '/^/col/^/';
		
		this.Tree 			= null;
		this.Window 		= null;
		this.Input 			= null;
		this.Textarea 		= null;
		this.Loader 		= null;
		this.Button 		= null;
		this.AddButton 		= null;
		this.RemoveButton 	= null;
		this.Submit 		= null;
		this.Sortable 		= null;
		this.Fields 		= null;
		this.Hidden 		= null;
		this.Structure 		= new Element('div');
		this.Structure.addClassName("structure_mini_container");
		
		this.aElements 		= $A();
		
		this.buildArea();
	},
	
	getHidden: function()
	{
		return this.Hidden;
	},
	
	getConf: function(sKey)
	{
		return (this.aCfg[sKey] != null) ? this.aCfg[sKey] : null;
	},
	
	getParentWidth: function(Node)
	{
		var iWidth = -1;
		var Parent = Node.parentNode;
		
		if (Parent) {
			if (Parent.tagName == "TD") {
				if (Parent.width == "") {
					Parent.width = "339";
				}
				if (Parent.width > 0) {
					iWidth = Parent.width;
				}
				else {
					iWidth = this.getParentWidth(Parent);
				}
			}
			else if (Parent.tagName == "TABLE") {
				if (Parent.width > 0) {
					iWidth = Parent.width;
				}
			}
			else {
				iWidth = this.getParentWidth(Parent);
			}
		}
		
		return iWidth;
	},
	
	
	
	buildArea: function()
	{
		var me 		= this;
		var sText 	= "";
		var sStyle 	= "";
		
		if (this.sDefault) {
			var aRTmp 	= this.sDefault.split(this.sRowDelimeter);
			var aCTmp 	= null;
			var iLength = aRTmp.length;
			
			for (var i = 0; i < iLength; i++) {
				aCTmp = aRTmp[i].split(this.sColDelimeter);
				
				if (aCTmp[0]) {
					sText += aCTmp[0];
					
					if (i < iLength - 1) {
						sText += "\n";
					}
				}
			}
		}
		
		if (this.sInputField == "div") {
			this.Textarea = new Element("span");
			this.Textarea.addClassName("structure_mini_div_input");
			this.Container.addClassName("structure_mini_placer");
			
			if (this.sStyle) {
				this.Textarea.addClassName(this.sStyle);
			}
			else {
				var iWidth = this.getParentWidth(this.Container);
				if (iWidth != -1 && iWidth < 340) {
					this.Container.removeClassName("structure_mini_placer");
					this.Container.addClassName("structure_mini_placer_ie");
					sStyle = "structure_mini_div_input_default_ie";
					this.Container.style.width = iWidth + "px";
					this.Textarea.style.width = (iWidth - 40) + "px";
				}
				else {
					sStyle = "structure_mini_div_input_default";
				}
			}
		}
		else if (this.sInputField == "textarea") {
			var Nobr = new Element("nobr");
			this.Container.insert(Nobr);
			this.Container = Nobr;
			this.Textarea = new Element("textarea", {"readonly": "readonly"});
			sStyle = "structure_mini_textarea";
		}
		else {
			var Nobr = new Element("nobr");
			this.Container.insert(Nobr);
			this.Container = Nobr;
			this.Textarea = new Element("input", {"readonly": "readonly"});
			sStyle = "structure_mini_input";
		}
		
		if (this.sStyle) {
			this.Textarea.addClassName(this.sStyle);
		}
		else {
			this.Textarea.addClassName(sStyle);
		}
		
		this.Hidden 		= $(document.createElement("input"));
		this.Loader 		= $(document.createElement("img"));
		this.Hidden.type 	= "hidden";
		this.Hidden.name 	= this.sInputName;
		this.Hidden.value 	= this.sDefault;
		this.Textarea.value = sText;
		this.Loader.src 	= "/templates/" + this.sSkin + "/images/loader.gif";
		this.Loader.hide();
		
		this.Button 	= $(document.createElement("img"));
		this.Button.src = "/modules/structure/view/templates/" + this.sSkin + "/img/structure_icon.png";
		this.Button.addClassName("structure_mini_button");
		this.Button.onclick = this._buttonLoader();
		
		this.Container.appendChild(this.Textarea);
		this.Container.appendChild(this.Button);
		this.Container.appendChild(this.Loader);
		this.Container.appendChild(this.Hidden);
		
		if (this.sDefault) {
			this.buildWindow();
		}
	},
	
	_buttonLoader: function()
	{
		var me = this;
		
		return function() {
			me.buildWindow(true);
		}
	},
	
	buildWindow: function(bShow)
	{
		if (!this.Window) {
			this.loadStructure(bShow);
		}
		else {
			this.Window.show();
		}
	},
	
	refreshButton: function()
	{
		// Refresh
		var me = this;
		var Link = $(document.createElement("img"));
		Link.src = "/templates/" + this.sSkin + "/images/reload.png";
		Link.style.cursor = "pointer";
		Link.onclick = function()
		{
			for (var i = me.Sortable.childNodes.length - 1; i >= 0; i--) {
				me.Sortable.removeChild(me.Sortable.childNodes[i]);
			}
			for (var i = me.Structure.childNodes.length - 1; i >= 0; i--) {
				me.Structure.removeChild(me.Structure.childNodes[i]);
			}
			me.loadStructure(true, true);
			return false;
		}
		
		return Link;
	},
	
	buildContent: function()
	{
		var Table, Tr, Td, Input;
		var me = this;
		
		Table 	= $(document.createElement("table"));
		Tr 		= $(Table.insertRow(0));
		Td 		= $(Tr.insertCell(0));
		
		Td.appendChild(this.refreshButton(this.Structure));
		
		Tr = $(Table.insertRow(1));
		Td = $(Tr.insertCell(0));
		
		Td.appendChild(this.Structure);
		Table.addClassName("structure_mini_table");
		
		Tr = $(Table.insertRow(2));
		Td = $(Tr.insertCell(0));
		this.Submit = $(document.createElement("input"));
		this.Submit.type = "button";
		this.Submit.value = "OK";
		
		Td.appendChild(this.Submit);
		
		return Table;
	},
	
	buildMultiContent: function()
	{
		var Table, Tr, Td, Selected, Input, Sortable;
		var me = this;
		
		Table 	= $(document.createElement("table"));
		Tr 		= $(Table.insertRow(0));
		Td 		= $(Tr.insertCell(0));
		
		this.Sortable 		= $(document.createElement("div"));
		this.Sortable.id 	= "structure_sortable_id";
		this.Sortable.addClassName("structure_mini_selected");
		
		Td.appendChild(this.refreshButton(this.Structure));
		
		Tr = $(Table.insertRow(1));
		Td = $(Tr.insertCell(0));
		
		Td.appendChild(this.Structure);
		
		Td 						= $(Tr.insertCell(1));
		this.AddButton 			= $(document.createElement("img"));
		this.AddButton.src 		= "/templates/" + this.sSkin + "/images/arrow_right.png";
		this.AddButton.style.margin = "5px";
		this.AddButton.style.cursor = "pointer";
		Td.appendChild(this.AddButton);
		Td.appendChild(document.createElement("br"));
		this.RemoveButton 		= $(document.createElement("img"));
		this.RemoveButton.src 	= "/templates/" + this.sSkin + "/images/arrow_left.png";
		this.RemoveButton.style.margin = "5px";
		this.RemoveButton.style.cursor = "pointer";
		Td.appendChild(this.RemoveButton);
		Td = $(Tr.insertCell(2));
		Td.appendChild(this.Sortable);
		
		Table.addClassName("structure_mini_table");
		
		Tr = $(Table.insertRow(2));
		Td = $(Tr.insertCell(0));
		this.Submit = $(document.createElement("input"));
		this.Submit.type = "button";
		this.Submit.value = "OK";
		
		//Td.colspan = "3";
		Td.appendChild(this.Submit);
		
		return Table;
	},
	
	loadStructure: function(bShow, bRefresh)
	{
		var me = this;
		this.Loader.show();
		this.Button.onclick = null;
		
		var callback = function(resp)
		{
			var JSON 	= resp.responseText.evalJSON();
			var Columns = $H(JSON.structure.columns);
			var aPos 	= me.Button.cumulativeOffset();
			var iX 		= aPos[0];
			var iY 		= aPos[1];
			
			if (!me.Window) {
				me.Window = new MSF_Window();
				if (!bShow) {
					me.Window.hide();
				}
			}
			me.Window.setTitle(aGlobalMsfWords["STRUCTURE_WINDOW_TITLE"]);
			
			var Data 	= new Object();
			var sPost 	= "{\"id\": \"false\"";
			var sSub 	= "{\"id\": \"false\"";
			
			if (JSON.structure.denied) {
				/*
				var Body = me.Window.body();
				for (var i = Body.childNodes.length - 1; i >= 0; i--) {
					Body.removeChild(Body.childNodes[i]);
				}
				Body.insert(new Element('span').insert(JSON.structure.accessDenied));
				*/
				me.Window.appendToBody(new Element('span').insert(JSON.structure.accessDenied));
				me.Hidden.value = "";
				if (me.sInputField == "div") {
					me.Textarea.appendChild(document.createTextNode(JSON.structure.changeDenied));
				}
				else {
					me.Textarea.value = JSON.structure.changeDenied;
				}
			}
			else {
				Data.tree = new Array(JSON.structure.tree[0]);
				
				Columns.each(
					function(element)
					{
						if (element[0] == "post") {
							for (var i = 0; i < element[1].length; i++) {
								sPost += ", \"" + element[1][i].title + "\": " + ((element[1][i].visible == 1) ? "\"true\"" : "\"false\"");
							}
						}
						else if (element[0] == "subdivision") {
							for (var i = 0; i < element[1].length; i++) {
								sSub += ", \"" + element[1][i].title + "\": " + ((element[1][i].visible == 1) ? "\"true\"" : "\"false\"");
							}
						}
					}
				);
				
				sPost 	+= "}";
				sSub 	+= "}";
				
				var Sub 		= sSub.evalJSON();
				var Post 		= sPost.evalJSON();
				
				if (me.Tree) {
					delete(me.Tree);
				}
				
				me.Tree = new StructureTree({
					mPlace 			: me.Structure,
					aData 			: Data,
					aColumns 		: {
						post 		: Post,
						subdivision : Sub
					},
					sSkin 			: me.sSkin,
					bMultiselect 	: me.bMulti,
					aDefaultValues 	: me.parseDefault(me.sDefault),
					isWindow 		: true,
					bDisableSubdivs : me.getConf("bDisableSubdivs")
				});
				
				if (!bRefresh) {
					if (me.bMulti) {
						me.Window.appendToBody(me.buildMultiContent());
						me.AddButton.observe("click", function() {
							me.addToSortable(me.Tree.getSelected());
							if (me.bMulti) {
								me.Tree.clearSelected();
							}
						});
						me.RemoveButton.observe("click", function() {
							me.remove();
							if (me.bMulti) {
								me.Tree.clearSelected();
							}
						});
						me.Submit.observe("click", function() {
							me.getValues();
							me.Window.hide();
							if (me.bMulti) {
								me.Tree.clearSelected();
							}
						});
						
						if (me.sDefault) {
							var aSelected 	= me.Tree.getSelected();
							var aResult 	= new Array();
							
							me.parseDefault(me.sDefault).each(function(d) {
								aSelected.each(function(e) {
									if (d == e.data.node_id) {
										aResult.push(e);
									}
								});
							});

							me.addToSortable(aResult);
							me.getValues();
						}
					}
					else {
						me.Window.appendToBody(me.buildContent());
						if (me.sDefault) {
							me.getValue(me.Tree.getSelected());
						}
						
						me.Submit.observe("click", function() {
							me.getValue(me.Tree.getSelected());
							me.Window.hide();
							if (me.bMulti) {
								me.Tree.clearSelected();
							}
						});
					}
				}
				
				if (me.bMulti) {
					me.Tree.clearSelected();
				}
			}
			
			if (!bRefresh) {
				me.Window.moveTo(iX, iY);
			}
			me.Button.onclick = me._buttonLoader();
			me.Loader.hide();
			
			if (me.sDefault) {
				WindowHandler.onLoad();
			}
		}
		
		new Ajax.Request(
			"/structure/view/ajaxrequest",
			{
				method		: "post",
				onSuccess 	: callback
			}
		);
	},
	
	parseDefault: function(sDefault)
	{
		var aIds = new Array();
	
		if (sDefault) {
			var aValues = sDefault.split(this.sRowDelimeter);
			
			for (var i = 0; i < aValues.length; i++) {
				aIds[i] = aValues[i].split(this.sColDelimeter)[1];
			}
		}

		return aIds;
	},

	addToSortable: function(aSelected)
	{
		var Div, Checkbox, me = this, sText = "";
		$A(aSelected).each(
			function(e)
			{
				if(me.aElements.indexOf(e) == -1) {
					Div = $(document.createElement("div"));
					Div.addClassName("structure_mini_sortable_element");
					Checkbox 		= $(document.createElement("input"));
					Checkbox.type 	= "checkbox";
					Div.appendChild(Checkbox);
					
					if (e.secLabel && e.secLabel == "") {
						Div.appendChild(document.createTextNode(" " + e.label.strip()));
						Checkbox.value = e.data.node_id + me.sColDelimeter + e.data.subject_id;
					}
					else {
						if (e.secLabel) {
							if (me.getConf("bShowPosts") == false) {
								Div.appendChild(document.createTextNode(" " + e.secLabel.strip()));
							}
							else {
								Div.appendChild(document.createTextNode(" " + e.secLabel.strip() + " (" + e.label.strip() + ")"));
							}
						}
						else {
							Div.appendChild(document.createTextNode(" " + e.label.strip()));
						}
						if (e.data.type == "post") {
							Checkbox.value = e.data.node_id + me.sColDelimeter + ((e.data.employee_id) ? e.data.employee_id : 0) + me.sColDelimeter + e.data.subject_id;
						}
						else {
							Checkbox.value = e.data.node_id + me.sColDelimeter + e.data.subject_id;
						}
					}
					
					me.Sortable.appendChild(Div);
					me.aElements.push(e);
					e.div = Div;
					e.div.childNodes[0].observe("click", function() { me.select(this, e.div) });
				}
			}
		);
		
		Sortable.create(this.Sortable, {tag: "div"});
	},
	
	remove: function()
	{
		var me = this;
				
		this.aElements.each(
			function(e)
			{
				if(e.div.selected) {
					me.aElements = me.aElements.without(e);
					e.div.parentNode.removeChild(e.div);				
				}			
			}
		);
	},
	
	select: function(Checkbox, Div)
	{
		if(Checkbox.checked) {
			Div.addClassName("structure_mini_sortable_selected");
			Div.selected = true;
		}
		else {
			Div.removeClassName("structure_mini_sortable_selected");
			Div.selected = false;
		}
	},
	
	getValues: function()
	{
		this.addToSortable(this.Tree.getSelected());
		this.Hidden.value = "";
		
		var Tmp;//, sText = "";
		var aText = [];
		var aDivs = this.Sortable.getElementsByTagName("div");
		for (var i = 0; i < aDivs.length; i++) {
			Tmp 	= $(aDivs[i]);
			//sText 	+= Tmp.childNodes[1].nodeValue.strip() + ", ";
			aText.push(Tmp.childNodes[1].nodeValue.strip());
			
			this.Hidden.value += Tmp.childNodes[1].nodeValue.strip() + this.sColDelimeter + Tmp.childNodes[0].value + this.sRowDelimeter;
		}
		
		this.Hidden.value = this.Hidden.value.substring(0, this.Hidden.value.length - this.sRowDelimeter.length);
		//sText = sText.substring(0, sText.length - 2);
		
		if (this.sInputField == "div") {
			this._clearInputs();
			for (var i = 0; i < aText.length; i++) {
				this.Textarea.appendChild(document.createTextNode(aText[i]));
				if (i < aText.length) {
					this.Textarea.appendChild(new Element('br'));
				}
			}
			//this.Textarea.appendChild(document.createTextNode(sText));
		}
		else {
			this.Textarea.value = "";
			for (var i = 0; i < aText.length; i++) {
				this.Textarea.value += aText[i] + "\n";
			}
			this.Textarea.value = this.Textarea.value.substring(0, this.Textarea.value.length - 1);
			//this.Textarea.value = sText;
		}
		
		if (this.OnChange) {
			this.OnChange(this.Hidden);
		}
	},
	
	_clearInputs: function()
	{
		for (var i = this.Textarea.childNodes.length - 1; i >= 0; i--) {
			this.Textarea.removeChild(this.Textarea.childNodes[i]);
		}
	},
	
	size: function()
	{
		return this.Sortable.getElementsByTagName("div").length;
	},
	
	getValue: function(aSelected)
	{
		var sText = "";
		var me = this;
		
		aSelected.each(function(e) {
			if (!e.label) {
				me.Hidden.value 	= "";
				me.Textarea.value 	= "";
			}
			else {
				if (e.secLabel && e.secLabel != "") {
					if (me.getConf("bShowPosts") == false) {
						sText = e.secLabel.strip();
					}
					else {
						sText = e.secLabel.strip() + " (" + e.label.strip() + ")";
					}
				}
				else {
					sText = e.label.strip();
				}
				
				me.Hidden.value 	= sText.strip() + me.sColDelimeter + e.data.node_id + me.sColDelimeter + ((e.data.employee_id) ? e.data.employee_id : 0) + me.sColDelimeter + e.data.subject_id;
				me.Textarea.value 	= sText.strip();
			}
		});
		
		if (this.OnChange) {
			this.OnChange(this.Hidden);
		}
	},
	
	destroy: function()
	{
		if (this.Container) {
			for (var i = this.Container.childNodes.length - 1; i >= 0; i--) {
				this.Container.removeChild(this.Container.childNodes[i]);
			}
		}
	}
}