var StructureTree = Class.create();
StructureTree.prototype =
{
// sPlaceId, aData, Columns, sSkin, bEdit, bMultiselect, aDefaultValues, aWords, aModules
	initialize: function(aCfg)
	{
		this.aCfg 		= aCfg;
		this.aTopBtns 	= this.getCfg("aButtons");
		this.sSkin 		= this.getCfg("sSkin");
		this.aData 		= this.getCfg("aData");
		this.aColumns 	= this.getCfg("aColumns", new Array());
		this.Container 	= $(this.getCfg("mPlace"));
		this.aDefault 	= this.getCfg("aDefaultValues");
		this.imgPath 	= "/templates/" + sGlobalMsfSkin + "/images";
		this.aNodes 	= new Array();
		this.nodeCount 	= 1;
		this.Root 		= new StructureTreeNode(0, null);
		this.aWindows 	= new Array();
		this.aAccess 	= new Array();
		this.aSelected 	= new Array();
		this.aButtons 	= new Array();
		this.OneClick	= false;
		
		this.buildTree();
	},
	
	getCfg: function(sKey, mDefault)
	{
		if (!mDefault) {
			mDefault = null;
		}
		
		return (this.aCfg[sKey] != null) ? this.aCfg[sKey] : mDefault;
	},

	buildTree: function()
	{
		this.iConfig = this.getCfg("aData")["iConfig"];
		this.fillNodes(this.getCfg("aData")["tree"], this.Root, 0);
		this.drawButtons();
		this.drawTree();
	},
	
	fillNodes: function(data, parentNode, level)
	{
		var Node;
		var me 		= this;
		var bHas 	= false;

		data.each(function(el) {
			Node 		= new StructureTreeNode(me.nodeCount, parentNode);
			Node.level 	= level;
			Node.data 	= el;
			me.aNodes.push(Node);
			me.modeCount++;

			if (el.value) {
				if (el.type == "post") {
					//Node.label 		= " " + el.value;
					Node.label 		= el.value;
					Node.secLabel 	= el.employee;
				}
				else {
					Node.label = " " + el.value;
				}
			}
			else {
				if (el.type == "post") {
					Node.label = aGlobalMsfWords["STRUCTURE_EMPLOYEE_EMPTY"];
				}
				else {
					Node.label = aGlobalMsfWords["STRUCTURE_SUBDIV_EMPTY"];
				}
			}
			
			if(el.type == "subdivision") {
				Node.style = "icon-section";
				
				if (me.getCfg("bMultiselect") && !me.getCfg("bDisableSubdivs")) {
					Node.style += " icon-section-can-select";
				}
				
				if (el.nodes) {
					el.nodes.each(
						function(el2)
						{
							if (el2.type == "post") {
								//if (el2.employee_id == el.employee_id) {
								if ((el2.subject_id == el.employee_id) && (el2.employee !== "")) {
									el2.isBoss = true;
								}
							}
						}
					);
				}
			}
			else {
				if(el.value) {
					//if (el.employee_id == iBossId) {
					if (el.isBoss) {
						Node.style = "icon-boss";
					}
					else {
						Node.style = "icon-user";
					}
				}
				else {
					Node.isEmpty = true;
					Node.style = "icon-user-disabled";
				}
			}
			
			if (parentNode) {
				parentNode.childNodes[parentNode.childNodes.size()] = Node;
			}
			if (el.nodes) {
				me.fillNodes(el.nodes, Node, level + 1);
			}
		});
	},
	
	drawButtons: function()
	{
		if (this.aTopBtns) {
			$(this.aTopBtns[0]).observe("click", this.expandAll.bind(null, this.aNodes, this));
			$(this.aTopBtns[1]).observe("click", this.collapseAll.bind(null, this.aNodes, this));
		}
		else {
			var Input, Div;
	
			Div = $(document.createElement("div"));
			Input = $(document.createElement("input"));
			Input.type = "button";
			Input.value = aGlobalMsfWords["STRUCTURE_EXPAND_BUTTON"];
			Event.observe(Input, "click", this.expandAll.bind(null, this.aNodes, this));
			Div.appendChild(Input);
	
			Input = $(document.createElement("input"));
			Input.type = "button";
			Input.value = aGlobalMsfWords["STRUCTURE_COLLAPSE_BUTTON"];
			Event.observe(Input, "click", this.collapseAll.bind(null, this.aNodes, this));
			Div.appendChild(Input);
	
			this.Container.appendChild(Div);
		}
	},

	drawTree: function()
	{
		var nodes 			= this.aNodes;
		var me 				= this;
		var currentDivId	= 0;
		var lastNodes		= new Array();
		lastNodes[0]		= false;
		var drawNodes = function(Container, nodes, isLast)
		{
			nodes.each(
				function(node)
				{
					var i;
					var position = (node.parentNode.Id == 0) ? "first" : node.getPosition();
					var hasChild = node.hasChild();					
					var Table = $(document.createElement("table"));
					Table.cellSpacing = "0";
					Table.cellPadding = "0";
					Container.appendChild(Table);

					var Tr = Table.insertRow(Table.rows.length);
					Tr.style.cursor = 'pointer';
					
					if(position == "last" || position == "first") {
						lastNodes[node.level] = true;
					}
					else {
						lastNodes[node.level] = false;
					}

					for(i = 0; i < node.level; i++) {
						var Td = $(Tr.insertCell(i));
						if(lastNodes[i]) {
							Td.addClassName("empty");
						}
						else {
							Td.addClassName("vline");
						}
					}

					var iconTd = $(Tr.insertCell(i++));

					if(position == "first") {
						if(hasChild) {
							iconTd.addClassName("first_open_out");
						}
						else {
							iconTd.addClassName("middle_empty");
						}
					}
					else if(position == "middle") {
						if(hasChild) {
							iconTd.addClassName("middle_open_out");
						}
						else {
							iconTd.addClassName("middle_empty");
						}
					}
					else {
						if(hasChild) {
							iconTd.addClassName("last_open_out");
						}
						else {
							iconTd.addClassName("last_empty");
						}
					}

					if(me.getCfg("bEdit") && me.iConfig != 50) {
						me.addEditButtons(Tr, node, i, currentDivId);
						i++;
					}

					Td = $(Tr.insertCell(i++));
					
			// links from structure to references {

					var iRefId = 0;
					if (node.data.type == "subdivision") {
						iRefId = 4;
					}
					else {
						iRefId = 3;
					}
					
					if (!me.getCfg("isWindow")) {
	
							
							//Link.href 	= "/references/viewrow/" + iRefId + "/" + node.data.subject_id;
							//if (node.secLabel && node.secLabel.strip() != "") {
							if (node.style !== "icon-section") {
								var Link 	= $(document.createElement("a", {style:"font-size:10pt;"}));
								Link.insert(node.label.strip() + " (" + node.secLabel.strip() +")");
								Event.observe(Link, "click", me.showWindow.bind(null, me, Math.random(), Td, "post", node.data, false));
							}
							else {
								//Td.style.backgroundColor = "#F5F5F5";
								Td.style.border 		= "1px solid #FFF";
								Td.style.padding 		= "5px";
								Td.style.paddingLeft 	= "0px";
								Td.style.paddingBottom	= "0px";
								var Link 	= new Element("A", {style:"cursor:pointer;font-weight:bold;color:#333333;"});
								if (node.label) {
									Link.insert(node.label.strip());
								}
								else if (node.secLabel) {
									Link.insert(node.secLabel.strip());
								}
								else {
									Link.insert("error");
								}
								
								Event.observe(Link, "click", me.showWindow.bind(null, me, Math.random(), Td, "subdivision", node.data, false));
							}							
							
							Td.appendChild(Link);

					}
					else {
						Td.insert(node.label.strip());
						if (node.secLabel && node.secLabel.strip() != "") {
							Td.appendChild(document.createTextNode(" (" + node.secLabel.strip() + ")"));
						}
					}
			// } links from structure to references
					
					
					Td.addClassName(node.style);
					node.labelContainer = Td;
					
					if (me.getCfg("isWindow")) {
						if (me.aDefault) {
							if (me.getCfg("bMultiselect")) {
								me.aDefault.each(
									function(element)
									{
										if (element == node.data.node_id) {
											me.aSelected.push(node);
											Td.addClassName("markedCell");
										}
									}
								);
							}
							else {
								if (me.aDefault[0] == node.data.node_id) {
									node.checked = true;
									me.aSelected[0] = node;
									Td.addClassName("markedCell");
								}
							}
						}
	
						Td.onclick = function()
						{
							if (me.getCfg("bSubdivisions")) {
								if (node.data.type == "subdivision") {
									var aTds = document.getElementsByClassName("markedCell");
									
									for (var x = 0; x < aTds.length; x++) {
										aTds[x].removeClassName("markedCell");
									}
									
									this.addClassName("markedCell");
									me.aSelected[0] = node;
								}
							}
							else if (!me.getCfg("bMultiselect")) {
								if (node.data.type != "subdivision") {
									var aTds = document.getElementsByClassName("markedCell");
									
									for (var x = 0; x < aTds.length; x++) {
										aTds[x].removeClassName("markedCell");
									}
									
									if (node.checked) {
										node.checked = false;
										this.removeClassName("markedCell");
										me.aSelected[0] = {};
									}
									else {
										node.checked = true;
										this.addClassName("markedCell");
										me.aSelected[0] = node;
									}
								}
							}
							else {
								if (me.getCfg("bDisableSubdivs") && node.data.type == "subdivision") {
								}
								else {
									if (node.checked) {
										node.checked = false;
										this.removeClassName("markedCell");
										nodes.each(function(cNode) {
											if (cNode.data.node_id == node.data.node_id) {
												me.aSelected = me.aSelected.without(cNode);
											}
										});
									}
									else {
										node.checked = true;
										this.addClassName("markedCell");
										me.aSelected.push(node);
									}
								}
							}
						}
					}

					if(node.hasChild()) {
						var Div = $(document.createElement("div"));
						Div.align = "left";
						Div.id = "branch_" + currentDivId++;
						Div.addClassName("branch");
						Container.appendChild(Div);
						node.childContainer = Div;
						node.iconTd = iconTd;
						node.isOpen = (me.getCookie(node.data.node_id) == 'false') ? false : true;
						
						me.toggleSavedBranch(node, me);
						Event.observe(iconTd, "click", me.toggleBranch.bind(null, node, me));
						Event.observe(iconTd, "mouseover", me.nodeMouseOver.bind(null, iconTd, node));
						Event.observe(iconTd, "mouseout", me.nodeMouseOut.bind(null, iconTd, node));
						drawNodes(Div, node.childNodes, isLast);
					}

				}
			);
		}

		var Div = $(document.createElement("div"));
		Div.addClassName("branch");
		this.Container.appendChild(Div);
		drawNodes(Div, this.Root.childNodes, false);
	},
	
	getSelected: function()
	{
		return this.aSelected;
	},
	
	clearSelected: function()
	{
		this.aSelected = new Array();
		
		var aTds = this.Container.getElementsByTagName('td');
		
		for (var i = 0; i < aTds.length; i++) {
			aTds[i].removeClassName('markedCell');
		}
		
		var nodes = function(node) {
			node.each(function(e) {
				e.checked = false;
				if (e.hasChild()) {
					nodes(e.childNodes);
				}
			});
		}
		
		nodes(this.aNodes);
	},

	addEditButtons: function(Tr, node, i, iId)
	{
		var Img, Td, Div, me, Body;
		
		Body 	= $$('html')[0];
		me 		= this;
		Div 	= $(document.createElement('div'));
		Td 		= Tr.insertCell(i);
		Img 	= $(document.createElement('img'));
		Img.src = '/library/MSF_Recordset/resources/default/img/rs-context-active.png';
		Img.addClassName('context_menu_button');
		//Div.addClassName('context_menu');
		Div.addClassName('rs-cell-context-options');
		//Div.style.width = '210px';
		Div.hide();
		Td.appendChild(Img);
		Td.appendChild(Div);
		this.addAllEditButtons(Div, node, i, iId);
		this.aButtons.push(Div);
		
		new RS_ContextMenu(Img, Div);		
	},
	
	hideButtons: function()
	{
		for (var i = 0; i < this.aButtons.length; i++) {
			this.aButtons[i].hide();
		}
	},

	addAllEditButtons: function(Container, node, i, iId)
	{
		var Img, url, sRandom, TdImg;

		var currentIndex	= node.parentNode.childNodes.indexOf(node);
		var parentSize		= node.parentNode.childNodes.size();
		window.editable 	= false;
		//add sub
		if (this.iConfig == 125 || this.iConfig == 100) {
			if(node.data.type == "subdivision") {
				//TdImg				= $(document.createElement('div'));
				TdImg	= new Element("a");
				TdImg.addClassName("rs-cell-context-option-open");
				
				Img 				= document.createElement("img");
				sRandom 			= Math.random();
				Img.style.cursor 	= "pointer";
				Img.src 			= "/modules/structure/view/templates/" + this.sSkin + "/img/section_add.gif";
				Img.id 				= "add_sub_" + sRandom;
				Event.observe(TdImg, "click", this.showWindow.bind(null, this, sRandom, Img.id, "subdivision", node.data, true));
				TdImg.appendChild(Img);
				TdImg.appendChild(document.createTextNode(' ' + aGlobalMsfWords['STRUCTURE_MENU_ADD_SUBDIVISION']));
				Container.appendChild(TdImg);
			}

			//add post
			if(node.data.type == "subdivision") {
				//TdImg				= $(document.createElement('div'));
				TdImg	= new Element("a");
				TdImg.addClassName("rs-cell-context-option-open");
				Img 				= document.createElement("img");
				sRandom 			= Math.random();
				Img.style.cursor 	= "pointer";
				Img.src 			= "/modules/structure/view/templates/" + this.sSkin + "/img/user_add.gif";
				Img.id 				= "add_post_" + sRandom;
				Event.observe(TdImg, "click", this.showWindow.bind(null, this, sRandom, Img.id, "post", node.data, true));
				TdImg.appendChild(Img);
				TdImg.appendChild(document.createTextNode(' ' + aGlobalMsfWords['STRUCTURE_MENU_ADD_POST']));
				Container.appendChild(TdImg);
			}
		}

		if (this.iConfig == 100 || this.iConfig == 150) {
			//edit
			//TdImg				= $(document.createElement('div'));
			/*
			TdImg	= new Element("a", {"class" : "rs-cell-context-option-open"});
			sRandom 			= Math.random();
			Img					= document.createElement("img");
			Img.src				= this.imgPath + "/folder_page_white.png";
			Img.style.cursor 	= "pointer";
			Img.id 				= "edit_post_" + sRandom;
			Event.observe(TdImg, "click", this.showWindow.bind(null, this, sRandom, Img.id, node.data.type, node.data, false));
			TdImg.appendChild(Img);
			TdImg.appendChild(document.createTextNode(aGlobalMsfWords['STRUCTURE_MENU_OPEN']));
			Container.appendChild(TdImg);
			*/
			window.editable = true;
			
			
			//move begin
			if(parentSize > 1 && currentIndex > 1) {
				//TdImg 				= $(document.createElement('div'));
				TdImg	= new Element("a");
				TdImg.addClassName("rs-cell-context-option-open");
				Img					= document.createElement("img");
				url					= "/structure/moveBegin/" + node.data.node_id + "/" + node.parentNode.childNodes[0].data.node_id;
				Img.src 			= this.imgPath + "/arrow_top_alter2.png";
				Img.style.cursor 	= "pointer";
				Event.observe(TdImg, "click", this.confirm.bind(null, url, false));
				TdImg.appendChild(Img);
				TdImg.appendChild(document.createTextNode(' ' + aGlobalMsfWords['STRUCTURE_MENU_MOVE_BEGIN']));
				Container.appendChild(TdImg);
			}
			
	
			//move up
			if(parentSize > 1 && currentIndex != 0) {
				//TdImg 				= $(document.createElement('div'));
				TdImg	= new Element("a");
				TdImg.addClassName("rs-cell-context-option-open");
				Img					= document.createElement("img");
				url					= "/structure/move/" + node.data.node_id + "/" + node.parentNode.childNodes[(currentIndex - 1)].data.node_id;
				Img.src 			= this.imgPath + "/arrow_up_alter.png";
				Img.style.cursor 	= "pointer";
				Event.observe(TdImg, "click", this.confirm.bind(null, url, false));
				TdImg.appendChild(Img);
				TdImg.appendChild(document.createTextNode(' ' + aGlobalMsfWords['STRUCTURE_MENU_MOVE_UP']));
				Container.appendChild(TdImg);
			}
			
			
			//move down
			if(parentSize > 1 && (currentIndex+1) < parentSize) {
				bHas 				= true;
				//TdImg				= $(document.createElement('div'));
				TdImg	= new Element("a");
				TdImg.addClassName("rs-cell-context-option-open");
				Img 				= document.createElement("img");
				url					= "/structure/move/" + node.data.node_id + "/" + node.parentNode.childNodes[(currentIndex + 1)].data.node_id;
				Img.src 			= this.imgPath + "/arrow_down_alter.png";
				Img.style.cursor 	= "pointer";
				Event.observe(TdImg, "click", this.confirm.bind(null, url, false));
				TdImg.appendChild(Img);
				TdImg.appendChild(document.createTextNode(' ' + aGlobalMsfWords['STRUCTURE_MENU_MOVE_DOWN']));
				Container.appendChild(TdImg);
			}
			
			
			//move end
			if(parentSize > 1 && (currentIndex+2)< parentSize) {
				bHas 				= true;
				//TdImg				= $(document.createElement('div'));
				TdImg	= new Element("a");
				TdImg.addClassName("rs-cell-context-option-open");
				Img 				= document.createElement("img");
				url					= "/structure/moveEnd/" + node.data.node_id + "/" + node.parentNode.childNodes[(parentSize - 1)].data.node_id;
				Img.src 			= this.imgPath + "/arrow_down_alter2.png";
				Img.style.cursor 	= "pointer";
				Event.observe(TdImg, "click", this.confirm.bind(null, url, false));
				TdImg.appendChild(Img);
				TdImg.appendChild(document.createTextNode(' ' + aGlobalMsfWords['STRUCTURE_MENU_MOVE_END']));
				Container.appendChild(TdImg);
			}
			
		}

		if (iId > 0 && (this.iConfig == 100 || this.iConfig == 125)) {
			//delete
			//TdImg					= $(document.createElement('div'));
			TdImg					= new Element("a");
			TdImg.addClassName("rs-cell-context-option-open");
			url						= "/structure/remove/" + node.data.type + "/" + node.data.node_id;
			Img						= document.createElement("img");
			Img.src					= this.imgPath + "/red_cross.png";
			Img.style.cursor 		= "pointer";
			Event.observe(TdImg, "click", this.confirm.bind(null, url, true, aGlobalMsfWords["STRUCTURE_DELETE_MESSAGE"]));
			TdImg.appendChild(Img);
			TdImg.appendChild(document.createTextNode(' ' + aGlobalMsfWords['STRUCTURE_MENU_DELETE']));
			Container.appendChild(TdImg);
		}
	},
	
	confirm: function(url, conf, message)
	{
		if (!this.OneClick) {
			if (conf) {
				if(confirm(message)) {
					window.location.href = url;
					this.OneClick = true;
				}
			}
			else {
				window.location.href = url;
				this.OneClick = true;
			}
		}
	},

	showWindow: function(me, i, container, type, data, bNew)
	{
		var aPos = Position.cumulativeOffset($(container));
		
		MSFW.Window.Manager.closeAll();

		if (!MSFW.Window.Manager.get(i)) {
			//var win 	= new MSF_Window();
			var win 	= new MSFW.Window();
			var Body 	= new Element("div", {style: "text-align: left; padding:3pt"});
			var Form 	= $(document.createElement("form"));
			var Input 	= document.createElement("input");
			var Content = new StructurePostWindowContent(
				i,
				me.aColumns,
				{
					aRefs: 	(me.getCfg("aReferences")[data.node_id]) ? me.getCfg("aReferences")[data.node_id] : new Object(),
					aFolds: (me.getCfg("aWfFolders")[data.node_id]) ? me.getCfg("aWfFolders")[data.node_id] : new Object(),
					aDocs: 	(me.getCfg("aWfDoctypes")[data.node_id]) ? me.getCfg("aWfDoctypes")[data.node_id] : new Object()
				},
				data,
				type,
				bNew
			);

			if (bNew) {
				sAction	= "add";
			}
			else {
				sAction = "edit";
			}
			
			Form.method = "post";
			Form.action = "/structure/" + sAction + "/" + type + "/" + data.node_id;
			//Input.type 	= "submit";
			//Input.value = aGlobalMsfWords["STRUCTURE_BTN_SAVE"];
			
			win.moveTo(aPos[0], aPos[1]);
			Body.insert(Form);
			win.appendToBody(Body);
			
			var sTitle = data.value;
			
			if (data.type == "post" && data.employee) {
				sTitle = data.value + " (" + data.employee + ")";
			}
			
			win.setTitle(sTitle);
			Content.set(Form);
			//Form.appendChild(Input);
			
			//Input = new Element("input", {type: "button", value: aGlobalMsfWords["STRUCTURE_BTN_CANSEL"]});
			//Input.onclick = function() {win.hide()};
			//Form.appendChild(Input);
			
			MSFW.Window.Manager.add(win, i);
		}
		else {
			MSFW.Window.Manager.get(i).moveTo(aPos[0], aPos[1]);
			MSFW.Window.Manager.get(i).show();
		}
	},

	toggleBranch: function(node, me)
	{position = (node.parentNode.Id == 0) ? "first" : node.getPosition();
		if(position == "first") {
			sOpenOutClass 	= "first_open_out";
			sOpenOverClass	= "first_open_over";
			sCloseOutClass	= "first_close_out";
			sCloseOverClass	= "first_close_over";
		}
		else if(position == "middle") {
			sOpenOutClass 	= "middle_open_out";
			sOpenOverClass	= "middle_open_over";
			sCloseOutClass	= "middle_close_out";
			sCloseOverClass	= "middle_close_over";
		}
		else {
			sOpenOutClass 	= "last_open_out";
			sOpenOverClass	= "last_open_over";
			sCloseOutClass	= "last_close_out";
			sCloseOverClass = "last_close_over";
		}
		
		if(node.isOpen) {
			node.iconTd.removeClassName(sOpenOutClass);
			node.iconTd.removeClassName(sOpenOverClass);
			node.iconTd.addClassName(sCloseOutClass);
			node.isOpen = false;
		}
		else {
			node.iconTd.removeClassName(sCloseOutClass);
			node.iconTd.removeClassName(sCloseOverClass);
			node.iconTd.addClassName(sOpenOutClass);
			node.isOpen = true;
		}
		
		if(node.isOpen) {
			MSF_Effect.show(node.childContainer);
		}
		else {
			MSF_Effect.hide(node.childContainer);
		}
		//node.childContainer.toggle();
		
		if (node.data && node.data.node_id) {
			me.setCookie(node.data.node_id, node.isOpen);
		}
	},
	
	toggleSavedBranch: function(node, me)
	{
		position = (node.parentNode.Id == 0) ? "first" : node.getPosition();
		if(position == "first") {
			sOpenOutClass 	= "first_open_out";
			sOpenOverClass	= "first_open_over";
			sCloseOutClass	= "first_close_out";
			sCloseOverClass	= "first_close_over";
		}
		else if(position == "middle") {
			sOpenOutClass 	= "middle_open_out";
			sOpenOverClass	= "middle_open_over";
			sCloseOutClass	= "middle_close_out";
			sCloseOverClass	= "middle_close_over";
		}
		else {
			sOpenOutClass 	= "last_open_out";
			sOpenOverClass	= "last_open_over";
			sCloseOutClass	= "last_close_out";
			sCloseOverClass = "last_close_over";
		}
		
		if(node.isOpen) {
			node.iconTd.removeClassName(sCloseOutClass);
			node.iconTd.removeClassName(sCloseOverClass);
			node.iconTd.addClassName(sOpenOutClass);
			node.childContainer.show();
		}
		else {
			node.iconTd.removeClassName(sOpenOutClass);
			node.iconTd.removeClassName(sOpenOverClass);
			node.iconTd.addClassName(sCloseOutClass);
			node.childContainer.hide();
		}
	},

	nodeMouseOver: function(td, node)
	{
		position = (node.parentNode.Id == 0) ? "first" : node.getPosition();
		if(position == "first") {
			sOpenOutClass 	= "first_open_out";
			sOpenOverClass	= "first_open_over";
			sCloseOutClass	= "first_close_out";
			sCloseOverClass	= "first_close_over";
		}
		else if(position == "middle") {
			sOpenOutClass 	= "middle_open_out";
			sOpenOverClass	= "middle_open_over";
			sCloseOutClass	= "middle_close_out";
			sCloseOverClass	= "middle_close_over";
		}
		else {
			sOpenOutClass 	= "last_open_out";
			sOpenOverClass	= "last_open_over";
			sCloseOutClass	= "last_close_out";
			sCloseOverClass = "last_close_over";
		}
		
		if(node.isOpen) {
			td.removeClassName(sOpenOutClass);
			td.addClassName(sOpenOverClass);

		}
		else {
			td.removeClassName(sCloseOutClass);
			td.addClassName(sCloseOverClass);
		}
	},

	nodeMouseOut: function(td, node)
	{
		position = (node.parentNode.Id == 0) ? "first" : node.getPosition();
		if(position == "first") {
			sOpenOutClass 	= "first_open_out";
			sOpenOverClass	= "first_open_over";
			sCloseOutClass	= "first_close_out";
			sCloseOverClass	= "first_close_over";
		}
		else if(position == "middle") {
			sOpenOutClass 	= "middle_open_out";
			sOpenOverClass	= "middle_open_over";
			sCloseOutClass	= "middle_close_out";
			sCloseOverClass	= "middle_close_over";
		}
		else {
			sOpenOutClass 	= "last_open_out";
			sOpenOverClass	= "last_open_over";
			sCloseOutClass	= "last_close_out";
			sCloseOverClass = "last_close_over";
		}
		
		if(node.isOpen) {
			td.removeClassName(sOpenOverClass);
			td.addClassName(sOpenOutClass);
		}
		else {
			td.removeClassName(sCloseOverClass);
			td.addClassName(sCloseOutClass);
		}
	},

	collapseAll: function(nodes, me)
	{
		nodes.each(
			function(e)
			{
				if(e && e.hasChild()) {
					position = (e.parentNode.Id == 0) ? "first" : e.getPosition();
					if(position == "first") {
						sOpenOutClass 	= "first_open_out";
						sOpenOverClass	= "first_open_over";
						sCloseOutClass	= "first_close_out";
					}
					else if(position == "middle") {
						sOpenOutClass 	= "middle_open_out";
						sOpenOverClass	= "middle_open_over";
						sCloseOutClass	= "middle_close_out";						
					}
					else {
						sOpenOutClass 	= "last_open_out";
						sOpenOverClass	= "last_open_over";
						sCloseOutClass	= "last_close_out";						
					}
					
					
					e.iconTd.removeClassName(sOpenOutClass);
					e.iconTd.removeClassName(sOpenOverClass);
					e.iconTd.addClassName(sCloseOutClass);
					/*if(e.isOpen) {
						MSF_Effect.hide(e.childContainer);
					}*/
					
					e.isOpen = false;
					e.childContainer.hide();					
					me.setCookie(e.data.node_id, e.isOpen);
				}
			}
		);
	},

	expandAll: function(nodes, me)
	{
		nodes.each(
			function(e)
			{
				if(e && e.hasChild()) {
					position = (e.parentNode.Id == 0) ? "first" : e.getPosition();
					if(position == "first") {
						sOpenOutClass 	= "first_open_out";						
						sCloseOutClass	= "first_close_out";
						sCloseOverClass	= "first_close_over";
					}
					else if(position == "middle") {
						sOpenOutClass 	= "middle_open_out";						
						sCloseOutClass	= "middle_close_out";
						sCloseOverClass	= "middle_close_over";						
					}
					else {
						sOpenOutClass 	= "last_open_out";						
						sCloseOutClass	= "last_close_out";
						sCloseOverClass = "last_close_over";						
					}
					
					e.iconTd.removeClassName(sCloseOutClass);
					e.iconTd.removeClassName(sCloseOverClass);
					e.iconTd.addClassName(sOpenOutClass);
					/*if(!e.isOpen) {
						MSF_Effect.show(e.childContainer);
					}*/
					
					e.isOpen = true;
					e.childContainer.show();					
					me.setCookie(e.data.node_id, e.isOpen);
				}
			}
		);
	},
	
	setCookie: function(name, value, expires, path, domain, secure)
	{
		document.cookie = name + "=" + escape(value) +
        ((expires) ? "; expires=" + expires : "; Mon, 05-Jan-2015 00:00:00 GMT") +
        ((path) ? "; path=" + path : "; /") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
	},
	
	getCookie: function(name)
	{
		var cookie = " " + document.cookie;
		var search = " " + name + "=";
		var setStr = null;
		var offset = 0;
		var end = 0;
		if (cookie.length > 0) {
			offset = cookie.indexOf(search);
			if (offset != -1) {
				offset += search.length;
				end = cookie.indexOf(";", offset)
				if (end == -1) {
					end = cookie.length;
				}
				setStr = unescape(cookie.substring(offset, end));
			}
		}
		
		return setStr;
	}
}