<?xml version='1.0'?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

<xsl:template match="/page/module">
	<b><xsl:value-of select="$STRUCTURE_DOCS_NOTIFY_MESSAGE"/></b>
	<br/><br/>
	<form method="post">
		<div id="structure"></div>
		<script>
			var aColumns = {
				subdivision: {"id":false,<xsl:for-each select="config/subdivision/column">
					<xsl:value-of select="@value"/>
				</xsl:for-each>},
				post: {"id":false,<xsl:for-each select="config/post/column">
					<xsl:value-of select="@value"/>
				</xsl:for-each>}
			};

			var Structure = new StructureTree({
				mPlace 			: 'structure',
				aData 			: eval(<xsl:value-of select="structure/@json"/>),
				sSkin 			: '<xsl:value-of select="structure/@skin"/>', 
				bEdit 			: false,
				aColumns 		: aColumns,
				isWindow 		: true,
				bSubdivisions 	: false,
				aModules 		: eval(<xsl:value-of select="modules/@json"/>),
				aReferences		: eval(<xsl:value-of select="references/@json"/>)
			});
			
			function isEmpty()
			{
				var aResult = Structure.getSelected();
				var bReturn = true;
				
				if ((aResult.length == 0) || (!aResult[0].Id)) {
					alert('<xsl:value-of select="$STRUCTURE_DELETE_DOCS_ALERT_MESSAGE"/>');
					bReturn = false;
				}
				else {
					$("structure").insert(
						new Element(
							"input",
							{
								"type" 	: "hidden",
								"name" 	: "structure_id",
								"value" : aResult[0].data.node_id
							}
						)
					);
				}
				
				return bReturn;
			}
		</script>
		<div>
			<input type="submit" value="{$LABEL_OK}" onclick="return isEmpty()"/> 
			<input type="button" value="{$LABEL_CANCEL}" onclick="window.location='/structure'" style="margin-left:5px"/>
		</div>
	</form>
</xsl:template>

</xsl:stylesheet>