<?php

defined("__MSF") or die("Direct access is not allowed");

class Struct_ModelXml extends MSF_ViewSupportXml
{
	public function viewTree($sJson, $aConfig, $sRefsJson, $sWfFoldersJson, $sWfDoctypesJson, $bConfirm = false)
	{
		$this->Template->addLink("/js/ext/tabs/livepipe.js", "text/javascript");
		$this->Template->addLink("/js/ext/tabs/control.tabs.js", "text/javascript");
		$this->addLinksOf("structure");
		$this->addLinksOf("references");

		$Element 	= $this->Template->createElement("structure");
		$Modules 	= $this->Template->createElement("modules");
		$Access 	= $this->Template->createElement("access");
		$Messages 	= $this->Template->createElement("messages");
		$Config 	= $this->Template->createElement("config");
		$Access->setAttribute("refsJson", $sRefsJson);
		$Access->setAttribute("foldersJson", $sWfFoldersJson);
		$Access->setAttribute("doctypesJson", $sWfDoctypesJson);
		$Element->setAttribute("skin", CNF_SKIN);
		$Element->setAttribute("json", $sJson);
		$Element->setAttribute("edit", ((MSF_Registry::get("MSF_Router")->isAdminMode()) ? "true" : "false"));
		$this->Root->appendChild($Messages);
		$this->Root->appendChild($Element);
		$this->Root->appendChild($Modules);
		$this->Root->appendChild($Access);
		$this->Root->appendChild($Config);
		
		foreach ($aConfig AS $k => $v) {
			$Item = $this->Template->createElement($k);
			
			$i = 0;
			foreach($v AS $k2 => $v2) {
				$sValue = "\"" . $v2["title"] . "\":" . (($v2["visible"] == 1) ? "true" : "false");
				
				if ($i < sizeof($v) - 1) {
					$sValue .= ",";
				}
				
				$Sub = $this->Template->createElement("column");
				$Sub->setAttribute("value", $sValue);
				$Item->appendChild($Sub);
				$i++;
			}
			
			$Config->appendChild($Item);
		}
		
		$this->Template->addXslPath("/modules/structure/view/templates/" . CNF_SKIN . "/" . (($bConfirm) ? "docs" : "view") . ".xsl");
	}
	
	public function access($aData)
	{
		$Access	= $this->Template->createElement("access");
		$this->Root->appendChild($Access);
		$iCount	= 0;
		foreach($aData as $aRow) {
			$Item	= $this->Template->createElement("item");
			$Item->setAttribute("id", $iCount);
			$Access->appendChild($Item);
			
			foreach($aRow as $n=>$k) {
				$Item->setAttribute($n, $k);
			}
			
			$iCount++;
		}
		
		$this->addTemplate("/modules/structure/view/templates/" . CNF_SKIN . "/access.xsl");
		$this->Template->addLink("/js/msf/element/MSF_ElementAdder.js", "text/javascript");
		$this->Template->addLink("/modules/references/view/js/REF_SaveHandler.js", "text/javascript");
		$this->addLinksOf("structure");
	}
}

?>