<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}


include_once "WFA_AktenplanDB.php";

class WFA_Aktenplan extends WF_ActionSupport implements WF_IAction
{
	const AKTENPLAN_REFERENCE_ID		= 14;
	
	const SUBJECTS_REFERENCE_ID			= 15;
	
	private $sActionType				= "";
			
	public function initialize()
	{
		
	}
	
	public function processSchedule()
	{
		return true;
	}

	public function processRequest()
	{
		$this->sActionType 	= "request";
		$sSubject			= $this->getParam("post", "subject");
		$sAktenplan			= $this->getParam("post", "aktenplan");
		$aLogText			= array("smallText"=>"", "fullText"=>"");
		
	
		try {
			$Doc		= $this->getDocument();
			$Aktenplan	= new WF_Aktenplan();
			$Log		= $this->getLog();
			$aToSave	= array();
			$Locale		= MSF_Registry::get("MSF_Locale");
			
			if($sAktenplan == "") {
				$Aktenplan->removeDocument($Doc->getDocumentId());
				$aLogText["smallText"]	= $Locale->getWord("WORKFLOW_LOG_REGISTRATION_DOCUMENT_AKTENPLAN_OFF");
			}
			else {
				$aToSave["aktenplan"]			= $sAktenplan;
				//$aToSave["subject"]				= $sSubject;
				$aToSave["aktenplan_titles"]	= $this->getAktenplanTitles($sAktenplan);
				//$aToSave["subject_title"]		= $this->getSubjectTitle($sSubject);
				
								
				$aLogText	= $this->getLogText($aToSave);
				
				$Aktenplan->removeDocument($Doc->getDocumentId());
				//$Aktenplan->addDocument($Doc->getDocumentId(), $Doc->getRegistrationNumber(), $sAktenplan, $sSubject);
				$Aktenplan->addDocument($Doc->getDocumentId(), $Doc->getRegistrationNumber(), $sAktenplan, "");
			}

			$RefValue	= new REF_Value();
			$RefValue->parse($sAktenplan);
			
			$this->callMove();
						
			$Log->display($this->getActionTitle(), $aLogText["smallText"], $aLogText["fullText"]);
			$Log->setDelegated(0, $this->getActionName(), $aToSave);
			$Log->report($this->getDocument()->getPointId(), $this->getActionName(), "," . implode(",", $RefValue->getKeysList()) . ",");
		}
		catch (ReferenceException $e){
			$this->exceptionRowNotFound();
			return self::SUCCESS;
		}
		catch(Exception $e) {
			debug($e);
			return self::FAILURE;
		}
					
		return self::SUCCESS;
	}

	public function processResponse()
	{
		return self::FAILURE;
	}
	
		
	public function processCall()
	{
		//echo "Fuck Fuck Fuck";
		//return true;
	}
	
	public function processExecute()
	{
		$this->sActionType 	= "execute";
		$aRoute				= $this->getSettings()->getActions($this->getActionId());
		$Log				= $this->getLog();
		$Locale				= MSF_Registry::get("MSF_Locale");
						
		//$sSubject	= $aRoute["options"]["subject"];
		$sAktenplan	= $aRoute["options"]["aktenplan"];
		$aLogs		= $Log->getDelegated($this->getDocument()->getPointId(), $this->getActionId());
		$aLogText	= array("smallText"=>"", "fullText"=>"");
				
		try {
			if(empty($aLogs) && $sAktenplan != "")	{
				$Doc		= $this->getDocument();
				$Aktenplan	= new WF_Aktenplan();
			
				$aToSave						= array();
				$aToSave["aktenplan"]			= $sAktenplan;
				//$aToSave["subject"]				= $sSubject;
				$aToSave["aktenplan_titles"]	= $this->getAktenplanTitles($sAktenplan);
				//$aToSave["subject_title"]		= $this->getSubjectTitle($sSubject);
			
				
				$Aktenplan->removeDocument($Doc->getDocumentId());
				//$Aktenplan->addDocument($Doc->getDocumentId(), $Doc->getRegistrationNumber(), $sAktenplan, $sSubject);
				$Aktenplan->addDocument($Doc->getDocumentId(), $Doc->getRegistrationNumber(), $sAktenplan, "");
				
				$aLogText	= $this->getLogText($aToSave);
				
				$RefValue	= new REF_Value();
				$RefValue->parse($sAktenplan);

				$this->callMove();
								
				$Log->display($this->getActionTitle(), $aLogText["smallText"], $aLogText["fullText"]);
				$Log->setDelegated(0, $this->getActionName(), $aToSave);
				$Log->report($this->getDocument()->getPointId(), $this->getActionName(), "," . implode(",", $RefValue->getKeysList()) . ",");
			}
											
		}
		catch (ReferenceException $e){
			$this->exceptionRowNotFound();
			return self::SUCCESS;
		}
		catch(Exception $e) {
			debug($e);
			return self::WAIT;
		}
					
		return self::SUCCESS;
	}

	private function callMove()
	{
		$aRoute		= $this->getSettings()->getActions($this->getActionId());
		if (isset($aRoute["options"])) {
			if (isset($aRoute["options"]["move_points"])) {		
				$this->call("move", array("iNewPoint" => $aRoute["options"]["move_points"]));
			}
		}
	}

	public function cancel()
	{
		return self::SUCCESS;
	}
	
	private function getSubjectTitle($sSubject)
	{
		if($sSubject == "") {
			$sSubjectTitle	= "";
		}
		else {
			$RefValue	= new REF_Value();
			$RefValue->parse($sSubject);
			$aKeys		= $RefValue->getKeysList();
			
			$Reference	= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
			$Reference->load(self::SUBJECTS_REFERENCE_ID);
			$aRow			= $Reference->row($aKeys[0])->show();
			$sSubjectTitle	= $aRow[0]["value"];
		}
				
		return $sSubjectTitle;
	}
	
	private function getAktenplanTitles($sAktenplan)
	{
		if($sAktenplan	== "") {
			$aAktenplanTitles	= array();
		}
		else {
			$RefValue	= new REF_Value();
			$RefValue->parse($sAktenplan);
	
			$aAktenplaIds		= $RefValue->getKeysList();
			$aAktenplanTitles	= array();
			
			$Reference	= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
			$Reference->load(self::AKTENPLAN_REFERENCE_ID);
			foreach($aAktenplaIds as $iId) {
				$aRows				= $Reference->row($iId)->show();
				foreach($aRows AS $aRow) {
					if ($aRow["name"] == "index") {
						$aTitles["index"] 		= $aRow["value"];
					}
					if ($aRow["name"] == "title") {
						$aTitles["title"] 		= $aRow["value"];
					}
					if ($aRow["name"] == "department") {
						$aTitles["department"] 	= $aRow["value"];
					}
				}
				$aTitles["link"] = "/references/viewrow/" . self::AKTENPLAN_REFERENCE_ID . "/" . $iId;
				array_push($aAktenplanTitles, $aTitles);
			}
		}
		
		return $aAktenplanTitles;
	}

	private function getLogText($aToSave)
	{
		$aText 		= array();
		foreach($aToSave["aktenplan_titles"] AS $aTitles) {
			$aText[]= $aTitles["index"] . "-" . $aTitles["title"] . "-" . $aTitles["department"];
		}
		
		$Locale		= MSF_Registry::get("MSF_Locale");
		$sSmallText	= $Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_AKTENPLAN")
					. " "
					. implode(", " , $aText)
					. ".";

		$sFullText	= "";
		
		/*
		if($aToSave["subject_title"] != "") {
			$sFullText	= $Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_AKTENPLAN")
						. " "
						. implode(", " , $aToSave["aktenplan_titles"])
						. "."
						. "<br/>"
						. $Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_SUBJECT")
						. $aToSave["subject_title"]
						. ".";
		}
		*/
		
		return array("smallText"=>$sSmallText, "fullText"=>$sFullText);
	}
	
	private function exceptionRowNotFound(){
		$oLocale = MSF_Registry::get("MSF_Locale");
		
		if ($this->sActionType == "request"){
			$Messenger 	= MSF_Registry::get("MSF_Messenger");
			$Messenger->addError($oLocale->getWord("WFA_MESSAGE_NOT_RECORD_AKTENPLAN"));					
		}
		
		$this->getLog()->display($this->getActionTitle(), $oLocale->getWord("WF_CONTEXT_EXECUTION_NOT_CORRECT_PARAMS"),
								 $oLocale->getWord("WF_CONTEXT_EXECUTION_NOT_CORRECT_PARAMS") . "\n" .
								 $oLocale->getWord("WFA_MESSAGE_NOT_RECORD_AKTENPLAN")
								 );
	}
	
}

?>