<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

class WFA_Condition extends WF_ActionSupport implements WF_IAction
{
	public function initialize()
	{
		
	}
	
	public function processSchedule()
	{
		return true;
	}

	public function processRequest()
	{
						
		return self::SUCCESS;
	}

	public function processResponse()
	{
		return self::FAILURE;
	}
	
	public function prepareSpa($aSpa)
	{
		return $aSpa;
	}
		
	public function processCall()
	{

	}
	
	private function buildParams() {
		$aRoute 	= $this->getSettings()->getActions($this->getActionId());
		$aParams 	= array_merge(
				array(
						"arg2_type" => "",
						"condition" => ""
						),
				$aRoute["options"]
				);

		return $aParams;
	}
		
	public function processExecute()
	{
		$aParams	= $this->buildParams();
		if (!isset($aParams["arg1"])) return self::NULL;
		
		$aFields 	= $this->getDocumentVersion()->getFields();
		
		$mArg2 		= isset($aParams["arg2_value"]) ? $aParams["arg2_value"] : "";
		$mArg1		= $this->getCompareValue(
				MSF_SL::getParam($aFields,$aParams["arg1"]), 
				$aParams["arg1"]
				);
		$mArg2 		= ($aParams["arg2_type"] == "field")
								? $this->getCompareValue($aFields[$aParams["arg2_value"]], $mArg2)
								: $this->getCompareValue($mArg2, $aParams["arg1"]);
		$sCondition = $aParams["condition"];

		// less, more, equal, not_equal, include, not_include
		switch($sCondition) {
			case "less":
				($mArg1 < $mArg2) ? $this->callAction($aParams, "if") : $this->callAction($aParams, "else");
				break;
			case "more":
				($mArg1 > $mArg2) ? $this->callAction($aParams, "if") : $this->callAction($aParams, "else");
				break;
			case "equal":
				($mArg1 == $mArg2) ? $this->callAction($aParams, "if") : $this->callAction($aParams, "else");
				break;
			case "not_equal":
				($mArg1 != $mArg2) ? $this->callAction($aParams, "if") : $this->callAction($aParams, "else");
				break;
			case "include":
				if (is_array($mArg2)) {
					$iCount = 0;
					foreach ($mArg2 as $sValue) {
						if (in_array($sValue, $mArg1)) {
							$iCount++;
						}
					}

					if ((empty($mArg1) && !empty($mArg2)) || ((!empty($mArg1) && empty($mArg2)))) {
						$iCount = -1;
					}
					(count($mArg2) == $iCount) ? $this->callAction($aParams, "if") : $this->callAction($aParams, "else");
				}
				else {
					if (strlen($mArg2) > 0) {
						(strpos($mArg1, $mArg2) !== false) ? $this->callAction($aParams, "if") : $this->callAction($aParams, "else");
					}
					else {
						($mArg1 == $mArg2) ? $this->callAction($aParams, "if") : $this->callAction($aParams, "else");
					}
				}
				break;
			case "not_include":
				if (is_array($mArg2)) {
					$iCount = 0;
					foreach ($mArg2 as $sValue) {
						if (in_array($sValue, $mArg1)) {
							$iCount++;
						}
					}
					if ((empty($mArg1) && !empty($mArg2)) || ((!empty($mArg1) && empty($mArg2)))) {
						$iCount = -1;
					}
					(count($mArg2) != $iCount) ? $this->callAction($aParams, "if") : $this->callAction($aParams, "else");
				}
				else {
					if (strlen($mArg2) > 0) {
						(strpos($mArg1, $mArg2) === false) ? $this->callAction($aParams, "if") : $this->callAction($aParams, "else");
					}
					else {
						($mArg1 != $mArg2) ? $this->callAction($aParams, "if") : $this->callAction($aParams, "else");
					}
				}
				break;
		}
		
		if (isset($aParams["condition-repeat"]) && $aParams["condition-repeat"] == 1) {
			return self::NULL;
		}
		
		return self::SUCCESS;
	}
	
	private function callAction($aParams, $sType)
	{
		switch ($aParams["action_" . $sType]) {
			case "move":
				$this->call("move",  array("iNewPoint" => $aParams["move_point_" . $sType]));
				$sActionTitle = MSF_Registry::get("MSF_Locale")->getWord("WFA_MOVE");
				$sSmallText	  = MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_LOG_MOVE_MOVED");
				$this->getDocument()->getLog()->display($sActionTitle, $sSmallText);		
				break;
			case "notify":
				if (isset($aParams["notify_address_value_" . $sType])) {
					$sTitle = $this->getDocument()->getTitle();
					
					$sNotifyText 	= $aParams["notify_text_" . $sType];
					$sDocument 		= MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCUMENT");
					$sUrl 			= $sDocument . (($sDocument{strlen($sDocument) - 1} != ":") ? ":" : "") . "<br/>" .
					"<a href=\"" . CNF_HOST_URL . "/workflow/document/view/" . $this->getDocument()->getDocumentId() . "\">" .
						$this->getDocument()->getTitle() .
					"</a><br/><br/>";
			
					if (!empty($sNotifyText)) {
						$sCommentWord 	= MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCTYPE_SPA_COMMENT");
						$sNotifyText 	= $sCommentWord . (($sCommentWord{strlen($sCommentWord) - 1} != ":") ? ":" : "") . "<br/>" . $sNotifyText;
					}
					$aAdress = $this->getValues()->toStructureIds($aParams["notify_address_value_" . $sType]);
					$this->call(
						"notify",
						array(
							"aStructure" 	=> $aAdress,
							"sSubject" 		=> $sTitle,
							"sText" 		=> $sUrl . $sNotifyText
						)
						
					);
					
					$UBox 	= MSF_Registry::get("MSF_UserBox");
					$aETmp 	= array();
					$sAddrs	= "";
					for ($i = 0; $i < count($aAdress); $i++) {
						$UBox->load($aAdress[$i], "structure", true);
						$aTmp = $UBox->getLoadedResult();
						
						for ($j = 0; $j < count($aTmp); $j++) {
							if (!in_array($aTmp[$j]["user"]["id"], $aETmp)) {
								$aETmp[] = $aTmp[$j]["user"]["id"];
								if ($i > 0) {
									$sAddrs .= ", ";
								}
								if (isset($aTmp[$j]["employee"]["name"])) {
									$sAddrs .= $aTmp[$j]["employee"]["name"];
								}
								elseif (isset($aTmp[$j]["user"]["login"])) {
									$sAddrs .= $aTmp[$j]["user"]["login"];
								}
							}
						}
					}

					$this->log($sAddrs, $aParams["notify_text_" . $sType]);
				}
				break;
		}
	}
	
	
	public function cancel()
	{
		return self::SUCCESS;
	}
	
	public function getLogTitle()
	{
		return MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_LOG_CONDITION_CHECKED");
	}

	public function getLogParams()
	{
		//debug($this->getLog($this->getDocument()->getPointId(), $this->getActionId()));
		return array();
	}
	
	private function log($sAdress, $sNotifyText)
	{
		$oRefValue = new REF_Value();
		$oRefValue->parse($sAdress);
		$ValuesList = $oRefValue->getValuesList();
		// STRUCT1, STRUCT2, = 3 elements
		$iLastId = count($ValuesList) - 1;
		if (isset($ValuesList[$iLastId]) && empty($ValuesList[$iLastId])) {
			array_pop($ValuesList);
		}
		
		if (count($ValuesList)) {
			$sFullText = (trim($sNotifyText)) ? implode(', ', $ValuesList) . "\n" . $sNotifyText : "";
			$this->getDocument()->getLog()->display(
			MSF_Registry::get("MSF_Locale")->getWord("WFA_NOTIFY"),
			implode(', ', $ValuesList),
			$sFullText
			);
		}
	}
	
	private function getCompareValue($mValue, $sName)
	{
		$Fields		= new REF_Fields($this->getDoctypeVersion()->getFieldsXml());
		$mReturn	= null;

		foreach($Fields->getAsList() as $aField) {
			if($aField["name"] == $sName) {
				switch($aField["type"]) {
					case REF_Fields::INTEGER:
						$mReturn = (int) $mValue;
						break;
					case REF_Fields::FLOAT:
						$mReturn = (float) $mValue;
						break;
					case REF_Fields::ENUM:
						$aTmp = MSF_EnumValue::parse($mValue);
						
						if ($aTmp === null) {
							if (isset($aField["optional"]["enum"])) {
								foreach ($aField["optional"]["enum"] as $iKey => $sValue) {
									if ($mValue == $iKey) {
										$mReturn = $sValue;
										break;
									}
								}
							}
						}
						else {
							$mReturn = $aTmp["value"];
						}
						
						if (is_numeric($mReturn)) {
							$mReturn = (int) $mReturn;
						}
						
						break;
					case REF_Fields::BOOLEAN:
						$aTmp = MSF_EnumValue::parse($mValue);
						
						if ($aTmp === null) {
							if (isset($aField["optional"]["labelYes"])) {
								if ($mValue == 0) {
									$mReturn = $aField["optional"]["labelNo"];
								}
								else {
									$mReturn = $aField["optional"]["labelYes"];
								}
							}
						}
						else {
							$mReturn = $aTmp["value"];
						}
						
						if (is_numeric($mReturn)) {
							$mReturn = (int) $mReturn;
						}
						
						break;
					case REF_Fields::REFERENCE:
					case REF_Fields::STRUCTURE:
						$mReturn = array();
						$RV	= new REF_Value();
						$RV->parse($mValue);
						//$mReturn = (string) implode(", ", $RV->getValuesList());
						//$mReturn = $RV->getValuesList();
						foreach ($RV->getKeysList() as $mIds) {
							if (is_array($mIds)) {
								$mReturn[] = $mIds[0];
							}
							else {
								$mReturn[] = $mIds;
							}
						}						
						break;
					case REF_Fields::DATE:
					case REF_Fields::TIMESTAMP:
						$mReturn = strtotime($mValue);
						break;
					default:
						$mReturn = (string) $mValue;
						break;
				}
				
				break;
			}
			
		}
		
		return $mReturn;
	}
		
}

?>