var WF_ConditionExecution = Class.create();
WF_ConditionExecution.prototype = Object.extend(new WF_AbstractExecution(),
{
	init : function()
	{
		this.buildEffect();
	},

	execute : function()
	{
		this.sValId 		= this.makeId("condition-arg2_value");
		this.sSecValue 		= this.get("arg2_value");
		this.FirstFields 	= this.getById("condition-arg1_select");
		this.SelectTypes 	= this.getById("condition-arg2_type");
		this.Condition		= this.getById("condition-condition");
		this.ValuesCont 	= this.getById("condition-arg2_cont");
		
		this.prepareFirstFields();
		this.defineActions();
		this.repeatAction();
	},
	
	defineActions: function()
	{
		var me 			= this;
		var SelectIf 	= this.getById("condition-action_if");
		var SelectElse 	= this.getById("condition-action_else");
		
		var onChangeFunc 	= function(Select, sType)
		{
			var aActions 	= ["notify", "move"];
			var Action 		= null;
			
			for (var i = 0; i < aActions.length; i++) {
				Action = me.getById("confition-action_" + aActions[i] + "_" + sType);
				if (Action) {
					if (aActions[i] == Select.value) {
						Action.show();
						me.buildAction(Select.value, sType);
					}
					else {
						Action.hide();
					}
				}
			}
		};
		var loadFunc = function(Select, sType)
		{
			for (var i = 0; i < Select.options.length; i++) {
				if (me.get("action_" + sType) == Select.options[i].value) {
					Select.options[i].selected = true;
					onChangeFunc(Select, sType);
					me.buildAction(Select.value, sType);
					break;
				}
			}
		};
		
		SelectIf.onchange 	= function() { onChangeFunc(this, "if"); };
		SelectElse.onchange = function() { onChangeFunc(this, "else"); };
		loadFunc(SelectIf, "if");
		loadFunc(SelectElse, "else");
	},
	
	buildAction: function(sName, sType)
	{
		var me = this;
		
		switch (sName) {
			case "move":
				this.getById("condition-move_point_" + sType).value = this.get("move_point_" + sType);
				break;
			case "notify":
				this.getById("condition-notify_text_" + sType).value = this.get("notify_text_" + sType);
				//this.getById("condition-notify_type_" + sType).value = this.get("notify_type_" + sType);
				this.addAddress("condition-a-notify_address_type_" + sType, "condition-a-notify_address_value_" + sType);
				
				/*
				var DocCont 	= this.getById("condition-notify_doc_fields_container_" + sType);
				var SelectType 	= this.getById("condition-notify_type_" + sType);
				
				for (var i = 0; i < SelectType.options.length; i++) {
					if (this.get("notify_type_" + sType) == SelectType.options.value) {
						SelectType.options[i].selected = true;
						break;
					}
				}
				
				SelectType.onchange = function()
				{
					if (this.value == "doc_field") {
						me._makeNotifySelect(DocCont, null, sType);
					}
					else {
						DocCont.update();
					}
				}
				
				var CSelect = this.getById("doc_field_" + sType);
				if (CSelect || SelectType.value == "doc_field") {
					this._makeNotifySelect(DocCont, CSelect, sType);
				}
				*/
				break;
		}
	},

	prepareFirstFields: function()
	{
		var me 			= this;
		var iCount 		= 1;
		var aAllowed 	= ["int", "float", "bool", "date", "timestamp", "string", "text", "enum", "structure", "reference"];
		var sValue 		= this.get("arg1");
		var sArgType 	= this.get("arg2_type");
		
		for (var i = 0; i < aFields.length; i++) {
			var bAllow = false;
			for (var j = 0; j < aAllowed.length; j++) {
				if (aAllowed[j] == aFields[i].type) {
					bAllow = true;
					break;
				}
			}
			if (!bAllow) {
				continue;
			}
			this.FirstFields.options[iCount] = new Option(aFields[i].title, aFields[i].name);
			this.FirstFields.options[iCount].setAttribute("type", aFields[i].type);
			if (sValue == aFields[i].name) {
				this.FirstFields.options[iCount].selected = true;
			}
			iCount++;
		}
		
		this.FirstFields.onchange = function()
		{
			var sType = this.options[this.selectedIndex].getAttribute("type");
			me.sSecValue = "";
			me.formConditions(sType);
			me.formTypes(sType, this.value);
			me.formSecondValues(sType, me.FirstFields.value);
		}
		
		var sType = this.FirstFields.options[this.FirstFields.selectedIndex].getAttribute("type");
		this.formConditions(sType);
		this.formTypes(sType, sArgType);
		
		if (sArgType != "") {
			if (sArgType == "field") {
				this.formSecondFields(sType, this.FirstFields.value);
			}
			else {
				this.formSecondValues(sType, this.FirstFields.value);
			}
		}
	},
	
	formConditions: function(sType)
	{
		var aValues = [];
		var sValue 	= this.get("condition");
		
		switch (sType) {
			case "int":
			case "float":
			case "date":
			case "timestamp":
				aValues = [{
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_LESS"],
					"value": "less"
				}, {
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_MORE"],
					"value": "more"
				}, {
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_EQUAL"],
					"value": "equal"
				}, {
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_NOT_EQUAL"],
					"value": "not_equal"
				}];
				break;
			case "bool":
				aValues = [{
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_EQUAL"],
					"value": "equal"
				}];
				break;
			case "string":
			case "text":
			case "reference":
			case "structure":
				aValues = [{
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_INCLUDE"],
					"value": "include"
				}, {
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_NOT_INCLUDE"],
					"value": "not_include"
				}, {
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_EQUAL"],
					"value": "equal"
				}, {
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_NOT_EQUAL"],
					"value": "not_equal"
				}];
				break;
			case "enum":
				aValues = [{
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_EQUAL"],
					"value": "equal"
				}, {
					"title": aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_NOT_EQUAL"],
					"value": "not_equal"
				}];
				break;
		}
		
		this.clearSelect(this.Condition);
		for (var i = 0; i < aValues.length; i++) {
			this.Condition.options[i] = new Option(aValues[i].title, aValues[i].value);
			if (sValue == aValues[i].value) {
				this.Condition.options[i].selected = true;
			}
		}
	},
	
	formTypes: function(sType, sValue)
	{
		var me = this;
		
		this.ValuesCont.update();
		this.clearSelect(this.SelectTypes);
		//this.SelectTypes.options[0] = new Option(aGlobalMsfWords["WORKFLOW_NULL"], "");
		
		if (sType != "" && sValue != "") {
			this.SelectTypes.options[0] = new Option(aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_VALUE"], "value");
			
			if (sType != "bool" && sType != "enum") {
				this.SelectTypes.options[1] = new Option(aGlobalMsfWords["WORKFLOW_DOCTYPE_ROUTER_CONDITION_FIELD"], "field");
			}
			
			this.SelectTypes.onchange = function()
			{
				me.sSecValue = "";
				if (this.value == "field") {
					me.formSecondFields(sType, me.FirstFields.value);
				}
				else {
					me.formSecondValues(sType, me.FirstFields.value);
				}
			}
			
			if (sValue != "") {
				for (var i = 0; i < this.SelectTypes.options.length; i++) {
					if (this.SelectTypes.options[i].value == sValue) {
						this.SelectTypes.options[i].selected = true;
						if (sValue == "field") {
							this.formSecondFields(sType, this.FirstFields.value);
						}
						else {
							this.formSecondValues(sType, this.FirstFields.value);
						}
					}
				}
			}
		}
	},
	
	formSecondFields: function(sType, sName)
	{
		var Select = new Element("select", {"name": this.makeName("arg2_value"), "id": this.sValId});
		var iCount = 0;
		
		for (var i = 0; i < aFields.length; i++) {
			if (aFields[i].type != sType || aFields[i].name == sName) {
				continue;
			}
			Select.options[iCount] = new Option(aFields[i].title, aFields[i].name);
			if (this.get("arg2_value") == aFields[i].name) {
				Select.options[iCount].selected = true;
			}
			iCount++;
		}
		
		this.ValuesCont.update(Select);
		Select.style.width = "175px";
	},
	
	formSecondValues: function(sType, sFieldName)
	{
		var Input 	= new Element("div");
		this.ValuesCont.update(Input);
		var sName 	= this.makeName("arg2_value");
		var bTime 	= true;
		
		switch (sType) {
			case "int":
			case "float":
			case "string":
			case "text":
				var oTempInput = new Element("input", {"name": sName, "value": this.sSecValue, "id": this.sValId});
				Input.insert(oTempInput);
				oTempInput.style.width = "175px";
				break;
			case "date":
				bTime = false;
			case "timestamp":
				this.addCalendar({
					mPlace			: Input,
					sInputName		: "arg2_value",
					sDefaultValues	: this.sSecValue,
					bTime			: bTime
				});
				
				if(typeof(this.isNew) != "undefined" && this.isNew == true) {
					var oHiddenInput	= new Element("INPUT");
					oHiddenInput.type	= "hidden";
					$("point-context-execution____" + this.___aConfig.iPointId).insert(oHiddenInput);
				}
					
				break;
			case "reference":
				var Options = this.defineFieldOptions(sFieldName);
				
				if (Options && Options.optional) {
					Options 		= Options.optional;
					var aColumns 	= {};
					var aFilters 	= {};
					
					if (Options.defaultFilter) {
						$H(Options.defaultFilter).each(function(e) {
							aFilters[e.key] = e.value;
						});
					}
                                        
                                        
                                        if(Options.columns != undefined){
                                            for (var i = 0; i < Options.columns.length; i++) {
                                                    if (Options.fieldsValue) {
                                                            aColumns[Options.columns[i]] = {
                                                                    "select": (Options.fieldsValue[Options.columns[i]]) ? true : false,
                                                                    "group": (Options.groupEnable == 1) ? true : false,
                                                                    "filter": (Options.filterEnable == 1) ? true : false,
                                                                    "sort": true
                                                            };
                                                    }
                                            }
                                        }
					
					this.addReference({
						mPlace			: 	Input,
						iRefId			: 	Options.reference,
						sInputName		: 	"arg2_value",
						aColumns		: 	aColumns,
						aDefaultGroups	: 	(Options.defaultGroup) ? Options.defaultGroup : [],
						bById			: 	true,
						bMultiselect	: 	(Options.multiselect == 0) ? false : true,
						sDefaultValues	: 	this.sSecValue,
						aDefaultFilters : 	aFilters
					});
					
					if(typeof(this.isNew) != "undefined" && this.isNew == true) {
						var oHiddenInput	= new Element("INPUT");
						oHiddenInput.type	= "hidden";
						$("point-context-execution____" + this.___aConfig.iPointId).insert(oHiddenInput);
					}
				}
				break;
			case "structure":
				var Options = this.defineFieldOptions(sFieldName);
				this.addStructure({
					"mPlace" 			: Input,
					"sInputName"  		: "arg2_value",
					"sDefaultValues" 	: this.sSecValue,
					"bMultiselect" 		: (Options.optional.multiselect == 1) ? true : false,
					"bShowPosts" 		: (Options.optional.postEnable == 1) ? true : false
				});
				
				if(typeof(this.isNew) != "undefined" && this.isNew == true) {
					var oHiddenInput	= new Element("INPUT");
					oHiddenInput.type	= "hidden";
					$("point-context-execution____" + this.___aConfig.iPointId).insert(oHiddenInput);
				}
				
				break;
			case "enum":
				var Enum = new Element("select", {"name": sName, "id": this.sValId});
				Input.insert(Enum);
				
				var Options = this.defineFieldOptions(sFieldName);
				if (Options && Options.optional) {
					for (var i = 0; i < Options.optional["enum"].length; i++) {
						Enum.options[i] = new Option(Options.optional["enum"][i], i);
						if (this.sSecValue == i) {
							Enum.options[i].selected = true;
						}
					}
				}
				break;
			case "bool":
				var Bool = new Element("select", {"name": sName, "id": this.sValId});
				Input.insert(Bool);
				
				var Options = this.defineFieldOptions(sFieldName);
				if (Options && Options.optional) {
					Bool.options[0] = new Option(Options.optional.labelYes, 1);
					Bool.options[1] = new Option(Options.optional.labelNo, 0);
					
					if (this.sSecValue == 1) {
						Bool.options[0].selected = true;
					}
					else {
						Bool.options[1].selected = true;
					}
				}
				break;
		}
		
		
	},
	
	defineFieldOptions: function(sFieldName)
	{
		for (var i = 0; i < aFields.length; i++) {
			if (aFields[i].name == sFieldName) {
				return aFields[i].value;
			}
		}
	},
	
	clearSelect: function(Select)
	{
		for (var i = Select.options.length - 1; i >= 0; i--) {
			Select.options[i] = null;
		}
	},
	
	repeatAction: function()
	{
		if(this.get("condition-repeat") == 1){
			var RepeatYes		= this.getById("condition-repeat-yes");
			var RepeatNo		= this.getById("condition-repeat-no");
			RepeatYes.checked 	= true;
			RepeatNo.checked 	= false;
		}
	},
	buildEffect : function()
	{
		var oSelect 	= this.getById('condition');
		Effect.BlindDown(oSelect);
	}
});