/**
 * [ADMIN ROUTE FORM SPEC]
 * # Тип адресата контролера,
 * controller_type['field', 'variable', 'structure'] 
 * 
 * # Значение адресата контролера,
 * controller_value['widget'] 
 * 
 * #  Отправить увед. Контроллеру
 * controller_send_mail['1', '0']
 * 
 * # Тип адресата исполнителя
 * executor_type['field', 'variable', 'structure']
 * 
 * # Тип адресата исполнителя
 * executor_value['widget']
 * 
 * # Тип даты исполнения
 * deadline_type['calendar', 'field(date, datetime)', 'after']
 * 
 * # Значение даты исполнения
 * deadline_value['widget']
 * 
 * # Количество предупреждений
 * number_of_mails[int]
 * 
 * # Состояние
 * status['enabled', 'disabled']
 * 
 * # Переместить на точку
 * number_of_points[int]
 */
var WF_ControlExecution = Class.create();
WF_ControlExecution.prototype = Object.extend(new WF_AbstractExecution(), 
{
	execute : function()
	{	
		this.__addController();
		this.__addExecutor();
		this.__addStatus();
		this.__addDeadline();		
		this.__addMailingNumber();
		this.__addPointNumber();
	},
	
	__addMailingNumber : function() {
		var oMnc 		= this.getById('control-mailing-number-container');
		var oInput 		= new Element('INPUT');
		oInput.name	 	= this.makeName('number_of_mails');
		oInput.value	= this.get('number_of_mails');
		oMnc.update(oInput);
		oInput.onkeydown = function(e) {
			var e = (!e) ? window.event : e;
			if (e.keyCode == 9) {
				return true;
			}
			
			if ((
					(e.keyCode >=96) && (e.keyCode <= 105)
				) || (
					(e.keyCode >=48) && (e.keyCode <= 57)
				) || (
					e.keyCode == 8
				) || (
					e.keyCode == 46
				) || (
					e.keyCode == 37
				) || (
					e.keyCode == 39
				)) {
				if (this.value.charAt(0) == '0') {	
					this.value = '';
				}
				
				return true;
			} else {
				oMe = this;
				oMe.style.backgroundColor = 'red';
				setTimeout(function() {oMe.style.backgroundColor = 'white'}, 500);
				return false;
			}
			
		};
		
		oInput.onchange = function(e) {
			if (!/^[0-9]+$/.test(this.value)) {
				this.value = '';
			}
			
		}; 
		
	},
	
	__addPointNumber : function() {
		var oMnc 		= this.getById('control-point-number-container');
		var oInput 		= new Element('INPUT');
		oInput.name	 	= this.makeName('number_of_points');
		oInput.value	= this.get('number_of_points');
		oMnc.update(oInput);
		oInput.onkeydown = function(e) {
			var e = (!e) ? window.event : e;
			 
			if (e.keyCode == 9) {
				return true;
			}
			
			if ((
					(e.keyCode >=96) && (e.keyCode <= 105)
				) || (
					(e.keyCode >=48) && (e.keyCode <= 57)
				) || (
					e.keyCode == 8
				) || (
					e.keyCode == 46
				) || (
					e.keyCode == 109
				) || (
				
					e.keyCode == 37
				) || (
					e.keyCode == 39
				)) {

				if (this.value.charAt(0) == '0') {
					this.value = '';
				}
				
				return true;
			} else {
				oMe = this;
				oMe.style.backgroundColor = 'red';
				setTimeout(function() {oMe.style.backgroundColor = 'white';}, 500);
				return false;
			}
			
		};
		
		oInput.onchange = function(e) {
			this.value = parseInt(this.value);
			if (isNaN(this.value)) {
				this.value = '';
			}			
		}; 
		
	},
	
	__addStatus : function() {
		var oSelect 	= this.getById('control-status');
		oSelect.name	= this.makeName('status');
		var hStatus 	= $H({
				'enabled' 	: aGlobalMsfWords["WFA_REMIND_ON"],
				'disabled' 	: aGlobalMsfWords["WFA_REMIND_OFF"]
				});
		var i		= 0;
		hStatus.each(function(h) {
			var oOption 		= new Option(h.value, h.key);
			oSelect.options[i] 	= oOption;
			oOption.selected 	= h.key == this.get('status');
			i++;
		}.bind(this));
		
		oSelect.onchange = function(oSelect) {
			var oOpt = this.getById('control-options');
			if (oSelect.value == 'enabled') {
				//oOpt.style.display = 'block';
				Effect.BlindDown(oOpt);
				
			}
			else {
				//oOptStyle.display = 'none';
				Effect.BlindUp(oOpt);
			}

		}.bind(this, oSelect);
		oSelect.onchange();
	},
	
	__addController : function() {
		this.addAddress('control-a-controller_type', 'control-a-controller_value');
	},
	
	__addExecutor : function() {
		this.addAddress('control-a-executor_type', 'control-a-executor_value');
	},
	
	__addDeadline : function() {
		var iDoctypeId		= aAllDTFields.get('current').get('doctypeId');
		var oTypeContainer 	= this.getById('control-deadline-type-container');
		var oValueContainer = this.getById('control-deadline-value-container');
		var oType 			= new Element('SELECT');
		var sDeadlineType 	= this.get('deadline_type');
		
		var aFields			= aAllDTFields.get('all').get(iDoctypeId).get('fields');
		oTypeContainer.update(oType);
		var isSelected		= false;
		var i				= 0;
		var hTypes			= $H({
			''				: aGlobalMsfWords["WFA_REMIND_DEADLINE_VALUE_CONTAINER_NO"],
			'dateTimeField' : aGlobalMsfWords["WFA_REMIND_DEADLINE_VALUE_CONTAINER_OP"],
			//'dateTime' 		: 'Дата',
			'after' 		: aGlobalMsfWords["WFA_REMIND_DEADLINE_VALUE_CONTAINER_VV"]
			
		});

		var oHandler = {
			addDateTimeField : function(oValueContainer, aFields, sName, sValue) {
				var oSelect 		= new Element("SELECT");
				var i				= 0;
				oSelect.name 		= sName; 
				oSelect.options[i] = new Option(aGlobalMsfWords["WFA_REMIND_VALUE_CONTAINER_NO"], '');
				aFields.each(function(hash) {
					if ((hash.value.get('type') == 'timestamp') || (hash.value.get('type') == 'date')) {
						var oOption = new Option(hash.value.get('title'), hash.key);
						if (sValue == hash.key) {
							oOption.selected = true;
						}
						
						oSelect.options[++i] = oOption;
					}

				});
				
				oValueContainer.update(oSelect);
			},
			
			addAfter : function(oValueContainer, oA) {
				oValueContainer.update();
				// days
				var oInput 				= new Element('INPUT');
				oInput.name				= oA.makeName('deadline_value_days');
				oInput.value			= oA.get('deadline_value_days');
				if (oInput.value.length == 0) {
					oInput.value = 0;
				}
			
				oInput.style.width		= "20px";
				oInput.style.textAlign	= "right";
				oInput.maxLength		= "3";
				oValueContainer.insert(oInput);
				oValueContainer.insert(aGlobalMsfWords["WORKFLOW_REMIND_DAYS"]);
				oInput.onkeydown = function(e) {
					var e = (!e) ? window.event : e;
					if (e.keyCode ==9) {
						return true;
					}
					
					if (((e.keyCode >=96) && (e.keyCode <= 105)) || ((e.keyCode >=48) && (e.keyCode <= 57)) || (e.keyCode == 8) || (e.keyCode == 46)|| (e.keyCode == 37)|| (e.keyCode == 39)) {
						if (this.value.charAt(0) == '0') {	
							this.value = '';
						}
						
						return true;
					} else {
						oMe = this;
						oMe.style.backgroundColor = 'red';
						setTimeout(function() {oMe.style.backgroundColor = 'white'}, 500);
						return false;
					}
					
				};
				
				oInput.onchange = function(e) {
					this.value = parseInt(this.value);
					if (isNaN(this.value)) { 
						this.value = '';
					}
					
				};
				
				// hous
				var oSelect				= new Element('SELECT');
				oSelect.name			= oA.makeName('deadline_value_hours');
				for (var i = 0; i < 24; i++) {
					var oOption = new Option(((i < 10)? '0' + i: i), i);
					oSelect.options[i] = oOption;
					if (oA.get('deadline_value_hours') == i) {
						oSelect.options[i].selected = true;
					}
					
				}
				oValueContainer.insert(oSelect);
				oValueContainer.insert(aGlobalMsfWords["WORKFLOW_REMIND_HOUR"]);
				
				// minuts
				var oSelect				= new Element('SELECT');
				oSelect.name			= oA.makeName('deadline_value_minuts');
				var j					= 0;
				for (var i = 0; i < 60; i = i+5) {
					var oOption = new Option(((i < 10)? '0' + i: i), i);
					oSelect.options[j] = oOption;
					if (oA.get('deadline_value_minuts') == i) {
						oSelect.options[j].selected = true;
					}
					j++;
					
				}
				
				oValueContainer.insert(oSelect);
				oValueContainer.insert(aGlobalMsfWords["WORKFLOW_REMIND_MINUT"]);
				
				// perezapisat' pole tip - data
				oValueContainer.insert(new Element("br"));
				oValueContainer.insert(aGlobalMsfWords["WORKFLOW_DOCTYPE_SPA_CONTROL_RECORD_DATA"]);
				var oSelect 		= new Element("SELECT");
				var i				= 0;
				oSelect.name 		= oA.makeName('record_data_field'); 
				oSelect.options[i++] = new Option(aGlobalMsfWords["WFA_REMIND_OPTION"], '');
				aFields.each(function(hash) {
					if ((hash.value.get('type') == 'timestamp') || (hash.value.get('type') == 'date')) {
						var oOption = new Option(hash.value.get('title'), hash.key);
						if (oA.get('record_data_field') == hash.key) {
							oOption.selected = true;
						}
						
						oSelect.options[i++] = oOption;
					}

				});
				
				oValueContainer.insert(oSelect);
			},
			
			addDateTime : function(oAction, oValueContainer) {
			//alert(sName + ':' + sValue);
				oValueContainer.update();
				sValue = oAction.get('deadline_value');
				if (!(/^[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{4}$/.test(sValue))) {
					sValue = '';
				}
				
				oAction.addCalendar({
					mPlace			: oValueContainer.id,
					sInputName		: 'deadline_value',
					sDefaultValues	: sValue/*,
					bTime			: true*/
				});

			},
			
			
			clear : function(oValueContainer) {
				oValueContainer.update(aGlobalMsfWords["WFA_REMIND_VALUE_CONTAINER_NO"]);
			}
			
		};
		
		oHandler.clear(oValueContainer);
		
		oType.onchange = function(oHandler, oType, oValueContainer, aFields) {
 			var sName 	= this.makeName('deadline_value');
			var sValue	= this.get('deadline_value');
			switch (oType.value) {
				case 'dateTimeField':
					oHandler.addDateTimeField(oValueContainer, aFields, sName, sValue);
					break;
				case 'after':
					oHandler.addAfter(oValueContainer, this);
					break;
				case 'dateTime':
					oHandler.addDateTime(this, oValueContainer);
					break;
				default:
					oHandler.clear(oValueContainer);
					break;
			}

		}.bind(this, oHandler, oType, oValueContainer, aFields);
		
		
		oType.name 			= this.makeName('deadline_type');
		oType.id			= this.makeId('control-deadline_type');
		hTypes.each(function(h) {
			var oOption 		= new Option(h.value, h.key);
			oType.options[i] 	= oOption;
			if (h.key == sDeadlineType) {
				oOption.selected = true;
				oType.onchange(oHandler, oType, oValueContainer, aFields);
			}

			i++;
		}.bind(this));

	}

});