<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="action[@type='control']">
		<form style="display: none" id="action_window_{@id}" method="post" action="{@url}">
			<script src="/modules/workflow/actions/control/default/StartCountBack.js?v={/page/module/@systemVersion}"></script>
			<style>
				.control-top-panel {
					width:100%;
					border:0px solid #cccccc;
					border-bottom-width:1px;
				}
				
				.control-top-panel td {
					padding-bottom:10px;
				}
				.control-center-panel {
					width:100%;
					border:0px solid #cccccc;
					border-bottom-width:1px;
					margin-top:5px;
					margin-bottom:5px;
				}
				.control-center-panel td {
					padding-top:5px;
					padding-bottom:5px;
				}
				
				.control-bottom-panel {
					padding-top:10px;
				}
				
				.control-deadline {
					text-align:right;
					vertical-align:middle;
				}
				
				.control-clock {
					color:#a9a9a9;
				}
				
			</style>
			<table style="width:400px; margin:10px"><tr><td>
				<table class='control-top-panel' width="100%">
					<tr>
						<td>
							
							<xsl:choose>
								<xsl:when test="item[@name='status']/@value = 'disabled'">
									<input id="control-status-{@id}" name="status" style="display:none;" value="disabled"/>
									<input id="control-switcher-{@id}" type="button" value="{$WFA_REMIND_ON}" onclick="enableOrDisableControl('{@id}')"/>	
								</xsl:when>
								<xsl:otherwise>
									<input id="control-status-{@id}" name="status" style="display:none;" value="enabled"/>
									<input id="control-switcher-{@id}" type="button" value="{$WFA_REMIND_OFF}" onclick="enableOrDisableControl('{@id}')"/>
								</xsl:otherwise>
							</xsl:choose>

						</td>
						<td class="control-deadline" align="right">
							<xsl:value-of select="$WORKFLOW_REMIND_SPA_DEADLINE"/>&#160;<span id="control-clock-{@id}" class="control-clock"></span>
							<script>
								StartCountDown(
										'control-clock-<xsl:value-of select="@id"/>',
										"<xsl:value-of select="item[@name='datetime']/@value"/>"
										);
							</script>
						</td>
					</tr>
				</table>
				<div id="control-container-{@id}">
					<table class='control-center-panel'>
						<tr id="control-controller-row">
							<td id="control-controller-title">
								<xsl:attribute name="style">
									<xsl:if test="item[@name='show_controler']/@value = 'off'">
										display:none;
									</xsl:if>
								</xsl:attribute>
								<xsl:value-of select="$WFA_CONTROL_CONTROLLER"/>
							</td>
							<td id="control-controller-container-{@id}">
								<xsl:attribute name="style">
									<xsl:if test="item[@name='show_controler']/@value = 'off'">
										display:none;
									</xsl:if>
								</xsl:attribute>
							</td>
							<script type="text/javascript">
								var oStructure = new MSFW.Placeholder.Structure({
									"Container"		: 	'control-controller-container-<xsl:value-of select="@id"/>',			
									"inputName"		: 	'controller',			
									"default"		: 	"<xsl:value-of select="item[@name='controller']/@value"/>",
									"multiselect" 	: 	true,
									"showPosts" 	: 	true
								});						
							</script>
						</tr>
						<tr>
							<td><xsl:value-of select="$WFA_CONTROL_EXECUTOR"/>:</td>
							<td id="control-executor-container-{@id}"></td>
							<script type="text/javascript">
							var oStructure = new MSFW.Placeholder.Structure({
								"Container"		: 	'control-executor-container-<xsl:value-of select="@id"/>',			
								"inputName"		: 	'executor',			
								"default"		: 	"<xsl:value-of select="item[@name='executor']/@value"/>",
								<xsl:choose>
									<xsl:when test="item[@name='executor_optional']/item[@name='multiselect']/@value = 0">
										"multiselect": false,
									</xsl:when>
									<xsl:otherwise>
										"multiselect": true,
									</xsl:otherwise>
								</xsl:choose>
								"showPosts" 	: 	true
							});
							</script>
						</tr>
						<tr>
							<td><xsl:value-of select="$WFA_CONTROL_DATE"/>:</td>
							<td id="control_calendar_container_{@id}"></td>
							<script type="text/javascript">
							var sId = 'control_calendar_container_<xsl:value-of select="@id"/>';
							var oP	= new MSFW.Placeholder.Calendar({
								"Container" : sId,
								"inputName" : 'datetime',
								"time"		: true,
								"default" 	: '<xsl:value-of select="item[@name='datetime']/@value"/>'
							});
							oP.addEventListener("buttonafterclick", function() {
								StartCountDown(
										'control-clock-<xsl:value-of select="@id"/>',
										oP.getInput().getHtmlInput().value
										);
							});
	
							</script>
						</tr>
						<tr id="control-mailing-number-row">
							<xsl:attribute name="style">
								<xsl:if test="item[@name='show_mails']/@value = 'off'">
									display:none;
								</xsl:if>
							</xsl:attribute>
							<td id="control-mailing-number-title"><xsl:value-of select="$WFA_CONTROL_REMIND_KOL"/></td>
							<td id="control-mailing-number-container-{@id}"></td>
							<script>
							var oBeforeContainer 	= $('control-mailing-number-container-<xsl:value-of select="@id"/>');
							var oInput 				= new Element('INPUT');
							oInput.name				= 'number_of_mails';
							oInput.value			= '<xsl:value-of select="item[@name='number_of_mails']/@value"/>'
							oInput.style.textAlign	= "left";
							oInput.maxLength		= "3";
							oBeforeContainer.insert(oInput);
							oInput.onkeypress = function(e) {
								var e = (!e) ? window.event : e;
								var keyCode = (e.charCode > e.keyCode) ? e.charCode : e.keyCode;
								if (keyCode == 9) {
									return true;
								}
								if (
								((keyCode &gt;= 48) &amp;&amp; (keyCode &lt;= 57)) || 
								(keyCode == 8) || (keyCode == 46)|| 
								(keyCode == 37)|| 
								(keyCode == 39)
								) {
									if (this.value.charAt(0) == '0') {	
										this.value = '';
									}
									
									return true;
								} else {
									oMe = this;
									oMe.style.backgroundColor = 'red';
									setTimeout(function() {oMe.style.backgroundColor = 'white';}, 500);
									return false;
								}
								
							};
							
							oInput.onchange = function(e) {
								this.value = parseInt(this.value);
								if (isNaN(this.value)) { 
									this.value = '';
								}
								
							};
							</script>
						</tr>
					</table>
				</div>
				<div class='control-bottom-panel'>
					<input type="submit" value="OK" onclick="oneClickHandler(this)"/>
				</div>
			</td></tr></table>
			<script>
			controlFirstRun('<xsl:value-of select="@id"/>');
			</script>
		</form>
	</xsl:template>
</xsl:stylesheet>