<?php
require_once "modules/workflow/actions/control/WFA_Control.php";
class WFA_ControlVar extends WF_VarsSupport implements WF_IVariable
{
	private $sHeadId;
	
	private $sBodyId;
	
	public function getHtml()
	{
		static $iId		= 0;
		$iDocumentId 	= $this->getActionSupport()->getDocument()->getDocumentId();
		$oControl 		= new WF_Control();
		if ($oControl->isControlled($iDocumentId)) {
			$this->sHeadId 	= 'wfa_control_head_' . $iId;
			$this->sBodyId 	= 'wfa_control_body_' . $iId;
			$aControl	 	= $oControl->findOneByDocumentId($iDocumentId);
			$oFinishDate 	= new MSF_Date($aControl['finish_at']);
			$iId++;
			$sStr = $this->makeValue(
					$this->structureValueToTitle($aControl['controller']),
					$this->structureValueToTitle($aControl['executor']),
					$oFinishDate->format('d.m.Y H:i')
					);
			$sStr = "<span id='wfa_control_span_" . $iId . "'>" .  $sStr . $this->scriptAlign($iId) . "</span>"; 
			return $sStr;
		}
		else {
			return '';
		}
	
	}
	
	private function getHtmlHead()
	{
		return '<div id="' . $this->sHeadId . '" onclick="' . $this->showHideJs() . '" style="font-weight:bold;border:1px solid #a9a9a9;cursor:pointer;color:#c24e4e;background-color:#f5f5f5;padding:4px;width:400px">' 
                            . MSF_Registry::get("MSF_Locale")->getWord("ACTION_CONTROL_VAR_ON") . '</div>';
	}
	
	private function makeValue($sController, $sExecutor, $sFinishAt)
	{
		$sHead = '<tr><td>' . $this->getHtmlHead() . '</td></tr>';
		$sBody = '<tr><td>' . $this->getHtmlBody($sController, $sExecutor, $sFinishAt) . '</td></tr>';
		return '<table width="400px">' . $sHead . $sBody . '</table>';
	}
	
	private function getHtmlBody($sController, $sExecutor, $sFinishAt) 
	{
		if (!empty($sController)) {
			$sController 	= '<tr><td>' . MSF_Registry::get('MSF_Locale')->getWord("WFA_CONTROL_CONTROLLER") . '</td><td>' . $sController . '</td></tr>';
		}
		
		if(!empty($sExecutor)) {
			$sExecutor 		= '<tr><td>' . MSF_Registry::get('MSF_Locale')->getWord("WFA_CONTROL_EXECUTOR") . ':</td><td>' . $sExecutor . '</td></tr>';
		}
		
		$sFinishAt 		= '<tr><td>' . MSF_Registry::get('MSF_Locale')->getWord("WFA_CONTROL_DATE") . ':</td><td>' . $sFinishAt . '</td></tr>';
		return '<div id="' . $this->sBodyId . '" style="display:none;"><table style="background-color: #fff;">' . $sController . $sExecutor . $sFinishAt . '</table></div>';
	}
	
	public function getValue()
	{
		return WFA_AuthorVar::getValue();
	}
	
	private function showHideJs() 
	{
		// return "($('".$this->sBodyId."').style.display == 'none') ? Effect.BlindDown($('".$this->sBodyId."')) : Effect.BlindUp($('".$this->sBodyId."'))";
		return "($('".$this->sBodyId."').style.display == 'none') ? MSF_Effect.show($('".$this->sBodyId."')) : MSF_Effect.hide($('".$this->sBodyId."'))";
	}
	
	private function structureValueToTitle($sStructureValue)
	{
		$oRv = new REF_Value();
		$oRv->parse($sStructureValue);
		return implode(', ', $oRv->getValuesList());
	}
	private function scriptAlign($iId) {
		return	"<script>" .
				"var spanParent = $('wfa_control_span_".$iId."').parentNode;" .
				"var spanChild = $('wfa_control_span_".$iId."').childNodes[0];" .
				"if (spanParent.style.textAlign=='right') spanChild.align = 'right';" .
				"</script>";
	}

}

?>