<?php

class WFA_DocumentsFamilyVar extends WF_VarsSupport implements WF_IVariable
{
	private $aTree 			= array();
	
	private $aDocuments 	= array();
	
	private $bVisible		= false;

	public function getHtml()
	{
		$aTree 	= MSF_XmlWrapper::xmlToArray($this->getActionSupport()->getDocument()->getFamilyTree());
		if (isset($aTree["root"])) {
			$aRoot 	= $aTree["root"]["value"];
			$this->aDocuments = $this->selectDocuments($this->getIds($aRoot));
			
			if (count($aRoot[0]["node"]) > 0) {
				$sHtml = $this->makeHtml($aRoot, 0);
				if ($this->bVisible) {
					return $sHtml;
				}
			}
			
		}

		return "";
	}
	
	private function getIds($aNodeSet)
	{
		$aResult = array();
		
		foreach ($aNodeSet as $aNode) {
			$aResult[] = $aNode["id"];
			if (count($aNode["node"]) > 0) {
				$aResult = array_merge($aResult, $this->getIds($aNode["node"]));
			}
		}
		
		return $aResult;
	}
	
	private function selectDocuments($aIds)
	{
		$aIds[] = 0;
		
		$sSql = "SELECT\n" .
					"document_id,\n" .
					"title\n" .
				"FROM\n" .
					"wf_documents\n" .
				"WHERE\n" .
					"document_id IN(" . implode(",", $aIds) . ")";
		
		return MSF_Registry::get("MSF_DB")->select($sSql);
	}
	
	private function makeHtml($aNodeSet, $iDeepness = 0)
	{
		if ($iDeepness > 0) {
			$iMargin = $iDeepness * 10;
			$sHtml = "<span style='margin: 0 " . $iMargin . "px 0 " . $iMargin . "px;'>";
		}
		else {
			$sHtml = "<span>";
		}

		foreach ($aNodeSet AS $aNode) {
			if (isset($aNode["visible"]) && $aNode["visible"] == 0) {
		
			}
			else {
				$sLink = $this->getUrl($aNode["id"]);
				if ($sLink != NULL) {
					if ($iDeepness > 0) {
						$sHtml .= "<br><span style='margin: 0 " . $iMargin . "px 0 " . $iMargin . "px;'> - ";
					}
					else {
						$sHtml .= "<span>";
					}
					
					$sHtml .= $sLink;
					$sHtml .= "</span>";
				}
			}
			if (count($aNode["node"]) > 0) {
				$sHtml .= $this->makeHtml($aNode["node"], $iDeepness + 1);
			}
			
		}
		
		if ($iDeepness > 0) {
			$sHtml .= "</span>";
		}
		else {
			$sHtml .= "</span>";
		}
		return $sHtml;
	}
	
	private function getUrl($iDocumentId)
	{
		if ($iDocumentId == $this->getActionSupport()->getDocument()->getDocumentId()) {
			return htmlspecialchars($this->getActionSupport()->getDocument()->getRowTitle());
		}
		else {
			for ($i = 0; $i < count($this->aDocuments); $i++) {
				if ($this->aDocuments[$i]["document_id"] == $iDocumentId) {
					$this->bVisible = true;
					return "<a href=\"/workflow/document/view/" . $iDocumentId . "\">" . $this->aDocuments[$i]["title"] . "</a>";
				}
			}
		}
		
	}
	
	public function getValue()
	{
		return "WFA_DocumentsFamilyVar::getValue()";
	}
	
}

?>