var WFA_DecisionSpa = Class.create();
WFA_DecisionSpa.prototype = Object.extend(new WF_AbstractForm(), {
    build: function()
    {
        this.iVariants 		= 0;
        var me 				= this;
        var Container 		= this.clone('decision_form');
        var WindowTitle 	= this.getById('decision_window_title');
        var Comment 		= this.getById('decision_comment');
        var File 			= this.getById('decision_file');
        var AddVariant 		= this.getById('decision_variant_add_link');
        var VContainer 		= this.getById('decision_variants_container');
        var VTContainer 	= this.getById('decision_variants_titles_container');
		
        this.initDSF();
        var aToDisable = [
        this.getById('decision_show_comment_yes'),
        this.getById('decision_show_comment_no'),
        this.getById('decision_show_file_yes'),
        this.getById('decision_show_file_no')
        ];
        this.setRadioAttributes(
            this.getById('decision_show_action_yes', this.getName('visible')),
            this.getById('decision_show_action_no', this.getName('visible')),
            this.getValue('visible'),
            aToDisable
            );
        this.getById('decision_show_action_yes').onclick = function() {
            me.disableElements(aToDisable, false)
        };
        this.getById('decision_show_action_no').onclick = function() {
            me.disableElements(aToDisable, true)
        };
		
        this.setRadioAttributes(
            this.getById('decision_show_comment_yes', this.getName('visible_comment')),
            this.getById('decision_show_comment_no', this.getName('visible_comment')),
            this.getValue('visible_comment')
            );
        this.setRadioAttributes(
            this.getById('decision_show_file_yes', this.getName('visible_file')),
            this.getById('decision_show_file_no', this.getName('visible_file')),
            this.getValue('visible_file')
            );
        this.setRadioAttributes(
            this.getById('decision_send_yes', this.getName('send_notify')),
            this.getById('decision_send_no', this.getName('send_notify')),
            this.getValue('send_notify')
            );
        this.setRadioAttributes(
            this.getById('decision_comment1_yes', this.getName('comment1')),
            this.getById('decision_comment1_no', this.getName('comment1')),
            this.getValue('comment1')
            );
        if($('use_eds_yes') != null){
        this.setRadioAttributesDefaultNo(
            this.getById('use_eds_yes', this.getName('use_eds')),
            this.getById('use_eds_no', this.getName('use_eds')),
            this.getValue('use_eds')
            );
        }
        WindowTitle.name 	= this.getName('window_title');
        WindowTitle.value 	= this.getValue('window_title');
        Comment.name 		= this.getName('comment');
        Comment.value 		= this.getValue('comment');
		
        AddVariant.onclick = function()
        {
            me.addVariant(VContainer, VTContainer);
            me.iVariants++;
            return false;
        }
		
        for (var i = 0; i < 100; i++) {
            var sTitle 	= this.getValue('title', 'variant_' + i);
            var sText 	= this.getValue('text', 'variant_' + i);
            var sPoint 	= this.getValue('stop', 'variant_' + i);
			
            if (sTitle != '' || sText != '' || sPoint != '') {
                this.addVariant(VContainer, VTContainer, i);
                this.iVariants++;
            }
			
        }
		
        return Container;
    },
	
    disableElements: function(aToDisable, bDisable)
    {
        for (var i = 0; i < aToDisable.length; i++) {
            aToDisable[i].disabled = bDisable;
        }
    },
	
    setRadioAttributes: function(Obj1, Obj2, sValue, aToDisable)
    {
        switch (sValue) {
            case '0':
                Obj1.checked = false;
                Obj2.checked = true;
                break;
            default:
                Obj1.checked = true;
                Obj2.checked = false;
                break;
        }
		
        if (aToDisable) {
            if (sValue == '0') {
                this.disableElements(aToDisable, true);
            }
        }
    },
    setRadioAttributesDefaultNo: function(Obj1, Obj2, sValue, aToDisable)
    {
        switch (sValue) {			
            case '1':
                Obj1.checked = true;
                Obj2.checked = false;
                break;
            default:
                Obj1.checked = false;
                Obj2.checked = true;
                break;
        }
		
        if (aToDisable) {
            if (sValue == '0') {
                this.disableElements(aToDisable, true);
            }
        }
    },
    addVariant: function(VContainer, VTContainer, i)
    {
        var tmp 	= this.iCount + '_' + this.iVariants;
        var me 		= this;
        var Variant = $('decision_variant_body');
        var VR 		= $('decision_variants_selected');
        VR 			= WF_ModifyClonedForm.start(VR.cloneNode(true), tmp, null, null, true);
        Variant 	= WF_ModifyClonedForm.start(Variant.cloneNode(true), tmp);
        VContainer.appendChild(Variant);
        VTContainer.appendChild(VR);
		
        var VarNumber 	= this.getVar('decision_variant_title_number');
        var VarTitle 	= this.getVar('decision_variant_title');
        var VarText 	= this.getVar('decision_variant_text');
        var VarStop 	= this.getVar('decision_variant_stop_document');
        var VarDelete 	= this.getVar('decision_variant_delete');
        var sGroupName 	= 'variant_' + this.iVariants;
		
        VarNumber.appendChild(document.createTextNode((this.iVariants + 1)));
        VarTitle.name 	= this.getName('title', sGroupName);
        VarTitle.value 	= this.getValue('title', 'variant_' + i);
        VarText.name 	= this.getName('text', sGroupName);
        VarText.value 	= this.getValue('text', 'variant_' + i);
        VarStop.name 	= this.getName('stop', sGroupName);
		
        VarStop.value 	= this.getValue('stop', 'variant_' + i);
        /*
		if (this.getValue('variant_' + this.iVariants, 'stop')) {
			VarStop.checked = true;
		}
		*/
		
        var Radio 	= this.getVar('variant_selected');
        var Title 	= this.getVar('decision_variant_title_selected_number');
        Radio.name 	= this.getName('selected_variant');
        Radio.value = "variant_" + this.iVariants;
        if (Radio.value == this.getValue('selected_variant')) {
            Radio.checked = true;
        }
        Title.appendChild(document.createTextNode((this.iVariants + 1)));
        this.checkedFirstRadiobatton(VTContainer, tmp, false);
		
        VarDelete.onclick = function()
        {
            if (confirm(aGlobalMsfWords['WORKFLOW_DOCTYPE_SPA_DECISION_DELETE_MESSAGE'])) {
                me.checkedFirstRadiobatton(VTContainer, tmp, true);
                VContainer.removeChild(Variant);
                VTContainer.removeChild(VR);
            }			
            return false;
        }
		
        Variant.show();
        VR.show();
    },
	
    getVar: function(sId)
    {
        return $(sId + '_' + this.iCount + '_' + this.iVariants);
    },
	
    checkedFirstRadiobatton: function(VTContainer, tmp, bDel)
    {
        var isCheckDel = (bDel && $("variant_selected_" + tmp).value == this.getValue('selected_variant')); // proveriaet udalenie vibrannogo varianta
        if (this.getValue('selected_variant') == "" || isCheckDel) {
            var aInput = VTContainer.getElementsByTagName("input");
            if (aInput.length > 0) {
                aInput[0].checked = true;
            }
        }
    },
	
    /**
	 * Adds fields to the digital sign
	 * @return void
	 */
    initDSF : function()
    {
        var me = this; 
        ({
            /**
			 * @var DomElement TAG SELECT
			 */
            oView			: me.getById('decision_dsf_view'),
			
            /**
			 * @var DomElement TAG INPUT TYPE = HIDDEN
			 */
            oContent		: me.getById('decision_dsf_content'),
			
            /**
			 * @var string TAG INPUT TYPE = HIDDEN
			 */
            sDefaultValue	: me.getValue('dsf_content'),
			
            /**
			 * @var Hash Prototypejs hash
			 */
            hFields			: me.__hAllDTFields.get('all').get(
                me.__hAllDTFields.get('current').get('doctypeId')
                ).get('fields'),
	
            init : function()
            {
                this.oContent.name = me.getName("dsf_content");
                return this;
            },
						
            view : function()
            {
                this.hFields.each(function(oHash) {
                    if (typeof(oHash.value) != "function") {
                        var i = this.oView.options.length;		
                        this.oView.options[i] = new Option(oHash.value.get('title'), oHash.key)
                        if (this.sDefaultValue.indexOf(oHash.key) != -1) {
                            this.oView.options[i].selected = true;
                        }
                    }

                }.bind(this));
				
                return this;
            },
			
            model : function()
            {
                this.oView.onchange = function() {
                    var aResult = [];
                    for (i = 0; i < this.oView.options.length; i++) {
                        if (this.oView.options[i].selected) {
                            aResult.push(this.oView.options[i].value);
                        }
						
                    }		
						
                    this.oContent.value = aResult.join(',');		
                }.bind(this);
				
                // Init default values
                this.oView.onchange();

            }
		
        }).init().view().model();

    }
});