<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="/page/module/actions/item[@name='decision']">
        <table id="decision_form" style="display: none" class="form">            
            <tr>
                <td class="form-row-title" title="{$WORKFLOW_DOCTYPE_DECISION_ACTION_HELP}">
                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DONT_SHOW_ACTION"/>
                </td>
                <td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_VARIANT_RADIO_HELP}">
                    <label>
                        <input id="decision_show_action_yes" type="radio" name="decision_show_action" checked="checked" value="1"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_YES"/>
                    </label>
                    <label>
                        <input id="decision_show_action_no" type="radio" name="decision_show_action" value="0"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_NO"/>
                    </label>
                </td>
            </tr>
            <tr>
                <td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_SHOW_COMMENT_HELP}">
                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_SHOW_COMMENT"/>
                </td>
                <td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_SHOW_COMMENT_HELP}">
                    <label>
                        <input id="decision_show_comment_yes" type="radio" name="decision_show_comment" checked="checked" value="1"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_YES"/>
                    </label>
                    <label>
                        <input id="decision_show_comment_no" type="radio" name="decision_show_comment" value="0"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_NO"/>
                    </label>
                </td>
            </tr>
            <tr>
                <td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_SHOW_FILE_HELP}">
                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_SHOW_FILE"/>
                </td>
                <td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_SHOW_FILE_HELP}">
                    <label>
                        <input id="decision_show_file_yes" type="radio" name="decision_show_file" checked="checked" value="1"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_YES"/>
                    </label>
                    <label>
                        <input id="decision_show_file_no" type="radio" name="decision_show_file" value="0"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_NO"/>
                    </label>
                </td>
            </tr>
            <tr>
                <td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_SEND_NOTIFY_HELP}">
                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_SEND_NOTIFY"/>
                </td>
                <td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_SEND_NOTIFY_HELP}">
                    <label>
                        <input id="decision_send_yes" type="radio" name="decision_send" checked="checked" value="1"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_YES"/>
                    </label>
                    <label>
                        <input id="decision_send_no" type="radio" name="decision_send" value="0"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_NO"/>
                    </label>
                </td>
            </tr>
			
            <tr>
                <td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_LIKE_A_COMMENT_HELP}">
                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_LIKE_A_COMMENT"/>
                </td>
                <td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_LIKE_A_COMMENT_HELP}">
                    <label>
                        <input id="decision_comment1_yes" type="radio" name="decision_comment1" checked="checked" value="1"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_YES"/>
                    </label>
                    <label>
                        <input id="decision_comment1_no" type="radio" name="decision_comment1" value="0"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_NO"/>
                    </label>
                </td>
            </tr>
            <tr>
                <td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_WINDOW_TITLE_HELP}">
                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_WINDOW_TITLE"/>
                </td>
                <td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_WINDOW_TITLE_HELP}">
                    <input type="text" id="decision_window_title" style="width: 90%"/>
                </td>
            </tr>
            <tr>
                <td class="form-row-title" title="{$DIGITAL_SIGN_FIELDS_HELP}">
                    <xsl:value-of select="$DIGITAL_SIGN_FIELDS"/>
                </td>
                <td class="form-row-value" title="{$DIGITAL_SIGN_FIELDS_HELP}">
                    <select id="decision_dsf_view" multiple ="yes" style="width:90%;"></select>
                    <input id="decision_dsf_content" type="text" style="display:none;"/>
                </td>
            </tr>
            <xsl:if test="@use_eds = '1'">
            <tr>
                <td class="form-row-title" title="{$DIGITAL_SIGN_USE_EDS_HELP}">
                    <xsl:value-of select="$DIGITAL_SIGN_USE_EDS"/>
                </td>
                <td class="form-row-value" title="{$DIGITAL_SIGN_USE_EDS_HELP}"> 
                    <label>
                        <input id="use_eds_yes" type="radio" name="decision_use_eds" value="1"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_YES"/>
                    </label>
                    <label>
                        <input id="use_eds_no" type="radio" name="decision_use_eds" checked="checked" value="0"/>
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_NO"/>
                    </label>
                    
                </td>
            </tr>
            </xsl:if>
            <tr>
                <td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_ADD_VARIANT_HELP}">
                    <a href="#" id="decision_variant_add_link" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_ADD_VARIANT_HELP}">
                        <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_ADD_VARIANT"/>
                    </a>
                </td>
                <td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_ADD_VARIANT_HELP}">
                </td>
            </tr>
            <tr>
                <td id="decision_variants_container" colspan="2">
                </td>
            </tr>
            <tr>
                <td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_COMMENT_HELP}">
                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_COMMENT"/>
                </td>
                <td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_COMMENT_HELP}">
                    <textarea id="decision_comment" style="width: 90%; height: 100px"></textarea>
                </td>
            </tr>
			<!-- 
			<tr>
				<td class="form-row-title">
					<xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_FILE"/>
				</td>
				<td class="form-row-value">
					<input type="file" id="decision_file"/>
				</td>
			</tr>
			 -->
            <tr>
                <td colspan="2" id="decision_variants_titles_container">
                </td>
            </tr>
        </table>

        <table class="form" id="decision_variant_body" style="display: none">
            <tr>
                <td class="form-row-title">
                    <fieldset>
                        <legend>
							&#160;
                            <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_VARIANT"/>
                            <span id="decision_variant_title_number"></span>
							&#160;
                        </legend>
                        <table class="form">
                            <tr>
                                <td></td>
                                <td></td>
                                <td rowspan="3" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_VARIANT_DELETE_HELP}">
                                    <input type="button" id="decision_variant_delete">
                                        <xsl:attribute name="value">
                                            <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_DELETE_VARIANT"/>
                                        </xsl:attribute>
                                    </input>
                                </td>
                            </tr>
                            <tr>
                                <td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_VARIANT_TITLE_HELP}">
                                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_TITLE"/>
                                </td>
                                <td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_VARIANT_TITLE_HELP}">
                                    <input type="text" id="decision_variant_title"/>
                                </td>
                            </tr>
                            <tr>
                                <td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_VARIANT_TEXT_HELP}">
                                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_TEXT"/>
                                </td>
                                <td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_VARIANT_TEXT_HELP}">
                                    <input type="text" id="decision_variant_text"/>
                                </td>
                            </tr>
							<!-- 
							<tr>
								<td class="form-row-title">
									<xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_STOP"/>
								</td>
								<td class="form-row-value">
									<input type="checkbox" id="decision_variant_stop_document"/>
								</td>
							</tr>
							 -->
                            <tr>
                                <td class="form-row-title" colspan="2" title="{$WORKFLOW_DOCTYPE_SPA_DECISION_VARIANT_POINT_HELP}">
                                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_MOVE_TO"/>
									&#160;
                                    <input id="decision_variant_stop_document" style="width: 20px"/>
									&#160;
                                    <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_MOVE_TO_POINTS"/>
                                </td>
                            </tr>
                        </table>
                    </fieldset>
                </td>
            </tr>
        </table>

        <div id="decision_variants_selected" style="display: none">
            <label>
                <input type="radio" id="variant_selected" name="selected"/>
                <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_VARIANT"/>
                <span id="decision_variant_title_selected_number"></span>
            </label>
        </div>
    </xsl:template>
</xsl:stylesheet>