<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="action[@type='decision']">        
        <form method="post" action="{@url}" id="action_window_{@id}" style="display: none" enctype="multipart/form-data">
            <script>
                function addDecisionFileField_<xsl:value-of select="@id"/>()
                {
                var Table 	= $('decision_action_window_table_<xsl:value-of select="@id"/>');
                var Tr 		= Table.insertRow($A(Table.rows).size());
                var Img 	= new Element('img', {
                'src': '/templates/default/images/red_cross.png',
                'style': 'cursor: pointer'
                });
					
                Img.onclick = function()
                {
                removeDecisionFileField_<xsl:value-of select="@id"/>(this);
                }
					
                $(Tr.insertCell(0)).insert(new Element('input', {'type': 'file', 'name': 'decision_file[]'}));
                $(Tr.insertCell(1)).insert(Img);
                }
				
                function removeDecisionFileField_<xsl:value-of select="@id"/>(img)
                {
                $('decision_action_window_table_<xsl:value-of select="@id"/>').deleteRow($(img).parentNode.parentNode.rowIndex);
                }
				
                function clearDecisionFileField_<xsl:value-of select="@id"/>(){
                var oPrnt = $('main');
                var oInp1 = oPrnt.getElementsByTagName('INPUT')[0];
                oPrnt.removeChild(oInp1);
                var oInp2 = new Element('INPUT', {
                type	:'file',
                name 	: 'decision_file[]'
                });
                oPrnt.insert(oInp2);
                }
            </script>
            <xsl:variable name="decision_action_id">
                <xsl:value-of select="@id"/>
            </xsl:variable>
            <table width="500px">
                <xsl:if test="item[@name='variant_0']">
                    <tr>
                        <td>
                            <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DECISION_VARIANTS"/>
                        </td>
                        <td>
                            <xsl:variable name="decision_selected_variant">
                                <xsl:choose>
                                    <xsl:when test="/page/module/decision_actions/item[@id=$decision_action_id]">
                                        <xsl:value-of select="/page/module/decision_actions/item[@id=$decision_action_id]/@selected_variant"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:value-of select="item[@name='selected_variant']/@value"/>
                                    </xsl:otherwise>
                                </xsl:choose>
                            </xsl:variable>
                            <div id="variant_cont_{@id}"/>
                            <script>
                                function createRadio(sName) {
									var oCont = $("variant_cont_" + "<xsl:value-of select="@id"/>");
                                oCont.update();
                                var i = 0;
                                <xsl:for-each select="item[@name=contains(@name, 'variant_')]">
                                    var oDiv	= new Element("DIV");
                                    var oInput  = new Element("INPUT", {"type":"radio",
                                    "name":"decision_variant",
																			"value":"<xsl:value-of select="@name"/>",
																			"onclick":"createRadio('<xsl:value-of select="@name"/>')"}
                                    );
										if ('<xsl:value-of select="@name"/>' == sName) {
                                    oInput.defaultChecked = true;
                                    oInput.checked = true;
                                    }
                                    oDiv.insert(oInput);
										oDiv.insert("<xsl:value-of select="item[@name='title']/@value"/>");
                                    oCont.insert(oDiv);
                                    i++;
                                </xsl:for-each>
                                }
								createRadio('<xsl:value-of select="$decision_selected_variant"/>');
                            </script>
                        </td>
                    </tr>
                </xsl:if>
                <xsl:if test="item[@name='use_eds']/@value = 1">
                    <xsl:if test="string-length(item[@name='dsf_content']/@value) > 1">
                        <tr>
                            <td>
                                <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DS"/>
                            </td>
                            <td>
                                <input type="checkbox" name="use_eds" id="use_eds" value="0"/>
                                <div id="eds_error" style="display:none;color:red; font-size:12px;"><xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_DS_ERROR"/></div>
                                <input type="hidden" name="hash_value" id="hash_value" value="{item[@name='hash_for_sign']/@value}"/>
                                <input type="hidden" name="fields_value" id="fields_value" value="{item[@name='fields_for_hash']/@value}"/>
                                <input type="hidden" name="eds_sign_cert" id="eds_sign_cert"/>                                
                            </td>
                        </tr>
                    </xsl:if>
                </xsl:if>
                <xsl:if test="item[@name='visible_comment']/@value=1">
                    <tr>
                        <td>
                            <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_COMMENT"/>
                        </td>
                        <td>                            
                            <textarea name="decision_comment" style="height: 150px; width: 350px">
                                <xsl:choose>
                                    <xsl:when test="/page/module/decision_actions/item[@id=$decision_action_id]">
                                        <xsl:value-of select="/page/module/decision_actions/item[@id=$decision_action_id]/@comment"/>
                                    </xsl:when>
                                    <xsl:otherwise>
                                        <xsl:value-of select="item[@name='comment']/@value"/>
                                    </xsl:otherwise>
                                </xsl:choose>
                            </textarea>
                        </td>
                    </tr>
                </xsl:if>
                <xsl:if test="item[@name='visible_file']/@value=1">
                    <tr>
                        <td>
                            <xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_FILE"/>
                        </td>
                        <td>
                            <table id="decision_action_window_table_{@id}">
                                <xsl:choose>
                                    <xsl:when test="/page/module/decision_actions/item[@id=$decision_action_id]/files/file">
                                        <xsl:for-each select="/page/module/decision_actions/item[@id=$decision_action_id]/files/file">
                                            <tr>
                                                <td style="padding: 5px">
                                                    <a href="/media/download/{@id}" target="_blank">
                                                        <xsl:value-of select="@name"/>
                                                    </a>
                                                    <input type="hidden" name="decision_added_file[name][]" value="{@name}"/>
                                                    <input type="hidden" name="decision_added_file[value][]" value="{@id}"/>
                                                </td>
                                                <td>
                                                    <img src="/templates/default/images/red_cross.png" onclick="removeDecisionFileField_{../../@id}(this)" style="cursor: pointer"/>
                                                </td>
                                            </tr>
                                        </xsl:for-each>
                                    </xsl:when>
                                    <xsl:when test="item[@name='files']">
                                        <xsl:for-each select="item[@name='files']/item">
                                            <tr>
                                                <td style="padding: 5px">
                                                    <a href="/media/download/{item[@name='value']/@value}" target="_blank">
                                                        <xsl:value-of select="item[@name='name']/@value"/>
                                                    </a>
                                                    <input type="hidden" name="decision_added_file[name][]" value="{item[@name='name']/@value}"/>
                                                    <input type="hidden" name="decision_added_file[value][]" value="{item[@name='value']/@value}"/>
                                                </td>
                                                <td>
                                                    <img src="/templates/default/images/red_cross.png" onclick="removeDecisionFileField_{../../@id}(this)" style="cursor: pointer"/>
                                                </td>
                                            </tr>
                                        </xsl:for-each>
                                    </xsl:when>
                                </xsl:choose>
                                <tr>
                                    <td id="main">
                                        <input type="file" name="decision_file[]"/>
                                    </td>
                                    <td>
                                        <img src="/templates/default/images/remove_row.png" onclick="clearDecisionFileField_{@id}()" style="cursor: pointer"/>
                                        <img src="/templates/default/images/add.png" onclick="addDecisionFileField_{@id}()" style="cursor: pointer"/>
                                    </td>
                                </tr>
                            </table>
                        </td>
                    </tr>
                </xsl:if>
                <tr>
                    <td colspan="2">
                        <input type="button" id="submit_button" name="ok" value="OK" onclick="oneClickSubmit(this)"/>
                    </td>
                </tr>
            </table>
        </form>
    </xsl:template>
</xsl:stylesheet>