<?php

defined('__MSF')
        or die('Direct access is not allowed');
include_once "modules/workflow/actions/decision/WFA_Decision.php";
include_once 'system/utils/MSF_String.php';

class WFA_DecisionVar extends WF_VarsSupport implements WF_IVariable {

    public function getHtml() {
        $sHtml = "";
        $aResult = $this->prepare();
        if (!empty($aResult)) {
            $Template = MSF_Registry::get("MSF_Template");
            $Decisions = $Template->createElement("decision_actions");
            $iStructId = $this->getActionSupport()->getStructureId();
            $Template->getModule()->appendChild($Decisions);
            $sStyleSrcTpl = CNF_ABS_PATH . "/modules/workflow/actions/decision/default/style.css";
            $sScriptSrcTpl = CNF_ABS_PATH . "/modules/workflow/actions/decision/WF_DecisionHandler.js";
            $sMainSrcTpl = CNF_ABS_PATH . "/modules/workflow/actions/decision/default/main.tpl";
            $sItemSrcTpl = CNF_ABS_PATH . "/modules/workflow/actions/decision/default/item.tpl";
            $sStyleTpl = MSF_File::read($sStyleSrcTpl);
            $sScriptTpl = MSF_File::read($sScriptSrcTpl);
            $sMainTpl = MSF_File::read($sMainSrcTpl);
            $sItemTpl = MSF_File::read($sItemSrcTpl);
            for ($i = 0; $i < sizeof($aResult); $i++) {
                if (empty($aResult[$i]["value"])) {
                    continue;
                }

                $sHtml .= $this->render(
                        $Template, $sMainTpl, $sItemTpl, $Decisions, $aResult[$i], $iStructId, $i
                );
            }

            $sHtml = "<div>\n"
                    . "<style>\n" . $sStyleTpl . "\n</style>\n"
                    . "<script language=\"javascript\">\n" . $sScriptTpl . "\n</script>\n"
                    . $sHtml
                    . "</div>";
        }

        return $sHtml;
    }

    private function prepare() {
        $aSpaList = $this->getActionSupport()->getSettings()->getPureActions();
        $iSpas = 0;
        $aResult = array();
        foreach ($aSpaList AS $iActionId => $aSpa) {
            if ($aSpa["name"] == "decision") {
                $iPoints = count($this->getActionSupport()->getSettings()->getRoute());
                $aLogs = array();
                $sTitle = trim($aSpa["options"]["window_title"]);
                $aTime = array();
                for ($j = 0; $j < $iPoints; $j++) {
                    $iLogCount = 0;
                    $aLog = $this->getActionSupport()->getDocument()->getLog()->getDelegated($j, $iActionId);
                    if (!empty($aLog["recs"]) && is_array($aLog["recs"])) {
                        foreach ($aLog["recs"] as $iKey => $aValue) {
                            if (isset($aValue["time"])) {
                                $aTime[$iKey][] = $aValue["time"];
                            }
                        }

                        foreach ($aLog["recs"] as $iId => $aValue) {
                            $bBreak = false;
                            if (isset($aValue["time"])) {
                                foreach ($aTime as $iKey => $aTimeValue) {
                                    if ($iId == $iKey) {
                                        foreach ($aTimeValue as $iTimeValue) {
                                            if ($aValue["time"] < $iTimeValue) {
                                                $bBreak = true;
                                                break;
                                            }
                                        }
                                        break;
                                    }
                                }
                                if ($bBreak) {
                                    continue;
                                }
                            }
                            $aValue["spa_id"] = $iActionId;
                            if (isset($aSpa["options"][$aValue["selected_variant"]])) {
                                $aValue["result"] = $aSpa["options"][$aValue["selected_variant"]];
                            }
                            $aLogs[$iLogCount][$iId] = $aValue;
                        }
                        $iLogCount++;
                    }
                }

                if (!empty($aLogs)) {
                    $aResult[$iSpas]["title"] = (empty($sTitle)) ? $aSpa["title"] : $sTitle;
                    $aResult[$iSpas]["value"] = $aLogs;
                    $aResult[$iSpas]["sign"] = WFA_Decision::sign(
                                    $aSpa, $this->getActionSupport()->getDocumentVersion()
                    );
                    $iSpas++;
                }
            }
        }

        // sort
        for ($i = 0; $i < count($aResult); $i++) {
            for ($j = 0; $j < count($aResult[$i]["value"]); $j++) {
                ksort($aResult[$i]["value"][$j]);
            }
        }

        return $aResult;
    }

    private function render($Template, $sMainTpl, $sItemTpl, $Decisions, $aResult, $iStructId, $iId) {
        $documentId = $this->getActionSupport()->getDocumentVersion()->getDocumentId();
        $documentVersionId = $this->getActionSupport()->getDocumentVersion()->getDocumentVersionId();
        $sBuffer = "";
        $sIsNewSign = false;
        $Files = $Template->createElement("files");
        $sDsIs = $this->getDsIs($aResult);
        for ($j = 0; $j < count($aResult["value"]); $j++) {
            foreach ($aResult["value"][$j] as $iActionStructId => $aValue) {
                $Decision = $Template->createElement("item");
                $Decision->appendChild($Files);
                $Decisions->appendChild($Decision);
                if ($iStructId == $iActionStructId) {
                    $Decision->setAttribute("id", $aValue["spa_id"]);
                    $Decision->setAttribute("comment", $aValue["comment"]);
                    $Decision->setAttribute("selected_variant", $aValue["selected_variant"]);
                }

                $sName = $this->getName($aValue);
                $sCreated = $aValue["created_at"];
                $sVote = $this->getVote($aValue);
                $sOpinion = $this->getOpinion($aValue);
                $sAttach = $this->getAttach($Template, $Files, $aValue, $iStructId, $iActionStructId);
                $sDsResult = $this->getDsResult($aResult, $aValue);
                $sDsClass = $this->getDsClass($aResult, $aValue);
                
                $edsHidden = "";
                $sFieldsHashSign = $aValue["sign"];
                if($sFieldsHashSign != ""){
                    $edsHidden = "<input type='hidden' name='".$iActionStructId."_ds_fields' id='".$iActionStructId."_ds_fields' value=$sFieldsHashSign/>";
                }
                if(strpos($sFieldsHashSign, "||")){
                    $sIsNewSign = true;
                }

                $sBuffer .= str_replace(
                        array("{NAME}", "{CREATED}", "{VOTE}", "{OPINION}", "{ATTACH}", "{ID}", "{DS_RESULT}", "{DS_CLASS}","{EDS_HIDDEN}"), 
                        array($sName, $sCreated, $sVote, $sOpinion, $sAttach, $iId, $sDsResult, $sDsClass, $edsHidden), $sItemTpl
                );
            }
        }
        if($sIsNewSign){
            $oLocale = MSF_Registry::get("MSF_Locale");
            $edsAccepted = $oLocale->getWord('DIGITAL_SIGN_EDS_ACCEPTED');
            $edsNotAccepted = $oLocale->getWord('DIGITAL_SIGN_EDS_NOT_ACCEPTED');
            $sMainTpl .= "<script>
                            var eds_accepted = '$edsAccepted';
                            var eds_not_accepted = '$edsNotAccepted';
                            $$('input[id$=\"ds_fields\"]').forEach(function(elem){
                                /*
                                valParams[0] = fieldNames
                                valParams[1] = hash
                                valParams[2] = signature
                                valParams[3] = certPEM
                                */
                                if(elem.value.indexOf('||') != -1){
                                    var valParams = elem.value.split(\"||\");
                                    param = '&documentId=$documentId&documentVersionId=$documentVersionId&fields='+valParams[0]+'&decId='+$(elem).id;
                                    new Ajax.Request(\"/workflow/ajaxHashForSign/\",
                                        {
                                            method 		: \"post\",
                                            parameters: param,
                                            onSuccess 	: function(response){
                                                var decId_ = response.responseText.evalJSON().decId;
                                                var hash_  = response.responseText.evalJSON().data;
                                                var elemVal = $(decId_).value.split('||');
                                                $(decId_).value = elemVal[0]+'||'+hash_+'||'+elemVal[2]+'||'+elemVal[3];
                                                var verifyResult = document.cpapplet.javaScriptCommand('verifyDataSignB64', new Array(hash_, elemVal[2], elemVal[3]));
                                                if(verifyResult){
                                                    $(decId_).up('span').className = 'decision-ds-accepted';
                                                    $(decId_).previous().innerHTML = eds_accepted;                                            
                                                } else {
                                                    $(decId_).up('span').className = 'decision-ds-not-accepted';
                                                    $(decId_).previous().innerHTML = eds_not_accepted;
                                                }
                                            },
                                            onComplete 	: function() {}
                                        }
                                    );
                                }
                            });
                          </script>";
        }
        return str_replace(
                        array("{TITLE}", "{ITEMS}", "{ID}", "{DS_IS}"), array($aResult["title"], $sBuffer, $iId, $sDsIs), $sMainTpl
        );
    }

    public function getValue() {
        return __CLASS__;
    }

    private function getAttach($Template, $Files, $aValue, $iStructId, $iActionStructId) {
        $sAttach = "";
        if (!empty($aValue["files"])) {
            $sAttach = "<div class=\"decision-attach\"><div class=\"decision-attach-title\">" . MSF_Registry::get("MSF_Locale")->getWord('WFA_DECSION_ATTACH') . "</div>" . "<ul class=\"decision-attach-content\">";
            foreach ($aValue["files"] as $aFile) {
                try {
                    $sUri = "/media/download/" . $aFile["value"];
                    $sAttach .= "<li><a href=\"" . $sUri . "\" target=\"_blank\">" . $aFile["name"] . "</a></li>";
                    if ($iStructId == $iActionStructId) {
                        $File = $Template->createElement("file");
                        $File->setAttribute("id", $aFile["value"]);
                        $File->setAttribute("name", $aFile["name"]);
                        $Files->appendChild($File);
                    }
                } catch (Exception $e) {
                    MSF_Logger::logTrace($e);
                }
            }

            $sAttach .= "</ul></div>";
        }

        return $sAttach;
    }

    private function getOpinion($aValue) {
        $sOpinion = "";
        if (isset($aValue["comment"]) && strlen($aValue["comment"]) > 0) {
            $sTemp = MSF_String::breakingLongWords(nl2br(htmlspecialchars($aValue["comment"])));
            $sOpinion = str_replace("  ", "&#160; ", $sTemp);
        }

        return $sOpinion;
    }

    private function getVote($aValue) {
        $sVote = "";
        if (isset($aValue["result"]) && isset($aValue["result"]["text"])) {
            $sVote = $aValue["result"]["text"];
        }

        return $sVote;
    }

    private function getName($aValue) {
        return $aValue["employeeName"] . (!empty($aValue["post"]) ? " (" . $aValue["post"] . ")" : "");
    }

    private function getDsResult($aResult, $aValue) {
        if (!isset($aValue["sign"])) {
            $aValue["sign"] = "none";
        }
        $pos = strpos($aValue["sign"], "||");
        $oLocale = MSF_Registry::get("MSF_Locale");
        if ($aResult["sign"] == "") {
            return "";
        } else if(strpos($aValue["sign"], "||") != false){
            return $oLocale->getWord("DIGITAL_SIGN_WAIT");
        } else if ($aResult["sign"] == $aValue["sign"]) {
            return $oLocale->getWord("DIGITAL_SIGN_ACCEPTED");
        } else {
            return $oLocale->getWord("DIGITAL_SIGN_NOT_ACCEPTED");
        }
    }

    private function getDsClass($aResult, $aValue) {
        if (!isset($aValue["sign"])) {
            $aValue["sign"] = "none";
        }

        if ($aResult["sign"] == "") {
            return "decision-ds-none";
        } else if(strpos($aValue["sign"], "||") != false){
            return "decision-ds-none";
        } else if ($aResult["sign"] == $aValue["sign"]) {
            return "decision-ds-accepted";
        } else {
            return "decision-ds-not-accepted";
        }
    }

    private function getDsIs($aResult) {
        if ($aResult["sign"] == "") {
            return "decision-ds-is-not";
        } else {
            return "decision-ds-is";
        }
    }

}

?>