var WFA_Execution = Class.create();
WFA_Execution.prototype = {

	oStrategy 		: null,
	
	aDoctypes 		: null,
	
	oDoctypeSelect	: null,
	
	aTypes			: null,
	
	
	initialize: function(aDoctypes, oStrategy)
	{
		this.aDoctypes 		= aDoctypes;
		this.oStrategy 		= oStrategy;
		this.oDoctypeSelect = null;
		this.aRecordTypes	= $H({
									"int"     	: "float",
									"float"     : "int",
									"date"		: "timestamp",
									"timestamp" : "date",
									"string"	: "int, float, reference, date, timestamp, bool, structure, enum, document",
									"text"		: "int, float, reference, date, timestamp, bool, structure, enum, document"
								  });
		this.addDocumentSelectWidget();
		this.addDoctypeSelectWidget();
		this.addOperationTypeSelectWidget();
		this.addNumberOfOperationsWidget();						
	},
	
	getDoctypesAsHash: function() {
		var hDoctypes = $H();
		this.aDoctypes.get("all").each(function(hash) {
			hDoctypes.set(hash.key, hash.value.get("title"));
		});

		return hDoctypes;
	},
	
	getDocFields: function() {
		var aDocFields;
		if(typeof(aTypesValues) == "undefined") {
			aDocFields = aFields;	
		}
		else {
			aTypesValues.each(function(hash) {
				if (hash['name'] == 'fields') {
					aDocFields = hash.value;					
				}
			});			
		}
		
		return aDocFields;
	},
	
	addDocumentSelectWidget: function()
	{			
		var aDocFields			= this.getDocFields();		
		var oTypeSelect 		= new Element("SELECT");
		var oStrategy			= this.oStrategy;
		oTypeSelect.name 		= this.oStrategy.getName("document_type");
		oTypeSelect.options[0] = new Option(aGlobalMsfWords["WORKFLOW_NULL"], "");
		oTypeSelect.options[1] 	= new Option(aGlobalMsfWords["WFA_EXECUTION_RELATED_DOCS"], "variable");
		oTypeSelect.options[2]	= new Option(aGlobalMsfWords["WFA_EXECUTION_DOCFIELD"], "exdocument");		
		oStrategy.getById("execution-document-type-port").update(oTypeSelect);		
		
		var oValueSelect 		= new Element("SELECT");
		oValueSelect.name 		= this.oStrategy.getName("document_value");		
		oValueSelect.options[0] = new Option(aGlobalMsfWords["WFA_EXECUTION_PARENT_DOCUMENT"], "parent");
		oValueSelect.options[1] = new Option(aGlobalMsfWords["WFA_EXECUTION_CHILD_DOCUMENTS"], "descendants");
		var oDocFieldSelect		= new Element("SELECT");
		oDocFieldSelect.name 	= this.oStrategy.getName("document_value");
		var oOption = new Option(aGlobalMsfWords["WORKFLOW_NULL"], '');
		var z = 0;		
		oDocFieldSelect.options[z++] = oOption;			
		aDocFields.each(function(hash) {
			if(hash["type"] == "document") {										
				var oOption = new Option(hash['title'], hash['name']);
				oDocFieldSelect.options[z] = oOption;
				if(oStrategy.getValue("document_type") == "exdocument") {
					if(hash['name'] == oStrategy.getValue("document_value")) {
						oDocFieldSelect.options[z].selected = true;	
					}
					
				}
				
				z++;
			}
		});	
		
		switch (this.oStrategy.getValue("document_type")) {
			case "variable":
				oTypeSelect.options[1].selected = true;
				oStrategy.getById("execution-document-value-port").update(oValueSelect);
				switch (this.oStrategy.getValue("document_value")) {
					case "parent":
						oValueSelect.options[0].selected = true;
						break;
					case "descendants":
						oValueSelect.options[1].selected = true;
						break;
				}
				
				break;
			case "exdocument":				
				oTypeSelect.options[2].selected = true;
				oStrategy.getById("execution-document-value-port").update(oDocFieldSelect);			
				break;
			default:
				oStrategy.getById("execution-document-value-port").update();
				break;
		}				
						
		oTypeSelect.onchange = function() {
			var oValuePort = oStrategy.getById("execution-document-value-port");
			if(oTypeSelect.value == "exdocument") {
				oValuePort.update();				
				oValuePort.insert(oDocFieldSelect);
			}
			else if(oTypeSelect.value == "variable") {
				oValuePort.update();
				oValuePort.insert(oValueSelect);
			}
			else {
				oValuePort.update();
			}
			
		}		
				
	},
	
	addDoctypeSelectWidget: function()
	{
		this.oDoctypeSelect				= new Element("SELECT", {className: "form-row-select"});
		var hDoctypes					= this.getDoctypesAsHash();
		var sValue						= this.oStrategy.getValue("doctype_id");
		var i 							= 1;
		this.oDoctypeSelect.name 		= this.oStrategy.getName("doctype_id");
		this.oDoctypeSelect.options[0] 	= new Option(aGlobalMsfWords["WFA_EXECUTION_NOT_SELECTED"], "0");
		hDoctypes.each(function(hash) {
			this.oDoctypeSelect.options[i] = new Option(hash.value, hash.key);
			if (hash.key == sValue) {
				this.oDoctypeSelect.options[i].selected = true;
			}
			
			i++;
			
		}.bind(this));
		
		this.oStrategy.getById("execution-doctype-port").update(this.oDoctypeSelect);
	},
	
	addOperationTypeSelectWidget:function(iDefaultValue)
	{
		var oSelect 			= new Element("SELECT");
		oSelect.name 			= this.oStrategy.getName("operation_type");
		oSelect.options[0]		= new Option(aGlobalMsfWords["WFA_EXECUTION_NOT_SELECTED"], "0");
		oSelect.options[1]		= new Option(aGlobalMsfWords["WFA_EXECUTION_MOVE"], "execution");
		oSelect.options[2]		= new Option(aGlobalMsfWords["WFA_EXECUTION_PERFORM"], "delegation");
		oSelect.options[3]		= new Option(aGlobalMsfWords["WFA_EXECUTION_RECORD"], "extrecord");
		oSelect.onchange		= function() {
			switch (oSelect.value) {
			
				case "execution":
					this.addOperationTypeExecutionSelectWidget();
					this.oStrategy.getById("execution-record-value-port").style.display	  = "none";					
					break;
					
				case "delegation":
					this.addOperationTypeDelegationSelectWidget();
					this.oStrategy.getById("execution-record-value-port").style.display	  = "none";					
					break;
				
				case "extrecord":
					this.addOperationTypeExtrecordSelectWidget();
					break;
				
				default:
					this.oStrategy.getById("execution-operation-value-port").update();
					this.oStrategy.getById("execution-record-value-port").style.display	= "none";
					break;
			}
			
		}.bind(this);
		
		this.oDoctypeSelect.onchange = function() {
			if (oSelect.value != 0) {
				if (oSelect.value == "execution") {
					this.addOperationTypeExecutionSelectWidget();
					this.oStrategy.getById("execution-record-value-port").style.display	  = "none";					
				}
				if (oSelect.value == "delegation") {
					this.addOperationTypeDelegationSelectWidget();
					this.oStrategy.getById("execution-record-value-port").style.display	  = "none";					
				}
				if (oSelect.value == "extrecord") {
					this.addOperationTypeExtrecordSelectWidget();
				}
								
			}
		}.bind(this);
		
		
		
		switch (this.oStrategy.getValue("operation_type")) {
			case "execution":
				oSelect.options[1].selected = true;
				this.addOperationTypeExecutionSelectWidget();
				break;
			case "delegation":
				oSelect.options[2].selected = true;
				this.addOperationTypeDelegationSelectWidget();
				break;
			case "extrecord":
				oSelect.options[3].selected = true;
				this.addOperationTypeExtrecordSelectWidget();
				break;
			default:
				oSelect.options[0].selected = true;
				break;
				
		}

		this.oStrategy.getById("execution-operation-type-port").update(oSelect);
	},
	
	addOperationTypeExecutionSelectWidget: function()
	{ 
		var oInput 		= new Element("INPUT");
		oInput.name 	= this.oStrategy.getName("operation_value");
		if (this.oStrategy.getValue("operation_type") == 'execution') {
			oInput.value	= this.oStrategy.getValue("operation_value");
		}
		this.oStrategy.getById("execution-operation-value-port").update(aGlobalMsfWords["WFA_EXECUTION_AT"]);
		this.oStrategy.getById("execution-operation-value-port").insert(oInput);
		this.oStrategy.getById("execution-operation-value-port").insert(aGlobalMsfWords["WFA_CONTROL_POINT"]);
		this.addVisibility("execution-operation-value-port", 0);
	},
	
	addVisibility: function(sPlace, iValue)
	{
		var oInput 		= new Element("INPUT");
		oInput.name 	= this.oStrategy.getName("visible");
		oInput.type		= "hidden";
		oInput.value	= iValue;
		this.oStrategy.getById(sPlace).insert(oInput);
	},
	
	addAuthorAddressWidget:function()
	{
		this.oStrategy.addAddress("execution-a-address_type", "execution-a-address_value");
	},
	
	addNumberOfOperationsWidget: function()
	{		
		var oSelect 			= new Element("SELECT");
		oSelect.name 			= this.oStrategy.getName("number_of_operations");
		oSelect.options[0]		= new Option(aGlobalMsfWords["WFA_EXECUTION_REPEATEDLY"], "multiple");
		oSelect.options[1]		= new Option(aGlobalMsfWords["WFA_EXECUTION_ONCE"], "single");
		switch (this.oStrategy.getValue("number_of_operations")) {
			case "multiple":
				oSelect.options[0].selected = true;
				break;
			case "single":
				oSelect.options[1].selected = true;
				break;
		}

		this.oStrategy.getById("execution-number-of-operations-port").update(oSelect);
	},
	
	addOperationTypeDelegationSelectWidget: function()
	{ 
		var oSelect 		= new Element("SELECT");
		var sValue			= this.oStrategy.getValue("operation_value");
		oSelect.name		= this.oStrategy.getName("operation_value");
		oSelect.options[0] 	= new Option(aGlobalMsfWords["WFA_EXECUTION_DOWNLOAD"], sValue);
		var oThis			= this;
		this.oStrategy.getById("execution-operation-value-port").update(oSelect);
		this.addVisibility("execution-operation-value-port", 1);
		var sPath = '/admin/workflow/getDoctypesSpa/' + this.oDoctypeSelect.value + '/'+ this.oStrategy.getType(); 
		new Ajax.Request(sPath, {
				method 		: "post",
				onSuccess 	: function(transport) {
					var hResult = $H(transport.responseText.evalJSON());
					if ((hResult.get("code") == 2) && (hResult.get("body")!= "")) {
						oSelect.update();
						oSelect.options[0] 	= new Option(aGlobalMsfWords["WORKFLOW_NULL"], "");
						$H(hResult.get("body")).each(function(hash){
							var i 				= oSelect.options.length;
							oSelect.options[i] 	= new Option(hash.value, hash.key);
							if ((sValue == hash.key) && (oThis.oStrategy.getValue("operation_type") == 'delegation')) {
								oSelect.options[i].selected = true;
								WindowHandler.onLoad();
							}
						});
						
					}
					else {
						oSelect.update();	
						oSelect.options[0] = new Option(aGlobalMsfWords["WFA_EXECUTION_NO_ACTION"]);
					}
					
				}.bind(this)
						
			}

		);

	},
	
	addOperationTypeExtrecordSelectWidget: function()
	{
		var me			   = this;
		var oStrategy	   = this.oStrategy;
		var aDestFields	   = null;
		var aDocFields	   = this.getDocFields();
		var sDest		   = this.oStrategy.getValue("operation_value");
		var sSource		   = this.oStrategy.getValue("docfield_name");						
		var oDestSelect	   = new Element("SELECT");		
		oDestSelect.name   = this.oStrategy.getName("operation_value");
		oDestSelect.options[0] = new Option(aGlobalMsfWords["WFA_EXECUTION_DOWNLOAD"], sDest);
		oStrategy.getById("execution-operation-value-port").update();
		oDiv				= new Element("DIV", {"style":"float: left; width: 70px; white-space: nowrap"});		
		oDiv.update(aGlobalMsfWords["WFA_EXECUTION_RECORD_TO"]);
		oStrategy.getById("execution-operation-value-port").insert(oDiv);		
		oStrategy.getById("execution-operation-value-port").insert(oDestSelect);
		var oSourceSelect  = new Element("SELECT");
		oSourceSelect.name = this.oStrategy.getName("docfield_name");		
		var oOption 	   = new Option(aGlobalMsfWords["WFA_EXECUTION_DOWNLOAD"], sSource);
		oSourceSelect.options[0]	= oOption;	
		oStrategy.getById("execution-record-value-port").update();
		oDiv						= new Element("DIV", {"style":"float: left; width: 70px; white-space: nowrap"});		
		oDiv.update(aGlobalMsfWords["WFA_EXECUTION_RECORD_FROM"]);
		oStrategy.getById("execution-record-value-port").insert(oDiv);		
		oStrategy.getById("execution-record-value-port").insert(oSourceSelect);		
		oStrategy.getById("execution-record-value-port").style.display = "";
				
		var sPath = "/admin/workflow/getDoctypeFields/" + this.oDoctypeSelect.value; 
		new Ajax.Request(sPath, {
				method 		: "post",
				onSuccess 	: function(transport) {					
					aDestFields = transport.responseText.evalJSON();
					oDestSelect.update();
					var sType	= "";
					var oOption = new Option(aGlobalMsfWords["WORKFLOW_NULL"], '');
					var z 		= 0;		
					oDestSelect.options[z++] = oOption;
					$H(aDestFields).each(function(hash) {
						if(hash.value.type != "table") {						
							var sKey = "ext_" + hash.key;
							if (hash.value.title) {
								oOption	 = new Option(hash.value.title, sKey);
								if(sKey == sDest) {
									oOption.selected = true;
									sType			 = hash.value.type;	
								}
								
								oDestSelect.options[z] = oOption;
							}

							z++;
						}
											
					});
					
					oSourceSelect.update();
					var oOption = new Option(aGlobalMsfWords["WORKFLOW_NULL"], '');
					var z 		= 0;		
					oSourceSelect.options[z++] = oOption;
					if (aDocFields.size() > 0) {
						aDocFields.each(function(hash) {
							if(hash.type == sType || (me.aRecordTypes.get(sType) && me.aRecordTypes.get(sType).indexOf(hash.type) != -1)) {
								oOption	 = new Option(hash.title, hash.name);
								if(hash.name == sSource) {
									oOption.selected = true;
								}
								
								oSourceSelect.options[z] = oOption;
								z++;														
							}
								
						});
					}

					
					oDestSelect.onchange = function() {
						sType		= "";
						$H(aDestFields).each(function(hash) {
							var sKey = "ext_" + hash.key;
							if(sKey == oDestSelect.value) {
								sType = hash.value.type;
							}
												
						});						
					
						oSourceSelect.update();						
						var oOption = new Option(aGlobalMsfWords["WORKFLOW_NULL"], '');
						var z 		= 0;		
						oSourceSelect.options[z++] = oOption;
						if (aDocFields.size() > 0) {
							aDocFields.each(function(hash) {
								if(hash.type == sType || (me.aRecordTypes.get(sType) && me.aRecordTypes.get(sType).indexOf(hash.type) != -1)) {
									oOption	 = new Option(hash.title, hash.name);								
									oSourceSelect.options[z] = oOption;
									z++;														
								}
								
							});
						
						}
													
					}
														
				}
						
			}

		);		 
		
	}
	
};