<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

class WFA_Move extends WF_ActionSupport implements WF_IAction
{
	private $oDocument;
	
	public function initialize()
	{
		
	}
		
	public function processSchedule()
	{
		
	}
	
	public function processCall()
	{
		$iCurrent	= $this->getDocument()->getPointId();
		$iNew		= $this->getParam("iNewPoint") + $iCurrent;
		return $this->move($iCurrent, $iNew, false);
	}
	
	public function processExecute()
	{
		$aRoute		= $this->getSettings()->getActions($this->getActionId());
		$iCurrent	= $this->getDocument()->getPointId();
		$iMove		= $aRoute["options"]["point_number"];
        $iNew		= $iCurrent + $iMove;
		return $this->move($iCurrent, $iNew, true, false);
	}

	public function processRequest()
	{
		$iCurrent	= $this->getDocument()->getPointId();
		$iMove		= (int) MSF_SL::getParam($_POST, "point_number", 0);
        $iNew		= $iCurrent + $iMove;
		return $this->move($iCurrent, $iNew);
	}

	public function processResponse()
	{
		return self::FAILURE;
	}

	private function removeLogAtPoint($iPoint)
	{
		$Log	= $this->getLog();
		$aLogs	= $Log->getDelegated($iPoint);
			
		
		foreach($aLogs as $iActionId=>$aValues) {
			$aAction	= $this->getSettings()->getActions($iActionId);
			if(!empty($aAction) && isset($aAction["name"])) {
				if ($aAction["name"] != "execution") {
					$this->call($aAction["name"], array(), "cancel", false, $iActionId);
					//$Log->clearDelegatedAction($iPoint, $iActionId);
				}
				else {
					$this->call($aAction["name"], array(), "cancel", true, $iActionId);
				}
			}
				
		}
											      		
		$Log->clearExecuted($iPoint);
		$Log->clearWaited($iPoint);
	}
	
	private function move($iCurrent, $iNew, $bUpdateDelegated = true, $bWriteDisplay = true)
	{
		$Settings	= $this->getSettings();
		$Document	= $this->getDocument();
		$Locale		= MSF_Registry::get("MSF_Locale");
		$Log		= $this->getLog();
		
		if(!$Settings->isPointExists($iNew)) {
        	return self::FAILURE;
     	}
	   
		if($iCurrent != $iNew) {
			$this->removeLogAtPoint($iNew);
		}
				
		$sSmallText	= $Locale->getWord("WORKFLOW_LOG_MOVE_MOVED");

		if ($bUpdateDelegated) {
			$Log->setDelegated(
					$this->getDocument()->getPointId(),
					$this->getActionId(),
					array(
							"point_id" => $iNew
							)
					);
			if($bWriteDisplay) {
				$Log->display($this->getActionTitle(), $sSmallText, "");
			}
			
		}

		$Log->report($this->getDocument()->getPointId(), $this->getActionName(), ($iNew - $iCurrent));
		
		$Document->setPointId($iNew);
		$oVersion = $this->getDocument()->getCurrentVersion();
		$oVersion->setSystemField(
				"status",
				(string)$this->getSettings()->getTitleOfPoint($iNew)
				);
		$oVersion->save();
		return self::SUCCESS;
	}
	
}

?>