var WFA_RecordSpa = Class.create();
WFA_RecordSpa.prototype = Object.extend(new WF_AbstractForm(), {
	build: function()
	{
		var Container 	= this.clone('record_form');
		var ShowAction1 = this.getById('record_show_action_yes', this.getName('visible'));
		var ShowAction2 = this.getById('record_show_action_no', this.getName('visible'));
		var LabelText 	= this.getById('record_label_text', this.getName('label_text'));
		var Replace 	= this.getById('record_replace_field', this.getName('replace_field'));
		var Value 		= this.getById('record_value_field', this.getName('field'));
		var Points 		= this.getById("move_points", this.getName('move_points'));
		Points.value 	= this.getValue("move_points");
		
		LabelText.value = this.getValue("label_text");
		this.aFields 	= this.getValues("fields");
		
		this.sValValue 	= this.getValue("value");
		this.sValName 	= this.getName("value");
		this.Cont 		= this.getById('record_selected_value_cont');
		this.oTrParam	= this.getById("record_parameters");
		this.aValues 	= [{"title": "WORKFLOW_FIELDS", 		"value": "field", 	"types": ["table", "file", "picture", "reference", "int", "float", "date", "timestamp", "string", "text", "structure", "document"]},
		      		       {"title": "WORKFLOW_VARIABLES", 		"value": "var", 	"types": ["structure", "date", "timestamp", "string", "text"]},
		    		       {"title": "WORKFLOW_VALUE", 			"value": "value", 	"types": ["reference", "int", "float", "enum", "bool", "date", "timestamp", "string", "text", "structure", "document"]},
		    		       {"title": "WFA_RECORD_PARAM_FORMULA","value": "formula", "types": ["int", "float"]},
		    		       {"title": "WORKFLOW_GROUPS",			"value": "groups",	"types": ["structure"]}
		    		      ];
		
		this.aVars 		= [
		
						   {"title": "WORKFLOW_VAR_USER", 				"value": "user", 				"type": ["structure","string","text"]},  
		           		   {"title": "WORKFLOW_VAR_AUTHOR", 			"value": "author", 				"type": ["structure", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_CREATED_AT", 		"value": "created_at", 			"type": ["date", "timestamp", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_MODIFIED_AT", 		"value": "modified_at", 		"type": ["date", "timestamp", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_STATUS", 			"value": "status", 				"type": ["string", "text"]},
		           		   {"title": "WORKFLOW_VAR_DOCTYPE", 			"value": "doctype", 			"type": ["string", "text"]},
		           		   {"title": "WORKFLOW_VAR_SUBDIVISION",		"value": "subdivision", 		"type": ["string", "text"]},
		           		   {"title": "WORKFLOW_VAR_TITLE",				"value": "title", 				"type": ["string", "text"]},
		           		   {"title": "WORKFLOW_VAR_AKTENPLAN",			"value": "aktenplan",			"type": ["string", "text"]},	           		   
		           		   {"title": "WORKFLOW_VAR_CURRENT_DATE", 		"value": "current_date", 		"type": ["date", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_CURRENT_DATE_TIME", 	"value": "current_date_time", 	"type": ["timestamp", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_CONTROL", 			"value": "control", 			"type": ["text"]},
		           		   {"title": "WORKFLOW_VAR_REGISTRATION_NUMBER","value": "registration_number", "type": ["string", "text"]},
		           		   {"title": "WORKFLOW_VAR_REGISTRATION_DATE", 	"value": "registration_date", 	"type": ["date", "timestamp", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_DOCUMENTS_FAMILY", 	"value": "documents_family", 	"type": ["text"]},	
		           		   {"title": "WORKFLOW_VAR_DECISION", 			"value": "decision",			"type": ["text"]}	           		   
		           		  ];
		           		  
		this.aTypes		= $H({
							"int"     	: "float",
							"float"     : "int",
							"date"		: "timestamp",
							"timestamp" : "date",
							"string"	: "int, float, reference, date, timestamp, bool, structure, enum, document",
							"text"		: "int, float, reference, date, timestamp, bool, structure, enum, document"
						  });
		
		switch (this.getValue('visible')) {
			case '1':
				ShowAction1.checked = true;
				ShowAction2.checked = false;
				break;
			case '0':
				ShowAction1.checked = false;
				ShowAction2.checked = true;
				break;
		}
		
		
		this.prepareFieldsReplace(Replace, Value);
		return Container;
	},
	
	prepareFieldsReplace: function(Replace, Value)
	{
		var me 				= this;
		Replace.options[0] 	= new Option(aGlobalMsfWords["WORKFLOW_NULL"], "");
		Value.options[0] 	= new Option(aGlobalMsfWords["WORKFLOW_NULL"], "");
		
		Replace.onchange = function()
		{
			me.Cont.update();
			me.clearSelect(Value, 1);
			if (this.value != "") {
				sFieldType = this.options[this.selectedIndex].getAttribute("type");
				me.prepareFieldsValue(
					sFieldType,
					Value,
					this.value,
					this.options[this.selectedIndex].getAttribute("ref")
				);
			}
			else {
				Value.onchange = null;
				me.parametersForRecord();
			}
			me.sValValue = "";
		}
		
		iCounter = 1
		for (var i = 0; i < this.aFields.length; i++) {
			Replace.options[iCounter] = new Option(this.aFields[i].title, this.aFields[i].name);
			Replace.options[iCounter].setAttribute("type", this.aFields[i].type);
			
			if (this.aFields[i].value && this.aFields[i].value.optional) {
				if (this.aFields[i].value.optional.multiselect) {
					Replace.options[iCounter].setAttribute("multi", this.aFields[i].value.optional.multiselect);
				}
				if (this.aFields[i].value.optional.reference) {
					Replace.options[iCounter].setAttribute("ref", this.aFields[i].value.optional.reference);
				}
			}
			
			if (this.getValue("replace_field") == Replace.options[iCounter].value) {
				Replace.options[iCounter].selected = true;
				Replace.onchange();
			}
			iCounter++;
		}
	},
	
	prepareFieldsValue: function(sReplaceType, Value, sFieldName, iRef)
	{
		var bAllowed;
		var iCounter 	= 1;
		var me 			= this;
		var SubSelect 	= new Element("select", {"name": this.sValName});
		
		Value.onchange = function()
		{
			me.clearSelect(SubSelect, 0);
			me.Cont.update();
			switch (this.value) {
				case "var":
					me.prepareVarValues(SubSelect, sReplaceType);
					break;
				case "field":
					me.prepareFieldValues(SubSelect, sReplaceType, sFieldName, iRef);
					break;
				case "value":
					me.prepareEmptyValues(sFieldName, sReplaceType);
					break;
				case "formula":
					me.prepareFormulaValues();
					break;
				case "groups":
					me.prepareGroupsValues(sFieldName);
					break;
			}
			
			if (this.value == "") {
				me.parametersForRecord();
			}
			else {
				me.parametersForRecord(sReplaceType);
			}
		}
		for (var i = 0; i < this.aValues.length; i++) {
			bAllowed = false;
			for (var j = 0; j < this.aValues[i].types.length; j++) {
				if (this.aValues[i].types[j] == sReplaceType || this.aValues[i].types[j] == "all") {
					bAllowed = true;
					break;
				}
			}
			
			if (bAllowed) {
				Value.options[iCounter] = new Option(aGlobalMsfWords[this.aValues[i].title], this.aValues[i].value);
				if (this.getValue("field") == Value.options[iCounter].value) {
					Value.options[iCounter].selected = true;
					Value.onchange();
				}
				iCounter++;
			}
		}
	},
	
	prepareVarValues: function(Select, sReplaceType)
	{
		var iCount = 0;
		this.Cont.insert(Select);
		
		for (var i = 0; i < this.aVars.length; i++) {
			bAllowed = false;
			for (var j = 0; j < this.aVars[i].type.length; j++) {
				if (this.aVars[i].type[j] == sReplaceType || this.aVars[i].type[j] == "all") {
					bAllowed = true;
					break;
				}
			}
			
			if (bAllowed) {
				Select.options[iCount] = new Option(aGlobalMsfWords[this.aVars[i].title], this.aVars[i].value);
				if (this.sValValue == Select.options[iCount].value) {
					Select.options[iCount].selected = true;
				}
				iCount++;
			}
		}		
	},
	
	prepareFieldValues: function(Select, sReplaceType, sFieldName, iRef)
	{

		var iCount 	= 0;

		this.Cont.insert(Select);
		for (var i = 0; i < this.aFields.length; i++) {
			if (this.aFields[i].type == sReplaceType || (this.aTypes.get(sReplaceType) && this.aTypes.get(sReplaceType).indexOf(this.aFields[i].type) != -1)) {
				if ((this.aFields[i].type == "table") && (this.aFields[i].name == sFieldName)) {
					if (this.aFields[i].value && this.aFields[i].value.optional) {						
						if (this.aFields[i].value.optional.reference && this.aFields[i].value.optional.reference != iRef) {
							continue;
						}
						
					}
			
					Select.options[0] = new Option(aGlobalMsfWords["WFA_RECORD_TABLE_ALL"], this.aFields[i].name);
					Select.options[1] = new Option(aGlobalMsfWords["WFA_RECORD_TABLE_TOP"], "top");
					Select.options[2] = new Option(aGlobalMsfWords["WFA_RECORD_TABLE_BOTTOM"], "bottom");
					switch (this.sValValue) {
						case "top":
							Select.options[1].selected = true;
							break;
						case "bottom":
							Select.options[2].selected = true;
							break;
						default:
							Select.options[0].selected = true;
							break;
					}			
				}
				else if (this.aFields[i].type != "table") {
					if (this.aFields[i].value && this.aFields[i].value.optional && sReplaceType != "string") {
						if (this.aFields[i].value.optional.reference && this.aFields[i].value.optional.reference != iRef) {
							continue;
						}
						
					}			
					Select.options[iCount] = new Option(this.aFields[i].title, this.aFields[i].name);
					if (this.sValValue == Select.options[iCount].value) {
						Select.options[iCount].selected = true;
					}
					
				}

				iCount++;
			}
			
		}

	},
	
	prepareEmptyValues: function(sFieldName, sReplaceType)
	{
		this.insertType(sFieldName, sReplaceType);
	},
	
	insertType: function(sFieldName, sType)
	{	
		var bTime = true;
		
		switch (sType) {
			case "int":
			case "float":
			case "string":
				this.Cont.insert(new Element("input", {"name": this.sValName, "value": this.sValValue}));
				break;
			case "text":
				var Options = this.defineFieldOptions(sFieldName);
				this.buildTextElement(Options);
				break;
			case "reference":
				var Options = this.defineFieldOptions(sFieldName);
				
				if (Options && Options.optional) {
					Options 		= Options.optional;
					var aColumns 	= {};
					var aFilters 	= {};
					
					if (Options.defaultFilter) {
						$H(Options.defaultFilter).each(function(e) {
							aFilters[e.key] = e.value;
						});
					}

                                        if(Options.columns != undefined){
                                            for (var i = 0; i < Options.columns.length; i++) {
                                                    if (Options.fieldsValue) {
                                                            aColumns[Options.columns[i]] = {
                                                                    "select": (Options.fieldsValue[Options.columns[i]]) ? true : false,
                                                                    "group": (Options.groupEnable == 1) ? true : false,
                                                                    "filter": (Options.filterEnable == 1) ? true : false,
                                                                    "sort": true
                                                            };
                                                    }
                                            }
                                        }
					
					new MSFW.Placeholder.Reference({
						"Container" : this.Cont,
						"inputName" : this.sValName,
						"referenceId" : Options.reference,
						"multiselect" : (Options.multiselect == 0) ? false : true,
						"byId" : true,
						"columns" : aColumns,
						"defaultGroups" : (Options.defaultGroup) ? Options.defaultGroup : [],
						"defaultFilters" : aFilters,
						"default" : this.sValValue
					});
					/*
					new ReferencePlaceholder({
						"mPlace" 			: this.Cont,
						"iRefId" 			: Options.reference,
						"aColumns" 			: aColumns,
						"sInputName" 		: this.sValName,
						"sDefaultValues" 	: this.sValValue,
						"bMultiselect" 		: (Options.multiselect == 0) ? false : true,
						"bById" 			: true,
						"aDefaultFilters" 	: aFilters,
						"aDefaultGroups" 	: (Options.defaultGroup) ? Options.defaultGroup : []
					});
					*/
				}
				break;
			case "structure":
				var Options = this.defineFieldOptions(sFieldName);
				
				new MSFW.Placeholder.Structure({
					"Container" : this.Cont,
					"inputName" : this.sValName,
					"multiselect" : (Options.optional.multiselect == 1) ? true : false,
					"default" : this.sValValue
				});
				
				/*
				new StructurePlaceholder({
					"mPlace" 			: this.Cont,
					"sInputName"  		: this.sValName,
					"sDefaultValues" 	: this.sValValue,
					"bMultiselect" 		: (Options.optional.multiselect == 1) ? true : false,
					"bShowPosts" 		: (Options.optional.postEnable == 1) ? true : false
				});
				*/
				break;
			case "date":
				bTime = false;
			case "timestamp":
				new MSFW.Placeholder.Calendar({
					"Container" : this.Cont,
					"inputName" : this.sValName,
					"time" : bTime,
					"default" : this.sValValue
				});
				/*
				new DatePlaceholder({
					"mPlace"			: this.Cont,
					"sInputName"		: this.sValName,
					"sDefaultValues"	: this.sValValue,
					"bTime"				: bTime
				});
				*/
				break;
			case "document":
				new MSFW.Placeholder.Document({
					"Container" : this.Cont,
					"inputName" : this.sValName,
					"multiselect" : false,
					"default" : this.sValValue
				});
				/*
				new MSF_DocumentPlaceholder(
					this.Cont,
					this.sValName,
					this.sValValue
				);
				*/
				break;
			case "enum":
				var Enum = new Element("select", {"name": this.sValName});
				this.Cont.insert(Enum);
				
				var Options = this.defineFieldOptions(sFieldName);
				if (Options && Options.optional) {
					for (var i = 0; i < Options.optional["enum"].length; i++) {
						Enum.options[i] = new Option(Options.optional["enum"][i], i);
						if (this.sValValue == i) {
							Enum.options[i].selected = true;
						}
					}
				}
				break;
			case "bool":
				var Bool = new Element("select", {"name": this.sValName});
				this.Cont.insert(Bool);
				
				var Options = this.defineFieldOptions(sFieldName);
				if (Options && Options.optional) {
					Bool.options[0] = new Option(Options.optional.labelYes, 1);
					Bool.options[1] = new Option(Options.optional.labelNo, 0);
					
					if (this.sValValue == 1) {
						Bool.options[0].selected = true;
					}
					else {
						Bool.options[1].selected = true;
					}
				}
				break;
		}
	},
	
	prepareGroupsValues : function(sFieldName) {
		var Options = this.defineFieldOptions(sFieldName);
		var oRefGroups = new MSFW.Placeholder.Reference({
			"Container"			: this.Cont,
			"referenceId"		: 316,
			"inputName"			: this.sValName,
			"columns"			: {	
									"name" 		: {	"select" : true,	"group" : true,	"sort" : true,	"filter" : true },
									"employee" 	: {	"select" : false,	"group" : true,	"sort" : true,	"filter" : true	}
								  },
			"defaultGroups"		: ["name"],
			"byId"				: true,
			"multiselect"		: (Options.optional.multiselect == 1) ? true : false,
			"default"			: this.sValValue,
			"valueSeparator"	: ", "
		});
	},
	
	defineFieldOptions: function(sFieldName)
	{
		for (var i = 0; i < this.aFields.length; i++) {
			if (this.aFields[i].name == sFieldName) {
				return this.aFields[i].value;
			}
		}
	},
	
	clearSelect: function(Select, iIndex)
	{
		for (var i = Select.options.length - 1; i >= iIndex; i--) {
			Select.options[i] = null;
		}
		
		if (Select.options[0]) {
			Select.options[0].selected = true;
		}
	},
	
	prepareFormulaValues: function() {
		this.Cont.insert(new Element("input", {"name": this.getName("formula"), "value": this.getValue("formula"), "style":"width:90%"}));
	},
	
	parametersForRecord: function(sFieldType)
	{
		this.oTrParam.show();
		var oSelectParam	  		= this.getById("record_param", this.getName("record_param"));
		oSelectParam.options.length = 0;
		oSelectParam.options[0] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_NONE"], "");
		oSelectParam.onchange 		= null;
		oSelectParam.value			= this.getValue("record_param");
		var oParamCont 				= this.getById("record_parameters_cont");
		oParamCont.update();
		switch(sFieldType) {
			case "string":
			case "text":
				oSelectParam.options[1] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_MERGE"], "merge");
				oSelectParam.value			= this.getValue("record_param");
				var me = this;
				oSelectParam.onchange = function() {
					if (oSelectParam.value != "") {			
						var oSelectParamValue 	= new Element("INPUT");
						oSelectParamValue.name  = me.getName("record_param_value");
						oSelectParamValue.value	= me.getValue("record_param_value");
						oParamCont.update(aGlobalMsfWords["WFA_RECORD_PARAM_MERGE_SEPARATOR"] + " ");
						oParamCont.insert(oSelectParamValue);
					}
					else {
						oParamCont.update();
					}
				}
				oSelectParam.onchange();
				break;
			case "structure":
				oSelectParam.options[1] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_ADD"], "merge");
				oSelectParam.options[2] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_DEL"], "delete");
				oSelectParam.options[3] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_BOSS"], "boss");
				oSelectParam.options[4] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_SUBDIVISION"], "subdivision");
				oSelectParam.value			= this.getValue("record_param");
			case "document":
			case "reference":
				oSelectParam.options[1] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_ADD"], "merge");
				oSelectParam.options[2] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_DEL"], "delete");
				oSelectParam.value			= this.getValue("record_param");
				break;
			default:
				oSelectParam.value			= "";
				this.oTrParam.hide();
				break;
		}		
	},
	
	
	buildTextElement : function(Options)
	{
		me 			= this;
		var Input	= $(new Element("input", {"name": this.sValName}));
		
		Input.value = this.sValValue;
		Input.type = "hidden";
		var oImg 		= new Element("IMG", {src: "/modules/workflow/view/templates/default/img/pencil.png", 
										      style: "cursor:pointer;", title: "Изменить"});
		
		var oValue 	  = new Element("DIV");
		oValue.innerHTML = 	Input.value;
		var oFieldset = new Element("FIELDSET");
		var oLegend   = new Element("LEGEND", {align: "right", style: "margin-left:auto"});
		this.Cont.insert(Input).insert(oFieldset.insert(oLegend.insert(oImg)).insert(oValue));

		var isDisplayed	= false;
		
		var oTa		= new Element("TEXTAREA");
		oTa.value = Input.value;

		//b window
		var showRTE = function () {
			// init window
			var oDiv 	= new Element("DIV");
			var oWin 	= new MSFW.Window();			
			var oOk		= new Element("INPUT", {type : "button", value : "ОК"});
			oDiv.insert(oTa);
			oDiv.insert(new Element("DIV").insert(oOk));
			oWin.setTitle("Значение по умолчанию");
			oWin.appendToBody(oDiv);
			oWin.show();
			var eltDims	= oDiv.getDimensions();
			oWin.height = eltDims.height;
			oWin.width  = 800;
			oWin.moveToCenter();
			Event.observe(oOk, "click", function() {
				Input.value		= oTa.innerHTML;
				oWin.hide();
				Input.value		= oTa.value;
				oValue.innerHTML 	= oTa.value;
			});
			initRte(oTa);
			oWin.addEventListener("close", function() {
				removeRte(oTa);
				isDisplayed = false;
			});

			isDisplayed = true;
			return false;
		}

		Event.observe(oImg, "click", function() {if (!isDisplayed){showRTE()}});			
	}
	
});