<?php
include_once "modules/workflow/actions/control/WF_Control.php";
include_once 'modules/references/library/Reference/REF_Value.php';

class WFA_RecordUtils
{
	
	/**
	 * Shitaet formulu dlya float i integer polei
	 *
	 * @param  array  $Options - parametri deistviya
	 * @param  object $Fields  - MSF_XmlWrapper
	 * @param  array  $aFields - znacheniya poley
	 * @param  string $mValue  - tekushee zapisivaemoe znachenie
	 * @return integer or float
	 */
	public static function recordFormula($Options, $Fields, $aFields)
	{
		$mValue   = 0;
		$sFormula = (string) $Options["formula"];
		if (strlen($sFormula) > 0) {
			if ($sFormula[0] == "=") {
				$sFormula[0] = "+";
			}
			if (!in_array($sFormula[0], array("+", "-", "*", "/"))) {
				$sFormula = "+" . $sFormula;
			}
			foreach ($Fields->getAsArray() AS $sKey => $aValue){
				if (empty($aFields[$sKey])) {
					$aFields[$sKey] = 0;
				}
				$sValue 	= ($aFields[$sKey] >= 0) ? $aFields[$sKey] : "(" . $aFields[$sKey] .")";
				$sFormula 	= str_replace("{" . $aValue["title"] . "}", $sValue, $sFormula);
			}
			$sFormula = preg_replace("#[A-Za-z]#i", "", $sFormula);
			
			try {
				if ($Options["optional"]["type"] == "int") {
					$mValue   = @eval("\$iValue = " . $sFormula ."; return \$iValue;");
					$mValue	  = round(substr($mValue, 0, 12));
				}
				else {
					$mValue   = @eval("\$iValue = " . $sFormula ."; return \$iValue;");
					$mValue	  = substr($mValue, 0, 15);
				}
			}
			catch (Exception $e) {
	
			}
		}
		
		return $mValue;
	}
	
	/**
	 * Ob'edinyaet stroki
	 *
	 * @param array  $Options - parametri deistviya
	 * @param array  $aFields - znacheniya poley
	 * @param string $sValue  - pribavlyaemoe znachenie
	 */
	public static function stringMerge($Options, $aFields, $sValue)
	{
		if(isset($Options["record_param"]) && $Options["record_param"] == "merge") {
			$sSeparator = $Options["record_param_value"];
			if (!empty($aFields[$Options["replace_field"]])) {			
				$sValue 	= $aFields[$Options["replace_field"]] . $sSeparator . $sValue;
			}
		}

		return $sValue;
	}
	
	public static function specialRecordParam($aOptions, $aFields)
	{
		$oRefValue 		= new REF_Value();
		$oFacade 		= MSF_OrgStructureFacade::getInstance();
		$sValue 		= $aOptions["value"];
		$oRefValue->parse($aOptions["value"]);
		$aAddKey 		= $oRefValue->getKeysList();
		$aAdd			= array();
		if (!empty($aOptions["value"])) {
			$aAdd			= explode("|^|row|^|", $aOptions["value"]);
		}
		$oRefValue->parse($aFields[$aOptions["replace_field"]]);
		$aValueKey 		= $oRefValue->getKeysList();
		$aValue			= array();
		if (!empty($aFields[$aOptions["replace_field"]])) {
			$aValue			= explode("|^|row|^|", $aFields[$aOptions["replace_field"]]);
		}
		
		if ($aOptions["record_param"] == "merge") {
			foreach ($aAddKey AS $Key => $aItem) {
				if (!in_array($aItem, $aValueKey)) {
					$aValue[] = $aAdd[$Key];
				}
			}
			$sValue = implode("|^|row|^|", $aValue);
		}
		if ($aOptions["record_param"] == "delete") {
			foreach ($aValueKey AS $Key => $aItem) {
				if (in_array($aItem, $aAddKey)) {
					unset($aValue[$Key]);
				}
			}
			$sValue = implode("|^|row|^|", $aValue);
		}
		if ($aOptions["record_param"] == "boss" && isset($aAddKey[0][0])) {
			$aTmp = array();
			
			for ($i = 0; $i < count($aAddKey); $i++) {
				$sBoss  = $oFacade->getBoss($aAddKey[$i][0]);
				if (!empty($sBoss)) {
					$aTmp[] = $sBoss;
				}
			}
			
			$sValue = implode("|^|row|^|", $aTmp);
		}
		if ($aOptions["record_param"] == "subdivision" && isset($aAddKey[0][0])) {
			$aTmp = array();
			if ($aOptions["optional"]["optional"]["multiselect"]) {
				for ($i = 0; $i < count($aAddKey); $i++) {
					$aSubject			= $oFacade->getSubjectByStructureId($aAddKey[$i][0]);
					if ($aSubject["parent_id"] != 0) {
						$aBossSubject 		= $oFacade->getSubjectByStructureId($aSubject["parent_id"]);
						$aBossSubdivision  	= $oFacade->getSubdivisionHashBySubjectId($aBossSubject["subject_id"]);
						$oRefValue->reset();
						$oRefValue->add(array($aBossSubject["node_id"], $aBossSubject["subject_id"]), $aBossSubdivision["subdivision"]);
						$aTmp[$i] = $oRefValue->format();
					}
				}
				$sValue = implode("|^|row|^|", $aTmp);
			} else {
				$sValue = "";
			}
		}
		return $sValue;
	}
	
	/**
	 * Preobrazuet lybie polya v stroku
	 *
	 * @param  array $aAction - parametri deistviya
	 * @param  mixed $mValue  - tekushee zapisivaemoe znachenie
	 * @return string
	 */
	public static function castToString($mValue, $sType)
	{
		switch ($sType) {
			case "structure":
			case "reference":
				$RefValue 	= new REF_Value();
				$RefValue->parse($mValue);
				$mValue 	= implode(", ", $RefValue->getValuesList());
				break;
			case "enum":
			case "bool":
				$aValue		= explode("|^|row|^|", $mValue);
				$mValue		= $aValue[0];
				break;
			case "document":
				$RefValue 	= new REF_Value();
				$RefValue->parse($mValue);
				$mValue 	= implode(", ", $RefValue->getValuesList());
				break;
			case "date":
			case "timestamp":
				$oDate = new MSF_Date();
				$mValue = $oDate->toViewFormat($mValue);
				break;
				
		}
		return $mValue;
	}
	
	/**
	 * Vozvrashaet peremennuyu control special for action record
	 *
	 * @param integer $iDocumentId
	 */
	public static function getVarControl($iDocumentId)
	{
		$oWfControl    = new WF_Control();
		$RefValue 	   = new REF_Value();
		$aControlParam = $oWfControl->findOneByDocumentId($iDocumentId);
		$sResult	   = "";
		if (!empty($aControlParam["executor"])) {
			$RefValue->parse($aControlParam["executor"]);
			$sResult  = MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCTYPE_SPA_CONTROL_CONTROLLABLE");
			$sResult .= implode(", ", $RefValue->getValuesList()) . "; ";
		}
		if (!empty($aControlParam["controller"])) {
			$RefValue->parse($aControlParam["controller"]);
			$sResult .= MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCTYPE_SPA_CONTROL_CONTROLLER");
			$sResult .= implode(", ", $RefValue->getValuesList()) . "; ";
		}
		if (!empty($aControlParam["finish_at"])) {
			$oDate = new MSF_Date($aControlParam["finish_at"]);
			$sResult .= MSF_Registry::get("MSF_Locale")->getWord("WFA_CONTROL_DATE") . ": ";
			$sResult .= $oDate->format(CNF_DATE_TIME_FORMAT);
		}

		return $sResult;
	}
	
	/**
	 * Vozvrashaet peremennuyu decision special for action record
	 *
	 * @param object $oAction
	 */
	public static function getVarDecision($oAction)
	{
		$aSpaList 	= $oAction->getSettings()->getPureActions();
		$aResult 	= array();
		$iSpas 		= 0;
		
		foreach ($aSpaList as $iActionId => $aSpa) {
			if ($aSpa["name"] == "decision") {
				$iPoints 	= count($oAction->getSettings()->getRoute());
				$aLogs 		= array();
				$sTitle 	= trim($aSpa["options"]["window_title"]);
				$aTime 		= array();
				
				for ($j = 0; $j < $iPoints; $j++) {
					$iLogCount 	= 0;
					$aLog 		= $oAction->getDocument()->getLog()->getDelegated($j, $iActionId);
					
					if (!empty($aLog["recs"])) {
						foreach ($aLog["recs"] as $iKey => $aValue) {
							if (isset($aValue["time"])) {
								$aTime[$iKey][] = $aValue["time"];
							}
						}
						
						foreach ($aLog["recs"] as $iId => $aValue) {
							$bBreak = false;
							if (isset($aValue["time"])) {
								foreach ($aTime as $iKey => $aTimeValue) {
									if ($iId == $iKey) {
										foreach ($aTimeValue as $iTimeValue) {
											if ($aValue["time"] < $iTimeValue) {
												$bBreak = true;
												break;
											}
										}
										break;
									}
								}
								if ($bBreak) {
									continue;
								}
							}
					
							$aValue["spa_id"] = $iActionId;
							if (isset($aSpa["options"][$aValue["selected_variant"]])) {
								$aValue["result"] = $aSpa["options"][$aValue["selected_variant"]];
							}
							$aLogs[$iLogCount][$iId] = $aValue;
						}
						$iLogCount++;
					}
				}
				
				if (!empty($aLogs)) {
					$aResult[$iSpas]["title"] = (empty($sTitle)) ? $aSpa["title"] : $sTitle;
					$aResult[$iSpas]["value"] = $aLogs;
					$iSpas++;
				}
			}
		}
		$sVarDecision = "";
		if (!empty($aResult)) {
			for ($i = 0; $i < sizeof($aResult); $i++) {
				if (empty($aResult[$i]["value"])) {
					continue;
				}
				if ($i > 0) {
					$sVarDecision .= "<br/>";
				}
				for ($j = 0; $j < count($aResult[$i]["value"]); $j++) {
					$iCount = 0;
					foreach ($aResult[$i]["value"][$j] as $iActionStructId => $aValue) {
						if ($iCount > 0) {
							$sVarDecision .= "<br/>";
						}						
						$sVarDecision .= $aValue["employeeName"];						
						if (!empty($aValue["post"])) {
							$sVarDecision .= " (" . $aValue["post"] . ")";
						}					

						$sVarDecision .= ", " . $aValue["created_at"];
						if (isset($aValue["result"]["text"]) && strlen($aValue["result"]["text"]) > 0) {
							$sVarDecision .= ", <b>" . $aResult[$i]["title"] . ": " . $aValue["result"]["text"] . "</b>, ";
						}
						else {
							$sVarDecision .= ", <b>" . $aResult[$i]["title"] . ": </b>";
						}
							
						if (isset($aValue["comment"]) && strlen($aValue["comment"]) > 0) {
							$sVarDecision .= $aValue["comment"];								
						}
						
						if (!empty($aValue["files"])) {
							foreach ($aValue["files"] as $aFile) {
								try {
									$sVarDecision .= ", <a href=\"/media/download/" . $aFile["value"] . "\" target=\"_blank\">" . $aFile["name"] . "</a>";
								}
								catch (Exception $e) {}
							}
						}

						$iCount++;
					}
				}
			}
		}
		
		return $sVarDecision;
	}
}
?>