var WF_RecordExecution = Class.create();
WF_RecordExecution.prototype = Object.extend(new WF_AbstractExecution(),
{
	init: function()
	{
		this.buildEffect();
	},
	execute: function()
	{

		var Replace 	= this.getById('replace_field');
		var Value 		= this.getById('field');
		this.aFields 	= aFields;

		this.sValId 	= this.makeId("record-value");
		this.sValName 	= this.makeName("value");
		this.sValValue 	= this.get("value");
		this.Cont 		= this.getById('record_selected_value_cont');
		this.oTrParam	= this.getById("record_parameters");
		this.aValues 	= [{"title": "WORKFLOW_FIELDS", 		"value": "field", 	"types": ["reference", "int", "float", "date", "timestamp", "string", "text", "structure", "document", "file", "picture", "table"]},
		      		       {"title": "WORKFLOW_VARIABLES", 		"value": "var", 	"types": ["structure", "date", "timestamp", "string", "text"]},
		    		       {"title": "WORKFLOW_VALUE", 			"value": "value", 	"types": ["reference", "int", "float", "enum", "bool", "date", "timestamp", "string", "text", "structure", "document"]},
		    		       {"title": "WFA_RECORD_PARAM_FORMULA","value": "formula", "types": ["int" , "float"]},
		    		       {"title": "WORKFLOW_GROUPS",			"value": "groups",	"types": ["structure"]} 
		    		      ];

		this.aVars 		= [
						   {"title": "WORKFLOW_VAR_USER", 				"value": "user", 				"type": ["structure", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_AUTHOR", 			"value": "author", 				"type": ["structure", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_CREATED_AT", 		"value": "created_at", 			"type": ["date", "timestamp", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_MODIFIED_AT", 		"value": "modified_at", 		"type": ["date", "timestamp", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_STATUS", 			"value": "status", 				"type": ["string", "text"]},
		           		   {"title": "WORKFLOW_VAR_DOCTYPE", 			"value": "doctype", 			"type": ["string", "text"]},
		           		   {"title": "WORKFLOW_VAR_SUBDIVISION",		"value": "subdivision", 		"type": ["string", "text"]},
		           		   {"title": "WORKFLOW_VAR_TITLE",				"value": "title", 				"type": ["string", "text"]},
		           		   {"title": "WORKFLOW_VAR_AKTENPLAN",			"value": "aktenplan",			"type": ["string", "text"]},	           		   
		           		   {"title": "WORKFLOW_VAR_CURRENT_DATE", 		"value": "current_date", 		"type": ["date", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_CURRENT_DATE_TIME", 	"value": "current_date_time", 	"type": ["timestamp", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_CONTROL", 			"value": "control", 			"type": ["text"]},
		           		   {"title": "WORKFLOW_VAR_REGISTRATION_NUMBER","value": "registration_number", "type": ["string", "text"]},
		           		   {"title": "WORKFLOW_VAR_REGISTRATION_DATE", 	"value": "registration_date", 	"type": ["date", "timestamp", "string", "text"]},
		           		   {"title": "WORKFLOW_VAR_DOCUMENTS_FAMILY", 	"value": "documents_family", 	"type": ["text"]},
		           		   {"title": "WORKFLOW_VAR_DECISION", 			"value": "decision",			"type": ["text"]}		           		   
		           		  ];
		           		  
		this.aTypes		= $H({
							"int"     	: "float",
							"float"     : "int",
							"date"		: "timestamp",
							"timestamp" : "date",
							"string"	: "int, float, reference, date, timestamp, bool, structure, enum, document",
							"text"		: "int, float, reference, date, timestamp, bool, structure, enum, document"
						  });
		
		this.prepareFieldsReplace(Replace, Value);
	},
	
	prepareFieldsReplace: function(Replace, Value)
	{

		var me 				= this;
		Replace.options[0] 	= new Option(aGlobalMsfWords["WORKFLOW_NULL"], "");
		Value.options[0] 	= new Option(aGlobalMsfWords["WORKFLOW_NULL"], "");
		
		Replace.onchange = function()
		{
			me.Cont.update();
			me.clearSelect(Value, 1);

			if (this.value != "") {

				sFieldType = this.options[this.selectedIndex].getAttribute("type");

				me.prepareFieldsValue(
					sFieldType,
					Value,
					this.value,
					this.options[this.selectedIndex].getAttribute("ref")
				);
			}
			else {
				Value.onchange = null;
				me.parametersForRecord();
			}
			
			me.sValValue = "";
			
		}
		
		iCounter = 1;
		for (var i = 0; i < this.aFields.length; i++) {

			try {
				
				if (this.aFields[i].type == "table") {
					continue;
				}

				Replace.options[iCounter] = new Option(this.aFields[i].title, this.aFields[i].name);
				Replace.options[iCounter].setAttribute("type", this.aFields[i].type);

				if (this.aFields[i].value && this.aFields[i].value.optional) {
					if (this.aFields[i].value.optional.multiselect) {
						Replace.options[iCounter].setAttribute("multi", this.aFields[i].value.optional.multiselect);
					}
					if (this.aFields[i].value.optional.reference) {
						Replace.options[iCounter].setAttribute("ref", this.aFields[i].value.optional.reference);
					}
				}

				if (this.get("replace_field") == Replace.options[iCounter].value) {

					Replace.options[iCounter].selected = true;

					Replace.onchange();


				}

				iCounter++;
			}
			catch (e) {
				break;
			}


		}

	},
	
	prepareFieldsValue: function(sReplaceType, Value, sFieldName, iRef)
	{

		var bAllowed;
		var iCounter 	= 1;
		var me 			= this;
		var SubSelect 	= new Element("select", {"name": this.sValName});

		if (!SubSelect.id) {
			SubSelect.id = this.makeId("value");
		}

		Value.onchange = function()
		{
			me.clearSelect(SubSelect, 0);
			me.Cont.update();
			switch (this.value) {
				case "var":
					me.prepareVarValues(SubSelect, sReplaceType);
					break;
				case "field":
					me.prepareFieldValues(SubSelect, sReplaceType, sFieldName, iRef);
					break;
				case "value":
					me.prepareEmptyValues(sFieldName, sReplaceType);
					break;
				case "formula":
					me.prepareFormulaValues();
					break;
				case "groups":
					me.prepareGroupsValues(sFieldName);
					break;
			}
			
			if (this.value == "") {
				me.parametersForRecord();
			}
			else {
				me.parametersForRecord(sReplaceType);
			}
		}

		for (var i = 0; i < this.aValues.length; i++) {
			bAllowed = false;
			for (var j = 0; j < this.aValues[i].types.length; j++) {
				if (this.aValues[i].types[j] == sReplaceType || this.aValues[i].types[j] == "all") {
					bAllowed = true;
					break;
				}
			}
			
			if (bAllowed) {
				Value.options[iCounter] = new Option(aGlobalMsfWords[this.aValues[i].title], this.aValues[i].value);
				if (this.get("field") == Value.options[iCounter].value) {
					Value.options[iCounter].selected = true;
					Value.onchange();
				}
				iCounter++;
			}
		}
	
	},
	
	prepareVarValues: function(Select, sReplaceType)
	{
		var iCount = 0;
		this.Cont.insert(Select);
		
		for (var i = 0; i < this.aVars.length; i++) {
			bAllowed = false;
			for (var j = 0; j < this.aVars[i].type.length; j++) {
				if (this.aVars[i].type[j] == sReplaceType || this.aVars[i].type[j] == "all") {
					bAllowed = true;
					break;
				}
			}
			
			if (bAllowed) {
				Select.options[iCount] = new Option(aGlobalMsfWords[this.aVars[i].title], this.aVars[i].value);
				if (this.sValValue == Select.options[iCount].value) {
					Select.options[iCount].selected = true;
				}
				iCount++;
			}
		}		
	},
	
	prepareFieldValues: function(Select, sReplaceType, sFieldName, iRef)
	{
		var iCount 	= 0;
		this.Cont.insert(Select);
		
		for (var i = 0; i < this.aFields.length; i++) {
			if (this.aFields[i].type == sReplaceType || (this.aTypes.get(sReplaceType) && this.aTypes.get(sReplaceType).indexOf(this.aFields[i].type) != -1)) {
				if (this.aFields[i].value && this.aFields[i].value.optional && sReplaceType != "string") {
					if (this.aFields[i].value.optional.reference && this.aFields[i].value.optional.reference != iRef) {
						continue;
					}
				}
				
				Select.options[iCount] = new Option(this.aFields[i].title, this.aFields[i].name);
				if (this.sValValue == Select.options[iCount].value) {
					Select.options[iCount].selected = true;
				}
				iCount++;
			}
		}
	},
	
	prepareEmptyValues: function(sFieldName, sReplaceType)
	{
		this.insertType(sFieldName, sReplaceType);
	},
	
	insertType: function(sFieldName, sType)
	{
		var bTime = true;
		
		switch (sType) {
			case "int":
			case "float":
			case "string":
				this.Cont.insert(new Element("input", {"id": this.sValId, "name": this.sValName, "value": this.sValValue}));
				break;
			case "text":
				var t = new Element("textarea", {"id": this.sValId, "name": this.sValName});
				t.style.width  = "98%";
				t.style.height = "40pt";
				t.style.display = "none";
				this.Cont.insert(t);
				t.style.display = "block";
				t.value = this.sValValue;
				break;
			case "reference":
				var Options = this.defineFieldOptions(sFieldName);
				
				if (Options && Options.optional) {
					Options 		= Options.optional;
					var aColumns 	= {};
					var aFilters 	= {};
					
					if (Options.defaultFilter) {
						$H(Options.defaultFilter).each(function(e) {
							aFilters[e.key] = e.value;
						});
					}

                                        if(Options.columns != undefined){
                                            for (var i = 0; i < Options.columns.length; i++) {
                                                    if (Options.fieldsValue) {
                                                            aColumns[Options.columns[i]] = {
                                                                    "select": (Options.fieldsValue[Options.columns[i]]) ? true : false,
                                                                    "group": (Options.groupEnable == 1) ? true : false,
                                                                    "filter": (Options.filterEnable == 1) ? true : false,
                                                                    "sort": true
                                                            };
                                                    }						
                                            }
                                        }
					
					this.addReference({
						mPlace			: 	this.Cont,
						iRefId			: 	Options.reference,
						sInputName		: 	"value",
						aColumns		: 	aColumns,
						aDefaultGroups	: 	(Options.defaultGroup) ? Options.defaultGroup : [],
						bById			: 	true,
						bMultiselect	: 	(Options.multiselect == 0) ? false : true,
						sDefaultValues	: 	this.sValValue,
						aDefaultFilters : 	aFilters,
						sSeparator		:   Options.separator
					});
				}
				break;
			case "structure":
				var Options = this.defineFieldOptions(sFieldName);
				
				this.addStructure({
					"mPlace" 			: this.Cont,
					//"sInputName"  		: this.sValName,
					"sInputName"  		: "value",
					"sDefaultValues" 	: this.sValValue,
					"bMultiselect" 		: (Options.optional.multiselect == 1) ? true : false,
					"bShowPosts" 		: (Options.optional.postEnable == 1) ? true : false
				});
				break;
			case "date":
				bTime = false;
			case "timestamp":
				this.addCalendar({
					"mPlace"			: this.Cont,
					"sInputName"		: "value",
					"sDefaultValues"	: this.sValValue,
					"bTime"				: bTime
				});
				break;
			case "document":
				var Options = this.defineFieldOptions(sFieldName);
				this.addDocument({
					mPlace			: this.Cont,
					sInputName		: "value",
					sDefaultValues	: this.sValValue,
					bMultiselect 	: Options.optional.multiselect
				});
				break;
			case "enum":
				var Enum = new Element("select", {"name": this.sValName});
				this.Cont.insert(Enum);
				
				var Options = this.defineFieldOptions(sFieldName);
				if (Options && Options.optional) {
					for (var i = 0; i < Options.optional["enum"].length; i++) {
						Enum.options[i] = new Option(Options.optional["enum"][i], i);
						if (this.sValValue == i) {
							Enum.options[i].selected = true;
						}
					}
				}
				break;
			case "bool":
				var Bool = new Element("select", {"name": this.sValName});
				this.Cont.insert(Bool);
				
				var Options = this.defineFieldOptions(sFieldName);
				if (Options && Options.optional) {
					Bool.options[0] = new Option(Options.optional.labelYes, 1);
					Bool.options[1] = new Option(Options.optional.labelNo, 0);
					
					if (this.sValValue == 1) {
						Bool.options[0].selected = true;
					}
					else {
						Bool.options[1].selected = true;
					}
				}
				break;
		}
	},
	
	prepareGroupsValues : function(sFieldName) {
		var Options = this.defineFieldOptions(sFieldName);
		var oRefGroups = new MSFW.Placeholder.Reference({
			"Container"			: this.Cont,
			"referenceId"		: 316,
			"inputName"			: this.sValName,
			"columns"			: {	
									"name" 		: {	"select" : true,	"group" : true,	"sort" : true,	"filter" : true },
									"employee" 	: {	"select" : false,	"group" : true,	"sort" : true,	"filter" : true	}
								  },
			"defaultGroups"		: ["name"],
			"byId"				: true,
			"multiselect"		: (Options.optional.multiselect == 1) ? true : false,
			"default"			: this.sValValue,
			"valueSeparator"	: ", "
		});
	},
		
	defineFieldOptions: function(sFieldName)
	{
		for (var i = 0; i < this.aFields.length; i++) {
			if (this.aFields[i].name == sFieldName) {
				return this.aFields[i].value;
			}
		}
	},
	
	clearSelect: function(Select, iIndex)
	{
		for (var i = Select.options.length - 1; i >= iIndex; i--) {
			Select.options[i] = null;
		}
		
		if (Select.options[0]) {
			Select.options[0].selected = true;
		}
	},
	
	prepareFormulaValues: function() {
		this.Cont.insert(new Element("input", {"name": this.makeName("formula"), "value": this.get("formula"), "style":"width:90%"}));
	},
	
	parametersForRecord: function(sFieldType)
	{
		this.oTrParam.show();
		var oSelectParam	  		= this.getById("record_param", this.makeName("record_param"));
		oSelectParam.name			= this.makeName("record_param");
		oSelectParam.options.length = 0;
		oSelectParam.options[0] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_NONE"], "");
		oSelectParam.onchange 		= null;
		var oParamCont 				= this.getById("record_parameters_cont");
		oParamCont.update();
		switch(sFieldType) {
			case "string":
			case "text":
				oSelectParam.options[1] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_MERGE"], "merge");
				oSelectParam.value			= this.get("record_param");
				var me = this;
				oSelectParam.onchange = function() {
					if (oSelectParam.value != "") {			
						var oSelectParamValue 	= new Element("INPUT");
						oSelectParamValue.name  = me.makeName("record_param_value");
						oSelectParamValue.value	= me.get("record_param_value");
						oParamCont.update(aGlobalMsfWords["WFA_RECORD_PARAM_MERGE_SEPARATOR"] + " ");
						oParamCont.insert(oSelectParamValue);
					}
					else {
						oParamCont.update();
					}
				}
				oSelectParam.onchange();
				break;
			case "structure":
				oSelectParam.options[1] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_ADD"], "merge");
				oSelectParam.options[2] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_DEL"], "delete");
				oSelectParam.options[3] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_BOSS"], "boss");
				oSelectParam.options[4] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_SUBDIVISION"], "subdivision");
				oSelectParam.value			= this.get("record_param");
				break;
			case "document":
			case "reference":
				oSelectParam.options[1] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_ADD"], "merge");
				oSelectParam.options[2] 	= new Option(aGlobalMsfWords["WFA_RECORD_PARAM_DEL"], "delete");
				oSelectParam.value			= this.get("record_param");
				break;
			default:
				oSelectParam.value			= "";
				this.oTrParam.hide();
				break;
		}		
	},
	buildEffect : function()
	{
		var oSelect 	= this.getById('record');
		Effect.BlindDown(oSelect);
	}
});