<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="action[@type='record']">
		<script>
			function addFileRecord(Img)
			{
				var oCont 	= $(Img.parentNode.parentNode);
				var oDiv 	= new Element('div');
				oDiv.setAttribute("style", "padding-bottom:3px");
				oDiv.insert(new Element('input', {'type': 'file', 'name': Img.id + '[]'}));
				oDiv.insert('&#160;');
				var oAddImg = new Element('IMG', {src:"/templates/default/images/add.png", id:Img.id, 
											      style: "cursor: pointer;"});
				oDiv.insert(oAddImg);
				var oRemoveImg = new Element('IMG', {src:"/templates/default/images/red_cross.png",
													 style: "cursor: pointer;"});
				oDiv.insert(oRemoveImg);
				
				oCont.insert(oDiv);
				Event.observe(oAddImg, "click", function(){addFileRecord(oAddImg)});
				Event.observe(oRemoveImg, "click", function(){removeFileRecord(oRemoveImg)});
			}
			function removeFileRecord(Img)
			{
				if (Img.parentNode.parentNode.childElementCount != 1) {
					Img.parentNode.parentNode.removeChild(Img.parentNode);
				}
			}
		</script>
		<xsl:variable name="record_id">
			<xsl:value-of select="@id"/>
		</xsl:variable>
		<xsl:variable name="type">
			<xsl:value-of select="item[@name='optional']/item[@name='type']/@value"/>
		</xsl:variable>
		<xsl:variable name="value">
			<xsl:value-of select="item[@name='value']/@value"/>
		</xsl:variable>
		<xsl:variable name="multi">
			<xsl:value-of select="item[@name='optional']/item[@name='optional']/item[@name='multiselect']/@value"/>
		</xsl:variable>
		<form method="post" action="{@url}" id="action_window_{@id}" style="display: none" enctype="multipart/form-data">
			<div class="admin-route-blc">
				<table class="admin-route-tbl">
					<tr>
						<td class="admin-route-rtd">
							<xsl:value-of select="item[@name='label_text']/@value"/>
							<br/>
							<xsl:choose>
								<xsl:when test="$type='table'">
									<div id="record_table_type_{$record_id}" style="width:100%;"></div>
									<script>
										/**
										 * 
									     */
										var sRawWidth = "<xsl:value-of select="item[@name='optional']/item[@name='width']/@value"/>";
										var sPreparedWidth = "";
										if (sRawWidth.indexOf('pt') > 1) {
											sPreparedWidth = parseFloat(sRawWidth) + "pt";
										}
										else if (sRawWidth.indexOf('%') > 1) {
											sPreparedWidth = screen.width * parseFloat(sRawWidth)/120 + "px";
										}
										else {
											sPreparedWidth = parseFloat(sRawWidth) + "px";
										}
										
										if ((sPreparedWidth == "NaNpx") ||(sPreparedWidth == "NaNpt") ||(sPreparedWidth == "NaN%")) {
											sPreparedWidth = "";	
										}
										
										new REF_Table({
											oContainer		: "record_table_type_<xsl:value-of select="$record_id"/>",
											sWidth 			: sPreparedWidth,
											sCellpadding 	: "<xsl:value-of select="item[@name='optional']/item[@name='cellpadding']/@value"/>",
											sCellspacing 	: "<xsl:value-of select="item[@name='optional']/item[@name='cellspacing']/@value"/>",
											sBorderWidth 	: "<xsl:value-of select="item[@name='optional']/item[@name='borderWidth']/@value"/>",
											sDisplayInRS 	: "<xsl:value-of select="item[@name='optional']/item[@name='displayInRS']/@value"/>",
											sMode 			: "edit",
											aFields 		: <xsl:value-of select="item[@name='optional']/item[@name='fields']/@value"/>,
											sName 			: "<xsl:value-of select="item[@name='replace_field']/@value"/>",
											sDefaultValue 	: "<xsl:value-of select="$value"/>"
										});
									</script>
								</xsl:when>
								<xsl:when test="$type='int'">
									<input name="{item[@name='replace_field']/@value}" value="{$value}" maxlength="12"/>
								</xsl:when>
								<xsl:when test="$type='float'">
									<input name="{item[@name='replace_field']/@value}" value="{$value}" maxlength="15"/>
								</xsl:when>
								<xsl:when test="$type='string'">
									<input name="{item[@name='replace_field']/@value}" value="{$value}" size="50"/>
								</xsl:when>
								<xsl:when test="$type='bool'">
									<select name="{item[@name='replace_field']/@value}" id="record_bool_id_{$record_id}">
										<option value="1"><xsl:value-of select="item[@name='optional']/item[@name='optional']/item[@name='labelYes']/@value"/></option>
										<option value="0"><xsl:value-of select="item[@name='optional']/item[@name='optional']/item[@name='labelNo']/@value"/></option>
									</select>
									<script>
										var Select = $("record_bool_id_<xsl:value-of select="$record_id"/>");
										
										for (var i = 0; i &lt; Select.options.length; i++) {
											if ("<xsl:value-of select="$value"/>" == Select.options[i].value) {
												Select.options[i].selected = true;
												break;
											}
										}
									</script>
								</xsl:when>
								<xsl:when test="$type='enum'">
									<select name="{item[@name='replace_field']/@value}" id="record_enum_id_{$record_id}">
										<xsl:for-each select="item[@name='optional']/item[@name='optional']/item[@name='enum']/item">
											<option value="{@name}"><xsl:value-of select="@value"/></option>
										</xsl:for-each>
									</select>
									<script>
										var Select = $("record_enum_id_<xsl:value-of select="$record_id"/>");
										
										for (var i = 0; i &lt; Select.options.length; i++) {
											if ("<xsl:value-of select="$value"/>" == Select.options[i].value) {
												Select.options[i].selected = true;
												break;
											}
										}
									</script>
								</xsl:when>
								<xsl:when test="$type='document'">
									<span id="record_document_id_{$record_id}"></span>
									<script>
										var aValue 	= new Array();
										var i		= 0;
										<xsl:for-each select="item[@name='value']/item">
											aValue[i++] = '<xsl:value-of select="@value"/>';
										</xsl:for-each>
										sValue = aValue.join("|^|row|^|");
										aDoctypes = new Array();
										var j		= 0;
										<xsl:for-each select="item[@name='optional']/item[@name='optional']/item[@name='doctypes']/item">
											aDoctypes[j++] = '<xsl:value-of select="@value"/>';
										</xsl:for-each>
										sDoctypes = aDoctypes.join(",");
										new MSFW.Placeholder.Document({
											"Container" 	: "record_document_id_<xsl:value-of select="$record_id"/>",
											"inputName" 	: "<xsl:value-of select="item[@name='replace_field']/@value"/>[]",
											"multiselect" 	: <xsl:choose><xsl:when test="$multi=1">true</xsl:when><xsl:otherwise>false</xsl:otherwise></xsl:choose>,
											"docTypes"		: sDoctypes,
											"default"		: sValue
										});
									</script>
								</xsl:when>
								<xsl:when test="$type='file' or $type='picture'">
									<style>
									ul.file-placeholder {
										float		: left;
										padding		: 0px;
										margin		: 0px;
										list-style	: none;
									}
									
									ul.file-placeholder li {
										
									}
									
									img.file-del, img.file-add {
										cursor		: pointer;
									}
									
									img.file-move {
										cursor		: move;
									}
									
									input.file-add {
										color:#A9A9A9;
									}
									</style>
									<div id="file-placeholder">
										<ul class= "file-placeholder" id="fp{item[@name='replace_field']/@value}">
											<xsl:for-each select="item[@name='files']/item">
												<xsl:choose>
													<xsl:when test="$multi=1">
														<li>
															<img class="file-move" src="/templates/default/images/move_row.png"/>
															<input type="hidden" name="record_added_file[name][]" value="{item[@name='name']/@value}"/>
															<input type="hidden" name="record_added_file[value][]" value="{item[@name='id']/@value}"/>
															<xsl:value-of select="item[@name='name']/@value"/>
															<img class="file-del" src="/templates/default/images/red_cross.png" 
																onclick="this.parentNode.parentNode.removeChild(this.parentNode);"/>
														</li>
													</xsl:when>
													<xsl:otherwise>
														<xsl:if test="position() = 1">
															<li>
																<input type="hidden" name="record_added_file[name][]" value="{item[@name='name']/@value}"/>
																<input type="hidden" name="record_added_file[value][]" value="{item[@name='id']/@value}"/>
																<xsl:value-of select="item[@name='name']/@value"/>
																<img class="file-del" src="/templates/default/images/red_cross.png" 
																	onclick="this.parentNode.parentNode.removeChild(this.parentNode);"/>
															</li>
														</xsl:if>
													</xsl:otherwise>
												</xsl:choose>
											</xsl:for-each>
											<xsl:choose>
												<xsl:when test="$multi=1">
													<li>
														<input class="file-add" type="file" name="{item[@name='replace_field']/@value}[]"/>
														<img class="file-del" src="/templates/default/images/remove_row.png" 
														onclick="trash{item[@name='replace_field']/@value}(this)"/>
														<script>
															function trash<xsl:value-of select="item[@name='replace_field']/@value"/>(oObj) {
																var oPrnt = oObj.parentNode;
																var oInp1 = oPrnt.getElementsByTagName('INPUT')[0];
																oPrnt.removeChild(oInp1);
																var oInp2 = new Element('INPUT', {
																		type	: 'file',
																		name 	: '<xsl:value-of select="item[@name='replace_field']/@value"/>[]'
																		});
																oPrnt.insertBefore(oInp2, oObj);
																oInp2.addClassName('file-add');
															}
														</script>
														<img class="file-add" src="/templates/default/images/add.png" onclick="add{item[@name='replace_field']/@value}()"/>
														<script>
															function add<xsl:value-of select="item[@name='replace_field']/@value"/>() {
																var oLi 	= new Element('LI');
																var oInput	= new Element('INPUT', {type : 'file'});
																var oDel	= new Element('IMG');
																oLi.insert(oInput).insert(oDel);
																$('fp<xsl:value-of select="item[@name='replace_field']/@value"/>').insert(oLi);
																oInput.name = '<xsl:value-of select="item[@name='replace_field']/@value"/>[]';
																oInput.addClassName('file-add');
																oDel.src	= '/templates/default/images/red_cross.png';
																oDel.addClassName('file-del');
																oDel.onclick= function() {
																	this.parentNode.parentNode.removeChild(this.parentNode);
																}
																
																Sortable.create(
																		'fp<xsl:value-of select="item[@name='replace_field']/@value"/>', 
																		{handle : 'file-move'}
																		);
																		
															}
														</script>	
													</li>
												</xsl:when>
												<xsl:otherwise>
													<li>
														<input class="file-add" type="file" name="{item[@name='replace_field']/@value}[]"/>
														<img class="file-del" src="/templates/default/images/remove_row.png" 
														onclick="trash{item[@name='replace_field']/@value}(this)"/>
														<script>
															function trash<xsl:value-of select="item[@name='replace_field']/@value"/>(oObj) {
																var oPrnt = oObj.parentNode;
																var oInp1 = oPrnt.getElementsByTagName('INPUT')[0];
																oPrnt.removeChild(oInp1);
																var oInp2 = new Element('INPUT', {
																		type	: 'file',
																		name 	: '<xsl:value-of select="item[@name='replace_field']/@value"/>[]'
																		});
																oPrnt.insertBefore(oInp2, oObj);
																oInp2.addClassName('file-add');
															}
														</script>
													</li>
												</xsl:otherwise>
											</xsl:choose>														
										</ul>
										<input type="file" style="display:none;" name="{item[@name='replace_field']/@value}[]"/>
										<div style="clear:both;"></div>
									</div>
							
									<script>
										Sortable.create("fp<xsl:value-of select="item[@name='replace_field']/@value"/>", {handle : "file-move"});
									</script>
								</xsl:when>
								<xsl:when test="$type='date'">
									<span id="record_date_id_{$record_id}"></span>
									<script>
										new MSFW.Placeholder.Calendar({
											"Container" : "record_date_id_<xsl:value-of select="$record_id"/>",
											"inputName" : "<xsl:value-of select="item[@name='replace_field']/@value"/>",
											"time" : false,
											"default" : "<xsl:value-of select="$value"/>"
										});	
									</script>
								</xsl:when>
								<xsl:when test="$type='timestamp'">
									<span id="record_timestamp_id_{$record_id}"></span>
									<script>
										new MSFW.Placeholder.Calendar({
											"Container" : "record_timestamp_id_<xsl:value-of select="$record_id"/>",
											"inputName" : "<xsl:value-of select="item[@name='replace_field']/@value"/>",
											"time" : true,
											"default" : "<xsl:value-of select="$value"/>"
										});	
									</script>
								</xsl:when>
								<xsl:when test="$type='structure'">
									<span id="record_structure_id_{$record_id}"></span>
									<script>
										new MSFW.Placeholder.Structure({
											"Container" : "record_structure_id_<xsl:value-of select="$record_id"/>",
											"inputName" : "<xsl:value-of select="item[@name='replace_field']/@value"/>",
											"multiselect" : <xsl:choose><xsl:when test="$multi=1">true</xsl:when><xsl:otherwise>false</xsl:otherwise></xsl:choose>,
											"showPosts" : "<xsl:choose><xsl:when test="item[@name='optional']/item[@name='optional']/item[@name='postEnable']/@value = 1">1</xsl:when><xsl:otherwise>0</xsl:otherwise></xsl:choose>",
											"default" : "<xsl:value-of select="$value"/>"
										});
									</script>
								</xsl:when>
								<xsl:when test="$type='reference'">
									<span id="record_refernce_id_{$record_id}"></span>
									<script>
										new MSFW.Placeholder.Reference({
											"Container" : "record_refernce_id_<xsl:value-of select="$record_id"/>",
											"inputName" : "<xsl:value-of select="item[@name='replace_field']/@value"/>",
											"referenceId" : <xsl:value-of select="item[@name='optional']/item[@name='optional']/item[@name='reference']/@value"/>,
											"multiselect" : <xsl:value-of select="$multi"/>,
											"objectId"	  : "<xsl:value-of select="item[@name='object_id']/@value"/>",	
											"unique"	  : "<xsl:if test="item[@name='optional']/item[@name='optional']/item[@name='unique']/@value = 1">1</xsl:if>
															<xsl:if test="item[@name='optional']/item[@name='optional']/item[@name='unique']/@value = 0">0</xsl:if>",
											"uniqueType"  : "doctype",
											"byId" : true,
											"columns" : <xsl:value-of select="item[@name='optional']/item[@name='optional']/item[@name='columns']/@value"/>,
											"default" : "<xsl:value-of select="$value"/>",
											"defaultGroups" : <xsl:value-of select="item[@name='optional']/item[@name='optional']/item[@name='defaultGroup']/@value"/>,
											"defaultFilters" : <xsl:value-of select="item[@name='optional']/item[@name='optional']/item[@name='defaultFilter']/@value"/>,
											"valueSeparator" : "<xsl:value-of select="item[@name='optional']/item[@name='optional']/item[@name='separator']/@value"/>"
										});
									</script>
								</xsl:when>
								<xsl:when test="$type='text'">
									<xsl:if test="item[@name='optional']/item[@name='optional']/item[@name='viewRTE']/@value = 1">
										<textarea id="record_ta_id_{@id}" name="{item[@name='replace_field']/@value}" class="rteEditor">
											<xsl:value-of select="$value"/>
										</textarea>
									</xsl:if>
									<xsl:if test="item[@name='optional']/item[@name='optional']/item[@name='viewRTE']/@value = 0">
										<textarea id="record_ta_id_{@id}" name="{item[@name='replace_field']/@value}">
											<xsl:value-of select="$value"/>
										</textarea>
										<script>initTextarea("record_ta_id_" + <xsl:value-of select="@id"/>);</script>
									</xsl:if>
								</xsl:when>
							</xsl:choose>
						</td>
						<input type="hidden" name="field" value="{item[@name='field']/@value}"/>
						<input type="hidden" name="replace_field" value="{item[@name='replace_field']/@value}"/>
					</tr>
					<tr>
						<td><input type="submit" value="OK" onclick="oneClickHandler(this)"/></td>
					</tr>
				</table>
			</div>
		</form>
	</xsl:template>
</xsl:stylesheet>