<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}


include_once "WFA_RegistrationDB.php";

class WFA_Registration extends WF_ActionSupport implements WF_IAction
{
	const AKTENPLAN_REFERENCE_ID	= 14;
	
	const SUBJECTS_REFERENCE_ID		= 15;
	
	const LOG_POINT_ID				= 0;
	
	const LOG_ACTION_ID				= "registration";
	
	private $DB						= null;
	
	public function initialize()
	{
		
	}
	
	public function processSchedule()
	{
		return true;
	}

	public function processRequest()
	{
		$sRegNumber	= $this->getParam("post", "registration_number");
		$Date		= new MSF_Date();
		$Locale		= MSF_Registry::get("MSF_Locale");
		$Log		= $this->getLog();
		
		try {
			$sRegNumber	= $this->getRegistrationNumber($sRegNumber);
							
			if($sRegNumber != "") {
				$RV	= new REF_Value();
				$RV->parse($sRegNumber);
				$aVals		= $RV->getValuesList();
				$sRegNumber	= $aVals[0];
				
				$aSearch	= array('[ДД]','[ММ]', '[ГГ]', '[ГГГГ]');
				$aReplace	= array(date('d', time()), date('m', time()), date('y', time()), date('Y', time()));
				$sRegNumber = str_replace ( $aSearch , $aReplace , $sRegNumber);
				
				$aToSave["registration_number"]	= $sRegNumber;
				$aToSave["registration_date"]	= $Date->format(CNF_DATE_FORMAT);
				$aToSave["registred"]			= 1;
				
				$this->saveRegistrationNumber($sRegNumber, $Date->format(CNF_DATE_FORMAT));
				$this->DB->setRegistrationDate($this->getDocument()->getDocumentId(), date("Y-m-d"));		
				
				$sSmallText	=
							$Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_NUMBER") .
							" " .
							$sRegNumber;
							
				$sFullText	=
							$Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_NUMBER") .
							" " .
							$sRegNumber .
							//"<br/>" .
							"\n" .
							$Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_DATE") .
							" " .
							$Date->format(CNF_DATE_FORMAT);
							
				
							
				//$Log->setDelegated($this->getDocument()->getPointId(), $this->getActionId(), $aToSave);
				$Log->setDelegated(self::LOG_POINT_ID, self::LOG_ACTION_ID, $aToSave);
				$Log->display($this->getActionTitle(), $sSmallText, $sFullText);
				$Log->report($this->getDocument()->getPointId(), $this->getActionName(), $sRegNumber);
				//$Doc->save();
			}
			else {
				MSF_Registry::get("MSF_Messenger")->addError($Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_WRONG_NUMBER"));
				$Log->display($this->getActionTitle(), $Locale->getWord("WF_CONTEXT_EXECUTION_NOT_CORRECT_PARAMS"),
							  $Locale->getWord("WF_CONTEXT_EXECUTION_NOT_CORRECT_PARAMS") . "\n" . 
							  $Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_WRONG_NUMBER")
							  );
				
				return self::NULL;
			}
			$this->callMove();
			return self::SUCCESS;
		}
		catch(Exception $e) {
			echo $e->getMessage();
			return self::FAILURE;
		}
		
	}

	public function processResponse()
	{
		return self::FAILURE;
	}
		
	public function processCall()
	{
		//return true;
	}
	
	public function processExecute()
	{
		$aRoute		= $this->getSettings()->getActions($this->getActionId());
		$Date		= new MSF_Date();		
		$sRegNumber	= $aRoute["options"]["registration_number"];
		
		try {
			$sRegNumber	= $this->getRegistrationNumber($sRegNumber);
			$Log		= $this->getLog();
			$Locale		= MSF_Registry::get("MSF_Locale");			
			if($sRegNumber != "") {
				$RV	= new REF_Value();
				$RV->parse($sRegNumber);
				$aVals		= $RV->getValuesList();
				$sRegNumber	= $aVals[0];								
				
				$this->saveRegistrationNumber($sRegNumber, $Date->format(CNF_DATE_FORMAT));
				$this->DB->setRegistrationDate($this->getDocument()->getDocumentId(), date("Y-m-d"));				
				//$Doc->save();
				
				$aToSave["registration_number"]	= $sRegNumber;
				$aToSave["registration_date"]	= $Date->format(CNF_DATE_FORMAT);
				$aToSave["registred"]			= 1;
					
				$sSmallText	=
							$Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_NUMBER") .
							" " .
							$sRegNumber;
							
				$sFullText	=
							$Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_NUMBER") .
							" " .
							$sRegNumber .
							//"<br/>" .
							"\n" .
							$Locale->getWord("WORKFLOW_DOCTYPE_SPA_REGISTRATION_DATE") .
							" " .
							$Date->format(CNF_DATE_FORMAT);
				
				$Log->setDelegated(self::LOG_POINT_ID, self::LOG_ACTION_ID, $aToSave);
				$Log->display($this->getActionTitle(), $sSmallText, $sFullText);
				$Log->report($this->getDocument()->getPointId(), $this->getActionName(), $sRegNumber);
			}
			else {
				$Log->display($this->getActionTitle(), $Locale->getWord("WF_CONTEXT_EXECUTION_NOT_CORRECT_PARAMS"),
							  $Locale->getWord("WF_CONTEXT_EXECUTION_NOT_CORRECT_PARAMS") . "\n" . 
							  $Locale->getWord("WFA_ERROR_REGISTRATION_NULL_NUMBER_REFERENCE")
							  );
			}
		}
		catch(Exception $e) {
			//echo $e->getMessage();
			return self::FAILURE;
		}
		
		$this->callMove();
		return self::SUCCESS;
	}

	private function callMove()
	{
		$aRoute		= $this->getSettings()->getActions($this->getActionId());
		if (isset($aRoute["options"])) {
			if (isset($aRoute["options"]["move_points"])) {		
				$this->call("move", array("iNewPoint" => $aRoute["options"]["move_points"]));
			}
		}
	}
	
	public function cancel()
	{
		return self::SUCCESS;
	}

	public function getLogTitle()
	{
		return MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_LOG_REGISTRATION_DOCUMENT_REGISTRED");
	}

	public function getLogParams()
	{
		//debug($this->getLog($this->getDocument()->getPointId(), $this->getActionId()));
		
		return array();
	}
	
	private function getRegistrationNumber($sRegNumber)
	{		
		if($sRegNumber == "") {
			return "";
		}
		
		$this->DB	= new WFA_RegistrationDB(MSF_Registry::get("MSF_DB"));
		$RefValue	= new REF_Value();
		$RefValue->parse($sRegNumber);
		
		$aKeys		= $RefValue->getKeysList();
		$iRowId		= $aKeys[0];
		if(empty($iRowId)) {
			$aPeriodCond	= $this->formDateCondition("1");			
			if($this->DB->isExistedNumber($sRegNumber, $aPeriodCond)) {
				$sRegNumber	= "";
			}
		}
		else {
			$aRow	= $this->DB->select($iRowId);
			if(empty($aRow)) {
				$sRegNumber	= "";
			}
			else {
				$iCount			= $aRow["count"];
				$aSearch		= array('[ДД]','[ММ]', '[ГГ]', '[ГГГГ]');
				$aReplace		= array(date('d', time()), date('m', time()), date('y', time()), date('Y', time()));
				$sSuffix		= str_replace ( $aSearch , $aReplace , $aRow["suffix"]);
				$sPrefix		= str_replace ( $aSearch , $aReplace , $aRow["prefix"]);
				$sNumbersCount	= $aRow["numbers_count"];								
				$aPeriodCond	= $this->formDateCondition(MSF_EnumValue::parse($aRow["periodicity"]));
				$sRegNumber	= $sPrefix . $iCount . $sSuffix;
				
				if(!$this->DB->documentsExists($sPrefix, $sSuffix, $aPeriodCond) && !empty($aPeriodCond)) {
					$iCount	= 1;
					$sRegNumber	= $sPrefix . $this->formRegistrationNumber($sNumbersCount, $iCount) . $sSuffix;		
				}
				
				if($this->DB->isExistedNumber($sRegNumber, $aPeriodCond)) {
					while($this->DB->isExistedNumber($sRegNumber, $aPeriodCond)) {
						$iCount++;
						$sRegNumber	= $sPrefix . $this->formRegistrationNumber($sNumbersCount, $iCount) . $sSuffix;
					}
				}
				
				$RV			= new REF_Value();
				$RV->add($iRowId, $sRegNumber);
				$sRegNumber	= $RV->format();
				
				$iCount++;				
				$this->DB->setCountValue($iRowId, $this->formRegistrationNumber($sNumbersCount, $iCount));				
			}
			
		}		
		
		return $sRegNumber;
	}
	
	private function formRegistrationNumber($sNumbersCount, $iCount)
	{
		$sResult = $iCount;
		if(MSF_EnumValue::parse($sNumbersCount) == null) {
			$iCounter = $sNumbersCount;						
		}
		else {
			$aTmp		= MSF_EnumValue::parse($sNumbersCount);
			$iCounter	= $aTmp["key"];					
		}					
						
		$iPre		= $iCounter - strlen($sResult);
		for($i = 0; $i <= $iPre; $i++) {
			$sResult = "0" . $sResult;					
		}

		return $sResult;
	}
	
	private function formDateCondition($Period)
	{	
		$aResult	= array();		
		if($Period == null) {
			$sPeriod 	= "0";			
		}
		else if(is_array($Period)){
			$sPeriod	= $Period["key"];
		}
		else {
			$sPeriod	= $Period;		
		}
		
		$iYear	= date("Y");
		$iMonth	= date("m");
		switch($sPeriod) {
			case "0":
				break;
			case "1":
				$aResult["sFrom"]	= "'" . $iYear . "-01-01'";
				$aResult["sTo"]		= "'" . ($iYear + 1) . "-01-01'";				
				break;
			case "2":				
				if($iMonth >= 1 && $iMonth <= 3) {
					$aResult["sFrom"]	= "'" . $iYear . "-01-01'";
					$aResult["sTo"]		= "'" . $iYear . "-04-01'";										
				}
				else if($iMonth >= 4 && $iMonth <= 6) {
					$aResult["sFrom"]	= "'" . $iYear . "-04-01'";
					$aResult["sTo"]		= "'" . $iYear . "-07-01'";					
				}
				else if($iMonth >= 7 && $iMonth <= 9) {
					$aResult["sFrom"]	= "'" . $iYear . "-07-01'";
					$aResult["sTo"]		= "'" . $iYear . "-10-01'";					
				}
				else if($iMonth >= 10 && $iMonth <= 12) {
					$aResult["sFrom"]	= "'" . $iYear . "-10-01'";
					$aResult["sTo"]		= "'" . ($iYear + 1) . "-01-01'";					
				}
				
				break;
			case "3":
				if($iMonth < 12) {
					$aResult["sFrom"]	= "'" . $iYear . "-" . $iMonth . "-01'";
					$aResult["sTo"]		= "'" . $iYear . "-" . ($iMonth + 1) . "-01'";						
				}
				else {
					$aResult["sFrom"]	= "'" . $iYear . "-01-" . $iMonth . "'";
					$aResult["sTo"]		= "'" . ($iYear + 1) . "-01-01'";					 
				}
				
				break;				
		}
		
		return $aResult;
		
		
	}
	
	private function saveRegistrationNumber($sRegNumber, $sRegDate) {
		$this->getDocument()->setRegistrationNumber($sRegNumber);
		$oVersion = $this->getDocumentVersion();
		$oVersion->setSystemField("registration_number", $sRegNumber);
		$oVersion->setSystemField("registration_date", $sRegDate);
		$oVersion->save();
	}
		
}

?>