<?php

require_once "modules/workflow/actions/registration/WFA_Registration.php";
class WFA_RegistrationViewPort extends WFA_AbstractViewPort
{
	/**
	 * @return void 
	 */
	public function port(array $aActionParams, array $aCurrentDelegated)
	{
		if($aActionParams["options"]["registration_number"] != "") {
			$RefValue	= new REF_Value();
			$RefValue->parse($aActionParams["options"]["registration_number"]);
	
			$DB			= new WFA_RegistrationDB(MSF_Registry::get("MSF_DB"));
			$aKeys		= $RefValue->getKeysList();
			$iRowId		= $aKeys[0];
			$aRow		= $DB->select($iRowId);
			if(!empty($aRow)) {
				
				$sPrefix		= $aRow["prefix"];
				$iCount			= (int)$aRow["count"];
				$sSuffix		= $aRow["suffix"];
				$sNumbersCount	= $aRow["numbers_count"];					
				
				if(MSF_EnumValue::parse($sNumbersCount) == null) {
					$iCounter = $sNumbersCount;						
				}
				else {
					$aTmp		= MSF_EnumValue::parse($sNumbersCount);
					$iCounter	= $aTmp["key"];					
				}					
								
				$iPre		= $iCounter - strlen($iCount);
				for($i = 0; $i <= $iPre; $i++) {
					$iCount = "0" . $iCount;					
				}				
				
				$sRegNumber	= $sPrefix . $iCount . $sSuffix;
				
				$RV			= new REF_Value();
				$RV->add($iRowId, $sRegNumber);				
				$sRegNumber	= $RV->format();
				$aCurrentDelegated["registration_number"] 	= htmlspecialchars($sRegNumber);
				//$aCurrentDelegated["registration_number"]	= str_replace("\"", "&#34;", $sRegNumber);
				$aCurrentDelegated["visible"]  		 		= $aActionParams["options"]["visible"];
				if (isset($aActionParams["options"]["object_id"])) {
					$aCurrentDelegated["object_id"]   			= $aActionParams["options"]["object_id"];
				}
				
			}				
			
		}
		
		return $aCurrentDelegated;
	}
	
}
?>