<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="action[@type='registration']">
		<form class="spa-form" style="display: none" id="action_window_{@id}" method="post" action="{@url}">
			<table>
				<tr>
					<td valign="top">
						<xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_REGISTRATION_NUMBER"/>						
						<xsl:if test="not (item[@name = 'registred']/@value = 1)">							
							<br/>
							<label><input onclick="changeRegistrationSource(this, '{@id}')" value="reference" checked="checked" type="radio" name="registration_type_{@id}"/><xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_REGISTRATION_TYPE_REFERENCE"/></label>
							<br/>
							<label><input onclick="changeRegistrationSource(this, '{@id}')" value="input" type="radio" name="registration_type_{@id}"/><xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_REGISTRATION_TYPE_INPUT"/></label>
						</xsl:if>						
					</td>
					<td>
						<xsl:choose>
							<xsl:when test="item[@name = 'registred']/@value = 1">
								<xsl:value-of disable-output-escaping="yes" select="item[@name = 'registration_number']/@value"/>
							</xsl:when>
							<xsl:otherwise>								
								<div id="registration_number_{@id}"/>
								<input disabled="disabled" style="display:none;" id="registration_input_{@id}" type="text" name="registration_number" maxlength="256"/>
							</xsl:otherwise>
						</xsl:choose>
					</td>
				</tr>				
				<tr>
					<td></td>
					<td>
						<xsl:if test="not(item[@name = 'registred']/@value = 1)">
							<input type="submit" value="OK" onclick="oneClickHandler(this)"/>
						</xsl:if>
					</td>
				</tr>
			</table>
			
			<script>				
				changeRegistrationSource	= function(input, id)
				{					
					if(input.value == "reference") {
						$("registration_number_" + id).show();
						$("registration_input_" + id).hide();
						$("registration_input_" + id).disable();
					}
					else {						
						$("registration_number_" + id).hide();
						$("registration_input_" + id).show();
						$("registration_input_" + id).enable();
					}
				}
			
				<xsl:if test="not(item[@name = 'registred']/@value = 1)">
					new MSFW.Placeholder.Reference({						
						"Container"			: 	"registration_number_<xsl:value-of select="@id"/>",
						"referenceId"		: 	5,
						"inputName"			: 	"registration_number",
						"columns"			: 
											{
												"category"		: {"select" : false,	"group" : true,	"filter" : true, "sort" : false},
												"title"			: {"select" : false,	"group" : true,	"filter" : true, "sort" : false},
												"prefix"		: {"select" : true,		"group" : true,	"filter" : true, "sort" : false},
												"count"			: {"select" : true,		"group" : true,	"filter" : true, "sort" : false},
												"suffix"		: {"select" : true,		"group" : true,	"filter" : true, "sort" : false}												
											},
						"byId"				: 	true,
						"multiselect"		: 	false,
						"defaultGroups"		: 	["category"],
						"default"			: 	"<xsl:value-of select="item[@name = 'registration_number']/@value"/>",
						"separator"			:	"<xsl:value-of select="@separator"/>"
					});
				</xsl:if>				
			</script>
		</form>
	</xsl:template>
</xsl:stylesheet>