var WFA_RemindSpa = Class.create(WF_AbstractForm, {
	build: function()
	{	
		this.Container	= this.clone("remind_form");
		//this.__addVisibility();
		this.__addAddressTypeAndValue();
		this.__addDeadlineTypeAndValue();
		this.__addBefore();
		this.__addFrequency();
		var Points 		= this.getById("move_points", this.getName('move_points'));
		Points.value 	= this.getValue("move_points");
		return this.Container;
	},
	
	__addVisibility :  function() {
	 	var oYes 		= this.getById('remind_visibility_yes');
	 	oYes.name 		= this.getName('visible')
	 	var oNo			= this.getById('remind_visibility_no');
	 	oNo.name 		= oYes.name;
	 	
	 	oYes.onclick	= function() {
			oYes.checked 		= true;
			oYes.defaultChecked = true;
			oNo.checked 		= false;
			oNo.defaultChecked 	= false;
	 	}
	 	
	 	oNo.onclick		= function () {
			oYes.checked 		= false;
			oYes.defaultChecked = false;
			oNo.checked 		= true;
			oNo.defaultChecked 	= true;
	 	}
		
		switch (this.getValue('visible')) {
			case '1':
				oYes.onclick();
				break;
			case '0':
				oNo.onclick();
				break;
			default:
				oYes.onclick();
				break;
		}
	},
	
	__addAddressTypeAndValue : function()
	{
		this.addBlock(this.getById("remind_address_container"), "address_type", "address_value");
	},
	
	__addDeadlineTypeAndValue : function()
	{
		var iDoctypeId		= this.__hAllDTFields.get('current').get('doctypeId');
		var oType 			= this.getById('remind_deadlines_type');
		var oContainer 		= this.getById('remind_deadlines_value_container');
		var aFields			= this.__hAllDTFields.get('all').get(iDoctypeId).get('fields');
		var me				= this;
		var oHandler	= {
			addDateField : function(oHandler, aFields, sName, sValue) {
				var oSelect 		= new Element("SELECT");
				var i				= 0;
				oSelect.name 		= sName; 
				oSelect.options[i] = new Option(aGlobalMsfWords["WFA_REMIND_VALUE_CONTAINER_NO"], '');
				aFields.each(function(hash) {
					if ((hash.value.get('type') == 'timestamp') || (hash.value.get('type') == 'date')) {
						var oOption = new Option(hash.value.get('title'), hash.key);
						if (sValue == hash.key) {
							oOption.selected = true;
						}
						
						oSelect.options[i++] = oOption;
					}

				});
				
				oHandler.update(oSelect);
				oHandler.insert(new Element("br"));	
				
				var oLabel 	 = new Element("label");
				var oCheck 	 = new Element("input", {"type": "checkbox", "name": me.getName("rewrite_data_fields")});								
				
				if (me.getValue("rewrite_data_fields") != "") {
					oCheck.defaultChecked = true;
				}				
				
				oLabel.insert(oCheck);
				oLabel.insert(aGlobalMsfWords["WORKFLOW_DOCTYPE_SPA_CONTROL_REWRITE_DATA"]);
				oHandler.insert(oLabel);
			},

			addAfter: function(oVc, oA) {
				// days
				oVc.update();
				var oInput 				= new Element('INPUT');
				oInput.name				= oA.getName('deadline_value_days');
				var iValue				= parseInt(oA.getValue('deadline_value_days'));
				if (isNaN(iValue)) {
					iValue = 0;
				}
				
				oInput.value			= iValue;
				oInput.style.width		= "20px";
				oInput.style.textAlign	= "right";
				oInput.maxLength		= "3";
				oVc.insert(oInput);
				oVc.insert(aGlobalMsfWords["WORKFLOW_REMIND_DAYS"]);
				oInput.onkeydown = function(e) {
					var e = (!e) ? window.event : e;
					// console.log(e.keyCode);
					if (e.keyCode ==9) {
						return true;
					}
					
					if (((e.keyCode >=96) && (e.keyCode <= 105)) || ((e.keyCode >=48) && (e.keyCode <= 57)) || (e.keyCode == 8) || (e.keyCode == 46)|| (e.keyCode == 37)|| (e.keyCode == 39)) {
						if (this.value.charAt(0) == '0') {	
							this.value = '';
						}
						
						return true;
					} else {
						oMe = this;
						oMe.style.backgroundColor = 'red';
						setTimeout(function() {oMe.style.backgroundColor = 'white'}, 500);
						return false;
					}
					
				};
				
				oInput.onchange = function(e) {
					this.value = parseInt(this.value);
					if (isNaN(this.value)) { 
						this.value = '';
					}
					
				};
				
				// hous
				var oSelect				= new Element('SELECT');
				oSelect.name			= oA.getName('deadline_value_hours');
				for (var i = 0; i < 24; i++) {
					var oOption = new Option(((i < 10)? '0' + i: i), i);
					oSelect.options[i] = oOption;
					if (oA.getValue('deadline_value_hours') == i) {
						oSelect.options[i].selected = true;
					}
					
				}
				oVc.insert(oSelect);
				oVc.insert(aGlobalMsfWords["WORKFLOW_REMIND_HOUR"]);
				
				// minuts
				var oSelect				= new Element('SELECT');
				oSelect.name			= oA.getName('deadline_value_minuts');
				var j					= 0;
				for (var i = 0; i < 60; i = i+5) {
					var oOption = new Option(((i < 10)? '0' + i: i), i);
					oSelect.options[j] = oOption;
					if (oA.getValue('deadline_value_minuts') == i) {
						oSelect.options[j].selected = true;
					}
					j++;
					
				}
				
				oVc.insert(oSelect);
				oVc.insert(aGlobalMsfWords["WORKFLOW_REMIND_MINUT"]);
				
				// perezapisat' pole tip - data
				oVc.insert(new Element("br"));
				oVc.insert(aGlobalMsfWords["WORKFLOW_DOCTYPE_SPA_CONTROL_RECORD_DATA"]);
				var oSelect 		= new Element("SELECT");
				var i				= 0;
				oSelect.name 		= oA.getName('record_data_field'); 
				oSelect.options[i++] = new Option(aGlobalMsfWords["WFA_REMIND_OPTION"], '');
				aFields.each(function(hash) {
					if ((hash.value.get('type') == 'timestamp') || (hash.value.get('type') == 'date')) {
						var oOption = new Option(hash.value.get('title'), hash.key);
						if (oA.getValue('record_data_field') == hash.key) {
							oOption.selected = true;
						}
						
						oSelect.options[i++] = oOption;
					}

				});
				
				oVc.insert(oSelect);
			},

			addDate : function(oVc, sName, sValue) {
				oVc.update();
				// example, 31.5.2009 12:48
				if (!(/^[0-9]{1,2}\.[0-9]{1,2}\.[0-9]{4}\s[0-9]{1,2}:[0-9]{1,2}$/.test(sValue))) {
					sValue = '';
				}

				
				new MSFW.Placeholder.Calendar({
					"Container" : oVc,
					"inputName" : sName,
					'time'		: true,
					"default" 	: sValue
				});

			},

			clear : function(oVc) {
				oVc.update(aGlobalMsfWords["WFA_REMIND_VALUE_CONTAINER_NO"]);
			}

		};

		oHandler.clear(oContainer);
		oType.name = this.getName('deadline_type');
		hTypes	= $H({
			'' 				: aGlobalMsfWords["WFA_REMIND_DEADLINE_VALUE_CONTAINER_NO"],
			'dateTimeField' : aGlobalMsfWords["WFA_REMIND_DEADLINE_VALUE_CONTAINER_OP"],
			'after' 		: aGlobalMsfWords["WFA_REMIND_DEADLINE_VALUE_CONTAINER_VV"],
			'dateTime' 		: aGlobalMsfWords["WFA_REMIND_DEADLINE_VALUE_CONTAINER_CAL"]
		});
		
		var i = 0;
		hTypes.each(function(hash) {
			var oOption = new Option(hash.value, hash.key);
			var sName	= this.getName('deadline_value');
			var sValue	= this.getValue('deadline_value');
			if (this.getValue('deadline_type') == hash.key) {
				oOption.selected = true;
				switch (this.getValue('deadline_type')) {
					case 'dateTimeField':
						oHandler.addDateField(
								oContainer, 
								aFields, 
								sName, 
								sValue
								);
						break;
					case 'after':
						oHandler.addAfter(oContainer, this);
						break;
					case 'dateTime':
						oHandler.addDate(oContainer, sName, sValue);
						break;
					default:
						oHandler.clear(oContainer);
						break;
				}
				
			}

			oType.options[i++] = oOption;
		}.bind(this));

		
		oType.onchange = function(oHandler, oType, oContainer, aFields) {
			var sName	= this.getName('deadline_value');
			var sValue	= this.getValue('deadline_value');
			switch (oType.value) {
				case 'dateTimeField':
					oHandler.addDateField(oContainer, aFields, sName, sValue);
					break;
				case 'after':
					oHandler.addAfter(oContainer, this);
					break;
				case 'dateTime':
					oHandler.addDate(oContainer, sName, sValue);
					break;
				default:
					oHandler.clear(oContainer);
					break;
			}
			
		}.bind(this, oHandler, oType, oContainer, aFields);
		

	},
	
	__addBefore : function() {
		var oBeforeContainer = this.getById('remind-before-container');
		// days
		var oInput 				= new Element('INPUT');
		oInput.name				= this.getName('before_days');
		var iValue				= parseInt(this.getValue('before_days'));
		if (isNaN(iValue)) {
			iValue = 0;
		}
		
		oInput.value			= iValue;
		oInput.style.width		= "20px";
		oInput.style.textAlign	= "right";
		oInput.maxLength		= "3";
		oBeforeContainer.insert(oInput);
		oBeforeContainer.insert(aGlobalMsfWords["WORKFLOW_REMIND_DAYS"]);
		oInput.onkeydown = function(e) {
			var e = (!e) ? window.event : e;
			// console.log(e.keyCode);
			if (e.keyCode ==9) {
				return true;
			}
			
			if (((e.keyCode >=96) && (e.keyCode <= 105)) || ((e.keyCode >=48) && (e.keyCode <= 57)) || (e.keyCode == 8) || (e.keyCode == 46)|| (e.keyCode == 37)|| (e.keyCode == 39)) {
				if (this.value.charAt(0) == '0') {	
					this.value = '';
				}
				
				return true;
			} else {
				oMe = this;
				oMe.style.backgroundColor = 'red';
				setTimeout(function() {oMe.style.backgroundColor = 'white'}, 500);
				return false;
			}
			
		};
		
		oInput.onchange = function(e) {
			this.value = parseInt(this.value);
			if (isNaN(this.value)) { 
				this.value = '';
			}
			
		};
		
		// hous
		var oSelect				= new Element('SELECT');
		oSelect.name			= this.getName('before_hours');
		for (var i = 0; i < 24; i++) {
			var oOption = new Option(((i < 10)? '0' + i: i), i);
			oSelect.options[i] = oOption;
			if (this.getValue('before_hours') == i) {
				oSelect.options[i].selected = true;
			}
			
		}
		oBeforeContainer.insert(oSelect);
		oBeforeContainer.insert(aGlobalMsfWords["WORKFLOW_REMIND_HOUR"]);
		
		// minuts
		var oSelect				= new Element('SELECT');
		oSelect.name			= this.getName('before_minuts');
		var j					= 0;
		for (var i = 0; i < 60; i = i+5) {
			var oOption = new Option(((i < 10)? '0' + i: i), i);
			oSelect.options[j] = oOption;
			if (this.getValue('before_minuts') == i) {
				oSelect.options[j].selected = true;
			}
			j++;
			
		}
		
		oBeforeContainer.insert(oSelect);
		oBeforeContainer.insert(aGlobalMsfWords["WORKFLOW_REMIND_MINUT"]);
	},
	
	__addFrequency : function() {
		var oSelect = this.getById('remind_frequency');
		oSelect.name = this.getName('frequency');
		hTypes	= $H({
			'' 				: aGlobalMsfWords["WFA_REMIND_"],
			'daily' 		: aGlobalMsfWords["WFA_REMIND_DAILY"],
			'weekly' 		: aGlobalMsfWords["WFA_REMIND_WEEKLY"],
			'monthly' 		: aGlobalMsfWords["WFA_REMIND_MONTHLY"],
			'yearly' 		: aGlobalMsfWords["WFA_REMIND_YEARLY"]
		});
		var aRemindCfg = aActionSettings.remind.remindSeconds.split(';');
		if (aRemindCfg != "") {
			for (var Key in aRemindCfg) {
				hTypes.each(function(hash) {
					if (aRemindCfg[Key] < 3600) {
						hTypes.set(aRemindCfg[Key], 'Через ' + Math.round((aRemindCfg[Key]/60)*100)/100 + ' ' + aGlobalMsfWords["WORKFLOW_REMIND_MINUT"]);
					}
					if ((aRemindCfg[Key] >= 3600) && (aRemindCfg[Key] < 86400)) {
						hTypes.set(aRemindCfg[Key], 'Через ' + Math.round((aRemindCfg[Key]/3600)*100)/100 + ' ' + aGlobalMsfWords["WORKFLOW_REMIND_HOUR"]);
					}
					if (aRemindCfg[Key] >= 86400) {
						hTypes.set(aRemindCfg[Key], 'Через ' + Math.round((aRemindCfg[Key]/86400)*100)/100 + ' ' + aGlobalMsfWords["WORKFLOW_REMIND_DAYS"]);
					}
				});
			};
		}
		var i = 0;
		hTypes.each(function(hash) {
			var oOption = new Option(hash.value, hash.key);
			if (this.getValue('frequency') == hash.key) {
				oOption.selected = true;
			}

			oSelect.options[i++] = oOption;
		}.bind(this));
	}
	

});
