<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

include_once 'WF_Remind.php';
include_once 'WF_DateFormatter.php';

class WFA_RemindViewPort extends WFA_AbstractViewPort
{
	/**
	 * @return array
	 */
	public function port(array $aActionParams, array $aCurrentDelegated)
	{
		$oDf 		= new WF_DateFormatter();
		$aOptions 	= array();
		$aAdress	= array();
		$aOptions 				= $aActionParams['options'];
		$iStructureId			= 0;
		if($aOptions["address_type"] == "vars" && $aOptions["address_value"] == "user") {
			$oUserBox				= MSF_Registry::get("MSF_UserBox");
			$oFacade				= MSF_OrgStructureFacade::getInstance();
			$iStructureId			= $this->iStructureId;
			if($oUserBox->getEmployeeAttribute("name") != $oFacade->getEmployeeNameByStructureId($iStructureId)) {
				$iUserId				= $oUserBox->getUserAttribute("id");
				$aUser					= $oUserBox->getUser($iUserId);			
				$aInfo					= $oUserBox->load($iUserId);
				foreach($aInfo["posts"] AS $aItem) {
					if($aItem["employee_ref_value"] == $aUser["employee_ref_value"]) {
						$iStructureId =	$aItem["node_id"];
						break;
					}
				}
					
			}				
			$aAdress[]				= $iStructureId;				
		}
		else if(isset($aOptions["address_value"])){
			$oDocFacade				= new WF_DocFacade();
			$aAdress				= $oDocFacade->addressValueToStructureIds($this->oDocument, $aOptions["address_value"]);		
		}
		
		$bExists 	 = false;		
		foreach ($aAdress AS $iStrId) {		
			$oRemind = new WF_Remind(
									$this->oDocument->getDocumentId(), 
									$iStrId,
									$aActionParams["spa_id"]
									);
			if ($oRemind->exists()) {
				$bExists = true;
			}
		}
		
		if ($bExists) {
			$aOptions['datetime'] 		= $oRemind->getDatetime();
			$aBefore					= explode('/', $oRemind->getBefore());
			$aOptions['before_days'] 	= $aBefore[0];
			$aOptions['before_hours'] 	= $aBefore[1];
			$aOptions['before_minuts'] 	= $aBefore[2];
			$aOptions['frequency'] 		= $oRemind->getFrequency();
			$aOptions['status']			= 'enabled';
		}
		else {
			$sType 			= MSF_SL::getParam($aOptions, 'deadline_type');
			$sValue 		= MSF_SL::getParam($aOptions, 'deadline_value');
			$sValueDays 	= MSF_SL::getParam($aOptions, 'deadline_value_days');
			$sValueHours 	= MSF_SL::getParam($aOptions, 'deadline_value_hours');
			$sValueMinuts 	= MSF_SL::getParam($aOptions, 'deadline_value_minuts');
			switch ($sType) {
				case '':
					$aOptions['datetime'] = $oDf->getDatetimeByDeadline(
							$this->oDocument->getCurrentVersion(), 
							$sType,
							null
							);
					break;
					
				case 'after':
					$aOptions['datetime'] = $oDf->getDatetimeByDeadline(
							$this->oDocument->getCurrentVersion(), 
							$sType,
							$sValueDays . '/' . $sValueHours . '/' . $sValueMinuts
							);
					break;
					
				default:
					$aOptions['datetime'] = $oDf->getDatetimeByDeadline(
							$this->oDocument->getCurrentVersion(), 
							$sType,
							$sValue
							);
					break;
				
			}

			$aOptions['status'] = 'disabled';
			
		}
		
		return $aOptions;
	}
	
}
?>