<?php
include_once 'WF_RemindDb.php';

/**
 * Responsibility: 
 */
class WF_Remind 
{

	private $oDb 					= null;
	
	private $iRemindId				= 0;
	
	private $iRemindAt				= 0;
	
	private $iStructureId			= 0;
	
	private $iDocumentId			= 0;
	
	private $sDocumentTitle			= '';
		
	private $sDatetime				= '';
	
	private $sBefore				= '';
	
	private $sFrequency				= '';
	
	private $iActionId				= '';
	
	public function __construct($iDocumentId, $iStructureId, $iActionId) 
	{
		$this->oDb = new WF_RemindDb();	
		$this->iDocumentId	= $iDocumentId;
		$this->iStructureId = $iStructureId;
		$this->iActionId	= $iActionId;
		if ($this->exists()) {
			$aRemind = $this->oDb->select($iDocumentId, $iStructureId, $iActionId);
			if (!empty($aRemind)) {
				$this->iRemindAt			= (int) $aRemind['remind_at'];
				$this->sDocumentTitle		= $aRemind['document_title'];
				$this->sDatetime			= $aRemind['datetime'];
				$this->sBefore				= $aRemind['before'];
				$this->sFrequency			= $aRemind['frequency'];
			}

		}
		
	}	
	
	public function setStructureId($iStructureId) 
	{
		$this->iStructureId 		= $iStructureId;
	}
	public function setDatetime($sDatetime) 
	{
		$this->sDatetime = $sDatetime;
	}
	public function setBefore($sBefore) 
	{
		$this->sBefore = $sBefore;
	}
	public function setFrequency($sFrequency) 
	{
		$this->sFrequency = $sFrequency;
	}
	public function setDocumentTitle($sTitle) 
	{
		$this->sDocumentTitle = $sTitle;
	}
	
	public function getRemindId() 
	{
		return $this->iRemindId;
	}
	public function getStructureId() 
	{
		return $this->iStructureId;
	}
	public function getRemindAt() 
	{
		return $this->iRemindAt;
	}
	public function getDocumentId() 
	{
		return $this->iDocumentId;
	}
	public function getDocumentTitle() 
	{
		return $this->sDocumentTitle;
	}
	public function getDatetime() 
	{
		return $this->sDatetime;
	}
	public function getBefore() {
		return $this->sBefore;	
	}
	public function getFrequency() 
	{
		return $this->sFrequency;
	}
	
	public function exists() 
	{
		return $this->oDb->exists($this->iDocumentId, $this->iStructureId, $this->iActionId);
	}
	
	public function save() 
	{
		$this->remove();		
		$this->prepareRemindAt();		
		$this->iRemindId = $this->oDb->insert(
				$this->iRemindAt,
				$this->iStructureId,
				$this->iDocumentId,
				$this->sDocumentTitle,
				$this->sDatetime,
				$this->sBefore,
				$this->sFrequency,
				$this->iActionId
				);
	
	}
	
	private function prepareRemindAt() 
	{
		$oDate 				= new WF_DateFormatter();
		$oDate->parse($this->sDatetime);
		$iWhen 				= $oDate->getTime();
		$iBefore 			= $oDate->getSecondsByMaskedPeriod($this->sBefore);
		$this->iRemindAt 	= $iWhen - $iBefore - 60;
		//echo "$iWhen - $iBefore - 60<br/>";
		//echo "c:".time() . " r:" .$this->iRemindAt . "d:" . ($this->iRemindAt - time());
		//exit();
	}
	
	public function remove() 
	{
		return $this->oDb->remove($this->iDocumentId, $this->iStructureId);
	}
	
	public static function test() 
	{
		echo '[WF_Remind]<br/>';
		$oR1 = new WF_Remind(5, 5);
		$oR1->setRemindAt(100);
		$oR1->save();
		$oR2 = new WF_Remind(5, 5);
		if ($oR2->getRemindAt() !== 100) {
			echo 'Test iRemindAt... failed<br/>';
		}
		
		$oR1->remove();
		exit();
	}
	
}

//WF_Remind::test();