<?php

/**
 * Responsibility: 
 */
class WF_RemindDb {
	
	/**
	 * @var MSF_DB 
	 */
	private $oDb = null;
	
	public function __construct() {
		$this->oDb = MSF_Registry::get('MSF_DB');
	}

	public function exists($iDocumentId, $iStructureId, $iActionId) {
		$sSql = 'SELECT count(*) AS total FROM wfa_remind WHERE document_id = ' . $iDocumentId . ' AND structure_id = ' . $iStructureId .
				' AND (action_id = ' . $iActionId . ' OR action_id = 0)';
		if ($this->oDb->select($sSql, true, 'total') > 0 ) {
			return true;
		}
		else {
			return false;
		}
		
	}
	
	public function select($iDocumentId, $iStructureId, $iActionId) {
		$sSql = 'SELECT * FROM wfa_remind WHERE document_id = ' . $iDocumentId . ' AND structure_id = ' . $iStructureId . 
				' AND (action_id = ' . $iActionId . ' OR action_id = 0)';
		return $this->oDb->select($sSql, true);
	}
	
	public function insert(
			$iRemindAt,
			$iStructureId,
			$iDocumentId,
			$sDocumentTitle,
			$sDatetime,
			$sBefore,
			$sFrequency,
			$iActionId
			) {
				
		$sSql  = 'INSERT INTO wfa_remind(';
		$sSql .= 'remind_at, structure_id, document_id, document_title, datetime, before, frequency, action_id';
		$sSql .= ') VALUES (';
		$sSql .= (int) $iRemindAt . ',';
		$sSql .= (int) $iStructureId . ',';
		$sSql .= (int) $iDocumentId . ',';
		$sSql .= '\'' . pg_escape_string($sDocumentTitle) . '\',';
		$sSql .= '\'' . $sDatetime . '\',';
		$sSql .= '\'' . $sBefore . '\',';
		$sSql .= '\'' . $sFrequency . '\',';
		$sSql .= '\'' . $iActionId . '\'';
		$sSql .= ')';
		$this->oDb->executeQuery($sSql);
		return $this->oDb->insertId();
	}
	
	public function remove($iDocumentId, $iStructureId) {
		$sSql = 'SELECT count(*) AS total FROM wfa_remind WHERE document_id = ' . $iDocumentId . ' AND structure_id = ' . $iStructureId;
		
		if ($this->oDb->select($sSql, true, 'total') > 0 ) {
			$sSql = 'DELETE FROM wfa_remind WHERE document_id = ' . $iDocumentId . ' AND structure_id = ' . $iStructureId;
			$this->oDb->executeQuery($sSql);
			return true;
		}
		else {
			return false;
		}
	}

}
