<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="action[@type='remind']">
		<script src="/modules/workflow/actions/remind/default/StartCountBack.js?v={/page/module/@systemVersion}"></script>
		<style>
			.remind-top-panel {
				width:100%;
				border:0px solid #cccccc;
				border-bottom-width:1px;
			}
			
			.remind-top-panel td {
				padding-bottom:10px;
			}
			.remind-center-panel {
				width:100%;
				border:0px solid #cccccc;
				border-bottom-width:1px;
				margin-top:5px;
				margin-bottom:5px;
			}
			.remind-center-panel td {
				padding-top:5px;
				padding-bottom:5px;
			}
			
			.remind-bottom-panel {
				padding-top:10px;
			}
			
			.remind-deadline {
				text-align:right;
				vertical-align:middle;
			}
			
			.remind-clock {
				color:#a9a9a9;
			}
			
		</style>
		<form style="display: none" id="action_window_{@id}" method="post" action="{@url}">
			<div class="spa-form">
				<input name="address" type="hidden" value="{item[@name='address_value']/@value}"/>
				<table class='remind-top-panel'>
					<tr>
						<td>
							
							<xsl:choose>
								<xsl:when test="item[@name='status']/@value = 'disabled'">
									<input id="remind-status-{@id}" name="status" style="display:none;" value="disabled"/>
									<input id="remind-switcher-{@id}" type="button" value="{$WFA_REMIND_ON}" onclick="enableOrDisableReminder('{@id}')"/>	
								</xsl:when>
								<xsl:otherwise>
									<input id="remind-status-{@id}" name="status" style="display:none;" value="enabled"/>
									<input id="remind-switcher-{@id}" type="button" value="{$WFA_REMIND_OFF}" onclick="enableOrDisableReminder('{@id}')"/>
								</xsl:otherwise>
							</xsl:choose>

						</td>
						<td class="remind-deadline">
							<xsl:value-of select="$WORKFLOW_REMIND_SPA_DEADLINE"/>&#160;<span id="remind-clock-{@id}" class="remind-clock"></span>
							<script>
								StartCountDown(
										'remind-clock-<xsl:value-of select="@id"/>',
										"<xsl:value-of select="item[@name='datetime']/@value"/>"
										);
							</script>
						</td>
					</tr>
				</table>
				<div id="remind-container-{@id}">
				<table class='remind-center-panel'>
					<tr>
						<td><xsl:value-of select="$WORKFLOW_DOCUMENT_LOG_ACTION_DATE"/></td>
						<td id="remind_calendar_container_{@id}"></td>
						<script type="text/javascript">
						var sId = 'remind_calendar_container_<xsl:value-of select="@id"/>';
						var oP	= new MSFW.Placeholder.Calendar({
							"Container" : sId,
							"inputName" : 'datetime',
							"time"		: true,
							"default" 	: '<xsl:value-of select="item[@name='datetime']/@value"/>'
						});
						oP.addEventListener("buttonafterclick", function() {
							StartCountDown(
									'remind-clock-<xsl:value-of select="@id"/>',
									$('remind_calendar_container_<xsl:value-of select="@id"/>').getElementsByTagName('input')[0].value
									);
						});

						</script>
					</tr>
					<tr>
						<td><xsl:value-of select="$WORKFLOW_REMIND_SPA_BEFORE"/></td>
						<td id="remind-before-container-{@id}"></td>
						<script>
						var oBeforeContainer = $('remind-before-container-<xsl:value-of select="@id"/>');
						// days
						var oInput 				= new Element('INPUT');
						oInput.name				= 'before_days';
						oInput.value			= '<xsl:value-of select="item[@name='before_days']/@value"/>'
						oInput.style.width		= "30px";
						oInput.style.textAlign	= "right";
						oInput.maxLength		= "3";
						oBeforeContainer.insert(oInput);
						oBeforeContainer.insert(aGlobalMsfWords["WORKFLOW_REMIND_DAYS"]);
						oInput.onkeydown = function(e) {
							var e = (!e) ? window.event : e;
							// console.log(e.keyCode);
							if (e.keyCode ==9) {
								return true;
							}
							
							if (
							(
							(e.keyCode &gt;= 96) &amp;&amp; (e.keyCode &lt;= 105)) || 
							((e.keyCode &gt;=48) &amp;&amp; (e.keyCode &lt;= 57)) || 
							(e.keyCode == 8) || (e.keyCode == 46)|| 
							(e.keyCode == 37)|| 
							(e.keyCode == 39)
							) {
								if (this.value.charAt(0) == '0') {	
									this.value = '';
								}
								
								return true;
							} else {
								oMe = this;
								oMe.style.backgroundColor = 'red';
								setTimeout(function() {oMe.style.backgroundColor = 'white'}, 500);
								return false;
							}
							
						};
						
						oInput.onchange = function(e) {
							this.value = parseInt(this.value);
							if (isNaN(this.value)) { 
								this.value = '';
							}
							
						};
						
						// hous
						var oSelect				= new Element('SELECT');
						oSelect.name			= 'before_hours';
						for (var i = 0; i &lt; 24; i++) {
							var oOption = new Option(((i &lt; 10)? '0' + i: i), i);
							oSelect.options[i] = oOption;
							if ('<xsl:value-of select="item[@name='before_hours']/@value"/>' == i) {
								oSelect.options[i].selected = true;
							}
							
						}
						oBeforeContainer.insert(oSelect);
						oBeforeContainer.insert(aGlobalMsfWords["WORKFLOW_REMIND_HOUR"]);
						
						// minuts
						var oSelect				= new Element('SELECT');
						oSelect.name			= 'before_minuts';
						var j					= 0;
						for (var i = 0; i &lt; 60; i = i+5) {
							var oOption = new Option(((i &lt; 10)? '0' + i: i), i);
							oSelect.options[j] = oOption;
							if ('<xsl:value-of select="item[@name='before_minuts']/@value"/>' == i) {
								oSelect.options[j].selected = true;
							}
							j++;
							
						}
						
						oBeforeContainer.insert(oSelect);
						oBeforeContainer.insert(aGlobalMsfWords["WORKFLOW_REMIND_MINUT"]);
						</script>
					</tr>
					<tr>
						<td><xsl:value-of select="$WORKFLOW_REMIND_SPA_FREQUENCY"/></td>
						<td>
							<select id="remind_frequency_{@id}" name="frequency"></select>
							<script>
							var oSelect = $('remind_frequency_<xsl:value-of select="@id"/>');
							var aStates	= $H({
									'' 			: aGlobalMsfWords["WFA_REMIND_"],
									'daily' 	: aGlobalMsfWords["WFA_REMIND_DAILY"],
									'weekly'	: aGlobalMsfWords["WFA_REMIND_WEEKLY"],
									'monthly'	: aGlobalMsfWords["WFA_REMIND_MONTHLY"],
									'yearly'	: aGlobalMsfWords["WFA_REMIND_YEARLY"]
									});
							var aRemindCfg = ('<xsl:value-of select="@remindSeconds"/>').split(';');
							if (aRemindCfg != "") {
								for (var Key in aRemindCfg) {
									aStates.each(function(hash) {
										if (aRemindCfg[Key] &lt; 3600) {
											aStates.set(aRemindCfg[Key], '<xsl:value-of select="$REMIND_THROUGH"/> ' + Math.round((aRemindCfg[Key]/60)*100)/100 + ' ' + aGlobalMsfWords["WORKFLOW_REMIND_MINUT"]);
										}
										if ((aRemindCfg[Key] &gt;= 3600) &amp;&amp; (aRemindCfg[Key] &lt; 86400)) {
											aStates.set(aRemindCfg[Key], '<xsl:value-of select="$REMIND_THROUGH"/> ' + Math.round((aRemindCfg[Key]/3600)*100)/100 + ' ' + aGlobalMsfWords["WORKFLOW_REMIND_HOUR"]);
										}
										if (aRemindCfg[Key] &gt;= 86400) {
											aStates.set(aRemindCfg[Key], '<xsl:value-of select="$REMIND_THROUGH"/> ' + Math.round((aRemindCfg[Key]/86400)*100)/100 + ' ' + aGlobalMsfWords["WORKFLOW_REMIND_DAYS"]);
										}
									});
									
								};
							};
							var i		= 0;
							aStates.each(function(hash) {
								var aOption = new Option(hash.value, hash.key);
								oSelect[i]	= aOption;
								if (hash.key == '<xsl:value-of select="item[@name='frequency']/@value"/>') {
									oSelect[i].selected = true;
								}
								
								i++;
							});
							</script>
						</td>
					</tr>
				</table>
				</div>
				<div class='remind-bottom-panel'>
					<input type="submit" value="OK" onclick="oneClickHandler(this)"/>
				</div>
			</div>
			<script>
			reminderFirstRun('<xsl:value-of select="@id"/>');
			</script>
		</form>
	</xsl:template>
</xsl:stylesheet>