<?php

defined('__MSF') or die('Direct access is not allowed');

class WFA_Remove extends WF_ActionSupport
{
	public function processResponse()
	{
		$bRemove 			= false;
		$aAllowedDoctypes	= WF_Utils::getAllowedAuthorIds($this->getDoctype()->getFolderId());
		$aAccessData		= isset($aAllowedDoctypes[$this->getDocument()->getDoctypeId()]) 
													? $aAllowedDoctypes[$this->getDocument()->getDoctypeId()] 
													: array();
		$iCurrStrId 		= $this->getDocument()->getStructureId();
		$aStrIds 			= array();
		
		for ($i = 0; $i < count($aAccessData); $i++) {
			$aStrIds = array_merge($aStrIds, $aAccessData[$i]["author_ids"]);
			if ($aAccessData[$i]["remove"] == 2) {
				$aStrIds = array_diff($aStrIds, $aAccessData[$i]["author_ids"]);
			}
			
		}
			

		if (in_array($iCurrStrId, $aStrIds)) {
			$bRemove = true;
		}
		elseif ($iCurrStrId == $this->getStructureId() && $this->getDocument()->getPointId() == 0) {
			$bRemove = true;
		}
		else if (!MSF_OrgStructureFacade::getInstance()->isStructureId($iCurrStrId)) {
			$bRemove = true;
		}
		
		if (!$bRemove) {
			MSF_Registry::get("MSF_Messenger")->addError(MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCUMENT_REMOVE_DENIED"));
			return self::SUCCESS;
		}
		else {
			MSF_Registry::get("MSF_Messenger")->addMessage(MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCUMENT_DELETED"));
			
			$Doctype			= $this->getDoctype();
			$DocumentVersion	= $this->getDocumentVersion();
			
			$UF	= new MSF_UniqueField(MSF_Registry::get("MSF_DB"));
			$UF->freeFields($DocumentVersion->getFieldsAsList(), MSF_UniqueField::TYPE_DOCTYPE, $Doctype->getDoctypeId());
						
			$this->getDocument()->remove();
			return self::SUCCESS;
		}
	}
}

?>