<?php
abstract class WFA_AbstractViewPortBuilder
{
	/**
	 * @var WF_Doctype
	 */
	protected $oDoctype;
	
	/**
	 * @var WF_DoctypeVersion
	 */
	protected $oDoctypeVersion;
	
	/**
	 * @var WF_Document
	 */
	
	protected $oDocument;
	
	/**
	 * @var WF_DocumentVersion
	 */
	
	protected $oDocumentVersion;
	
	/**
	 * @var integer
	 */
	protected $iStructureId;
	
	/**
	 * @var WF_Values
	 */
	
	protected $oValues;
	
	final public function __construct(WF_Doctype $oDoctype, WF_DoctypeVersion $oDoctypeVersion, 
									  WF_Document $oDocument, WF_DocumentVersion $oDocumentVersion, 
									  $iStructureId)
	{
		$this->oDoctype 		= $oDoctype;
		$this->oDoctypeVersion 	= $oDoctypeVersion;
		$this->oDocument		= $oDocument;
		$this->oDocumentVersion	= $oDocumentVersion;
		$this->iStructureId		= $iStructureId;
		$this->oValues = new WF_Values($oDocument, $oDocumentVersion, $oDoctypeVersion);
		
	}
	/**
	 * @return array|null
	 */
	abstract public function build(array $aAction);
	
	final public function getDoctype()
	{
		return $this->oDoctype;
	}
	
	final public function getDoctypeVersion()
	{
		return $this->oDoctypeVersion;
	}
	
	final public function getDocument()
	{
		return $this->oDocument;
	}
	
	final public function getDocumentVersion()
	{
		return $this->oDocumentVersion;
	}
	
	final public function getStructureId()
	{
		return $this->iStructureId;
	}
	
	final public function getValues()
	{
		return $this->oValues;
	}
	
}
?>