<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
/*
 * File: 	WFA_View.php
 * Date: 	27.02.2008
 * Time:	15:03:13
 * Detrix
 *
 */
include_once "modules/workflow/library/actions/WF_Points.php";
include_once "modules/workflow/library/variables/WF_Vars.php";
include_once "WFA_AbstractViewPort.php";
include_once "WFA_AbstractViewPortBuilder.php";
include_once "modules/workflow/library/actions/WF_DocCache.php";
/**
 * @package 	workflow
 * @author
 * @copyright 	Copyright (c) 2007, Detrix
 */
class WFA_View extends WF_ActionSupport
{
	public function initialize()
	{
		//esli eto versiaya - ne dolshen otrabativat backurl!!
		if(!$this->isVersion()) {
			//$this->BackUrl 		= new MSF_BackUrl();
		}
				
	}
		
	public function processResponse()
	{	
		$this->setTemplate();
		$this->addLinks();
		$this->addLogXml();
		if(!$this->isVersion()) {
			$this->addNewDocToActionBar();
			$this->addActionsToActionBar();
		}
		else {
			$this->addSettingCurrentVersion();
		}

		$this->addVersionsToActionBar();
		$this->addCloseToActionBar();
		$this->setDocumentIdToXml();
		return self::SUCCESS;
	}
	
	private function addSettingCurrentVersion()
	{
		$aDelegated	= $this->getSettings()->getDelegatedAtPoint($this->getDocument()->getPointId());
		$bHasAccess	= false;
		// check access
		foreach($aDelegated AS $aAction) {
			if ($aAction["name"] == "edit") {
				$bHasAccess = true;
				break;
			}
			
		}
                
		if ($bHasAccess) {
			$iDocId			= $this->getDocument()->getDocumentId();
			$iDocVerId 		= $this->getDocumentVersion()->getDocumentVersionId();
			$iCurDocVerId	= $this->getDocument()->getCurrentVersion()->getDocumentVersionId();
			// switch version
			if ($iCurDocVerId !== $iDocVerId) {
				MSF_Registry::get("MSF_ActionBar")->addAction(
                                                MSF_Registry::get("MSF_Locale")->getWord("DOCUMENT_VERSION_SET_CURRENT"),                                               
						"/workflow/document/setversion/" . $iDocId . "/" . $iDocVerId,
						CNX_ACTIONBAR_IMG, "", false, "left",
						MSF_Registry::get("MSF_Locale")->getWord("DOCUMENT_VERSION_SET_CURRENT")
						);
			}
			
		}

	}


	
	private function setTemplate()
	{
            $aDelegated = $this->getSettings()->getDelegatedAtPoint($this->getDocument()->getPointId());
            $bHasAccess = false;
            // check access
            foreach ($aDelegated AS $aAction) {
                if ($aAction["name"] == "edit") {
                    $bHasAccess = true;
                    break;
                }
            }
            MSF_Registry::set("HAS_ACCESS",$bHasAccess);
            MSF_Registry::set("DOC_TYPE_ID",$this->getDocument()->getDoctypeId());
            MSF_Registry::set("DOC_ID",$this->getDocument()->getDocumentId());
            MSF_Registry::set("DOC_VERSION_ID",$this->getDocumentVersion()->getDocumentVersionId());
            MSF_Registry::set("CURRENT_STRUCTURE_ID",$_SESSION["MSF_UserBox"]["currentStructureId"]);
            
            
		try {
			
                        $oCache 	= new WF_DocCache($this->getDocument()->getDoctypeId(), $this->getDocument()->getDocumentId());
			$iSubject 	= $this->getInitParam("subject_version_id");

                        if($oCache->exists() && $iSubject == 0) {
                            $sCache = $oCache->load();
                        } else {
                            $sCache = "";
                        }

                        if ((!$oCache->exists() || $bHasAccess || ($sCache == "")) || ($iSubject != 0)) {
				$sCache = "";
                                $Fields		= new REF_Fields($this->getDocument()->getDoctypeVersion()->getFieldsXml());
				$aFields	= $this->getDocumentVersion()->getFields();
                                
				$Template	= $this->getDocumentTemplate();
				if (CNF_MODE == "debug") {
					$this->addDebugInfo($Template);
				}
				
				foreach($aFields as $sKey=>$mVal) {
					$Fields->set($sKey, $mVal);
				}
  								
				$Template->setFields($Fields);	
				$Template->setPoints(new WF_Points($this->getDocument(), count($this->getSettings()->getRoute())));

				$Template->addViewTemplate($this->getTemplate(), "module/template");

				if ($iSubject == 0) {
					$oCache->save($Template->getViewForm());
				}
				
                                $sPath = CNF_ABS_PATH . "/modules/workflow/actions/view/" . CNF_SKIN . '/page.xsl';
				$this->Template->loadXsl($sPath);
				REF_Template::addTemplate($this->getTemplate(), "module/template", $sCache);
			}
			else {

				$sPath = CNF_ABS_PATH . "/modules/workflow/actions/view/" . CNF_SKIN . '/page.xsl';
				$this->Template->loadXsl($sPath);
				REF_Template::addTemplate($this->getTemplate(), "module/template", $sCache);
			}
		}
		catch (Exception $oE) {	
		
		}
		
	}
	
	private function addDebugInfo(REF_Template $oTemplate)
	{

		if ($this->getDocument() !== null) {
			$sOnClick 	= "onclick=\"$('debugged').visible() ? MSF_Effect.hide($('debugged')) : MSF_Effect.show($('debugged'))\"";
			$sStyle		= "style=\"font-weight:bold;color:#A9A9A9;border:1px solid #CCCCCC;cursor:pointer;padding:5px;\"";
			$oTemplate->addDebugInfo("<div " . $sOnClick . " " . $sStyle . ">DEBUG</div>");
			
			$aHash = array(
					"doctype_id" 			=> $this->getDoctype()->getDoctypeId(),
					"doctype_version_id" 	=> $this->getDoctypeVersion()->getDoctypeVersionId(),
					"document_id" 			=> $this->getDocument()->getDocumentId(),
					"document_version_id"	=> $this->getDocument()->getDocumentVersionId(),
					"sql_table"				=> "wf_documents_" . $this->getDoctypeVersion()->getExtname(),
					"point_id"				=> $this->getDocument()->getPointId(),
					"registration_number"	=> (strlen($this->getDocumentVersion()->getSystemField("registration_number") == 0) ? 
							"none" : $this->getDocument()->getRegistrationNumber()),
					"author"				=> $this->getDocumentVersion()->getSystemField("author_name")." (". $this->getDocument()->getStructureId().")",
					"employee"				=> $this->getEmployeeId() . "(" . $this->getStructureId() . ")" . " (". implode(".", $this->getEmployeePath()) . ")"
					);
			$oTemplate->addDebugInfo("<div id=\"debugged\" style=\"display:none;border:1px solid #CCCCCC;border-top-width:0px;padding:5px;\">");
			$oTemplate->addDebugInfo("<table>");
			foreach ($aHash AS $sKey => $sValue) {
				$oTemplate->addDebugInfo("<tr><td>".$sKey."</td><td>".$sValue."</td></tr>");
			}
						
			$oTemplate->addDebugInfo("</table>");
			$oTemplate->addDebugInfo("</div>");
		}
		
	}
	
	public function addActionsToActionBar()
	{
		MSF_Registry::get("MSF_Settings")->getXmlWrapper();		
		$aDelegated	= $this->getSettings()->getDelegatedAtPoint($this->getDocument()->getPointId());
		$aSettings  = MSF_Registry::get("MSF_Settings")->getXmlWrapper()->get("modules")->getValue("workflow");
		$aExt 		= explode(",", $aSettings["actions"]["0"]["settings"]["ext"]);
		$Template	= $this->getTemplate();
		$ActionBar	= MSF_Registry::get("MSF_ActionBar");		
		foreach($aDelegated AS $aAction) {
			// Добавляем id типа документа в опции
			$aAction["options"]["object_id"] = $this->getDoctype()->getDoctypeId();			
			if (in_array($aAction["name"], $aExt)) {
				$oBuilder 	= $this->newPortBuilder($aAction["name"]);
				$aNewAction = $oBuilder->build($aAction);
				
				if ($aNewAction !== null) {
					$oPort = $this->newPort(
							$aNewAction["name"],
							$oBuilder->getDoctype(), 
							$oBuilder->getDoctypeVersion(), 
							$oBuilder->getDocument(), 
							$oBuilder->getDocumentVersion(), 
							$oBuilder->getStructureId()
							);
					//debug($oBuilder->getDocument()->getLog()->getDelegated(), $aNewAction["spa_id"], $aAction["spa_id"]);
					$aDelegated = $oBuilder->getDocument()->getLog()->getDelegated(
									$oBuilder->getDocument()->getPointId(), 
									$aNewAction["ext_spa_id"]
									);									
					$aNewAction["options"] = $oPort->port($aNewAction, $aDelegated);
					$oPort->addActionToXml($this->getTemplate(), $aNewAction);
					$this->addActionToActionBar($ActionBar, $aNewAction);	
				}

			}
			else {								
				//$this->addActionToXml($Template, $aAction);
				$oPort = $this->newPort(
						$aAction["name"],
						$this->getDoctype(), 
						$this->getDoctypeVersion(), 
						$this->getDocument(), 
						$this->getDocumentVersion(), 
						$this->getStructureId()
						);
				$aAction["options"] = $oPort->port(
						$aAction, 
						$this->getLog()->getDelegated(
								$this->getDocument()->getPointId(), 
								$aAction["spa_id"]
								)
						);
				$oPort->addActionToXml($this->getTemplate(), $aAction);
				$this->addActionToActionBar($ActionBar, $aAction);		
			}

		}
		
	}
	
	public function newPortBuilder($sName)
	{
		$sClassname = "WFA_" . ucfirst($sName) . "ViewPortBuilder";
		$sClasspath = CNF_ABS_PATH . "/modules/workflow/actions/" .$sName . "/" . $sClassname . ".php";
		return $this->newInstance($sClasspath, $sClassname)
					->newInstance(
							$this->getDoctype(), 
							$this->getDoctypeVersion(), 
							$this->getDocument(), 
							$this->getDocumentVersion(), 
							$this->getStructureId()
							);
	}
	/**
	 * @return WFA_AbstractViewPort
	 */
	public function newPort($sName, WF_Doctype $oDoctype, WF_DoctypeVersion $oDoctypeVersion, 
							WF_Document $oDocument, WF_DocumentVersion $oDocumentVersion, 
							$iStructureId)
	{
		$sClassname = "WFA_" . ucfirst($sName) . "ViewPort";
		$sClasspath = CNF_ABS_PATH . "/modules/workflow/actions/" .$sName . "/" . $sClassname . ".php";
		return $this->newInstance($sClasspath, $sClassname)->newInstance(
				$oDoctype, 
				$oDoctypeVersion, 
				$oDocument, 
				$oDocumentVersion, 
				$iStructureId,
				$this
				);
				
	}
	
	
	private function newInstance($sClasspath, $sClassname)
	{
		include_once $sClasspath;
		return new ReflectionClass($sClassname);
	}
	
	public function addActionToActionBar(MSF_ActionBar $ActionBar, $aAction)
	{
		$sTitle 		= isset($aAction["title"]) ? $aAction["title"] : "";
		$sWindowTitle	= addslashes(trim(isset($aAction["options"]["window_title"]) ? $aAction["options"]["window_title"] : $sTitle));
		$bIsVisible 	= isset($aAction["options"]["visible"]) ? (int) $aAction["options"]["visible"] : 1;
		$sId			= "action_window_" . $aAction["spa_id"];
		$sAction		= "showActionWindow(this, '" . $sId . "', " . $bIsVisible . ", '" . $sWindowTitle . "'); return false;";
		$ActionBar->addAction($sTitle, "#" . $aAction["spa_id"], CNX_ACTIONBAR_IMG, $sAction, false, "left", $aAction["description"]);
		
	}
	
	public function addLogXml()
	{
		$this->getTemplate()->addXslPath("/modules/workflow/actions/view/default/doctype_spa.xsl");
		$this->getTemplate()->addXslPath("/modules/workflow/view/templates/default/xsl/documentLog.xsl");
		$aLogs		= $this->getLog()->getDisplay();
		$Template	= $this->getTemplate();
		$LogNode	= $Template->createElement("log");
		$Template->getModule()->appendChild($LogNode);
		
		foreach($aLogs as $aLog) {
			if ((CNF_MODE !== "debug") && ($aLog["employeeName"] == "DEBUG")) {
				continue;
			}
			
			$Item	= $Template->createElement("item");
			$LogNode->appendChild($Item);
			$Date	= new MSF_Date($aLog["timestamp"]);
			$Item->setAttribute("date", $Date->format(CNF_DATE_TIME_FORMAT));
			$bEncode = true;
			
			if (isset($aLog["specialchars"]) && $aLog["specialchars"]) {
				$bEncode = false;
			}
			
			foreach($aLog as $sKey=>$sValue) {
				if ($bEncode) {
					$sValue = nl2br(htmlspecialchars($sValue));
				}
				$Item->setAttribute($sKey, $sValue);
			}
			
			$Item->setAttribute("timestamp", MSF_String::random(10));
		}
		
	}
	
	private function setDocumentIdToXml()
	{
		$Template		= $this->getTemplate();
		$DocumentNode	= $Template->createElement("document");
		$DocumentNode->setAttribute("id", $this->getDocument()->getDocumentId());
		$Template->getModule()->appendChild($DocumentNode);
	}

	private function addLinks()
	{
		$this->addLinksOf("references");
		$this->addLinksOf("structure");
		$this->getTemplate()->addLink("/js/ext/calendar_date_select/js/calendar_date_select.js", "text/javascript");
		$this->getTemplate()->addLink("/js/ext/calendar_date_select/css/default.css", "text/css");
		$this->getTemplate()->addLink("/modules/workflow/view/js/showActionWindow.js", "text/javascript");
		$this->getTemplate()->addLink("/modules/workflow/view/js/WF_LogTable.js", "text/javascript");
	}
	
	private function addNewDocToActionBar()
	{
		if ($this->getDoctype()->getFolderId() != 0) {
			MSF_Registry::get("MSF_ActionBar")->addAction(
				MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_DOCUMENT_CREATE"),
				"/workflow/document/create/" . $this->getDocument()->getDoctypeId() . "",
				"",
				"",
				false,
				"right",
				MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_NEW_DOCUMENT_HELP")
			);
			
		}
		
	}
	
	private function addVersionsToActionBar()
	{
		$sTitle 	= "";
		$Locale 	= MSF_Registry::get("MSF_Locale");
		$ActionBar 	= MSF_Registry::get("MSF_ActionBar");
		$Date 		= new MSF_Date();
		$aResult 	= array();
		$iDocId		= $this->getDocument()->getDocumentId();
		$iDocVerId	= $this->getDocumentVersion()->getDocumentVersionId();
		
		$sSql = "SELECT * FROM wf_documents_versions "
			  . "WHERE document_id = " . $iDocId;
		foreach (MSF_Registry::get("MSF_DB")->select($sSql) AS $aRow) {
			$aTmp 				= array();
			$aTmp["title"] 		= 	$Locale->getWord("WORKFLOW_DOCTYPE_COMPARE_VERSION") . " " .
									$Date->parseAndFormat($aRow["created_at"], CNF_DATE_TIME_FORMAT) . ", " .
									mb_strtolower($Locale->getWord("WORKFLOW_ADMIN_LIST_AUTHOR"), "UTF-8") . " - " .
									$aRow["employee_name"];
			$aTmp["url"] 		= "/workflow/document/view/" . $aRow["document_id"] . "/" . $aRow["document_version_id"] . "";
			$aTmp["image"] 		= "";
			$aTmp["onclick"] 	= "";
			$aResult[] 			= $aTmp;
			if ($aRow["document_version_id"] == $iDocVerId) {
				$sTitle = $aTmp["title"];
			}
			
		}

		if ($this->isVersion()) {
			$sTitle = " (" . $sTitle . ")";
		}
		else {
			$sTitle = "";
		}
		
		$aDropDown[0]["title"]		= $Locale->getWord("MSF_EXPORT");
		$aDropDown[0]["url"]		= "/workflow/export/" . $this->getDocument()->getDocumentId() . "/" . $this->getInitParam("subject_version_id");
		$aDropDown[0]["image"]		= "";
		$aDropDown[0]["onclick"]	= "";
		$aDropDown[1]["title"]		= MSF_Registry::get("MSF_Locale")->getWord("DOCUMENT_VERSIONS");
		$aDropDown[1]["url"]		= "#";
		$aDropDown[1]["image"]		= "";
		$aDropDown[1]["onclick"]	= "";
		$aDropDown[1]["elements"]	= $aResult;
		
		
		$ActionBar->addDropDropDown($aDropDown);
		
		//$ActionBar->addDropDown(
		//	$Locale->getWord("WORKFLOW_ADMIN_LIST_ACTION_VERSIONS"),
		//	$aResult,
		//	"return false",
		//	"left",
		//	$Locale->getWord("WORKFLOW_VERSIONS_HELP")
		//);
		
		$sTitle2 	= "";
		$Folder		= new WF_Folder(new WF_FolderDB(MSF_Registry::get("MSF_DB")));
		
		try {
			$Folder->load($this->getDoctype()->getFolderId());
			$aConfig	= $Folder->getConfig();
			$sTitle2 	= $aConfig["name"] . $Locale->getWord("ROOT_TITLE_SEPARATOR");
			
			
			if((int)$aConfig["group_id"] != 0) {
				$FodlerGroup	= new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));
				$FodlerGroup->load($aConfig["group_id"]);
				$aGroupConfig	= $FodlerGroup->getConfig();
				$sTitle2		= $aGroupConfig["name"] . $Locale->getWord("ROOT_TITLE_SEPARATOR") . $sTitle2;
				
			}
			
		}
		catch (Exception $e) {}
		
		$Locale	= MSF_Registry::get("MSF_Locale");
		$this->getTemplate()->setPageTitle(
			$Locale->getWord("WORKFLOW_DOCUMENTS") .
			$Locale->getWord("ROOT_TITLE_SEPARATOR") .
			MSF_Registry::get("MSF_Locale")->getI18N($sTitle2) .
			MSF_Registry::get("MSF_Locale")->getI18N($this->getDoctype()->getTitle()) .
			MSF_Registry::get("MSF_Locale")->getI18N($sTitle)
			);

	}
	
	public function addCloseToActionBar()
	{
		$ActionBar 	= MSF_Registry::get("MSF_ActionBar");
		if($this->isVersion()) {
			$ActionBar->addAction(
				MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_ACTION_CLOSE"),
				"/workflow/document/view/" . $this->getDocument()->getDocumentId(),
					CNX_ACTIONBAR_IMG,
					"",
					false,
					"left",
					MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_TO_DOCUMENT_HELP")
			);
		}
		else {
			if($this->getDoctype()->getFolderId() != 0) {
				$ActionBar->addAction(
					MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_TO_FOLDER"),
					"/workflow/folders/" . $this->getDoctype()->getFolderId(),
					CNX_ACTIONBAR_IMG,
					"",
					false,
					"left",
					MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_TO_FOLDER_HELP")
				);
			}
			
		}
		
	}
	private function reflect()
	{
		$aDelegated = $this->getSettings()->getDelegatedAtPoint($this->getDocument()->getPointId());
		//debug($this->getDocument()->getPointId());
		for ($i = 0; $i < count($aDelegated); $i++) {
			$sClassname	= "WFA_" . ucfirst($aDelegated[$i]["name"]) . "View";
			$sClasspath = CNF_ABS_PATH . "/modules/workflow/actions/" . $aDelegated[$i]["name"] . "/" . $sClassname . ".php";
			if (!MSF_File::exists($sClasspath)) {
				continue;
			}
			
			include_once $sClasspath;
			$Class	 		= new ReflectionClass($sClassname);
			$Reflector 		= $Class->newInstance();
			if ($Reflector instanceof WFA_AstractViewPort) {
				//debug($this->getDocument()->getPointId(), $aDelegated[$i]["spa_id"]);
				$aReflected = $Reflector->reflect(
									$aDelegated[$i],
									$this->getLog()->getDelegated($this->getDocument()->getPointId(),$aDelegated[$i]["spa_id"])
									);
				$this->getLog()->setDelegated(
						$this->getDocument()->getPointId(),
						$aDelegated[$i]["spa_id"],
						/*$this->encodeSpecialChars(*/$aReflected/*)*/
						);
						
			}			
		}
		
	}
	
	
	
}

?>