<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output encoding="UTF-8" />
	<xsl:output method="html" indent="no" media-type="text/xhtml" />
	<xsl:template match="/">
		<xsl:text disable-output-escaping="yes">&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;</xsl:text>
		<html xml:lang="ru" lang="ru" xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
		<meta http-equiv="X-UA-Compatible" content="IE=8"/>
		<link rel="shortcut icon" href="/favicon.ico"/>
		<title>
			<xsl:value-of select="/page/module/@title"/>  — Detrix —  <xsl:value-of select="$MSF_LICENSE_OWNER"/>
		</title>
		<style type="text/css" media="all">
		@import url('/templates/default/styles/msf.css?v=<xsl:value-of select="/page/module/@systemVersion"/>');
		@import url('/templates/default/styles/print.css?v=<xsl:value-of select="/page/module/@systemVersion"/>');
		</style>
                <script>
		var	iTotalScripts = '<xsl:value-of select="/page/module/@totalScripts"/>';
                var jsLocale = {<xsl:value-of select="/page/module/@jsLocale"/>};
                var $LANG = '<xsl:value-of select="/page/module/@current_locale"/>';
		</script>
		<script type="text/javascript" src="/main/initGlobalMsfWords?v={/page/module/@systemVersion}"></script>
		<script type="text/javascript" src="/js/msf/windowHandler/WindowHandler.js?v={/page/module/@systemVersion}"></script>
		<script type="text/javascript" src="/js/ext/prototype/prototype.js?v={/page/module/@systemVersion}"></script>
		<script type="text/javascript" src="/js/msf/page/MSF_InitUtils.js?v={/page/module/@systemVersion}"></script>
		
		<!-- Tiny -->
		<script>			
			var sGlobalMsfSkin 	= 'default';
			var sRteType		= '<xsl:value-of select="/page/module/@rteType"/>';
			var iSubjectId		= '<xsl:value-of select="/page/module/@id"/>';
			var iExtraId		= '<xsl:value-of select="/page/module/@extra_id"/>';
			var iExtraName		= '<xsl:value-of select="/page/module/@extra_name"/>';
			var sCnfMode		= '<xsl:value-of select="$CNF_MODE"/>';
		</script>			
		<script type="text/javascript" src="/js/exp/tiny_mce/tiny_mce_src.js?v={/page/module/@systemVersion}" onload="doProgressBar()"></script>
		<script type="text/javascript" src="/js/msf/tiny_mce/MSF_Plugins.js?v={/page/module/@systemVersion}" onload="doProgressBar()"></script>
		<script type="text/javascript" src="/modules/workflow/view/js/WF_RtePlugins.js?v={/page/module/@systemVersion}" onload="doProgressBar()"></script>	
		<script type="text/javascript" src="/js/msf/tiny_mce/MSF_TinyUtils.js?v={/page/module/@systemVersion}" onload="doProgressBar()"></script>
		
		</head>
		
		<body style="padding:0px; margin-bottom:20pt;">                
		<bdo></bdo>
		<div id="about-system" style="display:none; width: 400px; margin: 5%;">
			<p>
				<center>
				<strong>
					<span style="font-size: x-large;">
						Detrix						
					</span>
				</strong>
				</center>
			</p>
			<p>
				<table style="font-size: 10pt;">
					<tr>
						<td rowspan="6" valign="top">						
							<img alt="" src="/templates/default/images/detrix-about.png" style="float: left; margin-left: 10px; margin-right: 10px;"/>											
						</td>
						<td style="color: rgb(128, 128, 128);">		
							<xsl:value-of select="$HELP_VERSION"/>&#160;<xsl:value-of select="/page/module/@systemVersion"/>						
						</td>										
					</tr>
					<tr>
						<td><xsl:value-of select="$HELP_RIGHTS"/></td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="$HELP_WORK_NUMBER"/>: <xsl:value-of select="$MSF_LICENSE_NUMBER"/>
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="$HELP_LICENSE_OWNER"/>: <xsl:value-of select="$MSF_LICENSE_OWNER"/>
						</td>
					</tr>
					<tr>
						<td style="padding-top:10px">© 2013 Detrix<br />
                                                    <a href="http://www.detrix.kz" target="_blank">www.detrix.kz</a></td>
					</tr>
				</table>
			</p>						
		</div>		
			<xsl:apply-templates select="/page/msfx/updater"/>
			<iframe name="md_upload_frame" style="display:none;" src="/templates/blank.html"></iframe>
			<table width="100%" height="100%" cellspacing="0">
				<tbody>
					<tr>
						<td colspan="2" style="padding:0 0 1px 0">
							<xsl:if test="/page/module/@hideMenu = 0">
								<div class="whois">
									<ul>                                                                            
                                                                                <li>
											<a href="/logout"><img src="/templates/default/images/whois-logout-icon.png" title="{$LOGOUT_ICON_TITLE}"/></a>
										</li>
										<li>
											<a href="/profile"><img src="/templates/default/images/whois-profile-icon.png" title="{$PROFILE_ICON_TITLE}"/></a>
										</li>
										<xsl:if test="/page/msfx/user/posts">
											<li>
												<div id="msf_change_post_form" style="display:none">									
												</div>
												<select onchange="msfPostOnChange(this.value)" class="escapeWindowHandler">
													<xsl:for-each select="/page/msfx/user/posts/item">
														<option value="{@id}">
															<xsl:if test="/page/msfx/user/@post_id=@id">
																<xsl:attribute name="selected">selected</xsl:attribute>
															</xsl:if>
															<xsl:value-of select="@title"/>
														</option>
													</xsl:for-each>
												</select>
											</li>
										</xsl:if>
										<li><a><xsl:value-of select="/page/msfx/user/@user_name"/></a></li>
										<li>
											<xsl:choose>
												<xsl:when test="/page/msfx/user/@page_url!=''">
													<a href="{/page/msfx/user/@page_url}">
														<img src="/templates/default/images/home_icon.png" title="{$HOME_ICON_TITLE}"/>
													</a>
												</xsl:when>
												<xsl:otherwise>
													<a><img src="/templates/default/images/whois-post-icon.png"/></a>
												</xsl:otherwise>
											</xsl:choose>
										</li>

                                                                        </ul>
								</div>
								<xsl:apply-templates select="/page/msfx/menu"/>
							</xsl:if>
						</td>
					</tr>
					<xsl:if test="/page/msfx/toolbar/item[@name = 'status']/@value = 'top' and /page/module/@hideToolbar = 0">
						<tr>
							<td id="toolbar_top" class="no-print form-row-value toolbar-vertical">
								<xsl:value-of disable-output-escaping="yes" select="/page/msfx/toolbar/item[@name = 'template']/@value"/>
							</td>
						</tr>
					</xsl:if>
					<tr>
						<xsl:if test="/page/msfx/toolbar/item[@name = 'status']/@value = 'left' and /page/module/@hideToolbar = 0">
							<td id="toolbar_left" valign="top" class="no-print form-row-value toolbar-gorizontal">
								<xsl:value-of disable-output-escaping="yes" select="/page/msfx/toolbar/item[@name = 'template']/@value"/>
							</td>
						</xsl:if>
							<td valign="top" width="100%" height="98%">							
								<xsl:if test="/page/module/@hideBarAndCrumbs = 0">
									<xsl:apply-templates select="/page/msfx/actionbar"/>
								</xsl:if>
								<script>
									<xsl:if test="/page/module/@hideMenu = 1">
									var HIDE_MENU = true;
									</xsl:if>
									<xsl:if test="/page/module/@hideMenu = 0">
									var HIDE_MENU = false;
									</xsl:if>
									<xsl:if test="/page/module/@hideBarAndCrumbs = 1">
									var HIDE_BAR_AND_CRUMBS = true;
									</xsl:if>
									<xsl:if test="/page/module/@hideBarAndCrumbs = 0">
									var HIDE_BAR_AND_CRUMBS = false;
									</xsl:if>
									<xsl:if test="/page/module/@hideTitle = 1">
									var HIDE_TITLE = true;
									</xsl:if>
									<xsl:if test="/page/module/@hideTitle = 0">
									var HIDE_TITLE = false;
									</xsl:if>
									<xsl:if test="/page/module/@hideToolbar = 1">
									var HIDE_TOOLBAR = true;
									</xsl:if>
									<xsl:if test="/page/module/@hideToolbar = 0">
									var HIDE_TOOLBAR = false;
									</xsl:if>
								</script>
								<div class="module" id="module">
									<xsl:if test="/page/msfx/messenger/errors/error">
										<div class="msfMessagesError">
											<xsl:for-each select="/page/msfx/messenger/errors/error">
												<div><xsl:value-of select="@value"/></div>
											</xsl:for-each>
										</div>
									</xsl:if>
									<xsl:if test="/page/msfx/messenger/messages/message">
										<div class="msfMessagesMessage">
											<xsl:for-each select="/page/msfx/messenger/messages/message">
												<div><xsl:value-of select="@value"/></div>
											</xsl:for-each>
										</div>
									</xsl:if>							
					
									<xsl:if test="/page/module/@hideTitle = 0">
										<div class="block title no-print">
											<xsl:value-of select="/page/module/@title"/>
										</div>
									</xsl:if>
								
									<xsl:apply-templates select="/page/module"/>
								</div>
							</td>
						<xsl:if test="/page/msfx/toolbar/item[@name = 'status']/@value = 'right' and /page/module/@hideToolbar = 0">
							<td id="toolbar_right" valign="top" class="no-print form-row-value toolbar-gorizontal">
								<xsl:value-of disable-output-escaping="yes" select="/page/msfx/toolbar/item[@name = 'template']/@value"/>
							</td>
						</xsl:if>
					</tr>
					<xsl:if test="/page/msfx/toolbar/item[@name = 'status']/@value = 'bottom' and /page/module/@hideToolbar = 0">
						<tr>
							<td id="toolbar_bottom" class="no-print form-row-value toolbar-vertical">
								<xsl:value-of disable-output-escaping="yes" select="/page/msfx/toolbar/item[@name = 'template']/@value"/>
							</td>
						</tr>
					</xsl:if>
				</tbody>
			</table>
			<xsl:if test="/page/module/@hideMenu = 1">
				<script>
				var aLinks = document.getElementsByTagName("A");
				for (i = 0; i &lt; aLinks.length; i++) {
					var sValue = aLinks[i].innerHTML;
					if (!aLinks[i].href) {
						continue;
					}
					else if (aLinks[i].href.indexOf("?") == -1) {
						aLinks[i].href 		= aLinks[i].href + "?hideMenu";
						aLinks[i].innerHTML = sValue;
					}
					else {
						aLinks[i].href		= aLinks[i].href + "&amp;hideMenu";
						aLinks[i].innerHTML = sValue;
					}
					
				}

				</script>
				<script type="text/javascript">
				registerEvent(resizeIframeContents);
				</script>
			</xsl:if>
			<p/>
			<div style="display:none;">
				<div id="login_layer" style="padding:5pt;">							
					<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
					<table cellpadding="5pt">
						<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
						<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
						<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
					</table>	
				</div>
			</div>
		</body>
		<script>
		doWindowOnLoad();
		</script>
		</html>
	</xsl:template>
</xsl:stylesheet>
