<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

include_once 'library/NuSoap/nusoap.php';
include_once 'modules/references/library/Reference/REF_Value.php';
include_once 'modules/1cv81/library/V81_ExchangerDB.php';
include_once 'modules/1cv81/library/V81_Base64FilesSaver.php';

class WFA_WsClient extends WF_ActionSupport implements WF_IAction
{
	private $mResult 		= null;
	
	private $aFields 		= array();
	
	private $aOptions		= array();
	
	public function initialize()
	{
		$aActionParams 	 = $this->getSettings()->getPureActions($this->getActionId());
		$this->aOptions  = $aActionParams["options"];	
	}

	public function processRequest()
	{	
		$iField				= 0;
		$aFieldsList	 	= $this->getDocument()->getCurrentVersion()->getFieldsAsList();
		$oValue			    = new REF_Value();
		$oDate 				= new MSF_Date();
		$sRecordType		= "";
		
		foreach ($this->aOptions AS $Key => $Value) {
			if ($Key == 'ws_fields_' . $iField) {
				$sField1C = $this->aOptions["ws_field1C_title_" . $iField];
				if ($Value !== 'document_id') {

					foreach ($aFieldsList AS $Field) {
						if ($this->aOptions["ws_record"] == $Field['name']) {
							$sRecordType = $Field['type'];
						}
						if ($this->aOptions[$Key] == $Field['name']) {
							switch ($Field['type']) {
								case 'reference':
									$this->aFields[$sField1C] = $this->isReferences($Field['optional']['reference'], $iField);
									if ($this->aFields[$sField1C] == false) {
										$this->aFields[$sField1C] = $this->getParam('post', $sField1C);
										$oValue->parse($this->aFields[$sField1C]);
										$aValue		 			  = $oValue->getValuesList();
										$this->aFields[$sField1C] = MSF_SL::getParam($aValue,0,0);
										$this->aFields[$sField1C] = str_replace('&quot;', '"',$this->aFields[$sField1C]);
									}
									
									break;
								case 'structure':
									$this->aFields[$sField1C] = $this->getParam('post', $sField1C);
									$oValue->parse($this->aFields[$sField1C]);
									$aValue		 			  = $oValue->getValuesList();
									$this->aFields[$sField1C] = MSF_SL::getParam($aValue,0,0);
									$this->aFields[$sField1C] = str_replace('&quot;', '"',$this->aFields[$sField1C]);
									break;
								case 'bool':
									$this->aFields[$sField1C] = $this->getParam('post', $sField1C);
									$aValue = explode('|^|row|^|', $this->aFields[$sField1C]);
									if (isset($aValue[1])) {
										$this->aFields[$sField1C] = $aValue[1];
									}
									if ($this->aFields[$sField1C] == 1) {
										$this->aFields[$sField1C] = "true";
									}
									else {
										$this->aFields[$sField1C] = "false";
									}
									break;
								case 'enum':
									$this->aFields[$sField1C] = $this->getParam('post', $sField1C);
									$aValue = explode('|^|row|^|', $this->aFields[$sField1C]);
									if (isset($aValue[1])) {
										$this->aFields[$sField1C] = $aValue[0];
									}
									break;
								case 'file':
								case 'picture':							
									$this->aFields[$sField1C] = $this->getParam('post', $sField1C);
									if (is_string($this->aFields[$sField1C])) {
										$this->aFields[$sField1C] = explode(",", $this->aFields[$sField1C]);
									}
									$this->aFields[$sField1C] = $this->decodeFile($sField1C);
									break;
								default:
									$this->aFields[$sField1C] = $this->getParam('post', $sField1C);
							}
						}
					}
					if (!isset($this->aFields[$sField1C])) {
						$this->aFields[$sField1C] = $this->getParam('post', $sField1C);
					}
				}
				else {
					$this->aFields[$sField1C] = $this->getDocument()->getDocumentId();
				}
				$iField++;
			}
		}
		
        $aParams = array();
        if (isset($this->aOptions['authentication_yes'])) {
            $aParams['login'] = $this->aOptions['client_login'];
            $aParams['password'] = $this->aOptions['client_password'];
        }
        //debug($aParams);exit;
        try {
            $oClient = new SoapClient($this->aOptions['ws_address'], $aParams);
            $this->mResult = $oClient->__soapCall($this->aOptions['ws_methods'], $this->aFields);
        }
        catch(SoapFault $fault) {
        	debug($fault);
        	exit();
            MSF_Logger::logMessage($fault->__toString());
            $oMessenger = MSF_Registry::get("MSF_Messenger");
            $oMessenger->addError(MSF_Registry::get("MSF_Locale")->getWord("WSCLIENT_ERROR_CONNECTION"));
            return self::NULL;
        }
        
		try {

			$j = 0;
			if (is_array($this->mResult)) {
				foreach ($this->mResult AS $mElement) {
					if (is_array($mElement)) {
						$this->mResult = "<table border=1>";
						foreach ($mElement AS $aRow) {
							foreach ($aRow AS $CellKey => $aCell){
								if (is_array($aCell)) {
									$this->mResult .= "<tr>";
									if ($j == 0) {
										foreach ($aCell AS $Key => $Value) {
											$this->mResult .= "<td><b>" . $Key . "</b></td>";
										}
										$this->mResult .= "</tr>";
										$this->mResult .= "<tr>";
									}
									foreach ($aCell AS $Key => $Value) {
										$this->mResult .= "<td>" . $Value . "</td>";
									}
									$j++;
									$this->mResult .= "</tr>";
								}
								else {
									$this->mResult .= "<tr>";
									$this->mResult .= "<td><b>" . $CellKey . "</b></td>";
									$this->mResult .= "<td>" . $aCell . "</td>";
									$this->mResult .= "</tr>";
								}
							}	
						}
						$this->mResult .= "</table>";
					}
					else {
						$this->mResult = $mElement;
					}
				}
			}
		}
		catch (Exception $oE) {
			$oMessenger = MSF_Registry::get("MSF_Messenger");
			$oMessenger->addError(MSF_Registry::get("MSF_Locale")->getWord("WSCLIENT_ERROR_CONNECTION"));
			return self::NULL;
		}
		//$this->getDocumentVersion()->setFields(array($this->aOptions["ws_record"] => $this->mResult));
		
		$OV 	= $this->getDocumentVersion();
		$NV 	= $this->getDocument()->newVersion();
		$OV->setSystemField("modified_at", $oDate->formatTimestamp());
		$oMediaId  = new WF_MediaId(MSF_Registry::get("MSF_DB"));	
		//$oMediaId->generate();
		$iUserId = $NV->getDocument()->getMediaId();

		switch ($sRecordType) {
			case 'date':
				$this->mResult = $oDate->formatDate($this->mResult);
				break;
			case 'timestamp':
				$this->mResult = $oDate->formatTimestamp($this->mResult);
				break;
			case 'file':
			case 'picture':
				if (!empty($this->mResult)) {
					$this->mResult = $this->saveFile($this->mResult, $iUserId);
				}
				break;
			default:
				break;
		}
		
		$aFieldsMerge = array_merge($OV->getFields(), array($this->aOptions["ws_record"] => $this->mResult));
		$NV->setFields($aFieldsMerge);
		$iResult= self::SUCCESS;
		if (!$this->areFieldsEqual($OV->getFields(), $NV->getFields())) {
			$OV->setSystemField("modified_at", $oDate->formatTimestamp());
			if ($this->saveDocumentVersion($NV, $OV)) {
				$iResult = self::SUCCESS;
			}
			else {
				$iResult = self::NULL;
			}
		}
		$this->callMove();
		$this->log();		
		return $iResult;
	}
	
	public function processExecute()
	{
		$aDocumentFields = $this->getDocument()->getCurrentVersion()->getFields();
		$aSystemFields	 = $this->getDocument()->getCurrentVersion()->getSystemFields();
		$aDocSysFields	 = array_merge($aDocumentFields, $aSystemFields);
		$oValue			 = new REF_Value();
		$oValue->parse($aDocSysFields['author_name']);
		$aAuthor 		 = $oValue->getValuesList();
		$aDocSysFields['author_name'] = $aAuthor[0];
		$oValue->parse($aDocSysFields['subdivision']);
		$aSubdivision	 = $oValue->getValuesList();
		$aDocSysFields['subdivision'] = $aSubdivision[0];
		$oDate = new MSF_Date();
		$aDocSysFields['created_at'] = $oDate->toViewFormat($aDocSysFields['created_at']);
		$aDocSysFields['modified_at'] = $oDate->toViewFormat($aDocSysFields['modified_at']);
		$iField 		 = 0;
		$aField			 = array();	
		foreach ($this->aOptions AS $Key => $Value) {
			if ($Key == 'ws_fields_' . $iField) {
				$sField1C = $this->aOptions["ws_field1C_title_" . $iField];
				if ($Value == 'document_id') {
					$aField[$sField1C] = $this->getDocument()->getDocumentId();
				}
				if (($Value !== '') && ($Value !== 'document_id')) {
					$aField[$sField1C] = $aDocSysFields[$Value];
				}
				$iField++;
			}
		}

		$this->setParam('post', $aField);
		return $this->processRequest();
	}

	private function callMove()
	{
		$aRoute		= $this->getSettings()->getActions($this->getActionId());
		if (isset($aRoute["options"])) {
			if (isset($aRoute["options"]["move_points"])) {		
				$this->call("move", array("iNewPoint" => $aRoute["options"]["move_points"]));
			}
		}
	}

	public function processResponse() 
	{
		return self::FAILURE;
	}
	
	private function isReferences($ReferenceId, $iField) 
	{
		$UserReference	 = new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
		$UserReference->load($ReferenceId);
		$DBRecord        = new V81_ExchangerDB('v81_comparison', 0);
        $aQueryResult    = $DBRecord->find("*" , "ref_doc_name = '" . $UserReference->getName() . "'", array());
         
        if (count($aQueryResult) == 0) {
        	$sResult = false;
        }
        else {
        	$XmlWrapper = new MSF_XmlWrapper($aQueryResult[0]['compared_xml']);
        	$aCompared  = $XmlWrapper->getAsArray();
        	$aRef		= $UserReference->getAsArray();
        	$oValue		= new REF_Value();
        	$aDocumentFields = $this->getDocument()->getCurrentVersion()->getFields();
        	$Key		= $this->aOptions['ws_fields_' . $iField];
			$oValue->parse($aDocumentFields[$Key]);
			$aNumber 	= $oValue->getKeysList();
			$aRefValue	= $UserReference->row($aNumber[0])->getAsHash();
			$sResult 	= $aRefValue[$aCompared['Код']['value']];      	
        }
        
        return $sResult; 
	}
	
	private function decodeFile($sField1C) {
		$Media 	= new MD_Media(new MD_MediaDB(MSF_Registry::get("MSF_DB")));
		$Media->setMaxFileSize(CNM_MEDIA_MAX_FILE_SIZE);
		$aLoad	= array();
		$iSize	= 0;
		if (!empty($_FILES)) {		
			$aFiles = (array) MSF_SL::getParam($_FILES, "load");
			$iSize 	= count($aFiles["name"]);
			for ($i = 0; $i < $iSize; $i++) {
				if ($aFiles["error"][$i] == 4) {
					continue;
				}
				$aLoad[$i]	 = $aFiles["name"][$i];
				$aLoad[$i]	.= "^name^";
				$aLoad[$i]	.= base64_encode(MSF_File::read($aFiles["tmp_name"][$i]));
			}
		}
		
		if (!empty($this->aFields[$sField1C])) {
			foreach ($this->aFields[$sField1C] AS $FileId) {
			    if(trim($FileId))
			    {
				$aFileInfo = $Media->getFileInfo($FileId);
				$aLoad[$iSize]  = $aFileInfo["name"];
				$aLoad[$iSize] .= "^name^";
				$aLoad[$iSize] .= base64_encode(MSF_File::read($aFileInfo["directory"]. '/' . $aFileInfo["file_id"]));
				$iSize++;
			    }
			}
		}

		$sResult = implode("^file^", $aLoad);
		
		return $sResult;
	}
	
	private function saveFile($mFile, $UserId) {
		$oSaveFile	= new V81_Base64FilesSaver();
		return $oSaveFile->saveBase64Files($UserId, $mFile);														
	}
	
	private function log() {
		$sShortText = MSF_Registry::get("MSF_Locale")->getWord("WSCLIENT_CONNECTION");
		$this->getDocument()->getLog()->display(
				$this->getActionTitle(),
				$sShortText,
				$this->prepareFullText($sShortText)
				);
	}
	
	private function prepareFullText($sShortText) {
		$aTitleFields = $this->getDocument()->getCurrentVersion()->getFieldsAsList();
		$sFullText	  = $sShortText . "\n";
		$i = 0;
		$sFullText 	.= $this->aOptions['ws_address'];
                                                                                                                    					
		return $sFullText;
	}
	
	public function saveDocumentVersion($DocumentVersion, $DocumentOldVersion)
	{
		$Date 		= new MSF_Date();
		$oUserBox 	= MSF_Registry::get("MSF_UserBox");
		$oMessenger = MSF_Registry::get("MSF_Messenger");
		$Doctype	= $this->getDoctype();
		$Locale 	= MSF_Registry::get("MSF_Locale");
		$bRedirect 	= false;
		$aUnfilledFields 	= $DocumentVersion->getUnfilledFields();
		$aIncorrectFields 	= $DocumentVersion->getIncorrectFields();

		if (empty($aIncorrectFields)) {
			if (empty($aUnfilledFields)) {
				$UF	= new MSF_UniqueField(MSF_Registry::get("MSF_DB"));
				$UF->freeFields($DocumentOldVersion->getFieldsAsList(), MSF_UniqueField::TYPE_DOCTYPE, $Doctype->getDoctypeId());
				$UF->blockFields($DocumentVersion->getFieldsAsList(), MSF_UniqueField::TYPE_DOCTYPE, $Doctype->getDoctypeId());
				
				$DocumentVersion->setStructureId($oUserBox->getCurrentStructureId());
				$DocumentVersion->setEmployeeName($oUserBox->getEmployeeAttribute("name"));
				$DocumentVersion->setCreatedAt($Date->format());
				$DocumentVersion->setSystemFields($DocumentOldVersion->getSystemFields());
				$DocumentVersion->save();
				$bRedirect = true;
			}
			else {
				$oMessenger->addError($Locale->getWord("WORKFLOW_FULFILL_FIELDS") . implode(", ", $aUnfilledFields));
			}
		}
		else {
			$oMessenger->addError($Locale->getWord("WORKFLOW_FULFILL_FIELDS_CORRECTLY") . implode(", ", $aIncorrectFields));
		}
		
		$this->isRedirectable($bRedirect);
		return $bRedirect;
	}
	
	private function areFieldsEqual($aOldFields, $aNewFields)
	{
		return ($aOldFields == $aNewFields);
	}


}

?>
