<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

include_once 'modules/references/library/Reference/REF_Value.php';

class WFA_WsclientViewPort extends WFA_AbstractViewPort
{
	
	public function port(array $aActionParams, array $aCurrentDelegated)
	{
		$oDate			 = new MSF_Date();
		$aDocumentFields = array();
		$aSystemFields	 = array();
		$aFieldsList	 = $this->oDocument->getCurrentVersion()->getFieldsAsList();
		$aSystemList 	 = $this->oDocument->getCurrentVersion()->getSystemFieldsAsList();
		foreach ($aFieldsList AS $Value) {
			$aFieldType[$Value['name']] = $Value['type'];
		}
		foreach ($aSystemList AS $Value) {
			$aFieldType[$Value['name']] = $Value['type'];
		}
		$aDocumentFields = $this->oDocument->getCurrentVersion()->getFields();
		$aSystemFields	 = $this->oDocument->getCurrentVersion()->getSystemFields();
		$aDocSysFields	 = array_merge($aDocumentFields, $aSystemFields);
		$aDocSysFields['created_at'] = str_replace("-", ".", $aDocSysFields['created_at']);
		$aDocSysFields['modified_at'] = str_replace("-", ".", $aDocSysFields['modified_at']);
		$aOptions 		 = array();
		$aOptions 	     = $aActionParams["options"];
		$iField 		 = 0;
		$aNewOptions	 = array();
		if (isset($aOptions['authentication_yes'])){
			$aNewOptions['authentication_yes'] = $aOptions['authentication_yes'];
			$aNewOptions['client_login'] 	   = $aOptions['client_login'];
			$aNewOptions['client_password']	   = $aOptions['client_password'];
		}
		$aNewOptions['visible'] = $aOptions['visible'];
		$aNewOptions['ws_address'] = $aOptions['ws_address'];
		$aNewOptions['ws_methods'] = isset($aOptions['ws_methods']) ? $aOptions['ws_methods'] : "";
		$aNewOptions['ws_record']  = $aOptions['ws_record'];
		$Fields 		= new MSF_XmlWrapper($this->oDoctypeVersion->getFieldsXml());
		
		foreach ($aOptions AS $Key => $Value) {
			if ($Key == 'ws_fields_' . $iField) {
				if ($Value == 'document_id') {
					$aNewOptions['fields'][$iField]['name'] 	= $aOptions['ws_field1C_title_' . $iField];
					$aNewOptions['fields'][$iField]['title'] 	= $aOptions['ws_title_field_' . $iField];
					$aNewOptions['fields'][$iField]['value']	= $this->oDocument->getDocumentId();
					if (isset($aOptions['ws_edit_field_' . $iField])) {
						$aNewOptions['fields'][$iField]['visible']	= $aOptions['ws_edit_field_' . $iField];
					}
					else {
						$aNewOptions['fields'][$iField]['visible']	= "";
					}
					$aNewOptions['fields'][$iField]['type']		= 'int';
				}
				if (($Value !== '') && ($Value !== 'document_id')) {
					if (isset($aDocSysFields[$Value]) && $aDocSysFields[$Value] !== '') {
						$aNewOptions['fields'][$iField]['name'] 	= $aOptions['ws_field1C_title_' . $iField];
						$aNewOptions['fields'][$iField]['title'] 	= $aOptions['ws_title_field_' . $iField];
						$aNewOptions['fields'][$iField]['value']	= $aDocSysFields[$Value];
						if (isset($aOptions['ws_edit_field_' . $iField])) {
							$aNewOptions['fields'][$iField]['visible']	= $aOptions['ws_edit_field_' . $iField];
						}
						else {
							$aNewOptions['fields'][$iField]['visible']	= "";
						}
						$aNewOptions['fields'][$iField]['type']		= $aFieldType[$Value];
					}
					else {
						$aNewOptions['fields'][$iField]['name'] 	= $aOptions['ws_field1C_title_' . $iField];
						$aNewOptions['fields'][$iField]['title'] 	= $aOptions['ws_title_field_' . $iField];
						$aNewOptions['fields'][$iField]['value']	= "";
						if (isset($aOptions['ws_edit_field_' . $iField])) {
							$aNewOptions['fields'][$iField]['visible']	= $aOptions['ws_edit_field_' . $iField];
						}
						$aNewOptions['fields'][$iField]['type']		= $aFieldType[$Value];
					}
					foreach ($Fields as $Data) {
						if ($Data->getName() == $aOptions[$Key]) {
							$aNewOptions['fields'][$iField]["optional"] = $Data->getValue();
						}		
					}
					switch ($aNewOptions['fields'][$iField]['type']) {
						case 'reference':
							$aNewOptions['fields'][$iField]["optional"] = $this->refOptional($aNewOptions['fields'][$iField]['type'], 
																							 $aNewOptions['fields'][$iField]);
							break;
						case 'structure':
							$aNewOptions['fields'][$iField]["optional"] = $aNewOptions['fields'][$iField]["optional"]["optional"];
							break;
						case 'bool':
							$aValue	= explode('|^|row|^|', $aNewOptions['fields'][$iField]['value']);
							$aNewOptions['fields'][$iField]['value'] = $aValue[1];
							break;
						case 'enum':
							$aValue	= explode('|^|row|^|', $aNewOptions['fields'][$iField]['value']);
							$aNewOptions['fields'][$iField]["optional"] = $aNewOptions['fields'][$iField]["optional"]["optional"];
							$aNewOptions['fields'][$iField]['value'] = $aValue[0];
							break;
						case 'date':
							$aNewOptions['fields'][$iField]['value'] = $oDate->toViewFormat($aNewOptions['fields'][$iField]['value']);
							break;
						case 'file':
						case 'picture':
							$aNewOptions['fields'][$iField]["optional"] = $aNewOptions['fields'][$iField]["optional"]["optional"];
							if (!empty($aNewOptions['fields'][$iField]["value"])) {
								$Media 	= new MD_Media(new MD_MediaDB(MSF_Registry::get("MSF_DB")));
								$aIds 	= explode(",", $aNewOptions['fields'][$iField]["value"]);
								$aNewOptions['fields'][$iField]["optional"]["files"] = array();
								
								foreach ($aIds as $iId) {
									$aFile 	= $Media->getFileInfo($iId);
									$aTmp 	= array();
									$aTmp["id"] 	= $aFile["file_id"];
									$aTmp["name"] 	= $aFile["name"];
									$aNewOptions['fields'][$iField]["optional"]["files"][] = $aTmp;
								}
							}
							break;
					}			
				}
				$iField++;
			}
		}
		//debug($aNewOptions);
		//exit();
		return $aNewOptions;
	}
	
	private function refOptional($sType, $aOptional)
	{
		$sColumns 	= "{";
		$sGroups 	= "[";
		$sFilters 	= "{";
		$iSize 		= count($aOptional["optional"]["optional"]["columns"]);
		$iCount 	= 0;
		$bGroup 	= ($aOptional["optional"]["optional"]["groupEnable"] == 1) ? "true" : "false";
		$bFilter 	= ($aOptional["optional"]["optional"]["filterEnable"] == 1) ? "true" : "false";
		$aFields 	= $aOptional["optional"]["optional"]["fieldsValue"];
		
		if (isset($aOptional["optional"]["optional"]["columns"])) {
			foreach ($aOptional["optional"]["optional"]["columns"] as $sValue) {
				$bSelect = "false";
				if (in_array($sValue, $aFields)) {
					$bSelect = "true";
				}
				$sColumns .= 	$sValue . ": {'select': " .
								$bSelect . ", 'group': " .
								$bGroup . ", 'filter': " .
								$bFilter . ", 'sort': true}";
				
				if ($iCount < $iSize - 1) {
					$sColumns .= ",";
				}
				
				$iCount++;
			}
		}
		
		if (isset($aOptional["optional"]["optional"]["defaultGroup"])) {
			$iSize 	= count($aOptional["optional"]["optional"]["defaultGroup"]);
			$iCount = 0;
			foreach ($aOptional["optional"]["optional"]["defaultGroup"] as $sValue) {
				$sGroups .= "'" . $sValue . "'";
				
				if ($iCount < $iSize - 1) {
					$sGroups .= ",";
				}
			}
		}
		
		if (isset($aOptional["optional"]["optional"]["defaultFilter"])) {
			$iSize 	= count($aOptional["optional"]["optional"]["defaultFilter"]);
			$iCount = 0;
			foreach ($aOptional["optional"]["optional"]["defaultFilter"] as $sKey => $sValue) {
				if (strlen($sValue) == 0) {
					continue;
				}
				$sFilters .= $sKey . ": '" . $sValue . "'";
				
				if ($iCount < $iSize - 1) {
					$sFilters .= ",";
				}
			}
		}
		
		$sColumns .= "}";
		$sGroups .= "]";
		$sFilters .= "}";
		$aNewOptional = array();
		$aNewOptional["reference"]		= $aOptional["optional"]["optional"]["reference"];
		$aNewOptional["groupEnable"] 	= $bGroup;
		$aNewOptional["filterEnable"] 	= $bFilter;
		$aNewOptional["columns"] 		= $sColumns;
		$aNewOptional["defaultGroup"] 	= $sGroups;
		$aNewOptional["defaultFilter"] 	= $sFilters;
		$aNewOptional["multiselect"] 	= ($aOptional["optional"]["optional"]["multiselect"] == 1) ? "true" : "false";
		
		return $aNewOptional;
	}
	
	
}
?>