<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="action[@type='wsclient']">
		
		<form style="display: none" id="action_window_{@id}" method="post" action="{@url}?request=yes" enctype="multipart/form-data">
			<div style="overflow: auto; max-height: 350pt;"><table><tbody id='ws_field_value_{@id}'></tbody></table></div>
			<script type="text/javascript">
				var oFieldsValue 	= $('ws_field_value_<xsl:value-of select="@id"/>');
				function addFileWsClient(Img)
				{
					var Cont 	= Img.parentNode.parentNode;
					var Div 	= new Element('div');
					
					Div.insert(new Element('input', {'type': 'file', 'name': 'load[]'}));
					Div.insert('&#160;');
					Div.insert('<img src="/templates/default/images/add.png" style="cursor: pointer;" onclick="addFileWsClient(this)"/>');
					Div.insert('<img src="/templates/default/images/red_cross.png" style="cursor: pointer;" onclick="removeFileWsClient(this)"/>');
					
					Cont.insert(Div);
				}
				function removeFileWsClient(Img)
				{
					if (Img.parentNode.parentNode.childElementCount != 1) {
						Img.parentNode.parentNode.removeChild(Img.parentNode);
					}
				}
				<xsl:for-each select="item[@name = 'fields']/item">
					var oTr 			= new Element('TR');
					var oTdTitle		= new Element('TD');
					var oTdValue		= new Element('TD');
					oTr.insert(oTdTitle);
					oTr.insert(oTdValue);
					oFieldsValue.insert(oTr);
					<xsl:if test="item[@name = 'visible']/@value = ''">
						oInput 			= new Element('INPUT');
						oInput.type 	= 'hidden';
						oInput.name		= '<xsl:value-of select="item[@name = 'name']/@value"/>';
						oInput.value 	= '<xsl:value-of select="item[@name = 'value']/@value"/>';
						oTdValue.insert(oInput);
					</xsl:if>
					<xsl:if test="item[@name = 'visible']/@value = 'on'">
						oTdTitle.insert('<xsl:value-of select="item[@name = 'title']/@value"/>');
						<xsl:choose>
							<xsl:when test="item[@name = 'type']/@value = 'file' or item[@name = 'type']/@value = 'picture'">
								<xsl:variable name="ws_client_name_file">
									<xsl:value-of select="item[@name = 'name']/@value"/>
								</xsl:variable>
								<xsl:for-each select="item[@name = 'optional']/item[@name = 'files']/item">
									var oDiv = new Element('DIV');
									oTdValue.insert(oDiv);
									oDiv.insert('<xsl:value-of select="item[@name='name']/@value"/>&#160;');
									oDiv.insert('<img src="/templates/default/images/add.png" style="cursor: pointer;" onclick="addFileWsClient(this)"/>');
									oDiv.insert('<img src="/templates/default/images/red_cross.png" style="cursor: pointer;" onclick="removeFileWsClient(this)"/>');
									oDiv.insert('<input type="hidden" name="{$ws_client_name_file}[]" value="{item[@name='id']/@value}"/>');
								</xsl:for-each>
								var oDiv = new Element('DIV');
								oTdValue.insert(oDiv);
								<xsl:choose>
									<xsl:when test="item[@name = 'optional']/item[@name = 'multiselect']/@value = 1">
										oDiv.insert('<input type="file" name="load[]"/>&#160;<img src="/templates/default/images/add.png" onclick="addFileWsClient(this)" style="cursor: pointer;"/>');
										oDiv.insert('<img src="/templates/default/images/red_cross.png" style="cursor: pointer;" onclick="removeFileWsClient(this)"/>');
									</xsl:when>
									<xsl:otherwise>
										oDiv.insert('<input type="file" name="load[]"/>');
									</xsl:otherwise>
								</xsl:choose>
							</xsl:when>
							<xsl:when test="item[@name = 'type']/@value = 'bool'">
									var oSelect  = new Element('SELECT');
									oSelect.name = '<xsl:value-of select="item[@name = 'name']/@value"/>';
									var oOption  = new Option('<xsl:value-of select="$LABEL_YES"/>', 1);
									oSelect.options[0] = oOption;
									var oOption  = new Option('<xsl:value-of select="$LABEL_NO"/>', 0);
									oSelect.options[1] = oOption;
									for (i=0; i &lt; 2; i++) {
										if (oSelect.options[i].value == <xsl:value-of select="item[@name = 'value']/@value"/>) {
											oSelect.options[i].selected = true;
										}
									}
									oTdValue.insert(oSelect);
							</xsl:when>
							<xsl:when test="item[@name = 'type']/@value = 'enum'">
								var oSelect 	= new Element('SELECT');
								oSelect.name 	= '<xsl:value-of select="item[@name = 'name']/@value"/>';
								var i = 0;
								var Value		= '<xsl:value-of select="item[@name = 'value']/@value"/>';
								<xsl:for-each select="item[@name='optional']/item[@name='enum']/item">
									var oOption = new Option('<xsl:value-of select="@value"/>', '<xsl:value-of select="@value"/>');
									oSelect.options[i] = oOption;
									if (oSelect.options[i].value == Value) {
										oSelect.options[i].selected = true;
									}
									i++;
								</xsl:for-each>
								oTdValue.insert(oSelect);
							</xsl:when>
							<xsl:when test="item[@name = 'type']/@value = 'timestamp'">
								var oCalendar	= new MSFW.Placeholder.Calendar({
									"Container" : oTdValue,
									"inputName" : '<xsl:value-of select="item[@name = 'name']/@value"/>',
									"time"		: true,
									"default" 	: '<xsl:value-of select="item[@name = 'value']/@value"/>'
								});
							</xsl:when>
							<xsl:when test="item[@name = 'type']/@value = 'date'">
								var oCalendar	= new MSFW.Placeholder.Calendar({
									"Container" : oTdValue,
									"inputName" : '<xsl:value-of select="item[@name = 'name']/@value"/>',
									"time"		: false,
									"default" 	: '<xsl:value-of select="item[@name = 'value']/@value"/>'
								});
							</xsl:when>	
							<xsl:when test="item[@name = 'type']/@value = 'structure'">	
								var oStructure = new MSFW.Placeholder.Structure({
									"Container"		: 	oTdValue,			
									"inputName"		: 	'<xsl:value-of select="item[@name = 'name']/@value"/>',			
									"default"		: 	'<xsl:value-of select="item[@name = 'value']/@value"/>',
									"multiselect" 	: 	<xsl:value-of select="item[@name = 'optional']/item[@name = 'multiselect']/@value"/>,
									"showPosts" 	:	<xsl:value-of select="item[@name = 'optional']/item[@name = 'postEnable']/@value"/>
								});
							</xsl:when>
							<xsl:when test="item[@name = 'type']/@value = 'reference'">
								new MSFW.Placeholder.Reference({
									"Container"			: 	oTdValue,
									"referenceId"		: 	<xsl:value-of select="item[@name = 'optional']/item[@name = 'reference']/@value"/>,
									"inputName"			: 	'<xsl:value-of select="item[@name = 'name']/@value"/>',
									"columns"			:	<xsl:value-of select="item[@name = 'optional']/item[@name = 'columns']/@value"/>,
									"byId"				: 	true,
									"multiselect"		: 	<xsl:value-of select="item[@name = 'optional']/item[@name = 'multiselect']/@value"/>,
									"defaultGroups"		: 	<xsl:value-of select="item[@name = 'optional']/item[@name = 'defaultGroup']/@value"/>,
									"defaultFilters"	:	<xsl:value-of select="item[@name = 'optional']/item[@name = 'defaultFilter']/@value"/>,
									"default"			: 	'<xsl:value-of select="item[@name = 'value']/@value"/>'
								});
							</xsl:when>
							<xsl:otherwise>
								oInput 			= new Element('INPUT');
								oInput.value 	= '<xsl:value-of select="item[@name = 'value']/@value"/>';
								oInput.name		= '<xsl:value-of select="item[@name = 'name']/@value"/>';
								oTdValue.insert(oInput);
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
				</xsl:for-each>
			</script>
			<input type="submit" value="OK" onclick="oneClickHandler(this)"/>
		</form>
	</xsl:template>
</xsl:stylesheet>