<?php

if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
/*
 * File: 	MSF_BackController.php
 * Date: 	18.01.2008
 * Time:	15:52:26
 * Detrix
 *
 */
// [include]

include_once 'system/MSF_Mcap.php';
include_once "system/mvc/MSF_ControllerSupport.php";
include_once 'system/utils/MSF_DBRecord.php';
include_once "system/mvc/MSF_ViewSupportXml.php";
include_once 'system/MSF_Registry.php';
include_once "modules/workflow/library/common/WF_Exception.php";
include_once "modules/workflow/library/doctype/WF_DoctypesList.php";
include_once "modules/workflow/view/xml/WF_DoctypesListXml.php";
include_once 'system/utils/MSF_XmlWrapper.php';
include_once 'system/utils/MSF_SL.php';

// [include actions]
include_once "modules/workflow/view/xml/WF_NullView.php";
include_once "modules/workflow/view/xml/WF_ModelXml.php";
include_once "modules/workflow/library/doctype/WF_DoctypesList.php";
include_once "modules/workflow/library/doctype/WF_Doctype.php";
include_once "modules/workflow/library/doctypeVersion/WF_DoctypeVersion.php";
include_once "modules/references/library/ReferencesList/REF_ReferencesList.php";
include_once "modules/workflow/view/xml/WF_FieldsXml.php";
include_once "modules/workflow/library/WF_Utils.php";
include_once "back/WFC_Abstract.php";
include_once "back/WFC_DoctypeVersions.php";
include_once "back/WFC_DoctypeEdit.php";
include_once "back/WFC_DoctypeSpa.php";
include_once "back/WFC_DoctypeCompare.php";
include_once "back/WFC_DoctypeRouter.php";
include_once "back/WFC_Folders.php";
include_once "back/WFC_FoldersGroups.php";
include_once "back/WFC_Template.php";
include_once "back/WFC_DoctypeFields.php";
include_once "back/WFC_DoctypeAccess.php";
include_once "back/WFC_MainList.php";
include_once "back/WFC_Route.php";
include_once "back/WFC_ArchiveOptions.php";
include_once "library/MSF_Export/MSF_ExportDoctype.php";
include_once "library/MSF_Import/MSF_ImportDoctype.php";
// [/include actions]

/**
 * @package 	workflow
 * @copyright 	Copyright (c) 2007, Detrix
 */
class MSF_BackController extends MSF_ControllerSupport
{
	/**
	 * @access 	public
	 * @return  void
	 * @throws 	Exception
	 */
	public function __construct()
	{
		parent::__construct();
		// Common code here
	}

	/**
	 * @access 	public
	 * @return  void
	 * @throws Exception
	 */
	public function indexAction()
	{
		$this->mainAction();
	}
	
	private function forTest()
	{
		
	}
	
	
	private function mainAction()
	{
		$Main = new WFC_MainList($this);
		$this->setView($Main->getView());
		
		$this->Template->setPageTitle(
				$this->locale("ROOT_ADMIN_MENU") .
				$this->locale("ROOT_TITLE_SEPARATOR") .
				$this->locale("WORKFLOW_ADMIN_MENU_DOCTYPES")
			);
	}
	
	public function mainajaxAction()
	{
		$Main = new WFC_MainList($this);
		$this->setView($Main->getAjaxView());
	}

	/**
	 * @access 	public
	 * @return  void
	 * @throws Exception
	 */
	public function doctypeAction()
	{
		$this->Template->setModuleAttrs("", $this->getModule(), $this->getIntParam(1));
				
		switch ($this->getParam(0)) {
			case "create"	:
			case "edit"		:
				$this->editDoctype();
				break;
			case "remove"	:
				$this->removeDoctype();
				break;
			case "compare"	:
				$this->compareDoctypes();
				break;
			case "spa"		:
				$this->spaDoctype();
				break;
			case "ajaxrequests":
				$this->ajaxRequests();
				break;
			case "router"	:
				$this->routerDoctype();
				break;
			case "route"	:
				$this->processRoute();
				break;
			case "fields"	:
				$this->fieldsDoctypes();
				break;
			case "access"	:
				$this->accessDoctypes();
				break;
			case "versions" :
				$this->showVersion();
				break;
			case "template" :
				$this->editTemplate();
				break;
			case "archive"	:
				$this->editArchiveOptions();
				break;
			case "export"	:
				$this->exportDoctype();
				break;
			case "import"	:
				$this->importDoctype();
				break;
			default			:
				$this->listDoctypes();
				break;
		}

		
		$iDoctypeId	= $this->getIntParam(1);
		if($iDoctypeId != 0) {
			$sTitle 	= "";
			$sFolders 	= "";
			$Doctype 	= new WF_Doctype($iDoctypeId);
			
			if ($this->getIntParam(2) > 0) {
				$UserBox 	= MSF_Registry::get("MSF_UserBox");
				$Date 		= new MSF_Date();
				$DV 		= new WF_DoctypeVersion($Doctype, $Doctype->getDoctypeVersionId());
				
				$UserBox->load($DV->getUserId());
				$aUser = $UserBox->getLoadedResult();
				
				$sTitle = 	" (" .
							$this->locale("WORKFLOW_DOCTYPE_COMPARE_VERSION") . " " .
							$Date->parseAndFormat($DV->getCreatedAt(), CNF_DATE_TIME_FORMAT) . ", " .
							mb_strtolower($this->locale("WORKFLOW_ADMIN_LIST_AUTHOR"), "UTF-8") . " - " .
							((isset($aUser["employee"]["name"])) ? $aUser["employee"]["name"] : "?") .
							")";
			}
			if ($Doctype->getFolderId() > 0) {
				$Folder 	= new WF_Folder(new WF_FolderDB($this->DB));
				$Folder->load($Doctype->getFolderId());
				$aFolder 	= $Folder->getConfig();
				
				if (!empty($aFolder["name"])) {
					if ((int) $aFolder["group_id"] > 0) {
						$FGroup 	= new WF_FolderGroup(new WF_FolderGroupDB($this->DB));
						$FGroup->load($aFolder["group_id"]);
						$aFGroup 	= $FGroup->getConfig();
						
						if (!empty($aFGroup["name"])) {
                                                    $sFolders .= MSF_Registry::get("MSF_Locale")->getI18N($aFGroup["name"]) . $this->locale("ROOT_TITLE_SEPARATOR");
						}
					}
					
					$sFolders .= MSF_Registry::get("MSF_Locale")->getI18N($aFolder["name"]) . $this->locale("ROOT_TITLE_SEPARATOR");
				}
			}
			$this->Template->setPageTitle(
				$this->locale("ROOT_ADMIN_MENU") .
				$this->locale("ROOT_TITLE_SEPARATOR") .
				$this->locale("WORKFLOW_ADMIN_MENU_DOCTYPES") .
				$this->locale("ROOT_TITLE_SEPARATOR") .
				$sFolders .
                                //$this->locale("ROOT_TITLE_SEPARATOR") .
				MSF_Registry::get("MSF_Locale")->getI18N($Doctype->getTitle()) .
                                MSF_Registry::get("MSF_Locale")->getI18N($sTitle)
			);
		}
		else{
			$this->Template->setPageTitle(
				$this->locale("ROOT_ADMIN_MENU") .
				$this->locale("ROOT_TITLE_SEPARATOR") .
				$this->locale("WORKFLOW_ADMIN_MENU_DOCTYPES")
			);
		}
	}
	
	private function showVersion()
	{
		$DV = new WFC_DoctypeVersions($this);
		$this->setView($DV->view($this->getIntParam(1), $this->getIntParam(2)));
	}
	
	private function exportDoctype()
	{
		$View		= new WF_ModelXml();
		$oExport	= new MSF_ExportDoctype($this->getIntParam(1));
		$oExport->download();
		$this->setView($View);
	}
	
	private function importDoctype()
	{
		$View		= new WF_ModelXml();
		if (IS_REQUEST) {
			$oImport	= new MSF_ImportDoctype($_FILES["importFile"]);
			if ($oImport->importSuccess()) {
				if ($oImport->complete()) {
					$Edit = new WFC_DoctypeEdit($this);
					$iDoctypeId = $oImport->getImportedDoctypeId();
					$View = $Edit->edit("edit", $iDoctypeId);
					$this->redirect('/admin/workflow/doctype/edit/' . $iDoctypeId, $this->locale("WORKFLOW_ADMIN_MENU_DOCTYPE_IMPORT_SUCCESS"));
				} else {
					MSF_Registry::get("MSF_Messenger")->addError($this->locale("WORKFLOW_ADMIN_MENU_DOCTYPE_IMPORT_ERROR"));
					$this->redirect('/admin/workflow');
				}
			}
			else {
				MSF_Registry::get("MSF_Messenger")->addError($this->locale("WORKFLOW_ADMIN_MENU_DOCTYPE_IMPORT_ERROR"));
				$this->redirect('/admin/workflow');
			}
		}
		$this->setView($View);
	}
	
	private function removeDoctype()
	{
		$iDoctypeId = (int) $this->getParam(1);
		$Doctype 	= new WF_Doctype($iDoctypeId);
		$View 		= new WF_ModelXml();
		
		if ($Doctype->exists($iDoctypeId)) {
			$aDocumentsIds = $Doctype->getDocumentsIds();
			
			if (IS_REQUEST || empty($aDocumentsIds)) {
				$this->docTypeRemoveEventLog($Doctype->getTitle());
				$Doctype->remove(true);
				$this->redirect('/admin/workflow', $this->locale("WORKFLOW_MESSAGE_DOCTYPE_REMOVED"));
			}
			else {
				$aDocuments = array();
				
				for ($i = 0; $i < count($aDocumentsIds); $i++) {
					$Tmp 			= $Doctype->getDocument($aDocumentsIds[$i]);
					$aTmp 			= array();
					$aTmp["id"] 	= $Tmp->getDocumentId();
					$aTmp["title"] 	= $Tmp->getTitle();
					$aDocuments[] 	= $aTmp;
				}
				$View->removeConfirm($aDocuments);
			}
		}
		else {
			MSF_Registry::get("MSF_Messenger")->addError($this->locale("WORKFLOW_DOCTYPE_ERROR_NOT_EXISTS"));
		}
		
		$this->setView($View);
	}

	private function docTypeRemoveEventLog($sEventTitle) {
		$oEventLog = new ELOG_EventLog(MSF_Registry::get("MSF_DB"));
		$oEventLog->addItem(array("event_type"=>"admin", "event_title"=>$sEventTitle, "message_type"=>"document"));
	}

	private function editDoctype()
	{
		$Edit = new WFC_DoctypeEdit($this);
		$this->setView($Edit->edit($this->getParam(0), $this->getIntParam(1)));
	}

	private function editTemplate()
	{
		if ($this->getParam(1) == "removefile") {
			$Media = new MD_Media(new MD_MediaDB(MSF_Registry::get("MSF_DB")));
			$Media->remove($this->getIntParam(3));
			$this->redirect("/admin/workflow/doctype/template/" . $this->getIntParam(2), $this->locale("WORKFLOW_ADMIN_MENU_DOCTYPE_TEMPLATE_FILE_DELETED"));
		}
		
		$Template = new WFC_Template($this, $this->getIntParam(1));
		if (IS_REQUEST) {
			$Template->edit();
		}

		$Template->view();
	}

	private function spaDoctype()
	{
		$iDoctypeId = $this->getIntParam(1);
		$Spa 		= new WFC_DoctypeSpa($this, $iDoctypeId);
		if (IS_REQUEST) {
			$Spa->edit();
		}
		
		$this->setView($Spa->view());
	}
	
	private function fieldsDoctypes()
	{
		$Fields = new WFC_DoctypeFields($this);
		$this->setView($Fields->edit($this->getIntParam(1)));
	}
	
	private function accessDoctypes()
	{
		$Access	= new WFC_DoctypeAccess($this);
		$this->setView($Access->edit($this->getIntParam(1)));
		//$Fields = new WFC_DoctypeFields($this);
		//$this->setView($Fields->edit($this->getIntParam(1)));
	}

	private function editArchiveOptions()
	{
		$oArchive = new WFC_ArchiveOptions($this);
		$this->setView($oArchive->edit($this->getIntParam(1)));
	}
	
	private function ajaxRequests()
	{
		$View = new MSF_ViewSupportJson();
		
		switch ($this->getParam(1)) {
			case "childdoc":
				$DL = new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));
				$View->set("doctypes", $DL->getAll());
				break;
			case "notify":
				$aResult 	= array();
				$Doctype 	= new WF_Doctype((int) MSF_SL::getParam($_POST, "doctype_id", 0));
				$FieldsXml 	= new MSF_XmlWrapper($Doctype->getFieldsXml());
				
				$i = 0;
				foreach ($FieldsXml AS $Data) {
					$aValue = $Data->getValue();
					
					if ($aValue["type"] == "bool") {
						$aResult[$i]["name"] 	= $Data->getName();
						$aResult[$i]["title"] 	= $Data->getTitle();
						$i++;
					}
				}
				
				$View->set("fields", $aResult);
				break;
		}
		
		$this->setView($View);
	}

	private function routerDoctype()
	{
		$Router = new WFC_DoctypeRouter($this);
		$this->setView($Router->edit($this->getIntParam(1)));
	}
	
	private function processRoute()
	{
		$Router = new WFC_Route($this);
		$this->setView($Router->edit($this->getIntParam(1)));
		
		/*
		$iDoctypeId	= $this->getIntParam(1);
		$oRoute 	= new WFC_Route($this);
		if (IS_REQUEST) {
			$iNewDoctypeId 	= $oRoute->edit($iDoctypeId);
			$sUri 			= "/admin/workflow/doctype/route/" . $iNewDoctypeId;
			if ($iNewDoctypeId > 0) {
				$this->redirect($sUri);
			}
			else {
				throw new Exception("WFC_Route::edit(\$iDoctypeId) returned zero");
			}
			
		}
		else {
			$oView = $oRoute->view($iDoctypeId);
			$this->setView($oView);
		}
		*/
	}
	
	private function compareDoctypes()
	{
		$Compare = new WFC_DoctypeCompare($this);
		$this->setView($Compare->edit($this->getIntParam(1)));
	}

	private function listDoctypes()
	{
		$List = new WF_DoctypesList($this->DB);
		$View = new WF_DoctypesListXml();
		$View->set($List->get());
		$this->setView($View);
	}

	public function foldersAction()
	{
		$FoldersActions	= new WFC_Folders($this);
		$sAction		= $this->getParam(0);

		switch($sAction) {
			case "edit"		:
				$FoldersActions->edit();
				break;
			case "add"		:
				$FoldersActions->add();
				break;
			case "compare"	:
				$FoldersActions->compare();
				break;
			case "fields"	:
				$FoldersActions->fields();
				break;
			case "access"	:
				$FoldersActions->access();
				break;
			case "remove"	:
				$FoldersActions->remove();
				break;
			case "ajaxrequest" 	:
				$FoldersActions->ajax();
				break;
			case "aktenplan"	;
				$FoldersActions->aktenplan();
				break;
			default			:
				$FoldersActions->index();
				break;
		}

	}

	public function folders_groupsAction()
	{
		$FoldersGroupsActions	= new WFC_FoldersGroups($this);
		$sAction				= $this->getParam(0);

		$sAction	= $this->getParam(0);
		switch($sAction) {
			case "edit"		:
				$FoldersGroupsActions->edit();
				break;
			case "add"		:
				$FoldersGroupsActions->add();
				break;
			case "remove"	:
				$FoldersGroupsActions->remove();
				break;
			default			:
				$FoldersGroupsActions->index();
				break;
		}

	}
	
	public function jsonDoctypeParamsAction()
	{
		$aParams 	= array();
		$oDoctype 	= new WF_Doctype($this->getIntParam(1));
		if ($oDoctype->exists()) {
			switch ($this->getParam(0)) {
				
				case "c_fields":
					$aFields = MSF_XmlWrapper::xmlToArray($oDoctype->getCurrentVersion()->getFieldsXml());
					foreach ($aFields AS $sFieldname => $aBody) {
						$aParams[$aBody["title"]] = $aBody["title"];
					}

					break;
				case "s_fields":
					/*
					$oSettings = new WF_SystemFieldsSettings();
					for ($i = 0; $i < $oSettings->size(); $i++) {
						$aParams[$oSettings[$i]["title"]] = "[" . $oSettings[$i]["title"] . "]";
					}
					*/

					$aFields = MSF_XmlWrapper::xmlToArray($oDoctype->getCurrentVersion()->getSystemFields()->__toString());
					foreach ($aFields AS $sFieldname => $aBody) {
						$aParams[MSF_Registry::get("MSF_Locale")->getWord($aBody["title"])] = "[" . MSF_Registry::get("MSF_Locale")->getWord($aBody["title"]) . "]";
					}
					

					break;
				case "vars":
					$oVars = new WF_Vars();
					$aVars = $oVars->getList();
					for ($i = 0; $i < count($aVars); $i++) {
						if ($aVars[$i]["mode"] == "variable") {
							$aParams[$aVars[$i]["title"]] = $aVars[$i]["tag"];
						}
						
					}

					break;
				case "all":
					//c_fields
					$aParams['c_fields'] 	= array();
					$aCFields 				= MSF_XmlWrapper::xmlToArray($oDoctype->getCurrentVersion()->getFieldsXml());
					foreach ($aCFields AS $sFieldname => $aBody) {
						$aParams['c_fields'][$sFieldname] 			= $aBody['value'];
						$aParams['c_fields'][$sFieldname]['title'] 	= $aBody["title"];
					}
					
					//s_fields
					$aParams['s_fields'] 	= array();
					$aSFields = MSF_XmlWrapper::xmlToArray($oDoctype->getCurrentVersion()->getSystemFields()->__toString());
					foreach ($aSFields AS $sFieldname => $aBody) {
						$aParams['s_fields'][$sFieldname] 			= $aBody['value'];
						$aParams['s_fields'][$sFieldname]['title'] 	= MSF_Registry::get("MSF_Locale")->getWord($aBody["title"]);
					}
					$oVars = new WF_Vars();
					$aVars = $oVars->getList();
					$aParams['vars'] = array();
					for ($i = 0; $i < count($aVars); $i++) {
						if ($aVars[$i]["mode"] == "variable") {
							$aParams['vars'][$aVars[$i]["name"]] = array();
						}
						
					}

					break;
			}
						
		}

		$this->setView(new MSF_ViewSupportJson($aParams));
	}
	
	public function getDoctypesSpaAction()
	{
		$iDoctypeId 	= $this->getParam(0);
		$sStrategy		= $this->getParam(1);
		$oDoctype		= new WF_Doctype($iDoctypeId);
		$oDoctype->getCurrentVersion();
		$oDoctypeVerion = new WF_DoctypeVersion($oDoctype, $oDoctype->getDoctypeVersionId());
		$oWraper		= new MSF_XmlWrapper($oDoctypeVerion->getSpaXml());
		$aAction 		= $oWraper->getAsArray();
		$aActionNames 	= array();
		$aNotPerform 	= array("decision", "edit", "control", "remind");
		foreach ($aAction AS $Key => $Value) {
			if ($Value["value"]["action"] !== "execution") {
				if ($sStrategy !== "route") {
					$aActionNames[$Key] = $Value['title'];
				}
				else if (!in_array($Value["value"]["action"], $aNotPerform)) {
					$aActionNames[$Key] = $Value['title'];
				}
			}
		}
		
		$aResult 	= array(
				'code' => '2',
				'body' => $aActionNames,	
				);
		$this->setView(new MSF_ViewSupportJson($aResult));
	}
	
	public function getDoctypeFieldsAction()
	{
		$aResult	= array();
		$iDoctypeId = $this->getIntParam(0);
		if($iDoctypeId == 0) {
			$this->setView(new MSF_ViewSupportJson($aResult));
			return;	
		}
		
		$oDoctype	= new WF_Doctype($iDoctypeId);
		$oVersion	= $oDoctype->getCurrentVersion();
		$sFields	= $oVersion->getFieldsXml();
		$oWrapper	= new MSF_XmlWrapper;		
		$aFields	= $oWrapper->xmlToArray($sFields);
				
		foreach($aFields AS $sKey => $aValue) {
			$aResult[$sKey]["title"] = $aValue["title"];
			$aResult[$sKey]["type"] = $aValue["value"]["type"];						
		}		
		
		$this->setView(new MSF_ViewSupportJson($aResult));		
	}
	
	public function getHaveDocumentsAction()
	{
		try {
			$oDoctype		 = new WF_Doctype($this->getIntParam(0));
			$oDoctypeVersion = $oDoctype->getCurrentVersion();		
			if ($oDoctypeVersion->exists()) {
				$sHaveDocuments	 	= ($oDoctypeVersion->getCountOfDocuments() > 0) ? "true" : "false";
			}
			else {
				$sHaveDocuments		= "false";
			}
			
		}
		catch (Exception $e) {
			$sHaveDocuments		= "false";
		}

		
		$this->setView(new MSF_ViewSupportJson($sHaveDocuments));
	}
	
	public function getSoapClientAction()
	{
		try {
			$sAdress   = $_POST['sAdress'];
			$oClient   = new nusoap_client($sAdress, true, false, false, false, false, 5);
			if (isset($_POST['ws_login'])) {
				$oClient->setCredentials($_POST['ws_login'], $_POST['ws_password'], "basic");
			}
			$oClient->decode_utf8 = false;
			$oClient->soap_defencoding = 'UTF-8';
			$oClient->loadWSDL();
			$aOperation = $oClient->wsdl->getOperations('soap');
			$aResult	= array();
			foreach ($aOperation AS $OperKey => $Value) 
			{
				$i			= 0;
				$aParam = $oClient->wsdl->getTypeDef($OperKey, false);
				if ($Value["input"]["use"] == 'literal') {
					if (isset($aParam["elements"])) {
						foreach ($aParam["elements"] AS $Key2 => $Value2) {
							$aResult[$OperKey][$i] = $Key2;
							$i++;
						}
					}
					else {
						$aResult[$OperKey][$i] = "";
						$i++;
					}
				}
				else {
					if (!empty($Value["input"]["parts"])) {
						foreach ($Value["input"]["parts"] AS $ComplexKey => $ComplexValue) {
							$aResult[$OperKey][$i] = $ComplexKey;
							$i++;
						}
					}
					else {
						$aResult[$OperKey][$i] = "";
						$i++;
					}
				}
			}
		}
		catch (Exception $e){
			$aResult = array();
		}
		
		$this->setView(new MSF_ViewSupportJson($aResult));
	}
	
	public function setDoctypeVersionAction()
	{
		$Locale 	= MSF_Registry::get("MSF_Locale");
                $iDtId 	= $this->getParam(0);
		$iDtvId = $this->getParam(1);
		$oDt 	= new WF_Doctype($iDtId);
		$oDtv	= $oDt->getVersion($iDtvId);
		$oDt->setFieldsXml($oDtv->getFieldsXml());
		$oDt->setDoctypeVersionId($iDtvId);
		$oDt->compareAll();
		//WF_Utils::saveAsNewVersion($oDt, array(), false);
		$oDt->save();
		$this->redirect("/admin/workflow/doctype/versions/" . $iDtId, $Locale->getWord("DOCTYPE_MSG_VERSION_CHANGE"));
	}
	
}

?>