<?php
/*
 * File: 	MSF_WSFrontController.php
 * Date: 	01.07.2009
 * Time:	16:47:53
 * Detrix
 */

// [include]
include_once "ws/WF_CreateDocumentWS.php";
include_once "ws/WF_SlowCreateDocumentWS.php";
include_once "ws/WF_MoveDocumentWS.php";
include_once "ws/WF_GetDoctypesWS.php";
include_once "ws/WF_GetFieldsWS.php";
// [/include]

/**
 * @package 	workflow
 * @copyright 	Copyright (c) 2007, Detrix LLP
 */
class MSF_WSController extends MSF_WSControllerSupport 
{
	protected $sURI		= "/ws/workflow";
	
	protected $aTypes 	= array(
			"field" => array(
					"name" => "field",
					"typeClass" => "complexType",
					"phpType" => "struct",
					"compositor" => "sequence",
					"restrictionBase" => "",
					"elements" => array(
						'name' => array('name' => 'name', 'type' => 'xsd:string'),
						'value' => array('name' => 'value', 'type' => 'xsd:string')
						),
					"attrs" => array(),
					"arrayType"	=> ""				
					),
			"doctype" => array(
					"name" => "doctype",
					"typeClass" => "complexType",
					"phpType" => "struct",
					"compositor" => "sequence",
					"restrictionBase" => "",
					"elements" => array(
						'id' => array('name' => 'id', 'type' => 'xsd:integer'),
						'name' => array('name' => 'name', 'type' => 'xsd:string')
						),
					"attrs" => array(),
					"arrayType"	=> ""				
					),
			"docfield" => array(
					"name" => "docfield",
					"typeClass" => "complexType",
					"phpType" => "struct",
					"compositor" => "sequence",
					"restrictionBase" => "",
					"elements" => array(
						'name' => array('name' => 'name', 'type' => 'xsd:string'),
						'type' => array('name' => 'type', 'type' => 'xsd:string')
						),
					"attrs" => array(),
					"arrayType"	=> ""				
					),
			"worker" => array(
					"name" => "worker",
					"typeClass" => "complexType",
					"phpType" => "struct",
					"compositor" => "sequence",
					"restrictionBase" => "",
					"elements" => array(
						'post' => array('name' => 'post', 'type' => 'xsd:string'),
						'subdiv' => array('name' => 'subdiv', 'type' => 'xsd:string'),
						'name' => array('name' => 'name', 'type' => 'xsd:string')						
						),
						"attrs" => array(),
						"arrayType"	=> ""
					),
			"fields" => array(
					"name" => "fields",
					"typeClass" => "complexType",
					"phpType" => "array",
					"compositor" => "",
					"restrictionBase" => "SOAP-ENC:Array",
					"elements" => array(),
					"attrs" => array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:field[]')),
					"arrayType" => 'tns:field'					
					),
			"doctypes" => array(
					"name" => "doctypes",
					"typeClass" => "complexType",
					"phpType" => "array",
					"compositor" => "",
					"restrictionBase" => "SOAP-ENC:Array",
					"elements" => array(),
					"attrs" => array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:doctype[]')),
					"arrayType" => 'tns:doctype'					
					),
			"docfields" => array(
					"name" => "docfields",
					"typeClass" => "complexType",
					"phpType" => "array",
					"compositor" => "",
					"restrictionBase" => "SOAP-ENC:Array",
					"elements" => array(),
					"attrs" => array(array('ref' => 'SOAP-ENC:arrayType', 'wsdl:arrayType' => 'tns:docfield[]')),
					"arrayType" => 'tns:docfield'					
					)					
			);
			
	
	protected $aProcs	= array(
			"WF_CreateDocumentWS__service" => array(
					"in" 	=> array(
							'doctypeId' 	=> 'xsd:integer',
							'fields' 		=> 'tns:fields',
							'structureId' 	=> 'xsd:integer'
							),
					"out"	=> array('return' => 'xsd:integer')	
					),
			"WF_SlowCreateDocumentWS__service" => array(
					"in" 	=> array(
							'doctypeId' 	=> 'xsd:integer',
							'fields' 		=> 'tns:fields',
							'worker' 		=> 'tns:worker'							
							),
					"out"	=> array('return' => 'xsd:integer')	
					),		
			"WF_GetFieldsWS__service" => array(
					"in" 	=> array(
							'doctypeId' => 'xsd:integer'
							),
					"out"	=> array('return' => 'tns:docfields')	
					),
			"WF_GetDoctypesWS__service" => array(
					"in" 	=> array(),
					"out"	=> array('return' => 'tns:doctypes')	
					),
			"WF_MoveDocumentWS__service" => array(
					"in" 	=> array(
							'iDocID' => 'xsd:integer',
							'iStep' 	=> 'xsd:integer'
							),
					"out"	=> array('return' 	=> 'xsd:integer')	
					)
					
			);
			
}

?>