<?php

include_once 'modules/workflow/controllers/ws/WF_DocumentServer.php';
include_once 'modules/workflow/controllers/ws/WF_LotusDocumentServer.php';
include_once 'modules/workflow/controllers/ws/WF_DocumentWSDLGenerator.php';
include_once 'msfx/userbox/MSF_UserBoxExtension.php';
include_once 'system/MSF_Settings.php';
include_once 'system/MSF_Locale.php';
include_once 'system/MSF_Template.php';

class MSF_WebServiceController
{
    public function __construct()
    {
        mb_internal_encoding('UTF-8');
        
        MSF_Registry::set("MSF_UserBox", MSF_UserBox::getInstance());
        MSF_Registry::set("MSF_Template", new MSF_Template());
        MSF_Registry::set("MSF_Settings", MSF_Settings::getInstance('<document></document>'));
    }
    
    public function indexAction()
    {
        
    }
    
    public function wsdlAction()
    {
        $oWsdlGen = new WF_DocumentWSDLGenerator();
        $oWsdlGen->handle();
        header('Content-type: text/xml');
        echo $oWsdlGen->generateWSDL();
    }
    
    public function serverAction()
    {
        if(!isset($_SERVER['PHP_AUTH_USER']))
            $this->authenticate();
        else
        {
            $bUnauthorizedAccess = false;
            $aSettings = MSF_Registry::get("MSF_Settings")->getConstants();
            $sLogin  = $aSettings['CNF_WS_LOGIN'];
            $sPasswd = $aSettings['CNF_WS_PASSWORD'];
            $sAuthor = $aSettings['CNF_WS_AUTHOR'];

            if($_SERVER['PHP_AUTH_USER'] != $sLogin) $bUnauthorizedAccess = true;
            if($_SERVER['PHP_AUTH_PW'] != $sPasswd) $bUnauthorizedAccess = true;
            
            if($bUnauthorizedAccess)
                $this->authenticate();
            else
            {
                $oSoapSrv = new WF_DocumentServer($sAuthor);
                $oSoapSrv->handle();
            }
        }
    }
    
    public function serverlotusAction()
    {
        if(!isset($_SERVER['PHP_AUTH_USER']))
            $this->authenticate();
        else
        {
            $bUnauthorizedAccess = false;
            $aSettings = MSF_Registry::get("MSF_Settings")->getConstants();
            $sLogin  = $aSettings['CNF_WS_LOGIN'];
            $sPasswd = $aSettings['CNF_WS_PASSWORD'];

            if($_SERVER['PHP_AUTH_USER'] != $sLogin) $bUnauthorizedAccess = true;
            if($_SERVER['PHP_AUTH_PW'] != $sPasswd) $bUnauthorizedAccess = true;
/*            
            $msg = "From settings.xml\n\t\"$sLogin\":\"$sPasswd\"\n";
            $msg.= "From user\n\t\"".$_SERVER['PHP_AUTH_USER']."\":\"".$_SERVER['PHP_AUTH_PW']."\"";
            file_put_contents(CNF_ABS_PATH."/temp/lotus", $msg);
*/            
            if($bUnauthorizedAccess)
                $this->authenticate();
            else
            {
                $aParams = MSF_Registry::get("MSF_Settings")->getXmlWrapper()->get("lotusclient")->getValue();
                $oSoapSrv = new WF_LotusDocumentServer($aParams['export_dir'], strtoupper($aParams['fs_files_charset']));
                $oSoapSrv->handle();
            }
        }
    }
    
    public function lotuswsdlAction()
    {
        $aDocsMap = array();
        for($k = 1; $k <= 50; $k++)
            $aDocsMap['Создать_'.$k] = $k;
        
        $result  = '<?xml version="1.0" encoding="UTF-8"?>';
        $result .= '<definitions name="LotusClient"';
        $result .= ' targetNamespace="urn:LotusClient"';
        $result .= ' xmlns:tns="http://'.$_SERVER['HTTP_HOST'].'/webservice/workflow/lotuswsdl"';
        $result .= ' xmlns:soap="http://schemas.xmlsoap.org/wsdl/soap/"';
        $result .= ' xmlns="http://schemas.xmlsoap.org/wsdl/">'."\n";
        
    //-- message
        foreach($aDocsMap as $proc_name => $aDocParams)
        {
            
        //-- create
            $result .= '<message name="'.$proc_name.'Request">';
            $result .= '<part name="Вложения" type="xsd:string"/>';
            for($i = 1; $i <= $aDocParams; $i++)
            {
                $result .= '<part name="Поле_'.$i.'" type="xsd:string"/>';
            }
            
            $result .= '</message>';
            $result .= '<message name="'.$proc_name.'Response">';
            $result .= '<part name="result" type="xsd:string"/>';
            $result .= '</message>';
        }
        
    //-- portType
        $result .= "\n".'<portType name="LotusClientPortType">';
        
        foreach($aDocsMap as $proc_name => $aDocParams)
        {   
            // create
            $result .= '<operation name="'.$proc_name.'">';
            $result .= '<input message="tns:'.$proc_name.'Request"/>';
            $result .= '<output message="tns:'.$proc_name.'Response"/>';
            $result .= '</operation>';
        }
        $result .= '</portType>'."\n";
        
        
    //-- binding
        $result .= '<binding name="LotusClientBinding" type="tns:LotusClientPortType">';
        $result .= '<soap:binding style="rpc" transport="http://schemas.xmlsoap.org/soap/http"/>';
        
        foreach($aDocsMap as $proc_name => $aDocParams)
        {
            
            // create
            $result .= '<operation name="'.$proc_name.'">';
            $result .= '<soap:operation soapAction="http://'.$_SERVER['HTTP_HOST'].'/srv.php#'.$proc_name.'"/>';
            $result .= '<input>';
            $result .= '<soap:body use="encoded" namespace="urn:LotusClient" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>';
            $result .= '</input>';
            $result .= '<output>';
            $result .= '<soap:body use="encoded" namespace="urn:LotusClient" encodingStyle="http://schemas.xmlsoap.org/soap/encoding/"/>';
            $result .= '</output>';
            $result .= '</operation>';
        }
        
        $result .= '</binding>'."\n";
        
    //-- service
        
        $result .= '<service name="LotusClientService">';
        $result .= '<port name="LotusClientPort" binding="LotusClientBinding">';
        $result .= '<soap:address location="http://'.$_SERVER['HTTP_HOST'].'/webservice/workflow/serverlotus"/>';
        $result .= '</port>';
        $result .= '</service>'."\n";
        
        $result .= '</definitions>';
        
        header('Content-type: text/xml');
        echo $result;
    }
    
    protected function authenticate()
    {
        header('WWW-Authenticate: Basic realm="Workflow WebService"');
        header('HTTP/1.0 401 Unauthorized');
        echo '<h1>Authentication required</h1><hr/><p><i>Workflow WebService</i></p>';
        exit;
    }
    
    public function setModule(){}
    public function setController(){}
    public function setAction(){}
    public function setParams(){}
    public function before(){}
    public function after(){}
}

?>
