<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

include_once "modules/workflow/view/xml/WF_AcrhiveOptionsXml.php";
include_once "modules/archive/library/ARCH_SecurityManager.php";
	
class WFC_ArchiveOptions extends WFC_Abstract {
	
	public function edit($iId, $iVersionId = 0)
	{
		$bCheck 	 	= true;
		$aResult	 	= array();
		$oView			= new WF_AcrhiveOptionsXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		$oManager		= new ARCH_SecurityManager($iId);
		$oXmlWrapper 	= new MSF_XmlWrapper;
		$Doctype 		= new WF_Doctype($iId);
		$DoctypeVersion = ($iVersionId > 0) ? $DoctypeVersion = $Doctype->getVersion($iVersionId) : $Doctype->getCurrentVersion();
		if(IS_REQUEST) {									
			$aAccess = (array) MSF_SL::getParam($_POST, "access", array());
			$aOptions["condition_kind"] = MSF_SL::getParam($_POST, "archive_options_select", array());
			if($aOptions["condition_kind"] == "days_run_out_field") {
				$aOptions["condition_params"]["field"] = MSF_SL::getParam($_POST, "date_field", array());
				$aOptions["condition_params"]["days"]  = MSF_SL::getParam($_POST, "days_count", array());
				if(empty($aOptions["condition_params"]["field"]) || $aOptions["condition_params"]["days"] == "") {
					$bCheck = false;			
				}
				
			}
			else {
				$aOptions["condition_params"]["days"]  = MSF_SL::getParam($_POST, "days_count", array());
				if($aOptions["condition_params"]["days"] == "") {
					$bCheck = false;			
				}
			}
				
			foreach ($aAccess AS $aValue) {
				if (empty($aValue["structure"])) {
					$bCheck = false;
					break;
				}
				
			}			
				
			if($bCheck) {				
				$oManager->edit($aAccess);
				$aParams 			 = array();
				$bNewVersion		 = false;
				$aParams["fields"] 	 = $DoctypeVersion->getFieldsXml();;
				$aParams["spa"] 	 = $DoctypeVersion->getSpaXml();
				$aParams["template"] = $DoctypeVersion->getTemplateXml();
				$aParams["route"] 	 = $DoctypeVersion->getRouteXml();
				$aParams["archive"]	 = $this->prepareArchiveXml($aOptions);
				WF_Utils::saveAsNewVersion($Doctype, $aParams, $bNewVersion);											
			}			
			
			if (!$bCheck) {
				MSF_Registry::get("MSF_Messenger")->addError(MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_ACCESS_ERROR"));
			}
			else {
				$this->Controller->redirect($_SERVER["REQUEST_URI"], $this->Controller->locale("WORKFLOW_ARCHIVE_SAVED"));
			}
			
		}
		
		$sFields 	 = $DoctypeVersion->getFieldsXml();
		$aFields 	 = $oXmlWrapper->xmlToArray($sFields);
		$aDateFields = array();
		foreach($aFields AS $sKey => $aValue) {
			if($aValue["value"]["type"] == "date" || $aValue["value"]["type"] == "timestamp") {
				$aDateFields[$sKey] = $aValue["title"];
			}
			
		}
		if (!$iVersionId) $this->addDoctypeActions($iId);
		
		if (!$bCheck) {			
			$aResult["access"]  = $aAccess;
			$aResult["options"] = $aOptions;
		}
		else {
			$aResult["access"]  = $oManager->get();
			$sOptions = $Doctype->getCurrentVersion()->getArchiveXml();
			$aOptions = $oXmlWrapper->xmlToArray($sOptions);			
			$aResult["options"] 							 = array();
			$aResult["options"]["condition_kind"] 			 = "";
			$aResult["options"]["condition_params"]["field"] = "";
			$aResult["options"]["condition_params"]["days"]  = 0;
			foreach($aOptions AS $sKey => $aValue) {
				$aResult["options"]["condition_kind"] = $sKey;
				$aResult["options"]["condition_params"]["days"] = $aValue["value"]["days"];
				if($sKey == "days_run_out_field") {
					$aResult["options"]["condition_params"]["field"] = $aValue["value"]["field"];
				}
				break;
			}
			
						
		}
		
		$aResult["datefields"] = $aDateFields;		
		$oView->changeOptions($aResult);
		return $oView;
	}
	
	private function prepareArchiveXml($aOptions)
	{
		if($aOptions["condition_kind"] == "days_never") {
			$sXml = "<document/>";
		}
		else {
			$oWrapper 	= new MSF_XmlWrapper();
			$oWrapper->set($aOptions["condition_kind"], $aOptions["condition_params"], "ArchiveCondition");
			$sXml 		= $oWrapper->getXml();
		}
		return $sXml;
	}
	
}

?>
