<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "modules/workflow/view/xml/WF_DoctypeEditXml.php";

class WFC_DoctypeEdit extends WFC_Abstract
{
	public function edit($sAction, $iDoctypeId)
	{
		$Doctype 			= new WF_Doctype($iDoctypeId);
		$aResult 			= array();
		$sTitle 			= (string) 	MSF_SL::getParam($_POST, "title");
		$sDescription 		= (string) 	MSF_SL::getParam($_POST, "description");
		$sFullDescription 	= (string) 	MSF_SL::getParam($_POST, "fullDescription");
		$bImportMode		= isset($_POST["importMode"]) && ($_POST["importMode"]=="1");
		
		if (IS_REQUEST) {
			if (strlen($sTitle)) {
				if ($sAction !== "edit") {
				    $sMessage = $this->Controller->locale("WORKFLOW_MESSAGE_DOCTYPE_CREATED");
					if ($Doctype->nameExists($sTitle)) {
						MSF_Registry::get("MSF_Messenger")->addError(
							$this->Controller->locale("WORKFLOW_MESSAGE_DOCTYPE_NAME_DULICATION")
						);
						
					}
					
				}
				
				$iUserId 	= MSF_Registry::get("MSF_UserBox")->getUserAttribute("id");
				$sDate 		= date("Y-m-d H:i");
				$Doctype->setUserId($iUserId);
				$Doctype->setTitle($sTitle);
				$Doctype->setDescription($sDescription);
				$Doctype->setFullDescription($sFullDescription);
				$aVersions = $Doctype->getDoctypeVersionsIds();
				$Doctype->setModifiedAt($sDate);
				$Doctype->save();
				if (empty($aVersions)) {
				    $Version = $Doctype->newVersion();
				    $Version->setUserId($iUserId);
				    $Version->setCreatedAt($sDate);
				    $Version->save();
				}
				
				if ($sAction == "edit") {
				    $sMessage = $this->Controller->locale("WORKFLOW_MESSAGE_DOCTYPE_SAVED");
				}
				
				$this->Controller->redirect("/admin/workflow/doctype/edit/" . $Doctype->getDoctypeId(), $sMessage);
				return;
			}
			else {
				if (!$bImportMode) {
					$aResult["title"] = $sTitle;
					$aResult["description"] = $sDescription;
					MSF_Registry::get("MSF_Messenger")->addError($this->Controller->locale("WORKFLOW_MESSAGE_EMPTY_TITLE"));
				}
			}

		}

		if ($sAction == "edit") {
			$aResult["title"] = $Doctype->getTitle();
			$aResult["description"] = $Doctype->getDescription();
			$aResult["fullDescription"] = $Doctype->getFullDescription();
		}
		$this->addDoctypeActions($iDoctypeId);
		$View = new WF_DoctypeEditXml();
		$View->show($aResult);
		
		MSF_RteObjectsIntegrator::files($iDoctypeId, "workflow_doctype");
		
		return $View;
	}
}

?>