<?
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

class WFC_DoctypeFields extends WFC_Abstract
{
	/**
	 * @return FieldsXml;
	 */
	public function edit($iDoctypeId)
	{
		
		$oDoctype = new WF_Doctype($iDoctypeId);
		// Process request if doctype existed
		if(IS_REQUEST && $oDoctype->exists()) {
			//debug($_POST);
			//exit();
			//mt();
			$oVersion 	= $oDoctype->getCurrentVersion();
			$aParams 	= $this->defineParamsArray($oVersion);

			// Save in current version
			if (MSF_SL::getParam($_POST, "save_in_version") == 1) {
				$this->saveInCurrentVersion($oDoctype, $oVersion, $aParams["fields"]);
       		}
       		// Save in new version
       		else {
       			// Delete empty doctype version
       			$bDocs = true;
	       		if($oVersion->exists() && ($oVersion->getCountOfDocuments() == 0)) {
	       			$oVersion->remove(true);
	       			$bDocs = false;
	       		}

	       		$isChanged = false;
	       		if (isset($_POST["fields"])) {
	       			$isChanged = $this->didFieldsChange($oVersion, (array) $_POST["fields"]);
	       		}
	       		else {
	       			if ($bDocs) {
	       				$isChanged = true;
	       			}
	       		}

	       		WF_Utils::saveAsNewVersion($oDoctype, $aParams, $isChanged);
       		}
			//debug(mt("stop"));
			//exit();
       		$this->Controller->redirect($_SERVER["REQUEST_URI"], $this->Controller->locale("WORKFLOW_FIELDS_SAVED"));
  		}  		
  		
  		$this->addDoctypeActions($iDoctypeId);
  		$oReferenceList	= new REF_ReferencesList(new REF_ReferencesListDB(MSF_Registry::get("MSF_DB")));
  		$DoctypeList	= new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));
  		$oView          = new FieldsXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
  		$oMediaId 		= new WF_MediaId();
  		MSF_RteObjectsIntegrator::files($oMediaId->get(), "workflow_doctype");
  		$oView->editDoctypeFields($oDoctype->getFieldsXml());
  		$oView->setReferencesList($oReferenceList->getList());
  		$oView->setDoctypesList($DoctypeList->getAll());  		

	 	return $oView;
	}
	

	/**
	 * Returns true if fields changed
	 * @return boolean
	 */
	private function didFieldsChange($oVersion, array $aPostField) {
		$isChanged 	= false;
		$oFields 	= new MSF_XmlWrapper($oVersion->getFieldsXml());
       	foreach ($aPostField as $sField => $aAttrs) {
       		//debug($aAttrs);
       		$sValType 	= $aAttrs["value"]["type"];
       		if ($sValType == "reference") {
       			$sValOptRef	= $aAttrs["value"]["optional"]["reference"];
       		}
       		
       		if($sValType == "notChoose" || ($sValType == "reference" && $sValOptRef == "-1")) {
       			continue;
       		}

       		if (substr_count($sField, "new_element_") > 0) {
       			$isChanged = true;
       			break;
       		}

       		foreach ($oFields as $Data) {
       			if ($sField == $Data->getName()) {
       				$aValue = $Data->getValue();
       				if ($sValType != $aValue["type"]) {
       					$isChanged = true;
       				}

       				if ($sValType == "reference" && $aValue["type"] == "reference") {
       					if ($sValOptRef != $aValue["optional"]["reference"]) {
       						$isChanged = true;
       					}

       				}
      

       				if ($sValType == "table" && $aValue["type"] == "table") {
       					$aOldFields = MSF_SL::getParam($aValue["optional"], "fields", array());       										
       					$aNewFields	= MSF_SL::getParam($aAttrs["value"]["optional"], "fields", array());
       					if (count($aOldFields) !== count($aNewFields)) {
       						$isChanged = true;
       					}
       					else {
       						foreach ($aOldFields AS $sField => $aBody) {
       							if (!array_key_exists($sField, $aNewFields)) {
       								$isChanged = true;
       							}
       							
       						}
       						
       					}

       				}

       			}

       		}

       	}

       	if (count($aPostField) != $oFields->getLength()) {
       		$isChanged = true;
       	}
       	
       	return $isChanged;
	}
	
	/**
	 * Defining an input array for a WF_Utils::saveAsNewVersion(WF_Doctype $oDoctype, array $aParams, bool $bChange)
	 * @return array
	 */
	private function defineParamsArray($oVersion) {
		$aParams 				= array();
		$aParams["fields"] 		= WF_Utils::prepareFields();
		$aParams["spa"] 		= $oVersion->getSpaXml();
		$aParams["template"] 	= $oVersion->getTemplateXml();
		$aParams["route"] 		= $oVersion->getRouteXml();
		$aParams["archive"]		= $oVersion->getArchiveXml();
		// Checking for an empty param
		foreach ($aParams as $sKey => $sValue) {
			if (strlen($sValue) == 0) {
				$aParams[$sKey] = "<document/>";
			}

		}
		
		return $aParams;
	}
	
	/**
	 * Saving in current version
	 * @return void
	 */
	private function saveInCurrentVersion($oDoctype, $oVersion, $aFields) {
       	$oVersion->updateFields($aFields);
       	$oDoctype->setFieldsXml($aFields);
       	$oDoctype->save();
       	WF_Utils::saveCompared($oDoctype, $oVersion);
	}
	
}
