<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "modules/workflow/library/doctype/WF_Doctype.php";
include_once "modules/workflow/library/actions/WF_ActionBox.php";
include_once "modules/workflow/view/xml/WF_DoctypeRouterXml.php";
include_once "modules/workflow/library/actions/WF_ActionBox.php";

class WFC_DoctypeRouter extends WFC_Abstract
{
	public function edit($iId)
	{
		$Doctype 		= new WF_Doctype($iId);
		$DoctypeVersion = $Doctype->getCurrentVersion();
		$sRouteXml 		= "";
		
		if (IS_REQUEST) {
			$sRouteXml = $this->prepareRouteXml($_POST);

			if ($DoctypeVersion->getCountOfDocuments() > 0) {
				WF_Utils::saveAsNewVersion($Doctype, array("route" => $sRouteXml));
			}
			else {
				$DoctypeVersion->setRouteXml($sRouteXml);
				$DoctypeVersion->save();
			}
			
			$this->Controller->redirect($_SERVER["REQUEST_URI"], "");
		}
		
		$sActionsXml 	= $DoctypeVersion->getSPAXml();
		$sRouteXml 		= $DoctypeVersion->getRouteXml();
		$sFieldsXml 	= $DoctypeVersion->getFieldsXml();
		$this->addDoctypeActions($iId);
		$View = new WF_DoctypeRouterXml();
		$ABox = WF_ActionBox::newInstance();
		$View->view($sActionsXml, $sRouteXml, $sFieldsXml, $ABox->getCfg());
		return $View;
	}
	
	private function prepareRouteXml($aResult)
	{
		$aPost 	= array();
		
		foreach ($aResult as $k => $v) {
			if (is_string($aResult[$k])) {
				continue;
			}
			
			$iCount 				= 0;
			$aPost[$k]["title"] 	= $v["title"];
			$aPost[$k]["control"] 	= $v["control"];
			$aPost[$k]["delegate"] 	= array();
			$aPost[$k]["execute"] 	= array();
			$aPost[$k]["wait"] 		= array();
			
			if (isset($aResult[$k]["delegate"])) {
				for ($i = 0; $i < sizeof($aResult[$k]["delegate"]); $i++) {
					if (!empty($aResult[$k]["delegate"][$i]["spa_id"])) {
						if (!isset($aResult[$k]["delegate"][$i]["value"])) {
							$aResult[$k]["delegate"][$i]["value"] = array("");
						}
						$aPost[$k]["delegate"][$iCount++] = $aResult[$k]["delegate"][$i];
					}
				}
			}
			if (isset($aResult[$k]["execute"])) {
				$iCount = 0;
				
				for ($i = 0; $i < sizeof($aResult[$k]["execute"]); $i++) {
					if (!empty($aResult[$k]["execute"][$i]["name"])) {
						if (!isset($aResult[$k]["execute"][$i]["value"])) {
							$aResult[$k]["execute"][$i]["value"] = "";
						}
						
						$aPost[$k]["execute"][$iCount++] = $aResult[$k]["execute"][$i];
					}
				}
			}
			if (isset($aResult[$k]["wait"])) {
				$aPost[$k]["wait"] = $aResult[$k]["wait"];
			}
		}
		
		$i 			= 0;
		$Wrapper 	= new MSF_XmlWrapper();
		foreach ($aPost AS $k => $aElement) {
			$sTitle = $aElement["title"];
			unset($aElement["title"]);
			
			$Wrapper->set($i++, $aElement, $sTitle);
		}
		
		return $Wrapper->getXml();
	}
}

?>