<?php

defined("__MSF")
		or die("Direct access is not allowed");

include_once "modules/workflow/library/doctype/WF_DoctypesListDB.php";
include_once "modules/workflow/library/doctype/WF_DoctypesList.php";
include_once "modules/workflow/library/doctype/WF_Doctype.php";
include_once "modules/workflow/library/actions/WF_ActionBox.php";
include_once "modules/workflow/view/xml/WF_DoctypeSpaXml.php";
include_once "system/utils/MSF_HtmlEntities.php";

class WFC_DoctypeSpa extends WFC_Abstract
{
	private $Doctype;

	public function __construct(MSF_ControllerSupport $Controller, $iDoctypeId)
	{
		parent::__construct($Controller);
		$this->Doctype 			= new WF_Doctype($iDoctypeId);
	}

	public function edit()
	{
		//debug($_POST);
		$sXml 			= $this->prepareSpaXml($_POST);
		$DoctypeVersion = $this->Doctype->getCurrentVersion();
		$sRouteXml 		= $this->Doctype->getRouteXml();
		$sRouteXml 		= $this->clearRoute($sXml, $sRouteXml);		
		if ($DoctypeVersion->getCountOfDocuments() > 0) {
			$bNewVersion = false;
			if (MSF_SL::getParam($_POST, "save_in_version") == 1) {
				$bNewVersion = false;
				//WF_Utils::saveAsNewVersion($this->Doctype, array("spa" => $sXml, "route" => $sRouteXml), false);
			}
			else {
				$bNewVersion = $this->didSpaChange($DoctypeVersion->getSpaXml(), $sXml);
				//WF_Utils::saveAsNewVersion($this->Doctype, array("spa" => $sXml, "route" => $sRouteXml));
			}
			
			WF_Utils::saveAsNewVersion($this->Doctype, array("spa" => $sXml, "route" => $sRouteXml), $bNewVersion);
		}
		else {
			$Date = new MSF_Date();
			$this->Doctype->setModifiedAt($Date->formatTimestamp());
			WF_Utils::saveAsNewVersion($this->Doctype, array("spa" => $sXml, "route" => $sRouteXml), false);
		}

		$this->Controller->redirect($_SERVER["REQUEST_URI"], $this->Controller->locale("WORKFLOW_SPA_SAVED"));
	}
	
	private function clearRoute($sSpaXml, $sRouteXml)
	{
		$aIds = array();
		foreach (new MSF_XmlWrapper($sSpaXml) as $Data) {
			$aIds[] = $Data->getName();
		}
		
		$Result = new MSF_XmlWrapper();
		foreach (new MSF_XmlWrapper($sRouteXml) as $Data) {
			$aValue 	= $Data->getValue();
			$aDelegate 	= $Data->getValue("delegate");
			$aWait 		= $Data->getValue("wait");
			
			if (!empty($aDelegate)) {
			//	foreach ($aDelegate as $iIndex => $aItem) {
			//		if (isset($aItem["spa_id"]) && !in_array($aItem["spa_id"], $aIds)) {
						//unset($aDelegate[$iIndex]);
			//		}
				//}
				
				$aValue["delegate"] = $aDelegate;
			}
			if (!empty($aWait)) {
				if (!in_array($aWait["spa_id"], $aIds)) {
					$aWait["spa_id"] 	= 0;
					$aWait["type"] 		= 0;
				}
				
				$aValue["wait"] = $aWait;
			}
			
			$Result->set($Data->getName(), $aValue, $Data->getTitle());
		}
		
		return $Result->getXml();
	}
	
	public function view()
	{
		$this->addDoctypeActions($this->Doctype->getDoctypeId());
		$ABox 	= WF_ActionBox::newInstance();
		$View 	= new WF_DoctypeSpaXml();
		$oXw	= new MSF_XmlWrapper($this->Doctype->getCurrentVersion()->getSpaXml());
		$View->view(
			$ABox->getCfg(),
			$oXw,
			$this->Doctype->getCurrentVersion()->getFieldsXml(),
			false,
			$this->Doctype->getCurrentVersion()->getSystemFieldsXml()
		);
		
//debug(MSF_XmlWrapper::xmlToArray($this->Doctype->getCurrentVersion()->getSpaXml()));
		return $View;
	}
	
	private function prepareSpaXml($aResult)
	{
		$aRequest 	= $this->prepareSpaRequest($aResult);
		$oXw 		= new MSF_XmlWrapper();
		foreach ($aRequest AS $sSpaId => $aAction) {
			if (is_array($aAction) && isset($aAction["action"])) {
				$iId	= $this->prepareSpaId($sSpaId);
				$aValue = $this->prepareSpaValue(
						$aAction["action"], 
						MSF_SL::getParam($aAction, "value", array()), 
						$aAction["description"]
						);
				$oXw->set($iId, $aValue, $aAction["title"]);
			}

		}
		return $oXw->getXml();
	}
	
	private function prepareSpaValue($sAction, array $aBody, $sDescription) {
		$aValue 				= array();
		
		$aValue["action"] 		= $sAction;
		$aValue["description"] 	= $sDescription;
		$aValue["value"] 		= $this->escape($aBody);
		return $aValue;

	}
	
	private function prepareSpaRequest($aResult) {
		$aRequest = array();
		foreach ($aResult as $k => $v) {
			if (is_string($aResult[$k])) {
				continue;
			}
			
			if (empty($aResult[$k]["action"])) {
				continue;
			}
			
			$aRequest[$k] = $v;
		}
		
		return $aRequest;
	}
	
	private function prepareSpaId($sSpaId) {
		static $iCounter = 100;
		if (substr_count($sSpaId, "new_action_") > 0) {
			$iSpaId = mt_rand(1000, 9999) . $iCounter;
		}
		else {
			$iSpaId = $sSpaId;
		}
		
		$iCounter++;
		
		return (int)$iSpaId;
	}
	
	private function escape(array $aBody)
	{
		$aResult = array();
		foreach ($aBody AS $sKey => $mValue) {
			if (is_array($mValue)) {
				$aResult[$sKey] = $this->escape($mValue);
			}
			else {
				$aResult[$sKey] = str_replace("&quot;", "\"", $mValue);
			}
				
		}
		return $aResult;
	}
	
	private function didSpaChange($sOldSpa, $sNewSpa)
	{		
		$isChanged = false;				
		$oOldSpa = new MSF_XmlWrapper($sOldSpa);
		$oNewSpa = new MSF_XmlWrapper($sNewSpa);		
		if($oOldSpa->getLength() != $oNewSpa->getLength()) {
			$isChanged = true;
		}
		
		if(!$isChanged) {
			$aOldSpa = $oOldSpa->getAsArray();
			$aNewSpa = $oNewSpa->getAsArray();
			if($aOldSpa != $aNewSpa) {
				$isChanged = true;
			}
			
		}
		
		return $isChanged;		
	}

}

?>