<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "modules/workflow/view/xml/WF_DoctypeVersionsXml.php";
include_once "modules/workflow/view/xml/WF_RouteXml.php";
include_once "modules/workflow/view/xml/WF_DoctypeSpaXml.php";
include_once "modules/workflow/view/xml/WF_FieldsXml.php";
include_once "modules/workflow/view/xml/WF_TemplateXml.php";

class WFC_DoctypeVersions extends WFC_Abstract
{
	public function view($iDoctypeId, $iVersionId)
	{
		$View = null;
		
		if ($iVersionId > 0) {
			$View = $this->showItem($iDoctypeId, $iVersionId);
		}
		else {
			$View = $this->showList($iDoctypeId);
		}
		
		return $View;
	}
	
	private function showList($iDoctypeId)
	{
		$aTypes 	= array("int", "timestamp", "string", "bool");
		$aTitles 	= array(
			"id",
			$this->Controller->locale("WORKFLOW_DOCUMENT_VERSIONS_CREATED_AT"),
			$this->Controller->locale("WORKFLOW_DOCUMENT_VERSIONS_USER"),			
			$this->Controller->locale("WORKFLOW_DOCUMENT_CURRENT_VERSION")
		);
		$aColumns 	= array("doc.doctype_version_id", "doc.created_at", "usr.login",
		"CASE dt.doctype_version_id WHEN doc.doctype_version_id THEN 'да' ELSE 'нет' END AS current_version");
		$aRSColumns = array();
		
		for ($i = 0; $i < (count($aTitles)); $i++) {
			$aRSColumns[$i]["name"] 	= $aColumns[$i];
			$aRSColumns[$i]["title"] 	= $aTitles[$i];
			$aRSColumns[$i]["sort"] 	= ($aTitles[$i] != "Текущая версия") ? true : false;
			$aRSColumns[$i]["filter"] 	= false;
			$aRSColumns[$i]["group"] 	= false;
			$aRSColumns[$i]["type"] 	= $aTypes[$i];
			$aRSColumns[$i]["compare"] 	= "equal";
			$aRSColumns[$i]["visible"] 	= ($aTitles[$i] == "id") ? false : true;
		}

		$Recordset = new MSF_Recordset(MSF_Registry::get("MSF_DB"));
		$Recordset->setTables(array(
			"wf_doctypes_versions AS doc",
			"ref_system_users AS usr
			LEFT JOIN
			wf_doctypes AS dt
			ON
			dt.doctype_id = " . $iDoctypeId
		));
		$Recordset->setConditions(array(
			"AND doc.doctype_id = " . $iDoctypeId,
			"AND usr.id = doc.user_id"
		));
		$Recordset->setBaseURL("/admin/workflow/doctype/versions/" . $iDoctypeId . "/?");
		$Recordset->setColumns($aRSColumns);
		$Recordset->setLink(array(
			"href" 	=> "/admin/workflow/doctype/versions/" . $iDoctypeId,
			"bind" 	=> array("doctype_version_id")
		));
		$Recordset->setActions(array(
			array(
				"title" 	=> $this->Controller->locale("WORKFLOW_ADMIN_LIST_ACTION_OPEN"),
				"href" 		=> "/admin/workflow/doctype/versions/" . $iDoctypeId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/folder_page_white.png",
				"bind" 		=> array("doctype_version_id"),
				"confirm" 	=> false
			),
			array(
				"title" 	=> MSF_Registry::get("MSF_Locale")->getWord("DOCUMENT_VERSION_SET_CURRENT"),
				"href" 		=> "/admin/workflow/setDoctypeVersion/" . $iDoctypeId,
				"image" 	=> "/templates/" . CNF_SKIN . "/images/folder_page_white.png",
				"bind" 		=> array("doctype_version_id"),
				"confirm" 	=> false
			)
		));
		
		$Recordset->setDefaultOrder("doc.created_at");
		$Recordset->setDefaultDirection("desc");
		$View = new WF_DoctypeVersionsXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		$View->buildRecordset($Recordset->getAllRecords());		
		$View->addTemplate("/modules/workflow/view/templates/default/xsl/doctypeVersions.xsl");
		
		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ACTION_CLOSE"),
			"/admin/workflow"
		);
		
		return $View;
	}
	
	private $Version;
	
	private $ABox;
	
	private function showItem($iDoctypeId, $iVersionId)
	{
		$View 			= null;
		$Doctype 		= new WF_Doctype($iDoctypeId);
		$this->Version 	= $Doctype->getVersion($iVersionId);
		$this->ABox 	= WF_ActionBox::newInstance();
		switch ($this->Controller->getParam(3)) {
			case "spa":
				$View = $this->spa();
				break;
			case "route":
				$View = $this->route();
				break;
			case "template":
				$View = $this->template();
				break;
			case "archive":
				$View = $this->archive($iDoctypeId, $iVersionId);
				break;
			default:
				$View = $this->fields();
				break;
		}
		
		$this->addActions($iDoctypeId, $iVersionId);
		return $View;
	}
	
	private function fields()
	{
		$View = new FieldsXml();
		$View->editDoctypeFields($this->Version->getFieldsXml(), true);
				
		return $View;
	}
	
	private function spa()
	{
		$View = new WF_DoctypeSpaXml();
		
		$View->view(
			$this->ABox->getCfg(),
			new MSF_XmlWrapper($this->Version->getSpaXml()),
			$this->Version->getFieldsXml(),
			true,
			$this->Version->getSystemFieldsXml()
		);
		
		return $View;
	}
	
	private function route()
	{
		$View = new WF_RouteXml();
		
		$View->initLinks();
		$View->initRoute($this->Version->getRouteXml());
		$View->initSpaActions(MSF_XmlWrapper::xmlToArray($this->Version->getSpaXml()));
		$View->initRouteActions();
		$View->initAddress($this->Version);
		$View->initFields($this->Version);
		$View->remindSettings();
		$View->formSystemFields($this->Version->getSystemFieldsXml());
		$View->injectAllDoctypes();
		$View->initTemplate(true);
		
		return $View;
	}
	
	private function template()
	{
		$View 	= new WF_TemplateXml();
		$WFVars = new WF_Vars();
		
		$View->view(
			$this->Version->getTemplateXml(),
			$this->Version->getFieldsXml(),
			MSF_Json::encode($WFVars->getList()),
			true
		);
		
		return $View;
	}
	
	private function archive($iDoctypeId, $iVersionId)
	{
		$oArchive = new WFC_ArchiveOptions($this->Controller);
		$View = $oArchive->edit($iDoctypeId, $iVersionId);
		return $View; 
	}
	
	private function addActions($iDoctypeId, $iVesrionId)
	{
		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ADMIN_LIST_ACTION_FIELDS"),
			"/admin/workflow/doctype/versions/" . $iDoctypeId . "/" . $iVesrionId
		);
		
		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ADMIN_MENU_DOCTYPE_SPA"),
			"/admin/workflow/doctype/versions/" . $iDoctypeId . "/" . $iVesrionId . "/spa"
		);
		
		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ADMIN_MENU_DOCTYPE_ROUTE"),
			"/admin/workflow/doctype/versions/" . $iDoctypeId . "/" . $iVesrionId . "/route"
		);

		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ADMIN_MENU_DOCTYPE_TEMPLATE"),
			"/admin/workflow/doctype/versions/" . $iDoctypeId . "/" . $iVesrionId . "/template"
		);
		
		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ADMIN_MENU_DOCTYPE_ARCHIVE"),
			"/admin/workflow/doctype/versions/" . $iDoctypeId . "/" . $iVesrionId . "/archive"
		);
		
		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ACTION_CLOSE"),
			"/admin/workflow/doctype/versions/" . $iDoctypeId
		);
	}
}

?>