<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

include_once "modules/workflow/view/xml/WF_FoldersListXml.php";
include_once "modules/workflow/library/folders/WF_FoldersList.php";
include_once "modules/workflow/library/folders/WF_Folder.php";
include_once "modules/workflow/library/folders/WF_FolderGroup.php";
include_once "modules/workflow/library/folders/WF_FoldersGroupsList.php";
include_once "modules/workflow/library/security/WF_FoldersSecurityManager.php";
include_once "modules/workflow/library/security/WF_AktenplanSecurityManager.php";


class WFC_Folders extends WFC_Abstract
{
	public function index()
	{
		MSF_Registry::get("MSF_ActionBar")->addAction(
			$this->Controller->locale("WORKFLOW_ACTIONBAR_ADD") . " " .
			$this->Controller->locale("WORKFLOW_ACTIONBAR_ADD_FOLDER"),
			"/admin/workflow/folders/add"
		);
		
		
		$View 			= new WF_FoldersListXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		$FoldersList 	= $this->prepareList();

		$View->buildRecordset($FoldersList->getListRecordset());
		$View->addTemplate("/modules/workflow/view/templates/default/xsl/foldersList.xsl");

		$this->Controller->setView($View);
		
		$this->Controller->getTemplate()->setPageTitle(
				$this->Controller->locale("ROOT_ADMIN_MENU") .
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") .
				$this->Controller->locale("WORKFLOW_FOLDERS")
			);
	}
	
	public function ajax()
	{
		$View 			= new WF_FoldersListXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		$FoldersList	= $this->prepareList();
		$View->buildGroup($FoldersList->getGroup());
		$this->Controller->setView($View);
	}
	
	private function prepareList()
	{
		$FoldersList = new WF_FoldersList();
		$FoldersList->setRpcUrl("/admin/workflow/folders/ajaxrequest/?");
		$FoldersList->setBaseUrl("/admin/workflow/folders/?");
		$FoldersList->addAction($this->Controller->locale("WORKFLOW_ADMIN_LIST_ACTION_OPEN"), "/admin/workflow/folders/edit", "/templates/default/images/folder_page_white.png", array("folder_id"));
 		//$FoldersList->addAction($this->Controller->locale("WORKFLOW_ADMIN_MENU_DOCTYPE_COMPARE"), "/admin/workflow/folders/compare", "/templates/default/img/view.gif", array("folder_id"));
 		//$FoldersList->addAction($this->Controller->locale("WORKFLOW_ADMIN_LIST_ACTION_ACCESS"), "/admin/workflow/folders/access", "/templates/default/images/key.png", array("folder_id"));
		$FoldersList->addAction($this->Controller->locale("WORKFLOW_ADMIN_LIST_ACTION_DELETE"), "/admin/workflow/folders/remove", "/templates/default/images/red_cross.png", array("folder_id"), true);
		$FoldersList->setLink(array(
 			"href" 	=> "/admin/workflow/folders/edit",
 			"bind" 	=> array("folder_id")
		));
		
		$FoldersList->setStateParams(array(
			"module"		=> "workflow",
			"action"		=> "folders_admin",
			"action_id"		=> 0,
			"structure_id"	=> MSF_Registry::get("MSF_UserBox")->getCurrentStructureId()
		));
				
		return $FoldersList;
	}

	public function edit()
	{
		try {
			$iFolderId		= $this->Controller->getIntParam(1);
			$Folder			= new WF_Folder(new WF_FolderDB(MSF_Registry::get("MSF_DB")));
			$View			= new WF_FolderXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
			$DoctypeList	= new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));
			$GroupList		= new WF_FoldersGroupsList();
	
			$Folder->load($iFolderId);
			$aConfig	= $Folder->getConfig();
			$aDoctypes 	= array();
			
			if(IS_REQUEST) {
				$aConfig["name"]		= MSF_SL::getParam($_POST, "name", "");
				$aConfig["group_id"]	= (int)MSF_SL::getParam($_POST, "group_id", 0);
				$aConfig["description"]	= MSF_SL::getParam($_POST, "description", "");
				$aConfig["full_description"]	= MSF_SL::getParam($_POST, "fullDescription", "");
				
							
				if (!strlen($aConfig["name"])) {
					$oMessenger		= MSF_Registry::get("MSF_Messenger");
					$oMessenger->addError($this->Controller->locale("WORKFLOW_MESSAGE_EMPTY_TITLE"));
					$aDoctypes = $this->prepareFoldersDoctypes();
					$aDoctypes = $aDoctypes["full"];
				}
				else {
					/*
					if ($Folder->nameExists($aConfig["name"])) {
						MSF_Registry::get("MSF_Messenger")->addError(
							$this->Controller->locale("WORKFLOW_MESSAGE_NAME_DULICATION")
						);
						
					}
					*/
					//debug(str_replace("&gt;&lt;", "&gt;<br/>&lt;", htmlspecialchars($aConfig["compared_xml"])));
					$aDoctypes = $this->prepareFoldersDoctypes();
					$aConfig["compared_xml"]	= $this->clearComparedXml($aConfig["compared_xml"], $aDoctypes["ids"]);
					
					//debug(str_replace("&gt;&lt;", "&gt;<br/>&lt;", htmlspecialchars($aConfig["compared_xml"])));
					
					
					$Folder->setConfig($aConfig);
					
					
					$Folder->removeTriggers();
					$DoctypeList->removeLink($iFolderId);
					$DoctypeList->saveLink($iFolderId, $aDoctypes["ids"]);
					$Folder->save();
					WF_Folder::reindex($iFolderId, $aDoctypes["ids"]);
					$this->Controller->redirect("/admin/workflow/folders/edit/" . $iFolderId, $this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_EDITED"));
				}
				
			}
			else {
				$aDoctypes = $DoctypeList->getLinked($iFolderId);
			}
	
			//$this->addCloseAction();
//			debug($DoctypeList->getLinked($iFolderId));
//                        exit;
                        $aGroupList = $GroupList->getList();

                        for ($i = 0; $i < sizeof($aGroupList); $i++) :
                            $aGroupList[$i]["name"] = MSF_Registry::get("MSF_Locale")->getI18N($aGroupList[$i]["name"]);
                        endfor;
			$View->editFolder($Folder->getConfig(), $aDoctypes, $DoctypeList->getUnlinked(), $aGroupList);
			$View->addTemplate("/modules/workflow/view/templates/default/xsl/editFolder.xsl");
			$this->Controller->setView($View);
			
			$this->buildActionPanel($iFolderId);
			$this->setPageTitle($aConfig["name"], $this->getGroupName($aConfig["group_id"]));
			
			MSF_RteObjectsIntegrator::files($iFolderId, "folders_back");
		}
		catch(WF_DoctypeNotExistedException $e){
			$this->Controller->redirect("/admin/workflow/folders/edit/" . $iFolderId, MSF_Registry::get("MSF_Locale")->getWord("ROOT_404_PAGE_DOCTYPE"));
		}
	}
	
	public function fields()
	{
		$iFolderId		= $this->Controller->getIntParam(1);
		$Folder			= new WF_Folder(new WF_FolderDB(MSF_Registry::get("MSF_DB")));
		$View			= new WF_FolderXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
				
		$Folder->load($iFolderId);
		$aConfig	= $Folder->getConfig();
		//$sOldFields = $aConfig["fields_xml"];
		$sOldFields		= $Folder->prepareRecordsetFields();
		
		if(IS_REQUEST) {
			$aConfig["fields_xml"]	= $this->prepareFolderFields();
			$Folder->setConfig($aConfig);
			
			$Folder->save($this->isRemovedFields($sOldFields, $Folder->prepareRecordsetFields()));

			$this->Controller->redirect("/admin/workflow/folders/fields/" . $iFolderId, $this->Controller->locale("WORKFLOW_FIELDS_SAVED"));
		}
		
		$View->editFolderFields($Folder->getConfig());
		$View->addTemplate("/modules/workflow/view/templates/default/xsl/editFolderFields.xsl");
		$this->Controller->setView($View);
		$this->buildActionPanel($iFolderId);

		$this->setPageTitle($aConfig["name"], $this->getGroupName($aConfig["group_id"]));
	}

	public function add()
	{
		$Folder			= new WF_Folder(new WF_FolderDB(MSF_Registry::get("MSF_DB")));
		$View			= new WF_FolderXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		$DoctypeList	= new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));
		$GroupList		= new WF_FoldersGroupsList();

		$Folder->create();

		if(IS_REQUEST) {
			$aConfig				= array();
			$aConfig["fields_xml"]	= $this->prepareFolderFields();
			$aConfig["name"]		= MSF_SL::getParam($_POST, "name", "");
			$aConfig["group_id"]	= (int)MSF_SL::getParam($_POST, "group_id", 0);
			$aConfig["description"]	= MSF_SL::getParam($_POST, "description", "");
			$aConfig["full_description"]	= MSF_SL::getParam($_POST, "fullDescription", "");

			$Folder->setConfig($aConfig);
			
			if (!strlen($aConfig["name"])) {
				$oMessenger		= MSF_Registry::get("MSF_Messenger");
				$oMessenger->addError($this->Controller->locale("WORKFLOW_MESSAGE_EMPTY_TITLE"));
			}
			else {
				if ($Folder->nameExists($aConfig["name"])) {
					MSF_Registry::get("MSF_Messenger")->addError(
						$this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_NAME_DULICATION")
					);
					
				}
				
				$aDoctypes = $this->prepareFoldersDoctypes();
				$iFolderId = $Folder->save();
				WF_Folder::reindex($iFolderId, $aDoctypes["ids"]);
				$DoctypeList->saveLink($iFolderId, $aDoctypes["ids"]);

				$this->Controller->redirect("/admin/workflow/folders/edit/" . $iFolderId, $this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_CREATED"));
				die();
			}
			
		}
		
		$aDoctypes = $this->prepareFoldersDoctypes();
		$this->addCloseAction();
		$View->editFolder($Folder->getConfig(), $aDoctypes["full"], $DoctypeList->getUnlinked(), $GroupList->getList());
		$View->addTemplate("/modules/workflow/view/templates/default/xsl/editFolder.xsl");
		$this->Controller->setView($View);
		
		$this->Controller->getTemplate()->setPageTitle(
			$this->Controller->locale("ROOT_ADMIN_MENU") .
			$this->Controller->locale("ROOT_TITLE_SEPARATOR") .
			$this->Controller->locale("WORKFLOW_FOLDERS")
		);
	}
	
	public function aktenplan()
	{
		$View			= new WF_FolderXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		$Manager		= new WF_AktenplanSecurityManager(MSF_Registry::get("MSF_DB"), 0);
		
		if(IS_REQUEST) {
			//debug($_POST);
			$aAccess	= (array) MSF_SL::getParam($_POST, "access", array());
			$aToSave	= array();
			$RV			= new REF_Value();
			$iGroup		= 1;
			
			
			foreach($aAccess as $Row) {
				$RV->parse(MSF_SL::getParam($Row, "structure", ""));
				$iCanView	= MSF_SL::getParam($Row, "can_view", 0);
				$aIds		= $RV->getKeysList();
				
				foreach($aIds as $mId) {
					if (is_array($mId)) {
						$mId = $mId[0];
					}
					$tmp	= array(
						"structure_id"	=> $mId,
						"can_view"		=> $iCanView,
						"group_id"		=> $iGroup
					);
					
					array_push($aToSave, $tmp);
				}
				
				$iGroup++;
			}
			
			
			$Manager->edit($aToSave);
			$this->Controller->redirect("/admin/workflow/folders/aktenplan", $this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_EDITED"));
		}
		
		$this->addCloseAction();
		$View->changeAccess($Manager->get());
		$this->Controller->setView($View);
		
		$this->setPageTitle($this->Controller->locale("WORKFLOW_FOLDER_AKTENPLAN"));
		
	}

	public function access()
	{
		$iFolderId		= $this->Controller->getIntParam(1);
		$View			= new WF_FolderXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		$Manager		= new WF_FoldersSecurityManager(MSF_Registry::get("MSF_DB"), $iFolderId);
		
		$Folder			= new WF_Folder(new WF_FolderDB(MSF_Registry::get("MSF_DB")));
		$Folder->load($iFolderId);
		$aConfig	= $Folder->getConfig();
		
		if(IS_REQUEST) {
			//debug($_POST);
			$aAccess	= (array) MSF_SL::getParam($_POST, "access", array());
			$aToSave	= array();
			$RV			= new REF_Value();
			$iGroup		= 1;
			
			
			foreach($aAccess as $Row) {
				$RV->parse(MSF_SL::getParam($Row, "structure", ""));
				$iCanView	= MSF_SL::getParam($Row, "can_view", 0);
				$aIds		= $RV->getKeysList();
				
				foreach($aIds as $mId) {
					if (is_array($mId)) {
						$mId = $mId[0];
					}
					$tmp	= array(
						"structure_id"	=> $mId,
						"can_view"		=> $iCanView,
						"group_id"		=> $iGroup
					);
					
					array_push($aToSave, $tmp);
				}
				
				$iGroup++;
			}
			
			$Manager->edit($aToSave);
			$this->Controller->redirect("/admin/workflow/folders/access/" . $iFolderId, $this->Controller->locale("WORKFLOW_ACCESS_SAVED"));
		}
		
		/*
		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ACTION_ADD"),
			"#"
		);
		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ACTION_CLOSE"),
			"/admin/workflow/folders/edit/" . $iFolderId
		);
		*/
		$this->buildActionPanel($iFolderId);
		$View->changeAccess($Manager->get());
		$this->Controller->setView($View);
		
		$this->setPageTitle($aConfig["name"], $this->getGroupName($aConfig["group_id"]));
	}
	
	public function compare()
	{
		$iFolderId		= $this->Controller->getIntParam(1);
		$Folder			= new WF_Folder(new WF_FolderDB(MSF_Registry::get("MSF_DB")));
		$View			= new WF_FolderXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));
		$DoctypeList	= new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));

		$Folder->load($iFolderId);
		$aConfig	= $Folder->getConfig();
		
		//$SystemFields->
		//echo $SystemFields->__toString();
		
		if(IS_REQUEST) {
			$sCompareXml	= $this->prepareFolderComapareXml();
			
			$aConfig["compared_xml"]	= $sCompareXml;
			$Folder->setConfig($aConfig);
			$Folder->save();
			$Folder->build();
			
			$this->Controller->redirect("/admin/workflow/folders/compare/" . $iFolderId, $this->Controller->locale("WORKFLOW_COMPARE_SAVED"));
		}
		
		$aDoctypes	= $DoctypeList->getLinked($iFolderId);
		$aDoctypes	= $this->prepareDoctypeFieldsXml($aDoctypes);
		
		//echo $aConfig["compared_xml"];
		$View->compare($aConfig["fields_xml"], $aConfig["compared_xml"], $aDoctypes);

		$this->Controller->setView($View);
		$this->buildActionPanel($iFolderId);
		$this->setPageTitle($aConfig["name"], $this->getGroupName($aConfig["group_id"]));
	}

	public function remove()
	{
		$iFolderId		= $this->Controller->getIntParam(1);
		$Folder			= new WF_Folder(new WF_FolderDB(MSF_Registry::get("MSF_DB")));
		$DoctypeList	= new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));

		$Folder->load($iFolderId);
		$Folder->remove();

		$DoctypeList->removeLink($iFolderId);


		$this->Controller->redirect("/admin/workflow/folders/", $this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_REMOVED"));
	}

	private function addCloseAction()
	{
		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ACTION_CLOSE"),
			"/admin/workflow/folders"
		);
	}
	
	private function prepareDoctypeFieldsXml($aDoctypes)
	{
		$aReturn	= array();
		foreach($aDoctypes as $aDoctype) {
			$Settings = new WF_SystemFieldsSettings();
			$Settings->bindPoints($aDoctype["route_xml"]);
			
			
			$PlainFields	= new DOMDocument();
			$PlainFields->loadXML($aDoctype["fields_xml"]);
			
			$SystemFields	= new DOMDocument();
			$SystemFields->loadXML($Settings->__toString());
			
			$Elements	= $SystemFields->getElementsByTagName("element");
			foreach($Elements as $Element) {
				$Import	= $PlainFields->importNode($Element->cloneNode(true), true);
				$PlainFields->documentElement->appendChild($Import);
			}
			
			unset($aDoctype["system_fields_xml"]);
			$aDoctype["fields_xml"]	= $PlainFields->saveHTML();
			array_push($aReturn, $aDoctype);
		}
			
		return $aReturn;
	}
	
	private function prepareFolderFields()
	{
		$aFields	= MSF_SL::getParam($_POST, "fields", array());
		$Root		= new DOMDocument();
		$Document	= $Root->createElement("document");
//		debug($aFields);
//		die();
		$Root->appendChild($Document);
		foreach($aFields as $sName=>$aField) {
			$iVisible	= (int) MSF_SL::getParam($aField, "visible", 0);
			$iGroup		= (int) MSF_SL::getParam($aField, "group", 0);
			$iStatic	= (int) MSF_SL::getParam($aField, "static", 0);
			
			$sTitle		= MSF_SL::getParam($aField, "title");
			$sType		= MSF_SL::getParam($aField, "type");
			$sColumn	= MSF_SL::getParam($aField, "column", "");	
                        $sVisibleOnLocale = MSF_SL::getParam($aField, "visible_on_locale", "both");
                        
			if($sType == "notChoose") {
				continue;
			}
			
						
			if($iStatic	== 1) {
				switch($sColumn) {
					case "employee_name"		:
					case "registration_number"	:
					case "doctype"				:
					case "subdivision"			:
					case "status"				:
						$sType	= "string";
						break;
					case "modified_at"			:
						$sType	= "timestamp";
						break;
					case "created_at"			:
						$sType	= "date";
						break;
					default						:
						$sType	= "string";
				}
				
			}
			
			if(strstr($sName, "new_element")) {
				if($iStatic	== 1) {
					$sName	= $sColumn;
				}
				else {
					$sName	= "field_" . MSF_String::hash(microtime(), 10);
				}
								
			}
			else {
				$sName	= MSF_String::addslashes($sName);
			}

			$Element	= $Root->createElement("element");
			$Document->appendChild($Element);

			$Element->setAttribute("name", $sName);
			$Element->setAttribute("title", $sTitle);
			$Element->setAttribute("type", "array");

			$Type	= $Root->createElement("item");
			$Type->setAttribute("name", "type");
			$Type->setAttribute("type", "string");
			$Type->setAttribute("value", $sType);
			
			$Column	= $Root->createElement("item");
			$Column->setAttribute("name", "column");
			$Column->setAttribute("type", "string");
			$Column->setAttribute("value", $sColumn);

			$Visible	= $Root->createElement("item");
			$Visible->setAttribute("name", "visible");
			$Visible->setAttribute("type", "int");
			$Visible->setAttribute("value", $iVisible);

			$Group	= $Root->createElement("item");
			$Group->setAttribute("name", "group");
			$Group->setAttribute("type", "int");
			$Group->setAttribute("value", $iGroup);
			
			$Static	= $Root->createElement("item");
			$Static->setAttribute("name", "static");
			$Static->setAttribute("type", "int");
			$Static->setAttribute("value", $iStatic);
                        
                        $VisibleOnLocale = $Root->createElement("item");
                        $VisibleOnLocale->setAttribute("name", "visible_on_locale");
                        $VisibleOnLocale->setAttribute("type", "string");
                        $VisibleOnLocale->setAttribute("value", $sVisibleOnLocale);



			$Element->appendChild($Type);
			$Element->appendChild($Column);
			$Element->appendChild($Visible);
			$Element->appendChild($Group);
			$Element->appendChild($Static);
			$Element->appendChild($VisibleOnLocale);
		}
		
		return $Root->saveHTML();
	}

	private function prepareFoldersDoctypes()
	{
		$aDoctypes	= MSF_SL::getParam($_POST, "doctypes", array());
		$aFull		= array();
		$aIds 		= array();
		foreach($aDoctypes as $iId) {
			$Doctype 	= new WF_Doctype($iId);
			$aTmp 		= array();
			$aTmp["doctype_id"] = $iId;
			$aTmp["title"] 		= $Doctype->getTitle();
			$aFull[] 			= $aTmp;
			$aIds[] 			= $iId;
		}
		return array("full" => $aFull, "ids" => $aIds);
	}

	private function prepareFolderComapareXml()
	{
		$aCompare	= array();
		$aTypes		= array();
		
		foreach($_POST as $sKey=>$aValue) {
			if($sKey == "btn" || $sKey == "is_request") {
				continue;
			}

			$aTmp	= split("::", $sKey);
			//debug($aTmp);

			$sField	= $aValue[0];
			$sField	= split("::", $sField);
			$sField	= $sField[0];

			if(!isset($aCompare[$sField])) {
				$aCompare[$sField] 	= array();
			}

			$aCompare[$sField][$aTmp[2]]	= $aTmp[1];
			$aTypes[$aTmp[1]] = str_replace("fields_", "", $aTmp[0]);
		}

		//Example:
		//<document>
		// 	<element name="field_e1fb95827e" type="array">
		//		<item name="field0" type="array">
		//			<item name="doctype_id" type="int" value="603" /> 
		//			<item name="name" type="string" value="field_d729f3e278" /> 
		//			<item name="type" type="string" value="string" /> 
		//		</item>
		//	</element>
		//</document>
		$Root = new DOMDocument();

		$Document = $Root->createElement("document");
		$Root->appendChild($Document);

		foreach($aCompare as $sKey=>$aValue) {
			$Element	= $Root->createElement("element");
			$Element->setAttribute("name", $sKey);
			$Element->setAttribute("type", "array");
			$Document->appendChild($Element);

			$i	= 0;
			foreach($aValue as $iDoctypeId=>$sFieldName) {
				$Field	= $Root->createElement("item");
				$Field->setAttribute("name", "field" . $i);
				$Field->setAttribute("type", "array");
				$Element->appendChild($Field);

				$DoctypeId	= $Root->createElement("item");
				$DoctypeId->setAttribute("name", "doctype_id");
				$DoctypeId->setAttribute("type", "int");
				$DoctypeId->setAttribute("value", $iDoctypeId);
				$Field->appendChild($DoctypeId);

				$Name	= $Root->createElement("item");
				$Name->setAttribute("name", "name");
				$Name->setAttribute("type", "string");
				$Name->setAttribute("value", $sFieldName);
				$Field->appendChild($Name);
				
				$Type	= $Root->createElement("item");
				$Type->setAttribute("name", "type");
				$Type->setAttribute("type", "string");
				$Type->setAttribute("value", $aTypes[$sFieldName]);
				$Field->appendChild($Type);
				$i++;
			}

		}

		//echo htmlspecialchars($Root->saveHTML());
		//exit();
		return $Root->saveHTML();
	}

	private function prepareDoctypeFields($aDoctypes)
	{
		
		/*
		 *
		 * 	employee_name
			registration_number
			created_at
			modified_at
			doctype
			subdivision
			status
		 *
		 */
		
		$aSpecialFields	= array(
			array(
				"name"	=> "employee_name",
				"type"	=> "string",
				"title"	=> "Автор"
			),
			array(
				"name"	=> "registration_number",
				"type"	=> "string",
				"title"	=> "Регистрационный номер"
			),
			array(
				"name"	=> "created_at",
				"type"	=> "date",
				"title"	=> "Дата создания"
			),
			array(
				"name"	=> "modified_at",
				"type"	=> "date",
				"title"	=> "Дата модификации"
			),
			array(
				"name"	=> "doctype",
				"type"	=> "string",
				"title"	=> "Тип"
			),
			array(
				"name"	=> "subdivision",
				"type"	=> "string",
				"title"	=> "Подразделение"
			),
			array(
				"name"	=> "status",
				"type"	=> "string",
				"title"	=> "Статус"
			)
		);
		
		/*
		 * <element title="Подписывающий" name="field_b7a6507d64" type="array">
				<item name="type" type="text" value="structure"/>
				<item name="required" type="text" value="0"/>
				<item name="defaultValue" type="array">
					<item name="0" type="text" value="0"/>
				</item>
			</element>
		*/
		
		//$aSpecialFields	= array();
		
		/*
		foreach($aDoctypes as &$aDoctype) {
			//echo $aDoctype["fields_xml"];
			$Document	= new DOMDocument();
			$Document->loadXML($aDoctype["fields_xml"]);
			
			$Parent		= $Document->childNodes->item(0);
			
			foreach($aSpecialFields as $aField) {
				$Element	= $Document->createElement("element");
				$Parent->insertBefore($Element, $Parent->childNodes->item(0));
				
				$Element->setAttribute("title", $aField["title"]);
				$Element->setAttribute("name", $aField["name"]);
				$Element->setAttribute("type", "array");
				
				$Item	= $Document->createElement("item");
				$Element->appendChild($Item);
				$Item->setAttribute("name", "type");
				$Item->setAttribute("type", "text");
				$Item->setAttribute("value", $aField["type"]);

				$Item	= $Document->createElement("item");
				$Element->appendChild($Item);
				$Item->setAttribute("name", "title");
				$Item->setAttribute("type", "text");
				$Item->setAttribute("value", $aField["title"]);
			}
						
			
			$aDoctype["fields_xml"]	= str_replace("<?xml version=\"1.0\"?>", "", $Document->saveXML());
		}
		*/
		return $aDoctypes;
	}
	
	private function buildActionPanel($iId)
	{
		$AB	= MSF_Registry::get("MSF_ActionBar");
		
		$AB->addAction(
			$this->Controller->locale("WORKFLOW_ACTIONBAR_MAIN"),
			"/admin/workflow/folders/edit/" . $iId . "/",
			""
		);
		
		$AB->addAction(
			$this->Controller->locale("WORKFLOW_ACTIONBAR_FIELDS"),
			"/admin/workflow/folders/fields/" . $iId . "/",
			""
		);
		
		$AB->addAction(
			$this->Controller->locale("WORKFLOW_ACTIONBAR_FIELDS_COMPARE"),
			"/admin/workflow/folders/compare/" . $iId . "/",
			""
		);
		
		$AB->addAction(
			$this->Controller->locale("WORKFLOW_ADMIN_LIST_ACTION_ACCESS"),
			"/admin/workflow/folders/access/" . $iId . "/",
			""
		);
		
		$AB->addAction(
			$this->Controller->locale("WORKFLOW_ACTION_CLOSE"),
			"/admin/workflow/folders/",
			""
		);
		
		$AB->addAction(
			$this->Controller->locale("WORKFLOW_ACCESS_CAN_VIEW"),
			"/workflow/folders/" . $iId,
			"",
			"",
			false,
			"right"
		);
		
	}
	
	private function getGroupName($iId)
	{
		$sName = "";
		
		if ((int) $iId > 0) {
			$Group 	= new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));
			$Group->load($iId);
			$aGroup = $Group->getConfig();
			
			if (!empty($aGroup["name"])) {
				$sName = $aGroup["name"];
			}
		}
		
		return $sName;
	}
	
	private function setPageTitle($sName, $sGroupName = "")
	{
                $sGroupName = MSF_Registry::get("MSF_Locale")->getI18N($sGroupName);
		if (!empty($sGroupName)) {
			$sGroupName .= $this->Controller->locale("ROOT_TITLE_SEPARATOR");
		}
		
		$this->Controller->getTemplate()->setPageTitle(
				$this->Controller->locale("ROOT_ADMIN_MENU") .
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") .
				$this->Controller->locale("WORKFLOW_FOLDERS") .
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") .
				$sGroupName .
				MSF_Registry::get("MSF_Locale")->getI18N($sName)
			);
	}
	
	private function isRemovedFields(array $aOldFields, array $aNewFields)
	{
		$bResult	= false;
		$aOld		= $this->getFieldsList($aOldFields);
		$aNew		= $this->getFieldsList($aNewFields);
		
		foreach($aOld as $sField) {
			if(!in_array($sField, $aNew)) {
				$bResult	= true;
				break;
			}
			
		}
				
		return $bResult;
	}
	
	private function getFieldsList(array $aFields)
	{
		$aReturn	= array();
		foreach($aFields as $aField) {
			array_push($aReturn, $aField["name"]);
		}
		
		return $aReturn;
	}
	
	private function clearComparedXml($sXml, $aDoctypes)
	{
		$OldFields	= new MSF_XmlWrapper($sXml);
		$NewFields	= new MSF_XmlWrapper();
		
		foreach($OldFields as $OldField) {
			//debug($OldField->getName());
			$sName	= $OldField->getName();
			$aTmp	= array();
			$iCount	= 0;
			
			foreach($OldField->getValue() as $aField) {
				if(in_array($aField["doctype_id"], $aDoctypes)) {
					$aTmp["field" + $iCount]	= $aField;
					$iCount++;
				}
			}
			
			if(count($aTmp)) {
				$NewFields->set($sName, $aTmp);
			}
			
		}
		
		return $NewFields->getXml();
	}
}
?>