<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}


class WFC_FoldersGroups extends WFC_Abstract
{
	public function index()
	{
		MSF_Registry::get("MSF_ActionBar")->addAction(
			$this->Controller->locale("WORKFLOW_ACTIONBAR_ADD") . " " .
			$this->Controller->locale("WORKFLOW_ACTIONBAR_ADD_GROUP"),
			"/admin/workflow/folders_groups/add"
		);
		
		$GroupList	= new WF_FoldersGroupsList();
		$View		= new WF_FoldersGroupsListXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));

		$GroupList->setBaseUrl("/admin/workflow/folders_groups/?");
		$GroupList->addAction($this->Controller->locale("WORKFLOW_ADMIN_LIST_ACTION_OPEN"), "/admin/workflow/folders_groups/edit", "/templates/default/images/folder_page_white.png", array("group_id"));
		$GroupList->addAction($this->Controller->locale("WORKFLOW_ADMIN_LIST_ACTION_DELETE"), "/admin/workflow/folders_groups/remove", "/templates/default/images/red_cross.png", array("group_id"), true);
		$GroupList->setLink(array(
			"href" 	=> "/admin/workflow/folders_groups/edit",
			"bind" 	=> array("group_id")
		));
		
		$View->buildRecordset($GroupList->getListRecordset());
		$View->addTemplate("/modules/workflow/view/templates/default/xsl/foldersGroupsList.xsl");

		$this->Controller->setView($View);
		
		$this->Controller->getTemplate()->setPageTitle(				
				$this->Controller->locale("ROOT_ADMIN_MENU") .
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") . 
				$this->Controller->locale("WORKFLOW_FOLDERS_GROUPS")	
			);
	}

	public function edit()
	{
		$iId			= $this->Controller->getIntParam(1);
		$FolderGroup	= new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));
		$View			= new WF_FolderGroupXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));

		$FolderGroup->load($iId);
		$aConfig	= $FolderGroup->getConfig();
	
		if(IS_REQUEST) {			
			$aConfig["name"]		= MSF_SL::getParam($_POST, "name");
			$aConfig["description"]	= MSF_SL::getParam($_POST, "description");
			$FolderGroup->setConfig($aConfig);
			$iId	= $FolderGroup->save();
			/*
			if ($FolderGroup->nameExists($aConfig["name"])) {
				MSF_Registry::get("MSF_Messenger")->addError(
					$this->Controller->locale("WORKFLOW_MESSAGE_NAME_DULICATION")
				);
				
			}
			*/
			
			$this->Controller->redirect("/admin/workflow/folders_groups/edit/" . $iId . "/", $this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_GROUP_SAVED"));
		}
		else {
			$View->edit($FolderGroup->getConfig());
			$this->Controller->setView($View);
		}
		
		$this->addCloseAction();
		$this->Controller->getTemplate()->setPageTitle(				
				$this->Controller->locale("ROOT_ADMIN_MENU") .
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") . 
				$this->Controller->locale("WORKFLOW_FOLDERS_GROUPS")	.
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") . 
				MSF_Registry::get("MSF_Locale")->getI18N($aConfig["name"])			
			);
	}

	public function add()
	{
		$FolderGroup	= new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));
		$View			= new WF_FolderGroupXml(MSF_Registry::get("MSF_Template"), MSF_Registry::get("MSF_Locale"));

		$FolderGroup->create();
		if(IS_REQUEST) {
			$aConfig				= array();
			$aConfig["name"]		= MSF_SL::getParam($_POST, "name");
			$aConfig["description"]	= MSF_SL::getParam($_POST, "description");
			if (strlen($aConfig["name"])) {
				if ($FolderGroup->nameExists($aConfig["name"])) {
					MSF_Registry::get("MSF_Messenger")->addError(
						$this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_GROUP_NAME_DULICATION")
					);
					
				}
				
				$FolderGroup->setConfig($aConfig);
				$FolderGroup->save();
				$this->Controller->redirect(
						"/admin/workflow/folders_groups/",
						$this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_GROUP_CREATED")
						);
			}
			else {
				MSF_Registry::get("MSF_Messenger")->addError(
						$this->Controller->locale("WORKFLOW_MESSAGE_EMPTY_TITLE")
						);
				$View->edit($aConfig);
				$this->Controller->setView($View);
			}
			
		}
		else {
			$View->edit($FolderGroup->getConfig());
			$this->Controller->setView($View);
		}
		
		$this->addCloseAction();
		
		$this->Controller->getTemplate()->setPageTitle(				
				$this->Controller->locale("ROOT_ADMIN_MENU") .
				$this->Controller->locale("ROOT_TITLE_SEPARATOR") . 
				$this->Controller->locale("WORKFLOW_FOLDERS_GROUPS")	
			);
	}

	public function remove()
	{
		$iId			= $this->Controller->getIntParam(1);
		$FolderGroup	= new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));


		$FolderGroup->load($iId);
		$FolderGroup->remove();

		$this->Controller->redirect("/admin/workflow/folders_groups/", $this->Controller->locale("WORKFLOW_MESSAGE_FOLDER_GROUP_REMOVED"));
	}

	private function addCloseAction()
	{
		$this->Controller->addAction(
			$this->Controller->locale("WORKFLOW_ACTION_CLOSE"),
			"/admin/workflow/folders_groups"
		);
	}
}
?>