<?php

include_once 'modules/workflow/library/actions/WF_DocFacade.php';
include_once 'modules/workflow/library/actions/WF_ExecutionContext.php';
include_once 'modules/workflow/library/doctype/WF_Doctype.php';
include_once "modules/workflow/library/actions/WF_ActionBox.php";

class WF_DocumentServer
{
    protected $oServer;
    protected $oDb;
    protected $sNewDocAuthor;
    
    public function __construct($sAuthor)
    {
        $this->oServer = new SoapServer(null, array('uri'=>'http://'.$_SERVER['HTTP_HOST'].'/'));
        $this->oDb = MSF_Registry::get('MSF_DB');
        $this->sNewDocAuthor = $sAuthor;
    }
    
    public function handle()
    {
        $this->oServer->setObject($this);
        // $request = file_get_contents('php://input'); file_put_contents('/usr/hosting/tmp/raw_data.dat', $request); $this->oServer->handle($request);
        $this->oServer->handle();
    }
    
    public function __call($method, $args)
    {
        list($sAction, $noneedit, $iDocTypeId) = explode('_', $method);
        $sAction = mb_strtolower($sAction);
        
        $iDocTypeId = intval($iDocTypeId);
        
        $result = '-1';
        
        switch($sAction)
        {
            case 'создать':
                $result = $this->createDocumentHandler($iDocTypeId, $args);
                break;
            case 'записать':
                $result = $this->updateDocumentHandler($iDocTypeId, $args);
                break;
            case 'переместить':
                $result = $this->moveDocumentHandler($iDocTypeId, $args);
                break;
        }
        
        return $result;
    }
    
    /**
     *  @return integer -1 on error or > 0 OK
     */
    protected function createDocumentHandler($oDocTypeId, $args)
    {
        $iResult = '-1';
        
        $aFieldsData = array();
        $this->oDb->executeQuery('SELECT fields_xml FROM wf_doctypes WHERE doctype_id = '.$oDocTypeId);
        $go = $this->oDb->fetchArray();
        $xml = new SimpleXMLElement($go['fields_xml']);
        
        foreach($xml->element as $el)
        {
            $attrs = $el->attributes();
            $aFieldsData[strval($attrs->name)] = current($args);
            next($args);
        }
        
        $oDt = new WF_Doctype($oDocTypeId);
        $oDoc = $oDt->newDocument();
        $oDoc->setStructureId($this->sNewDocAuthor);
        $oDv = $oDoc->getCurrentVersion();
	$Date = new MSF_Date();
	$oDv->setSystemField("created_at", $Date->formatTimestamp());
	$oDv->setSystemField("modified_at", $Date->formatTimestamp());
        $oDv->setStructureId($this->sNewDocAuthor);
        $oDv->setFields($aFieldsData);
        $oDv->save();
        $iResult = $oDv->getDocumentId();
//        if(is_numeric($iResult) && $iResult > 0)
//    	    $this->oDb->executeQuery('UPDATE wf_documents SET structure_id = 146 WHERE document_id = '.$iResult);
        $oDocFacade = new WF_DocFacade();
        $oDocFacade->initContextExecution($oDv->getDocument());
        
        
        return $iResult;
    }
    
    /**
     *  @return integer -1 on error or > 0 OK
     */
    protected function updateDocumentHandler($oDocTypeId, $args)
    {
        reset($args);
        $iDocumentId = current($args);
        
        $aFieldsData = array();
        $this->oDb->executeQuery('SELECT fields_xml FROM wf_doctypes WHERE doctype_id = '.$oDocTypeId);
        $go = $this->oDb->fetchArray();
        $xml = new SimpleXMLElement($go['fields_xml']);
        
        foreach($xml->element as $el)
        {
            $attrs = $el->attributes();
            $aFieldsData[strval($attrs->name)] = next($args);
        }
        
        try {
            $oDt = new WF_Doctype($oDocTypeId);
            $oDv = $oDt->getDocument($iDocumentId)->newVersion();
            $oDv->setFields($aFieldsData);
            $oDv->save();
            
            $oDocFacade = new WF_DocFacade();
            $oDocFacade->initContextExecution($oDv->getDocument());
        }
        catch(Exception $e)
        {
            return '-1';
        }
        
        return '1';
    }
    
    /**
     *  @return integer -1 on error or > 0 OK
     */
    protected function moveDocumentHandler($oDocTypeId, $args)
    {
        
        reset($args);
        $iDocumentId = intval(current($args));
        $iStep       = intval(next($args));
        
        if($iStep == 0)
            return '-1';
        
        try {
            $Ab = WF_ActionBox::newInstance();
            $Ab->loadAction('view', 0, $iDocumentId, 0, true);
            $Ab->getAction()->call("move", array("iNewPoint" => $iStep), "call", true, 0, $iDocumentId);
        }
        catch(Exception $e) {
            return '-1';
        }
        
        return '1';
    }
}

?>