<?php

class WF_GetFieldsWS {
	
	public static function service($iDoctypeId) {
		
		$oObj = new self ( );
		$aFileds = $oObj->getFields ($iDoctypeId);
		return $aFileds;
	}
	
	public function getFields($iDoctypeId) {
		
		//MSF_Registry::set ( "MSF_Settings", $oSettings );
		
		try {
			$oDoctype = new WF_Doctype ( $iDoctypeId );
		} catch ( Exception $oException ) {
			$oDoctype = NULL;
		}
		
		if ($oDoctype != NULL) {
			$oXmlWrapper = new MSF_XmlWrapper ( );
			$sXML = $oDoctype->getFieldsXml ();
			$aXML = $oXmlWrapper->xmlToArray ( $sXML );
			
			$aFileds = array ();
			
			foreach ( $aXML as $Key => $Value ) {
				$sName = $Value ["title"];
				$sType = $Value ["value"] ["type"];
				
				$aFileds[] = array(
					"name" => $sName,
					"type" => $sType
				);			
			}
			
			return $aFileds;
		} 
		
		else {
			return false;
		}
		
	}
	
	public static function test() {
		DEFINE ( '__MSF', true );
		DEFINE ( 'CNF_ABS_PATH', 'D:/projects/msf.lcl/wwwroot' );
		set_include_path ( get_include_path () . PATH_SEPARATOR . CNF_ABS_PATH );
		
		include_once "system/utils/MSF_Date.php";
		include_once "system/utils/MSF_String.php";
		include_once "system/MSF_ThrowableException.php";
		
		include_once "system/utils/MSF_XmlWrapper.php";
		include_once "modules/references/library/Reference/UserReference.php";
		include_once "system/MSF_Template.php";
		include_once "system/MSF_Settings.php";
		include_once "system/MSF_IOException.php";
		include_once "system/utils/MSF_File.php";
		include_once "system/mvc/MSF_ModelDBSupport.php";
		include_once "library/MSF_DBTree/MSF_DBTree.php";
		include_once "msfx/userbox/library/MSF_UserBox.php";
		
		include_once "system/MSF_Locale.php";
		include_once "system/utils/MSF_DB.php";
		include_once "system/MSF_Registry.php";
		include_once "system/utils/MSF_DBRecord.php";
		include_once "modules/workflow/library/common/WF_Exception.php";
		include_once "modules/workflow/library/doctype/WF_Doctype.php";
		
		$oDb = new MSF_DB ( );
		$oDb->connect ( 'server', 'manuscript', 'detrix', '1', 'manuscript' );
		MSF_Registry::set ( "MSF_DB", $oDb );
		MSF_Registry::set ( "MSF_Locale", new MSF_Locale ( 'cs/languages/russian.ini' ) );
		MSF_Registry::set ( "MSF_UserBox", MSF_UserBox::getInstance () );
		MSF_Registry::set ( "MSF_Template", new MSF_Template ( ) );
		$sContent = MSF_File::read ( CNF_ABS_PATH . '/settings.xml' );
		$oSettings = MSF_Settings::getInstance ( $sContent );
		MSF_Registry::set ( "MSF_Settings", $oSettings );
		
		$oObj = new self ( );
		$result = $oObj->getFields ( 760 );
		
		echo "<pre>";
		print_r ( $result );
		echo "</pre>";
	}

}

?>