<?php

class WF_LotusDocumentServer
{
    protected $oServer;
    protected $oDb;
    protected $sExportDir = '';
    protected $sFSCharset = '';
    
    public function __construct($exportDir, $charset)
    {
        $this->oServer = new SoapServer(null, array('uri'=>'http://'.$_SERVER['HTTP_HOST'].'/'));
        $this->oDb = MSF_Registry::get('MSF_DB');
        $this->sExportDir = $exportDir;
        $this->sFSCharset = $charset;
    }
    
    public function handle()
    {
        $this->oServer->setObject($this);
        //$request = file_get_contents('php://input'); file_put_contents('/var/www/lotus/test/raw_data.dat', $request); $this->oServer->handle($request);
        $this->oServer->handle();
    }
    
    public function __call($method, $args)
    {
        $dir  = date('YmdHis');
        $dir .= 'x'.sprintf('%08x',mt_rand());
        $size = sizeof($args);
        
        reset($args);
        $att = current($args);
        
        $result = '<?xml version="1.0" encoding="UTF-8"?><document items="'.sizeof($args).'">'."\n";
        
        for($i = 1; $i < sizeof($args); $i++)
        {
            $result .= '<item>'.$args[$i].'</item>'."\n";
        }
        
        if(trim($att))
        {
            $attachments = explode('^file^', $att);
            if(sizeof($attachments) > 0)
            {
                if(!file_exists($this->sExportDir.'/'.$dir))
                    @mkdir($this->sExportDir.'/'.$dir, 0777);
                
                $iter = 1;
                foreach($attachments as $b64file)
                {
                    list($sFileName, $b64content) = explode('^name^', $b64file);
                    @mkdir($this->sExportDir.'/'.$dir.'/'.$iter, 0777);
                    $result .= '<attach>'.$dir.'/'.$iter.'/'.$sFileName.'</attach>';
                    if($this->sFSCharset != 'UTF-8')
                        $sFileName = iconv('UTF-8', $this->sFSCharset, $sFileName);
                    $file_content = base64_decode($b64content);
                    file_put_contents($this->sExportDir.'/'.$dir.'/'.$iter.'/'.$sFileName, $file_content);
                    @chmod($this->sExportDir.'/'.$dir.'/'.$iter.'/'.$sFileName, 0777);
                    $iter++;
                }
            }
        }
        
        $result .= '</document>';
        file_put_contents($this->sExportDir.'/'.$dir.'.xml', $result);
        @chmod($this->sExportDir.'/'.$dir.'.xml', 0777);
    }
}

?>
