<?php
include_once "modules/workflow/library/actions/WF_DocFacade.php";
include_once "modules/workflow/library/actions/WF_ExecutionContext.php";

class WF_MoveDocumentWS
{
	public static function service($iDocID, $iStep)
	{
		$oObj = new self;
		$iPointID = $oObj->moveDocument($iDocID, $iStep);
		return $iPointID;
	}
	
	public function moveDocument($iDocID, $iStep)
	{
		MSF_Registry::set ( "MSF_UserBox", MSF_UserBox::getInstance () );
		
		$oDocFacade = new WF_DocFacade();
		$oXmlWrapper = new MSF_XmlWrapper();
		$oDocument = $oDocFacade->getDocumentById($iDocID);		
		$sXml	= $oDocument->getDoctypeVersion()->getRouteXml();
		$aXml	= $oXmlWrapper->xmlToArray($sXml);		
		$CurrentPintId = $oDocument->getPointId();
		$iPointId = $CurrentPintId + $iStep;		
		
		if($iPointId >= 0 && $iPointId < count($aXml) && $oDocument != NULL)
		{
			$oDocument->setPointId($iPointId);
			$oDv = $oDocument->getCurrentVersion();
			$oDv->setSystemField('status', $aXml[$iPointId]['title']);
			$oDv->save();
			$oDocument->save();
			$oDocFacade->initContextExecution($oDocument);
			
			return $iPointId;
		}
		
		else
		{
			return -1;
		}
				
	}
	
	public static function test()
	{
		DEFINE('__MSF', true);
		DEFINE('CNF_ABS_PATH', 'D:/projects/msf.lcl/wwwroot');
		set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);
		
		include_once "system/MSF_ThrowableException.php";
		include_once "system/utils/MSF_XmlWrapper.php";
		include_once "modules/references/library/Reference/REF_Value.php";
		include_once "system/utils/MSF_Date.php";
		include_once "system/MSF_Locale.php";
		include_once "system/utils/MSF_DB.php";
		include_once "system/utils/MSF_DBRecord.php";
		include_once "modules/references/library/Reference/UserReference.php";
		include_once "system/MSF_Template.php";
		include_once "msfx/userbox/library/MSF_UserBox.php";
		include_once "system/MSF_Registry.php";
		include_once "modules/workflow/library/common/WF_Exception.php";
		include_once "system/utils/MSF_SL.php";
		include_once "system/MSF_Settings.php";
		include_once "modules/workflow/library/actions/WF_DocFacade.php";
		include_once "system/MSF_IOException.php";
		include_once "system/utils/MSF_File.php";
		include_once "modules/workflow/library/actions/WF_ExecutionContext.php";
		
		$oDb = new MSF_DB();
		$oDb->connect('server', 'manuscript', 'detrix', '1', 'manuscript');
		MSF_Registry::set("MSF_DB", $oDb);
		MSF_Registry::set("MSF_Locale", new MSF_Locale('cs/languages/russian.ini'));
		MSF_Registry::set("MSF_UserBox", MSF_UserBox::getInstance());
		MSF_Registry::set("MSF_Template", new MSF_Template());
		$sContent  = MSF_File::read(CNF_ABS_PATH . '/settings.xml');
		$oSettings = MSF_Settings::getInstance($sContent);
		MSF_Registry::set("MSF_Settings", $oSettings);
		
		$oObj = new self;		
		
		echo "<pre>";
		var_dump($oObj->moveDocument(8700,-1));
		echo "</pre>";		
		
	}
}

?>