<?php

include_once "modules/structure/library/Struct_StructureIdSeeker.php";
include_once "modules/1cv81/library/V81_Base64FilesSaver.php";
include_once "msfx/messenger/library/MSF_Messenger.php";


class WF_SlowCreateDocumentWS {
	
	public static function service($iDoctypeId, $aFields, $aWorker)
	{
		$oObj = new self ();
		$iDocumentId = $oObj->slowCreateDocument($iDoctypeId, $aFields, $aWorker);
		return $iDocumentId;		
	}
	
	public function slowCreateDocument($iDoctypeId, $aFields, $aWorker)
	{
		
		$oSeeker = new Struct_StructureIdSeeker();
		$iStructureId = $oSeeker->seek($aWorker["post"], $aWorker["subdiv"], $aWorker["name"]);
		if($iStructureId != -1) {						
			MSF_Registry::set("MSF_UserBox", MSF_UserBox::getInstance());					
			$oDoctype 			= new WF_Doctype($iDoctypeId);
			$Date 				= new MSF_Date();
			$RefValue 			= new REF_Value();
			$oStructureFacade	= MSF_OrgStructureFacade::getInstance();
			$oUserBox 			= MSF_Registry::get("MSF_UserBox");			
			$oDocument			= $oDoctype->newDocument();
			$oMediaId  			= new WF_MediaId();										
			$iUserId  			= $oMediaId->get();									
			$oDocument->setStructureId($iStructureId);
			$oDocument->setMediaId($iUserId);
			$oDoctypeVersion	= $oDocument->getDoctypeVersion();		
			$oDocumentVersion	= $oDocument->getCurrentVersion();		
			$aPhysFields 		= array();
			$aDocFields 		= $oDocumentVersion->getFieldsAsList();		
			$sEmployeeName		= $oStructureFacade->getEmployeeNameByStructureId($iStructureId);					
			$RefValue->add($iStructureId, $sEmployeeName);
			$sAuthorName = $RefValue->format();
			$RefValue = new REF_Value();
			$RefValue->add(
					$oUserBox->getStructureAttribute("subdivision_id"),
					$oUserBox->getStructureAttribute("subdivision")
					);						
			$sSubdivision = $RefValue->format();
			$oDocumentVersion->setSystemField("author_name", $sAuthorName);
			$oDocumentVersion->setSystemField("subdivision", $sSubdivision);
			$Date = new MSF_Date();
			$oDocumentVersion->setSystemField("created_at", $Date->formatTimestamp());
			$oDocumentVersion->setSystemField("modified_at", $Date->formatTimestamp());
			$oDocumentVersion->setSystemField("doctype", $oDoctype->getTitle());
			$aRoute = MSF_XmlWrapper::xmlToArray($oDoctypeVersion->getRouteXml());
			if (isset($aRoute[0])) {
				$oDocumentVersion->setSystemField("status", $aRoute[0]["title"]);
			}
	
			$oDocumentVersion->setStructureId($iStructureId);
			$oDocumentVersion->setEmployeeName($sEmployeeName);
			$oDocumentVersion->setCreatedAt($Date->format());			
			foreach ($aDocFields as $docKey => $docValue) {
				for($i = 0; $i < count($aFields); $i++) {
					if($aFields[$i]["name"] == $docValue["title"]) {
						$sName = $docValue["name"];
						if($docValue["type"] == "reference") {							
							$aRef = preg_split('/,/', $aFields[$i]["value"]);
							if(isset($docValue["optional"]["columns"])) {
								$aPhysFields[$sName] = $oSeeker->makeRefValue($aRef[0],
								 $docValue["optional"]["columns"], ", ", $aRef[1]);						
							}
							else {
								$aPhysFields[$sName] = "";													 					
							}
						}
						else if($docValue["type"] == "file" || $docValue["type"] == "picture") {							
							$oFileSaver = new V81_Base64FilesSaver();
							$sFilesId = $oFileSaver->saveBase64Files($iUserId, $aFields[$i]["value"]);
							$aPhysFields[$sName] = $sFilesId;														
						}
						else {
							$aPhysFields[$sName] = $aFields[$i]["value"];
						}
						
					}
					
				}	
									
			}		

			$oDocFacade  = new WF_DocFacade();
			$oXmlWrapper = new MSF_XmlWrapper();
			$Template    = MSF_Registry::get("MSF_Template");
			MSF_Registry::set("MSF_Messenger", new MSF_Messenger($Template));
			$sXml		 = $oDocument->getDoctypeVersion()->getRouteXml();
			$aXml		 = $oXmlWrapper->xmlToArray($sXml);
			$oDocument->setPointId(0);
			$oDocumentVersion->setSystemField('status', $aXml[0]['title']);
			$oDocumentVersion->setFields($aPhysFields);
			$oDocumentVersion->setStructureId($iStructureId);					
			$oDocumentVersion->save();
			$oDocument->save();						
			$iDocId 	   = $oDocument->getDocumentId();						
			$oPostDocument = $oDocFacade->getDocumentById($iDocId);			
			$oDocFacade->initContextExecution($oPostDocument);
	
			return $iDocId;		
		}
		
		else {
			return -1;
		}
				
	}	
	
}
?>