<?php
include_once "modules/workflow/library/common/WF_Exception.php";
include_once "modules/workflow/library/actions/WF_ActionBox.php";
include_once "modules/workflow/library/schedule/WF_Schedule.php";
include_once "msfx/userbox/MSF_UserBoxExtension.php";

class WF_PeriodicalActionExecutor implements IDaemon
{
	private $oWFSchedule 	= null;
	
	private $aTasks			= array();
	
	public function __construct()
	{
		$this->oWFSchedule 	= new WF_Schedule();
		$this->aTasks		= $this->oWFSchedule->getTasks();
		
		//print_r($this->aTasks);
	}

	public function run()
	{/*
		$this->initTemplate();
		$this->initActionBar();
		$this->initUserBox();
		//print_r($this->aTasks[126]->expired());
		
		foreach ($this->aTasks AS $iTaskId => $Task) {
			//try {
				if ($Task->expired()) {
					$this->runTask($iTaskId, $Task);
					$this->oWFSchedule->markTaskAsExecuted($iTaskId);
				}
				
			//}
			
			
		}
	*/
	}
	
	private function initTemplate()
	{
		$Template = new MSF_Template();
		MSF_Registry::set("MSF_Template", $Template);
	}

	private function initActionBar()
	{
		MSF_Registry::set("MSF_ActionBar", null);
	}	
	
	private function initUserBox()
	{
		$Extension = new MSF_UserBoxExtension();
		$Extension->execute();
	}

	private function runTask($iTaskId, $Task)
	{
		
		$Ab = WF_ActionBox::newInstance();
		$Ab->loadAction(
				$Task->getActionName(), 
				$Task->getActionId(), 
				$Task->getDocumentId(),
				0,
				true);
		
		$Action	= $Ab->getAction();		
		
		$Action->setInitParam("spa_name", 			$Task->getActionName());
		$Action->setInitParam("spa_id", 			$Task->getActionId());
		$Action->setInitParam("subject_id", 		$Task->getDocumentId());
		$Action->setInitParam("subject_version_id", 0);
		$Action->setInitParam("initializing", 		true);
		$Action->setInitParam("task_id", 			$iTaskId);
		
		if ($Ab->process("schedule") !== WF_IAction::SUCCESS) {
			throw new WF_ActionRuntimeException("WF_PeriodicalActionExecutor::runTask() [" . $Task->getActionName() . "]");
		}
			
	}

}
?>