<html>
<head>
<title></title>
<style>
body {
	color			: #FFFFFF;
	background-color: #000000;
}

a {
	color:#FFFFFF;
	text-decoration:underline;
	cursor:pointer;
}

a:hover {
	text-decoration:none;
}
</style>
</head>
<body>
<?php
/************************************************************************************************\
 * 
 * 
 *
 \***********************************************************************************************/

DEFINE("__MSF", true);
DEFINE("CNF_ABS_PATH", dirname(__FILE__) . "/../../../");
set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);


include_once dirname(__FILE__) . "/../../../system/MSF_ThrowableException.php";
include_once dirname(__FILE__) . "/../../../system/utils/MSF_DB.php";
include_once dirname(__FILE__) . "/../../../system/utils/MSF_XmlWrapper.php";
include_once dirname(__FILE__) . "/../../../system/utils/MSF_String.php";
include_once dirname(__FILE__) . "/../../../system/mvc/MSF_ModelDBSupport.php";
include_once dirname(__FILE__) . "/../../../system/mvc/MSF_ViewSupportXml.php";
include_once dirname(__FILE__) . "/../../../system/MSF_Registry.php";
include_once dirname(__FILE__) . "/../../../system/MSF_Locale.php";
include_once dirname(__FILE__) . "/../../../modules/workflow/library/common/WF_Exception.php";
include_once dirname(__FILE__) . "/../../../modules/workflow/library/folders/WF_Folder.php";
include_once dirname(__FILE__) . "/../../../modules/workflow/library/doctype/WF_DoctypesList.php";
include_once dirname(__FILE__) . "/../../../modules/workflow/library/doctype/WF_Doctype.php";
include_once dirname(__FILE__) . "/../../../modules/workflow/library/doctype/WF_DoctypesListDB.php";



class WfDb
{
	private $oDb		= null;
	
	private $aProps		= array();
	
	private $aDoctypes 	= array();
	
	public function __construct($aProps)
	{
		$this->aProps = $aProps;
	}
	
	public function initDb()
	{
		$this->oDb = new MSF_DB();
		try {
			$this->oDb->connect(
				$this->aProps["sSqlHost"], 
				$this->aProps["sSqlDatabase"], 
				$this->aProps["sSqlUsername"], 
				$this->aProps["sSqlPassword"], 
				$this->aProps["sSqlScheme"],
				$this->aProps["sSqlPort"]
				);
			MSF_Registry::set("MSF_Locale", new MSF_Locale(""));
			MSF_Registry::set("MSF_DB", $this->oDb);
			$this->log("Инициализация соединения с базой данных... Сделано");
		}
		catch (Exception $e) {
			$this->log("Инициализация соединения с базой данных... " . $e->getMessage());
		}
		
	}
	
	public function initDoctypes()
	{
		$sSql 				= "SELECT doctype_id, folder_id, title FROM wf_doctypes";
		$this->aDoctypes 	= $this->oDb->select($sSql);
		$this->log("Загрузка списка типов документов... " . (empty($this->aDoctypes) ? "Нет типов документов" :  "Сделано"));
		$this->initDoctypeVersion();
	}
	
	public function initDoctypeVersion()
	{
		for ($i = 0; $i < count($this->aDoctypes); $i++) {
			$iDoctypeId = (int) $this->aDoctypes[$i]["doctype_id"];
			$sSql 		= "SELECT doctype_version_id, extname FROM wf_doctypes_versions WHERE doctype_id = " . $iDoctypeId;
			$aVersions 	= $this->oDb->select($sSql);
			$this->aDoctypes[$i]["versions"] = $aVersions;
		}
		
		$this->log("Загрузка списка версий типов документов... Сделано");
		$this->initDocuments();
	}
	
	public function initDocuments()
	{
		for ($i = 0; $i < count($this->aDoctypes); $i++) {
			for ($j = 0; $j < count($this->aDoctypes[$i]["versions"]); $j++ ) {
				$iDoctypeVersionId = (int) $this->aDoctypes[$i]["versions"][$j]["doctype_version_id"];
				$sSql 		= "SELECT document_id, media_id FROM wf_documents WHERE doctype_version_id = " . $iDoctypeVersionId;
				$aDocuments = $this->oDb->select($sSql);
				$this->aDoctypes[$i]["versions"][$j]["documents"] = $aDocuments;
			}
			
		}
		
		$this->log("Загрузка списка документов... Сделано");
		$this->initDocumentsVersions();
	}
	
	public function initDocumentsVersions()
	{
		for ($i = 0; $i < count($this->aDoctypes); $i++) {
			for ($j = 0; $j < count($this->aDoctypes[$i]["versions"]); $j++ ) {
				for ($k =0; $k < count($this->aDoctypes[$i]["versions"][$j]["documents"]); $k++) {
					$iDocumentId 	= (int) $this->aDoctypes[$i]["versions"][$j]["documents"][$k]["document_id"];
					$sSql 			= "SELECT document_version_id FROM wf_documents_versions WHERE document_id = " . $iDocumentId;
					$aVersions 		= $this->oDb->select($sSql);
					$this->aDoctypes[$i]["versions"][$j]["documents"][$k]["versions"] = $aVersions;
				}

			}
			
		}
		
		$this->log("Загрузка списка версий документов... Сделано");
	}
	
	public function showDoctypes()
	{
		$this->initDoctypes();
		$this->log("<br/>");
		$this->log("<br/>");
		$this->log("Отображение базы документооборота... В процессе");
		$iDoctypesCount = count($this->aDoctypes);
		$this->log("Найдено типов документов: <b>" . $iDoctypesCount . "</b>");
		if ($iDoctypesCount == 0) return;
		$this->log("Вывожу подробную информацию о типах документов: ");
		$this->log("<br/>");
		$this->log("<br/>");
		for ($i = 0; $i < $iDoctypesCount; $i++) {
			$aDoctype = $this->aDoctypes[$i];
			$this->log("Тип документа " . $aDoctype["doctype_id"]);
			$this->log("---- Заголовок: " . $aDoctype["title"]);
			$iDoctypeVersionsCount = count($aDoctype["versions"]);
			if ($iDoctypeVersionsCount == 0) continue;
			$this->log("---- Количество версий: " . $iDoctypeVersionsCount);
			for ($j = 0; $j < $iDoctypeVersionsCount; $j++ ) {
				$aDoctypeVersion = $aDoctype["versions"][$j];
				$this->log("---- ---- Версия: " . $aDoctypeVersion["doctype_version_id"]);
				$this->log("---- ---- Таблица: " . $this->getExtname($aDoctypeVersion["extname"]));
				$iDocumentsCount = count($aDoctypeVersion["documents"]);
				if ($iDocumentsCount == 0) continue;
				$this->log("---- ---- Количество документов: " . $iDocumentsCount);
				for ($k = 0; $k < $iDocumentsCount; $k++) {
					$aDocument = $aDoctypeVersion["documents"][$k];
					$this->log("---- ---- ---- Документ: " . $aDocument["document_id"]);
					$iDocumentsVersionsCount = count($aDocument["versions"]);
					if ($iDocumentsVersionsCount == 0) continue;
					$this->log("---- ---- ---- Медиа ИД: " . $aDocument["media_id"]);
					$this->log("---- ---- ---- Количество версий: " . $iDocumentsVersionsCount);
					for ($m =0; $m < $iDocumentsVersionsCount; $m++) {
						$aDocumentVersion = $aDocument["versions"][$m];
						$this->log("---- ---- ---- ---- Версия: " . $aDocumentVersion["document_version_id"]);
					}

				}

			}
			
			$this->log("<br/>");
		}

		$this->log("Отображение базы документооборота... Сделано");	
	}
	
	public function clearDoctypes()
	{
		$this->initDoctypes();
		$this->log("<br/>");
		$this->log("<br/>");
		$this->log("Очищение базы документооборота... В процессе");
		$iDoctypesCount = count($this->aDoctypes);
		$this->log("Найдено типов документов: <b>" . $iDoctypesCount . "</b>");
		if ($iDoctypesCount == 0) return;
		$this->log("Вывожу подробную информацию об удалении: ");
		$this->log("<br/>");
		$this->log("<br/>");
		for ($i = 0; $i < $iDoctypesCount; $i++) {
			$aDoctype = $this->aDoctypes[$i];
			$this->log("Тип документа " . $aDoctype["doctype_id"]);
			$this->log("---- Удаление: " . $this->removeDoctype($aDoctype["doctype_id"]));
			$this->log("---- Заголовок: " . $aDoctype["title"]);
			$iDoctypeVersionsCount = count($aDoctype["versions"]);
			if ($iDoctypeVersionsCount == 0) continue;
			$this->log("---- Количество версий: " . $iDoctypeVersionsCount);
			for ($j = 0; $j < $iDoctypeVersionsCount; $j++ ) {
				$aDoctypeVersion = $aDoctype["versions"][$j];
				$this->log("---- ---- Версия: " . $aDoctypeVersion["doctype_version_id"]);
				$this->log("---- ---- Удаление: " . $this->removeDoctypeVersion($aDoctypeVersion["doctype_version_id"]));
				$this->log("---- ---- Таблица: " . $this->getExtname($aDoctypeVersion["extname"]));
				$this->log("---- ---- Удаление: " . $this->removeDoctypeVersionTable($aDoctypeVersion["extname"]));
				$iDocumentsCount = count($aDoctypeVersion["documents"]);
				if ($iDocumentsCount == 0) continue;
				$this->log("---- ---- Количество документов: " . $iDocumentsCount);
				for ($k = 0; $k < $iDocumentsCount; $k++) {
					$aDocument = $aDoctypeVersion["documents"][$k];
					$this->log("---- ---- ---- Документ: " . $aDocument["document_id"]);
					$this->log("---- ---- ---- Удаление: " . $this->removeDocument($aDocument["document_id"]));
					$iDocumentsVersionsCount = count($aDocument["versions"]);
					if ($iDocumentsVersionsCount == 0) continue;
					$this->log("---- ---- ---- Количество версий: " . $iDocumentsVersionsCount);
					for ($m =0; $m < $iDocumentsVersionsCount; $m++) {
						$aDocumentVersion = $aDocument["versions"][$m];
						$this->log("---- ---- ---- ---- Версия: " . $aDocumentVersion["document_version_id"]);
						$this->log("---- ---- ---- ---- Удаление: " . $this->removeDocumentVersion($aDocumentVersion["document_version_id"]));
					}

				}

			}
			
			$this->log("<br/>");
		}

		$this->log("Очищение базы документооборота... Сделано");	
	}
	
	public function removeDocumentVersion($iDocumentVersionId)
	{
		$sSql = "DELETE FROM wf_documents_versions WHERE document_version_id = " . (int) $iDocumentVersionId;
		$this->oDb->executeQuery($sSql);
		return ($this->oDb->affectedRows() > 0) ? "Сделано" : "Прервано";
	}
	
	public function removeDocument($iDocumentId)
	{
		$sSql = "DELETE FROM wf_documents WHERE document_id = " . (int) $iDocumentId;
		$this->oDb->executeQuery($sSql);
		return ($this->oDb->affectedRows() > 0) ? "Сделано" : "Прервано";
	}
	
	public function removeDoctypeVersion($iDoctypeVersionId)
	{
		$sSql = "DELETE FROM wf_doctypes_versions WHERE doctype_version_id = " . (int) $iDoctypeVersionId;
		$this->oDb->executeQuery($sSql);
		return ($this->oDb->affectedRows() > 0) ? "Сделано" : "Прервано";
	}
	
	public function removeDoctypeVersionTable($sExtname)
	{
		$sSql = "DROP TABLE " . $this->getExtname($sExtname);
		return $this->oDb->executeQuery($sSql) ? "Сделано" : "Прервано";
	}
	
	public function removeDoctype($iDoctypeId)
	{
		$sSql = "DELETE FROM wf_doctypes WHERE doctype_id = " . (int) $iDoctypeId;
		$this->oDb->executeQuery($sSql);
		return ($this->oDb->affectedRows() > 0) ? "Сделано" : "Прервано";
	}
	
	public function showControls()
	{
		$this->log("<br/>");
		$this->log("<br/>");
		$this->log("Глобальные действия:");
		//
		$this->log("<a href=\"?action=viewFolders\">Показать базу данных журналов.</a>");
		//
		$this->log("<a href=\"?action=viewDoctypes\">Показать базу данных типов документов.</a>");
		//
		$sMessage = "Удалить все типы документов, версии типов документов, документы и версии документов?";
		$this->log("<a onclick=\"confirm('" . $sMessage . "')\" href=\"?action=clearDoctypes\">Очистить базу данных документооборота.</a>");
		//
		$sMessage = "Удалить все журналы?";
		$this->log("<a onclick=\"confirm('" . $sMessage . "')\" href=\"?action=clearFolders\">Очистить базу данных журналов.</a>");

	}
	
	public function log($sMessage = "")
	{
		echo "<div>" . $sMessage . "</div>\n";
	}
	
	private function getExtname($sExtname)
	{
		return "wf_documents_" . $sExtname; 
	}
		
	public function debug($mVar)
	{
		echo "<pre>\n";
		print_r($mVar);
		echo "\n</pre>\n"; 
	}
	
	private $aFolders = array();
	
	public function initFolders()
	{
		$sSql 				= "SELECT folder_id, name FROM wf_folders";
		$this->aFolders 	= $this->oDb->select($sSql);
		$this->log("Загрузка списка журналов... " . (empty($this->aFolders) ? "Нет журналов" :  "Сделано"));
	}

	public function showFolders()
	{
		$this->initFolders();
		$this->log("<br/>");
		$this->log("<br/>");
		$this->log("Отображение базы данных журналов... В процессе");
		$iFoldersCount = count($this->aFolders);
		$this->log("Найдено журналов: <b>" . $iFoldersCount . "</b>");
		if ($iFoldersCount == 0) return;
		$this->log("Вывожу подробную информацию о журналах: ");
		$this->log("<br/>");
		$this->log("<br/>");
		for ($i = 0; $i < $iFoldersCount; $i++) {
			$this->log("Журнал " . $this->aFolders[$i]["folder_id"]);
			$this->log("---- Заголовок " . $this->aFolders[$i]["name"]);
			$this->log("<br/>");
		}

		$this->log("Отображение базы данных журналов... Сделано");
	}
	
	public function clearFolders()
	{
		$this->initFolders();
		$this->log("<br/>");
		$this->log("<br/>");
		$this->log("Очищение базы данных журналов... В процессе");
		$iFoldersCount = count($this->aFolders);
		$this->log("Найдено журналов: <b>" . $iFoldersCount . "</b>");
		if ($iFoldersCount == 0) return;
		$this->log("Вывожу подробную информацию об удалении журналах: ");
		$this->log("<br/>");
		$this->log("<br/>");
		for ($i = 0; $i < $iFoldersCount; $i++) {
			$this->log("Журнал " . $this->aFolders[$i]["folder_id"]);
			$this->log("---- Заголовок " . $this->aFolders[$i]["name"]);
			$this->log("---- Удаление " . $this->removeFolder($this->aFolders[$i]["folder_id"]));
			$this->log("<br/>");
		}

		$this->log("Очищение базы данных журналов... Сделано");
	}
	
	public function removeFolder($iFolderId)
	{
		try {
			$Folder			= new WF_Folder(new WF_FolderDB($this->oDb));
			$DoctypeList	= new WF_DoctypesList(new WF_DoctypesListDB($this->oDb));
			$Folder->load($iFolderId);
			$Folder->remove();
			$DoctypeList->removeLink($iFolderId);
			return "Сделано";
		}
		catch (Exception $e) {
			return $e->getMessage();
		}
	}
	
	public static function main(array $aArgs = array())
	{
		$oWfDb = new self($aArgs);
		$oWfDb->initDb();
		
		switch (isset($_GET["action"]) ? $_GET["action"] : "view") {
			case "viewFolders":
				$oWfDb->showFolders();
				break;
			case "clearFolders":
				$oWfDb->clearFolders();
				break;
			case "viewDoctypes":
				$oWfDb->showDoctypes();
				break;
			case "clearDoctypes":
				$oWfDb->clearDoctypes();
				break;
			default:
				break;
			
		}
		
		$oWfDb->showControls();
	}
	
}

WfDb::main(
		array(
				"sSqlHost" 		=> "server",
				"sSqlDatabase" 	=> "manuscript",
				"sSqlUsername"	=> "detrix",
				"sSqlPassword"	=> "1",
				"sSqlScheme"	=> "manuscript"
				)
		);
?>

</body>
</html>