<?php
	HEADER("Content-type: text/html; charset=utf-8");
?>
<html>
<head>
<title></title>
<style>
body {
	color			: #FFFFFF;
	background-color: #000000;
}

a {
	color:#FFFFFF;
	text-decoration:underline;
	cursor:pointer;
}

a:hover {
	text-decoration:none;
}
</style>
</head>
<body>
<?php
/************************************************************************************************\
 * 
 * 
 *
 \***********************************************************************************************/

DEFINE("__MSF", true);
DEFINE("CNF_ABS_PATH", dirname(__FILE__) . "/../../../");
set_include_path(get_include_path() . PATH_SEPARATOR . CNF_ABS_PATH);



include_once dirname(__FILE__) . "/../../../system/MSF_ThrowableException.php";
include_once dirname(__FILE__) . "/../../../system/utils/MSF_DB.php";
include_once dirname(__FILE__) . "/../../../system/utils/MSF_XmlWrapper.php";
include_once dirname(__FILE__) . "/../../../system/utils/MSF_String.php";
include_once dirname(__FILE__) . "/../../../system/mvc/MSF_ModelDBSupport.php";
include_once dirname(__FILE__) . "/../../../system/mvc/MSF_ViewSupportXml.php";
include_once dirname(__FILE__) . "/../../../system/MSF_Registry.php";
include_once dirname(__FILE__) . "/../../../system/MSF_Locale.php";
include_once dirname(__FILE__) . "/../../../modules/workflow/library/common/WF_Exception.php";
include_once dirname(__FILE__) . "/../../../modules/workflow/library/folders/WF_Folder.php";
include_once dirname(__FILE__) . "/../../../modules/workflow/library/doctype/WF_DoctypesList.php";
include_once dirname(__FILE__) . "/../../../modules/workflow/library/doctype/WF_Doctype.php";
include_once dirname(__FILE__) . "/../../../modules/workflow/library/doctype/WF_DoctypesListDB.php";



class WfDb
{
	private $oDb		= null;
	
	private $aProps		= array();
	
	private $aDoctypes 	= array();
	
	public function __construct($aProps)
	{
		$this->aProps = $aProps;
	}
	
	public function initDb()
	{
		$this->oDb = new MSF_DB();
		try {
			$this->oDb->connect(
				$this->aProps["sSqlHost"], 
				$this->aProps["sSqlDatabase"], 
				$this->aProps["sSqlUsername"], 
				$this->aProps["sSqlPassword"], 
				$this->aProps["sSqlScheme"],
				$this->aProps["sSqlPort"]
				);
				
			MSF_Registry::set("MSF_Locale", new MSF_Locale(""));
			MSF_Registry::set("MSF_DB", $this->oDb);
			$this->log("Инициализация соединения с базой данных... Сделано");
		}
		catch (Exception $e) {
			$this->log("Инициализация соединения с базой данных... " . $e->getMessage());
		}
		
	}
	
	public function log($sMessage = "")
	{
		echo "<div>" . $sMessage . "</div>\n";
	}
	
	public function showTable($iId)
	{
		$sSql	=	"SELECT" . "\n" . 
						"*" . "\n" .
					"FROM" . "\n" .
						"wf_reports" . "\n" .
					"WHERE" . "\n" .
						"document_id='" . $iId . "'";
		
		$sTable	= "";
		$sTable	.= "<table border=\"1\" cellpadding=\"1\" cellspacing=\"2\">";
		$sTable	.= "<tr>";
		$sTable	.= "<td>log_id</td>";
		$sTable	.= "<td>document_id</td>";
		$sTable	.= "<td>point_id</td>";
		$sTable	.= "<td>action_name</td>";
		$sTable	.= "<td>employee_id</td>";
		$sTable	.= "<td>result</td>";
		$sTable	.= "<td>created_at</td>";
		$sTable	.= "</tr>";
		
		$aReports 	= $this->oDb->select($sSql);
		
		foreach($aReports as $aReport) {
			$sTable	.= "<tr>";
			$sTable	.= "<td>" . $aReport["log_id"] . "</td>";
			$sTable	.= "<td>" . $aReport["document_id"] . "</td>";
			$sTable	.= "<td>" . $aReport["point_id"] . "</td>";
			$sTable	.= "<td>" . $aReport["action_name"] . "</td>";
			$sTable	.= "<td>" . $aReport["employee_id"] . "</td>";
			$sTable	.= "<td>" . $aReport["result"] . "</td>";
			$sTable	.= "<td>" . $aReport["created_at"] . "</td>";
			$sTable	.= "</tr>";
		}
		
		$sTable	.= "</table>";
		
		$this->log($sTable);
	}
	
	public static function main(array $aArgs = array())
	{
		$oWfDb = new self($aArgs);
		$oWfDb->initDb();
		
		
		if(isset($_GET["id"])) {
			$oWfDb->showTable((int)$_GET["id"]);
		}
		
	}
	
}

WfDb::main(
		array(
				"sSqlHost" 		=> "server",
				"sSqlDatabase" 	=> "manuscript",
				"sSqlUsername"	=> "detrix",
				"sSqlPassword"	=> "1",
				"sSqlScheme"	=> "manuscript"
				)
		);
?>

</body>
</html>