<?php
include_once "modules/workflow/library/common/WF_Exception.php";
include_once "modules/workflow/library/doctype/WF_Doctype.php";
include_once "modules/workflow/library/doctype/WF_DoctypeDB.php";
include_once "modules/workflow/library/doctype/WF_DoctypeCompare.php";

include_once "modules/workflow/library/doctype/WF_DoctypesList.php";
include_once "modules/workflow/library/doctype/WF_DoctypesListDB.php";
include_once "modules/workflow/library/security/WF_DoctypeSwitcher.php";
include_once "modules/structure/library/Struct_Utils.php";
include_once "modules/workflow/library/security/WF_DoctypeAccess.php";
/**
 * Static class
 */
class WF_Utils
{
	/**
	 * Dont set constructor as public
	 */
	private function __construct()
	{}

	private function __clone()
	{}

	// public static function functionName() {}
	// TODO Убрать этот метод из этого класса public static function prepareFields()
	/**
	 * Parsit polya is $_POST i vosvrashaet XML
	 *
	 * @return string
	 * @access public
	 */
	public static function prepareFields()
	{
		if(isset($_POST["fields"])) {
			$aSearch 	= array("<", ">");
			$Root		= new DOMDocument();

			$Document	= $Root->createElement("document");
			$Root->appendChild($Document);
			$XmlWrapper	= new MSF_XmlWrapper();
	
			foreach($_POST["fields"] as $sName=>$aField) {
							
				if($aField["value"]["type"] == "notChoose" || (
					$aField["value"]["type"] == "reference" && $aField["value"]["optional"]["reference"] == "-1"
				)) {
					continue;
				}
				
				if(strstr($sName, "new_element")) {
					$sName	= "field_" . MSF_String::hash(microtime(), 10);
				}
				else {
					$sName	= MSF_String::addslashes($sName);
				}
				
				$sType 	= $aField["value"]["type"];
				$sTitle = $aField["title"];
				$sTitle = str_replace($aSearch, "", $sTitle);
				
				$XmlWrapper->set($sName, $aField["value"], $sTitle);
			}
			//echo $XmlWrapper->getXml();
			$sXML	= str_replace("<?xml version=\"1.0\"?>", "", $XmlWrapper->getXml());
			
			return $sXML;
		}
		else {
			return "<document/>";
		}

	}

	/**
	 * Sozdaet novuyu versiu doctypa i sopastavlyaet s ney vse polya
	 * v versiyah i shurnale
	 *
	 * @param WF_Doctype $Doctype
	 * @param array $aParams
	 * @return void
	 * @access public
	 */
	public static function saveAsNewVersion(WF_Doctype $Doctype, $aParams, $bChangedFields = true)
	{
		$NV 	= $Doctype->getCurrentVersion();
		$Date 	= new MSF_Date();
		
		$Doctype->setModifiedAt($Date->formatTimestamp());
		if (isset($aParams["fields"])) {
			$Doctype->setFieldsXml($aParams["fields"]);
			$NV->setFieldsXml($Doctype->getFieldsXml());
		}
		if (isset($aParams["spa"])) {
			$NV->setSpaXml($aParams["spa"]);
		}
		if (isset($aParams["route"])) {
			$Doctype->setRouteXml($aParams["route"]);
			$NV->setRouteXml($aParams["route"]);
		}
		if (isset($aParams["template"])) {
			$NV->setTemplateXml($aParams["template"]);
		}
		if (isset($aParams["archive"])) {
			$NV->setArchiveXml($aParams["archive"]);		
		}
		
		if ($Doctype->getDoctypeVersionId() == 0 || $bChangedFields) {
			$Doctype->save();
			$CV = $Doctype->getCurrentVersion();
			$NV = $Doctype->newVersion();
			$NV->setTemplateXml(MSF_SL::getParam($aParams,"template",$CV->getTemplateXml(), true));
			$NV->setArchiveXml(MSF_SL::getParam($aParams,"archive",$CV->getArchiveXml(), true));
			$NV->setRouteXml(MSF_SL::getParam($aParams,"route",$CV->getRouteXml(), true));
			$NV->setSpaXml(MSF_SL::getParam($aParams,"spa",$CV->getSpaXml(), true));
			$NV->setUserId(MSF_Registry::get("MSF_UserBox")->getUserAttribute("id"));
			$NV->setCreatedAt(date("Y-m-d H:i"));
			$NV->save();
		}
		else {
			$NV->save();
			$Doctype->save();
		}
		
		self::saveCompared($Doctype, $NV);
	}
	
	public static function saveCompared(WF_Doctype $Doctype, WF_DoctypeVersion $NV)
	{
		
		$Compare 	= new WF_DoctypeCompare($Doctype);
		$Compare->getVersions();
		$aDoctype 	= $Compare->getComparedResult();
		$Wrapper 	= new MSF_XmlWrapper($NV->getFieldsXml());
		
		$sName = $NV->getExtname();
		foreach ($Wrapper as $Data) {
			for ($i = 0; $i < sizeof($aDoctype); $i++) {
				echo $aDoctype[$i]["name"] . '<br/>';
				if ($Data->getName() == $aDoctype[$i]["name"] && $Data->getValue("type") == $aDoctype[$i]["type"]) {
					$aTmp["name"] 				= $Data->getName();
					$aTmp["type"] 				= $Data->getValue("type");
					$aTmp["title"] 				= $Data->getTitle();
					$aTmp["version"] 			= $sName;
					$aDoctype[$i]["compared"][] = $aTmp;
				}
				
			}
			
		}
		
		//debug($aDoctype);
		//exit();
		$Compare->saveComparedResult($aDoctype, false);
		//exit();		
		if ($Doctype->getFolderId() > 0) {
			$Folder = new WF_Folder(new WF_FolderDB(MSF_Registry::get("MSF_DB")));
			try {
				$Folder->load($Doctype->getFolderId()); // trows WF_FolderNotFoundException
				$aConf 		= $Folder->getConfig();
				$Wrapper 	= new MSF_XmlWrapper($aConf["compared_xml"]);
				$NewWrapper = new MSF_XmlWrapper();
				$Fields 	= new MSF_XmlWrapper($aConf["fields_xml"]);
				$iDocSize 	= count($aDoctype);
				foreach ($Wrapper as $Data) {
					$bModified = false;
					foreach ($Data->getValue() as $aValue) {
						if ($aValue["doctype_id"] == $Doctype->getDoctypeId()) {
							if ($iDocSize == 0) {
								$bModified = true;
								$NewWrapper->set("", array());
							}
							else {
								for ($i = 0; $i < $iDocSize; $i++) {
									foreach ($Fields as $Field) {
										if ($aDoctype[$i]["name"] == $aValue["name"] && $Data->getName() == $Field->getName() && $aDoctype[$i]["type"] == $Field->getValue("type")) {
											$bModified = true;
											$NewWrapper->set($Data->getName(), $Data->getValue());
										}
										
									}
									
								}
								
							}
							
						}
						
					}
					
					if (!$bModified) {
						$NewWrapper->set($Data->getName(), $Data->getValue());
					}
				}
				
				$aConf["compared_xml"] = $NewWrapper->getXml();
				
				$Folder->setConfig($aConf);
				//v save uzhe vizivaetsya WF_Folder::build()
				//$Folder->build();
				$Folder->save();
			}
			catch (WF_FolderNotFoundException $FNFE) {
				// If folder doesnt exist exception will be trown
			}
		}
		
		
	}

	public static function appendDate($Template, $Node)
	{
		$DateNode	= $Template->createElement("date");
		$Node->appendChild($DateNode);
		
		$Day	= $Template->createElement("item");
		$DateNode->appendChild($Day);
		$Day->setAttribute("name", "day");
		for($i=1; $i<32; $i++) {
			$Item	= $Template->createElement("item");
			$Day->appendChild($Item);
			$Item->setAttribute("value", $i);
			
			if($i == date("d")) {
				$Item->setAttribute("selected", "true");
			}

		}
		
		$Month	= $Template->createElement("item");
		$DateNode->appendChild($Month);
		$Month->setAttribute("name", "month");
		for($i=1; $i<13; $i++) {
			$Item	= $Template->createElement("item");
			$Month->appendChild($Item);
			$Item->setAttribute("value", $i);
			
			if($i == date("m")) {
				$Item->setAttribute("selected", "true");
			}

		}
		
		$Year	= $Template->createElement("item");
		$DateNode->appendChild($Year);
		$Year->setAttribute("name", "year");
		for($i=1970; $i<2030; $i++) {
			$Item	= $Template->createElement("item");
			$Year->appendChild($Item);
			$Item->setAttribute("value", $i);
			
			if($i == date("Y")) {
				$Item->setAttribute("selected", "true");
			}

		}
		
	}
	
	/**
	 * Returns allowed author ids. -1 - all folders
	 * @return array()
     */
	public static function getAllowedAuthorIds($iFolderId)
	{
		// Initialization
		$oDa		= new WF_DoctypeAccess();
		$aPaths		= self::getPath();
		$aDoctypes	= self::getDoctypesByFolderId($iFolderId);
		$aAuthorIds = array();
		$aMissed	= self::getMissedAuthors($aDoctypes);
		foreach ($aDoctypes AS $iDoctypeId) {
			$aAuthorIds[$iDoctypeId] = array();
			foreach ($aPaths AS $iPathId) {
				$aAuthorIds[$iDoctypeId] += $oDa->get($iDoctypeId, $iPathId);
			}
			
			if (isset($aMissed[$iDoctypeId])) {
				$aAuthorIds[$iDoctypeId][0]["author_ids"] = array_merge(
						$aAuthorIds[$iDoctypeId][0]["author_ids"], 
						$aMissed[$iDoctypeId]
						);
			}
				
		}

		return $aAuthorIds;
	}
	
	private static function getMissedAuthors($aDoctypes)
	{
		$aAllowedDoctypes 	= array();
		$oDa 				= new WF_DoctypeAccess();
		foreach ($aDoctypes AS $iDoctypeId) {
			$aAccess = $oDa->get($iDoctypeId, 1);
			if (!empty($aAccess) && $aAccess[0]["view"] == 1) {
				$aAllowedDoctypes[]	= $iDoctypeId;
			}
			
		}
		
		$aResult= array();
		if (!empty($aAllowedDoctypes)) {
			$sSql 	= "SELECT "
					. "DISTINCT d.structure_id, d.doctype_id "
					. "FROM "
					. "wf_documents d "
					. "WHERE "
					. "d.structure_id NOT IN(SELECT s.node_id FROM structure s) "
					. "AND "
					. "doctype_id IN (" . implode(", ", $aAllowedDoctypes) . ")";
			$oDb 	= MSF_Registry::get("MSF_DB");
			
			foreach ($oDb->select($sSql) AS $aRow) {
				if (!isset($aResult[$aRow["doctype_id"]])) {
					$aResult[$aRow["doctype_id"]] = array();
				}
				
				$aResult[$aRow["doctype_id"]][] = $aRow["structure_id"];
			}
			
		}
		
		return $aResult;
		
	}
	
	public static function getDoctypesByFolderId($iFolderId)
	{
		$oDb 				= MSF_Registry::get("MSF_DB");
		$oDoctypesListDb 	= new WF_DoctypesListDB($oDb);
		$oDoctypesList 		= new WF_DoctypesList($oDoctypesListDb);
		$aDoctypes 			= array();
		
		if($iFolderId == -1) {
			$aList	= $oDoctypesList->getAll();
		}
		else {
			$aList	= $oDoctypesList->getLinked($iFolderId);
		}
		
		
		foreach ($aList AS $aBody) {
			$aDoctypes[] = $aBody["doctype_id"];
		}
		
		return $aDoctypes;
	}
	
	// @TODO ispravit pri perenose metoda
	public static function getPath()
	{
		$oStructure		= MSF_Registry::get("MSF_UserBox");
		$mPath 			= $oStructure->getCurrentStructurePath();
		
		if (empty($mPath)) {
			$mPath = array(0);
		}
		else {
			$mPath = explode(".", $mPath);
		}
		
		return array_reverse($mPath);
	}
	
	/**
	 * 
	 */
	public static function getAllowedDocumentIds($iFolderId)
	{
		$oDb 		= MSF_Registry::get("MSF_DB");
		$aPaths 	= self::getPath();
		$aDoctypes	= self::getDoctypesByFolderId($iFolderId);
		
		$oDta 		= new WF_DoctypeAccess();
		$oStrId		= MSF_OrgStructureFacade::getInstance()->getCurrentStructureId();
		$aNewDt		= array(0);
		foreach ($aDoctypes AS $iDoctype) {
			$aAccess = $oDta->get($iDoctype, $oStrId);
			if ($aAccess && $aAccess[0]["view"] == 1) {
				$aNewDt[] = $iDoctype;
			}
		}
		$sSql	= "SELECT" . "\n"
					. "wfd.document_id AS document_id" . "\n"
				. "FROM" . "\n"
					. "wf_documents wfd," . "\n"
					. "wf_documents_access_list wfdacl" . "\n"
				. "WHERE" . "\n"
					. "wfd.document_id = wfdacl.document_id" . "\n"
				. "AND (" . "\n"
					. "wfdacl.structure_id IN (" . implode(", ", $aPaths) . ")"
				. ")";

		$aDocumentIds = array();
		foreach ($oDb->select($sSql) AS $aRow) {
			$aDocumentIds[] = $aRow["document_id"];
		}

		return $aDocumentIds;
	}
	
	public static function getFromFamilyRecursive($aRootValue, $iDocumentId)
	{		
		foreach($aRootValue AS $aValue) {
			if($aValue["id"] == $iDocumentId) {
				return $aValue["node"];	
			}
			else {
				if(!empty($aValue["node"])) {
					$aResult	= self::getFromFamilyRecursive($aValue["node"], $iDocumentId);
					if(!empty($aResult)) {
						return $aResult;
					}
					
				}
				else {
					continue;	
				}
				
			}
			
		}
		
		$aResult = array();
		return $aResult;
		
	}
	
}

?>