<?php
include_once "WF_IAction.php";
abstract class WF_AbstractAction implements WF_IAction
{

	private $aParams 			= array();
	
	private $aInitParams 		= array();
	
	final public function setInitParam($sName, $mValue)
	{
		$this->aInitParams[$sName] = $mValue;
	}

	final public function unsetInitParam($sName)
	{
		if ($this->hasInitParam($sName)) {
			unset($this->aInitParams[$sName]);
		}

	}

	final public function hasInitParam($sName)
	{
		return array_key_exists($sName, $this->aInitParams);
	}

	final public function getInitParam($sName)
	{
		$mResult = array();
		if ($this->hasInitParam($sName)) {
			$mResult = $this->aInitParams[$sName];
		}
		else {
			$mResult = null;
		}

		return $mResult;
	}

	final public function setParam($sName, $mValue)
	{
		
		$this->aParams[$sName] = $mValue;
	}

	final public function unsetParam($sName)
	{
		if ($this->hasParam($sName)) {
			unset($this->aParams[$sName]);
		}

	}

	final public function hasParam($sName)
	{
		return array_key_exists($sName, $this->aParams);
	}

	final public function getParam($sName, $sKey = null, $mDeafult = null)
	{
		$mResult = array();
		if ($this->hasParam($sName)) {
			if ($sKey == null) {
				$mResult = $this->aParams[$sName];
			}
			else {
				$mResult = MSF_SL::getParam($this->aParams[$sName], $sKey, $mDeafult);
			}
			
		}
		else {
			$mResult = null;
		}

		// poka net filtrov nujen etot kostyl
		if (!is_array($mResult)) {
			$mResult = str_replace("&shy;", " ", $mResult);
		}
		
		return $mResult;
	}
	
	public function initialize()
	{

	}
	
	public function prepareSpa($aSpaValue)
	{
		return $aSpaValue;
	}
		
	public function getLogTitle()
	{
		return null;
	}

	public function getLogParams()
	{
		return array();
	}
	
	public function processExecute()
	{
		return self::FAILURE;
	}

	public function processSchedule()
	{
		return self::FAILURE;
	}
	
	public function processCall()
	{
		return self::FAILURE;
	}

	public function processRequest()
	{
		return self::FAILURE;
	}

	public function cancel()
	{		
	
	}

}

?>