<?php
defined("__MSF")
		or die("Direct access is not allowed");


include_once "modules/media/library/WF_MediaId.php";
include_once "modules/workflow/library/doctype/WF_Doctype.php";
include_once "modules/workflow/library/doctypeVersion/WF_DoctypeVersion.php";
include_once "modules/workflow/library/document/WF_Document.php";
include_once "modules/workflow/library/documentVersion/WF_DocumentVersion.php";

include_once "modules/workflow/library/logs/WF_Log.php";
include_once "modules/workflow/library/actions/WF_ActionSupportDB.php";

include_once "modules/workflow/library/actions/WF_SystemActionSupport.php";

include_once "modules/workflow/library/doctypeVersion/WF_DelegateValues.php";

include_once "modules/workflow/library/security/WF_DoctypeSwitcher.php";
include_once "modules/workflow/library/security/WF_DocumentSwitcher.php";

/**
 * @package 	workflow
 * @copyright 	Copyright (c) 2007, Detrix
 */
abstract class WF_ActionSupportOld
{
	const FINISH_POINT			= 500;
	
	/**
	 * @var 	array Init params
	 * @access 	private
	 */
	private $aInitParams 		= array();

	/**
	 * @var 	array System params
	 * @access 	private
	 */
	private $aParams 			= array();
	
	/**
	 * @var MSF_ViewSupportXml
	 */
	private $View				= null;
	
	/**
	 * @var WF_Doctype
	 */
	private $Doctype			= null;

	/**
	 * @var WF_DoctypeVersion
	 */
	private $DoctypeVersion		= null;

	/**
	 * @var WF_Document
	 */
	private $Document			= null;
	
	/**
	 * @var WF_Log
	 */
	private $Log				= null;
	
	/**
	 * @var MSF_UserBox
	 */
	private $UserBox			= null;
	
	/**
	 * @var MSF_Template
	 */
	private $Template			= null;
	
	/**
	 * @var MSF_ActionBar
	 */
	private $ActionBar			= null;
	
	/**
	 * @var WF_DelegateValues
	 */
	private $DelegateValues		= null;
	
	/**
	 * @var WF_Values
	 */
	private $WfValues			= null;
	
	/**
	 * @var int
	 */
	private $iActionId			= 0;
	
	/**
	 * @var string
	 */
	private $sActionName		= "";
	
	/**
	 * @var array
	 */
	private $aSpa				= array();
	
	/**
	 * @var array
	 */
	private $aRoute				= array();
	
	/**
	 * @var array
	 */
	private $aSettings			= array();
	
	/**
	 * @var string
	 */
	private $sRedirectUrl		= "";
	
	/**
	 * @var array
	 */
	private static $aActionBarActions	= array();
	
	protected  $isVersion 			= false;
	
	/**
	 * Vozvrashaet ActionBar
	 *
	 * @return MSF_ActionBar
	 * @access public
	 */
	public function getActionBar()
	{
		return $this->ActionBar;
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// Constructor
	/////////////////////////////////////////////////////////////////////////////////////////////////
	/**
	 * @param string $sActionName
	 * @param int $iActionId
	 * @param int $iDocumentId
	 * @param int $iDocumentVersionId
	 * @param int $bInitializing
	 * @param WF_IAction $CallerAction
	 * @return void
	 * @access public
	 */
	public function __construct($sActionName, $iActionId, $iDocumentId, $iDocumentVersionId, $bInitializing = true, $CallerAction = null)
	{
//		/debug($sActionName, $iActionId, $iDocumentId, $iDocumentVersionId, $bInitializing, $CallerAction);
		if ($iDocumentVersionId > 0) {
			$this->isVersion = true;
		}
		
		$Db 					= MSF_Registry::get("MSF_DB");
		$this->UserBox			= MSF_Registry::get("MSF_UserBox");
		$this->Db 				= new WF_ActionSupportDB($Db);
		$this->Template 		= MSF_Registry::get("MSF_Template");
		$this->ActionBar		= MSF_Registry::get("MSF_ActionBar");
		$this->aSettings		= $this->buildSettings();
		$iDoctypeId				= 0;
		if ($bInitializing) {
			if ($CallerAction === null) {
				$iDoctypeId = $this->Db->getDoctypeId($iDocumentId);
				if ($iDoctypeId > 0) {
					$this->Doctype			= new WF_Doctype($iDoctypeId);
					$this->DoctypeVersion	= $this->Doctype->getVersion($this->Db->getDoctypeVersionId($iDocumentId));
					$this->Document 		= $this->DoctypeVersion->getDocument($iDocumentId);
					$this->DocumentVersion 	= ($iDocumentVersionId == 0) ? $this->Document->getCurrentVersion() : $this->Document->getVersion($iDocumentVersionId);
					$this->DelegateValues	= new WF_DelegateValues($this->Document, $this->DoctypeVersion, $this->UserBox->getCurrentStructureId());
					$this->WfValues			= new WF_Values($this->Document, $this->DoctypeVersion);
					$this->iActionId 		= $iActionId;
					$this->sActionName		= $sActionName;
					$this->aSpa				= $this->buildSpa($this->DoctypeVersion->getSpaXml());
					$this->aRoute			= $this->buildRoute($this->DoctypeVersion->getRouteXml());
					$this->Log				= WF_Log::newInstance($Db, $iDocumentId);
					$bInitialized 			= true;
					$isMain					= true;
					$this->debug();
					
				}
				else {
					$isMain					= false;
					$bInitialized 			= false;
				}
							
			}
			else {
					$this->Doctype			= $CallerAction->getDoctype();
					$this->DoctypeVersion	= $CallerAction->getDoctypeVersion();
					$this->Document 		= $CallerAction->getDocument();
					$this->DocumentVersion 	= $CallerAction->getDocumentVersion();
					$this->DelegateValues	= new WF_DelegateValues($this->Document, $this->DoctypeVersion, $this->UserBox->getCurrentStructureId());
					$this->WfValues			= new WF_Values($this->Document, $this->DoctypeVersion);
					$this->iActionId 		= $iActionId;
					$this->sActionName		= $sActionName;
					$this->aSpa				= $CallerAction->getSpa();
					$this->aRoute			= $CallerAction->getRoute();
					$this->Log				= $CallerAction->getLogInstance();
					$bInitialized 			= true;
					$isMain					= false;

			}

		}
		else {
			$bInitialized 	= false;
			$isMain			= false;
		}

		$oDb 		= MSF_Registry::get("MSF_DB");
		$oStructure	= MSF_Registry::get("MSF_UserBox");
		$this->setInitParam("initialized", $bInitialized);
		$this->setInitParam("allowed", true);
		$aAllowed	= array("view", "remove");
		if ($bInitialized && (in_array($sActionName, $aAllowed))) {
			$oDSwitcher = new WF_DocumentSwitcher($oDb);
			if ($oDSwitcher->hasAccess("view", WF_Utils::getPath(), array("document_id"=>$iDocumentId))) {
				$isAllowed = true;
			}
			else {
				$oDtSwitcher 	= new WF_DoctypeSwitcher($oDb);
				$aParams 		= array(
						"doctype_id" 	=> $iDoctypeId,
						"author_id"		=> $this->Document->getStructureId()
						);
				$isAllowed	 = $oDtSwitcher->hasAccess("view", WF_Utils::getPath(), $aParams);
			}
			
			if ($isMain) {
				$sStructure		= $oStructure->getCurrentStructurePath();
				$aStructure		= explode(".", $sStructure);
				$iStructureId	= $aStructure[count($aStructure) - 1];
				$iAuthorId		= $this->Document->getStructureId();
				if ($isAllowed || ($iStructureId == $iAuthorId)) {
					//echo "<div>Execute block launched</div>";
					$this->execute();
				}
				else {
					//echo("<br/>DENY:" . $sActionName .  ":" .  __FILE__ . ':'. __LINE__ . "<br/>");
					MSF_AccessDenied::exitApp("viewAction()");
				}
			}

			
		}

	}
	
	/**
	 * @return array
	 * @access private
	 */
	private function buildSettings()
	{
		$aWFSettings 		= MSF_Registry::get("MSF_Settings")->getModule("workflow");
		$aResultSettings 	= array();
		foreach ($aWFSettings["actions"] AS $aWFAppSettings) {
			$aSettings = (isset($aWFAppSettings["settings"])) ? $aWFAppSettings["settings"]: array();
			$aResultSettings[$aWFAppSettings["name"]] = $aSettings;
			
		}

		return $aResultSettings;
	}
	
	/**
	 * Vozvrashaet nastroiki deistbiy. Esli deistvie
	 * ukazanno, to vozvrashautsya tolko ego nastroiki
	 *
	 * @param string $sActionName
	 * @return array
	 * @access public
	 */
	public function getSettings($sActionName = null)
	{
		if ($sActionName == null) {
			$aResult = $this->aSettings;
		}
		else {
			$aResult = $this->aSettings[$sActionName];
		}
		
		return $aResult;
	}
	
	/**
	 * Debug functiya. Raspechativaet peremennie documenta, uidet iz prodaction versii
	 *
	 * @return void
	 * @access public
	 */
	public function debug()
	{
		echo "<div>";
		echo "<b> doctype id:</b> " 				. $this->Doctype->getDoctypeId();
		echo "<b> doctype version id:</b> " 		. $this->Doctype->getDoctypeVersionId();
		echo "<b> document id:</b> " 				. $this->Document->getDocumentId();
		echo "<b> document version id:</b> " 		. $this->Document->getDocumentVersionId();
		echo "<b> doctype version extname:</b> " 	. $this->DoctypeVersion->getExtname();
		echo "</div>";
		echo "<div>";
		echo "<b> point id:</b> " 					. $this->Document->getPointId();
		echo "<b> spa:</b> " 						. (count((array)$this->getSpa()) == 0 ? "none" : "filled");
		echo "<b> route:</b> " 						. (count((array)$this->getRoute()) == 0 ? "none" : "filled");
		echo "<b> registration number:</b> " 		. (strlen($this->Document->getRegistrationNumber() == 0) ? "none" : $this->Document->getRegistrationNumber());
		echo "<b> route:</b> " 						. $this->Document->getEmployeeName()."(". $this->Document->getStructureId().")";
		echo "</div>";
	}
	
	/**
	 * Vozvrashaet template
	 *
	 * @return MSF_Template
	 * @access public
	 */
	public function getTemplate()
	{
		return $this->Template;
	}
	
	/**
	 * Vozvrashaet node modulya
	 *
	 * @return DOMElement
	 * @access public
	 */
	public function getModule()
	{
		return $this->Template->getmodule();
	}
	
	/**
	 * Dobavlyaet file modulya
	 *
	 * @param string $sModuleName
	 * @access public
	 */
	public function addLinksOf($sModuleName)
	{
		$this->Template->addLinksOf(CNF_ABS_PATH . "/modules/" . $sModuleName . "/view/links.ini");
	}
	
	/**
	 * Vozvrashaet url perenapravleniya deistviya
	 *
	 * @return string
	 * @access public
	 */
	public function getRedirectUrl()
	{
		if ($this->sRedirectUrl == "") {
			if ($this->Document !== null) {
				$this->sRedirectUrl = $this->getRedirectUrlToDocument($this->Document->getDocumentId());
			}
			
		}
		
		return $this->sRedirectUrl;
	}
	/**
	 * Vozvrashaet url perenapravleniya k documenty
	 *
	 * @param int $iDocumentId
	 * @return string
	 * @access public
	 */
	public function getRedirectUrlToDocument($iDocumentId)
	{
		return "/workflow/document/view/" . $iDocumentId;
	}
	
	/**
	 * Ustanavlivaet url perenapravleniya
	 *
	 * @param string $sRedirectUrl
	 * @return void
	 * @access public
	 */
	public function setRedirectUrl($sRedirectUrl)
	{
		$this->sRedirectUrl = $sRedirectUrl;
	}
	
	/**
	 * @param string $sRouteXml
	 * @return array
	 */
	private function buildRoute($sRouteXml)
	{
		$aRoute 		= MSF_XmlWrapper::xmlToArray($sRouteXml);
		$iDocumentId 	= $this->Document->getDocumentId();
		foreach ($aRoute AS $iPointId => $aPointBody) {
			if (isset($aPointBody["value"]["execute"])) {
				$iExecuteLength = $aPointBody["value"]["execute"];
				for ($i = 0; $i < count($iExecuteLength); $i++) {
					$iSpaId = $this->getDynamicActionId($iDocumentId, $iPointId, $i);
					$aRoute[$iPointId]["value"]["execute"][$i]["spa_id"] = $iSpaId;
					$this->reflectOnSpa(
							$iSpaId,
							$aRoute[$iPointId]["value"]["execute"][$i]["name"],
							$aRoute[$iPointId]["value"]["execute"][$i]["value"]
							);
				}
				
			}
			
		}

		return $aRoute;
	}
	
	/**
	 * Vozvrashaet marshrut
	 *
	 * @return array
	 * @access public
	 */
	public function getRoute() {
		return $this->aRoute;
	}
	
	/**
	 * Vozvrashaet spa
	 *
	 * @return array
	 * @access public
	 */
	public function getSpa() {
		return $this->aSpa;
	}
	
	/**
	 * Vozvrashaet action id
	 *
	 * @param int $iDocumentId
	 * @param int $iPointId
	 * @param int $iSystemId
	 * @return int
	 * @access public
	 */
	public function getDynamicActionId($iDocumentId, $iPointId, $iSystemId) {
		return (int) $iDocumentId . $iPointId . $iSystemId;
	}
	
	/**
	 * Proveryaet, est li dostup
	 *
	 * @return bool
	 * @access public
	 */
	public function hasAccess()
	{
		return $this->DelegateValues->isDelegated($this->getActionId());
	}
	
	/**
	 * Prevrashaet SpaXML v massiv
	 *
	 * @param string $sSpaXml
	 * @return array
	 * @access private
	 */
	private function buildSpa($sSpaXml) {
		$aSpa 		= MSF_XmlWrapper::xmlToArray($sSpaXml);
		$aSpa[0]	= array (
						"title" => "__VIEW__",
						"value" => array(
								"action" 	=> "view",
								"value"		=> array()
								)
						);
		return $aSpa;
	}
	
	private function reflectOnSpa($iSpaId, $sSpaName, $aSpaValue) {
		$this->aSpa[$iSpaId] = array (
				"title"		=> "__" . strtoupper($sSpaName) . "__",
				"value" 	=> array (
						"action"	=> $sSpaName,
						"value"		=> $aSpaValue
						)
				);
	}
	
	
	/**
	 * tipa zaglushka, hotya mozhet i zdes ostanetsya
	 *
	 * @return bool
	 */
	public function isInWait()
	{
		return $this->DelegateValues->isInWait($this->Document->getPointId(), $this->getActionId());
	}
	
	public function isFinalPoint()
	{
		$aRoute	= $this->getRoute();
		return !isset($aRoute[($this->getPointId() + 1)]);
	}
	
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// Params
	/////////////////////////////////////////////////////////////////////////////////////////////////

	final public function setInitParam($sName, $mValue)
	{
		$this->aInitParams[$sName] = $mValue;
	}

	final public function unsetInitParam($sName)
	{
		if ($this->hasInitParam($sName)) {
			unset($this->aInitParams[$sName]);
		}

	}

	final public function hasInitParam($sName)
	{
		return array_key_exists($sName, $this->aInitParams);
	}

	final public function getInitParam($sName)
	{
		$mResult = array();
		if ($this->hasInitParam($sName)) {
			$mResult = $this->aInitParams[$sName];
		}
		else {
			$mResult = null;
		}

		return $mResult;
	}

	final public function setParam($sName, $mValue)
	{
		$this->aParams[$sName] = $mValue;
	}

	final public function unsetParam($sName)
	{
		if ($this->hasParam($sName)) {
			unset($this->aParams[$sName]);
		}

	}

	final public function hasParam($sName)
	{
		return array_key_exists($sName, $this->aParams);
	}

	final public function getParam($sName, $sKey = null, $mDeafult = null)
	{
		$mResult = array();
		if ($this->hasParam($sName)) {
			if ($sKey == null) {
				$mResult = $this->aParams[$sName];
			}
			else {
				$mResult = MSF_SL::getParam($this->aParams[$sName], $sKey, $mDeafult);
			}
			
		}
		else {
			$mResult = null;
		}

		return $mResult;
	}
	
	final protected function toStructureIds($aTypeValue)
	{
		return $this->WfValues->toStructureIds($aTypeValue);
	}
	
	final protected function isVersion()
	{
		return $this->isVersion;
	}
	
	final protected function getStructureValues()
	{
		return $this->WfValues->getStructureValues();
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// Action
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	final public function getActionId()
	{
		return $this->iActionId;
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// 4 D's
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	final public function getDoctype()
	{
		return $this->Doctype;
	}

	final public function getDoctypeVersion()
	{
		return $this->DoctypeVersion;
	}
	
	final public function getDocument()
	{
		return $this->Document;
	}

	final public function getDocumentVersion()
	{
		return $this->DocumentVersion;
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// Logs
	/////////////////////////////////////////////////////////////////////////////////////////////////

	final public function getLog($iPointId, $iActionId)
	{
		return $this->Log->get($iPointId, $iActionId);
	}
	
	/**
	 * @return MSF_Log
	 */
	final public function getLogInstance()
	{
		return $this->Log;
	}
	
	final public function getAllLogs()
	{
		return $this->Log->getAllSortedByDate();
	}

	final public function addLog($iPointId, $iActionId, $aValue, $iStructure = 0, $sEmployeeName = "")
	{
		if ($iStructure == 0) {
			$iStructure 	= $this->getStructureId();
			$sEmployeeName 	= $this->getEmployeeName();
		}
		
		$this->Log->setStructureId($iStructure);
		$this->Log->setEmployeeName($sEmployeeName);
		$this->Log->add($iPointId, $iActionId, $aValue);
	}
	
	final public function removeLog($iPointId, $iActionId)
	{
		$this->Log->remove($iPointId, $iActionId);
	}
	
	final public function logStatus($iStatus)
	{
		$aToSave						= array();
		$aToSave["system"]				= array();
		$aToSave["system"]["status"]	= $iStatus;
		$this->addLog($this->Document->getPointId(), $this->getActionId(), $aToSave);
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// Router
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	final public function getCountOfPoints()
	{
		return count($this->aRoute);
	}
	
	final public function getPointId()
	{
		if ($this->Document !== null) {
			return $this->getDocument()->getPointId();
		}
		else {
			return 0;
		}

	}
	
	final public function isPointExisted($iPointId)
	{
		return array_key_exists($iPointId, $this->aRoute);
	}
	
	final public function getDelegateAtPoint($iPointId)
	{
		return $this->getXxxAtPoint("delegate", $iPointId);
	}
	
	final public function getExecuteAtPoint($iPointId)
	{
		return $this->getXxxAtPoint("execute", $iPointId);
	}
	
	final public function getWaitAtPoint($iPointId)
	{
		return $this->getXxxAtPoint("wait", $iPointId);
	}
	
	final public function getControlAtPoint($iPointId)
	{
		return $this->getXxxAtPoint("control", $iPointId);
	}
	
	final public function getTitleAtPoint($iPointId)
	{
		if ($this->isPointExisted($iPointId)) {
			$sResult = $this->aRoute[$iPointId]["title"];
		}
		else {
			$sResult = "";
		}
		if ($iPointId == self::FINISH_POINT) {
			$sResult = MSF_Registry::get("MSF_Locale")->getWord("WORKFLOW_FINISH_POINT");
		}
		
		return $sResult;
	}
	
	final public function isRouteFinished()
	{
		return ($this->getCountOfPoints() >= 500) ? true : false;
	}
	
	final public function editPoint($iPointId)
	{
		$bResult = false;
		if ($iPointId == self::FINISH_POINT || $this->isPointExisted($iPointId)) {
			$this->Document->setPointId($iPointId);
			$this->Document->setStatus($this->getTitleAtPoint($iPointId));
			$this->Document->save();
			$bResult = true;
		}

		return $bResult;
	}

	final private function getXxxAtPoint($sXxx, $iPointId)
	{
		if ($this->isPointExisted($iPointId)) {
			if (isset($this->aRoute[$iPointId]["value"][$sXxx])) {
				$aResult = $this->aRoute[$iPointId]["value"][$sXxx];
			}
			else {
				$aResult = array();
			}
			
		}
		else {
			$aResult = array();
		}
		
		return $aResult;
	}
	
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// Spa
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	final public function getSpaActionName($iSpaId)
	{
		if ($this->isSpaActionExists($iSpaId)) {
			$mResult = $this->aSpa[$iSpaId]["value"]["action"];
		}
		else {
			$mResult = "";
		}
		
		return $mResult;
	}
	
	// TODO переправить на нормальный стиль
	final public function getFullSpaList()
	{
		$aFullSpaList = array();
		foreach ($this->aSpa AS $iId => $aValue) {
			$aFullSpaList[] = $iId;
		}
		
		return $aFullSpaList;
	}
	
	final public function getCurrentSpaList()
	{
		$aSpaList 	= array();
		$iPointId	= $this->getDocument()->getPointId();
		$aDelegate 	= $this->getDelegateAtPoint($iPointId);
		foreach ($aDelegate AS $aItem) {
			//debug($this->isSpaActionExists($aItem["spa_id"]), $aItem);
			if ($this->isSpaActionExists($aItem["spa_id"])) {
				$aSpaList[] = $aItem["spa_id"];
			}
			
		}

		return $aSpaList;
	}
	
	final public function isSpaActionExists($iSpaActionId)
	{
		//debug($this->aSpa, $this->aRoute);
		return (array_key_exists($iSpaActionId, $this->aSpa));
	}
	
	final public function getSpaAction($iSpaActionId)
	{
		if ($this->isSpaActionExists($iSpaActionId)) {
			$mResult = $this->aSpa[$iSpaActionId];
			$mResult["settings"] = $this->getSettings($mResult["value"]["action"]);
		}
		else {
			$mResult = null;
		}
		
		return $mResult;
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// View
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	final public function setView($View)
	{
		$this->View = $View;
	}
	
	final public function getView()
	{
		if ($this->View == null) {
			$this->View = new MSF_ViewSupportXml();
		}
		
		return $this->View;
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// WF_IAction realization
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	private function verifySpa()
	{
		switch ($this->iActionId) {
			case 0:
				if ($this->sActionName !== "xxx") {
					throw new WF_ActionRuntimeException("Validation of SPA failed cuz 0 not eq view");
				}
				
				break;
			default:
				$sAction = $this->getSpaActionName($this->iActionId);
				if ((strlen($sAction) == 0) || ($this->sActionName !== $sAction)) {
					throw new WF_ActionRuntimeException("Validation of SPA failed");
				}

				break;
		}
		
	}
		
	private function verifyDelegate()
	{
			
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// user
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	public function getStructureId() {
		return $this->UserBox->getCurrentStructureId();
	}
	
	public function getEmployeeName() {
		return $this->UserBox->getEmployeeAttribute("name");
	}
	
	public function call($sAction, $aParams, $sType = "call", $bInitializing = true,
						 $iActionId = 0, $iSubjectId = 0, $iSubjectVersionId = 0)
	{
		$Ab 				= WF_ActionBox::newInstance();
		$iActionId 			= ($iActionId == 0) ? $this->getActionId() : $iActionId;
		//$iSubjectId			= ($iSubjectId == 0) ? $this->getInitParam("subject_id") : $iSubjectId;
		//$iSubjectVersionId	= ($iSubjectVersionId == 0) ? $this->getInitParam("subject_version_id") : $iSubjectVersionId;
		//debug($sAction, $iSubjectId, $iSubjectVersionId);
		$iSubjectId			= ($iSubjectId == 0) ? $this->getDocument()->getDocumentId() : $iSubjectId;
		$iSubjectVersionId	= ($iSubjectVersionId == 0) ? $this->getDocumentVersion()->getDocumentVersionId() : $iSubjectVersionId;
		$Ab->loadAction(
				$sAction,
				$iActionId,
				$this->getInitParam("subject_id"),
				$this->getInitParam("subject_version_id"),
				$bInitializing,
				$this
				);

		$Ab->setInitParam("spa_name", 				$sAction);
		$Ab->setInitParam("spa_id", 				$iActionId);
		$Ab->setInitParam("subject_id", 			$iSubjectId);
		$Ab->setInitParam("subject_version_id", 	$iSubjectVersionId);
		$Ab->setInitParam("initializing", 			$bInitializing);
		foreach ($aParams AS $sName => $mValue) {
			$Ab->setParam($sName, $mValue);
		}
		return $Ab->process($sType);
	}
	
	public function getActionName()
	{
		return $this->sActionName;
	}
	
	public function addSpaToActionBar()
	{
		if(!in_array($this->getActionId(), self::$aActionBarActions)) {
			if($this->DelegateValues->isDelegated($this->getActionId())) {
				$aSpa = $this->getSpaAction($this->getActionId());
				if (isset($aSpa["value"]["value"]["common"]["window_title"])) {
					$sWindowTitle = trim($aSpa["value"]["value"]["common"]["window_title"]);
				}
				
				if (empty($sWindowTitle)) {
					$sWindowTitle = $this->getParam("title");
				}
				
				$this->getActionBar()->addAction(
					$this->getParam("title"),
					"#" . $this->getActionId(),
					CNX_ACTIONBAR_IMG,
					"showActionWindow(this, 'action_window_" . $this->getActionId() . "', " . $this->isActionVisible() . ", '" . $sWindowTitle . "'); return false;"
				);
				array_push(self::$aActionBarActions, $this->getActionId());
			}
			
		}
	}
	
	private function isActionVisible()
	{
		$iVisible 	= 0;
		$aSpa 		= $this->getSpaAction($this->getActionId());
		
		if (isset($aSpa["value"]["value"]["common"]["visible"])) {
			$iVisible = $aSpa["value"]["value"]["common"]["visible"];
		}
		
		return $iVisible;
	}
	
	public function addSpaXml($SpaNode)
	{
		$iSpaId			= $this->iActionId;
		$sSpaTitle 		= $this->getParam("title");
		$sSpaName		= $this->sActionName;
		$aSpaValue		= $this->getParam("value");
		$aSpaSettings	= $this->getSettings($this->sActionName);
		$ElmAction	= $this->Template->createElement("action");
		$ElmAction->setAttribute("id", 		$iSpaId);
		$ElmAction->setAttribute("title",	$sSpaTitle);
		$ElmAction->setAttribute("type", 	$sSpaName);
		foreach ($aSpaSettings AS $sName => $sValue) {
			$ElmAction->setAttribute($sName, $sValue);
		}

		$aAction = (array) $aSpaValue;
		foreach ($aAction as $sGroupname => $aValues) {
			$ElmItem = $this->Template->createElement("item");
			$ElmItem->setAttribute("name", $sGroupname);
			foreach ((array)$aValues AS $sKey => $mValue) {
				$ElmSubItem = $this->Template->createElement("item");
				$ElmSubItem->setAttribute("name", $sKey);
				if (is_array($mValue)) {
					foreach ($mValue AS $sKey1 => $sValue1) {
						$ElmArrayItem = $this->Template->createElement("item");
						$ElmArrayItem->setAttribute("name", $sKey1);
						$ElmArrayItem->setAttribute("value", $sValue1);
						$ElmSubItem->appendChild($ElmArrayItem);
					}

				}
				else {
					$ElmSubItem->setAttribute("value", $mValue);
				}

				$ElmItem->appendChild($ElmSubItem);
			}

			$ElmAction->appendChild($ElmItem);

		}

		$SpaNode->appendChild($ElmAction);
	}
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	// WF_IAction realization
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	public function initialize()
	{

	}
	
	public function prepareSpa($aSpaValue)
	{
		//
	}
		
	public function getLogTitle()
	{
		return "__NO_TITLE_FOR_THIS_LOG__";
	}

	public function getLogParams()
	{
		return array();
	}
	
	public function processObject()
	{
		return $this;
	}

	public function processExecute()
	{
		return self::FAILURE;
	}

	public function processSchedule()
	{
		return self::FAILURE;
	}
	
	public function processCall()
	{
		return self::FAILURE;
	}

	public function processRequest()
	{
		return self::FAILURE;
	}

	public function cancel()
	{
		$this->saveCurrentHabitat(array());
	}

	final public function saveCurrentHabitat($aHabitat)
	{
		$this->addLog(
				$this->getDocument()->getPointId(),
				$this->getActionId(),
				$aHabitat
				);
	}
	
	final public function getCurrentHabitat()
	{
		$iPointId 		= $this->getDocument()->getPointId();
		$iActionId 		= $this->getActionId();
		$aTempHabitat 	= $this->getLog($iPointId, $iActionId);
		$aHabitat = array();

		if (empty($aTempHabitat)) {
			$aHabitat["execute"] = $this->prepareHabitatExecute();
		}
		else {
			$aLogIds 		= array();
			foreach ($aTempHabitat AS $iLogId => $aLogBody) {
				$aLogIds[] = $iLogId;
			}
			
			$iLastestLog 	= array_pop($aLogIds);
			$this->getLogInstance()->removeByLogId($aLogIds);
			$aHabitat = $aTempHabitat[$iLastestLog]["value"];

		}
		
		return $aHabitat;
	}
	
	final private function prepareHabitatExecute()
	{

		$aHabitatExecute 	= array();
		$aRoute 			= $this->getRoute();
		foreach ($aRoute AS $iPointId => $aPoint) {
			$aHabitatExecute[$iPointId] = array();
			if (isset($aPoint["value"]["execute"])) {
				foreach ($aPoint["value"]["execute"] AS $aExecuteBody) {
					$iSpaId = $aExecuteBody["spa_id"];
					$aHabitatExecute[$iPointId][$iSpaId] = WF_IAction::WAIT;
				}
				
			}
			
		}

		return $aHabitatExecute;
	}
	
	private function execute()
	{
		$iPointId	= $this->getDocument()->getPointId();
		if ((count($this->aRoute) > 0) && ($this->getActionName() == "view") && ($iPointId < 500)) {
			$bIsModified= false;
			$aPoint 	= $this->aRoute[$this->Document->getPointId()];
			$aCfg 		= MSF_Registry::get("MSF_Settings")->getXmlWrapper()->get("modules")->getValue("workflow");
			$aActions 	= array();
			$aCurrentHabitat = array();
			foreach ($aCfg["actions"] AS $aAction) {
				$aActions[$aAction["name"]] = $aAction["classname"];
			}
			if (isset($aPoint["value"]["execute"])) {
				$aCurrentHabitat = $this->getCurrentHabitat();
				if (isset($aCurrentHabitat["execute"])) {
					foreach ($aPoint["value"]["execute"] AS $iId => $aAction) {
						if (array_key_exists($aAction["spa_id"], $aCurrentHabitat["execute"][$iPointId])) {
							switch ((int)$aCurrentHabitat["execute"][$iPointId][$aAction["spa_id"]]) {
								case  WF_IAction::SUCCESS:
									break;
								case  WF_IAction::WAIT:
									$iStatus 		= $this->call($aAction["name"], array(), "execute", true, $aAction["spa_id"]);
									$aCurrentHabitat["execute"][$iPointId][$aAction["spa_id"]] = $iStatus;
									if ($iStatus == WF_IAction::SUCCESS) {
										$this->saveCurrentHabitat($aCurrentHabitat);
										$bRedirect 		= true;
									}

									break;
								case  WF_IAction::WAIT:
									$iStatus 		= $this->call($aAction["name"], array(), "execute", true, $aAction["spa_id"]);
									$aCurrentHabitat["execute"][$iPointId][$aAction["spa_id"]] = $iStatus;
									if ($iStatus == WF_IAction::SUCCESS) {
										$this->saveCurrentHabitat($aCurrentHabitat);
										$bRedirect 		= true;
									}

									break;
								case  WF_IAction::FAILURE:
									// log
									break;
							}

						}

					}

				}

			}
			
			if (!empty($bRedirect)) {
				//MSF_Registry::get("MSF_Messenger")->redirect("/workflow/document/view/".$this->getDocument()->getDocumentId());
			}
			
		}
		
	}

}

?>