<?php
defined("__MSF")
		or die("Direct access is not allowed");
		
include_once "WF_ActionBuilder.php";
include_once "modules/media/library/WF_MediaId.php";
include_once "modules/workflow/library/doctypeVersion/WF_DelegateValues.php";

/**
 * @package 	workflow
 * @copyright 	Copyright (c) 2007, Detrix
 */
abstract class WF_ActionSupport extends WF_ActionBuilder
{
	/**
	 * @var REF_Template
	 */
	private $DocumentTemplate;

	/**
	 * @var MSF_ViewSupportXml
	 */
	private $View	= null;
	
	private $sActionTitle	= null;
	
	public $iRequestId		= 0;
	
	/**
	 * @return REF_Template
	 */
	final public function getDocumentTemplate()
	{
		if(!$this->DocumentTemplate) {
			$MediaId = new WF_MediaId();			
			$MediaId->generate();
			
			$WFVars 	= new WF_Vars($this);
			
			$this->DocumentTemplate	= new REF_Template($this->getDoctypeVersion()->getTemplateXml());
			$this->DocumentTemplate->setExtra("workflow_document", $MediaId->get());
			$this->DocumentTemplate->setUniqueId($this->getDoctype()->getDoctypeId());
			$this->DocumentTemplate->setUniqueType(MSF_UniqueField::TYPE_DOCTYPE);
			
			$this->DocumentTemplate->setVars($WFVars);
		}
		
		return $this->DocumentTemplate;
	}
	
	final public function setView($View)
	{
		$this->View = $View;
	}
	
	final public function getView()
	{
		if ($this->View == null) {
			$this->View = new MSF_ViewSupportXml();
		}
		
		return $this->View;
	}
	
	/**
	 * @return MSF_Template
	 */
	final public function getTemplate()
	{
		return MSF_Registry::get("MSF_Template");
	}

	final public function addLinksOf($sModuleName)
	{
		$this->Template->addLinksOf(CNF_ABS_PATH . "/modules/" . $sModuleName . "/view/links.ini");
	}
	
	final public function getActionTitle()
	{		
		if($this->sActionTitle === null) {
			$aActions	= $this->getSettings()->getPureActions();
			if(isset($aActions[$this->getActionId()]) && isset($aActions[$this->getActionId()]["title"])) {
				$this->sActionTitle	= $aActions[$this->getActionId()]["title"];
			}
			else {
				$this->sActionTitle	= "";
			}
			
		}
		
		return $this->sActionTitle;
	}
	
}


?>