<?php

class WF_DocCache
{
	private $sDtPath = "";
	
	private $sDocPath = "";
	
	public function __construct($iDtId, $iDocId = 0)
	{
		$this->sDtPath 	= CNF_ABS_PATH . "/var/docs/" . $iDtId;	
		$this->sDocPath = $this->sDtPath . "/" . $iDocId;	
	}
	
	public function exists()
	{
		return MSF_File::exists($this->sDocPath);
	}
	
	public function save($sContent)
	{
		if (!MSF_Dir::exists($this->sDtPath)) {
			MSF_Dir::create($this->sDtPath);
		}
		
		MSF_File::write($this->sDocPath, $sContent);
	}	
	
	public function load()
	{
		try {
			$sResult = MSF_File::read($this->sDocPath);
		}
		catch (Exception $oE) {
			MSF_Logger::log($oE);
			$sResult = "";
		}
		
		return $sResult;
	}	
	
	public function remove()
	{
		if ($this->exists()) {
			MSF_File::remove($this->sDocPath);
		}
		
	}

	public function reset()
	{
		try {
			if (MSF_Dir::exists($this->sDtPath)) {
				MSF_Dir::remove($this->sDtPath);
			}
		}
		catch (Exception $oE) {
			MSF_Logger::logTrace($oE);
		}


	}
	
}
