<?php
/**
 * @author
 */
class WF_ExecutionContext
{
	/**
	 * @var WF_ActionSupport
	 */
	private $oAction 	= null;
	
	private $aExecute 	= array();
	
	/**
	 * @var WF_Log
	 */
	private $oLog		= null;
	
	private $iPointId	= 0;
	

	public function __construct(WF_ActionSupport $oAction)
	{
		$this->oAction 				= $oAction;
		$this->oAction->iRequestId 	= $this->oAction->getActionId();
		$this->oLog					= $oAction->getDocument()->getLog();
		$this->iPointId				= $oAction->getDocument()->getPointId();
		$this->aExecute 			= $oAction->getSettings()->getExecutionAtPoint($this->iPointId);
	}
	
	public function execute()
	{				
		$iStructureId 	= $this->oLog->getStructureId();
		$sEmployeeName	= $this->oLog->getEmployeeName();
		$bSuccess 		= false;					
		$this->set(0, "Detrix");
		try {
			for ($i = 0; $i < count($this->aExecute); $i++) {	
				if ($this->isExecuted($i)) {
					$bSuccess = true;
					if ($this->isPointChanged()) {
						break;
					}
					
				}

			}			

		}
		catch (Exception $e) {
			MSF_Logger::logTrace($e);
			if (CNF_MODE == "debug") {
				debug($e);
			}
			else {
				$this->logError($i);
			}

		}

		$this->set($iStructureId, $sEmployeeName);
		return $bSuccess;
	}
	
	private function set($iStructureId, $sEmployeeName) 
	{
		$this->oLog->setStructureId($iStructureId);
		$this->oLog->setEmployeeName($sEmployeeName);
	} 
	
	private function devLog($i)
	{
		$this->set(0, "DEBUG");
		$this->oLog->display($this->aExecute[$i]["title"], $this->iPointId . ", " . $this->aExecute[$i]["spa_id"]);
		$this->set(0, "Detrix");
	}
	
	private function isExecuted($i)
	{
		if (!$this->oLog->isExecuted($this->iPointId, $this->aExecute[$i]["spa_id"])) {
			switch ($this->oAction->call(
					$this->aExecute[$i]["name"], 
					array(), 
					"execute", 
					true, 
					$this->aExecute[$i]["spa_id"]
					)) {
				case WF_IAction::SUCCESS:
					$this->oLog->addExecuted($this->iPointId, $this->aExecute[$i]["spa_id"]);
					$this->devLog($i);
					$this->oAction->save();
					return true;
				case WF_IAction::NULL:
					$this->devLog($i);
					$this->oAction->save();
				default: // case WF_IAction::SUCCESS:
					return false;
			}									
			
		}
		else {
			return false;
		}
		
	}
	
	private function isPointChanged()
	{
		return $this->iPointId !== $this->oAction->getDocument()->getPointId();
	}
	
	private function logError($i)
	{
		$oL = MSF_Registry::get("MSF_Locale");
		$sM = $oL->getWord("WF_CONTEXT_EXECUTION_NOT_CORRECT_PARAMS");
		$sT = $this->aExecute[$i]["title"];
		$this->oLog->display($sT, $sM);
	}

}