<?php

defined("__MSF")
	or die("Direct access is not allowed");

include_once CNF_ABS_PATH . "/components/WorkFlow/library/WF_Exception.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/doctypeVersion/WF_DoctypeVersionDB.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/doctypeVersion/WF_DoctypeVersion.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/doctype/WF_DoctypeDB.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/doctype/WF_Doctype.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/documentVersion/WF_DocumentVersionDB.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/documentVersion/WF_DocumentVersion.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/document/WF_DocumentDB.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/document/WF_Document.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/WF_Employee.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/WF_Form.php";

class WF_DoctypeProcessor
{
	private $DB;

	private $bMode;

	private $Com;

	private $iDocumentId = 0;

	public function __construct(MSF_DB $DB, $bMode = false, $Com = null)
	{
		$this->DB 		= $DB;
		$this->bMode 	= $bMode;
		$this->Com 		= $Com;
	}

	public function show()
	{
		$Doctype = new WF_Doctype(new WF_DoctypeDB($this->DB));
		if ($Doctype->exists(P_ID)) {
			$Doctype->load(P_ID); //
			$DoctypeVersion = new WF_DoctypeVersion($Doctype, new WF_DoctypeVersionDB(MSF_Registry::get("MSF_DB")));
			$DoctypeVersion->load();

			$Template = $DoctypeVersion->getTemplateXml();
			$Form = new WF_Form($Template, $this->Com);
			$Form->setMode($this->bMode);
			$Form->setFields($Template->getFields());
			$Form->display();
		}
	}

	public function save()
	{
		$Doctype = new WF_Doctype(new WF_DoctypeDB($this->DB));

		if ($Doctype->exists(P_ID)) {
			$User				= MSF_Registry::get("MSF_User");
			$OS					= MSF_Registry::get("MSF_OrgStructure");
			$aId				= $OS->getEmployeeId($User->getId());
			$Employee 			= new WF_Employee($aId[0], $User->getFullname());
			$Doctype->load(P_ID);
			$DoctypeVersion 	= new WF_DoctypeVersion($Doctype, new WF_DoctypeVersionDB($this->DB));
			$DocumentVersion 	= new WF_DocumentVersion($Doctype, new WF_DocumentVersionDB($this->DB));
			$Document 			= new WF_Document(new WF_DocumentDB($this->DB));

			$DoctypeVersion->load($Doctype->getDoctypeVersionId());

			$Template = $DoctypeVersion->getTemplateXml();

			$DocumentVersion->setEmployee($Employee);
			$DocumentVersion->setDoctypeVersion($DoctypeVersion);
			$DocumentVersion->setFields($Template->getFields($_POST));
			$Document->setEmployee($Employee);

			if (!$Document->exists()) {
				$Document->create($DocumentVersion);
			}

			$DocumentVersion->create($Document);
			$Document->setDocumentVersionId($DocumentVersion->getDocumentVersionId());
			$Document->save();
			$this->iDocumentId = $Document->getDocumentId();
		}
	}

	public function getDocumentId()
	{
		return $this->iDocumentId;
	}
}

?>