<?php

defined("__MSF")
	or die("Direct access is not allowed");

include_once CNF_ABS_PATH . "/components/WorkFlow/library/WF_Exception.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/doctype/WF_DoctypeDB.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/doctype/WF_Doctype.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/doctypeVersion/WF_DoctypeVersionDB.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/doctypeVersion/WF_DoctypeVersion.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/documentVersion/WF_DocumentVersionDB.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/documentVersion/WF_DocumentVersion.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/document/WF_DocumentDB.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/document/WF_Document.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/WF_Employee.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/WF_Form.php";

class WF_DocumentProcessor
{
	private $DB;

	private $bMode;

	private $Com;

	public function __construct(MSF_DB $DB, $bMode = false, $Com = null)
	{
		$this->DB 		= $DB;
		$this->bMode 	= $bMode;
		$this->Com 		= $Com;
	}

	public function show()
	{
		$Document = new WF_Document(new WF_DocumentDB($this->DB));
		if ($Document->exists(P_ID)) {
			$Document->load(P_ID);

			$DocumentVersion 	= new WF_DocumentVersion(new WF_DocumentVersionDB($this->DB));
			$Doctype 			= new WF_Doctype(new WF_DoctypeDB($this->DB));
			$DoctypeVersion 	= new WF_DoctypeVersion(new WF_DoctypeVersionDB($this->DB));

			$DocumentVersion->load($Document->getDocumentVersionId());
			$DoctypeVersion->load($DocumentVersion->getDoctypeVersionId());
			$Template = $DoctypeVersion->getTemplateXml();
			$Form = new WF_Form($Template, $this->Com);
			$Form->setMode($this->bMode);

			$Form->setFields($Template->getFields($DocumentVersion->getFields()));
			$Form->display();
		}
	}

	public function save()
	{
		$Document = new WF_Document(new WF_DocumentDB($this->DB));
		if ($Document->exists(P_ID)) {
			$User				= MSF_Registry::get("MSF_User");
			$OS					= MSF_Registry::get("MSF_OrgStructure");
			$aId				= $OS->getEmployeeId($User->getId());
			$Employee 			= new WF_Employee($aId[0], $User->getFullname());
			$DocumentVersion 	= new WF_DocumentVersion(new WF_DocumentVersionDB($this->DB));
			$NewDocumentVersion	= new WF_DocumentVersion(new WF_DocumentVersionDB($this->DB));
			$DoctypeVersion 	= new WF_DoctypeVersion(new WF_DoctypeVersionDB($this->DB));

			$Document->load(P_ID);
			$DocumentVersion->load($Document->getDocumentVersionId());
			$DoctypeVersion->load($DocumentVersion->getDoctypeVersionId());

			//$DocumentVersion->create($Document);
			//

			$Template = $DoctypeVersion->getTemplateXml();
			$NewDocumentVersion->setDoctypeVersion($DoctypeVersion);
			$NewDocumentVersion->setEmployee($Employee);
			//debug($Template->getFields($_POST));
			$Document->setEmployee($Employee);
			$NewDocumentVersion->setFields($Template->getFields($_POST));
			$NewDocumentVersion->create($Document);
			$Document->setDocumentVersionId($NewDocumentVersion->getDocumentVersionId());
			$Document->save();
		}
	}
}

?>