<?php
defined("__MSF")
	or die("Direct access is not allowed");


include_once "WF_IForm.php";
include_once CNF_ABS_PATH . "/components/WorkFlow/library/WF_RefValue.php";

/**
 * @package WF
 * @author Detrix
 * @copyright Copyright (c)2007 Detrix
 */
class WF_Form implements WF_IForm
{
	private $DocTpl;

	private $MsfTpl;

	private $Root;

	private $bMode;

	private $aFields;

	public function __construct(WF_ITemplate $DocTpl, $Com = null)
	{
		$this->aFields  = array();
		$this->DocTpl	= $DocTpl;
		$this->MsfTpl 	= MSF_Registry::get("MSF_Template");
		$this->Root	 	= $Com;
	}

	public function setMode($bMode)
	{
		$this->bMode = (boolean)$bMode;
	}

	public function setFields($aFields)
	{
		$this->aFields = (array) $aFields;
	}

	/**
	 * @return void
	 */
	public function display()
	{
		//$this->appendControls();
		$this->appendDocumentFields();
		$this->MsfTpl->createTemplateElement(
				"component[@name='WorkFlow']/document",
				$this->DocTpl->getFormXml($this->bMode)
				);
		//
	}
	private function commentDefinition($sXml)
	{
		$sXml = str_replace('<?', '<!--', $sXml);
		return str_replace('?>', '-->', $sXml);
	}
	private function appendDocumentFields()
	{
		$Document = $this->MsfTpl->createElement("document");
		for ($i = 0; $i < count($this->aFields); $i++) {
			if ($this->aFields[$i]["type"] == "reference") {
				if ($this->bMode) {
					$sValue = WF_RefValue::getAsString($this->aFields[$i]["value"], "value");
				}
				else {
					$sValue = WF_RefValue::getAsString($this->aFields[$i]["value"], "id");

				}

			}
			else {
				$sValue = $this->aFields[$i]["value"];
			}

			$Field = $this->MsfTpl->createElement("field", $sValue);
			$Field->setAttribute("name",  $this->aFields[$i]["name"]);
			$Field->setAttribute("title", $this->aFields[$i]["title"]);
			$Field->setAttribute("type",  $this->aFields[$i]["type"]);
			$Document->appendChild($Field);
		}

		$this->Root->appendChild($Document);
	}

	private function appendControls()
	{
		$Controls = $this->MsfTpl->createElement("controls");
		for ($i = 0; $i < count($this->aFields); $i++) {
			/*
			$Control = $this->MsfTpl->createElement("control", $this->aFields[$i]["value"]);
			$Field->setAttribute("name",  $this->aFields[$i]["name"]);
			$Field->setAttribute("title", $this->aFields[$i]["title"]);
			$Field->setAttribute("type",  $this->aFields[$i]["type"]);
			$Controls->appendChild($Field);
			*/
		}

		$this->Root->appendChild($Controls);
	}
}
?>
