<?php
defined("__MSF")
		or die("Direct access is not allowed");

/*
 * Created on 25.10.2007
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */
include_once "modules/workflow/library/doctype/WF_DoctypeDB.php";
include_once "modules/workflow/library/doctype/WF_DoctypeNotExistedException.php";
include_once "modules/workflow/library/doctype/WF_DoctypeNotExistedException.php";
include_once "modules/workflow/library/doctype/WF_DoctypeNotCreatedException.php";
include_once "modules/workflow/library/doctype/WF_DoctypeNotSavedException.php";
include_once "modules/workflow/library/doctype/WF_DoctypeNotRemovedException.php";
include_once "modules/workflow/library/doctype/WF_DoctypeHasNotEmptyVersionException.php";

include_once "modules/workflow/library/doctypeVersion/WF_DoctypeVersion.php";
include_once "modules/workflow/library/doctypeVersion/WF_DoctypeVersionDB.php";

include_once "modules/workflow/library/document/WF_Document.php";
include_once "modules/workflow/library/document/WF_DocumentDB.php";
include_once "modules/workflow/library/doctype/WF_DoctypeDB.php";

include_once "modules/workflow/library/actions/WF_DocCache.php";

/**
 * Doctype
 * @copyright Copyright (c) 2007, Detrix
 */
class WF_Doctype
{
	/***/
	private $DB;

	private $iDoctypeId;

	private $iDoctypeVersionId;

	private $iUserId;

	private $iFolderId;

	private $sTitle;

	private $sDescription;
	
	private $sFullDescription;

	private $sFieldsXml;

	private $sComparedXml;

	private $sCreatedAt;
	
	private $sModifiedAt;
	
	private $sRouteXml;
	
	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// Setters
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	public function setDoctypeVersionId($iDoctypeVersionId)
	{
		$this->iDoctypeVersionId = (int) $iDoctypeVersionId;
	}

	/**
	 * Set's doctype title
	 * @param string $sTitle Doctype's title
	 * @return void
	 */
	public function setTitle($sTitle)
	{
		$this->sTitle = (string) $sTitle;
	}

	public function setDescription($sDescription)
	{
		$this->sDescription = (string) $sDescription;
	}
	
	public function setFullDescription($sDescription)
	{
		$this->sFullDescription	= (string)$sDescription;
	}

	public function setUserId($iUserId)
	{
		$this->iUserId = $iUserId;
	}

	public function setCreatedAt($sCreatedAt)
	{
		$DateFormat = new MSF_Date();
		$this->sCreatedAt = $DateFormat->parseAndFormat($sCreatedAt);
	}
	
	public function setModifiedAt($sModifiedAt)
	{
		$DateFormat = new MSF_Date();
		$this->sModifiedAt = $DateFormat->parseAndFormat($sModifiedAt);
	}

	public function setFieldsXml($sFieldsXml)
	{
		$aEntities = array(
		"&laquo;" 	=> "&#171;",
		"&raquo;" 	=> "&#187;",
		"&ndash;" 	=> "&#8211;",
		"&nbsp"		=> "&#160;",
		"\\"		=> "\\\\"
		);
		foreach ($aEntities AS $sSearch => $sReplace) {
			$sFieldsXml = str_replace($sSearch, $sReplace, $sFieldsXml);
		}
		
		$this->sFieldsXml = $sFieldsXml;
	}
	
	public function setComparedXml($sComparedXml)
	{
		$this->sComparedXml = (string) $sComparedXml;
	}
	
	public function setRouteXml($sRouteXml) {
		$this->sRouteXml = $sRouteXml;
	}
	
	public function getRouteXml() {
		return $this->sRouteXml;
	}

	public function setFolderId($iFolderId)
	{
		$this->iFolderId = (int) $iFolderId;
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// Getters
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////

	/**
	 * Get's doctype ID
	 * @return integer
	 */
	public function getDoctypeId()
	{
		return $this->iDoctypeId;
	}

	public function getDescription()
	{
		return $this->sDescription;
	}

	public function getFullDescription()
	{
		return $this->sFullDescription;
	}
	
	public function getFieldsXml()
	{
		return $this->sFieldsXml;
	}

	public function getComparedXml()
	{
		return $this->sComparedXml;
	}

	public function getFolderId()
	{
		return $this->iFolderId;
	}

	public function getUserId()
	{
		return $this->iUserId;
	}

	public function getTitle()
	{
		return $this->sTitle;
	}

	public function getCreatedAt()
	{
		return $this->sCreatedAt;
	}
	
	public function getModifiedAt()
	{
		return $this->sModifiedAt;
	}

	/**
	 * Get's doctype version ID
	 * @return integer
	 */
	public function getDoctypeVersionId()
	{
		return $this->iDoctypeVersionId;
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// Public Doers
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////

	public function __construct($iDoctypeId = 0)
	{
		$this->reset();
		$this->iDoctypeId 	= (int) $iDoctypeId;
		$this->DB 			= new WF_DoctypeDB(MSF_Registry::get("MSF_DB"));
		if ($this->iDoctypeId > 0) {
			if ($this->exists()) {
				$aDoctype					= $this->DB->select($this->iDoctypeId);
				$this->iDoctypeId			= $aDoctype["doctype_id"];
				$this->iDoctypeVersionId 	= $aDoctype["doctype_version_id"];
				$this->iUserId				= $aDoctype["user_id"];
				$this->sCreatedAt			= $aDoctype["created_at"];
				$this->sModifiedAt			= $aDoctype["modified_at"];
				$this->iFolderId			= $aDoctype["folder_id"];
                                $this->sTitle			 	= $aDoctype["title"]; //MSF_Registry::get("MSF_Locale")->getI18N($aDoctype["title"]);
				$this->sDescription 		= $aDoctype["description"];
				$this->sFullDescription		= $aDoctype["full_description"];
				$this->sFieldsXml 			= $aDoctype["fields_xml"];
				$this->sComparedXml 		= $aDoctype["compared_xml"];
				$this->sRouteXml	 		= $aDoctype["route_xml"];
				/*

				*/
			}
			else {
				throw new WF_DoctypeNotExistedException($this->iDoctypeId);
			}

		}
		else {
			$Date 	= new MSF_Date();
			$sDate 	= $Date->parseAndFormat(date("Y-m-d H:i"));
			$this->sCreatedAt 	= $sDate;
			$this->sModifiedAt 	= $sDate;
		}
	}

	public function exists()
	{
		return ($this->DB->selectCount($this->iDoctypeId) == 1) ? true : false;
	}
	
	public function save()
	{
		$oCache = new WF_DocCache($this->getDoctypeId());
		$oCache->reset();
		if ($this->exists()) {
			$this->DB->update (
					$this->iDoctypeId,
					$this->iDoctypeVersionId,
					$this->sFieldsXml,
					$this->sComparedXml,
					$this->sTitle,
					$this->sDescription,
					$this->sFullDescription,
					$this->iFolderId,
					$this->sModifiedAt,
					$this->sRouteXml
					);

		}
		else {
			$this->iDoctypeId = $this->DB->insert(
				$this->iDoctypeVersionId,
				$this->iUserId,
				$this->iFolderId,
				$this->sFieldsXml,
				$this->sComparedXml,
				$this->sTitle,
				$this->sDescription,
				$this->sFullDescription,
				$this->sCreatedAt,
				$this->sModifiedAt,
				$this->sRouteXml
			);

			if ($this->iDoctypeId == 0) {
				$this->reset();
				throw new WF_DoctypeNotCreatedException();
			}

		}

	}
	
	public function nameExists($sTitle) {
		$sSQL =	"SELECT" . "\n" .
					"COUNT(*) AS total" . "\n" .
				"FROM" . "\n" .
					"wf_doctypes" . "\n" .
				"WHERE" . "\n" .
					"title = '" . MSF_Registry::get('MSF_DB')->escapeString($sTitle) . "'";


		return $this->DB->DB->select($sSQL, true, 'total') > 0;
	}

	public function remove()
	// throws MSF_DBException, WF_DoctypeNotRemovedException, WF_DoctypeVersionNotRemovedException
	{
		if ($this->exists()) {
			foreach ($this->getDoctypeVersionsIds() AS $iDoctypeVersionId) {
				$this->getVersion($iDoctypeVersionId)->remove();
			}

			// removing of the empty doctypes
			foreach ($this->getDocumentsIds() AS $iDocumentId) {
				$EmptyDocument = new WF_Document($this, $this->newVersion(), $iDocumentId);
				$EmptyDocument->remove();
			}

			if (($this->DB->delete($this->iDoctypeId) <> 1)) {
				throw new WF_DoctypeNotRemovedException($this->iDoctypeId);
			}

		}

	}

	public function newVersion()
	{
		return $this->getVersion(0);
	}

	public function getCurrentVersion()
	{
		return $this->getVersion($this->iDoctypeVersionId);
	}

	public function getVersion($iDoctypeVersionId)
	{
		return new WF_DoctypeVersion($this, $iDoctypeVersionId);
	}

	public function getDoctypeVersionsIds()
	{
		$aResult = array();
		if ($this->exists()) {
			$aVersions = $this->DB->selectDoctypeVersionsIds($this->iDoctypeId);
			for ($i = 0; $i < count($aVersions); $i++) {
				$aResult[] = $aVersions[$i]["doctype_version_id"];
			}

		}

		return $aResult;
	}

	public function getDocumentsIds()
	{
		$aResult = array();
		if ($this->exists()) {
			$aVersions = $this->DB->selectDocumentsIds($this->iDoctypeId);
			for ($i = 0; $i < count($aVersions); $i++) {
				$aResult[] = $aVersions[$i]["document_id"];
			}

		}

		return $aResult;
	}

	/**
	 * @return WF_Document
	 */
	public function newDocument()
	{
		return $this->getCurrentVersion()->newDocument();
	}

	public function getDocument($iDocumentId)
	{
		return $this->getCurrentVersion()->getDocument($iDocumentId);
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// Private Doers
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////

	private function reset()
	{
		$this->iDoctypeId 			= 0;
		$this->iDoctypeVersionId 	= 0;
		$this->iFolderId			= 0;
		$this->iUserId 				= 0;
		$this->iCreatedAt			= 0;
		$this->sTitle				= "No title";
		$this->sDescription			= "No description";
		$this->sFieldsXml			= "<document/>";
		$this->sSystemFieldsXml		= "<document/>";
		$this->sComparedXml			= "<document/>";
		$this->sRouteXml			= "<document/>";
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// UNSAFE CODE
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////
	public function getVersionsData()
	{
		$aVersions = array();
		foreach ($this->DB->selectDoctypeVersions($this->iDoctypeId) AS $aVersion) {
			$oSystemFieldsSettings		= new WF_SystemFieldsSettings();
			$oSystemFieldsSettings->bindPoints($aVersion["route_xml"]);
			$aVersions[] = array(
				"doctype_version_id" 	=> $aVersion["doctype_version_id"],
				"extname" 				=> $aVersion["extname"],
				"template_xml"			=> $aVersion["template_xml"],
				"route_xml"				=> $aVersion["route_xml"],
				"fields_xml"			=> $aVersion["fields_xml"],
				"system_fields"			=> $oSystemFieldsSettings,
				"spa_xml"				=> $aVersion["spa_xml"],
				"user_id" 				=> $aVersion["doctype_version_id"],
				"created_at"			=> $aVersion["created_at"]
			
			);
			
		}
		
		return $aVersions;
	}
	
    public function existsElement($sColumn, $sValue, $iDoctypeId)
	{
		return $this->DB->existsElement($sColumn, $sValue, $iDoctypeId);
	}
	
	/**
	 * Returns compared(user fields, system static fields, system point fields) xml
	 * Result pattern:
  	 * <?xml version="1.0"?>
  	 * <document>
  	 *   <element title="[doctype fields title]:string" type="array">
 	 * 		 <item name="type" type="string" value="[types]:string" /> - find
 	 *  		 <item name="fields" type="array">
 	 *   			 <item name="[0..N]:integer" type="array">
 	 *	 			 <item name="tablename" type="string" value="[doctype version tables name]:string" />
 	 *	 			 <item name="fieldname" type="string" value="[doctype version fields name]:string" />
 	 * 	 			 <item name="compared_with" type="string" value="[doctype fields name]:string" />
 	 *  		</item>
 	 * 		 </item>
 	 *	 </element>
 	 * </document>
  	 */
	public function compareAll() {
		$oCompared	= new MSF_XmlWrapper();
		$k			= 0;
		foreach ($this->getVersionsData() AS $aVersion) {
			$aFields = $aVersion['system_fields']->export();
			for ($i = 0; $i < count($aFields); $i++) {
				$aBody 				= array();
				$aBody['type'] 		= $aFields[$i]['type'];
				$aBody['fields']	= array();
				$aBody['fields'][0]	= array(
						'tablename' 	=> $aVersion['extname'],
						'fieldname' 	=> $aFields[$i]['name'],
						'compared_with'	=> $aFields[$i]['name']
						);
				$oCompared->set($k++, $aBody, $aFields[$i]['title']);
			}
			
		}
		
		foreach (MSF_XmlWrapper::xmlToArray($this->getComparedXml()) AS $aField) {
			$oCompared->set($k++, $aField['value'], $aField['title']);
		}

		// debug(htmlspecialchars($oCompared->getXml()));
		// exit();
		return $oCompared->getXml();
	}
	
}