<?php
/*
 * Created on 25.10.2007
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */

include_once "system/mvc/MSF_ModelDBSupport.php";

class WF_DoctypeDB extends MSF_ModelDBSupport
{
	/**
	 * @param MSF_DB $DB Instance of MSF_DB
	 */
	public function __construct(MSF_DB $DB) {

		$this->DB = $DB;
	}

	public function get()
	{
		return $this->DB;
	}

	/**
	 * Return's the number of doctypes
	 * Uses SQL tables:
	 * - #__wf_doctypes
	 * @param integer $iDoctypeId Optional
	 * @return integer
	 */
	public function selectCount($iDoctypeId = null)
	// throws DBException
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"wf_doctypes\n" .
				(($iDoctypeId !== null)
					?
						"WHERE\n" .
							"doctype_id=" . $iDoctypeId
					:
						""
				);

		return $this->DB->select($sSql, true, "total");

	}

	/**
	 * Return's insertID if doctype inserted normally
	 * else return's zero.
	 * Uses SQL tables:
	 * - #__wf_doctypes
	 * @param integer 	$iDoctypeVersionId 	Doctype's verions id
	 * @param integer 	$iUserId 			Doctype's author id
	 * @param string 	$sTitle 			Doctype's title
	 * @param integer 	$iCreatedAt 		Doctype's time of creation
	 * @return integer
	 * @throws DBException
	 */
	public function insert($iDoctypeVersionId, $iUserId, $iFolderId, $sFieldXml, $sCopparedXml,
			$sTitle, $sDescription, $sFullDescription, $sCreatedAt, $sModifiedAt, $sRouteXml)
	// throws DBException
	{
		$sSql = "INSERT INTO\n" .
					"wf_doctypes\n" .
				"(\n" .
					"doctype_version_id" . ",\n" .
					"user_id" . ",\n" .
					"folder_id" . ",\n" .
					"fields_xml" . ",\n" .
					"compared_xml" . ",\n" .
					"title" . ",\n" .
					"description,\n" .
					"created_at," . "\n" .
					"modified_at," . "\n" .
					"route_xml," . "\n" .
					"full_description" . "\n" .
				") VALUES (\n" .
					$iDoctypeVersionId . ",\n" .
					$iUserId . ",\n" .
					$iFolderId . ",\n" .
					"'" . $this->escapeValue($sFieldXml) . "',\n" .
					"'" . $this->escapeValue($sCopparedXml) . "',\n" .
					"'" . $this->escapeValue($sTitle) . "',\n" .
					"'" . $this->escapeValue($sDescription) . "',\n" .
					"'" . $sCreatedAt . "',\n" .
					"'" . $sModifiedAt . "',\n" .
					"'" . $this->escapeValue($sRouteXml) . "',\n" .
					"'" . $this->escapeValue($sFullDescription) . "'" .
				")";

		$this->DB->executeQuery($sSql);
		return $this->DB->insertId("wf_doctypes", "doctype_id");
	}

	/**
	 * Return's fields of doctypes
	 * Uses SQL tables:
	 * - #__wf_doctypes
	 * @param integer $iDoctypeId
	 * @return array
	 */
	public function select($iDoctypeId)
	// throws DBException
	{
		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"wf_doctypes\n" .
				"WHERE\n" .
					"doctype_id = " . $iDoctypeId . "\n" .
				"LIMIT 1";

		return $this->DB->select($sSql, true);

	}

	public function selectDoctypeVersionsIds($iDoctypeId)
	// throws DBException
	{
		$sSql = "SELECT\n" .
					"doctype_version_id\n" .
				"FROM\n" .
					"wf_doctypes_versions\n" .
				"WHERE\n" .
					"doctype_id = " . $iDoctypeId;;

		return $this->DB->select($sSql);

	}

	public function selectDocumentsIds($iDoctypeId)
	// throws DBException
	{
		$sSql = "SELECT\n" .
					"document_id\n" .
				"FROM\n" .
					"wf_documents\n" .
				"WHERE\n" .
					"doctype_id = " . $iDoctypeId;;

		return $this->DB->select($sSql);

	}

	/**
	 * Return's number of affected rows
	 * Uses SQL tables:
	 * - #__wf_doctypes
	 * @param integer 	$iDoctypeId 		Doctype's id
	 * @param integer 	$iDoctypeVersionId 	Doctype's verions id
	 * @param integer 	$iUserId 			Doctype's author id
	 * @param string 	$sTitle 			Doctype's title
	 * @param integer 	$iCreatedAt 		Doctype's time of creation
	 * @return boolean
	 * @throws DBException
	 */
	public function update($iDoctypeId, $iDoctypeVersionId, $sFieldsXml, $sComparedXml, $sTitle, $sDescription, $sFullDescription, $iFolderId, $sModifiedAt, $sRouteXml)
	// throws DBException
	{
		$sSql = "UPDATE\n" .
					"wf_doctypes\n" .
				"SET\n" .
					"doctype_version_id = " . $iDoctypeVersionId . ",\n" .
					"fields_xml 		= '" . $this->escapeValue($sFieldsXml) . "',\n" .
					"compared_xml 		= '" . $this->escapeValue($sComparedXml) . "',\n" .
					"title 				= '" . $this->escapeValue($sTitle) . "',\n" .
					"description 		= '" . $this->escapeValue($sDescription) . "',\n" .
					"full_description	= '" . $this->escapeValue($sFullDescription) . "',\n" .
					"folder_id 			= '" . $iFolderId . "',\n" .
					"modified_at 		= '" . $sModifiedAt . "',\n" .
					"route_xml 			= '" . $this->escapeValue($sRouteXml) . "'\n" .
				"WHERE\n" .
					"doctype_id = " . $iDoctypeId;

		//echo $sSql;die();
		$this->DB->executeQuery($sSql);
		return $this->DB->affectedRows();
	}

	/**
	 * Delete's row from doctypes
	 * Uses SQL tables:
	 * - #__wf_doctypes
	 * @param integer $iDoctypeId
	 * @return boolean
	 */
	public function delete($iDoctypeId)
	// throws DBException
	{
		$sSql = "DELETE FROM\n" .
					"wf_doctypes\n" .
				"WHERE\n" .
					"doctype_id = " . $iDoctypeId;

		$this->DB->executeQuery($sSql);
		return $this->DB->affectedRows();
	}

	public function selectDoctypeVersions($iDoctypeId)
	{
		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"wf_doctypes_versions\n" .
				"WHERE\n" .
					"doctype_id = " . $iDoctypeId . "\n" .
				"ORDER BY\n" .
					"doctype_version_id DESC";

		return $this->DB->select($sSql);
	}
	
    public function existsElement($sColumn, $sValue, $iDoctypeId)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"wf_doctypes\n" .
				"WHERE\n" .
					(($iDoctypeId > 0)
						?
							"doctype_id != " . $iDoctypeId . "\n" .
						"AND\n"
						:
						""
					) .
					$sColumn . " = '" . $this->escapeValue($sValue) . "'";

		return $this->DB->select($sSql, true, "total");
	}

/*
	public function selectDocumentVersionIds($iDoctypeVersionId)
	{
		$sSql = "SELECT\n" .
					"document_version_id\n" .
				"FROM\n" .
					"wf_documents_versions\n" .
				"WHERE\n" .
					"doctype_version_id = " . $iDoctypeVersionId;

		return $this->DB->select($sSql);
	}

	public function selectDocuments($sDoctypeVersionIds)
	{
		$sSql = "SELECT\n" .
					"doc.document_id\n" .
				"FROM\n" .
					"wf_documents doc,\n" .
					"wf_documents_versions doc_ver\n" .
				"WHERE\n" .
					"doc.document_id = doc_ver.document_id\n" .
				"AND\n" .
					"doc_ver.doctype_version_id IN (" . $sDoctypeVersionIds . ")";

		return $this->DB->select($sSql);
	}
*/
}

?>