<?php

defined('__MSF') or die('Direct access is not allowed');

include_once "library/MSF_Recordset/MSF_Recordset.php";
include_once "WF_DoctypesListDB.php";

class WF_DoctypesList
{
	/**
	 * @var MSF_Recordset
	 */
	private $Recordset;

	private $Locale;

	private $DB;

	public function __construct($DB)
	{
		$this->DB			= $DB;
		$this->Locale 		= MSF_Registry::get("MSF_Locale");
		$this->Recordset 	= new MSF_Recordset(MSF_Registry::get("MSF_DB"));
	}

	public function get()
	{
		//$sSelect 	= "SELECT dt.doctype_id, dt.title, dt.user_id, dt.created_at AS created_at, dtv.created_at AS modified_at";
		//$sSelect 	= "SELECT ";
		//$sFrom 		= "FROM wf_doctypes dt, wf_doctypes_versions dtv";
		//$sWhere 	= "WHERE dt.doctype_id = dtv.doctype_id AND dt.doctype_version_id = dtv.doctype_version_id";

		$aRColumns 	= array();
		$aColumns 	= array("dt.doctype_id", "dt.title", "dt.user_id", "dt.created_at", " dtv.created_at AS modified_at");
		$aTypes 	= array("int", "string", "text", "date", "date");
		$aTitles 	= array(
			"id",
			$this->Locale->getWord("WORKFLOW_ADMIN_LIST_TITLE"),
			$this->Locale->getWord("WORKFLOW_ADMIN_LIST_AUTHOR"),
			$this->Locale->getWord("WORKFLOW_ADMIN_LIST_CREATED"),
			$this->Locale->getWord("WORKFLOW_ADMIN_LIST_CHANGED")
		);

		for ($i = 0; $i < sizeof($aTitles); $i++) {
			$aRColumns[$i]["title"] 	= $aTitles[$i];
			$aRColumns[$i]["name"] 		= $aColumns[$i];
			$aRColumns[$i]["type"] 		= $aTypes[$i];
			$aRColumns[$i]["sort"] 		= true;
			$aRColumns[$i]["filter"] 	= true;
			$aRColumns[$i]["group"] 	= false;
			$aRColumns[$i]["compare"] 	= "like";
			$aRColumns[$i]["visible"] 	= true;
		}

		//$this->Recordset->setSelect($sSelect);
		//$this->Recordset->setFrom($sFrom);
		//$this->Recordset->setWhere($sWhere);
		$this->Recordset->setTables(array(
			"wf_doctypes AS dt",
			"wf_doctypes_versions AS dtv"
		));
		
		$this->Recordset->setConditions(array(
			"AND dt.doctype_id = dtv.doctype_id",
			"AND dt.doctype_version_id = dtv.doctype_version_id"
		));
		
		$this->Recordset->setColumns($aRColumns);
		$this->Recordset->setBaseUrl("/admin/workflow/doctype/list?");
		$this->Recordset->setMultiActionField("doctype_id");
		
		$this->Recordset->setActions(array(
			array(
				"title" 	=> $this->Locale->getWord("WORKFLOW_ADMIN_LIST_ACTION_EDIT"),
				"href" 		=> "/admin/workflow/doctype/edit",
				"image" 	=> "/templates/" . CNF_SKIN . "/img/edit.gif",
				"bind" 		=> array("doctype_id"),
				"confirm" 	=> false
			),
			array(
				"title" 	=> $this->Locale->getWord("WORKFLOW_ADMIN_LIST_ACTION_DELETE"),
				"href" 		=> "/admin/workflow/doctype/remove",
				"image" 	=> "/templates/" . CNF_SKIN . "/img/remove.gif",
				"bind" 		=> array("doctype_id"),
				"confirm" 	=> true
			),
			array(
				"title" 	=> $this->Locale->getWord("WORKFLOW_ADMIN_LIST_ACTION_VERSIONS"),
				"href" 		=> "/admin/workflow/doctype/versions",
				"image" 	=> "/templates/" . CNF_SKIN . "/img/view.gif",
				"bind" 		=> array("doctype_id"),
				"confirm" 	=> false
			),
			array(
				"title" 	=> $this->Locale->getWord("WORKFLOW_ADMIN_LIST_ACTION_FIELDS"),
				"href" 		=> "/admin/workflow/doctype/fields",
				"image" 	=> "/templates/" . CNF_SKIN . "/img/view.gif",
				"bind" 		=> array("doctype_id"),
				"confirm" 	=> false
			),
			array(
				"title" 	=> $this->Locale->getWord("WORKFLOW_ADMIN_LIST_ACTION_ACCESS"),
				"href" 		=> "/admin/workflow/doctype/access",
				"image" 	=> "/templates/" . CNF_SKIN . "/img/access.gif",
				"bind" 		=> array("doctype_id"),
				"confirm" 	=> false
			)
		));
		
		return $this->Recordset->getAllRecords();
	}

	public function getUnlinked()
	{
		return $this->DB->getUnlinked();
	}

	public function getLinked($iId)
	{
		return $this->DB->getLinked($iId);
	}

	public function saveLink($iId, $aDoctypes)
	{
		if(!empty($aDoctypes)) {
			$this->DB->saveLink($iId, $aDoctypes);
		}

	}
	
	public function getAll()
	{
		return $this->DB->select();
	}

	public function removeLink($iId) {
		$this->DB->removeLink($iId);
	}

}