<?php
if(!defined("__MSF")) {
	 die("Direct access is not allowed");
}
class WF_DoctypesListDB
{
	/**
	 * @var MSF_DB Instance of MSF_DB
	 */
	private $DB;

	/**
	 * @param MSF_DB $DB Instance of MSF_DB
	 */
	public function __construct(MSF_DB $DB) {

		$this->DB = $DB;
	}

	public function getUnlinked()
	{
		$sSQL	=	"SELECT" . "\n" .
						"doctype_id, title, fields_xml, route_xml" . "\n" .
					"FROM" . "\n" .
						"wf_doctypes" . "\n" .
					"WHERE" . "\n" .
						"folder_id='0'" . "\n" .
					"ORDER BY" . "\n" .
						"title";

		return $this->DB->select($sSQL);
	}

	public function getLinked($iId)
	{
		$sSQL	=	"SELECT" . "\n" .
						"doctype_id, title, fields_xml, description, route_xml" . "\n" .
					"FROM" . "\n" .
						"wf_doctypes" . "\n" .
					"WHERE" . "\n" .
						"folder_id='" . $iId . "'" . "\n" .
					"ORDER BY" . "\n" .
						"title";


		return $this->DB->select($sSQL);
	}
	
	public function select()
	{
		$sSql = "SELECT\n" .
					"doctype_id,\n" .
					"title,\n" .
					"fields_xml,\n" .
					"description\n" .
				"FROM\n" .
					"wf_doctypes\n" .
				"ORDER BY\n" .
					"title";
		
		return $this->DB->select($sSql);
	}

	public function saveLink($iId, $iDoctypes)
	{
		$sSQL	=	"UPDATE" . "\n" .
						"wf_doctypes" . "\n" .
					"SET" . "\n" .
						"folder_id='0'" . "\n" .
					"WHERE" . "\n" .
						"folder_id='" . $iId . "'";
		$this->DB->executeQuery($sSQL);

		$sSQL	=	"UPDATE" . "\n" .
						"wf_doctypes" . "\n" .
					"SET" . "\n" .
						"folder_id='" . $iId . "'" . "\n" .
					"WHERE" . "\n" .
						"doctype_id" . "\n" .
					"IN" . "\n" .
						"(" . implode(",", $iDoctypes) . ")";

		$this->DB->executeQuery($sSQL);
	}

	public function removeLink($iId)
	{
		$sSQL	=	"UPDATE" . "\n" .
						"wf_doctypes" . "\n" .
					"SET" . "\n" .
						"folder_id='0'" . "\n" .
					"WHERE" . "\n" .
						"folder_id='" . $iId . "'";

		
		$this->DB->executeQuery($sSQL);
	}
}

?>