<?php
defined("__MSF")
		or die("Direct access is not allowed");
include_once "modules/workflow/library/doctypeVersion/WF_DoctypeVersionNotCreatedException.php";
include_once "modules/workflow/library/doctypeVersion/WF_DoctypeVersionNotExistedException.php";
include_once "modules/workflow/library/doctypeVersion/WF_DoctypeVersionNotRemovedException.php";
include_once "modules/workflow/library/doctypeVersion/WF_DoctypeVersionNotEmptyException.php";
include_once "modules/workflow/library/doctypeVersion/WF_VarManager.php";
include_once "modules/workflow/library/doctypeVersion/WF_SystemFieldsSettings.php";
include_once "modules/workflow/library/doctypeVersion/WF_DoctypeVersionCleaner.php";

/**
 * Doctype's version
 * @copyright Copyright (c) 2007, Detrix
 */
class WF_DoctypeVersion
{
	private $Doctype;

	private $DB;

	private $iDoctypeId;

	private $sExtname;

	private $sTemplateXml;

	private $sRouteXml;
	
	private $sArchiveXml;

	private $sFieldsXml;
	
	private $sSystemFieldsXml;
	
	private $oSystemFieldsSettings;

	private $sSpaXml;

	private $iDoctypeVersionId;

	private $iUserId;

	private $sCreatedAt			= '1970-01-01 00:00:00';
	


	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// Setters
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////

	public function setTemplateXml($sTemplateXml)
	{
		$this->sTemplateXml = (string) $sTemplateXml;
	}

	public function setRouteXml($sRouteXml)
	{
		$this->sRouteXml = (string) $sRouteXml;
	}
	
	public function setArchiveXml($sArchiveXml)
	{
		$this->sArchiveXml = (string) $sArchiveXml;
	}

	public function setFieldsXml($sFieldsXml)
	{
		$this->sFieldsXml = (string) $sFieldsXml;
	}
	
	public function setSpaXml($sSpaXml)
	{
		$this->sSpaXml = (string) $sSpaXml;
	}

	public function setUserId($iUserId)
	{
		$this->iUserId = (int) $iUserId;
	}

	public function setCreatedAt($sCreatedAt)
	{
		$DateFormat = new MSF_Date();
		$this->sCreatedAt = $DateFormat->parseAndFormat($sCreatedAt);
	}
	
	public function setDoctypeId($iDoctypeId)
	{
		$this->iDoctypeId = $iDoctypeId;
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// Getters
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////

	public function getDoctypeId()
	{
		return $this->iDoctypeId;
	}

	public function getUserId()
	{
		return $this->iUserId;
	}

	public function getDoctypeVersionId()
	{
		return $this->iDoctypeVersionId;
	}

	public function getExtname()
	{
		return $this->sExtname;
	}

	public function getCreatedAt()
	{
		return $this->sCreatedAt;
	}

	public function getTemplateXml()
	{
		return $this->sTemplateXml;
	}

	public function getSpaXml()
	{
		return $this->sSpaXml;
	}

	public function getFieldsXml()
	{
		return $this->sFieldsXml;
	}

	public function getSystemFields()
	{
		return $this->oSystemFieldsSettings;
	}
	
	public function getSystemFieldsXml()
	{
		return $this->oSystemFieldsSettings->__toString();
	}

	public function getRouteXml()
	{
		return $this->sRouteXml;
	}
	
	public function getArchiveXml()
	{
		return $this->sArchiveXml;
	}

	public function getDoctype()
	{
		return $this->Doctype;
	}
	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// Public Doers
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////

	public function __construct($Doctype, $iDoctypeVersionId = 0)
	{
		$this->Doctype 				= $Doctype;
		$this->DB 					= new WF_DoctypeVersionDB(MSF_Registry::get("MSF_DB"));
		$this->reset();
		$this->iDoctypeVersionId 	= (int) $iDoctypeVersionId;
		if ($this->Doctype->exists() && ($this->iDoctypeVersionId > 0)) {
			if ($this->exists()) {
				$aDoctypeVersion 			= $this->DB->select($this->Doctype->getDoctypeId(), $this->iDoctypeVersionId);
				$this->sExtname				= $aDoctypeVersion["extname"];

				$this->sTemplateXml 		= $aDoctypeVersion["template_xml"];
				$this->sRouteXml 			= $aDoctypeVersion["route_xml"];
				$this->sArchiveXml			= $aDoctypeVersion["archive_xml"];
				$this->sFieldsXml 			= $aDoctypeVersion["fields_xml"];
				$this->sSpaXml 				= $aDoctypeVersion["spa_xml"];
				$this->iUserId				= $aDoctypeVersion["user_id"];
				$this->sCreatedAt			= $aDoctypeVersion["created_at"];
				$this->oSystemFieldsSettings = new WF_SystemFieldsSettings();
				$this->oSystemFieldsSettings->bindPoints($this->sRouteXml);
			}
			else {
				throw new WF_DoctypeVersionNotExistedException($this->iDoctypeVersionId);
			}

		}

	}
	


	public function exists()
	// throws DBException
	{
		return ($this->DB->selectCount($this->iDoctypeVersionId, $this->iDoctypeId) == 1) ? true : false;
	}
	
	public function updateFields($sNewFieldsXml)
	{
		if ($this->exists()) {
			$aNewFields 	= array();
			$aOldFields 	= $this->getFields();
			$Wrapper 		= new MSF_XmlWrapper($sNewFieldsXml);
			foreach ($Wrapper as $sName => $Data) {
				$aNewFields[] 	= array(
					"name"		=> $sName,
					"type"		=> $this->oSystemFieldsSettings->getSqlType($Data->getValue("type")),
					"default"	=> $Data->getValue("default")
				);
			}
			
			foreach ($aOldFields as $aOldItem) {
				$bExists = false;
				foreach ($aNewFields as $aNewItem) {
					if ($aOldItem["name"] == $aNewItem["name"]) {
						$bExists = true;
						break;
					}
				}
				
				if (!$bExists) {
					$this->DB->removeFromTable($this->sExtname, $aOldItem["name"]);
				}
			}
			
			foreach ($aNewFields as $aNewItem) {
				$bNew = true;
				foreach ($aOldFields as $aOldItem) {
					if ($aNewItem["name"] == $aOldItem["name"]) {
						$bNew = false;
						break;
					}
				}
				
				if ($bNew) {
					$this->DB->addToTable($this->sExtname, $aNewItem["name"], $aNewItem["type"]);
				}
			}
			
			$this->setFieldsXml($sNewFieldsXml);
		}
		
		$this->save();
	}

	public function save()
	{
		$this->clear();
		$DB = MSF_Registry::get("MSF_DB");
		if ($this->exists()) {
			$this->DB->update(
					$this->iDoctypeVersionId,
					$this->sTemplateXml,
					$this->sRouteXml,
					$this->sArchiveXml,
					$this->sFieldsXml,
					$this->sSpaXml,
					MSF_Registry::get("MSF_UserBox")->getUserAttribute("id")
					);
		}
		else if ($this->Doctype->exists()) {
			$DB->begin();
			$this->sExtname 				= MSF_String::random(10);
			$this->oSystemFieldsSettings 	= new WF_SystemFieldsSettings();
			$this->oSystemFieldsSettings->bindPoints($this->sRouteXml);
			$oDate = new MSF_Date();
			$this->iDoctypeVersionId 	= $this->DB->insert(
					$this->iDoctypeId,
					$this->sExtname,
					$this->sTemplateXml,
					$this->sRouteXml,
					$this->sArchiveXml,
					$this->sFieldsXml,
					$this->sSpaXml,
					$this->iUserId,
					$oDate->formatTimestamp()
					);
					
			if ($this->iDoctypeVersionId > 0) {
				$this->DB->createTable($this->sExtname, $this->getFields(), $this->oSystemFieldsSettings);
				$this->Doctype->setDoctypeVersionId($this->iDoctypeVersionId);
				$this->Doctype->save();
				$DB->commit();
			}
			else {
				$DB->rollBack();
				$this->reset();
				throw new WF_DoctypeVersionNotCreatedException("Doctype version not created");
			}

		}
		else {
			throw new WF_DoctypeNotCreatedException("Doctype not created");
		}

	}

	public function remove()
	{
		$DB = MSF_Registry::get("MSF_DB");
		if ($this->exists()) {
			foreach ($this->getDocumentsIds() AS $iDocumentId) {
				$this->getDocument($iDocumentId)->remove();
			}

			$DB->begin();
			if ($this->DB->delete($this->iDoctypeId, $this->iDoctypeVersionId) == 1) {
				$this->DB->dropTable($this->sExtname);
				$DB->commit();
				if ($this->iDoctypeVersionId == $this->Doctype->getDoctypeVersionId()) {
					$this->Doctype->setDoctypeVersionId(0);
				}
				
				$this->Doctype->save();
			}
			else {
				$DB->rollBack();
				throw new WF_DoctypeVersionNotRemovedException($this->iDoctypeVersionId);
			}

		}

	}

	public function getCountOfDocuments()
	{
		return $this->DB->selectDocumentsCount($this->sExtname);
	}

	public function getDocumentsIds()
	{
		$aResult = array();
		if ($this->exists()) {
			$aVersions = $this->DB->selectDocumentsIds($this->iDoctypeId, $this->iDoctypeVersionId);
			for ($i = 0; $i < count($aVersions); $i++) {
				$aResult[] = $aVersions[$i]["document_id"];
			}

		}

		return $aResult;
	}

	public function newDocument()
	{
		return $this->getDocument(0);
	}

	public function getDocument($iDocumentId)
	{
		return new WF_Document($this, $iDocumentId);
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// Private Doers
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////

	private function reset()
	{
		$this->iDoctypeId 			= $this->Doctype->getDoctypeId();
		$this->sFieldsXml			= $this->Doctype->getFieldsXml();
		$this->sSystemFieldsXml 	= "<document/>";
		$this->sExtname 			= "";
		$this->sTemplateXml			= "";
		$this->sRouteXml 			= "<document/>";
		$this->sArchiveXml 			= "<document/>";
		$this->sSpaXml 				= "<document/>";
		$this->iUserId				= 0;
		$this->iCreatedAt			= 0;
	}

	private function getFields()
	{

		$XW 		= new MSF_XmlWrapper($this->sFieldsXml);
		$aResult	= array();
		foreach ($XW AS $sName => $Data) {
			$aResult[] = array(
				"name"		=> $sName,
				"type"		=> $this->oSystemFieldsSettings->getSqlType($Data->getValue("type")),
				"default"	=> $Data->getValue("default")
			);

		}

		return $aResult;
	}

	/////////////////////////////////////////////////////////////////////////////////////////////////
	//
	// UNSAFE CODE
	//
	/////////////////////////////////////////////////////////////////////////////////////////////////
	
	/**
	 * Clears fields, spa & route xml
	 * @return void
	 */
	private function clear() {
		$oCleaner 			= new WF_DoctypeVersionCleaner();
		$oCleaner->setFieldsXml($this->sFieldsXml);
		$oCleaner->setSpaXml($this->sSpaXml);
		$oCleaner->setRouteXml($this->sRouteXml);
		$oCleaner->clean();
		$this->sFieldsXml	= $oCleaner->getFieldsXml();
		$this->sSpaXml		= $oCleaner->getSpaXml();
		$this->sRouteXml 	= $oCleaner->getRouteXml();
	}
}