<?php

defined('__MSF') or die('Direct access is not allowed');

/*
 * Created on 26.10.2007
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */
class WF_DoctypeVersionDB extends MSF_ModelDBSupport
{
	/**
	 * @param MSF_DB $DB Instance of MSF_DB
	 */
	public function __construct(MSF_DB $DB) {

		$this->DB = $DB;
	}

	/**
	 * Return's the number of doctypes
	 * Uses SQL tables:
	 * - #__wf_doctypes
	 * @param integer $iDoctypeId Optional
	 * @return integer
	 */
	public function selectCount($iDoctypeVersionId = null, $iDoctypeId = null)
	// throws DBException
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"wf_doctypes_versions\n" .
				(($iDoctypeVersionId !== null && $iDoctypeId !== null)
					?
						"WHERE\n" .
							"doctype_version_id = " . $iDoctypeVersionId . "\n" .
						"AND\n" .
							"doctype_id = " . $iDoctypeId
					:
						""
				);

		return $this->DB->select($sSql, true, "total");
	}

	public function insert($iDoctypeId, $sExtname,
			$sTemplateXml, $sRouteXml, $sArchiveXml = "", $sFieldsXml, $sSPAXml, $iUserId, $sCreatedAt)
	// throws DBException
	{
		$sSql 	= "INSERT INTO\n" 					.
						"wf_doctypes_versions\n"	.
				"(\n" 								.
					"doctype_id,\n" 				.
					"extname,\n" 					.
					"template_xml,\n" 				.
					"route_xml,\n" 					.
					"archive_xml,\n" 				.
					"fields_xml,\n" 				.
					"spa_xml,\n" 					.
					"user_id,\n" 					.
					"created_at\n" 					.
				") VALUES (\n" 						.
					$iDoctypeId . ",\n" 			.
					"'"  . $sExtname . "',\n" 		.
					"'" . $this->escapeValue($sTemplateXml) . "',\n" 	.
					"'" . $this->escapeValue($sRouteXml) . "',\n" 		.
					"'" . $this->escapeValue($sArchiveXml) . "',\n" 	.
					"'" . $this->escapeValue($sFieldsXml) . "',\n" 		.
					"'" . $this->escapeValue($sSPAXml) . "',\n" 		.
					$iUserId . ",\n" 				.
					"'" . $sCreatedAt . "'\n" 		.
				")";

		$this->DB->executeQuery($sSql);
		return $this->DB->insertId("wf_doctypes_versions", "doctype_version_id");
	}

	public function update($iDoctypeVersionId, $sTemplateXml,
			$sRouteXml, $sArchiveXml = "", $sFieldsXml, $sSpaXml, $iUserId)
	{
		$sSql = "UPDATE\n" .
						"wf_doctypes_versions\n" .
				"SET\n" .
					"template_xml 	= '" . $this->escapeValue($sTemplateXml) . "',\n" .
					"route_xml 		= '" . $this->escapeValue($sRouteXml) . "',\n" .
					"archive_xml	= '" . $this->escapeValue($sArchiveXml) . "',\n" .
					"spa_xml 		= '" . $this->escapeValue($sSpaXml) . "',\n" .
					"fields_xml 	= '" . $this->escapeValue($sFieldsXml) . "',\n" .
					"user_id		= '" . $iUserId . "',\n" .
					"created_at 	= '" . date("Y-m-d H:i") . "'\n" .
				"WHERE\n" .
					"doctype_version_id='" . $iDoctypeVersionId . "'";


		$this->DB->executeQuery($sSql);
	}

	public function select($iDoctypeId, $iDoctypeVersionId)
	// throws DBException
	{
		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"wf_doctypes_versions\n" .
				"WHERE\n" .
					"doctype_id = " . $iDoctypeId . "\n" .
				"AND\n" .
					"doctype_version_id = " . $iDoctypeVersionId;

		return $this->DB->select($sSql, true);

	}

	public function delete($iDoctypeId, $iDoctypeVersionId)
	// throws DBException
	{
		$sSql = "DELETE FROM\n" .
					"wf_doctypes_versions\n" .
				"WHERE\n" .
					"doctype_id = " . $iDoctypeId . "\n" .
				"AND\n" .
					"doctype_version_id = " . $iDoctypeVersionId;

		$this->DB->executeQuery($sSql);
		return $this->DB->affectedRows();
	}
	
	public function addToTable($sTableName, $sFieldName, $sFieldType)
	{
		$sSql = "ALTER TABLE " . CNF_SQL_SCHEME . ".wf_documents_" . $sTableName . "\n" .
				"ADD " . $sFieldName . " " . $sFieldType;
		
		$this->DB->executeQuery($sSql);
	}
	
	public function removeFromTable($sTableName, $sFieldName)
	{
		$sSql = "ALTER TABLE " . CNF_SQL_SCHEME . ".wf_documents_" . $sTableName . "\n" .
				"DROP " . $sFieldName;
		
		$this->DB->executeQuery($sSql);
	}

	public function createTable($sTableName, $aParams, $aSystemFields)
	// throws DBException
	{
		$sSql = "CREATE TABLE " . CNF_SQL_SCHEME . ".wf_documents_" . $sTableName . " (\n" .
					"document_version_id integer NOT NULL,\n";

		for ($i = 0; $i < count($aParams); $i++) {
			$sSql .= $aParams[$i]["name"] . " " . $aParams[$i]["type"] . ",\n";
		}
		
		for ($i = 0; $i < $aSystemFields->size(); $i++) {
			$sSql .= $aSystemFields[$i]["name"] . " " . $aSystemFields[$i]["sqlType"] . ",\n";
		}

		$sSql .= 	"CONSTRAINT wf_documents_" . $sTableName . "_pkey PRIMARY KEY (document_version_id)\n" .
				")";
		
		/*
		$sSql .= "\n" .
				")\n" .
				"WITH OIDS";
		*/
		//echo $sSql;
		//exit();
		$this->DB->executeQuery($sSql);
	}
/*
	public function deleteTable($iDoctypeVersionId, $sTableName, $bWithDocuments)
	{
		$bResult = false;

		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"wf_documents_" . $sTableName;

		if (($this->DB->select($sSql, true, "total") == 0) || $bWithDocuments) {
			$bResult = true;
		}

		return $bResult;
	}
*/
	public function dropTable($sTableName)
	{
		$this->DB->executeQuery("DROP TABLE wf_documents_" . $sTableName);
	}

	public function selectDocumentsCount($sTableName)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"wf_documents_" . $sTableName;

		return $this->DB->select($sSql, true, "total");
	}


	public function selectDocumentsIds($iDoctypeId, $iDoctypeVersionId)
	// throws DBException
	{
		$sSql = "SELECT\n" .
					"document_id\n" .
				"FROM\n" .
					"wf_documents\n" .
				"WHERE\n" .
					"doctype_version_id = " . $iDoctypeVersionId . "\n" .
				"AND\n" .
					"doctype_id = " . $iDoctypeId;

		return $this->DB->select($sSql);

	}
}
?>
