<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "WF_RouterPointNotFoundException.php";

class WF_Router
{
	private $aRoute = array();
	
	public function __construct($sRouteXml)
	{
		$Wrapper 		= new MSF_XmlWrapper($sRouteXml);
		$this->aRoute 	= $Wrapper->getAsArray();
		
		if (empty($this->aRoute)) {
			$this->aRoute = array();
		}
	}
	
	public function getPointTitle($iPointId)
	{
		$this->checkPoint($iPointId);
		return $this->aRoute[$iPointId]["value"]["control"]["title"];
	}
	
	public function getDelegate($iPointId)
	{
		$this->checkPoint($iPointId);
		return $this->aRoute[$iPointId]["value"]["delegate"];
	}
	
	public function getSystem($iPointId)
	{
		$this->checkPoint($iPointId);
		return $this->aRoute[$iPointId]["value"]["execute"];
	}
	
	public function getWait($iPointId)
	{
		$this->checkPoint($iPointId);
		return $this->aRoute[$iPointId]["value"]["wait"];
	}
	
	public function getControlTime($iPointId)
	{
		$this->checkPoint($iPointId);
		
		$iValue = $this->aRoute[$iPointId]["value"]["control"]["control_value"];
		
		switch ($this->aRoute[$iPointId]["value"]["control"]["control_type"]) {
			case "hours":
				$iValue = $iValue * 60 * 60;
				break;
			case "days":
				$iValue = $iValue * 24 * 60 * 60;
				break;
		}
		
		return $iValue;
	}
	
	public function getSize()
	{
		$iSize = 0;
		
		foreach ($this->aRoute AS $k => $v) {
			if ((int) $k < 500) {
				$iSize++;
			}
		}
		
		return $iSize;
	}
	
	public function isFinished()
	{
		return isset($this->aRoute[500]);
	}
	
	public function pointExists($iPointId)
	{
		return isset($this->aRoute[$iPointId]);
	}
	
	public function addPoint($iPointId)
	{
		if (!isset($this->aRoute[$iPointId])) {
			$this->aRoute[$iPointId] = true;
		}
	}
	
	private function checkPoint($iPointId)
	{
		if (!isset($this->aRoute[$iPointId])) {
			throw new WF_PouterPointNotFoundException("Point " . $iPointId . " not exists"); 
		}
	}
}






?>