<?php
defined("__MSF") or
	die("Direct access is not allowed");
	
include_once "WF_DoctypeVersion.php";
class WF_SystemFieldsSettings implements ArrayAccess
{
	private $aFields = array (
			array (
					"name"	=> "author_name",
					"type"	=> "structure"
					),
			array (
					"name"	=> "created_at",
					"type"	=> "date"
					),
			array (
					"name"	=> "modified_at",
					"type"	=> "timestamp"
					),
			array (
					"name"	=> "status",
					"type"	=> "string"
					),
			array (
					"name"	=> "doctype",
					"type"	=> "string"
					),
			array (
					"name"	=> "subdivision",
					"type"	=> "reference"
					),
			array (
					"name"	=> "registration_number",
					"type"	=> "string"
					),
			array (
					"name"	=> "registration_date",
					"type"	=> "date"
					)

			);

	public function __toString()
	{
		$sXml = "<document>\n";
		for ($i = 0; $i < $this->size(); $i++) {
			$sXml .= $this->fieldToXml($this->aFields[$i]);
		}
		
		$sXml .= "</document>";
		return $sXml;
	}
	
	private function fieldToXml($aField)
	{
		return	"<element title=\"" . $this->getTitle($aField["name"]) . "\" name=\"" . $aField["name"] . "\" type=\"array\">\n"
					. "<item name=\"type\" type=\"text\" value=\"" . $aField["type"] . "\"/>\n"
					. "<item name=\"required\" type=\"int\" value=\"1\"/>\n"
					. "<item name=\"defaultValue\" type=\"" ./* $aField["type"] .*/ "\" value=\"\"/>\n"
				. "</element>\n";
	}
	
	private function getTitle($sName)
	{
		$sTitle = "WFSF_" . strtoupper($sName);
		return MSF_Registry::get("MSF_Locale")->getWord($sTitle);
	}
	
	public static function getSqlType($sType)
	{
		switch ($sType) {
	 		case "int"			:
	 			$sSql = "bigint";
	 			break;
	 		case "date"			:
	 			$sSql = "date";
	 			break;
	 		case "timestamp"	:
	 			$sSql = "timestamp";
	 			break;
	 		case "time"			:
	 			$sSql = "time";
	 			break;
	 		case "float"		:
	 			$sSql = "numeric";
	 			break;
	 		case "table"		:
	 		case "picture"		:
			case "file"			:
	 		case "string"		:
	 		case "reference"	:
	 		case "structure"	:
	 		case "document"		:
	 		case "text"			:
	 		case "bool"			:
	 		case "enum"			:
	 			$sSql = "text";
	 			break;
		}
		
		return $sSql;
	}
	
	public function offsetGet($sKey)
	{
		return array(
			"name" 		=> $this->aFields[$sKey]["name"],
			"title" 	=> $this->getTitle($this->aFields[$sKey]["name"]),
			"type"		=> $this->aFields[$sKey]["type"],
			"sqlType" 	=> $this->getSqlType($this->aFields[$sKey]["type"])
		);
	}
	
	public function offsetSet($sKey, $aValue)
	{
		$this->aFields[$sKey] = $aValue;
	}
	
	public function offsetUnset($sKey)
	{
		unset($this->aFields[$sKey]);
	}
	
	public function offsetExists($sKey)
	{
		return array_key_exists($sKey, $this->aFields);
	}
	
	public function size()
	{
		return count($this->aFields);
	}
	
	public function bindPoints($sRouteXml) {
		/*
		$iCount =  count(MSF_XmlWrapper::xmlToArray($sRouteXml));
		$oLocale 					= MSF_Registry::get('MSF_Locale');
		for ($i = 0; $i < $iCount; $i++ ) {
			$oLocale->addWord("WFSF_POINT_" . $i, $oLocale->getWord("WFSF_POINT") . " ". $i);
		}	
		for ($i = 0; $i < $iCount; $i++) {
			$this->aFields[] = array (
					"name"	=> "point_" . $i,
					"type"	=> "date"
					);
		}
		*/
		//debug(MSF_XmlWrapper::xmlToArray($sRouteXml), $this->aFields);
		//exit();
	}
	
	public function export() {
		$aResult = array();
		for ($i = 0; $i < $this->size(); $i++) {
			$aResult[] = $this[$i];
		}
		return $aResult;
	}
	
}

?>