<?php

/*
 * Created on 25.10.2007
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */
class WF_DocumentDB extends MSF_ModelDBSupport
{
	/**
	 * @param MSF_DB $DB Instance of MSF_DB
	 */
	public function __construct(MSF_DB $DB) {

		$this->DB = $DB;
	}

	public function get()
	{
		return $this->DB;
	}

	public function selectCount($iDocumentId = null)
	// throws DBException
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"wf_documents\n" .
				(($iDocumentId !== null)
					?
						"WHERE\n" .
							"document_id=" . $iDocumentId
					:
						""
				);

		return $this->DB->select($sSql, true, "total");

	}

	public function insert($iDoctypeId, $iDoctypeVersionId, $iDocumentVersionId,
							$iParentId, $iPointId, $iStructureId, $iMediaId, $sFamilyTree, $sTitle, $sRegistrationNumber, $sLog
							)
	// throws DBException
	{		
		$sSql = "INSERT INTO\n" .
					"wf_documents\n" .
				"(\n" .
					"doctype_id,\n" .
					"doctype_version_id,\n" .
					"document_version_id,\n" .
					"parent_id,\n" .
					"point_id,\n" .
					"structure_id,\n" .
					"media_id,\n" .
					"family_tree, \n" .
					"title, \n" .
					"registration_number, \n" .
					"log" . "\n" .
				")\n" .
				"values(\n" .
					$iDoctypeId . ",\n" .
					$iDoctypeVersionId . ",\n" .
					$iDocumentVersionId . ",\n" .
					$iParentId . ",\n" .
					$iPointId . ",\n" .
					$iStructureId . ",\n" .
					$iMediaId . ",\n" .
					"'" . $sFamilyTree . "',\n" .
					"'" . $this->escapeValue($sTitle) . "',\n" .
					"'" . $this->escapeValue($sRegistrationNumber) . "',\n" .
					"'" . $this->escapeValue($sLog) . "'" . "\n" .
				")";
		$this->DB->executeQuery($sSql);
		//MSF_Registry::get("MSF_Messenger")->addError($sSql . "<br/><br/>");
		return $this->DB->insertId("wf_documents", "document_id");
	}

	public function select($iDoctypeId, $iDoctypeVersionId, $iDocumentId)
	// throws DBException
	{
		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"wf_documents\n" .
				"WHERE\n" .
		//			"doctype_id = " . $iDoctypeId . "\n" .
		//		"AND\n" .
		//			"doctype_version_id = " . $iDoctypeVersionId . "\n" .
		//		"AND\n" .
					"document_id = " . $iDocumentId;
		return $this->DB->select($sSql, true);

	}

	public function update($iDocumentId, $iDocumentVersionId,
			$iPointId, $sTitle, $sRegistrationNumber, $sLog, $iStructureId
			)
	// throws DBException
	{
		$sSql = "UPDATE\n" .
					"wf_documents\n" .
				"SET\n" .
					"document_version_id 	= " 	. $iDocumentVersionId . ",\n" .
					"point_id 				= " 	. $iPointId . ",\n" .
					"title 					= '" 	. $this->escapeValue($sTitle) . "',\n" .
					"registration_number	= '"	. $this->escapeValue($sRegistrationNumber) . "',\n" .
					"log					= "		. "'" . $this->escapeValue($sLog) . "'" . ",\n" .
					"structure_id			= "		. $iStructureId . "\n" .
				"WHERE\n" .
					"document_id = " . $iDocumentId;
		//MSF_Registry::get("MSF_Messenger")->addError($sSql . "<br/><br/>");
		$this->DB->executeQuery($sSql);
		return $this->DB->affectedRows();
	}

	public function delete($iDocumentId)
	// throws DBException
	{
		$sSql = "DELETE FROM\n" .
					"wf_documents\n" .
				"WHERE\n" .
					"document_id = " . $iDocumentId;

		$this->DB->executeQuery($sSql);
		return $this->DB->affectedRows();
	}

	public function selectIds($iDoctypeVersionId)
	{
		$sSql = "SELECT\n" .
					"document_id,\n" .
					"document_version_id\n" .
				"FROM\n" .
					"wf_documents_versions\n" .
				"WHERE\n" .
					"doctype_version_id = " . $iDoctypeVersionId;

		return $this->DB->select($sSql);
	}
	
	public function selectDocumentVersionsIds($iDocumentId)
	// throws DBException
	{
		$sSql = "SELECT\n" .
					"document_version_id\n" .
				"FROM\n" .
					"wf_documents_versions\n" .
				"WHERE\n" .
					"document_id = " . $iDocumentId;

		return $this->DB->select($sSql);

	}
}

?>
