<?php

defined("__MSF")
	or die("Direct access is not allowed");

class WF_DocumentLogSetDB extends MSF_ModelDBSupport
{
	public function __construct(MSF_DB $DB)
	{
		$this->DB = $DB;
	}
	
	public function existsLog($iDocumentId, $iActionId)
	{
		$sSql = "SELECT\n" .
					"document_log_id\n" .
				"FROM\n" .
					"wf_documents_logs\n" .
				"WHERE\n" .
					"document_id = " . $iDocumentId . "\n" .
				"AND\n" .
					"action_id = " . $iActionId;
		
		$aRes = $this->DB->select($sSql, true);
		
		return (isset($aRes["document_log_id"])) ? $aRes["document_log_id"] : 0;
	}
	
	public function insertLog($aParams)
	{
		$sSql = "INSERT INTO\n" .
					"wf_documents_logs\n" .
				"(\n" .
					"document_id,\n" .
					"action_id,\n" .
					"point_id,\n" .
					"displayable\n" .
				") VALUES (\n" .
					$aParams["document_id"] . ",\n" .
					$aParams["action_id"] . ",\n" .
					$aParams["point_id"] . ",\n" .
					$aParams["displayable"] . "\n" .
				")";
	
		$this->DB->executeQuery($sSql);
		return $this->DB->insertId("wf_documents_logs", "document_log_id");
	}
	
	public function updateLog($iDocumentId, $iPointId)
	{
		$sSql = "UPDATE\n" .
					"wf_documents_logs\n" .
				"SET\n" .
					"document_id = '" . $iDocumentId . "*'\n" .
				"WHERE\n" .
					"document_id = '" . $iDocumentId . "'";
		
		$this->DB->executeQuery($sSql);
	}
	
	public function insertLogValue($aParams)
	{
		$aParams = $this->escapeHashValues($aParams);
		
		$sSql = "INSERT INTO\n" .
					"wf_documents_logs_values\n" .
				"(\n" .
					"document_log_id" . ",\n" .
					"employee_id" . ",\n" .
					"employee_name" . ",\n" .
					"value" . ",\n" .
					"description" . ",\n" .
					"created_at" . "\n" .
				") VALUES (\n" .
					$aParams["document_log_id"] . ",\n" .
					$aParams["employee_id"] . ",\n" .
					"'" . $aParams["employee_name"] . "',\n" .
					"'" . $aParams["value"] . "',\n" .
					"'" . $aParams["description"] . "',\n" .
					$aParams["created_at"] . "\n" .
				")";
		
		$this->DB->executeQuery($sSql);
		return ($this->DB->affectedRows() == 1) ? true : false;
	}
	
	public function selectLogs($iDocumentId)
	{
		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"wf_documents_logs\n" .
				"WHERE\n" .
					"document_id = " . $iDocumentId;
		
		return $this->DB->select($sSql);
	}
	
	public function selectValues($iDocumentId)
	{
		$sSql = "SELECT\n" .
					"lv.*\n" .
				"FROM\n" .
					"wf_documents_logs_values lv,\n" .
					"wf_documents_logs l\n" .
				"WHERE\n" .
					"l.document_log_id = lv.document_log_id\n" .
				"AND\n" .
					"l.document_id = " . $iDocumentId;
		
		return $this->DB->select($sSql);
	}
	
	public function deleteLogs($mDocumentLogIds)
	{
		$b = false;
		if (is_array($mDocumentLogIds)) {
			$mDocumentLogIds = implode(",", $mDocumentLogIds);
		}
		
		$sSql = "DELETE FROM\n" .
					"wf_documents_logs\n" .
				"WHERE\n" .
					"document_log_id IN (" . $mDocumentLogIds . ")";
		
		$this->DB->executeQuery($sSql);
		
		if ($this->DB->affectedRows() > 0) {
			$sSql = "DELETE FROM\n" .
					"wf_documents_logs_values\n" .
				"WHERE\n" .
					"document_log_id IN (" . $mDocumentLogIds . ")";
		
			$this->DB->executeQuery($sSql);
			$b = true;
		}
		
		return $b;
	}
	
	public function deleteLogValues($mDocumentValueIds)
	{
		if (is_array($mDocumentValueIds)) {
			$mDocumentValueIds = implode(",", $mDocumentValueIds);
		}
		
		$sSql = "DELETE FROM\n" .
					"#__wf_documents_logs_values\n" .
				"WHERE\n" .
					"document_log_value_id IN (" . $mDocumentValueIds . ")";
		
		$this->DB->executeQuery($sSql);
		return ($this->DB->affectedRows() > 0) ? true : false;
	}
}

?>