<?php

defined('__MSF')
	or die('Direct access is not allowed');

class WF_DocumentVersionDB extends MSF_ModelDBSupport
{
	public function __construct(MSF_DB $DB)
	{
		$this->DB = $DB;
	}

	public function selectCount($iDocumentVersionId = 0, $sExt = "")
	{
		if (empty($sExt)) {
			$sExt = "wf_documents_versions";
		}
		else {
			$sExt = "wf_documents_$sExt";
		}
		
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					$sExt . "\n" .
				"WHERE\n" .
							"document_version_id = " . $iDocumentVersionId;

		return $this->DB->select($sSql, true, "total");
	}

	public function insert($iDocumentId, $iStructureId, $sEmployeeName, $sCreatedAt)
	{
		$sSql = "INSERT INTO\n" .
					"wf_documents_versions\n" .
				"(\n" .
					"document_id,\n" .
					"structure_id,\n" .
					"employee_name,\n" .
					"created_at\n" .
				")\n" .
				"values(\n" .
					$iDocumentId . ",\n" .
					$iStructureId . ",\n" .
					"'" . $this->escapeValue($sEmployeeName) . "',\n" .
					"'" . $sCreatedAt . "'\n" .
				")";
		$this->DB->executeQuery($sSql);
		return $this->DB->insertId("wf_documents_versions", "document_version_id");
	}

	public function insertDocument($sTableName, $iDocumentVersionId, $aFields, $aSystemFields)
	{
		$iSize 	= count($aFields);
		$iSSize = count($aSystemFields);
		
		$sSql = "INSERT INTO\n" .
					"wf_documents_" . $sTableName . "\n" .
				"(\n" .
					"document_version_id";
		
		for ($i = 0; $i < $iSize; $i++) {
			$sSql .= ",\n" . $aFields[$i]["name"];
		}
		
		for ($i = 0; $i < $iSSize; $i++) {
			$sSql .= ",\n" . $aSystemFields[$i]["name"];
		}
		
		$sSql .= "\n)\n" .
				"values(\n" .
					$iDocumentVersionId;

		for ($i = 0; $i < $iSize; $i++) {
			if((string) $aFields[$i]["value"] !== "") {
				$sSql .= ",\n'" . $this->escapeValue($aFields[$i]["value"]) . "'";
			}
			else {
				$sSql .= ",\n null";
			}
			
		}
					
		for ($i = 0; $i < $iSSize; $i++) {
			if($aSystemFields[$i]["value"] !== "") {
				$sSql .= ",\n'" . $this->escapeValue($aSystemFields[$i]["value"]) . "'";
			}
			else {
				$sSql .= ",\n null";
			}
			
		}
		
		$sSql .= "\n)";
		$this->DB->executeQuery($sSql);
		$this->DB->commit();
		
	}
	
	public function exists($sExt, $iId)
	{
		
	}
	
	public function updateDocument($sTableName, $iDocumentVersionId, $aFields, $aSystemFields)
	{
		$iSize 	= count($aFields);
		$iSSize = count($aSystemFields);
		
		$sSql = "UPDATE\n" .
					"wf_documents_" . $sTableName . "\n" .
				"SET\n";
		for ($i = 0; $i < $iSSize; $i++) {
			if($aSystemFields[$i]["value"] !== "") {
				$sSql .= $aSystemFields[$i]["name"] . "='" . $this->escapeValue($aSystemFields[$i]["value"]) . "'";
			}
			else {
				$sSql .= $aSystemFields[$i]["name"] . "=null";
			}
			
			
			if ($i < $iSSize - 1) {
				$sSql .= ",";
			}
			
			$sSql .= "\n";
		}
		
		if ($iSize > 0) {
			$sSql .= ",\n";
		}
		
		for ($i = 0; $i < $iSize; $i++) {
			//$sSql .= $aFields[$i]["name"] . "='" . $aFields[$i]["value"] . "'";
			if($aFields[$i]["value"] !== "") {
				$sSql .= $aFields[$i]["name"] . "='" . $this->escapeValue($aFields[$i]["value"]) . "'";
			}
			else {
				$sSql .= $aFields[$i]["name"] . "=null";
			}
			
			
			if ($i < $iSize - 1) {
				$sSql .= ",\n";
			}
		}


		
		$sSql .= "\nWHERE\n" .
					"document_version_id = " . $iDocumentVersionId;
		
		$this->DB->executeQuery($sSql);
	}

	public function select($iDocumentVersionId)
	{
		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"wf_documents_versions\n" .
				"WHERE\n" .
					"document_version_id = " . $iDocumentVersionId . "\n" .
				"LIMIT 1";

		return $this->DB->select($sSql, true);
	}

	public function selectDocument($sTableName, $iDocumentVersionId)
	{
		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"wf_documents_" . $sTableName . "\n" .
				"WHERE\n" .
					"document_version_id = " . $iDocumentVersionId;
		return $this->DB->select($sSql, true);
	}

	public function delete($iDocumentVersionId)
	{
		$sSql = "DELETE FROM\n" .
					"wf_documents_versions\n" .
				"WHERE\n" .
					"document_version_id = " . $iDocumentVersionId;

		$this->DB->executeQuery($sSql);
		return ($this->DB->affectedRows() > 0) ? true : false;
	}

	public function deleteFields($sTableName, $iDocumentVersionId)
	{
		$sSql = "DELETE FROM\n" .
					"wf_documents_" . $sTableName . "\n" .
				"WHERE\n" .
					"document_version_id = " . $iDocumentVersionId;

		$this->DB->executeQuery($sSql);
		return ($this->DB->affectedRows() > 0) ? true : false;
	}
}

?>