<?
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

class WF_FolderDB extends MSF_ModelDBSupport
{
	/**
	 * Vozvrashet config
	 *
	 * @param int $iId
	 * @return array
	 */
	public function getConfig($iId)
	{
		$sSQL =	"SELECT" . "\n" .
					"name, description, fields_xml, view_table, compared_xml, group_id, full_description" . "\n" .
				"FROM" . "\n" .
					"wf_folders" . "\n" .
				"WHERE" . "\n" .
					"folder_id='" . $iId . "'";


		return $this->DB->select($sSQL, true);
	}

	/**
	 * Sohranyaet config
	 *
	 * @param array $aConfig
	 * @param int $iId
	 * @return void
	 * @access public
	 */
	public function saveConfig($aConfig, $iId)
	{
		$Date	= new MSF_Date(time());
		$sSQL	=	"UPDATE" . "\n" .
						"wf_folders" . "\n" .
					"SET" . "\n";

		$i	= 0;
		foreach($aConfig as $n=>$v) {
			$sSQL	.=	$n . "='" . $this->escapeValue($v) . "'," . "\n";

			$i++;
		}

		$sSQL .=	"modified_at='" . $Date->formatTimestamp() . "'" . "\n";
		$sSQL .=	"WHERE" . "\n" .
						"folder_id='" . $iId . "'";

		
		$this->DB->executeQuery($sSQL);
	}

	/**
	 * Dobalyaet zapis o novom zhurnale i vosvrashaet ego id.
	 *
	 * @param array $aConfig
	 * @return int
	 * @access public
	 */
	public function create($aConfig)
	{
		$Date	= new MSF_Date(time());
		
		$sSQL	=	"INSERT INTO" . "\n" .
						"wf_folders (name, description, full_description, fields_xml, view_table, created_at, modified_at, compared_xml, group_id)" . "\n" .
					"VALUES" . "\n" .
						"(" . "\n" .
						"'" . $this->escapeValue($aConfig["name"]) . "'," . "\n" .
						"'" . $this->escapeValue($aConfig["description"]) . "'," . "\n" .
						"'" . $this->escapeValue($aConfig["full_description"]) . "'," . "\n" .
						"'" . $this->escapeValue($aConfig["fields_xml"]) . "'," . "\n" .
						"'wf_folder_" . MSF_String::random(8) . "'," . "\n" .
						"'" . $Date->formatDate() . "'," . "\n" .
						"'" . $Date->formatTimestamp() . "'," . "\n" .
						"'" . $this->escapeValue($aConfig["compared_xml"]) . "'," . "\n" .
						"'" . $aConfig["group_id"] . "'" . "\n" .
						")";


		$this->DB->executeQuery($sSQL);
		return $this->DB->insertId("wf_folders", "folder_id");
	}

	/**
	 * Sozdaet tablice zhurnala
	 *
	 * @param string $sTableName
	 * @param array $aFields
	 * @return void
	 * @access public
	 */
	public function createView($sTableName, $aFields)
	{
		$sSQL		= "SELECT COUNT(*) AS total FROM pg_tables WHERE tablename = '" . $sTableName . "'";
		$aResult	= $this->DB->select($sSQL, true);

		if($aResult["total"] > 0) {
			$sSQL	= "DROP TABLE " . $sTableName;
			$this->DB->executeQuery($sSQL);
		}

		$sSQL	=	"CREATE TABLE " . $sTableName . " (" . "\n";
		$sSQL	.=	"document_version_id integer NOT NULL DEFAULT 0";

		foreach($aFields as $sName=>$sType) {
			$sSQL	.=	"," . "\n" . $sName . " " . WF_SystemFieldsSettings::getSqlType($sType);//$this->selectType($sType);
		}

		$sSQL	.=	"," . "\n" . "CONSTRAINT " . $sTableName . "_pkey PRIMARY KEY (document_version_id)";
		$sSQL	.=	"\n" . ") WITH OIDS;";

		$this->DB->executeQuery($sSQL);
	}

	/**
	 * Udalyaet tablicu zhurnala.
	 *
	 * @param string $sTable
	 * @return void
	 * @access public
	 */
	public function removeView($sTable)
	{
		$sSQL		= "SELECT COUNT(*) AS total FROM pg_tables WHERE tablename = '" . $sTable . "'";
		$aResult	= $this->DB->select($sSQL, true);

		if($aResult["total"] > 0) {
			$sSQL	= "DROP TABLE " . $sTable;
			$this->DB->executeQuery($sSQL);
		}
	}

	/**
	 * Udalyaet zapis o zhurnale s tablici shurnalov
	 *
	 * @param int $iId
	 * @return void
	 * @access public
	 */
	public function removeFolder($iId)
	{
		$sSQL	= 	"DELETE" . "\n" .
					"FROM" . "\n" .
						"wf_folders" . "\n" .
					"WHERE" . "\n" .
						"folder_id='" . $iId . "'";

		$this->DB->executeQuery($sSQL);
	}

	/**
	 * Perepisivaet dannie iz talic documentov v tablicu
	 * zhurnala. Veshaet triggeri na tablici documentov, chtovi
	 * dannie v tablice documenotv vsegda obnovlyalis, esli menyaetsya tablica documentov
	 *
	 * @param string $sViewTable
	 * @param array $aVersions
	 * @return void
	 * @access public
	 */
	public function associateFolder($sViewTable, $aVersions)
	{
		
		foreach($aVersions as $sTable=>$aFields) {
			//vineseno za tranzakticu, t.k. ya ne nashel normalmoy
			//konstrukcii "DROP TRIGGER IF EXISTS" dlya pg 8.1
			//i sdelal proverku cherez iskluchenie

			$this->removeTrigger($sTable);
			//if(!empty($aFields)) {
				$this->DB->begin();
				$this->DB->executeQuery("LOCK TABLE wf_documents_" . $sTable . " IN SHARE MODE");
				$this->copyDataToFolder($sViewTable, $sTable, $aFields);
				$this->buildTrigger($sViewTable, $sTable, $aFields);
				$this->DB->commit();
			//}

		}

	}
	
	/**
	 * kopiruet dannie is tablici documentov v tablicu zhurnala
	 *
	 * @param string $sViewTable
	 * @param string $sTable
	 * @param array $aFields
	 * @return void
	 * @access private
	 */
	private function copyDataToFolder($sViewTable, $sTable, $aFields)
	{
		$aFrom	= array("document_version_id");
		$aTo	= array("document_version_id");
		foreach($aFields as $sFrom=>$sTo) {
			array_push($aFrom, $sFrom);
			array_push($aTo, $sTo);
		}

		$sSQL = "INSERT INTO " . $sViewTable . " (" . implode(", ", $aTo) . ") SELECT " . implode(", ", $aFrom) . " FROM wf_documents_" . $sTable;
		$this->DB->executeQuery($sSQL);
	}

	/**
	 * veshaet trigger na tablicu documentov
	 *
	 * @param string $sViewTable
	 * @param string $sTable
	 * @param array $aFields
	 * @return void
	 * @access private
	 */
	private function buildTrigger($sViewTable, $sTable, $aFields)
	{
		$sUpdate	= "";
		$aFrom		= array("NEW.document_version_id");
		$aTo		= array("document_version_id");
		
		foreach($aFields as $sFrom=>$sTo) {
			array_push($aFrom, "NEW." . $sFrom);
			array_push($aTo, $sTo);

			$sUpdate .= ", " . $sTo . "=NEW." . $sFrom;
		}


		$sSQL	=	"CREATE OR REPLACE FUNCTION folder_associate_" . $sTable . "() RETURNS TRIGGER AS " . '$folder_associate_' . $sTable . '$' . "\n" .
						"BEGIN" . "\n" .
							"IF (TG_OP = 'DELETE') THEN" . "\n" .
								"DELETE" . "\n" .
								"FROM" . "\n" .
									$sViewTable . "\n" .
								"WHERE" . "\n" .
									"document_version_id=OLD.document_version_id;" . "\n" .
							"ELSIF (TG_OP = 'UPDATE') THEN" . "\n" .
								"UPDATE" . "\n" .
									$sViewTable . "\n" .
								"SET" . "\n" .
									"document_version_id=document_version_id" . "\n" .
									$sUpdate . "\n" .
								"WHERE" . "\n" .
									"document_version_id=NEW.document_version_id;" . "\n" .
							"ELSIF (TG_OP = 'INSERT') THEN" . "\n" .
								"DELETE FROM" . "\n" .
									$sViewTable . "\n" .
								"WHERE" . "\n" .
									"document_version_id IN (" . "\n" .
										"SELECT" . "\n" .
											"document_version_id". "\n" .
										"FROM". "\n" .
											"wf_documents_versions". "\n" .
										"WHERE". "\n" .
											"document_id = (" . "\n" .
												"SELECT" . "\n" .
													"document_id". "\n" .
												"FROM". "\n" .
													"wf_documents_versions". "\n" .
												"WHERE". "\n" .
													"document_version_id = NEW.document_version_id" . "\n" .
											")" . "\n" .
									");" . "\n" .
								"INSERT INTO" . "\n" .
									$sViewTable . "(" . implode(",", $aTo) . ")" . "\n" .
								"VALUES" . "\n" .
									"(" . implode(",", $aFrom) . ");" . "\n" .
							"END IF;" . "\n" .
							"RETURN NULL;" . "\n" .
						"END;" . "\n" .
						'$folder_associate_' . $sTable . '$' . " LANGUAGE plpgsql;";

		$sSQL	.=	"\n\n";
		$sSQL	.=	"CREATE TRIGGER folder_associate_" . $sTable . "\n" .
					"AFTER INSERT OR UPDATE OR DELETE ON wf_documents_" . $sTable . "\n" .
    				"FOR EACH ROW EXECUTE PROCEDURE folder_associate_" . $sTable . "();";

		//debug($sSQL,$aTo, $aFrom, $sUpdate);
		//exit();
    	$this->DB->executeQuery($sSQL);
	}

	/**
	 * udalyaet trigger s tablici documentov
	 *
	 * @param string $sTable
	 * @return void
	 * @access public
	 */
	public function removeTrigger($sTable)
	{
		$sSQL	= "DROP TRIGGER folder_associate_" . $sTable . " ON wf_documents_" . $sTable . ";";
		try {
			$this->DB->executeQuery($sSQL);
		}
		catch(MSF_DBException $e) {

		}

		$sSQL	= "DROP FUNCTION folder_associate_" . $sTable . "();";
		try {
			$this->DB->executeQuery($sSQL);
		}
		catch(MSF_DBException $e) {

		}

	}

	/**
	 * nachalo transakcii
	 *
	 * @return void
	 * @access public
	 */
	public  function begin()
	{
		$this->DB->begin();
	}
	
	/**
	 * Konec transakcii
	 *
	 * @return void
	 * @access public
	 */
	public function commit()
	{
		$this->DB->commit();
	}

	/**
	 * vozvrashaet spisok documentov
	 *
	 * @param array $aConfig
	 * @param array $aColumns
	 * @return array
	 */
	public function getDocumentsList($aConfig, $aColumns, $aStructureIds = array(), $aDocumentIds = array())
	{
		$sSQL	= 	"SELECT" . "\n";
		
		$iTotal	= count($aColumns);
		for($i=0; $i<$iTotal; $i++) {
			$sSQL .= $aColumns[$i]["name"];
			$sSQL .= ",\n";
		}
		
		$sSQL	.=		"title" . "\n" .
					"FROM " . "\n" .
						$aConfig["view_table"] . ", wf_documents" . "\n" .
					"WHERE" . "\n" .
						"wf_documents.document_version_id=" . $aConfig["view_table"] . ".document_version_id";
		
		if (!empty($aStructureIds)) {
			$sSQL .= "\nAND(\n" .
						"structure_id IN (" . implode(",", $aStructureIds) . ")\n" .
					"OR\n" .
						"document_id IN (" . implode(",", $aDocumentIds) . "))";
		}
						
		return $this->DB->select($sSQL);
	}
	
	public function nameExists($sName, $iFolderId)
	{
		$sSQL	=	"SELECT" . "\n" .
						"COUNT(*) AS total" . "\n" .
					"FROM" . "\n" .
						"wf_folders" . "\n" .
					"WHERE" . "\n" .
						"name='" . $this->escapeValue($sName) . "'" . "\n" .
					"AND" . "\n" .
						"folder_id !=" . $iFolderId;
		
		return $this->DB->select($sSQL, true, "total");
	}
}
?>