<?
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

class WF_FolderGroupDB extends MSF_ModelDBSupport
{
	/**
	 * Vozvrashaet config
	 *
	 * @param int $iId
	 * @return unknown
	 */
	public function getConfig($iId)
	{
		$sSQL =	"SELECT" . "\n" .
					"name, description, user_id" . "\n" .
				"FROM" . "\n" .
					"wf_folders_groups" . "\n" .
				"WHERE" . "\n" .
					"group_id='" . $iId . "'";


		return $this->DB->select($sSQL, true);
	}

	/**
	 * Sohranyaet config
	 *
	 * @param array $aConfig
	 * @param int $iId
	 * @return void
	 * @access public
	 */
	public function saveConfig($aConfig, $iId)
	{
		$Date	= new MSF_Date();
		$sSQL	=	"UPDATE" . "\n" .
						"wf_folders_groups" . "\n" .
					"SET" . "\n";

		$i	= 0;
		foreach($aConfig as $n=>$v) {
			$sSQL	.=	$n . "='" . $this->escapeValue($v) . "'," . "\n";

			$i++;
		}

		$sSQL .=	"modified_at='" . $Date->formatTimestamp() . "'" . "\n";
		$sSQL .=	"WHERE" . "\n" .
						"group_id='" . $iId . "'";


		$this->DB->executeQuery($sSQL);
	}

	/**
	 * Sozdaet novuyu gruppu i vosvrashaet ee id
	 *
	 * @param array $aConfig
	 * @return int
	 * @access public
	 */
	public function create($aConfig)
	{
		$aConfig = $this->escapeHashValues($aConfig);
		
		$Date	= new MSF_Date();
		$sSQL	=	"INSERT INTO" . "\n" .
						"wf_folders_groups (name, description, user_id, created_at, modified_at)" . "\n" .
					"VALUES" . "\n" .
						"(" . "\n" .
						"'" . $aConfig["name"] . "'," . "\n" .
						"'" . $aConfig["description"] . "'," . "\n" .
						"'-1'," . "\n" .
						"'" . $Date->formatDate() . "'," .
						"'" . $Date->formatTimestamp() . "'" .
						")";


		$this->DB->executeQuery($sSQL);
		return $this->DB->insertId("wf_folders_groups", "group_id");
	}

	/**
	 * Udalyaet gruppu
	 *
	 * @param int $iId
	 * @return void
	 * @access public
	 */
	public function removeGroup($iId)
	{
		$sSQL	= 	"DELETE" . "\n" .
					"FROM" . "\n" .
						"wf_folders_groups" . "\n" .
					"WHERE" . "\n" .
						"group_id='" . $iId . "'";

		$this->DB->executeQuery($sSQL);
	}

	/**
	 * Udalyaet iz shurnalov ssilku na gruppu
	 *
	 * @param int $iId
	 * @return void
	 * @access public
	 */
	public function removeLinks($iId)
	{
		$sSQL	=	"UPDATE" . "\n" .
						"wf_folders" . "\n" .
					"SET" . "\n" .
						"group_id=0" . "\n" .
					"WHERE" . "\n" .
						"group_id=" . $iId;


		$this->DB->executeQuery($sSQL);
	}

	/**
	 * Vozvrashaet spisok papok
	 *
	 * @param int $iId
	 * @return array
	 * @return void
	 * @access public
	 */
	public function getFolders($iId)
	{
		$sSQL	=	"SELECT" . "\n" .
						"folder_id, name, description" . "\n" .
					"FROM" . "\n" .
						"wf_folders" . "\n" .
					"WHERE" . "\n" .
						"group_id='" . $iId . "'\n" .
					"ORDER BY" . "\n" .
						"name";

		return $this->DB->select($sSQL);
	}
	
	public function getFoldersWithDoctypes($sDoctypes)
	{
		$sWhere	= "";
		if($sDoctypes != "") {
			$sWhere = "AND doctype_id IN(" . $sDoctypes . ")";		
		}
		
		$sSQL	= "SELECT" . "\n" .
					"wf_folders.folder_id" . "\n" . 
				"FROM" . "\n" . 
					"wf_folders" . "\n" .
				"WHERE" . "\n" . 
					"(SELECT COUNT(*) FROM wf_doctypes WHERE wf_doctypes.folder_id = wf_folders.folder_id " . $sWhere . ") > 0";
		return $this->DB->select($sSQL);
	}

}
?>