<?php
include_once "WF_Task.php";
include_once "WF_ScheduleDB.php";

/**
 */
class WF_Schedule
{
	/**
	 * @var array
	 */
	private $aTasks 	= array();
	
	/**
	 * @var WF_ScheduleDB
	 */
	private $oDb		= null;
	
	/**
	 * @return void
	 * @access public
	 */
	public function __construct()
	{
		$oDb		= MSF_Registry::get("MSF_DB");
		$this->oDb 	= new WF_ScheduleDB($oDb);
	}
	
	/**
	 * Dobavlyaet zadachu v spisok zadach i vozvrashaet ee id
	 *
	 * @param WF_Task $oWFTask
	 * @return int
	 * @access public
	 */
	public function addTask(WF_Task $oWFTask)
	{
		return $this->oDb->addTask($oWFTask);
	}

	/**
	 * Provaeryaet po id est li takaya zadacha
	 *
	 * @param int $iTaskId
	 * @return bool
	 * @access public
	 */
	public function isTaskExisted($iTaskId)
	{
		return $this->oDb->isTaskExisted($iTaskId);
	}

	/**
	 * Udalyaet zadachu
	 *
	 * @param int $iTaskId
	 * @return bool
	 * @access public
	 */
	public function removeTask($iTaskId)
	{
		return $this->oDb->removeTask($iTaskId);
	}
	
	/**
	 * Pomechaet zadachu kak vipolnennuyu
	 *
	 * @param int $iTaskId
	 * @return void
	 * @access public
	 */
	public function markTaskAsExecuted($iTaskId)
	{
		$this->oDb->markTaskAsExecuted($iTaskId, time());
	}
	
	/**
	 * Vozvrashaet vse zadachi
	 *
	 * @return array
	 * @access public
	 */
	public function getTasks()
	{
		$aTasks = array();
		foreach ($this->oDb->getTasks() AS $aTask) {
			$aTasks[$aTask["task_id"]] = new WF_Task();
			$aTasks[$aTask["task_id"]]->setDocumentId($aTask["document_id"]);
			$aTasks[$aTask["task_id"]]->setActionId($aTask["action_id"]);
			$aTasks[$aTask["task_id"]]->setActionName($aTask["action_name"]);
			$aTasks[$aTask["task_id"]]->setTimeout($aTask["timeout"]);
			$aTasks[$aTask["task_id"]]->setExecutedAt($aTask["executed_at"]);
		}
		
		return $aTasks;
	}

}

?>