<?php
/**
 */
class WF_ScheduleDB
{
	/**
	 * Kolichestvo vipolnyaemih zadach za raz
	 * 
	 */
	const GET_LIMIT = 100;
	
	/**
	 * Enter description here...
	 *
	 * @var MSF_DB
	 */
	private $oDb = null;
	
	/**
	 * @param MSF_DB $oDb
	 * @return void
	 * @access public
	 */
	public function __construct(MSF_DB $oDb)
	{
		$this->oDb = $oDb;
	}
	
	/**
	 * rovaeryaet po id est li takaya zadacha
	 *
	 * @param int $iTaskId
	 * @return bool
	 * @access public
	 */
	public function isTaskExisted($iTaskId)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"wf_schedule";
		return $this->oDb->select($sSql, true, "total") == 1 ? true : false;
	}
	
	/**
	 * dobavlyaet zadachu v spisok i vozvrashaet id
	 *
	 * @param WF_Task $oWFTask
	 * @return int
	 * @access public
	 */
	public function addTask(WF_Task $oWFTask)
	{
		$sSql = "INSERT INTO\n" .
					"wf_schedule\n" .
				"(\n" .
					"document_id," . "\n" .
					"action_id," . "\n" .
					"action_name," . "\n" .
					"timeout," . "\n" .
					"executed_at" . "\n" .
				") VALUES (\n" .
					$oWFTask->getDocumentId() . ",\n" .
					$oWFTask->getActionId() . ",\n" .
					"'" . $oWFTask->getActionName() . "',\n" .
					$oWFTask->getTimeout() . ",\n" .
					$oWFTask->getExecutedAt() . "\n" .
				")";
		$this->oDb->executeQuery($sSql);
		return $this->oDb->insertId("wf_schedule", "task_id");
	}
	
	/**
	 * Udalyaet zadachu iz spiska
	 *
	 * @param int $iTaskId
	 * @return boll
	 * @access public
	 */
	public function removeTask($iTaskId)
	{
		$sSql = "DELETE FROM\n" .
					"wf_schedule\n" .
				"WHERE\n" .
					"task_id = " . $iTaskId;

		$this->oDb->executeQuery($sSql);
		return $this->oDb->affectedRows() == 1 ? true : false;
	}
	
	/**
	 * Remember limit which equals 500
	 * 
	 * @return array
	 * @access public
	 */
	public function getTasks()
	{
		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"wf_schedule\n" .
				"LIMIT " . self::GET_LIMIT;
		

		return $this->oDb->select($sSql);
	}
	
	/**
	 * pomechaet zadachu kak vipolnennuyu
	 *
	 * @param int $iTaskId
	 * @param int $iExecutedAt
	 * @return bool
	 * @access public
	 */
	public function markTaskAsExecuted($iTaskId, $iExecutedAt)
	{
		$sSql = "UPDATE\n" .
					"wf_schedule\n" .
				"SET\n" .
					"executed_at = " . $iExecutedAt . "\n" . 
				"WHERE\n" .
					"task_id = " . $iTaskId;

		$this->oDb->executeQuery($sSql);
		return $this->oDb->affectedRows() == 1 ? true : false;
	}
	
}

?>