<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
include_once "system/security/MSF_ISecurityManager.php";
include_once "WF_AktenplanSecurityManagerDB.php";
include_once "system/security/MSF_SecurityMatrixNotSavedException.php";

class WF_AktenplanSecurityManager implements MSF_ISecurityManager 
{	
	/**
	 * @var WF_FoldersSecurityManagerDB
	 */
	private $DB;
	
		
	/**
	 * @param MSF_DB $DB
	 * @param int $iId
	 * @return void
	 * @access public
	 */
	public function __construct(MSF_DB $DB, $iId)
	{
		$this->DB			= new WF_AktenplanSecurityManagerDB($DB);		
	}
	
	/**
	 * Izmenyaet matricu dostupa
	 *
	 * @param array $aPost
	 * @return void
	 * @access public
	 */
	public function edit($aPost)
	{
		try {
			$this->DB->edit($aPost);
		}
		catch(MSF_DBException $e) {
			throw new MSF_SecurityMatrixNotSavedException($e->getMessage());
		}
		
	}
	
	/**
	 * Vozvrashaet matricu dostupa na document
	 *
	 * @return array
	 * @access public
	 */
	public function get()
	{
		return $this->DB->get();
	}
}

?>