<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
include_once "system/security/MSF_Access.php";
include_once "WF_AktenplanSwitcherDB.php";

class WF_AktenplanSwitcher extends MSF_Access
{
	
	/**
	 * @var WF_FoldersSwitcherDB
	 */
	private $DB 			= null;
	
	/**
	 * @var array
	 */
	private $aAccessTypes	= array(
			"view" 		=> "can_view"
			);
	
	/**
	 * @return void
	 * @access protected
	 */
	protected function initialize()
	{
		$this->DB = new WF_AktenplanSwitcherDB($this->getDb());
	}
	
	/**
	 * Vozvrashaet znachenie dostupa
	 *
	 * @param string $sAccessType
	 * @param int $iStructureId
	 * @param int $iFolderId
	 * @return int
	 * @access protected
	 */
	protected function getAccessValue($sAccessType, $iStructureId, $iFolderId)
	{
		$iResult = self::INHERIT;
		$aRights = $this->DB->select($iStructureId);
		
		if (!isset($this->aAccessTypes[$sAccessType])) {
			$iResult = self::DENY;
		}
		else if (count($aRights) > 0) {
			$iResult = $aRights[$this->aAccessTypes[$sAccessType]];
		}
		
		return $iResult;
	}
	
	
}
?>