<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "modules/structure/library/Struct_Tree.php";
include_once "WF_DoctypeAccessDB.php";

class WF_DoctypeAccess
{
	/**
	 * @var array
	 */
	private $aStruct;
	
	/**
	 * @var WF_DoctypeAccessDB
	 */
	private $DB;
	
	/**
	 * @var array
	 */
	private $aAccess;
	
	/**
	 * @return void
	 * @access public
	 *
	 */
	public function __construct()
	{
		$Struct 		= new Struct_Tree(MSF_Registry::get("MSF_DB"));
		$this->DB 		= new WF_DoctypeAccessDB(MSF_Registry::get("MSF_DB"));
		$this->aStruct 	= $Struct->get(false);
		$this->aAccess 	= $this->DB->select();
	}
	
	/**
	 * Vidaet spisol documentov, na kotoriy est dostup
	 *
	 * @param int $iDoctypeId
	 * @param int $iAuthorId
	 * @return array
	 * @access public
	 */
	public function get($iDoctypeId, $iStructure_id)
	{
		$iCounter 	= 0;
		$aResult 	= array();
		$aAccess 	= $this->defineAccessArray($iDoctypeId, $iStructure_id);
		
		for ($i = 0; $i < count($aAccess); $i++) {
			$aResult[$iCounter]["author_ids"] 	= array();
			$aResult[$iCounter]["view"] 		= $aAccess[$i]["can_view"];
			$aResult[$iCounter]["remove"] 		= $aAccess[$i]["can_remove"];
			$this->defineIds($aAccess[$i]["author_id"], $aResult[$iCounter]["author_ids"]);
			$iCounter++;
		}
		
		return $aResult;
	}
	
	private function defineAccessArray($iDoctypeId, $iStructure_id)
	{
		$aResult = array();
		
		for ($i = 0; $i < count($this->aAccess); $i++) {
			if ($iDoctypeId == $this->aAccess[$i]["doctype_id"] && $this->aAccess[$i]["structure_id"] == $iStructure_id) {
				$aResult[] = $this->aAccess[$i];
			}
		}
		
		return $aResult;
	}
	
	/**
	 * @param int $iId
	 * @param array $aResult
	 * @return void
	 * @access private
	 */
	private function defineIds($iId, &$aResult)
	{
		for ($i = 0; $i < count($this->aStruct); $i++) {
			if ($this->aStruct[$i]["node_id"] == $iId) {
				if ($this->aStruct[$i]["type"] == "subdivision") {
					$aResult[] = $iId;
					$this->getSub($this->aStruct, $iId, $aResult);
				}
				elseif (!in_array($iId, $aResult)) {
					$aResult[] = $iId;
				}
			}
		}
	}
	
	/**
	 * @param array $aStruct
	 * @param int $iId
	 * @param array $aResult
	 * @return void
	 * @access private
	 */
	private function getSub($aStruct, $iId, &$aResult)
	{
		for ($i = 0; $i < count($aStruct); $i++) {
			if ($aStruct[$i]["parent_id"] == $iId) {
				if ($aStruct[$i]["type"] == "subdivision") {
					$aResult[] = $aStruct[$i]["node_id"];
					$this->getSub($aStruct, $aStruct[$i]["node_id"], $aResult);
				}
				elseif(!in_array($aStruct[$i]["node_id"], $aResult)) {
					$aResult[] = $aStruct[$i]["node_id"];
				}
			}
		}
	}
}

?>