<?php

defined("__MSF") or die("Direct access is not allowed");

class WF_DocumentSecurityManagerDB extends MSF_ModelDBSupport
{
	/**
	 * Proveryaet, sushestvuet li pravilo dostupa
	 *
	 * @param array $aPost
	 * @param int $iDocumentId
	 * @return array
	 * @access public
	 */
	public function exists($aPost, $iDocumentId)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"wf_documents_access_list\n" .
				"WHERE\n" .
					"structure_id = " . $this->escapeValue($aPost["structure_id"]) . "\n" .
				"AND\n" .
					"document_id = " . $iDocumentId;
		
		return $this->DB->select($sSql, true, "total");
	}
	
	/**
	 * Dobavlyaet novie pravila v matricu dostupa
	 *
	 * @param array $aPost
	 * @param int $iDocumentId
	 * @return void
	 * @access public
	 */
	public function insert($aPost, $iDocumentId)
	{
		$sSql = "INSERT INTO\n" .
					"wf_documents_access_list\n" .
				"(\n" .
					"structure_id,\n" .
					"document_id\n" .
				")\n" .
				"VALUES(\n" .
					$this->escapeValue($aPost["structure_id"]) . ",\n" .
					$iDocumentId . "\n" .
				")";
		$this->DB->executeQuery($sSql);
	}
	
	/**
	 * Vozvrashaet matricu dostupa documenta
	 *
	 * @param int $iDocumentId
	 * @return array
	 * @access public
	 */
	public function select($iDocumentId)
	{
		$sSql = "SELECT\n" .
					"*\n" .
				"FROM\n" .
					"wf_documents_access_list\n" .
				"WHERE\n" .
					"document_id = " . $iDocumentId;
		
		return $this->DB->select($sSql);
	}
	
	/**
	 * Udalyaet matricu dostupa documenta
	 *
	 * @param int $iDocumentId
	 * @return void
	 * @access public
	 */
	public function delete($iDocumentId)
	{
		$sSql = "DELETE FROM\n" .
					"wf_documents_access_list\n" .
				"WHERE\n" .
					"document_id = " . $iDocumentId;
		
		$this->DB->executeQuery($sSql);
	}
}

?>