<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "system/security/MSF_Access.php";
include_once "WF_DocumentSwitcherDB.php";

class WF_DocumentSwitcher extends MSF_Access
{
	/**
	 * @var WF_DocumentSwitcherDB
	 */
	private $DB;
	
	/**
	 * @return void
	 * @access protected
	 */
	protected function initialize()
	{
		$this->DB = new WF_DocumentSwitcherDB($this->getDb());
	}
	
	/**
	 * Vozvrashaet znachenie dostupa
	 *
	 * @param string $sAccessType
	 * @param int $iStructureId
	 * @param array $aParams
	 * @return int
	 * @access protected
	 */
	protected function getAccessValue($sAccessType, $iStructureId, $aParams)
	{
		$iResult = $this->DB->select($aParams["document_id"], $iStructureId);
		
		if ($iResult == 1) {
			$iResult = self::ALLOW;
		}
		else {
			$iResult = self::DENY;
		}
		
		return $iResult;
	}
}

?>