<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
include_once "WF_MediaSwitcherDb.php";
include_once "WF_DocumentSwitcher.php";
class WF_MediaSwitcher extends MSF_Access
{
	const DOCUMENTS_EXTRA_NAME 	= "workflow_document";
	
	const DOCTYPES_EXTRA_NAME 	= "workflow_doctype";
	
	private $iDocumentId		= 0;
	
	private $iDoctypeId			= 0;
	
	protected function getAccessValue($sAccessType, $iStructurePath, $aExtra)
	{
		
		$iResult 	= self::DENY;
		switch ($aExtra["name"]) {
			case self::DOCTYPES_EXTRA_NAME:
				$iResult = self::ALLOW;
				break;
				
			case self::DOCUMENTS_EXTRA_NAME:	
				$aParams 	= $this->getParams($aExtra["id"]);		
				if (empty($aParams)) {
					return self::ALLOW;
				}
				if (!isset($aParams["structure_id"])) {
					$aParams["structure_id"] = 0;
				}
				if (!isset($aParams["doctype_id"])) {
					$aParams["doctype_id"] = 0;
				}	
				if (!isset($aParams["document_id"])) {
					$aParams["document_id"] = 0;
				}	
				
				if ($iStructurePath == $aParams["structure_id"]) {
					$bResult = true;
				}
				else {
					$oDocumentSwitcher = new WF_DocumentSwitcher($this->getDb());
					$bResult = $oDocumentSwitcher->hasAccess(
							$sAccessType,
							array($iStructurePath),
							array("document_id" => $aParams["document_id"])
							);
							
				}

				if ($bResult) {
					$iResult = self::ALLOW;
				}
				else {
					$UserBox = MSF_Registry::get("MSF_UserBox");
					$oDoctypeSwitcher = new WF_DoctypeSwitcher($this->getDb());
					//debug($iStructurePath, explode(".", $UserBox->getCurrentStructurePath()), WF_Utils::getPath());
					$bResult = $oDoctypeSwitcher->hasAccess(
							$sAccessType,
							WF_Utils::getPath(),
							array(
									"doctype_id"	=> $aParams["doctype_id"],
									"author_id"		=> $aParams["structure_id"]
									)
							);
					if ($bResult) {
						$iResult = self::ALLOW;
					}
					else {
						$iResult = self::DENY;
					}
					
				}

				break;

		}

		return $iResult;
	}
	
	private function getParams($iMediaId)
	{
		$oDb = new WF_MediaSwitcherDb($this->getDb());
		return $oDb->get($iMediaId);
	}
	
	
}
?>