<?php
/*
 * File: WF_MenuService.php
 * Created at: 15.01.2008
 */
defined("__MSF")
	or die("Direct access is not allowed");

include_once "modules/workflow/library/folders/WF_FoldersGroupsList.php";
include_once "modules/workflow/library/folders/WF_FolderGroup.php";
include_once "modules/workflow/library/security/WF_FoldersSwitcher.php";
include_once "modules/workflow/library/WF_Utils.php";
include_once "modules/workflow/library/security/WF_AktenplanSwitcher.php";
include_once "modules/archive/library/ARCH_SecurityManager.php";

/**
 * @package WF
 * @author Detrix
 * @copyright Copyright (c) 2007, Detrix
 */
class WF_MenuService implements MSF_IService
{
	private $Menu	= null;

	private $Locale	= null;

	public function __construct()
	{
		$this->Menu 	= MSF_Registry::get("MSF_Menu");
		$this->Locale	= MSF_Registry::get("MSF_Locale");
	}

	public function execute()
	{
		if (MSF_Registry::get("MSF_UserBox")->isAdmin()) {
			//$this->buildAdmin();
		}
		$this->buildWorkflow();
	}

	private function buildAdmin()
	{
		$this->Menu->setItem("admin", "workflow_admin", $this->Locale->getWord("WORKFLOW_MODULE_NAME"), "#", "", "return false");
		$this->Menu->setItem("workflow_admin", "workflow_doctypes", $this->Locale->getWord("WORKFLOW_ADMIN_MENU_DOCTYPES"), "/admin/workflow", "image");
		$this->Menu->setItem("workflow_admin", "workflow_folders", $this->Locale->getWord("WORKFLOW_FOLDERS"), "/admin/workflow/folders", "image");
		$this->Menu->setItem("workflow_admin", "workflow_folders_groups", $this->Locale->getWord("WORKFLOW_FOLDERS_GROUPS"), "/admin/workflow/folders_groups", "image");
	}

	private function buildWorkflow()
	{
		$FolderSwitcher 			= new WF_FoldersSwitcher(MSF_Registry::get("MSF_DB"));
		$AktenplanSwitcher 	= new WF_AktenplanSwitcher(MSF_Registry::get("MSF_DB"));
		
		$GroupList	= new WF_FoldersGroupsList();
		$aList		= $GroupList->getList();

		$this->Menu->setItem(null, "workflow", $this->Locale->getWord("WORKFLOW_DOCUMENTS"), "#", "image");
		
		
		$aToMenu	= array();
		foreach($aList as $aGroup) {
			//$this->Menu->setItem("workflow", "workflow_folders_group_" . $aGroup["group_id"], $aGroup["name"], "#", "image", "return false");
			$aGroupFolders	= array();
			
			$Group	= new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));
			$Group->load($aGroup["group_id"]);

			$aFolders	= $Group->getFolders();
			foreach($aFolders as $aFolder) {
				if ($FolderSwitcher->hasAccess("view", WF_Utils::getPath(), $aFolder["folder_id"])) {
					//$this->Menu->setItem("workflow_folders_group_" . $aGroup["group_id"], "workflow_group_" . $aFolder["folder_id"], $aFolder["name"], "/workflow/folders/" . $aFolder["folder_id"], "image");
					$aTmp = array(
						"folder_id"		=> $aFolder["folder_id"],
						"name"			=> $aFolder["name"],
						"description" 	=> $aFolder["description"]
					);
					array_push($aGroupFolders, $aTmp);
				}
				
			}
			if(!empty($aGroupFolders)) {
				$aTmp	= array(
					"group_id"		=> $aGroup["group_id"],
					"name"			=> $aGroup["name"],
					"description" 	=> $aGroup["description"],
					"folders"		=> $aGroupFolders
				);
				
				array_push($aToMenu, $aTmp);
			}

		}
		//debug($aToMenu);
		foreach($aToMenu as $aGroup) {
			$this->Menu->setItem("workflow", "workflow_folders_group_" . $aGroup["group_id"], $aGroup["name"], "#", "image", "return false", $aGroup["description"]);
			
			foreach($aGroup["folders"] as $aFolder) {
				$this->Menu->setItem("workflow_folders_group_" . $aGroup["group_id"], "workflow_group_" . $aFolder["folder_id"], $aFolder["name"], "/workflow/folders/" . $aFolder["folder_id"], "image", "", $aFolder["description"]);
			}
		}
		
		$oArchiveSecurityManager = new ARCH_SecurityManager();
		if($oArchiveSecurityManager->hasMenuAccess()) {		
			$this->Menu->setItem("workflow", "arch_main", $this->Locale->getWord("WORKFLOW_ADMIN_MENU_DOCTYPE_ARCHIVE"), "/archive", "image");
		}
		if($AktenplanSwitcher->hasAccess("view", WF_Utils::getPath(), 0)) {
			$this->Menu->setItem("workflow", "workflow_group_dossier", $this->Locale->getWord("WORKFLOW_FOLDER_AKTENPLAN"), "/workflow/dossier", "image");
		}
		
		$Group	= new WF_FolderGroup(new WF_FolderGroupDB(MSF_Registry::get("MSF_DB")));
		$Group->load(0);

		$aFolders	= $Group->getFolders();
		
		foreach($aFolders as $aFolder) {
			if ($FolderSwitcher->hasAccess("view", WF_Utils::getPath(), $aFolder["folder_id"])) {
				$this->Menu->setItem("workflow", "workflow_group_" . $aFolder["folder_id"], $aFolder["name"], "/workflow/folders/" . $aFolder["folder_id"], "image", "", $aFolder["description"]);
			}
					
		}
	}

}
?>