var WF_AbstractForm = Class.create();
WF_AbstractForm.prototype =
{
	initialize: function(sName, Container, iCount, aTypesValues, SubmitBtn)
	{
		this.sName 			= sName;
		this.aValue 		= new Array();
		this.iCount 		= iCount;
		this.Container 		= Container;
		this.SubmitBtn 		= $(SubmitBtn);
		this.aTypesValues 	= aTypesValues;
		this.iCounter 		= 0;
	},
	
	clone: function(sFormId)
	{
		var Body = WF_ModifyClonedForm.start(
			$(sFormId).cloneNode(true),
			this.iCount
		);
		this.Container.appendChild(Body);

		Body.show();
		return Body;
	},
	
	getById: function(sId, sName)
	{
		var Elm = $(sId + "_" + this.iCount);
		
		if (sName && Elm && Elm.parentNode && Elm.tagName == "INPUT" && Elm.type == "radio") {
			var Parent 		= Elm.parentNode;
			var isChecked 	= (Elm.checked) ? true : false;
			
			var NewElm = new Element("input", {
				"type" 		: "radio",
				"name" 		: sName,
				"value"		: Elm.value,
				"id" 		: Elm.id
			});

			NewElm.defaultChecked = isChecked;
			Parent.replaceChild(NewElm, Elm);
			Elm = NewElm;
		}
		else if (sName) {
			Elm.name = sName;
		}
		
		return Elm;
	},
	
	setValue: function(aValue)
	{
		this.aValue = aValue;
	},
	
	/*
	getName: function(sGroup, sName, isArray)
	{
		return this.sName + "[value][" + sGroup + "][" + sName + "]" + ((isArray) ? "[]" : "");
	},
	
	getValue: function(sGroup, sName)
	{
		return (this.aValue && this.aValue[sGroup] && this.aValue[sGroup][sName]) ? this.aValue[sGroup][sName] : "";
	},
	*/
	
	getName: function(sName, sGroup, isArray)
	{
		if (sGroup) {
			sName = this.sName + "[value][" + sGroup + "][" + sName + "]" + ((isArray) ? "[]" : "");
		}
		else {
			sName = this.sName + "[value][" + sName + "]" + ((isArray) ? "[]" : "");
		}

		return sName;
	},
	
	getValue: function(sName, sGroup)
	{
		if (sGroup) {
			return (this.aValue && this.aValue[sGroup] && this.aValue[sGroup][sName]) ? this.aValue[sGroup][sName] : "";
		}
		else {
			return (this.aValue && this.aValue[sName]) ? this.aValue[sName] : "";
		}
	},
	
	getButton: function()
	{
		return this.SubmitBtn;
	},
	
	getValues: function(sType)
	{
		for (var i = 0; i < this.aTypesValues.length; i++) {
			if (this.aTypesValues[i].name == sType) {
				return this.aTypesValues[i].value;
			}
		}
	},
	
	addBlock: function(Container, sTypeName, sValueName, OnTypeChange, bStructureShowPosts)
	{
		var me 			= this;
		var Form 		= WF_ModifyClonedForm.start(
			$("router_delegate_types_values").cloneNode(true),
			this.iCount + "_" + this.iCounter
		);
		Container.appendChild(Form);
		
		var Types 	= this._getByBlockId("router_delegate_type");
		var Values 	= this._getByBlockId("router_delegate_value");
		
		Types.name = this.getName(sTypeName);
		
		for (var i = 0; i < Types.options.length; i++) {
			if (this.getValue(sTypeName) == Types.options[i].value) {
				Types.options[i].selected = true;
				Types.options[i].setAttribute("selected", "selected");
				
				if (Types.options[i].value != "") {
					Values.insert(new Element("br"));
					this._addValues(
						Values,
						this.getName(sValueName),
						Types.options[i].value,
						this.getValue(sValueName),
						bStructureShowPosts
					);
					if (OnTypeChange && OnTypeChange.value == Types.options[i].value) {
						Values.insert(new Element("br"));
						Values.insert(OnTypeChange.element.cloneNode(true));
					}
				}
			}
		}
		
		Types.onchange = function()
		{
			if (Values.childNodes.length > 0) {
				for (var i = Values.childNodes.length - 1; i >=0; i--) {
					Values.removeChild(Values.childNodes[i]);
				}
			}
			if (this.value != "") {
				Values.insert(new Element("br"));
				me._addValues(
					Values,
					me.getName(sValueName),
					this.value,
					"",
					bStructureShowPosts
				);
				if (OnTypeChange && OnTypeChange.value == this.value) {
					Values.insert(new Element("br"));
					Values.insert(OnTypeChange.element.cloneNode(true));
				}
			}
			return false;
		};
		
		this.iCounter++;
		Form.show();
	},
	
	_addValues: function(Values, sName, sValue, sData, bStructureShowPosts)
	{
		var Obj;
		
		switch (sValue) {
			case "groups":
				Obj = $(document.createElement("span"));
				Values.appendChild(Obj);
		
				var oRefGroups = new MSFW.Placeholder.Reference({
					"Container"			: Obj,
					"referenceId"		: 316,
					"inputName"			: sName,
					"columns"			: {	
											"name" 		: {	"select" : true,	"group" : true,	"sort" : true,	"filter" : true },
											"employee" 	: {	"select" : false,	"group" : true,	"sort" : true,	"filter" : true	}
										  },
					"defaultGroups"		: ["name"],
					"byId"				: true,
					"multiselect"		: true,
					"default"			: sData,
					"valueSeparator"	: ", "
				});
				break;
			case "structure":
				Obj = $(document.createElement("span"));
				Values.appendChild(Obj);
				
				new MSFW.Placeholder.Structure({
					"Container" : Obj,
					"inputName" : sName,
					"multiselect" : true,
					"default" : sData,
					"showPosts" : bStructureShowPosts
				});
				break;
			default:
				var Option;
				Obj 		= $(document.createElement("select"));
				Obj.name 	= sName;
				Values.appendChild(Obj);
				Option = new Element("option", {"value": ""});
				Option.insert(aGlobalMsfWords["WORKFLOW_NULL"]);
				Obj.insert(Option);
				for (var i = 0; i < this.aTypesValues.length; i++) {
					if (this.aTypesValues[i]["name"] == sValue) {
						aValue = this.aTypesValues[i]["value"];
						
						for (var j = 0; j < aValue.length; j++) {
							if ((aValue[j]["show"] == "action" || aValue[j]["show"] == "all") || (sValue == "fields" && aValue[j]["type"] == "structure")) {
								Option 			= $(document.createElement("option"));
								Option.value 	= aValue[j]["name"];
								if (sData && sData == Option.value) {
									Option.selected = true;
									Option.setAttribute("selected", "selected");
								}
								Option.appendChild(document.createTextNode(aValue[j]["title"]));
								Obj.appendChild(Option);
							}
						}
					}
				}
				break;
		}
	},
	
	_getByBlockId: function(sId)
	{
		return $(sId + "_" + this.iCount + "_" + this.iCounter)
	},
	
	__hAllDTFields : null,
	
	setAllDTFields: function(hAllDTFields) {
		var oHashizer = {
			hash : function(hHash) {
				hHash = $H(hHash);
				hHash.each(function(kav) {
					if (typeof kav.value == "object") {
						hHash.set(kav.key, this.hash(kav.value));
					}
					else {
						hHash.set(kav.key, kav.value);
					}
					
				
				}.bind(this));
				return hHash;
			}
		}
		
		this.__hAllDTFields = oHashizer.hash(hAllDTFields);
	}
}