var WF_Address = Class.create(); 
WF_Address.prototype =
{
	initialize : function(sName, sAType, sAValue, sVType, sVValue, sNType, sNValue)
	{
		this.sContext		= null;
		this.aAddress 		= aAddress;
		this.sName			= sName;
		this.sAType			= sAType;
		this.sAValue		= sAValue;
		this.sVType			= sVType;
		this.sVValue		= sVValue;
		this.sNType			= sNType;
		this.sNValue		= sNValue;
		this.onChangeValue 	= null;
		this.onChangeFields	= function(){};
		this.onChangeType 	= null;
		this.onChangeStructureValue = function(){};
		this.onChangeRefGroupsValue = function(){};
		this.onUpdateTitle	= function(oSelect) {};
	},
	
	getNamed : function(sInputName, iPointId, iActionId)
	{
		var aMap = {
				"@pointId" 	: (iPointId) ? iPointId : WF_Utils.sDelimiter,
				"@actionId" : (iActionId) ? iActionId : WF_Utils.sDelimiter
				};
		var sResult = sInputName;
		for (sKey in aMap) {
			sResult = WF_Utils.strReplace(sKey, aMap[sKey], sResult);
		}

		return sResult;
	},

	update : function(oElement, sType, sValue)
	{
		var aProps = {};
		aProps.name = oElement;
		if (WF_Utils.isCloned(oElement, this.sName)) {
			aProps.type 		= WF_Utils.$(oElement, this.sName, this.sAType);
			aProps.value 		= WF_Utils.$(oElement, this.sName, this.sAValue);
			aProps.typeId 		= WF_Utils.makeId(oElement, this.sName, this.sVType	);
			aProps.valueId 		= WF_Utils.makeId(oElement, this.sName, this.sVValue);
			var aLocation		= WF_Utils.parseId(oElement, this.sName).split(WF_Utils.sDelimiter);
			aProps.pointId		= aLocation[0];
			aProps.actionId		= aLocation[1];
		}
		else {
			aProps.type 		= $(this.sAType);
			aProps.value 		= $(this.sAValue);
			aProps.typeId 		= this.sVType;
			aProps.valueId 		= this.sVValue;
			aProps.pointId		= 0;
			aProps.actionId		= 0;
		}
		
		this.createType(aProps, sType, sValue);
		this.updateValue(aProps, sValue);
	},
	
	createType : function(aProps, sType, sValue)
	{
		var oThis 			= this;
		var oSelect 		= document.createElement("SELECT");
		oSelect.id 			= aProps.typeId;
		oSelect.name		= this.getNamed(this.sNType, aProps.pointId, aProps.actionId);
		oSelect.onchange 	= function() {oThis.updateValue(aProps)};;
		var iCounter 		= 0;
		
		oSelect.options[iCounter++] = new Option(aGlobalMsfWords["WORKFLOW_NULL"], 0);	
		for (sId in aAddress) {
			oSelect.options[iCounter++] = new Option(aAddress[sId]["title"], sId);
		}
			
		aProps.type.update(oSelect);
		if (sType) {
			for (i = 0; i < oSelect.options.length; i++) {
				if (oSelect.options[i].value == sType) {
					oSelect.options[i].selected=true;
					this.updateValue(aProps, sValue);
					break;
				}
				
			}
			
		}


	},
	

	updateValue : function(aProps, sValue) 
	{
		if($(aProps.typeId).value == "vars") {
			this.createVarsValue(aProps, sValue);
		}
		else if($(aProps.typeId).value == "structure") {
			this.createStructureValue(aProps, sValue);
		}
		else if($(aProps.typeId).value == "fields") {
			this.createFieldsValue(aProps, sValue);
		}
		else if($(aProps.typeId).value == "groups") {
			this.createRefGroupsValue(aProps, sValue);
		}
		else {
			aProps.value.update(aGlobalMsfWords["WORKFLOW_NULL"]);
		}
		
	},
	
	createVarsValue : function(aProps, aValue)
	{
		var iCounter 		= 0;
		var oThis 			= this;
		var oSelect 		= document.createElement("SELECT");
		oSelect.id 			= aProps.valueId;
		oSelect.onchange 	= function() {
				oThis.onChangeFields(oSelect);
				if (this.value == 'any') {
					oThis.onChangeAnyValue(this, oThis, aProps, aValue);
				}
				else {
					var oDivs = this.parentNode.getElementsByTagName('DIV');
					if (oDivs.length > 0) {
						this.parentNode.removeChild(oDivs.item(0));
					}
					
				}
				
			}
		oSelect.name	= this.getNamed(this.sNValue, aProps.pointId, aProps.actionId);
		oSelect.options[iCounter++] = new Option(aGlobalMsfWords["WORKFLOW_NULL"], 0);
		if (this.sContext == "waiting") {
			for (sId in aAddress["vars"]["options"]) {
				oSelect.options[iCounter++] = new Option(aAddress["vars"]["options"][sId], sId);
			}
		
		}
		else {
			oSelect.options[iCounter++] = new Option(aAddress["vars"]["options"]["author"], "author");
		}
		
		aProps.value.update(oSelect);
		
		if (aValue) {
			for (i = 0; i < oSelect.options.length; i++) {
				if (aValue.name) {
					if (oSelect.options[i].value == aValue.name) {
						oSelect.options[i].selected=true;
						if (aValue.name == 'any') {
							this.onChangeAnyValue(oSelect, this, aProps, aValue);
						}
		
						break;
					}
							
				} 
				else {
					if (oSelect.options[i].value == aValue) {
						oSelect.options[i].selected=true;
						break;
					}
					
				}	
					
			}

		}	
		
		this.onUpdateTitle(oSelect);

	},
	
	onChangeAnyValue : function(oTarget, oContext, aProps, aValue) {
		var iCount 		= 0;
		var oDiv 		= document.createElement('DIV');
		var oSelect		= document.createElement('SELECT');
		oSelect.style.display = 'none';
		oSelect.name	= oContext.getNamed('route[@pointId][wait][value][field]', aProps.pointId, aProps.actionId);
		var oBr			= document.createElement('BR');
		var oCheckbox	= document.createElement('INPUT');
		var oText		= document.createTextNode(aGlobalMsfWords["WORKFLOW_OVERWRITE_FIELD"]);
		oCheckbox.type 	= 'checkbox';
		
		oCheckbox.onclick = function() {
					if (this.checked) {
						oSelect.style.display = 'block';
					}
					else {
						oSelect.style.display = 'none';
					}
				}
		oCheckbox.name	= oContext.getNamed('route[@pointId][wait][value][overwrite]', aProps.pointId, aProps.actionId); 
		oSelect.options[iCount++] = new Option(aGlobalMsfWords["WORKFLOW_NULL"], 0);
		if (aAddress["fields"]) {
			for (sId in aAddress["fields"]["options"]) {
				oSelect.options[iCount++] = new Option(aAddress["fields"]["options"][sId], sId);
			}
			
		}


		oDiv.appendChild(oCheckbox);
		oDiv.appendChild(oText);						
		oDiv.appendChild(oBr);
		oDiv.appendChild(oSelect);
		oTarget.parentNode.appendChild(oDiv);
		if (aValue) {
		
			for (i = 0; i < oSelect.options.length; i++) {
				if (oSelect.options[i].value == aValue.field) {
					oSelect.options[i].selected = true;
					oSelect.style.display = 'block';
					break;
				}
				
			}
			
			if (aValue.overwrite) {
				oCheckbox.checked = true;
			}

		}

	},

	createStructureValue : function(aProps, sValue)
	{
		var oThis = this;
		aProps.value.update();
		var oStructure = new MSFW.Placeholder.Structure({
			"Container"         : aProps.value,
			"inputName"       	: WF_Utils.strReplace("[name]", "", this.getNamed(this.sNValue, aProps.pointId, aProps.actionId)),
			"multiselect"     	: true,
            "default"   		: sValue,
            "showPosts" 		: true
		});
		oStructure.getInput().getHtmlInput().id = aProps.valueId;
		this.onChangeStructureValue.bind(oStructure).call();
		oStructure.getInput().addEventListener("valuechange", this.onChangeStructureValue.bind(oStructure));
	},
	
	createRefGroupsValue : function(aProps, sValue)
	{
		var oThis = this;
		aProps.value.update();

		var oRefGroups = new MSFW.Placeholder.Reference({
			"Container"			: aProps.value,
			"referenceId"		: 316,
			"inputName"			: WF_Utils.strReplace("[name]", "", this.getNamed(this.sNValue, aProps.pointId, aProps.actionId)),
			"columns"			: {	
									"name" 		: {	"select" : true,	"group" : true,	"sort" : true,	"filter" : true },
									"employee" 	: {	"select" : false,	"group" : true,	"sort" : true,	"filter" : true	}
								  },
			"defaultGroups"		: ["name"],
			"byId"				: true,
			"multiselect"		: true,
			"default"			: sValue,
			"valueSeparator"	: ", "
		});
		oRefGroups.getInput().getHtmlInput().id = aProps.valueId;
		this.onChangeRefGroupsValue.bind(oRefGroups).call();
		oRefGroups.getInput().addEventListener("valuechange", this.onChangeRefGroupsValue.bind(oRefGroups));		
	},
	
	createFieldsValue : function(aProps, sValue)
	{
		var iCount = 0;
		var oThis = this;
		var oSelect = document.createElement("SELECT");
		oSelect.id = aProps.valueId;
		var zis = this;
		
		oSelect.name = WF_Utils.strReplace("[name]", "", this.getNamed(this.sNValue, aProps.pointId, aProps.actionId));
		//this.getNamed(this.sNValue, aProps.pointId, aProps.actionId);
		oSelect.options[iCount++] = new Option(aGlobalMsfWords["WORKFLOW_NULL"], 0);
		for (sId in aAddress["fields"]["options"]) {
			oSelect.options[iCount++] = new Option(aAddress["fields"]["options"][sId], sId);
		}
		
		aProps.value.update(oSelect);
		if (sValue) {
			for (i = 0; i < oSelect.options.length; i++) {
				if (oSelect.options[i].value == sValue) {
					oSelect.options[i].selected=true;
					break;
				}
				
			}

		}	
		
		this.onUpdateTitle(oSelect);
		Event.observe(oSelect, "change", function() {this.onChangeFields(oSelect)}.bind(this));

	}

}