var WF_DoctypeCompare = Class.create();
WF_DoctypeCompare.prototype =
{
	initialize: function()
	{
		this.aDraggables 	= new Array();
		this.aDragDivs 		= new Array();
		this.aFields 		= new Array();
		this.aColors 		= new Array();
	},
	
	addToArray: function(sContainerId, sDraggableId)
	{
		var Element = $(sDraggableId);
		var sId 	= this.getId(Element.id);
		
		if (!this.aDraggables[sId]) {
			this.aDraggables[sId] = new Array();
		}
		
		Element.style.backgroundColor = this.aColors[sId];
		this.aDraggables[sId][sContainerId] = Element;
	},
	
	addDraggable: function(sDraggableId)
	{
		var Obj = $(sDraggableId);
		var sId = this.getId(Obj.id);
		//$(sDraggableId).style.backgroundColor = this.getRandomColor(sId);
		Obj.style.borderColor = this.getRandomColor(sId);
		Obj.style.borderWidth = "2px";
		Obj.style.borderStyle = "solid";
		
		var me = this;
		this.aDragDivs[this.aDragDivs.length] = new Draggable(
			sDraggableId,
			{
				revert: true
			}
		);
	},
	
	appendColor: function(sId)
	{
		$(sId).style.backgroundColor = this.getRandomColor(sId);
	},
	
	onDrop: function(element, sDroppableId)
	{
		if (this.getType(element.id) == this.getType(sDroppableId)) {
			var iId 			= this.getId(element.id);
			var iContainerId 	= this.getId(sDroppableId);
			var Container 		= $(sDroppableId);
			
			if (Container.childNodes.length > 0) {
				for (var i = 0; i < Container.childNodes.length; i++) {
					if (Container.childNodes[i].id) {
						var iTmp = this.getId(Container.childNodes[i].id);
						if (iTmp == iId) {
							this.toTrash(Container.childNodes[i]);
						}
					}
				}
			}
			
			this.addField(Container.id, element.id);
			Container.appendChild(element);
			this.appendPosition(element, Container);
		}
		else {
			alert(aGlobalMsfWords["WORKFLOW_MESSAGE_DOCTYPE_COMPARE_ALERT"]);
		}
	},
	
	addField: function(sContainerId, sElementId)
	{
		var Input 	= document.createElement('input');
		Input.type 	= 'hidden';
		Input.name 	= 'fields_' + sElementId + '[]';
		Input.id 	= 'input_field_' + sElementId;
		Input.value = this.getFieldName(sContainerId) + '::' + this.getFieldName(sElementId);
		this.deleteField(sElementId);
		$('fields_container').appendChild(Input);
	},
	
	deleteField: function(sElementId)
	{
		if ($('input_field_' + sElementId)) {
			$('fields_container').removeChild($('input_field_' + sElementId));
		}
	},
	
	toTrash: function(element)
	{
		var Container = $('draggable_container_' + this.getId(element.id));
		this.deleteField(element.id);
		Container.appendChild(element);
	},
	
	getType: function(sId)
	{
		var aParsed = sId.split('::');
		return aParsed[0];
	},
	
	getFieldName: function(sId)
	{
		var aParsed = sId.split('::');
		return aParsed[1];
	},
	
	getId: function(sId)
	{
		var aParsed = sId.split('::');
		return aParsed[aParsed.length - 1];
	},
	
	appendPosition: function(element, td)
	{
		element.style.left = td.style.left;
		element.style.top = td.style.top;
	},
	
	getRandomColor: function(sId)
	{
		var bCheck 	= false;
		var Color 	= new Object();
	
		for (var i = 0; i < this.aColors.length; i++) {
			if (this.aColors[i].id == sId) {
				bCheck 	= true;
				Color.r = this.aColors[i].r;
				Color.g = this.aColors[i].g;
				Color.b = this.aColors[i].b;
				break;
			}
		}
		
		if (!bCheck) {
			Color = this.randomColor();
			
			for (var i = 0; i < this.aColors.length; i++) {
				if (this.aColors[i].r == Color.r &&
					this.aColors[i].g == Color.g &&
					this.aColors[i].b == Color.b) {
					Color = this.randomColor();
					break;
				}
			}
			
			Color = this.checkRandom(Color);
			
			var Obj = new Object();
			Obj.id 	= sId;
			Obj.r 	= Color.r;
			Obj.g 	= Color.g;
			Obj.b 	= Color.b;
			this.aColors.push(Obj);
		}
		
		return 'rgb(' + Color.r + ', ' + Color.g + ', ' + Color.b + ')';
	},

	checkRandom: function(Color)
	{
		var bCheck = false;
		var iCheck = 20;
		
		for (var i = 0; i < this.aColors.length; i++) {
			var iR = this.aColors[i].r - Color.r;
			var iG = this.aColors[i].g - Color.g;
			if ((iR < iCheck && iR > -iCheck) || (iG < iCheck && iG > -iCheck)) {
				Color 	= this.randomColor();
				bCheck 	= true;
				break;
			}
		}
		
		if (bCheck) {
			//Color = this.checkRandom(Color);
		}
		
		return Color;
	},

	randomColor: function()
	{
		var Obj = new Object;
		Obj.r 	= Math.floor(this.getRandom('r') * 255);
		Obj.g	= Math.floor(this.getRandom('g') * 255);
		Obj.b 	= Math.floor(this.getRandom('b') * 255);
		
		return Obj; 
	},
	
	getRandom: function(sType)
	{
		var iCheck = 0.15;
		
		switch (sType) {
			case 'g':
			case 'b':
				iCheck = 0.3;
				break;
		}
	
		iRandom = Math.random();
		
		if (iRandom < iCheck) {
			iRandom = this.getRandom(sType);
		}

		return iRandom;
	}
}