var WF_DoctypeRouter = Class.create();
WF_DoctypeRouter.prototype =
{
	initialize: function(sContainerId, sTemplateId, sAddButtonId, aTypesValues, aData, aWords)
	{
		this.Container 		= $(sContainerId);
		this.Template 		= $(sTemplateId);
		this.AddButton 		= $(sAddButtonId);
		this.aTypesValues 	= aTypesValues;
		this.aData 			= aData;
		this.aWords 		= aWords;
		this.iCounter 		= 0;
		
		this.addNewPoint();
	},
	
	addNewPoint: function()
	{
		var me = this;
		this.AddButton.observe('click', function() {
			me.newForm();
		});
	},
	
	newForm: function(aData)
	{
		var Router = WF_ModifyClonedForm.start(this.Template.cloneNode(true), this.iCounter);
		this.Container.appendChild(Router);
		Router.show();
		new WF_DoctypeRouterNewPoint(
			Router,
			this.iCounter,
			this.aTypesValues,
			aData,
			this.aWords
		);
		this.iCounter++;
		Sortable.create(this.Container, {tag: "div"});
	}
}

var WF_DoctypeRouterNewPoint = Class.create();
WF_DoctypeRouterNewPoint.prototype =
{
	initialize: function(Point, iCounter, aTypesValues, aData, aWords)
	{
		this.Point 			= Point;
		this.iCounter 		= iCounter;
		this.aTypesValues 	= aTypesValues;
		this.aData 			= aData;
		this.aWords 		= aWords;
		this.iDelegate 		= 0;
		this.iExecute 		= 0;
		this.DelWindow 		= null;
		this.ExecWindow 	= null;
		this.WaitWindow 	= null;
		
		this.aDelegate 		= new Array();
		
		this.defineObjects();
		this.appendFormActions();
		this.appendWindows();
		this.appendButtonActions();
	},
	
	
	
	
	/****************************************** executed methods ***************************************/
	defineObjects: function()
	{
		this.iNumber 			= (this.iCounter + 1);
		this.sName 				= "new_router_" + this.iCounter;
		this.NumberValue 		= this.get("number");
		this.CloseLink 			= this.get("close_link");
		this.DeleteLink 		= this.get("delete_link");
		this.Container 			= this.get("closing_container");
		this.OnCloseTitle 		= this.get("onclose_title");
		this.Title 				= this.get("title");
		this.AddDelegateLink 	= this.get("add_delegate_link");
		this.AddExecuteLink 	= this.get("add_execute_link");
		this.EditWaitLink 		= this.get("edit_wait_link");
		this.DelegateContainer 	= this.get("delegate_container");
		this.ExecuteContainer 	= this.get("execute_container");
		this.WaitContainer 		= this.get("wait_container");
		
		this.DelegateBody 		= this.cloneForm($("doctype_router_delegate_body"));
		this.ExecuteBody 		= this.cloneForm($("doctype_router_execute_body"));
		this.WaitBody 			= this.cloneForm($("doctype_router_wait_body"));
		
		this.DelegateWindow 	= null;
		this.ExecuteWindow 		= null;
		this.WaitWindow 		= null;
	},
	
	appendFormActions: function()
	{
		var me = this;
		var appendTitle = function(sText)
		{
			if (me.OnCloseTitle.childNodes[0]) {
				me.OnCloseTitle.removeChild(me.OnCloseTitle.childNodes[0]);
			}
			me.OnCloseTitle.appendChild(document.createTextNode(sText));
		}
		
		this.Title.name = this.sName + "[title]";
		this.Title.observe("change", function() {
			appendTitle(this.value);
		});
		this.CloseLink.observe("click", function() {
			if (me.Container.visible()) {
				appendTitle(me.iNumber + '. ' + me.Title.value);
				me.Container.hide();
				me.OnCloseTitle.parentNode.addClassName("msfRouterTitleClosed");
				me.CloseLink.removeClassName("msfRouterWindowOpened");
				me.CloseLink.addClassName("msfRouterWindowClosed");
			}
			else {
				appendTitle(me.Title.value);
				me.Container.show();
				me.OnCloseTitle.parentNode.removeClassName("msfRouterTitleClosed");
				me.CloseLink.removeClassName("msfRouterWindowClosed");
				me.CloseLink.addClassName("msfRouterWindowOpened");
			}
		});
		this.DeleteLink.observe("click", function() {
			if (confirm(me.aWords["WORKFLOW_DOCTYPE_ROUTER_MESSAGE"])) {
				me.Point.parentNode.removeChild(me.Point);
			}
		});
		this.NumberValue.appendChild(
			document.createTextNode(this.iNumber)
		);
	},
	
	appendWindows: function()
	{
		this.DelWindow = new MSF_Window();
		this.DelWindow.setTitle("Delegate window");
		this.DelWindow.hide();
		this.DelWindow.appendToBody(this.DelegateBody);
		this.DelegateBody.show();
		WindowManager.add(this.DelWindow, this.getWindowName("delegate"));
		
		this.ExecWindow = new MSF_Window();
		this.ExecWindow.setTitle("Execute window");
		this.ExecWindow.hide();
		this.ExecWindow.appendToBody(this.ExecuteBody);
		this.ExecuteBody.show();
		WindowManager.add(this.ExecWindow, this.getWindowName("execute"));
		
		this.WaitWindow = new MSF_Window();
		this.WaitWindow.setTitle("Wait window");
		this.WaitWindow.hide();
		this.WaitWindow.appendToBody(this.WaitBody);
		this.WaitBody.show();
		WindowManager.add(this.WaitWindow, this.getWindowName("wait"));
	},
	/****************************************** executed methods ***************************************/
	
	
	
	
	appendButtonActions: function()
	{
		var me = this;
		this.AddDelegateLink.observe("click", function() {
			me.showDelWindow(this);
		});
		this.AddExecuteLink.observe("click", function() {
		});
		this.EditWaitLink.observe("click", function() {
		});
	},
	
	
	
	
	
	/********************************************** DELEGATE ACTIONS ******************************************/
	
	/********************************************** DELEGATE ACTIONS ******************************************/
	
	
	
	
	
	
	
	/********************************************** EXECUTE ACTIONS ******************************************/
	
	/********************************************** EXECUTE ACTIONS ******************************************/
	
	
	
	
	
	
	
	
	/**************************************************************************/
	setValues: function(sName, sType, sData)
	{
		var aValues, Obj;
		
		for (var i = 0; i < this.aTypesValues.length; i++) {
			if (this.aTypesValues[i].name == sName) {
				aValues = this.aTypesValues[i].value;
				if (sName == "structure") {
					Obj = $(document.createElement("div"));
					new StructurePlaceholder({
						mPlace 			: Obj,
						sInputName 		: "",
						bMultiselect 	: true,
						sDefaultValues 	: sData
					});
				}
				else {
					Obj = $(document.createElement("select"));
					for (var j = 0; j < aValues.length; j++) {
						if (aValues[j].show && (aValues[j].show == sType || aValues[j].show == "all")) {
							Obj.options[Obj.options.length] = new Option(aValues[j].title, aValues[j].name);
						}
					}
				}
			}
		}
		
		return Obj;
	},
	
	get: function(sId)
	{
		return $("doctype_router_" + sId + "_" + this.iCounter);
	},
	
	getName: function(sType, iCounter, sValue)
	{
		return this.sName + "[" + sType + "][" + iCounter + "][" + sValue + "]";
	},
	
	getUnique: function()
	{
		return "doctype_router_" + this.iCounter + "_" + Math.random();
	},
	
	cloneForm: function(Form)
	{
		return WF_ModifyClonedForm.start(Form.cloneNode(true), this.iCounter);
	},
	
	clearElement: function(Element)
	{
		for (var i = 0; i < Element.childNodes.length; i++) {
			Element.removeChild(Element.childNodes[i]);
		}
	}
}