var WF_DoctypeSpa = Class.create();
WF_DoctypeSpa.prototype =
{
	__hAllDTFields : null,
	
	initialize: function(sFromContainerId, sSpaId, sAddLink, aData, aTypesValues, hAllDTFields)
	{
		this.__hAllDTFields = hAllDTFields;
	
		this.FormContainer 	= $(sFromContainerId);
		this.Spa 			= $(sSpaId);
		//this.AddLink 		= $(sAddLink);
		this.aAddLink 		= this._defineAddButtons(sAddLink);
		this.iCount 		= 0;
		this.aData 			= aData;
		this.aTypesValues 	= aTypesValues;
		
		this._addSpa();
		this._loadData();
		
		Sortable.create(this.FormContainer, {tag:'DIV', handle:"point-drag"});
	},
	
	_defineAddButtons: function(sId)
	{
		var Tmp 	= null;
		var aResult = new Array();
		
		for (var i = 0; i < 5; i++) {
			Tmp = $(sId + "_" + i);
			if (Tmp) {
				aResult.push(Tmp);
			}
		}
		
		return aResult;
	},
	
	/*
	_addSpa: function()
	{
		var me = this;
		
		this.AddLink.onclick = function()
		{
			me._newForm(null, true);
			return false;
		}
	},
	*/
	
	_addSpa: function()
	{
		var me = this;
		var btnOnclick = function()
		{
			me._newForm(null, true);
			return false;
		}
		
		for (var i = 0; i < this.aAddLink.length; i++) {
			this.aAddLink[i].onclick = btnOnclick;
		}
	},
	
	_loadData: function()
	{
		for (var i = 0; i < this.aData.length; i++) {
			this._newForm(this.aData[i]);
		}
	},
	
	_newForm: function(aData, isNew)
	{
		var Spa = this.Spa.cloneNode(true);
		this.FormContainer.appendChild(Spa);
		Spa.show();
		new WF_PrepareSpa(Spa, this.iCount, aData, this.aTypesValues, isNew, this.__hAllDTFields);
		this.iCount++;
	}
}

var WF_PrepareSpa = Class.create();
WF_PrepareSpa.prototype =
{	
	initialize: function(Spa, iCount, aData, aTypesValues, isNew, hAllDTFields)
	{
		this.__hAllDTFields = hAllDTFields;
		
		this.Spa 	= Spa;
		this.iCount = iCount;
		this.aData 	= aData;
		this.isNew 	= isNew;
		this.aTypesValues = aTypesValues;
		
		WF_ModifyClonedForm.start(this.Spa, iCount);
		this._modifyLinks();
	},
	
	_modifyLinks: function()
	{
		var me 			= this;
		var sName 		= (this.aData && this.aData['spa_id']) ? this.aData['spa_id'] : 'new_action_' + this.iCount;
		var Container 	= $('doctype_spa_body_container_' + this.iCount);
		var Close 		= $('spa_closing_container_' + this.iCount);
		var Toggle 		= $('doctype_spa_close_link_' + this.iCount);
		var Delete 		= $('doctype_spa_delete_link_' + this.iCount);
		var Title 		= $('onclose_title_' + this.iCount);
		var ITitle 		= $('doctype_spa_title_' + this.iCount);
		var Desc 		= $('doctype_spa_description_' + this.iCount);
		var Select 		= $('doctype_spa_actions_' + this.iCount);
		var ToggleCont 	= $('doctype_spa_close_link_container_' + this.iCount);
		ITitle.name 	= sName + '[title]';
		Select.name 	= sName + '[action]';
		Desc.name 		= sName + '[description]';
		
		if (ITitle.value.strip() == '') {
			ITitle.value = aGlobalMsfWords['WORKFLOW_NEW_ADDED_ACTION'];
			Title.appendChild(document.createTextNode(ITitle.value));
		}
		
		Toggle.onclick 	= function()
		{
			me._closeContainer(Close, Toggle, Title, ITitle.value);
			return false;
		};
		ToggleCont.onclick = Toggle.onclick;
		Delete.onclick 	= function()
		{
			if (confirm(aGlobalMsfWords['WORKFLOW_DOCTYPE_ROUTER_ACTION_MESSAGE'])) {
				me.Spa.parentNode.removeChild(me.Spa);
			}
			return false;
		};
		Select.onchange = function()
		{
			if (Container.childNodes[0]) {
				//Container.removeChild(Container.childNodes[0]);
				Container.update();
			}
			if (this.value != '') {
				me._newAction(this.value, sName, Container, new Array(), true);
			}
		};
		
		this._loadData(sName, Container, ITitle, Desc, Select, Toggle, Title, Close);
		
		if (this.isNew) {
			var Anchor = $('anonymous_element_' + this.iCount);
			Anchor.name = Anchor.id;
			window.location = window.location.href.split("#")[0] + "#" + Anchor.name;
			ITitle.activate();
		}
	},
	
	_loadData: function(sName, Container, ITitle, Desc, Select, A, Title, Close)
	{
		if (this.aData) {
			var Option;
			
			for (var i = 0; i < Select.options.length; i++) {
				Option = Select.options[i];
				if (Option.value == this.aData['name']) {
					Option.selected = true;
					Option.setAttribute('selected', 'selected');
				}
			}
			
			ITitle.value = this.aData['title'];
			Desc.value = this.aData['description'];
			this._newAction(this.aData['name'], sName, Container, this.aData['value'], false);
			this._closeContainer(Close, A, Title, ITitle.value);
		}
	},
	
	_closeContainer: function(Container, A, Title, sInputTitle)
	{
		if (A.childNodes[0]) {
			A.removeChild(A.childNodes[0]);
		}
		
		if (Title.childNodes[0]) {
			Title.removeChild(Title.childNodes[0]);
		}
		Title.appendChild(document.createTextNode(sInputTitle));
		
		if (!Container.visible()) {
			A.className = 'field-main-controls-visible';
			Container.show();
		}
		else {
			A.className = 'field-main-controls-hidden';
			Container.hide();
		}
	},
	
	_newAction: function(sActionName, sFieldsName, Container, aData, isNew)
	{
		var Factory, Action, Form;

		Factory = new SpaFactory(sActionName);
		Action 	= Factory.process(sFieldsName, Container, this.iCount, this.aTypesValues);
		Action.setAllDTFields(this.__hAllDTFields);
		if (Action) {
			Action.setValue(aData);
			Form 	= Action.build();
			Form.show();
			if(isNew) {
				var oHiddenInput	= new Element("INPUT");
				oHiddenInput.type	= "hidden";
				Container.insert(oHiddenInput);
			}// na sluchai WindowHandler.iCounted iz-za placeholdera
		}
	},
	
	getObject: function()
	{
		return this.Spa;
	}
}