tinymce.create("tinymce.plugins.WFVarsPlugin", {

	sImgUri			: "/modules/workflow/view/templates/default/img/var.png",
	
	sRemoteJsonUri	: "/admin/workflow/jsonDoctypeParams/vars",

	oEditor 		: null,
	
	isMenuRendered	: false,
	
	aFields 		: {},
	
	init : function(ed, url) {
		this.oEditor 	= ed;
	},
	
	paste : function(sValue) {
		this.oEditor.execCommand("mceInsertContent", 0, sValue);
	},		

	createControl: function(n, cm) {
		if (n !== "wfvars") return null;
		var oThis = this;  
		var c = cm.createSplitButton("wfvars", {
			title 	: aGlobalMsfWords['WORKFLOW_VARS'],
			image 	: this.sImgUri

		});

		c.onRenderMenu.add(function(c, m) {
			var oMenuItem 	= m.add({title : aGlobalMsfWords['WORKFLOW_VARS'], "class" : "mceMenuItemTitle"});
			oMenuItem.setDisabled(true);
			var sUri = oThis.sRemoteJsonUri + "/" + oThis.oEditor.settings.subject_id;
			new Ajax.Request(sUri, {
				onSuccess: function(transport) {
					if ((transport.responseText.length > 0) && (transport.responseText !== "[]")) {
						var aFields = $H(transport.responseText.evalJSON());
						if (aFields.size() > 0) {
							aFields.each(function(e)
							{
							      oThis.renderMenuField(m, oThis, e.key, e.value);
							});						
							
						}		
												
					}

				}
				
			});
			
		});
		
		return c;
	},
	
	renderMenuField : function(oMenu, oThis, sTitle, sValue)
	{
		oMenu.add({title : sTitle, onclick : function() {
			oThis.paste(sValue);
		}});
		
	},

	
	getInfo : function() {
		return {
			longname 	: "WFVars",
			author 		: "Andrey Surov",
			authorurl 	: "http://www.detrix.kz",
			infourl 	: "http://www.detrix.kz",
			version 	: tinymce.majorVersion + "." + tinymce.minorVersion
		};
	}

});





tinymce.create("tinymce.plugins.WFSFieldsPlugin", {

	sImgUri			: "/modules/workflow/view/templates/default/img/sfield.png",
	
	sRemoteJsonUri	: "/admin/workflow/jsonDoctypeParams/s_fields",

	oEditor 		: null,
	
	isMenuRendered	: false,
	
	aFields 		: {},
	
	init : function(ed, url) {
		this.oEditor 	= ed;
	},
	
	paste : function(sValue) {
		this.oEditor.execCommand("mceInsertContent", 0, sValue);
	},		

	createControl: function(n, cm) {
		if (n !== "wfsfields") return null;
		var oThis = this;  
		var c = cm.createSplitButton("wfsfields", {
			title 	: aGlobalMsfWords['WORKFLOW_SFIELDS'],
			image 	: this.sImgUri

		});

		c.onRenderMenu.add(function(c, m) {
			var oMenuItem 	= m.add({title : aGlobalMsfWords['WORKFLOW_SFIELDS'], "class" : "mceMenuItemTitle"});
			oMenuItem.setDisabled(true);
			var sUri = oThis.sRemoteJsonUri + "/" + oThis.oEditor.settings.subject_id;
			new Ajax.Request(sUri, {
				onSuccess: function(transport) {
					if ((transport.responseText.length > 0) && (transport.responseText !== "[]")) {
						var aFields = $H(transport.responseText.evalJSON());
						if (aFields.size() > 0) {
							aFields.each(function(e)
							{
							      oThis.renderMenuField(m, oThis, e.key, e.value);
							});						
							
						}		
												
					}

				}
				
			});
			
		});
		
		return c;
	},
	
	renderMenuField : function(oMenu, oThis, sTitle, sValue)
	{
		oMenu.add({title : sTitle, onclick : function() {
			oThis.paste(sValue);
		}});
		
	},

	
	getInfo : function() {
		return {
			longname 	: "WFFields",
			author 		: "Detrix LLP",
			authorurl 	: "http://www.newinttech.com",
			infourl 	: "http://www.newinttech.com",
			version 	: tinymce.majorVersion + "." + tinymce.minorVersion
		};
	}

});





tinymce.create("tinymce.plugins.WFCFieldsPlugin", {

	sImgUri			: "/modules/workflow/view/templates/default/img/cfield.png",
	
	sRemoteJsonUri	: "/admin/workflow/jsonDoctypeParams/c_fields",

	oEditor 		: null,
	
	isMenuRendered	: false,
	
	aFields 		: {},
	
	init : function(ed, url) {
		this.oEditor 	= ed;
	},
	
	paste : function(sValue) {
		this.oEditor.execCommand("mceInsertContent", 0, sValue);
	},		

	createControl: function(n, cm) {
		if (n !== "wfcfields") return null;
		var oThis = this;  
		var c = cm.createSplitButton("wfcfields", {
			title 	: aGlobalMsfWords['WORKFLOW_CFIELDS'],
			image 	: this.sImgUri

		});

		c.onRenderMenu.add(function(c, m) {
			var oMenuItem 	= m.add({title : aGlobalMsfWords['WORKFLOW_CFIELDS'], "class" : "mceMenuItemTitle"});
			oMenuItem.setDisabled(true);
			var sUri = oThis.sRemoteJsonUri + "/" + oThis.oEditor.settings.subject_id;
			new Ajax.Request(sUri, {
				onSuccess: function(transport) {
					if ((transport.responseText.length > 0) && (transport.responseText !== "[]")) {
						var aFields = $H(transport.responseText.evalJSON());
						if (aFields.size() > 0) {
							aFields.each(function(e)
							{
							      oThis.renderMenuField(m, oThis, e.key, e.value);
							});						
							
						}		
												
					}

				}
				
			});
			
		});
		
		return c;
	},
	
	renderMenuField : function(oMenu, oThis, sTitle, sValue)
	{
		oMenu.add({title : sTitle, onclick : function() {
			var sTmp = sValue;
			if (oThis.substrCount(oThis.oEditor.getContent(), "{" + sValue + "}") > 0) {
				sTmp += " [*]";
			}
			oThis.paste("{" + sTmp + "}");
		}});
		
	},

	
	getInfo : function() {
		return {
			longname 	: "WFFields",
			author 		: "Detrix LLP",
			authorurl 	: "http://www.newinttech.com",
			infourl 	: "http://www.newinttech.com",
			version 	: tinymce.majorVersion + "." + tinymce.minorVersion
		};
	},
	
	substrCount: function(sString, sSubstring)
	{
		var iResult = 0;
		
		for (var i=0; i< sString.length; i++) {
			if (sSubstring == sString.substr(i, sSubstring.length)) {
				iResult++;
			}
		}

		return iResult++;
	}

});

tinymce.PluginManager.add('wfvars', 	tinymce.plugins.WFVarsPlugin);
tinymce.PluginManager.add('wfsfields', 	tinymce.plugins.WFSFieldsPlugin);
tinymce.PluginManager.add('wfcfields', 	tinymce.plugins.WFCFieldsPlugin);
