<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:template match="/page/module">
		<script src="/modules/references/view/js/REF_SaveHandler.js"></script>
		<script>
			registerEvent(function() {
				new REF_SaveHandler($("compare_form"), $("savecompare_button"), $("login_layer"), "submit");
			});	
		</script>
		<script>
			document.onkeydown = function(e){
				key = (!e) ? window.event : e;
				if (key.ctrlKey &amp;&amp; key.keyCode == 13){
					$("savecompare_button").click();
				} 
			}
		</script>
		<script type="text/javascript">
			WindowHandler.attachHandlers();
		</script>
		<script type="text/javascript">
			var DC = new WF_DoctypeCompare();
		</script>
		<form method="post" id="compare_form">			
			<table width="100%" cellpadding="0" cellspacing="0">
				<tr>
					<td valign="top" width="55%">
						<table class="dtc_table">
							<tr>
								<div id="dtc_trash">
									<xsl:value-of select="$WORKFLOW_DOCTYPE_COMPARE_TRASH"/>
								</div>
								<td colspan="2" id="dtc_table_title">
									<xsl:value-of select="$WORKFLOW_DOCTYPE_COMPARE_FIELDS"/>
								</td>
							</tr>
							<xsl:for-each select="doctype/element">
								<tr>
									<td>
										<xsl:value-of select="@title"/>
										(<xsl:choose>
											<xsl:when test="@ref_title">
												<xsl:value-of select="@ref_title"/>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="@word"/>
											</xsl:otherwise>
										</xsl:choose>)
									</td>
									<td class="doctype_compare_drop">
										<xsl:attribute name="id">
											<xsl:value-of select="@type"/>
											<xsl:text>::</xsl:text>
											<xsl:value-of select="@name"/>
										</xsl:attribute>
										<xsl:for-each select="field">
											<xsl:call-template name="doctype_version_div"/>
										</xsl:for-each>
									</td>
									<script type="text/javascript">
										Droppables.add(
											'<xsl:value-of select="@type"/>::<xsl:value-of select="@name"/>',
											{
												accept: 'doctype_compare_drag',
												onDrop: function(element)
												{
													DC.onDrop(element, '<xsl:value-of select="@type"/>::<xsl:value-of select="@name"/>');
												}
											}
										)
										
										function openList(element){
											img = element.down(0);
											id  = element.readAttribute('id');
											$('draggable_container_'+id).toggle();
											if($('draggable_container_'+id).visible()){
												img.writeAttribute('src','/modules/workflow/view/templates/default/img/log/log_arrow_opened.png');
											}
											else {
												img.writeAttribute('src','/modules/workflow/view/templates/default/img/log/log_arrow_closed.png');
											}
										}
									</script>
								</tr>
							</xsl:for-each>
							<tr>
								<td colspan="2">
									<input id="savecompare_button" style="float:left;" type="button" name="btn">
										<xsl:attribute name="value">
											<xsl:value-of select="$WORKFLOW_BTN_SAVE"/>
										</xsl:attribute>
									</input>
									<img id="busy_loader" height="25" width="25" src="/templates/default/images/win/big-ajax-loader.gif" style="display:none;"/>
								</td>
							</tr>
						</table>
						<script>
							<xsl:for-each select="doctype/element">
								<xsl:for-each select="field">
									DC.addToArray(
										'<xsl:value-of select="parent::element/@name"/>',
										'<xsl:value-of select="@type"/>
										<xsl:text>::</xsl:text>
										<xsl:value-of select="@name"/>
										<xsl:text>::</xsl:text>
										<xsl:value-of select="@version"/>'
									);
								</xsl:for-each>
							</xsl:for-each>
						</script>
						<div id="fields_container">
							<xsl:for-each select="doctype/element/field">
								<input type="hidden">
									<xsl:attribute name="name">
										<xsl:text>fields_</xsl:text>
										<xsl:value-of select="@type"/>
										<xsl:text>::</xsl:text>
										<xsl:value-of select="@name"/>
										<xsl:text>::</xsl:text>
										<xsl:value-of select="@version"/>
										<xsl:text>[]</xsl:text>
									</xsl:attribute>
									<xsl:attribute name="id">
										<xsl:text>input_field_</xsl:text>
										<xsl:value-of select="@type"/>
										<xsl:text>::</xsl:text>
										<xsl:value-of select="@name"/>
										<xsl:text>::</xsl:text>
										<xsl:value-of select="@version"/>
									</xsl:attribute>
									<xsl:attribute name="value">
										<xsl:value-of select="parent::element/@name"/>
										<xsl:text>::</xsl:text>
										<xsl:value-of select="@name"/>
									</xsl:attribute>
								</input>
							</xsl:for-each>
						</div>
					</td>
					<td width="5%"></td>
					<td width="35%" valign="top">
						<xsl:for-each select="versions/item">
							<table width="100%">
								<tr>
									<td style="cursor:pointer" class="dtc_version" onclick="javascript:openList(this);">
										<xsl:attribute name="id">
											<xsl:value-of select="@version"/>
										</xsl:attribute>
										<xsl:choose>
											<xsl:when test="@title!=''">
												<xsl:value-of select="@title"/>
											</xsl:when>
											<xsl:otherwise>
												<xsl:value-of select="$WORKFLOW_DOCTYPE_COMPARE_VERSION"/>&#xA0;
												<xsl:value-of select="@id"/>
											</xsl:otherwise>
										</xsl:choose>
											<img align="right" style="margin:4px" src="/modules/workflow/view/templates/default/img/log/log_arrow_closed.png" />
										<script>
											DC.appendColor('<xsl:value-of select="@version"/>');
											
										</script>										
									</td>
								</tr>
								<tr>
									<td style="display:none">
										<xsl:attribute name="id">
											<xsl:text>draggable_container_</xsl:text>
											<xsl:value-of select="@version"/>
										</xsl:attribute>
										<xsl:for-each select="field">
											<xsl:call-template name="doctype_version_div"/>
										</xsl:for-each>
									</td>
								</tr>
							</table>
							
						</xsl:for-each>
					</td>
				</tr>
			</table>
			<script type="text/javascript">
				Droppables.add(
					"dtc_trash",
					{
						accept: 'doctype_compare_drag',
						onDrop: function(element)
						{
							DC.toTrash(element);
						}
					}
				)
			</script>
			<input type="hidden" name="is_request" value="true"/>
		</form>
		<div style="display:none;">
			<div id="login_layer" style="padding:5pt;">							
					<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
					<table cellpadding="5pt">
					<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
					<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
					<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
				</table>	
			</div>
		</div>
	</xsl:template>

	<xsl:template name="doctype_version_div">
		<div class="doctype_compare_drag">
			<xsl:attribute name="id">
				<xsl:value-of select="@type"/>
				<xsl:text>::</xsl:text>
				<xsl:value-of select="@name"/>
				<xsl:text>::</xsl:text>
				<xsl:value-of select="@version"/>
			</xsl:attribute>
			<xsl:value-of select="@title"/>
			(<xsl:choose>
				<xsl:when test="@ref_title">
					<xsl:value-of select="@ref_title"/>
				</xsl:when>
				<xsl:otherwise>
					<xsl:value-of select="@word"/>
				</xsl:otherwise>
			</xsl:choose>)
		</div>
		<script type="text/javascript">
			DC.addDraggable("<xsl:value-of select="@type"/>
				<xsl:text>::</xsl:text>
				<xsl:value-of select="@name"/>
				<xsl:text>::</xsl:text>
				<xsl:value-of select="@version"/>");
		</script>
	</xsl:template>
</xsl:stylesheet>