<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"><xsl:output encoding="utf-8" />

	<xsl:template match="/page/module"><style>
			.msfRouterDivForm {
				padding-bottom: 2px;
			}
			.msfRouterTable {
				background-color: #ebecee;
			}
			.msfRouterNumber {
				font-size: 72px;
				width: 102px;
				text-align: center;
				height: 107px;
			}
			.msfRouterTitle {
				font-size: 14px;
			}
			.msfRouterTitleClosed {
				background-color: #ebecee;
				cursor: move;
			}
			.msfRouterText {
				font-family: verdana;
				color: #9096a7;
				font-size: 10px;
			}
			.msfRouterInput {
				border: 1px #7f9db9 solid;
				height: 18px;
				width: 100%
			}
			.msfRouterWindowDelete {
				cursor: pointer;
				vertical-align: bottom;
				text-align: right;
			}
			.msfRouterWindowClosed {
				cursor: pointer;
				width: 14px;
				height: 13px;
				background: url(/templates/default/img/wf.closed.gif) no-repeat bottom right;
			}
			.msfRouterWindowOpened {
				cursor: pointer;
				width: 14px;
				height: 13px;
				background: url(/templates/default/img/wf.opened.gif) no-repeat bottom right;
			}
		</style>
		<xsl:for-each select="actions/item">
			<xsl:apply-templates select="/page/module/actions/item[@name=current()/@name]"/>
		</xsl:for-each>
		
		<script type="text/javascript">
			var RouterFactory = Class.create();
			RouterFactory.prototype =
			{
				initialize: function(sRouter)
				{
					this.sRouter = sRouter;
				},

				process: function(sName, aWords, Container, iCount, aTypesValues)
				{
					switch (this.sRouter) {<xsl:for-each select="actions/item">
						<xsl:if test="@in_spa=0">
						case '<xsl:value-of select="@name"/>':
							return new <xsl:value-of select="@class"/>(
								sName,
								aWords,
								Container,
								iCount,
								aTypesValues,
								'router_form_submit_button'
							);
							break;</xsl:if></xsl:for-each>
					}
				}
			}
		</script>
		<span id="router_delegate_types_values" style="display: none">
			<select id="router_delegate_type">
				<option value="">-------------------</option>
				<xsl:for-each select="types/item">
					<option>
						<xsl:attribute name="value">
							<xsl:value-of select="@name"/>
						</xsl:attribute>
						<xsl:value-of select="@title"/>
					</option>
				</xsl:for-each>
			</select>
			<span id="router_delegate_value"></span>
		</span>
		
		<form method="post" id="doctype_router_action_form">
			<table>
				<tr>
					<td>
						<div class="msfButton" id="doctype_router_add_link">
							<div id="msfButtonLeft"></div>
							<div id="msfButtonText"><xsl:value-of select="$WORKFLOW_DOCTYPE_ROUTER_ADD"/></div>
							<div id="msfButtonImage"><img src="/templates/default/img/wf.add.gif"/></div>
							<div id="msfButtonRight"></div>
						</div>
					</td>
				</tr>
				<tr>
					<td id="doctype_router_container">
					</td>
				</tr>
				<tr>
					<td>
						<div class="msfButton" onclick="$('doctype_router_action_form').submit()">
							<div id="msfButtonLeft"></div>
							<div id="msfButtonText"><xsl:value-of select="$WORKFLOW_BTN_SAVE"/></div>
							<div id="msfButtonImage"></div>
							<div id="msfButtonRight"></div>
						</div>
					</td>
				</tr>
			</table>
		</form>






















		<div id="doctype_router_template" style="display: none" class="msfRouterDivForm">
			<table width="1000" cellpadding="10" cellspacing="0" height="35">
				<tr class="msfRouterTitle">
					<td id="doctype_router_onclose_title">
					</td>
					<td valign="top">
						<table cellpadding="0" cellspacing="0" align="right">
							<tr>
								<td class="msfRouterWindowOpened" id="doctype_router_close_link">
									&#32;
								</td>
								<td width="10">&#32;</td>
								<td class="msfRouterWindowDelete" id="doctype_router_delete_link">
									<img src="/templates/default/img/wf.delete.gif"/>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
			<div id="doctype_router_closing_container">
				<table width="1000" cellpadding="10" cellspacing="2" class="msfRouterText">
					<tr class="msfRouterTable">
						<td colspan="4">
							<table cellpadding="0" cellspacing="0" width="100%">
								<tr>
									<td width="100"><xsl:value-of select="$WORKFLOW_DOCTYPE_ROUTER_TITLE"/></td>
									<td><input class="msfRouterInput" id="doctype_router_title"/></td>
								</tr>
							</table>
						</td>
					</tr>
					<tr class="msfRouterTable">
						<td class="msfRouterNumber" id="doctype_router_number"></td>
						<td valign="top">
							<table cellpadding="0" cellspacing="0" width="100%">
								<tr>
									<td>
										<div class="msfButton" id="doctype_router_add_delegate_link">
											<div id="msfButtonLeft"></div>
											<div id="msfButtonText"><xsl:value-of select="$ROUTER_DELEGATE"/></div>
											<div id="msfButtonImage"><img src="/templates/default/img/wf.add.gif"/></div>
											<div id="msfButtonRight"></div>
										</div>
									</td>
								</tr>
								<tr>
									<td id="doctype_router_delegate_container"></td>
								</tr>
							</table>
						</td>
						<td valign="top">
							<table cellpadding="0" cellspacing="0" width="100%">
								<tr>
									<td>
										<div class="msfButton" id="doctype_router_add_execute_link">
											<div id="msfButtonLeft"></div>
											<div id="msfButtonText"><xsl:value-of select="$ROUTER_EXECUTE"/></div>
											<div id="msfButtonImage"><img src="/templates/default/img/wf.add.gif"/></div>
											<div id="msfButtonRight"></div>
										</div>
									</td>
								</tr>
								<tr>
									<td id="doctype_router_execute_container"></td>
								</tr>
							</table>
						</td>
						<td valign="top">
							<table cellpadding="0" cellspacing="0" width="100%">
								<tr>
									<td>
										<div class="msfButton" id="doctype_router_edit_wait_link">
											<div id="msfButtonLeft"></div>
											<div id="msfButtonText"><xsl:value-of select="$ROUTER_WAIT"/></div>
											<div id="msfButtonImage"><img src="/templates/default/img/wf.edit.gif"/></div>
											<div id="msfButtonRight"></div>
										</div>
									</td>
								</tr>
								<tr>
									<td id="doctype_router_wait_container"></td>
								</tr>
							</table>
						</td>
					</tr>
				</table>
			</div>
		</div>
		
		<div id="doctype_router_delegate_body" style="display: none; padding: 10px 25px 5px 15px">
			<table width="420" cellpadding="10" cellspacing="0">
				<tr>
					<td width="120"><xsl:value-of select="$LABEL_ACTION"/></td>
					<td>
						<select id="doctype_router_delegate_action">
							<option value=""></option>
							<xsl:for-each select="actions/item">
								<xsl:if test="@in_spa=1">
									<option>
										<xsl:attribute name="value">
											<xsl:value-of select="@id"/>
										</xsl:attribute>
										<xsl:value-of select="@title"/>
									</option>
								</xsl:if>
							</xsl:for-each>
						</select>
					</td>
				</tr>
				<tr>
					<td><xsl:value-of select="$LABEL_TYPE_OF_VALUE"/></td>
					<td>
						<select id="doctype_router_delegate_type">
							<option value=""></option>
							<xsl:for-each select="types/item">
								<option>
									<xsl:attribute name="value">
										<xsl:value-of select="@name"/>
									</xsl:attribute>
									<xsl:value-of select="@title"/>
								</option>
							</xsl:for-each>
						</select>
					</td>
				</tr>
				<tr>
					<td><xsl:value-of select="$LABEL_VALUE"/></td>
					<td id="doctype_router_delegate_value_container">
					</td>
				</tr>
				<tr>
					<td>
						<div class="msfButton" id="doctype_router_delegate_submit_link" style="padding-top: 10px">
							<div id="msfButtonLeft"></div>
							<div id="msfButtonText" style="width: 55px; text-align: center">OK</div>
							<div id="msfButtonRight"></div>
						</div>
					</td>
				</tr>
			</table>
		</div>

		<div id="doctype_router_execute_body" style="display: none; padding: 10px 25px 5px 15px">
			<table width="420" cellpadding="10" cellspacing="0">
				<tr>
					<td width="120"><xsl:value-of select="$LABEL_ACTION"/></td>
					<td>
						<select id="doctype_router_execute_value">
							<option value=""></option>
							<xsl:for-each select="actions/item">
								<xsl:if test="@class and @in_spa='0'">
									<option>
										<xsl:attribute name="value">
											<xsl:value-of select="@name"/>
										</xsl:attribute>
										<xsl:value-of select="@title"/>
									</option>
								</xsl:if>
							</xsl:for-each>
						</select>
					</td>
				</tr>
				<tr>
					<td id="doctype_router_execute_action_container" colspan="2">
					</td>
				</tr>
				<tr>
					<td>
						<div class="msfButton" id="doctype_router_execute_submit_link" style="padding-top: 10px">
							<div id="msfButtonLeft"></div>
							<div id="msfButtonText" style="width: 55px; text-align: center">OK</div>
							<div id="msfButtonRight"></div>
						</div>
					</td>
				</tr>
			</table>
		</div>
		
		<div id="doctype_router_wait_body" style="display: none; padding: 10px 25px 5px 15px">
			<table width="420" cellpadding="10" cellspacing="0">
				<tr>
					<td width="120"><xsl:value-of select="$LABEL_ACTION"/></td>
					<td>
						<select id="doctype_router_wait_action" name="spa_id">
							<option value=""></option>
						</select>
					</td>
				</tr>
				<tr>
					<td><xsl:value-of select="$LABEL_TYPE_OF_VALUE"/></td>
					<td>
						<select id="doctype_router_wait_type" name="type">
							<option value=""></option>
							<xsl:for-each select="types/item">
								<option>
									<xsl:attribute name="value">
										<xsl:value-of select="@name"/>
									</xsl:attribute>
									<xsl:value-of select="@title"/>
								</option>
							</xsl:for-each>
						</select>
					</td>
				</tr>
				<tr>
					<td><xsl:value-of select="$LABEL_VALUE"/></td>
					<td>
						<select id="doctype_router_wait_value" name="value">
							<option value=""></option>
						</select>
					</td>
				</tr>
				<tr>
					<td><xsl:value-of select="$LABEL_CONTROL"/></td>
					<td>
						<input type="text" id="doctype_router_wait_control_time" name="control_time"/>
						<select id="doctype_router_wait_control_type" name="control_type">
							<option value="days">
								<xsl:value-of select="$WORKFLOW_DOCTYPE_ROUTER_DAYS"/>
							</option>
							<option value="hours">
								<xsl:value-of select="$WORKFLOW_DOCTYPE_ROUTER_HOURS"/>
							</option>
						</select>
					</td>
				</tr>
				<tr>
					<td>
						<div class="msfButton" id="doctype_router_wait_submit_link" style="padding-top: 10px">
							<div id="msfButtonLeft"></div>
							<div id="msfButtonText" style="width: 55px; text-align: center">OK</div>
							<div id="msfButtonRight"></div>
						</div>
					</td>
				</tr>
			</table>
		</div>
		
		<script>
			var aActions = [<xsl:for-each select="actions/item">
				<xsl:if test="@in_spa=0">
				{
					spa_id: '<xsl:value-of select="@id"/>',
					name: '<xsl:value-of select="@name"/>',
					value: eval(<xsl:value-of select="@value"/>)
				}<xsl:if test="position()!=last()">
					,
				</xsl:if>
				</xsl:if>
				</xsl:for-each>
			];
			var aWords = {
				'WORKFLOW_ACTION_SHOW': '<xsl:value-of select="$WORKFLOW_ACTION_SHOW"/>',
				'WORKFLOW_ACTION_HIDE': '<xsl:value-of select="$WORKFLOW_ACTION_HIDE"/>',
				'WORKFLOW_DOCTYPE_ROUTER_MESSAGE': '<xsl:value-of select="$WORKFLOW_DOCTYPE_ROUTER_MESSAGE"/>',
				'WORKFLOW_DOCTYPE_ROUTER_ACTION_MESSAGE': '<xsl:value-of select="$WORKFLOW_DOCTYPE_ROUTER_ACTION_MESSAGE"/>'
			};
			var aData = [<xsl:for-each select="router/document/element">
				{
					title: '<xsl:value-of select="@title"/>',
					control: {
						value: '<xsl:value-of select="item[@name='control']/item[@name='time']/@value"/>',
						type: '<xsl:value-of select="item[@name='control']/item[@name='type']/@value"/>'
					},
					delegate: [<xsl:for-each select="item[@name='delegate']/item">
						{
							spa_id: '<xsl:value-of select="item[@name='spa_id']/@value"/>',
							type: '<xsl:value-of select="item[@name='type']/@value"/>',
							value: '<xsl:value-of select="item[@name='value']/@value"/>'
						}<xsl:if test="position()!=last()">
							,
						</xsl:if>
					</xsl:for-each>
					],
					execute: [<xsl:for-each select="item[@name='execute']/item">
						{
							name: '<xsl:value-of select="item[@name='name']/@value"/>',
							value: eval(<xsl:value-of select="item[@name='value']/@value"/>)
						}<xsl:if test="position()!=last()">
							,
						</xsl:if>
					</xsl:for-each>
					],
					wait: {
						spa_id: '<xsl:value-of select="item[@name='wait']/item[@name='spa_id']/@value"/>',
						type: '<xsl:value-of select="item[@name='wait']/item[@name='type']/@value"/>',
						value: '<xsl:value-of select="item[@name='wait']/item[@name='value']/@value"/>'
					}
				}<xsl:if test="position()!=last()">
					,
				</xsl:if>
			</xsl:for-each>
			];
			var aTypesValues = [<xsl:for-each select="types/item">
				{
					name: '<xsl:value-of select="@name"/>',
					value: [<xsl:for-each select="item">{
							name: '<xsl:value-of select="@name"/>',
							title: '<xsl:value-of select="@title"/>',
							show: '<xsl:value-of select="@show"/>'
						}<xsl:if test="position()!=last()">
							,
						</xsl:if>
					</xsl:for-each>]
				}<xsl:if test="position()!=last()">,</xsl:if>
			</xsl:for-each>
			];
			new WF_DoctypeRouter(
				'doctype_router_container',
				'doctype_router_template',
				'doctype_router_add_link',
				aTypesValues,
				aData,
				aWords
			);
		</script>
	</xsl:template>
</xsl:stylesheet>