<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"><xsl:output encoding="utf-8" />
	<xsl:template match="/page/module">
		<script src="/modules/workflow/actions/create/WFA_CreateWidgets.js?v={/page/module/@systemVersion}"></script>
		<script type="text/javascript">
			WindowHandler.attachHandlers();
		</script>
		<script type="text/javascript">
			<xsl:call-template name="data"/>
		</script>
		<xsl:call-template name="point"/>
		<xsl:call-template name="form-delegation"/>
		<xsl:call-template name="form-execution"/>

		<div id="c-route">
			<xsl:apply-templates select="route/document"/>
		</div>
		
		<script type="text/javascript">
			<xsl:call-template name="logic"/>
		</script>
	</xsl:template>
	
	<xsl:template name="data">
	
		var aRouteCfg	=	<xsl:value-of select="route"/>;
		var aSpaCfg			= {};
		aSpaCfg[0]		= 	{
				"title" : 	"<xsl:value-of select="$WORKFLOW_NULL"/>"
				};
		var aLoadedSpa	= <xsl:value-of select="spa"/>;
		for (iSpaId in aLoadedSpa) {
			aSpaCfg[iSpaId] = aLoadedSpa[iSpaId];
		}
		delete(aLoadedSpa);
		var aActionSettings = <xsl:value-of select="/page/module/remindcfg"/>;
		var aSystemFields 	= <xsl:value-of select="/page/module/sysfields"/>;
		var aExcCfg		 	= <xsl:value-of select="execution"/>
		var aAddress	 	= <xsl:value-of select="address"/>
		var aFields		 	= <xsl:value-of select="fields/json"/>
		var aAllDTFields 	= $H(<xsl:value-of select="/page/module/doctypes"/>);
		var oHashizer = {
			hash : function(hHash) {
				hHash = $H(hHash);
				hHash.each(function(kav) {
					if (typeof kav.value == "object") {
						hHash.set(kav.key, this.hash(kav.value));
					}
					else {
						hHash.set(kav.key, kav.value);
					}
					
				
				}.bind(this));
				return hHash;
			}
		}
		aAllDTFields 	 =  oHashizer.hash(aAllDTFields);
	</xsl:template>
	
	<xsl:template name="logic">
		registerEvent(function() {
			oPoint		= new WF_Point();
			oWaiting	= new WF_WaitingContext();
			oDelegation	= new WF_DelegationContext();
			oExecution	= new WF_ExecutionContext();
			oRouter 	= new WF_Route(oPoint, oDelegation, oExecution, oWaiting, aRouteCfg);
		});
	</xsl:template>
	
	<xsl:template name="point">
		<div id="point" class="point">
			<div class="point-main">
				<div id="point-title" class="point-main-title-doct-vers" onclick="oPoint.updateVisibility(WF_Utils.$(this, 'point-title', 'point-visibility'))">
					<xsl:value-of select="$WORKFLOW_NEW_POINT"/>
				</div>
				<div class="point-main-controls">
					<div id="point-visibility" class="point-main-controls-visible" onclick="oPoint.updateVisibility(this)" title="{$WORKFLOW_ACTION_HIDE}"></div>
				</div>
			</div>
			<div id="point-body" class="point-body">
				<div class="point-title">
					<xsl:value-of select="$WORKFLOW_TITLE"/>
					<input id="point-name" name="route[@pointId][title]" value="{$WORKFLOW_NEW_POINT}" onchange="oPoint.updateTitle(this)"/>
				</div>
				<div id="point-context" class="point-context">
					<xsl:call-template name="context-execution"/>
					<xsl:call-template name="context-delegation"/>
					<xsl:call-template name="context-waiting"/>
				</div>
			</div>
		</div>
	</xsl:template>

	<xsl:template name="form-delegation">

		<div id="d-form" style="display:none;">
			<div id="d-head" class="action-title-container">
				<div class="action-title">
					<a id="d-title">
						<xsl:value-of select="$WORKFLOW_NULL"/>
					</a>
				</div>
				<span id="d-remove"></span>
			</div>
			<div id="d-body">
				<table>
					<tr>
						<td>
							<xsl:value-of select="$WORKFLOW_TITLE"/>
						</td>
						<td>
							<select id="d-name" name="route[@pointId][delegate][@actionId][spa_id]" onchange="oDelegation.update(this)"/>
							<script>
								if ($A(aSpaCfg).size() > 0) {
									var iCounter = 0;
									for (iSpaId in aSpaCfg) {
										if (aSpaCfg[iSpaId]['title']) {
											$('d-name').options[iCounter++] = new Option(aSpaCfg[iSpaId]['title'], iSpaId);
										}
										
									}
									
								}
							</script>
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="$WORKFLOW_TYPE"/>
						</td>
						<td>
							<div id="a-type">
								<xsl:value-of select="$WORKFLOW_NULL"/>
							</div>
							<!-- route[@pointId][delegate][@actionId][type] -->
						</td>
					</tr>
					<tr>
						<td>
							<xsl:value-of select="$WORKFLOW_VALUE"/>
						</td>
						<td>
							<div id="a-value">
								<xsl:value-of select="$WORKFLOW_NULL"/>
							</div>
							<!-- route[@pointId][delegate][@actionId][value] -->
						</td>
					</tr>
				</table>
				<span id="d-edit"/>
			</div>
		</div>
	</xsl:template>

	<xsl:template name="context-delegation">
		<div id="point-context-delegation" class="point-context-delegation">
			<div class="point-main-controls-bar">
				<div class="point-main-controls-disabled">
					<xsl:value-of select="$WORKFLOW_DELEGATE"/>
				</div>
			</div>
		</div>
	</xsl:template>
	
	<xsl:template name="context-execution">
		<div id="point-context-execution" class="point-context-execution">
			<div class="point-main-controls-bar">
				<div class="point-main-controls-disabled">
					<xsl:value-of select="$WORKFLOW_EXECUTE"/>
				</div>
			</div>
		</div>
	</xsl:template>
	
	<xsl:template name="context-waiting">
		<div id="point-context-waiting" class="point-context-waiting">
			<div class="point-main-controls-bar">
				<div class="point-main-controls-disabled" id="w-edit-button">
					<xsl:value-of select="$WORKFLOW_WAIT"/>
				</div>
			</div>
			<div id="w-form">
				<div id="w-head">
					<a id="w-title" class="waiting-action" onclick="oWaiting.showForm(this)">
						<xsl:value-of select="$WORKFLOW_NULL"/>
					</a>
				</div>
				<div id="w-body" style="display:none;">
					<table>
						<tr>
							<td>
								<xsl:value-of select="$WORKFLOW_TITLE"/>
							</td>
							<td>
								<select id="w-name" name="route[@pointId][wait][spa_id]" onchange="oWaiting.updateAdresses(this);">
									<option value="0" selected="selected">
										<xsl:value-of select="$WORKFLOW_NULL"/>
									</option>
								</select>
							</td>
						</tr>
						<tr>
							<td>
								<xsl:value-of select="$WORKFLOW_TYPE"/>
							</td>
							<td>
								<div id="b-type">
									<xsl:value-of select="$WORKFLOW_NULL"/>
								</div>
							</td>
						</tr>
						<tr>
							<td>
								<xsl:value-of select="$WORKFLOW_VALUE"/>
							</td>
							<td>
								<div id="b-value">
									<xsl:value-of select="$WORKFLOW_NULL"/>
								</div>
							</td>
						</tr>
					</table>
					<span id="w-edit"/>
				</div>
			</div>
		</div>
	</xsl:template>
	
	<xsl:template match="route/document">
			<xsl:apply-templates/>
	</xsl:template>

	<xsl:template name="form-execution">
		<div id="form-execution">
			<div id="e-form" style="display:none;">
				<div id="e-head" class="action-title-container">
					<div class="action-title">
						<a id="e-title">
							<xsl:value-of select="$WORKFLOW_NULL"/>
						</a>
					</div>
					<span id="e-remove"></span>
				</div>
				<div id="e-body" style="margin: 10px;">
					<table>
						<tr>
							<td class="admin-route-ltd">
								<xsl:value-of select="$WORKFLOW_TITLE"/>
							</td>
							<td class="admin-route-rtd">
								<select id="e-name" name="route[@pointId][execute][@actionId][name]" onchange="oExecution.update(this)">
									<option value="0">
										<xsl:value-of select="$WORKFLOW_NULL"/>
									</option>
								</select>
									<script>
										//if (aExcCfg.length > 0) {
											var iCounter = 1;
											for (iExcId in aExcCfg) {
												$('e-name').options[iCounter++] = new Option(aGlobalMsfWords["WFA_" + aExcCfg[iExcId]['name'].toUpperCase()], aExcCfg[iExcId]['name']);
											}
											
										//}

									</script>
							</td>
						</tr>
					</table>
					<div id="e-anchor"></div>
					<span id="e-edit"/>
				</div>
			</div>
			<xsl:apply-templates select="wfa-tpls"/>
		</div>
	</xsl:template>
</xsl:stylesheet>