<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:template match="/page/module">
		<script src="/modules/workflow/actions/create/WFA_CreateWidgets.js?v={/page/module/@systemVersion}"></script>
		<xsl:for-each select="actions/item">
			<xsl:apply-templates select="/page/module/actions/item[@name=current()/@name]"/>
		</xsl:for-each>
		<script src="/modules/references/view/js/REF_SaveHandler.js"></script>
		<script src="/modules/workflow/view/js/WF_SaveVariantsWindow.js"></script>
		<script type="text/javascript">
			var SpaFactory = Class.create();
			SpaFactory.prototype =
			{
				initialize: function(sAction)
				{
					this.sAction = sAction;
				},

				process: function(sName, Container, iCount, aTypesValues)
				{
					switch (this.sAction) {<xsl:for-each select="actions/item">
						case '<xsl:value-of select="@name"/>':
							return new <xsl:value-of select="@class"/>(
								sName,
								Container,
								iCount,
								aTypesValues,
								'savedoctype_button'
							);
							break;</xsl:for-each>
					}
				}
			}
		</script>		
		<script>
			registerEvent(function() {
				new REF_SaveHandler($("doctype_form"), $("savedoctype_button"), $("login_layer"), "showSaveVariantsWindow");
			});	
		</script>
		<script>
			document.onkeydown = function(e){
				key = (!e) ? window.event : e;
				if (key.ctrlKey &amp;&amp; key.keyCode == 13){
					$("savedoctype_button").click();
				} 
			}
		</script>
		<form method="post" id="doctype_form" autocomplete="off">
			<div style="display: block;" id="doctype_spa_add_link_1">
				<div class="add-field" title="{$WORKFLOW_DOCTYPE_SPA_ADD_HELP}"><xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_ADD"/></div>
			</div>
			<br/>
			<div class="WF_Fields_ElementContainer" style="clear: left;" id="doctype_spa_container">
			</div>
			<br/>
			<div style="display: block;" id="doctype_spa_add_link_2" title="{$WORKFLOW_DOCTYPE_SPA_ADD_HELP}">
				<div class="add-field"><xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_ADD"/></div>
			</div>			
			<div style="clear: left; padding-top: 10pt;">
				<div style="display:none;">
				<label>
					<input type="checkbox" name="save_in_version" value="1" id="doctypeSaveVersion"/>
					<xsl:value-of select="$WORKFLOW_DOCTYPE_SAVE_IN_VERSION"/>
				</label>
				</div>
				<br/><br/>
				<div>
					<input type="button" name="ok" id="savedoctype_button" value="{$WORKFLOW_BTN_SAVE}" style="float:left;"/>
					<img id="busy_loader" height="25" width="25" src="/templates/default/images/win/big-ajax-loader.gif" style="display:none;"/>
				</div>
			</div>
			<div style="display:none;">
				<div id="login_layer" style="padding:5pt;">							
						<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
						<table cellpadding="5pt">
						<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
						<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
						<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
					</table>	
				</div>
			</div>
			<div id="SaveVariantsWindow" class="save-window" style="display:none;">				
				<table>
					<tr>
						<td colspan="3" width="360">
							<xsl:value-of select="$WORKFLOW_DOCTYPE_SAVE_IN_VERSION_MSG"  disable-output-escaping="yes"/>																					
						</td>
					</tr>
					<tr>
						<td>
							<input type="button" id="nv_button" onclick="saveVersionChecked(0)" value="{$WORKFLOW_DOCTYPE_SAVEWINDOW_INNEW}" style="width:81px;"/>
						</td>
						<td>
							<input type="button" id="cv_button" onclick="saveVersionChecked(1)" value="{$WORKFLOW_DOCTYPE_SAVEWINDOW_INCURRENT}" style="width:202px;"/>
						</td>								
						<td>
							<input type="button" onclick="closeSaveVariantsWindow()" value="{$WORKFLOW_DOCTYPE_SAVEWINDOW_CANCEL}" style="width:73px;"/>
						</td>
					</tr>				
				</table>
			</div>
		</form>
		
		<div class="form" id="doctype_spa_form" style="display: none; width: 700pt;">
			<table class="field-main-title" width="100%">
				<tr>
					<td width="20pt">
						<div class="point-drag">
							<img src="/templates/default/images/page_with_arrow.png"/>
						</div>
					</td>
					<td id="doctype_spa_close_link_container">
						<span id="onclose_title"></span>
					</td>
					<td class="field-main-controls">
						<div class="field-main-controls-visible" id="doctype_spa_close_link"/>
						<div class="field-main-controls-remove" id="doctype_spa_delete_link"/>
					</td>
				</tr>
			</table>
			<div id="spa_closing_container">
				<table class="form">
					<tr>
						<td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_ACTION_NAME_HELP}">
							<xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_ACTION_NAME"/>
						</td>
						<td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_ACTION_NAME_HELP}">
							<a id="anonymous_element">
								<input type="text" id="doctype_spa_title" style="width: 90%"/>
							</a>
						</td>
					</tr>
					<tr>
						<td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_ACTION_DESCRIPTION_HELP}">
							<xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_ACTION_DESCRIPTION"/>
						</td>
						<td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_ACTION_DESCRIPTION_HELP}">
							<textarea style="width: 90%" id="doctype_spa_description"></textarea>
						</td>
					</tr>
					<tr>
						<td class="form-row-title" title="{$WORKFLOW_DOCTYPE_SPA_TYPE_HELP}">
							<xsl:value-of select="$WORKFLOW_DOCTYPE_TYPE"/>
						</td>
						<td class="form-row-value" title="{$WORKFLOW_DOCTYPE_SPA_TYPE_HELP}">
							<select id="doctype_spa_actions">
								<option value=""><xsl:value-of select="$WORKFLOW_NULL"/></option>
								<xsl:for-each select="actions/item">
									<option>
										<xsl:attribute name="value">
											<xsl:value-of select="@name"/>
										</xsl:attribute>
										<xsl:value-of select="@title"/>
									</option>
								</xsl:for-each>
							</select>
						</td>
					</tr>
				</table>
				<div id="doctype_spa_body_container"></div>
			</div>
		</div>
		
		<div id="router_delegate_body" style="display: none">
			<span id="router_delegate_types_values">
				<select id="router_delegate_type">
					<option value=""><xsl:value-of select="$WORKFLOW_NULL"/></option>
					<xsl:for-each select="types/item">
						<option>
							<xsl:attribute name="value">
								<xsl:value-of select="@name"/>
							</xsl:attribute>
							<xsl:value-of select="@title"/>
						</option>
					</xsl:for-each>
				</select>
				<span id="router_delegate_value"></span>
			</span>
			<a href="#" id="router_delegate_delete_link">
				<xsl:value-of select="$WORKFLOW_ACTION_DELETE"/>
			</a>
		</div>
		
		<script>
			var aData = [
			<xsl:for-each select="spa/item">
				{
					spa_id: '<xsl:value-of select="@spa_id"/>',
					name: '<xsl:value-of select="@name"/>',
					title: '<xsl:value-of select="@title"/>',
					description: '<xsl:value-of select="@description"/>',
					value: <xsl:value-of select="@value"/>
				}<xsl:if test="position()!=last()">
					<xsl:text>,</xsl:text>
				</xsl:if>
			</xsl:for-each>
			];
			var aTypesValues = [<xsl:for-each select="types/item">
				{
					name: '<xsl:value-of select="@name"/>',
					value: [<xsl:for-each select="item">{
							name: '<xsl:value-of select="@name"/>',
							title: '<xsl:value-of select="@title"/>',
							type: '<xsl:value-of select="@type"/>',
							show: '<xsl:value-of select="@show"/>',
							value: eval(<xsl:value-of select="@value"/>)
						}<xsl:if test="position()!=last()">
							,
						</xsl:if>
					</xsl:for-each>]
				}<xsl:if test="position()!=last()">,</xsl:if>
			</xsl:for-each>
			];
			
			var aAllDTFields = <xsl:value-of select="/page/module/doctypes"/>;
			
			var aActionSettings = <xsl:value-of select="/page/module/remindcfg"/>;
			
			var aSystemFields = <xsl:value-of select="/page/module/sysfields"/>;
			
			var DoctypeSpa = new WF_DoctypeSpa(
				'doctype_spa_container',
				'doctype_spa_form',
				'doctype_spa_add_link',
				aData,
				aTypesValues,
				//
				aAllDTFields
			);
		</script>
		<script type="text/javascript">
			WindowHandler.attachHandlers();
		</script>
	</xsl:template>
</xsl:stylesheet>