<?xml version="1.0"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:template match="/page/module">
		<script type="text/javascript">
			WindowHandler.attachHandlers();
		</script>
		<!--  -->
		<script src="/modules/workflow/actions/create/WFA_CreateWidgets.js?v={/page/module/@systemVersion}"></script>
		<xsl:for-each select="actions/item">
			<xsl:apply-templates select="/page/module/actions/item[@name=current()/@name]"/>
		</xsl:for-each>
		<script type="text/javascript">
			var SpaFactory = Class.create();
			SpaFactory.prototype =
			{
				initialize: function(sAction)
				{
					this.sAction = sAction;
				},

				process: function(sName, Container, iCount, aTypesValues)
				{
					switch (this.sAction) {<xsl:for-each select="actions/item">
						case '<xsl:value-of select="@name"/>':
							return new <xsl:value-of select="@class"/>(
								sName,
								Container,
								iCount,
								aTypesValues,
								'spa_form_submit_button'
							);
							break;</xsl:for-each>
					}
				}
			}
		</script>
		
		<div id="spa_main_form_element">
			<span id="doctype_spa_add_link"></span>
			<div class="WF_Fields_ElementContainer" id="doctype_spa_container">
			</div>
		</div>
		
		<div class="form" id="doctype_spa_form" style="display: none">
			<table class="field-main-title" width="100%">
				<tr>
					<td id="doctype_spa_close_link_container">
						<span id="onclose_title"></span>
					</td>
					<td class="field-main-controls">
						<div class="field-main-controls-visible" id="doctype_spa_close_link"/>
						<div id="doctype_spa_delete_link"/>
					</td>
				</tr>
			</table>
			<div id="spa_closing_container">
				<table class="form">
					<tr>
						<td class="form-row-title">
							<xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_ACTION_NAME"/>
						</td>
						<td class="form-row-value">
							<input type="text" id="doctype_spa_title" style="width: 90%"/>
						</td>
					</tr>
					<tr>
						<td class="form-row-title">
							<xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_ACTION_DESCRIPTION"/>
						</td>
						<td class="form-row-value">
							<textarea style="width: 90%" id="doctype_spa_description"></textarea>
						</td>
					</tr>
					<tr>
						<td class="form-row-title">
							<xsl:value-of select="$WORKFLOW_DOCTYPE_TYPE"/>
						</td>
						<td class="form-row-value">
							<select id="doctype_spa_actions">
								<option value=""><xsl:value-of select="$WORKFLOW_NULL"/></option>
								<xsl:for-each select="actions/item">
									<option>
										<xsl:attribute name="value">
											<xsl:value-of select="@name"/>
										</xsl:attribute>
										<xsl:value-of select="@title"/>
									</option>
								</xsl:for-each>
							</select>
						</td>
					</tr>
				</table>
				<div id="doctype_spa_body_container"></div>
			</div>
		</div>
		
		<div id="router_delegate_body" style="display: none">
			<span id="router_delegate_types_values">
				<select id="router_delegate_type">
					<option value=""><xsl:value-of select="$WORKFLOW_NULL"/></option>
					<xsl:for-each select="types/item">
						<option>
							<xsl:attribute name="value">
								<xsl:value-of select="@name"/>
							</xsl:attribute>
							<xsl:value-of select="@title"/>
						</option>
					</xsl:for-each>
				</select>
				<span id="router_delegate_value"></span>
			</span>
			<a href="#" id="router_delegate_delete_link">
				<xsl:value-of select="$WORKFLOW_ACTION_DELETE"/>
			</a>
		</div>
		
		<script>
			var aData = [
			<xsl:for-each select="spa/item">
				{
					spa_id: '<xsl:value-of select="@spa_id"/>',
					name: '<xsl:value-of select="@name"/>',
					title: '<xsl:value-of select="@title"/>',
					description: '<xsl:value-of select="@description"/>',
					value: <xsl:value-of select="@value"/>
				}<xsl:if test="position()!=last()">
					<xsl:text>,</xsl:text>
				</xsl:if>
			</xsl:for-each>
			];
			var aTypesValues = [<xsl:for-each select="types/item">
				{
					name: '<xsl:value-of select="@name"/>',
					value: [<xsl:for-each select="item">{
							name: '<xsl:value-of select="@name"/>',
							title: '<xsl:value-of select="@title"/>',
							type: '<xsl:value-of select="@type"/>',
							show: '<xsl:value-of select="@show"/>',
							value: eval(<xsl:value-of select="@value"/>)
						}<xsl:if test="position()!=last()">
							,
						</xsl:if>
					</xsl:for-each>]
				}<xsl:if test="position()!=last()">,</xsl:if>
			</xsl:for-each>
			];
			
			var aAllDTFields = <xsl:value-of select="/page/module/doctypes"/>;
			
			var aActionSettings = <xsl:value-of select="/page/module/remindcfg"/>;
			
			var aSystemFields = <xsl:value-of select="/page/module/sysfields"/>;
			
			var DoctypeSpa = new WF_DoctypeSpa(
				'doctype_spa_container',
				'doctype_spa_form',
				'doctype_spa_add_link',
				aData,
				aTypesValues,
				aAllDTFields
			);
			
			function disableElements(aElements)
			{
				for (var i = 0; i &lt; aElements.length; i++) {
					aElements[i].disabled = "disabled";
				}
			}
			
			disableElements($$('input'));
			disableElements($$('textarea'));
			disableElements($$('select'));
		</script>
	</xsl:template>
</xsl:stylesheet>