<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/page/module">
		<script src="/modules/references/view/js/REF_SaveHandler.js"></script>
		<script>
			registerEvent(function() {
				new REF_SaveHandler($("access_form"), $("savedoctype_button"), $("login_layer"), "submit");
			});	
		</script>
		<script>
			document.onkeydown = function(e){
				key = (!e) ? window.event : e;
				if (key.ctrlKey &amp;&amp; key.keyCode == 13){
					$("savedoctype_button").click();
				} 
			}
		</script>
		<script type="text/javascript">
			WindowHandler.attachHandlers();
		</script>	
		<table border="0" width="100%">
			<tr id="test_element">
				<td valign="top" class="form-row-value" title="{$WORKFLOW_ACCESS_SUBJECT_HELP}">
					<div id="structure_container_|i|"/>
					<div
						class="msfJsScript"
						place="structure_container_|i|"
						inputname="access[|i|][structure]"
						multiselect="true"
						defaultvalues=""
					/>
				</td>
				<td valign="top" class="form-row-value" title="{$WORKFLOW_ACCESS_AUTHOR_HELP}">
					<div id="author_container_|i|"/>
					<div
						class="msfJsScript"
						place="author_container_|i|"
						inputname="access[|i|][author]"
						multiselect="true"
						defaultvalues=""
					/>
				</td>
				<td  valign="top" class="form-row-value" title="{$WORKFLOW_ACCESS_VIEW_HELP}">
					<select name="access[|i|][can_view]">
						<!-- <option value="0"><xsl:value-of select="$WORKFLOW_ACCESS_INHERIT"/></option> -->
						<option value="1"><xsl:value-of select="$WORKFLOW_ACCESS_ALLOW"/></option>
						<option value="2"><xsl:value-of select="$WORKFLOW_ACCESS_DENY"/></option>
					</select>						
				</td>
				<td  valign="top" class="form-row-value" title="{$WORKFLOW_ACCESS_REMOVE_HELP}">
					<select name="access[|i|][can_remove]">
						<!-- <option value="0"><xsl:value-of select="$WORKFLOW_ACCESS_INHERIT"/></option> -->
						<option value="1"><xsl:value-of select="$WORKFLOW_ACCESS_ALLOW"/></option>
						<option value="2"><xsl:value-of select="$WORKFLOW_ACCESS_DENY"/></option>
					</select>						
				</td>				
				<td  valign="top" class="form-row-value">
					<a href="#" id="remove_element">
						<img title="{$WORKFLOW_ACCESS_DELETE}" src="/templates/default/images/red_cross.png" border="0"/>
					</a>
				</td>
			</tr>
		</table>
	
	<div class="add-field" id="doctype_access_add_button" title="{$WORKFLOW_ACCESS_ADD_HELP}">
		<xsl:value-of select="$WORKFLOW_ACCESS_ADD"/>
	</div><br/>
	<form id="access_form" method="post" style="clear: left; width: 90%">
		<div style="display:none;">
			<div id="login_layer" style="padding:5pt;">							
					<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
					<table cellpadding="5pt">
					<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
					<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
					<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
				</table>	
			</div>
		</div>
		<table id="elements_container" class="form">
			<tr>
				<td class="form-row-value" title="{$WORKFLOW_ACCESS_SUBJECT_HELP}"><xsl:value-of select="$WORKFLOW_ACCESS_SUBJECT_OF_ACCESS"/></td>
				<td class="form-row-value" title="{$WORKFLOW_ACCESS_AUTHOR_HELP}"><xsl:value-of select="$WORKFLOW_ACCESS_SUBJECT_OF_AUTHOR"/></td>
				<td width="125" class="form-row-value" title="{$WORKFLOW_ACCESS_VIEW_HELP}"><xsl:value-of select="$WORKFLOW_ACCESS_CAN_VIEW"/></td>
				<td width="125" class="form-row-value" title="{$WORKFLOW_ACCESS_REMOVE_HELP}"><xsl:value-of select="$WORKFLOW_ACCESS_CAN_REMOVE"/></td>			
				<td class="form-row-value">&#160;</td>
			</tr>			
			<xsl:for-each select="access/item">				
				<tr id="test_element">
					<td valign="top" class="form-row-value" title="{$WORKFLOW_ACCESS_SUBJECT_HELP}">
						<div id="structure_container_|i|"/>
						<div
							class="msfJsScript"
							place="structure_container_|i|"
							inputname="access[|i|][structure]"
							multiselect="true"
							defaultvalues="{@structure}"
						/>
					</td>
					<td valign="top" class="form-row-value" title="{$WORKFLOW_ACCESS_AUTHOR_HELP}">
						<div id="author_container_|i|"/>
						<div
							class="msfJsScript"
							place="author_container_|i|"
							inputname="access[|i|][author]"
							multiselect="true"
							defaultvalues="{@author}"
						/>
					</td>
					<td  valign="top" class="form-row-value" title="{$WORKFLOW_ACCESS_VIEW_HELP}">
						<select name="access[|i|][can_view]">
							<!-- <option value="0">
								<xsl:if test="@can_view = 0">
									<xsl:attribute name="selected">
										<xsl:text>selected</xsl:text>
									</xsl:attribute>
								</xsl:if>
								<xsl:value-of select="$WORKFLOW_ACCESS_INHERIT"/>
							</option> -->
							<option value="1">
								<xsl:if test="@can_view = 1">
									<xsl:attribute name="selected">
										<xsl:text>selected</xsl:text>
									</xsl:attribute>
								</xsl:if>
								<xsl:value-of select="$WORKFLOW_ACCESS_ALLOW"/>
							</option>
							<option value="2">
								<xsl:if test="@can_view = 2">
									<xsl:attribute name="selected">
										<xsl:text>selected</xsl:text>
									</xsl:attribute>
								</xsl:if>
								<xsl:value-of select="$WORKFLOW_ACCESS_DENY"/>
							</option>
						</select>						
					</td>
					<td  valign="top" class="form-row-value" title="{$WORKFLOW_ACCESS_REMOVE_HELP}">
						<select name="access[|i|][can_remove]">
							<!-- <option value="0">
								<xsl:if test="@can_remove = 0">
									<xsl:attribute name="selected">
										<xsl:text>selected</xsl:text>
									</xsl:attribute>
								</xsl:if>
								<xsl:value-of select="$WORKFLOW_ACCESS_INHERIT"/>
							</option> -->
							<option value="1">
								<xsl:if test="@can_remove = 1">
									<xsl:attribute name="selected">
										<xsl:text>selected</xsl:text>
									</xsl:attribute>
								</xsl:if>
								<xsl:value-of select="$WORKFLOW_ACCESS_ALLOW"/>
							</option>
							<option value="2">
								<xsl:if test="@can_remove = 2">
									<xsl:attribute name="selected">
										<xsl:text>selected</xsl:text>
									</xsl:attribute>
								</xsl:if>
								<xsl:value-of select="$WORKFLOW_ACCESS_DENY"/>
							</option>
						</select>						
					</td>					
					<td  valign="top" class="form-row-value">
						<a href="#" id="remove_element">
							<img title="{$WORKFLOW_ACCESS_DELETE}" src="/templates/default/images/red_cross.png" border="0"/>
						</a>
					</td>
				</tr>						
			</xsl:for-each>			
		</table><br/>
		<div class="add-field" id="doctype_access_add_button1" title="{$WORKFLOW_ACCESS_ADD_HELP}">
			<xsl:value-of select="$WORKFLOW_ACCESS_ADD"/>
		</div>
		<div style="clear: left"></div>
		<input type="hidden" name="is_request" value="true"/>
		<input value="{$WORKFLOW_ACCESS_SAVE}" id="savedoctype_button" type="button" style="float:left;"/>
		<img id="busy_loader" height="25" width="25" src="/templates/default/images/win/big-ajax-loader.gif" style="display:none;"/>
	</form>	
	
	<script>
		new MSF_ElementAdder('test_element', 'elements_container', ['doctype_access_add_button', 'doctype_access_add_button1'], 'remove_element', '<xsl:value-of select="$WORKFLOW_ACCESS_SURE"/>');
	</script>
	
	</xsl:template>
</xsl:stylesheet>
