<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/page/module">
		<script src="/modules/references/view/js/REF_SaveHandler.js"></script>
		<script>
			registerEvent(function() {
				new REF_SaveHandler($("archive_options_form"), $("savedoctype_button"), $("login_layer"), "submit");
			});	
		</script>
		<script>
			document.onkeydown = function(e){
				key = (!e) ? window.event : e;
				if (key.ctrlKey &amp;&amp; key.keyCode == 13){
					$("savedoctype_button").click();
				} 
			}
		</script>
		<script type="text/javascript">
			WindowHandler.attachHandlers();
		</script>	
		<table border="0" width="100%">
			<tr id="test_element">
				<td valign="top" class="form-row-value">
					<div id="structure_container_|i|"/>
					<div
						class="msfJsScript"
						place="structure_container_|i|"
						inputname="access[|i|][structure]"
						multiselect="true"
						defaultvalues=""
					/>
				</td>				
				<td  valign="top" class="form-row-value">
					<select name="access[|i|][can_view]">
						<!-- <option value="0"><xsl:value-of select="$WORKFLOW_ACCESS_INHERIT"/></option> -->
						<option value="1"><xsl:value-of select="$WORKFLOW_ACCESS_ALLOW"/></option>
						<option value="2"><xsl:value-of select="$WORKFLOW_ACCESS_DENY"/></option>
					</select>						
				</td>
				<td  valign="top" class="form-row-value">
					<select name="access[|i|][can_remove]">
						<!-- <option value="0"><xsl:value-of select="$WORKFLOW_ACCESS_INHERIT"/></option> -->
						<option value="1"><xsl:value-of select="$WORKFLOW_ACCESS_ALLOW"/></option>
						<option value="2"><xsl:value-of select="$WORKFLOW_ACCESS_DENY"/></option>
					</select>						
				</td>				
				<td  valign="top" class="form-row-value">
					<a href="#" id="remove_element">
						<img src="/templates/default/images/red_cross.png" border="0"/>
					</a>
				</td>
			</tr>
		</table>	
	
	<form method="post" id="archive_options_form" style="clear: left; width: 900px">
		<div style="display:none;">
			<div id="login_layer" style="padding:5pt;">							
					<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
					<table cellpadding="5pt">
					<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
					<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
					<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
				</table>	
			</div>
		</div>
		<div>		
			<b><xsl:value-of select="$WORKFLOW_ARCHIVE_GENERAL"/></b>
			<table id="archive_options" class="form">
				<tr>
					<td class="form-row-value"><xsl:value-of select="$WORKFLOW_ARCHIVE_CONDITION"/></td>
					<td width="125" class="form-row-value"><xsl:value-of select="$WORKFLOW_ARCHIVE_DATEFIELD"/></td>
					<td width="140" class="form-row-value"><xsl:value-of select="$WORKFLOW_ARCHIVE_DAYS_RUNOUT"/></td>
				</tr>
				<tr>
					<td class="form-row-value">
						<p><input type="radio" id="days_never" name="archive_options_select" value="days_never" checked="true" title="{$WORKFLOW_ARCHIVE_NEVER_HELP}"/><xsl:value-of select="$WORKFLOW_ARCHIVE_NEVER"/></p>
						<p><input type="radio" id="days_run_out_action" name="archive_options_select" value="days_run_out_action" title="{$WORKFLOW_ARCHIVE_ACTION_CONDITION_HELP}"/><xsl:value-of select="$WORKFLOW_ARCHIVE_ACTION_CONDITION"/></p>
						<p><input type="radio" id="days_run_out_field" name="archive_options_select" value="days_run_out_field" title="{$WORKFLOW_ARCHIVE_FIELD_CONDITION_HELP}"/><xsl:value-of select="$WORKFLOW_ARCHIVE_FIELD_CONDITION"/></p>
					</td>
					<td class="form-row-value">
						<select name="date_field" id="date_field">						  						  
						</select>
					</td>
					<td class="form-row-value">
						<input type="text" name="days_count" id="days_count" maxlength="9" size="9"/><xsl:value-of select="$WORKFLOW_DOCTYPE_SPA_CONTROL_DAYS"/>
					</td>
				</tr>
			</table><br/>			
			<div style="clear: left"></div>
			<b><xsl:value-of select="$WORKFLOW_ARCHIVE_SECURITY"/></b>
			<table id="elements_container" class="form" title="{$WORKFLOW_ARCHIVE_SECURITY_HELP}">
				<tr>
					<td class="form-row-value"><xsl:value-of select="$WORKFLOW_ACCESS_SUBJECT_OF_ACCESS"/></td>				
					<td width="125" class="form-row-value"><xsl:value-of select="$WORKFLOW_ACCESS_CAN_VIEW"/></td>
					<td width="125" class="form-row-value"><xsl:value-of select="$WORKFLOW_ACCESS_CAN_REMOVE"/></td>			
					<td width="15" class="form-row-value">
						<a href="#" id="archive_options_add_button">
							<img src="/templates/default/images/addrow.png" border="0"/>
						</a>
					</td>
				</tr>			
				<xsl:for-each select="access/item">				
					<tr id="test_element">
						<td valign="top" class="form-row-value">
							<div id="structure_container_|i|"/>
							<div
								class="msfJsScript"
								place="structure_container_|i|"
								inputname="access[|i|][structure]"
								multiselect="true"
								defaultvalues="{@structure}"
							/>
						</td>					
						<td  valign="top" class="form-row-value">
							<select name="access[|i|][can_view]">
								<!-- <option value="0">
									<xsl:if test="@can_view = 0">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$WORKFLOW_ACCESS_INHERIT"/>
								</option> -->
								<option value="1">
									<xsl:if test="@can_view = 1">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$WORKFLOW_ACCESS_ALLOW"/>
								</option>
								<option value="2">
									<xsl:if test="@can_view = 2">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$WORKFLOW_ACCESS_DENY"/>
								</option>
							</select>						
						</td>
						<td  valign="top" class="form-row-value">
							<select name="access[|i|][can_remove]">
								<!-- <option value="0">
									<xsl:if test="@can_remove = 0">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$WORKFLOW_ACCESS_INHERIT"/>
								</option> -->
								<option value="1">
									<xsl:if test="@can_remove = 1">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$WORKFLOW_ACCESS_ALLOW"/>
								</option>
								<option value="2">
									<xsl:if test="@can_remove = 2">
										<xsl:attribute name="selected">
											<xsl:text>selected</xsl:text>
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="$WORKFLOW_ACCESS_DENY"/>
								</option>
							</select>						
						</td>					
						<td  valign="top" class="form-row-value">
							<a href="#" id="remove_element">
								<img src="/templates/default/images/red_cross.png" border="0"/>
							</a>
						</td>
					</tr>						
				</xsl:for-each>						
			</table><br/>						
			<div style="clear: left"></div>
			<input type="hidden" name="is_request" value="true"/>
			<input value="{$WORKFLOW_ACCESS_SAVE}" id="savedoctype_button" type="button" style="float:left;"/>
			<img id="busy_loader" height="25" width="25" src="/templates/default/images/win/big-ajax-loader.gif" style="display:none;"/>
		</div>
	</form>	
	
	<script>
		var dateFields	  = $H(<xsl:value-of select="dateFields"/>);		
		var conditionKind = <xsl:value-of select="conditionKind"/>;
		var selField      = <xsl:value-of select="dateField"/>;
		var selDays	      = <xsl:value-of select="daysCount"/>;
		var oRadioNever	  = $("days_never");
		var oRadioAction  = $("days_run_out_action");
		var oRadioField	  = $("days_run_out_field");
		var oSelectField  = $("date_field");
		var oRunoutDays	  = $("days_count");
				
		i = 0;			
		var oOption	= new Option('<xsl:value-of select="$NOT_SELECTED3"/>', "");
		oSelectField.options[i++] = oOption;						
		dateFields.each(function(e) {				
			if(typeof(dateFields.get(e.key)) != "function" &amp;&amp; typeof(dateFields.get(e.key)) != "undefined") {			
				oOption	= new Option(e.value, e.key);
				if(e.key == selField) {
					oOption.selected = true;
				}
				oSelectField.options[i++] = oOption;
			}							
		});								
			
		oRunoutDays.value = selDays;				
		if(conditionKind == "days_run_out_field") {			
			oRadioField.checked	   	    = true;
			oRadioField.defaultChecked  = true;
			oRadioAction.checked 		= false;
			oRadioAction.defaultChecked = false;
			oRadioNever.checked			= false;
			oRadioNever.defaultChecked	= false;
		}
		else if(conditionKind == "days_run_out_action") {			
			oRadioField.checked 		= false;
			oRadioField.defaultChecked  = false;
			oRadioAction.checked 		= true;
			oRadioAction.defaultChecked = true;			
			oRadioNever.checked			= false;
			oRadioNever.defaultChecked	= false;
			oSelectField.disabled 		= true;			
		}
		else {
			oRadioField.checked 		= false;
			oRadioField.defaultChecked  = false;
			oRadioAction.checked 		= false;
			oRadioAction.defaultChecked = false;			
			oRadioNever.checked			= true;
			oRadioNever.defaultChecked	= true;
			oSelectField.disabled 		= true;
			oRunoutDays.disabled		= true;	
		}
		
		oRadioAction.onclick = function() {
			oRadioField.checked  		= false;
			oRadioField.defaultChecked  = false;
			oRadioAction.checked 		= true;
			oRadioAction.defaultChecked = true;
			oSelectField.disabled 		= true;
			oRunoutDays.disabled		= false;
		}
		
		oRadioField.onclick	 = function() {
			oRadioField.checked  		= true;
			oRadioField.defaultChecked  = true;
			oRadioAction.checked 		= false;
			oRadioAction.defaultChecked = false;
			oSelectField.disabled 		= false;
			oRunoutDays.disabled		= false;
		}
		
		oRadioNever.onclick	 = function() {
			oRadioField.checked  		= false;
			oRadioField.defaultChecked  = false;
			oRadioAction.checked 		= false;
			oRadioAction.defaultChecked = false;
			oRadioNever.checked			= true;
			oRadioNever.defaultChecked	= true;
			oSelectField.disabled 		= true;
			oRunoutDays.disabled		= true;
		}		
		
		oRunoutDays.onkeydown = function(e) {
			e = (!e) ? window.event : e;
			if (
					((e.keyCode >=96) &amp;&amp; (e.keyCode &lt;= 105)) || ((e.keyCode &gt;=48) &amp;&amp; (e.keyCode &lt;= 57))
					 || (e.keyCode == 8) || (e.keyCode == 9) || (e.keyCode == 46)|| (e.keyCode == 37) || (e.keyCode == 39) || (e.keyCode == 189) || (e.keyCode == 109)
					 || (e.ctrlKey &amp;&amp; (e.keyCode == 67  || e.keyCode == 86 || e.keyCode == 88 || e.keyCode == 90 || e.keyCode == 65))
					 || (e.shiftKey &amp;&amp; (e.keyCode == 35 || e.keyCode == 36))
				) {
				if (this.value.charAt(0) == '0') {	
					this.value = '';
				}	
				return true;
			} else {
				return false;
			}			
		}
		
		oRunoutDays.onchange = function(e) {
			this.value = parseInt(this.value);
			if (isNaN(this.value)) {	
				this.value = '';
			}	
			
		};				
			
		new MSF_ElementAdder('test_element', 'elements_container', 'archive_options_add_button', 'remove_element', '<xsl:value-of select="$WORKFLOW_ACCESS_SURE"/>');
	</script>
	
	</xsl:template>
</xsl:stylesheet>