<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="log">
		<br/><br/>
		<xsl:if test="/page/module/@hideLog = 0">
	
			<style>
				.logRecCont {
					cursor: pointer;
					width: 85%;
					height: 20px;
				}
				.logRecContBg {
					background: url(/modules/workflow/view/templates/default/img/log/log_closed_middle.png);
				}
				.logText {
					padding-left: 5px;
					color: #0056a4;
					font-size: 10px;
					font-family: verdana;
					width: 12%;
				}
				.logDate {
					color: #0056a4;
				}
				.logLeftPart {
					height: 20px;
					width: 3px;
				}
				.logLeftPartBg {
					background: url(/modules/workflow/view/templates/default/img/log/log_closed_left.png);
				}
				.logRightPart {
					height: 20px;
					width: 3px;
				}
				.logRightPartBg {
					background: url(/modules/workflow/view/templates/default/img/log/log_closed_right.png);
				}
				.logArrow {
					text-align: right;
					width: 2.5%;
				}
				.logArrow img {
					margin-right: 5px;
				}
				.logMiddleLine {
					background-color: #cac2e5;
					height: 1px;
					font-size: 1px;
				}
				.logLeftPartOverBg {
					background: url(/modules/workflow/view/templates/default/img/log/log_opened_left_ov.png);
				}
				.logRightPartOverBg {
					background: url(/modules/workflow/view/templates/default/img/log/log_opened_right_ov.png);
				}
				.logRecContOverBg {
					background: url(/modules/workflow/view/templates/default/img/log/log_opened_middle_ov.png);
				}
			</style>
			<script>
				function openLogRecords(Cont)
				{
					var Records = $('documentLogsId');
					var Arrow 	= $('documentLogArrow');
					var Cont 	= $(Cont);
					var Left 	= $('documentLogLeft');
					var Right 	= $('documentLogRight');
					
					var onout = function()
					{
						Cont.removeClassName('logRecContOverBg');
						Left.removeClassName('logLeftPartOverBg');
						Right.removeClassName('logRightPartOverBg');
					}
					var onover = function()
					{
						Cont.addClassName('logRecContOverBg');
						Left.addClassName('logLeftPartOverBg');
						Right.addClassName('logRightPartOverBg');
					}
					
					if (Records.visible()) {
						Records.hide();
						Cont.addClassName('logRecContBg');
						Left.addClassName('logLeftPartBg');
						Right.addClassName('logRightPartBg');
						Arrow.src = '/modules/workflow/view/templates/default/img/log/log_arrow_closed.png';
						Cont.onmouseover = Cont.onmouseout = null;
						onout();
					}
					else {
						Records.show();
						Cont.removeClassName('logRecContBg');
						Left.removeClassName('logLeftPartBg');
						Right.removeClassName('logRightPartBg');
						Arrow.src = '/modules/workflow/view/templates/default/img/log/log_arrow_opened.png';
						onover();
						Cont.onmouseover = onover;
						Cont.onmouseout = onout;
						resizeIframeContents();
					}
				}
			</script>
			<table class="no-print logRecCont logRecContBg" cellpadding="0" cellspacing="0" onclick="openLogRecords(this)">
				<tr>
					<td><div class="logLeftPart logLeftPartBg" id="documentLogLeft"/></td>
					<td class="logText"><xsl:value-of select="$WORKFLOW_LOG_TITLE"/></td>
					<td width="84%"><div class="logMiddleLine"></div></td>
					<td class="logArrow"><img src="/modules/workflow/view/templates/default/img/log/log_arrow_closed.png" id="documentLogArrow"/></td>
					<td class="logRightPart logRightPartBg" id="documentLogRight"></td>
				</tr>
			</table>
			<div style="display:none; padding-left: 10px" id="documentLogsId">
				<xsl:for-each select="item">			
					<ul class="no-print" style="clear:left;list-style-type:none;wisth:100%;padding:0px;margin:0px;line-height:20px;">
						<li style="float:left;">
							<span class="logDate"><xsl:value-of select="@date"/>&#160;</span>			
							<xsl:value-of select="@employeeName"/>&#160;	
							<b><xsl:value-of select="@actionTitle"/></b>&#160;	
						</li>
						<li style="float:left;">
							<xsl:if test="not(@fullText = '')">
								<img style="cursor:pointer; margin-top:3pt;" src="/templates/default/images/square_blue_add_mini.png" id="oc_button_{@timestamp}">
									<xsl:attribute name="onclick">
											var s = $('s<xsl:value-of select="@timestamp"/>'); 
											var f = $('f<xsl:value-of select="@timestamp"/>'); 
											if (f.style.display == 'none') {
												f.style.display = 'block';
												s.style.display = 'none';
											}
											else {
												f.style.display = 'none';
												s.style.display = 'block';
											}
										
									</xsl:attribute>
								</img>
							</xsl:if>
						</li>
						<li style="float:left;width:40%">
							<ul style="list-style-type:none;padding:0px;margin:0px;">
								<li id="s{@timestamp}" style="vertical-align:middle;"><xsl:value-of select="@smallText" disable-output-escaping="yes"/></li>
								<xsl:if test="not(@fullText = '')">
									<li id="f{@timestamp}" style="display:none;"><xsl:value-of select="@fullText" disable-output-escaping="yes"/></li>
								</xsl:if>
							</ul>
						</li>
					</ul>				
		
				</xsl:for-each>
			</div>
			<br/><br/>
		</xsl:if>
		
	</xsl:template>
	
</xsl:stylesheet>