<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:template match="/page/module">
		<script src="/modules/references/view/js/REF_SaveHandler.js"></script>
			<script>
				registerEvent(function() {					
					new REF_SaveHandler($("folderForm"), $("subm"), $("login_layer"), "submit");
				});	
			</script>
			<script>
				document.onkeydown = function(e){
					key = (!e) ? window.event : e;
					if (key.ctrlKey &amp;&amp; key.keyCode == 13){
						$("subm").click();
					} 
				}
			</script>
		<script type="text/javascript">
			WindowHandler.attachHandlers();
			
			function disabledSubm(){
		 		$("subm").disabled	= true;
		 	}
		</script>	
		<form method="post" id="folderForm" name="folderForm">
			<div style="display:none;">
				<div id="login_layer" style="padding:5pt;">							
						<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
						<table cellpadding="5pt">
						<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
						<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
						<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
					</table>	
				</div>
			</div>
			<table class="form" border="0">
				<tr>
					<td valign="top" class="form-row-title">
						<xsl:value-of select="$WORKFLOW_ADMIN_LIST_TITLE"/>
					</td>
					<td class="form-row-value">
						<input type="text" name="name" value="{folder/@name}" class="wide"/>
					</td>
				</tr>
				<tr>
					<td valign="top" class="form-row-title">
						<xsl:value-of select="$WORKFLOW_ADMIN_LIST_SMALL_DESCRIPTION"/>
					</td>
					<td class="form-row-value">
						<textarea name="description" class="wide"><xsl:value-of select="folder/@description"/></textarea>
					</td>
				</tr>
				<tr>
					<td valign="top" class="form-row-title">
						<xsl:value-of select="$WORKFLOW_ADMIN_LIST_FULL_DESCRIPTION"/>
					</td>
					<td class="form-row-value">
						<textarea id="fullDescription" name="fullDescription" class="wide"><xsl:value-of select="folder/@fullDescription"/></textarea>
						<script>
							initRte("fullDescription");
						</script>
					</td>
				</tr>
				<tr>
					<td valign="top" class="form-row-title">
						<xsl:value-of select="$WORKFLOW_ADMIN_LIST_GROUP"/>
					</td>
					<td class="form-row-value">
						<select name="group_id">
							<option value="0"><xsl:value-of select="$LABEL_NO"/></option>
							<xsl:for-each select="groups/group">
								<option value="{@group_id}">
									<xsl:if test="@selected = 1">
										<xsl:attribute name="selected">
											selected
										</xsl:attribute>
									</xsl:if>
									<xsl:value-of select="@name"/>
								</option>
							</xsl:for-each>
						</select>
					</td>
				</tr>
				<tr>
					<td valign="top" class="form-row-title">
						<xsl:value-of select="$WORKFLOW_FOLDERS_DOCTYPES"/>
					</td>
					<td class="form-row-value">
						<table border="0" cellpading="1" cellspacing="1" width="90%">
							<tr>
								<td width="45%">
									<select id="doctypesList" multiple="multiple" style="height: 150px; width: 100%;">
										<xsl:for-each select="doctypes/doctype">
											<option value="{@doctype_id}"><xsl:value-of select="@title"/></option>
										</xsl:for-each>
									</select>
								</td>
								<td align="center" width="10%">
									<img style="margin: 0px 0px 5px 10px; cursor: pointer" src="/templates/default/images/arrow_right.png" onClick="WF_Folder_addDoctype('doctypesList', 'selectedDoctypes')"/>
									<br/>
									<img style="margin: 5px 0px 0px 10px; cursor: pointer" src="/templates/default/images/arrow_left.png" onClick="WF_Folder_addDoctype('selectedDoctypes', 'doctypesList')"/>
								</td>
								<td width="45%">
									<select id="selectedDoctypes" style="height: 150px; width: 100%;" multiple="multiple" name="doctypes[]">
										<xsl:for-each select="folder/foldersDoctypes/doctype">
											<option value="{@doctype_id}">
												<xsl:value-of select="@title"/>
											</option>
										</xsl:for-each>
									</select>
								</td>
							</tr>
						</table>
					</td>
				</tr>								
				<tr>
					<td class="form-row-value" colspan="2">
						<input id="subm" type="button" value="{$WORKFLOW_SAVE}" onclick="WF_Folder_formSend('selectedDoctypes');"/>
						<img id="busy_loader" style="display:none;" height="25" width="25" src="/templates/default/images/win/big-ajax-loader.gif"/>
					</td>
				</tr>				
			</table>
		</form>

	</xsl:template>
</xsl:stylesheet>