<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"><xsl:output encoding="utf-8" />
	<xsl:template match="/page/module">
		<!--  -->
		<script src="/modules/workflow/actions/create/WFA_CreateWidgets.js?v={/page/module/@systemVersion}"></script>
		<script type="text/javascript">
			<xsl:call-template name="data"/>
		</script>
		<xsl:call-template name="point"/>	 
		<form action="#">
			<xsl:call-template name="form-delegation"/>
			<xsl:call-template name="form-execution"/>
		</form>
		<script src="/modules/references/view/js/REF_SaveHandler.js"></script>
		<script src="/modules/workflow/view/js/WF_SaveVariantsWindow.js"></script>
		<script>
			registerEvent(function() {
				new REF_SaveHandler($("doctype_form"), $("savedoctype_button"), $("login_layer"), "showSaveVariantsWindow");
			});	
		</script>
		<script>
			document.onkeydown = function(e){
				key = (!e) ? window.event : e;
				if (key.ctrlKey &amp;&amp; key.keyCode == 13){
					$("savedoctype_button").click();
				} 
			}
		</script>
		<form name="route" id="doctype_form" method="POST" action="?request=yes">
			<div class="route-actions" title="{$WORKFLOW_ROUTE_POINT_ADD_HELP}">
				<div class="add-point" onclick="oRouter.add()">
					<xsl:value-of select="$WORKFLOW_ACTION_ADD"/>
				</div>
			</div><br/>
			<div id="c-route">
				<xsl:apply-templates select="route/document"/>
			</div>
			<div class="route-actions" style="clear: left">
				<br/>
				<div class="add-point" onclick="oRouter.add()" title="{$WORKFLOW_ROUTE_POINT_ADD_HELP}">
					<xsl:value-of select="$WORKFLOW_ACTION_ADD"/>
				</div>
			</div>
			<div style="clear:left;">
				<div style="display:none;">
				<label>
					<input type="checkbox" name="save_in_version" value="1" id="doctypeSaveVersion"/>
					<xsl:value-of select="$WORKFLOW_DOCTYPE_SAVE_IN_VERSION"/>
				</label>
				</div>
				<div style="margin-top:10px;">
					<input type="button" id="savedoctype_button" value="{$WORKFLOW_BTN_SAVE}" style="float:left;"/>
					<img id="busy_loader" height="25" width="25" src="/templates/default/images/win/big-ajax-loader.gif" style="display:none;"/>
				</div>
			</div>
			<div style="display:none;">
				<div id="login_layer" style="padding:5pt;">							
						<input id="ajax_login" type="hidden" value="{$CURRENT_LOGIN}"/>
						<table cellpadding="5pt">
						<tr><td colspan="2" id="ajax_error"><xsl:value-of select="$ROOT_LOGIN_CONTINUE_MSG"/>:</td></tr>
						<tr><td><xsl:value-of select="$ROOT_LABEL_PASSWORD"/>: </td><td><input id="ajax_password" type="password"/></td></tr>
						<tr><td colspan="2" align="right"><input id="ajax_button" type="button" value="{$ROOT_LOG_IN}"/></td></tr>
					</table>	
				</div>
			</div>
			<div id="SaveVariantsWindow" class="save-window" style="display:none;">				
				<table>
					<tr>
						<td colspan="3" width="360">
							<xsl:value-of select="$WORKFLOW_DOCTYPE_SAVE_IN_VERSION_MSG"  disable-output-escaping="yes"/>																					
						</td>
					</tr>
					<tr>
						<td title="{$WORKFLOW_ROUTE_SAVEWINDOW_INNEW_HELP}">
							<input type="button" id="nv_button" onclick="saveVersionChecked(0)" value="{$WORKFLOW_DOCTYPE_SAVEWINDOW_INNEW}" style="width:81px;"/>
						</td>
						<td title="{$WORKFLOW_ROUTE_SAVEWINDOW_INCURRENT_HELP}">
							<input type="button" id="cv_button" onclick="saveVersionChecked(1)" value="{$WORKFLOW_DOCTYPE_SAVEWINDOW_INCURRENT}" style="width:202px;"/>
						</td>											
						<td title="{$WORKFLOW_DOCTYPE_SAVEWINDOW_CANCEL_HELP}">
							<input type="button" onclick="closeSaveVariantsWindow()" value="{$WORKFLOW_DOCTYPE_SAVEWINDOW_CANCEL}" style="width:73px;"/>
						</td>
					</tr>				
				</table>
			</div>
		</form>
		<script type="text/javascript">
			<xsl:call-template name="logic"/>
		</script>
	</xsl:template>
	
	<xsl:template name="data">
		var aRouteCfg	=	<xsl:value-of select="route"/>;
		var aSpaCfg			= new Array();
		aSpaCfg[0]		= 	{
				"title" : 	"<xsl:value-of select="$WORKFLOW_NULL"/>"
				};
		var aLoadedSpa	= <xsl:value-of select="spa"/>;
		for (iSpaId in aLoadedSpa) {
			aSpaCfg[iSpaId] = aLoadedSpa[iSpaId];
		}
		delete(aLoadedSpa);
		var aExcCfg			=	<xsl:value-of select="execution"/>
		var aActionSettings = <xsl:value-of select="/page/module/remindcfg"/>;
		var aSystemFields 	= <xsl:value-of select="/page/module/sysfields"/>;
		var aAddress		= 	<xsl:value-of select="address"/>
		var aFields			= 	<xsl:value-of select="fields/json"/>
		var aAllDTFields 	=	$H(<xsl:value-of select="/page/module/doctypes"/>);
		var oHashizer = {
			hash : function(hHash) {
				hHash = $H(hHash);
				hHash.each(function(kav) {
					if (typeof kav.value == "object") {
						hHash.set(kav.key, this.hash(kav.value));
					}
					else {
						hHash.set(kav.key, kav.value);
					}
					
				
				}.bind(this));
				return hHash;
			}
		}
		
		aAllDTFields = oHashizer.hash(aAllDTFields);
	</xsl:template>
	
	<xsl:template name="logic">
		registerEvent(function() {
			oPoint		= new WF_Point();
			oWaiting	= new WF_WaitingContext();
			oDelegation	= new WF_DelegationContext();
			oExecution	= new WF_ExecutionContext();
			oRouter 	= new WF_Route(oPoint, oDelegation, oExecution, oWaiting, aRouteCfg);
		});

		window.onerror = function(desc, page, line) {
		  // alert('Error description:\t' + desc + '\nPage address:\t' + page + '\nLine number:\t' + line);
		  // return true;
		}
		
		WindowHandler.attachHandlers();
	</xsl:template>

	<xsl:template name="point">
		<div id="point" class="point">
			<div class="point-main">
				<div class="point-drag">
					<img src="/templates/default/images/page_with_arrow.png"/>
				</div>
				<div id="point-title" class="point-main-title" onclick="oPoint.updateVisibility(WF_Utils.$(this, 'point-title', 'point-visibility'))">
					<xsl:value-of select="$WORKFLOW_NEW_POINT"/>
				</div>
				<div class="point-main-controls">
					<div id="point-visibility" class="point-main-controls-visible" onclick="oPoint.updateVisibility(this)" title="{$WORKFLOW_ACTION_HIDE}"></div>
					<div id="point-remove" class="point-main-controls-remove" onclick="oPoint.remove(this)" title="{$WORKFLOW_ACTION_DELETE_POINT}"></div>
				</div>
			</div>
			<div id="point-body" class="point-body">
				<div class="point-title" title="{$WORKFLOW_TITLE_HELP}">
					<xsl:value-of select="$WORKFLOW_TITLE"/>
					<input id="point-name" name="route[@pointId][title]" value="{$WORKFLOW_NEW_POINT}" onchange="oPoint.updateTitle(this)"/>
				</div>
				<div id="point-context" class="point-context">
					<xsl:call-template name="context-execution"/>
					<xsl:call-template name="context-delegation"/>
					<xsl:call-template name="context-waiting"/>
				</div>
			</div>
		</div>
	</xsl:template>

	<xsl:template name="form-delegation">

		<div id="d-form" style="display:none;">
			<div id="d-head" class="action-title-container">
				<div class="action-drag">
					<img src="/templates/default/images/page_with_arrow.png"/>
				</div>
				<a id="d-title">
					<div class="action-title">
						<xsl:value-of select="$WORKFLOW_NULL"/>
					</div>
				</a>
				<a id="d-remove"> <img title="{$WORKFLOW_ACTION_DELETE}" style="margin-left:1pt;" src="/templates/default/images/red_cross.png"/></a>
			</div>
			<div id="d-body" class="admin-route-blc">
				<table class="admin-route-tbl">
					<tr>
						<td class="admin-route-ltd" title="{$WORKFLOW_DELEGATE_TITLE_HELP}">
							<xsl:value-of select="$WORKFLOW_TITLE"/>
						</td>
						<td class="admin-route-rtd" title="{$WORKFLOW_DELEGATE_TITLE_HELP}">
							<select id="d-name" name="route[@pointId][delegate][@actionId][spa_id]" onchange="oDelegation.update(this)">
								<script>
									if ($A(aSpaCfg).size() > 0) {
										var iCounter = 0;
										for (iSpaId in aSpaCfg) {
											if (aSpaCfg[iSpaId]['title']) {
												$('d-name').options[iCounter++] = new Option(aSpaCfg[iSpaId]['title'], iSpaId);
											}
											
										}
										
									}
								</script>
							</select>
						</td>
					</tr>
					<tr>
						<td class="admin-route-ltd" title="{$WORKFLOW_DELEGATE_TYPE_HELP}">
							<xsl:value-of select="$WORKFLOW_TYPE"/>
						</td>
						<td class="admin-route-rtd" title="{$WORKFLOW_DELEGATE_TYPE_HELP}">
							<div id="a-type">
								<xsl:value-of select="$WORKFLOW_NULL"/>
							</div>
							<!-- route[@pointId][delegate][@actionId][type] -->
						</td>
					</tr>
					<tr>
						<td class="admin-route-ltd" title="{$WORKFLOW_DELEGATE_VALUE_HELP}">
							<xsl:value-of select="$WORKFLOW_VALUE"/>
						</td>
						<td class="admin-route-rtd" title="{$WORKFLOW_DELEGATE_VALUE_HELP}">
							<div id="a-value">
								<xsl:value-of select="$WORKFLOW_NULL"/>
							</div>
							<!-- route[@pointId][delegate][@actionId][value] -->
						</td>
					</tr>
				</table>
				<input class="admin-route-btn" type="button" id="d-edit" onclick="oDelegation.add(this)" value="{$WORKFLOW_SAVE}"/>
			</div>
		</div>
	</xsl:template>

	<xsl:template name="context-delegation">
		<div id="point-context-delegation" class="point-context-delegation">
			<div class="point-main-controls-bar">
				<div class="point-main-controls-delegate" onclick="oDelegation.showBlankForm(this.parentNode)" title="{$WORKFLOW_DELEGATE_HELP}">
					<xsl:value-of select="$WORKFLOW_DELEGATE"/>
				</div>
			</div>
			<div class="context-delegation-blank"></div>
			<div id="delegation-drag" class="delegation-drag"></div>
		</div>
	</xsl:template>
	
	<xsl:template name="context-execution">
		<div id="point-context-execution" class="point-context-execution">
			<div class="point-main-controls-bar">
				<div class="point-main-controls-execute" onclick="oExecution.showBlankForm(this.parentNode)" title="{$WORKFLOW_EXECUTE_HELP}">
					<xsl:value-of select="$WORKFLOW_EXECUTE"/>
				</div>
			</div>
			<div class="context-execution-blank"></div>
			<div id="execution-drag" class="execution-drag"></div>
		</div>
		
	</xsl:template>
	
	<xsl:template name="context-waiting">
		<div id="point-context-waiting" class="point-context-waiting">
			<div class="point-main-controls-bar">
				<div class="point-main-controls-wait" id="w-edit-button" onclick="oWaiting.showForm(WF_Utils.$(this, 'w-edit-button', 'w-title'))" title="{$WORKFLOW_WAIT_HELP}">
					<xsl:value-of select="$WORKFLOW_WAIT"/>
				</div>
			</div>
			<div id="w-form">
				<div id="w-head">
					<a id="w-title" class="waiting-action" onclick="oWaiting.showForm(this)">
						<xsl:value-of select="$WORKFLOW_NULL"/>
					</a>
				</div>
				<div class="admin-route-blc" id="w-body" style="display:none;">
					<table class="admin-route-tbl">
						<tr>
							<td class="admin-route-ltd" title="{$WORKFLOW_WAIT_TITLE_HELP}">
								<xsl:value-of select="$WORKFLOW_TITLE"/>
							</td>
							<td class="admin-route-rtd" title="{$WORKFLOW_WAIT_TITLE_HELP}">
								<select id="w-name" name="route[@pointId][wait][spa_id]" onchange="oWaiting.updateAdresses(this);">
									<option value="0" selected="selected">
										<xsl:value-of select="$WORKFLOW_NULL"/>
									</option>
								</select>
							</td>
						</tr>
						<tr>
							<td class="admin-route-ltd" title="{$WORKFLOW_WAIT_TYPE_HELP}">
								<xsl:value-of select="$WORKFLOW_TYPE"/>
							</td>
							<td class="admin-route-rtd" title="{$WORKFLOW_WAIT_TYPE_HELP}">
								<div id="b-type">
									<xsl:value-of select="$WORKFLOW_NULL"/>
								</div>
							</td>
						</tr>
						<tr>
							<td class="admin-route-ltd" title="{$WORKFLOW_WAIT_VALUE_HELP}">
								<xsl:value-of select="$WORKFLOW_VALUE"/>
							</td>
							<td class="admin-route-rtd" title="{$WORKFLOW_WAIT_VALUE_HELP}">
								<div id="b-value">
									<xsl:value-of select="$WORKFLOW_NULL"/>
								</div>
							</td>
						</tr>
					</table>
					<input class="admin-route-btn" type="button" id="w-edit" onclick="oWaiting.ok(this)" value="{$WORKFLOW_SAVE}"/>
				</div>
			</div>
		</div>
	</xsl:template>
	
	<xsl:template match="route/document">
			<xsl:apply-templates/>
	</xsl:template>

	<xsl:template name="form-execution">
		<div id="form-execution">
			<div id="e-form" style="display:none;">
				<div id="e-head" class="action-title-container">
					<div class="action-drag">
						<img src="/templates/default/images/page_with_arrow.png"/>
					</div>
					<div class="action-title">
						<a id="e-title">
							<xsl:value-of select="$WORKFLOW_NULL"/>
						</a>
					</div>
					<a id="e-remove"> <img title="{$WORKFLOW_ACTION_DELETE}" style="margin-left:1pt;" src="/templates/default/images/red_cross.png"/></a>
				</div>
				<div id="e-body" class="admin-route-blc">
					<table class="admin-route-tbl">
						<tr>
							<td class="admin-route-ltd" title="{$WORKFLOW_EXECUTE_TITLE_HELP}">
								<xsl:value-of select="$WORKFLOW_TITLE"/>								
							</td>
							<td class="admin-route-rtd" title="{$WORKFLOW_EXECUTE_TITLE_HELP}">
								<select id="e-name" name="route[@pointId][execute][@actionId][name]" onchange="oExecution.update(this)">
									<option value="0">
										<xsl:value-of select="$WORKFLOW_NULL"/>
									</option>
									<script>
										//if (aExcCfg.length > 0) {
											var iCounter = 1;
											for (iExcId in aExcCfg) {
												$('e-name').options[iCounter++] = new Option(aGlobalMsfWords["WFA_" + aExcCfg[iExcId]['name'].toUpperCase()], aExcCfg[iExcId]['name']);
											}
											
										//}

									</script>
								</select>
							</td>
						</tr>
					</table>
					<div id="e-anchor"></div>
					<input type="button" class="admin-route-btn" id="e-edit" onclick="oExecution.add(this)" value="{$WORKFLOW_SAVE}"/>
					<!-- 
					<a id="e-edit" style="display:block;cursor:pointer;" onclick="oExecution.add(this)">
						<xsl:value-of select="$WORKFLOW_ACTION_ADD"/>
					</a>
					-->
				</div>
			</div>
			<xsl:apply-templates select="wfa-tpls"/>
		</div>
	</xsl:template>
</xsl:stylesheet>