<?php

defined("__MSF") or die("Direct access is not allowed");

class WF_DoctypeCompareXml extends MSF_ViewSupportXml
{
	public function view($aResult, $aVersions, $sVersion)
	{
		$this->Template->addLink("/modules/workflow/view/js/WF_DoctypeCompare.js", "text/javascript");
		$this->Template->addLink("/modules/workflow/view/css/doctypeCompare.css", "text/css");
		
		$Doctype = $this->Template->createElement("doctype");
		$Doctype->setAttribute("version", $sVersion);
		
		for ($i = 0; $i < sizeof($aResult); $i++) {
			$Element = $this->Template->createElement("element");
			$Element->setAttribute("title", $aResult[$i]["title"]);
			$Element->setAttribute("type", $aResult[$i]["type"]);
			$Element->setAttribute("word", $this->getType($aResult[$i]["type"]));
			$Element->setAttribute("name", $aResult[$i]["name"]);
			
			if (isset($aResult[$i]["ref_title"])) {
				$Element->setAttribute("ref_title", $aResult[$i]["ref_title"]);
			}
			
			if (isset($aResult[$i]["compared"])) {
				for ($j = 0; $j < sizeof($aResult[$i]["compared"]); $j++) {
					$Field = $this->Template->createElement("field");
					$Field->setAttribute("title", $aResult[$i]["compared"][$j]["title"]);
					$Field->setAttribute("type", $aResult[$i]["compared"][$j]["type"]);
					$Field->setAttribute("word", $this->getType($aResult[$i]["compared"][$j]["type"]));
					$Field->setAttribute("name", $aResult[$i]["compared"][$j]["name"]);
					$Field->setAttribute("version", $aResult[$i]["compared"][$j]["version"]);
					
					if (isset($aResult[$i]["compared"][$j]["ref_title"])) {
						$Field->setAttribute("ref_title", $aResult[$i]["compared"][$j]["ref_title"]);
					}
					
					$Element->appendChild($Field);
				}
			}
			
			$Doctype->appendChild($Element);
		}
		
		$this->Root->appendChild($Doctype);
		
		$Element = $this->Template->createElement("versions");
		
		for ($i = 0; $i < sizeof($aVersions); $i++) {
			$Item = $this->Template->createElement("item");
			$Item->setAttribute("version", $aVersions[$i]["version"]);
			$Item->setAttribute("id", ($i + 1));
			
			for ($j = 0; $j < sizeof($aVersions[$i]) - 1; $j++) {
				$Field = $this->Template->createElement("field");
				$Field->setAttribute("title", $aVersions[$i][$j]["title"]);
				$Field->setAttribute("type", $aVersions[$i][$j]["type"]);
				$Field->setAttribute("word", $this->getType($aVersions[$i][$j]["type"]));
				$Field->setAttribute("name", $aVersions[$i][$j]["name"]);
				$Field->setAttribute("version", $aVersions[$i]["version"]);
				
				if (isset($aVersions[$i][$j]["ref_title"])) {
					$Field->setAttribute("ref_title", $aVersions[$i][$j]["ref_title"]);
				}
				
				$Item->appendChild($Field);
			}
			
			$Element->appendChild($Item);
		}
		
		$this->Root->appendChild($Element);
		
		$this->Template->addLink("/js/ext/scriptaculous/effects.js", "text/javascript");
		$this->Template->addLink("/js/ext/scriptaculous/dragdrop.js", "text/javascript");
		$this->Template->addLink("/js/ext/scriptaculous/controls.js", "text/javascript");
		//$this->Template->addLink("/modules/workflow/view/templates/" . CNF_SKIN . "/css/doctype_compare.css", "text/css");
		$this->Template->addXslPath("/modules/workflow/view/templates/" . CNF_SKIN . "/doctype_compare.xsl");
	}
	
	private function getType($sSourceType)
	{
		return $this->Locale->getWord("WORKFLOW_TYPE_" . strtoupper($sSourceType));
	}
}

?>