<?php

defined("__MSF") or die("Direct access is not allowed");

class WF_DoctypeRouterXml extends MSF_ViewSupportXml
{
	public function view($sActionsXml, $sRouteXml, $sFieldsXml, $aActions, $bView = false)
	{
		$this->addLinksOf("references");
		$this->formActionsXml($sActionsXml, $aActions);
		$this->formSettingsXml($sFieldsXml);
		$this->formDataXml($sRouteXml);
		$this->formDoctypeFieldsXml($sFieldsXml);
		
		for ($i = 0; $i < sizeof($aActions); $i++) {
			if (!empty($aActions[$i]["routerJsClasspath"])) {
				$this->Template->addLink($aActions[$i]["routerJsClasspath"], "text/javascript");
			}
		}
		
		$this->addLinksOf("structure");
		$this->Template->addLink("/modules/workflow/view/templates/" . CNF_SKIN . "/css/doctype_router.css", "text/css");
		$this->Template->addLink("/modules/workflow/view/js/WF_ModifyClonedForm.js", "text/javascript");
		$this->Template->addLink("/modules/workflow/view/js/WF_DoctypeRouter.js", "text/javascript");
		
		if ($bView) {
			$this->Template->addXslPath("/modules/workflow/view/templates/" . CNF_SKIN . "/doctype_router_view.xsl");
		}
		else {
			$this->Template->addXslPath("/modules/workflow/view/templates/" . CNF_SKIN . "/doctype_router.xsl");
		}
	}
	
	private function formDataXml($sXml)
	{
		$Wrapper = new MSF_XmlWrapper($sXml);
		$WResult = new MSF_XmlWrapper();
		
		foreach ($Wrapper as $Data) {
			$aValue = $Data->getValue();
			
			if (isset($aValue["execute"])) {
				foreach ($aValue["execute"] as $k => $aArray) {
					if (isset($aValue["execute"][$k]["value"])) {
						$aValue["execute"][$k]["value"] = MSF_Json::encode($aValue["execute"][$k]["value"]);
					}
				}
			}
			
			$WResult->set($Data->getName(), $aValue, $Data->getTitle());
		}
		
		$Element = $this->Template->createElement("router");
		$this->Root->appendChild($Element);
		$this->Template->appendXmlString($Element, str_replace("<?xml version=\"1.0\"?>", "", $WResult->getXml()));
	}
	
	private function formActionsXml($sActionsXml, $aActions)
	{
		$Actions 	= $this->Template->createElement("actions");
		$Wrapper 	= new MSF_XmlWrapper($sActionsXml);
		$j 			= 100;
		$this->Template->addLink("/modules/workflow/view/js/WF_AbstractForm.js", "text/javascript");

		for ($i = 0; $i < sizeof($aActions); $i++) {
			$sPath = $this->getRouteXslPath($aActions[$i]["name"]);
			
			
			if (isset($aActions[$i]["routerJsClasspath"]) && MSF_File::exists(substr($aActions[$i]["routerJsClasspath"], 1))) {
				$Item = $this->Template->createElement("item");
				$Item->setAttribute("id", $j++);
				$Item->setAttribute("name", $aActions[$i]["name"]);
				$Item->setAttribute("title", $aActions[$i]["title"]);
				$Item->setAttribute("class", $aActions[$i]["routerJsClassname"]);
				$Item->setAttribute("in_spa", 0);
				$Actions->appendChild($Item);
				
				if (MSF_File::exists($sPath)) {
					$this->Template->addXslPath("/" . $sPath);
				}
			}
			
			foreach ($Wrapper AS $iSpaId => $Data) {
				$aValues 			= $Data->getValue();
				$aValues["value"] 	= "";
				if ($aValues["action"] == $aActions[$i]["name"]) {
					$Item = $this->Template->createElement("item");
					$Item->setAttribute("id", 		$iSpaId);
					$Item->setAttribute("name", 	$aActions[$i]["name"]);
					$Item->setAttribute("title", 	$Data->getTitle());
					$Item->setAttribute("value", 	MSF_Json::encode($aValues["value"]));
					$Item->setAttribute("in_spa", 	1);
					
					if (isset($aActions[$i]["routerJsClasspath"]) && MSF_File::exists($sPath)) {
						$Item->setAttribute("class", $aActions[$i]["routerJsClassname"]);
					}
					
					$Actions->appendChild($Item);
					
					if (MSF_File::exists($sPath)) {
						$this->Template->addXslPath("/" . $sPath);
					}
					
				}
				
			}
			
		}
		
		$this->Root->appendChild($Actions);
	}
	
	private function getRouteXslPath($sAction) {
		return "modules/workflow/actions/" . $sAction . "/" . CNF_SKIN . "/back_router.xsl";
	}
	
	private function formSettingsXml($sXml)
	{
		$VM 		= new WF_VarManager();
		//$aSettings 	= MSF_Registry::get("MSF_Settings")->getXmlWrapper()->get("modules")->getValue("workflow");
		$aSettings 	= $VM->getValues();
		$Types 		= $this->Template->createElement("types");
		
		foreach ($aSettings AS $k => $v) {
			$Item = $this->Template->createElement("item");
			$Item->setAttribute("name", strtolower($k));
			$Item->setAttribute("title", $this->Locale->getWord("WORKFLOW_TYPE_" . strtoupper($k)));
			
			switch (strtolower($k)) {
				case "fields":
					$this->formFields($sXml, $Item);
					break;
			}
			
			if (!empty($v)) {
				foreach ($v AS $v2) {
					$InnerItem = $this->Template->createElement("item");
					$InnerItem->setAttribute("name", strtolower($v2["name"]));
					$InnerItem->setAttribute("show", strtolower($v2["show"]));
					$InnerItem->setAttribute("title", $v2["title"]);
					$Item->appendChild($InnerItem);
				}
			}
			
			$Types->appendChild($Item);
		}
		
		$this->Root->appendChild($Types);
	}
	
	private function formFields($sXml, $Root)
	{
		$Wrapper = new MSF_XmlWrapper($sXml);
		
		foreach ($Wrapper AS $Data) {
			$aValues = $Data->getValue();
			
			if ($aValues["type"] == "structure") {
				//if (isset($aValues["optional"]["reference"])) {
					$Item = $this->Template->createElement("item");
					$Item->setAttribute("name", $Data->getName());
					$Item->setAttribute("title", $Data->getTitle());
					$Root->appendChild($Item);
				//}
			}
		}
	}
	
	private function formDoctypeFieldsXml($sXml)
	{
		$Wrapper = new MSF_XmlWrapper($sXml);
		
		$Doctype	= $this->Template->createElement("doctype");
		$this->Root->appendChild($Doctype);
		
		$Fields		= $this->Template->createElement("fields");
		$Doctype->appendChild($Fields);
		
		foreach ($Wrapper as $Data) {
			$Item	= $this->Template->createElement("item");
			$Fields->appendChild($Item);
			
			$Item->setAttribute("name", $Data->getName());
			$Item->setAttribute("title", $Data->getTitle());
		}
		
	}
	
}

?>