<?php

defined("__MSF") or die("Direct access is not allowed");

class WF_DoctypeSpaXml extends MSF_ViewSupportXml
{
	private $Doctype = null;
	
	public function view($aActions, $Xml, $sFields, $bView = false, $sSystemFields)
	{
		$this->buildAllDoctypes();
		$this->formActions($aActions);
		$this->formSettingsXml($sFields);
		
		$this->formSpa($Xml);
		$this->remindSettings();
		$this->systemFields($sSystemFields);
		$this->Template->addLink("/js/ext/calendar_date_select/js/calendar_date_select.js", "text/javascript");
		$this->Template->addLink("/js/ext/calendar_date_select/css/default.css", "text/css");
		$this->Template->addLink("/js/msf/date/DatePlaceholder.js", "text/javascript");
		
		$this->Template->addLink("/modules/workflow/view/css/Fields.css", "text/css");
		$this->Template->addLink("/modules/workflow/view/templates/" . CNF_SKIN . "/css/doctype_spa.css", "text/css");
		$this->Template->addLink("/modules/workflow/view/js/WF_ModifyClonedForm.js", "text/javascript");
		$this->Template->addLink("/modules/workflow/view/js/WF_Utils.js", "text/javascript");
		$this->Template->addLink("/modules/workflow/view/js/WF_DoctypeSpa.js", "text/javascript");
		
		if ($bView) {
			$this->Template->addXslPath("/modules/workflow/view/templates/" . CNF_SKIN . "/doctype_spa_view.xsl");
		}
		else {
			$this->Template->addXslPath("/modules/workflow/view/templates/" . CNF_SKIN . "/doctype_spa.xsl");
		}
		
		
		
		$this->addLinksOf("references");
		$this->addLinksOf("structure");
                
                /*Для тестирования*/
//                $dom = $this->Template->getDomDocument();
//                $xmldata = $dom->saveXML();
//                echo $xmldata;
	}	
	
	private function buildAllDoctypes() {
		// $aStub = array(
		//		"current" => array(
		//				"doctypeId" => 588
		//				),
		//		"all" => array(
		//				588 => array(
		//						"title" 	=> "title",
		//						"fields"	=> array(
		//								"x1" => array(
		//										"title" => "STRUCTURA",
		//										"type"	=> "structure"	
		//										)
		//								)
		//						)
		//				)
		//		);
		//
		$oDtList 	= new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));
		$aDtList	= array(
				"current" => array(
						"doctypeId" => $this->Root->getAttribute("id")
						),
				"all" => array()
				);

		foreach ($oDtList->getAll() AS $aDt) {
			$aDtList["all"][$aDt["doctype_id"]] = array(
					"title" 		=> $aDt["title"],
					"description"	=> $aDt["description"],
					"fields"		=> array()
					);
			$oXw = new MSF_XmlWrapper($aDt["fields_xml"]);
			foreach ($oXw AS $sName => $oXwData) {
				$sType = $oXwData->getValue("type");
				if ($sType == "reference") {
					$aOptions 	 = $oXwData->getValue("optional");
					$sType 		.= $aOptions["reference"];
				}
				
				$aDtList["all"][$aDt["doctype_id"]]["fields"][$sName] = array(
						"type" 	=> $sType,
						"title" => $oXwData->getTitle()
						);

			}
			
		}

		$this->Template->getModule()->appendChild(
				$this->Template->createElement(
						"doctypes", 
						MSF_Json::encode($aDtList)
						)
				);
	}
	
	private function formSettingsXml($sXml)
	{
		$VM 		= new WF_VarManager();
		//$aSettings 	= MSF_Registry::get("MSF_Settings")->getXmlWrapper()->get("modules")->getValue("workflow");
		$aSettings 	= $VM->getValues();
		$Types 		= $this->Template->createElement("types");
		//debug($aSettings);
		foreach ($aSettings AS $k => $v) {
			$Item = $this->Template->createElement("item");
			$Item->setAttribute("name", strtolower($k));
			$Item->setAttribute("title", $this->Locale->getWord("WORKFLOW_" . strtoupper($k)));
			
			switch (strtolower($k)) {
				case "fields":
					$this->formFields($sXml, $Item);
					break;
			}
			
			if (!empty($v)) {
				foreach ($v AS $v2) {
					$InnerItem = $this->Template->createElement("item");
					$InnerItem->setAttribute("name", strtolower($v2["name"]));
					$InnerItem->setAttribute("show", strtolower($v2["show"]));
					$InnerItem->setAttribute("title", $this->Locale->getWord($v2["title"]));
					$Item->appendChild($InnerItem);
				}
			}
			
			$Types->appendChild($Item);
		}
		
		$this->Root->appendChild($Types);
	}
	
	private function formFields($sXml, $Root)
	{
		$Wrapper = new MSF_XmlWrapper($sXml);
		
		foreach ($Wrapper AS $Data) {
			$aValues = $Data->getValue();
			
			//if ($aValues["type"] == "structure") {
				//if (isset($aValues["optional"]["reference"])) {
					$Item = $this->Template->createElement("item");
					$Item->setAttribute("name", $Data->getName());
					$Item->setAttribute("type", $aValues["type"]);
					$Item->setAttribute("title", addslashes($Data->getTitle()));
					$Item->setAttribute("value", MSF_Json::encode($Data->getValue()));
					$Root->appendChild($Item);
				//}
			//}
		}
	}
	
	private function formActions($aActions)
	{
		$aTitles = array();
		foreach ($aActions as $iKey => $aAction) {
		   $aTitles[$iKey] = $aAction["title"];
		}
		
		asort($aTitles);
		$aTmpActions = array();
		foreach ($aTitles AS $iSpaId => $sTitle) {
			$aTmpActions[$iSpaId] = $aActions[$iSpaId];
		}
		
		$aActions= $aTmpActions;
		$Actions = $this->Template->createElement("actions");
		$this->Template->addLink("/modules/workflow/view/js/WF_AbstractForm.js", "text/javascript");
		
		for ($i = 0; $i < sizeof($aActions); $i++) {
			if (isset($aActions[$i]["spaJsClasspath"])) {
				$Item = $this->Template->createElement("item");
				$Item->setAttribute("id", 		$i);
				$Item->setAttribute("name", 	$aActions[$i]["name"]);
				$Item->setAttribute("title", 	$aActions[$i]["title"]);
				$Item->setAttribute("class", 	$aActions[$i]["spaJsClassname"]);
                                if(defined('CNF_USE_EDS')){
                                    $Item->setAttribute("use_eds",  CNF_USE_EDS);
                                } else {
                                    $Item->setAttribute("use_eds",  "0");
                                }
				$Actions->appendChild($Item);
				$this->Template->addLink($aActions[$i]["spaJsClasspath"], "text/javascript");
				
				$sPath = "modules/workflow/actions/" . $aActions[$i]["name"] . "/" . CNF_SKIN . "/back_spa.xsl";
				if (MSF_File::exists($sPath)) {
					$this->Template->addXslPath("/" . $sPath);
				}
                                }
			}
		
		$this->Root->appendChild($Actions);
		/*
		$aSort 		= array("edit", "notify", "decision", "move", "registration", "aktenplan", "control", "create", "record");
		$aTmpActs 	= array();
		$Actions 	= $this->Template->createElement("actions");
		$this->Template->addLink("/modules/workflow/view/js/WF_AbstractForm.js", "text/javascript");
		
		for ($j = 0; $j < count($aSort); $j++) {
			for ($i = 0; $i < count($aActions); $i++) {
				if ($aSort[$j] == $aActions[$i]["name"] && isset($aActions[$i]["spaJsClasspath"])) {
					$aTmpActs[] = $aActions[$i];
					break;
				}
			}
		}
		
		for ($i = 0; $i < count($aTmpActs); $i++) {
			$Item = $this->Template->createElement("item");
			$Item->setAttribute("id", 		$i);
			$Item->setAttribute("name", 	$aTmpActs[$i]["name"]);
			$Item->setAttribute("title", 	$aTmpActs[$i]["title"]);
			$Item->setAttribute("class", 	$aTmpActs[$i]["spaJsClassname"]);
			$Actions->appendChild($Item);
			$this->Template->addLink($aTmpActs[$i]["spaJsClasspath"], "text/javascript");
			
			$sPath = "modules/workflow/actions/" . $aTmpActs[$i]["name"] . "/" . CNF_SKIN . "/back_spa.xsl";
			if (MSF_File::exists($sPath)) {
				$this->Template->addXslPath("/" . $sPath);
			}
		}
		
		$this->Root->appendChild($Actions);
		*/
	}
	
	private function formSpa($Xml)
	{
		$Spa 	= $this->Template->createElement("spa");
		foreach ($Xml AS $Data) {
			
			$Item = $this->Template->createElement("item");
			$Item->setAttribute("spa_id", 	$Data->getName());
			$Item->setAttribute("title", 	addslashes($Data->getTitle()));
			$Item->setAttribute("description", 	addslashes($Data->getValue("description")));
			$Item->setAttribute("name", 	$Data->getValue("action"));
			$Item->setAttribute("value", 	MSF_JSON::encode($Data->getValue("value")));
			$Spa->appendChild($Item);
		}
		
		$this->Root->appendChild($Spa);
	}
	
	private function remindSettings () {
		$sContent  				= MSF_File::read(CNF_ABS_PATH . '/settings.xml');
		$this->oXmlWrapper		= new MSF_XmlWrapper();
		$aContent				= $this->oXmlWrapper->xmlToArray($sContent);
		$aSettings				= array();
		foreach ($aContent["modules"]["value"]["workflow"]["actions"] AS $Key => $sValue) {
			$SetKey				= $aContent["modules"]["value"]["workflow"]["actions"][$Key]["name"];
			if(isset($sValue["settings"])) {
				$aSettings[$SetKey]	= $sValue["settings"];
			}
			else {
				$aSettings[$SetKey]	= "";
			}
		}
		$this->Template->getModule()->appendChild(
				$this->Template->createElement(
						"remindcfg", 
						MSF_Json::encode($aSettings)
						)
				);
	}
	
	private function systemFields($sXml)
	{
		$Wrapper = new MSF_XmlWrapper();		
		$this->Template->getModule()->appendChild(
				$this->Template->createElement(
						"sysfields", 
						MSF_Json::encode($Wrapper->xmlToArray($sXml))
						)
				);
	}
}

?>