<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}

class FieldsXml extends MSF_ViewSupportXml
{
	public function editDoctypeFields($sXml, $bView = false)
	{
		// chtoby u staryh documentov byli vybrany vse tipy v pole document
		$oWrapper = new MSF_XmlWrapper($sXml);
		$aFields  = $oWrapper->getAsArray();
		foreach($aFields AS $Key => $Value) {
			if($Value["value"]["type"] == "document" && !isset($Value["value"]["optional"]["doctypes"])) {
				$DoctypeList = new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));
				$aList		 = $DoctypeList->getAll();
				foreach($aList as $aDoctype) {	
					$aFields[$Key]["value"]["optional"]["doctypes"][] = $aDoctype["doctype_id"];				
				}
						
			}
			
		}
		
		$oWrapper->clear();
		$oWrapper->import($aFields);
		$sXml = $oWrapper->getXml();
		//				
		if ($bView) {
			$this->Template->appendXmlString($this->Root, MSF_SL::slashXml($this->modifyTypes($sXml)));
			$this->Template->addXslPath("/modules/workflow/view/templates/" . CNF_SKIN . "/xsl/viewFields.xsl");
		}
		else {
			try {
				$this->Template->appendXmlString($this->Root, MSF_SL::slashXml($sXml));
			}
			catch (Exception $oException) {
				$this->addError($oException->getMessage());
				$Wrapper = new MSF_XmlWrapper();
				$this->Template->appendXmlString($this->Root, $Wrapper->getXml());
			}

			$this->Template->addXslPath("/modules/workflow/view/templates/" . CNF_SKIN . "/xsl/editFields.xsl");
		}

		$this->Template->addLink("/modules/references/view/js/REF_Field.js", "text/javascript");
		$this->Template->addLink("/modules/references/view/js/REF_TableField.js", "text/javascript");
		$this->Template->addLink("/modules/references/view/js/REF_FieldsController.js", "text/javascript");
		$this->Template->addLink("/modules/references/view/css/Fields.css", "text/css");
		$this->Template->addXslPath("/modules/references/view/templates/" . CNF_SKIN . "/editFieldsTemplates.xsl");
		$this->Template->addLink("/js/ext/calendar_date_select/js/calendar_date_select.js", "text/javascript");
		$this->Template->addLink("/js/ext/calendar_date_select/css/default.css", "text/css");
		$this->Template->addLink("/js/msf/date/DatePlaceholder.js", "text/javascript");
		$this->addLinksOf("references");
		$this->addLinksOf("structure");
	}

	public function setReferencesList($aList)
	{
		$References	= $this->Template->createElement("references");
		$this->Root->appendChild($References);
		foreach($aList as $aRow) {
			$Reference	= $this->Template->createElement("reference");
			$References->appendChild($Reference);
			$Reference->setAttribute("id", $aRow["reference_id"]);
			$Reference->setAttribute("name", addslashes($aRow["name"]));
			//$Columns	= $this->Template->createElement("columns");
			foreach($aRow["columns"] as $aColumn) {
				$Column	= $this->Template->createElement("column");
				$Reference->appendChild($Column);
				$Column->setAttribute("name", addslashes($aColumn["name"]));
				$Column->setAttribute("title", addslashes($aColumn["title"]));
			}

		}

	}
	
	public function setDoctypesList($aList)
	{
		$Doctypes	= $this->Template->createElement("doctypes");
		foreach($aList as $aDoctype) {
			$Doctype 	= $this->Template->createElement("doctype");
			$Doctypes->appendChild($Doctype);

			$Doctype->setAttribute("doctype_id", $aDoctype["doctype_id"]);
			$Doctype->setAttribute("title", addslashes($aDoctype["title"]));
		}

		$this->Root->appendChild($Doctypes);
	}	

	private function modifyTypes($sXml)
	{
		$Wrapper 	= new MSF_XmlWrapper($sXml);
		$NewWrapper = new MSF_XmlWrapper();
		foreach ($Wrapper as $Data) {
			$aValue = $Data->getValue();
			$aValue["type"] = $this->Locale->getWord("WORKFLOW_TYPE_" . strtoupper($aValue["type"]));
			$Data->setValue($aValue);
			$NewWrapper->set($Data->getName(), $aValue, $Data->getTitle());
		}

		return $NewWrapper->getXml();
	}
	public function applyEmplpyeeAndPostFields()
	{
		$this->Template
			 ->getModule()
			 ->setAttribute("employeeAndPostFields", MSF_Json::encode(
				 array("employee" 	=> MSF_RefUtils::getFieldsOfReference(2)),
				 array("post" 		=> MSF_RefUtils::getFieldsOfReference(3))
				 ));
	}

}