<?php
if(!defined("__MSF")) {
	die("Direct access is not allowed");
}
include_once "library/MSF_Recordset/MSF_RecordsetXml.php";
include_once "modules/main/library/orgStructure/MSF_OrgStructureFacade.php";

class WF_FolderXml extends MSF_RecordsetXml
{
	public function editFolder($aFolder, $aFolderDoctypes, $aDoctypes, $aGroups)
	{
		//debug($aFolder);
		$Folder	= $this->Template->createElement("folder");
		$this->Root->appendChild($Folder);

		$Folder->setAttribute("name", MSF_SL::getParam($aFolder, "name", ""));
		$Folder->setAttribute("description", MSF_SL::getParam($aFolder, "description", ""));
		$Folder->setAttribute("fullDescription", stripslashes(MSF_SL::getParam($aFolder, "full_description", "", true)));

		$FoldersDictypes	= $this->Template->createElement("foldersDoctypes");
		$Folder->appendChild($FoldersDictypes);

		foreach($aFolderDoctypes as $aDoctype) {
			$Doctype 	= $this->Template->createElement("doctype");
			$FoldersDictypes->appendChild($Doctype);

			$Doctype->setAttribute("doctype_id", $aDoctype["doctype_id"]);
			$Doctype->setAttribute("title", MSF_Registry::get("MSF_Locale")->getI18N($aDoctype["title"]));
		}


		$Doctypes	= $this->Template->createElement("doctypes");
		foreach($aDoctypes as $aDoctype) {
			$Doctype 	= $this->Template->createElement("doctype");
			$Doctypes->appendChild($Doctype);

			$Doctype->setAttribute("doctype_id", $aDoctype["doctype_id"]);
			$Doctype->setAttribute("title", MSF_Registry::get("MSF_Locale")->getI18N($aDoctype["title"]));
		}

		$this->Root->appendChild($Doctypes);

		$Groups	= $this->Template->createElement("groups");
		foreach($aGroups as $aGroup) {
			$Group	= $this->Template->createElement("group");
			$Groups->appendChild($Group);

			if($aGroup["group_id"] == $aFolder["group_id"]) {
				$Group->setAttribute("selected", 1);
			}

			$Group->setAttribute("group_id", $aGroup["group_id"]);
			$Group->setAttribute("name", $aGroup["name"]);
		}
		$this->Root->appendChild($Groups);


		$this->Template->addLink("/modules/workflow/view/js/WF_FoldersAdmin.js", "text/javascript");
		$this->Template->addLink("/modules/workflow/view/css/WF_FoldersAdmin.css", "text/css");
		$this->Template->addLink("/js/ext/scriptaculous/scriptaculous.js", "text/javascript");
	}
	
	public function editFolderFields($aFolder)
	{
		$Folder	= $this->Template->createElement("folder");
		$this->Root->appendChild($Folder);
		
		$this->Template->appendXmlString($Folder,  MSF_SL::slashXml(MSF_SL::getParam($aFolder, "fields_xml", "")));

		$this->Template->addLink("/modules/workflow/view/js/WF_FoldersAdmin.js", "text/javascript");
		$this->Template->addLink("/modules/workflow/view/css/WF_FoldersAdmin.css", "text/css");
		$this->Template->addLink("/js/ext/scriptaculous/scriptaculous.js", "text/javascript");
		$this->Template->addLink("/templates/default/styles/fields.css", "text/css");
		$this->Template->addLink("/modules/references/view/css/Fields.css", "text/css");
	}

	public function compare($sFolderXml, $sComparedXml, $aDoctypes)
	{
		$FolderXml		= new MSF_XmlWrapper($sFolderXml);
		$ComparedXml	= new MSF_XmlWrapper($sComparedXml);
		$Folder			= $this->Template->createElement("doctype");
		$aCompared		= array();
		
		
		$this->Root->appendChild($Folder);
		//echo $sComparedXml;
		foreach($FolderXml as $Field) {
			$aValues	= $Field->getValue();
			
			if($aValues["static"] == 1) {
				continue;
			}
			
			$Element	= $this->Template->createElement("element");

			
			$Element->setAttribute("title", MSF_Registry::get("MSF_Locale")->getI18N($Field->getTitle()));
			$Element->setAttribute("type", $aValues["type"]);
			$Element->setAttribute("word", $this->getType($aValues["type"]));
			$Element->setAttribute("name", $Field->getName());
			$Folder->appendChild($Element);

			$Compared	= $ComparedXml->get($Field->getName());
			$Compared	= $Compared->getValue();
			
			if($Compared) {
				foreach($Compared as $FieldXml) {
					if($aValues["type"] == $this->getDoctypeFieldType($FieldXml, $aDoctypes)) {
						$Field	= $this->Template->createElement("field");
						$Field->setAttribute("type", $aValues["type"]);
						$Field->setAttribute("word", $this->getType($aValues["type"]));
						$Field->setAttribute("name", $FieldXml["name"]);
						$Field->setAttribute("version", $FieldXml["doctype_id"]);
	
						
						$aCompared[$FieldXml["name"]][$FieldXml["doctype_id"]]	= $Field;
						$Element->appendChild($Field);
					}
					
				}

			}

		}

				
		$Versions	= $this->Template->createElement("versions");
		$this->Root->appendChild($Versions);

		foreach($aDoctypes as $aDoctype) {
			$Item	= $this->Template->createElement("item");
			$Item->setAttribute("title", MSF_Registry::get("MSF_Locale")->getI18N($aDoctype["title"]));
			$Item->setAttribute("version", $aDoctype["doctype_id"]);
			$Item->setAttribute("id", $aDoctype["doctype_id"]);
			$Versions->appendChild($Item);
			
			
			$FieldsXml	= new MSF_XmlWrapper($aDoctype["fields_xml"]);
			
			foreach($FieldsXml as $FieldXml) {
				$sTitle = $this->Locale->getWord($FieldXml->getTitle());
				if(isset($aCompared[$FieldXml->getName()]) && isset($aCompared[$FieldXml->getName()][$aDoctype["doctype_id"]])) {
					$aCompared[$FieldXml->getName()][$aDoctype["doctype_id"]]->setAttribute("title", MSF_Registry::get("MSF_Locale")->getI18N($sTitle));
				}
				else {
					$aValues	= $FieldXml->getValue();
					$Field		= $this->Template->createElement("field");
                                        //дописать перевод системных полей
                                        switch ($sTitle) {
                                            case "АВТОР":
                                                $sTitle = MSF_Registry::get("MSF_Locale")->getWord("LABEL_VAR_AUTHOR");
                                                break;
                                            case "ДАТА СОЗДАНИЯ":
                                                $sTitle = MSF_Registry::get("MSF_Locale")->getWord("LABEL_VAR_CREATED_AT");
                                                break;
                                            case "ДАТА/ВРЕМЯ ИЗМЕНЕНИЯ":
                                                $sTitle = MSF_Registry::get("MSF_Locale")->getWord("LABEL_VAR_MODIFIED_AT");
                                                break;
                                            case "СОСТОЯНИЕ":
                                                $sTitle = MSF_Registry::get("MSF_Locale")->getWord("LABEL_VAR_STATUS");
                                                break;
                                            case "ТИП ДОКУМЕНТА":
                                                $sTitle = MSF_Registry::get("MSF_Locale")->getWord("LABEL_VAR_DOCTYPE");
                                                break;
                                            case "ПОДРАЗДЕЛЕНИЕ":
                                                $sTitle = MSF_Registry::get("MSF_Locale")->getWord("LABEL_VAR_SUBDIVISION");
                                                break;
                                                   
                                        }
                                        if($sTitle == "АВТОР") {
                                            
                                        }
                                        $Field->setAttribute("title", MSF_Registry::get("MSF_Locale")->getI18N($sTitle));
					//$Field->setAttribute("title", $FieldXml->getTitle());
					$Field->setAttribute("type", $aValues["type"]);
					$Field->setAttribute("word", $this->getType($aValues["type"]));
					$Field->setAttribute("name", $FieldXml->getName());
					$Field->setAttribute("version", $aDoctype["doctype_id"]);
	
					$Item->appendChild($Field);
				}
				
			}

		}

		$this->Template->addLink("/modules/workflow/view/js/WF_DoctypeCompare.js", "text/javascript");
		$this->Template->addLink("/js/ext/scriptaculous/effects.js", "text/javascript");
		$this->Template->addLink("/js/ext/scriptaculous/dragdrop.js", "text/javascript");
		$this->Template->addLink("/js/ext/scriptaculous/controls.js", "text/javascript");
		//$this->Template->addLink("/modules/workflow/view/templates/" . CNF_SKIN . "/css/doctype_compare.css", "text/css");
		$this->Template->addLink("/modules/workflow/view/css/doctypeCompare.css", "text/css");
		$this->Template->addXslPath("/modules/workflow/view/templates/" . CNF_SKIN . "/doctype_compare.xsl");
	}
	
	private function getType($sSourceType)
	{
		return $this->Locale->getWord("WORKFLOW_TYPE_" . strtoupper($sSourceType));
	}
	
	public function changeAccess($aData)
	{
		$aReady	= array();
		foreach($aData as $aRow) {
			if(!isset($aReady[$aRow["group_id"]])) {
				$aReady[$aRow["group_id"]] = array(
					"can_view"	=> $aRow["can_view"],
					"structure"	=> array()
				);
			}

			$aReady[$aRow["group_id"]]["structure"][] = $aRow["structure_id"];
		}
		
		$Access	= $this->Template->createElement("access");
		$this->Root->appendChild($Access);
		$iCount	= 0;
		foreach($aReady as $aRow) {
			$aRow["structure"] = MSF_OrgStructureFacade::getInstance()->strIdsToRefValue($aRow["structure"]);
			$Item	= $this->Template->createElement("item");
			$Item->setAttribute("id", $iCount);
			$Access->appendChild($Item);
			
			foreach($aRow as $n=>$k) {
				$Item->setAttribute($n, $k);
			}
			
			$iCount++;
		}
		
		$this->addTemplate("/modules/workflow/view/templates/default/xsl/accessFolders.xsl");
		$this->Template->addLink("/js/msf/element/MSF_ElementAdder.js", "text/javascript");
		$this->addLinksOf("structure");
	}

	private function getDoctypeFieldType($aField, $aDoctypes)
	{
		$iDoctypeId	= $aField["doctype_id"];
		$sName		= $aField["name"];
		$sType		= "none";
		
		foreach($aDoctypes as $aDoctype) {
			if($aDoctype["doctype_id"] == $iDoctypeId) {
				$FieldsXml	= new MSF_XmlWrapper($aDoctype["fields_xml"]);
				
				foreach($FieldsXml as $FieldXml) {
					if($sName == $FieldXml->getName()) {
						$aValues	= $FieldXml->getValue();
						$sType		= $aValues["type"];
						break;
					}
										
				}
				
			}
			
		}
		
		return $sType;
	}
	
}
?>