<?php
defined("__MSF") or die("Direct access is not allowed");

include_once "modules/workflow/library/actions/WF_ActionBox.php";

class WF_RouteXml extends MSF_ViewSupportXml
{
	private $oModule 	= null;

	private $aModulesLinks = array (
			"references",
			"structure"
			);

	private $aLinks = array (
			"/modules/workflow/view/templates/default/css/route.css" 	=> "text/css",
			"/modules/workflow/view/js/WF_Utils.js" 		 			=> "text/javascript",
			"/modules/workflow/view/js/WF_ModifyClonedForm.js" 			=> "text/javascript",
			"/modules/workflow/view/js/WF_Point.js" 				 	=> "text/javascript",
			"/modules/workflow/view/js/WF_Route.js" 					=> "text/javascript",
			"/modules/workflow/view/js/WF_DelegationContext.js" 	 	=> "text/javascript",
			"/modules/workflow/view/js/WF_ExecutionContext.js" 	 		=> "text/javascript",
			"/modules/workflow/view/js/WF_WaitingContext.js" 	 		=> "text/javascript",
			"/modules/workflow/view/js/WF_Address.js" 		 			=> "text/javascript",
			"/modules/workflow/view/js/WF_AbstractExecution.js" 		=> "text/javascript",
			"/js/msf/date/DatePlaceholder.js"							=> "text/javascript",
			"/js/ext/calendar_date_select/js/calendar_date_select.js"	=> "text/javascript",
			"/js/ext/calendar_date_select/css/default.css"				=> "text/css"
		);
				
	public function initialize()
	{
		$this->oModule = $this->Template->getModule();
	}

	public function initLinks()
	{
		foreach ($this->aLinks AS $sLinkName => $sLinkType) {
			$this->Template->addLink($sLinkName, $sLinkType);
		}
		foreach ($this->aModulesLinks AS $sLinksName) {
			$this->addLinksOf($sLinksName);
		}
		
	}

	public function initTemplate($bView = false)
	{
		if ($bView) {
			$this->Template->addXslPath("/modules/workflow/view/templates/" . CNF_SKIN . "/doctype_router_view.xsl");
		}
		else {
			$this->Template->addXslPath("/modules/workflow/view/templates/" . CNF_SKIN . "/xsl/route.xsl");
		}

	}

	public function initRoute($sRouteXml)
	{
		$aRoute	= MSF_XmlWrapper::xmlToArray($sRouteXml);
		$oRoute = $this->Template->createElement("route", MSF_JSON::encode($aRoute));
		$this->oModule->appendChild($oRoute);
	}

	public function initRouteActions()
	{
		$aExecute = array();
		$oWfaTpls = $this->Template->createElement("wfa-tpls");
		$this->oModule->appendChild($oWfaTpls);
		
		foreach (WF_ActionBox::newInstance()->getCfg() AS $iActionId => $aCfg) {
			if ($aCfg["hasRoute"]) {
				$aExecute[($iActionId + 1)] = array(
						"name"	=> $aCfg["name"],
						"title" => "WFA_" . strToUpper($aCfg["name"])
						);
				$this->Template->addXslPath($aCfg["routePath"]);
				$oWfaTpl = $this->Template->createElement($aCfg["name"]);
				$oWfaTpls->appendChild($oWfaTpl);
				
				if (file_exists(CNF_ABS_PATH . "/modules/workflow/actions/" . $aCfg["name"] . "/" . CNF_SKIN . "/WF_" . ucfirst($aCfg["name"]) . "Execution.js")) {
					$this->Template->addLink("/modules/workflow/actions/" . $aCfg["name"] . "/" . CNF_SKIN . "/WF_" . ucfirst($aCfg["name"]) . "Execution.js", "text/javascript");
				}

			}

		}

		$oExc = $this->Template->createElement("execution", MSF_JSON::encode($aExecute));
		$this->oModule->appendChild($oExc);
	}

	public function initSpaActions($aSpaCfg)
	{
		$aTitles = array();
		foreach ($aSpaCfg as $iKey => $aAction) {
		   $aTitles[$iKey] = $aAction["title"];
		}
		
		asort($aTitles);
		$aTmpSpa = array();
		//$aTmpSpa[""] = array("title"=>"Не выбрано");
		foreach ($aTitles AS $iSpaId => $sTitle) {
			$aTmpSpa[$iSpaId] 					= $aSpaCfg[$iSpaId];
			$aTmpSpa[$iSpaId]["name"] 			= $aSpaCfg[$iSpaId]["value"]["action"];
			$aTmpSpa[$iSpaId]["value"]["name"]	= $aSpaCfg[$iSpaId]["value"]["action"];
			$aTmpSpa[$iSpaId]['chars_title'] 	= str_replace("&","&amp;",htmlspecialchars($aTmpSpa[$iSpaId]['title']));
		}

		$oSpa = $this->Template->createElement("spa", MSF_JSON::encode($aTmpSpa));
		$this->oModule->appendChild($oSpa);
	}

	public function initAddress($oDoctypeVersion)
	{
		$aAddressCfg = array (
				"structure" => array(
						"title"		=> $this->getWord("STRUCTURE_MODULE_NAME")
						),
				"groups" => array(
						"title"		=> $this->getWord("WORKFLOW_GROUPS")
						),
				"vars" => array (
						"title"		=> $this->getWord("WORKFLOW_VARIABLES"),
						"options" 	=> array(
								"author"	=> $this->getWord("WORKFLOW_VAR_AUTHOR"),
								"all" 		=> $this->getWord("WORKFLOW_VAR_ALL"),
								"any" 		=> $this->getWord("WORKFLOW_VAR_ANY")
								)

						)

				);
		$aFields = $this->getFields($oDoctypeVersion);
		if (count($aFields) > 0) {
			$aAddressCfg["fields"] = array (
						"title"		=> $this->getWord("WORKFLOW_FIELDS"),
						"options" 	=> $aFields
						);
		}

		$oAddress = $this->Template->createElement("address", MSF_JSON::encode($aAddressCfg));
		$this->oModule->appendChild($oAddress);
	}

	public function initFields($oDoctypeVersion)
	{
		$aFields = array();
		foreach (MSF_XmlWrapper::xmlToArray($oDoctypeVersion->getFieldsXml()) AS $sName => $aBody) {
			$aFields[] = array(
					"name"	=> $sName,
					"type" 	=> $aBody["value"]["type"] ,
					"title" => $aBody["title"],
					"value" => $aBody["value"]
					);

		}

		//$oFieldsXml		= MSF_SL::hashlist2dom("xml", "field", $aFields, "tags");
		$oFieldsJson 	= $this->Template->createElement("json", MSF_JSON::encode($aFields));
		$oFields 		= $this->Template->createElement("fields");
		$oFields->appendChild($oFieldsJson);
		//$oFields->appendChild($oFieldsXml);
		$this->oModule->appendChild($oFields);
	}
	
	private function getFields($oDoctypeVersion)
	{
		$aFields = array();
		foreach (MSF_XmlWrapper::xmlToArray($oDoctypeVersion->getFieldsXml()) AS $sName => $aBody) {
			if ($aBody["value"]["type"] == "structure") {
				$aFields[$sName] = $aBody["title"];
			}
		}
		return $aFields;
	}
	
	public function injectAllDoctypes() {
		$oDtList 	= new WF_DoctypesList(new WF_DoctypesListDB(MSF_Registry::get("MSF_DB")));
		$aDtList	= array(
				"current" => array(
						"doctypeId" => $this->Root->getAttribute("id")
						),
				"all" => array()
				);

		foreach ($oDtList->getAll() AS $aDt) {
			$aDtList["all"][$aDt["doctype_id"]] = array(
					"title" 		=> $aDt["title"],
					"description"	=> $aDt["description"],
					"fields"		=> array()
					);

			$oXw = new MSF_XmlWrapper($aDt["fields_xml"]);
			foreach ($oXw AS $sName => $oXwData) {
				$sType = $oXwData->getValue("type");
				if ($sType == "reference") {
					$aOptions 	 = $oXwData->getValue("optional");
					$sType 		.= $aOptions["reference"];
				}
				
				$aDtList["all"][$aDt["doctype_id"]]["fields"][$sName] = array(
						"type" 	=> $sType,
						"title" => $oXwData->getTitle()
						);

			}
			
		}
	
		$this->Template->getModule()->appendChild(
				$this->Template->createElement(
						"doctypes", 
						MSF_Json::encode($aDtList)
						)
				);
	}
	
	public function remindSettings () {
		$sContent  				= MSF_File::read(CNF_ABS_PATH . '/settings.xml');
		$this->oXmlWrapper		= new MSF_XmlWrapper();
		$aContent				= $this->oXmlWrapper->xmlToArray($sContent);
		$aSettings				= array();
		foreach ($aContent["modules"]["value"]["workflow"]["actions"] AS $Key => $sValue) {
			$SetKey				= $aContent["modules"]["value"]["workflow"]["actions"][$Key]["name"];
			if(isset($sValue["settings"])) {
				$aSettings[$SetKey]	= $sValue["settings"];
			}
			else {
				$aSettings[$SetKey]	= "";
			}
		}
		$this->Template->getModule()->appendChild(
				$this->Template->createElement(
						"remindcfg", 
						MSF_Json::encode($aSettings)
						)
				);
	}
	
	public function formSystemFields($sXml)
	{
		$Wrapper = new MSF_XmlWrapper();		
		$this->Template->getModule()->appendChild(
				$this->Template->createElement(
						"sysfields", 
						MSF_Json::encode($Wrapper->xmlToArray($sXml))
						)
				);
	}	

}

?>