<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:template match="/page/msfx/actionbar">
		<xsl:if test="links-left/link or dropdowns-left/dropdown or links-right/link or dropdowns-right/dropdown">
			<div class="block contextbar">
				<div class="contextbar-left">
                    <!-- applet cache_option="Yes" name ="cpapplet" code="hedin.cryptopro.applet.AppletClass" codebase="/japp" archive="/japp/cpapplet.jar"
                                                width="1" height="1">
                        <div id="no_java_err"><xsl:value-of select="$JAPP_ERROR_RUN"/>
                        </div>
                    </applet -->
					<ul class="contextbar-actionbar">
					<xsl:for-each select="dropdowns-left/dropdropdown">
							<li onclick="{@onclick}" id="{@id}" class="contextbar-actionbar-preitem">
								<img src="/templates/default/images/ext_actions_pc.png"/>								
								<ul id="{@itembar_id}" onMouseOver="{@onMouseOver}" class="contextbar-actionbar-dropitembar">
									<xsl:for-each select="dropdown">
										<li class="contextbar-actionbar-subitem">
											<a href="{@url}" id="{@id}" title="{@description}" class="contextbar-actionbar-sublink"><xsl:value-of select="@title"/></a>											
											<ul class="contextbar-actionbar-subitembar">
												<xsl:for-each select="element">
													<li onclick="document.location.href &#61; &quot;{@url}&quot;" class="contextbar-actionbar-subitem">
														<a href="#" id="{@id}" title="{@description}" class="contextbar-actionbar-sublink"><xsl:value-of select="@title"/></a>
													</li>
												</xsl:for-each>
											</ul>
										</li>
									</xsl:for-each>
								</ul>
							</li>	
						</xsl:for-each>
						<xsl:for-each select="dropdowns-left/dropdown">
							<li class="contextbar-actionbar-item">						
								<a title="{@help}" href="#" onclick="{@onclick}" id="{@id}" class="contextbar-actionbar-link"><xsl:value-of select="@title"/></a>
								<br/>
								<ul class="contextbar-actionbar-itembar">
									<xsl:for-each select="element">
										<li onclick="document.location.href &#61; &quot;{@url}&quot;" class="contextbar-actionbar-subitem">
											<a href="#" id="{@id}" title="{@description}" class="contextbar-actionbar-sublink"><xsl:value-of select="@title"/></a>
										</li>
									</xsl:for-each>
								</ul>						
							</li>
						</xsl:for-each>
						<xsl:for-each select="links-left/link">
							<xsl:choose>
								<xsl:when test="@selected='false'">
									<li class="contextbar-actionbar-item">
										<a title="{@help}" href="{@url}" id="{@id}" onclick="{@onclick}" class="contextbar-actionbar-link"><xsl:value-of select="@title"/></a>
									</li>
								</xsl:when>
								<xsl:otherwise>
									<li class="contextbar-actionbar-item-selected">
										<span class="contextbar-actionbar-link"><xsl:value-of select="@title"/></span>
									</li>
								</xsl:otherwise>
							</xsl:choose>				
						</xsl:for-each>
					</ul>
				</div>
				
				<div class="contextbar-right">
					<ul class="contextbar-actionbar">
						<xsl:for-each select="dropdowns-right/dropdown">
							<li class="contextbar-actionbar-item">						
								<a title="{@help}" href="#" onclick="{@onclick}" id="{@id}" class="contextbar-actionbar-link"><xsl:value-of select="@title"/></a>
								<br/>
								<ul class="contextbar-actionbar-itembar">
									<xsl:for-each select="element">
										<li onclick="document.location.href &#61; &quot;{@url}&quot;" class="contextbar-actionbar-subitem">
											<a href="#" id="{@id}" title="{@description}" class="contextbar-actionbar-sublink"><xsl:value-of select="@title"/></a>
										</li>
									</xsl:for-each>
								</ul>						
							</li>
						</xsl:for-each>
						<xsl:for-each select="links-right/link">
							<xsl:choose>
								<xsl:when test="@selected='false'">
									<li class="contextbar-actionbar-item">
										<a title="{@help}" href="{@url}" id="{@id}" onclick="{@onclick}" class="contextbar-actionbar-link"><xsl:value-of select="@title"/></a>
									</li>
								</xsl:when>
								<xsl:otherwise>
									<li class="contextbar-actionbar-item-selected">
										<span class="contextbar-actionbar-link"><xsl:value-of select="@title"/></span>
									</li>
								</xsl:otherwise>
							</xsl:choose>				
						</xsl:for-each>
					</ul>
				</div>
			</div>
		</xsl:if>
		<xsl:if test="dropdowns-left/dropdropdown">
			<script>
				var oHtml		= $$("html")[0];
				var oABButton	= $('<xsl:value-of select="dropdowns-left/dropdropdown/@id"/>');				
				
				if (oABButton) {
					oHtml.observe("click", hideExtMenu.bindAsEventListener());
					oABButton.observe("click", buttonClick.bindAsEventListener());	
				}
							
				
				function hideExtMenu(e)
				{
					var oTarget	= e.target;
					var oMenu	= $('<xsl:value-of select="dropdowns-left/dropdropdown/@itembar_id"/>');										
					var ret		= false;
					while(oTarget) {
						if((oTarget == oMenu) || (oTarget == oABButton)) {
							ret	= true;
							break;
						}
						
						oTarget	= oTarget.parentNode;
					}
					
					if(!e || !ret) {
						var oHtml	= $$("html")[0];						
						oMenu.style.display = "none";
						oHtml.stopObserving("click", hideExtMenu.bindAsEventListener());
					}
										
				}
				
				function buttonClick()
				{
					var oButton				= $('<xsl:value-of select="dropdowns-left/dropdropdown/@id"/>');
					var oMenu				= $('<xsl:value-of select="dropdowns-left/dropdropdown/@itembar_id"/>');
					var aCoords				= oButton.viewportOffset();
					oMenu.style.left		= aCoords[0] + "px";
					oMenu.style.top			= aCoords[1] + "px";
					oMenu.style.marginTop	= "25px";
					if(oMenu.style.display &amp;&amp; oMenu.style.display != "none") {
						oMenu.style.display = "none";							
					}
					else {
						oMenu.style.display="block";
					}
					
				}			
			</script>
		</xsl:if>		
	</xsl:template>
</xsl:stylesheet>