<?php
if (!defined("__MSF")) {
    exit("Direct access is not allowed");
}

include_once "library/MSF_AuthenticationFactory.php";

class MSF_AuthenticationExtension extends MSF_MsfxSupport
{
     public function execute($isRedirectable = true, $isAjax = false)
     {
     	$aConfig 	= $this->getconfig();
     	$oAuth		= MSF_AuthenticationFactory::create($aConfig);
        MSF_Registry::set("MSF_Authentication", $oAuth);
        if ($oAuth->isLogout()) {
            $oAuth->logout();
        }

        if (!$oAuth->verify()) {
            if ($oAuth->isLogin()) {
                list($sLogin, $sPassword) = $oAuth->getLoginAndPassword();
                $iId = $oAuth->login($sLogin, $sPassword, $isRedirectable);
                if ($iId && $isRedirectable) {
                    $oAuth->redirectById($iId);
                    exit();
                }
				
            }
            if ($oAuth->isGetLogin()) {
                list($sLogin, $sPassword) = $oAuth->getLoginAndPassword(true, $oAuth->getSecret());
                $iId = $oAuth->login($sLogin, $sPassword, $isRedirectable, false);
                if ($iId && $isRedirectable) {
                    $oAuth->redirectById($iId);
                    exit();
                }
            }
            if (!$isAjax) {
                $oAuth->render();
            }
		}
		elseif (($oAuth->getUri() == "/") && $isRedirectable) {
            $oAuth->redirectByUri();
        }

    }

     private function getConfig()
     {
     	$oXw		= MSF_Registry::get("MSF_Settings")->getXmlWrapper();
     	$aConfig 	= $oXw->get("extensions")->getValue("authentication");
        return $aConfig["settings"];
    }


     
}

?>
