<?php

defined("__MSF") or die("Direct access is not allowed");

class MSF_AuthenticationDB
{
	private $DB;
	
	public function __construct(MSF_DB $DB)
	{
		$this->DB = $DB;
	}
	
	public function getUserIdByLogin($sLogin)
	{
		$sSql = "SELECT\n" .
					"id\n" .
				"FROM\n" .
					"ref_system_users\n" .
				"WHERE\n" .
					"login = '" . $sLogin . "'";
		$aResult = $this->DB->select($sSql); 
		if (count($aResult) == 0) {
			return 0;
		}
		else {
			return $aResult[0]["id"];
		}

	}
	
	public function exists($iUserId)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"users_sessions\n" .
				"WHERE\n" .
					"user_id = " . $iUserId;
		
		return $this->DB->select($sSql, true, "total");
	}
	
	public function insert($iUserId, $sSessionId)
	{
		$sSql = "INSERT INTO\n" .
					"users_sessions\n" .
				"(\n" .
					"user_id,\n" .
					"session_id\n" .
				")\n" .
				"values(\n" .
					$iUserId . ",\n" .
					"'" . $sSessionId . "'\n" .
				")";
		
		$this->DB->executeQuery($sSql);
	}
	
	public function update($iUserId, $sSessionId)
	{
		$sSql = "UPDATE\n" .
					"users_sessions\n" .
				"SET\n" .
					"session_id = '" . $sSessionId . "'\n" .
				"WHERE\n" .
					"user_id = " . $iUserId;
		
		$this->DB->executeQuery($sSql);
	}
	
	public function insertLog($iUserId, $sIpAddress, $iTime)
	{
		$sSql = "INSERT INTO\n" .
					"users_logs\n" .
				"(\n" .
					"user_id,\n" .
					"ip_address,\n" .
					"logged_at" .
				")\n" .
				"values(\n" .
					$iUserId . ",\n" .
					"'" . $sIpAddress . "',\n" .
					$iTime . "\n" .
				")";
		
		$this->DB->executeQuery($sSql);
	}
	
	public function verify($sSessionId)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"users_sessions\n" .
				"WHERE\n" .
					"session_id = '" . $sSessionId . "'";
		
		return $this->DB->select($sSql, true, "total");
	}
	
	public function delete($iUserId)
	{
		$sSql = "DELETE\n" .
				"FROM users_sessions\n" .
				"WHERE\n" .
					"user_id = " . $iUserId;
		$this->DB->executeQuery($sSql);
	}
	
	public function checkLostUsersDB()
	{
                $sSql = "SELECT  count(*)  FROM  information_schema.columns  WHERE  table_name  =  'lost_users'";
                $aResult = $this->DB->select($sSql);
                if($aResult[0]["count"] == 4){
                    $sSql = "DROP  TABLE  lost_users";
                    $this->DB->executeQuery($sSql);
                    
                    $sSql = "CREATE TABLE lost_users (\n" .
						"id integer DEFAULT nextval('lost_users_id_seq'::regclass) NOT NULL,\n" . 
						"login character varying,\n" . 
						"secret character varying,\n" .
                                                "params character varying, \n" .
						"changed_at timestamp without time zone)";
			$this->DB->executeQuery($sSql);
                }
                
		$sSql = "SELECT COUNT(tablename) FROM pg_tables WHERE tablename='lost_users'";
		$aResult = $this->DB->select($sSql);
		if ($aResult[0]["count"] == 0) {
			$sSql = "CREATE SEQUENCE lost_users_id_seq\n" . 
					"INCREMENT BY 1\n" . 
					"NO MAXVALUE\n" .
					"NO MINVALUE\n" . 
					"CACHE 1";
			$this->DB->executeQuery($sSql);
			$sSql = "ALTER TABLE lost_users_id_seq\n" . 
					"OWNER TO postgres";
			$this->DB->executeQuery($sSql);
			$sSql = "CREATE TABLE lost_users (\n" .
						"id integer DEFAULT nextval('lost_users_id_seq'::regclass) NOT NULL,\n" . 
						"login character varying,\n" . 
						"secret character varying,\n" .
                                                "params character varying, \n" .
						"changed_at timestamp without time zone)";
			$this->DB->executeQuery($sSql);
		}
	}
	
	public function insertLostUser($sLogin, $sSecret)
	{
		$sSql = "INSERT INTO\n" .
				"lost_users\n" .
				"(\n" .
					"login,\n" .
					"secret,\n" .
					"changed_at" .
				")\n" .
				"VALUES(\n" .
					"'" . $sLogin . "',\n" .
					"'" . $sSecret . "',\n" .
					"'today'::timestamp\n" .
				")";
		
		$this->DB->executeQuery($sSql);
	}
        
        public function insertSecretParams($sLogin, $sSecret, $sParams){
            $sSql = "INSERT INTO\n" .
				"lost_users\n" .
				"(\n" .
					"login,\n" .
					"secret,\n" .
                                        "params, \n" .
					"changed_at" .
				")\n" .
				"VALUES(\n" .
					"'" . $sLogin . "',\n" .
					"'" . $sSecret . "',\n" .
                                        "'" . $sParams . "',".
					"'today'::timestamp\n" .
				")";
		
		$this->DB->executeQuery($sSql);
        }
	
	public function newLostUser($sLogin)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"lost_users\n" .
				"WHERE\n" .
					"login = '" . $sLogin . "' AND changed_at > 'yesterday'::timestamp";
		return $this->DB->select($sSql, true, "total");
	}
	
	public function deleteOldLostUsers()
	{
               // проверяем - есть ли пользователи с устаревшими ключами для удаления
                $sSql = "SELECT\n" .
                "id\n" .
                "FROM\n" .
                "lost_users\n" .
                "WHERE\n" .
                "changed_at < 'today'::timestamp";
            $aResult = $this->DB->select($sSql);
            if (count($aResult) > 0) {//есть что почистить
                // чистим таблицу 
                $sSql = "DELETE\n" .
                    "FROM lost_users\n" .
                    "WHERE\n" .
                    "changed_at < 'today'::timestamp";
                $this->DB->executeQuery($sSql);
                // чистим кэш; это нужно для удаления секретных ключей из закешированных
                // полей файлового типа
                $oDir = new MSF_Dir();
                $oDir->cleanDirectory($_SERVER['DOCUMENT_ROOT'] . "/var/docs"); 
            }
	}
	
	public function loginExists($sLogin)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"ref_system_users\n" .
				"WHERE\n" .
					"login = '" . $sLogin . "'";
		
		return $this->DB->select($sSql, true, "total");		
	}
	
	
	public function secretExists($sSecret)
	{
		$sSql = "SELECT\n" .
					"COUNT(*) AS total\n" .
				"FROM\n" .
					"lost_users\n" .
				"WHERE\n" .
					"secret = '" . $sSecret . "'";
		return $this->DB->select($sSql, true, "total");		
	}
	
	public function getEmail($sLogin)
	{
		$sSql = "SELECT\n" .
					"email\n" .
				"FROM\n" .
					"ref_system_users\n" .
				"WHERE\n" .
					"login = '" . $sLogin . "'";
		
		return $this->DB->select($sSql, true, "email");			
	}
	
	public function getPassword($sLogin)
	{
		$sSql = "SELECT\n" .
					"password\n" .
				"FROM\n" .
					"ref_system_users\n" .
				"WHERE\n" .
					"login = '" . $sLogin . "'";
		
		return $this->DB->select($sSql, true, "password");			
	}
		
	public function getLogin($sSecret)
	{
		$sSql = "SELECT\n" .
					"login\n" .
				"FROM\n" .
					"lost_users\n" .
				"WHERE\n" .
					"secret = '" . $sSecret . "'";
		
		return $this->DB->select($sSql, true, "login");		
	}
        
        	public function getSessionId($sUserId)
	{
		
        		$sSql = "SELECT\n" .
					"session_id\n" .
				"FROM\n" .
					"users_sessions\n" .
				"WHERE\n" .
					"user_id = " . $sUserId;            
                    
		return $this->DB->select($sSql, true, "session_id");		
	}
	
}

?>