<?php
if (!defined("__MSF")) {
	exit("Direct access is not allowed");
}

include_once "MSF_AuthenticationDB.php";
include_once "MSF_LocalAuthentication.php";
include_once "MSF_LdapAuthentication.php";
include_once "MSF_NtlmAuthentication.php";
require_once "msfx/last_url/library/MSF_LastUrl.php";

class MSF_AuthenticationFactory
{
	/**
	 * @return MSF_AbstractAuth
	 */
	public static function create($aConfig, $isRedirectable = true)
	{
   	switch ($aConfig["login_type"]) {
     		case "MSF":
     			return new MSF_LocalAuthentication($aConfig, $isRedirectable);
     			break;
        	case "LDAP":
        		return new MSF_LdapAuthentication($aConfig);
     			break;
        	case "LDAP-SSO":
        		return new MSF_NtlmAuthentication($aConfig);
     			break;
        	default:
        		throw new MSF_ThrowableException("Authentication type not setted");
        		break;
     		
     	}

	}

}

?>