<?php
if (!defined("__MSF")) {
	exit("Direct access is not allowed");
}

include_once "MSF_AbstractAuth.php";
include_once "MSF_LocalAuthentication.php";
class MSF_LdapAuthentication extends MSF_LocalAuthentication
{

	public function login($sLogin, $sPassword)
	{
		$iUserId = 0;
		if ($this->ldapLogin($sLogin, $sPassword)) {
			$iUserId = $this->oAuthDb->getUserIdByLogin($sLogin);
		}

		$this->loginById($iUserId);
		return $iUserId;
	}
	
	protected function ldapLogin($sUser, $sPassword)
	{
	    $rConnection 	= $this->ldapConnect();
	    $sUsername		= $sUser . "@" . $this->aConfig["ldap_domain"];
	    $bBind			= $this->ldapBind($rConnection, $sUsername, $sPassword);
		@ldap_close($rConnection);
    	return $bBind;
	} 
	
	protected function ldapConnect()
	{
		$rConnection = ldap_connect($this->aConfig["ldap_host"], $this->aConfig["ldap_port"]);
		ldap_set_option ($rConnection, LDAP_OPT_PROTOCOL_VERSION, 3);
		ldap_set_option ($rConnection, LDAP_OPT_REFERRALS, 0);
    	return $rConnection;
	} 
	
	protected function ldapBind($rConnect, $sUsername, $sPassword)
	{
	    try {
	    	if (strlen($sPassword) > 0) {
	    		$bBind 	= @ldap_bind($rConnect, $sUsername, $sPassword);
	    	}
	    	else {
	    		$bBind  = false;
	    	}
	    }
    	catch (Exception $oE) {
    		MSF_Logger::logTrace($oE);
    		$bBind 	= false;
    	}
    	
    	return $bBind;
	}
	
}

?>