<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "MSF_AbstractAuth.php";
include_once "modules/lms/library/LMS_MailDB.php";
include_once "modules/lms/library/LMS_Mail.php";

class MSF_LocalAuthentication extends MSF_AbstractAuth
{
	/**
	 * @var MSF_AuthenticationDB
	 */
	protected $oAuthDb	 = null;
	
	private $sSecret = "";
	
	public function __construct($aConfig)
	{
		parent::__construct($aConfig);
		$this->oAuthDb = new MSF_AuthenticationDB($this->oDb);
	}
	
	public function isLogin()
    {
    	$iPost = ((count($_POST) < 4) && isset($_POST["login"]) && isset($_POST["password"]));
    	return $iPost; 
    }
	
	public function login($sLogin, $sPassword, $isRedirectable = true, $bEncrypt = true)
	{
		if ($bEncrypt) {
			$sPassword = MSF_String::encrypt($sPassword);
		}
		$iUserId = $this->oUb->find($sLogin, $sPassword);
		$this->loginById($iUserId, $isRedirectable);
		return $iUserId;
	}

	public function verify()
	{
		if (isset($_SESSION["User"]) && isset($_SESSION["MSF_UserBox"])) {
			$sSessionId = "";
			$aUser 		= $_SESSION["User"];
//			debug($_SESSION["MSF_UserBox"]);
//                        exit;
                        if(isset($_SESSION["MSF_UserBox"]["user"]["language"])){
                            if($_SESSION["MSF_UserBox"]["user"]["language"] == ""){
                                $_SESSION["MSF_UserBox"]["user"]["language"] = CNF_LANGUAGE;
                            }
                        } else {
                            $_SESSION["MSF_UserBox"]["user"]["language"] = CNF_LANGUAGE;
//                            $UserReferenceDB = new UserReferenceDB(MSF_Registry::get("MSF_DB"));
//                            $UserReferenceDB->patchColumnTemplate('ref_system_users', 'language', 'string','Язык');
                        } 
                        
			if (isset($aUser["session_time"]) && ($aUser["session_time"] < time())) {
				$sNew = str_replace("/logout", "", $_SERVER["REQUEST_URI"]);
				$sUrl = ($sNew != "") ? $sNew : "/";
				$this->logout($sUrl);
			}
			
			if (isset($aUser["unique_id"])) {
				$sSessionId = $aUser["unique_id"];
			}
			
			if ($this->oAuthDb->verify($sSessionId) == 1) {
				$aUser["session_time"] 	= $this->getTime();
				$_SESSION["User"] 		= $aUser;
				return true;
			}
		}
		
		$this->oUb->destroy();
		return false;
	}
	

	public function render()
	{
		$sTemlate = CNF_ABS_PATH . "/templates/" . CNF_SKIN . "/login.xsl";
		$this->oMessenger->appendErrors();
		$this->oTemplater->loadXsl($sTemlate);
		$aWords = array(
				"ROOT_LOGIN_TITLE",
				"ROOT_LABEL_LOGIN",
				"ROOT_LABEL_PASSWORD",
				"ROOT_BTN_ENTER",
				"ROOT_MESSAGE_USER_BLOCKED",
				"ROOT_MESSAGE_USER_INCORRECT",
				"ROOT_BROWSER_CHECK_FAILDED",
				"ROOT_BROWSER_CHECK_PARTIAL",
				"ROOT_BROWSER_CHECK_IE"
				);
				
		foreach (MSF_Registry::get("MSF_Locale")->getDictionary() AS $sName => $sValue) {
			if (in_array($sName, $aWords)) {
				$this->oTemplater->addVariable(strtoupper($sName), $sValue);
			}
			
		}

		switch (MSF_SL::getParam($_GET, "msf_view")) {
			case "xml":
				ob_end_clean();
				ob_start();
				HEADER("Content-type: text/xml; charset=utf-8");
				echo $this->oTemplater->getXml();
				break;
			case "xsl":
				ob_end_clean();
				ob_start();
				HEADER("Content-type: text/xml; charset=utf-8");
				echo $this->oTemplater->getXsl();
				break;
			case "noAuthForm" :
				break;
			default:
				HEADER("Content-type: text/html; charset=utf-8");
				echo $this->oTemplater->process();
				break;
		}
		
		exit();
	}
	
    public function getLoginAndPassword($bGet = false, $sSecret = "")
    {
    	$aResult = array();
     	if ($bGet) {
     		$sLogin = $this->oAuthDb->getLogin($sSecret);
     		if (strlen($sLogin)) {
	    		$aResult = array(
	    					$sLogin,
	    					$this->oAuthDb->getPassword($sLogin)
	    					);
     		}
     	}
     	else {
    		$aResult = array (
    			(string) MSF_SL::getParam($_POST, "login"),
				(string) MSF_SL::getParam($_POST, "password")
     			); 
     	}
     	return $aResult;
    }
    
    public function sendMessage()
    {
    	$sLogin = trim($_POST["login"]);
    	if ($this->oAuthDb->loginExists($sLogin)) {
	    	$sEmail = trim($this->oAuthDb->getEmail($sLogin));
	
	    	if ($this->oAuthDb->loginExists($sLogin) && strlen($sEmail)) {
	
	    		$this->oAuthDb->checkLostUsersDB();
				if (!$this->oAuthDb->newLostUser($sLogin)) {
	
					$this->oAuthDb->deleteOldLostUsers();
	
					$sSecret = md5(MSF_String::random(10) . microtime());
					$this->oAuthDb->insertLostUser($sLogin, $sSecret);
					$this->sendMail($sEmail, $sLogin, $sSecret);
	
				}
	    	}
    	}
    }
    
    private function sendMail($sEmail, $sLogin, $sSecret)
    {
    	try {
			$Mail = new LMS_Mail(new LMS_MailDB(MSF_Registry::get("MSF_DB")));
			if ($Mail->isSystemSmtp()) {
	    	
		    	$sText = MSF_Registry::get("MSF_Locale")->getWord("ROOT_MESSAGE_LOST_PSW_TEXT") . " ";
				$sProtocol 	= (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on") ? "https://" : "http://";
				$sLink = $sProtocol . $_SERVER['HTTP_HOST'] . "/login/" . $sSecret;
				$sText.= "<a href='" .$sLink . "'>" . $sLink . "</a><br /><br />";
				$sText.= MSF_Registry::get("MSF_Locale")->getWord("ROOT_MESSAGE_LOST_PSW_LAST");
				$iUserId = $this->oAuthDb->getUserIdByLogin($sLogin);							
				
				$Mail->setFrom("", "Detrix");
				$Mail->setTo($iUserId, $sEmail);
				$Mail->setSubject(MSF_Registry::get("MSF_Locale")->getWord("ROOT_MESSAGE_LOST_PSW_SUBJECT"));
				$Mail->setType("text/html");
				$Mail->setBody($sText);
				$Mail->save(0, true);    	
			}
    	}
    	catch (Exception $e) {
    		if (CNF_MODE == "debug") {
				debug($e);
			}    							
    	}
			
	}
    
    public function isGetLogin()
    {
    	if (isset($_GET["msf_path"])) {
	    	$sGet = $_GET["msf_path"];
	    	if (count($sGet)==1) {
	    		$aTmp = explode('/', $sGet);
	    		if (isset($aTmp[1])) {
	    			if ($aTmp[1] == 'login') {
	    				if (isset($aTmp[2])) {
	    					if (strlen($aTmp[2])==32) {
	    						$this->oAuthDb->deleteOldLostUsers();
	    						if ($this->oAuthDb->secretExists($aTmp[2])) {
	    							$this->sSecret = $aTmp[2];
	    							return true;
	    						}
	    					}
	    				}
	    			} else if($aTmp[1] == 'media' || $aTmp[1] == 'workflow'){
                                    if(isset($_GET["key"])){
                                        $this->oAuthDb->checkLostUsersDB();
                                        $this->oAuthDb->deleteOldLostUsers();
                                        if($this->oAuthDb->secretExists($_GET["key"])){
                                            $this->sSecret = $_GET["key"];
                                            return true;
                                        }                                        
                                    }                                    
                                }
	    		}
	    	}
    	}
    	return false;
    }

    public function getSecret()
    {
    	return $this->sSecret;
    }

}

?>