<?php

/**
 *
 */
class MSF_NtlmPrompt
{

	private $aHeaders 	= array();
	
	private $sAuth		= "";
	
	private $sBody		= "";
	
	public function __construct()
	{
		$this->aHeaders = apache_request_headers();
		if (!isset($this->aHeaders["Authorization"])){
			$this->sendUnauthorized();
		}
		else {
			$this->sAuth = $this->aHeaders["Authorization"];
			if ($this->isAuth()) {
				$this->decode();
				if ($this->isUnauthorized()) {
					// msg type 1
					$this->sendHash();
				}
				
			}
			
		}
		
	}
	
	public function sendOk() {
		HEADER('HTTP/1.1 200 Ok');
	}

	private function isAuth()
	{
		return substr($this->sAuth, 0, 5) == "NTLM ";
	}
	
	private function decode()
	{
		$this->sBody = base64_decode(substr($this->sAuth, 5));
		if ($this->isAuthError()) {
			return null;
		}
		else {
			return $this->sBody;
		}
		
	}
	
	private function isAuthError()
	{
		return substr($this->sBody, 0, 8) != "NTLMSSP\x00";
	}
	
	private function sendUnauthorized()
	{
		HEADER("HTTP/1.1 401 Unauthorized");
		HEADER("WWW-Authenticate: NTLM");
		exit();
	}
	
	private function sendHash()
	{
		$sBody 	 
		/*00*/	= "N". "T"."L"."M"
		/*04*/	. "S". "S"."P"."\x00"
		/*08*/	. "\x02\x00\x00\x00"
		/*12*/	. "\x00\x00\x00\x00"
		/*16*/	. "\x00\x00\x00\x00" 
		/*20*/	. "\x01\x02\x81\x00"
		/*24*/	. "\x00\x00\x00\x00"
		/*28*/	. "\x00\x00\x00\x00"
		/*32*/	. "\x00\x00\x00\x00"
		/*36*/ 	. "\x00\x00\x00\x00"
		/*40*/	. "\x00\x00\x00\x00"
		/*44*/	. "\x00\x00\x00\x00"; 
		HEADER("HTTP/1.1 401 Unauthorized");
		HEADER("WWW-Authenticate: NTLM " . base64_encode($sBody));
		exit();
	}
	
	private function isUnauthorized()
	{
		return $this->sBody[8] == "\x01";
	}
	
	public function isAuthorized()
	{
		return $this->sBody[8] == "\x03";
	}
	
	private function extractParam($iStart, $isUnicode = true)
	{
		$iLength = (ord($this->sBody[$iStart + 1]) * 256) + ord($this->sBody[$iStart]);
		$iOffset = (ord($this->sBody[$iStart + 5]) * 256) + ord($this->sBody[$iStart + 4]);
		if ($isUnicode) {
			return strtolower(str_replace("\0", '', substr($this->sBody, $iOffset, $iLength)));
		}
		else {
			return strtolower(substr($this->sBody, $iOffset, $iLength));
		}

	}
	
	public function getUser()
	{
		$sUser 		= $this->extractParam(36);
		$sDomain 	= $this->extractParam(28);
		if ($sDomain !== "") {
			return $sUser . "@" . $sDomain;
		}
		else {
			return $sUser;
		}
		
	}
	
	public function getUsername()
	{
		return $this->extractParam(36);		
	}
	
	public function getWorkstation()
	{
		return $this->extractParam(44);
	}
	
}
