<?php

include_once "msfx/basket/MSF_BasketDB.php";

class MSF_Basket {
	
	public function addDeletedRefElement($iSubjectId, $iContextId)
	{
		$oReference		= new UserReference(new UserReferenceDB(MSF_Registry::get("MSF_DB")));
		$oReference->load($iSubjectId, array());
		$aElementFields = $oReference->row($iContextId)->getAsHash();
		$oXMLWrapper 	= new MSF_XmlWrapper;
		foreach($aElementFields AS $Key => $Value) {
			 $oXMLWrapper->set($Key, $Value);
		}
		
		$sXML			= $oXMLWrapper->getXml();
		$sDescription 	= "Element was deleted from reference ".$oReference->getName();		
		$sDateTime		= date("Y-m-d H:i:s");
		$DBRecord 		= new MSF_BasketDB("msf_basket", 0);
		$DBRecord->insert(array("subject_id" => $iSubjectId, 
						"context_id" 	=> $iContextId,
						"body_xml" 		=> $sXML,
						"subject" 		=> "reference",
						"description" 	=> $sDescription,
						"datetime"		=> $sDateTime));		
	}
	
	public function getRefData($iRefId)
	{
		$oXMLWrapper 	= new MSF_XmlWrapper;
		$DBRecord 		= new MSF_BasketDB("msf_basket", 0);
		$aPreData 		= $DBRecord->find("context_id, body_xml, datetime", "subject_id = ".$iRefId, array());
		$aData 			= array();
		for($i = 0; $i < count($aPreData); $i++) {
			$aData[$i]["id"]   = $aPreData[$i]["context_id"];
			$aData[$i]["date"] = strtotime($aPreData[$i]["datetime"]);
			$aFields	   = $oXMLWrapper->xmlToArray($aPreData[$i]["body_xml"]);
			foreach ($aFields AS $Key => $Value) {
				$aData[$i]["fields"][$Key] = $Value["value"];
			}
			
		}
		
		return $aData;		
	}
		
}
?>