var BrowserDetect = {
	init: function () {
		this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
		this.version = this.searchVersion(navigator.userAgent)
			|| this.searchVersion(navigator.appVersion)
			|| "an unknown version";
		this.OS = this.searchString(this.dataOS) || "an unknown OS";
	},
	searchString: function (data) {
		for (var i=0;i<data.length;i++)	{
			var dataString = data[i].string;
			var dataProp = data[i].prop;
			this.versionSearchString = data[i].versionSearch || data[i].identity;
			if (dataString) {
				if (dataString.indexOf(data[i].subString) != -1)
					return data[i].identity;
			}
			else if (dataProp)
				return data[i].identity;
		}
	},
	searchVersion: function (dataString) {
		var index = dataString.indexOf(this.versionSearchString);
		if (index == -1) return;
		return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
	},
	dataBrowser: [
		{
			string: navigator.userAgent,
			subString: "Chrome",
			identity: "Chrome"
		},
		{ 	string: navigator.userAgent,
			subString: "OmniWeb",
			versionSearch: "OmniWeb/",
			identity: "OmniWeb"
		},
		{
			string: navigator.vendor,
			subString: "Apple",
			identity: "Safari",
			versionSearch: "Version"
		},
		{
			prop: window.opera,
			identity: "Opera"
		},
		{
			string: navigator.vendor,
			subString: "iCab",
			identity: "iCab"
		},
		{
			string: navigator.vendor,
			subString: "KDE",
			identity: "Konqueror"
		},
		{
			string: navigator.userAgent,
			subString: "Firefox",
			identity: "Firefox"
		},
		{
			string: navigator.vendor,
			subString: "Camino",
			identity: "Camino"
		},
		{		// for newer Netscapes (6+)
			string: navigator.userAgent,
			subString: "Netscape",
			identity: "Netscape"
		},
		{
			string: navigator.userAgent,
			subString: "MSIE",
			identity: "Explorer",
			versionSearch: "MSIE"
		},
		{
			string: navigator.userAgent,
			subString: "Gecko",
			identity: "Mozilla",
			versionSearch: "rv"
		},
		{ 		// for older Netscapes (4-)
			string: navigator.userAgent,
			subString: "Mozilla",
			identity: "Netscape",
			versionSearch: "Mozilla"
		}
	],
	dataOS : [
		{
			string: navigator.platform,
			subString: "Win",
			identity: "Windows"
		},
		{
			string: navigator.platform,
			subString: "Mac",
			identity: "Mac"
		},
		{
			   string: navigator.userAgent,
			   subString: "iPhone",
			   identity: "iPhone/iPod"
	    },
		{
			string: navigator.platform,
			subString: "Linux",
			identity: "Linux"
		}
	]

};
BrowserDetect.init();

var MSF_Menu = Class.create();
MSF_Menu.prototype =
{
	initialize: function(sMenuId)
	{
		this.Menu 		= $(sMenuId);
		this.isOpened 	= false;
		this.iTimeout 	= 500;
		this.bMany 		= false;
		
		this.appendRootLinks();
	},
	
	appendRootLinks: function()
	{
		var Li, Link;
		var me = this;
	
		for (var i = 0; i < this.Menu.childNodes.length; i++) {
			Li = $(this.Menu.childNodes[i]);
			if (Li.tagName == 'LI') {
				for (var j = 0; j < Li.childNodes.length; j++) {
					this.observeHide($(Li.parentNode));
					Link = $(Li.childNodes[j]);
					if (Link && Link.tagName == 'A' && Link.href.substr(Link.href.length - 1, Link.href.length) == '#') {
						Link.onclick = function()
						{
							//
							if (me.isOpened) {
								this.removeClassName('msfMenuSelected');
							}
							else {
								this.addClassName('msfMenuSelected');
							}
							//
							
							me.showChild(this);
							return false;
						}
						Link.observe('mouseover', function() {
							if (me.isOpened) {
								me.closeAll(me.Menu);
								me.showChild(this);
								
								//
								this.addClassName('msfMenuSelected');
								//
							}
						});
						this.appendLinks(me.getChildByLink(Link));
					}
				}
			}
		}
	},
	
	appendLinks: function(Menu)
	{
		var aLinks 	 = Menu.getElementsByTagName('a');
		var Link 	 = null;
		var me 		 = this;
		var Timer 	 = null;
		var Parent 	 = null;
		var sOnClick = "";
		for (var i = 0; i < aLinks.length; i++) {
			Link 	 = $(aLinks[i]);
			Link.id  = Math.random();
			sOnClick = Link.onclick ? Link.onclick.toString() : '';
			if(sOnClick.indexOf("showAboutProgramWindow()") == -1) {
				Link.onclick = function()
				{
					if (Timer) {
						clearTimeout(Timer);
					}
					me.closeAll(this.parentNode.parentNode, this);
					me.showChild(this, true);
					if (this.href.substr(this.href.length - 1, this.href.length) == '#') {
						return false;
					}
				};
			}
			else {
				Link.onclick = function()
				{
					if (Timer) {
						clearTimeout(Timer);
					}
					me.closeAll(me.Menu);
					showAboutProgramWindow();					
				};
			}
			
			Parent = Link.parentNode;
			Link.observe('mouseover', function() {
				
				//
				this.addClassName('msfSubmenuSelected');
				//
				
				var meLink = this;
				Timer = setTimeout(function() {
					me.closeAll(meLink.parentNode.parentNode, meLink);
					me.showChild(meLink, true);
					
					//
					Timer = null;
					//
					
				}, me.iTimeout);
			});
			Link.observe('mouseout', function() {
			
				//
				var mUl = me.hasChildren(this);
				if (!mUl) {
					this.removeClassName('msfSubmenuSelected');
				}
				//
				
				if (Timer) {
					clearTimeout(Timer);
					
					//
					if (mUl && !$(mUl).visible()) {
						this.removeClassName('msfSubmenuSelected');
					}
					//
				}
			});
		}
	},
	
	checkParent: function(Element)
	{
		var iResult = 0;
		
		if (Element.parentNode.tagName == 'UL') {
			iResult++;
		}
		if (Element.parentNode.tagName != 'DIV') {
			iResult += this.checkParent(Element.parentNode);
		}
		
		return iResult;
	},	
	
	getChildByLink: function(Element)
	{
		var Parent 	= Element.parentNode;
		var Ul 		= null;
		
		for (var i = 0; i < Parent.childNodes.length; i++) {
			if (Parent.childNodes[i].tagName == 'UL') {
				Ul = $(Parent.childNodes[i]);
			}
		}
		
		return Ul;
	},
	
	showChild: function(Link, bSub)
	{
		var Li 		= $(Link.parentNode);
		var me 		= this;
		var Ul 		= null;
		var aPos 	= new Array();
		
		for (var i = 0; i < Li.childNodes.length; i++) {
			Ul = $(Li.childNodes[i]);
			if (Ul.tagName == 'UL') {
				if (Ul.visible()) {
					Ul.hide();
					if (!bSub) {
						me.isOpened = false;
					}
				}
				else {
					Ul.show();
					
					if (this.checkParent(Ul) > 1) {
						Ul.style.left 		= Li.parentNode.getWidth() + 'px';
						Ul.style.marginTop 	= - Li.getHeight() + 'px';
					}
					if (!bSub) {
						me.isOpened = true;
					}
				}
			}
		}
		
		return false;
	},
	
	
	//
	hasChildren: function(Link)
	{
		var Parent 	= $(Link.parentNode);
		var aUls 	= Parent.getElementsByTagName('UL');
		
		return (aUls.length > 0) ? aUls[0] : null;
	},
	//
	
	
	closeAll: function(Menu, Element)
	{
		var aUls = Menu.getElementsByTagName('UL');
		for (var i = aUls.length - 1; i >= 0; i--) {
			$(aUls[i]).hide();
		}
		
		//
		var aLinks = Menu.getElementsByTagName('A');
		for (var i = aLinks.length - 1; i >= 0; i--) {
			var Link = $(aLinks[i]);
			if (Element) {
				if (Link.id != Element.id) {
					Link.removeClassName('msfSubmenuSelected');
				}
			}
			else {
				Link.removeClassName('msfSubmenuSelected');
				Link.removeClassName('msfMenuSelected');
			}
		}
		//
	},
	
	observeHide: function(Element)
	{
		var me 		= this;
		var Html 	= $$('html')[0];
		
		var test 	= {
			ob: function()
			{
				me.closeAll(me.Menu);
				me.isOpened = false;
				Html.stopObserving('click', test.buf);
			}
		}
		
		test.buf = test.ob.bindAsEventListener(test);
		
		Element.observe('mouseout', function() {
			Html.observe('click', test.buf);
		});
		
		Element.observe('mouseover', function() {
			Html.stopObserving('click', test.buf);
		});
		
		if(BrowserDetect.browser == 'Safari') {
			Html.ontouchstart = function(e) {
				var theTarget = e.target ? e.target : e.srcElement;
				if( theTarget && ( theTarget.nodeType == 3 || theTarget.nodeType == 4 ) ) {
					theTarget = theTarget.parentNode;
				}
				
				if(!getParent(theTarget)) {
					me.closeAll(me.Menu);
					me.isOpened = false;
					Html.stopObserving('click', test.buf);
				}
				
			}
		}
		
		var getParent = function(elem) {
			var parent = elem.parentNode;
			if(parent == null) {
				return 0;
			}
			else if(parent.className == 'msfMenu') {
				return 1;
			}
			else {
				return getParent(parent);
			}
			
		}
		
	}
	
	/*
	observeHide: function(Element)
	{
		var me 		= this;
		var Html 	= $$('html')[0];
		
		var observeBody = function()
		{
			Html.observe('click', function() {
				me.closeAll(me.Menu);
				me.isOpened = false;
				stopBody();
			});
		}
		var stopBody = function()
		{
			Html.stopObserving('click');
		}
		
		Element.observe('mouseout', function() {
			observeBody();
		});
		Element.observe('mouseover', function() {
			stopBody();
		});
	}
	*/
}
