<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "MSF_MenuException.php";

class MSF_Menu
{
	private $aElements 	= array();

	private $Template 	= null;

	private $Root 		= null;

	private $iCount 	= 0;

	public function __construct(MSF_Template $Template)
	{
		if(!isset($_SESSION["menu"])){
			$this->Template = $Template;
			$this->Root 	= $Template->createMsfx("menu");
		}
	}

	public function setItem($mParent, $sName, $sValue, $sUrl, $sImage = "", $sOnclick = "", $sTitle = "", $aParams = array())
	{
		$this->verify($mParent, $sName);
		$this->create($sName, $sValue, $sUrl, $sImage, $sOnclick, $sTitle, $aParams);
		$this->add($mParent, $sName);
	}

	private function create($sName, $sValue, $sUrl, $sImage, $sOnclick, $sTitle, $aParams = array())
	{
		$this->aElements[$sName] = $this->Template->createElement("item");
		$this->aElements[$sName]->setAttribute("value", MSF_Registry::get("MSF_Locale")->getI18N($sValue));
		$this->aElements[$sName]->setAttribute("url",	$sUrl);
		$this->aElements[$sName]->setAttribute("image", $sImage);
		$this->aElements[$sName]->setAttribute("onclick", $sOnclick);
		$this->aElements[$sName]->setAttribute("title", MSF_Registry::get("MSF_Locale")->getI18N($sTitle));
		$this->aElements[$sName]->setAttribute("id", $this->iCount++);
		
		if (is_array($aParams) && !empty($aParams)) {
			foreach ($aParams AS $sAttrName => $sAttrValue) {
				$this->aElements[$sName]->setAttribute($sAttrName, $sAttrValue);
			}
		}

	}

	private function verify($mParent, $sName)
	{
		if (array_key_exists($sName, $this->aElements)) {
			//throw new MSF_MenuException("Item has already created <" . $sName . ">");
		}
		else if (!is_null($mParent) && !array_key_exists($mParent, $this->aElements)) {
			//throw new MSF_MenuException("Parent node does not exist <" . $mParent . ">");
		}

	}

	private function add($mParent, $sName)
	{
		if (!is_null($mParent) && array_key_exists($mParent, $this->aElements)) {
			$this->aElements[$mParent]->setAttribute("child", 1);
			$this->aElements[$mParent]->appendChild($this->aElements[$sName]);
		}
		else {
			$this->aElements[$sName]->setAttribute("child", 0);
			$this->Root->appendChild($this->aElements[$sName]);
		}

	}
	
	public function getRoot() {
		return $this->Root;
	}
	
	public function setRoot($root) {
		$this->Root=$root;
	}
}

?>