<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:template match="/page/msfx/menu">
		<div class="block mainmenu">
			<!-- <img class="logo" src="/templates/default/images/logo.gif" alt="Manuscript's logo"/> -->
			<div class="msfMenu">
				<ul id="msfMenu">
					<li style="width: 15px">&#160;</li>
					<li>
						<div class="mainmenu-delimiter"></div>
					</li>
					<xsl:for-each select="item">
						<li>
							<a class="mainmenu-item" href="{@url}" onclick="{@onclick}" title="{@title}">
								<xsl:value-of select="@value"/>
							</a>
							<xsl:call-template name="menu_items"/>
						</li>
						<li>
							<div class="mainmenu-delimiter"></div>
						</li>
					</xsl:for-each>
				</ul>
			</div>
			<div class="msfMenuSearch">
				<xsl:if test="@contextSearchEnabled = 1">
					<div class="mainmenu-delimiter">&#160;</div>
					<div class="searchContainer">
						<div>
							<div>
								<img src="/templates/default/images/search_icon.jpg"/>
								<xsl:choose>
									<xsl:when test="@contextSearchValue">
										<input id="csValue" class="searchInput" value="{@contextSearchValue}" onfocus="MSF_SearchInput.full(this, true)" onblur="MSF_SearchInput.full(this, false)"/>
									</xsl:when>
									<xsl:otherwise>
										<input id="csValue" class="searchInput" value="{$ROOT_SEARCH_FULL}" onfocus="MSF_SearchInput.full(this, true)" onblur="MSF_SearchInput.full(this, false)"/>
									</xsl:otherwise>
								</xsl:choose>

							</div>
						</div>
					</div>
					<div class="searchButton">
						<input onclick="sendContextSearchValue()" type="submit" value="{$ROOT_BTN_SEARCH}"/>
					</div>
					<script>
					function sendContextSearchValue() {
						var stopValue 	= "<xsl:value-of select="$ROOT_SEARCH_FULL"/>";
						var action 		= "<xsl:value-of select="@contextSearchAction"/>";
						if ($("csValue").value == stopValue) {
							$("csValue").value = "";
						}
						
						window.location = action + "&amp;rs_search=" + encodeURIComponent($("csValue").value);
					}

					$("csValue").observe("keyup", function(event){
						//13 - enter
						if(event.keyCode == 13){
							sendContextSearchValue();
						}
						
					});
					</script>
				</xsl:if>
			</div>

			<script>
				new MSF_Menu('msfMenu');
			</script>
		</div>
	</xsl:template>

	<xsl:template name="menu_items">
		<ul class="msfSubmenu" style="display: none">
			<xsl:for-each select="item">
				<xsl:choose>
					<xsl:when test="@child = 1">
						<li>
							<a class="msfMenuParent" href="{@url}" onclick="{@onclick}" title="{@title}">
								<xsl:value-of select="@value"/>
							</a>
							<xsl:call-template name="menu_items"/>
						</li>
					</xsl:when>
					<xsl:otherwise>
						<li>
							<a href="{@url}" onclick="{@onclick}" title="{@title}">
								<xsl:value-of select="@value"/>
							</a>
						</li>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:for-each>
		</ul>
	</xsl:template>
</xsl:stylesheet>