<?php
/*
 * File: MSF_Messenger.php
 * Created at: 16.01.2008
 */
defined("__MSF")
	or die("Direct access is not allowed");

/**
 * @package <package>
 * @author Detrix
 * @copyright Copyright (c) 2007, Detrix
 */
class MSF_Messenger
{
	private $Template		= null;

	private $ElmMessenger 	= null;

	private $ElmMessages 	= null;

	private $ElmErrors		= null;

	public function __construct(MSF_Template $Template)
	{
		if (!isset($_SESSION["msf"])) {
			$_SESSION["msf"] = array();
		}
		if (!isset($_SESSION["msf"]["messages"])) {
			$_SESSION["msf"]["messages"] = array();
		}
		if (!isset($_SESSION["msf"]["errors"])) {
			$_SESSION["msf"]["errors"] = array();
		}
		$this->Template		= $Template;
		$this->ElmMessenger	= $this->Template->createMsfx("messenger");
		$this->ElmMessages  = $this->Template->createElement("messages");
		$this->ElmErrors  	= $this->Template->createElement("errors");
		$this->ElmMessenger->appendChild($this->ElmMessages);
		$this->ElmMessenger->appendChild($this->ElmErrors);
	}

	// stub
	public function redirect($sUrl, $sMessage = "", $isError = false)
	{		
		if (isset($_GET['hideMenu'])) {
			if (!strstr($sUrl, '?')) {
				$sUrl = $sUrl . '?hideMenu';
			}
			else {
				$sUrl = $sUrl . '&hideMenu';
			}
			
		}

		if($isError) {
			$this->addError($sMessage);
		}
		else {
			$this->addMessage($sMessage);
		}
	
		HEADER("Location: " . $sUrl);
		//echo $sUrl;
		exit();
	}

	public function addMessage($sMessage)
	{
		if (!empty($sMessage) && !in_array($sMessage, $_SESSION["msf"]["messages"])) {
			$_SESSION["msf"]["messages"][] = $sMessage;
		}
	}

	public function addError($sError)
	{
		/*
		$ElmError = $this->Template->createElement("error");
		$ElmError->setAttribute("value", $sError);
		$this->ElmErrors->appendChild($ElmError);*/
		
		if (!empty($sError) && !in_array($sError, $_SESSION["msf"]["errors"])) {
			$_SESSION["msf"]["errors"][] = $sError;
		}		
	}

	public function appendMessages()
	{
		if (!empty($_SESSION["msf"]["messages"])) {
			foreach ($_SESSION["msf"]["messages"] AS $k => $v) {
				$ElmMessage = $this->Template->createElement("message");
				$ElmMessage->setAttribute("value", $v);
				$this->ElmMessages->appendChild($ElmMessage);

				unset($_SESSION["msf"]["messages"][$k]);
			}
		}
	}
	
	public function appendErrors()
	{
		if (!empty($_SESSION["msf"]["errors"])) {
			foreach ($_SESSION["msf"]["errors"] AS $k => $v) {
				$ElmMessage = $this->Template->createElement("error");
				$ElmMessage->setAttribute("value", $v);
				$this->ElmErrors->appendChild($ElmMessage);				
				unset($_SESSION["msf"]["errors"][$k]);
			}
		}
	}

}
?>