var MSF_UpdaterController = Class.create();
MSF_UpdaterController.prototype =
{
	oUpdater		: null,
	
	iTestInc		: null,
	
	sRequestUri 	: null,
	
	aRequestParams	: null,
	
	iFrequency		: null,
	
	aResponse		: null,
	
	sMethod			: null,
	
	sMessage		: null,
	
	sAlertMessage	: null,
	
	iUnread			: null,
	
	bFirstRequest 	: true,
	
	iNumMessages 	: 0,
	
	initialize	: function(aParams)
	{
		this.iUnread		= 0;
		this.oUpdater 		= new MSF_Updater();
		this.iFrequency		= (aParams["frequency"] > 30000) ? aParams["frequency"] : 30000;
		this.sMessage		= aParams["message"];
		this.sAlertMessage	= aParams["alertMessage"];
		this.sRequestUri	= aParams["uri"] + "/" + aParams["id"];
		this.sMethod		= aParams["method"];
		this.sUri 			= aParams["currUri"];
	},

	execute 	: function()
	{
		this.addExecutor(this);
	},
	
	addExecutor : function (oController) {
		oController.sTitle = oController.oUpdater.getTitle();
		oController.makeRequest(oController);
	},
	
	
	
	makeRequest: function(oController)
	{
	
		var oAction = function() {
			new Ajax.Request(oController.sRequestUri, {
			    method		: oController.sMethod,
			    onComplete	: function(transport) {
			    	try {
			    		if (200 == transport.status) {
					    	var aResponse 	= transport.responseText.evalJSON();
					    	var sAlert		= oController.sAlertMessage + aResponse.count;
					    	if (aResponse.count > 0) {
								oController.oUpdater.setTitle(oController.sMessage + aResponse.count + ". " + oController.oUpdater.title);
							}
							else {
								oController.sTitle1 = oController.oUpdater.title;
								oController.oUpdater.setTitle(oController.sTitle1);
							}
					    	
					    	if (aResponse.alert) {
				    			// alert(sAlert);
					    	}
		
					    	if (aResponse.count > oController.iNumMessages) {
					    		oController.mail();
					    	}
					    	
					    	oController.iNumMessages 	= aResponse.count;
					    	this.bFirstRequest 			= false;
			    		}

			    	}
			    	catch (e) {
			    		//alert(e);
			    	}
			    	
			    	this.makeRequest(oController);
			    }.bind(this)
			    	
			});
		}.bind(this);
		
		setTimeout(oAction, this.iFrequency);
	},
	
	check : function()
	{
	
	},
	
	mail: function()
	{
		var aUri = this.sUri.split("/");
		if (aUri[1] && aUri[1] == "lms") {
			if ((aUri[2] && aUri[2] == "folder") || !aUri[2]) {
				if (!this.bFirstRequest) {
					window.location.href = window.location.href;
				}
				
			}
			
		}
		
	}
}