<?php

class MSF_UpdaterXml
{
	/**
	 * @var MSF_Template
     */
	private $oTemplate = null;
	
	public function __construct()
	{
		$this->oTemplate = MSF_Registry::get("MSF_Template");
	}
	
	public function appendToXml()
	{
		$this->oTemplate->addXslPath("/msfx/updater/templates/" . CNF_SKIN . "/updater.xsl");
		
		$sUri = $_SERVER["REQUEST_URI"];
		if ($sUri == "/") {
			$sUri .= MSF_Registry::get("MSF_Router")->getModule();
		}
		$this->createMsfxWithParams(
			array(array("uri" => $sUri))
		);
	}
	
	private function createMsfxWithParams($aParams)
	{
		$oUpdater = $this->oTemplate->createMsfx("updater");
		for ($i = 0; $i < count($aParams); $i++) {
			$oSample = $this->oTemplate->createElement("item");
			foreach ($aParams[$i] as $k => $v) {
				$oSample->setAttribute("name", $k);
				try {
					$oSample->setAttribute("value", $v);
				}
				catch (Exception $oE){ 
					$oSample->setAttribute("value", "");
				}
				
			}
			$oUpdater->appendChild($oSample);
		}
		
		//
		return $oUpdater;
	}
}

?>
