<?php

defined("__MSF") or die("Direct access is not allowed");

include_once "library/MSF_UserBox.php";
class MSF_UserBoxExtension extends MSF_MsfxSupport
{
	public function execute()
	{
		$Template 	= MSF_Registry::get("MSF_Template");
		$UserBox 	= MSF_UserBox::getInstance();
		MSF_Registry::set("MSF_UserBox", $UserBox);
		
		$Element = $Template->createMsfx("user");
		$Element->setAttribute("post_id", $UserBox->getCurrentPostId());
		$Element->setAttribute("user_name", $UserBox->getEmployeeAttribute("name"));
		
		$sPage = "";
		if ($UserBox->getUserAttribute("start_page_type") == 0) {
			$sPage 		= $UserBox->getUserAttribute("page_url");
			$sProtocol 	= (isset($_SERVER["HTTPS"]) && $_SERVER["HTTPS"] == "on") ? "https://" : "http://";
			$sServer 	= $sProtocol . $_SERVER["HTTP_HOST"];
			$sPage 		= str_replace($sServer, "", $sPage);
			$sPage 		= "/" . trim($sPage, "/");
		}
		$Element->setAttribute("page_url", $sPage);
		//debug($_SESSION);
		//exit();
		$aStrIds 	= $UserBox->getStructureAttribute("id_list");
		$iSize 		= count($aStrIds);
		//debug($aStrIds);
		if ($iSize > 1) {
			$aPosts = $UserBox->getPosts();
			$Posts 	= $Template->createElement("posts");
			//for ($i = 0; $i < $iSize; $i++) {
			for ($i = 0; $i < count($aPosts); $i++) {
				$sPost = $aPosts[$i]["post"];
				if (isset($aPosts[$i]["boss"])) {
					$sPost .= " " . MSF_Registry::get("MSF_Locale")->getWord("ROOT_POST_IO");
				}
				$Item = $Template->createElement("item");
				$Item->setAttribute("id", $aPosts[$i]["id"]);
				$Item->setAttribute("title", $sPost);
				$Posts->appendChild($Item);
			}
			$Element->appendChild($Posts);
		}
	}
}

?>