<?php

DEFINE('__MSF', true);
include_once '../../library/NuSoap/nusoap.php';

$uri = "/ws/FileUpload";
$server = new nusoap_server('');
$server->configureWSDL('FileUpload', $uri);
$server->wsdl->schemaTargetNamespace = 'urn:upload';
$server->wsdl->addComplexType(
        'Document', 'complexType', 'struct', 'all', '', array(
    'documentVerId' => array('name' => 'documentVerId', 'type' => 'xsd:long'),
    'fileId' => array('name' => 'fileId', 'type' => 'xsd:long'),
    'message' => array('name' => 'message', 'type' => 'xsd:string')
        )
);
$server->register(
        'upload', array('file' => 'xsd:base64Binary', 'fileId' => 'xsd:long',
    'fileSize' => 'xsd:long', 'docTypeVerId' => 'xsd:long', 'key' => 'xsd:string'), array('result' => 'tns:Document'), $uri);

function upload($file, $fileId, $fileSize, $docTypeVerId, $key) {
    $LOG_DIR = $_SERVER['DOCUMENT_ROOT'] . "/var/logs/wsUploads.log";
    $today = getdate();
    $log_message = "upload  - ".$today['year']."-".$today['mon']."-".$today['mday']."   ".$today['housr'].":".$today['minutes'].":".$today['seconds'];
    error_log($log_message, 3, $LOG_DIR);

    $params = getParameters();
    $connection_string = "host=" . $params['host'] . "  port=" . $params['port'] .
            " dbname=" . $params['database'] . " user=" . $params['user'] .
            " password=" . $params['password'];
    $pg_conn = pg_connect($connection_string);

    $sql = "SET search_path TO " . $params['scheme'];
    $query_result = pg_query($pg_conn, $sql);

    $sql = "SELECT params FROM manuscript.lost_users WHERE secret = '$key'";
    $query_result = pg_query($pg_conn, $sql);
    $row = pg_fetch_array($query_result);
    $param_value = $row["params"];
    $paramsArray = explode(":", $param_value);
    //Array ( [0] => 13 [1] => 51 [2] => field_e592bb8356 [3]=>3)
    
    $document_id = $paramsArray[1];
    $file_field_name = $paramsArray[2];
    $current_structure_id = $paramsArray[3];

    $sql = "SELECT  fields_xml, route_xml, doctype_version_id  FROM  wf_doctypes  WHERE  doctype_id = " . $paramsArray[0];
    $query_result = pg_query($pg_conn, $sql);
    $row = pg_fetch_array($query_result);

    $doctype_version_id = $row["doctype_version_id"];

    $sql = "SELECT  extname, fields_xml, route_xml, spa_xml  FROM  wf_doctypes_versions  WHERE  doctype_id = " . $paramsArray[0] . "  and  doctype_version_id = " . $doctype_version_id;
    $query_result = pg_query($pg_conn, $sql);
    $row = pg_fetch_array($query_result);

    $extname = $row["extname"];
    $fieldsXml = $row["fields_xml"];
    $routeXml = $row["route_xml"];
    $spaXml = $row["spa_xml"];

    $document_file_field_name = "";
    $document_date_fields = array();
    $document_integer_fields = array();
    $fieldsNameType = array();
    $fields_xml = simplexml_load_string($fieldsXml);
    if ($fields_xml) {
        foreach ($fields_xml->element as $elem) {
            $field_name = $elem['name'];
            $field_type = $elem->xpath('item[@name="type"]');
            $fieldsNameType["$field_name"] = $field_type[0]['value'];
            if ($field_type[0]['value'] == "file") {
                $document_file_field_name = $field_name;
            } else if ($field_type[0]['value'] == "date") {
                $document_date_fields[] = $field_name;
            } else if ($field_type[0]['value'] == "int") {
                $document_integer_fields[] = $field_name;
            }
        }
    }
    /* ---------------------- */
    $xml_route = simplexml_load_string($routeXml);
    $xml_spa = simplexml_load_string($spaXml);

    $spa_edit = array();
    $spa_type = array("vars", "fields", "groups", "structure");
    foreach ($xml_spa->element as $elem) {
        $elem_type = $elem->xpath('item[@value="edit"]');
        if ($elem_type[0]["value"]) {
            $spa_edit[] = $elem["name"];
        }
    }
    $has_access = false;
    foreach ($xml_route->element as $elem) {
        foreach ($elem->xpath('item[@name="delegate"]/item') as $item) {
            $items = $item->item;
            if (in_array((int) $items[0]["value"], $spa_edit) && in_array($items[1]["value"], $spa_type)) {
                switch ($items[1]["value"]) {
                    case "vars":
                        $sql = "SELECT  structure_id  FROM  wf_documents  WHERE  document_id = " . $document_id .
                                " order by document_version_id desc limit 1";
                        $query_result = pg_query($pg_conn, $sql);
                        $row = pg_fetch_array($query_result);
                        if ($row["structure_id"] == $current_structure_id) {
                            $has_access = true;
                        }

                        $log_message = "vars
                        sql: $sql
                        query_error: " . pg_last_error() . "
                        wf_documents structure_id: " . $row["structure_id"] . "
                        lost_user structure_id: $current_structure_id
                        has_access: $has_access
                        ------------------------------------------------------------";
                        error_log($log_message, 3, $LOG_DIR);
                        break;
                    case "fields":
                        $sql = "SELECT  document_version_id  FROM  wf_documents  
                                WHERE  document_id = $document_id";
                        $query_result = pg_query($pg_conn, $sql);
                        $row = pg_fetch_array($query_result);
                        
                        error_log("sql:$sql
                                ".  pg_last_error(), 3, $LOG_DIR);

                        $sql = "SELECT  " . $items[2]["value"] . "  FROM  wf_documents_$extname  
                                WHERE  document_version_id = " . $row["document_version_id"];
                        $query_result = pg_query($pg_conn, $sql);
                        $row = pg_fetch_array($query_result);
                        
                        error_log("sql:$sql
                                ".  pg_last_error(), 3, $LOG_DIR);
                        error_log("
                            ".$row[(string) $items[2]["value"]], 3, $LOG_DIR);

                        $emps = explode("|^|row|^|", $row[(string) $items[2]["value"]]);
                        foreach ($emps as $emp) {
                            error_log("\nemp: $emp\ncurrent_structure_id: $current_structure_id", 3, $LOG_DIR);
                            if ($has_access)
                                break;
                            $has_access = acl($emp, $current_structure_id);
                        }

                        $log_message = "fields
                        " . $row[(string) $items[2]["value"]] . "
                        has_access: $has_access
                        ------------------------------------------------------------";
                        error_log($log_message, 3, $LOG_DIR);
                        break;
                    case "groups":
                        $sql = "SELECT  employee  FROM  ref_system_groups
                                WHERE id = $current_structure_id";
                        $query_result = pg_query($pg_conn, $sql);
                        $row = pg_fetch_array($query_result);

                        error_log("sql:$sql
                                ".  pg_last_error(), 3, $LOG_DIR);
                        
                        $emps = explode("|^|row|^|", $row["employee"]);
                        foreach ($emps as $emp) {
                            error_log("emp: $emp
                                    structure_id: $current_structure_id".  pg_last_error(), 3, $LOG_DIR);
                            if ($has_access)
                                break;
                            $has_access = acl($emp, $current_structure_id);
                        }
                        $log_message = "groups
                        " . $row["employee"] . "
                        has_access: $has_access
                        ------------------------------------------------------------";
                        error_log($log_message, 3, $LOG_DIR);
                        break;
                    case "structure":
                        $emps = explode("|^|row|^|", $items[2]["value"]);
                        foreach ($emps as $emp) {
                            if ($has_access)
                                break;
                            $has_access = acl($emp, $current_structure_id);
                        }
                        $log_message = "structure
                        " . $items[2]["value"] . "
                        has_access: $has_access
                        ------------------------------------------------------------";
                        error_log($log_message, 3, $LOG_DIR);
                        break;
                }
            }
        }
    }
    if (!$has_access) {
        $log_message = "нет прав для редактирования документа
            параметры которые отправил агент - fileId: $fileId, documentVersionId: $docTypeVerId, key: $key
            параметры которые лежат в базе(lost_user) - documentId: $document_id, field_name: $file_field_name, current_structure_id: $current_structure_id
            ---------------------------------------------------------------------------------------";
        error_log($log_message, 3, $LOG_DIR);
        return array('documentVerId' => $docTypeVerId, 'fileId' => $fileId, 'message' => 'false');
    }

    /* ---------------------- */
    $sql = "SELECT  *  FROM  wf_documents_versions  WHERE  document_id = " . $document_id . "  order by document_version_id desc limit 1";
    $query_result = pg_query($pg_conn, $sql);
    $row = pg_fetch_array($query_result);

    $dd_emp_name = $row["employee_name"];
    $dd_structure_id = $row["structure_id"];
    $dd_document_version_id = $row["document_version_id"];
    
    $sql = "SELECT  structure_id  FROM  wf_documents_versions  WHERE  document_version_id = " . $docTypeVerId;
    $query_result = pg_query($pg_conn, $sql);
    $row = pg_fetch_array($query_result);
    $dvi_structure_id = $row["structure_id"];

//    $docTypeVerId = 0;
    if (($docTypeVerId == $dd_document_version_id) && ($current_structure_id == $dvi_structure_id)) {

        $log_message = "версий документов совпали (ид с агента и с базой)
            произойдет обновление таблицы md_media
            ------------------------------------------------------------";
        error_log($log_message, 3, $LOG_DIR);

        $md_file_path = getDirToUpload($params["upload_dir"]);
        uploadToDir($md_file_path, $fileId, $file);

        $sql = "UPDATE  md_media
            SET directory = '" . str_replace($_SERVER['DOCUMENT_ROOT'] . "/", "", $md_file_path) . "',
                md5 = '" . md5_file($md_file_path . "/" . $fileId) . "',
                sha1 = '" . sha1_file($md_file_path . "/" . $fileId) . "',
                created_at = " . time() . ",
                size = " . filesize($md_file_path . "/" . $fileId) . "
            WHERE file_id = $fileId";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        $sql = "INSERT  INTO  cs_indexed
            (subject_id, module, operation, context_id)
            VALUES ($paramsArray[1],'workflow','index',$paramsArray[0])";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        $new_document_version_id = $dd_document_version_id;
        $md_new_file_id = $fileId;
    } else {
        $sql = "SELECT  subject_id  FROM  structure  WHERE  node_id = ".$current_structure_id;
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);
        $subject_id = $row["subject_id"];
        
        $log_message = "\n$sql
                        \n".  pg_last_error();
        error_log($log_message, 3, $LOG_DIR);
        
        $sql = "SELECT  employee_ref_value  FROM  ref_system_posts  WHERE  id = ".$subject_id;
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);
        $employee_ref_value = $row["employee_ref_value"];
        $emp_ref_array = explode("/^/col/^/", $employee_ref_value);
        
        $log_message = "\n$sql
                        \n".  pg_last_error();
        error_log($log_message, 3, $LOG_DIR);
        
        
        $sql = "INSERT INTO  wf_documents_versions
        (
            document_id,employee_name,created_at,structure_id
        ) VALUES (
            $document_id,
            '$emp_ref_array[0]',
            'now'::timestamp,
            $current_structure_id
        ) RETURNING document_version_id";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        $log_message = "sql:$sql
                        ".  pg_last_error();
        error_log($log_message, 3, $LOG_DIR);
        
        $new_document_version_id = $row["document_version_id"];
        
        $sql = "UPDATE  wf_documents
            SET document_version_id = $new_document_version_id
            WHERE document_id = $document_id";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);
        
        $log_message = "sql:$sql
                        ".  pg_last_error();
        error_log($log_message, 3, $LOG_DIR);

        $sql = "SELECT  *  FROM  md_media
            WHERE file_id = $fileId";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);
        
        $log_message = "sql:$sql
                        ".  pg_last_error();
        error_log($log_message, 3, $LOG_DIR);

        $md_name = $row["name"];
        $md_directory = $row["directory"];
        $md_md5 = $row["md5"];
        $md_sha1 = $row["sha1"];
        $md_module = $row["module"];
        $md_user_id = $row["user_id"];
        $md_created_at = $row["created_at"];
        $md_type = $row["type"];
        $md_size = $row["size"];

        $md_file_path = getDirToUpload($params["upload_dir"]);
        

        $sql = "INSERT INTO  md_media
        (
            name,directory,md5,sha1,module,user_id,created_at,type,size
        ) VALUES (
            '$md_name',
            '" . str_replace($_SERVER['DOCUMENT_ROOT'] . "/", "", $md_file_path) . "',
            '" . md5('test') . "',
            '" . sha1('test') . "',
            '$md_module',
            $md_user_id,
            " . time() . ",
            '$md_type',
            $md_size
        ) RETURNING file_id";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        $log_message = "sql:$sql
                        file_id:".$row["file_id"]."
                        ".  pg_last_error();
        error_log($log_message, 3, $LOG_DIR);
        
        $md_new_file_id = $row["file_id"];
        uploadToDir($md_file_path, $md_new_file_id, $file);              

        $sql = "UPDATE  md_media
        SET md5 = '" . md5_file($md_file_path . "/" . $md_new_file_id) . "',
            sha1 = '" . sha1_file($md_file_path . "/" . $md_new_file_id) . "',
            size = " . filesize($md_file_path . "/" . $md_new_file_id) . "
            WHERE file_id = " . $md_new_file_id;
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        $log_message = "sql:$sql
                        ".  pg_last_error();
        error_log($log_message, 3, $LOG_DIR);
        $log_message = "новый ид файла в md_media: $md_new_file_id
                        путь: $md_file_path";
        error_log($log_message, 3, $LOG_DIR);

        $sql = "SELECT  *  FROM  wf_documents_$extname
            WHERE document_version_id = $dd_document_version_id";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_assoc($query_result);
        unset($row["document_version_id"]);

        $sql = "INSERT INTO  wf_documents_$extname
        (
            document_version_id
            ";
        foreach ($row as $key => $value) {
            $sql .= ", $key";
        }
        $sql .= ") VALUES (
            $new_document_version_id
            ";
        foreach ($row as $key => $value) {
            if ($file_field_name == $key) {
                $value = str_replace($fileId, $md_new_file_id, $value);
                $sql .= ",'$value'";
            } else if (in_array($key, $document_date_fields)) {
                if (empty($value))
                    $sql .= ",NULL";
                else
                    $sql .= ",to_date('$value','YYYY-MM-DD')";
            } else if ($key == "modified_at") {
                if (empty($value))
                    $sql .= ",NULL";
                else
                    $sql .= ",to_timestamp('$value','YYYY-MM-DD HH24:MI:SS')";
            } else if ($key == "created_at") {
                if (empty($value))
                    $sql .= ",NULL";
                else
                    $sql .= ",to_date('$value','YYYY-MM-DD')";
            } else if ($key == "registration_date") {
                if (empty($value))
                    $sql .= ",NULL";
                else
                    $sql .= ",to_date('$value','YYYY-MM-DD')";
            }else if (in_array($key, $document_integer_fields)) {
                if (empty($value))
                    $sql .= ",NULL";
                else
                    $sql .= ",$value";
            } else {
                if (empty($value))
                    $sql .= ",NULL";
                else
                    $sql .= ",'$value'";
            }
        }
        $sql .= ")";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);
        
        $log_message = "таблица wf_documents_$extname
                        sql: $sql
                        nошибка в селекте: ".  pg_last_error();
        error_log($log_message, 3, $LOG_DIR);

        $sql = "INSERT  INTO  cs_indexed
            (subject_id, module, operation, context_id)
            VALUES ($paramsArray[1],'workflow','index',$paramsArray[0])";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);


        $log_message = "версий документов не совпали
            создается новая версия документа: $new_document_version_id
            создается новая запис в таблице md_media: $md_new_file_id
            ------------------------------------------------------------";
        error_log($log_message, 3, $LOG_DIR);
    }
    
    $delete_file = $_SERVER['DOCUMENT_ROOT']."/var/docs/".$paramsArray[0]."/$document_id";
    unlink($delete_file);
    
    $result = array('documentVerId' => $new_document_version_id, 'fileId' => $md_new_file_id, 'message' => 'true');
    return $result;
}

function getParameters() {
    $xml = simplexml_load_file('../../settings.xml');

    $xml_host = $xml->xpath('element/item[@name="sql_host"]/@value');
    $xml_scheme = $xml->xpath('element/item[@name="sql_scheme"]/@value');
    $xml_database = $xml->xpath('element/item[@name="sql_database"]/@value');
    $xml_user = $xml->xpath('element/item[@name="sql_user"]/@value');
    $xml_password = $xml->xpath('element/item[@name="sql_password"]/@value');
    $xml_port = $xml->xpath('element/item[@name="sql_port"]/@value');

    $xml_upload_directory = $xml->xpath('element[@name="modules"]/item/item/item[@name="upload_directory"]/@value');

    $parameters = array();
    $parameters['host'] = $xml_host[0]->value;
    $parameters['scheme'] = $xml_scheme[0]->value;
    $parameters['database'] = $xml_database[0]->value;
    $parameters['user'] = $xml_user[0]->value;
    $parameters['password'] = $xml_password[0]->value;
    $parameters['port'] = $xml_port[0]->value;

    $parameters['upload_dir'] = $xml_upload_directory[0]->value;


    return $parameters;
}

function random($iLength) {
    list($t1, $t2) = explode(' ', microtime());
    $sSource = $t1 . $t2 . mt_srand((float) $t1 + ((float) $t2 * 100000));
    return hash_($sSource, $iLength);
}

function hash_($sSource, $iLength) {
    $sResult = "";
    $iCount = ceil(abs($iLength) / 32) + 1;

    for ($i = 0; $i < $iCount; $i++) {
        $sResult .= md5($i . $iCount . $iLength . $sSource);
    }

    $i = 0;
    while (is_numeric($sResult[$i])) {
        $i++;
    }

    return substr($sResult, $i, $iLength);
}

function createDir($dirName) {
    mkdir($dirName);
    umask(umask(0));
    chmod($dirName, 0770);
}

function getDirToUpload($upload_dir) {
    $absolute_path = $_SERVER['DOCUMENT_ROOT'];
    $sDir = $absolute_path . "/" . $upload_dir;

    if (!file_exists($sDir)) {
        createDir($upload_dir);
    }

    $sDir .= "/" . date("Y");
    if (!file_exists($sDir)) {
        createDir($sDir);
    }

    $sDir .= "/" . date("m");
    if (!file_exists($sDir)) {
        createDir($sDir);
    }

    $sDir .= "/" . date("d");
    if (!file_exists($sDir)) {
        createDir($sDir);
    }

    $sFullPath = $sDir . "/" . date("H");
    if (!file_exists($sFullPath)) {
        createDir($sFullPath);
    }

    $sFullPath = $sFullPath . "/" . random(10);
    createDir($sFullPath);

    return $sFullPath;
}

function uploadToDir($newFilePath, $file_id, $fileBinary) {
    file_put_contents($newFilePath . "/" . $file_id, $fileBinary, LOCK_EX);
}

function acl($pattern, $cur_struc_id) {
    $LOG_DIR = $_SERVER['DOCUMENT_ROOT'] . "/var/logs/wsUploads.log";    
    error_log("\nfunction acl", 3, $LOG_DIR);
    $acl_access = false;
    $aclpar = getParameters();
    $connection = "host=" . $aclpar['host'] . "  port=" . $aclpar['port'] . " dbname=" . $aclpar['database'] . " user=" . $aclpar['user'] . " password=" . $aclpar['password'];
    $pgconn = pg_connect($connection);
    $sql = "SET search_path TO " . $aclpar['scheme'];
    $query_result = pg_query($pgconn, $sql);
    error_log("\n$sql\n".  pg_last_error(), 3, $LOG_DIR);
    
    if (substr_count($pattern, "/^/col/^/") == 2) {
        error_log("\n/^/col/^/ - 2", 3, $LOG_DIR);
        $pattArr = explode("/^/col/^/", $pattern);
        $sql = "SELECT  path  FROM  structure  WHERE node_id = $cur_struc_id";
        $query_result = pg_query($pgconn, $sql);
        $row = pg_fetch_array($query_result);
        error_log("\n$sql\n".  pg_last_error(), 3, $LOG_DIR);
        if (strpos($row["path"], $pattArr[1]) !== false) {
            $acl_access = true;
        }
    } else if (substr_count($pattern, "/^/col/^/") == 3) {
        error_log("\n/^/col/^/ - 3", 3, $LOG_DIR);
        $pattArr = explode("/^/col/^/", $pattern);
        if ($pattArr[1] == $cur_struc_id)
            $acl_access = true;
    }

    return $acl_access;
}

$HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
$server->service($HTTP_RAW_POST_DATA);
?>
