<?php

if (!isset($_SERVER['PHP_AUTH_USER'])) {
    header('WWW-Authenticate: Basic realm="MSF Realm"');
    header('HTTP/1.0 401 Unauthorized');
    exit('Authentication was cancelled');
} else {
    DEFINE('__MSF', true);
    include_once '../../library/NuSoap/nusoap.php';

    $uri = "/ws/reference";
    $server = new nusoap_server('');
    $server->configureWSDL('reference', $uri);
    $server->wsdl->schemaTargetNamespace = 'urn:demo';
    $server->register(
            'slozhit', array('PoleSpravochnika' => 'xsd:string', 'Slagaemoe' => 'xsd:integer'), array('result' => 'xsd:string'), $uri);
    $server->register(
            'vichest', array('PoleSpravochnika' => 'xsd:string', 'Vichitaemoe' => 'xsd:integer'), array('result' => 'xsd:string'), $uri);
    $server->register(
            'zapis', array('PoleSpravochnika' => 'xsd:string', 'Znacheniye' => 'xsd:string'), array('result' => 'xsd:string'), $uri);

    function slozhit($PoleSpravochnika, $Slagaemoe) {
        $params = parseParameters($PoleSpravochnika);
        $sql_params = getParameters();
        $connection_string = "host=" . $sql_params['host'] . "  port=" . $sql_params['port'] . " dbname=" . $sql_params['database'] . " user=" . $sql_params['user'] . " password=" . $sql_params['password'];
        $pg_conn = pg_connect($connection_string);
        $sql = "SELECT  table_name  FROM  manuscript.references_config  WHERE  reference_id = $params[0]";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        $sql = "UPDATE  manuscript.$row[0]  SET $params[3] = ((SELECT  $params[3]  FROM  manuscript.$row[0] WHERE  id = $params[2]) + $Slagaemoe)  WHERE  id = $params[2]; commit;";
        //$sql = "UPDATE  manuscript.$row[0]  SET $params[3] = ($params[1] + $Slagaemoe)  WHERE  id = $params[2]; commit;";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        pg_free_result($query_result);
        pg_close($pg_conn);

        return "";
    }

    function vichest($PoleSpravochnika, $Vichitaemoe) {
        $params = parseParameters($PoleSpravochnika);
        $sql_params = getParameters();
        $connection_string = "host=" . $sql_params['host'] . "  port=" . $sql_params['port'] . " dbname=" . $sql_params['database'] . " user=" . $sql_params['user'] . " password=" . $sql_params['password'];
        $pg_conn = pg_connect($connection_string);
        $sql = "SELECT  table_name  FROM  manuscript.references_config  WHERE  reference_id = $params[0]";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        $sql = "UPDATE  manuscript.$row[0]  SET $params[3] = ((SELECT  $params[3]  FROM  manuscript.$row[0] WHERE  id = $params[2]) - $Vichitaemoe)  WHERE  id = $params[2]; commit;";
        //$sql = "UPDATE  manuscript.$row[0]  SET $params[3] = ($params[1] - $Vichitaemoe)  WHERE  id = $params[2]; commit;";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        pg_free_result($query_result);
        pg_close($pg_conn);

        return "";
    }
    
    function zapis($PoleSpravochnika, $Znacheniye) {
        $params = parseParameters($PoleSpravochnika);
        $sql_params = getParameters();
        $connection_string = "host=" . $sql_params['host'] . "  port=" . $sql_params['port'] . " dbname=" . $sql_params['database'] . " user=" . $sql_params['user'] . " password=" . $sql_params['password'];
        $pg_conn = pg_connect($connection_string);
        $sql = "SELECT  table_name  FROM  manuscript.references_config  WHERE  reference_id = $params[0]";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        $sql = "UPDATE  manuscript.$row[0]  SET $params[3] = '$Znacheniye'  WHERE  id = $params[2]; commit;";
        $query_result = pg_query($pg_conn, $sql);
        $row = pg_fetch_array($query_result);

        pg_free_result($query_result);
        pg_close($pg_conn);

        return "";
    }

    /*
     * returns
     * array[0] - Reference Id in 
     * array[1] - Reference Name Value
     * array[2] - Reference Row Id
     * array[3] - Reference Column Name
     */

    function parseParameters($parameters) {
        return explode("/^/col/^/", $parameters);
    }

    function getParameters() {
        $xml = simplexml_load_file('../../settings.xml');

        $xml_host = $xml->xpath('element/item[@name="sql_host"]/@value');
        $xml_scheme = $xml->xpath('element/item[@name="sql_scheme"]/@value');
        $xml_database = $xml->xpath('element/item[@name="sql_database"]/@value');
        $xml_user = $xml->xpath('element/item[@name="sql_user"]/@value');
        $xml_password = $xml->xpath('element/item[@name="sql_password"]/@value');
        $xml_port = $xml->xpath('element/item[@name="sql_port"]/@value');
        
        $sql_parameters = array();
        $sql_parameters['host'] = $xml_host[0]->value;
        $sql_parameters['scheme'] = $xml_scheme[0]->value;
        $sql_parameters['database'] = $xml_database[0]->value;
        $sql_parameters['user'] = $xml_user[0]->value;
        $sql_parameters['password'] = $xml_password[0]->value;
        $sql_parameters['port'] = $xml_port[0]->value;
        
        return $sql_parameters;
    }

    $HTTP_RAW_POST_DATA = isset($HTTP_RAW_POST_DATA) ? $HTTP_RAW_POST_DATA : '';
    $server->service($HTTP_RAW_POST_DATA);
}
?>