<?php

defined("__MSF")
        or die("Direct access is not allowed");

class MSF_Locale {

    private $aDictionary = array();

    public function __construct($sPath) {
        $this->loadDictionary($sPath);
    }

    public function loadDictionary($sPath) {
        $this->aDictionary = array_merge($this->aDictionary, parse_ini_file($sPath, true));
    }

    public function getWord($sName) {

        if (isset($this->aDictionary[$sName])) {
            return $this->aDictionary[$sName];
        } else {
            return $sName;
        }
    }

    public function getI18N($sString) {
        $rLabel = "";
        if(isset($_SESSION["MSF_UserBox"]["user"]))  
            $lan = $_SESSION["MSF_UserBox"]["user"]; 
        else
            $lan["language"] = "ru";        
        if (array_key_exists("language", $lan)) {
            if ($lan["language"] != "") {
                $lang = $lan["language"];
                $has_match = preg_match("/#$lang#.*#\/$lang#/", $sString, $locale_match);
                if ($has_match == 1) {
                    $rLabel = $locale_match[0];
                    $rLabel = str_replace("#$lang#", "", $rLabel);
                    $rLabel = str_replace("#/$lang#", "", $rLabel);
                } else {
                    $rLabel = $sString;
                }
            }
        }
        
        return $rLabel;
    }

    public function addWord($sName, $sValue) {
        $this->aDictionary[$sName] = $sValue;
    }

    public function getDictionary() {
        return $this->aDictionary;
    }

}

?>