<?php
/*
 * File: MSF_ServiceLoader.php
 * Created at: 15.01.2008
 */
defined("__MSF")
	or die("Direct access is not allowed");

/**
 * @package <package>
 * @author Detrix
 * @copyright Copyright (c) 2007, Detrix
 */
class MSF_ServiceLoader
{
	private $sModulesPath = "";

	public function __construct()
	{
		$this->sModulesPath = CNF_ABS_PATH . "/modules";
	}

	public function load()
	{
		$sModules = MSF_Dir::read($this->sModulesPath, "dir");
		foreach ($sModules AS $sModule) {
			$this->loadServices($this->sModulesPath . "/" . $sModule . "/services");
		}

	}

	private function loadServices($sServicesPath)
	{
		if (MSF_Dir::exists($sServicesPath)) {
			$aServices = MSF_Dir::read($sServicesPath, "file");
			foreach ($aServices AS $sService) {
				list($sClassname, $sExtension) = explode(".", $sService);
				if ($sExtension == "php") {
					include_once $sServicesPath . "/" . $sService;
					$Class 		= new ReflectionClass($sClassname);
					if ($this->verify($Class)) {
						$Service	= $Class->newInstance();
						$Service->execute();
					}

				}

			}

		}

	}

	public function verify($Class)
	{
		$bResult = false;
		foreach ($Class->getInterfaces() AS $Interface) {
			if ($Interface->getName() == "MSF_IService") {
				$bResult = true;
				break;
			}

		}

		return $bResult;
	}

}
?>