<?php

/*
 * File: 	MSF_WSControllerSupport.php
 * Date: 	01.07.2009
 * Time:	16:47:53
 * Detrix
 */

// [include]
include_once "library/NuSoap/nusoap.php";
// [/include]

/**
 * @package 	system
 */
class MSF_WSControllerSupport extends MSF_Mcap 
{
	/**
	 * @var soap_server
	 */
	protected $oService = null;
	
	protected $sURI		= "/ws/workflow";
	
	protected $aProcs	= array(
			"MSF_WSControllerSupport__stub" => array(
					"in" 	=> array('stub' 	=> 'xsd:integer'),
					"out"	=> array('return' 	=> 'xsd:integer')	
					)
					
			);
			
	final public function __construct()
	{
		$this->oService = new soap_server();
		$this->oService->decode_utf8 = false;
		$this->oService->soap_defencoding = 'UTF-8';
		// {protocol}://{server}/soapAction
		list($sProtocol) = explode("/", $_SERVER["SERVER_PROTOCOL"]);
		$sURI = strtolower($sProtocol) . "://" . $_SERVER['SERVER_NAME'] . $this->sURI;
		$this->oService->configureWSDL('detrix', 'urn:detrix', $sURI);
		$this->oService->wsdl->schemaTargetNamespace = 'urn:detrix';
		$this->initialize();
	}
	
	public function initialize()
	{		
					
		/*
                 * 
                 * 
		*/
	}
	
	private function addComplexType($sName, $aParams)
	{
		$this->oService->wsdl->addComplexType(
			$sName,
			$aParams["typeClass"],
			$aParams["phpType"],
			$aParams["compositor"],
			$aParams["restrictionBase"],
			$aParams["elements"],
			$aParams["attrs"],
			$aParams["arrayType"]			
		);
	}
	
	private function register($sName, $aParams, $aReturn)
	{
		$this->oService->register(
			$sName,
			$aParams,
		    $aReturn,
		    'urn:detrix',
		    'urn:detrix/' . $sName,
		    'rpc',
		    'encoded',  
		    ''
		);
		
	}
	
	final public function indexAction()
	{
		$this->service();
	}
	
	final public function wsdlAction()
	{
		$this->service();
	}
	
	private function service()
	{
		if (!isset($_SERVER['PHP_AUTH_USER']) || ($_SERVER['PHP_AUTH_USER'] != CNF_WS_LOGIN
			|| $_SERVER['PHP_AUTH_PW']) != CNF_WS_PASSWORD) {
		    header('WWW-Authenticate: Basic realm="MSF Realm"');
		    header('HTTP/1.0 401 Unauthorized');
		    echo 'Cancel';
		    exit;
		}
		else {		
			foreach ($this->aTypes AS $sName => $aBody) {
				$this->addComplexType($sName, $aBody);
			}
			
			foreach ($this->aProcs AS $sName => $aBody) {
				$this->register($sName, $aBody["in"], $aBody["out"]);
			}		
		    
			$this->oService->service(MSF_SL::getParam($GLOBALS, "HTTP_RAW_POST_DATA"));
		}			    
	}
	
	public function before()
	{}
	
	public function after()
	{}
	
	public function stub($iStubNumber)
	{
		return $iStubNumber * $iStubNumber;
	}

}
?>