<?php
abstract class MSF_Access
{
	const INHERIT 	= 0;
	
	const ALLOW		= 1;
	
	const DENY		= 2;

	private $oDb;
	
	final public function __construct(MSF_DB $oDb)
	{
		$this->oDb = $oDb;
		$this->initialize();
	}
	
	/**
	 * @return MSF_DB
	 */
	final protected function getDb()
	{
		return $this->oDb;
	}

	/**
	 * @return boolean
 	 */
	final public function hasAccess($sAccessType, $aStructurePath, $mParams, $iStartId = 0)
	{
		$bResult = false;
		//debug($mParams);
		if (isset($aStructurePath[$iStartId])) {			
			switch ($this->getAccessValue($sAccessType, $aStructurePath[$iStartId], $mParams)) {
				case self::INHERIT:
					$bResult = $this->hasAccess($sAccessType, $aStructurePath, $mParams, ($iStartId + 1));
					break;
				case self::ALLOW:
					$bResult = true;
					break;
				case self::DENY:
					$bResult = false;
					break;
			}

		}
		//debug($sAccessType, $aStructurePath, $mParams, $iStartId, $bResult);
		return $bResult;
	}
	
	/**
	 * 
	 */
	protected function initialize()
	{
		// You should inherit this method
	}

	/**
	 * Returs access value:
	 * - 0 inherit
	 * - 1 grant
	 * - 2 deny
	 * @return integer
	 */
	abstract protected function getAccessValue($sAccessType, $iStructureId, $mObjectId);
}
?>