<?php
include_once "MSF_ILicenseManager.php";
include_once "MSF_LicenseLoader.php";
include_once "MSF_LicenseParser.php";
include_once "MSF_LicenseCounter.php";
include_once "MSF_LicenseCounterDB.php";
include_once "MSF_LicenseCheckerFactory.php";

class MSF_LicenseManager implements MSF_ILicenseManager
{
	private $oData 		= null;

	private $oCounter 	= null;
	
	private $oChecker	= null;

	public function __construct(MSF_DB $oDb, $sLicenseFilePath)
	{
		$this->oCounter = $this->getCounter($oDb);
		$this->oData	= $this->parse($this->load($sLicenseFilePath));
		DEFINE('CNF_IS_CONCURRENT', $this->oData->get('is_concurrent'));
		
		$this->oChecker	= $this->getChecker();
		//DEFINE("MSF_LICENSE_OWNER", " — Detrix — " . $this->oData->get("owner"));		
		MSF_Registry::get("MSF_Locale")->addWord("MSF_LICENSE_OWNER", $this->oData->get("owner"));
		MSF_Registry::get("MSF_Locale")->addWord("MSF_LICENSE_NUMBER", (int)$this->oData->get("number"));
		DEFINE("MSF_NUMBER_OF_LICENSES", (int)$this->oData->get("number"));
	}
	
	public function execute()
	{
		if ($this->oChecker->isValid($this->oData)) {
			//$bResult = $this->oCounter->count() <= MSF_NUMBER_OF_LICENSES;
			$bResult = true;			
		}
		else {
			$bResult = false;
		}

		return $bResult;
	}
	
	private function getChecker()
	{
		return MSF_LicenseCheckerFactory::create("md5");
	}
	
	private function getCounter(MSF_DB $oDb)
	{
		$oCounterDb = new MSF_LicenseCounterDB($oDb);
		return new MSF_LicenseCounter($oCounterDb);
	}

	private function load($sLicenseFilePath)
	{
		$oLoader = new MSF_LicenseLoader();
		return $oLoader->load($sLicenseFilePath);
	}
	
	private function parse($sContent)
	{
		$oParser = new MSF_LicenseParser();
		return $oParser->parse($sContent);
	}

}
?>