<?php
	define("__MSF", true);	
	include_once "system/shedule/library/MSF_Shedule.php";
	include_once "system/MSF_ThrowableException.php";
	include_once "system/MSF_IOException.php";
	include_once "system/utils/MSF_XmlWrapper.php";
	include_once "system/utils/MSF_File.php";
	
	$sDirName	= dirname(__FILE__);
	$sConfPath	= $sDirName . "/settings.ini";
	$sLockFile	= $sDirName . "/lockme.tmp";
	
	if(MSF_FILE::exists($sLockFile)) {
		fputs(STDERR, "Demon already running. To run again remove 'lockme.tmp'.\n");
		exit();
	}
	$rHandle	= fopen($sLockFile, "w");
	fwrite($rHandle, "run!");
	
	if(!MSF_FILE::exists($sConfPath)) {
		fputs(STDERR, "Config file not found.\n");
		exit();
	}
	$aConf	= parse_ini_file($sConfPath);
	
	if(!chdir($aConf["dir_root"])) {
		fputs(STDERR, "Can`t change dir.\n");
		exit();
	}	
	
	
	if(pcntl_fork()) {
		die();
	}
	posix_setsid();
	if(pcntl_fork()) {
		die();
	}
		
	try {
		$Shedule	= new MSF_Shedule($aConf);
		$Shedule->run();
	}
	catch(Exception $e) {
		fputs(STDERR, $e->getMessage() . "\n");
		MSF_File::remove($sLockFile);
	}
	
?>