<?php
defined("__MSF")
	or die("Direct access is not allowed");

abstract class MSF_TestUnit
{
	private $aMessages		= "";

	private $bProcessed 	= true;

	final public function __construct()
	{}

	final public function __clone()
	{}

	final public function addMessage($sType, $sStatus, $sMessage)
	{
		try {
			throw new Exception("no message");
		}
		catch (Exception $e) {
			$aTraces 	= $e->getTrace();
	 		if (isset($aTraces[2]) && isset($aTraces[2]["line"])) {
	 			$sType = $sType . "#" . $aTraces[2]["line"];
	 		}

 		}

		$this->aMessages[] = array
		(
			"type"		=> $sType,
			"status" 	=> $sStatus,
			"message" 	=> $sMessage

		);

	}

	final public function assertTrue($bValue, $sMessage = '')
	{
		return $this->process("assertTrue", $bValue, $sMessage);

	}

	final public function pass($sMessage = "")
	{
		return $this->process("pass", true, $sMessage);
	}

	final public function fail($sMessage = "")
	{
		return $this->process("fail", false, $sMessage);
	}

	final public function assertFalse($bValue, $sMessage = '')
	{
		return $this->process("assertFalse", !$bValue, "[" . serialize($bValue) . "] " . "\r\n" . $sMessage);

	}

	final public function assertObject($mVar, $sMessage = '')
	{
		return $this->process("assertObject", is_object($mVar), "[" . serialize($mVar) . "] " . "\r\n" . $sMessage);
	}

	final public function assertNull($mVar, $sMessage = '')
	{
		return $this->process("assertNull", is_null($mVar), "[" . serialize($mVar) . "] " . "\r\n" . $sMessage);
	}

	final public function assertEquals($mValue1, $mValue2, $sMessage = '')
	{
		return $this->process("assertEquals", (($mValue1 == $mValue2) ? true : false), "[" . serialize($mValue1) .' == '. serialize($mValue2) . '] ' . "\r\n" . $sMessage);

	}

	final public function process($sType, $bValue, $sMessage = "")
	{
		if ($bValue === true) {
			//$this->addMessage($sType, "passed", $sMessage);
			return true;
		}
		else {
			$this->bProcessed = false;
			$this->addMessage($sType, "failed", $sMessage);
			return false;
		}

	}

	final public function getMessages()
	{
		return $this->aMessages;
	}

	final public function getStatus()
	{
		return ($this->bProcessed) ? "passed" : "failed";
	}

	final public function getBooleanStatus()
	{
		return $this->bProcessed;
	}

	final public function debug($mVar)
	{
		echo "\n";
		print_r($mVar);
		echo "\n";
	}

	abstract public function setUp();

	abstract public function setDown();

	abstract public function test();

}


?>