<?php
/**
 * @author T. Anre
 */
class MSF_Cache
{
	/**
	 * @var Memcache
	 */
	private $oMc	= null;
	
	private $sName;
	
	/**
	 * @var string
	 */
	private $sHost;
	
	/**
	 * @var integer
	 */
	private $sPort;
	
	/**
	 * @var array
	 */
	private $aCache = array();
	
	/**
	 * @var MSF_Cache
	 */
	private static $oInstance = null;
	
	/**
	 * @var boolean
	 */
	private $isEnabled;
	
	/**
	 * @return MSF_Cache
	 */
	public static function getInstance()
	{
		if (self::$oInstance == null) {
			self::$oInstance = new self();
		}
		
		return self::$oInstance;
	}
	
	/**
	 * @return boolean 
	 */
	public function isEnabled()
	{
		return $this->isEnabled;
	}
	
	/**
	 * @return void
	 */
	public function set($sName, $mValue)
	{
		$this->aCache[$sName] = $mValue;
	}

	/**
	 * @return boolean
	 */
	public function has($sName)
	{
		return isset($this->aCache[$sName]);
	}
	
	/**
	 * @retunr mixed
	 */
	public function get($sName)
	{
		if ($this->has($sName)) {
			return $this->aCache[$sName];
		}
		else {
			return null;
		}
	
	}
	
	/**
	 * @return void
	 */
	public function connect($sHost, $sPort)
	{
		$this->sHost = $sHost;
		$this->sPort = $sPort;
		if ($this->oMc == null) {
			$this->oMc 		 = new Memcache();
			$this->oMc->connect($sHost, $sPort);
			$this->isEnabled = true;
		}

	}
	
	public function serializeAndSave()
	{
		if ($this->sHost && $this->sPort) {
			$_SESSION['MSF_Cache'] 				= array();
			$_SESSION['MSF_Cache']['host'] 		= $this->sHost;
			$_SESSION['MSF_Cache']['port'] 		= $this->sPort;
			$this->oMc->set($this->sName, serialize($this->aCache), MEMCACHE_COMPRESSED);
		}
		
	}
	
	private function __construct()
	{
		// msf.lcl.MSF_Cache
		$this->sName = $_SERVER["SERVER_NAME"] . '.MSF_Cache';
		if (isset($_SESSION['MSF_Cache']) && $_SESSION['MSF_Cache']['host'] && $_SESSION['MSF_Cache']['port']) {
			$this->connect($_SESSION['MSF_Cache']['host'], $_SESSION['MSF_Cache']['port']);
			$this->aCache 		= unserialize($this->oMc->get($this->sName));
			$this->isEnabled 	= true;
		}
		else {
			$this->isEnabled 	= false;
		}
		
	}
	
}

?>