<?php
/*
 * Created on 04.05.2007
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */

defined("__MSF")
	or die ("Direct access is not allowed");

include_once "MSF_DirNotFoundException.php";

final class MSF_Dir
{
	public static function exists($sDirpath)
	{
		return is_dir($sDirpath);
	}

	/**
	 * @throws MSF_DirNotFoundException
	 * @return array(list)
	 */
	public static function read($sDirpath, $sType = "")
	{
		$aResult = array();
		if (!self::exists($sDirpath)) {
			throw new MSF_DirNotFoundException($sDirpath);
		}
		else if ($rDirPointer = opendir($sDirpath)) {
	  		while (false !== ($sName = readdir($rDirPointer))) {
	  			switch (true) {
	  				case ($sName == ".") || ($sName == ".."):
	  					// do nothing
	  					break;

	  				case ($sType == "dir"):
	  					if (is_dir($sDirpath . "/" . $sName)) {
	  						array_push($aResult, $sName);
	  					}
	  					break;

	  				case ($sType == "file"):
	  					if (is_file($sDirpath . "/" . $sName)) {
	  						array_push($aResult, $sName);
	  					}
	  					break;

	  				default:
	  					array_push($aResult, $sName);
	  					break;

	  			}

	  		}

	  		closedir($rDirPointer);
		}

		return $aResult;
	}

	public static function create($sDirname)
	{
		$iUmask = umask(0);
		try {
			mkdir($sDirname);
			umask($iUmask);
			chmod($sDirname, 0770);
		}
		catch (Exception $e) {
			throw new MSF_DirNotFoundException("Can`t create dir '" . $sDirname . "'\n" . $e->getMessage());
		}
		
	}
	
	public function remove($sDirname)
	{
		if (!self::exists($sDirname)) {
			throw new MSF_DirNotFoundException($sDirname);
		}

		$aFiles	= self::read($sDirname);
		foreach($aFiles as $sFile) {
			$sPath	= $sDirname . "/" . $sFile;
			if(is_dir($sPath)) {
				self::remove($sPath);	
			}
			else {
				unlink($sPath);
			}
			
		}
		
		return rmdir($sDirname);
	}
        
        //функция для очистики 
        //написана для очистки кэша
        function cleanDirectory($path)
        {
            if (substr($path, strlen($path)-1, 1) != '/') $path .= '/'; 
            if ($handle = @opendir($path)){ 
                while ($obj = readdir($handle)){ 
                    if ($obj != '.' && $obj != '..'){ 
                        if (is_dir($path.$obj)){ 
                            if (!$this->cleanDirectory($path.$obj)) {
                                return false; 
                            }
                        } elseif (is_file($path.$obj)){ 
                                if (!unlink($path.$obj))    return false; 
                            } 
                    } 
                } 
                closedir($handle); 
                return true; 
            } 
            return false; 
        }

}

?>