<?php
/*
 * Created on 04.05.2007
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */

defined("__MSF")
	or die ("Direct access is not allowed");

include_once "MSF_FileNotFoundException.php";

final class MSF_File
{
	/**
	 * @throws MSF_FileNotFoundException
	 * @throws MSF_IOException
	 * @return string
	 */
	public static function read($sFilepath, $sMode = "rb")
	{
		$sData = "";
		
		if (!self::exists($sFilepath)) {
			throw new MSF_FileNotFoundException($sFilepath);
		}
		else if ($rFileLink = @fopen($sFilepath, $sMode)) {
			$iSize = filesize($sFilepath);
			
			if ($iSize > 0) {
				flock($rFileLink, LOCK_SH);
			 	$sData = @fread($rFileLink, $iSize);
				flock($rFileLink, LOCK_UN);
			 	fclose($rFileLink);
			}
		}
		else {
			throw new MSF_IOException("Can't read file " . $sFilepath);
		}

		return $sData;
	}

	/**
	 * @throws MSF_FileNotFoundException
	 * @throws MSF_IOException
	 * @return void
	 */
	public static function write($sFilepath, $sData, $sMode = "w", $bChmod = null)
	{
		if (!self::exists($sFilepath)) {
			$rFileLink = @fopen($sFilepath, $sMode);
			fclose($rFileLink);
			if(!is_null($bChmod)) {
				chmod($sFilepath, $bChmod);
			}
			
		}
		
		if ($rFileLink = @fopen($sFilepath, $sMode)) {
			flock($rFileLink, LOCK_EX);
			set_file_buffer($rFileLink, 0);
			@fwrite($rFileLink, $sData);
			fflush($rFileLink);
			flock($rFileLink, LOCK_UN);
			fclose($rFileLink);
			

		}
		else {
			throw new MSF_IOException("Can't write to file " . $sFilepath);
		}

	}

	public static function exists($sFilepath)
	{
		return ((file_exists($sFilepath) == true) && (is_readable($sFilepath) == true));
	}

	public static function copy($sOldPath, $sNewPath)
	{
		return copy($sOldPath, $sNewPath);
	}
	
	public static function move($sOldPath, $sNewPath)
	{
		return rename($sOldPath, $sNewPath);
	}
	
	public static function remove($sFile)
	{
		if(!self::exists($sFile)) {
			throw new MSF_FileNotFoundException($sFile);
		}
		
		return unlink($sFile);
	}
	
}

?>