<?php
/**
 * JSON wrapper
 * Created on 10.05.2007
 */
final class MSF_Json
{
	/**
	 * Encode to JSON
	 * @param mixed $mVar Source variable
	 * @public
	 * @static
	 * @return string
	 */
	public static function encode($mVar)
	{
		$mPrepared = self::prepare($mVar);
		return json_encode($mPrepared);
	}
	
	private static function prepare($mVar)
	{
		if (is_array($mVar)) {
			foreach ($mVar AS $sKey => $mValue) {
				$mVar[$sKey] = self::prepare($mValue);
			}
			
		}
		else {
			$mVar = str_replace('&quot;', '&amp;quot;', $mVar);
		}
		
		return $mVar;
	}

	/**
	 * Decodes a JSON string
	 * @param mixed $sJson The json string being decoded.
	 * @param boolean $isAssoc optional When TRUE, returned objects will be converted into associative arrays
	 * @public
	 * @static
	 * @return mixed
	 */
	public static function decode($sJson, $isAssoc = true)
	{
		return json_decode($sJson, $isAssoc);
	}

}

?>
