<?php

/*
 * File: MSF_Date.php
 * Created at: 01.02.2010
 */
defined("__MSF")
	or die("Direct access is not allowed");

/**
 * @package MSF_Core
 * @author Detrix
 * @copyright Copyright (c) 2010, Detrix
 */
class MSF_Logger 
{
	public static function logMessage($sMessage, $type = "user") 
	{
		$oDate = new MSF_Date();
		$sFile = "";
                $sEntry = "";
                if($type == "user"){
                    $sFile = CNF_ABS_PATH . "/var/logs/user-".$oDate->format("Ymd").".log";
                    $sEntry = 	$oDate->formatTimestamp() . "\t" . 
					MSF_CLIENT . "\t" .
					(IS_REQUEST ? "POST" : "GET") . "\t" .
					MSF_SL::getParam($_GET, "msf_path") . "\t" .
					$sMessage . "\r\n";
                } else if($type == "cron"){
                    $sFile = CNF_ABS_PATH . "/var/logs/cron-".$oDate->format("Ymd").".log";
                    $sEntry = $sMessage . "\r\n";
                }
		
		MSF_File::write($sFile, $sEntry, "a+", 0775);
	}
	
	public static function logTrace(Exception $oException, $type = "user") 
	{
		$sMsg 	= get_class($oException) . ": " . $oException->getMessage(). "\r\n";
		$aTrace = $oException->getTrace();
		$iSize = count($aTrace);
		for ($i = 0; $i < $iSize; $i++) {
			$sMsg 	.= ((array_key_exists("file", $aTrace[$i])) 	? $aTrace[$i]["file"] 	: "?") 	. " "
					.  ((array_key_exists("line", $aTrace[$i])) 	? $aTrace[$i]["line"] 	: "?");
			if ($i < $iSize - 1) {
				$sMsg .= "\r\n";
			}
			
		}
		self::logMessage($sMsg, $type);
	}
	
}
