<?php
/*
 * Created on 04.05.2007
 *
 * To change the template for this generated file go to
 * Window - Preferences - PHPeclipse - PHP - Code Templates
 */

defined("__MSF")
	or die ("Direct access is not allowed");

/**
 * @cut specialChars2Utf
 * @cut debug // debug
 * @cut string2list
 * @cut timeZoneOffset // maybe use as const? body: time() + 3600 * CNF_TIME_ZONE;
 * @cut parseINI
 * @cut serialize look MSF_Serialization::serialize()
 * @cut unserialize look MSF_Serialization::unserialize()
 * @cut serializeParam look MSF_Serialization::serialize()
 * @cut unserializeParam look MSF_Serialization::unserialize()
 * @cut specialCharsEncode look MSF_SpecialChars::encode()
 * @cut specialCharsDecode look MSF_SpecialChars::decode()
 * @cut escapeString look
 * @cut convert look MSF_Charset::convert()
 * @cut generateString look self::getString
 */
final class MSF_SL
{
	public static function getParam(&$aSource, $sParamName, $mDefaultValue = null)
	{
		$mResult = "";
		if (isset($aSource[$sParamName]) == true) {
			if (is_string($aSource[$sParamName]) == true) {
				/*
				if ($bSafe) {
					if (get_magic_quotes_gpc() == 1) {
						$mResult = stripslashes($aSource[$sParamName]);
					}
					else {
						$mResult = $aSource[$sParamName];
					}
				}
				else {
					$mResult = MSF_String::encodeSpecialChars($aSource[$sParamName]);
				}
				*/
				$mResult = trim($aSource[$sParamName]);
			}
			else {
				$mResult = $aSource[$sParamName];
			}

		}
		else {
			$mResult = $mDefaultValue;
		}

		return $mResult;
	}

	public static function getMicrotime()
	{
		list($fMSec, $fSec) = explode(' ', microtime());
		return (float) $fMSec + (float) $fSec;
	}

	public static function hash2dom($sName, $aHash, $sType = "attrs")
    {
    	$Element = MSF_Registry::get("MSF_Template")->createElement($sName);

		switch ($sType) {
			case "attrs":
				foreach ($aHash AS $k => $v) {
					$Element->setAttribute($k, $v);
				}
				break;
			case "tags":
				foreach ($aHash AS $k => $v) {
					$Element->appendChild(new DOMElement($k, $v));
				}
				break;
		}

		return $Element;
    }

    public static function hashlist2dom($sName, $sItemName, $aList, $sType = "attrs")
    {
    	$Element = MSF_Registry::get("MSF_Template")->createElement($sName);

        foreach ($aList AS $v) {
            $Element->appendChild(MSF_SL::hash2dom($sItemName, $v, $sType));
        }

        return $Element;
    }

    public static function array2dom($aInput, $sName = "item")
    {
    	$Template	= MSF_Registry::get("MSF_Template");
    	$Element 	= $Template->createElement($sName);
    
    	if(is_array($aInput)) {
	    	foreach($aInput as $sName=>$mValue) {
	    		$Item	= $Template->createElement("item");
	    		$Item->setAttribute("name", $sName);
	    		
	    		if(!is_array($mValue)) {
	    			$Item->setAttribute("value", $mValue);
	    		}
	    		else {
	    			$TmpItem	= self::array2dom($mValue);
	    			$Item->appendChild($TmpItem);
	    		}
	    		
	    		$Element->appendChild($Item);
	    	}
    	}
    	
    	
    	return $Element;
    }
    
    public static function slashXml($sString, $bSpecialChars = false)
    {
    	$Wrapper 	= new MSF_XmlWrapper($sString);
		$NewWrapper = new MSF_XmlWrapper();
		
		foreach ($Wrapper as $Data) {
			$NewWrapper->set(
				self::slashString($Data->getName(), $bSpecialChars),
				self::slashArray($Data->getValue(), $bSpecialChars),
				self::slashString($Data->getTitle(), $bSpecialChars)
			);
		}
		
		return $NewWrapper->getXml();
    }
    
    public static function slashArray($aArray, $bSpecialChars = false)
    {
    	$aResult = array();
    	
    	foreach ($aArray as $sKey => $mValue) {
    		if (is_array($mValue)) {
    			$aResult[$sKey] = self::slashArray($mValue, $bSpecialChars);
    		}
    		else {
    			$aResult[$sKey] = self::slashString($mValue, $bSpecialChars);
    		}
    	}
    	
    	return $aResult;
    }
    
    public static function slashString($sString, $bSpecialChars = false)
    {
    	$sString = ($bSpecialChars) ? htmlspecialchars($sString) : $sString;
    	$sString = str_replace(
    		array("'", "\""),
    		array("\'", "\\\""),
    		$sString
    	);
    	
    	return $sString;
    }
}

?>