<?php
/*
 * File: MSF_SpecialChars.php
 * Created at: 04.01.2008
 */
defined("__MSF")
	or die("Direct access is not allowed");

	
require_once "Crypt/Blowfish.php";
	
/**
 * @package MSF_Core
 * @author Detrix
 * @copyright Copyright (c) 2007, Detrix
 */
class MSF_String
{
	private static $sSuperDuperSecretKey	= "!-eeflslskdjfla;456864~}{fjkdlswkfkll@#$%#$9f0sf8a723#@";
	
	public static function addSlashes($sString)
	{
		return addslashes($sString);
	}

	public static function stripSlashes($sString)
	{
		return stripslashes($sString);
	}
	
	public function recursiveAddSlashes($aArray)
	{
		$aReturn	= array();
		foreach($aArray as $sKey=>$mValue) {
			if(is_array($mValue)) {
				$aReturn[$sKey]	= self::recursiveAddSlashes($mValue);
			}
			else {
				$aReturn[$sKey]	= self::addSlashes($mValue);
			}
			
		}
		
		return $aReturn;
	}
	
	// This is fucking stub one
	public static function encodeSpecialChars($sString)
	{
		return self::addSlashes($sString);
	}

	// This is fucking stub two
	public static function decodeSpecialChars($sString)
	{
		return self::stripSlashes($sString);
	}

	public static function encodeSpecialCharsFull($sString)
	{
		$sString = htmlspecialchars($sString);
		$sString = self::addSlashes($sString);
		$sString = str_replace("#","&#37;", $sString);
		return $sString;
	}

	public static function decodeSpecialCharsFull($sString)
	{
		$sString = str_replace("&#37;", "#", $sString);
		$sString = self::stripSlashes($sString);
		$sString = htmlspecialchars_decode($sString);
		return $sString;
	}

	public static function random($iLength)
	{
		$sResult 	= '';
		$iCount 	= ceil(abs($iLength)/32) + 1;
		list($t1, $t2) = explode(' ', microtime());
		$sSource = $t1 . $t2 . mt_srand((float) $t1 + ((float) $t2 * 100000));
		return self::hash($sSource, $iLength);

	}

	public static function hash($sSource, $iLength)
	{
		$sResult 	= "";
		$iCount 	= ceil(abs($iLength)/32) + 1;

		for ($i = 0; $i < $iCount; $i++) {
			$sResult .= md5($i . $iCount . $iLength . $sSource);
		}

		$i = 0;
		while (is_numeric($sResult[$i])) {
			$i++;
		}

		return substr($sResult, $i, $iLength);

	}
	
	public static function encrypt($sStr)
	{
		$sReturn	= "";
		if(trim((string)$sStr) != "") {
			$BlowFish	= new Crypt_Blowfish(self::$sSuperDuperSecretKey);
			$sReturn	= base64_encode(trim($BlowFish->encrypt($sStr)));
		}
		
		return $sReturn;
	}

	public static function decrypt($sStr)
	{
		$sReturn	= "";
		if(trim((string)$sStr) != "") {
			$BlowFish	= new Crypt_Blowfish(self::$sSuperDuperSecretKey);
			$sReturn	= trim($BlowFish->decrypt(base64_decode($sStr)));
		}

		return $sReturn;
	}
	

	public static function unescape($sEscapedString)
	{
		$aTable = array(
		' ' => '%u0020',
		'!' => '%21',
		',' => '%2C',
		':' => '%3A',
		';' => '%u003B',
		'=' => '%u003D',
		'"' => '%u0022',
		'>' => '%u003E',
		'<' => '%u003C',
		'\'' =>'%u0027',
		'/' => '%u002F',
		'_' => '%u005F',
		'|' => '%u007C',
		'.' => '%u002E',
		'?' => '%u003F',
		'-' => '%u002D',
		'№' => '%u2116',
		'0' => '%u0030',
		'1' => '%u0031',
		'2' => '%u0032',
		'3' => '%u0033',
		'4' => '%u0034',
		'5' => '%u0035',
		'6' => '%u0036',
		'7' => '%u0037',
		'8' => '%u0038',
		'9' => '%u0039',
		'a' => '%u0061',
		'b' => '%u0062',
		'c' => '%u0063',
		'd' => '%u0064',
		'e' => '%u0065',
		'f' => '%u0066',
		'g' => '%u0067',
		'h' => '%u0068',
		'i' => '%u0069',
		'j' => '%u006A',
		'k' => '%u006B',
		'l' => '%u006C',
		'm' => '%u006D',
		'n' => '%u006E',
		'o' => '%u006F',
		'p' => '%u0070',
		'q' => '%u0071',
		'r' => '%u0072',
		's' => '%u0073',
		't' => '%u0074',
		'u' => '%u0075',
		'v' => '%u0076',
		'w' => '%u0077',
		'x' => '%u0078',
		'y' => '%u0079',
		'z' => '%u007A',
		'А' => '%u0410',
		'Б' => '%u0411',
		'В' => '%u0412',
		'Г' => '%u0413',
		'Д' => '%u0414',
		'Е' => '%u0415',
		'Ё' => '%u0401',
		'Ж' => '%u0416',
		'З' => '%u0417',
		'И' => '%u0418',
		'Й' => '%u0419',
		'К' => '%u041A',
		'Л' => '%u041B',
		'М' => '%u041C',
		'Н' => '%u041D',
		'О' => '%u041E',
		'П' => '%u041F',
		'Р' => '%u0420',
		'С' => '%u0421',
		'Т' => '%u0422',
		'У' => '%u0423',
		'Ф' => '%u0424',
		'Х' => '%u0425',
		'Ц' => '%u0426',
		'Ч' => '%u0427',
		'Ш' => '%u0428',
		'Щ' => '%u0429',
		'Ъ' => '%u042A',
		'Ы' => '%u042B',
		'Ь' => '%u042C',
		'Э' => '%u042D',
		'Ю' => '%u042E',
		'Я' => '%u042F',
		'а' => '%u0430',
		'б' => '%u0431',
		'в' => '%u0432',
		'г' => '%u0433',
		'д' => '%u0434',
		'е' => '%u0435',
		'ё' => '%u0451',
		'ж' => '%u0436',
		'з' => '%u0437',
		'и' => '%u0438',
		'й' => '%u0439',
		'к' => '%u043A',
		'л' => '%u043B',
		'м' => '%u043C',
		'н' => '%u043D',
		'о' => '%u043E',
		'п' => '%u043F',
		'р' => '%u0440',
		'с' => '%u0441',
		'т' => '%u0442',
		'у' => '%u0443',
		'ф' => '%u0444',
		'х' => '%u0445',
		'ц' => '%u0446',
		'ч' => '%u0447',
		'ш' => '%u0448',
		'щ' => '%u0449',
		'ъ' => '%u044A',
		'ы' => '%u044B',
		'ь' => '%u044C',
		'э' => '%u044D',
		'ю' => '%u044E',
		'я' => '%u044F'
		);

		$aFlippedTable = array_flip($aTable);
		return strtr($sEscapedString, $aFlippedTable);
	}
	
	public static function breakingLongWords($sText)
	{
		$sTextResult	= '';
		$sDelimiter		= ' ';
		$sWordDelimiter	= '<wbr/>';
		$aText 			= preg_split("%(<.*?>)%is", $sText, -1, PREG_SPLIT_DELIM_CAPTURE);
		for($i = 0; $i < count($aText); $i++)
		{
			if($i & 1) {
				$sTextResult .= $aText[$i];
			}
			else {
				foreach (explode($sDelimiter, $aText[$i]) AS $sWord) {		
					$iWordLength 	= mb_strlen($sWord);
					$iMaxWordLength	= 60;
					$sTemp			= '';
					if ($iWordLength > $iMaxWordLength) {						
						// это просто ппц костыль
						$aLetters = array();
						preg_match_all('/&#?[a-z0-9]+;|./iu', $sWord, $aLetters);
						$aLetters = MSF_SL::getParam($aLetters, 0, array());
						for ($j = 0; $j < count($aLetters); $j++) {
							$sLetter 	  = $aLetters[$j];
							if ($j == ($iMaxWordLength - 1)) {
								$sTemp .= $sLetter . $sWordDelimiter;
								$iMaxWordLength = $iMaxWordLength + 60;
							}
							else {
								$sTemp .= $sLetter;
							}					 
						}
						
					}
					else {
						$sTemp = $sWord . $sDelimiter;
					}
		
					$sTextResult .= $sTemp;
				}
			}
		}

		return $sTextResult;
	}
	
}
?>