<?php
require_once "MSF_IXmlWrapper.php";
require_once "MSF_XmlWrapperData.php";
require_once "MSF_IXmlWrapperHandler.php";
require_once "MSF_XmlWrapperException.php";
require_once 'MSF_HtmlEntities.php';
/**
 * TODO add
 * TODO set
 */
class MSF_XmlWrapper implements MSF_IXmlWrapper 
{
	/**
	  * Array  (
           *    [0] => xxx
	  * ) 
	  */
	private $aIds		= array();
	
	/**
	  * Array (
      *    [xxx] => Array (  
      *             [title] => title,
	  *	      		[type]	=> array,
      *            	[value] => Array   (
      *            			[yyy] 	=> zzz
      *            			)
	  *
	  *     )
	  *
	  * ) 
	  */
	private $aData		= array();
	
	private $iCounter	= 0;
	
	public static function xmlToArray($sXml)
	{
		$Xw = new MSF_XmlWrapper($sXml);
		return $Xw->getAsArray();
	}
	
	public function __construct($sXml = null)
	{
		$isDbExisted = false;
		if(MSF_Registry::exists('MSF_DB')) {
			$isDbExisted = true;
			$oDbCache = new MSF_DbCache();
		}
		
		if (empty($sXml)) {
			$sXml = '<document/>';
		}
		else {
			$s = md5($sXml);
			if ($isDbExisted && $oDbCache->isExisted($s)) {
				list($this->aIds, $this->aData, $this->iCounter) = $oDbCache->get($s);//$_SESSION['xcache'][$s];
			}
			else {
				$oXml 	= new SimpleXMLElement($this->xmlEntities($sXml));
				$i		= 0;
				foreach ($oXml AS $oElm) {
					$aAttrs = $this->getAttrs($oElm);
					if (!isset($aAttrs['name'])) {
						$aAttrs['name'] = $i++;
					}
					$this->reId($aAttrs['name']);
					$this->aData[$aAttrs['name']] 				= array();
					if (isset($aAttrs['type'])) {
						$this->aData[$aAttrs['name']]['type'] 	= $aAttrs['type'];
					}
					else {
						$this->aData[$aAttrs['name']]['type'] 	= 'string';
					}
					
					if (isset($aAttrs['title'])) {
						$this->aData[$aAttrs['name']]['title'] 	= $aAttrs['title'];
					}
					else {
						$this->aData[$aAttrs['name']]['title'] 	= '';
					}
					
					if (isset($aAttrs['value'])) {
						$this->aData[$aAttrs['name']]['value'] = $aAttrs['value'];
					}
					else if ($aAttrs['type'] == self::TYPE_ARRAY) {
						$this->aData[$aAttrs['name']]['value'] = $this->buildArr($oElm);
					}
		
				}
				
				if($isDbExisted) {
					$oDbCache->set($s, array($this->aIds, $this->aData, $this->iCounter));
				}
				
			}
			
		}

	}
	
	public function xmlEntities($str)
	{
	    $xml 	= array('&#34;','&#38;','&#38;','&#60;','&#62;','&#160;','&#161;','&#162;','&#163;','&#164;','&#165;','&#166;','&#167;','&#168;','&#169;','&#170;','&#171;','&#172;','&#173;','&#174;','&#175;','&#176;','&#177;','&#178;','&#179;','&#180;','&#181;','&#182;','&#183;','&#184;','&#185;','&#186;','&#187;','&#188;','&#189;','&#190;','&#191;','&#192;','&#193;','&#194;','&#195;','&#196;','&#197;','&#198;','&#199;','&#200;','&#201;','&#202;','&#203;','&#204;','&#205;','&#206;','&#207;','&#208;','&#209;','&#210;','&#211;','&#212;','&#213;','&#214;','&#215;','&#216;','&#217;','&#218;','&#219;','&#220;','&#221;','&#222;','&#223;','&#224;','&#225;','&#226;','&#227;','&#228;','&#229;','&#230;','&#231;','&#232;','&#233;','&#234;','&#235;','&#236;','&#237;','&#238;','&#239;','&#240;','&#241;','&#242;','&#243;','&#244;','&#245;','&#246;','&#247;','&#248;','&#249;','&#250;','&#251;','&#252;','&#253;','&#254;','&#255;', '&#149;');
	    $html 	= array('&quot;','&amp;','&amp;','&lt;','&gt;','&nbsp;','&iexcl;','&cent;','&pound;','&curren;','&yen;','&brvbar;','&sect;','&uml;','&copy;','&ordf;','&laquo;','&not;','&shy;','&reg;','&macr;','&deg;','&plusmn;','&sup2;','&sup3;','&acute;','&micro;','&para;','&middot;','&cedil;','&sup1;','&ordm;','&raquo;','&frac14;','&frac12;','&frac34;','&iquest;','&Agrave;','&Aacute;','&Acirc;','&Atilde;','&Auml;','&Aring;','&AElig;','&Ccedil;','&Egrave;','&Eacute;','&Ecirc;','&Euml;','&Igrave;','&Iacute;','&Icirc;','&Iuml;','&ETH;','&Ntilde;','&Ograve;','&Oacute;','&Ocirc;','&Otilde;','&Ouml;','&times;','&Oslash;','&Ugrave;','&Uacute;','&Ucirc;','&Uuml;','&Yacute;','&THORN;','&szlig;','&agrave;','&aacute;','&acirc;','&atilde;','&auml;','&aring;','&aelig;','&ccedil;','&egrave;','&eacute;','&ecirc;','&euml;','&igrave;','&iacute;','&icirc;','&iuml;','&eth;','&ntilde;','&ograve;','&oacute;','&ocirc;','&otilde;','&ouml;','&divide;','&oslash;','&ugrave;','&uacute;','&ucirc;','&uuml;','&yacute;','&thorn;','&yuml;', '&bull;');
	    $str 	= str_ireplace($html,$xml,$str);
	    return $str;
	} 

	/**
	 * @param string $sName
	 * @return MSF_XMLWrapperData
	 */
	public function get($sName)
	{
		$oData = new MSF_XMLWrapperData($sName);
		if (isset($this->aData[$sName])) {
			$aData = $this->aData[$sName];
			$oData->setType($aData['type']);
			$oData->setTitle($aData['title']);
			$oData->setValue($aData['value']);
		}

		return $oData;
	}
	
	public function getById($iId) 
	{
		if (($iId >= 0) && ($iId < $this->getLength())) {
			return $this->get($this->aIds[$iId]);
		}
		else {
			return new MSF_XMLWrapperData('');	
		}
		
	}

	public function getLength()
	{
		return count($this->aData);
	}

	public function rewind()
	{
		$this->iCounter = 0;
	}

	/**
	 * @return MSF_XMLWrapperData
	 */
	public function current()
	{
		return $this->getById($this->iCounter);
	}

	public function key()
	{
		return $this->aIds[$this->iCounter];
	}

	public function next()
	{
		$this->iCounter++;
	}

	public function valid()
	{
		return $this->iCounter < count($this->aIds);
	}

	public function set($sName, $mValue, $sTitle = "empty")
	{
		$this->addId($sName);
		$this->aData[$sName] = array(
				'title' => $sTitle,
				'type'	=> $this->getType($mValue),
				'value' => $mValue
				);

	}
	
	public function clear()
	{
		$this->aIds		= array();
		$this->aData	= array();
	}
	
	public function remove($sName)
	{
		$this->remId($sName);
		unset($this->aData[$sName]);
	}
	
	public function rename($sOldName, $sNewName)
	{
		if (isset($this->aData[$sNewName])) {
			$this->updId($sOldName, $sNewName);
			$this->aData[$sNewName] = $this->aData[$sOldName];
			unset($this->aData[$sOldName]);
		}

	}

	public function getAsArray()
	{
		$aResult = array();
		foreach ($this->aData AS $sName => $aBody) {
			$aResult[$sName] = array(
					"title" => $aBody['title'],
					"value" => $aBody['value']
					);
		}
		
		return $aResult;
	}

	public function getXml()
	{		
		$sPost	= chr(10) . chr(13);
		$sPre	= chr(9);
		$sResult  = '<document>' . $sPost;
		foreach ($this->aData AS $sName => $aBody) {
			if ($aBody['type'] == self::TYPE_ARRAY) {
				$sResult .= $sPre . '<element type="' . $aBody['type']  
								 . '" name="' . $sName
								 . '" title="' . $this->esaceTagSigns($aBody['title']) 
								 . '">' . $sPost;
				$sResult .= $this->buildXml($aBody['value'], 2);
				$sResult .= $sPre . '</element>' . $sPost;
			}
			else {
				// $sResult .= '<element type="' . $aBody['type']  
				$sResult .= $sPre . '<element name="' . $sName
								 . '" title="' . $this->esaceTagSigns($aBody['title']) 
								 . '" value="' . $this->esaceTagSigns($aBody['value']) 
								 . '">';
				$sResult .= $sPre . '</element>' . $sPost;
			}

		}
		
		$sResult .= '</document>';
		return $sResult;
	}
	
	public function import($aData)
	{
		foreach ($aData AS $sName => $aElement) {
			if (isset($aElement['value']) && isset($aElement['title'])) {
				$this->set($sName, $aElement['value'], $aElement['title']);
			}
			else if (isset($aElement['value']) && !isset($aElement['title'])) {
				$this->set($sName, $aElement['value'], "");
			}
			else {
				$this->set($sName, array(), "");
			}
			
		}
		
	}

	private function getAttrs(SimpleXMLElement $oElm)
	{
		$aAttrs = array();
		foreach ($oElm->attributes() AS $sKey => $sValue) {
			$aAttrs[(string)$sKey] = (string)$sValue;
		}
		
		return $aAttrs;
	}
	
	private function buildArr(SimpleXMLElement $oElm)
	{
		$aResult = array();
		foreach ($oElm->item AS $oSubElm) {
			$aAttrs = $this->getAttrs($oSubElm);
			switch (MSF_SL::getParam($aAttrs, "type", "string")) {
				case self::TYPE_ARRAY:
					$aResult[$aAttrs['name']] = $this->buildArr($oSubElm);
					break;
				default:
					$aResult[$aAttrs['name']] = $aAttrs['value'];
					break;
			}

		}
		
		return $aResult;
	}
	
	private function buildXml(array $aData, $iDeep = 0)
	{
		$sPre	= "";
		for($i = 0; $i < $iDeep; $i++) {
			$sPre .= chr(9);	
		}
		
		$sPost	= chr(10) . chr(13);
		$sResult = '';
		foreach ($aData AS $sKey => $mValue) {
			$sType = $this->getType($mValue);
			switch ($sType) {
				case self::TYPE_ARRAY:
					$sResult .= $sPre . '<item type="' . $sType 
								. '" name="' . $sKey 
								. '">' . $sPost;
					$sResult .= $this->buildXml($mValue, $iDeep + 1);
					$sResult .= $sPre . '</item>' . $sPost;
					break;
				default:
					//$sResult .= '<item type="' . $sType 
					$sResult .= $sPre . '<item name="' . $sKey 
							. '" value="' . $this->esaceTagSigns($mValue) 
							. '"/>' . $sPost;
					break;
			}
			
		}
		
		return $sResult;
	}
	
	private function esaceTagSigns($sMessage)
	{
		$sMessage = str_replace('&', '&#38;', $sMessage);
		$sMessage = str_replace('<', '&#60;', $sMessage);
		$sMessage = str_replace('>', '&#62;', $sMessage);
		$sMessage = str_replace('"', '&#34;', $sMessage);
		$sMessage = str_replace('*', '&#42;', $sMessage);
		return $sMessage;
	}
	
	private function remId($sName) 
	{
		$aTemp = array();
		for ($i = 0; $i < count($this->aIds); $i++) {
			if ($this->aIds[$i] !== $sName) {
				$aTemp = $this->aIds[$i];
			}

		}

		$this->iIds = $aTemp;
	}
	
	private function updId($sName, $sNewName)
	{
		for ($i = 0; $i < count($this->iIds); $i++) {
			if ($this->iIds[$i] == $sName) {
				$this->iIds[$i] = $sNewName;
			}
			
		}
		
	}
	
	private function reId($sName)
	{
		$this->remId($sName);
		$this->aIds[] = $sName;
	}
	
	private function addId($sName)
	{
		$this->remId($sName);
		$this->aIds[] = $sName;
	}
	
	private function getType($mValue)
	{
		$sType = gettype($mValue);
		switch ($sType) {
			case "integer":
				$sType = self::TYPE_INT;
				break;
			case "string":
				$sType = self::TYPE_TEXT;
				break;
		}

		return $sType;
	}


}
/*
// get example
$XW = new MSF_XmlWrapper (
		'<document><element title="&#1058;&#1077;&#1084;&#1072;" name="field_ea4ac9370c" type="array"><item name="type" type="text" value="string"></item><item name="required" type="text" value="1"></item><item name="defaultValue" type="text" value=""></item></element><element title="&#1054;&#1087;&#1080;&#1089;&#1072;&#1085;&#1080;&#1077;" name="field_db0d7074f2" type="array"><item name="type" type="text" value="text"></item><item name="required" type="text" value="0"></item><item name="defaultValue" type="text" value=""></item></element><element title="&#1055;&#1088;&#1080;&#1086;&#1088;&#1080;&#1090;&#1077;&#1090;" name="field_e619572283" type="array"><item name="type" type="text" value="enum"></item><item name="required" type="text" value="0"></item><item name="optional" type="array"><item name="enum" type="array"><item name="0" type="text" value="&#1054;&#1095;&#1077;&#1085;&#1100; &#1074;&#1099;&#1089;&#1086;&#1082;&#1080;&#1081;"></item><item name="1" type="text" value="&#1042;&#1099;&#1089;&#1086;&#1082;&#1080;&#1081;"></item><item name="2" type="text" value="&#1057;&#1088;&#1077;&#1076;&#1085;&#1080;&#1081;"></item><item name="3" type="text" value="&#1053;&#1080;&#1079;&#1082;&#1080;&#1081;"></item><item name="4" type="text" value="&#1054;&#1095;&#1077;&#1085;&#1100; &#1085;&#1080;&#1079;&#1082;&#1080;&#1081;"></item></item></item><item name="defaultValue" type="text" value="2"></item></element><element title="&#1041;&#1088;&#1072;&#1091;&#1079;&#1077;&#1088;" name="field_a91c2e4cad" type="array"><item name="type" type="text" value="enum"></item><item name="required" type="text" value="0"></item><item name="defaultValue" type="text" value="0"></item><item name="optional" type="array"><item name="enum" type="array"><item name="0" type="text" value="FF3"></item><item name="1" type="text" value="IE7"></item><item name="2" type="text" value="Opera"></item><item name="3" type="text" value="other"></item></item></item></element><element title="&#1048;&#1089;&#1087;&#1086;&#1083;&#1085;&#1080;&#1090;&#1077;&#1083;&#1100;" name="field_a5f31796f1" type="array"><item name="type" type="text" value="structure"></item><item name="required" type="text" value="0"></item><item name="optional" type="array"><item name="postEnable" type="text" value="1"></item><item name="multiselect" type="text" value="1"></item></item><item name="defaultValue" type="text" value=""></item></element></document>'
		);
debug($XW->getAsArray());
foreach ($XW AS $sName => $Data) {
	$XW->rename($sName, "abzzz");
	debug("abzzz", $XW->get($Data->getName()));
}


$XW = new MSF_XmlWrapper();
$XW->set("name", array(array(5)), "title");
$XW->set("name", array(array(7)), "title");
debug	(
		$XW->get("name")->getName(),
		$XW->get("name")->getTitle(),
		$XW->get("name")->getValue(),
		htmlSpecialChars($XW->getXml())
		);
exit();
*/
?>