<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output encoding="UTF-8" />
	<xsl:output method="html" indent="no" media-type="text/xhtml" />
	<xsl:template match="/">
		<xsl:text disable-output-escaping="yes">&lt;!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"&gt;</xsl:text>
		<html xml:lang="ru" lang="ru" xmlns="http://www.w3.org/1999/xhtml">
		<head>
		<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
		<meta http-equiv="pragma" content="no-cache"/>
		<link rel="shortcut icon" href="/favicon.ico"/>
		<title>
			<xsl:value-of select="/page/module/@title"/>
			
		</title>
		<style type="text/css" media="all">
		@import url('/templates/default/styles/msf.css');
		@import url('/templates/default/styles/print.css');
		</style>
		<script>
		var	iTotalScripts = '<xsl:value-of select="/page/module/@totalScripts"/>';
		</script>
		<script type="text/javascript" src="/js/ext/prototype/prototype.js"></script>
		<script type="text/javascript" src="/js/msf/page/MSF_InitUtils.js?v={/page/module/@systemVersion}"></script>
		</head>
		
		<body style="padding:0px; margin-bottom:20pt;">				
		<div id="page-head">			
			<bdo></bdo>
			<xsl:apply-templates select="/page/msfx/updater"/>
		</div>
		
		<div id="page-content">
			<iframe name="md_upload_frame" style="display:none;" src="/templates/blank.html"></iframe>
			<xsl:if test="/page/module/@hideMenu = 0">
				<div class="whois">
					<ul>
						<li><a href="/logout"><img src="/templates/default/images/whois-logout-icon.png"/></a></li>	
						<li><a href="/profile"><img src="/templates/default/images/whois-profile-icon.png"/></a></li>
						<xsl:if test="/page/msfx/user/posts">
							<li>
								<form style="display:none" method="post" action="/profile/changepost" id="msf_change_post_form">
									<input id="msf_input_post" name="post"/>
								</form>
								<select class="escapeWindowHandler">
									<xsl:for-each select="/page/msfx/user/posts/item">
										<option value="{@id}">
											<xsl:if test="/page/msfx/user/@post_id=@id">
												<xsl:attribute name="selected">selected</xsl:attribute>
											</xsl:if>
											<xsl:value-of select="@title"/>
										</option>
									</xsl:for-each>
								</select>
							</li>
						</xsl:if>
						<li><a><xsl:value-of select="/page/msfx/user/@user_name"/></a></li>
						<li>
							<xsl:choose>
								<xsl:when test="/page/msfx/user/@page_url!=''">
									<a href="{/page/msfx/user/@page_url}"><img src="/templates/default/images/icon_home.gif"/></a>
								</xsl:when>
								<xsl:otherwise>
									<a><img src="/templates/default/images/whois-post-icon.png"/></a>
								</xsl:otherwise>
							</xsl:choose>
						</li>
					</ul>
				</div>
				<xsl:apply-templates select="/page/msfx/menu"/>
			</xsl:if>
			<xsl:apply-templates select="/page/msfx/actionbar"/>
			<div class="module" id="module">
				<xsl:if test="/page/msfx/messenger/errors/error">
					<div class="msfMessagesError">
						<xsl:for-each select="/page/msfx/messenger/errors/error">
							<div><xsl:value-of select="@value"/></div>
						</xsl:for-each>
					</div>
				</xsl:if>
				<xsl:if test="/page/msfx/messenger/messages/message">
					<div class="msfMessagesMessage">
						<xsl:for-each select="/page/msfx/messenger/messages/message">
							<div><xsl:value-of select="@value"/></div>
						</xsl:for-each>
					</div>
				</xsl:if>				
				
				<xsl:apply-templates select="/page/module"/>
			</div>			
		</div>
		</body>		
		</html>
	</xsl:template>
</xsl:stylesheet>