<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:template match="/">		
		<html>
		<head>
		<link rel="shortcut icon" href="/favicon.ico"/>
		<meta http-equiv="content-type" content="text/html; charset=UTF-8"/>
		<meta http-equiv="pragma" content="no-cache"/>
		<style type="text/css" media="all">
			body, div, a, select, li, input {
				font-family	: Verdana;
				font-size	: 10pt;
				color		: #333333;
			}
			input {				
				border	: 1px solid #4B8DF9;
				background: #4B8DF9;
				color: white;
			}
			h2 {
        font-family	: Verdana;
				font-size	: 14pt;
				color		: #CC0000;
			}
			#browserPartial {
				padding:5pt;
				background-color:#ffec93;
				border: 1px solid #ffdb58;
				font-family:Arial;
				font-size:10pt;
				color:#333333;
			}
			#browserFailed {
				padding:5pt;
				background-color:#e696c0;
				border: 1px solid #e64658;
				font-family:Arial;
				font-size:10pt;
				color:#333333;
			}
			#browserIE {
				padding:5pt;
				background-color:#98FB98;
				border: 1px solid #32CD32;
				font-family:Arial;
				font-size:10pt;
				color:#333333;
			}
      
			#loginFailed {
				padding:5pt;
				background-color:#e696c0;
				border: 1px solid #e64658;
				font-family:Arial;
				font-size:10pt;
				color:#333333;
			}
		</style>		
		<title>
			<xsl:value-of select="$ROOT_LOGIN_TITLE"/>
		</title>
		<script type="text/javascript" src="/js/msf/browser/browser.js?v={/page/module/@systemVersion}"></script>		
		</head>
		
		<body onload="document.getElementsByTagName('input')[0].focus()" style="text-align:center;">
		<form method="post">
			<table style="margin-left:auto;margin-right:auto;margin-top:77px;">
				<tr>
					<td>
						
						<xsl:for-each select="/page/msfx/messenger/errors/error">
							<div id="loginFailed" style="text-align:left;">
								<xsl:value-of select="@value"/>
							</div>
						</xsl:for-each>	
					
						<div id="browserFailed" style="display:none;text-align:left;">
							<xsl:value-of select="$ROOT_BROWSER_CHECK_FAILDED" disable-output-escaping="yes"/>
						</div>
						<div id="browserPartial" style="display:none;text-align:left;">
							<xsl:value-of select="$ROOT_BROWSER_CHECK_PARTIAL" disable-output-escaping="yes"/>
						</div>
						<div id="browserIE" style="display:none;text-align:left;">
							<xsl:value-of select="$ROOT_BROWSER_CHECK_IE" disable-output-escaping="yes"/>
						</div>
					</td>
				</tr>
				<tr>
					<td>
						<table width="500px">
							<tr>
								<td align="center">
									<a href="http://www.detrix.kz" target="_blank">
										<img style="margin-bottom:10px;" src="/templates/default/images/detrix.png" border="0"/><hr />
									</a>
								</td>
							</tr>
							<tr>	
								<td  style="padding:5px;padding-right:40px;padding-left:40px; text-align:center;">
                                                                    <h2><xsl:value-of select="$ROOT_LOGIN_TITLE"/></h2>
									<table>
										<tr>
											<td style="padding:5px;padding-right:0px;padding-left:40px; text-align:left;">
												<xsl:value-of select="$ROOT_LABEL_LOGIN"/>: </td>
											<td style="padding:5px;padding-right:40px;padding-left:0px; text-align:left;">	<input type="text" name="login"/>
											</td>
										</tr>
										<tr>
											<td style="padding:5px;padding-right:0px;padding-left:40px; text-align:left;">
												<xsl:value-of select="$ROOT_LABEL_PASSWORD"/>:
											</td> 
											<td style="padding:5px;padding-right:40px;padding-left:0px; text-align:left;"><input name="password" type="password"/>
											</td>
										</tr>
										<tr>
											<td style="padding:5px;padding-right:40px;padding-left:40px; text-align:left;">
												<input id="browserCheck" type="submit" value="{$ROOT_BTN_ENTER}"/>
											</td>
										</tr>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>

		</form>
		<script>
			var iCheck = checkBrowser();
			if(iCheck == 0) {		
				document.getElementById("browserFailed").style.display = "";
			}
			else if (iCheck == 2) {
				document.getElementById("browserPartial").style.display = "";
			}
			else if (iCheck == 3) {
				document.getElementById("browserIE").style.display = "";
			}
		</script>
		</body>

		</html>
	</xsl:template>
</xsl:stylesheet>
